# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### AlbBackendGroup <a name="AlbBackendGroup" id="@cdktf/provider-yandex.AlbBackendGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group yandex_alb_backend_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroup.Initializer"></a>

```typescript
import { AlbBackendGroup } from '@cdktf/provider-yandex'

new AlbBackendGroup(scope: Construct, id: string, config?: AlbBackendGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig">AlbBackendGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.AlbBackendGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupConfig">AlbBackendGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.putGrpcBackend">putGrpcBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.putHttpBackend">putHttpBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.putStreamBackend">putStreamBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetGrpcBackend">resetGrpcBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetHttpBackend">resetHttpBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetStreamBackend">resetStreamBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.AlbBackendGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.AlbBackendGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.AlbBackendGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.AlbBackendGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.AlbBackendGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.AlbBackendGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putGrpcBackend` <a name="putGrpcBackend" id="@cdktf/provider-yandex.AlbBackendGroup.putGrpcBackend"></a>

```typescript
public putGrpcBackend(value: AlbBackendGroupGrpcBackend[] | IResolvable): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroup.putGrpcBackend.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] | cdktf.IResolvable

---

##### `putHttpBackend` <a name="putHttpBackend" id="@cdktf/provider-yandex.AlbBackendGroup.putHttpBackend"></a>

```typescript
public putHttpBackend(value: IResolvable | AlbBackendGroupHttpBackend[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroup.putHttpBackend.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]

---

##### `putStreamBackend` <a name="putStreamBackend" id="@cdktf/provider-yandex.AlbBackendGroup.putStreamBackend"></a>

```typescript
public putStreamBackend(value: IResolvable | AlbBackendGroupStreamBackend[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroup.putStreamBackend.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.AlbBackendGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: AlbBackendGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.AlbBackendGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.AlbBackendGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetGrpcBackend` <a name="resetGrpcBackend" id="@cdktf/provider-yandex.AlbBackendGroup.resetGrpcBackend"></a>

```typescript
public resetGrpcBackend(): void
```

##### `resetHttpBackend` <a name="resetHttpBackend" id="@cdktf/provider-yandex.AlbBackendGroup.resetHttpBackend"></a>

```typescript
public resetHttpBackend(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.AlbBackendGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.AlbBackendGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.AlbBackendGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetStreamBackend` <a name="resetStreamBackend" id="@cdktf/provider-yandex.AlbBackendGroup.resetStreamBackend"></a>

```typescript
public resetStreamBackend(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.AlbBackendGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.AlbBackendGroup.isConstruct"></a>

```typescript
import { AlbBackendGroup } from '@cdktf/provider-yandex'

AlbBackendGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.AlbBackendGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.grpcBackend">grpcBackend</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList">AlbBackendGroupGrpcBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.httpBackend">httpBackend</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList">AlbBackendGroupHttpBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.streamBackend">streamBackend</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList">AlbBackendGroupStreamBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference">AlbBackendGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.grpcBackendInput">grpcBackendInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.httpBackendInput">httpBackendInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.streamBackendInput">streamBackendInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.AlbBackendGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.AlbBackendGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.AlbBackendGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.AlbBackendGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.AlbBackendGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.AlbBackendGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbBackendGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbBackendGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbBackendGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbBackendGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.AlbBackendGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `grpcBackend`<sup>Required</sup> <a name="grpcBackend" id="@cdktf/provider-yandex.AlbBackendGroup.property.grpcBackend"></a>

```typescript
public readonly grpcBackend: AlbBackendGroupGrpcBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList">AlbBackendGroupGrpcBackendList</a>

---

##### `httpBackend`<sup>Required</sup> <a name="httpBackend" id="@cdktf/provider-yandex.AlbBackendGroup.property.httpBackend"></a>

```typescript
public readonly httpBackend: AlbBackendGroupHttpBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList">AlbBackendGroupHttpBackendList</a>

---

##### `streamBackend`<sup>Required</sup> <a name="streamBackend" id="@cdktf/provider-yandex.AlbBackendGroup.property.streamBackend"></a>

```typescript
public readonly streamBackend: AlbBackendGroupStreamBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList">AlbBackendGroupStreamBackendList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbBackendGroup.property.timeouts"></a>

```typescript
public readonly timeouts: AlbBackendGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference">AlbBackendGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `grpcBackendInput`<sup>Optional</sup> <a name="grpcBackendInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.grpcBackendInput"></a>

```typescript
public readonly grpcBackendInput: AlbBackendGroupGrpcBackend[] | IResolvable;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] | cdktf.IResolvable

---

##### `httpBackendInput`<sup>Optional</sup> <a name="httpBackendInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.httpBackendInput"></a>

```typescript
public readonly httpBackendInput: IResolvable | AlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `streamBackendInput`<sup>Optional</sup> <a name="streamBackendInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.streamBackendInput"></a>

```typescript
public readonly streamBackendInput: IResolvable | AlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.AlbBackendGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AlbBackendGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.AlbBackendGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbBackendGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbBackendGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.AlbBackendGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.AlbBackendGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### AlbHttpRouter <a name="AlbHttpRouter" id="@cdktf/provider-yandex.AlbHttpRouter"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router yandex_alb_http_router}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbHttpRouter.Initializer"></a>

```typescript
import { AlbHttpRouter } from '@cdktf/provider-yandex'

new AlbHttpRouter(scope: Construct, id: string, config?: AlbHttpRouterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig">AlbHttpRouterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.AlbHttpRouter.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbHttpRouterConfig">AlbHttpRouterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbHttpRouter.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.AlbHttpRouter.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbHttpRouter.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbHttpRouter.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.AlbHttpRouter.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.AlbHttpRouter.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.AlbHttpRouter.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.AlbHttpRouter.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.AlbHttpRouter.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouter.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.AlbHttpRouter.putTimeouts"></a>

```typescript
public putTimeouts(value: AlbHttpRouterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbHttpRouter.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.AlbHttpRouter.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.AlbHttpRouter.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.AlbHttpRouter.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.AlbHttpRouter.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.AlbHttpRouter.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.AlbHttpRouter.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.AlbHttpRouter.isConstruct"></a>

```typescript
import { AlbHttpRouter } from '@cdktf/provider-yandex'

AlbHttpRouter.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.AlbHttpRouter.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference">AlbHttpRouterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.AlbHttpRouter.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.AlbHttpRouter.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbHttpRouter.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.AlbHttpRouter.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.AlbHttpRouter.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.AlbHttpRouter.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.AlbHttpRouter.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbHttpRouter.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbHttpRouter.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbHttpRouter.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbHttpRouter.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.AlbHttpRouter.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbHttpRouter.property.timeouts"></a>

```typescript
public readonly timeouts: AlbHttpRouterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference">AlbHttpRouterTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.AlbHttpRouter.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AlbHttpRouterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.AlbHttpRouter.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbHttpRouter.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbHttpRouter.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.AlbHttpRouter.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbHttpRouter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouter.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.AlbHttpRouter.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### AlbLoadBalancer <a name="AlbLoadBalancer" id="@cdktf/provider-yandex.AlbLoadBalancer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer yandex_alb_load_balancer}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancer.Initializer"></a>

```typescript
import { AlbLoadBalancer } from '@cdktf/provider-yandex'

new AlbLoadBalancer(scope: Construct, id: string, config: AlbLoadBalancerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig">AlbLoadBalancerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.AlbLoadBalancer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig">AlbLoadBalancerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.putAllocationPolicy">putAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.putListener">putListener</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetListener">resetListener</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetRegionId">resetRegionId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.AlbLoadBalancer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbLoadBalancer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.AlbLoadBalancer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.AlbLoadBalancer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.AlbLoadBalancer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.AlbLoadBalancer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.AlbLoadBalancer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAllocationPolicy` <a name="putAllocationPolicy" id="@cdktf/provider-yandex.AlbLoadBalancer.putAllocationPolicy"></a>

```typescript
public putAllocationPolicy(value: AlbLoadBalancerAllocationPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancer.putAllocationPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a>

---

##### `putListener` <a name="putListener" id="@cdktf/provider-yandex.AlbLoadBalancer.putListener"></a>

```typescript
public putListener(value: IResolvable | AlbLoadBalancerListener[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancer.putListener.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.AlbLoadBalancer.putTimeouts"></a>

```typescript
public putTimeouts(value: AlbLoadBalancerTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancer.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.AlbLoadBalancer.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.AlbLoadBalancer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.AlbLoadBalancer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.AlbLoadBalancer.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetListener` <a name="resetListener" id="@cdktf/provider-yandex.AlbLoadBalancer.resetListener"></a>

```typescript
public resetListener(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.AlbLoadBalancer.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRegionId` <a name="resetRegionId" id="@cdktf/provider-yandex.AlbLoadBalancer.resetRegionId"></a>

```typescript
public resetRegionId(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.AlbLoadBalancer.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.AlbLoadBalancer.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.AlbLoadBalancer.isConstruct"></a>

```typescript
import { AlbLoadBalancer } from '@cdktf/provider-yandex'

AlbLoadBalancer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.AlbLoadBalancer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference">AlbLoadBalancerAllocationPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.listener">listener</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList">AlbLoadBalancerListenerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference">AlbLoadBalancerTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.allocationPolicyInput">allocationPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.listenerInput">listenerInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.regionIdInput">regionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.regionId">regionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.AlbLoadBalancer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.AlbLoadBalancer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.AlbLoadBalancer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.AlbLoadBalancer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.AlbLoadBalancer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.AlbLoadBalancer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbLoadBalancer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbLoadBalancer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbLoadBalancer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbLoadBalancer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.AlbLoadBalancer.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: AlbLoadBalancerAllocationPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference">AlbLoadBalancerAllocationPolicyOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.AlbLoadBalancer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `listener`<sup>Required</sup> <a name="listener" id="@cdktf/provider-yandex.AlbLoadBalancer.property.listener"></a>

```typescript
public readonly listener: AlbLoadBalancerListenerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList">AlbLoadBalancerListenerList</a>

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.AlbLoadBalancer.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.AlbLoadBalancer.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbLoadBalancer.property.timeouts"></a>

```typescript
public readonly timeouts: AlbLoadBalancerTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference">AlbLoadBalancerTimeoutsOutputReference</a>

---

##### `allocationPolicyInput`<sup>Optional</sup> <a name="allocationPolicyInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.allocationPolicyInput"></a>

```typescript
public readonly allocationPolicyInput: AlbLoadBalancerAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `listenerInput`<sup>Optional</sup> <a name="listenerInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.listenerInput"></a>

```typescript
public readonly listenerInput: IResolvable | AlbLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `regionIdInput`<sup>Optional</sup> <a name="regionIdInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.regionIdInput"></a>

```typescript
public readonly regionIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.AlbLoadBalancer.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AlbLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.AlbLoadBalancer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbLoadBalancer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbLoadBalancer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.AlbLoadBalancer.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.AlbLoadBalancer.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `regionId`<sup>Required</sup> <a name="regionId" id="@cdktf/provider-yandex.AlbLoadBalancer.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.AlbLoadBalancer.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.AlbLoadBalancer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### AlbTargetGroup <a name="AlbTargetGroup" id="@cdktf/provider-yandex.AlbTargetGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group yandex_alb_target_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbTargetGroup.Initializer"></a>

```typescript
import { AlbTargetGroup } from '@cdktf/provider-yandex'

new AlbTargetGroup(scope: Construct, id: string, config?: AlbTargetGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig">AlbTargetGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.AlbTargetGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbTargetGroupConfig">AlbTargetGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.putTarget">putTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetTarget">resetTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbTargetGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.AlbTargetGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbTargetGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbTargetGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.AlbTargetGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.AlbTargetGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.AlbTargetGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.AlbTargetGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.AlbTargetGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTarget` <a name="putTarget" id="@cdktf/provider-yandex.AlbTargetGroup.putTarget"></a>

```typescript
public putTarget(value: IResolvable | AlbTargetGroupTarget[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbTargetGroup.putTarget.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.AlbTargetGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: AlbTargetGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbTargetGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.AlbTargetGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.AlbTargetGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.AlbTargetGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.AlbTargetGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.AlbTargetGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTarget` <a name="resetTarget" id="@cdktf/provider-yandex.AlbTargetGroup.resetTarget"></a>

```typescript
public resetTarget(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.AlbTargetGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.AlbTargetGroup.isConstruct"></a>

```typescript
import { AlbTargetGroup } from '@cdktf/provider-yandex'

AlbTargetGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.AlbTargetGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.target">target</a></code> | <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList">AlbTargetGroupTargetList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference">AlbTargetGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.targetInput">targetInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.AlbTargetGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.AlbTargetGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbTargetGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.AlbTargetGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.AlbTargetGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.AlbTargetGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.AlbTargetGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbTargetGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbTargetGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbTargetGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbTargetGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.AlbTargetGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.AlbTargetGroup.property.target"></a>

```typescript
public readonly target: AlbTargetGroupTargetList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList">AlbTargetGroupTargetList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbTargetGroup.property.timeouts"></a>

```typescript
public readonly timeouts: AlbTargetGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference">AlbTargetGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `targetInput`<sup>Optional</sup> <a name="targetInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.targetInput"></a>

```typescript
public readonly targetInput: IResolvable | AlbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.AlbTargetGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AlbTargetGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.AlbTargetGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbTargetGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbTargetGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.AlbTargetGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbTargetGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.AlbTargetGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### AlbVirtualHost <a name="AlbVirtualHost" id="@cdktf/provider-yandex.AlbVirtualHost"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host yandex_alb_virtual_host}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHost.Initializer"></a>

```typescript
import { AlbVirtualHost } from '@cdktf/provider-yandex'

new AlbVirtualHost(scope: Construct, id: string, config: AlbVirtualHostConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig">AlbVirtualHostConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.AlbVirtualHost.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostConfig">AlbVirtualHostConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.putModifyRequestHeaders">putModifyRequestHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.putModifyResponseHeaders">putModifyResponseHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.putRoute">putRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetAuthority">resetAuthority</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetModifyRequestHeaders">resetModifyRequestHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetModifyResponseHeaders">resetModifyResponseHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetRoute">resetRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHost.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.AlbVirtualHost.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbVirtualHost.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHost.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.AlbVirtualHost.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.AlbVirtualHost.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.AlbVirtualHost.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.AlbVirtualHost.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.AlbVirtualHost.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHost.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putModifyRequestHeaders` <a name="putModifyRequestHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.putModifyRequestHeaders"></a>

```typescript
public putModifyRequestHeaders(value: IResolvable | AlbVirtualHostModifyRequestHeaders[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHost.putModifyRequestHeaders.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]

---

##### `putModifyResponseHeaders` <a name="putModifyResponseHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.putModifyResponseHeaders"></a>

```typescript
public putModifyResponseHeaders(value: IResolvable | AlbVirtualHostModifyResponseHeaders[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHost.putModifyResponseHeaders.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]

---

##### `putRoute` <a name="putRoute" id="@cdktf/provider-yandex.AlbVirtualHost.putRoute"></a>

```typescript
public putRoute(value: IResolvable | AlbVirtualHostRoute[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHost.putRoute.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.AlbVirtualHost.putTimeouts"></a>

```typescript
public putTimeouts(value: AlbVirtualHostTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHost.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a>

---

##### `resetAuthority` <a name="resetAuthority" id="@cdktf/provider-yandex.AlbVirtualHost.resetAuthority"></a>

```typescript
public resetAuthority(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.AlbVirtualHost.resetId"></a>

```typescript
public resetId(): void
```

##### `resetModifyRequestHeaders` <a name="resetModifyRequestHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.resetModifyRequestHeaders"></a>

```typescript
public resetModifyRequestHeaders(): void
```

##### `resetModifyResponseHeaders` <a name="resetModifyResponseHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.resetModifyResponseHeaders"></a>

```typescript
public resetModifyResponseHeaders(): void
```

##### `resetRoute` <a name="resetRoute" id="@cdktf/provider-yandex.AlbVirtualHost.resetRoute"></a>

```typescript
public resetRoute(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.AlbVirtualHost.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.AlbVirtualHost.isConstruct"></a>

```typescript
import { AlbVirtualHost } from '@cdktf/provider-yandex'

AlbVirtualHost.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.AlbVirtualHost.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.modifyRequestHeaders">modifyRequestHeaders</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList">AlbVirtualHostModifyRequestHeadersList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.modifyResponseHeaders">modifyResponseHeaders</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList">AlbVirtualHostModifyResponseHeadersList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.route">route</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList">AlbVirtualHostRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference">AlbVirtualHostTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.authorityInput">authorityInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.modifyRequestHeadersInput">modifyRequestHeadersInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.modifyResponseHeadersInput">modifyResponseHeadersInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.routeInput">routeInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.authority">authority</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.AlbVirtualHost.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.AlbVirtualHost.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHost.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.AlbVirtualHost.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.AlbVirtualHost.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.AlbVirtualHost.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.AlbVirtualHost.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbVirtualHost.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbVirtualHost.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbVirtualHost.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbVirtualHost.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `modifyRequestHeaders`<sup>Required</sup> <a name="modifyRequestHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.property.modifyRequestHeaders"></a>

```typescript
public readonly modifyRequestHeaders: AlbVirtualHostModifyRequestHeadersList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList">AlbVirtualHostModifyRequestHeadersList</a>

---

##### `modifyResponseHeaders`<sup>Required</sup> <a name="modifyResponseHeaders" id="@cdktf/provider-yandex.AlbVirtualHost.property.modifyResponseHeaders"></a>

```typescript
public readonly modifyResponseHeaders: AlbVirtualHostModifyResponseHeadersList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList">AlbVirtualHostModifyResponseHeadersList</a>

---

##### `route`<sup>Required</sup> <a name="route" id="@cdktf/provider-yandex.AlbVirtualHost.property.route"></a>

```typescript
public readonly route: AlbVirtualHostRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList">AlbVirtualHostRouteList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbVirtualHost.property.timeouts"></a>

```typescript
public readonly timeouts: AlbVirtualHostTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference">AlbVirtualHostTimeoutsOutputReference</a>

---

##### `authorityInput`<sup>Optional</sup> <a name="authorityInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.authorityInput"></a>

```typescript
public readonly authorityInput: string[];
```

- *Type:* string[]

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `modifyRequestHeadersInput`<sup>Optional</sup> <a name="modifyRequestHeadersInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.modifyRequestHeadersInput"></a>

```typescript
public readonly modifyRequestHeadersInput: IResolvable | AlbVirtualHostModifyRequestHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]

---

##### `modifyResponseHeadersInput`<sup>Optional</sup> <a name="modifyResponseHeadersInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.modifyResponseHeadersInput"></a>

```typescript
public readonly modifyResponseHeadersInput: IResolvable | AlbVirtualHostModifyResponseHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `routeInput`<sup>Optional</sup> <a name="routeInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.routeInput"></a>

```typescript
public readonly routeInput: IResolvable | AlbVirtualHostRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.AlbVirtualHost.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | AlbVirtualHostTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a>

---

##### `authority`<sup>Required</sup> <a name="authority" id="@cdktf/provider-yandex.AlbVirtualHost.property.authority"></a>

```typescript
public readonly authority: string[];
```

- *Type:* string[]

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbVirtualHost.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.AlbVirtualHost.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHost.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHost.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.AlbVirtualHost.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ApiGateway <a name="ApiGateway" id="@cdktf/provider-yandex.ApiGateway"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway yandex_api_gateway}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ApiGateway.Initializer"></a>

```typescript
import { ApiGateway } from '@cdktf/provider-yandex'

new ApiGateway(scope: Construct, id: string, config: ApiGatewayConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig">ApiGatewayConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ApiGateway.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ApiGateway.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ApiGateway.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ApiGatewayConfig">ApiGatewayConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ApiGateway.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ApiGateway.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ApiGateway.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ApiGateway.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ApiGateway.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ApiGateway.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ApiGateway.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ApiGateway.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ApiGateway.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ApiGateway.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ApiGateway.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ApiGateway.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ApiGateway.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ApiGateway.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ApiGateway.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ApiGateway.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGateway.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ApiGateway.putTimeouts"></a>

```typescript
public putTimeouts(value: ApiGatewayTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ApiGateway.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ApiGateway.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ApiGateway.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ApiGateway.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ApiGateway.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ApiGateway.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ApiGateway.isConstruct"></a>

```typescript
import { ApiGateway } from '@cdktf/provider-yandex'

ApiGateway.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ApiGateway.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference">ApiGatewayTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.userDomains">userDomains</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.specInput">specInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.spec">spec</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ApiGateway.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ApiGateway.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ApiGateway.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ApiGateway.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ApiGateway.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ApiGateway.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ApiGateway.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ApiGateway.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ApiGateway.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ApiGateway.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ApiGateway.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ApiGateway.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@cdktf/provider-yandex.ApiGateway.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.ApiGateway.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ApiGateway.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ApiGateway.property.timeouts"></a>

```typescript
public readonly timeouts: ApiGatewayTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference">ApiGatewayTimeoutsOutputReference</a>

---

##### `userDomains`<sup>Required</sup> <a name="userDomains" id="@cdktf/provider-yandex.ApiGateway.property.userDomains"></a>

```typescript
public readonly userDomains: string[];
```

- *Type:* string[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ApiGateway.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ApiGateway.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ApiGateway.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ApiGateway.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ApiGateway.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `specInput`<sup>Optional</sup> <a name="specInput" id="@cdktf/provider-yandex.ApiGateway.property.specInput"></a>

```typescript
public readonly specInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ApiGateway.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ApiGatewayTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ApiGateway.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ApiGateway.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ApiGateway.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ApiGateway.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ApiGateway.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `spec`<sup>Required</sup> <a name="spec" id="@cdktf/provider-yandex.ApiGateway.property.spec"></a>

```typescript
public readonly spec: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGateway.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ApiGateway.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### CdnOriginGroup <a name="CdnOriginGroup" id="@cdktf/provider-yandex.CdnOriginGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group yandex_cdn_origin_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnOriginGroup.Initializer"></a>

```typescript
import { CdnOriginGroup } from '@cdktf/provider-yandex'

new CdnOriginGroup(scope: Construct, id: string, config: CdnOriginGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig">CdnOriginGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.CdnOriginGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnOriginGroupConfig">CdnOriginGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.putOrigin">putOrigin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.resetUseNext">resetUseNext</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnOriginGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.CdnOriginGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.CdnOriginGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnOriginGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.CdnOriginGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.CdnOriginGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.CdnOriginGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.CdnOriginGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.CdnOriginGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putOrigin` <a name="putOrigin" id="@cdktf/provider-yandex.CdnOriginGroup.putOrigin"></a>

```typescript
public putOrigin(value: IResolvable | CdnOriginGroupOrigin[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnOriginGroup.putOrigin.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.CdnOriginGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: CdnOriginGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnOriginGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a>

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.CdnOriginGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.CdnOriginGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetUseNext` <a name="resetUseNext" id="@cdktf/provider-yandex.CdnOriginGroup.resetUseNext"></a>

```typescript
public resetUseNext(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.CdnOriginGroup.isConstruct"></a>

```typescript
import { CdnOriginGroup } from '@cdktf/provider-yandex'

CdnOriginGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.CdnOriginGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.origin">origin</a></code> | <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList">CdnOriginGroupOriginList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference">CdnOriginGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.originInput">originInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.useNextInput">useNextInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.useNext">useNext</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.CdnOriginGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.CdnOriginGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnOriginGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.CdnOriginGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.CdnOriginGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.CdnOriginGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.CdnOriginGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.CdnOriginGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.CdnOriginGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.CdnOriginGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.CdnOriginGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.CdnOriginGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `origin`<sup>Required</sup> <a name="origin" id="@cdktf/provider-yandex.CdnOriginGroup.property.origin"></a>

```typescript
public readonly origin: CdnOriginGroupOriginList;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList">CdnOriginGroupOriginList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.CdnOriginGroup.property.timeouts"></a>

```typescript
public readonly timeouts: CdnOriginGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference">CdnOriginGroupTimeoutsOutputReference</a>

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.CdnOriginGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.CdnOriginGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `originInput`<sup>Optional</sup> <a name="originInput" id="@cdktf/provider-yandex.CdnOriginGroup.property.originInput"></a>

```typescript
public readonly originInput: IResolvable | CdnOriginGroupOrigin[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.CdnOriginGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CdnOriginGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a>

---

##### `useNextInput`<sup>Optional</sup> <a name="useNextInput" id="@cdktf/provider-yandex.CdnOriginGroup.property.useNextInput"></a>

```typescript
public readonly useNextInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.CdnOriginGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.CdnOriginGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `useNext`<sup>Required</sup> <a name="useNext" id="@cdktf/provider-yandex.CdnOriginGroup.property.useNext"></a>

```typescript
public readonly useNext: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.CdnOriginGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### CdnResource <a name="CdnResource" id="@cdktf/provider-yandex.CdnResource"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource yandex_cdn_resource}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnResource.Initializer"></a>

```typescript
import { CdnResource } from '@cdktf/provider-yandex'

new CdnResource(scope: Construct, id: string, config?: CdnResourceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResource.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceConfig">CdnResourceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.CdnResource.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.CdnResource.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.CdnResource.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceConfig">CdnResourceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResource.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.putOptions">putOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.putSslCertificate">putSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetActive">resetActive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetCname">resetCname</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetOptions">resetOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetOriginGroupId">resetOriginGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetOriginGroupName">resetOriginGroupName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetOriginProtocol">resetOriginProtocol</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetSecondaryHostnames">resetSecondaryHostnames</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetSslCertificate">resetSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.resetUpdatedAt">resetUpdatedAt</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnResource.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.CdnResource.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.CdnResource.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnResource.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.CdnResource.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.CdnResource.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.CdnResource.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.CdnResource.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.CdnResource.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnResource.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnResource.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnResource.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnResource.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnResource.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnResource.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnResource.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResource.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putOptions` <a name="putOptions" id="@cdktf/provider-yandex.CdnResource.putOptions"></a>

```typescript
public putOptions(value: CdnResourceOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnResource.putOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a>

---

##### `putSslCertificate` <a name="putSslCertificate" id="@cdktf/provider-yandex.CdnResource.putSslCertificate"></a>

```typescript
public putSslCertificate(value: CdnResourceSslCertificate): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnResource.putSslCertificate.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.CdnResource.putTimeouts"></a>

```typescript
public putTimeouts(value: CdnResourceTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.CdnResource.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a>

---

##### `resetActive` <a name="resetActive" id="@cdktf/provider-yandex.CdnResource.resetActive"></a>

```typescript
public resetActive(): void
```

##### `resetCname` <a name="resetCname" id="@cdktf/provider-yandex.CdnResource.resetCname"></a>

```typescript
public resetCname(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.CdnResource.resetId"></a>

```typescript
public resetId(): void
```

##### `resetOptions` <a name="resetOptions" id="@cdktf/provider-yandex.CdnResource.resetOptions"></a>

```typescript
public resetOptions(): void
```

##### `resetOriginGroupId` <a name="resetOriginGroupId" id="@cdktf/provider-yandex.CdnResource.resetOriginGroupId"></a>

```typescript
public resetOriginGroupId(): void
```

##### `resetOriginGroupName` <a name="resetOriginGroupName" id="@cdktf/provider-yandex.CdnResource.resetOriginGroupName"></a>

```typescript
public resetOriginGroupName(): void
```

##### `resetOriginProtocol` <a name="resetOriginProtocol" id="@cdktf/provider-yandex.CdnResource.resetOriginProtocol"></a>

```typescript
public resetOriginProtocol(): void
```

##### `resetSecondaryHostnames` <a name="resetSecondaryHostnames" id="@cdktf/provider-yandex.CdnResource.resetSecondaryHostnames"></a>

```typescript
public resetSecondaryHostnames(): void
```

##### `resetSslCertificate` <a name="resetSslCertificate" id="@cdktf/provider-yandex.CdnResource.resetSslCertificate"></a>

```typescript
public resetSslCertificate(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.CdnResource.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetUpdatedAt` <a name="resetUpdatedAt" id="@cdktf/provider-yandex.CdnResource.resetUpdatedAt"></a>

```typescript
public resetUpdatedAt(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResource.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.CdnResource.isConstruct"></a>

```typescript
import { CdnResource } from '@cdktf/provider-yandex'

CdnResource.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.CdnResource.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.options">options</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference">CdnResourceOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.sslCertificate">sslCertificate</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference">CdnResourceSslCertificateOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference">CdnResourceTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.activeInput">activeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.cnameInput">cnameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.optionsInput">optionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originGroupIdInput">originGroupIdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originGroupNameInput">originGroupNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originProtocolInput">originProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.secondaryHostnamesInput">secondaryHostnamesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.sslCertificateInput">sslCertificateInput</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.updatedAtInput">updatedAtInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.active">active</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.cname">cname</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originGroupId">originGroupId</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originGroupName">originGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.originProtocol">originProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.secondaryHostnames">secondaryHostnames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.updatedAt">updatedAt</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.CdnResource.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.CdnResource.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnResource.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.CdnResource.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.CdnResource.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.CdnResource.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.CdnResource.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.CdnResource.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.CdnResource.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.CdnResource.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.CdnResource.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.CdnResource.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.CdnResource.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `options`<sup>Required</sup> <a name="options" id="@cdktf/provider-yandex.CdnResource.property.options"></a>

```typescript
public readonly options: CdnResourceOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference">CdnResourceOptionsOutputReference</a>

---

##### `sslCertificate`<sup>Required</sup> <a name="sslCertificate" id="@cdktf/provider-yandex.CdnResource.property.sslCertificate"></a>

```typescript
public readonly sslCertificate: CdnResourceSslCertificateOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference">CdnResourceSslCertificateOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.CdnResource.property.timeouts"></a>

```typescript
public readonly timeouts: CdnResourceTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference">CdnResourceTimeoutsOutputReference</a>

---

##### `activeInput`<sup>Optional</sup> <a name="activeInput" id="@cdktf/provider-yandex.CdnResource.property.activeInput"></a>

```typescript
public readonly activeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cnameInput`<sup>Optional</sup> <a name="cnameInput" id="@cdktf/provider-yandex.CdnResource.property.cnameInput"></a>

```typescript
public readonly cnameInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.CdnResource.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `optionsInput`<sup>Optional</sup> <a name="optionsInput" id="@cdktf/provider-yandex.CdnResource.property.optionsInput"></a>

```typescript
public readonly optionsInput: CdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a>

---

##### `originGroupIdInput`<sup>Optional</sup> <a name="originGroupIdInput" id="@cdktf/provider-yandex.CdnResource.property.originGroupIdInput"></a>

```typescript
public readonly originGroupIdInput: number;
```

- *Type:* number

---

##### `originGroupNameInput`<sup>Optional</sup> <a name="originGroupNameInput" id="@cdktf/provider-yandex.CdnResource.property.originGroupNameInput"></a>

```typescript
public readonly originGroupNameInput: string;
```

- *Type:* string

---

##### `originProtocolInput`<sup>Optional</sup> <a name="originProtocolInput" id="@cdktf/provider-yandex.CdnResource.property.originProtocolInput"></a>

```typescript
public readonly originProtocolInput: string;
```

- *Type:* string

---

##### `secondaryHostnamesInput`<sup>Optional</sup> <a name="secondaryHostnamesInput" id="@cdktf/provider-yandex.CdnResource.property.secondaryHostnamesInput"></a>

```typescript
public readonly secondaryHostnamesInput: string[];
```

- *Type:* string[]

---

##### `sslCertificateInput`<sup>Optional</sup> <a name="sslCertificateInput" id="@cdktf/provider-yandex.CdnResource.property.sslCertificateInput"></a>

```typescript
public readonly sslCertificateInput: CdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a>

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.CdnResource.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | CdnResourceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a>

---

##### `updatedAtInput`<sup>Optional</sup> <a name="updatedAtInput" id="@cdktf/provider-yandex.CdnResource.property.updatedAtInput"></a>

```typescript
public readonly updatedAtInput: string;
```

- *Type:* string

---

##### `active`<sup>Required</sup> <a name="active" id="@cdktf/provider-yandex.CdnResource.property.active"></a>

```typescript
public readonly active: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cname`<sup>Required</sup> <a name="cname" id="@cdktf/provider-yandex.CdnResource.property.cname"></a>

```typescript
public readonly cname: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.CdnResource.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `originGroupId`<sup>Required</sup> <a name="originGroupId" id="@cdktf/provider-yandex.CdnResource.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

---

##### `originGroupName`<sup>Required</sup> <a name="originGroupName" id="@cdktf/provider-yandex.CdnResource.property.originGroupName"></a>

```typescript
public readonly originGroupName: string;
```

- *Type:* string

---

##### `originProtocol`<sup>Required</sup> <a name="originProtocol" id="@cdktf/provider-yandex.CdnResource.property.originProtocol"></a>

```typescript
public readonly originProtocol: string;
```

- *Type:* string

---

##### `secondaryHostnames`<sup>Required</sup> <a name="secondaryHostnames" id="@cdktf/provider-yandex.CdnResource.property.secondaryHostnames"></a>

```typescript
public readonly secondaryHostnames: string[];
```

- *Type:* string[]

---

##### `updatedAt`<sup>Required</sup> <a name="updatedAt" id="@cdktf/provider-yandex.CdnResource.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResource.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.CdnResource.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeDisk <a name="ComputeDisk" id="@cdktf/provider-yandex.ComputeDisk"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk yandex_compute_disk}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeDisk.Initializer"></a>

```typescript
import { ComputeDisk } from '@cdktf/provider-yandex'

new ComputeDisk(scope: Construct, id: string, config?: ComputeDiskConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig">ComputeDiskConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ComputeDisk.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskConfig">ComputeDiskConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.putDiskPlacementPolicy">putDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetBlockSize">resetBlockSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetDiskPlacementPolicy">resetDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetImageId">resetImageId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetSize">resetSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetSnapshotId">resetSnapshotId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetType">resetType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeDisk.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeDisk.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeDisk.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeDisk.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeDisk.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeDisk.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeDisk.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeDisk.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeDisk.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeDisk.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeDisk.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeDisk.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeDisk.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeDisk.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeDisk.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeDisk.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDisk.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putDiskPlacementPolicy` <a name="putDiskPlacementPolicy" id="@cdktf/provider-yandex.ComputeDisk.putDiskPlacementPolicy"></a>

```typescript
public putDiskPlacementPolicy(value: ComputeDiskDiskPlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeDisk.putDiskPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeDisk.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeDiskTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeDisk.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a>

---

##### `resetBlockSize` <a name="resetBlockSize" id="@cdktf/provider-yandex.ComputeDisk.resetBlockSize"></a>

```typescript
public resetBlockSize(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeDisk.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetDiskPlacementPolicy` <a name="resetDiskPlacementPolicy" id="@cdktf/provider-yandex.ComputeDisk.resetDiskPlacementPolicy"></a>

```typescript
public resetDiskPlacementPolicy(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeDisk.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeDisk.resetId"></a>

```typescript
public resetId(): void
```

##### `resetImageId` <a name="resetImageId" id="@cdktf/provider-yandex.ComputeDisk.resetImageId"></a>

```typescript
public resetImageId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeDisk.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeDisk.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.ComputeDisk.resetSize"></a>

```typescript
public resetSize(): void
```

##### `resetSnapshotId` <a name="resetSnapshotId" id="@cdktf/provider-yandex.ComputeDisk.resetSnapshotId"></a>

```typescript
public resetSnapshotId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeDisk.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.ComputeDisk.resetType"></a>

```typescript
public resetType(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.ComputeDisk.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeDisk.isConstruct"></a>

```typescript
import { ComputeDisk } from '@cdktf/provider-yandex'

ComputeDisk.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeDisk.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.diskPlacementPolicy">diskPlacementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference">ComputeDiskDiskPlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.productIds">productIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference">ComputeDiskTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.blockSizeInput">blockSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.diskPlacementPolicyInput">diskPlacementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.imageIdInput">imageIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.snapshotIdInput">snapshotIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.blockSize">blockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeDisk.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeDisk.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeDisk.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeDisk.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeDisk.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeDisk.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeDisk.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeDisk.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeDisk.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeDisk.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeDisk.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeDisk.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `diskPlacementPolicy`<sup>Required</sup> <a name="diskPlacementPolicy" id="@cdktf/provider-yandex.ComputeDisk.property.diskPlacementPolicy"></a>

```typescript
public readonly diskPlacementPolicy: ComputeDiskDiskPlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference">ComputeDiskDiskPlacementPolicyOutputReference</a>

---

##### `productIds`<sup>Required</sup> <a name="productIds" id="@cdktf/provider-yandex.ComputeDisk.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeDisk.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeDisk.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeDiskTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference">ComputeDiskTimeoutsOutputReference</a>

---

##### `blockSizeInput`<sup>Optional</sup> <a name="blockSizeInput" id="@cdktf/provider-yandex.ComputeDisk.property.blockSizeInput"></a>

```typescript
public readonly blockSizeInput: number;
```

- *Type:* number

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeDisk.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `diskPlacementPolicyInput`<sup>Optional</sup> <a name="diskPlacementPolicyInput" id="@cdktf/provider-yandex.ComputeDisk.property.diskPlacementPolicyInput"></a>

```typescript
public readonly diskPlacementPolicyInput: ComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeDisk.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeDisk.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `imageIdInput`<sup>Optional</sup> <a name="imageIdInput" id="@cdktf/provider-yandex.ComputeDisk.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeDisk.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeDisk.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.ComputeDisk.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="snapshotIdInput" id="@cdktf/provider-yandex.ComputeDisk.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeDisk.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeDiskTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a>

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.ComputeDisk.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.ComputeDisk.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `blockSize`<sup>Required</sup> <a name="blockSize" id="@cdktf/provider-yandex.ComputeDisk.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeDisk.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeDisk.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDisk.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeDisk.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeDisk.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeDisk.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeDisk.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeDisk.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.ComputeDisk.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeDisk.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDisk.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeDisk.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeDiskPlacementGroup <a name="ComputeDiskPlacementGroup" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group yandex_compute_disk_placement_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer"></a>

```typescript
import { ComputeDiskPlacementGroup } from '@cdktf/provider-yandex'

new ComputeDiskPlacementGroup(scope: Construct, id: string, config?: ComputeDiskPlacementGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig">ComputeDiskPlacementGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig">ComputeDiskPlacementGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeDiskPlacementGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.isConstruct"></a>

```typescript
import { ComputeDiskPlacementGroup } from '@cdktf/provider-yandex'

ComputeDiskPlacementGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference">ComputeDiskPlacementGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeDiskPlacementGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference">ComputeDiskPlacementGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeDiskPlacementGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a>

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeDiskPlacementGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeImage <a name="ComputeImage" id="@cdktf/provider-yandex.ComputeImage"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_image yandex_compute_image}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeImage.Initializer"></a>

```typescript
import { ComputeImage } from '@cdktf/provider-yandex'

new ComputeImage(scope: Construct, id: string, config?: ComputeImageConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeImageConfig">ComputeImageConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeImage.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeImage.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ComputeImage.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeImageConfig">ComputeImageConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetFamily">resetFamily</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetMinDiskSize">resetMinDiskSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetOsType">resetOsType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetPooled">resetPooled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetProductIds">resetProductIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetSourceDisk">resetSourceDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetSourceFamily">resetSourceFamily</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetSourceImage">resetSourceImage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetSourceSnapshot">resetSourceSnapshot</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetSourceUrl">resetSourceUrl</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeImage.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeImage.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeImage.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeImage.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeImage.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeImage.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeImage.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeImage.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeImage.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeImage.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeImage.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeImage.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeImage.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeImage.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeImage.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeImage.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImage.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeImage.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeImageTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeImage.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeImage.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFamily` <a name="resetFamily" id="@cdktf/provider-yandex.ComputeImage.resetFamily"></a>

```typescript
public resetFamily(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeImage.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeImage.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeImage.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMinDiskSize` <a name="resetMinDiskSize" id="@cdktf/provider-yandex.ComputeImage.resetMinDiskSize"></a>

```typescript
public resetMinDiskSize(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeImage.resetName"></a>

```typescript
public resetName(): void
```

##### `resetOsType` <a name="resetOsType" id="@cdktf/provider-yandex.ComputeImage.resetOsType"></a>

```typescript
public resetOsType(): void
```

##### `resetPooled` <a name="resetPooled" id="@cdktf/provider-yandex.ComputeImage.resetPooled"></a>

```typescript
public resetPooled(): void
```

##### `resetProductIds` <a name="resetProductIds" id="@cdktf/provider-yandex.ComputeImage.resetProductIds"></a>

```typescript
public resetProductIds(): void
```

##### `resetSourceDisk` <a name="resetSourceDisk" id="@cdktf/provider-yandex.ComputeImage.resetSourceDisk"></a>

```typescript
public resetSourceDisk(): void
```

##### `resetSourceFamily` <a name="resetSourceFamily" id="@cdktf/provider-yandex.ComputeImage.resetSourceFamily"></a>

```typescript
public resetSourceFamily(): void
```

##### `resetSourceImage` <a name="resetSourceImage" id="@cdktf/provider-yandex.ComputeImage.resetSourceImage"></a>

```typescript
public resetSourceImage(): void
```

##### `resetSourceSnapshot` <a name="resetSourceSnapshot" id="@cdktf/provider-yandex.ComputeImage.resetSourceSnapshot"></a>

```typescript
public resetSourceSnapshot(): void
```

##### `resetSourceUrl` <a name="resetSourceUrl" id="@cdktf/provider-yandex.ComputeImage.resetSourceUrl"></a>

```typescript
public resetSourceUrl(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeImage.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeImage.isConstruct"></a>

```typescript
import { ComputeImage } from '@cdktf/provider-yandex'

ComputeImage.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeImage.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference">ComputeImageTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.familyInput">familyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.minDiskSizeInput">minDiskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.osTypeInput">osTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.pooledInput">pooledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.productIdsInput">productIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceDiskInput">sourceDiskInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceFamilyInput">sourceFamilyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceImageInput">sourceImageInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceSnapshotInput">sourceSnapshotInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceUrlInput">sourceUrlInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.family">family</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.minDiskSize">minDiskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.osType">osType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.pooled">pooled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.productIds">productIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceDisk">sourceDisk</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceFamily">sourceFamily</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceImage">sourceImage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceSnapshot">sourceSnapshot</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.sourceUrl">sourceUrl</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeImage.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeImage.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeImage.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeImage.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeImage.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeImage.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeImage.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeImage.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeImage.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeImage.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeImage.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeImage.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeImage.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeImage.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeImage.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeImageTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference">ComputeImageTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeImage.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `familyInput`<sup>Optional</sup> <a name="familyInput" id="@cdktf/provider-yandex.ComputeImage.property.familyInput"></a>

```typescript
public readonly familyInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeImage.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeImage.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeImage.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `minDiskSizeInput`<sup>Optional</sup> <a name="minDiskSizeInput" id="@cdktf/provider-yandex.ComputeImage.property.minDiskSizeInput"></a>

```typescript
public readonly minDiskSizeInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeImage.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `osTypeInput`<sup>Optional</sup> <a name="osTypeInput" id="@cdktf/provider-yandex.ComputeImage.property.osTypeInput"></a>

```typescript
public readonly osTypeInput: string;
```

- *Type:* string

---

##### `pooledInput`<sup>Optional</sup> <a name="pooledInput" id="@cdktf/provider-yandex.ComputeImage.property.pooledInput"></a>

```typescript
public readonly pooledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `productIdsInput`<sup>Optional</sup> <a name="productIdsInput" id="@cdktf/provider-yandex.ComputeImage.property.productIdsInput"></a>

```typescript
public readonly productIdsInput: string[];
```

- *Type:* string[]

---

##### `sourceDiskInput`<sup>Optional</sup> <a name="sourceDiskInput" id="@cdktf/provider-yandex.ComputeImage.property.sourceDiskInput"></a>

```typescript
public readonly sourceDiskInput: string;
```

- *Type:* string

---

##### `sourceFamilyInput`<sup>Optional</sup> <a name="sourceFamilyInput" id="@cdktf/provider-yandex.ComputeImage.property.sourceFamilyInput"></a>

```typescript
public readonly sourceFamilyInput: string;
```

- *Type:* string

---

##### `sourceImageInput`<sup>Optional</sup> <a name="sourceImageInput" id="@cdktf/provider-yandex.ComputeImage.property.sourceImageInput"></a>

```typescript
public readonly sourceImageInput: string;
```

- *Type:* string

---

##### `sourceSnapshotInput`<sup>Optional</sup> <a name="sourceSnapshotInput" id="@cdktf/provider-yandex.ComputeImage.property.sourceSnapshotInput"></a>

```typescript
public readonly sourceSnapshotInput: string;
```

- *Type:* string

---

##### `sourceUrlInput`<sup>Optional</sup> <a name="sourceUrlInput" id="@cdktf/provider-yandex.ComputeImage.property.sourceUrlInput"></a>

```typescript
public readonly sourceUrlInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeImage.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeImageTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeImage.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `family`<sup>Required</sup> <a name="family" id="@cdktf/provider-yandex.ComputeImage.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeImage.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeImage.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeImage.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `minDiskSize`<sup>Required</sup> <a name="minDiskSize" id="@cdktf/provider-yandex.ComputeImage.property.minDiskSize"></a>

```typescript
public readonly minDiskSize: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeImage.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `osType`<sup>Required</sup> <a name="osType" id="@cdktf/provider-yandex.ComputeImage.property.osType"></a>

```typescript
public readonly osType: string;
```

- *Type:* string

---

##### `pooled`<sup>Required</sup> <a name="pooled" id="@cdktf/provider-yandex.ComputeImage.property.pooled"></a>

```typescript
public readonly pooled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `productIds`<sup>Required</sup> <a name="productIds" id="@cdktf/provider-yandex.ComputeImage.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

---

##### `sourceDisk`<sup>Required</sup> <a name="sourceDisk" id="@cdktf/provider-yandex.ComputeImage.property.sourceDisk"></a>

```typescript
public readonly sourceDisk: string;
```

- *Type:* string

---

##### `sourceFamily`<sup>Required</sup> <a name="sourceFamily" id="@cdktf/provider-yandex.ComputeImage.property.sourceFamily"></a>

```typescript
public readonly sourceFamily: string;
```

- *Type:* string

---

##### `sourceImage`<sup>Required</sup> <a name="sourceImage" id="@cdktf/provider-yandex.ComputeImage.property.sourceImage"></a>

```typescript
public readonly sourceImage: string;
```

- *Type:* string

---

##### `sourceSnapshot`<sup>Required</sup> <a name="sourceSnapshot" id="@cdktf/provider-yandex.ComputeImage.property.sourceSnapshot"></a>

```typescript
public readonly sourceSnapshot: string;
```

- *Type:* string

---

##### `sourceUrl`<sup>Required</sup> <a name="sourceUrl" id="@cdktf/provider-yandex.ComputeImage.property.sourceUrl"></a>

```typescript
public readonly sourceUrl: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImage.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeImage.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeInstance <a name="ComputeInstance" id="@cdktf/provider-yandex.ComputeInstance"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance yandex_compute_instance}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstance.Initializer"></a>

```typescript
import { ComputeInstance } from '@cdktf/provider-yandex'

new ComputeInstance(scope: Construct, id: string, config: ComputeInstanceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig">ComputeInstanceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ComputeInstance.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceConfig">ComputeInstanceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putBootDisk">putBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putNetworkInterface">putNetworkInterface</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putPlacementPolicy">putPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putSchedulingPolicy">putSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putSecondaryDisk">putSecondaryDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetAllowStoppingForUpdate">resetAllowStoppingForUpdate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetHostname">resetHostname</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetMetadata">resetMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetNetworkAccelerationType">resetNetworkAccelerationType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetPlacementPolicy">resetPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetPlatformId">resetPlatformId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetSchedulingPolicy">resetSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetSecondaryDisk">resetSecondaryDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstance.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeInstance.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeInstance.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeInstance.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeInstance.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeInstance.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeInstance.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeInstance.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstance.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstance.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstance.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstance.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstance.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstance.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstance.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstance.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putBootDisk` <a name="putBootDisk" id="@cdktf/provider-yandex.ComputeInstance.putBootDisk"></a>

```typescript
public putBootDisk(value: ComputeInstanceBootDisk): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putBootDisk.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a>

---

##### `putNetworkInterface` <a name="putNetworkInterface" id="@cdktf/provider-yandex.ComputeInstance.putNetworkInterface"></a>

```typescript
public putNetworkInterface(value: IResolvable | ComputeInstanceNetworkInterface[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putNetworkInterface.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]

---

##### `putPlacementPolicy` <a name="putPlacementPolicy" id="@cdktf/provider-yandex.ComputeInstance.putPlacementPolicy"></a>

```typescript
public putPlacementPolicy(value: ComputeInstancePlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.ComputeInstance.putResources"></a>

```typescript
public putResources(value: ComputeInstanceResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a>

---

##### `putSchedulingPolicy` <a name="putSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstance.putSchedulingPolicy"></a>

```typescript
public putSchedulingPolicy(value: ComputeInstanceSchedulingPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putSchedulingPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a>

---

##### `putSecondaryDisk` <a name="putSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstance.putSecondaryDisk"></a>

```typescript
public putSecondaryDisk(value: IResolvable | ComputeInstanceSecondaryDisk[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putSecondaryDisk.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeInstance.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeInstanceTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstance.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a>

---

##### `resetAllowStoppingForUpdate` <a name="resetAllowStoppingForUpdate" id="@cdktf/provider-yandex.ComputeInstance.resetAllowStoppingForUpdate"></a>

```typescript
public resetAllowStoppingForUpdate(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstance.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeInstance.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHostname` <a name="resetHostname" id="@cdktf/provider-yandex.ComputeInstance.resetHostname"></a>

```typescript
public resetHostname(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeInstance.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeInstance.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMetadata` <a name="resetMetadata" id="@cdktf/provider-yandex.ComputeInstance.resetMetadata"></a>

```typescript
public resetMetadata(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeInstance.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkAccelerationType` <a name="resetNetworkAccelerationType" id="@cdktf/provider-yandex.ComputeInstance.resetNetworkAccelerationType"></a>

```typescript
public resetNetworkAccelerationType(): void
```

##### `resetPlacementPolicy` <a name="resetPlacementPolicy" id="@cdktf/provider-yandex.ComputeInstance.resetPlacementPolicy"></a>

```typescript
public resetPlacementPolicy(): void
```

##### `resetPlatformId` <a name="resetPlatformId" id="@cdktf/provider-yandex.ComputeInstance.resetPlatformId"></a>

```typescript
public resetPlatformId(): void
```

##### `resetSchedulingPolicy` <a name="resetSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstance.resetSchedulingPolicy"></a>

```typescript
public resetSchedulingPolicy(): void
```

##### `resetSecondaryDisk` <a name="resetSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstance.resetSecondaryDisk"></a>

```typescript
public resetSecondaryDisk(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.ComputeInstance.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeInstance.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.ComputeInstance.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeInstance.isConstruct"></a>

```typescript
import { ComputeInstance } from '@cdktf/provider-yandex'

ComputeInstance.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeInstance.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference">ComputeInstanceBootDiskOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList">ComputeInstanceNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference">ComputeInstancePlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference">ComputeInstanceResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference">ComputeInstanceSchedulingPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.secondaryDisk">secondaryDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList">ComputeInstanceSecondaryDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference">ComputeInstanceTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.allowStoppingForUpdateInput">allowStoppingForUpdateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.bootDiskInput">bootDiskInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.hostnameInput">hostnameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.metadataInput">metadataInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.networkAccelerationTypeInput">networkAccelerationTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.networkInterfaceInput">networkInterfaceInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.placementPolicyInput">placementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.platformIdInput">platformIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.schedulingPolicyInput">schedulingPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.secondaryDiskInput">secondaryDiskInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.allowStoppingForUpdate">allowStoppingForUpdate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.hostname">hostname</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeInstance.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeInstance.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstance.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeInstance.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeInstance.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeInstance.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeInstance.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeInstance.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeInstance.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeInstance.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeInstance.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.ComputeInstance.property.bootDisk"></a>

```typescript
public readonly bootDisk: ComputeInstanceBootDiskOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference">ComputeInstanceBootDiskOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeInstance.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstance.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.ComputeInstance.property.networkInterface"></a>

```typescript
public readonly networkInterface: ComputeInstanceNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList">ComputeInstanceNetworkInterfaceList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.ComputeInstance.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: ComputeInstancePlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference">ComputeInstancePlacementPolicyOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.ComputeInstance.property.resources"></a>

```typescript
public readonly resources: ComputeInstanceResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference">ComputeInstanceResourcesOutputReference</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.ComputeInstance.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: ComputeInstanceSchedulingPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference">ComputeInstanceSchedulingPolicyOutputReference</a>

---

##### `secondaryDisk`<sup>Required</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.ComputeInstance.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: ComputeInstanceSecondaryDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList">ComputeInstanceSecondaryDiskList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeInstance.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeInstance.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference">ComputeInstanceTimeoutsOutputReference</a>

---

##### `allowStoppingForUpdateInput`<sup>Optional</sup> <a name="allowStoppingForUpdateInput" id="@cdktf/provider-yandex.ComputeInstance.property.allowStoppingForUpdateInput"></a>

```typescript
public readonly allowStoppingForUpdateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `bootDiskInput`<sup>Optional</sup> <a name="bootDiskInput" id="@cdktf/provider-yandex.ComputeInstance.property.bootDiskInput"></a>

```typescript
public readonly bootDiskInput: ComputeInstanceBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstance.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeInstance.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostnameInput`<sup>Optional</sup> <a name="hostnameInput" id="@cdktf/provider-yandex.ComputeInstance.property.hostnameInput"></a>

```typescript
public readonly hostnameInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeInstance.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeInstance.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metadataInput`<sup>Optional</sup> <a name="metadataInput" id="@cdktf/provider-yandex.ComputeInstance.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeInstance.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkAccelerationTypeInput`<sup>Optional</sup> <a name="networkAccelerationTypeInput" id="@cdktf/provider-yandex.ComputeInstance.property.networkAccelerationTypeInput"></a>

```typescript
public readonly networkAccelerationTypeInput: string;
```

- *Type:* string

---

##### `networkInterfaceInput`<sup>Optional</sup> <a name="networkInterfaceInput" id="@cdktf/provider-yandex.ComputeInstance.property.networkInterfaceInput"></a>

```typescript
public readonly networkInterfaceInput: IResolvable | ComputeInstanceNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]

---

##### `placementPolicyInput`<sup>Optional</sup> <a name="placementPolicyInput" id="@cdktf/provider-yandex.ComputeInstance.property.placementPolicyInput"></a>

```typescript
public readonly placementPolicyInput: ComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a>

---

##### `platformIdInput`<sup>Optional</sup> <a name="platformIdInput" id="@cdktf/provider-yandex.ComputeInstance.property.platformIdInput"></a>

```typescript
public readonly platformIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.ComputeInstance.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: ComputeInstanceResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a>

---

##### `schedulingPolicyInput`<sup>Optional</sup> <a name="schedulingPolicyInput" id="@cdktf/provider-yandex.ComputeInstance.property.schedulingPolicyInput"></a>

```typescript
public readonly schedulingPolicyInput: ComputeInstanceSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a>

---

##### `secondaryDiskInput`<sup>Optional</sup> <a name="secondaryDiskInput" id="@cdktf/provider-yandex.ComputeInstance.property.secondaryDiskInput"></a>

```typescript
public readonly secondaryDiskInput: IResolvable | ComputeInstanceSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.ComputeInstance.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeInstance.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeInstanceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a>

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.ComputeInstance.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `allowStoppingForUpdate`<sup>Required</sup> <a name="allowStoppingForUpdate" id="@cdktf/provider-yandex.ComputeInstance.property.allowStoppingForUpdate"></a>

```typescript
public readonly allowStoppingForUpdate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstance.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstance.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostname`<sup>Required</sup> <a name="hostname" id="@cdktf/provider-yandex.ComputeInstance.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstance.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstance.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.ComputeInstance.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstance.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkAccelerationType`<sup>Required</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.ComputeInstance.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.ComputeInstance.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstance.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeInstance.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstance.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeInstance.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeInstanceGroup <a name="ComputeInstanceGroup" id="@cdktf/provider-yandex.ComputeInstanceGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group yandex_compute_instance_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroup.Initializer"></a>

```typescript
import { ComputeInstanceGroup } from '@cdktf/provider-yandex'

new ComputeInstanceGroup(scope: Construct, id: string, config: ComputeInstanceGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig">ComputeInstanceGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ComputeInstanceGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig">ComputeInstanceGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putAllocationPolicy">putAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putApplicationLoadBalancer">putApplicationLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putDeployPolicy">putDeployPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putHealthCheck">putHealthCheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putInstanceTemplate">putInstanceTemplate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putLoadBalancer">putLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putScalePolicy">putScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetApplicationLoadBalancer">resetApplicationLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetHealthCheck">resetHealthCheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetLoadBalancer">resetLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetMaxCheckingHealthDuration">resetMaxCheckingHealthDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.resetVariables">resetVariables</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeInstanceGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeInstanceGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeInstanceGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeInstanceGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeInstanceGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeInstanceGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAllocationPolicy` <a name="putAllocationPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.putAllocationPolicy"></a>

```typescript
public putAllocationPolicy(value: ComputeInstanceGroupAllocationPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putAllocationPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a>

---

##### `putApplicationLoadBalancer` <a name="putApplicationLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.putApplicationLoadBalancer"></a>

```typescript
public putApplicationLoadBalancer(value: ComputeInstanceGroupApplicationLoadBalancer): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putApplicationLoadBalancer.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a>

---

##### `putDeployPolicy` <a name="putDeployPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.putDeployPolicy"></a>

```typescript
public putDeployPolicy(value: ComputeInstanceGroupDeployPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putDeployPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a>

---

##### `putHealthCheck` <a name="putHealthCheck" id="@cdktf/provider-yandex.ComputeInstanceGroup.putHealthCheck"></a>

```typescript
public putHealthCheck(value: IResolvable | ComputeInstanceGroupHealthCheck[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putHealthCheck.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]

---

##### `putInstanceTemplate` <a name="putInstanceTemplate" id="@cdktf/provider-yandex.ComputeInstanceGroup.putInstanceTemplate"></a>

```typescript
public putInstanceTemplate(value: ComputeInstanceGroupInstanceTemplate): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putInstanceTemplate.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a>

---

##### `putLoadBalancer` <a name="putLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.putLoadBalancer"></a>

```typescript
public putLoadBalancer(value: ComputeInstanceGroupLoadBalancer): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putLoadBalancer.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a>

---

##### `putScalePolicy` <a name="putScalePolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.putScalePolicy"></a>

```typescript
public putScalePolicy(value: ComputeInstanceGroupScalePolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putScalePolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeInstanceGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeInstanceGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a>

---

##### `resetApplicationLoadBalancer` <a name="resetApplicationLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetApplicationLoadBalancer"></a>

```typescript
public resetApplicationLoadBalancer(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHealthCheck` <a name="resetHealthCheck" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetHealthCheck"></a>

```typescript
public resetHealthCheck(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetLoadBalancer` <a name="resetLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetLoadBalancer"></a>

```typescript
public resetLoadBalancer(): void
```

##### `resetMaxCheckingHealthDuration` <a name="resetMaxCheckingHealthDuration" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetMaxCheckingHealthDuration"></a>

```typescript
public resetMaxCheckingHealthDuration(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetVariables` <a name="resetVariables" id="@cdktf/provider-yandex.ComputeInstanceGroup.resetVariables"></a>

```typescript
public resetVariables(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeInstanceGroup.isConstruct"></a>

```typescript
import { ComputeInstanceGroup } from '@cdktf/provider-yandex'

ComputeInstanceGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeInstanceGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference">ComputeInstanceGroupAllocationPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.applicationLoadBalancer">applicationLoadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference">ComputeInstanceGroupApplicationLoadBalancerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference">ComputeInstanceGroupDeployPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.healthCheck">healthCheck</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList">ComputeInstanceGroupHealthCheckList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.instances">instances</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList">ComputeInstanceGroupInstancesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference">ComputeInstanceGroupInstanceTemplateOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.loadBalancer">loadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference">ComputeInstanceGroupLoadBalancerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference">ComputeInstanceGroupScalePolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference">ComputeInstanceGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.allocationPolicyInput">allocationPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.applicationLoadBalancerInput">applicationLoadBalancerInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.deployPolicyInput">deployPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.healthCheckInput">healthCheckInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.instanceTemplateInput">instanceTemplateInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.loadBalancerInput">loadBalancerInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.maxCheckingHealthDurationInput">maxCheckingHealthDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.scalePolicyInput">scalePolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.variablesInput">variablesInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.maxCheckingHealthDuration">maxCheckingHealthDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.variables">variables</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: ComputeInstanceGroupAllocationPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference">ComputeInstanceGroupAllocationPolicyOutputReference</a>

---

##### `applicationLoadBalancer`<sup>Required</sup> <a name="applicationLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.applicationLoadBalancer"></a>

```typescript
public readonly applicationLoadBalancer: ComputeInstanceGroupApplicationLoadBalancerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference">ComputeInstanceGroupApplicationLoadBalancerOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deployPolicy`<sup>Required</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: ComputeInstanceGroupDeployPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference">ComputeInstanceGroupDeployPolicyOutputReference</a>

---

##### `healthCheck`<sup>Required</sup> <a name="healthCheck" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.healthCheck"></a>

```typescript
public readonly healthCheck: ComputeInstanceGroupHealthCheckList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList">ComputeInstanceGroupHealthCheckList</a>

---

##### `instances`<sup>Required</sup> <a name="instances" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.instances"></a>

```typescript
public readonly instances: ComputeInstanceGroupInstancesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList">ComputeInstanceGroupInstancesList</a>

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: ComputeInstanceGroupInstanceTemplateOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference">ComputeInstanceGroupInstanceTemplateOutputReference</a>

---

##### `loadBalancer`<sup>Required</sup> <a name="loadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.loadBalancer"></a>

```typescript
public readonly loadBalancer: ComputeInstanceGroupLoadBalancerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference">ComputeInstanceGroupLoadBalancerOutputReference</a>

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: ComputeInstanceGroupScalePolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference">ComputeInstanceGroupScalePolicyOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference">ComputeInstanceGroupTimeoutsOutputReference</a>

---

##### `allocationPolicyInput`<sup>Optional</sup> <a name="allocationPolicyInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.allocationPolicyInput"></a>

```typescript
public readonly allocationPolicyInput: ComputeInstanceGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a>

---

##### `applicationLoadBalancerInput`<sup>Optional</sup> <a name="applicationLoadBalancerInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.applicationLoadBalancerInput"></a>

```typescript
public readonly applicationLoadBalancerInput: ComputeInstanceGroupApplicationLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deployPolicyInput`<sup>Optional</sup> <a name="deployPolicyInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.deployPolicyInput"></a>

```typescript
public readonly deployPolicyInput: ComputeInstanceGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `healthCheckInput`<sup>Optional</sup> <a name="healthCheckInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.healthCheckInput"></a>

```typescript
public readonly healthCheckInput: IResolvable | ComputeInstanceGroupHealthCheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `instanceTemplateInput`<sup>Optional</sup> <a name="instanceTemplateInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.instanceTemplateInput"></a>

```typescript
public readonly instanceTemplateInput: ComputeInstanceGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a>

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `loadBalancerInput`<sup>Optional</sup> <a name="loadBalancerInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.loadBalancerInput"></a>

```typescript
public readonly loadBalancerInput: ComputeInstanceGroupLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a>

---

##### `maxCheckingHealthDurationInput`<sup>Optional</sup> <a name="maxCheckingHealthDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.maxCheckingHealthDurationInput"></a>

```typescript
public readonly maxCheckingHealthDurationInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `scalePolicyInput`<sup>Optional</sup> <a name="scalePolicyInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.scalePolicyInput"></a>

```typescript
public readonly scalePolicyInput: ComputeInstanceGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a>

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeInstanceGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a>

---

##### `variablesInput`<sup>Optional</sup> <a name="variablesInput" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.variablesInput"></a>

```typescript
public readonly variablesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maxCheckingHealthDuration`<sup>Required</sup> <a name="maxCheckingHealthDuration" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.maxCheckingHealthDuration"></a>

```typescript
public readonly maxCheckingHealthDuration: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `variables`<sup>Required</sup> <a name="variables" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.variables"></a>

```typescript
public readonly variables: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeInstanceGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputePlacementGroup <a name="ComputePlacementGroup" id="@cdktf/provider-yandex.ComputePlacementGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group yandex_compute_placement_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputePlacementGroup.Initializer"></a>

```typescript
import { ComputePlacementGroup } from '@cdktf/provider-yandex'

new ComputePlacementGroup(scope: Construct, id: string, config?: ComputePlacementGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig">ComputePlacementGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ComputePlacementGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig">ComputePlacementGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputePlacementGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputePlacementGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputePlacementGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputePlacementGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputePlacementGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputePlacementGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputePlacementGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputePlacementGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputePlacementGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputePlacementGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputePlacementGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputePlacementGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputePlacementGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputePlacementGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputePlacementGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputePlacementGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputePlacementGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputePlacementGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputePlacementGroup.isConstruct"></a>

```typescript
import { ComputePlacementGroup } from '@cdktf/provider-yandex'

ComputePlacementGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputePlacementGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference">ComputePlacementGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputePlacementGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputePlacementGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputePlacementGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputePlacementGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputePlacementGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputePlacementGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputePlacementGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputePlacementGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputePlacementGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputePlacementGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputePlacementGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputePlacementGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputePlacementGroup.property.timeouts"></a>

```typescript
public readonly timeouts: ComputePlacementGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference">ComputePlacementGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputePlacementGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputePlacementGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputePlacementGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputePlacementGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputePlacementGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputePlacementGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputePlacementGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputePlacementGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ComputeSnapshot <a name="ComputeSnapshot" id="@cdktf/provider-yandex.ComputeSnapshot"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot yandex_compute_snapshot}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeSnapshot.Initializer"></a>

```typescript
import { ComputeSnapshot } from '@cdktf/provider-yandex'

new ComputeSnapshot(scope: Construct, id: string, config: ComputeSnapshotConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig">ComputeSnapshotConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ComputeSnapshot.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeSnapshotConfig">ComputeSnapshotConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeSnapshot.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ComputeSnapshot.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeSnapshot.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeSnapshot.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ComputeSnapshot.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ComputeSnapshot.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ComputeSnapshot.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ComputeSnapshot.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ComputeSnapshot.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshot.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ComputeSnapshot.putTimeouts"></a>

```typescript
public putTimeouts(value: ComputeSnapshotTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeSnapshot.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeSnapshot.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeSnapshot.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ComputeSnapshot.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeSnapshot.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeSnapshot.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ComputeSnapshot.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ComputeSnapshot.isConstruct"></a>

```typescript
import { ComputeSnapshot } from '@cdktf/provider-yandex'

ComputeSnapshot.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ComputeSnapshot.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.storageSize">storageSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference">ComputeSnapshotTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.sourceDiskIdInput">sourceDiskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.sourceDiskId">sourceDiskId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ComputeSnapshot.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ComputeSnapshot.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeSnapshot.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ComputeSnapshot.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ComputeSnapshot.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ComputeSnapshot.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ComputeSnapshot.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeSnapshot.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeSnapshot.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeSnapshot.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeSnapshot.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ComputeSnapshot.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.ComputeSnapshot.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `storageSize`<sup>Required</sup> <a name="storageSize" id="@cdktf/provider-yandex.ComputeSnapshot.property.storageSize"></a>

```typescript
public readonly storageSize: number;
```

- *Type:* number

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeSnapshot.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeSnapshotTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference">ComputeSnapshotTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `sourceDiskIdInput`<sup>Optional</sup> <a name="sourceDiskIdInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.sourceDiskIdInput"></a>

```typescript
public readonly sourceDiskIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ComputeSnapshot.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ComputeSnapshotTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeSnapshot.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeSnapshot.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ComputeSnapshot.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeSnapshot.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeSnapshot.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `sourceDiskId`<sup>Required</sup> <a name="sourceDiskId" id="@cdktf/provider-yandex.ComputeSnapshot.property.sourceDiskId"></a>

```typescript
public readonly sourceDiskId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshot.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ComputeSnapshot.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ContainerRegistry <a name="ContainerRegistry" id="@cdktf/provider-yandex.ContainerRegistry"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_registry yandex_container_registry}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRegistry.Initializer"></a>

```typescript
import { ContainerRegistry } from '@cdktf/provider-yandex'

new ContainerRegistry(scope: Construct, id: string, config?: ContainerRegistryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig">ContainerRegistryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ContainerRegistry.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRegistryConfig">ContainerRegistryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRegistry.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ContainerRegistry.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ContainerRegistry.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRegistry.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ContainerRegistry.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ContainerRegistry.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ContainerRegistry.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ContainerRegistry.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ContainerRegistry.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRegistry.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistry.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ContainerRegistry.putTimeouts"></a>

```typescript
public putTimeouts(value: ContainerRegistryTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRegistry.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a>

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ContainerRegistry.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ContainerRegistry.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ContainerRegistry.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ContainerRegistry.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ContainerRegistry.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ContainerRegistry.isConstruct"></a>

```typescript
import { ContainerRegistry } from '@cdktf/provider-yandex'

ContainerRegistry.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ContainerRegistry.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference">ContainerRegistryTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ContainerRegistry.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ContainerRegistry.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRegistry.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ContainerRegistry.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ContainerRegistry.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ContainerRegistry.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ContainerRegistry.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRegistry.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRegistry.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRegistry.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRegistry.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ContainerRegistry.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ContainerRegistry.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ContainerRegistry.property.timeouts"></a>

```typescript
public readonly timeouts: ContainerRegistryTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference">ContainerRegistryTimeoutsOutputReference</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ContainerRegistry.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ContainerRegistry.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ContainerRegistry.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ContainerRegistry.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ContainerRegistry.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ContainerRegistryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a>

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ContainerRegistry.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistry.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ContainerRegistry.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ContainerRegistry.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistry.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ContainerRegistry.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ContainerRegistryIamBinding <a name="ContainerRegistryIamBinding" id="@cdktf/provider-yandex.ContainerRegistryIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding yandex_container_registry_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer"></a>

```typescript
import { ContainerRegistryIamBinding } from '@cdktf/provider-yandex'

new ContainerRegistryIamBinding(scope: Construct, id: string, config: ContainerRegistryIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig">ContainerRegistryIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig">ContainerRegistryIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.isConstruct"></a>

```typescript
import { ContainerRegistryIamBinding } from '@cdktf/provider-yandex'

ContainerRegistryIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.registryIdInput">registryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `registryIdInput`<sup>Optional</sup> <a name="registryIdInput" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.registryIdInput"></a>

```typescript
public readonly registryIdInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ContainerRegistryIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ContainerRepository <a name="ContainerRepository" id="@cdktf/provider-yandex.ContainerRepository"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_repository yandex_container_repository}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRepository.Initializer"></a>

```typescript
import { ContainerRepository } from '@cdktf/provider-yandex'

new ContainerRepository(scope: Construct, id: string, config?: ContainerRepositoryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig">ContainerRepositoryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ContainerRepository.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRepositoryConfig">ContainerRepositoryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRepository.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ContainerRepository.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ContainerRepository.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRepository.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ContainerRepository.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ContainerRepository.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ContainerRepository.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ContainerRepository.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ContainerRepository.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRepository.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRepository.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRepository.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRepository.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRepository.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRepository.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRepository.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepository.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ContainerRepository.putTimeouts"></a>

```typescript
public putTimeouts(value: ContainerRepositoryTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRepository.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a>

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ContainerRepository.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ContainerRepository.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ContainerRepository.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ContainerRepository.isConstruct"></a>

```typescript
import { ContainerRepository } from '@cdktf/provider-yandex'

ContainerRepository.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ContainerRepository.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference">ContainerRepositoryTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ContainerRepository.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ContainerRepository.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRepository.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ContainerRepository.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ContainerRepository.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ContainerRepository.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ContainerRepository.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRepository.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRepository.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRepository.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRepository.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ContainerRepository.property.timeouts"></a>

```typescript
public readonly timeouts: ContainerRepositoryTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference">ContainerRepositoryTimeoutsOutputReference</a>

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ContainerRepository.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ContainerRepository.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ContainerRepository.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ContainerRepositoryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a>

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepository.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ContainerRepository.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepository.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ContainerRepository.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ContainerRepositoryIamBinding <a name="ContainerRepositoryIamBinding" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding yandex_container_repository_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer"></a>

```typescript
import { ContainerRepositoryIamBinding } from '@cdktf/provider-yandex'

new ContainerRepositoryIamBinding(scope: Construct, id: string, config: ContainerRepositoryIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig">ContainerRepositoryIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig">ContainerRepositoryIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.isConstruct"></a>

```typescript
import { ContainerRepositoryIamBinding } from '@cdktf/provider-yandex'

ContainerRepositoryIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.repositoryIdInput">repositoryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.repositoryId">repositoryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `repositoryIdInput`<sup>Optional</sup> <a name="repositoryIdInput" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.repositoryIdInput"></a>

```typescript
public readonly repositoryIdInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `repositoryId`<sup>Required</sup> <a name="repositoryId" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.repositoryId"></a>

```typescript
public readonly repositoryId: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ContainerRepositoryIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataprocCluster <a name="DataprocCluster" id="@cdktf/provider-yandex.DataprocCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster yandex_dataproc_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocCluster.Initializer"></a>

```typescript
import { DataprocCluster } from '@cdktf/provider-yandex'

new DataprocCluster(scope: Construct, id: string, config: DataprocClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig">DataprocClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataprocCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterConfig">DataprocClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.putClusterConfig">putClusterConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetBucket">resetBucket</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetHostGroupIds">resetHostGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetUiProxy">resetUiProxy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.resetZoneId">resetZoneId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataprocCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataprocCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataprocCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataprocCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataprocCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataprocCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataprocCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putClusterConfig` <a name="putClusterConfig" id="@cdktf/provider-yandex.DataprocCluster.putClusterConfig"></a>

```typescript
public putClusterConfig(value: DataprocClusterClusterConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocCluster.putClusterConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.DataprocCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: DataprocClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a>

---

##### `resetBucket` <a name="resetBucket" id="@cdktf/provider-yandex.DataprocCluster.resetBucket"></a>

```typescript
public resetBucket(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataprocCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataprocCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataprocCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHostGroupIds` <a name="resetHostGroupIds" id="@cdktf/provider-yandex.DataprocCluster.resetHostGroupIds"></a>

```typescript
public resetHostGroupIds(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataprocCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataprocCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.DataprocCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.DataprocCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetUiProxy` <a name="resetUiProxy" id="@cdktf/provider-yandex.DataprocCluster.resetUiProxy"></a>

```typescript
public resetUiProxy(): void
```

##### `resetZoneId` <a name="resetZoneId" id="@cdktf/provider-yandex.DataprocCluster.resetZoneId"></a>

```typescript
public resetZoneId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataprocCluster.isConstruct"></a>

```typescript
import { DataprocCluster } from '@cdktf/provider-yandex'

DataprocCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataprocCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference">DataprocClusterClusterConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference">DataprocClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.bucketInput">bucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.clusterConfigInput">clusterConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.hostGroupIdsInput">hostGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.uiProxyInput">uiProxyInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.zoneIdInput">zoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.bucket">bucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.uiProxy">uiProxy</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataprocCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataprocCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataprocCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataprocCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataprocCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataprocCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataprocCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataprocCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataprocCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataprocCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.DataprocCluster.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: DataprocClusterClusterConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference">DataprocClusterClusterConfigOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataprocCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataprocCluster.property.timeouts"></a>

```typescript
public readonly timeouts: DataprocClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference">DataprocClusterTimeoutsOutputReference</a>

---

##### `bucketInput`<sup>Optional</sup> <a name="bucketInput" id="@cdktf/provider-yandex.DataprocCluster.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* string

---

##### `clusterConfigInput`<sup>Optional</sup> <a name="clusterConfigInput" id="@cdktf/provider-yandex.DataprocCluster.property.clusterConfigInput"></a>

```typescript
public readonly clusterConfigInput: DataprocClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataprocCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataprocCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataprocCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostGroupIdsInput`<sup>Optional</sup> <a name="hostGroupIdsInput" id="@cdktf/provider-yandex.DataprocCluster.property.hostGroupIdsInput"></a>

```typescript
public readonly hostGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataprocCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataprocCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataprocCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.DataprocCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.DataprocCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.DataprocCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DataprocClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a>

---

##### `uiProxyInput`<sup>Optional</sup> <a name="uiProxyInput" id="@cdktf/provider-yandex.DataprocCluster.property.uiProxyInput"></a>

```typescript
public readonly uiProxyInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `zoneIdInput`<sup>Optional</sup> <a name="zoneIdInput" id="@cdktf/provider-yandex.DataprocCluster.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* string

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="@cdktf/provider-yandex.DataprocCluster.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataprocCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataprocCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataprocCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.DataprocCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataprocCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataprocCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataprocCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataprocCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataprocCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `uiProxy`<sup>Required</sup> <a name="uiProxy" id="@cdktf/provider-yandex.DataprocCluster.property.uiProxy"></a>

```typescript
public readonly uiProxy: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataprocCluster.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataprocCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DatatransferEndpoint <a name="DatatransferEndpoint" id="@cdktf/provider-yandex.DatatransferEndpoint"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint yandex_datatransfer_endpoint}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpoint.Initializer"></a>

```typescript
import { DatatransferEndpoint } from '@cdktf/provider-yandex'

new DatatransferEndpoint(scope: Construct, id: string, config?: DatatransferEndpointConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig">DatatransferEndpointConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DatatransferEndpoint.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointConfig">DatatransferEndpointConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.putSettings">putSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.resetSettings">resetSettings</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpoint.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DatatransferEndpoint.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DatatransferEndpoint.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpoint.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DatatransferEndpoint.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DatatransferEndpoint.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DatatransferEndpoint.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DatatransferEndpoint.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DatatransferEndpoint.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpoint.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putSettings` <a name="putSettings" id="@cdktf/provider-yandex.DatatransferEndpoint.putSettings"></a>

```typescript
public putSettings(value: DatatransferEndpointSettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpoint.putSettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DatatransferEndpoint.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DatatransferEndpoint.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DatatransferEndpoint.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DatatransferEndpoint.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DatatransferEndpoint.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSettings` <a name="resetSettings" id="@cdktf/provider-yandex.DatatransferEndpoint.resetSettings"></a>

```typescript
public resetSettings(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DatatransferEndpoint.isConstruct"></a>

```typescript
import { DatatransferEndpoint } from '@cdktf/provider-yandex'

DatatransferEndpoint.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DatatransferEndpoint.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.author">author</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference">DatatransferEndpointSettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.settingsInput">settingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DatatransferEndpoint.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DatatransferEndpoint.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpoint.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DatatransferEndpoint.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DatatransferEndpoint.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DatatransferEndpoint.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DatatransferEndpoint.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DatatransferEndpoint.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DatatransferEndpoint.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DatatransferEndpoint.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DatatransferEndpoint.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `author`<sup>Required</sup> <a name="author" id="@cdktf/provider-yandex.DatatransferEndpoint.property.author"></a>

```typescript
public readonly author: string;
```

- *Type:* string

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.DatatransferEndpoint.property.settings"></a>

```typescript
public readonly settings: DatatransferEndpointSettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference">DatatransferEndpointSettingsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `settingsInput`<sup>Optional</sup> <a name="settingsInput" id="@cdktf/provider-yandex.DatatransferEndpoint.property.settingsInput"></a>

```typescript
public readonly settingsInput: DatatransferEndpointSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DatatransferEndpoint.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DatatransferEndpoint.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferEndpoint.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DatatransferEndpoint.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DatatransferEndpoint.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpoint.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DatatransferEndpoint.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DatatransferTransfer <a name="DatatransferTransfer" id="@cdktf/provider-yandex.DatatransferTransfer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer yandex_datatransfer_transfer}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferTransfer.Initializer"></a>

```typescript
import { DatatransferTransfer } from '@cdktf/provider-yandex'

new DatatransferTransfer(scope: Construct, id: string, config?: DatatransferTransferConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig">DatatransferTransferConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DatatransferTransfer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferTransferConfig">DatatransferTransferConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetSourceId">resetSourceId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetTargetId">resetTargetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.resetType">resetType</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferTransfer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DatatransferTransfer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DatatransferTransfer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferTransfer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DatatransferTransfer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DatatransferTransfer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DatatransferTransfer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DatatransferTransfer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DatatransferTransfer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferTransfer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DatatransferTransfer.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DatatransferTransfer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DatatransferTransfer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DatatransferTransfer.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DatatransferTransfer.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSourceId` <a name="resetSourceId" id="@cdktf/provider-yandex.DatatransferTransfer.resetSourceId"></a>

```typescript
public resetSourceId(): void
```

##### `resetTargetId` <a name="resetTargetId" id="@cdktf/provider-yandex.DatatransferTransfer.resetTargetId"></a>

```typescript
public resetTargetId(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.DatatransferTransfer.resetType"></a>

```typescript
public resetType(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DatatransferTransfer.isConstruct"></a>

```typescript
import { DatatransferTransfer } from '@cdktf/provider-yandex'

DatatransferTransfer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DatatransferTransfer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.warning">warning</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.sourceIdInput">sourceIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.targetIdInput">targetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.sourceId">sourceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.targetId">targetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.type">type</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DatatransferTransfer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DatatransferTransfer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferTransfer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DatatransferTransfer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DatatransferTransfer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DatatransferTransfer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DatatransferTransfer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DatatransferTransfer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DatatransferTransfer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DatatransferTransfer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DatatransferTransfer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `warning`<sup>Required</sup> <a name="warning" id="@cdktf/provider-yandex.DatatransferTransfer.property.warning"></a>

```typescript
public readonly warning: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `sourceIdInput`<sup>Optional</sup> <a name="sourceIdInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.sourceIdInput"></a>

```typescript
public readonly sourceIdInput: string;
```

- *Type:* string

---

##### `targetIdInput`<sup>Optional</sup> <a name="targetIdInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.targetIdInput"></a>

```typescript
public readonly targetIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.DatatransferTransfer.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DatatransferTransfer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DatatransferTransfer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferTransfer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DatatransferTransfer.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DatatransferTransfer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `sourceId`<sup>Required</sup> <a name="sourceId" id="@cdktf/provider-yandex.DatatransferTransfer.property.sourceId"></a>

```typescript
public readonly sourceId: string;
```

- *Type:* string

---

##### `targetId`<sup>Required</sup> <a name="targetId" id="@cdktf/provider-yandex.DatatransferTransfer.property.targetId"></a>

```typescript
public readonly targetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DatatransferTransfer.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransfer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DatatransferTransfer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexAlbBackendGroup <a name="DataYandexAlbBackendGroup" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group yandex_alb_backend_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroup } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroup(scope: Construct, id: string, config?: DataYandexAlbBackendGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig">DataYandexAlbBackendGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig">DataYandexAlbBackendGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.putGrpcBackend">putGrpcBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.putHttpBackend">putHttpBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.putStreamBackend">putStreamBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetBackendGroupId">resetBackendGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetGrpcBackend">resetGrpcBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetHttpBackend">resetHttpBackend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetStreamBackend">resetStreamBackend</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putGrpcBackend` <a name="putGrpcBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putGrpcBackend"></a>

```typescript
public putGrpcBackend(value: IResolvable | DataYandexAlbBackendGroupGrpcBackend[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putGrpcBackend.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]

---

##### `putHttpBackend` <a name="putHttpBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putHttpBackend"></a>

```typescript
public putHttpBackend(value: IResolvable | DataYandexAlbBackendGroupHttpBackend[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putHttpBackend.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]

---

##### `putStreamBackend` <a name="putStreamBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putStreamBackend"></a>

```typescript
public putStreamBackend(value: IResolvable | DataYandexAlbBackendGroupStreamBackend[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.putStreamBackend.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]

---

##### `resetBackendGroupId` <a name="resetBackendGroupId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetBackendGroupId"></a>

```typescript
public resetBackendGroupId(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetGrpcBackend` <a name="resetGrpcBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetGrpcBackend"></a>

```typescript
public resetGrpcBackend(): void
```

##### `resetHttpBackend` <a name="resetHttpBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetHttpBackend"></a>

```typescript
public resetHttpBackend(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetStreamBackend` <a name="resetStreamBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.resetStreamBackend"></a>

```typescript
public resetStreamBackend(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.isConstruct"></a>

```typescript
import { DataYandexAlbBackendGroup } from '@cdktf/provider-yandex'

DataYandexAlbBackendGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.grpcBackend">grpcBackend</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList">DataYandexAlbBackendGroupGrpcBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.httpBackend">httpBackend</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList">DataYandexAlbBackendGroupHttpBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.streamBackend">streamBackend</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList">DataYandexAlbBackendGroupStreamBackendList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.grpcBackendInput">grpcBackendInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.httpBackendInput">httpBackendInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.streamBackendInput">streamBackendInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `grpcBackend`<sup>Required</sup> <a name="grpcBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.grpcBackend"></a>

```typescript
public readonly grpcBackend: DataYandexAlbBackendGroupGrpcBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList">DataYandexAlbBackendGroupGrpcBackendList</a>

---

##### `httpBackend`<sup>Required</sup> <a name="httpBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.httpBackend"></a>

```typescript
public readonly httpBackend: DataYandexAlbBackendGroupHttpBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList">DataYandexAlbBackendGroupHttpBackendList</a>

---

##### `streamBackend`<sup>Required</sup> <a name="streamBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.streamBackend"></a>

```typescript
public readonly streamBackend: DataYandexAlbBackendGroupStreamBackendList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList">DataYandexAlbBackendGroupStreamBackendList</a>

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `grpcBackendInput`<sup>Optional</sup> <a name="grpcBackendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.grpcBackendInput"></a>

```typescript
public readonly grpcBackendInput: IResolvable | DataYandexAlbBackendGroupGrpcBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]

---

##### `httpBackendInput`<sup>Optional</sup> <a name="httpBackendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.httpBackendInput"></a>

```typescript
public readonly httpBackendInput: IResolvable | DataYandexAlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `streamBackendInput`<sup>Optional</sup> <a name="streamBackendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.streamBackendInput"></a>

```typescript
public readonly streamBackendInput: IResolvable | DataYandexAlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexAlbBackendGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexAlbHttpRouter <a name="DataYandexAlbHttpRouter" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router yandex_alb_http_router}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer"></a>

```typescript
import { DataYandexAlbHttpRouter } from '@cdktf/provider-yandex'

new DataYandexAlbHttpRouter(scope: Construct, id: string, config?: DataYandexAlbHttpRouterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig">DataYandexAlbHttpRouterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig">DataYandexAlbHttpRouterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetHttpRouterId">resetHttpRouterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHttpRouterId` <a name="resetHttpRouterId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetHttpRouterId"></a>

```typescript
public resetHttpRouterId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.isConstruct"></a>

```typescript
import { DataYandexAlbHttpRouter } from '@cdktf/provider-yandex'

DataYandexAlbHttpRouter.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexAlbHttpRouter.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexAlbLoadBalancer <a name="DataYandexAlbLoadBalancer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer yandex_alb_load_balancer}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancer } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancer(scope: Construct, id: string, config?: DataYandexAlbLoadBalancerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig">DataYandexAlbLoadBalancerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig">DataYandexAlbLoadBalancerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetLoadBalancerId">resetLoadBalancerId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.putTimeouts"></a>

```typescript
public putTimeouts(value: DataYandexAlbLoadBalancerTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a>

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLoadBalancerId` <a name="resetLoadBalancerId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetLoadBalancerId"></a>

```typescript
public resetLoadBalancerId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.isConstruct"></a>

```typescript
import { DataYandexAlbLoadBalancer } from '@cdktf/provider-yandex'

DataYandexAlbLoadBalancer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList">DataYandexAlbLoadBalancerAllocationPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.listener">listener</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList">DataYandexAlbLoadBalancerListenerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.regionId">regionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference">DataYandexAlbLoadBalancerTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.loadBalancerIdInput">loadBalancerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.loadBalancerId">loadBalancerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: DataYandexAlbLoadBalancerAllocationPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList">DataYandexAlbLoadBalancerAllocationPolicyList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `listener`<sup>Required</sup> <a name="listener" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.listener"></a>

```typescript
public readonly listener: DataYandexAlbLoadBalancerListenerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList">DataYandexAlbLoadBalancerListenerList</a>

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `regionId`<sup>Required</sup> <a name="regionId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.timeouts"></a>

```typescript
public readonly timeouts: DataYandexAlbLoadBalancerTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference">DataYandexAlbLoadBalancerTimeoutsOutputReference</a>

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `loadBalancerIdInput`<sup>Optional</sup> <a name="loadBalancerIdInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.loadBalancerIdInput"></a>

```typescript
public readonly loadBalancerIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DataYandexAlbLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a>

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `loadBalancerId`<sup>Required</sup> <a name="loadBalancerId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.loadBalancerId"></a>

```typescript
public readonly loadBalancerId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexAlbTargetGroup <a name="DataYandexAlbTargetGroup" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group yandex_alb_target_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer"></a>

```typescript
import { DataYandexAlbTargetGroup } from '@cdktf/provider-yandex'

new DataYandexAlbTargetGroup(scope: Construct, id: string, config?: DataYandexAlbTargetGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig">DataYandexAlbTargetGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig">DataYandexAlbTargetGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetTargetGroupId">resetTargetGroupId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTargetGroupId` <a name="resetTargetGroupId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.resetTargetGroupId"></a>

```typescript
public resetTargetGroupId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.isConstruct"></a>

```typescript
import { DataYandexAlbTargetGroup } from '@cdktf/provider-yandex'

DataYandexAlbTargetGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.target">target</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList">DataYandexAlbTargetGroupTargetList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.targetGroupIdInput">targetGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.target"></a>

```typescript
public readonly target: DataYandexAlbTargetGroupTargetList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList">DataYandexAlbTargetGroupTargetList</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `targetGroupIdInput`<sup>Optional</sup> <a name="targetGroupIdInput" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.targetGroupIdInput"></a>

```typescript
public readonly targetGroupIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexAlbTargetGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexAlbVirtualHost <a name="DataYandexAlbVirtualHost" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host yandex_alb_virtual_host}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHost } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHost(scope: Construct, id: string, config?: DataYandexAlbVirtualHostConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig">DataYandexAlbVirtualHostConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig">DataYandexAlbVirtualHostConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetHttpRouterId">resetHttpRouterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetVirtualHostId">resetVirtualHostId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetHttpRouterId` <a name="resetHttpRouterId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetHttpRouterId"></a>

```typescript
public resetHttpRouterId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetName"></a>

```typescript
public resetName(): void
```

##### `resetVirtualHostId` <a name="resetVirtualHostId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.resetVirtualHostId"></a>

```typescript
public resetVirtualHostId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.isConstruct"></a>

```typescript
import { DataYandexAlbVirtualHost } from '@cdktf/provider-yandex'

DataYandexAlbVirtualHost.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.authority">authority</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.modifyRequestHeaders">modifyRequestHeaders</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList">DataYandexAlbVirtualHostModifyRequestHeadersList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.modifyResponseHeaders">modifyResponseHeaders</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList">DataYandexAlbVirtualHostModifyResponseHeadersList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.route">route</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList">DataYandexAlbVirtualHostRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.virtualHostIdInput">virtualHostIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.virtualHostId">virtualHostId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `authority`<sup>Required</sup> <a name="authority" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.authority"></a>

```typescript
public readonly authority: string[];
```

- *Type:* string[]

---

##### `modifyRequestHeaders`<sup>Required</sup> <a name="modifyRequestHeaders" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.modifyRequestHeaders"></a>

```typescript
public readonly modifyRequestHeaders: DataYandexAlbVirtualHostModifyRequestHeadersList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList">DataYandexAlbVirtualHostModifyRequestHeadersList</a>

---

##### `modifyResponseHeaders`<sup>Required</sup> <a name="modifyResponseHeaders" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.modifyResponseHeaders"></a>

```typescript
public readonly modifyResponseHeaders: DataYandexAlbVirtualHostModifyResponseHeadersList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList">DataYandexAlbVirtualHostModifyResponseHeadersList</a>

---

##### `route`<sup>Required</sup> <a name="route" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.route"></a>

```typescript
public readonly route: DataYandexAlbVirtualHostRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList">DataYandexAlbVirtualHostRouteList</a>

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `virtualHostIdInput`<sup>Optional</sup> <a name="virtualHostIdInput" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.virtualHostIdInput"></a>

```typescript
public readonly virtualHostIdInput: string;
```

- *Type:* string

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `virtualHostId`<sup>Required</sup> <a name="virtualHostId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.virtualHostId"></a>

```typescript
public readonly virtualHostId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexAlbVirtualHost.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexApiGateway <a name="DataYandexApiGateway" id="@cdktf/provider-yandex.DataYandexApiGateway"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway yandex_api_gateway}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexApiGateway.Initializer"></a>

```typescript
import { DataYandexApiGateway } from '@cdktf/provider-yandex'

new DataYandexApiGateway(scope: Construct, id: string, config?: DataYandexApiGatewayConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig">DataYandexApiGatewayConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexApiGateway.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig">DataYandexApiGatewayConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.resetApiGatewayId">resetApiGatewayId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexApiGateway.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexApiGateway.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexApiGateway.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexApiGateway.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexApiGateway.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexApiGateway.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexApiGateway.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexApiGateway.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexApiGateway.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexApiGateway.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetApiGatewayId` <a name="resetApiGatewayId" id="@cdktf/provider-yandex.DataYandexApiGateway.resetApiGatewayId"></a>

```typescript
public resetApiGatewayId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexApiGateway.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexApiGateway.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexApiGateway.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexApiGateway.isConstruct"></a>

```typescript
import { DataYandexApiGateway } from '@cdktf/provider-yandex'

DataYandexApiGateway.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexApiGateway.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.domain">domain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.userDomains">userDomains</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.apiGatewayIdInput">apiGatewayIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.apiGatewayId">apiGatewayId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexApiGateway.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexApiGateway.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexApiGateway.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexApiGateway.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexApiGateway.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexApiGateway.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexApiGateway.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexApiGateway.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexApiGateway.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexApiGateway.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexApiGateway.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexApiGateway.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexApiGateway.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `domain`<sup>Required</sup> <a name="domain" id="@cdktf/provider-yandex.DataYandexApiGateway.property.domain"></a>

```typescript
public readonly domain: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexApiGateway.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.DataYandexApiGateway.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexApiGateway.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `userDomains`<sup>Required</sup> <a name="userDomains" id="@cdktf/provider-yandex.DataYandexApiGateway.property.userDomains"></a>

```typescript
public readonly userDomains: string[];
```

- *Type:* string[]

---

##### `apiGatewayIdInput`<sup>Optional</sup> <a name="apiGatewayIdInput" id="@cdktf/provider-yandex.DataYandexApiGateway.property.apiGatewayIdInput"></a>

```typescript
public readonly apiGatewayIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexApiGateway.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexApiGateway.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexApiGateway.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `apiGatewayId`<sup>Required</sup> <a name="apiGatewayId" id="@cdktf/provider-yandex.DataYandexApiGateway.property.apiGatewayId"></a>

```typescript
public readonly apiGatewayId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexApiGateway.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexApiGateway.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexApiGateway.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGateway.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexApiGateway.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexCdnOriginGroup <a name="DataYandexCdnOriginGroup" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group yandex_cdn_origin_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer"></a>

```typescript
import { DataYandexCdnOriginGroup } from '@cdktf/provider-yandex'

new DataYandexCdnOriginGroup(scope: Construct, id: string, config?: DataYandexCdnOriginGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig">DataYandexCdnOriginGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig">DataYandexCdnOriginGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetOriginGroupId">resetOriginGroupId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetOriginGroupId` <a name="resetOriginGroupId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.resetOriginGroupId"></a>

```typescript
public resetOriginGroupId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.isConstruct"></a>

```typescript
import { DataYandexCdnOriginGroup } from '@cdktf/provider-yandex'

DataYandexCdnOriginGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.origin">origin</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList">DataYandexCdnOriginGroupOriginList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.useNext">useNext</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.originGroupIdInput">originGroupIdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.originGroupId">originGroupId</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `origin`<sup>Required</sup> <a name="origin" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.origin"></a>

```typescript
public readonly origin: DataYandexCdnOriginGroupOriginList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList">DataYandexCdnOriginGroupOriginList</a>

---

##### `useNext`<sup>Required</sup> <a name="useNext" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.useNext"></a>

```typescript
public readonly useNext: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `originGroupIdInput`<sup>Optional</sup> <a name="originGroupIdInput" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.originGroupIdInput"></a>

```typescript
public readonly originGroupIdInput: number;
```

- *Type:* number

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `originGroupId`<sup>Required</sup> <a name="originGroupId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexCdnOriginGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexCdnResource <a name="DataYandexCdnResource" id="@cdktf/provider-yandex.DataYandexCdnResource"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource yandex_cdn_resource}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnResource.Initializer"></a>

```typescript
import { DataYandexCdnResource } from '@cdktf/provider-yandex'

new DataYandexCdnResource(scope: Construct, id: string, config?: DataYandexCdnResourceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig">DataYandexCdnResourceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexCdnResource.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig">DataYandexCdnResourceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.putOptions">putOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.putSslCertificate">putSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetActive">resetActive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetCname">resetCname</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetOptions">resetOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetOriginGroupId">resetOriginGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetOriginGroupName">resetOriginGroupName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetOriginProtocol">resetOriginProtocol</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetResourceId">resetResourceId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetSecondaryHostnames">resetSecondaryHostnames</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetSslCertificate">resetSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.resetUpdatedAt">resetUpdatedAt</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnResource.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexCdnResource.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexCdnResource.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexCdnResource.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexCdnResource.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexCdnResource.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexCdnResource.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexCdnResource.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexCdnResource.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResource.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putOptions` <a name="putOptions" id="@cdktf/provider-yandex.DataYandexCdnResource.putOptions"></a>

```typescript
public putOptions(value: DataYandexCdnResourceOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexCdnResource.putOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a>

---

##### `putSslCertificate` <a name="putSslCertificate" id="@cdktf/provider-yandex.DataYandexCdnResource.putSslCertificate"></a>

```typescript
public putSslCertificate(value: DataYandexCdnResourceSslCertificate): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexCdnResource.putSslCertificate.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a>

---

##### `resetActive` <a name="resetActive" id="@cdktf/provider-yandex.DataYandexCdnResource.resetActive"></a>

```typescript
public resetActive(): void
```

##### `resetCname` <a name="resetCname" id="@cdktf/provider-yandex.DataYandexCdnResource.resetCname"></a>

```typescript
public resetCname(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexCdnResource.resetId"></a>

```typescript
public resetId(): void
```

##### `resetOptions` <a name="resetOptions" id="@cdktf/provider-yandex.DataYandexCdnResource.resetOptions"></a>

```typescript
public resetOptions(): void
```

##### `resetOriginGroupId` <a name="resetOriginGroupId" id="@cdktf/provider-yandex.DataYandexCdnResource.resetOriginGroupId"></a>

```typescript
public resetOriginGroupId(): void
```

##### `resetOriginGroupName` <a name="resetOriginGroupName" id="@cdktf/provider-yandex.DataYandexCdnResource.resetOriginGroupName"></a>

```typescript
public resetOriginGroupName(): void
```

##### `resetOriginProtocol` <a name="resetOriginProtocol" id="@cdktf/provider-yandex.DataYandexCdnResource.resetOriginProtocol"></a>

```typescript
public resetOriginProtocol(): void
```

##### `resetResourceId` <a name="resetResourceId" id="@cdktf/provider-yandex.DataYandexCdnResource.resetResourceId"></a>

```typescript
public resetResourceId(): void
```

##### `resetSecondaryHostnames` <a name="resetSecondaryHostnames" id="@cdktf/provider-yandex.DataYandexCdnResource.resetSecondaryHostnames"></a>

```typescript
public resetSecondaryHostnames(): void
```

##### `resetSslCertificate` <a name="resetSslCertificate" id="@cdktf/provider-yandex.DataYandexCdnResource.resetSslCertificate"></a>

```typescript
public resetSslCertificate(): void
```

##### `resetUpdatedAt` <a name="resetUpdatedAt" id="@cdktf/provider-yandex.DataYandexCdnResource.resetUpdatedAt"></a>

```typescript
public resetUpdatedAt(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexCdnResource.isConstruct"></a>

```typescript
import { DataYandexCdnResource } from '@cdktf/provider-yandex'

DataYandexCdnResource.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexCdnResource.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.options">options</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference">DataYandexCdnResourceOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.sslCertificate">sslCertificate</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference">DataYandexCdnResourceSslCertificateOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.activeInput">activeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.cnameInput">cnameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.optionsInput">optionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupIdInput">originGroupIdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupNameInput">originGroupNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originProtocolInput">originProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.resourceIdInput">resourceIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.secondaryHostnamesInput">secondaryHostnamesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.sslCertificateInput">sslCertificateInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.updatedAtInput">updatedAtInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.active">active</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.cname">cname</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupId">originGroupId</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupName">originGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.originProtocol">originProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.resourceId">resourceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.secondaryHostnames">secondaryHostnames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.updatedAt">updatedAt</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexCdnResource.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexCdnResource.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnResource.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexCdnResource.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexCdnResource.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexCdnResource.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexCdnResource.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexCdnResource.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexCdnResource.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexCdnResource.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexCdnResource.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexCdnResource.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexCdnResource.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `options`<sup>Required</sup> <a name="options" id="@cdktf/provider-yandex.DataYandexCdnResource.property.options"></a>

```typescript
public readonly options: DataYandexCdnResourceOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference">DataYandexCdnResourceOptionsOutputReference</a>

---

##### `sslCertificate`<sup>Required</sup> <a name="sslCertificate" id="@cdktf/provider-yandex.DataYandexCdnResource.property.sslCertificate"></a>

```typescript
public readonly sslCertificate: DataYandexCdnResourceSslCertificateOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference">DataYandexCdnResourceSslCertificateOutputReference</a>

---

##### `activeInput`<sup>Optional</sup> <a name="activeInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.activeInput"></a>

```typescript
public readonly activeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cnameInput`<sup>Optional</sup> <a name="cnameInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.cnameInput"></a>

```typescript
public readonly cnameInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `optionsInput`<sup>Optional</sup> <a name="optionsInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.optionsInput"></a>

```typescript
public readonly optionsInput: DataYandexCdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a>

---

##### `originGroupIdInput`<sup>Optional</sup> <a name="originGroupIdInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupIdInput"></a>

```typescript
public readonly originGroupIdInput: number;
```

- *Type:* number

---

##### `originGroupNameInput`<sup>Optional</sup> <a name="originGroupNameInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupNameInput"></a>

```typescript
public readonly originGroupNameInput: string;
```

- *Type:* string

---

##### `originProtocolInput`<sup>Optional</sup> <a name="originProtocolInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originProtocolInput"></a>

```typescript
public readonly originProtocolInput: string;
```

- *Type:* string

---

##### `resourceIdInput`<sup>Optional</sup> <a name="resourceIdInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.resourceIdInput"></a>

```typescript
public readonly resourceIdInput: string;
```

- *Type:* string

---

##### `secondaryHostnamesInput`<sup>Optional</sup> <a name="secondaryHostnamesInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.secondaryHostnamesInput"></a>

```typescript
public readonly secondaryHostnamesInput: string[];
```

- *Type:* string[]

---

##### `sslCertificateInput`<sup>Optional</sup> <a name="sslCertificateInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.sslCertificateInput"></a>

```typescript
public readonly sslCertificateInput: DataYandexCdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a>

---

##### `updatedAtInput`<sup>Optional</sup> <a name="updatedAtInput" id="@cdktf/provider-yandex.DataYandexCdnResource.property.updatedAtInput"></a>

```typescript
public readonly updatedAtInput: string;
```

- *Type:* string

---

##### `active`<sup>Required</sup> <a name="active" id="@cdktf/provider-yandex.DataYandexCdnResource.property.active"></a>

```typescript
public readonly active: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cname`<sup>Required</sup> <a name="cname" id="@cdktf/provider-yandex.DataYandexCdnResource.property.cname"></a>

```typescript
public readonly cname: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnResource.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `originGroupId`<sup>Required</sup> <a name="originGroupId" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

---

##### `originGroupName`<sup>Required</sup> <a name="originGroupName" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originGroupName"></a>

```typescript
public readonly originGroupName: string;
```

- *Type:* string

---

##### `originProtocol`<sup>Required</sup> <a name="originProtocol" id="@cdktf/provider-yandex.DataYandexCdnResource.property.originProtocol"></a>

```typescript
public readonly originProtocol: string;
```

- *Type:* string

---

##### `resourceId`<sup>Required</sup> <a name="resourceId" id="@cdktf/provider-yandex.DataYandexCdnResource.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* string

---

##### `secondaryHostnames`<sup>Required</sup> <a name="secondaryHostnames" id="@cdktf/provider-yandex.DataYandexCdnResource.property.secondaryHostnames"></a>

```typescript
public readonly secondaryHostnames: string[];
```

- *Type:* string[]

---

##### `updatedAt`<sup>Required</sup> <a name="updatedAt" id="@cdktf/provider-yandex.DataYandexCdnResource.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResource.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexCdnResource.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexClientConfig <a name="DataYandexClientConfig" id="@cdktf/provider-yandex.DataYandexClientConfig"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/client_config yandex_client_config}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexClientConfig.Initializer"></a>

```typescript
import { DataYandexClientConfig } from '@cdktf/provider-yandex'

new DataYandexClientConfig(scope: Construct, id: string, config?: DataYandexClientConfigConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig">DataYandexClientConfigConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexClientConfig.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig">DataYandexClientConfigConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexClientConfig.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexClientConfig.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexClientConfig.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexClientConfig.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexClientConfig.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexClientConfig.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexClientConfig.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexClientConfig.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexClientConfig.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexClientConfig.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexClientConfig.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexClientConfig.isConstruct"></a>

```typescript
import { DataYandexClientConfig } from '@cdktf/provider-yandex'

DataYandexClientConfig.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexClientConfig.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.iamToken">iamToken</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexClientConfig.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexClientConfig.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexClientConfig.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexClientConfig.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexClientConfig.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexClientConfig.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexClientConfig.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexClientConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexClientConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexClientConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexClientConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexClientConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexClientConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `iamToken`<sup>Required</sup> <a name="iamToken" id="@cdktf/provider-yandex.DataYandexClientConfig.property.iamToken"></a>

```typescript
public readonly iamToken: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexClientConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexClientConfig.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexClientConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfig.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexClientConfig.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeDisk <a name="DataYandexComputeDisk" id="@cdktf/provider-yandex.DataYandexComputeDisk"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk yandex_compute_disk}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeDisk.Initializer"></a>

```typescript
import { DataYandexComputeDisk } from '@cdktf/provider-yandex'

new DataYandexComputeDisk(scope: Construct, id: string, config?: DataYandexComputeDiskConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig">DataYandexComputeDiskConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeDisk.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig">DataYandexComputeDiskConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.putDiskPlacementPolicy">putDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetDiskId">resetDiskId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetDiskPlacementPolicy">resetDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeDisk.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeDisk.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeDisk.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeDisk.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDisk.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDisk.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeDisk.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeDisk.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDisk.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putDiskPlacementPolicy` <a name="putDiskPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeDisk.putDiskPlacementPolicy"></a>

```typescript
public putDiskPlacementPolicy(value: DataYandexComputeDiskDiskPlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeDisk.putDiskPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a>

---

##### `resetDiskId` <a name="resetDiskId" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetDiskId"></a>

```typescript
public resetDiskId(): void
```

##### `resetDiskPlacementPolicy` <a name="resetDiskPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetDiskPlacementPolicy"></a>

```typescript
public resetDiskPlacementPolicy(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputeDisk.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeDisk.isConstruct"></a>

```typescript
import { DataYandexComputeDisk } from '@cdktf/provider-yandex'

DataYandexComputeDisk.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeDisk.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.blockSize">blockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.diskPlacementPolicy">diskPlacementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference">DataYandexComputeDiskDiskPlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.instanceIds">instanceIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.productIds">productIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.diskIdInput">diskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.diskPlacementPolicyInput">diskPlacementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `blockSize`<sup>Required</sup> <a name="blockSize" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `diskPlacementPolicy`<sup>Required</sup> <a name="diskPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.diskPlacementPolicy"></a>

```typescript
public readonly diskPlacementPolicy: DataYandexComputeDiskDiskPlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference">DataYandexComputeDiskDiskPlacementPolicyOutputReference</a>

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `instanceIds`<sup>Required</sup> <a name="instanceIds" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.instanceIds"></a>

```typescript
public readonly instanceIds: string[];
```

- *Type:* string[]

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `productIds`<sup>Required</sup> <a name="productIds" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `diskIdInput`<sup>Optional</sup> <a name="diskIdInput" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.diskIdInput"></a>

```typescript
public readonly diskIdInput: string;
```

- *Type:* string

---

##### `diskPlacementPolicyInput`<sup>Optional</sup> <a name="diskPlacementPolicyInput" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.diskPlacementPolicyInput"></a>

```typescript
public readonly diskPlacementPolicyInput: DataYandexComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDisk.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeDisk.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeDiskPlacementGroup <a name="DataYandexComputeDiskPlacementGroup" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group yandex_compute_disk_placement_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer"></a>

```typescript
import { DataYandexComputeDiskPlacementGroup } from '@cdktf/provider-yandex'

new DataYandexComputeDiskPlacementGroup(scope: Construct, id: string, config?: DataYandexComputeDiskPlacementGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig">DataYandexComputeDiskPlacementGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig">DataYandexComputeDiskPlacementGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetGroupId">resetGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetGroupId` <a name="resetGroupId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetGroupId"></a>

```typescript
public resetGroupId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.isConstruct"></a>

```typescript
import { DataYandexComputeDiskPlacementGroup } from '@cdktf/provider-yandex'

DataYandexComputeDiskPlacementGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.groupIdInput">groupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.groupId">groupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `groupIdInput`<sup>Optional</sup> <a name="groupIdInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeImage <a name="DataYandexComputeImage" id="@cdktf/provider-yandex.DataYandexComputeImage"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_image yandex_compute_image}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeImage.Initializer"></a>

```typescript
import { DataYandexComputeImage } from '@cdktf/provider-yandex'

new DataYandexComputeImage(scope: Construct, id: string, config?: DataYandexComputeImageConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig">DataYandexComputeImageConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeImage.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig">DataYandexComputeImageConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetFamily">resetFamily</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetImageId">resetImageId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeImage.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeImage.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeImage.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeImage.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeImage.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeImage.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeImage.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeImage.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeImage.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeImage.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFamily` <a name="resetFamily" id="@cdktf/provider-yandex.DataYandexComputeImage.resetFamily"></a>

```typescript
public resetFamily(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputeImage.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeImage.resetId"></a>

```typescript
public resetId(): void
```

##### `resetImageId` <a name="resetImageId" id="@cdktf/provider-yandex.DataYandexComputeImage.resetImageId"></a>

```typescript
public resetImageId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputeImage.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeImage.isConstruct"></a>

```typescript
import { DataYandexComputeImage } from '@cdktf/provider-yandex'

DataYandexComputeImage.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeImage.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.minDiskSize">minDiskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.osType">osType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.pooled">pooled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.productIds">productIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.familyInput">familyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.imageIdInput">imageIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.family">family</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeImage.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeImage.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeImage.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeImage.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeImage.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeImage.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeImage.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeImage.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeImage.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeImage.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeImage.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeImage.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeImage.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeImage.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `minDiskSize`<sup>Required</sup> <a name="minDiskSize" id="@cdktf/provider-yandex.DataYandexComputeImage.property.minDiskSize"></a>

```typescript
public readonly minDiskSize: number;
```

- *Type:* number

---

##### `osType`<sup>Required</sup> <a name="osType" id="@cdktf/provider-yandex.DataYandexComputeImage.property.osType"></a>

```typescript
public readonly osType: string;
```

- *Type:* string

---

##### `pooled`<sup>Required</sup> <a name="pooled" id="@cdktf/provider-yandex.DataYandexComputeImage.property.pooled"></a>

```typescript
public readonly pooled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `productIds`<sup>Required</sup> <a name="productIds" id="@cdktf/provider-yandex.DataYandexComputeImage.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeImage.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeImage.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `familyInput`<sup>Optional</sup> <a name="familyInput" id="@cdktf/provider-yandex.DataYandexComputeImage.property.familyInput"></a>

```typescript
public readonly familyInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputeImage.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeImage.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `imageIdInput`<sup>Optional</sup> <a name="imageIdInput" id="@cdktf/provider-yandex.DataYandexComputeImage.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputeImage.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `family`<sup>Required</sup> <a name="family" id="@cdktf/provider-yandex.DataYandexComputeImage.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeImage.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeImage.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeImage.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeImage.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImage.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeImage.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeInstance <a name="DataYandexComputeInstance" id="@cdktf/provider-yandex.DataYandexComputeInstance"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance yandex_compute_instance}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstance.Initializer"></a>

```typescript
import { DataYandexComputeInstance } from '@cdktf/provider-yandex'

new DataYandexComputeInstance(scope: Construct, id: string, config?: DataYandexComputeInstanceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig">DataYandexComputeInstanceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeInstance.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig">DataYandexComputeInstanceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.putPlacementPolicy">putPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetInstanceId">resetInstanceId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.resetPlacementPolicy">resetPlacementPolicy</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstance.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeInstance.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeInstance.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeInstance.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstance.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstance.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeInstance.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeInstance.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstance.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putPlacementPolicy` <a name="putPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstance.putPlacementPolicy"></a>

```typescript
public putPlacementPolicy(value: DataYandexComputeInstancePlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeInstance.putPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a>

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetId"></a>

```typescript
public resetId(): void
```

##### `resetInstanceId` <a name="resetInstanceId" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetInstanceId"></a>

```typescript
public resetInstanceId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetName"></a>

```typescript
public resetName(): void
```

##### `resetPlacementPolicy` <a name="resetPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstance.resetPlacementPolicy"></a>

```typescript
public resetPlacementPolicy(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeInstance.isConstruct"></a>

```typescript
import { DataYandexComputeInstance } from '@cdktf/provider-yandex'

DataYandexComputeInstance.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeInstance.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList">DataYandexComputeInstanceBootDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.metadata">metadata</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList">DataYandexComputeInstanceNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference">DataYandexComputeInstancePlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList">DataYandexComputeInstanceResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList">DataYandexComputeInstanceSchedulingPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.secondaryDisk">secondaryDisk</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList">DataYandexComputeInstanceSecondaryDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.instanceIdInput">instanceIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.placementPolicyInput">placementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.instanceId">instanceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.bootDisk"></a>

```typescript
public readonly bootDisk: DataYandexComputeInstanceBootDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList">DataYandexComputeInstanceBootDiskList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `networkAccelerationType`<sup>Required</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.networkInterface"></a>

```typescript
public readonly networkInterface: DataYandexComputeInstanceNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList">DataYandexComputeInstanceNetworkInterfaceList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: DataYandexComputeInstancePlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference">DataYandexComputeInstancePlacementPolicyOutputReference</a>

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.resources"></a>

```typescript
public readonly resources: DataYandexComputeInstanceResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList">DataYandexComputeInstanceResourcesList</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: DataYandexComputeInstanceSchedulingPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList">DataYandexComputeInstanceSchedulingPolicyList</a>

---

##### `secondaryDisk`<sup>Required</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: DataYandexComputeInstanceSecondaryDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList">DataYandexComputeInstanceSecondaryDiskList</a>

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `instanceIdInput`<sup>Optional</sup> <a name="instanceIdInput" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.instanceIdInput"></a>

```typescript
public readonly instanceIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `placementPolicyInput`<sup>Optional</sup> <a name="placementPolicyInput" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.placementPolicyInput"></a>

```typescript
public readonly placementPolicyInput: DataYandexComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a>

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `instanceId`<sup>Required</sup> <a name="instanceId" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstance.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeInstance.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeInstanceGroup <a name="DataYandexComputeInstanceGroup" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group yandex_compute_instance_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroup } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroup(scope: Construct, id: string, config: DataYandexComputeInstanceGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig">DataYandexComputeInstanceGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig">DataYandexComputeInstanceGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.isConstruct"></a>

```typescript
import { DataYandexComputeInstanceGroup } from '@cdktf/provider-yandex'

DataYandexComputeInstanceGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList">DataYandexComputeInstanceGroupAllocationPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.applicationBalancerState">applicationBalancerState</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList">DataYandexComputeInstanceGroupApplicationBalancerStateList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.applicationLoadBalancer">applicationLoadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList">DataYandexComputeInstanceGroupApplicationLoadBalancerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.deletionProtection">deletionProtection</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList">DataYandexComputeInstanceGroupDeployPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.healthCheck">healthCheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList">DataYandexComputeInstanceGroupHealthCheckList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instances">instances</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList">DataYandexComputeInstanceGroupInstancesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList">DataYandexComputeInstanceGroupInstanceTemplateList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.loadBalancer">loadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList">DataYandexComputeInstanceGroupLoadBalancerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.loadBalancerState">loadBalancerState</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList">DataYandexComputeInstanceGroupLoadBalancerStateList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.maxCheckingHealthDuration">maxCheckingHealthDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList">DataYandexComputeInstanceGroupScalePolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.variables">variables</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceGroupIdInput">instanceGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceGroupId">instanceGroupId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: DataYandexComputeInstanceGroupAllocationPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList">DataYandexComputeInstanceGroupAllocationPolicyList</a>

---

##### `applicationBalancerState`<sup>Required</sup> <a name="applicationBalancerState" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.applicationBalancerState"></a>

```typescript
public readonly applicationBalancerState: DataYandexComputeInstanceGroupApplicationBalancerStateList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList">DataYandexComputeInstanceGroupApplicationBalancerStateList</a>

---

##### `applicationLoadBalancer`<sup>Required</sup> <a name="applicationLoadBalancer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.applicationLoadBalancer"></a>

```typescript
public readonly applicationLoadBalancer: DataYandexComputeInstanceGroupApplicationLoadBalancerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList">DataYandexComputeInstanceGroupApplicationLoadBalancerList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `deployPolicy`<sup>Required</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: DataYandexComputeInstanceGroupDeployPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList">DataYandexComputeInstanceGroupDeployPolicyList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `healthCheck`<sup>Required</sup> <a name="healthCheck" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.healthCheck"></a>

```typescript
public readonly healthCheck: DataYandexComputeInstanceGroupHealthCheckList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList">DataYandexComputeInstanceGroupHealthCheckList</a>

---

##### `instances`<sup>Required</sup> <a name="instances" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instances"></a>

```typescript
public readonly instances: DataYandexComputeInstanceGroupInstancesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList">DataYandexComputeInstanceGroupInstancesList</a>

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: DataYandexComputeInstanceGroupInstanceTemplateList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList">DataYandexComputeInstanceGroupInstanceTemplateList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `loadBalancer`<sup>Required</sup> <a name="loadBalancer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.loadBalancer"></a>

```typescript
public readonly loadBalancer: DataYandexComputeInstanceGroupLoadBalancerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList">DataYandexComputeInstanceGroupLoadBalancerList</a>

---

##### `loadBalancerState`<sup>Required</sup> <a name="loadBalancerState" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.loadBalancerState"></a>

```typescript
public readonly loadBalancerState: DataYandexComputeInstanceGroupLoadBalancerStateList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList">DataYandexComputeInstanceGroupLoadBalancerStateList</a>

---

##### `maxCheckingHealthDuration`<sup>Required</sup> <a name="maxCheckingHealthDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.maxCheckingHealthDuration"></a>

```typescript
public readonly maxCheckingHealthDuration: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: DataYandexComputeInstanceGroupScalePolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList">DataYandexComputeInstanceGroupScalePolicyList</a>

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `variables`<sup>Required</sup> <a name="variables" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.variables"></a>

```typescript
public readonly variables: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `instanceGroupIdInput`<sup>Optional</sup> <a name="instanceGroupIdInput" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceGroupIdInput"></a>

```typescript
public readonly instanceGroupIdInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `instanceGroupId`<sup>Required</sup> <a name="instanceGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.instanceGroupId"></a>

```typescript
public readonly instanceGroupId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputePlacementGroup <a name="DataYandexComputePlacementGroup" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group yandex_compute_placement_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer"></a>

```typescript
import { DataYandexComputePlacementGroup } from '@cdktf/provider-yandex'

new DataYandexComputePlacementGroup(scope: Construct, id: string, config?: DataYandexComputePlacementGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig">DataYandexComputePlacementGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig">DataYandexComputePlacementGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetGroupId">resetGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetGroupId` <a name="resetGroupId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetGroupId"></a>

```typescript
public resetGroupId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.isConstruct"></a>

```typescript
import { DataYandexComputePlacementGroup } from '@cdktf/provider-yandex'

DataYandexComputePlacementGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.groupIdInput">groupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.groupId">groupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `groupIdInput`<sup>Optional</sup> <a name="groupIdInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputePlacementGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexComputeSnapshot <a name="DataYandexComputeSnapshot" id="@cdktf/provider-yandex.DataYandexComputeSnapshot"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot yandex_compute_snapshot}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer"></a>

```typescript
import { DataYandexComputeSnapshot } from '@cdktf/provider-yandex'

new DataYandexComputeSnapshot(scope: Construct, id: string, config?: DataYandexComputeSnapshotConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig">DataYandexComputeSnapshotConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig">DataYandexComputeSnapshotConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.resetSnapshotId">resetSnapshotId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSnapshotId` <a name="resetSnapshotId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.resetSnapshotId"></a>

```typescript
public resetSnapshotId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.isConstruct"></a>

```typescript
import { DataYandexComputeSnapshot } from '@cdktf/provider-yandex'

DataYandexComputeSnapshot.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.productIds">productIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.sourceDiskId">sourceDiskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.storageSize">storageSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.snapshotIdInput">snapshotIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `productIds`<sup>Required</sup> <a name="productIds" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

---

##### `sourceDiskId`<sup>Required</sup> <a name="sourceDiskId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.sourceDiskId"></a>

```typescript
public readonly sourceDiskId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `storageSize`<sup>Required</sup> <a name="storageSize" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.storageSize"></a>

```typescript
public readonly storageSize: number;
```

- *Type:* number

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="snapshotIdInput" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshot.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexComputeSnapshot.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexContainerRegistry <a name="DataYandexContainerRegistry" id="@cdktf/provider-yandex.DataYandexContainerRegistry"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/container_registry yandex_container_registry}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer"></a>

```typescript
import { DataYandexContainerRegistry } from '@cdktf/provider-yandex'

new DataYandexContainerRegistry(scope: Construct, id: string, config?: DataYandexContainerRegistryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig">DataYandexContainerRegistryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexContainerRegistry.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig">DataYandexContainerRegistryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.resetRegistryId">resetRegistryId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexContainerRegistry.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexContainerRegistry.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexContainerRegistry.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexContainerRegistry.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexContainerRegistry.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexContainerRegistry.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRegistry.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRegistryId` <a name="resetRegistryId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.resetRegistryId"></a>

```typescript
public resetRegistryId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexContainerRegistry.isConstruct"></a>

```typescript
import { DataYandexContainerRegistry } from '@cdktf/provider-yandex'

DataYandexContainerRegistry.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexContainerRegistry.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.registryIdInput">registryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `registryIdInput`<sup>Optional</sup> <a name="registryIdInput" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.registryIdInput"></a>

```typescript
public readonly registryIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistry.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexContainerRegistry.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexContainerRepository <a name="DataYandexContainerRepository" id="@cdktf/provider-yandex.DataYandexContainerRepository"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/container_repository yandex_container_repository}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexContainerRepository.Initializer"></a>

```typescript
import { DataYandexContainerRepository } from '@cdktf/provider-yandex'

new DataYandexContainerRepository(scope: Construct, id: string, config?: DataYandexContainerRepositoryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig">DataYandexContainerRepositoryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexContainerRepository.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig">DataYandexContainerRepositoryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.resetRepositoryId">resetRepositoryId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexContainerRepository.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexContainerRepository.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexContainerRepository.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexContainerRepository.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRepository.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRepository.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexContainerRepository.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexContainerRepository.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexContainerRepository.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexContainerRepository.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexContainerRepository.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexContainerRepository.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRepositoryId` <a name="resetRepositoryId" id="@cdktf/provider-yandex.DataYandexContainerRepository.resetRepositoryId"></a>

```typescript
public resetRepositoryId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexContainerRepository.isConstruct"></a>

```typescript
import { DataYandexContainerRepository } from '@cdktf/provider-yandex'

DataYandexContainerRepository.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexContainerRepository.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.repositoryIdInput">repositoryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.repositoryId">repositoryId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `repositoryIdInput`<sup>Optional</sup> <a name="repositoryIdInput" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.repositoryIdInput"></a>

```typescript
public readonly repositoryIdInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `repositoryId`<sup>Required</sup> <a name="repositoryId" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.repositoryId"></a>

```typescript
public readonly repositoryId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepository.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexContainerRepository.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexDataprocCluster <a name="DataYandexDataprocCluster" id="@cdktf/provider-yandex.DataYandexDataprocCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster yandex_dataproc_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer"></a>

```typescript
import { DataYandexDataprocCluster } from '@cdktf/provider-yandex'

new DataYandexDataprocCluster(scope: Construct, id: string, config?: DataYandexDataprocClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig">DataYandexDataprocClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexDataprocCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig">DataYandexDataprocClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexDataprocCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexDataprocCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexDataprocCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexDataprocCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexDataprocCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexDataprocCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexDataprocCluster.isConstruct"></a>

```typescript
import { DataYandexDataprocCluster } from '@cdktf/provider-yandex'

DataYandexDataprocCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexDataprocCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.bucket">bucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList">DataYandexDataprocClusterClusterConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.deletionProtection">deletionProtection</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.uiProxy">uiProxy</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: DataYandexDataprocClusterClusterConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList">DataYandexDataprocClusterClusterConfigList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `uiProxy`<sup>Required</sup> <a name="uiProxy" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.uiProxy"></a>

```typescript
public readonly uiProxy: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexDataprocCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexDnsZone <a name="DataYandexDnsZone" id="@cdktf/provider-yandex.DataYandexDnsZone"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone yandex_dns_zone}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDnsZone.Initializer"></a>

```typescript
import { DataYandexDnsZone } from '@cdktf/provider-yandex'

new DataYandexDnsZone(scope: Construct, id: string, config?: DataYandexDnsZoneConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig">DataYandexDnsZoneConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexDnsZone.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig">DataYandexDnsZoneConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDnsZone.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexDnsZone.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexDnsZone.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexDnsZone.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexDnsZone.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexDnsZone.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexDnsZone.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexDnsZone.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexDnsZone.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZone.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.DataYandexDnsZone.putTimeouts"></a>

```typescript
public putTimeouts(value: DataYandexDnsZoneTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexDnsZone.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a>

---

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.DataYandexDnsZone.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexDnsZone.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexDnsZone.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexDnsZone.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.DataYandexDnsZone.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexDnsZone.isConstruct"></a>

```typescript
import { DataYandexDnsZone } from '@cdktf/provider-yandex'

DataYandexDnsZone.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexDnsZone.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.privateNetworks">privateNetworks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.public">public</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference">DataYandexDnsZoneTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexDnsZone.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexDnsZone.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDnsZone.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexDnsZone.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexDnsZone.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexDnsZone.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexDnsZone.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexDnsZone.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexDnsZone.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexDnsZone.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexDnsZone.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexDnsZone.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexDnsZone.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexDnsZone.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `privateNetworks`<sup>Required</sup> <a name="privateNetworks" id="@cdktf/provider-yandex.DataYandexDnsZone.property.privateNetworks"></a>

```typescript
public readonly privateNetworks: string[];
```

- *Type:* string[]

---

##### `public`<sup>Required</sup> <a name="public" id="@cdktf/provider-yandex.DataYandexDnsZone.property.public"></a>

```typescript
public readonly public: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataYandexDnsZone.property.timeouts"></a>

```typescript
public readonly timeouts: DataYandexDnsZoneTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference">DataYandexDnsZoneTimeoutsOutputReference</a>

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexDnsZone.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.DataYandexDnsZone.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexDnsZone.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexDnsZone.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexDnsZone.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.DataYandexDnsZone.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DataYandexDnsZoneTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a>

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexDnsZone.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexDnsZone.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDnsZone.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexDnsZone.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZone.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexDnsZone.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexFunction <a name="DataYandexFunction" id="@cdktf/provider-yandex.DataYandexFunction"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function yandex_function}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunction.Initializer"></a>

```typescript
import { DataYandexFunction } from '@cdktf/provider-yandex'

new DataYandexFunction(scope: Construct, id: string, config?: DataYandexFunctionConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig">DataYandexFunctionConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexFunction.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionConfig">DataYandexFunctionConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.resetFunctionId">resetFunctionId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunction.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexFunction.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexFunction.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexFunction.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunction.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexFunction.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunction.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexFunction.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexFunction.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunction.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunction.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexFunction.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetFunctionId` <a name="resetFunctionId" id="@cdktf/provider-yandex.DataYandexFunction.resetFunctionId"></a>

```typescript
public resetFunctionId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexFunction.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexFunction.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexFunction.isConstruct"></a>

```typescript
import { DataYandexFunction } from '@cdktf/provider-yandex'

DataYandexFunction.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexFunction.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.entrypoint">entrypoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.environment">environment</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.imageSize">imageSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.loggroupId">loggroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.runtime">runtime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.functionIdInput">functionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.functionId">functionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexFunction.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexFunction.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunction.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexFunction.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexFunction.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexFunction.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexFunction.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunction.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunction.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunction.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunction.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexFunction.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexFunction.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `entrypoint`<sup>Required</sup> <a name="entrypoint" id="@cdktf/provider-yandex.DataYandexFunction.property.entrypoint"></a>

```typescript
public readonly entrypoint: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexFunction.property.environment"></a>

```typescript
public readonly environment: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `executionTimeout`<sup>Required</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.DataYandexFunction.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

---

##### `imageSize`<sup>Required</sup> <a name="imageSize" id="@cdktf/provider-yandex.DataYandexFunction.property.imageSize"></a>

```typescript
public readonly imageSize: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexFunction.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `loggroupId`<sup>Required</sup> <a name="loggroupId" id="@cdktf/provider-yandex.DataYandexFunction.property.loggroupId"></a>

```typescript
public readonly loggroupId: string;
```

- *Type:* string

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.DataYandexFunction.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `runtime`<sup>Required</sup> <a name="runtime" id="@cdktf/provider-yandex.DataYandexFunction.property.runtime"></a>

```typescript
public readonly runtime: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexFunction.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `tags`<sup>Required</sup> <a name="tags" id="@cdktf/provider-yandex.DataYandexFunction.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexFunction.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexFunction.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `functionIdInput`<sup>Optional</sup> <a name="functionIdInput" id="@cdktf/provider-yandex.DataYandexFunction.property.functionIdInput"></a>

```typescript
public readonly functionIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexFunction.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexFunction.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexFunction.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.DataYandexFunction.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunction.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexFunction.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunction.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexFunction.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexFunctionScalingPolicy <a name="DataYandexFunctionScalingPolicy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy yandex_function_scaling_policy}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer"></a>

```typescript
import { DataYandexFunctionScalingPolicy } from '@cdktf/provider-yandex'

new DataYandexFunctionScalingPolicy(scope: Construct, id: string, config: DataYandexFunctionScalingPolicyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig">DataYandexFunctionScalingPolicyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig">DataYandexFunctionScalingPolicyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.putPolicy">putPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetPolicy">resetPolicy</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putPolicy` <a name="putPolicy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.putPolicy"></a>

```typescript
public putPolicy(value: IResolvable | DataYandexFunctionScalingPolicyPolicy[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.putPolicy.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetId"></a>

```typescript
public resetId(): void
```

##### `resetPolicy` <a name="resetPolicy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.resetPolicy"></a>

```typescript
public resetPolicy(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.isConstruct"></a>

```typescript
import { DataYandexFunctionScalingPolicy } from '@cdktf/provider-yandex'

DataYandexFunctionScalingPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.policy">policy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList">DataYandexFunctionScalingPolicyPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.functionIdInput">functionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.policyInput">policyInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.functionId">functionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `policy`<sup>Required</sup> <a name="policy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.policy"></a>

```typescript
public readonly policy: DataYandexFunctionScalingPolicyPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList">DataYandexFunctionScalingPolicyPolicyList</a>

---

##### `functionIdInput`<sup>Optional</sup> <a name="functionIdInput" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.functionIdInput"></a>

```typescript
public readonly functionIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `policyInput`<sup>Optional</sup> <a name="policyInput" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.policyInput"></a>

```typescript
public readonly policyInput: IResolvable | DataYandexFunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicy.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexFunctionTrigger <a name="DataYandexFunctionTrigger" id="@cdktf/provider-yandex.DataYandexFunctionTrigger"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger yandex_function_trigger}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer"></a>

```typescript
import { DataYandexFunctionTrigger } from '@cdktf/provider-yandex'

new DataYandexFunctionTrigger(scope: Construct, id: string, config?: DataYandexFunctionTriggerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig">DataYandexFunctionTriggerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig">DataYandexFunctionTriggerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.resetTriggerId">resetTriggerId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTriggerId` <a name="resetTriggerId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.resetTriggerId"></a>

```typescript
public resetTriggerId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.isConstruct"></a>

```typescript
import { DataYandexFunctionTrigger } from '@cdktf/provider-yandex'

DataYandexFunctionTrigger.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.dlq">dlq</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList">DataYandexFunctionTriggerDlqList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.function">function</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList">DataYandexFunctionTriggerFunctionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.iot">iot</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList">DataYandexFunctionTriggerIotList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.logging">logging</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList">DataYandexFunctionTriggerLoggingList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.logGroup">logGroup</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList">DataYandexFunctionTriggerLogGroupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.messageQueue">messageQueue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList">DataYandexFunctionTriggerMessageQueueList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.objectStorage">objectStorage</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList">DataYandexFunctionTriggerObjectStorageList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.timer">timer</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList">DataYandexFunctionTriggerTimerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.triggerIdInput">triggerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.triggerId">triggerId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `dlq`<sup>Required</sup> <a name="dlq" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.dlq"></a>

```typescript
public readonly dlq: DataYandexFunctionTriggerDlqList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList">DataYandexFunctionTriggerDlqList</a>

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.function"></a>

```typescript
public readonly function: DataYandexFunctionTriggerFunctionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList">DataYandexFunctionTriggerFunctionList</a>

---

##### `iot`<sup>Required</sup> <a name="iot" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.iot"></a>

```typescript
public readonly iot: DataYandexFunctionTriggerIotList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList">DataYandexFunctionTriggerIotList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `logging`<sup>Required</sup> <a name="logging" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.logging"></a>

```typescript
public readonly logging: DataYandexFunctionTriggerLoggingList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList">DataYandexFunctionTriggerLoggingList</a>

---

##### `logGroup`<sup>Required</sup> <a name="logGroup" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.logGroup"></a>

```typescript
public readonly logGroup: DataYandexFunctionTriggerLogGroupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList">DataYandexFunctionTriggerLogGroupList</a>

---

##### `messageQueue`<sup>Required</sup> <a name="messageQueue" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.messageQueue"></a>

```typescript
public readonly messageQueue: DataYandexFunctionTriggerMessageQueueList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList">DataYandexFunctionTriggerMessageQueueList</a>

---

##### `objectStorage`<sup>Required</sup> <a name="objectStorage" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.objectStorage"></a>

```typescript
public readonly objectStorage: DataYandexFunctionTriggerObjectStorageList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList">DataYandexFunctionTriggerObjectStorageList</a>

---

##### `timer`<sup>Required</sup> <a name="timer" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.timer"></a>

```typescript
public readonly timer: DataYandexFunctionTriggerTimerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList">DataYandexFunctionTriggerTimerList</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `triggerIdInput`<sup>Optional</sup> <a name="triggerIdInput" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.triggerIdInput"></a>

```typescript
public readonly triggerIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `triggerId`<sup>Required</sup> <a name="triggerId" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.triggerId"></a>

```typescript
public readonly triggerId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTrigger.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexFunctionTrigger.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIamPolicy <a name="DataYandexIamPolicy" id="@cdktf/provider-yandex.DataYandexIamPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy yandex_iam_policy}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamPolicy.Initializer"></a>

```typescript
import { DataYandexIamPolicy } from '@cdktf/provider-yandex'

new DataYandexIamPolicy(scope: Construct, id: string, config: DataYandexIamPolicyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig">DataYandexIamPolicyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIamPolicy.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig">DataYandexIamPolicyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.putBinding">putBinding</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIamPolicy.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIamPolicy.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIamPolicy.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamPolicy.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIamPolicy.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamPolicy.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIamPolicy.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIamPolicy.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicy.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putBinding` <a name="putBinding" id="@cdktf/provider-yandex.DataYandexIamPolicy.putBinding"></a>

```typescript
public putBinding(value: IResolvable | DataYandexIamPolicyBinding[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIamPolicy.putBinding.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIamPolicy.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIamPolicy.isConstruct"></a>

```typescript
import { DataYandexIamPolicy } from '@cdktf/provider-yandex'

DataYandexIamPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIamPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.binding">binding</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList">DataYandexIamPolicyBindingList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.policyData">policyData</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.bindingInput">bindingInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `binding`<sup>Required</sup> <a name="binding" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.binding"></a>

```typescript
public readonly binding: DataYandexIamPolicyBindingList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList">DataYandexIamPolicyBindingList</a>

---

##### `policyData`<sup>Required</sup> <a name="policyData" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.policyData"></a>

```typescript
public readonly policyData: string;
```

- *Type:* string

---

##### `bindingInput`<sup>Optional</sup> <a name="bindingInput" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.bindingInput"></a>

```typescript
public readonly bindingInput: IResolvable | DataYandexIamPolicyBinding[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicy.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIamPolicy.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIamRole <a name="DataYandexIamRole" id="@cdktf/provider-yandex.DataYandexIamRole"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_role yandex_iam_role}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamRole.Initializer"></a>

```typescript
import { DataYandexIamRole } from '@cdktf/provider-yandex'

new DataYandexIamRole(scope: Construct, id: string, config?: DataYandexIamRoleConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig">DataYandexIamRoleConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIamRole.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig">DataYandexIamRoleConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.resetRoleId">resetRoleId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamRole.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIamRole.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIamRole.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIamRole.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamRole.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIamRole.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamRole.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIamRole.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIamRole.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamRole.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexIamRole.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIamRole.resetId"></a>

```typescript
public resetId(): void
```

##### `resetRoleId` <a name="resetRoleId" id="@cdktf/provider-yandex.DataYandexIamRole.resetRoleId"></a>

```typescript
public resetRoleId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIamRole.isConstruct"></a>

```typescript
import { DataYandexIamRole } from '@cdktf/provider-yandex'

DataYandexIamRole.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIamRole.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.roleIdInput">roleIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.roleId">roleId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIamRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIamRole.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamRole.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIamRole.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIamRole.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIamRole.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIamRole.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamRole.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamRole.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamRole.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamRole.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexIamRole.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIamRole.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `roleIdInput`<sup>Optional</sup> <a name="roleIdInput" id="@cdktf/provider-yandex.DataYandexIamRole.property.roleIdInput"></a>

```typescript
public readonly roleIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexIamRole.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamRole.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `roleId`<sup>Required</sup> <a name="roleId" id="@cdktf/provider-yandex.DataYandexIamRole.property.roleId"></a>

```typescript
public readonly roleId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRole.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIamRole.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIamServiceAccount <a name="DataYandexIamServiceAccount" id="@cdktf/provider-yandex.DataYandexIamServiceAccount"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account yandex_iam_service_account}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer"></a>

```typescript
import { DataYandexIamServiceAccount } from '@cdktf/provider-yandex'

new DataYandexIamServiceAccount(scope: Construct, id: string, config?: DataYandexIamServiceAccountConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig">DataYandexIamServiceAccountConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig">DataYandexIamServiceAccountConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.resetName"></a>

```typescript
public resetName(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.isConstruct"></a>

```typescript
import { DataYandexIamServiceAccount } from '@cdktf/provider-yandex'

DataYandexIamServiceAccount.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccount.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIamServiceAccount.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIamUser <a name="DataYandexIamUser" id="@cdktf/provider-yandex.DataYandexIamUser"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iam_user yandex_iam_user}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamUser.Initializer"></a>

```typescript
import { DataYandexIamUser } from '@cdktf/provider-yandex'

new DataYandexIamUser(scope: Construct, id: string, config?: DataYandexIamUserConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig">DataYandexIamUserConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIamUser.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIamUserConfig">DataYandexIamUserConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.resetLogin">resetLogin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.resetUserId">resetUserId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamUser.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIamUser.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIamUser.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIamUser.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamUser.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIamUser.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIamUser.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIamUser.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIamUser.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamUser.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIamUser.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLogin` <a name="resetLogin" id="@cdktf/provider-yandex.DataYandexIamUser.resetLogin"></a>

```typescript
public resetLogin(): void
```

##### `resetUserId` <a name="resetUserId" id="@cdktf/provider-yandex.DataYandexIamUser.resetUserId"></a>

```typescript
public resetUserId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIamUser.isConstruct"></a>

```typescript
import { DataYandexIamUser } from '@cdktf/provider-yandex'

DataYandexIamUser.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIamUser.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.defaultEmail">defaultEmail</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.loginInput">loginInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.userIdInput">userIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.login">login</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.userId">userId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIamUser.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIamUser.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamUser.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIamUser.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIamUser.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIamUser.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIamUser.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamUser.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamUser.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamUser.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamUser.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `defaultEmail`<sup>Required</sup> <a name="defaultEmail" id="@cdktf/provider-yandex.DataYandexIamUser.property.defaultEmail"></a>

```typescript
public readonly defaultEmail: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIamUser.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `loginInput`<sup>Optional</sup> <a name="loginInput" id="@cdktf/provider-yandex.DataYandexIamUser.property.loginInput"></a>

```typescript
public readonly loginInput: string;
```

- *Type:* string

---

##### `userIdInput`<sup>Optional</sup> <a name="userIdInput" id="@cdktf/provider-yandex.DataYandexIamUser.property.userIdInput"></a>

```typescript
public readonly userIdInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamUser.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `login`<sup>Required</sup> <a name="login" id="@cdktf/provider-yandex.DataYandexIamUser.property.login"></a>

```typescript
public readonly login: string;
```

- *Type:* string

---

##### `userId`<sup>Required</sup> <a name="userId" id="@cdktf/provider-yandex.DataYandexIamUser.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUser.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIamUser.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIotCoreDevice <a name="DataYandexIotCoreDevice" id="@cdktf/provider-yandex.DataYandexIotCoreDevice"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device yandex_iot_core_device}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer"></a>

```typescript
import { DataYandexIotCoreDevice } from '@cdktf/provider-yandex'

new DataYandexIotCoreDevice(scope: Construct, id: string, config?: DataYandexIotCoreDeviceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig">DataYandexIotCoreDeviceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig">DataYandexIotCoreDeviceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.resetDeviceId">resetDeviceId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDeviceId` <a name="resetDeviceId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.resetDeviceId"></a>

```typescript
public resetDeviceId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.isConstruct"></a>

```typescript
import { DataYandexIotCoreDevice } from '@cdktf/provider-yandex'

DataYandexIotCoreDevice.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.aliases">aliases</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.certificates">certificates</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.passwords">passwords</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.deviceIdInput">deviceIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.deviceId">deviceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `aliases`<sup>Required</sup> <a name="aliases" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.aliases"></a>

```typescript
public readonly aliases: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `certificates`<sup>Required</sup> <a name="certificates" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `passwords`<sup>Required</sup> <a name="passwords" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

##### `deviceIdInput`<sup>Optional</sup> <a name="deviceIdInput" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.deviceIdInput"></a>

```typescript
public readonly deviceIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `deviceId`<sup>Required</sup> <a name="deviceId" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDevice.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIotCoreDevice.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexIotCoreRegistry <a name="DataYandexIotCoreRegistry" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry yandex_iot_core_registry}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer"></a>

```typescript
import { DataYandexIotCoreRegistry } from '@cdktf/provider-yandex'

new DataYandexIotCoreRegistry(scope: Construct, id: string, config?: DataYandexIotCoreRegistryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig">DataYandexIotCoreRegistryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig">DataYandexIotCoreRegistryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetRegistryId">resetRegistryId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRegistryId` <a name="resetRegistryId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.resetRegistryId"></a>

```typescript
public resetRegistryId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.isConstruct"></a>

```typescript
import { DataYandexIotCoreRegistry } from '@cdktf/provider-yandex'

DataYandexIotCoreRegistry.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.certificates">certificates</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.passwords">passwords</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.registryIdInput">registryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `certificates`<sup>Required</sup> <a name="certificates" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `passwords`<sup>Required</sup> <a name="passwords" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `registryIdInput`<sup>Optional</sup> <a name="registryIdInput" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.registryIdInput"></a>

```typescript
public readonly registryIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexIotCoreRegistry.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexKubernetesCluster <a name="DataYandexKubernetesCluster" id="@cdktf/provider-yandex.DataYandexKubernetesCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster yandex_kubernetes_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer"></a>

```typescript
import { DataYandexKubernetesCluster } from '@cdktf/provider-yandex'

new DataYandexKubernetesCluster(scope: Construct, id: string, config?: DataYandexKubernetesClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig">DataYandexKubernetesClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig">DataYandexKubernetesClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.isConstruct"></a>

```typescript
import { DataYandexKubernetesCluster } from '@cdktf/provider-yandex'

DataYandexKubernetesCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIpv4Range">clusterIpv4Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIpv6Range">clusterIpv6Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.kmsProvider">kmsProvider</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList">DataYandexKubernetesClusterKmsProviderList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.master">master</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList">DataYandexKubernetesClusterMasterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkImplementation">networkImplementation</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList">DataYandexKubernetesClusterNetworkImplementationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkPolicyProvider">networkPolicyProvider</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nodeIpv4CidrMaskSize">nodeIpv4CidrMaskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nodeServiceAccountId">nodeServiceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.releaseChannel">releaseChannel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceIpv4Range">serviceIpv4Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceIpv6Range">serviceIpv6Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterIpv4Range`<sup>Required</sup> <a name="clusterIpv4Range" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIpv4Range"></a>

```typescript
public readonly clusterIpv4Range: string;
```

- *Type:* string

---

##### `clusterIpv6Range`<sup>Required</sup> <a name="clusterIpv6Range" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIpv6Range"></a>

```typescript
public readonly clusterIpv6Range: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `kmsProvider`<sup>Required</sup> <a name="kmsProvider" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.kmsProvider"></a>

```typescript
public readonly kmsProvider: DataYandexKubernetesClusterKmsProviderList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList">DataYandexKubernetesClusterKmsProviderList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `master`<sup>Required</sup> <a name="master" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.master"></a>

```typescript
public readonly master: DataYandexKubernetesClusterMasterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList">DataYandexKubernetesClusterMasterList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `networkImplementation`<sup>Required</sup> <a name="networkImplementation" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkImplementation"></a>

```typescript
public readonly networkImplementation: DataYandexKubernetesClusterNetworkImplementationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList">DataYandexKubernetesClusterNetworkImplementationList</a>

---

##### `networkPolicyProvider`<sup>Required</sup> <a name="networkPolicyProvider" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.networkPolicyProvider"></a>

```typescript
public readonly networkPolicyProvider: string;
```

- *Type:* string

---

##### `nodeIpv4CidrMaskSize`<sup>Required</sup> <a name="nodeIpv4CidrMaskSize" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nodeIpv4CidrMaskSize"></a>

```typescript
public readonly nodeIpv4CidrMaskSize: number;
```

- *Type:* number

---

##### `nodeServiceAccountId`<sup>Required</sup> <a name="nodeServiceAccountId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nodeServiceAccountId"></a>

```typescript
public readonly nodeServiceAccountId: string;
```

- *Type:* string

---

##### `releaseChannel`<sup>Required</sup> <a name="releaseChannel" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.releaseChannel"></a>

```typescript
public readonly releaseChannel: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `serviceIpv4Range`<sup>Required</sup> <a name="serviceIpv4Range" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceIpv4Range"></a>

```typescript
public readonly serviceIpv4Range: string;
```

- *Type:* string

---

##### `serviceIpv6Range`<sup>Required</sup> <a name="serviceIpv6Range" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.serviceIpv6Range"></a>

```typescript
public readonly serviceIpv6Range: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexKubernetesCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexKubernetesNodeGroup <a name="DataYandexKubernetesNodeGroup" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group yandex_kubernetes_node_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroup } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroup(scope: Construct, id: string, config?: DataYandexKubernetesNodeGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig">DataYandexKubernetesNodeGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig">DataYandexKubernetesNodeGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetNodeGroupId">resetNodeGroupId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNodeGroupId` <a name="resetNodeGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.resetNodeGroupId"></a>

```typescript
public resetNodeGroupId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.isConstruct"></a>

```typescript
import { DataYandexKubernetesNodeGroup } from '@cdktf/provider-yandex'

DataYandexKubernetesNodeGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList">DataYandexKubernetesNodeGroupAllocationPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.allowedUnsafeSysctls">allowedUnsafeSysctls</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList">DataYandexKubernetesNodeGroupDeployPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.instanceGroupId">instanceGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList">DataYandexKubernetesNodeGroupInstanceTemplateList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList">DataYandexKubernetesNodeGroupMaintenancePolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeLabels">nodeLabels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeTaints">nodeTaints</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList">DataYandexKubernetesNodeGroupScalePolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.versionInfo">versionInfo</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList">DataYandexKubernetesNodeGroupVersionInfoList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeGroupIdInput">nodeGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeGroupId">nodeGroupId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: DataYandexKubernetesNodeGroupAllocationPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList">DataYandexKubernetesNodeGroupAllocationPolicyList</a>

---

##### `allowedUnsafeSysctls`<sup>Required</sup> <a name="allowedUnsafeSysctls" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.allowedUnsafeSysctls"></a>

```typescript
public readonly allowedUnsafeSysctls: string[];
```

- *Type:* string[]

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deployPolicy`<sup>Required</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: DataYandexKubernetesNodeGroupDeployPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList">DataYandexKubernetesNodeGroupDeployPolicyList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `instanceGroupId`<sup>Required</sup> <a name="instanceGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.instanceGroupId"></a>

```typescript
public readonly instanceGroupId: string;
```

- *Type:* string

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: DataYandexKubernetesNodeGroupInstanceTemplateList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList">DataYandexKubernetesNodeGroupInstanceTemplateList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenancePolicy`<sup>Required</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: DataYandexKubernetesNodeGroupMaintenancePolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList">DataYandexKubernetesNodeGroupMaintenancePolicyList</a>

---

##### `nodeLabels`<sup>Required</sup> <a name="nodeLabels" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeLabels"></a>

```typescript
public readonly nodeLabels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `nodeTaints`<sup>Required</sup> <a name="nodeTaints" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeTaints"></a>

```typescript
public readonly nodeTaints: string[];
```

- *Type:* string[]

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: DataYandexKubernetesNodeGroupScalePolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList">DataYandexKubernetesNodeGroupScalePolicyList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `versionInfo`<sup>Required</sup> <a name="versionInfo" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.versionInfo"></a>

```typescript
public readonly versionInfo: DataYandexKubernetesNodeGroupVersionInfoList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList">DataYandexKubernetesNodeGroupVersionInfoList</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeGroupIdInput`<sup>Optional</sup> <a name="nodeGroupIdInput" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeGroupIdInput"></a>

```typescript
public readonly nodeGroupIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeGroupId`<sup>Required</sup> <a name="nodeGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.nodeGroupId"></a>

```typescript
public readonly nodeGroupId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexLbNetworkLoadBalancer <a name="DataYandexLbNetworkLoadBalancer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer yandex_lb_network_load_balancer}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancer } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancer(scope: Construct, id: string, config?: DataYandexLbNetworkLoadBalancerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig">DataYandexLbNetworkLoadBalancerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig">DataYandexLbNetworkLoadBalancerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetNetworkLoadBalancerId">resetNetworkLoadBalancerId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkLoadBalancerId` <a name="resetNetworkLoadBalancerId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.resetNetworkLoadBalancerId"></a>

```typescript
public resetNetworkLoadBalancerId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.isConstruct"></a>

```typescript
import { DataYandexLbNetworkLoadBalancer } from '@cdktf/provider-yandex'

DataYandexLbNetworkLoadBalancer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.attachedTargetGroup">attachedTargetGroup</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.listener">listener</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList">DataYandexLbNetworkLoadBalancerListenerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.regionId">regionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.networkLoadBalancerIdInput">networkLoadBalancerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.networkLoadBalancerId">networkLoadBalancerId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `attachedTargetGroup`<sup>Required</sup> <a name="attachedTargetGroup" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.attachedTargetGroup"></a>

```typescript
public readonly attachedTargetGroup: DataYandexLbNetworkLoadBalancerAttachedTargetGroupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `listener`<sup>Required</sup> <a name="listener" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.listener"></a>

```typescript
public readonly listener: DataYandexLbNetworkLoadBalancerListenerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList">DataYandexLbNetworkLoadBalancerListenerList</a>

---

##### `regionId`<sup>Required</sup> <a name="regionId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkLoadBalancerIdInput`<sup>Optional</sup> <a name="networkLoadBalancerIdInput" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.networkLoadBalancerIdInput"></a>

```typescript
public readonly networkLoadBalancerIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkLoadBalancerId`<sup>Required</sup> <a name="networkLoadBalancerId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.networkLoadBalancerId"></a>

```typescript
public readonly networkLoadBalancerId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexLbTargetGroup <a name="DataYandexLbTargetGroup" id="@cdktf/provider-yandex.DataYandexLbTargetGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group yandex_lb_target_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer"></a>

```typescript
import { DataYandexLbTargetGroup } from '@cdktf/provider-yandex'

new DataYandexLbTargetGroup(scope: Construct, id: string, config?: DataYandexLbTargetGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig">DataYandexLbTargetGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig">DataYandexLbTargetGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.resetTargetGroupId">resetTargetGroupId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTargetGroupId` <a name="resetTargetGroupId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.resetTargetGroupId"></a>

```typescript
public resetTargetGroupId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.isConstruct"></a>

```typescript
import { DataYandexLbTargetGroup } from '@cdktf/provider-yandex'

DataYandexLbTargetGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.target">target</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList">DataYandexLbTargetGroupTargetList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.targetGroupIdInput">targetGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.target"></a>

```typescript
public readonly target: DataYandexLbTargetGroupTargetList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList">DataYandexLbTargetGroupTargetList</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `targetGroupIdInput`<sup>Optional</sup> <a name="targetGroupIdInput" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.targetGroupIdInput"></a>

```typescript
public readonly targetGroupIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexLbTargetGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexLoggingGroup <a name="DataYandexLoggingGroup" id="@cdktf/provider-yandex.DataYandexLoggingGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/logging_group yandex_logging_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer"></a>

```typescript
import { DataYandexLoggingGroup } from '@cdktf/provider-yandex'

new DataYandexLoggingGroup(scope: Construct, id: string, config?: DataYandexLoggingGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig">DataYandexLoggingGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexLoggingGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig">DataYandexLoggingGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.resetGroupId">resetGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLoggingGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexLoggingGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexLoggingGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexLoggingGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexLoggingGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexLoggingGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLoggingGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetGroupId` <a name="resetGroupId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.resetGroupId"></a>

```typescript
public resetGroupId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexLoggingGroup.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexLoggingGroup.isConstruct"></a>

```typescript
import { DataYandexLoggingGroup } from '@cdktf/provider-yandex'

DataYandexLoggingGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexLoggingGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.retentionPeriod">retentionPeriod</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.groupIdInput">groupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.groupId">groupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `retentionPeriod`<sup>Required</sup> <a name="retentionPeriod" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.retentionPeriod"></a>

```typescript
public readonly retentionPeriod: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `groupIdInput`<sup>Optional</sup> <a name="groupIdInput" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexLoggingGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbClickhouseCluster <a name="DataYandexMdbClickhouseCluster" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster yandex_mdb_clickhouse_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseCluster } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseCluster(scope: Construct, id: string, config?: DataYandexMdbClickhouseClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig">DataYandexMdbClickhouseClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig">DataYandexMdbClickhouseClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.putCloudStorage">putCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetCloudStorage">resetCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putCloudStorage` <a name="putCloudStorage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.putCloudStorage"></a>

```typescript
public putCloudStorage(value: DataYandexMdbClickhouseClusterCloudStorage): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.putCloudStorage.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a>

---

##### `resetCloudStorage` <a name="resetCloudStorage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetCloudStorage"></a>

```typescript
public resetCloudStorage(): void
```

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetName"></a>

```typescript
public resetName(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.isConstruct"></a>

```typescript
import { DataYandexMdbClickhouseCluster } from '@cdktf/provider-yandex'

DataYandexMdbClickhouseCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList">DataYandexMdbClickhouseClusterAccessList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList">DataYandexMdbClickhouseClusterBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clickhouse">clickhouse</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList">DataYandexMdbClickhouseClusterClickhouseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cloudStorage">cloudStorage</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference">DataYandexMdbClickhouseClusterCloudStorageOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList">DataYandexMdbClickhouseClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.embeddedKeeper">embeddedKeeper</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.formatSchema">formatSchema</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList">DataYandexMdbClickhouseClusterFormatSchemaList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList">DataYandexMdbClickhouseClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList">DataYandexMdbClickhouseClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.mlModel">mlModel</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList">DataYandexMdbClickhouseClusterMlModelList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.shardGroup">shardGroup</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList">DataYandexMdbClickhouseClusterShardGroupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.sqlDatabaseManagement">sqlDatabaseManagement</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.sqlUserManagement">sqlUserManagement</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList">DataYandexMdbClickhouseClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList">DataYandexMdbClickhouseClusterZookeeperList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cloudStorageInput">cloudStorageInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.access"></a>

```typescript
public readonly access: DataYandexMdbClickhouseClusterAccessList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList">DataYandexMdbClickhouseClusterAccessList</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbClickhouseClusterBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList">DataYandexMdbClickhouseClusterBackupWindowStartList</a>

---

##### `clickhouse`<sup>Required</sup> <a name="clickhouse" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clickhouse"></a>

```typescript
public readonly clickhouse: DataYandexMdbClickhouseClusterClickhouseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList">DataYandexMdbClickhouseClusterClickhouseList</a>

---

##### `cloudStorage`<sup>Required</sup> <a name="cloudStorage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cloudStorage"></a>

```typescript
public readonly cloudStorage: DataYandexMdbClickhouseClusterCloudStorageOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference">DataYandexMdbClickhouseClusterCloudStorageOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.database"></a>

```typescript
public readonly database: DataYandexMdbClickhouseClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList">DataYandexMdbClickhouseClusterDatabaseList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `embeddedKeeper`<sup>Required</sup> <a name="embeddedKeeper" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.embeddedKeeper"></a>

```typescript
public readonly embeddedKeeper: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `formatSchema`<sup>Required</sup> <a name="formatSchema" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.formatSchema"></a>

```typescript
public readonly formatSchema: DataYandexMdbClickhouseClusterFormatSchemaList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList">DataYandexMdbClickhouseClusterFormatSchemaList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbClickhouseClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList">DataYandexMdbClickhouseClusterHostList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbClickhouseClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList">DataYandexMdbClickhouseClusterMaintenanceWindowList</a>

---

##### `mlModel`<sup>Required</sup> <a name="mlModel" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.mlModel"></a>

```typescript
public readonly mlModel: DataYandexMdbClickhouseClusterMlModelList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList">DataYandexMdbClickhouseClusterMlModelList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `shardGroup`<sup>Required</sup> <a name="shardGroup" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.shardGroup"></a>

```typescript
public readonly shardGroup: DataYandexMdbClickhouseClusterShardGroupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList">DataYandexMdbClickhouseClusterShardGroupList</a>

---

##### `sqlDatabaseManagement`<sup>Required</sup> <a name="sqlDatabaseManagement" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.sqlDatabaseManagement"></a>

```typescript
public readonly sqlDatabaseManagement: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `sqlUserManagement`<sup>Required</sup> <a name="sqlUserManagement" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.sqlUserManagement"></a>

```typescript
public readonly sqlUserManagement: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbClickhouseClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList">DataYandexMdbClickhouseClusterUserList</a>

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `zookeeper`<sup>Required</sup> <a name="zookeeper" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.zookeeper"></a>

```typescript
public readonly zookeeper: DataYandexMdbClickhouseClusterZookeeperList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList">DataYandexMdbClickhouseClusterZookeeperList</a>

---

##### `cloudStorageInput`<sup>Optional</sup> <a name="cloudStorageInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.cloudStorageInput"></a>

```typescript
public readonly cloudStorageInput: DataYandexMdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbClickhouseCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbElasticsearchCluster <a name="DataYandexMdbElasticsearchCluster" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchCluster } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchCluster(scope: Construct, id: string, config?: DataYandexMdbElasticsearchClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig">DataYandexMdbElasticsearchClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig">DataYandexMdbElasticsearchClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.isConstruct"></a>

```typescript
import { DataYandexMdbElasticsearchCluster } from '@cdktf/provider-yandex'

DataYandexMdbElasticsearchCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList">DataYandexMdbElasticsearchClusterConfigAList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList">DataYandexMdbElasticsearchClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList">DataYandexMdbElasticsearchClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.config"></a>

```typescript
public readonly config: DataYandexMdbElasticsearchClusterConfigAList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList">DataYandexMdbElasticsearchClusterConfigAList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbElasticsearchClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList">DataYandexMdbElasticsearchClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbElasticsearchClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList">DataYandexMdbElasticsearchClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbGreenplumCluster <a name="DataYandexMdbGreenplumCluster" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster yandex_mdb_greenplum_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumCluster } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumCluster(scope: Construct, id: string, config?: DataYandexMdbGreenplumClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig">DataYandexMdbGreenplumClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig">DataYandexMdbGreenplumClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.isConstruct"></a>

```typescript
import { DataYandexMdbGreenplumCluster } from '@cdktf/provider-yandex'

DataYandexMdbGreenplumCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList">DataYandexMdbGreenplumClusterAccessList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList">DataYandexMdbGreenplumClusterBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.deletionProtection">deletionProtection</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterHostCount">masterHostCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterHosts">masterHosts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList">DataYandexMdbGreenplumClusterMasterHostsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterSubcluster">masterSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList">DataYandexMdbGreenplumClusterMasterSubclusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentHostCount">segmentHostCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentHosts">segmentHosts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList">DataYandexMdbGreenplumClusterSegmentHostsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentInHost">segmentInHost</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentSubcluster">segmentSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList">DataYandexMdbGreenplumClusterSegmentSubclusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.userName">userName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.access"></a>

```typescript
public readonly access: DataYandexMdbGreenplumClusterAccessList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList">DataYandexMdbGreenplumClusterAccessList</a>

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbGreenplumClusterBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList">DataYandexMdbGreenplumClusterBackupWindowStartList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `masterHostCount`<sup>Required</sup> <a name="masterHostCount" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterHostCount"></a>

```typescript
public readonly masterHostCount: number;
```

- *Type:* number

---

##### `masterHosts`<sup>Required</sup> <a name="masterHosts" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterHosts"></a>

```typescript
public readonly masterHosts: DataYandexMdbGreenplumClusterMasterHostsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList">DataYandexMdbGreenplumClusterMasterHostsList</a>

---

##### `masterSubcluster`<sup>Required</sup> <a name="masterSubcluster" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.masterSubcluster"></a>

```typescript
public readonly masterSubcluster: DataYandexMdbGreenplumClusterMasterSubclusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList">DataYandexMdbGreenplumClusterMasterSubclusterList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `segmentHostCount`<sup>Required</sup> <a name="segmentHostCount" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentHostCount"></a>

```typescript
public readonly segmentHostCount: number;
```

- *Type:* number

---

##### `segmentHosts`<sup>Required</sup> <a name="segmentHosts" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentHosts"></a>

```typescript
public readonly segmentHosts: DataYandexMdbGreenplumClusterSegmentHostsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList">DataYandexMdbGreenplumClusterSegmentHostsList</a>

---

##### `segmentInHost`<sup>Required</sup> <a name="segmentInHost" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentInHost"></a>

```typescript
public readonly segmentInHost: number;
```

- *Type:* number

---

##### `segmentSubcluster`<sup>Required</sup> <a name="segmentSubcluster" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.segmentSubcluster"></a>

```typescript
public readonly segmentSubcluster: DataYandexMdbGreenplumClusterSegmentSubclusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList">DataYandexMdbGreenplumClusterSegmentSubclusterList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `userName`<sup>Required</sup> <a name="userName" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbGreenplumCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbKafkaCluster <a name="DataYandexMdbKafkaCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster yandex_mdb_kafka_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaCluster } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaCluster(scope: Construct, id: string, config?: DataYandexMdbKafkaClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig">DataYandexMdbKafkaClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig">DataYandexMdbKafkaClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putTopic">putTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetConfig">resetConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetSubnetIds">resetSubnetIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetTopic">resetTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetUser">resetUser</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putConfig"></a>

```typescript
public putConfig(value: DataYandexMdbKafkaClusterConfigA): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a>

---

##### `putTopic` <a name="putTopic" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putTopic"></a>

```typescript
public putTopic(value: IResolvable | DataYandexMdbKafkaClusterTopic[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putTopic.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | DataYandexMdbKafkaClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetConfig` <a name="resetConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetConfig"></a>

```typescript
public resetConfig(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSubnetIds` <a name="resetSubnetIds" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetSubnetIds"></a>

```typescript
public resetSubnetIds(): void
```

##### `resetTopic` <a name="resetTopic" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetTopic"></a>

```typescript
public resetTopic(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.resetUser"></a>

```typescript
public resetUser(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.isConstruct"></a>

```typescript
import { DataYandexMdbKafkaCluster } from '@cdktf/provider-yandex'

DataYandexMdbKafkaCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference">DataYandexMdbKafkaClusterConfigAOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList">DataYandexMdbKafkaClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList">DataYandexMdbKafkaClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.topic">topic</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList">DataYandexMdbKafkaClusterTopicList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList">DataYandexMdbKafkaClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.subnetIdsInput">subnetIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.topicInput">topicInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.config"></a>

```typescript
public readonly config: DataYandexMdbKafkaClusterConfigAOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference">DataYandexMdbKafkaClusterConfigAOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbKafkaClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList">DataYandexMdbKafkaClusterHostList</a>

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbKafkaClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList">DataYandexMdbKafkaClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `topic`<sup>Required</sup> <a name="topic" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.topic"></a>

```typescript
public readonly topic: DataYandexMdbKafkaClusterTopicList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList">DataYandexMdbKafkaClusterTopicList</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbKafkaClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList">DataYandexMdbKafkaClusterUserList</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.configInput"></a>

```typescript
public readonly configInput: DataYandexMdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `subnetIdsInput`<sup>Optional</sup> <a name="subnetIdsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.subnetIdsInput"></a>

```typescript
public readonly subnetIdsInput: string[];
```

- *Type:* string[]

---

##### `topicInput`<sup>Optional</sup> <a name="topicInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.topicInput"></a>

```typescript
public readonly topicInput: IResolvable | DataYandexMdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | DataYandexMdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbKafkaConnector <a name="DataYandexMdbKafkaConnector" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector yandex_mdb_kafka_connector}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnector } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnector(scope: Construct, id: string, config: DataYandexMdbKafkaConnectorConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig">DataYandexMdbKafkaConnectorConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig">DataYandexMdbKafkaConnectorConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.isConstruct"></a>

```typescript
import { DataYandexMdbKafkaConnector } from '@cdktf/provider-yandex'

DataYandexMdbKafkaConnector.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.connectorConfigMirrormaker">connectorConfigMirrormaker</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.properties">properties</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.tasksMax">tasksMax</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `connectorConfigMirrormaker`<sup>Required</sup> <a name="connectorConfigMirrormaker" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.connectorConfigMirrormaker"></a>

```typescript
public readonly connectorConfigMirrormaker: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList</a>

---

##### `properties`<sup>Required</sup> <a name="properties" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.properties"></a>

```typescript
public readonly properties: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `tasksMax`<sup>Required</sup> <a name="tasksMax" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.tasksMax"></a>

```typescript
public readonly tasksMax: number;
```

- *Type:* number

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnector.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbKafkaTopic <a name="DataYandexMdbKafkaTopic" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic yandex_mdb_kafka_topic}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer"></a>

```typescript
import { DataYandexMdbKafkaTopic } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaTopic(scope: Construct, id: string, config: DataYandexMdbKafkaTopicConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig">DataYandexMdbKafkaTopicConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig">DataYandexMdbKafkaTopicConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.isConstruct"></a>

```typescript
import { DataYandexMdbKafkaTopic } from '@cdktf/provider-yandex'

DataYandexMdbKafkaTopic.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.partitions">partitions</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList">DataYandexMdbKafkaTopicTopicConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

##### `topicConfig`<sup>Required</sup> <a name="topicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.topicConfig"></a>

```typescript
public readonly topicConfig: DataYandexMdbKafkaTopicTopicConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList">DataYandexMdbKafkaTopicTopicConfigList</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopic.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbMongodbCluster <a name="DataYandexMdbMongodbCluster" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster yandex_mdb_mongodb_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer"></a>

```typescript
import { DataYandexMdbMongodbCluster } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbCluster(scope: Construct, id: string, config?: DataYandexMdbMongodbClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig">DataYandexMdbMongodbClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig">DataYandexMdbMongodbClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.isConstruct"></a>

```typescript
import { DataYandexMdbMongodbCluster } from '@cdktf/provider-yandex'

DataYandexMdbMongodbCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList">DataYandexMdbMongodbClusterClusterConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList">DataYandexMdbMongodbClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList">DataYandexMdbMongodbClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList">DataYandexMdbMongodbClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList">DataYandexMdbMongodbClusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.sharded">sharded</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList">DataYandexMdbMongodbClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: DataYandexMdbMongodbClusterClusterConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList">DataYandexMdbMongodbClusterClusterConfigList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.database"></a>

```typescript
public readonly database: DataYandexMdbMongodbClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList">DataYandexMdbMongodbClusterDatabaseList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbMongodbClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList">DataYandexMdbMongodbClusterHostList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbMongodbClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList">DataYandexMdbMongodbClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbMongodbClusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList">DataYandexMdbMongodbClusterResourcesList</a>

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `sharded`<sup>Required</sup> <a name="sharded" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.sharded"></a>

```typescript
public readonly sharded: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbMongodbClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList">DataYandexMdbMongodbClusterUserList</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbMongodbCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbMysqlCluster <a name="DataYandexMdbMysqlCluster" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster yandex_mdb_mysql_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer"></a>

```typescript
import { DataYandexMdbMysqlCluster } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlCluster(scope: Construct, id: string, config?: DataYandexMdbMysqlClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig">DataYandexMdbMysqlClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig">DataYandexMdbMysqlClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetMysqlConfig">resetMysqlConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.putAccess"></a>

```typescript
public putAccess(value: DataYandexMdbMysqlClusterAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a>

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMysqlConfig` <a name="resetMysqlConfig" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetMysqlConfig"></a>

```typescript
public resetMysqlConfig(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.isConstruct"></a>

```typescript
import { DataYandexMdbMysqlCluster } from '@cdktf/provider-yandex'

DataYandexMdbMysqlCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference">DataYandexMdbMysqlClusterAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList">DataYandexMdbMysqlClusterBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList">DataYandexMdbMysqlClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList">DataYandexMdbMysqlClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList">DataYandexMdbMysqlClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList">DataYandexMdbMysqlClusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList">DataYandexMdbMysqlClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.mysqlConfigInput">mysqlConfigInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.mysqlConfig">mysqlConfig</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.access"></a>

```typescript
public readonly access: DataYandexMdbMysqlClusterAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference">DataYandexMdbMysqlClusterAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbMysqlClusterBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList">DataYandexMdbMysqlClusterBackupWindowStartList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.database"></a>

```typescript
public readonly database: DataYandexMdbMysqlClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList">DataYandexMdbMysqlClusterDatabaseList</a>

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbMysqlClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList">DataYandexMdbMysqlClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbMysqlClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList">DataYandexMdbMysqlClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbMysqlClusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList">DataYandexMdbMysqlClusterResourcesList</a>

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbMysqlClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList">DataYandexMdbMysqlClusterUserList</a>

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.accessInput"></a>

```typescript
public readonly accessInput: DataYandexMdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `mysqlConfigInput`<sup>Optional</sup> <a name="mysqlConfigInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.mysqlConfigInput"></a>

```typescript
public readonly mysqlConfigInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `mysqlConfig`<sup>Required</sup> <a name="mysqlConfig" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.mysqlConfig"></a>

```typescript
public readonly mysqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbMysqlCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbPostgresqlCluster <a name="DataYandexMdbPostgresqlCluster" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster yandex_mdb_postgresql_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlCluster } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlCluster(scope: Construct, id: string, config?: DataYandexMdbPostgresqlClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig">DataYandexMdbPostgresqlClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig">DataYandexMdbPostgresqlClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.isConstruct"></a>

```typescript
import { DataYandexMdbPostgresqlCluster } from '@cdktf/provider-yandex'

DataYandexMdbPostgresqlCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList">DataYandexMdbPostgresqlClusterConfigAList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList">DataYandexMdbPostgresqlClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList">DataYandexMdbPostgresqlClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList">DataYandexMdbPostgresqlClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList">DataYandexMdbPostgresqlClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.config"></a>

```typescript
public readonly config: DataYandexMdbPostgresqlClusterConfigAList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList">DataYandexMdbPostgresqlClusterConfigAList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.database"></a>

```typescript
public readonly database: DataYandexMdbPostgresqlClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList">DataYandexMdbPostgresqlClusterDatabaseList</a>

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbPostgresqlClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList">DataYandexMdbPostgresqlClusterHostList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbPostgresqlClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList">DataYandexMdbPostgresqlClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbPostgresqlClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList">DataYandexMdbPostgresqlClusterUserList</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbRedisCluster <a name="DataYandexMdbRedisCluster" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster yandex_mdb_redis_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer"></a>

```typescript
import { DataYandexMdbRedisCluster } from '@cdktf/provider-yandex'

new DataYandexMdbRedisCluster(scope: Construct, id: string, config?: DataYandexMdbRedisClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig">DataYandexMdbRedisClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig">DataYandexMdbRedisClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.isConstruct"></a>

```typescript
import { DataYandexMdbRedisCluster } from '@cdktf/provider-yandex'

DataYandexMdbRedisCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList">DataYandexMdbRedisClusterConfigAList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList">DataYandexMdbRedisClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList">DataYandexMdbRedisClusterMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.persistenceMode">persistenceMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList">DataYandexMdbRedisClusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.sharded">sharded</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.tlsEnabled">tlsEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.config"></a>

```typescript
public readonly config: DataYandexMdbRedisClusterConfigAList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList">DataYandexMdbRedisClusterConfigAList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbRedisClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList">DataYandexMdbRedisClusterHostList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexMdbRedisClusterMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList">DataYandexMdbRedisClusterMaintenanceWindowList</a>

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `persistenceMode`<sup>Required</sup> <a name="persistenceMode" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.persistenceMode"></a>

```typescript
public readonly persistenceMode: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbRedisClusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList">DataYandexMdbRedisClusterResourcesList</a>

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `sharded`<sup>Required</sup> <a name="sharded" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.sharded"></a>

```typescript
public readonly sharded: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbRedisCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMdbSqlserverCluster <a name="DataYandexMdbSqlserverCluster" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster yandex_mdb_sqlserver_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverCluster } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverCluster(scope: Construct, id: string, config?: DataYandexMdbSqlserverClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig">DataYandexMdbSqlserverClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig">DataYandexMdbSqlserverClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetSqlserverConfig">resetSqlserverConfig</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSqlserverConfig` <a name="resetSqlserverConfig" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.resetSqlserverConfig"></a>

```typescript
public resetSqlserverConfig(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.isConstruct"></a>

```typescript
import { DataYandexMdbSqlserverCluster } from '@cdktf/provider-yandex'

DataYandexMdbSqlserverCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList">DataYandexMdbSqlserverClusterBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList">DataYandexMdbSqlserverClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList">DataYandexMdbSqlserverClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList">DataYandexMdbSqlserverClusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList">DataYandexMdbSqlserverClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.sqlserverConfigInput">sqlserverConfigInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.sqlserverConfig">sqlserverConfig</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbSqlserverClusterBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList">DataYandexMdbSqlserverClusterBackupWindowStartList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.database"></a>

```typescript
public readonly database: DataYandexMdbSqlserverClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList">DataYandexMdbSqlserverClusterDatabaseList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.host"></a>

```typescript
public readonly host: DataYandexMdbSqlserverClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList">DataYandexMdbSqlserverClusterHostList</a>

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbSqlserverClusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList">DataYandexMdbSqlserverClusterResourcesList</a>

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.user"></a>

```typescript
public readonly user: DataYandexMdbSqlserverClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList">DataYandexMdbSqlserverClusterUserList</a>

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `sqlserverConfigInput`<sup>Optional</sup> <a name="sqlserverConfigInput" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.sqlserverConfigInput"></a>

```typescript
public readonly sqlserverConfigInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `sqlserverConfig`<sup>Required</sup> <a name="sqlserverConfig" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.sqlserverConfig"></a>

```typescript
public readonly sqlserverConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMdbSqlserverCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexMessageQueue <a name="DataYandexMessageQueue" id="@cdktf/provider-yandex.DataYandexMessageQueue"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/message_queue yandex_message_queue}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMessageQueue.Initializer"></a>

```typescript
import { DataYandexMessageQueue } from '@cdktf/provider-yandex'

new DataYandexMessageQueue(scope: Construct, id: string, config: DataYandexMessageQueueConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig">DataYandexMessageQueueConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMessageQueue.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig">DataYandexMessageQueueConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.resetAccessKey">resetAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.resetSecretKey">resetSecretKey</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMessageQueue.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexMessageQueue.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexMessageQueue.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMessageQueue.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexMessageQueue.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexMessageQueue.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexMessageQueue.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexMessageQueue.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexMessageQueue.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMessageQueue.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAccessKey` <a name="resetAccessKey" id="@cdktf/provider-yandex.DataYandexMessageQueue.resetAccessKey"></a>

```typescript
public resetAccessKey(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexMessageQueue.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSecretKey` <a name="resetSecretKey" id="@cdktf/provider-yandex.DataYandexMessageQueue.resetSecretKey"></a>

```typescript
public resetSecretKey(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexMessageQueue.isConstruct"></a>

```typescript
import { DataYandexMessageQueue } from '@cdktf/provider-yandex'

DataYandexMessageQueue.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexMessageQueue.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.arn">arn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.accessKeyInput">accessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.secretKeyInput">secretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.accessKey">accessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `arn`<sup>Required</sup> <a name="arn" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.arn"></a>

```typescript
public readonly arn: string;
```

- *Type:* string

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

##### `accessKeyInput`<sup>Optional</sup> <a name="accessKeyInput" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.accessKeyInput"></a>

```typescript
public readonly accessKeyInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `secretKeyInput`<sup>Optional</sup> <a name="secretKeyInput" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.secretKeyInput"></a>

```typescript
public readonly secretKeyInput: string;
```

- *Type:* string

---

##### `accessKey`<sup>Required</sup> <a name="accessKey" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueue.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexMessageQueue.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexOrganizationmanagerSamlFederation <a name="DataYandexOrganizationmanagerSamlFederation" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation yandex_organizationmanager_saml_federation}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederation } from '@cdktf/provider-yandex'

new DataYandexOrganizationmanagerSamlFederation(scope: Construct, id: string, config?: DataYandexOrganizationmanagerSamlFederationConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig">DataYandexOrganizationmanagerSamlFederationConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig">DataYandexOrganizationmanagerSamlFederationConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetFederationId">resetFederationId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetOrganizationId">resetOrganizationId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFederationId` <a name="resetFederationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetFederationId"></a>

```typescript
public resetFederationId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetName"></a>

```typescript
public resetName(): void
```

##### `resetOrganizationId` <a name="resetOrganizationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.resetOrganizationId"></a>

```typescript
public resetOrganizationId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.isConstruct"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederation } from '@cdktf/provider-yandex'

DataYandexOrganizationmanagerSamlFederation.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.autoCreateAccountOnLogin">autoCreateAccountOnLogin</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.caseInsensitiveNameIds">caseInsensitiveNameIds</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.cookieMaxAge">cookieMaxAge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.issuer">issuer</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.securitySettings">securitySettings</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList">DataYandexOrganizationmanagerSamlFederationSecuritySettingsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.ssoBinding">ssoBinding</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.ssoUrl">ssoUrl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.federationIdInput">federationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.federationId">federationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `autoCreateAccountOnLogin`<sup>Required</sup> <a name="autoCreateAccountOnLogin" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.autoCreateAccountOnLogin"></a>

```typescript
public readonly autoCreateAccountOnLogin: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `caseInsensitiveNameIds`<sup>Required</sup> <a name="caseInsensitiveNameIds" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.caseInsensitiveNameIds"></a>

```typescript
public readonly caseInsensitiveNameIds: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `cookieMaxAge`<sup>Required</sup> <a name="cookieMaxAge" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.cookieMaxAge"></a>

```typescript
public readonly cookieMaxAge: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `issuer`<sup>Required</sup> <a name="issuer" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.issuer"></a>

```typescript
public readonly issuer: string;
```

- *Type:* string

---

##### `securitySettings`<sup>Required</sup> <a name="securitySettings" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.securitySettings"></a>

```typescript
public readonly securitySettings: DataYandexOrganizationmanagerSamlFederationSecuritySettingsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList">DataYandexOrganizationmanagerSamlFederationSecuritySettingsList</a>

---

##### `ssoBinding`<sup>Required</sup> <a name="ssoBinding" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.ssoBinding"></a>

```typescript
public readonly ssoBinding: string;
```

- *Type:* string

---

##### `ssoUrl`<sup>Required</sup> <a name="ssoUrl" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.ssoUrl"></a>

```typescript
public readonly ssoUrl: string;
```

- *Type:* string

---

##### `federationIdInput`<sup>Optional</sup> <a name="federationIdInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.federationIdInput"></a>

```typescript
public readonly federationIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `federationId`<sup>Required</sup> <a name="federationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.federationId"></a>

```typescript
public readonly federationId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederation.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexOrganizationmanagerSamlFederationUserAccount <a name="DataYandexOrganizationmanagerSamlFederationUserAccount" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account yandex_organizationmanager_saml_federation_user_account}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationUserAccount } from '@cdktf/provider-yandex'

new DataYandexOrganizationmanagerSamlFederationUserAccount(scope: Construct, id: string, config: DataYandexOrganizationmanagerSamlFederationUserAccountConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig">DataYandexOrganizationmanagerSamlFederationUserAccountConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig">DataYandexOrganizationmanagerSamlFederationUserAccountConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.isConstruct"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationUserAccount } from '@cdktf/provider-yandex'

DataYandexOrganizationmanagerSamlFederationUserAccount.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.federationIdInput">federationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.nameIdInput">nameIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.federationId">federationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.nameId">nameId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `federationIdInput`<sup>Optional</sup> <a name="federationIdInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.federationIdInput"></a>

```typescript
public readonly federationIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameIdInput`<sup>Optional</sup> <a name="nameIdInput" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.nameIdInput"></a>

```typescript
public readonly nameIdInput: string;
```

- *Type:* string

---

##### `federationId`<sup>Required</sup> <a name="federationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.federationId"></a>

```typescript
public readonly federationId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `nameId`<sup>Required</sup> <a name="nameId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.nameId"></a>

```typescript
public readonly nameId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccount.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexResourcemanagerCloud <a name="DataYandexResourcemanagerCloud" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud yandex_resourcemanager_cloud}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer"></a>

```typescript
import { DataYandexResourcemanagerCloud } from '@cdktf/provider-yandex'

new DataYandexResourcemanagerCloud(scope: Construct, id: string, config?: DataYandexResourcemanagerCloudConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig">DataYandexResourcemanagerCloudConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig">DataYandexResourcemanagerCloudConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetCloudId">resetCloudId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetCloudId` <a name="resetCloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetCloudId"></a>

```typescript
public resetCloudId(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.isConstruct"></a>

```typescript
import { DataYandexResourcemanagerCloud } from '@cdktf/provider-yandex'

DataYandexResourcemanagerCloud.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloud.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexResourcemanagerFolder <a name="DataYandexResourcemanagerFolder" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder yandex_resourcemanager_folder}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer"></a>

```typescript
import { DataYandexResourcemanagerFolder } from '@cdktf/provider-yandex'

new DataYandexResourcemanagerFolder(scope: Construct, id: string, config?: DataYandexResourcemanagerFolderConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig">DataYandexResourcemanagerFolderConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig">DataYandexResourcemanagerFolderConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetCloudId">resetCloudId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetCloudId` <a name="resetCloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetCloudId"></a>

```typescript
public resetCloudId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.isConstruct"></a>

```typescript
import { DataYandexResourcemanagerFolder } from '@cdktf/provider-yandex'

DataYandexResourcemanagerFolder.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolder.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexServerlessContainer <a name="DataYandexServerlessContainer" id="@cdktf/provider-yandex.DataYandexServerlessContainer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container yandex_serverless_container}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer"></a>

```typescript
import { DataYandexServerlessContainer } from '@cdktf/provider-yandex'

new DataYandexServerlessContainer(scope: Construct, id: string, config?: DataYandexServerlessContainerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig">DataYandexServerlessContainerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexServerlessContainer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig">DataYandexServerlessContainerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.resetContainerId">resetContainerId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexServerlessContainer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexServerlessContainer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexServerlessContainer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexServerlessContainer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexServerlessContainer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexServerlessContainer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetContainerId` <a name="resetContainerId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.resetContainerId"></a>

```typescript
public resetContainerId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexServerlessContainer.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexServerlessContainer.isConstruct"></a>

```typescript
import { DataYandexServerlessContainer } from '@cdktf/provider-yandex'

DataYandexServerlessContainer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexServerlessContainer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.concurrency">concurrency</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.image">image</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList">DataYandexServerlessContainerImageList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.revisionId">revisionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.containerIdInput">containerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.containerId">containerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `concurrency`<sup>Required</sup> <a name="concurrency" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.concurrency"></a>

```typescript
public readonly concurrency: number;
```

- *Type:* number

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `executionTimeout`<sup>Required</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

---

##### `image`<sup>Required</sup> <a name="image" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.image"></a>

```typescript
public readonly image: DataYandexServerlessContainerImageList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList">DataYandexServerlessContainerImageList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `revisionId`<sup>Required</sup> <a name="revisionId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.revisionId"></a>

```typescript
public readonly revisionId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

##### `containerIdInput`<sup>Optional</sup> <a name="containerIdInput" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.containerIdInput"></a>

```typescript
public readonly containerIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `containerId`<sup>Required</sup> <a name="containerId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.containerId"></a>

```typescript
public readonly containerId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexServerlessContainer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcAddress <a name="DataYandexVpcAddress" id="@cdktf/provider-yandex.DataYandexVpcAddress"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address yandex_vpc_address}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcAddress.Initializer"></a>

```typescript
import { DataYandexVpcAddress } from '@cdktf/provider-yandex'

new DataYandexVpcAddress(scope: Construct, id: string, config?: DataYandexVpcAddressConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig">DataYandexVpcAddressConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcAddress.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig">DataYandexVpcAddressConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.resetAddressId">resetAddressId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcAddress.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcAddress.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcAddress.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcAddress.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcAddress.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcAddress.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcAddress.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcAddress.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcAddress.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddress.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAddressId` <a name="resetAddressId" id="@cdktf/provider-yandex.DataYandexVpcAddress.resetAddressId"></a>

```typescript
public resetAddressId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexVpcAddress.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcAddress.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexVpcAddress.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcAddress.isConstruct"></a>

```typescript
import { DataYandexVpcAddress } from '@cdktf/provider-yandex'

DataYandexVpcAddress.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcAddress.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList">DataYandexVpcAddressExternalIpv4AddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.reserved">reserved</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.used">used</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.addressIdInput">addressIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.addressId">addressId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `externalIpv4Address`<sup>Required</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: DataYandexVpcAddressExternalIpv4AddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList">DataYandexVpcAddressExternalIpv4AddressList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `reserved`<sup>Required</sup> <a name="reserved" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.reserved"></a>

```typescript
public readonly reserved: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `used`<sup>Required</sup> <a name="used" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.used"></a>

```typescript
public readonly used: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `addressIdInput`<sup>Optional</sup> <a name="addressIdInput" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.addressIdInput"></a>

```typescript
public readonly addressIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `addressId`<sup>Required</sup> <a name="addressId" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.addressId"></a>

```typescript
public readonly addressId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddress.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcAddress.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcNetwork <a name="DataYandexVpcNetwork" id="@cdktf/provider-yandex.DataYandexVpcNetwork"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network yandex_vpc_network}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer"></a>

```typescript
import { DataYandexVpcNetwork } from '@cdktf/provider-yandex'

new DataYandexVpcNetwork(scope: Construct, id: string, config?: DataYandexVpcNetworkConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig">DataYandexVpcNetworkConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcNetwork.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig">DataYandexVpcNetworkConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.resetNetworkId">resetNetworkId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcNetwork.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcNetwork.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcNetwork.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcNetwork.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcNetwork.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcNetwork.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcNetwork.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexVpcNetwork.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkId` <a name="resetNetworkId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.resetNetworkId"></a>

```typescript
public resetNetworkId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcNetwork.isConstruct"></a>

```typescript
import { DataYandexVpcNetwork } from '@cdktf/provider-yandex'

DataYandexVpcNetwork.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcNetwork.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.defaultSecurityGroupId">defaultSecurityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `defaultSecurityGroupId`<sup>Required</sup> <a name="defaultSecurityGroupId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.defaultSecurityGroupId"></a>

```typescript
public readonly defaultSecurityGroupId: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetwork.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcNetwork.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcRouteTable <a name="DataYandexVpcRouteTable" id="@cdktf/provider-yandex.DataYandexVpcRouteTable"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table yandex_vpc_route_table}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer"></a>

```typescript
import { DataYandexVpcRouteTable } from '@cdktf/provider-yandex'

new DataYandexVpcRouteTable(scope: Construct, id: string, config?: DataYandexVpcRouteTableConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig">DataYandexVpcRouteTableConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig">DataYandexVpcRouteTableConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.resetRouteTableId">resetRouteTableId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRouteTableId` <a name="resetRouteTableId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.resetRouteTableId"></a>

```typescript
public resetRouteTableId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.isConstruct"></a>

```typescript
import { DataYandexVpcRouteTable } from '@cdktf/provider-yandex'

DataYandexVpcRouteTable.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.staticRoute">staticRoute</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList">DataYandexVpcRouteTableStaticRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.routeTableIdInput">routeTableIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.routeTableId">routeTableId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `staticRoute`<sup>Required</sup> <a name="staticRoute" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.staticRoute"></a>

```typescript
public readonly staticRoute: DataYandexVpcRouteTableStaticRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList">DataYandexVpcRouteTableStaticRouteList</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `routeTableIdInput`<sup>Optional</sup> <a name="routeTableIdInput" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.routeTableIdInput"></a>

```typescript
public readonly routeTableIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `routeTableId`<sup>Required</sup> <a name="routeTableId" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.routeTableId"></a>

```typescript
public readonly routeTableId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTable.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcRouteTable.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcSecurityGroup <a name="DataYandexVpcSecurityGroup" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group yandex_vpc_security_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroup } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroup(scope: Construct, id: string, config?: DataYandexVpcSecurityGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig">DataYandexVpcSecurityGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig">DataYandexVpcSecurityGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.isConstruct"></a>

```typescript
import { DataYandexVpcSecurityGroup } from '@cdktf/provider-yandex'

DataYandexVpcSecurityGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.egress">egress</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList">DataYandexVpcSecurityGroupEgressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.ingress">ingress</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList">DataYandexVpcSecurityGroupIngressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `egress`<sup>Required</sup> <a name="egress" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.egress"></a>

```typescript
public readonly egress: DataYandexVpcSecurityGroupEgressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList">DataYandexVpcSecurityGroupEgressList</a>

---

##### `ingress`<sup>Required</sup> <a name="ingress" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.ingress"></a>

```typescript
public readonly ingress: DataYandexVpcSecurityGroupIngressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList">DataYandexVpcSecurityGroupIngressList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcSecurityGroupRule <a name="DataYandexVpcSecurityGroupRule" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule yandex_vpc_security_group_rule}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupRule } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroupRule(scope: Construct, id: string, config: DataYandexVpcSecurityGroupRuleConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig">DataYandexVpcSecurityGroupRuleConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig">DataYandexVpcSecurityGroupRuleConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.isConstruct"></a>

```typescript
import { DataYandexVpcSecurityGroupRule } from '@cdktf/provider-yandex'

DataYandexVpcSecurityGroupRule.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.direction">direction</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.ruleIdInput">ruleIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupBindingInput">securityGroupBindingInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.ruleId">ruleId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupBinding">securityGroupBinding</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `direction`<sup>Required</sup> <a name="direction" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.direction"></a>

```typescript
public readonly direction: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `ruleIdInput`<sup>Optional</sup> <a name="ruleIdInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.ruleIdInput"></a>

```typescript
public readonly ruleIdInput: string;
```

- *Type:* string

---

##### `securityGroupBindingInput`<sup>Optional</sup> <a name="securityGroupBindingInput" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupBindingInput"></a>

```typescript
public readonly securityGroupBindingInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `ruleId`<sup>Required</sup> <a name="ruleId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.ruleId"></a>

```typescript
public readonly ruleId: string;
```

- *Type:* string

---

##### `securityGroupBinding`<sup>Required</sup> <a name="securityGroupBinding" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.securityGroupBinding"></a>

```typescript
public readonly securityGroupBinding: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRule.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexVpcSubnet <a name="DataYandexVpcSubnet" id="@cdktf/provider-yandex.DataYandexVpcSubnet"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet yandex_vpc_subnet}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer"></a>

```typescript
import { DataYandexVpcSubnet } from '@cdktf/provider-yandex'

new DataYandexVpcSubnet(scope: Construct, id: string, config?: DataYandexVpcSubnetConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig">DataYandexVpcSubnetConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexVpcSubnet.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig">DataYandexVpcSubnetConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSubnet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexVpcSubnet.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexVpcSubnet.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexVpcSubnet.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexVpcSubnet.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexVpcSubnet.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnet.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexVpcSubnet.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexVpcSubnet.isConstruct"></a>

```typescript
import { DataYandexVpcSubnet } from '@cdktf/provider-yandex'

DataYandexVpcSubnet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexVpcSubnet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.dhcpOptions">dhcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList">DataYandexVpcSubnetDhcpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.routeTableId">routeTableId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `dhcpOptions`<sup>Required</sup> <a name="dhcpOptions" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.dhcpOptions"></a>

```typescript
public readonly dhcpOptions: DataYandexVpcSubnetDhcpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList">DataYandexVpcSubnetDhcpOptionsList</a>

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `routeTableId`<sup>Required</sup> <a name="routeTableId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.routeTableId"></a>

```typescript
public readonly routeTableId: string;
```

- *Type:* string

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnet.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexVpcSubnet.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexYdbDatabaseDedicated <a name="DataYandexYdbDatabaseDedicated" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated yandex_ydb_database_dedicated}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicated } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicated(scope: Construct, id: string, config?: DataYandexYdbDatabaseDedicatedConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig">DataYandexYdbDatabaseDedicatedConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig">DataYandexYdbDatabaseDedicatedConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetDatabaseId">resetDatabaseId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDatabaseId` <a name="resetDatabaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetDatabaseId"></a>

```typescript
public resetDatabaseId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.isConstruct"></a>

```typescript
import { DataYandexYdbDatabaseDedicated } from '@cdktf/provider-yandex'

DataYandexYdbDatabaseDedicated.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.assignPublicIps">assignPublicIps</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databasePath">databasePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList">DataYandexYdbDatabaseDedicatedLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.locationId">locationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList">DataYandexYdbDatabaseDedicatedScalePolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.storageConfig">storageConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList">DataYandexYdbDatabaseDedicatedStorageConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.tlsEnabled">tlsEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.ydbApiEndpoint">ydbApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.ydbFullEndpoint">ydbFullEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databaseIdInput">databaseIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databaseId">databaseId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `assignPublicIps`<sup>Required</sup> <a name="assignPublicIps" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.assignPublicIps"></a>

```typescript
public readonly assignPublicIps: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `databasePath`<sup>Required</sup> <a name="databasePath" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databasePath"></a>

```typescript
public readonly databasePath: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.location"></a>

```typescript
public readonly location: DataYandexYdbDatabaseDedicatedLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList">DataYandexYdbDatabaseDedicatedLocationList</a>

---

##### `locationId`<sup>Required</sup> <a name="locationId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: DataYandexYdbDatabaseDedicatedScalePolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList">DataYandexYdbDatabaseDedicatedScalePolicyList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `storageConfig`<sup>Required</sup> <a name="storageConfig" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.storageConfig"></a>

```typescript
public readonly storageConfig: DataYandexYdbDatabaseDedicatedStorageConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList">DataYandexYdbDatabaseDedicatedStorageConfigList</a>

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ydbApiEndpoint`<sup>Required</sup> <a name="ydbApiEndpoint" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.ydbApiEndpoint"></a>

```typescript
public readonly ydbApiEndpoint: string;
```

- *Type:* string

---

##### `ydbFullEndpoint`<sup>Required</sup> <a name="ydbFullEndpoint" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.ydbFullEndpoint"></a>

```typescript
public readonly ydbFullEndpoint: string;
```

- *Type:* string

---

##### `databaseIdInput`<sup>Optional</sup> <a name="databaseIdInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databaseIdInput"></a>

```typescript
public readonly databaseIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `databaseId`<sup>Required</sup> <a name="databaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.databaseId"></a>

```typescript
public readonly databaseId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicated.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DataYandexYdbDatabaseServerless <a name="DataYandexYdbDatabaseServerless" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless yandex_ydb_database_serverless}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseServerless } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseServerless(scope: Construct, id: string, config?: DataYandexYdbDatabaseServerlessConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig">DataYandexYdbDatabaseServerlessConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig">DataYandexYdbDatabaseServerlessConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetDatabaseId">resetDatabaseId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetName">resetName</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDatabaseId` <a name="resetDatabaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetDatabaseId"></a>

```typescript
public resetDatabaseId(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetId"></a>

```typescript
public resetId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.resetName"></a>

```typescript
public resetName(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.isConstruct"></a>

```typescript
import { DataYandexYdbDatabaseServerless } from '@cdktf/provider-yandex'

DataYandexYdbDatabaseServerless.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databasePath">databasePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.documentApiEndpoint">documentApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.locationId">locationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.tlsEnabled">tlsEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.ydbApiEndpoint">ydbApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.ydbFullEndpoint">ydbFullEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databaseIdInput">databaseIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databaseId">databaseId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `databasePath`<sup>Required</sup> <a name="databasePath" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databasePath"></a>

```typescript
public readonly databasePath: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `documentApiEndpoint`<sup>Required</sup> <a name="documentApiEndpoint" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.documentApiEndpoint"></a>

```typescript
public readonly documentApiEndpoint: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `locationId`<sup>Required</sup> <a name="locationId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ydbApiEndpoint`<sup>Required</sup> <a name="ydbApiEndpoint" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.ydbApiEndpoint"></a>

```typescript
public readonly ydbApiEndpoint: string;
```

- *Type:* string

---

##### `ydbFullEndpoint`<sup>Required</sup> <a name="ydbFullEndpoint" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.ydbFullEndpoint"></a>

```typescript
public readonly ydbFullEndpoint: string;
```

- *Type:* string

---

##### `databaseIdInput`<sup>Optional</sup> <a name="databaseIdInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databaseIdInput"></a>

```typescript
public readonly databaseIdInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `databaseId`<sup>Required</sup> <a name="databaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.databaseId"></a>

```typescript
public readonly databaseId: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerless.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DnsRecordset <a name="DnsRecordset" id="@cdktf/provider-yandex.DnsRecordset"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset yandex_dns_recordset}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DnsRecordset.Initializer"></a>

```typescript
import { DnsRecordset } from '@cdktf/provider-yandex'

new DnsRecordset(scope: Construct, id: string, config: DnsRecordsetConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig">DnsRecordsetConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DnsRecordset.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DnsRecordsetConfig">DnsRecordsetConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DnsRecordset.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DnsRecordset.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DnsRecordset.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DnsRecordset.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DnsRecordset.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DnsRecordset.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DnsRecordset.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DnsRecordset.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DnsRecordset.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DnsRecordset.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DnsRecordset.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DnsRecordset.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DnsRecordset.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DnsRecordset.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DnsRecordset.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DnsRecordset.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordset.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.DnsRecordset.putTimeouts"></a>

```typescript
public putTimeouts(value: DnsRecordsetTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DnsRecordset.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a>

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DnsRecordset.resetId"></a>

```typescript
public resetId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.DnsRecordset.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DnsRecordset.isConstruct"></a>

```typescript
import { DnsRecordset } from '@cdktf/provider-yandex'

DnsRecordset.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DnsRecordset.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference">DnsRecordsetTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.dataInput">dataInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.zoneIdInput">zoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.data">data</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DnsRecordset.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DnsRecordset.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DnsRecordset.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DnsRecordset.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DnsRecordset.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DnsRecordset.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DnsRecordset.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DnsRecordset.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DnsRecordset.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DnsRecordset.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DnsRecordset.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.DnsRecordset.property.timeouts"></a>

```typescript
public readonly timeouts: DnsRecordsetTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference">DnsRecordsetTimeoutsOutputReference</a>

---

##### `dataInput`<sup>Optional</sup> <a name="dataInput" id="@cdktf/provider-yandex.DnsRecordset.property.dataInput"></a>

```typescript
public readonly dataInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DnsRecordset.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DnsRecordset.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.DnsRecordset.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DnsRecordsetTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a>

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.DnsRecordset.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.DnsRecordset.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `zoneIdInput`<sup>Optional</sup> <a name="zoneIdInput" id="@cdktf/provider-yandex.DnsRecordset.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* string

---

##### `data`<sup>Required</sup> <a name="data" id="@cdktf/provider-yandex.DnsRecordset.property.data"></a>

```typescript
public readonly data: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DnsRecordset.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DnsRecordset.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DnsRecordset.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DnsRecordset.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DnsRecordset.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordset.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DnsRecordset.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### DnsZone <a name="DnsZone" id="@cdktf/provider-yandex.DnsZone"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone yandex_dns_zone}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DnsZone.Initializer"></a>

```typescript
import { DnsZone } from '@cdktf/provider-yandex'

new DnsZone(scope: Construct, id: string, config: DnsZoneConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZone.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DnsZoneConfig">DnsZoneConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.DnsZone.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DnsZone.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DnsZone.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DnsZoneConfig">DnsZoneConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZone.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetPrivateNetworks">resetPrivateNetworks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetPublic">resetPublic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DnsZone.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.DnsZone.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DnsZone.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DnsZone.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.DnsZone.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.DnsZone.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.DnsZone.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.DnsZone.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.DnsZone.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DnsZone.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DnsZone.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DnsZone.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DnsZone.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DnsZone.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DnsZone.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DnsZone.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZone.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.DnsZone.putTimeouts"></a>

```typescript
public putTimeouts(value: DnsZoneTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DnsZone.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.DnsZone.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.DnsZone.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.DnsZone.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.DnsZone.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.DnsZone.resetName"></a>

```typescript
public resetName(): void
```

##### `resetPrivateNetworks` <a name="resetPrivateNetworks" id="@cdktf/provider-yandex.DnsZone.resetPrivateNetworks"></a>

```typescript
public resetPrivateNetworks(): void
```

##### `resetPublic` <a name="resetPublic" id="@cdktf/provider-yandex.DnsZone.resetPublic"></a>

```typescript
public resetPublic(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.DnsZone.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZone.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.DnsZone.isConstruct"></a>

```typescript
import { DnsZone } from '@cdktf/provider-yandex'

DnsZone.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.DnsZone.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference">DnsZoneTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.privateNetworksInput">privateNetworksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.publicInput">publicInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.privateNetworks">privateNetworks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.public">public</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.DnsZone.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.DnsZone.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DnsZone.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.DnsZone.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.DnsZone.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.DnsZone.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.DnsZone.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DnsZone.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DnsZone.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DnsZone.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DnsZone.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.DnsZone.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.DnsZone.property.timeouts"></a>

```typescript
public readonly timeouts: DnsZoneTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference">DnsZoneTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.DnsZone.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.DnsZone.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.DnsZone.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.DnsZone.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DnsZone.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `privateNetworksInput`<sup>Optional</sup> <a name="privateNetworksInput" id="@cdktf/provider-yandex.DnsZone.property.privateNetworksInput"></a>

```typescript
public readonly privateNetworksInput: string[];
```

- *Type:* string[]

---

##### `publicInput`<sup>Optional</sup> <a name="publicInput" id="@cdktf/provider-yandex.DnsZone.property.publicInput"></a>

```typescript
public readonly publicInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.DnsZone.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | DnsZoneTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a>

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.DnsZone.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DnsZone.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DnsZone.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DnsZone.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DnsZone.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DnsZone.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `privateNetworks`<sup>Required</sup> <a name="privateNetworks" id="@cdktf/provider-yandex.DnsZone.property.privateNetworks"></a>

```typescript
public readonly privateNetworks: string[];
```

- *Type:* string[]

---

##### `public`<sup>Required</sup> <a name="public" id="@cdktf/provider-yandex.DnsZone.property.public"></a>

```typescript
public readonly public: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DnsZone.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZone.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.DnsZone.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### Function <a name="Function" id="@cdktf/provider-yandex.Function"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function yandex_function}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.Function.Initializer"></a>

```typescript
import { Function } from '@cdktf/provider-yandex'

new Function(scope: Construct, id: string, config: FunctionConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.Function.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.Function.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.Function.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionConfig">FunctionConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.Function.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.Function.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.Function.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionConfig">FunctionConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.Function.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.Function.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.Function.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.Function.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.Function.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.putContent">putContent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.putPackage">putPackage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetContent">resetContent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetEnvironment">resetEnvironment</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetExecutionTimeout">resetExecutionTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetPackage">resetPackage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetTags">resetTags</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.Function.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.Function.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.Function.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.Function.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.Function.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.Function.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.Function.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.Function.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.Function.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.Function.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.Function.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.Function.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.Function.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.Function.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.Function.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.Function.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.Function.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.Function.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.Function.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.Function.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putContent` <a name="putContent" id="@cdktf/provider-yandex.Function.putContent"></a>

```typescript
public putContent(value: FunctionContent): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.Function.putContent.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a>

---

##### `putPackage` <a name="putPackage" id="@cdktf/provider-yandex.Function.putPackage"></a>

```typescript
public putPackage(value: FunctionPackage): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.Function.putPackage.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.Function.putTimeouts"></a>

```typescript
public putTimeouts(value: FunctionTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.Function.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a>

---

##### `resetContent` <a name="resetContent" id="@cdktf/provider-yandex.Function.resetContent"></a>

```typescript
public resetContent(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.Function.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetEnvironment` <a name="resetEnvironment" id="@cdktf/provider-yandex.Function.resetEnvironment"></a>

```typescript
public resetEnvironment(): void
```

##### `resetExecutionTimeout` <a name="resetExecutionTimeout" id="@cdktf/provider-yandex.Function.resetExecutionTimeout"></a>

```typescript
public resetExecutionTimeout(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.Function.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.Function.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.Function.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPackage` <a name="resetPackage" id="@cdktf/provider-yandex.Function.resetPackage"></a>

```typescript
public resetPackage(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.Function.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetTags` <a name="resetTags" id="@cdktf/provider-yandex.Function.resetTags"></a>

```typescript
public resetTags(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.Function.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.Function.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.Function.isConstruct"></a>

```typescript
import { Function } from '@cdktf/provider-yandex'

Function.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.Function.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.Function.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.Function.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.content">content</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference">FunctionContentOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.imageSize">imageSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.loggroupId">loggroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.package">package</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference">FunctionPackageOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference">FunctionTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.contentInput">contentInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.entrypointInput">entrypointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.environmentInput">environmentInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.executionTimeoutInput">executionTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.memoryInput">memoryInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.packageInput">packageInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.runtimeInput">runtimeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.tagsInput">tagsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.userHashInput">userHashInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.entrypoint">entrypoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.environment">environment</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.runtime">runtime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.tags">tags</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.Function.property.userHash">userHash</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.Function.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.Function.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.Function.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.Function.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.Function.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.Function.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.Function.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.Function.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.Function.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.Function.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.Function.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `content`<sup>Required</sup> <a name="content" id="@cdktf/provider-yandex.Function.property.content"></a>

```typescript
public readonly content: FunctionContentOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionContentOutputReference">FunctionContentOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.Function.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `imageSize`<sup>Required</sup> <a name="imageSize" id="@cdktf/provider-yandex.Function.property.imageSize"></a>

```typescript
public readonly imageSize: number;
```

- *Type:* number

---

##### `loggroupId`<sup>Required</sup> <a name="loggroupId" id="@cdktf/provider-yandex.Function.property.loggroupId"></a>

```typescript
public readonly loggroupId: string;
```

- *Type:* string

---

##### `package`<sup>Required</sup> <a name="package" id="@cdktf/provider-yandex.Function.property.package"></a>

```typescript
public readonly package: FunctionPackageOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionPackageOutputReference">FunctionPackageOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.Function.property.timeouts"></a>

```typescript
public readonly timeouts: FunctionTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference">FunctionTimeoutsOutputReference</a>

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.Function.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `contentInput`<sup>Optional</sup> <a name="contentInput" id="@cdktf/provider-yandex.Function.property.contentInput"></a>

```typescript
public readonly contentInput: FunctionContent;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.Function.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `entrypointInput`<sup>Optional</sup> <a name="entrypointInput" id="@cdktf/provider-yandex.Function.property.entrypointInput"></a>

```typescript
public readonly entrypointInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.Function.property.environmentInput"></a>

```typescript
public readonly environmentInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `executionTimeoutInput`<sup>Optional</sup> <a name="executionTimeoutInput" id="@cdktf/provider-yandex.Function.property.executionTimeoutInput"></a>

```typescript
public readonly executionTimeoutInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.Function.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.Function.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.Function.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@cdktf/provider-yandex.Function.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.Function.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `packageInput`<sup>Optional</sup> <a name="packageInput" id="@cdktf/provider-yandex.Function.property.packageInput"></a>

```typescript
public readonly packageInput: FunctionPackage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a>

---

##### `runtimeInput`<sup>Optional</sup> <a name="runtimeInput" id="@cdktf/provider-yandex.Function.property.runtimeInput"></a>

```typescript
public readonly runtimeInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.Function.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `tagsInput`<sup>Optional</sup> <a name="tagsInput" id="@cdktf/provider-yandex.Function.property.tagsInput"></a>

```typescript
public readonly tagsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.Function.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | FunctionTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a>

---

##### `userHashInput`<sup>Optional</sup> <a name="userHashInput" id="@cdktf/provider-yandex.Function.property.userHashInput"></a>

```typescript
public readonly userHashInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.Function.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `entrypoint`<sup>Required</sup> <a name="entrypoint" id="@cdktf/provider-yandex.Function.property.entrypoint"></a>

```typescript
public readonly entrypoint: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.Function.property.environment"></a>

```typescript
public readonly environment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `executionTimeout`<sup>Required</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.Function.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.Function.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.Function.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.Function.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.Function.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.Function.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `runtime`<sup>Required</sup> <a name="runtime" id="@cdktf/provider-yandex.Function.property.runtime"></a>

```typescript
public readonly runtime: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.Function.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `tags`<sup>Required</sup> <a name="tags" id="@cdktf/provider-yandex.Function.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

---

##### `userHash`<sup>Required</sup> <a name="userHash" id="@cdktf/provider-yandex.Function.property.userHash"></a>

```typescript
public readonly userHash: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.Function.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.Function.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### FunctionIamBinding <a name="FunctionIamBinding" id="@cdktf/provider-yandex.FunctionIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding yandex_function_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionIamBinding.Initializer"></a>

```typescript
import { FunctionIamBinding } from '@cdktf/provider-yandex'

new FunctionIamBinding(scope: Construct, id: string, config: FunctionIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig">FunctionIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.FunctionIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionIamBindingConfig">FunctionIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.FunctionIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.FunctionIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.FunctionIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.FunctionIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.FunctionIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.FunctionIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.FunctionIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.FunctionIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.FunctionIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.FunctionIamBinding.isConstruct"></a>

```typescript
import { FunctionIamBinding } from '@cdktf/provider-yandex'

FunctionIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.FunctionIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.functionIdInput">functionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.functionId">functionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.FunctionIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.FunctionIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.FunctionIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.FunctionIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.FunctionIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.FunctionIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `functionIdInput`<sup>Optional</sup> <a name="functionIdInput" id="@cdktf/provider-yandex.FunctionIamBinding.property.functionIdInput"></a>

```typescript
public readonly functionIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.FunctionIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.FunctionIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.FunctionIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.FunctionIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.FunctionIamBinding.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.FunctionIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.FunctionIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.FunctionIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.FunctionIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### FunctionScalingPolicy <a name="FunctionScalingPolicy" id="@cdktf/provider-yandex.FunctionScalingPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy yandex_function_scaling_policy}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionScalingPolicy.Initializer"></a>

```typescript
import { FunctionScalingPolicy } from '@cdktf/provider-yandex'

new FunctionScalingPolicy(scope: Construct, id: string, config: FunctionScalingPolicyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig">FunctionScalingPolicyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.FunctionScalingPolicy.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig">FunctionScalingPolicyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.putPolicy">putPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.resetPolicy">resetPolicy</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionScalingPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.FunctionScalingPolicy.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.FunctionScalingPolicy.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionScalingPolicy.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.FunctionScalingPolicy.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.FunctionScalingPolicy.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.FunctionScalingPolicy.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.FunctionScalingPolicy.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.FunctionScalingPolicy.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicy.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putPolicy` <a name="putPolicy" id="@cdktf/provider-yandex.FunctionScalingPolicy.putPolicy"></a>

```typescript
public putPolicy(value: IResolvable | FunctionScalingPolicyPolicy[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionScalingPolicy.putPolicy.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.FunctionScalingPolicy.resetId"></a>

```typescript
public resetId(): void
```

##### `resetPolicy` <a name="resetPolicy" id="@cdktf/provider-yandex.FunctionScalingPolicy.resetPolicy"></a>

```typescript
public resetPolicy(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.FunctionScalingPolicy.isConstruct"></a>

```typescript
import { FunctionScalingPolicy } from '@cdktf/provider-yandex'

FunctionScalingPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.FunctionScalingPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.policy">policy</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList">FunctionScalingPolicyPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.functionIdInput">functionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.policyInput">policyInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.functionId">functionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `policy`<sup>Required</sup> <a name="policy" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.policy"></a>

```typescript
public readonly policy: FunctionScalingPolicyPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList">FunctionScalingPolicyPolicyList</a>

---

##### `functionIdInput`<sup>Optional</sup> <a name="functionIdInput" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.functionIdInput"></a>

```typescript
public readonly functionIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `policyInput`<sup>Optional</sup> <a name="policyInput" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.policyInput"></a>

```typescript
public readonly policyInput: IResolvable | FunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicy.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.FunctionScalingPolicy.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### FunctionTrigger <a name="FunctionTrigger" id="@cdktf/provider-yandex.FunctionTrigger"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger yandex_function_trigger}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTrigger.Initializer"></a>

```typescript
import { FunctionTrigger } from '@cdktf/provider-yandex'

new FunctionTrigger(scope: Construct, id: string, config: FunctionTriggerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig">FunctionTriggerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.FunctionTrigger.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerConfig">FunctionTriggerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putDlq">putDlq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putFunction">putFunction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putIot">putIot</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putLogging">putLogging</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putLogGroup">putLogGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putMessageQueue">putMessageQueue</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putObjectStorage">putObjectStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.putTimer">putTimer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetDlq">resetDlq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetIot">resetIot</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetLogging">resetLogging</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetLogGroup">resetLogGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetMessageQueue">resetMessageQueue</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetObjectStorage">resetObjectStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.resetTimer">resetTimer</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTrigger.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.FunctionTrigger.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.FunctionTrigger.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.FunctionTrigger.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.FunctionTrigger.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.FunctionTrigger.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.FunctionTrigger.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.FunctionTrigger.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTrigger.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTrigger.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putDlq` <a name="putDlq" id="@cdktf/provider-yandex.FunctionTrigger.putDlq"></a>

```typescript
public putDlq(value: FunctionTriggerDlq): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putDlq.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a>

---

##### `putFunction` <a name="putFunction" id="@cdktf/provider-yandex.FunctionTrigger.putFunction"></a>

```typescript
public putFunction(value: FunctionTriggerFunction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putFunction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a>

---

##### `putIot` <a name="putIot" id="@cdktf/provider-yandex.FunctionTrigger.putIot"></a>

```typescript
public putIot(value: FunctionTriggerIot): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putIot.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a>

---

##### `putLogging` <a name="putLogging" id="@cdktf/provider-yandex.FunctionTrigger.putLogging"></a>

```typescript
public putLogging(value: FunctionTriggerLogging): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putLogging.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a>

---

##### `putLogGroup` <a name="putLogGroup" id="@cdktf/provider-yandex.FunctionTrigger.putLogGroup"></a>

```typescript
public putLogGroup(value: FunctionTriggerLogGroup): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putLogGroup.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a>

---

##### `putMessageQueue` <a name="putMessageQueue" id="@cdktf/provider-yandex.FunctionTrigger.putMessageQueue"></a>

```typescript
public putMessageQueue(value: FunctionTriggerMessageQueue): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putMessageQueue.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a>

---

##### `putObjectStorage` <a name="putObjectStorage" id="@cdktf/provider-yandex.FunctionTrigger.putObjectStorage"></a>

```typescript
public putObjectStorage(value: FunctionTriggerObjectStorage): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putObjectStorage.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.FunctionTrigger.putTimeouts"></a>

```typescript
public putTimeouts(value: FunctionTriggerTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a>

---

##### `putTimer` <a name="putTimer" id="@cdktf/provider-yandex.FunctionTrigger.putTimer"></a>

```typescript
public putTimer(value: FunctionTriggerTimer): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.FunctionTrigger.putTimer.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.FunctionTrigger.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetDlq` <a name="resetDlq" id="@cdktf/provider-yandex.FunctionTrigger.resetDlq"></a>

```typescript
public resetDlq(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.FunctionTrigger.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.FunctionTrigger.resetId"></a>

```typescript
public resetId(): void
```

##### `resetIot` <a name="resetIot" id="@cdktf/provider-yandex.FunctionTrigger.resetIot"></a>

```typescript
public resetIot(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.FunctionTrigger.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetLogging` <a name="resetLogging" id="@cdktf/provider-yandex.FunctionTrigger.resetLogging"></a>

```typescript
public resetLogging(): void
```

##### `resetLogGroup` <a name="resetLogGroup" id="@cdktf/provider-yandex.FunctionTrigger.resetLogGroup"></a>

```typescript
public resetLogGroup(): void
```

##### `resetMessageQueue` <a name="resetMessageQueue" id="@cdktf/provider-yandex.FunctionTrigger.resetMessageQueue"></a>

```typescript
public resetMessageQueue(): void
```

##### `resetObjectStorage` <a name="resetObjectStorage" id="@cdktf/provider-yandex.FunctionTrigger.resetObjectStorage"></a>

```typescript
public resetObjectStorage(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.FunctionTrigger.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetTimer` <a name="resetTimer" id="@cdktf/provider-yandex.FunctionTrigger.resetTimer"></a>

```typescript
public resetTimer(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.FunctionTrigger.isConstruct"></a>

```typescript
import { FunctionTrigger } from '@cdktf/provider-yandex'

FunctionTrigger.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.FunctionTrigger.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.dlq">dlq</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference">FunctionTriggerDlqOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.function">function</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference">FunctionTriggerFunctionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.iot">iot</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference">FunctionTriggerIotOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.logging">logging</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference">FunctionTriggerLoggingOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.logGroup">logGroup</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference">FunctionTriggerLogGroupOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.messageQueue">messageQueue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference">FunctionTriggerMessageQueueOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.objectStorage">objectStorage</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference">FunctionTriggerObjectStorageOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference">FunctionTriggerTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.timer">timer</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference">FunctionTriggerTimerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.dlqInput">dlqInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.functionInput">functionInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.iotInput">iotInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.loggingInput">loggingInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.logGroupInput">logGroupInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.messageQueueInput">messageQueueInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.objectStorageInput">objectStorageInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.timerInput">timerInput</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.FunctionTrigger.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.FunctionTrigger.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTrigger.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.FunctionTrigger.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.FunctionTrigger.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.FunctionTrigger.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.FunctionTrigger.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionTrigger.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionTrigger.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionTrigger.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionTrigger.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.FunctionTrigger.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `dlq`<sup>Required</sup> <a name="dlq" id="@cdktf/provider-yandex.FunctionTrigger.property.dlq"></a>

```typescript
public readonly dlq: FunctionTriggerDlqOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference">FunctionTriggerDlqOutputReference</a>

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.FunctionTrigger.property.function"></a>

```typescript
public readonly function: FunctionTriggerFunctionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference">FunctionTriggerFunctionOutputReference</a>

---

##### `iot`<sup>Required</sup> <a name="iot" id="@cdktf/provider-yandex.FunctionTrigger.property.iot"></a>

```typescript
public readonly iot: FunctionTriggerIotOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference">FunctionTriggerIotOutputReference</a>

---

##### `logging`<sup>Required</sup> <a name="logging" id="@cdktf/provider-yandex.FunctionTrigger.property.logging"></a>

```typescript
public readonly logging: FunctionTriggerLoggingOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference">FunctionTriggerLoggingOutputReference</a>

---

##### `logGroup`<sup>Required</sup> <a name="logGroup" id="@cdktf/provider-yandex.FunctionTrigger.property.logGroup"></a>

```typescript
public readonly logGroup: FunctionTriggerLogGroupOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference">FunctionTriggerLogGroupOutputReference</a>

---

##### `messageQueue`<sup>Required</sup> <a name="messageQueue" id="@cdktf/provider-yandex.FunctionTrigger.property.messageQueue"></a>

```typescript
public readonly messageQueue: FunctionTriggerMessageQueueOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference">FunctionTriggerMessageQueueOutputReference</a>

---

##### `objectStorage`<sup>Required</sup> <a name="objectStorage" id="@cdktf/provider-yandex.FunctionTrigger.property.objectStorage"></a>

```typescript
public readonly objectStorage: FunctionTriggerObjectStorageOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference">FunctionTriggerObjectStorageOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.FunctionTrigger.property.timeouts"></a>

```typescript
public readonly timeouts: FunctionTriggerTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference">FunctionTriggerTimeoutsOutputReference</a>

---

##### `timer`<sup>Required</sup> <a name="timer" id="@cdktf/provider-yandex.FunctionTrigger.property.timer"></a>

```typescript
public readonly timer: FunctionTriggerTimerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference">FunctionTriggerTimerOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.FunctionTrigger.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `dlqInput`<sup>Optional</sup> <a name="dlqInput" id="@cdktf/provider-yandex.FunctionTrigger.property.dlqInput"></a>

```typescript
public readonly dlqInput: FunctionTriggerDlq;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.FunctionTrigger.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `functionInput`<sup>Optional</sup> <a name="functionInput" id="@cdktf/provider-yandex.FunctionTrigger.property.functionInput"></a>

```typescript
public readonly functionInput: FunctionTriggerFunction;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a>

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.FunctionTrigger.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `iotInput`<sup>Optional</sup> <a name="iotInput" id="@cdktf/provider-yandex.FunctionTrigger.property.iotInput"></a>

```typescript
public readonly iotInput: FunctionTriggerIot;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a>

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.FunctionTrigger.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `loggingInput`<sup>Optional</sup> <a name="loggingInput" id="@cdktf/provider-yandex.FunctionTrigger.property.loggingInput"></a>

```typescript
public readonly loggingInput: FunctionTriggerLogging;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a>

---

##### `logGroupInput`<sup>Optional</sup> <a name="logGroupInput" id="@cdktf/provider-yandex.FunctionTrigger.property.logGroupInput"></a>

```typescript
public readonly logGroupInput: FunctionTriggerLogGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a>

---

##### `messageQueueInput`<sup>Optional</sup> <a name="messageQueueInput" id="@cdktf/provider-yandex.FunctionTrigger.property.messageQueueInput"></a>

```typescript
public readonly messageQueueInput: FunctionTriggerMessageQueue;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.FunctionTrigger.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `objectStorageInput`<sup>Optional</sup> <a name="objectStorageInput" id="@cdktf/provider-yandex.FunctionTrigger.property.objectStorageInput"></a>

```typescript
public readonly objectStorageInput: FunctionTriggerObjectStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a>

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.FunctionTrigger.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | FunctionTriggerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a>

---

##### `timerInput`<sup>Optional</sup> <a name="timerInput" id="@cdktf/provider-yandex.FunctionTrigger.property.timerInput"></a>

```typescript
public readonly timerInput: FunctionTriggerTimer;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.FunctionTrigger.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.FunctionTrigger.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionTrigger.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.FunctionTrigger.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.FunctionTrigger.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTrigger.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.FunctionTrigger.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccount <a name="IamServiceAccount" id="@cdktf/provider-yandex.IamServiceAccount"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account yandex_iam_service_account}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccount.Initializer"></a>

```typescript
import { IamServiceAccount } from '@cdktf/provider-yandex'

new IamServiceAccount(scope: Construct, id: string, config: IamServiceAccountConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig">IamServiceAccountConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccount.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountConfig">IamServiceAccountConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccount.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccount.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccount.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccount.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccount.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccount.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccount.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccount.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccount.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccount.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccount.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.IamServiceAccount.putTimeouts"></a>

```typescript
public putTimeouts(value: IamServiceAccountTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccount.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IamServiceAccount.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.IamServiceAccount.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccount.resetId"></a>

```typescript
public resetId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.IamServiceAccount.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccount.isConstruct"></a>

```typescript
import { IamServiceAccount } from '@cdktf/provider-yandex'

IamServiceAccount.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccount.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference">IamServiceAccountTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccount.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccount.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccount.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccount.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccount.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccount.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccount.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccount.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccount.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccount.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IamServiceAccount.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.IamServiceAccount.property.timeouts"></a>

```typescript
public readonly timeouts: IamServiceAccountTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference">IamServiceAccountTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IamServiceAccount.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.IamServiceAccount.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccount.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.IamServiceAccount.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.IamServiceAccount.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | IamServiceAccountTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccount.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.IamServiceAccount.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccount.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IamServiceAccount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccount.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccount.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountApiKey <a name="IamServiceAccountApiKey" id="@cdktf/provider-yandex.IamServiceAccountApiKey"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key yandex_iam_service_account_api_key}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer"></a>

```typescript
import { IamServiceAccountApiKey } from '@cdktf/provider-yandex'

new IamServiceAccountApiKey(scope: Construct, id: string, config: IamServiceAccountApiKeyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig">IamServiceAccountApiKeyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountApiKey.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig">IamServiceAccountApiKeyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.resetPgpKey">resetPgpKey</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountApiKey.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountApiKey.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountApiKey.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountApiKey.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountApiKey.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountApiKey.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountApiKey.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IamServiceAccountApiKey.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.resetId"></a>

```typescript
public resetId(): void
```

##### `resetPgpKey` <a name="resetPgpKey" id="@cdktf/provider-yandex.IamServiceAccountApiKey.resetPgpKey"></a>

```typescript
public resetPgpKey(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountApiKey.isConstruct"></a>

```typescript
import { IamServiceAccountApiKey } from '@cdktf/provider-yandex'

IamServiceAccountApiKey.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountApiKey.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.encryptedSecretKey">encryptedSecretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.keyFingerprint">keyFingerprint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.pgpKeyInput">pgpKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.pgpKey">pgpKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `encryptedSecretKey`<sup>Required</sup> <a name="encryptedSecretKey" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.encryptedSecretKey"></a>

```typescript
public readonly encryptedSecretKey: string;
```

- *Type:* string

---

##### `keyFingerprint`<sup>Required</sup> <a name="keyFingerprint" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.keyFingerprint"></a>

```typescript
public readonly keyFingerprint: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `pgpKeyInput`<sup>Optional</sup> <a name="pgpKeyInput" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.pgpKeyInput"></a>

```typescript
public readonly pgpKeyInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `pgpKey`<sup>Required</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKey.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountApiKey.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountIamBinding <a name="IamServiceAccountIamBinding" id="@cdktf/provider-yandex.IamServiceAccountIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding yandex_iam_service_account_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer"></a>

```typescript
import { IamServiceAccountIamBinding } from '@cdktf/provider-yandex'

new IamServiceAccountIamBinding(scope: Construct, id: string, config: IamServiceAccountIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig">IamServiceAccountIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig">IamServiceAccountIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.isConstruct"></a>

```typescript
import { IamServiceAccountIamBinding } from '@cdktf/provider-yandex'

IamServiceAccountIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountIamMember <a name="IamServiceAccountIamMember" id="@cdktf/provider-yandex.IamServiceAccountIamMember"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member yandex_iam_service_account_iam_member}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer"></a>

```typescript
import { IamServiceAccountIamMember } from '@cdktf/provider-yandex'

new IamServiceAccountIamMember(scope: Construct, id: string, config: IamServiceAccountIamMemberConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig">IamServiceAccountIamMemberConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountIamMember.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig">IamServiceAccountIamMemberConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountIamMember.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountIamMember.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountIamMember.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountIamMember.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamMember.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountIamMember.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamMember.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamMember.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountIamMember.isConstruct"></a>

```typescript
import { IamServiceAccountIamMember } from '@cdktf/provider-yandex'

IamServiceAccountIamMember.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountIamMember.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.memberInput">memberInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.member">member</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `memberInput`<sup>Optional</sup> <a name="memberInput" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.memberInput"></a>

```typescript
public readonly memberInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMember.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamMember.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountIamPolicy <a name="IamServiceAccountIamPolicy" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy yandex_iam_service_account_iam_policy}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer"></a>

```typescript
import { IamServiceAccountIamPolicy } from '@cdktf/provider-yandex'

new IamServiceAccountIamPolicy(scope: Construct, id: string, config: IamServiceAccountIamPolicyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig">IamServiceAccountIamPolicyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig">IamServiceAccountIamPolicyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.isConstruct"></a>

```typescript
import { IamServiceAccountIamPolicy } from '@cdktf/provider-yandex'

IamServiceAccountIamPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.policyDataInput">policyDataInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.policyData">policyData</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `policyDataInput`<sup>Optional</sup> <a name="policyDataInput" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.policyDataInput"></a>

```typescript
public readonly policyDataInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `policyData`<sup>Required</sup> <a name="policyData" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.policyData"></a>

```typescript
public readonly policyData: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountIamPolicy.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountKey <a name="IamServiceAccountKey" id="@cdktf/provider-yandex.IamServiceAccountKey"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key yandex_iam_service_account_key}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountKey.Initializer"></a>

```typescript
import { IamServiceAccountKey } from '@cdktf/provider-yandex'

new IamServiceAccountKey(scope: Construct, id: string, config: IamServiceAccountKeyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig">IamServiceAccountKeyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountKey.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig">IamServiceAccountKeyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetFormat">resetFormat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetKeyAlgorithm">resetKeyAlgorithm</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.resetPgpKey">resetPgpKey</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountKey.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountKey.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountKey.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountKey.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountKey.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountKey.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountKey.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountKey.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountKey.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountKey.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IamServiceAccountKey.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFormat` <a name="resetFormat" id="@cdktf/provider-yandex.IamServiceAccountKey.resetFormat"></a>

```typescript
public resetFormat(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountKey.resetId"></a>

```typescript
public resetId(): void
```

##### `resetKeyAlgorithm` <a name="resetKeyAlgorithm" id="@cdktf/provider-yandex.IamServiceAccountKey.resetKeyAlgorithm"></a>

```typescript
public resetKeyAlgorithm(): void
```

##### `resetPgpKey` <a name="resetPgpKey" id="@cdktf/provider-yandex.IamServiceAccountKey.resetPgpKey"></a>

```typescript
public resetPgpKey(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountKey.isConstruct"></a>

```typescript
import { IamServiceAccountKey } from '@cdktf/provider-yandex'

IamServiceAccountKey.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountKey.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.encryptedPrivateKey">encryptedPrivateKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.keyFingerprint">keyFingerprint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.privateKey">privateKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.publicKey">publicKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.formatInput">formatInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.keyAlgorithmInput">keyAlgorithmInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.pgpKeyInput">pgpKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.format">format</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.keyAlgorithm">keyAlgorithm</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.pgpKey">pgpKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountKey.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountKey.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountKey.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountKey.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountKey.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountKey.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountKey.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountKey.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountKey.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountKey.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountKey.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IamServiceAccountKey.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `encryptedPrivateKey`<sup>Required</sup> <a name="encryptedPrivateKey" id="@cdktf/provider-yandex.IamServiceAccountKey.property.encryptedPrivateKey"></a>

```typescript
public readonly encryptedPrivateKey: string;
```

- *Type:* string

---

##### `keyFingerprint`<sup>Required</sup> <a name="keyFingerprint" id="@cdktf/provider-yandex.IamServiceAccountKey.property.keyFingerprint"></a>

```typescript
public readonly keyFingerprint: string;
```

- *Type:* string

---

##### `privateKey`<sup>Required</sup> <a name="privateKey" id="@cdktf/provider-yandex.IamServiceAccountKey.property.privateKey"></a>

```typescript
public readonly privateKey: string;
```

- *Type:* string

---

##### `publicKey`<sup>Required</sup> <a name="publicKey" id="@cdktf/provider-yandex.IamServiceAccountKey.property.publicKey"></a>

```typescript
public readonly publicKey: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `formatInput`<sup>Optional</sup> <a name="formatInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.formatInput"></a>

```typescript
public readonly formatInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `keyAlgorithmInput`<sup>Optional</sup> <a name="keyAlgorithmInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.keyAlgorithmInput"></a>

```typescript
public readonly keyAlgorithmInput: string;
```

- *Type:* string

---

##### `pgpKeyInput`<sup>Optional</sup> <a name="pgpKeyInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.pgpKeyInput"></a>

```typescript
public readonly pgpKeyInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountKey.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountKey.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `format`<sup>Required</sup> <a name="format" id="@cdktf/provider-yandex.IamServiceAccountKey.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountKey.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `keyAlgorithm`<sup>Required</sup> <a name="keyAlgorithm" id="@cdktf/provider-yandex.IamServiceAccountKey.property.keyAlgorithm"></a>

```typescript
public readonly keyAlgorithm: string;
```

- *Type:* string

---

##### `pgpKey`<sup>Required</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountKey.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountKey.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKey.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountKey.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IamServiceAccountStaticAccessKey <a name="IamServiceAccountStaticAccessKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key yandex_iam_service_account_static_access_key}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer"></a>

```typescript
import { IamServiceAccountStaticAccessKey } from '@cdktf/provider-yandex'

new IamServiceAccountStaticAccessKey(scope: Construct, id: string, config: IamServiceAccountStaticAccessKeyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig">IamServiceAccountStaticAccessKeyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig">IamServiceAccountStaticAccessKeyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetPgpKey">resetPgpKey</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetId"></a>

```typescript
public resetId(): void
```

##### `resetPgpKey` <a name="resetPgpKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.resetPgpKey"></a>

```typescript
public resetPgpKey(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.isConstruct"></a>

```typescript
import { IamServiceAccountStaticAccessKey } from '@cdktf/provider-yandex'

IamServiceAccountStaticAccessKey.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.accessKey">accessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.encryptedSecretKey">encryptedSecretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.keyFingerprint">keyFingerprint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.pgpKeyInput">pgpKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.pgpKey">pgpKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `accessKey`<sup>Required</sup> <a name="accessKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `encryptedSecretKey`<sup>Required</sup> <a name="encryptedSecretKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.encryptedSecretKey"></a>

```typescript
public readonly encryptedSecretKey: string;
```

- *Type:* string

---

##### `keyFingerprint`<sup>Required</sup> <a name="keyFingerprint" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.keyFingerprint"></a>

```typescript
public readonly keyFingerprint: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `pgpKeyInput`<sup>Optional</sup> <a name="pgpKeyInput" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.pgpKeyInput"></a>

```typescript
public readonly pgpKeyInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `pgpKey`<sup>Required</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKey.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IotCoreDevice <a name="IotCoreDevice" id="@cdktf/provider-yandex.IotCoreDevice"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device yandex_iot_core_device}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IotCoreDevice.Initializer"></a>

```typescript
import { IotCoreDevice } from '@cdktf/provider-yandex'

new IotCoreDevice(scope: Construct, id: string, config: IotCoreDeviceConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig">IotCoreDeviceConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IotCoreDevice.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreDeviceConfig">IotCoreDeviceConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetAliases">resetAliases</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetCertificates">resetCertificates</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetPasswords">resetPasswords</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IotCoreDevice.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IotCoreDevice.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IotCoreDevice.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IotCoreDevice.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IotCoreDevice.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IotCoreDevice.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IotCoreDevice.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IotCoreDevice.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IotCoreDevice.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IotCoreDevice.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDevice.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.IotCoreDevice.putTimeouts"></a>

```typescript
public putTimeouts(value: IotCoreDeviceTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IotCoreDevice.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a>

---

##### `resetAliases` <a name="resetAliases" id="@cdktf/provider-yandex.IotCoreDevice.resetAliases"></a>

```typescript
public resetAliases(): void
```

##### `resetCertificates` <a name="resetCertificates" id="@cdktf/provider-yandex.IotCoreDevice.resetCertificates"></a>

```typescript
public resetCertificates(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IotCoreDevice.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IotCoreDevice.resetId"></a>

```typescript
public resetId(): void
```

##### `resetPasswords` <a name="resetPasswords" id="@cdktf/provider-yandex.IotCoreDevice.resetPasswords"></a>

```typescript
public resetPasswords(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.IotCoreDevice.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IotCoreDevice.isConstruct"></a>

```typescript
import { IotCoreDevice } from '@cdktf/provider-yandex'

IotCoreDevice.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IotCoreDevice.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference">IotCoreDeviceTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.aliasesInput">aliasesInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.certificatesInput">certificatesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.passwordsInput">passwordsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.registryIdInput">registryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.aliases">aliases</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.certificates">certificates</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.passwords">passwords</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IotCoreDevice.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IotCoreDevice.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IotCoreDevice.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IotCoreDevice.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IotCoreDevice.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IotCoreDevice.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IotCoreDevice.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IotCoreDevice.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IotCoreDevice.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IotCoreDevice.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IotCoreDevice.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IotCoreDevice.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.IotCoreDevice.property.timeouts"></a>

```typescript
public readonly timeouts: IotCoreDeviceTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference">IotCoreDeviceTimeoutsOutputReference</a>

---

##### `aliasesInput`<sup>Optional</sup> <a name="aliasesInput" id="@cdktf/provider-yandex.IotCoreDevice.property.aliasesInput"></a>

```typescript
public readonly aliasesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `certificatesInput`<sup>Optional</sup> <a name="certificatesInput" id="@cdktf/provider-yandex.IotCoreDevice.property.certificatesInput"></a>

```typescript
public readonly certificatesInput: string[];
```

- *Type:* string[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IotCoreDevice.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IotCoreDevice.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.IotCoreDevice.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordsInput`<sup>Optional</sup> <a name="passwordsInput" id="@cdktf/provider-yandex.IotCoreDevice.property.passwordsInput"></a>

```typescript
public readonly passwordsInput: string[];
```

- *Type:* string[]

---

##### `registryIdInput`<sup>Optional</sup> <a name="registryIdInput" id="@cdktf/provider-yandex.IotCoreDevice.property.registryIdInput"></a>

```typescript
public readonly registryIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.IotCoreDevice.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | IotCoreDeviceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a>

---

##### `aliases`<sup>Required</sup> <a name="aliases" id="@cdktf/provider-yandex.IotCoreDevice.property.aliases"></a>

```typescript
public readonly aliases: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `certificates`<sup>Required</sup> <a name="certificates" id="@cdktf/provider-yandex.IotCoreDevice.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IotCoreDevice.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreDevice.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IotCoreDevice.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `passwords`<sup>Required</sup> <a name="passwords" id="@cdktf/provider-yandex.IotCoreDevice.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.IotCoreDevice.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDevice.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IotCoreDevice.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### IotCoreRegistry <a name="IotCoreRegistry" id="@cdktf/provider-yandex.IotCoreRegistry"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry yandex_iot_core_registry}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IotCoreRegistry.Initializer"></a>

```typescript
import { IotCoreRegistry } from '@cdktf/provider-yandex'

new IotCoreRegistry(scope: Construct, id: string, config: IotCoreRegistryConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig">IotCoreRegistryConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.IotCoreRegistry.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreRegistryConfig">IotCoreRegistryConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetCertificates">resetCertificates</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetPasswords">resetPasswords</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IotCoreRegistry.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.IotCoreRegistry.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.IotCoreRegistry.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IotCoreRegistry.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.IotCoreRegistry.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.IotCoreRegistry.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.IotCoreRegistry.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.IotCoreRegistry.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.IotCoreRegistry.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistry.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.IotCoreRegistry.putTimeouts"></a>

```typescript
public putTimeouts(value: IotCoreRegistryTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.IotCoreRegistry.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a>

---

##### `resetCertificates` <a name="resetCertificates" id="@cdktf/provider-yandex.IotCoreRegistry.resetCertificates"></a>

```typescript
public resetCertificates(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.IotCoreRegistry.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.IotCoreRegistry.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.IotCoreRegistry.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.IotCoreRegistry.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPasswords` <a name="resetPasswords" id="@cdktf/provider-yandex.IotCoreRegistry.resetPasswords"></a>

```typescript
public resetPasswords(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.IotCoreRegistry.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.IotCoreRegistry.isConstruct"></a>

```typescript
import { IotCoreRegistry } from '@cdktf/provider-yandex'

IotCoreRegistry.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.IotCoreRegistry.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference">IotCoreRegistryTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.certificatesInput">certificatesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.passwordsInput">passwordsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.certificates">certificates</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.passwords">passwords</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.IotCoreRegistry.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.IotCoreRegistry.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IotCoreRegistry.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.IotCoreRegistry.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.IotCoreRegistry.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.IotCoreRegistry.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.IotCoreRegistry.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IotCoreRegistry.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IotCoreRegistry.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IotCoreRegistry.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IotCoreRegistry.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.IotCoreRegistry.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.IotCoreRegistry.property.timeouts"></a>

```typescript
public readonly timeouts: IotCoreRegistryTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference">IotCoreRegistryTimeoutsOutputReference</a>

---

##### `certificatesInput`<sup>Optional</sup> <a name="certificatesInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.certificatesInput"></a>

```typescript
public readonly certificatesInput: string[];
```

- *Type:* string[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordsInput`<sup>Optional</sup> <a name="passwordsInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.passwordsInput"></a>

```typescript
public readonly passwordsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.IotCoreRegistry.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | IotCoreRegistryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a>

---

##### `certificates`<sup>Required</sup> <a name="certificates" id="@cdktf/provider-yandex.IotCoreRegistry.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.IotCoreRegistry.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.IotCoreRegistry.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreRegistry.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.IotCoreRegistry.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IotCoreRegistry.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `passwords`<sup>Required</sup> <a name="passwords" id="@cdktf/provider-yandex.IotCoreRegistry.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistry.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.IotCoreRegistry.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### KmsSecretCiphertext <a name="KmsSecretCiphertext" id="@cdktf/provider-yandex.KmsSecretCiphertext"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext yandex_kms_secret_ciphertext}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KmsSecretCiphertext.Initializer"></a>

```typescript
import { KmsSecretCiphertext } from '@cdktf/provider-yandex'

new KmsSecretCiphertext(scope: Construct, id: string, config: KmsSecretCiphertextConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig">KmsSecretCiphertextConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.KmsSecretCiphertext.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig">KmsSecretCiphertextConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.resetAadContext">resetAadContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KmsSecretCiphertext.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.KmsSecretCiphertext.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.KmsSecretCiphertext.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KmsSecretCiphertext.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.KmsSecretCiphertext.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.KmsSecretCiphertext.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.KmsSecretCiphertext.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.KmsSecretCiphertext.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.KmsSecretCiphertext.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertext.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.KmsSecretCiphertext.putTimeouts"></a>

```typescript
public putTimeouts(value: KmsSecretCiphertextTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KmsSecretCiphertext.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a>

---

##### `resetAadContext` <a name="resetAadContext" id="@cdktf/provider-yandex.KmsSecretCiphertext.resetAadContext"></a>

```typescript
public resetAadContext(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.KmsSecretCiphertext.resetId"></a>

```typescript
public resetId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.KmsSecretCiphertext.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.KmsSecretCiphertext.isConstruct"></a>

```typescript
import { KmsSecretCiphertext } from '@cdktf/provider-yandex'

KmsSecretCiphertext.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.KmsSecretCiphertext.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.ciphertext">ciphertext</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference">KmsSecretCiphertextTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.aadContextInput">aadContextInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.keyIdInput">keyIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.plaintextInput">plaintextInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.aadContext">aadContext</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.keyId">keyId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.plaintext">plaintext</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `ciphertext`<sup>Required</sup> <a name="ciphertext" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.ciphertext"></a>

```typescript
public readonly ciphertext: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.timeouts"></a>

```typescript
public readonly timeouts: KmsSecretCiphertextTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference">KmsSecretCiphertextTimeoutsOutputReference</a>

---

##### `aadContextInput`<sup>Optional</sup> <a name="aadContextInput" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.aadContextInput"></a>

```typescript
public readonly aadContextInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `keyIdInput`<sup>Optional</sup> <a name="keyIdInput" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.keyIdInput"></a>

```typescript
public readonly keyIdInput: string;
```

- *Type:* string

---

##### `plaintextInput`<sup>Optional</sup> <a name="plaintextInput" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.plaintextInput"></a>

```typescript
public readonly plaintextInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | KmsSecretCiphertextTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a>

---

##### `aadContext`<sup>Required</sup> <a name="aadContext" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.aadContext"></a>

```typescript
public readonly aadContext: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `keyId`<sup>Required</sup> <a name="keyId" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* string

---

##### `plaintext`<sup>Required</sup> <a name="plaintext" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.plaintext"></a>

```typescript
public readonly plaintext: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertext.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.KmsSecretCiphertext.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### KmsSymmetricKey <a name="KmsSymmetricKey" id="@cdktf/provider-yandex.KmsSymmetricKey"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key yandex_kms_symmetric_key}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KmsSymmetricKey.Initializer"></a>

```typescript
import { KmsSymmetricKey } from '@cdktf/provider-yandex'

new KmsSymmetricKey(scope: Construct, id: string, config?: KmsSymmetricKeyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig">KmsSymmetricKeyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.KmsSymmetricKey.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig">KmsSymmetricKeyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetDefaultAlgorithm">resetDefaultAlgorithm</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetRotationPeriod">resetRotationPeriod</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KmsSymmetricKey.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.KmsSymmetricKey.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.KmsSymmetricKey.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KmsSymmetricKey.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKey.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKey.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKey.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.KmsSymmetricKey.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.KmsSymmetricKey.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKey.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.KmsSymmetricKey.putTimeouts"></a>

```typescript
public putTimeouts(value: KmsSymmetricKeyTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KmsSymmetricKey.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a>

---

##### `resetDefaultAlgorithm` <a name="resetDefaultAlgorithm" id="@cdktf/provider-yandex.KmsSymmetricKey.resetDefaultAlgorithm"></a>

```typescript
public resetDefaultAlgorithm(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.KmsSymmetricKey.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.KmsSymmetricKey.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.KmsSymmetricKey.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.KmsSymmetricKey.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.KmsSymmetricKey.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRotationPeriod` <a name="resetRotationPeriod" id="@cdktf/provider-yandex.KmsSymmetricKey.resetRotationPeriod"></a>

```typescript
public resetRotationPeriod(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.KmsSymmetricKey.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.KmsSymmetricKey.isConstruct"></a>

```typescript
import { KmsSymmetricKey } from '@cdktf/provider-yandex'

KmsSymmetricKey.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.KmsSymmetricKey.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.rotatedAt">rotatedAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference">KmsSymmetricKeyTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.defaultAlgorithmInput">defaultAlgorithmInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.rotationPeriodInput">rotationPeriodInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.defaultAlgorithm">defaultAlgorithm</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.rotationPeriod">rotationPeriod</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.KmsSymmetricKey.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.KmsSymmetricKey.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KmsSymmetricKey.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.KmsSymmetricKey.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.KmsSymmetricKey.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.KmsSymmetricKey.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.KmsSymmetricKey.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSymmetricKey.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSymmetricKey.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSymmetricKey.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSymmetricKey.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.KmsSymmetricKey.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `rotatedAt`<sup>Required</sup> <a name="rotatedAt" id="@cdktf/provider-yandex.KmsSymmetricKey.property.rotatedAt"></a>

```typescript
public readonly rotatedAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.KmsSymmetricKey.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.KmsSymmetricKey.property.timeouts"></a>

```typescript
public readonly timeouts: KmsSymmetricKeyTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference">KmsSymmetricKeyTimeoutsOutputReference</a>

---

##### `defaultAlgorithmInput`<sup>Optional</sup> <a name="defaultAlgorithmInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.defaultAlgorithmInput"></a>

```typescript
public readonly defaultAlgorithmInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `rotationPeriodInput`<sup>Optional</sup> <a name="rotationPeriodInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.rotationPeriodInput"></a>

```typescript
public readonly rotationPeriodInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.KmsSymmetricKey.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | KmsSymmetricKeyTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a>

---

##### `defaultAlgorithm`<sup>Required</sup> <a name="defaultAlgorithm" id="@cdktf/provider-yandex.KmsSymmetricKey.property.defaultAlgorithm"></a>

```typescript
public readonly defaultAlgorithm: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.KmsSymmetricKey.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.KmsSymmetricKey.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKey.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.KmsSymmetricKey.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.KmsSymmetricKey.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `rotationPeriod`<sup>Required</sup> <a name="rotationPeriod" id="@cdktf/provider-yandex.KmsSymmetricKey.property.rotationPeriod"></a>

```typescript
public readonly rotationPeriod: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKey.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.KmsSymmetricKey.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### KmsSymmetricKeyIamBinding <a name="KmsSymmetricKeyIamBinding" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding yandex_kms_symmetric_key_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer"></a>

```typescript
import { KmsSymmetricKeyIamBinding } from '@cdktf/provider-yandex'

new KmsSymmetricKeyIamBinding(scope: Construct, id: string, config: KmsSymmetricKeyIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig">KmsSymmetricKeyIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig">KmsSymmetricKeyIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.isConstruct"></a>

```typescript
import { KmsSymmetricKeyIamBinding } from '@cdktf/provider-yandex'

KmsSymmetricKeyIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.symmetricKeyIdInput">symmetricKeyIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.symmetricKeyId">symmetricKeyId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `symmetricKeyIdInput`<sup>Optional</sup> <a name="symmetricKeyIdInput" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.symmetricKeyIdInput"></a>

```typescript
public readonly symmetricKeyIdInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

##### `symmetricKeyId`<sup>Required</sup> <a name="symmetricKeyId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.symmetricKeyId"></a>

```typescript
public readonly symmetricKeyId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### KubernetesCluster <a name="KubernetesCluster" id="@cdktf/provider-yandex.KubernetesCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster yandex_kubernetes_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesCluster.Initializer"></a>

```typescript
import { KubernetesCluster } from '@cdktf/provider-yandex'

new KubernetesCluster(scope: Construct, id: string, config: KubernetesClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig">KubernetesClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.KubernetesCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterConfig">KubernetesClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.putKmsProvider">putKmsProvider</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.putMaster">putMaster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.putNetworkImplementation">putNetworkImplementation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetClusterIpv4Range">resetClusterIpv4Range</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetClusterIpv6Range">resetClusterIpv6Range</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetKmsProvider">resetKmsProvider</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetNetworkImplementation">resetNetworkImplementation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetNetworkPolicyProvider">resetNetworkPolicyProvider</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetNodeIpv4CidrMaskSize">resetNodeIpv4CidrMaskSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetReleaseChannel">resetReleaseChannel</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetServiceIpv4Range">resetServiceIpv4Range</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetServiceIpv6Range">resetServiceIpv6Range</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.KubernetesCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.KubernetesCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.KubernetesCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.KubernetesCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.KubernetesCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.KubernetesCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.KubernetesCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putKmsProvider` <a name="putKmsProvider" id="@cdktf/provider-yandex.KubernetesCluster.putKmsProvider"></a>

```typescript
public putKmsProvider(value: KubernetesClusterKmsProvider): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesCluster.putKmsProvider.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a>

---

##### `putMaster` <a name="putMaster" id="@cdktf/provider-yandex.KubernetesCluster.putMaster"></a>

```typescript
public putMaster(value: KubernetesClusterMaster): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesCluster.putMaster.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a>

---

##### `putNetworkImplementation` <a name="putNetworkImplementation" id="@cdktf/provider-yandex.KubernetesCluster.putNetworkImplementation"></a>

```typescript
public putNetworkImplementation(value: KubernetesClusterNetworkImplementation): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesCluster.putNetworkImplementation.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.KubernetesCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: KubernetesClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a>

---

##### `resetClusterIpv4Range` <a name="resetClusterIpv4Range" id="@cdktf/provider-yandex.KubernetesCluster.resetClusterIpv4Range"></a>

```typescript
public resetClusterIpv4Range(): void
```

##### `resetClusterIpv6Range` <a name="resetClusterIpv6Range" id="@cdktf/provider-yandex.KubernetesCluster.resetClusterIpv6Range"></a>

```typescript
public resetClusterIpv6Range(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.KubernetesCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.KubernetesCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.KubernetesCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetKmsProvider` <a name="resetKmsProvider" id="@cdktf/provider-yandex.KubernetesCluster.resetKmsProvider"></a>

```typescript
public resetKmsProvider(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.KubernetesCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.KubernetesCluster.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkImplementation` <a name="resetNetworkImplementation" id="@cdktf/provider-yandex.KubernetesCluster.resetNetworkImplementation"></a>

```typescript
public resetNetworkImplementation(): void
```

##### `resetNetworkPolicyProvider` <a name="resetNetworkPolicyProvider" id="@cdktf/provider-yandex.KubernetesCluster.resetNetworkPolicyProvider"></a>

```typescript
public resetNetworkPolicyProvider(): void
```

##### `resetNodeIpv4CidrMaskSize` <a name="resetNodeIpv4CidrMaskSize" id="@cdktf/provider-yandex.KubernetesCluster.resetNodeIpv4CidrMaskSize"></a>

```typescript
public resetNodeIpv4CidrMaskSize(): void
```

##### `resetReleaseChannel` <a name="resetReleaseChannel" id="@cdktf/provider-yandex.KubernetesCluster.resetReleaseChannel"></a>

```typescript
public resetReleaseChannel(): void
```

##### `resetServiceIpv4Range` <a name="resetServiceIpv4Range" id="@cdktf/provider-yandex.KubernetesCluster.resetServiceIpv4Range"></a>

```typescript
public resetServiceIpv4Range(): void
```

##### `resetServiceIpv6Range` <a name="resetServiceIpv6Range" id="@cdktf/provider-yandex.KubernetesCluster.resetServiceIpv6Range"></a>

```typescript
public resetServiceIpv6Range(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.KubernetesCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.KubernetesCluster.isConstruct"></a>

```typescript
import { KubernetesCluster } from '@cdktf/provider-yandex'

KubernetesCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.KubernetesCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.kmsProvider">kmsProvider</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference">KubernetesClusterKmsProviderOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.logGroupId">logGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.master">master</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference">KubernetesClusterMasterOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkImplementation">networkImplementation</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference">KubernetesClusterNetworkImplementationOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference">KubernetesClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv4RangeInput">clusterIpv4RangeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv6RangeInput">clusterIpv6RangeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.kmsProviderInput">kmsProviderInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.masterInput">masterInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkImplementationInput">networkImplementationInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkPolicyProviderInput">networkPolicyProviderInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.nodeIpv4CidrMaskSizeInput">nodeIpv4CidrMaskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.nodeServiceAccountIdInput">nodeServiceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.releaseChannelInput">releaseChannelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv4RangeInput">serviceIpv4RangeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv6RangeInput">serviceIpv6RangeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv4Range">clusterIpv4Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv6Range">clusterIpv6Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.networkPolicyProvider">networkPolicyProvider</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.nodeIpv4CidrMaskSize">nodeIpv4CidrMaskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.nodeServiceAccountId">nodeServiceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.releaseChannel">releaseChannel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv4Range">serviceIpv4Range</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv6Range">serviceIpv6Range</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.KubernetesCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.KubernetesCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.KubernetesCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.KubernetesCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.KubernetesCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.KubernetesCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KubernetesCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KubernetesCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KubernetesCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KubernetesCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.KubernetesCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.KubernetesCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `kmsProvider`<sup>Required</sup> <a name="kmsProvider" id="@cdktf/provider-yandex.KubernetesCluster.property.kmsProvider"></a>

```typescript
public readonly kmsProvider: KubernetesClusterKmsProviderOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference">KubernetesClusterKmsProviderOutputReference</a>

---

##### `logGroupId`<sup>Required</sup> <a name="logGroupId" id="@cdktf/provider-yandex.KubernetesCluster.property.logGroupId"></a>

```typescript
public readonly logGroupId: string;
```

- *Type:* string

---

##### `master`<sup>Required</sup> <a name="master" id="@cdktf/provider-yandex.KubernetesCluster.property.master"></a>

```typescript
public readonly master: KubernetesClusterMasterOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference">KubernetesClusterMasterOutputReference</a>

---

##### `networkImplementation`<sup>Required</sup> <a name="networkImplementation" id="@cdktf/provider-yandex.KubernetesCluster.property.networkImplementation"></a>

```typescript
public readonly networkImplementation: KubernetesClusterNetworkImplementationOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference">KubernetesClusterNetworkImplementationOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.KubernetesCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.KubernetesCluster.property.timeouts"></a>

```typescript
public readonly timeouts: KubernetesClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference">KubernetesClusterTimeoutsOutputReference</a>

---

##### `clusterIpv4RangeInput`<sup>Optional</sup> <a name="clusterIpv4RangeInput" id="@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv4RangeInput"></a>

```typescript
public readonly clusterIpv4RangeInput: string;
```

- *Type:* string

---

##### `clusterIpv6RangeInput`<sup>Optional</sup> <a name="clusterIpv6RangeInput" id="@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv6RangeInput"></a>

```typescript
public readonly clusterIpv6RangeInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.KubernetesCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.KubernetesCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.KubernetesCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `kmsProviderInput`<sup>Optional</sup> <a name="kmsProviderInput" id="@cdktf/provider-yandex.KubernetesCluster.property.kmsProviderInput"></a>

```typescript
public readonly kmsProviderInput: KubernetesClusterKmsProvider;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a>

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.KubernetesCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `masterInput`<sup>Optional</sup> <a name="masterInput" id="@cdktf/provider-yandex.KubernetesCluster.property.masterInput"></a>

```typescript
public readonly masterInput: KubernetesClusterMaster;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.KubernetesCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.KubernetesCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `networkImplementationInput`<sup>Optional</sup> <a name="networkImplementationInput" id="@cdktf/provider-yandex.KubernetesCluster.property.networkImplementationInput"></a>

```typescript
public readonly networkImplementationInput: KubernetesClusterNetworkImplementation;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a>

---

##### `networkPolicyProviderInput`<sup>Optional</sup> <a name="networkPolicyProviderInput" id="@cdktf/provider-yandex.KubernetesCluster.property.networkPolicyProviderInput"></a>

```typescript
public readonly networkPolicyProviderInput: string;
```

- *Type:* string

---

##### `nodeIpv4CidrMaskSizeInput`<sup>Optional</sup> <a name="nodeIpv4CidrMaskSizeInput" id="@cdktf/provider-yandex.KubernetesCluster.property.nodeIpv4CidrMaskSizeInput"></a>

```typescript
public readonly nodeIpv4CidrMaskSizeInput: number;
```

- *Type:* number

---

##### `nodeServiceAccountIdInput`<sup>Optional</sup> <a name="nodeServiceAccountIdInput" id="@cdktf/provider-yandex.KubernetesCluster.property.nodeServiceAccountIdInput"></a>

```typescript
public readonly nodeServiceAccountIdInput: string;
```

- *Type:* string

---

##### `releaseChannelInput`<sup>Optional</sup> <a name="releaseChannelInput" id="@cdktf/provider-yandex.KubernetesCluster.property.releaseChannelInput"></a>

```typescript
public readonly releaseChannelInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `serviceIpv4RangeInput`<sup>Optional</sup> <a name="serviceIpv4RangeInput" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv4RangeInput"></a>

```typescript
public readonly serviceIpv4RangeInput: string;
```

- *Type:* string

---

##### `serviceIpv6RangeInput`<sup>Optional</sup> <a name="serviceIpv6RangeInput" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv6RangeInput"></a>

```typescript
public readonly serviceIpv6RangeInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.KubernetesCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | KubernetesClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a>

---

##### `clusterIpv4Range`<sup>Required</sup> <a name="clusterIpv4Range" id="@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv4Range"></a>

```typescript
public readonly clusterIpv4Range: string;
```

- *Type:* string

---

##### `clusterIpv6Range`<sup>Required</sup> <a name="clusterIpv6Range" id="@cdktf/provider-yandex.KubernetesCluster.property.clusterIpv6Range"></a>

```typescript
public readonly clusterIpv6Range: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.KubernetesCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.KubernetesCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.KubernetesCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.KubernetesCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.KubernetesCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `networkPolicyProvider`<sup>Required</sup> <a name="networkPolicyProvider" id="@cdktf/provider-yandex.KubernetesCluster.property.networkPolicyProvider"></a>

```typescript
public readonly networkPolicyProvider: string;
```

- *Type:* string

---

##### `nodeIpv4CidrMaskSize`<sup>Required</sup> <a name="nodeIpv4CidrMaskSize" id="@cdktf/provider-yandex.KubernetesCluster.property.nodeIpv4CidrMaskSize"></a>

```typescript
public readonly nodeIpv4CidrMaskSize: number;
```

- *Type:* number

---

##### `nodeServiceAccountId`<sup>Required</sup> <a name="nodeServiceAccountId" id="@cdktf/provider-yandex.KubernetesCluster.property.nodeServiceAccountId"></a>

```typescript
public readonly nodeServiceAccountId: string;
```

- *Type:* string

---

##### `releaseChannel`<sup>Required</sup> <a name="releaseChannel" id="@cdktf/provider-yandex.KubernetesCluster.property.releaseChannel"></a>

```typescript
public readonly releaseChannel: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `serviceIpv4Range`<sup>Required</sup> <a name="serviceIpv4Range" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv4Range"></a>

```typescript
public readonly serviceIpv4Range: string;
```

- *Type:* string

---

##### `serviceIpv6Range`<sup>Required</sup> <a name="serviceIpv6Range" id="@cdktf/provider-yandex.KubernetesCluster.property.serviceIpv6Range"></a>

```typescript
public readonly serviceIpv6Range: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.KubernetesCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### KubernetesNodeGroup <a name="KubernetesNodeGroup" id="@cdktf/provider-yandex.KubernetesNodeGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group yandex_kubernetes_node_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroup.Initializer"></a>

```typescript
import { KubernetesNodeGroup } from '@cdktf/provider-yandex'

new KubernetesNodeGroup(scope: Construct, id: string, config: KubernetesNodeGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig">KubernetesNodeGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.KubernetesNodeGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig">KubernetesNodeGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putAllocationPolicy">putAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putDeployPolicy">putDeployPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putInstanceTemplate">putInstanceTemplate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putMaintenancePolicy">putMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putScalePolicy">putScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetAllocationPolicy">resetAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetAllowedUnsafeSysctls">resetAllowedUnsafeSysctls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetDeployPolicy">resetDeployPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetMaintenancePolicy">resetMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetNodeLabels">resetNodeLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetNodeTaints">resetNodeTaints</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.resetVersion">resetVersion</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.KubernetesNodeGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.KubernetesNodeGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.KubernetesNodeGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.KubernetesNodeGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.KubernetesNodeGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.KubernetesNodeGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAllocationPolicy` <a name="putAllocationPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.putAllocationPolicy"></a>

```typescript
public putAllocationPolicy(value: KubernetesNodeGroupAllocationPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putAllocationPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a>

---

##### `putDeployPolicy` <a name="putDeployPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.putDeployPolicy"></a>

```typescript
public putDeployPolicy(value: KubernetesNodeGroupDeployPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putDeployPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a>

---

##### `putInstanceTemplate` <a name="putInstanceTemplate" id="@cdktf/provider-yandex.KubernetesNodeGroup.putInstanceTemplate"></a>

```typescript
public putInstanceTemplate(value: KubernetesNodeGroupInstanceTemplate): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putInstanceTemplate.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a>

---

##### `putMaintenancePolicy` <a name="putMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.putMaintenancePolicy"></a>

```typescript
public putMaintenancePolicy(value: KubernetesNodeGroupMaintenancePolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putMaintenancePolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a>

---

##### `putScalePolicy` <a name="putScalePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.putScalePolicy"></a>

```typescript
public putScalePolicy(value: KubernetesNodeGroupScalePolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putScalePolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.KubernetesNodeGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: KubernetesNodeGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a>

---

##### `resetAllocationPolicy` <a name="resetAllocationPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetAllocationPolicy"></a>

```typescript
public resetAllocationPolicy(): void
```

##### `resetAllowedUnsafeSysctls` <a name="resetAllowedUnsafeSysctls" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetAllowedUnsafeSysctls"></a>

```typescript
public resetAllowedUnsafeSysctls(): void
```

##### `resetDeployPolicy` <a name="resetDeployPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetDeployPolicy"></a>

```typescript
public resetDeployPolicy(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenancePolicy` <a name="resetMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetMaintenancePolicy"></a>

```typescript
public resetMaintenancePolicy(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNodeLabels` <a name="resetNodeLabels" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetNodeLabels"></a>

```typescript
public resetNodeLabels(): void
```

##### `resetNodeTaints` <a name="resetNodeTaints" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetNodeTaints"></a>

```typescript
public resetNodeTaints(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetVersion` <a name="resetVersion" id="@cdktf/provider-yandex.KubernetesNodeGroup.resetVersion"></a>

```typescript
public resetVersion(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.KubernetesNodeGroup.isConstruct"></a>

```typescript
import { KubernetesNodeGroup } from '@cdktf/provider-yandex'

KubernetesNodeGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.KubernetesNodeGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference">KubernetesNodeGroupAllocationPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference">KubernetesNodeGroupDeployPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceGroupId">instanceGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference">KubernetesNodeGroupInstanceTemplateOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference">KubernetesNodeGroupMaintenancePolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference">KubernetesNodeGroupScalePolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference">KubernetesNodeGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.versionInfo">versionInfo</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList">KubernetesNodeGroupVersionInfoList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.allocationPolicyInput">allocationPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.allowedUnsafeSysctlsInput">allowedUnsafeSysctlsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.deployPolicyInput">deployPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceTemplateInput">instanceTemplateInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.maintenancePolicyInput">maintenancePolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeLabelsInput">nodeLabelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeTaintsInput">nodeTaintsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.scalePolicyInput">scalePolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.allowedUnsafeSysctls">allowedUnsafeSysctls</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeLabels">nodeLabels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeTaints">nodeTaints</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.version">version</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: KubernetesNodeGroupAllocationPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference">KubernetesNodeGroupAllocationPolicyOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `deployPolicy`<sup>Required</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: KubernetesNodeGroupDeployPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference">KubernetesNodeGroupDeployPolicyOutputReference</a>

---

##### `instanceGroupId`<sup>Required</sup> <a name="instanceGroupId" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceGroupId"></a>

```typescript
public readonly instanceGroupId: string;
```

- *Type:* string

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: KubernetesNodeGroupInstanceTemplateOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference">KubernetesNodeGroupInstanceTemplateOutputReference</a>

---

##### `maintenancePolicy`<sup>Required</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: KubernetesNodeGroupMaintenancePolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference">KubernetesNodeGroupMaintenancePolicyOutputReference</a>

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: KubernetesNodeGroupScalePolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference">KubernetesNodeGroupScalePolicyOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.timeouts"></a>

```typescript
public readonly timeouts: KubernetesNodeGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference">KubernetesNodeGroupTimeoutsOutputReference</a>

---

##### `versionInfo`<sup>Required</sup> <a name="versionInfo" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.versionInfo"></a>

```typescript
public readonly versionInfo: KubernetesNodeGroupVersionInfoList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList">KubernetesNodeGroupVersionInfoList</a>

---

##### `allocationPolicyInput`<sup>Optional</sup> <a name="allocationPolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.allocationPolicyInput"></a>

```typescript
public readonly allocationPolicyInput: KubernetesNodeGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a>

---

##### `allowedUnsafeSysctlsInput`<sup>Optional</sup> <a name="allowedUnsafeSysctlsInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.allowedUnsafeSysctlsInput"></a>

```typescript
public readonly allowedUnsafeSysctlsInput: string[];
```

- *Type:* string[]

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `deployPolicyInput`<sup>Optional</sup> <a name="deployPolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.deployPolicyInput"></a>

```typescript
public readonly deployPolicyInput: KubernetesNodeGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `instanceTemplateInput`<sup>Optional</sup> <a name="instanceTemplateInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.instanceTemplateInput"></a>

```typescript
public readonly instanceTemplateInput: KubernetesNodeGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a>

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenancePolicyInput`<sup>Optional</sup> <a name="maintenancePolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.maintenancePolicyInput"></a>

```typescript
public readonly maintenancePolicyInput: KubernetesNodeGroupMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `nodeLabelsInput`<sup>Optional</sup> <a name="nodeLabelsInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeLabelsInput"></a>

```typescript
public readonly nodeLabelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nodeTaintsInput`<sup>Optional</sup> <a name="nodeTaintsInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeTaintsInput"></a>

```typescript
public readonly nodeTaintsInput: string[];
```

- *Type:* string[]

---

##### `scalePolicyInput`<sup>Optional</sup> <a name="scalePolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.scalePolicyInput"></a>

```typescript
public readonly scalePolicyInput: KubernetesNodeGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a>

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | KubernetesNodeGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a>

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `allowedUnsafeSysctls`<sup>Required</sup> <a name="allowedUnsafeSysctls" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.allowedUnsafeSysctls"></a>

```typescript
public readonly allowedUnsafeSysctls: string[];
```

- *Type:* string[]

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `nodeLabels`<sup>Required</sup> <a name="nodeLabels" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeLabels"></a>

```typescript
public readonly nodeLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nodeTaints`<sup>Required</sup> <a name="nodeTaints" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.nodeTaints"></a>

```typescript
public readonly nodeTaints: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.KubernetesNodeGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LbNetworkLoadBalancer <a name="LbNetworkLoadBalancer" id="@cdktf/provider-yandex.LbNetworkLoadBalancer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer yandex_lb_network_load_balancer}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer"></a>

```typescript
import { LbNetworkLoadBalancer } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancer(scope: Construct, id: string, config?: LbNetworkLoadBalancerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig">LbNetworkLoadBalancerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig">LbNetworkLoadBalancerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.putAttachedTargetGroup">putAttachedTargetGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.putListener">putListener</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetAttachedTargetGroup">resetAttachedTargetGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetListener">resetListener</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetRegionId">resetRegionId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.resetType">resetType</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAttachedTargetGroup` <a name="putAttachedTargetGroup" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putAttachedTargetGroup"></a>

```typescript
public putAttachedTargetGroup(value: IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putAttachedTargetGroup.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]

---

##### `putListener` <a name="putListener" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putListener"></a>

```typescript
public putListener(value: IResolvable | LbNetworkLoadBalancerListener[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putListener.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putTimeouts"></a>

```typescript
public putTimeouts(value: LbNetworkLoadBalancerTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a>

---

##### `resetAttachedTargetGroup` <a name="resetAttachedTargetGroup" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetAttachedTargetGroup"></a>

```typescript
public resetAttachedTargetGroup(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetListener` <a name="resetListener" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetListener"></a>

```typescript
public resetListener(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRegionId` <a name="resetRegionId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetRegionId"></a>

```typescript
public resetRegionId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.resetType"></a>

```typescript
public resetType(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.isConstruct"></a>

```typescript
import { LbNetworkLoadBalancer } from '@cdktf/provider-yandex'

LbNetworkLoadBalancer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.attachedTargetGroup">attachedTargetGroup</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList">LbNetworkLoadBalancerAttachedTargetGroupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.listener">listener</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList">LbNetworkLoadBalancerListenerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference">LbNetworkLoadBalancerTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.attachedTargetGroupInput">attachedTargetGroupInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.listenerInput">listenerInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.regionIdInput">regionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.regionId">regionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.type">type</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `attachedTargetGroup`<sup>Required</sup> <a name="attachedTargetGroup" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.attachedTargetGroup"></a>

```typescript
public readonly attachedTargetGroup: LbNetworkLoadBalancerAttachedTargetGroupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList">LbNetworkLoadBalancerAttachedTargetGroupList</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `listener`<sup>Required</sup> <a name="listener" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.listener"></a>

```typescript
public readonly listener: LbNetworkLoadBalancerListenerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList">LbNetworkLoadBalancerListenerList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.timeouts"></a>

```typescript
public readonly timeouts: LbNetworkLoadBalancerTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference">LbNetworkLoadBalancerTimeoutsOutputReference</a>

---

##### `attachedTargetGroupInput`<sup>Optional</sup> <a name="attachedTargetGroupInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.attachedTargetGroupInput"></a>

```typescript
public readonly attachedTargetGroupInput: IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `listenerInput`<sup>Optional</sup> <a name="listenerInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.listenerInput"></a>

```typescript
public readonly listenerInput: IResolvable | LbNetworkLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `regionIdInput`<sup>Optional</sup> <a name="regionIdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.regionIdInput"></a>

```typescript
public readonly regionIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbNetworkLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a>

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `regionId`<sup>Required</sup> <a name="regionId" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.LbNetworkLoadBalancer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LbTargetGroup <a name="LbTargetGroup" id="@cdktf/provider-yandex.LbTargetGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group yandex_lb_target_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbTargetGroup.Initializer"></a>

```typescript
import { LbTargetGroup } from '@cdktf/provider-yandex'

new LbTargetGroup(scope: Construct, id: string, config?: LbTargetGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig">LbTargetGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.LbTargetGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbTargetGroupConfig">LbTargetGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.putTarget">putTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetRegionId">resetRegionId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetTarget">resetTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbTargetGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.LbTargetGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.LbTargetGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbTargetGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.LbTargetGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.LbTargetGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.LbTargetGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.LbTargetGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.LbTargetGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbTargetGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTarget` <a name="putTarget" id="@cdktf/provider-yandex.LbTargetGroup.putTarget"></a>

```typescript
public putTarget(value: IResolvable | LbTargetGroupTarget[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbTargetGroup.putTarget.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.LbTargetGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: LbTargetGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbTargetGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.LbTargetGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.LbTargetGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.LbTargetGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.LbTargetGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.LbTargetGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRegionId` <a name="resetRegionId" id="@cdktf/provider-yandex.LbTargetGroup.resetRegionId"></a>

```typescript
public resetRegionId(): void
```

##### `resetTarget` <a name="resetTarget" id="@cdktf/provider-yandex.LbTargetGroup.resetTarget"></a>

```typescript
public resetTarget(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.LbTargetGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.LbTargetGroup.isConstruct"></a>

```typescript
import { LbTargetGroup } from '@cdktf/provider-yandex'

LbTargetGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.LbTargetGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.target">target</a></code> | <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList">LbTargetGroupTargetList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference">LbTargetGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.regionIdInput">regionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.targetInput">targetInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.regionId">regionId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.LbTargetGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.LbTargetGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbTargetGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.LbTargetGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.LbTargetGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.LbTargetGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.LbTargetGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LbTargetGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LbTargetGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LbTargetGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LbTargetGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.LbTargetGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.LbTargetGroup.property.target"></a>

```typescript
public readonly target: LbTargetGroupTargetList;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbTargetGroupTargetList">LbTargetGroupTargetList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.LbTargetGroup.property.timeouts"></a>

```typescript
public readonly timeouts: LbTargetGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference">LbTargetGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.LbTargetGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.LbTargetGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.LbTargetGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.LbTargetGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.LbTargetGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `regionIdInput`<sup>Optional</sup> <a name="regionIdInput" id="@cdktf/provider-yandex.LbTargetGroup.property.regionIdInput"></a>

```typescript
public readonly regionIdInput: string;
```

- *Type:* string

---

##### `targetInput`<sup>Optional</sup> <a name="targetInput" id="@cdktf/provider-yandex.LbTargetGroup.property.targetInput"></a>

```typescript
public readonly targetInput: IResolvable | LbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.LbTargetGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LbTargetGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.LbTargetGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.LbTargetGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LbTargetGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.LbTargetGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbTargetGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `regionId`<sup>Required</sup> <a name="regionId" id="@cdktf/provider-yandex.LbTargetGroup.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.LbTargetGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### LoggingGroup <a name="LoggingGroup" id="@cdktf/provider-yandex.LoggingGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/logging_group yandex_logging_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LoggingGroup.Initializer"></a>

```typescript
import { LoggingGroup } from '@cdktf/provider-yandex'

new LoggingGroup(scope: Construct, id: string, config?: LoggingGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig">LoggingGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.LoggingGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LoggingGroupConfig">LoggingGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetRetentionPeriod">resetRetentionPeriod</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LoggingGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.LoggingGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.LoggingGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LoggingGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.LoggingGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.LoggingGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.LoggingGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.LoggingGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.LoggingGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LoggingGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LoggingGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LoggingGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LoggingGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LoggingGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LoggingGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LoggingGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.LoggingGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: LoggingGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LoggingGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.LoggingGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.LoggingGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.LoggingGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.LoggingGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.LoggingGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRetentionPeriod` <a name="resetRetentionPeriod" id="@cdktf/provider-yandex.LoggingGroup.resetRetentionPeriod"></a>

```typescript
public resetRetentionPeriod(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.LoggingGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.LoggingGroup.isConstruct"></a>

```typescript
import { LoggingGroup } from '@cdktf/provider-yandex'

LoggingGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.LoggingGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference">LoggingGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.retentionPeriodInput">retentionPeriodInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.retentionPeriod">retentionPeriod</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.LoggingGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.LoggingGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LoggingGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.LoggingGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.LoggingGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.LoggingGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.LoggingGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LoggingGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LoggingGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LoggingGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LoggingGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.LoggingGroup.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.LoggingGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.LoggingGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.LoggingGroup.property.timeouts"></a>

```typescript
public readonly timeouts: LoggingGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference">LoggingGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.LoggingGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.LoggingGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.LoggingGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.LoggingGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.LoggingGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `retentionPeriodInput`<sup>Optional</sup> <a name="retentionPeriodInput" id="@cdktf/provider-yandex.LoggingGroup.property.retentionPeriodInput"></a>

```typescript
public readonly retentionPeriodInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.LoggingGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | LoggingGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.LoggingGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.LoggingGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.LoggingGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.LoggingGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LoggingGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `retentionPeriod`<sup>Required</sup> <a name="retentionPeriod" id="@cdktf/provider-yandex.LoggingGroup.property.retentionPeriod"></a>

```typescript
public readonly retentionPeriod: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.LoggingGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbClickhouseCluster <a name="MdbClickhouseCluster" id="@cdktf/provider-yandex.MdbClickhouseCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster yandex_mdb_clickhouse_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseCluster.Initializer"></a>

```typescript
import { MdbClickhouseCluster } from '@cdktf/provider-yandex'

new MdbClickhouseCluster(scope: Construct, id: string, config: MdbClickhouseClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig">MdbClickhouseClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbClickhouseCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig">MdbClickhouseClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putClickhouse">putClickhouse</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putCloudStorage">putCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putDatabase">putDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putFormatSchema">putFormatSchema</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putMlModel">putMlModel</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putShardGroup">putShardGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.putZookeeper">putZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetAdminPassword">resetAdminPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetCloudStorage">resetCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetCopySchemaOnNewHosts">resetCopySchemaOnNewHosts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetDatabase">resetDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetEmbeddedKeeper">resetEmbeddedKeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetFormatSchema">resetFormatSchema</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetMlModel">resetMlModel</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetShardGroup">resetShardGroup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetSqlDatabaseManagement">resetSqlDatabaseManagement</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetSqlUserManagement">resetSqlUserManagement</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetUser">resetUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetVersion">resetVersion</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.resetZookeeper">resetZookeeper</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbClickhouseCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbClickhouseCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbClickhouseCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbClickhouseCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbClickhouseCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbClickhouseCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.MdbClickhouseCluster.putAccess"></a>

```typescript
public putAccess(value: MdbClickhouseClusterAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a>

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbClickhouseCluster.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbClickhouseClusterBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a>

---

##### `putClickhouse` <a name="putClickhouse" id="@cdktf/provider-yandex.MdbClickhouseCluster.putClickhouse"></a>

```typescript
public putClickhouse(value: MdbClickhouseClusterClickhouse): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putClickhouse.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a>

---

##### `putCloudStorage` <a name="putCloudStorage" id="@cdktf/provider-yandex.MdbClickhouseCluster.putCloudStorage"></a>

```typescript
public putCloudStorage(value: MdbClickhouseClusterCloudStorage): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putCloudStorage.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a>

---

##### `putDatabase` <a name="putDatabase" id="@cdktf/provider-yandex.MdbClickhouseCluster.putDatabase"></a>

```typescript
public putDatabase(value: IResolvable | MdbClickhouseClusterDatabase[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putDatabase.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]

---

##### `putFormatSchema` <a name="putFormatSchema" id="@cdktf/provider-yandex.MdbClickhouseCluster.putFormatSchema"></a>

```typescript
public putFormatSchema(value: IResolvable | MdbClickhouseClusterFormatSchema[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putFormatSchema.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbClickhouseCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbClickhouseClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbClickhouseCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbClickhouseClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a>

---

##### `putMlModel` <a name="putMlModel" id="@cdktf/provider-yandex.MdbClickhouseCluster.putMlModel"></a>

```typescript
public putMlModel(value: IResolvable | MdbClickhouseClusterMlModel[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putMlModel.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]

---

##### `putShardGroup` <a name="putShardGroup" id="@cdktf/provider-yandex.MdbClickhouseCluster.putShardGroup"></a>

```typescript
public putShardGroup(value: IResolvable | MdbClickhouseClusterShardGroup[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putShardGroup.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbClickhouseCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbClickhouseClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a>

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbClickhouseCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbClickhouseClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]

---

##### `putZookeeper` <a name="putZookeeper" id="@cdktf/provider-yandex.MdbClickhouseCluster.putZookeeper"></a>

```typescript
public putZookeeper(value: MdbClickhouseClusterZookeeper): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseCluster.putZookeeper.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a>

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetAdminPassword` <a name="resetAdminPassword" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetAdminPassword"></a>

```typescript
public resetAdminPassword(): void
```

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetCloudStorage` <a name="resetCloudStorage" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetCloudStorage"></a>

```typescript
public resetCloudStorage(): void
```

##### `resetCopySchemaOnNewHosts` <a name="resetCopySchemaOnNewHosts" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetCopySchemaOnNewHosts"></a>

```typescript
public resetCopySchemaOnNewHosts(): void
```

##### `resetDatabase` <a name="resetDatabase" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetDatabase"></a>

```typescript
public resetDatabase(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetEmbeddedKeeper` <a name="resetEmbeddedKeeper" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetEmbeddedKeeper"></a>

```typescript
public resetEmbeddedKeeper(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetFormatSchema` <a name="resetFormatSchema" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetFormatSchema"></a>

```typescript
public resetFormatSchema(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetMlModel` <a name="resetMlModel" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetMlModel"></a>

```typescript
public resetMlModel(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetShardGroup` <a name="resetShardGroup" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetShardGroup"></a>

```typescript
public resetShardGroup(): void
```

##### `resetSqlDatabaseManagement` <a name="resetSqlDatabaseManagement" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetSqlDatabaseManagement"></a>

```typescript
public resetSqlDatabaseManagement(): void
```

##### `resetSqlUserManagement` <a name="resetSqlUserManagement" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetSqlUserManagement"></a>

```typescript
public resetSqlUserManagement(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetUser"></a>

```typescript
public resetUser(): void
```

##### `resetVersion` <a name="resetVersion" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetVersion"></a>

```typescript
public resetVersion(): void
```

##### `resetZookeeper` <a name="resetZookeeper" id="@cdktf/provider-yandex.MdbClickhouseCluster.resetZookeeper"></a>

```typescript
public resetZookeeper(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbClickhouseCluster.isConstruct"></a>

```typescript
import { MdbClickhouseCluster } from '@cdktf/provider-yandex'

MdbClickhouseCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbClickhouseCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference">MdbClickhouseClusterAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference">MdbClickhouseClusterBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.clickhouse">clickhouse</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference">MdbClickhouseClusterClickhouseOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.cloudStorage">cloudStorage</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference">MdbClickhouseClusterCloudStorageOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList">MdbClickhouseClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.formatSchema">formatSchema</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList">MdbClickhouseClusterFormatSchemaList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList">MdbClickhouseClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference">MdbClickhouseClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.mlModel">mlModel</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList">MdbClickhouseClusterMlModelList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.shardGroup">shardGroup</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList">MdbClickhouseClusterShardGroupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference">MdbClickhouseClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList">MdbClickhouseClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference">MdbClickhouseClusterZookeeperOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.adminPasswordInput">adminPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.clickhouseInput">clickhouseInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.cloudStorageInput">cloudStorageInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.copySchemaOnNewHostsInput">copySchemaOnNewHostsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.databaseInput">databaseInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.embeddedKeeperInput">embeddedKeeperInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.formatSchemaInput">formatSchemaInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.mlModelInput">mlModelInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.shardGroupInput">shardGroupInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlDatabaseManagementInput">sqlDatabaseManagementInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlUserManagementInput">sqlUserManagementInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.zookeeperInput">zookeeperInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.adminPassword">adminPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.copySchemaOnNewHosts">copySchemaOnNewHosts</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.embeddedKeeper">embeddedKeeper</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlDatabaseManagement">sqlDatabaseManagement</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlUserManagement">sqlUserManagement</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.version">version</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.access"></a>

```typescript
public readonly access: MdbClickhouseClusterAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference">MdbClickhouseClusterAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbClickhouseClusterBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference">MdbClickhouseClusterBackupWindowStartOutputReference</a>

---

##### `clickhouse`<sup>Required</sup> <a name="clickhouse" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.clickhouse"></a>

```typescript
public readonly clickhouse: MdbClickhouseClusterClickhouseOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference">MdbClickhouseClusterClickhouseOutputReference</a>

---

##### `cloudStorage`<sup>Required</sup> <a name="cloudStorage" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.cloudStorage"></a>

```typescript
public readonly cloudStorage: MdbClickhouseClusterCloudStorageOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference">MdbClickhouseClusterCloudStorageOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.database"></a>

```typescript
public readonly database: MdbClickhouseClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList">MdbClickhouseClusterDatabaseList</a>

---

##### `formatSchema`<sup>Required</sup> <a name="formatSchema" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.formatSchema"></a>

```typescript
public readonly formatSchema: MdbClickhouseClusterFormatSchemaList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList">MdbClickhouseClusterFormatSchemaList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.host"></a>

```typescript
public readonly host: MdbClickhouseClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList">MdbClickhouseClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbClickhouseClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference">MdbClickhouseClusterMaintenanceWindowOutputReference</a>

---

##### `mlModel`<sup>Required</sup> <a name="mlModel" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.mlModel"></a>

```typescript
public readonly mlModel: MdbClickhouseClusterMlModelList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList">MdbClickhouseClusterMlModelList</a>

---

##### `shardGroup`<sup>Required</sup> <a name="shardGroup" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.shardGroup"></a>

```typescript
public readonly shardGroup: MdbClickhouseClusterShardGroupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList">MdbClickhouseClusterShardGroupList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbClickhouseClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference">MdbClickhouseClusterTimeoutsOutputReference</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.user"></a>

```typescript
public readonly user: MdbClickhouseClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList">MdbClickhouseClusterUserList</a>

---

##### `zookeeper`<sup>Required</sup> <a name="zookeeper" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.zookeeper"></a>

```typescript
public readonly zookeeper: MdbClickhouseClusterZookeeperOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference">MdbClickhouseClusterZookeeperOutputReference</a>

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.accessInput"></a>

```typescript
public readonly accessInput: MdbClickhouseClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a>

---

##### `adminPasswordInput`<sup>Optional</sup> <a name="adminPasswordInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.adminPasswordInput"></a>

```typescript
public readonly adminPasswordInput: string;
```

- *Type:* string

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbClickhouseClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a>

---

##### `clickhouseInput`<sup>Optional</sup> <a name="clickhouseInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.clickhouseInput"></a>

```typescript
public readonly clickhouseInput: MdbClickhouseClusterClickhouse;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a>

---

##### `cloudStorageInput`<sup>Optional</sup> <a name="cloudStorageInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.cloudStorageInput"></a>

```typescript
public readonly cloudStorageInput: MdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a>

---

##### `copySchemaOnNewHostsInput`<sup>Optional</sup> <a name="copySchemaOnNewHostsInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.copySchemaOnNewHostsInput"></a>

```typescript
public readonly copySchemaOnNewHostsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.databaseInput"></a>

```typescript
public readonly databaseInput: IResolvable | MdbClickhouseClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `embeddedKeeperInput`<sup>Optional</sup> <a name="embeddedKeeperInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.embeddedKeeperInput"></a>

```typescript
public readonly embeddedKeeperInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `formatSchemaInput`<sup>Optional</sup> <a name="formatSchemaInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.formatSchemaInput"></a>

```typescript
public readonly formatSchemaInput: IResolvable | MdbClickhouseClusterFormatSchema[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbClickhouseClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbClickhouseClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a>

---

##### `mlModelInput`<sup>Optional</sup> <a name="mlModelInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.mlModelInput"></a>

```typescript
public readonly mlModelInput: IResolvable | MdbClickhouseClusterMlModel[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `shardGroupInput`<sup>Optional</sup> <a name="shardGroupInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.shardGroupInput"></a>

```typescript
public readonly shardGroupInput: IResolvable | MdbClickhouseClusterShardGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]

---

##### `sqlDatabaseManagementInput`<sup>Optional</sup> <a name="sqlDatabaseManagementInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlDatabaseManagementInput"></a>

```typescript
public readonly sqlDatabaseManagementInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sqlUserManagementInput`<sup>Optional</sup> <a name="sqlUserManagementInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlUserManagementInput"></a>

```typescript
public readonly sqlUserManagementInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbClickhouseClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbClickhouseClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `zookeeperInput`<sup>Optional</sup> <a name="zookeeperInput" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.zookeeperInput"></a>

```typescript
public readonly zookeeperInput: MdbClickhouseClusterZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a>

---

##### `adminPassword`<sup>Required</sup> <a name="adminPassword" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.adminPassword"></a>

```typescript
public readonly adminPassword: string;
```

- *Type:* string

---

##### `copySchemaOnNewHosts`<sup>Required</sup> <a name="copySchemaOnNewHosts" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.copySchemaOnNewHosts"></a>

```typescript
public readonly copySchemaOnNewHosts: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `embeddedKeeper`<sup>Required</sup> <a name="embeddedKeeper" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.embeddedKeeper"></a>

```typescript
public readonly embeddedKeeper: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `sqlDatabaseManagement`<sup>Required</sup> <a name="sqlDatabaseManagement" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlDatabaseManagement"></a>

```typescript
public readonly sqlDatabaseManagement: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sqlUserManagement`<sup>Required</sup> <a name="sqlUserManagement" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.sqlUserManagement"></a>

```typescript
public readonly sqlUserManagement: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbClickhouseCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbElasticsearchCluster <a name="MdbElasticsearchCluster" id="@cdktf/provider-yandex.MdbElasticsearchCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer"></a>

```typescript
import { MdbElasticsearchCluster } from '@cdktf/provider-yandex'

new MdbElasticsearchCluster(scope: Construct, id: string, config: MdbElasticsearchClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig">MdbElasticsearchClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbElasticsearchCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig">MdbElasticsearchClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbElasticsearchCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbElasticsearchCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbElasticsearchCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbElasticsearchCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putConfig"></a>

```typescript
public putConfig(value: MdbElasticsearchClusterConfigA): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a>

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbElasticsearchClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbElasticsearchClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbElasticsearchClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a>

---

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbElasticsearchCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbElasticsearchCluster.isConstruct"></a>

```typescript
import { MdbElasticsearchCluster } from '@cdktf/provider-yandex'

MdbElasticsearchCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbElasticsearchCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference">MdbElasticsearchClusterConfigAOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList">MdbElasticsearchClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference">MdbElasticsearchClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference">MdbElasticsearchClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.config"></a>

```typescript
public readonly config: MdbElasticsearchClusterConfigAOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference">MdbElasticsearchClusterConfigAOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.host"></a>

```typescript
public readonly host: MdbElasticsearchClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList">MdbElasticsearchClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbElasticsearchClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference">MdbElasticsearchClusterMaintenanceWindowOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbElasticsearchClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference">MdbElasticsearchClusterTimeoutsOutputReference</a>

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.configInput"></a>

```typescript
public readonly configInput: MdbElasticsearchClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbElasticsearchClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbElasticsearchClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbElasticsearchClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a>

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbElasticsearchCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbGreenplumCluster <a name="MdbGreenplumCluster" id="@cdktf/provider-yandex.MdbGreenplumCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster yandex_mdb_greenplum_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumCluster.Initializer"></a>

```typescript
import { MdbGreenplumCluster } from '@cdktf/provider-yandex'

new MdbGreenplumCluster(scope: Construct, id: string, config: MdbGreenplumClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig">MdbGreenplumClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbGreenplumCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig">MdbGreenplumClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.putMasterSubcluster">putMasterSubcluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.putSegmentSubcluster">putSegmentSubcluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbGreenplumCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbGreenplumCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbGreenplumCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbGreenplumCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbGreenplumCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbGreenplumCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.MdbGreenplumCluster.putAccess"></a>

```typescript
public putAccess(value: MdbGreenplumClusterAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a>

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbGreenplumCluster.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbGreenplumClusterBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a>

---

##### `putMasterSubcluster` <a name="putMasterSubcluster" id="@cdktf/provider-yandex.MdbGreenplumCluster.putMasterSubcluster"></a>

```typescript
public putMasterSubcluster(value: MdbGreenplumClusterMasterSubcluster): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.putMasterSubcluster.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a>

---

##### `putSegmentSubcluster` <a name="putSegmentSubcluster" id="@cdktf/provider-yandex.MdbGreenplumCluster.putSegmentSubcluster"></a>

```typescript
public putSegmentSubcluster(value: MdbGreenplumClusterSegmentSubcluster): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.putSegmentSubcluster.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbGreenplumCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbGreenplumClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a>

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbGreenplumCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbGreenplumCluster.isConstruct"></a>

```typescript
import { MdbGreenplumCluster } from '@cdktf/provider-yandex'

MdbGreenplumCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbGreenplumCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference">MdbGreenplumClusterAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference">MdbGreenplumClusterBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHosts">masterHosts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList">MdbGreenplumClusterMasterHostsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.masterSubcluster">masterSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference">MdbGreenplumClusterMasterSubclusterOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHosts">segmentHosts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList">MdbGreenplumClusterSegmentHostsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentSubcluster">segmentSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference">MdbGreenplumClusterSegmentSubclusterOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference">MdbGreenplumClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHostCountInput">masterHostCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.masterSubclusterInput">masterSubclusterInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHostCountInput">segmentHostCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentInHostInput">segmentInHostInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentSubclusterInput">segmentSubclusterInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.userNameInput">userNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.userPasswordInput">userPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHostCount">masterHostCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHostCount">segmentHostCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentInHost">segmentInHost</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.userName">userName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.userPassword">userPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.access"></a>

```typescript
public readonly access: MdbGreenplumClusterAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference">MdbGreenplumClusterAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbGreenplumClusterBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference">MdbGreenplumClusterBackupWindowStartOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `masterHosts`<sup>Required</sup> <a name="masterHosts" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHosts"></a>

```typescript
public readonly masterHosts: MdbGreenplumClusterMasterHostsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList">MdbGreenplumClusterMasterHostsList</a>

---

##### `masterSubcluster`<sup>Required</sup> <a name="masterSubcluster" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.masterSubcluster"></a>

```typescript
public readonly masterSubcluster: MdbGreenplumClusterMasterSubclusterOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference">MdbGreenplumClusterMasterSubclusterOutputReference</a>

---

##### `segmentHosts`<sup>Required</sup> <a name="segmentHosts" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHosts"></a>

```typescript
public readonly segmentHosts: MdbGreenplumClusterSegmentHostsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList">MdbGreenplumClusterSegmentHostsList</a>

---

##### `segmentSubcluster`<sup>Required</sup> <a name="segmentSubcluster" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentSubcluster"></a>

```typescript
public readonly segmentSubcluster: MdbGreenplumClusterSegmentSubclusterOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference">MdbGreenplumClusterSegmentSubclusterOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbGreenplumClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference">MdbGreenplumClusterTimeoutsOutputReference</a>

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.accessInput"></a>

```typescript
public readonly accessInput: MdbGreenplumClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a>

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbGreenplumClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `masterHostCountInput`<sup>Optional</sup> <a name="masterHostCountInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHostCountInput"></a>

```typescript
public readonly masterHostCountInput: number;
```

- *Type:* number

---

##### `masterSubclusterInput`<sup>Optional</sup> <a name="masterSubclusterInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.masterSubclusterInput"></a>

```typescript
public readonly masterSubclusterInput: MdbGreenplumClusterMasterSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `segmentHostCountInput`<sup>Optional</sup> <a name="segmentHostCountInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHostCountInput"></a>

```typescript
public readonly segmentHostCountInput: number;
```

- *Type:* number

---

##### `segmentInHostInput`<sup>Optional</sup> <a name="segmentInHostInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentInHostInput"></a>

```typescript
public readonly segmentInHostInput: number;
```

- *Type:* number

---

##### `segmentSubclusterInput`<sup>Optional</sup> <a name="segmentSubclusterInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentSubclusterInput"></a>

```typescript
public readonly segmentSubclusterInput: MdbGreenplumClusterSegmentSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a>

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbGreenplumClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a>

---

##### `userNameInput`<sup>Optional</sup> <a name="userNameInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.userNameInput"></a>

```typescript
public readonly userNameInput: string;
```

- *Type:* string

---

##### `userPasswordInput`<sup>Optional</sup> <a name="userPasswordInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.userPasswordInput"></a>

```typescript
public readonly userPasswordInput: string;
```

- *Type:* string

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `masterHostCount`<sup>Required</sup> <a name="masterHostCount" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.masterHostCount"></a>

```typescript
public readonly masterHostCount: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `segmentHostCount`<sup>Required</sup> <a name="segmentHostCount" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentHostCount"></a>

```typescript
public readonly segmentHostCount: number;
```

- *Type:* number

---

##### `segmentInHost`<sup>Required</sup> <a name="segmentInHost" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.segmentInHost"></a>

```typescript
public readonly segmentInHost: number;
```

- *Type:* number

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `userName`<sup>Required</sup> <a name="userName" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* string

---

##### `userPassword`<sup>Required</sup> <a name="userPassword" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.userPassword"></a>

```typescript
public readonly userPassword: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbGreenplumCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbKafkaCluster <a name="MdbKafkaCluster" id="@cdktf/provider-yandex.MdbKafkaCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster yandex_mdb_kafka_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaCluster.Initializer"></a>

```typescript
import { MdbKafkaCluster } from '@cdktf/provider-yandex'

new MdbKafkaCluster(scope: Construct, id: string, config: MdbKafkaClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig">MdbKafkaClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbKafkaCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig">MdbKafkaClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.putTopic">putTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetEnvironment">resetEnvironment</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetHostGroupIds">resetHostGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetSubnetIds">resetSubnetIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetTopic">resetTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.resetUser">resetUser</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbKafkaCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbKafkaCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbKafkaCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbKafkaCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbKafkaCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.MdbKafkaCluster.putConfig"></a>

```typescript
public putConfig(value: MdbKafkaClusterConfigA): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a>

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbKafkaCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbKafkaClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbKafkaCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbKafkaClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a>

---

##### `putTopic` <a name="putTopic" id="@cdktf/provider-yandex.MdbKafkaCluster.putTopic"></a>

```typescript
public putTopic(value: IResolvable | MdbKafkaClusterTopic[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.putTopic.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbKafkaCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbKafkaClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]

---

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbKafkaCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbKafkaCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetEnvironment` <a name="resetEnvironment" id="@cdktf/provider-yandex.MdbKafkaCluster.resetEnvironment"></a>

```typescript
public resetEnvironment(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbKafkaCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHostGroupIds` <a name="resetHostGroupIds" id="@cdktf/provider-yandex.MdbKafkaCluster.resetHostGroupIds"></a>

```typescript
public resetHostGroupIds(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbKafkaCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbKafkaCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbKafkaCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbKafkaCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetSubnetIds` <a name="resetSubnetIds" id="@cdktf/provider-yandex.MdbKafkaCluster.resetSubnetIds"></a>

```typescript
public resetSubnetIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbKafkaCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetTopic` <a name="resetTopic" id="@cdktf/provider-yandex.MdbKafkaCluster.resetTopic"></a>

```typescript
public resetTopic(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.MdbKafkaCluster.resetUser"></a>

```typescript
public resetUser(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbKafkaCluster.isConstruct"></a>

```typescript
import { MdbKafkaCluster } from '@cdktf/provider-yandex'

MdbKafkaCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbKafkaCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference">MdbKafkaClusterConfigAOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList">MdbKafkaClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference">MdbKafkaClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference">MdbKafkaClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.topic">topic</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList">MdbKafkaClusterTopicList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList">MdbKafkaClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.hostGroupIdsInput">hostGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.subnetIdsInput">subnetIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.topicInput">topicInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbKafkaCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbKafkaCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbKafkaCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbKafkaCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbKafkaCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbKafkaCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbKafkaCluster.property.config"></a>

```typescript
public readonly config: MdbKafkaClusterConfigAOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference">MdbKafkaClusterConfigAOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbKafkaCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbKafkaCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbKafkaCluster.property.host"></a>

```typescript
public readonly host: MdbKafkaClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList">MdbKafkaClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbKafkaCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbKafkaClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference">MdbKafkaClusterMaintenanceWindowOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbKafkaCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbKafkaCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbKafkaClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference">MdbKafkaClusterTimeoutsOutputReference</a>

---

##### `topic`<sup>Required</sup> <a name="topic" id="@cdktf/provider-yandex.MdbKafkaCluster.property.topic"></a>

```typescript
public readonly topic: MdbKafkaClusterTopicList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList">MdbKafkaClusterTopicList</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbKafkaCluster.property.user"></a>

```typescript
public readonly user: MdbKafkaClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList">MdbKafkaClusterUserList</a>

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.configInput"></a>

```typescript
public readonly configInput: MdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostGroupIdsInput`<sup>Optional</sup> <a name="hostGroupIdsInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.hostGroupIdsInput"></a>

```typescript
public readonly hostGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbKafkaClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `subnetIdsInput`<sup>Optional</sup> <a name="subnetIdsInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.subnetIdsInput"></a>

```typescript
public readonly subnetIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbKafkaClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a>

---

##### `topicInput`<sup>Optional</sup> <a name="topicInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.topicInput"></a>

```typescript
public readonly topicInput: IResolvable | MdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbKafkaCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbKafkaCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbKafkaCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbKafkaCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbKafkaCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.MdbKafkaCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbKafkaCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbKafkaCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbKafkaCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.MdbKafkaCluster.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbKafkaCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbKafkaConnector <a name="MdbKafkaConnector" id="@cdktf/provider-yandex.MdbKafkaConnector"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector yandex_mdb_kafka_connector}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnector.Initializer"></a>

```typescript
import { MdbKafkaConnector } from '@cdktf/provider-yandex'

new MdbKafkaConnector(scope: Construct, id: string, config: MdbKafkaConnectorConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig">MdbKafkaConnectorConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbKafkaConnector.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig">MdbKafkaConnectorConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.putConnectorConfigMirrormaker">putConnectorConfigMirrormaker</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.resetConnectorConfigMirrormaker">resetConnectorConfigMirrormaker</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.resetProperties">resetProperties</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.resetTasksMax">resetTasksMax</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnector.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbKafkaConnector.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbKafkaConnector.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnector.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaConnector.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbKafkaConnector.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaConnector.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbKafkaConnector.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbKafkaConnector.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnector.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConnectorConfigMirrormaker` <a name="putConnectorConfigMirrormaker" id="@cdktf/provider-yandex.MdbKafkaConnector.putConnectorConfigMirrormaker"></a>

```typescript
public putConnectorConfigMirrormaker(value: IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnector.putConnectorConfigMirrormaker.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]

---

##### `resetConnectorConfigMirrormaker` <a name="resetConnectorConfigMirrormaker" id="@cdktf/provider-yandex.MdbKafkaConnector.resetConnectorConfigMirrormaker"></a>

```typescript
public resetConnectorConfigMirrormaker(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbKafkaConnector.resetId"></a>

```typescript
public resetId(): void
```

##### `resetProperties` <a name="resetProperties" id="@cdktf/provider-yandex.MdbKafkaConnector.resetProperties"></a>

```typescript
public resetProperties(): void
```

##### `resetTasksMax` <a name="resetTasksMax" id="@cdktf/provider-yandex.MdbKafkaConnector.resetTasksMax"></a>

```typescript
public resetTasksMax(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbKafkaConnector.isConstruct"></a>

```typescript
import { MdbKafkaConnector } from '@cdktf/provider-yandex'

MdbKafkaConnector.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbKafkaConnector.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.connectorConfigMirrormaker">connectorConfigMirrormaker</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList">MdbKafkaConnectorConnectorConfigMirrormakerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.connectorConfigMirrormakerInput">connectorConfigMirrormakerInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.propertiesInput">propertiesInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.tasksMaxInput">tasksMaxInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.properties">properties</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.tasksMax">tasksMax</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbKafkaConnector.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbKafkaConnector.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnector.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbKafkaConnector.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbKafkaConnector.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbKafkaConnector.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbKafkaConnector.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaConnector.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaConnector.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaConnector.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaConnector.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `connectorConfigMirrormaker`<sup>Required</sup> <a name="connectorConfigMirrormaker" id="@cdktf/provider-yandex.MdbKafkaConnector.property.connectorConfigMirrormaker"></a>

```typescript
public readonly connectorConfigMirrormaker: MdbKafkaConnectorConnectorConfigMirrormakerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList">MdbKafkaConnectorConnectorConfigMirrormakerList</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `connectorConfigMirrormakerInput`<sup>Optional</sup> <a name="connectorConfigMirrormakerInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.connectorConfigMirrormakerInput"></a>

```typescript
public readonly connectorConfigMirrormakerInput: IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `propertiesInput`<sup>Optional</sup> <a name="propertiesInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.propertiesInput"></a>

```typescript
public readonly propertiesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `tasksMaxInput`<sup>Optional</sup> <a name="tasksMaxInput" id="@cdktf/provider-yandex.MdbKafkaConnector.property.tasksMaxInput"></a>

```typescript
public readonly tasksMaxInput: number;
```

- *Type:* number

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbKafkaConnector.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaConnector.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaConnector.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `properties`<sup>Required</sup> <a name="properties" id="@cdktf/provider-yandex.MdbKafkaConnector.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `tasksMax`<sup>Required</sup> <a name="tasksMax" id="@cdktf/provider-yandex.MdbKafkaConnector.property.tasksMax"></a>

```typescript
public readonly tasksMax: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnector.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbKafkaConnector.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbKafkaTopic <a name="MdbKafkaTopic" id="@cdktf/provider-yandex.MdbKafkaTopic"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic yandex_mdb_kafka_topic}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaTopic.Initializer"></a>

```typescript
import { MdbKafkaTopic } from '@cdktf/provider-yandex'

new MdbKafkaTopic(scope: Construct, id: string, config: MdbKafkaTopicConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig">MdbKafkaTopicConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbKafkaTopic.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig">MdbKafkaTopicConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.putTopicConfig">putTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.resetTopicConfig">resetTopicConfig</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaTopic.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbKafkaTopic.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbKafkaTopic.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaTopic.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaTopic.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbKafkaTopic.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbKafkaTopic.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbKafkaTopic.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbKafkaTopic.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopic.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbKafkaTopic.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbKafkaTopicTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaTopic.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a>

---

##### `putTopicConfig` <a name="putTopicConfig" id="@cdktf/provider-yandex.MdbKafkaTopic.putTopicConfig"></a>

```typescript
public putTopicConfig(value: MdbKafkaTopicTopicConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaTopic.putTopicConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a>

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbKafkaTopic.resetId"></a>

```typescript
public resetId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbKafkaTopic.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetTopicConfig` <a name="resetTopicConfig" id="@cdktf/provider-yandex.MdbKafkaTopic.resetTopicConfig"></a>

```typescript
public resetTopicConfig(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbKafkaTopic.isConstruct"></a>

```typescript
import { MdbKafkaTopic } from '@cdktf/provider-yandex'

MdbKafkaTopic.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbKafkaTopic.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference">MdbKafkaTopicTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference">MdbKafkaTopicTopicConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.partitionsInput">partitionsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.replicationFactorInput">replicationFactorInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.topicConfigInput">topicConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.partitions">partitions</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbKafkaTopic.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbKafkaTopic.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaTopic.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbKafkaTopic.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbKafkaTopic.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbKafkaTopic.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbKafkaTopic.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaTopic.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaTopic.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaTopic.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaTopic.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbKafkaTopic.property.timeouts"></a>

```typescript
public readonly timeouts: MdbKafkaTopicTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference">MdbKafkaTopicTimeoutsOutputReference</a>

---

##### `topicConfig`<sup>Required</sup> <a name="topicConfig" id="@cdktf/provider-yandex.MdbKafkaTopic.property.topicConfig"></a>

```typescript
public readonly topicConfig: MdbKafkaTopicTopicConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference">MdbKafkaTopicTopicConfigOutputReference</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `partitionsInput`<sup>Optional</sup> <a name="partitionsInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.partitionsInput"></a>

```typescript
public readonly partitionsInput: number;
```

- *Type:* number

---

##### `replicationFactorInput`<sup>Optional</sup> <a name="replicationFactorInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.replicationFactorInput"></a>

```typescript
public readonly replicationFactorInput: number;
```

- *Type:* number

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbKafkaTopicTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a>

---

##### `topicConfigInput`<sup>Optional</sup> <a name="topicConfigInput" id="@cdktf/provider-yandex.MdbKafkaTopic.property.topicConfigInput"></a>

```typescript
public readonly topicConfigInput: MdbKafkaTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a>

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbKafkaTopic.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaTopic.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaTopic.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.MdbKafkaTopic.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaTopic.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopic.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbKafkaTopic.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbMongodbCluster <a name="MdbMongodbCluster" id="@cdktf/provider-yandex.MdbMongodbCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster yandex_mdb_mongodb_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbCluster.Initializer"></a>

```typescript
import { MdbMongodbCluster } from '@cdktf/provider-yandex'

new MdbMongodbCluster(scope: Construct, id: string, config: MdbMongodbClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig">MdbMongodbClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbMongodbCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig">MdbMongodbClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putClusterConfig">putClusterConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putDatabase">putDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetClusterId">resetClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbMongodbCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbMongodbCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbMongodbCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbMongodbCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbMongodbCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbMongodbCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbMongodbCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putClusterConfig` <a name="putClusterConfig" id="@cdktf/provider-yandex.MdbMongodbCluster.putClusterConfig"></a>

```typescript
public putClusterConfig(value: MdbMongodbClusterClusterConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putClusterConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a>

---

##### `putDatabase` <a name="putDatabase" id="@cdktf/provider-yandex.MdbMongodbCluster.putDatabase"></a>

```typescript
public putDatabase(value: IResolvable | MdbMongodbClusterDatabase[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putDatabase.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbMongodbCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbMongodbClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbMongodbCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbMongodbClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbMongodbCluster.putResources"></a>

```typescript
public putResources(value: MdbMongodbClusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbMongodbCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbMongodbClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a>

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbMongodbCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbMongodbClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]

---

##### `resetClusterId` <a name="resetClusterId" id="@cdktf/provider-yandex.MdbMongodbCluster.resetClusterId"></a>

```typescript
public resetClusterId(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbMongodbCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbMongodbCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbMongodbCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbMongodbCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbMongodbCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbMongodbCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbMongodbCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbMongodbCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbMongodbCluster.isConstruct"></a>

```typescript
import { MdbMongodbCluster } from '@cdktf/provider-yandex'

MdbMongodbCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbMongodbCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference">MdbMongodbClusterClusterConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList">MdbMongodbClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList">MdbMongodbClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference">MdbMongodbClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference">MdbMongodbClusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.sharded">sharded</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference">MdbMongodbClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList">MdbMongodbClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.clusterConfigInput">clusterConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.databaseInput">databaseInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbMongodbCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbMongodbCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbMongodbCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbMongodbCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbMongodbCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbMongodbCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbMongodbCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbMongodbCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbMongodbCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbMongodbCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.MdbMongodbCluster.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: MdbMongodbClusterClusterConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference">MdbMongodbClusterClusterConfigOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbMongodbCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbMongodbCluster.property.database"></a>

```typescript
public readonly database: MdbMongodbClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList">MdbMongodbClusterDatabaseList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbMongodbCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbMongodbCluster.property.host"></a>

```typescript
public readonly host: MdbMongodbClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList">MdbMongodbClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbMongodbCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbMongodbClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference">MdbMongodbClusterMaintenanceWindowOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbMongodbCluster.property.resources"></a>

```typescript
public readonly resources: MdbMongodbClusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference">MdbMongodbClusterResourcesOutputReference</a>

---

##### `sharded`<sup>Required</sup> <a name="sharded" id="@cdktf/provider-yandex.MdbMongodbCluster.property.sharded"></a>

```typescript
public readonly sharded: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbMongodbCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbMongodbCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbMongodbClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference">MdbMongodbClusterTimeoutsOutputReference</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbMongodbCluster.property.user"></a>

```typescript
public readonly user: MdbMongodbClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList">MdbMongodbClusterUserList</a>

---

##### `clusterConfigInput`<sup>Optional</sup> <a name="clusterConfigInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.clusterConfigInput"></a>

```typescript
public readonly clusterConfigInput: MdbMongodbClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.databaseInput"></a>

```typescript
public readonly databaseInput: IResolvable | MdbMongodbClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbMongodbClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbMongodbClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbMongodbClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbMongodbClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbMongodbCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbMongodbClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbMongodbCluster.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbMongodbCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbMongodbCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbMongodbCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbMongodbCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbMongodbCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbMongodbCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbMongodbCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbMongodbCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbMongodbCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbMysqlCluster <a name="MdbMysqlCluster" id="@cdktf/provider-yandex.MdbMysqlCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster yandex_mdb_mysql_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlCluster.Initializer"></a>

```typescript
import { MdbMysqlCluster } from '@cdktf/provider-yandex'

new MdbMysqlCluster(scope: Construct, id: string, config: MdbMysqlClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig">MdbMysqlClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbMysqlCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig">MdbMysqlClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putDatabase">putDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putRestore">putRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetAllowRegenerationHost">resetAllowRegenerationHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetMysqlConfig">resetMysqlConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetRestore">resetRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbMysqlCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbMysqlCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbMysqlCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbMysqlCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbMysqlCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbMysqlCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbMysqlCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.MdbMysqlCluster.putAccess"></a>

```typescript
public putAccess(value: MdbMysqlClusterAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a>

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbMysqlCluster.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbMysqlClusterBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a>

---

##### `putDatabase` <a name="putDatabase" id="@cdktf/provider-yandex.MdbMysqlCluster.putDatabase"></a>

```typescript
public putDatabase(value: IResolvable | MdbMysqlClusterDatabase[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putDatabase.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbMysqlCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbMysqlClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbMysqlCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbMysqlClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbMysqlCluster.putResources"></a>

```typescript
public putResources(value: MdbMysqlClusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a>

---

##### `putRestore` <a name="putRestore" id="@cdktf/provider-yandex.MdbMysqlCluster.putRestore"></a>

```typescript
public putRestore(value: MdbMysqlClusterRestore): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putRestore.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbMysqlCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbMysqlClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a>

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbMysqlCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbMysqlClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.MdbMysqlCluster.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetAllowRegenerationHost` <a name="resetAllowRegenerationHost" id="@cdktf/provider-yandex.MdbMysqlCluster.resetAllowRegenerationHost"></a>

```typescript
public resetAllowRegenerationHost(): void
```

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbMysqlCluster.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbMysqlCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbMysqlCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbMysqlCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbMysqlCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbMysqlCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbMysqlCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetMysqlConfig` <a name="resetMysqlConfig" id="@cdktf/provider-yandex.MdbMysqlCluster.resetMysqlConfig"></a>

```typescript
public resetMysqlConfig(): void
```

##### `resetRestore` <a name="resetRestore" id="@cdktf/provider-yandex.MdbMysqlCluster.resetRestore"></a>

```typescript
public resetRestore(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbMysqlCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbMysqlCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbMysqlCluster.isConstruct"></a>

```typescript
import { MdbMysqlCluster } from '@cdktf/provider-yandex'

MdbMysqlCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbMysqlCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference">MdbMysqlClusterAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference">MdbMysqlClusterBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList">MdbMysqlClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList">MdbMysqlClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference">MdbMysqlClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference">MdbMysqlClusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.restore">restore</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference">MdbMysqlClusterRestoreOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference">MdbMysqlClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList">MdbMysqlClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.allowRegenerationHostInput">allowRegenerationHostInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.databaseInput">databaseInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.mysqlConfigInput">mysqlConfigInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.restoreInput">restoreInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.allowRegenerationHost">allowRegenerationHost</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.mysqlConfig">mysqlConfig</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.version">version</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbMysqlCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbMysqlCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbMysqlCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbMysqlCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbMysqlCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbMysqlCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbMysqlCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbMysqlCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbMysqlCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbMysqlCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.MdbMysqlCluster.property.access"></a>

```typescript
public readonly access: MdbMysqlClusterAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference">MdbMysqlClusterAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbMysqlCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbMysqlClusterBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference">MdbMysqlClusterBackupWindowStartOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbMysqlCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbMysqlCluster.property.database"></a>

```typescript
public readonly database: MdbMysqlClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList">MdbMysqlClusterDatabaseList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbMysqlCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbMysqlCluster.property.host"></a>

```typescript
public readonly host: MdbMysqlClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList">MdbMysqlClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbMysqlCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbMysqlClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference">MdbMysqlClusterMaintenanceWindowOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbMysqlCluster.property.resources"></a>

```typescript
public readonly resources: MdbMysqlClusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference">MdbMysqlClusterResourcesOutputReference</a>

---

##### `restore`<sup>Required</sup> <a name="restore" id="@cdktf/provider-yandex.MdbMysqlCluster.property.restore"></a>

```typescript
public readonly restore: MdbMysqlClusterRestoreOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference">MdbMysqlClusterRestoreOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbMysqlCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbMysqlCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbMysqlClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference">MdbMysqlClusterTimeoutsOutputReference</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbMysqlCluster.property.user"></a>

```typescript
public readonly user: MdbMysqlClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList">MdbMysqlClusterUserList</a>

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.accessInput"></a>

```typescript
public readonly accessInput: MdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a>

---

##### `allowRegenerationHostInput`<sup>Optional</sup> <a name="allowRegenerationHostInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.allowRegenerationHostInput"></a>

```typescript
public readonly allowRegenerationHostInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbMysqlClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.databaseInput"></a>

```typescript
public readonly databaseInput: IResolvable | MdbMysqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbMysqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbMysqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a>

---

##### `mysqlConfigInput`<sup>Optional</sup> <a name="mysqlConfigInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.mysqlConfigInput"></a>

```typescript
public readonly mysqlConfigInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbMysqlClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a>

---

##### `restoreInput`<sup>Optional</sup> <a name="restoreInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.restoreInput"></a>

```typescript
public readonly restoreInput: MdbMysqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbMysqlClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbMysqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbMysqlCluster.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `allowRegenerationHost`<sup>Required</sup> <a name="allowRegenerationHost" id="@cdktf/provider-yandex.MdbMysqlCluster.property.allowRegenerationHost"></a>

```typescript
public readonly allowRegenerationHost: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbMysqlCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbMysqlCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbMysqlCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbMysqlCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbMysqlCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbMysqlCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `mysqlConfig`<sup>Required</sup> <a name="mysqlConfig" id="@cdktf/provider-yandex.MdbMysqlCluster.property.mysqlConfig"></a>

```typescript
public readonly mysqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbMysqlCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbMysqlCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbMysqlCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbMysqlCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbPostgresqlCluster <a name="MdbPostgresqlCluster" id="@cdktf/provider-yandex.MdbPostgresqlCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster yandex_mdb_postgresql_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer"></a>

```typescript
import { MdbPostgresqlCluster } from '@cdktf/provider-yandex'

new MdbPostgresqlCluster(scope: Construct, id: string, config: MdbPostgresqlClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig">MdbPostgresqlClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbPostgresqlCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig">MdbPostgresqlClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putDatabase">putDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putRestore">putRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetHostMasterName">resetHostMasterName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetRestore">resetRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbPostgresqlCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbPostgresqlCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbPostgresqlCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbPostgresqlCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putConfig"></a>

```typescript
public putConfig(value: MdbPostgresqlClusterConfigA): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a>

---

##### `putDatabase` <a name="putDatabase" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putDatabase"></a>

```typescript
public putDatabase(value: IResolvable | MdbPostgresqlClusterDatabase[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putDatabase.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbPostgresqlClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbPostgresqlClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a>

---

##### `putRestore` <a name="putRestore" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putRestore"></a>

```typescript
public putRestore(value: MdbPostgresqlClusterRestore): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putRestore.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbPostgresqlClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a>

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbPostgresqlClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]

---

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHostMasterName` <a name="resetHostMasterName" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetHostMasterName"></a>

```typescript
public resetHostMasterName(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetRestore` <a name="resetRestore" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetRestore"></a>

```typescript
public resetRestore(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbPostgresqlCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbPostgresqlCluster.isConstruct"></a>

```typescript
import { MdbPostgresqlCluster } from '@cdktf/provider-yandex'

MdbPostgresqlCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbPostgresqlCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference">MdbPostgresqlClusterConfigAOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList">MdbPostgresqlClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList">MdbPostgresqlClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference">MdbPostgresqlClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.restore">restore</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference">MdbPostgresqlClusterRestoreOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference">MdbPostgresqlClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList">MdbPostgresqlClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.databaseInput">databaseInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostMasterNameInput">hostMasterNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.restoreInput">restoreInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostMasterName">hostMasterName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.config"></a>

```typescript
public readonly config: MdbPostgresqlClusterConfigAOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference">MdbPostgresqlClusterConfigAOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.database"></a>

```typescript
public readonly database: MdbPostgresqlClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList">MdbPostgresqlClusterDatabaseList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.host"></a>

```typescript
public readonly host: MdbPostgresqlClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList">MdbPostgresqlClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbPostgresqlClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference">MdbPostgresqlClusterMaintenanceWindowOutputReference</a>

---

##### `restore`<sup>Required</sup> <a name="restore" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.restore"></a>

```typescript
public readonly restore: MdbPostgresqlClusterRestoreOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference">MdbPostgresqlClusterRestoreOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbPostgresqlClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference">MdbPostgresqlClusterTimeoutsOutputReference</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.user"></a>

```typescript
public readonly user: MdbPostgresqlClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList">MdbPostgresqlClusterUserList</a>

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.configInput"></a>

```typescript
public readonly configInput: MdbPostgresqlClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.databaseInput"></a>

```typescript
public readonly databaseInput: IResolvable | MdbPostgresqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbPostgresqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]

---

##### `hostMasterNameInput`<sup>Optional</sup> <a name="hostMasterNameInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostMasterNameInput"></a>

```typescript
public readonly hostMasterNameInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbPostgresqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `restoreInput`<sup>Optional</sup> <a name="restoreInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.restoreInput"></a>

```typescript
public readonly restoreInput: MdbPostgresqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbPostgresqlClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbPostgresqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostMasterName`<sup>Required</sup> <a name="hostMasterName" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.hostMasterName"></a>

```typescript
public readonly hostMasterName: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbPostgresqlCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbRedisCluster <a name="MdbRedisCluster" id="@cdktf/provider-yandex.MdbRedisCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster yandex_mdb_redis_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisCluster.Initializer"></a>

```typescript
import { MdbRedisCluster } from '@cdktf/provider-yandex'

new MdbRedisCluster(scope: Construct, id: string, config: MdbRedisClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig">MdbRedisClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbRedisCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfig">MdbRedisClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetPersistenceMode">resetPersistenceMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetSharded">resetSharded</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.resetTlsEnabled">resetTlsEnabled</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbRedisCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbRedisCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbRedisCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbRedisCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbRedisCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbRedisCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbRedisCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.MdbRedisCluster.putConfig"></a>

```typescript
public putConfig(value: MdbRedisClusterConfigA): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a>

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbRedisCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbRedisClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]

---

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.MdbRedisCluster.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: MdbRedisClusterMaintenanceWindow): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.putMaintenanceWindow.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbRedisCluster.putResources"></a>

```typescript
public putResources(value: MdbRedisClusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbRedisCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbRedisClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbRedisCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a>

---

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbRedisCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbRedisCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbRedisCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbRedisCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbRedisCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.MdbRedisCluster.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```

##### `resetPersistenceMode` <a name="resetPersistenceMode" id="@cdktf/provider-yandex.MdbRedisCluster.resetPersistenceMode"></a>

```typescript
public resetPersistenceMode(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbRedisCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetSharded` <a name="resetSharded" id="@cdktf/provider-yandex.MdbRedisCluster.resetSharded"></a>

```typescript
public resetSharded(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbRedisCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetTlsEnabled` <a name="resetTlsEnabled" id="@cdktf/provider-yandex.MdbRedisCluster.resetTlsEnabled"></a>

```typescript
public resetTlsEnabled(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbRedisCluster.isConstruct"></a>

```typescript
import { MdbRedisCluster } from '@cdktf/provider-yandex'

MdbRedisCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbRedisCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference">MdbRedisClusterConfigAOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList">MdbRedisClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference">MdbRedisClusterMaintenanceWindowOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference">MdbRedisClusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference">MdbRedisClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.persistenceModeInput">persistenceModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.shardedInput">shardedInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.tlsEnabledInput">tlsEnabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.persistenceMode">persistenceMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.sharded">sharded</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.tlsEnabled">tlsEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbRedisCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbRedisCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbRedisCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbRedisCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbRedisCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbRedisCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbRedisCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbRedisCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbRedisCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbRedisCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbRedisCluster.property.config"></a>

```typescript
public readonly config: MdbRedisClusterConfigAOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference">MdbRedisClusterConfigAOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbRedisCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbRedisCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbRedisCluster.property.host"></a>

```typescript
public readonly host: MdbRedisClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterHostList">MdbRedisClusterHostList</a>

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbRedisCluster.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbRedisClusterMaintenanceWindowOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference">MdbRedisClusterMaintenanceWindowOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbRedisCluster.property.resources"></a>

```typescript
public readonly resources: MdbRedisClusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference">MdbRedisClusterResourcesOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbRedisCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbRedisCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbRedisClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference">MdbRedisClusterTimeoutsOutputReference</a>

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.configInput"></a>

```typescript
public readonly configInput: MdbRedisClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a>

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbRedisClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: MdbRedisClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `persistenceModeInput`<sup>Optional</sup> <a name="persistenceModeInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.persistenceModeInput"></a>

```typescript
public readonly persistenceModeInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbRedisClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `shardedInput`<sup>Optional</sup> <a name="shardedInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.shardedInput"></a>

```typescript
public readonly shardedInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbRedisClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a>

---

##### `tlsEnabledInput`<sup>Optional</sup> <a name="tlsEnabledInput" id="@cdktf/provider-yandex.MdbRedisCluster.property.tlsEnabledInput"></a>

```typescript
public readonly tlsEnabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbRedisCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbRedisCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbRedisCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbRedisCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbRedisCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbRedisCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbRedisCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbRedisCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `persistenceMode`<sup>Required</sup> <a name="persistenceMode" id="@cdktf/provider-yandex.MdbRedisCluster.property.persistenceMode"></a>

```typescript
public readonly persistenceMode: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbRedisCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `sharded`<sup>Required</sup> <a name="sharded" id="@cdktf/provider-yandex.MdbRedisCluster.property.sharded"></a>

```typescript
public readonly sharded: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.MdbRedisCluster.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbRedisCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MdbSqlserverCluster <a name="MdbSqlserverCluster" id="@cdktf/provider-yandex.MdbSqlserverCluster"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster yandex_mdb_sqlserver_cluster}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverCluster.Initializer"></a>

```typescript
import { MdbSqlserverCluster } from '@cdktf/provider-yandex'

new MdbSqlserverCluster(scope: Construct, id: string, config: MdbSqlserverClusterConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig">MdbSqlserverClusterConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbSqlserverCluster.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig">MdbSqlserverClusterConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putDatabase">putDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putHost">putHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.putUser">putUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetDeletionProtection">resetDeletionProtection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetHostGroupIds">resetHostGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetSqlserverConfig">resetSqlserverConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverCluster.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MdbSqlserverCluster.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MdbSqlserverCluster.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MdbSqlserverCluster.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MdbSqlserverCluster.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MdbSqlserverCluster.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MdbSqlserverCluster.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverCluster.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbSqlserverCluster.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbSqlserverClusterBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a>

---

##### `putDatabase` <a name="putDatabase" id="@cdktf/provider-yandex.MdbSqlserverCluster.putDatabase"></a>

```typescript
public putDatabase(value: IResolvable | MdbSqlserverClusterDatabase[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putDatabase.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]

---

##### `putHost` <a name="putHost" id="@cdktf/provider-yandex.MdbSqlserverCluster.putHost"></a>

```typescript
public putHost(value: IResolvable | MdbSqlserverClusterHost[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putHost.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbSqlserverCluster.putResources"></a>

```typescript
public putResources(value: MdbSqlserverClusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.MdbSqlserverCluster.putTimeouts"></a>

```typescript
public putTimeouts(value: MdbSqlserverClusterTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a>

---

##### `putUser` <a name="putUser" id="@cdktf/provider-yandex.MdbSqlserverCluster.putUser"></a>

```typescript
public putUser(value: IResolvable | MdbSqlserverClusterUser[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverCluster.putUser.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]

---

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetDeletionProtection` <a name="resetDeletionProtection" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetDeletionProtection"></a>

```typescript
public resetDeletionProtection(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetHostGroupIds` <a name="resetHostGroupIds" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetHostGroupIds"></a>

```typescript
public resetHostGroupIds(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetSqlserverConfig` <a name="resetSqlserverConfig" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetSqlserverConfig"></a>

```typescript
public resetSqlserverConfig(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.MdbSqlserverCluster.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MdbSqlserverCluster.isConstruct"></a>

```typescript
import { MdbSqlserverCluster } from '@cdktf/provider-yandex'

MdbSqlserverCluster.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MdbSqlserverCluster.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference">MdbSqlserverClusterBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.database">database</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList">MdbSqlserverClusterDatabaseList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.host">host</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList">MdbSqlserverClusterHostList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference">MdbSqlserverClusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference">MdbSqlserverClusterTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.user">user</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList">MdbSqlserverClusterUserList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.databaseInput">databaseInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.deletionProtectionInput">deletionProtectionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.environmentInput">environmentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.hostGroupIdsInput">hostGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.hostInput">hostInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.sqlserverConfigInput">sqlserverConfigInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.userInput">userInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.environment">environment</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.sqlserverConfig">sqlserverConfig</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.version">version</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbSqlserverClusterBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference">MdbSqlserverClusterBackupWindowStartOutputReference</a>

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.database"></a>

```typescript
public readonly database: MdbSqlserverClusterDatabaseList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList">MdbSqlserverClusterDatabaseList</a>

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.host"></a>

```typescript
public readonly host: MdbSqlserverClusterHostList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList">MdbSqlserverClusterHostList</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.resources"></a>

```typescript
public readonly resources: MdbSqlserverClusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference">MdbSqlserverClusterResourcesOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.timeouts"></a>

```typescript
public readonly timeouts: MdbSqlserverClusterTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference">MdbSqlserverClusterTimeoutsOutputReference</a>

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.user"></a>

```typescript
public readonly user: MdbSqlserverClusterUserList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList">MdbSqlserverClusterUserList</a>

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbSqlserverClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.databaseInput"></a>

```typescript
public readonly databaseInput: IResolvable | MdbSqlserverClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]

---

##### `deletionProtectionInput`<sup>Optional</sup> <a name="deletionProtectionInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.deletionProtectionInput"></a>

```typescript
public readonly deletionProtectionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.environmentInput"></a>

```typescript
public readonly environmentInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `hostGroupIdsInput`<sup>Optional</sup> <a name="hostGroupIdsInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.hostGroupIdsInput"></a>

```typescript
public readonly hostGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.hostInput"></a>

```typescript
public readonly hostInput: IResolvable | MdbSqlserverClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbSqlserverClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `sqlserverConfigInput`<sup>Optional</sup> <a name="sqlserverConfigInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.sqlserverConfigInput"></a>

```typescript
public readonly sqlserverConfigInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | MdbSqlserverClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.userInput"></a>

```typescript
public readonly userInput: IResolvable | MdbSqlserverClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `deletionProtection`<sup>Required</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `hostGroupIds`<sup>Required</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `sqlserverConfig`<sup>Required</sup> <a name="sqlserverConfig" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.sqlserverConfig"></a>

```typescript
public readonly sqlserverConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverCluster.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MdbSqlserverCluster.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### MessageQueue <a name="MessageQueue" id="@cdktf/provider-yandex.MessageQueue"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/message_queue yandex_message_queue}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MessageQueue.Initializer"></a>

```typescript
import { MessageQueue } from '@cdktf/provider-yandex'

new MessageQueue(scope: Construct, id: string, config?: MessageQueueConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MessageQueueConfig">MessageQueueConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.MessageQueue.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MessageQueue.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.MessageQueue.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MessageQueueConfig">MessageQueueConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetAccessKey">resetAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetContentBasedDeduplication">resetContentBasedDeduplication</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetDelaySeconds">resetDelaySeconds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetFifoQueue">resetFifoQueue</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetMaxMessageSize">resetMaxMessageSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetMessageRetentionSeconds">resetMessageRetentionSeconds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetNamePrefix">resetNamePrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetReceiveWaitTimeSeconds">resetReceiveWaitTimeSeconds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetRedrivePolicy">resetRedrivePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetSecretKey">resetSecretKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.resetVisibilityTimeoutSeconds">resetVisibilityTimeoutSeconds</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MessageQueue.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.MessageQueue.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.MessageQueue.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MessageQueue.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.MessageQueue.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.MessageQueue.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.MessageQueue.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.MessageQueue.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.MessageQueue.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MessageQueue.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MessageQueue.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MessageQueue.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MessageQueue.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MessageQueue.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MessageQueue.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MessageQueue.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MessageQueue.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAccessKey` <a name="resetAccessKey" id="@cdktf/provider-yandex.MessageQueue.resetAccessKey"></a>

```typescript
public resetAccessKey(): void
```

##### `resetContentBasedDeduplication` <a name="resetContentBasedDeduplication" id="@cdktf/provider-yandex.MessageQueue.resetContentBasedDeduplication"></a>

```typescript
public resetContentBasedDeduplication(): void
```

##### `resetDelaySeconds` <a name="resetDelaySeconds" id="@cdktf/provider-yandex.MessageQueue.resetDelaySeconds"></a>

```typescript
public resetDelaySeconds(): void
```

##### `resetFifoQueue` <a name="resetFifoQueue" id="@cdktf/provider-yandex.MessageQueue.resetFifoQueue"></a>

```typescript
public resetFifoQueue(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.MessageQueue.resetId"></a>

```typescript
public resetId(): void
```

##### `resetMaxMessageSize` <a name="resetMaxMessageSize" id="@cdktf/provider-yandex.MessageQueue.resetMaxMessageSize"></a>

```typescript
public resetMaxMessageSize(): void
```

##### `resetMessageRetentionSeconds` <a name="resetMessageRetentionSeconds" id="@cdktf/provider-yandex.MessageQueue.resetMessageRetentionSeconds"></a>

```typescript
public resetMessageRetentionSeconds(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.MessageQueue.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNamePrefix` <a name="resetNamePrefix" id="@cdktf/provider-yandex.MessageQueue.resetNamePrefix"></a>

```typescript
public resetNamePrefix(): void
```

##### `resetReceiveWaitTimeSeconds` <a name="resetReceiveWaitTimeSeconds" id="@cdktf/provider-yandex.MessageQueue.resetReceiveWaitTimeSeconds"></a>

```typescript
public resetReceiveWaitTimeSeconds(): void
```

##### `resetRedrivePolicy` <a name="resetRedrivePolicy" id="@cdktf/provider-yandex.MessageQueue.resetRedrivePolicy"></a>

```typescript
public resetRedrivePolicy(): void
```

##### `resetSecretKey` <a name="resetSecretKey" id="@cdktf/provider-yandex.MessageQueue.resetSecretKey"></a>

```typescript
public resetSecretKey(): void
```

##### `resetVisibilityTimeoutSeconds` <a name="resetVisibilityTimeoutSeconds" id="@cdktf/provider-yandex.MessageQueue.resetVisibilityTimeoutSeconds"></a>

```typescript
public resetVisibilityTimeoutSeconds(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.MessageQueue.isConstruct"></a>

```typescript
import { MessageQueue } from '@cdktf/provider-yandex'

MessageQueue.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.MessageQueue.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.arn">arn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.accessKeyInput">accessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.contentBasedDeduplicationInput">contentBasedDeduplicationInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.delaySecondsInput">delaySecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.fifoQueueInput">fifoQueueInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.maxMessageSizeInput">maxMessageSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.messageRetentionSecondsInput">messageRetentionSecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.namePrefixInput">namePrefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.receiveWaitTimeSecondsInput">receiveWaitTimeSecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.redrivePolicyInput">redrivePolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.secretKeyInput">secretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.visibilityTimeoutSecondsInput">visibilityTimeoutSecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.accessKey">accessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.contentBasedDeduplication">contentBasedDeduplication</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.delaySeconds">delaySeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.fifoQueue">fifoQueue</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.maxMessageSize">maxMessageSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.messageRetentionSeconds">messageRetentionSeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.namePrefix">namePrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.receiveWaitTimeSeconds">receiveWaitTimeSeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.redrivePolicy">redrivePolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.visibilityTimeoutSeconds">visibilityTimeoutSeconds</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.MessageQueue.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.MessageQueue.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MessageQueue.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.MessageQueue.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.MessageQueue.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.MessageQueue.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.MessageQueue.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MessageQueue.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MessageQueue.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MessageQueue.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MessageQueue.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `arn`<sup>Required</sup> <a name="arn" id="@cdktf/provider-yandex.MessageQueue.property.arn"></a>

```typescript
public readonly arn: string;
```

- *Type:* string

---

##### `accessKeyInput`<sup>Optional</sup> <a name="accessKeyInput" id="@cdktf/provider-yandex.MessageQueue.property.accessKeyInput"></a>

```typescript
public readonly accessKeyInput: string;
```

- *Type:* string

---

##### `contentBasedDeduplicationInput`<sup>Optional</sup> <a name="contentBasedDeduplicationInput" id="@cdktf/provider-yandex.MessageQueue.property.contentBasedDeduplicationInput"></a>

```typescript
public readonly contentBasedDeduplicationInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `delaySecondsInput`<sup>Optional</sup> <a name="delaySecondsInput" id="@cdktf/provider-yandex.MessageQueue.property.delaySecondsInput"></a>

```typescript
public readonly delaySecondsInput: number;
```

- *Type:* number

---

##### `fifoQueueInput`<sup>Optional</sup> <a name="fifoQueueInput" id="@cdktf/provider-yandex.MessageQueue.property.fifoQueueInput"></a>

```typescript
public readonly fifoQueueInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.MessageQueue.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `maxMessageSizeInput`<sup>Optional</sup> <a name="maxMessageSizeInput" id="@cdktf/provider-yandex.MessageQueue.property.maxMessageSizeInput"></a>

```typescript
public readonly maxMessageSizeInput: number;
```

- *Type:* number

---

##### `messageRetentionSecondsInput`<sup>Optional</sup> <a name="messageRetentionSecondsInput" id="@cdktf/provider-yandex.MessageQueue.property.messageRetentionSecondsInput"></a>

```typescript
public readonly messageRetentionSecondsInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MessageQueue.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `namePrefixInput`<sup>Optional</sup> <a name="namePrefixInput" id="@cdktf/provider-yandex.MessageQueue.property.namePrefixInput"></a>

```typescript
public readonly namePrefixInput: string;
```

- *Type:* string

---

##### `receiveWaitTimeSecondsInput`<sup>Optional</sup> <a name="receiveWaitTimeSecondsInput" id="@cdktf/provider-yandex.MessageQueue.property.receiveWaitTimeSecondsInput"></a>

```typescript
public readonly receiveWaitTimeSecondsInput: number;
```

- *Type:* number

---

##### `redrivePolicyInput`<sup>Optional</sup> <a name="redrivePolicyInput" id="@cdktf/provider-yandex.MessageQueue.property.redrivePolicyInput"></a>

```typescript
public readonly redrivePolicyInput: string;
```

- *Type:* string

---

##### `secretKeyInput`<sup>Optional</sup> <a name="secretKeyInput" id="@cdktf/provider-yandex.MessageQueue.property.secretKeyInput"></a>

```typescript
public readonly secretKeyInput: string;
```

- *Type:* string

---

##### `visibilityTimeoutSecondsInput`<sup>Optional</sup> <a name="visibilityTimeoutSecondsInput" id="@cdktf/provider-yandex.MessageQueue.property.visibilityTimeoutSecondsInput"></a>

```typescript
public readonly visibilityTimeoutSecondsInput: number;
```

- *Type:* number

---

##### `accessKey`<sup>Required</sup> <a name="accessKey" id="@cdktf/provider-yandex.MessageQueue.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

---

##### `contentBasedDeduplication`<sup>Required</sup> <a name="contentBasedDeduplication" id="@cdktf/provider-yandex.MessageQueue.property.contentBasedDeduplication"></a>

```typescript
public readonly contentBasedDeduplication: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `delaySeconds`<sup>Required</sup> <a name="delaySeconds" id="@cdktf/provider-yandex.MessageQueue.property.delaySeconds"></a>

```typescript
public readonly delaySeconds: number;
```

- *Type:* number

---

##### `fifoQueue`<sup>Required</sup> <a name="fifoQueue" id="@cdktf/provider-yandex.MessageQueue.property.fifoQueue"></a>

```typescript
public readonly fifoQueue: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.MessageQueue.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `maxMessageSize`<sup>Required</sup> <a name="maxMessageSize" id="@cdktf/provider-yandex.MessageQueue.property.maxMessageSize"></a>

```typescript
public readonly maxMessageSize: number;
```

- *Type:* number

---

##### `messageRetentionSeconds`<sup>Required</sup> <a name="messageRetentionSeconds" id="@cdktf/provider-yandex.MessageQueue.property.messageRetentionSeconds"></a>

```typescript
public readonly messageRetentionSeconds: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MessageQueue.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `namePrefix`<sup>Required</sup> <a name="namePrefix" id="@cdktf/provider-yandex.MessageQueue.property.namePrefix"></a>

```typescript
public readonly namePrefix: string;
```

- *Type:* string

---

##### `receiveWaitTimeSeconds`<sup>Required</sup> <a name="receiveWaitTimeSeconds" id="@cdktf/provider-yandex.MessageQueue.property.receiveWaitTimeSeconds"></a>

```typescript
public readonly receiveWaitTimeSeconds: number;
```

- *Type:* number

---

##### `redrivePolicy`<sup>Required</sup> <a name="redrivePolicy" id="@cdktf/provider-yandex.MessageQueue.property.redrivePolicy"></a>

```typescript
public readonly redrivePolicy: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.MessageQueue.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

##### `visibilityTimeoutSeconds`<sup>Required</sup> <a name="visibilityTimeoutSeconds" id="@cdktf/provider-yandex.MessageQueue.property.visibilityTimeoutSeconds"></a>

```typescript
public readonly visibilityTimeoutSeconds: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueue.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.MessageQueue.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### OrganizationmanagerOrganizationIamBinding <a name="OrganizationmanagerOrganizationIamBinding" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding yandex_organizationmanager_organization_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer"></a>

```typescript
import { OrganizationmanagerOrganizationIamBinding } from '@cdktf/provider-yandex'

new OrganizationmanagerOrganizationIamBinding(scope: Construct, id: string, config: OrganizationmanagerOrganizationIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig">OrganizationmanagerOrganizationIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig">OrganizationmanagerOrganizationIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.isConstruct"></a>

```typescript
import { OrganizationmanagerOrganizationIamBinding } from '@cdktf/provider-yandex'

OrganizationmanagerOrganizationIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### OrganizationmanagerOrganizationIamMember <a name="OrganizationmanagerOrganizationIamMember" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member yandex_organizationmanager_organization_iam_member}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer"></a>

```typescript
import { OrganizationmanagerOrganizationIamMember } from '@cdktf/provider-yandex'

new OrganizationmanagerOrganizationIamMember(scope: Construct, id: string, config: OrganizationmanagerOrganizationIamMemberConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig">OrganizationmanagerOrganizationIamMemberConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig">OrganizationmanagerOrganizationIamMemberConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.isConstruct"></a>

```typescript
import { OrganizationmanagerOrganizationIamMember } from '@cdktf/provider-yandex'

OrganizationmanagerOrganizationIamMember.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.memberInput">memberInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.member">member</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `memberInput`<sup>Optional</sup> <a name="memberInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.memberInput"></a>

```typescript
public readonly memberInput: string;
```

- *Type:* string

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMember.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### OrganizationmanagerSamlFederation <a name="OrganizationmanagerSamlFederation" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation yandex_organizationmanager_saml_federation}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederation } from '@cdktf/provider-yandex'

new OrganizationmanagerSamlFederation(scope: Construct, id: string, config: OrganizationmanagerSamlFederationConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig">OrganizationmanagerSamlFederationConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig">OrganizationmanagerSamlFederationConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putSecuritySettings">putSecuritySettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetAutoCreateAccountOnLogin">resetAutoCreateAccountOnLogin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetCaseInsensitiveNameIds">resetCaseInsensitiveNameIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetCookieMaxAge">resetCookieMaxAge</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetSecuritySettings">resetSecuritySettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putSecuritySettings` <a name="putSecuritySettings" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putSecuritySettings"></a>

```typescript
public putSecuritySettings(value: OrganizationmanagerSamlFederationSecuritySettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putSecuritySettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putTimeouts"></a>

```typescript
public putTimeouts(value: OrganizationmanagerSamlFederationTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a>

---

##### `resetAutoCreateAccountOnLogin` <a name="resetAutoCreateAccountOnLogin" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetAutoCreateAccountOnLogin"></a>

```typescript
public resetAutoCreateAccountOnLogin(): void
```

##### `resetCaseInsensitiveNameIds` <a name="resetCaseInsensitiveNameIds" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetCaseInsensitiveNameIds"></a>

```typescript
public resetCaseInsensitiveNameIds(): void
```

##### `resetCookieMaxAge` <a name="resetCookieMaxAge" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetCookieMaxAge"></a>

```typescript
public resetCookieMaxAge(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetSecuritySettings` <a name="resetSecuritySettings" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetSecuritySettings"></a>

```typescript
public resetSecuritySettings(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.isConstruct"></a>

```typescript
import { OrganizationmanagerSamlFederation } from '@cdktf/provider-yandex'

OrganizationmanagerSamlFederation.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.securitySettings">securitySettings</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference">OrganizationmanagerSamlFederationSecuritySettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference">OrganizationmanagerSamlFederationTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.autoCreateAccountOnLoginInput">autoCreateAccountOnLoginInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.caseInsensitiveNameIdsInput">caseInsensitiveNameIdsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cookieMaxAgeInput">cookieMaxAgeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.issuerInput">issuerInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.securitySettingsInput">securitySettingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoBindingInput">ssoBindingInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoUrlInput">ssoUrlInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.autoCreateAccountOnLogin">autoCreateAccountOnLogin</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.caseInsensitiveNameIds">caseInsensitiveNameIds</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cookieMaxAge">cookieMaxAge</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.issuer">issuer</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoBinding">ssoBinding</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoUrl">ssoUrl</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `securitySettings`<sup>Required</sup> <a name="securitySettings" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.securitySettings"></a>

```typescript
public readonly securitySettings: OrganizationmanagerSamlFederationSecuritySettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference">OrganizationmanagerSamlFederationSecuritySettingsOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.timeouts"></a>

```typescript
public readonly timeouts: OrganizationmanagerSamlFederationTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference">OrganizationmanagerSamlFederationTimeoutsOutputReference</a>

---

##### `autoCreateAccountOnLoginInput`<sup>Optional</sup> <a name="autoCreateAccountOnLoginInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.autoCreateAccountOnLoginInput"></a>

```typescript
public readonly autoCreateAccountOnLoginInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `caseInsensitiveNameIdsInput`<sup>Optional</sup> <a name="caseInsensitiveNameIdsInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.caseInsensitiveNameIdsInput"></a>

```typescript
public readonly caseInsensitiveNameIdsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cookieMaxAgeInput`<sup>Optional</sup> <a name="cookieMaxAgeInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cookieMaxAgeInput"></a>

```typescript
public readonly cookieMaxAgeInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `issuerInput`<sup>Optional</sup> <a name="issuerInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.issuerInput"></a>

```typescript
public readonly issuerInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `securitySettingsInput`<sup>Optional</sup> <a name="securitySettingsInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.securitySettingsInput"></a>

```typescript
public readonly securitySettingsInput: OrganizationmanagerSamlFederationSecuritySettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a>

---

##### `ssoBindingInput`<sup>Optional</sup> <a name="ssoBindingInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoBindingInput"></a>

```typescript
public readonly ssoBindingInput: string;
```

- *Type:* string

---

##### `ssoUrlInput`<sup>Optional</sup> <a name="ssoUrlInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoUrlInput"></a>

```typescript
public readonly ssoUrlInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | OrganizationmanagerSamlFederationTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a>

---

##### `autoCreateAccountOnLogin`<sup>Required</sup> <a name="autoCreateAccountOnLogin" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.autoCreateAccountOnLogin"></a>

```typescript
public readonly autoCreateAccountOnLogin: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `caseInsensitiveNameIds`<sup>Required</sup> <a name="caseInsensitiveNameIds" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.caseInsensitiveNameIds"></a>

```typescript
public readonly caseInsensitiveNameIds: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `cookieMaxAge`<sup>Required</sup> <a name="cookieMaxAge" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.cookieMaxAge"></a>

```typescript
public readonly cookieMaxAge: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `issuer`<sup>Required</sup> <a name="issuer" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.issuer"></a>

```typescript
public readonly issuer: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

##### `ssoBinding`<sup>Required</sup> <a name="ssoBinding" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoBinding"></a>

```typescript
public readonly ssoBinding: string;
```

- *Type:* string

---

##### `ssoUrl`<sup>Required</sup> <a name="ssoUrl" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.ssoUrl"></a>

```typescript
public readonly ssoUrl: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederation.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerCloud <a name="ResourcemanagerCloud" id="@cdktf/provider-yandex.ResourcemanagerCloud"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud yandex_resourcemanager_cloud}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerCloud.Initializer"></a>

```typescript
import { ResourcemanagerCloud } from '@cdktf/provider-yandex'

new ResourcemanagerCloud(scope: Construct, id: string, config?: ResourcemanagerCloudConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig">ResourcemanagerCloudConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerCloud.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig">ResourcemanagerCloudConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetOrganizationId">resetOrganizationId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerCloud.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerCloud.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerCloud.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerCloud.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloud.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloud.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloud.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerCloud.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloud.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ResourcemanagerCloud.putTimeouts"></a>

```typescript
public putTimeouts(value: ResourcemanagerCloudTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerCloud.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetName"></a>

```typescript
public resetName(): void
```

##### `resetOrganizationId` <a name="resetOrganizationId" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetOrganizationId"></a>

```typescript
public resetOrganizationId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ResourcemanagerCloud.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerCloud.isConstruct"></a>

```typescript
import { ResourcemanagerCloud } from '@cdktf/provider-yandex'

ResourcemanagerCloud.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerCloud.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference">ResourcemanagerCloudTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.timeouts"></a>

```typescript
public readonly timeouts: ResourcemanagerCloudTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference">ResourcemanagerCloudTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ResourcemanagerCloudTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloud.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloud.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerCloudIamBinding <a name="ResourcemanagerCloudIamBinding" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding yandex_resourcemanager_cloud_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer"></a>

```typescript
import { ResourcemanagerCloudIamBinding } from '@cdktf/provider-yandex'

new ResourcemanagerCloudIamBinding(scope: Construct, id: string, config: ResourcemanagerCloudIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig">ResourcemanagerCloudIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig">ResourcemanagerCloudIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.isConstruct"></a>

```typescript
import { ResourcemanagerCloudIamBinding } from '@cdktf/provider-yandex'

ResourcemanagerCloudIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerCloudIamMember <a name="ResourcemanagerCloudIamMember" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member yandex_resourcemanager_cloud_iam_member}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer"></a>

```typescript
import { ResourcemanagerCloudIamMember } from '@cdktf/provider-yandex'

new ResourcemanagerCloudIamMember(scope: Construct, id: string, config: ResourcemanagerCloudIamMemberConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig">ResourcemanagerCloudIamMemberConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig">ResourcemanagerCloudIamMemberConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.isConstruct"></a>

```typescript
import { ResourcemanagerCloudIamMember } from '@cdktf/provider-yandex'

ResourcemanagerCloudIamMember.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.memberInput">memberInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.member">member</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `memberInput`<sup>Optional</sup> <a name="memberInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.memberInput"></a>

```typescript
public readonly memberInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMember.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerFolder <a name="ResourcemanagerFolder" id="@cdktf/provider-yandex.ResourcemanagerFolder"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder yandex_resourcemanager_folder}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerFolder.Initializer"></a>

```typescript
import { ResourcemanagerFolder } from '@cdktf/provider-yandex'

new ResourcemanagerFolder(scope: Construct, id: string, config?: ResourcemanagerFolderConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig">ResourcemanagerFolderConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerFolder.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig">ResourcemanagerFolderConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetCloudId">resetCloudId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerFolder.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerFolder.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerFolder.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerFolder.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolder.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolder.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolder.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerFolder.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolder.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ResourcemanagerFolder.putTimeouts"></a>

```typescript
public putTimeouts(value: ResourcemanagerFolderTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerFolder.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a>

---

##### `resetCloudId` <a name="resetCloudId" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetCloudId"></a>

```typescript
public resetCloudId(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ResourcemanagerFolder.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerFolder.isConstruct"></a>

```typescript
import { ResourcemanagerFolder } from '@cdktf/provider-yandex'

ResourcemanagerFolder.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerFolder.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference">ResourcemanagerFolderTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.timeouts"></a>

```typescript
public readonly timeouts: ResourcemanagerFolderTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference">ResourcemanagerFolderTimeoutsOutputReference</a>

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ResourcemanagerFolderTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a>

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolder.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolder.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerFolderIamBinding <a name="ResourcemanagerFolderIamBinding" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding yandex_resourcemanager_folder_iam_binding}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamBinding } from '@cdktf/provider-yandex'

new ResourcemanagerFolderIamBinding(scope: Construct, id: string, config: ResourcemanagerFolderIamBindingConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig">ResourcemanagerFolderIamBindingConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig">ResourcemanagerFolderIamBindingConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.isConstruct"></a>

```typescript
import { ResourcemanagerFolderIamBinding } from '@cdktf/provider-yandex'

ResourcemanagerFolderIamBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBinding.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerFolderIamMember <a name="ResourcemanagerFolderIamMember" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member yandex_resourcemanager_folder_iam_member}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamMember } from '@cdktf/provider-yandex'

new ResourcemanagerFolderIamMember(scope: Construct, id: string, config: ResourcemanagerFolderIamMemberConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig">ResourcemanagerFolderIamMemberConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig">ResourcemanagerFolderIamMemberConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetSleepAfter">resetSleepAfter</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSleepAfter` <a name="resetSleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.resetSleepAfter"></a>

```typescript
public resetSleepAfter(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.isConstruct"></a>

```typescript
import { ResourcemanagerFolderIamMember } from '@cdktf/provider-yandex'

ResourcemanagerFolderIamMember.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.memberInput">memberInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.sleepAfterInput">sleepAfterInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.member">member</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `memberInput`<sup>Optional</sup> <a name="memberInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.memberInput"></a>

```typescript
public readonly memberInput: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `sleepAfterInput`<sup>Optional</sup> <a name="sleepAfterInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.sleepAfterInput"></a>

```typescript
public readonly sleepAfterInput: number;
```

- *Type:* number

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `sleepAfter`<sup>Required</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMember.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ResourcemanagerFolderIamPolicy <a name="ResourcemanagerFolderIamPolicy" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy yandex_resourcemanager_folder_iam_policy}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamPolicy } from '@cdktf/provider-yandex'

new ResourcemanagerFolderIamPolicy(scope: Construct, id: string, config: ResourcemanagerFolderIamPolicyConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig">ResourcemanagerFolderIamPolicyConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig">ResourcemanagerFolderIamPolicyConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.resetId">resetId</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.resetId"></a>

```typescript
public resetId(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.isConstruct"></a>

```typescript
import { ResourcemanagerFolderIamPolicy } from '@cdktf/provider-yandex'

ResourcemanagerFolderIamPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.policyDataInput">policyDataInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.policyData">policyData</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `policyDataInput`<sup>Optional</sup> <a name="policyDataInput" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.policyDataInput"></a>

```typescript
public readonly policyDataInput: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `policyData`<sup>Required</sup> <a name="policyData" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.policyData"></a>

```typescript
public readonly policyData: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicy.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### ServerlessContainer <a name="ServerlessContainer" id="@cdktf/provider-yandex.ServerlessContainer"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container yandex_serverless_container}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ServerlessContainer.Initializer"></a>

```typescript
import { ServerlessContainer } from '@cdktf/provider-yandex'

new ServerlessContainer(scope: Construct, id: string, config: ServerlessContainerConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig">ServerlessContainerConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.ServerlessContainer.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerConfig">ServerlessContainerConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.putImage">putImage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetConcurrency">resetConcurrency</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetCoreFraction">resetCoreFraction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetCores">resetCores</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetExecutionTimeout">resetExecutionTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ServerlessContainer.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.ServerlessContainer.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ServerlessContainer.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ServerlessContainer.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.ServerlessContainer.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.ServerlessContainer.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.ServerlessContainer.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.ServerlessContainer.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.ServerlessContainer.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ServerlessContainer.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainer.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putImage` <a name="putImage" id="@cdktf/provider-yandex.ServerlessContainer.putImage"></a>

```typescript
public putImage(value: ServerlessContainerImage): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ServerlessContainer.putImage.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.ServerlessContainer.putTimeouts"></a>

```typescript
public putTimeouts(value: ServerlessContainerTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ServerlessContainer.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a>

---

##### `resetConcurrency` <a name="resetConcurrency" id="@cdktf/provider-yandex.ServerlessContainer.resetConcurrency"></a>

```typescript
public resetConcurrency(): void
```

##### `resetCoreFraction` <a name="resetCoreFraction" id="@cdktf/provider-yandex.ServerlessContainer.resetCoreFraction"></a>

```typescript
public resetCoreFraction(): void
```

##### `resetCores` <a name="resetCores" id="@cdktf/provider-yandex.ServerlessContainer.resetCores"></a>

```typescript
public resetCores(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ServerlessContainer.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetExecutionTimeout` <a name="resetExecutionTimeout" id="@cdktf/provider-yandex.ServerlessContainer.resetExecutionTimeout"></a>

```typescript
public resetExecutionTimeout(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ServerlessContainer.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.ServerlessContainer.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ServerlessContainer.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.ServerlessContainer.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.ServerlessContainer.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.ServerlessContainer.isConstruct"></a>

```typescript
import { ServerlessContainer } from '@cdktf/provider-yandex'

ServerlessContainer.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.ServerlessContainer.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.image">image</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference">ServerlessContainerImageOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.revisionId">revisionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference">ServerlessContainerTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.concurrencyInput">concurrencyInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.coreFractionInput">coreFractionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.coresInput">coresInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.executionTimeoutInput">executionTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.imageInput">imageInput</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.memoryInput">memoryInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.concurrency">concurrency</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.ServerlessContainer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.ServerlessContainer.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ServerlessContainer.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.ServerlessContainer.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.ServerlessContainer.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.ServerlessContainer.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.ServerlessContainer.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ServerlessContainer.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ServerlessContainer.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ServerlessContainer.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ServerlessContainer.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.ServerlessContainer.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `image`<sup>Required</sup> <a name="image" id="@cdktf/provider-yandex.ServerlessContainer.property.image"></a>

```typescript
public readonly image: ServerlessContainerImageOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference">ServerlessContainerImageOutputReference</a>

---

##### `revisionId`<sup>Required</sup> <a name="revisionId" id="@cdktf/provider-yandex.ServerlessContainer.property.revisionId"></a>

```typescript
public readonly revisionId: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.ServerlessContainer.property.timeouts"></a>

```typescript
public readonly timeouts: ServerlessContainerTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference">ServerlessContainerTimeoutsOutputReference</a>

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.ServerlessContainer.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

##### `concurrencyInput`<sup>Optional</sup> <a name="concurrencyInput" id="@cdktf/provider-yandex.ServerlessContainer.property.concurrencyInput"></a>

```typescript
public readonly concurrencyInput: number;
```

- *Type:* number

---

##### `coreFractionInput`<sup>Optional</sup> <a name="coreFractionInput" id="@cdktf/provider-yandex.ServerlessContainer.property.coreFractionInput"></a>

```typescript
public readonly coreFractionInput: number;
```

- *Type:* number

---

##### `coresInput`<sup>Optional</sup> <a name="coresInput" id="@cdktf/provider-yandex.ServerlessContainer.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* number

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ServerlessContainer.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `executionTimeoutInput`<sup>Optional</sup> <a name="executionTimeoutInput" id="@cdktf/provider-yandex.ServerlessContainer.property.executionTimeoutInput"></a>

```typescript
public readonly executionTimeoutInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ServerlessContainer.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.ServerlessContainer.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `imageInput`<sup>Optional</sup> <a name="imageInput" id="@cdktf/provider-yandex.ServerlessContainer.property.imageInput"></a>

```typescript
public readonly imageInput: ServerlessContainerImage;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a>

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ServerlessContainer.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@cdktf/provider-yandex.ServerlessContainer.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ServerlessContainer.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.ServerlessContainer.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.ServerlessContainer.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | ServerlessContainerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a>

---

##### `concurrency`<sup>Required</sup> <a name="concurrency" id="@cdktf/provider-yandex.ServerlessContainer.property.concurrency"></a>

```typescript
public readonly concurrency: number;
```

- *Type:* number

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ServerlessContainer.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.ServerlessContainer.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ServerlessContainer.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `executionTimeout`<sup>Required</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.ServerlessContainer.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ServerlessContainer.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.ServerlessContainer.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ServerlessContainer.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ServerlessContainer.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ServerlessContainer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ServerlessContainer.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainer.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.ServerlessContainer.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### StorageBucket <a name="StorageBucket" id="@cdktf/provider-yandex.StorageBucket"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket yandex_storage_bucket}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucket.Initializer"></a>

```typescript
import { StorageBucket } from '@cdktf/provider-yandex'

new StorageBucket(scope: Construct, id: string, config?: StorageBucketConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketConfig">StorageBucketConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.StorageBucket.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucket.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.StorageBucket.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketConfig">StorageBucketConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putCorsRule">putCorsRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putGrant">putGrant</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putLifecycleRule">putLifecycleRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putLogging">putLogging</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putServerSideEncryptionConfiguration">putServerSideEncryptionConfiguration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putVersioning">putVersioning</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.putWebsite">putWebsite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetAccessKey">resetAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetAcl">resetAcl</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetBucket">resetBucket</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetBucketPrefix">resetBucketPrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetCorsRule">resetCorsRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetForceDestroy">resetForceDestroy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetGrant">resetGrant</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetLifecycleRule">resetLifecycleRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetLogging">resetLogging</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetPolicy">resetPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetSecretKey">resetSecretKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetServerSideEncryptionConfiguration">resetServerSideEncryptionConfiguration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetVersioning">resetVersioning</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetWebsite">resetWebsite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetWebsiteDomain">resetWebsiteDomain</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.resetWebsiteEndpoint">resetWebsiteEndpoint</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucket.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.StorageBucket.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.StorageBucket.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.StorageBucket.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.StorageBucket.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.StorageBucket.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.StorageBucket.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.StorageBucket.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucket.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucket.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucket.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucket.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucket.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucket.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucket.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucket.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putCorsRule` <a name="putCorsRule" id="@cdktf/provider-yandex.StorageBucket.putCorsRule"></a>

```typescript
public putCorsRule(value: IResolvable | StorageBucketCorsRule[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putCorsRule.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]

---

##### `putGrant` <a name="putGrant" id="@cdktf/provider-yandex.StorageBucket.putGrant"></a>

```typescript
public putGrant(value: IResolvable | StorageBucketGrant[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putGrant.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]

---

##### `putLifecycleRule` <a name="putLifecycleRule" id="@cdktf/provider-yandex.StorageBucket.putLifecycleRule"></a>

```typescript
public putLifecycleRule(value: IResolvable | StorageBucketLifecycleRule[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putLifecycleRule.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]

---

##### `putLogging` <a name="putLogging" id="@cdktf/provider-yandex.StorageBucket.putLogging"></a>

```typescript
public putLogging(value: IResolvable | StorageBucketLogging[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putLogging.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]

---

##### `putServerSideEncryptionConfiguration` <a name="putServerSideEncryptionConfiguration" id="@cdktf/provider-yandex.StorageBucket.putServerSideEncryptionConfiguration"></a>

```typescript
public putServerSideEncryptionConfiguration(value: StorageBucketServerSideEncryptionConfiguration): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putServerSideEncryptionConfiguration.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a>

---

##### `putVersioning` <a name="putVersioning" id="@cdktf/provider-yandex.StorageBucket.putVersioning"></a>

```typescript
public putVersioning(value: StorageBucketVersioning): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putVersioning.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a>

---

##### `putWebsite` <a name="putWebsite" id="@cdktf/provider-yandex.StorageBucket.putWebsite"></a>

```typescript
public putWebsite(value: StorageBucketWebsite): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucket.putWebsite.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a>

---

##### `resetAccessKey` <a name="resetAccessKey" id="@cdktf/provider-yandex.StorageBucket.resetAccessKey"></a>

```typescript
public resetAccessKey(): void
```

##### `resetAcl` <a name="resetAcl" id="@cdktf/provider-yandex.StorageBucket.resetAcl"></a>

```typescript
public resetAcl(): void
```

##### `resetBucket` <a name="resetBucket" id="@cdktf/provider-yandex.StorageBucket.resetBucket"></a>

```typescript
public resetBucket(): void
```

##### `resetBucketPrefix` <a name="resetBucketPrefix" id="@cdktf/provider-yandex.StorageBucket.resetBucketPrefix"></a>

```typescript
public resetBucketPrefix(): void
```

##### `resetCorsRule` <a name="resetCorsRule" id="@cdktf/provider-yandex.StorageBucket.resetCorsRule"></a>

```typescript
public resetCorsRule(): void
```

##### `resetForceDestroy` <a name="resetForceDestroy" id="@cdktf/provider-yandex.StorageBucket.resetForceDestroy"></a>

```typescript
public resetForceDestroy(): void
```

##### `resetGrant` <a name="resetGrant" id="@cdktf/provider-yandex.StorageBucket.resetGrant"></a>

```typescript
public resetGrant(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.StorageBucket.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLifecycleRule` <a name="resetLifecycleRule" id="@cdktf/provider-yandex.StorageBucket.resetLifecycleRule"></a>

```typescript
public resetLifecycleRule(): void
```

##### `resetLogging` <a name="resetLogging" id="@cdktf/provider-yandex.StorageBucket.resetLogging"></a>

```typescript
public resetLogging(): void
```

##### `resetPolicy` <a name="resetPolicy" id="@cdktf/provider-yandex.StorageBucket.resetPolicy"></a>

```typescript
public resetPolicy(): void
```

##### `resetSecretKey` <a name="resetSecretKey" id="@cdktf/provider-yandex.StorageBucket.resetSecretKey"></a>

```typescript
public resetSecretKey(): void
```

##### `resetServerSideEncryptionConfiguration` <a name="resetServerSideEncryptionConfiguration" id="@cdktf/provider-yandex.StorageBucket.resetServerSideEncryptionConfiguration"></a>

```typescript
public resetServerSideEncryptionConfiguration(): void
```

##### `resetVersioning` <a name="resetVersioning" id="@cdktf/provider-yandex.StorageBucket.resetVersioning"></a>

```typescript
public resetVersioning(): void
```

##### `resetWebsite` <a name="resetWebsite" id="@cdktf/provider-yandex.StorageBucket.resetWebsite"></a>

```typescript
public resetWebsite(): void
```

##### `resetWebsiteDomain` <a name="resetWebsiteDomain" id="@cdktf/provider-yandex.StorageBucket.resetWebsiteDomain"></a>

```typescript
public resetWebsiteDomain(): void
```

##### `resetWebsiteEndpoint` <a name="resetWebsiteEndpoint" id="@cdktf/provider-yandex.StorageBucket.resetWebsiteEndpoint"></a>

```typescript
public resetWebsiteEndpoint(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.StorageBucket.isConstruct"></a>

```typescript
import { StorageBucket } from '@cdktf/provider-yandex'

StorageBucket.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.StorageBucket.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.bucketDomainName">bucketDomainName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.corsRule">corsRule</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList">StorageBucketCorsRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.grant">grant</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList">StorageBucketGrantList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.lifecycleRule">lifecycleRule</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList">StorageBucketLifecycleRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.logging">logging</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList">StorageBucketLoggingList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.serverSideEncryptionConfiguration">serverSideEncryptionConfiguration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference">StorageBucketServerSideEncryptionConfigurationOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.versioning">versioning</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference">StorageBucketVersioningOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.website">website</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference">StorageBucketWebsiteOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.accessKeyInput">accessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.aclInput">aclInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.bucketInput">bucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.bucketPrefixInput">bucketPrefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.corsRuleInput">corsRuleInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.forceDestroyInput">forceDestroyInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.grantInput">grantInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.lifecycleRuleInput">lifecycleRuleInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.loggingInput">loggingInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.policyInput">policyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.secretKeyInput">secretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.serverSideEncryptionConfigurationInput">serverSideEncryptionConfigurationInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.versioningInput">versioningInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.websiteDomainInput">websiteDomainInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.websiteEndpointInput">websiteEndpointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.websiteInput">websiteInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.accessKey">accessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.acl">acl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.bucket">bucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.bucketPrefix">bucketPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.forceDestroy">forceDestroy</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.policy">policy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.websiteDomain">websiteDomain</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.websiteEndpoint">websiteEndpoint</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.StorageBucket.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.StorageBucket.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucket.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.StorageBucket.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.StorageBucket.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.StorageBucket.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.StorageBucket.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.StorageBucket.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.StorageBucket.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.StorageBucket.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.StorageBucket.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bucketDomainName`<sup>Required</sup> <a name="bucketDomainName" id="@cdktf/provider-yandex.StorageBucket.property.bucketDomainName"></a>

```typescript
public readonly bucketDomainName: string;
```

- *Type:* string

---

##### `corsRule`<sup>Required</sup> <a name="corsRule" id="@cdktf/provider-yandex.StorageBucket.property.corsRule"></a>

```typescript
public readonly corsRule: StorageBucketCorsRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList">StorageBucketCorsRuleList</a>

---

##### `grant`<sup>Required</sup> <a name="grant" id="@cdktf/provider-yandex.StorageBucket.property.grant"></a>

```typescript
public readonly grant: StorageBucketGrantList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketGrantList">StorageBucketGrantList</a>

---

##### `lifecycleRule`<sup>Required</sup> <a name="lifecycleRule" id="@cdktf/provider-yandex.StorageBucket.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: StorageBucketLifecycleRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList">StorageBucketLifecycleRuleList</a>

---

##### `logging`<sup>Required</sup> <a name="logging" id="@cdktf/provider-yandex.StorageBucket.property.logging"></a>

```typescript
public readonly logging: StorageBucketLoggingList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLoggingList">StorageBucketLoggingList</a>

---

##### `serverSideEncryptionConfiguration`<sup>Required</sup> <a name="serverSideEncryptionConfiguration" id="@cdktf/provider-yandex.StorageBucket.property.serverSideEncryptionConfiguration"></a>

```typescript
public readonly serverSideEncryptionConfiguration: StorageBucketServerSideEncryptionConfigurationOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference">StorageBucketServerSideEncryptionConfigurationOutputReference</a>

---

##### `versioning`<sup>Required</sup> <a name="versioning" id="@cdktf/provider-yandex.StorageBucket.property.versioning"></a>

```typescript
public readonly versioning: StorageBucketVersioningOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference">StorageBucketVersioningOutputReference</a>

---

##### `website`<sup>Required</sup> <a name="website" id="@cdktf/provider-yandex.StorageBucket.property.website"></a>

```typescript
public readonly website: StorageBucketWebsiteOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference">StorageBucketWebsiteOutputReference</a>

---

##### `accessKeyInput`<sup>Optional</sup> <a name="accessKeyInput" id="@cdktf/provider-yandex.StorageBucket.property.accessKeyInput"></a>

```typescript
public readonly accessKeyInput: string;
```

- *Type:* string

---

##### `aclInput`<sup>Optional</sup> <a name="aclInput" id="@cdktf/provider-yandex.StorageBucket.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* string

---

##### `bucketInput`<sup>Optional</sup> <a name="bucketInput" id="@cdktf/provider-yandex.StorageBucket.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* string

---

##### `bucketPrefixInput`<sup>Optional</sup> <a name="bucketPrefixInput" id="@cdktf/provider-yandex.StorageBucket.property.bucketPrefixInput"></a>

```typescript
public readonly bucketPrefixInput: string;
```

- *Type:* string

---

##### `corsRuleInput`<sup>Optional</sup> <a name="corsRuleInput" id="@cdktf/provider-yandex.StorageBucket.property.corsRuleInput"></a>

```typescript
public readonly corsRuleInput: IResolvable | StorageBucketCorsRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]

---

##### `forceDestroyInput`<sup>Optional</sup> <a name="forceDestroyInput" id="@cdktf/provider-yandex.StorageBucket.property.forceDestroyInput"></a>

```typescript
public readonly forceDestroyInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `grantInput`<sup>Optional</sup> <a name="grantInput" id="@cdktf/provider-yandex.StorageBucket.property.grantInput"></a>

```typescript
public readonly grantInput: IResolvable | StorageBucketGrant[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.StorageBucket.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `lifecycleRuleInput`<sup>Optional</sup> <a name="lifecycleRuleInput" id="@cdktf/provider-yandex.StorageBucket.property.lifecycleRuleInput"></a>

```typescript
public readonly lifecycleRuleInput: IResolvable | StorageBucketLifecycleRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]

---

##### `loggingInput`<sup>Optional</sup> <a name="loggingInput" id="@cdktf/provider-yandex.StorageBucket.property.loggingInput"></a>

```typescript
public readonly loggingInput: IResolvable | StorageBucketLogging[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]

---

##### `policyInput`<sup>Optional</sup> <a name="policyInput" id="@cdktf/provider-yandex.StorageBucket.property.policyInput"></a>

```typescript
public readonly policyInput: string;
```

- *Type:* string

---

##### `secretKeyInput`<sup>Optional</sup> <a name="secretKeyInput" id="@cdktf/provider-yandex.StorageBucket.property.secretKeyInput"></a>

```typescript
public readonly secretKeyInput: string;
```

- *Type:* string

---

##### `serverSideEncryptionConfigurationInput`<sup>Optional</sup> <a name="serverSideEncryptionConfigurationInput" id="@cdktf/provider-yandex.StorageBucket.property.serverSideEncryptionConfigurationInput"></a>

```typescript
public readonly serverSideEncryptionConfigurationInput: StorageBucketServerSideEncryptionConfiguration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a>

---

##### `versioningInput`<sup>Optional</sup> <a name="versioningInput" id="@cdktf/provider-yandex.StorageBucket.property.versioningInput"></a>

```typescript
public readonly versioningInput: StorageBucketVersioning;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a>

---

##### `websiteDomainInput`<sup>Optional</sup> <a name="websiteDomainInput" id="@cdktf/provider-yandex.StorageBucket.property.websiteDomainInput"></a>

```typescript
public readonly websiteDomainInput: string;
```

- *Type:* string

---

##### `websiteEndpointInput`<sup>Optional</sup> <a name="websiteEndpointInput" id="@cdktf/provider-yandex.StorageBucket.property.websiteEndpointInput"></a>

```typescript
public readonly websiteEndpointInput: string;
```

- *Type:* string

---

##### `websiteInput`<sup>Optional</sup> <a name="websiteInput" id="@cdktf/provider-yandex.StorageBucket.property.websiteInput"></a>

```typescript
public readonly websiteInput: StorageBucketWebsite;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a>

---

##### `accessKey`<sup>Required</sup> <a name="accessKey" id="@cdktf/provider-yandex.StorageBucket.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

---

##### `acl`<sup>Required</sup> <a name="acl" id="@cdktf/provider-yandex.StorageBucket.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* string

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="@cdktf/provider-yandex.StorageBucket.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

---

##### `bucketPrefix`<sup>Required</sup> <a name="bucketPrefix" id="@cdktf/provider-yandex.StorageBucket.property.bucketPrefix"></a>

```typescript
public readonly bucketPrefix: string;
```

- *Type:* string

---

##### `forceDestroy`<sup>Required</sup> <a name="forceDestroy" id="@cdktf/provider-yandex.StorageBucket.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucket.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `policy`<sup>Required</sup> <a name="policy" id="@cdktf/provider-yandex.StorageBucket.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.StorageBucket.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

##### `websiteDomain`<sup>Required</sup> <a name="websiteDomain" id="@cdktf/provider-yandex.StorageBucket.property.websiteDomain"></a>

```typescript
public readonly websiteDomain: string;
```

- *Type:* string

---

##### `websiteEndpoint`<sup>Required</sup> <a name="websiteEndpoint" id="@cdktf/provider-yandex.StorageBucket.property.websiteEndpoint"></a>

```typescript
public readonly websiteEndpoint: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucket.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.StorageBucket.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### StorageObject <a name="StorageObject" id="@cdktf/provider-yandex.StorageObject"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/storage_object yandex_storage_object}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageObject.Initializer"></a>

```typescript
import { StorageObject } from '@cdktf/provider-yandex'

new StorageObject(scope: Construct, id: string, config: StorageObjectConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObject.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.StorageObjectConfig">StorageObjectConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.StorageObject.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageObject.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.StorageObject.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageObjectConfig">StorageObjectConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObject.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetAccessKey">resetAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetAcl">resetAcl</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetContent">resetContent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetContentBase64">resetContentBase64</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetContentType">resetContentType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetSecretKey">resetSecretKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.resetSource">resetSource</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageObject.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.StorageObject.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.StorageObject.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageObject.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.StorageObject.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.StorageObject.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.StorageObject.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.StorageObject.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.StorageObject.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageObject.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageObject.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageObject.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageObject.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageObject.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageObject.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageObject.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageObject.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `resetAccessKey` <a name="resetAccessKey" id="@cdktf/provider-yandex.StorageObject.resetAccessKey"></a>

```typescript
public resetAccessKey(): void
```

##### `resetAcl` <a name="resetAcl" id="@cdktf/provider-yandex.StorageObject.resetAcl"></a>

```typescript
public resetAcl(): void
```

##### `resetContent` <a name="resetContent" id="@cdktf/provider-yandex.StorageObject.resetContent"></a>

```typescript
public resetContent(): void
```

##### `resetContentBase64` <a name="resetContentBase64" id="@cdktf/provider-yandex.StorageObject.resetContentBase64"></a>

```typescript
public resetContentBase64(): void
```

##### `resetContentType` <a name="resetContentType" id="@cdktf/provider-yandex.StorageObject.resetContentType"></a>

```typescript
public resetContentType(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.StorageObject.resetId"></a>

```typescript
public resetId(): void
```

##### `resetSecretKey` <a name="resetSecretKey" id="@cdktf/provider-yandex.StorageObject.resetSecretKey"></a>

```typescript
public resetSecretKey(): void
```

##### `resetSource` <a name="resetSource" id="@cdktf/provider-yandex.StorageObject.resetSource"></a>

```typescript
public resetSource(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObject.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.StorageObject.isConstruct"></a>

```typescript
import { StorageObject } from '@cdktf/provider-yandex'

StorageObject.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.StorageObject.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.accessKeyInput">accessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.aclInput">aclInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.bucketInput">bucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.contentBase64Input">contentBase64Input</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.contentInput">contentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.contentTypeInput">contentTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.keyInput">keyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.secretKeyInput">secretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.sourceInput">sourceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.accessKey">accessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.acl">acl</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.bucket">bucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.content">content</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.contentBase64">contentBase64</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.contentType">contentType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.key">key</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.secretKey">secretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.source">source</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.StorageObject.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.StorageObject.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageObject.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.StorageObject.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.StorageObject.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.StorageObject.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.StorageObject.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.StorageObject.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.StorageObject.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.StorageObject.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.StorageObject.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `accessKeyInput`<sup>Optional</sup> <a name="accessKeyInput" id="@cdktf/provider-yandex.StorageObject.property.accessKeyInput"></a>

```typescript
public readonly accessKeyInput: string;
```

- *Type:* string

---

##### `aclInput`<sup>Optional</sup> <a name="aclInput" id="@cdktf/provider-yandex.StorageObject.property.aclInput"></a>

```typescript
public readonly aclInput: string;
```

- *Type:* string

---

##### `bucketInput`<sup>Optional</sup> <a name="bucketInput" id="@cdktf/provider-yandex.StorageObject.property.bucketInput"></a>

```typescript
public readonly bucketInput: string;
```

- *Type:* string

---

##### `contentBase64Input`<sup>Optional</sup> <a name="contentBase64Input" id="@cdktf/provider-yandex.StorageObject.property.contentBase64Input"></a>

```typescript
public readonly contentBase64Input: string;
```

- *Type:* string

---

##### `contentInput`<sup>Optional</sup> <a name="contentInput" id="@cdktf/provider-yandex.StorageObject.property.contentInput"></a>

```typescript
public readonly contentInput: string;
```

- *Type:* string

---

##### `contentTypeInput`<sup>Optional</sup> <a name="contentTypeInput" id="@cdktf/provider-yandex.StorageObject.property.contentTypeInput"></a>

```typescript
public readonly contentTypeInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.StorageObject.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `keyInput`<sup>Optional</sup> <a name="keyInput" id="@cdktf/provider-yandex.StorageObject.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* string

---

##### `secretKeyInput`<sup>Optional</sup> <a name="secretKeyInput" id="@cdktf/provider-yandex.StorageObject.property.secretKeyInput"></a>

```typescript
public readonly secretKeyInput: string;
```

- *Type:* string

---

##### `sourceInput`<sup>Optional</sup> <a name="sourceInput" id="@cdktf/provider-yandex.StorageObject.property.sourceInput"></a>

```typescript
public readonly sourceInput: string;
```

- *Type:* string

---

##### `accessKey`<sup>Required</sup> <a name="accessKey" id="@cdktf/provider-yandex.StorageObject.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

---

##### `acl`<sup>Required</sup> <a name="acl" id="@cdktf/provider-yandex.StorageObject.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* string

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="@cdktf/provider-yandex.StorageObject.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

---

##### `content`<sup>Required</sup> <a name="content" id="@cdktf/provider-yandex.StorageObject.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* string

---

##### `contentBase64`<sup>Required</sup> <a name="contentBase64" id="@cdktf/provider-yandex.StorageObject.property.contentBase64"></a>

```typescript
public readonly contentBase64: string;
```

- *Type:* string

---

##### `contentType`<sup>Required</sup> <a name="contentType" id="@cdktf/provider-yandex.StorageObject.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageObject.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `key`<sup>Required</sup> <a name="key" id="@cdktf/provider-yandex.StorageObject.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

---

##### `secretKey`<sup>Required</sup> <a name="secretKey" id="@cdktf/provider-yandex.StorageObject.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

---

##### `source`<sup>Required</sup> <a name="source" id="@cdktf/provider-yandex.StorageObject.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObject.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.StorageObject.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcAddress <a name="VpcAddress" id="@cdktf/provider-yandex.VpcAddress"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address yandex_vpc_address}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcAddress.Initializer"></a>

```typescript
import { VpcAddress } from '@cdktf/provider-yandex'

new VpcAddress(scope: Construct, id: string, config?: VpcAddressConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressConfig">VpcAddressConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcAddress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcAddress.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.VpcAddress.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressConfig">VpcAddressConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.putExternalIpv4Address">putExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetExternalIpv4Address">resetExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcAddress.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcAddress.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcAddress.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcAddress.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcAddress.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcAddress.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcAddress.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcAddress.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcAddress.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcAddress.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcAddress.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcAddress.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcAddress.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcAddress.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcAddress.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcAddress.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddress.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putExternalIpv4Address` <a name="putExternalIpv4Address" id="@cdktf/provider-yandex.VpcAddress.putExternalIpv4Address"></a>

```typescript
public putExternalIpv4Address(value: VpcAddressExternalIpv4Address): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcAddress.putExternalIpv4Address.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcAddress.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcAddressTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcAddress.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcAddress.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetExternalIpv4Address` <a name="resetExternalIpv4Address" id="@cdktf/provider-yandex.VpcAddress.resetExternalIpv4Address"></a>

```typescript
public resetExternalIpv4Address(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcAddress.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcAddress.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcAddress.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.VpcAddress.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcAddress.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcAddress.isConstruct"></a>

```typescript
import { VpcAddress } from '@cdktf/provider-yandex'

VpcAddress.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcAddress.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference">VpcAddressExternalIpv4AddressOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.reserved">reserved</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference">VpcAddressTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.used">used</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.externalIpv4AddressInput">externalIpv4AddressInput</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcAddress.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcAddress.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcAddress.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcAddress.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcAddress.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcAddress.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcAddress.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcAddress.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcAddress.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcAddress.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcAddress.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcAddress.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `externalIpv4Address`<sup>Required</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.VpcAddress.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: VpcAddressExternalIpv4AddressOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference">VpcAddressExternalIpv4AddressOutputReference</a>

---

##### `reserved`<sup>Required</sup> <a name="reserved" id="@cdktf/provider-yandex.VpcAddress.property.reserved"></a>

```typescript
public readonly reserved: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcAddress.property.timeouts"></a>

```typescript
public readonly timeouts: VpcAddressTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference">VpcAddressTimeoutsOutputReference</a>

---

##### `used`<sup>Required</sup> <a name="used" id="@cdktf/provider-yandex.VpcAddress.property.used"></a>

```typescript
public readonly used: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcAddress.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `externalIpv4AddressInput`<sup>Optional</sup> <a name="externalIpv4AddressInput" id="@cdktf/provider-yandex.VpcAddress.property.externalIpv4AddressInput"></a>

```typescript
public readonly externalIpv4AddressInput: VpcAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcAddress.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcAddress.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcAddress.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.VpcAddress.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcAddress.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcAddressTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcAddress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcAddress.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcAddress.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcAddress.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcAddress.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddress.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcAddress.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcDefaultSecurityGroup <a name="VpcDefaultSecurityGroup" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group yandex_vpc_default_security_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroup } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroup(scope: Construct, id: string, config: VpcDefaultSecurityGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig">VpcDefaultSecurityGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig">VpcDefaultSecurityGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.putEgress">putEgress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.putIngress">putIngress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetEgress">resetEgress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetIngress">resetIngress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putEgress` <a name="putEgress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putEgress"></a>

```typescript
public putEgress(value: IResolvable | VpcDefaultSecurityGroupEgress[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putEgress.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]

---

##### `putIngress` <a name="putIngress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putIngress"></a>

```typescript
public putIngress(value: IResolvable | VpcDefaultSecurityGroupIngress[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putIngress.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcDefaultSecurityGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetEgress` <a name="resetEgress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetEgress"></a>

```typescript
public resetEgress(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetIngress` <a name="resetIngress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetIngress"></a>

```typescript
public resetIngress(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.isConstruct"></a>

```typescript
import { VpcDefaultSecurityGroup } from '@cdktf/provider-yandex'

VpcDefaultSecurityGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.egress">egress</a></code> | <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList">VpcDefaultSecurityGroupEgressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.ingress">ingress</a></code> | <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList">VpcDefaultSecurityGroupIngressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference">VpcDefaultSecurityGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.egressInput">egressInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.ingressInput">ingressInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `egress`<sup>Required</sup> <a name="egress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.egress"></a>

```typescript
public readonly egress: VpcDefaultSecurityGroupEgressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList">VpcDefaultSecurityGroupEgressList</a>

---

##### `ingress`<sup>Required</sup> <a name="ingress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.ingress"></a>

```typescript
public readonly ingress: VpcDefaultSecurityGroupIngressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList">VpcDefaultSecurityGroupIngressList</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.timeouts"></a>

```typescript
public readonly timeouts: VpcDefaultSecurityGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference">VpcDefaultSecurityGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `egressInput`<sup>Optional</sup> <a name="egressInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.egressInput"></a>

```typescript
public readonly egressInput: IResolvable | VpcDefaultSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `ingressInput`<sup>Optional</sup> <a name="ingressInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.ingressInput"></a>

```typescript
public readonly ingressInput: IResolvable | VpcDefaultSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcDefaultSecurityGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcDefaultSecurityGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcNetwork <a name="VpcNetwork" id="@cdktf/provider-yandex.VpcNetwork"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network yandex_vpc_network}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcNetwork.Initializer"></a>

```typescript
import { VpcNetwork } from '@cdktf/provider-yandex'

new VpcNetwork(scope: Construct, id: string, config?: VpcNetworkConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig">VpcNetworkConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.VpcNetwork.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcNetworkConfig">VpcNetworkConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcNetwork.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcNetwork.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcNetwork.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcNetwork.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcNetwork.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcNetwork.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcNetwork.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcNetwork.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcNetwork.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcNetwork.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcNetwork.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcNetwork.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcNetwork.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcNetwork.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcNetwork.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcNetwork.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetwork.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcNetwork.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcNetworkTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcNetwork.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcNetwork.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcNetwork.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcNetwork.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcNetwork.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.VpcNetwork.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcNetwork.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcNetwork.isConstruct"></a>

```typescript
import { VpcNetwork } from '@cdktf/provider-yandex'

VpcNetwork.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcNetwork.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.defaultSecurityGroupId">defaultSecurityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference">VpcNetworkTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcNetwork.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcNetwork.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcNetwork.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcNetwork.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcNetwork.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcNetwork.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcNetwork.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcNetwork.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcNetwork.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcNetwork.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcNetwork.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcNetwork.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `defaultSecurityGroupId`<sup>Required</sup> <a name="defaultSecurityGroupId" id="@cdktf/provider-yandex.VpcNetwork.property.defaultSecurityGroupId"></a>

```typescript
public readonly defaultSecurityGroupId: string;
```

- *Type:* string

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.VpcNetwork.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcNetwork.property.timeouts"></a>

```typescript
public readonly timeouts: VpcNetworkTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference">VpcNetworkTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcNetwork.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcNetwork.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcNetwork.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcNetwork.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.VpcNetwork.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcNetwork.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcNetworkTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcNetwork.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcNetwork.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcNetwork.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcNetwork.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcNetwork.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetwork.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcNetwork.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcRouteTable <a name="VpcRouteTable" id="@cdktf/provider-yandex.VpcRouteTable"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table yandex_vpc_route_table}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcRouteTable.Initializer"></a>

```typescript
import { VpcRouteTable } from '@cdktf/provider-yandex'

new VpcRouteTable(scope: Construct, id: string, config: VpcRouteTableConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig">VpcRouteTableConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.VpcRouteTable.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcRouteTableConfig">VpcRouteTableConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.putStaticRoute">putStaticRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetStaticRoute">resetStaticRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcRouteTable.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcRouteTable.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcRouteTable.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcRouteTable.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcRouteTable.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcRouteTable.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcRouteTable.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcRouteTable.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcRouteTable.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcRouteTable.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTable.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putStaticRoute` <a name="putStaticRoute" id="@cdktf/provider-yandex.VpcRouteTable.putStaticRoute"></a>

```typescript
public putStaticRoute(value: IResolvable | VpcRouteTableStaticRoute[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcRouteTable.putStaticRoute.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcRouteTable.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcRouteTableTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcRouteTable.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcRouteTable.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcRouteTable.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcRouteTable.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcRouteTable.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.VpcRouteTable.resetName"></a>

```typescript
public resetName(): void
```

##### `resetStaticRoute` <a name="resetStaticRoute" id="@cdktf/provider-yandex.VpcRouteTable.resetStaticRoute"></a>

```typescript
public resetStaticRoute(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcRouteTable.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcRouteTable.isConstruct"></a>

```typescript
import { VpcRouteTable } from '@cdktf/provider-yandex'

VpcRouteTable.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcRouteTable.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.staticRoute">staticRoute</a></code> | <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList">VpcRouteTableStaticRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference">VpcRouteTableTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.staticRouteInput">staticRouteInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcRouteTable.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcRouteTable.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcRouteTable.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcRouteTable.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcRouteTable.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcRouteTable.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcRouteTable.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcRouteTable.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcRouteTable.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcRouteTable.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcRouteTable.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcRouteTable.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `staticRoute`<sup>Required</sup> <a name="staticRoute" id="@cdktf/provider-yandex.VpcRouteTable.property.staticRoute"></a>

```typescript
public readonly staticRoute: VpcRouteTableStaticRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList">VpcRouteTableStaticRouteList</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcRouteTable.property.timeouts"></a>

```typescript
public readonly timeouts: VpcRouteTableTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference">VpcRouteTableTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcRouteTable.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcRouteTable.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcRouteTable.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcRouteTable.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.VpcRouteTable.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.VpcRouteTable.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `staticRouteInput`<sup>Optional</sup> <a name="staticRouteInput" id="@cdktf/provider-yandex.VpcRouteTable.property.staticRouteInput"></a>

```typescript
public readonly staticRouteInput: IResolvable | VpcRouteTableStaticRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcRouteTable.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcRouteTableTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcRouteTable.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcRouteTable.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcRouteTable.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcRouteTable.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcRouteTable.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcRouteTable.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTable.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcRouteTable.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcSecurityGroup <a name="VpcSecurityGroup" id="@cdktf/provider-yandex.VpcSecurityGroup"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group yandex_vpc_security_group}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroup.Initializer"></a>

```typescript
import { VpcSecurityGroup } from '@cdktf/provider-yandex'

new VpcSecurityGroup(scope: Construct, id: string, config: VpcSecurityGroupConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig">VpcSecurityGroupConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.VpcSecurityGroup.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig">VpcSecurityGroupConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.putEgress">putEgress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.putIngress">putIngress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetEgress">resetEgress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetIngress">resetIngress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroup.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcSecurityGroup.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcSecurityGroup.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroup.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroup.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroup.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroup.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcSecurityGroup.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcSecurityGroup.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroup.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putEgress` <a name="putEgress" id="@cdktf/provider-yandex.VpcSecurityGroup.putEgress"></a>

```typescript
public putEgress(value: IResolvable | VpcSecurityGroupEgress[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroup.putEgress.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]

---

##### `putIngress` <a name="putIngress" id="@cdktf/provider-yandex.VpcSecurityGroup.putIngress"></a>

```typescript
public putIngress(value: IResolvable | VpcSecurityGroupIngress[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroup.putIngress.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroup.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcSecurityGroupTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroup.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcSecurityGroup.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetEgress` <a name="resetEgress" id="@cdktf/provider-yandex.VpcSecurityGroup.resetEgress"></a>

```typescript
public resetEgress(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcSecurityGroup.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcSecurityGroup.resetId"></a>

```typescript
public resetId(): void
```

##### `resetIngress` <a name="resetIngress" id="@cdktf/provider-yandex.VpcSecurityGroup.resetIngress"></a>

```typescript
public resetIngress(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcSecurityGroup.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.VpcSecurityGroup.resetName"></a>

```typescript
public resetName(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroup.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcSecurityGroup.isConstruct"></a>

```typescript
import { VpcSecurityGroup } from '@cdktf/provider-yandex'

VpcSecurityGroup.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcSecurityGroup.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.egress">egress</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList">VpcSecurityGroupEgressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.ingress">ingress</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList">VpcSecurityGroupIngressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference">VpcSecurityGroupTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.egressInput">egressInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.ingressInput">ingressInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcSecurityGroup.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcSecurityGroup.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroup.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcSecurityGroup.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcSecurityGroup.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcSecurityGroup.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcSecurityGroup.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSecurityGroup.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSecurityGroup.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSecurityGroup.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSecurityGroup.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcSecurityGroup.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `egress`<sup>Required</sup> <a name="egress" id="@cdktf/provider-yandex.VpcSecurityGroup.property.egress"></a>

```typescript
public readonly egress: VpcSecurityGroupEgressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList">VpcSecurityGroupEgressList</a>

---

##### `ingress`<sup>Required</sup> <a name="ingress" id="@cdktf/provider-yandex.VpcSecurityGroup.property.ingress"></a>

```typescript
public readonly ingress: VpcSecurityGroupIngressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList">VpcSecurityGroupIngressList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.VpcSecurityGroup.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSecurityGroup.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSecurityGroupTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference">VpcSecurityGroupTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `egressInput`<sup>Optional</sup> <a name="egressInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.egressInput"></a>

```typescript
public readonly egressInput: IResolvable | VpcSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `ingressInput`<sup>Optional</sup> <a name="ingressInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.ingressInput"></a>

```typescript
public readonly ingressInput: IResolvable | VpcSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcSecurityGroup.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcSecurityGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcSecurityGroup.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroup.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroup.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcSecurityGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcSecurityGroup.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroup.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcSecurityGroup.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcSecurityGroupRule <a name="VpcSecurityGroupRule" id="@cdktf/provider-yandex.VpcSecurityGroupRule"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule yandex_vpc_security_group_rule}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer"></a>

```typescript
import { VpcSecurityGroupRule } from '@cdktf/provider-yandex'

new VpcSecurityGroupRule(scope: Construct, id: string, config: VpcSecurityGroupRuleConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig">VpcSecurityGroupRuleConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.VpcSecurityGroupRule.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig">VpcSecurityGroupRuleConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetFromPort">resetFromPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetPredefinedTarget">resetPredefinedTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetProtocol">resetProtocol</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetToPort">resetToPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetV4CidrBlocks">resetV4CidrBlocks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.resetV6CidrBlocks">resetV6CidrBlocks</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupRule.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcSecurityGroupRule.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcSecurityGroupRule.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroupRule.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcSecurityGroupRule.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcSecurityGroupRule.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRule.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroupRule.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcSecurityGroupRuleTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSecurityGroupRule.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFromPort` <a name="resetFromPort" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetFromPort"></a>

```typescript
public resetFromPort(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetPredefinedTarget` <a name="resetPredefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetPredefinedTarget"></a>

```typescript
public resetPredefinedTarget(): void
```

##### `resetProtocol` <a name="resetProtocol" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetProtocol"></a>

```typescript
public resetProtocol(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetToPort` <a name="resetToPort" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetToPort"></a>

```typescript
public resetToPort(): void
```

##### `resetV4CidrBlocks` <a name="resetV4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetV4CidrBlocks"></a>

```typescript
public resetV4CidrBlocks(): void
```

##### `resetV6CidrBlocks` <a name="resetV6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRule.resetV6CidrBlocks"></a>

```typescript
public resetV6CidrBlocks(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcSecurityGroupRule.isConstruct"></a>

```typescript
import { VpcSecurityGroupRule } from '@cdktf/provider-yandex'

VpcSecurityGroupRule.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcSecurityGroupRule.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference">VpcSecurityGroupRuleTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.directionInput">directionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.fromPortInput">fromPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.predefinedTargetInput">predefinedTargetInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupBindingInput">securityGroupBindingInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.toPortInput">toPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.v6CidrBlocksInput">v6CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.direction">direction</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupBinding">securityGroupBinding</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSecurityGroupRuleTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference">VpcSecurityGroupRuleTimeoutsOutputReference</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `directionInput`<sup>Optional</sup> <a name="directionInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.directionInput"></a>

```typescript
public readonly directionInput: string;
```

- *Type:* string

---

##### `fromPortInput`<sup>Optional</sup> <a name="fromPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* number

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `predefinedTargetInput`<sup>Optional</sup> <a name="predefinedTargetInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.predefinedTargetInput"></a>

```typescript
public readonly predefinedTargetInput: string;
```

- *Type:* string

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `securityGroupBindingInput`<sup>Optional</sup> <a name="securityGroupBindingInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupBindingInput"></a>

```typescript
public readonly securityGroupBindingInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcSecurityGroupRuleTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a>

---

##### `toPortInput`<sup>Optional</sup> <a name="toPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* number

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocksInput`<sup>Optional</sup> <a name="v6CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.v6CidrBlocksInput"></a>

```typescript
public readonly v6CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `direction`<sup>Required</sup> <a name="direction" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.direction"></a>

```typescript
public readonly direction: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupBinding`<sup>Required</sup> <a name="securityGroupBinding" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupBinding"></a>

```typescript
public readonly securityGroupBinding: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRule.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcSecurityGroupRule.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### VpcSubnet <a name="VpcSubnet" id="@cdktf/provider-yandex.VpcSubnet"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet yandex_vpc_subnet}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSubnet.Initializer"></a>

```typescript
import { VpcSubnet } from '@cdktf/provider-yandex'

new VpcSubnet(scope: Construct, id: string, config: VpcSubnetConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig">VpcSubnetConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.VpcSubnet.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetConfig">VpcSubnetConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.putDhcpOptions">putDhcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetDhcpOptions">resetDhcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetRouteTableId">resetRouteTableId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetTimeouts">resetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSubnet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.VpcSubnet.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.VpcSubnet.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSubnet.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.VpcSubnet.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.VpcSubnet.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.VpcSubnet.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.VpcSubnet.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.VpcSubnet.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSubnet.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSubnet.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSubnet.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSubnet.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSubnet.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSubnet.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSubnet.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnet.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putDhcpOptions` <a name="putDhcpOptions" id="@cdktf/provider-yandex.VpcSubnet.putDhcpOptions"></a>

```typescript
public putDhcpOptions(value: VpcSubnetDhcpOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSubnet.putDhcpOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.VpcSubnet.putTimeouts"></a>

```typescript
public putTimeouts(value: VpcSubnetTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.VpcSubnet.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcSubnet.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetDhcpOptions` <a name="resetDhcpOptions" id="@cdktf/provider-yandex.VpcSubnet.resetDhcpOptions"></a>

```typescript
public resetDhcpOptions(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.VpcSubnet.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.VpcSubnet.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcSubnet.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.VpcSubnet.resetName"></a>

```typescript
public resetName(): void
```

##### `resetRouteTableId` <a name="resetRouteTableId" id="@cdktf/provider-yandex.VpcSubnet.resetRouteTableId"></a>

```typescript
public resetRouteTableId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.VpcSubnet.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.VpcSubnet.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.VpcSubnet.isConstruct"></a>

```typescript
import { VpcSubnet } from '@cdktf/provider-yandex'

VpcSubnet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.VpcSubnet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.dhcpOptions">dhcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference">VpcSubnetDhcpOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference">VpcSubnetTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.dhcpOptionsInput">dhcpOptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.routeTableIdInput">routeTableIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.routeTableId">routeTableId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.VpcSubnet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.VpcSubnet.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSubnet.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.VpcSubnet.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.VpcSubnet.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.VpcSubnet.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.VpcSubnet.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSubnet.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSubnet.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSubnet.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSubnet.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.VpcSubnet.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `dhcpOptions`<sup>Required</sup> <a name="dhcpOptions" id="@cdktf/provider-yandex.VpcSubnet.property.dhcpOptions"></a>

```typescript
public readonly dhcpOptions: VpcSubnetDhcpOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference">VpcSubnetDhcpOptionsOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSubnet.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSubnetTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference">VpcSubnetTimeoutsOutputReference</a>

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSubnet.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcSubnet.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `dhcpOptionsInput`<sup>Optional</sup> <a name="dhcpOptionsInput" id="@cdktf/provider-yandex.VpcSubnet.property.dhcpOptionsInput"></a>

```typescript
public readonly dhcpOptionsInput: VpcSubnetDhcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a>

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.VpcSubnet.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.VpcSubnet.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcSubnet.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.VpcSubnet.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.VpcSubnet.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `routeTableIdInput`<sup>Optional</sup> <a name="routeTableIdInput" id="@cdktf/provider-yandex.VpcSubnet.property.routeTableIdInput"></a>

```typescript
public readonly routeTableIdInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.VpcSubnet.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | VpcSubnetTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a>

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcSubnet.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.VpcSubnet.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcSubnet.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcSubnet.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSubnet.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSubnet.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.VpcSubnet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcSubnet.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `routeTableId`<sup>Required</sup> <a name="routeTableId" id="@cdktf/provider-yandex.VpcSubnet.property.routeTableId"></a>

```typescript
public readonly routeTableId: string;
```

- *Type:* string

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSubnet.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.VpcSubnet.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnet.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.VpcSubnet.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### YandexProvider <a name="YandexProvider" id="@cdktf/provider-yandex.YandexProvider"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex yandex}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YandexProvider.Initializer"></a>

```typescript
import { YandexProvider } from '@cdktf/provider-yandex'

new YandexProvider(scope: Construct, id: string, config?: YandexProviderConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.YandexProviderConfig">YandexProviderConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.YandexProvider.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YandexProvider.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.YandexProvider.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YandexProviderConfig">YandexProviderConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetAlias">resetAlias</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetCloudId">resetCloudId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetEndpoint">resetEndpoint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetInsecure">resetInsecure</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetMaxRetries">resetMaxRetries</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetOrganizationId">resetOrganizationId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetPlaintext">resetPlaintext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetServiceAccountKeyFile">resetServiceAccountKeyFile</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetStorageAccessKey">resetStorageAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetStorageEndpoint">resetStorageEndpoint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetStorageSecretKey">resetStorageSecretKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetToken">resetToken</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetYmqAccessKey">resetYmqAccessKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetYmqEndpoint">resetYmqEndpoint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetYmqSecretKey">resetYmqSecretKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.resetZone">resetZone</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YandexProvider.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.YandexProvider.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.YandexProvider.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YandexProvider.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.YandexProvider.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.YandexProvider.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.YandexProvider.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.YandexProvider.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.YandexProvider.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `resetAlias` <a name="resetAlias" id="@cdktf/provider-yandex.YandexProvider.resetAlias"></a>

```typescript
public resetAlias(): void
```

##### `resetCloudId` <a name="resetCloudId" id="@cdktf/provider-yandex.YandexProvider.resetCloudId"></a>

```typescript
public resetCloudId(): void
```

##### `resetEndpoint` <a name="resetEndpoint" id="@cdktf/provider-yandex.YandexProvider.resetEndpoint"></a>

```typescript
public resetEndpoint(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.YandexProvider.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetInsecure` <a name="resetInsecure" id="@cdktf/provider-yandex.YandexProvider.resetInsecure"></a>

```typescript
public resetInsecure(): void
```

##### `resetMaxRetries` <a name="resetMaxRetries" id="@cdktf/provider-yandex.YandexProvider.resetMaxRetries"></a>

```typescript
public resetMaxRetries(): void
```

##### `resetOrganizationId` <a name="resetOrganizationId" id="@cdktf/provider-yandex.YandexProvider.resetOrganizationId"></a>

```typescript
public resetOrganizationId(): void
```

##### `resetPlaintext` <a name="resetPlaintext" id="@cdktf/provider-yandex.YandexProvider.resetPlaintext"></a>

```typescript
public resetPlaintext(): void
```

##### `resetServiceAccountKeyFile` <a name="resetServiceAccountKeyFile" id="@cdktf/provider-yandex.YandexProvider.resetServiceAccountKeyFile"></a>

```typescript
public resetServiceAccountKeyFile(): void
```

##### `resetStorageAccessKey` <a name="resetStorageAccessKey" id="@cdktf/provider-yandex.YandexProvider.resetStorageAccessKey"></a>

```typescript
public resetStorageAccessKey(): void
```

##### `resetStorageEndpoint` <a name="resetStorageEndpoint" id="@cdktf/provider-yandex.YandexProvider.resetStorageEndpoint"></a>

```typescript
public resetStorageEndpoint(): void
```

##### `resetStorageSecretKey` <a name="resetStorageSecretKey" id="@cdktf/provider-yandex.YandexProvider.resetStorageSecretKey"></a>

```typescript
public resetStorageSecretKey(): void
```

##### `resetToken` <a name="resetToken" id="@cdktf/provider-yandex.YandexProvider.resetToken"></a>

```typescript
public resetToken(): void
```

##### `resetYmqAccessKey` <a name="resetYmqAccessKey" id="@cdktf/provider-yandex.YandexProvider.resetYmqAccessKey"></a>

```typescript
public resetYmqAccessKey(): void
```

##### `resetYmqEndpoint` <a name="resetYmqEndpoint" id="@cdktf/provider-yandex.YandexProvider.resetYmqEndpoint"></a>

```typescript
public resetYmqEndpoint(): void
```

##### `resetYmqSecretKey` <a name="resetYmqSecretKey" id="@cdktf/provider-yandex.YandexProvider.resetYmqSecretKey"></a>

```typescript
public resetYmqSecretKey(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.YandexProvider.resetZone"></a>

```typescript
public resetZone(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.YandexProvider.isConstruct"></a>

```typescript
import { YandexProvider } from '@cdktf/provider-yandex'

YandexProvider.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.YandexProvider.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.metaAttributes">metaAttributes</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.terraformProviderSource">terraformProviderSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.aliasInput">aliasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.cloudIdInput">cloudIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.endpointInput">endpointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.insecureInput">insecureInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.maxRetriesInput">maxRetriesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.organizationIdInput">organizationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.plaintextInput">plaintextInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.serviceAccountKeyFileInput">serviceAccountKeyFileInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageAccessKeyInput">storageAccessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageEndpointInput">storageEndpointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageSecretKeyInput">storageSecretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.tokenInput">tokenInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqAccessKeyInput">ymqAccessKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqEndpointInput">ymqEndpointInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqSecretKeyInput">ymqSecretKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.cloudId">cloudId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.endpoint">endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.insecure">insecure</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.maxRetries">maxRetries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.organizationId">organizationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.plaintext">plaintext</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.serviceAccountKeyFile">serviceAccountKeyFile</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageAccessKey">storageAccessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageEndpoint">storageEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.storageSecretKey">storageSecretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.token">token</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqAccessKey">ymqAccessKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqEndpoint">ymqEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.ymqSecretKey">ymqSecretKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.zone">zone</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.YandexProvider.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.YandexProvider.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YandexProvider.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.YandexProvider.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `metaAttributes`<sup>Required</sup> <a name="metaAttributes" id="@cdktf/provider-yandex.YandexProvider.property.metaAttributes"></a>

```typescript
public readonly metaAttributes: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.YandexProvider.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.YandexProvider.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `terraformProviderSource`<sup>Optional</sup> <a name="terraformProviderSource" id="@cdktf/provider-yandex.YandexProvider.property.terraformProviderSource"></a>

```typescript
public readonly terraformProviderSource: string;
```

- *Type:* string

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@cdktf/provider-yandex.YandexProvider.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `aliasInput`<sup>Optional</sup> <a name="aliasInput" id="@cdktf/provider-yandex.YandexProvider.property.aliasInput"></a>

```typescript
public readonly aliasInput: string;
```

- *Type:* string

---

##### `cloudIdInput`<sup>Optional</sup> <a name="cloudIdInput" id="@cdktf/provider-yandex.YandexProvider.property.cloudIdInput"></a>

```typescript
public readonly cloudIdInput: string;
```

- *Type:* string

---

##### `endpointInput`<sup>Optional</sup> <a name="endpointInput" id="@cdktf/provider-yandex.YandexProvider.property.endpointInput"></a>

```typescript
public readonly endpointInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.YandexProvider.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `insecureInput`<sup>Optional</sup> <a name="insecureInput" id="@cdktf/provider-yandex.YandexProvider.property.insecureInput"></a>

```typescript
public readonly insecureInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maxRetriesInput`<sup>Optional</sup> <a name="maxRetriesInput" id="@cdktf/provider-yandex.YandexProvider.property.maxRetriesInput"></a>

```typescript
public readonly maxRetriesInput: number;
```

- *Type:* number

---

##### `organizationIdInput`<sup>Optional</sup> <a name="organizationIdInput" id="@cdktf/provider-yandex.YandexProvider.property.organizationIdInput"></a>

```typescript
public readonly organizationIdInput: string;
```

- *Type:* string

---

##### `plaintextInput`<sup>Optional</sup> <a name="plaintextInput" id="@cdktf/provider-yandex.YandexProvider.property.plaintextInput"></a>

```typescript
public readonly plaintextInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serviceAccountKeyFileInput`<sup>Optional</sup> <a name="serviceAccountKeyFileInput" id="@cdktf/provider-yandex.YandexProvider.property.serviceAccountKeyFileInput"></a>

```typescript
public readonly serviceAccountKeyFileInput: string;
```

- *Type:* string

---

##### `storageAccessKeyInput`<sup>Optional</sup> <a name="storageAccessKeyInput" id="@cdktf/provider-yandex.YandexProvider.property.storageAccessKeyInput"></a>

```typescript
public readonly storageAccessKeyInput: string;
```

- *Type:* string

---

##### `storageEndpointInput`<sup>Optional</sup> <a name="storageEndpointInput" id="@cdktf/provider-yandex.YandexProvider.property.storageEndpointInput"></a>

```typescript
public readonly storageEndpointInput: string;
```

- *Type:* string

---

##### `storageSecretKeyInput`<sup>Optional</sup> <a name="storageSecretKeyInput" id="@cdktf/provider-yandex.YandexProvider.property.storageSecretKeyInput"></a>

```typescript
public readonly storageSecretKeyInput: string;
```

- *Type:* string

---

##### `tokenInput`<sup>Optional</sup> <a name="tokenInput" id="@cdktf/provider-yandex.YandexProvider.property.tokenInput"></a>

```typescript
public readonly tokenInput: string;
```

- *Type:* string

---

##### `ymqAccessKeyInput`<sup>Optional</sup> <a name="ymqAccessKeyInput" id="@cdktf/provider-yandex.YandexProvider.property.ymqAccessKeyInput"></a>

```typescript
public readonly ymqAccessKeyInput: string;
```

- *Type:* string

---

##### `ymqEndpointInput`<sup>Optional</sup> <a name="ymqEndpointInput" id="@cdktf/provider-yandex.YandexProvider.property.ymqEndpointInput"></a>

```typescript
public readonly ymqEndpointInput: string;
```

- *Type:* string

---

##### `ymqSecretKeyInput`<sup>Optional</sup> <a name="ymqSecretKeyInput" id="@cdktf/provider-yandex.YandexProvider.property.ymqSecretKeyInput"></a>

```typescript
public readonly ymqSecretKeyInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.YandexProvider.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="@cdktf/provider-yandex.YandexProvider.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="@cdktf/provider-yandex.YandexProvider.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.YandexProvider.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `insecure`<sup>Optional</sup> <a name="insecure" id="@cdktf/provider-yandex.YandexProvider.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maxRetries`<sup>Optional</sup> <a name="maxRetries" id="@cdktf/provider-yandex.YandexProvider.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* number

---

##### `organizationId`<sup>Optional</sup> <a name="organizationId" id="@cdktf/provider-yandex.YandexProvider.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

---

##### `plaintext`<sup>Optional</sup> <a name="plaintext" id="@cdktf/provider-yandex.YandexProvider.property.plaintext"></a>

```typescript
public readonly plaintext: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serviceAccountKeyFile`<sup>Optional</sup> <a name="serviceAccountKeyFile" id="@cdktf/provider-yandex.YandexProvider.property.serviceAccountKeyFile"></a>

```typescript
public readonly serviceAccountKeyFile: string;
```

- *Type:* string

---

##### `storageAccessKey`<sup>Optional</sup> <a name="storageAccessKey" id="@cdktf/provider-yandex.YandexProvider.property.storageAccessKey"></a>

```typescript
public readonly storageAccessKey: string;
```

- *Type:* string

---

##### `storageEndpoint`<sup>Optional</sup> <a name="storageEndpoint" id="@cdktf/provider-yandex.YandexProvider.property.storageEndpoint"></a>

```typescript
public readonly storageEndpoint: string;
```

- *Type:* string

---

##### `storageSecretKey`<sup>Optional</sup> <a name="storageSecretKey" id="@cdktf/provider-yandex.YandexProvider.property.storageSecretKey"></a>

```typescript
public readonly storageSecretKey: string;
```

- *Type:* string

---

##### `token`<sup>Optional</sup> <a name="token" id="@cdktf/provider-yandex.YandexProvider.property.token"></a>

```typescript
public readonly token: string;
```

- *Type:* string

---

##### `ymqAccessKey`<sup>Optional</sup> <a name="ymqAccessKey" id="@cdktf/provider-yandex.YandexProvider.property.ymqAccessKey"></a>

```typescript
public readonly ymqAccessKey: string;
```

- *Type:* string

---

##### `ymqEndpoint`<sup>Optional</sup> <a name="ymqEndpoint" id="@cdktf/provider-yandex.YandexProvider.property.ymqEndpoint"></a>

```typescript
public readonly ymqEndpoint: string;
```

- *Type:* string

---

##### `ymqSecretKey`<sup>Optional</sup> <a name="ymqSecretKey" id="@cdktf/provider-yandex.YandexProvider.property.ymqSecretKey"></a>

```typescript
public readonly ymqSecretKey: string;
```

- *Type:* string

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.YandexProvider.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProvider.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.YandexProvider.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### YdbDatabaseDedicated <a name="YdbDatabaseDedicated" id="@cdktf/provider-yandex.YdbDatabaseDedicated"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated yandex_ydb_database_dedicated}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer"></a>

```typescript
import { YdbDatabaseDedicated } from '@cdktf/provider-yandex'

new YdbDatabaseDedicated(scope: Construct, id: string, config: YdbDatabaseDedicatedConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig">YdbDatabaseDedicatedConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.YdbDatabaseDedicated.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig">YdbDatabaseDedicatedConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.putLocation">putLocation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.putScalePolicy">putScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.putStorageConfig">putStorageConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetAssignPublicIps">resetAssignPublicIps</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetLocation">resetLocation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetLocationId">resetLocationId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicated.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.YdbDatabaseDedicated.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.YdbDatabaseDedicated.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicated.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.YdbDatabaseDedicated.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.YdbDatabaseDedicated.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicated.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putLocation` <a name="putLocation" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putLocation"></a>

```typescript
public putLocation(value: YdbDatabaseDedicatedLocation): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putLocation.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a>

---

##### `putScalePolicy` <a name="putScalePolicy" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putScalePolicy"></a>

```typescript
public putScalePolicy(value: YdbDatabaseDedicatedScalePolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putScalePolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a>

---

##### `putStorageConfig` <a name="putStorageConfig" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putStorageConfig"></a>

```typescript
public putStorageConfig(value: YdbDatabaseDedicatedStorageConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putStorageConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a>

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putTimeouts"></a>

```typescript
public putTimeouts(value: YdbDatabaseDedicatedTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicated.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a>

---

##### `resetAssignPublicIps` <a name="resetAssignPublicIps" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetAssignPublicIps"></a>

```typescript
public resetAssignPublicIps(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetLocation` <a name="resetLocation" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetLocation"></a>

```typescript
public resetLocation(): void
```

##### `resetLocationId` <a name="resetLocationId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetLocationId"></a>

```typescript
public resetLocationId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.YdbDatabaseDedicated.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.YdbDatabaseDedicated.isConstruct"></a>

```typescript
import { YdbDatabaseDedicated } from '@cdktf/provider-yandex'

YdbDatabaseDedicated.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.YdbDatabaseDedicated.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.databasePath">databasePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference">YdbDatabaseDedicatedLocationOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference">YdbDatabaseDedicatedScalePolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.storageConfig">storageConfig</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference">YdbDatabaseDedicatedStorageConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference">YdbDatabaseDedicatedTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.tlsEnabled">tlsEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.ydbApiEndpoint">ydbApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.ydbFullEndpoint">ydbFullEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.assignPublicIpsInput">assignPublicIpsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationIdInput">locationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationInput">locationInput</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.scalePolicyInput">scalePolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.storageConfigInput">storageConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.subnetIdsInput">subnetIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.assignPublicIps">assignPublicIps</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationId">locationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `databasePath`<sup>Required</sup> <a name="databasePath" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.databasePath"></a>

```typescript
public readonly databasePath: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.location"></a>

```typescript
public readonly location: YdbDatabaseDedicatedLocationOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference">YdbDatabaseDedicatedLocationOutputReference</a>

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: YdbDatabaseDedicatedScalePolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference">YdbDatabaseDedicatedScalePolicyOutputReference</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `storageConfig`<sup>Required</sup> <a name="storageConfig" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.storageConfig"></a>

```typescript
public readonly storageConfig: YdbDatabaseDedicatedStorageConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference">YdbDatabaseDedicatedStorageConfigOutputReference</a>

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.timeouts"></a>

```typescript
public readonly timeouts: YdbDatabaseDedicatedTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference">YdbDatabaseDedicatedTimeoutsOutputReference</a>

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ydbApiEndpoint`<sup>Required</sup> <a name="ydbApiEndpoint" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.ydbApiEndpoint"></a>

```typescript
public readonly ydbApiEndpoint: string;
```

- *Type:* string

---

##### `ydbFullEndpoint`<sup>Required</sup> <a name="ydbFullEndpoint" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.ydbFullEndpoint"></a>

```typescript
public readonly ydbFullEndpoint: string;
```

- *Type:* string

---

##### `assignPublicIpsInput`<sup>Optional</sup> <a name="assignPublicIpsInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.assignPublicIpsInput"></a>

```typescript
public readonly assignPublicIpsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `locationIdInput`<sup>Optional</sup> <a name="locationIdInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationIdInput"></a>

```typescript
public readonly locationIdInput: string;
```

- *Type:* string

---

##### `locationInput`<sup>Optional</sup> <a name="locationInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationInput"></a>

```typescript
public readonly locationInput: YdbDatabaseDedicatedLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `scalePolicyInput`<sup>Optional</sup> <a name="scalePolicyInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.scalePolicyInput"></a>

```typescript
public readonly scalePolicyInput: YdbDatabaseDedicatedScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a>

---

##### `storageConfigInput`<sup>Optional</sup> <a name="storageConfigInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.storageConfigInput"></a>

```typescript
public readonly storageConfigInput: YdbDatabaseDedicatedStorageConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a>

---

##### `subnetIdsInput`<sup>Optional</sup> <a name="subnetIdsInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.subnetIdsInput"></a>

```typescript
public readonly subnetIdsInput: string[];
```

- *Type:* string[]

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | YdbDatabaseDedicatedTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a>

---

##### `assignPublicIps`<sup>Required</sup> <a name="assignPublicIps" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.assignPublicIps"></a>

```typescript
public readonly assignPublicIps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `locationId`<sup>Required</sup> <a name="locationId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicated.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.YdbDatabaseDedicated.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

### YdbDatabaseServerless <a name="YdbDatabaseServerless" id="@cdktf/provider-yandex.YdbDatabaseServerless"></a>

Represents a {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless yandex_ydb_database_serverless}.

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseServerless.Initializer"></a>

```typescript
import { YdbDatabaseServerless } from '@cdktf/provider-yandex'

new YdbDatabaseServerless(scope: Construct, id: string, config: YdbDatabaseServerlessConfig)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | The scope in which to define this construct. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.id">id</a></code> | <code>string</code> | The scoped construct ID. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig">YdbDatabaseServerlessConfig</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

The scope in which to define this construct.

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.id"></a>

- *Type:* string

The scoped construct ID.

Must be unique amongst siblings in the same scope

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.YdbDatabaseServerless.Initializer.parameter.config"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig">YdbDatabaseServerlessConfig</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.addOverride">addOverride</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.overrideLogicalId">overrideLogicalId</a></code> | Overrides the auto-generated logical ID with a specific ID. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.toMetadata">toMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.toTerraform">toTerraform</a></code> | Adds this resource to the terraform JSON output. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.putTimeouts">putTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetLocationId">resetLocationId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.resetTimeouts">resetTimeouts</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseServerless.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addOverride` <a name="addOverride" id="@cdktf/provider-yandex.YdbDatabaseServerless.addOverride"></a>

```typescript
public addOverride(path: string, value: any): void
```

###### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.YdbDatabaseServerless.addOverride.parameter.path"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseServerless.addOverride.parameter.value"></a>

- *Type:* any

---

##### `overrideLogicalId` <a name="overrideLogicalId" id="@cdktf/provider-yandex.YdbDatabaseServerless.overrideLogicalId"></a>

```typescript
public overrideLogicalId(newLogicalId: string): void
```

Overrides the auto-generated logical ID with a specific ID.

###### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="@cdktf/provider-yandex.YdbDatabaseServerless.overrideLogicalId.parameter.newLogicalId"></a>

- *Type:* string

The new logical ID to use for this stack element.

---

##### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetOverrideLogicalId"></a>

```typescript
public resetOverrideLogicalId(): void
```

Resets a previously passed logical Id to use the auto-generated logical id again.

##### `toMetadata` <a name="toMetadata" id="@cdktf/provider-yandex.YdbDatabaseServerless.toMetadata"></a>

```typescript
public toMetadata(): any
```

##### `toTerraform` <a name="toTerraform" id="@cdktf/provider-yandex.YdbDatabaseServerless.toTerraform"></a>

```typescript
public toTerraform(): any
```

Adds this resource to the terraform JSON output.

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerless.interpolationForAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `putTimeouts` <a name="putTimeouts" id="@cdktf/provider-yandex.YdbDatabaseServerless.putTimeouts"></a>

```typescript
public putTimeouts(value: YdbDatabaseServerlessTimeouts): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseServerless.putTimeouts.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a>

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetId"></a>

```typescript
public resetId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetLocationId` <a name="resetLocationId" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetLocationId"></a>

```typescript
public resetLocationId(): void
```

##### `resetTimeouts` <a name="resetTimeouts" id="@cdktf/provider-yandex.YdbDatabaseServerless.resetTimeouts"></a>

```typescript
public resetTimeouts(): void
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="@cdktf/provider-yandex.YdbDatabaseServerless.isConstruct"></a>

```typescript
import { YdbDatabaseServerless } from '@cdktf/provider-yandex'

YdbDatabaseServerless.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="@cdktf/provider-yandex.YdbDatabaseServerless.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.cdktfStack">cdktfStack</a></code> | <code>cdktf.TerraformStack</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformMetaArguments">terraformMetaArguments</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformResourceType">terraformResourceType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformGeneratorMetadata">terraformGeneratorMetadata</a></code> | <code>cdktf.TerraformProviderGeneratorMetadata</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.dependsOn">dependsOn</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.createdAt">createdAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.databasePath">databasePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.documentApiEndpoint">documentApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference">YdbDatabaseServerlessTimeoutsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.tlsEnabled">tlsEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.ydbApiEndpoint">ydbApiEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.ydbFullEndpoint">ydbFullEndpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.locationIdInput">locationIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.timeoutsInput">timeoutsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.locationId">locationId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.cdktfStack"></a>

```typescript
public readonly cdktfStack: TerraformStack;
```

- *Type:* cdktf.TerraformStack

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.friendlyUniqueId"></a>

```typescript
public readonly friendlyUniqueId: string;
```

- *Type:* string

---

##### `terraformMetaArguments`<sup>Required</sup> <a name="terraformMetaArguments" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformMetaArguments"></a>

```typescript
public readonly terraformMetaArguments: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `terraformResourceType`<sup>Required</sup> <a name="terraformResourceType" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformResourceType"></a>

```typescript
public readonly terraformResourceType: string;
```

- *Type:* string

---

##### `terraformGeneratorMetadata`<sup>Optional</sup> <a name="terraformGeneratorMetadata" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.terraformGeneratorMetadata"></a>

```typescript
public readonly terraformGeneratorMetadata: TerraformProviderGeneratorMetadata;
```

- *Type:* cdktf.TerraformProviderGeneratorMetadata

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.dependsOn"></a>

```typescript
public readonly dependsOn: string[];
```

- *Type:* string[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `createdAt`<sup>Required</sup> <a name="createdAt" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.createdAt"></a>

```typescript
public readonly createdAt: string;
```

- *Type:* string

---

##### `databasePath`<sup>Required</sup> <a name="databasePath" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.databasePath"></a>

```typescript
public readonly databasePath: string;
```

- *Type:* string

---

##### `documentApiEndpoint`<sup>Required</sup> <a name="documentApiEndpoint" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.documentApiEndpoint"></a>

```typescript
public readonly documentApiEndpoint: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `timeouts`<sup>Required</sup> <a name="timeouts" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.timeouts"></a>

```typescript
public readonly timeouts: YdbDatabaseServerlessTimeoutsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference">YdbDatabaseServerlessTimeoutsOutputReference</a>

---

##### `tlsEnabled`<sup>Required</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ydbApiEndpoint`<sup>Required</sup> <a name="ydbApiEndpoint" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.ydbApiEndpoint"></a>

```typescript
public readonly ydbApiEndpoint: string;
```

- *Type:* string

---

##### `ydbFullEndpoint`<sup>Required</sup> <a name="ydbFullEndpoint" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.ydbFullEndpoint"></a>

```typescript
public readonly ydbFullEndpoint: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `locationIdInput`<sup>Optional</sup> <a name="locationIdInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.locationIdInput"></a>

```typescript
public readonly locationIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `timeoutsInput`<sup>Optional</sup> <a name="timeoutsInput" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.timeoutsInput"></a>

```typescript
public readonly timeoutsInput: IResolvable | YdbDatabaseServerlessTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `locationId`<sup>Required</sup> <a name="locationId" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerless.property.tfResourceType">tfResourceType</a></code> | <code>string</code> | *No description.* |

---

##### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="@cdktf/provider-yandex.YdbDatabaseServerless.property.tfResourceType"></a>

```typescript
public readonly tfResourceType: string;
```

- *Type:* string

---

## Structs <a name="Structs" id="Structs"></a>

### AlbBackendGroupConfig <a name="AlbBackendGroupConfig" id="@cdktf/provider-yandex.AlbBackendGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupConfig.Initializer"></a>

```typescript
import { AlbBackendGroupConfig } from '@cdktf/provider-yandex'

const albBackendGroupConfig: AlbBackendGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#description AlbBackendGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#folder_id AlbBackendGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.grpcBackend">grpcBackend</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] \| cdktf.IResolvable</code> | grpc_backend block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.httpBackend">httpBackend</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]</code> | http_backend block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#id AlbBackendGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#labels AlbBackendGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.streamBackend">streamBackend</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]</code> | stream_backend block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#description AlbBackendGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#folder_id AlbBackendGroup#folder_id}.

---

##### `grpcBackend`<sup>Optional</sup> <a name="grpcBackend" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.grpcBackend"></a>

```typescript
public readonly grpcBackend: AlbBackendGroupGrpcBackend[] | IResolvable;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] | cdktf.IResolvable

grpc_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_backend AlbBackendGroup#grpc_backend}

---

##### `httpBackend`<sup>Optional</sup> <a name="httpBackend" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.httpBackend"></a>

```typescript
public readonly httpBackend: IResolvable | AlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]

http_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_backend AlbBackendGroup#http_backend}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#id AlbBackendGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#labels AlbBackendGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}.

---

##### `streamBackend`<sup>Optional</sup> <a name="streamBackend" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.streamBackend"></a>

```typescript
public readonly streamBackend: IResolvable | AlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]

stream_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_backend AlbBackendGroup#stream_backend}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbBackendGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: AlbBackendGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeouts AlbBackendGroup#timeouts}

---

### AlbBackendGroupGrpcBackend <a name="AlbBackendGroupGrpcBackend" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackend } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackend: AlbBackendGroupGrpcBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}.

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}.

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}.

---

### AlbBackendGroupGrpcBackendHealthcheck <a name="AlbBackendGroupGrpcBackendHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendHealthcheck: AlbBackendGroupGrpcBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.interval">interval</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.timeout">timeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}. |

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}.

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}.

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}.

---

### AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck <a name="AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendHealthcheckGrpcHealthcheck: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}.

---

### AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck <a name="AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendHealthcheckHttpHealthcheck: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.path">path</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}. |

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}.

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}.

---

### AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck <a name="AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendHealthcheckStreamHealthcheck: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}.

---

### AlbBackendGroupGrpcBackendLoadBalancingConfig <a name="AlbBackendGroupGrpcBackendLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendLoadBalancingConfig: AlbBackendGroupGrpcBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}.

---

### AlbBackendGroupGrpcBackendTls <a name="AlbBackendGroupGrpcBackendTls" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendTls } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendTls: AlbBackendGroupGrpcBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}

---

### AlbBackendGroupGrpcBackendTlsValidationContext <a name="AlbBackendGroupGrpcBackendTlsValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendTlsValidationContext } from '@cdktf/provider-yandex'

const albBackendGroupGrpcBackendTlsValidationContext: AlbBackendGroupGrpcBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}.

---

### AlbBackendGroupHttpBackend <a name="AlbBackendGroupHttpBackend" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackend } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackend: AlbBackendGroupHttpBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.storageBucket">storageBucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#storage_bucket AlbBackendGroup#storage_bucket}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}.

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}.

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}.

---

##### `storageBucket`<sup>Optional</sup> <a name="storageBucket" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.storageBucket"></a>

```typescript
public readonly storageBucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#storage_bucket AlbBackendGroup#storage_bucket}.

---

##### `targetGroupIds`<sup>Optional</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}.

---

### AlbBackendGroupHttpBackendHealthcheck <a name="AlbBackendGroupHttpBackendHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendHealthcheck: AlbBackendGroupHttpBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.interval">interval</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.timeout">timeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}. |

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}.

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}.

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}.

---

### AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck <a name="AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendHealthcheckGrpcHealthcheck: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}.

---

### AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck <a name="AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendHealthcheckHttpHealthcheck: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.path">path</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}. |

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}.

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}.

---

### AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck <a name="AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendHealthcheckStreamHealthcheck: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}.

---

### AlbBackendGroupHttpBackendLoadBalancingConfig <a name="AlbBackendGroupHttpBackendLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendLoadBalancingConfig: AlbBackendGroupHttpBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}.

---

### AlbBackendGroupHttpBackendTls <a name="AlbBackendGroupHttpBackendTls" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendTls } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendTls: AlbBackendGroupHttpBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}

---

### AlbBackendGroupHttpBackendTlsValidationContext <a name="AlbBackendGroupHttpBackendTlsValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendTlsValidationContext } from '@cdktf/provider-yandex'

const albBackendGroupHttpBackendTlsValidationContext: AlbBackendGroupHttpBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}.

---

### AlbBackendGroupStreamBackend <a name="AlbBackendGroupStreamBackend" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackend } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackend: AlbBackendGroupStreamBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#name AlbBackendGroup#name}.

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#target_group_ids AlbBackendGroup#target_group_ids}.

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck AlbBackendGroup#healthcheck}

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#load_balancing_config AlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#port AlbBackendGroup#port}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#tls AlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#weight AlbBackendGroup#weight}.

---

### AlbBackendGroupStreamBackendHealthcheck <a name="AlbBackendGroupStreamBackendHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendHealthcheck: AlbBackendGroupStreamBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.interval">interval</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.timeout">timeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}. |

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval AlbBackendGroup#interval}.

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#timeout AlbBackendGroup#timeout}.

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#grpc_healthcheck AlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthcheck_port AlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#healthy_threshold AlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http_healthcheck AlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#interval_jitter_percent AlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#stream_healthcheck AlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#unhealthy_threshold AlbBackendGroup#unhealthy_threshold}.

---

### AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck <a name="AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendHealthcheckGrpcHealthcheck: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#service_name AlbBackendGroup#service_name}.

---

### AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck <a name="AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendHealthcheckHttpHealthcheck: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.path">path</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}. |

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#path AlbBackendGroup#path}.

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#host AlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#http2 AlbBackendGroup#http2}.

---

### AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck <a name="AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendHealthcheckStreamHealthcheck: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#receive AlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#send AlbBackendGroup#send}.

---

### AlbBackendGroupStreamBackendLoadBalancingConfig <a name="AlbBackendGroupStreamBackendLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendLoadBalancingConfig: AlbBackendGroupStreamBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#locality_aware_routing_percent AlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#panic_threshold AlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#strict_locality AlbBackendGroup#strict_locality}.

---

### AlbBackendGroupStreamBackendTls <a name="AlbBackendGroupStreamBackendTls" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendTls } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendTls: AlbBackendGroupStreamBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#sni AlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#validation_context AlbBackendGroup#validation_context}

---

### AlbBackendGroupStreamBackendTlsValidationContext <a name="AlbBackendGroupStreamBackendTlsValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendTlsValidationContext } from '@cdktf/provider-yandex'

const albBackendGroupStreamBackendTlsValidationContext: AlbBackendGroupStreamBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_bytes AlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#trusted_ca_id AlbBackendGroup#trusted_ca_id}.

---

### AlbBackendGroupTimeouts <a name="AlbBackendGroupTimeouts" id="@cdktf/provider-yandex.AlbBackendGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbBackendGroupTimeouts.Initializer"></a>

```typescript
import { AlbBackendGroupTimeouts } from '@cdktf/provider-yandex'

const albBackendGroupTimeouts: AlbBackendGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#create AlbBackendGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#delete AlbBackendGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#update AlbBackendGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#create AlbBackendGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#delete AlbBackendGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.AlbBackendGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_backend_group#update AlbBackendGroup#update}.

---

### AlbHttpRouterConfig <a name="AlbHttpRouterConfig" id="@cdktf/provider-yandex.AlbHttpRouterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbHttpRouterConfig.Initializer"></a>

```typescript
import { AlbHttpRouterConfig } from '@cdktf/provider-yandex'

const albHttpRouterConfig: AlbHttpRouterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#description AlbHttpRouter#description}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#folder_id AlbHttpRouter#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#id AlbHttpRouter#id}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#labels AlbHttpRouter#labels}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#name AlbHttpRouter#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#description AlbHttpRouter#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#folder_id AlbHttpRouter#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#id AlbHttpRouter#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#labels AlbHttpRouter#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#name AlbHttpRouter#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbHttpRouterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: AlbHttpRouterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#timeouts AlbHttpRouter#timeouts}

---

### AlbHttpRouterTimeouts <a name="AlbHttpRouterTimeouts" id="@cdktf/provider-yandex.AlbHttpRouterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbHttpRouterTimeouts.Initializer"></a>

```typescript
import { AlbHttpRouterTimeouts } from '@cdktf/provider-yandex'

const albHttpRouterTimeouts: AlbHttpRouterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#create AlbHttpRouter#create}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#delete AlbHttpRouter#delete}. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#update AlbHttpRouter#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#create AlbHttpRouter#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#delete AlbHttpRouter#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.AlbHttpRouterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_http_router#update AlbHttpRouter#update}.

---

### AlbLoadBalancerAllocationPolicy <a name="AlbLoadBalancerAllocationPolicy" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy.Initializer"></a>

```typescript
import { AlbLoadBalancerAllocationPolicy } from '@cdktf/provider-yandex'

const albLoadBalancerAllocationPolicy: AlbLoadBalancerAllocationPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy.property.location">location</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]</code> | location block. |

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy.property.location"></a>

```typescript
public readonly location: IResolvable | AlbLoadBalancerAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]

location block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#location AlbLoadBalancer#location}

---

### AlbLoadBalancerAllocationPolicyLocation <a name="AlbLoadBalancerAllocationPolicyLocation" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.Initializer"></a>

```typescript
import { AlbLoadBalancerAllocationPolicyLocation } from '@cdktf/provider-yandex'

const albLoadBalancerAllocationPolicyLocation: AlbLoadBalancerAllocationPolicyLocation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.zoneId">zoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#zone_id AlbLoadBalancer#zone_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.disableTraffic">disableTraffic</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#disable_traffic AlbLoadBalancer#disable_traffic}. |

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}.

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#zone_id AlbLoadBalancer#zone_id}.

---

##### `disableTraffic`<sup>Optional</sup> <a name="disableTraffic" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation.property.disableTraffic"></a>

```typescript
public readonly disableTraffic: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#disable_traffic AlbLoadBalancer#disable_traffic}.

---

### AlbLoadBalancerConfig <a name="AlbLoadBalancerConfig" id="@cdktf/provider-yandex.AlbLoadBalancerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.Initializer"></a>

```typescript
import { AlbLoadBalancerConfig } from '@cdktf/provider-yandex'

const albLoadBalancerConfig: AlbLoadBalancerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a></code> | allocation_policy block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#network_id AlbLoadBalancer#network_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#description AlbLoadBalancer#description}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#folder_id AlbLoadBalancer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#id AlbLoadBalancer#id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#labels AlbLoadBalancer#labels}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.listener">listener</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]</code> | listener block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.regionId">regionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#region_id AlbLoadBalancer#region_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#security_group_ids AlbLoadBalancer#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: AlbLoadBalancerAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a>

allocation_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allocation_policy AlbLoadBalancer#allocation_policy}

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#network_id AlbLoadBalancer#network_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#description AlbLoadBalancer#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#folder_id AlbLoadBalancer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#id AlbLoadBalancer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#labels AlbLoadBalancer#labels}.

---

##### `listener`<sup>Optional</sup> <a name="listener" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.listener"></a>

```typescript
public readonly listener: IResolvable | AlbLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]

listener block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#listener AlbLoadBalancer#listener}

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}.

---

##### `regionId`<sup>Optional</sup> <a name="regionId" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#region_id AlbLoadBalancer#region_id}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#security_group_ids AlbLoadBalancer#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbLoadBalancerConfig.property.timeouts"></a>

```typescript
public readonly timeouts: AlbLoadBalancerTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#timeouts AlbLoadBalancer#timeouts}

---

### AlbLoadBalancerListener <a name="AlbLoadBalancerListener" id="@cdktf/provider-yandex.AlbLoadBalancerListener"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListener.Initializer"></a>

```typescript
import { AlbLoadBalancerListener } from '@cdktf/provider-yandex'

const albLoadBalancerListener: AlbLoadBalancerListener = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListener.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListener.property.endpoint">endpoint</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]</code> | endpoint block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListener.property.http">http</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a></code> | http block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListener.property.stream">stream</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a></code> | stream block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListener.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a></code> | tls block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancerListener.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}.

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="@cdktf/provider-yandex.AlbLoadBalancerListener.property.endpoint"></a>

```typescript
public readonly endpoint: IResolvable | AlbLoadBalancerListenerEndpoint[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]

endpoint block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#endpoint AlbLoadBalancer#endpoint}

---

##### `http`<sup>Optional</sup> <a name="http" id="@cdktf/provider-yandex.AlbLoadBalancerListener.property.http"></a>

```typescript
public readonly http: AlbLoadBalancerListenerHttp;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a>

http block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http AlbLoadBalancer#http}

---

##### `stream`<sup>Optional</sup> <a name="stream" id="@cdktf/provider-yandex.AlbLoadBalancerListener.property.stream"></a>

```typescript
public readonly stream: AlbLoadBalancerListenerStream;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a>

stream block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream AlbLoadBalancer#stream}

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.AlbLoadBalancerListener.property.tls"></a>

```typescript
public readonly tls: AlbLoadBalancerListenerTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#tls AlbLoadBalancer#tls}

---

### AlbLoadBalancerListenerEndpoint <a name="AlbLoadBalancerListenerEndpoint" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpoint } from '@cdktf/provider-yandex'

const albLoadBalancerListenerEndpoint: AlbLoadBalancerListenerEndpoint = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint.property.address">address</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]</code> | address block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint.property.ports">ports</a></code> | <code>number[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#ports AlbLoadBalancer#ports}. |

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint.property.address"></a>

```typescript
public readonly address: IResolvable | AlbLoadBalancerListenerEndpointAddress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]

address block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}

---

##### `ports`<sup>Required</sup> <a name="ports" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint.property.ports"></a>

```typescript
public readonly ports: number[];
```

- *Type:* number[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#ports AlbLoadBalancer#ports}.

---

### AlbLoadBalancerListenerEndpointAddress <a name="AlbLoadBalancerListenerEndpointAddress" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddress } from '@cdktf/provider-yandex'

const albLoadBalancerListenerEndpointAddress: AlbLoadBalancerListenerEndpointAddress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a></code> | external_ipv4_address block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.externalIpv6Address">externalIpv6Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a></code> | external_ipv6_address block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.internalIpv4Address">internalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a></code> | internal_ipv4_address block. |

---

##### `externalIpv4Address`<sup>Optional</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a>

external_ipv4_address block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#external_ipv4_address AlbLoadBalancer#external_ipv4_address}

---

##### `externalIpv6Address`<sup>Optional</sup> <a name="externalIpv6Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.externalIpv6Address"></a>

```typescript
public readonly externalIpv6Address: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a>

external_ipv6_address block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#external_ipv6_address AlbLoadBalancer#external_ipv6_address}

---

##### `internalIpv4Address`<sup>Optional</sup> <a name="internalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress.property.internalIpv4Address"></a>

```typescript
public readonly internalIpv4Address: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a>

internal_ipv4_address block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#internal_ipv4_address AlbLoadBalancer#internal_ipv4_address}

---

### AlbLoadBalancerListenerEndpointAddressExternalIpv4Address <a name="AlbLoadBalancerListenerEndpointAddressExternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressExternalIpv4Address } from '@cdktf/provider-yandex'

const albLoadBalancerListenerEndpointAddressExternalIpv4Address: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}.

---

### AlbLoadBalancerListenerEndpointAddressExternalIpv6Address <a name="AlbLoadBalancerListenerEndpointAddressExternalIpv6Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressExternalIpv6Address } from '@cdktf/provider-yandex'

const albLoadBalancerListenerEndpointAddressExternalIpv6Address: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}.

---

### AlbLoadBalancerListenerEndpointAddressInternalIpv4Address <a name="AlbLoadBalancerListenerEndpointAddressInternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressInternalIpv4Address } from '@cdktf/provider-yandex'

const albLoadBalancerListenerEndpointAddressInternalIpv4Address: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#address AlbLoadBalancer#address}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#subnet_id AlbLoadBalancer#subnet_id}.

---

### AlbLoadBalancerListenerHttp <a name="AlbLoadBalancerListenerHttp" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttp"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttp.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttp } from '@cdktf/provider-yandex'

const albLoadBalancerListenerHttp: AlbLoadBalancerListenerHttp = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a></code> | handler block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp.property.redirects">redirects</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a></code> | redirects block. |

---

##### `handler`<sup>Optional</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttp.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a>

handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}

---

##### `redirects`<sup>Optional</sup> <a name="redirects" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttp.property.redirects"></a>

```typescript
public readonly redirects: AlbLoadBalancerListenerHttpRedirects;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a>

redirects block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#redirects AlbLoadBalancer#redirects}

---

### AlbLoadBalancerListenerHttpHandler <a name="AlbLoadBalancerListenerHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerHttpHandler: AlbLoadBalancerListenerHttpHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a></code> | http2_options block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}. |

---

##### `allowHttp10`<sup>Optional</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}.

---

##### `http2Options`<sup>Optional</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a>

http2_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}

---

##### `httpRouterId`<sup>Optional</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}.

---

### AlbLoadBalancerListenerHttpHandlerHttp2Options <a name="AlbLoadBalancerListenerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const albLoadBalancerListenerHttpHandlerHttp2Options: AlbLoadBalancerListenerHttpHandlerHttp2Options = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}. |

---

##### `maxConcurrentStreams`<sup>Optional</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}.

---

### AlbLoadBalancerListenerHttpRedirects <a name="AlbLoadBalancerListenerHttpRedirects" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpRedirects } from '@cdktf/provider-yandex'

const albLoadBalancerListenerHttpRedirects: AlbLoadBalancerListenerHttpRedirects = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects.property.httpToHttps">httpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_to_https AlbLoadBalancer#http_to_https}. |

---

##### `httpToHttps`<sup>Optional</sup> <a name="httpToHttps" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects.property.httpToHttps"></a>

```typescript
public readonly httpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_to_https AlbLoadBalancer#http_to_https}.

---

### AlbLoadBalancerListenerStream <a name="AlbLoadBalancerListenerStream" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStream"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStream.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerStream } from '@cdktf/provider-yandex'

const albLoadBalancerListenerStream: AlbLoadBalancerListenerStream = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a></code> | handler block. |

---

##### `handler`<sup>Optional</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStream.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a>

handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}

---

### AlbLoadBalancerListenerStreamHandler <a name="AlbLoadBalancerListenerStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerStreamHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerStreamHandler: AlbLoadBalancerListenerStreamHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}. |

---

##### `backendGroupId`<sup>Optional</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}.

---

### AlbLoadBalancerListenerTls <a name="AlbLoadBalancerListenerTls" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTls.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTls } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTls: AlbLoadBalancerListenerTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls.property.defaultHandler">defaultHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a></code> | default_handler block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls.property.sniHandler">sniHandler</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]</code> | sni_handler block. |

---

##### `defaultHandler`<sup>Required</sup> <a name="defaultHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTls.property.defaultHandler"></a>

```typescript
public readonly defaultHandler: AlbLoadBalancerListenerTlsDefaultHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a>

default_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#default_handler AlbLoadBalancer#default_handler}

---

##### `sniHandler`<sup>Optional</sup> <a name="sniHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTls.property.sniHandler"></a>

```typescript
public readonly sniHandler: IResolvable | AlbLoadBalancerListenerTlsSniHandler[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]

sni_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#sni_handler AlbLoadBalancer#sni_handler}

---

### AlbLoadBalancerListenerTlsDefaultHandler <a name="AlbLoadBalancerListenerTlsDefaultHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsDefaultHandler: AlbLoadBalancerListenerTlsDefaultHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a></code> | http_handler block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a></code> | stream_handler block. |

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}.

---

##### `httpHandler`<sup>Optional</sup> <a name="httpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.httpHandler"></a>

```typescript
public readonly httpHandler: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a>

http_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_handler AlbLoadBalancer#http_handler}

---

##### `streamHandler`<sup>Optional</sup> <a name="streamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler.property.streamHandler"></a>

```typescript
public readonly streamHandler: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a>

stream_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream_handler AlbLoadBalancer#stream_handler}

---

### AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler <a name="AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsDefaultHandlerHttpHandler: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a></code> | http2_options block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}. |

---

##### `allowHttp10`<sup>Optional</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}.

---

##### `http2Options`<sup>Optional</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a>

http2_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}

---

##### `httpRouterId`<sup>Optional</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}.

---

### AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options <a name="AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}. |

---

##### `maxConcurrentStreams`<sup>Optional</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}.

---

### AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler <a name="AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsDefaultHandlerStreamHandler: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}. |

---

##### `backendGroupId`<sup>Optional</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}.

---

### AlbLoadBalancerListenerTlsSniHandler <a name="AlbLoadBalancerListenerTlsSniHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsSniHandler: AlbLoadBalancerListenerTlsSniHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a></code> | handler block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.serverNames">serverNames</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#server_names AlbLoadBalancer#server_names}. |

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerTlsSniHandlerHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a>

handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#handler AlbLoadBalancer#handler}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#name AlbLoadBalancer#name}.

---

##### `serverNames`<sup>Required</sup> <a name="serverNames" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler.property.serverNames"></a>

```typescript
public readonly serverNames: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#server_names AlbLoadBalancer#server_names}.

---

### AlbLoadBalancerListenerTlsSniHandlerHandler <a name="AlbLoadBalancerListenerTlsSniHandlerHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsSniHandlerHandler: AlbLoadBalancerListenerTlsSniHandlerHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a></code> | http_handler block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a></code> | stream_handler block. |

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#certificate_ids AlbLoadBalancer#certificate_ids}.

---

##### `httpHandler`<sup>Optional</sup> <a name="httpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.httpHandler"></a>

```typescript
public readonly httpHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a>

http_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_handler AlbLoadBalancer#http_handler}

---

##### `streamHandler`<sup>Optional</sup> <a name="streamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler.property.streamHandler"></a>

```typescript
public readonly streamHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a>

stream_handler block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#stream_handler AlbLoadBalancer#stream_handler}

---

### AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsSniHandlerHandlerHttpHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a></code> | http2_options block. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}. |

---

##### `allowHttp10`<sup>Optional</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#allow_http10 AlbLoadBalancer#allow_http10}.

---

##### `http2Options`<sup>Optional</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a>

http2_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http2_options AlbLoadBalancer#http2_options}

---

##### `httpRouterId`<sup>Optional</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#http_router_id AlbLoadBalancer#http_router_id}.

---

### AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}. |

---

##### `maxConcurrentStreams`<sup>Optional</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#max_concurrent_streams AlbLoadBalancer#max_concurrent_streams}.

---

### AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler } from '@cdktf/provider-yandex'

const albLoadBalancerListenerTlsSniHandlerHandlerStreamHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}. |

---

##### `backendGroupId`<sup>Optional</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#backend_group_id AlbLoadBalancer#backend_group_id}.

---

### AlbLoadBalancerTimeouts <a name="AlbLoadBalancerTimeouts" id="@cdktf/provider-yandex.AlbLoadBalancerTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbLoadBalancerTimeouts.Initializer"></a>

```typescript
import { AlbLoadBalancerTimeouts } from '@cdktf/provider-yandex'

const albLoadBalancerTimeouts: AlbLoadBalancerTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#create AlbLoadBalancer#create}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#delete AlbLoadBalancer#delete}. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#update AlbLoadBalancer#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#create AlbLoadBalancer#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#delete AlbLoadBalancer#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.AlbLoadBalancerTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_load_balancer#update AlbLoadBalancer#update}.

---

### AlbTargetGroupConfig <a name="AlbTargetGroupConfig" id="@cdktf/provider-yandex.AlbTargetGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbTargetGroupConfig.Initializer"></a>

```typescript
import { AlbTargetGroupConfig } from '@cdktf/provider-yandex'

const albTargetGroupConfig: AlbTargetGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#description AlbTargetGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#folder_id AlbTargetGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#id AlbTargetGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#labels AlbTargetGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#name AlbTargetGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.target">target</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]</code> | target block. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#description AlbTargetGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#folder_id AlbTargetGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#id AlbTargetGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#labels AlbTargetGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#name AlbTargetGroup#name}.

---

##### `target`<sup>Optional</sup> <a name="target" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.target"></a>

```typescript
public readonly target: IResolvable | AlbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]

target block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#target AlbTargetGroup#target}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbTargetGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: AlbTargetGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#timeouts AlbTargetGroup#timeouts}

---

### AlbTargetGroupTarget <a name="AlbTargetGroupTarget" id="@cdktf/provider-yandex.AlbTargetGroupTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbTargetGroupTarget.Initializer"></a>

```typescript
import { AlbTargetGroupTarget } from '@cdktf/provider-yandex'

const albTargetGroupTarget: AlbTargetGroupTarget = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTarget.property.ipAddress">ipAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#ip_address AlbTargetGroup#ip_address}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTarget.property.privateIpv4Address">privateIpv4Address</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#private_ipv4_address AlbTargetGroup#private_ipv4_address}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTarget.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#subnet_id AlbTargetGroup#subnet_id}. |

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.AlbTargetGroupTarget.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#ip_address AlbTargetGroup#ip_address}.

---

##### `privateIpv4Address`<sup>Optional</sup> <a name="privateIpv4Address" id="@cdktf/provider-yandex.AlbTargetGroupTarget.property.privateIpv4Address"></a>

```typescript
public readonly privateIpv4Address: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#private_ipv4_address AlbTargetGroup#private_ipv4_address}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbTargetGroupTarget.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#subnet_id AlbTargetGroup#subnet_id}.

---

### AlbTargetGroupTimeouts <a name="AlbTargetGroupTimeouts" id="@cdktf/provider-yandex.AlbTargetGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbTargetGroupTimeouts.Initializer"></a>

```typescript
import { AlbTargetGroupTimeouts } from '@cdktf/provider-yandex'

const albTargetGroupTimeouts: AlbTargetGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#create AlbTargetGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#delete AlbTargetGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#update AlbTargetGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#create AlbTargetGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#delete AlbTargetGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.AlbTargetGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_target_group#update AlbTargetGroup#update}.

---

### AlbVirtualHostConfig <a name="AlbVirtualHostConfig" id="@cdktf/provider-yandex.AlbVirtualHostConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostConfig.Initializer"></a>

```typescript
import { AlbVirtualHostConfig } from '@cdktf/provider-yandex'

const albVirtualHostConfig: AlbVirtualHostConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_router_id AlbVirtualHost#http_router_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.authority">authority</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#authority AlbVirtualHost#authority}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#id AlbVirtualHost#id}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.modifyRequestHeaders">modifyRequestHeaders</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]</code> | modify_request_headers block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.modifyResponseHeaders">modifyResponseHeaders</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]</code> | modify_response_headers block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.route">route</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]</code> | route block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_router_id AlbVirtualHost#http_router_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}.

---

##### `authority`<sup>Optional</sup> <a name="authority" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.authority"></a>

```typescript
public readonly authority: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#authority AlbVirtualHost#authority}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#id AlbVirtualHost#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `modifyRequestHeaders`<sup>Optional</sup> <a name="modifyRequestHeaders" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.modifyRequestHeaders"></a>

```typescript
public readonly modifyRequestHeaders: IResolvable | AlbVirtualHostModifyRequestHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]

modify_request_headers block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#modify_request_headers AlbVirtualHost#modify_request_headers}

---

##### `modifyResponseHeaders`<sup>Optional</sup> <a name="modifyResponseHeaders" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.modifyResponseHeaders"></a>

```typescript
public readonly modifyResponseHeaders: IResolvable | AlbVirtualHostModifyResponseHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]

modify_response_headers block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#modify_response_headers AlbVirtualHost#modify_response_headers}

---

##### `route`<sup>Optional</sup> <a name="route" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.route"></a>

```typescript
public readonly route: IResolvable | AlbVirtualHostRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]

route block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#route AlbVirtualHost#route}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.AlbVirtualHostConfig.property.timeouts"></a>

```typescript
public readonly timeouts: AlbVirtualHostTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#timeouts AlbVirtualHost#timeouts}

---

### AlbVirtualHostModifyRequestHeaders <a name="AlbVirtualHostModifyRequestHeaders" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.Initializer"></a>

```typescript
import { AlbVirtualHostModifyRequestHeaders } from '@cdktf/provider-yandex'

const albVirtualHostModifyRequestHeaders: AlbVirtualHostModifyRequestHeaders = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.append">append</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.remove">remove</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.replace">replace</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}.

---

##### `append`<sup>Optional</sup> <a name="append" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}.

---

##### `remove`<sup>Optional</sup> <a name="remove" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.remove"></a>

```typescript
public readonly remove: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}.

---

##### `replace`<sup>Optional</sup> <a name="replace" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}.

---

### AlbVirtualHostModifyResponseHeaders <a name="AlbVirtualHostModifyResponseHeaders" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.Initializer"></a>

```typescript
import { AlbVirtualHostModifyResponseHeaders } from '@cdktf/provider-yandex'

const albVirtualHostModifyResponseHeaders: AlbVirtualHostModifyResponseHeaders = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.append">append</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.remove">remove</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.replace">replace</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}.

---

##### `append`<sup>Optional</sup> <a name="append" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#append AlbVirtualHost#append}.

---

##### `remove`<sup>Optional</sup> <a name="remove" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.remove"></a>

```typescript
public readonly remove: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove AlbVirtualHost#remove}.

---

##### `replace`<sup>Optional</sup> <a name="replace" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace AlbVirtualHost#replace}.

---

### AlbVirtualHostRoute <a name="AlbVirtualHostRoute" id="@cdktf/provider-yandex.AlbVirtualHostRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRoute.Initializer"></a>

```typescript
import { AlbVirtualHostRoute } from '@cdktf/provider-yandex'

const albVirtualHostRoute: AlbVirtualHostRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRoute.property.grpcRoute">grpcRoute</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a></code> | grpc_route block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRoute.property.httpRoute">httpRoute</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a></code> | http_route block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRoute.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}. |

---

##### `grpcRoute`<sup>Optional</sup> <a name="grpcRoute" id="@cdktf/provider-yandex.AlbVirtualHostRoute.property.grpcRoute"></a>

```typescript
public readonly grpcRoute: AlbVirtualHostRouteGrpcRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a>

grpc_route block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_route AlbVirtualHost#grpc_route}

---

##### `httpRoute`<sup>Optional</sup> <a name="httpRoute" id="@cdktf/provider-yandex.AlbVirtualHostRoute.property.httpRoute"></a>

```typescript
public readonly httpRoute: AlbVirtualHostRouteHttpRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a>

http_route block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_route AlbVirtualHost#http_route}

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostRoute.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#name AlbVirtualHost#name}.

---

### AlbVirtualHostRouteGrpcRoute <a name="AlbVirtualHostRouteGrpcRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRoute } from '@cdktf/provider-yandex'

const albVirtualHostRouteGrpcRoute: AlbVirtualHostRouteGrpcRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcMatch">grpcMatch</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]</code> | grpc_match block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcRouteAction">grpcRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a></code> | grpc_route_action block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcStatusResponseAction">grpcStatusResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a></code> | grpc_status_response_action block. |

---

##### `grpcMatch`<sup>Optional</sup> <a name="grpcMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcMatch"></a>

```typescript
public readonly grpcMatch: IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]

grpc_match block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_match AlbVirtualHost#grpc_match}

---

##### `grpcRouteAction`<sup>Optional</sup> <a name="grpcRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcRouteAction"></a>

```typescript
public readonly grpcRouteAction: AlbVirtualHostRouteGrpcRouteGrpcRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a>

grpc_route_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_route_action AlbVirtualHost#grpc_route_action}

---

##### `grpcStatusResponseAction`<sup>Optional</sup> <a name="grpcStatusResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute.property.grpcStatusResponseAction"></a>

```typescript
public readonly grpcStatusResponseAction: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a>

grpc_status_response_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#grpc_status_response_action AlbVirtualHost#grpc_status_response_action}

---

### AlbVirtualHostRouteGrpcRouteGrpcMatch <a name="AlbVirtualHostRouteGrpcRouteGrpcMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcMatch } from '@cdktf/provider-yandex'

const albVirtualHostRouteGrpcRouteGrpcMatch: AlbVirtualHostRouteGrpcRouteGrpcMatch = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch.property.fqmn">fqmn</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a></code> | fqmn block. |

---

##### `fqmn`<sup>Optional</sup> <a name="fqmn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch.property.fqmn"></a>

```typescript
public readonly fqmn: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a>

fqmn block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#fqmn AlbVirtualHost#fqmn}

---

### AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn <a name="AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn } from '@cdktf/provider-yandex'

const albVirtualHostRouteGrpcRouteGrpcMatchFqmn: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.property.exact">exact</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.property.prefix">prefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}. |

---

##### `exact`<sup>Optional</sup> <a name="exact" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}.

---

### AlbVirtualHostRouteGrpcRouteGrpcRouteAction <a name="AlbVirtualHostRouteGrpcRouteGrpcRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcRouteAction } from '@cdktf/provider-yandex'

const albVirtualHostRouteGrpcRouteGrpcRouteAction: AlbVirtualHostRouteGrpcRouteGrpcRouteAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.autoHostRewrite">autoHostRewrite</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.maxTimeout">maxTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#max_timeout AlbVirtualHost#max_timeout}. |

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}.

---

##### `autoHostRewrite`<sup>Optional</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}.

---

##### `hostRewrite`<sup>Optional</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}.

---

##### `idleTimeout`<sup>Optional</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}.

---

##### `maxTimeout`<sup>Optional</sup> <a name="maxTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction.property.maxTimeout"></a>

```typescript
public readonly maxTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#max_timeout AlbVirtualHost#max_timeout}.

---

### AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction <a name="AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction } from '@cdktf/provider-yandex'

const albVirtualHostRouteGrpcRouteGrpcStatusResponseAction: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction.property.status">status</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}. |

---

##### `status`<sup>Optional</sup> <a name="status" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}.

---

### AlbVirtualHostRouteHttpRoute <a name="AlbVirtualHostRouteHttpRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRoute } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRoute: AlbVirtualHostRouteHttpRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.directResponseAction">directResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a></code> | direct_response_action block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.httpMatch">httpMatch</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]</code> | http_match block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.httpRouteAction">httpRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a></code> | http_route_action block. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.redirectAction">redirectAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a></code> | redirect_action block. |

---

##### `directResponseAction`<sup>Optional</sup> <a name="directResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.directResponseAction"></a>

```typescript
public readonly directResponseAction: AlbVirtualHostRouteHttpRouteDirectResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a>

direct_response_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#direct_response_action AlbVirtualHost#direct_response_action}

---

##### `httpMatch`<sup>Optional</sup> <a name="httpMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.httpMatch"></a>

```typescript
public readonly httpMatch: IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]

http_match block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_match AlbVirtualHost#http_match}

---

##### `httpRouteAction`<sup>Optional</sup> <a name="httpRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.httpRouteAction"></a>

```typescript
public readonly httpRouteAction: AlbVirtualHostRouteHttpRouteHttpRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a>

http_route_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_route_action AlbVirtualHost#http_route_action}

---

##### `redirectAction`<sup>Optional</sup> <a name="redirectAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute.property.redirectAction"></a>

```typescript
public readonly redirectAction: AlbVirtualHostRouteHttpRouteRedirectAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a>

redirect_action block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#redirect_action AlbVirtualHost#redirect_action}

---

### AlbVirtualHostRouteHttpRouteDirectResponseAction <a name="AlbVirtualHostRouteHttpRouteDirectResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteDirectResponseAction } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRouteDirectResponseAction: AlbVirtualHostRouteHttpRouteDirectResponseAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction.property.body">body</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#body AlbVirtualHost#body}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction.property.status">status</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}. |

---

##### `body`<sup>Optional</sup> <a name="body" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction.property.body"></a>

```typescript
public readonly body: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#body AlbVirtualHost#body}.

---

##### `status`<sup>Optional</sup> <a name="status" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction.property.status"></a>

```typescript
public readonly status: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#status AlbVirtualHost#status}.

---

### AlbVirtualHostRouteHttpRouteHttpMatch <a name="AlbVirtualHostRouteHttpRouteHttpMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpMatch } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRouteHttpMatch: AlbVirtualHostRouteHttpRouteHttpMatch = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch.property.httpMethod">httpMethod</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_method AlbVirtualHost#http_method}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch.property.path">path</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a></code> | path block. |

---

##### `httpMethod`<sup>Optional</sup> <a name="httpMethod" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch.property.httpMethod"></a>

```typescript
public readonly httpMethod: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#http_method AlbVirtualHost#http_method}.

---

##### `path`<sup>Optional</sup> <a name="path" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch.property.path"></a>

```typescript
public readonly path: AlbVirtualHostRouteHttpRouteHttpMatchPath;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a>

path block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#path AlbVirtualHost#path}

---

### AlbVirtualHostRouteHttpRouteHttpMatchPath <a name="AlbVirtualHostRouteHttpRouteHttpMatchPath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpMatchPath } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRouteHttpMatchPath: AlbVirtualHostRouteHttpRouteHttpMatchPath = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath.property.exact">exact</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath.property.prefix">prefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}. |

---

##### `exact`<sup>Optional</sup> <a name="exact" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#exact AlbVirtualHost#exact}.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix AlbVirtualHost#prefix}.

---

### AlbVirtualHostRouteHttpRouteHttpRouteAction <a name="AlbVirtualHostRouteHttpRouteHttpRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpRouteAction } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRouteHttpRouteAction: AlbVirtualHostRouteHttpRouteHttpRouteAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.autoHostRewrite">autoHostRewrite</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.prefixRewrite">prefixRewrite</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix_rewrite AlbVirtualHost#prefix_rewrite}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.timeout">timeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#timeout AlbVirtualHost#timeout}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.upgradeTypes">upgradeTypes</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#upgrade_types AlbVirtualHost#upgrade_types}. |

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#backend_group_id AlbVirtualHost#backend_group_id}.

---

##### `autoHostRewrite`<sup>Optional</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#auto_host_rewrite AlbVirtualHost#auto_host_rewrite}.

---

##### `hostRewrite`<sup>Optional</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#host_rewrite AlbVirtualHost#host_rewrite}.

---

##### `idleTimeout`<sup>Optional</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#idle_timeout AlbVirtualHost#idle_timeout}.

---

##### `prefixRewrite`<sup>Optional</sup> <a name="prefixRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.prefixRewrite"></a>

```typescript
public readonly prefixRewrite: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#prefix_rewrite AlbVirtualHost#prefix_rewrite}.

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#timeout AlbVirtualHost#timeout}.

---

##### `upgradeTypes`<sup>Optional</sup> <a name="upgradeTypes" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction.property.upgradeTypes"></a>

```typescript
public readonly upgradeTypes: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#upgrade_types AlbVirtualHost#upgrade_types}.

---

### AlbVirtualHostRouteHttpRouteRedirectAction <a name="AlbVirtualHostRouteHttpRouteRedirectAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteRedirectAction } from '@cdktf/provider-yandex'

const albVirtualHostRouteHttpRouteRedirectAction: AlbVirtualHostRouteHttpRouteRedirectAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.removeQuery">removeQuery</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove_query AlbVirtualHost#remove_query}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replaceHost">replaceHost</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_host AlbVirtualHost#replace_host}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePath">replacePath</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_path AlbVirtualHost#replace_path}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePort">replacePort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_port AlbVirtualHost#replace_port}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePrefix">replacePrefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_prefix AlbVirtualHost#replace_prefix}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replaceScheme">replaceScheme</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_scheme AlbVirtualHost#replace_scheme}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.responseCode">responseCode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#response_code AlbVirtualHost#response_code}. |

---

##### `removeQuery`<sup>Optional</sup> <a name="removeQuery" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.removeQuery"></a>

```typescript
public readonly removeQuery: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#remove_query AlbVirtualHost#remove_query}.

---

##### `replaceHost`<sup>Optional</sup> <a name="replaceHost" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replaceHost"></a>

```typescript
public readonly replaceHost: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_host AlbVirtualHost#replace_host}.

---

##### `replacePath`<sup>Optional</sup> <a name="replacePath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePath"></a>

```typescript
public readonly replacePath: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_path AlbVirtualHost#replace_path}.

---

##### `replacePort`<sup>Optional</sup> <a name="replacePort" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePort"></a>

```typescript
public readonly replacePort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_port AlbVirtualHost#replace_port}.

---

##### `replacePrefix`<sup>Optional</sup> <a name="replacePrefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replacePrefix"></a>

```typescript
public readonly replacePrefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_prefix AlbVirtualHost#replace_prefix}.

---

##### `replaceScheme`<sup>Optional</sup> <a name="replaceScheme" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.replaceScheme"></a>

```typescript
public readonly replaceScheme: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#replace_scheme AlbVirtualHost#replace_scheme}.

---

##### `responseCode`<sup>Optional</sup> <a name="responseCode" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction.property.responseCode"></a>

```typescript
public readonly responseCode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#response_code AlbVirtualHost#response_code}.

---

### AlbVirtualHostTimeouts <a name="AlbVirtualHostTimeouts" id="@cdktf/provider-yandex.AlbVirtualHostTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.AlbVirtualHostTimeouts.Initializer"></a>

```typescript
import { AlbVirtualHostTimeouts } from '@cdktf/provider-yandex'

const albVirtualHostTimeouts: AlbVirtualHostTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#create AlbVirtualHost#create}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#delete AlbVirtualHost#delete}. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#update AlbVirtualHost#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#create AlbVirtualHost#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#delete AlbVirtualHost#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.AlbVirtualHostTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/alb_virtual_host#update AlbVirtualHost#update}.

---

### ApiGatewayConfig <a name="ApiGatewayConfig" id="@cdktf/provider-yandex.ApiGatewayConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ApiGatewayConfig.Initializer"></a>

```typescript
import { ApiGatewayConfig } from '@cdktf/provider-yandex'

const apiGatewayConfig: ApiGatewayConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#name ApiGateway#name}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.spec">spec</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#spec ApiGateway#spec}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#description ApiGateway#description}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#folder_id ApiGateway#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#id ApiGateway#id}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#labels ApiGateway#labels}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ApiGatewayConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ApiGatewayConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ApiGatewayConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ApiGatewayConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ApiGatewayConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#name ApiGateway#name}.

---

##### `spec`<sup>Required</sup> <a name="spec" id="@cdktf/provider-yandex.ApiGatewayConfig.property.spec"></a>

```typescript
public readonly spec: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#spec ApiGateway#spec}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ApiGatewayConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#description ApiGateway#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ApiGatewayConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#folder_id ApiGateway#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ApiGatewayConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#id ApiGateway#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ApiGatewayConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#labels ApiGateway#labels}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ApiGatewayConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ApiGatewayTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#timeouts ApiGateway#timeouts}

---

### ApiGatewayTimeouts <a name="ApiGatewayTimeouts" id="@cdktf/provider-yandex.ApiGatewayTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ApiGatewayTimeouts.Initializer"></a>

```typescript
import { ApiGatewayTimeouts } from '@cdktf/provider-yandex'

const apiGatewayTimeouts: ApiGatewayTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#create ApiGateway#create}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#delete ApiGateway#delete}. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#update ApiGateway#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ApiGatewayTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#create ApiGateway#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ApiGatewayTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#delete ApiGateway#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ApiGatewayTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/api_gateway#update ApiGateway#update}.

---

### CdnOriginGroupConfig <a name="CdnOriginGroupConfig" id="@cdktf/provider-yandex.CdnOriginGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnOriginGroupConfig.Initializer"></a>

```typescript
import { CdnOriginGroupConfig } from '@cdktf/provider-yandex'

const cdnOriginGroupConfig: CdnOriginGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#name CdnOriginGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.origin">origin</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]</code> | origin block. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#id CdnOriginGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupConfig.property.useNext">useNext</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#use_next CdnOriginGroup#use_next}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#name CdnOriginGroup#name}.

---

##### `origin`<sup>Required</sup> <a name="origin" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.origin"></a>

```typescript
public readonly origin: IResolvable | CdnOriginGroupOrigin[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]

origin block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#origin CdnOriginGroup#origin}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#id CdnOriginGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: CdnOriginGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#timeouts CdnOriginGroup#timeouts}

---

##### `useNext`<sup>Optional</sup> <a name="useNext" id="@cdktf/provider-yandex.CdnOriginGroupConfig.property.useNext"></a>

```typescript
public readonly useNext: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#use_next CdnOriginGroup#use_next}.

---

### CdnOriginGroupOrigin <a name="CdnOriginGroupOrigin" id="@cdktf/provider-yandex.CdnOriginGroupOrigin"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnOriginGroupOrigin.Initializer"></a>

```typescript
import { CdnOriginGroupOrigin } from '@cdktf/provider-yandex'

const cdnOriginGroupOrigin: CdnOriginGroupOrigin = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin.property.source">source</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#source CdnOriginGroup#source}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin.property.backup">backup</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#backup CdnOriginGroup#backup}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#enabled CdnOriginGroup#enabled}. |

---

##### `source`<sup>Required</sup> <a name="source" id="@cdktf/provider-yandex.CdnOriginGroupOrigin.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#source CdnOriginGroup#source}.

---

##### `backup`<sup>Optional</sup> <a name="backup" id="@cdktf/provider-yandex.CdnOriginGroupOrigin.property.backup"></a>

```typescript
public readonly backup: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#backup CdnOriginGroup#backup}.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.CdnOriginGroupOrigin.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#enabled CdnOriginGroup#enabled}.

---

### CdnOriginGroupTimeouts <a name="CdnOriginGroupTimeouts" id="@cdktf/provider-yandex.CdnOriginGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnOriginGroupTimeouts.Initializer"></a>

```typescript
import { CdnOriginGroupTimeouts } from '@cdktf/provider-yandex'

const cdnOriginGroupTimeouts: CdnOriginGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#create CdnOriginGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#delete CdnOriginGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#update CdnOriginGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#create CdnOriginGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#delete CdnOriginGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.CdnOriginGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_origin_group#update CdnOriginGroup#update}.

---

### CdnResourceConfig <a name="CdnResourceConfig" id="@cdktf/provider-yandex.CdnResourceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnResourceConfig.Initializer"></a>

```typescript
import { CdnResourceConfig } from '@cdktf/provider-yandex'

const cdnResourceConfig: CdnResourceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.active">active</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#active CdnResource#active}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.cname">cname</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cname CdnResource#cname}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#id CdnResource#id}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.options">options</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a></code> | options block. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.originGroupId">originGroupId</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_group_id CdnResource#origin_group_id}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.originGroupName">originGroupName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_group_name CdnResource#origin_group_name}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.originProtocol">originProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_protocol CdnResource#origin_protocol}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.secondaryHostnames">secondaryHostnames</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#secondary_hostnames CdnResource#secondary_hostnames}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.sslCertificate">sslCertificate</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a></code> | ssl_certificate block. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceConfig.property.updatedAt">updatedAt</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#updated_at CdnResource#updated_at}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.CdnResourceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.CdnResourceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.CdnResourceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.CdnResourceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `active`<sup>Optional</sup> <a name="active" id="@cdktf/provider-yandex.CdnResourceConfig.property.active"></a>

```typescript
public readonly active: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#active CdnResource#active}.

---

##### `cname`<sup>Optional</sup> <a name="cname" id="@cdktf/provider-yandex.CdnResourceConfig.property.cname"></a>

```typescript
public readonly cname: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cname CdnResource#cname}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.CdnResourceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#id CdnResource#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `options`<sup>Optional</sup> <a name="options" id="@cdktf/provider-yandex.CdnResourceConfig.property.options"></a>

```typescript
public readonly options: CdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a>

options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#options CdnResource#options}

---

##### `originGroupId`<sup>Optional</sup> <a name="originGroupId" id="@cdktf/provider-yandex.CdnResourceConfig.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_group_id CdnResource#origin_group_id}.

---

##### `originGroupName`<sup>Optional</sup> <a name="originGroupName" id="@cdktf/provider-yandex.CdnResourceConfig.property.originGroupName"></a>

```typescript
public readonly originGroupName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_group_name CdnResource#origin_group_name}.

---

##### `originProtocol`<sup>Optional</sup> <a name="originProtocol" id="@cdktf/provider-yandex.CdnResourceConfig.property.originProtocol"></a>

```typescript
public readonly originProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#origin_protocol CdnResource#origin_protocol}.

---

##### `secondaryHostnames`<sup>Optional</sup> <a name="secondaryHostnames" id="@cdktf/provider-yandex.CdnResourceConfig.property.secondaryHostnames"></a>

```typescript
public readonly secondaryHostnames: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#secondary_hostnames CdnResource#secondary_hostnames}.

---

##### `sslCertificate`<sup>Optional</sup> <a name="sslCertificate" id="@cdktf/provider-yandex.CdnResourceConfig.property.sslCertificate"></a>

```typescript
public readonly sslCertificate: CdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a>

ssl_certificate block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#ssl_certificate CdnResource#ssl_certificate}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.CdnResourceConfig.property.timeouts"></a>

```typescript
public readonly timeouts: CdnResourceTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#timeouts CdnResource#timeouts}

---

##### `updatedAt`<sup>Optional</sup> <a name="updatedAt" id="@cdktf/provider-yandex.CdnResourceConfig.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#updated_at CdnResource#updated_at}.

---

### CdnResourceOptions <a name="CdnResourceOptions" id="@cdktf/provider-yandex.CdnResourceOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnResourceOptions.Initializer"></a>

```typescript
import { CdnResourceOptions } from '@cdktf/provider-yandex'

const cdnResourceOptions: CdnResourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.allowedHttpMethods">allowedHttpMethods</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#allowed_http_methods CdnResource#allowed_http_methods}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.browserCacheSettings">browserCacheSettings</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#browser_cache_settings CdnResource#browser_cache_settings}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.cacheHttpHeaders">cacheHttpHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cache_http_headers CdnResource#cache_http_headers}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.cors">cors</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cors CdnResource#cors}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.customHostHeader">customHostHeader</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#custom_host_header CdnResource#custom_host_header}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.customServerName">customServerName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#custom_server_name CdnResource#custom_server_name}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.disableCache">disableCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#disable_cache CdnResource#disable_cache}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.disableProxyForceRanges">disableProxyForceRanges</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#disable_proxy_force_ranges CdnResource#disable_proxy_force_ranges}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.edgeCacheSettings">edgeCacheSettings</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#edge_cache_settings CdnResource#edge_cache_settings}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.fetchedCompressed">fetchedCompressed</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#fetched_compressed CdnResource#fetched_compressed}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.forwardHostHeader">forwardHostHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#forward_host_header CdnResource#forward_host_header}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.gzipOn">gzipOn</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#gzip_on CdnResource#gzip_on}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.ignoreCookie">ignoreCookie</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#ignore_cookie CdnResource#ignore_cookie}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.ignoreQueryParams">ignoreQueryParams</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#ignore_query_params CdnResource#ignore_query_params}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.proxyCacheMethodsSet">proxyCacheMethodsSet</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#proxy_cache_methods_set CdnResource#proxy_cache_methods_set}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.queryParamsBlacklist">queryParamsBlacklist</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#query_params_blacklist CdnResource#query_params_blacklist}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.queryParamsWhitelist">queryParamsWhitelist</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#query_params_whitelist CdnResource#query_params_whitelist}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.redirectHttpsToHttp">redirectHttpsToHttp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#redirect_https_to_http CdnResource#redirect_https_to_http}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.redirectHttpToHttps">redirectHttpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#redirect_http_to_https CdnResource#redirect_http_to_https}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.slice">slice</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#slice CdnResource#slice}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.staticRequestHeaders">staticRequestHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#static_request_headers CdnResource#static_request_headers}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptions.property.staticResponseHeaders">staticResponseHeaders</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#static_response_headers CdnResource#static_response_headers}. |

---

##### `allowedHttpMethods`<sup>Optional</sup> <a name="allowedHttpMethods" id="@cdktf/provider-yandex.CdnResourceOptions.property.allowedHttpMethods"></a>

```typescript
public readonly allowedHttpMethods: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#allowed_http_methods CdnResource#allowed_http_methods}.

---

##### `browserCacheSettings`<sup>Optional</sup> <a name="browserCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptions.property.browserCacheSettings"></a>

```typescript
public readonly browserCacheSettings: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#browser_cache_settings CdnResource#browser_cache_settings}.

---

##### `cacheHttpHeaders`<sup>Optional</sup> <a name="cacheHttpHeaders" id="@cdktf/provider-yandex.CdnResourceOptions.property.cacheHttpHeaders"></a>

```typescript
public readonly cacheHttpHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cache_http_headers CdnResource#cache_http_headers}.

---

##### `cors`<sup>Optional</sup> <a name="cors" id="@cdktf/provider-yandex.CdnResourceOptions.property.cors"></a>

```typescript
public readonly cors: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#cors CdnResource#cors}.

---

##### `customHostHeader`<sup>Optional</sup> <a name="customHostHeader" id="@cdktf/provider-yandex.CdnResourceOptions.property.customHostHeader"></a>

```typescript
public readonly customHostHeader: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#custom_host_header CdnResource#custom_host_header}.

---

##### `customServerName`<sup>Optional</sup> <a name="customServerName" id="@cdktf/provider-yandex.CdnResourceOptions.property.customServerName"></a>

```typescript
public readonly customServerName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#custom_server_name CdnResource#custom_server_name}.

---

##### `disableCache`<sup>Optional</sup> <a name="disableCache" id="@cdktf/provider-yandex.CdnResourceOptions.property.disableCache"></a>

```typescript
public readonly disableCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#disable_cache CdnResource#disable_cache}.

---

##### `disableProxyForceRanges`<sup>Optional</sup> <a name="disableProxyForceRanges" id="@cdktf/provider-yandex.CdnResourceOptions.property.disableProxyForceRanges"></a>

```typescript
public readonly disableProxyForceRanges: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#disable_proxy_force_ranges CdnResource#disable_proxy_force_ranges}.

---

##### `edgeCacheSettings`<sup>Optional</sup> <a name="edgeCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptions.property.edgeCacheSettings"></a>

```typescript
public readonly edgeCacheSettings: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#edge_cache_settings CdnResource#edge_cache_settings}.

---

##### `fetchedCompressed`<sup>Optional</sup> <a name="fetchedCompressed" id="@cdktf/provider-yandex.CdnResourceOptions.property.fetchedCompressed"></a>

```typescript
public readonly fetchedCompressed: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#fetched_compressed CdnResource#fetched_compressed}.

---

##### `forwardHostHeader`<sup>Optional</sup> <a name="forwardHostHeader" id="@cdktf/provider-yandex.CdnResourceOptions.property.forwardHostHeader"></a>

```typescript
public readonly forwardHostHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#forward_host_header CdnResource#forward_host_header}.

---

##### `gzipOn`<sup>Optional</sup> <a name="gzipOn" id="@cdktf/provider-yandex.CdnResourceOptions.property.gzipOn"></a>

```typescript
public readonly gzipOn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#gzip_on CdnResource#gzip_on}.

---

##### `ignoreCookie`<sup>Optional</sup> <a name="ignoreCookie" id="@cdktf/provider-yandex.CdnResourceOptions.property.ignoreCookie"></a>

```typescript
public readonly ignoreCookie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#ignore_cookie CdnResource#ignore_cookie}.

---

##### `ignoreQueryParams`<sup>Optional</sup> <a name="ignoreQueryParams" id="@cdktf/provider-yandex.CdnResourceOptions.property.ignoreQueryParams"></a>

```typescript
public readonly ignoreQueryParams: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#ignore_query_params CdnResource#ignore_query_params}.

---

##### `proxyCacheMethodsSet`<sup>Optional</sup> <a name="proxyCacheMethodsSet" id="@cdktf/provider-yandex.CdnResourceOptions.property.proxyCacheMethodsSet"></a>

```typescript
public readonly proxyCacheMethodsSet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#proxy_cache_methods_set CdnResource#proxy_cache_methods_set}.

---

##### `queryParamsBlacklist`<sup>Optional</sup> <a name="queryParamsBlacklist" id="@cdktf/provider-yandex.CdnResourceOptions.property.queryParamsBlacklist"></a>

```typescript
public readonly queryParamsBlacklist: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#query_params_blacklist CdnResource#query_params_blacklist}.

---

##### `queryParamsWhitelist`<sup>Optional</sup> <a name="queryParamsWhitelist" id="@cdktf/provider-yandex.CdnResourceOptions.property.queryParamsWhitelist"></a>

```typescript
public readonly queryParamsWhitelist: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#query_params_whitelist CdnResource#query_params_whitelist}.

---

##### `redirectHttpsToHttp`<sup>Optional</sup> <a name="redirectHttpsToHttp" id="@cdktf/provider-yandex.CdnResourceOptions.property.redirectHttpsToHttp"></a>

```typescript
public readonly redirectHttpsToHttp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#redirect_https_to_http CdnResource#redirect_https_to_http}.

---

##### `redirectHttpToHttps`<sup>Optional</sup> <a name="redirectHttpToHttps" id="@cdktf/provider-yandex.CdnResourceOptions.property.redirectHttpToHttps"></a>

```typescript
public readonly redirectHttpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#redirect_http_to_https CdnResource#redirect_http_to_https}.

---

##### `slice`<sup>Optional</sup> <a name="slice" id="@cdktf/provider-yandex.CdnResourceOptions.property.slice"></a>

```typescript
public readonly slice: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#slice CdnResource#slice}.

---

##### `staticRequestHeaders`<sup>Optional</sup> <a name="staticRequestHeaders" id="@cdktf/provider-yandex.CdnResourceOptions.property.staticRequestHeaders"></a>

```typescript
public readonly staticRequestHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#static_request_headers CdnResource#static_request_headers}.

---

##### `staticResponseHeaders`<sup>Optional</sup> <a name="staticResponseHeaders" id="@cdktf/provider-yandex.CdnResourceOptions.property.staticResponseHeaders"></a>

```typescript
public readonly staticResponseHeaders: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#static_response_headers CdnResource#static_response_headers}.

---

### CdnResourceSslCertificate <a name="CdnResourceSslCertificate" id="@cdktf/provider-yandex.CdnResourceSslCertificate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnResourceSslCertificate.Initializer"></a>

```typescript
import { CdnResourceSslCertificate } from '@cdktf/provider-yandex'

const cdnResourceSslCertificate: CdnResourceSslCertificate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificate.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#type CdnResource#type}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificate.property.certificateManagerId">certificateManagerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#certificate_manager_id CdnResource#certificate_manager_id}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.CdnResourceSslCertificate.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#type CdnResource#type}.

---

##### `certificateManagerId`<sup>Optional</sup> <a name="certificateManagerId" id="@cdktf/provider-yandex.CdnResourceSslCertificate.property.certificateManagerId"></a>

```typescript
public readonly certificateManagerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#certificate_manager_id CdnResource#certificate_manager_id}.

---

### CdnResourceTimeouts <a name="CdnResourceTimeouts" id="@cdktf/provider-yandex.CdnResourceTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.CdnResourceTimeouts.Initializer"></a>

```typescript
import { CdnResourceTimeouts } from '@cdktf/provider-yandex'

const cdnResourceTimeouts: CdnResourceTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#create CdnResource#create}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#delete CdnResource#delete}. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#update CdnResource#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.CdnResourceTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#create CdnResource#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.CdnResourceTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#delete CdnResource#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.CdnResourceTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/cdn_resource#update CdnResource#update}.

---

### ComputeDiskConfig <a name="ComputeDiskConfig" id="@cdktf/provider-yandex.ComputeDiskConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeDiskConfig.Initializer"></a>

```typescript
import { ComputeDiskConfig } from '@cdktf/provider-yandex'

const computeDiskConfig: ComputeDiskConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.blockSize">blockSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#block_size ComputeDisk#block_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#description ComputeDisk#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.diskPlacementPolicy">diskPlacementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a></code> | disk_placement_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#folder_id ComputeDisk#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#id ComputeDisk#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.imageId">imageId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#image_id ComputeDisk#image_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#labels ComputeDisk#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#name ComputeDisk#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#size ComputeDisk#size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.snapshotId">snapshotId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#snapshot_id ComputeDisk#snapshot_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#type ComputeDisk#type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#zone ComputeDisk#zone}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeDiskConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeDiskConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeDiskConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeDiskConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `blockSize`<sup>Optional</sup> <a name="blockSize" id="@cdktf/provider-yandex.ComputeDiskConfig.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#block_size ComputeDisk#block_size}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeDiskConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#description ComputeDisk#description}.

---

##### `diskPlacementPolicy`<sup>Optional</sup> <a name="diskPlacementPolicy" id="@cdktf/provider-yandex.ComputeDiskConfig.property.diskPlacementPolicy"></a>

```typescript
public readonly diskPlacementPolicy: ComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a>

disk_placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#disk_placement_policy ComputeDisk#disk_placement_policy}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeDiskConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#folder_id ComputeDisk#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDiskConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#id ComputeDisk#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeDiskConfig.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#image_id ComputeDisk#image_id}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeDiskConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#labels ComputeDisk#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeDiskConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#name ComputeDisk#name}.

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.ComputeDiskConfig.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#size ComputeDisk#size}.

---

##### `snapshotId`<sup>Optional</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeDiskConfig.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#snapshot_id ComputeDisk#snapshot_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeDiskConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeDiskTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#timeouts ComputeDisk#timeouts}

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.ComputeDiskConfig.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#type ComputeDisk#type}.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeDiskConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#zone ComputeDisk#zone}.

---

### ComputeDiskDiskPlacementPolicy <a name="ComputeDiskDiskPlacementPolicy" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy.Initializer"></a>

```typescript
import { ComputeDiskDiskPlacementPolicy } from '@cdktf/provider-yandex'

const computeDiskDiskPlacementPolicy: ComputeDiskDiskPlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy.property.diskPlacementGroupId">diskPlacementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#disk_placement_group_id ComputeDisk#disk_placement_group_id}. |

---

##### `diskPlacementGroupId`<sup>Required</sup> <a name="diskPlacementGroupId" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy.property.diskPlacementGroupId"></a>

```typescript
public readonly diskPlacementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#disk_placement_group_id ComputeDisk#disk_placement_group_id}.

---

### ComputeDiskPlacementGroupConfig <a name="ComputeDiskPlacementGroupConfig" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.Initializer"></a>

```typescript
import { ComputeDiskPlacementGroupConfig } from '@cdktf/provider-yandex'

const computeDiskPlacementGroupConfig: ComputeDiskPlacementGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#description ComputeDiskPlacementGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#folder_id ComputeDiskPlacementGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#id ComputeDiskPlacementGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#labels ComputeDiskPlacementGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#name ComputeDiskPlacementGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#zone ComputeDiskPlacementGroup#zone}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#description ComputeDiskPlacementGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#folder_id ComputeDiskPlacementGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#id ComputeDiskPlacementGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#labels ComputeDiskPlacementGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#name ComputeDiskPlacementGroup#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeDiskPlacementGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#timeouts ComputeDiskPlacementGroup#timeouts}

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#zone ComputeDiskPlacementGroup#zone}.

---

### ComputeDiskPlacementGroupTimeouts <a name="ComputeDiskPlacementGroupTimeouts" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.Initializer"></a>

```typescript
import { ComputeDiskPlacementGroupTimeouts } from '@cdktf/provider-yandex'

const computeDiskPlacementGroupTimeouts: ComputeDiskPlacementGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#create ComputeDiskPlacementGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#delete ComputeDiskPlacementGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#update ComputeDiskPlacementGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#create ComputeDiskPlacementGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#delete ComputeDiskPlacementGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk_placement_group#update ComputeDiskPlacementGroup#update}.

---

### ComputeDiskTimeouts <a name="ComputeDiskTimeouts" id="@cdktf/provider-yandex.ComputeDiskTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeDiskTimeouts.Initializer"></a>

```typescript
import { ComputeDiskTimeouts } from '@cdktf/provider-yandex'

const computeDiskTimeouts: ComputeDiskTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#create ComputeDisk#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#delete ComputeDisk#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#update ComputeDisk#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeDiskTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#create ComputeDisk#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeDiskTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#delete ComputeDisk#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeDiskTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_disk#update ComputeDisk#update}.

---

### ComputeImageConfig <a name="ComputeImageConfig" id="@cdktf/provider-yandex.ComputeImageConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeImageConfig.Initializer"></a>

```typescript
import { ComputeImageConfig } from '@cdktf/provider-yandex'

const computeImageConfig: ComputeImageConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#description ComputeImage#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.family">family</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#family ComputeImage#family}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#folder_id ComputeImage#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#id ComputeImage#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#labels ComputeImage#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.minDiskSize">minDiskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#min_disk_size ComputeImage#min_disk_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#name ComputeImage#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.osType">osType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#os_type ComputeImage#os_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.pooled">pooled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#pooled ComputeImage#pooled}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.productIds">productIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#product_ids ComputeImage#product_ids}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.sourceDisk">sourceDisk</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_disk ComputeImage#source_disk}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.sourceFamily">sourceFamily</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_family ComputeImage#source_family}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.sourceImage">sourceImage</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_image ComputeImage#source_image}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.sourceSnapshot">sourceSnapshot</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_snapshot ComputeImage#source_snapshot}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.sourceUrl">sourceUrl</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_url ComputeImage#source_url}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeImageConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeImageConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeImageConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeImageConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeImageConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#description ComputeImage#description}.

---

##### `family`<sup>Optional</sup> <a name="family" id="@cdktf/provider-yandex.ComputeImageConfig.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#family ComputeImage#family}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeImageConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#folder_id ComputeImage#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeImageConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#id ComputeImage#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeImageConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#labels ComputeImage#labels}.

---

##### `minDiskSize`<sup>Optional</sup> <a name="minDiskSize" id="@cdktf/provider-yandex.ComputeImageConfig.property.minDiskSize"></a>

```typescript
public readonly minDiskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#min_disk_size ComputeImage#min_disk_size}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeImageConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#name ComputeImage#name}.

---

##### `osType`<sup>Optional</sup> <a name="osType" id="@cdktf/provider-yandex.ComputeImageConfig.property.osType"></a>

```typescript
public readonly osType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#os_type ComputeImage#os_type}.

---

##### `pooled`<sup>Optional</sup> <a name="pooled" id="@cdktf/provider-yandex.ComputeImageConfig.property.pooled"></a>

```typescript
public readonly pooled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#pooled ComputeImage#pooled}.

---

##### `productIds`<sup>Optional</sup> <a name="productIds" id="@cdktf/provider-yandex.ComputeImageConfig.property.productIds"></a>

```typescript
public readonly productIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#product_ids ComputeImage#product_ids}.

---

##### `sourceDisk`<sup>Optional</sup> <a name="sourceDisk" id="@cdktf/provider-yandex.ComputeImageConfig.property.sourceDisk"></a>

```typescript
public readonly sourceDisk: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_disk ComputeImage#source_disk}.

---

##### `sourceFamily`<sup>Optional</sup> <a name="sourceFamily" id="@cdktf/provider-yandex.ComputeImageConfig.property.sourceFamily"></a>

```typescript
public readonly sourceFamily: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_family ComputeImage#source_family}.

---

##### `sourceImage`<sup>Optional</sup> <a name="sourceImage" id="@cdktf/provider-yandex.ComputeImageConfig.property.sourceImage"></a>

```typescript
public readonly sourceImage: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_image ComputeImage#source_image}.

---

##### `sourceSnapshot`<sup>Optional</sup> <a name="sourceSnapshot" id="@cdktf/provider-yandex.ComputeImageConfig.property.sourceSnapshot"></a>

```typescript
public readonly sourceSnapshot: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_snapshot ComputeImage#source_snapshot}.

---

##### `sourceUrl`<sup>Optional</sup> <a name="sourceUrl" id="@cdktf/provider-yandex.ComputeImageConfig.property.sourceUrl"></a>

```typescript
public readonly sourceUrl: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#source_url ComputeImage#source_url}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeImageConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeImageTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#timeouts ComputeImage#timeouts}

---

### ComputeImageTimeouts <a name="ComputeImageTimeouts" id="@cdktf/provider-yandex.ComputeImageTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeImageTimeouts.Initializer"></a>

```typescript
import { ComputeImageTimeouts } from '@cdktf/provider-yandex'

const computeImageTimeouts: ComputeImageTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#create ComputeImage#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#delete ComputeImage#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#update ComputeImage#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeImageTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#create ComputeImage#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeImageTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#delete ComputeImage#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeImageTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_image#update ComputeImage#update}.

---

### ComputeInstanceBootDisk <a name="ComputeInstanceBootDisk" id="@cdktf/provider-yandex.ComputeInstanceBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.Initializer"></a>

```typescript
import { ComputeInstanceBootDisk } from '@cdktf/provider-yandex'

const computeInstanceBootDisk: ComputeInstanceBootDisk = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk.property.autoDelete">autoDelete</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#auto_delete ComputeInstance#auto_delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk.property.deviceName">deviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#device_name ComputeInstance#device_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk.property.diskId">diskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#disk_id ComputeInstance#disk_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a></code> | initialize_params block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk.property.mode">mode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#mode ComputeInstance#mode}. |

---

##### `autoDelete`<sup>Optional</sup> <a name="autoDelete" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.property.autoDelete"></a>

```typescript
public readonly autoDelete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#auto_delete ComputeInstance#auto_delete}.

---

##### `deviceName`<sup>Optional</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#device_name ComputeInstance#device_name}.

---

##### `diskId`<sup>Optional</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#disk_id ComputeInstance#disk_id}.

---

##### `initializeParams`<sup>Optional</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a>

initialize_params block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#initialize_params ComputeInstance#initialize_params}

---

##### `mode`<sup>Optional</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceBootDisk.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#mode ComputeInstance#mode}.

---

### ComputeInstanceBootDiskInitializeParams <a name="ComputeInstanceBootDiskInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.Initializer"></a>

```typescript
import { ComputeInstanceBootDiskInitializeParams } from '@cdktf/provider-yandex'

const computeInstanceBootDiskInitializeParams: ComputeInstanceBootDiskInitializeParams = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.blockSize">blockSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#block_size ComputeInstance#block_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#description ComputeInstance#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.imageId">imageId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#image_id ComputeInstance#image_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#name ComputeInstance#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#size ComputeInstance#size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.snapshotId">snapshotId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#snapshot_id ComputeInstance#snapshot_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#type ComputeInstance#type}. |

---

##### `blockSize`<sup>Optional</sup> <a name="blockSize" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#block_size ComputeInstance#block_size}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#description ComputeInstance#description}.

---

##### `imageId`<sup>Optional</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#image_id ComputeInstance#image_id}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#name ComputeInstance#name}.

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#size ComputeInstance#size}.

---

##### `snapshotId`<sup>Optional</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#snapshot_id ComputeInstance#snapshot_id}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#type ComputeInstance#type}.

---

### ComputeInstanceConfig <a name="ComputeInstanceConfig" id="@cdktf/provider-yandex.ComputeInstanceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceConfig.Initializer"></a>

```typescript
import { ComputeInstanceConfig } from '@cdktf/provider-yandex'

const computeInstanceConfig: ComputeInstanceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a></code> | boot_disk block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.networkInterface">networkInterface</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]</code> | network_interface block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.allowStoppingForUpdate">allowStoppingForUpdate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#allow_stopping_for_update ComputeInstance#allow_stopping_for_update}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#description ComputeInstance#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#folder_id ComputeInstance#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.hostname">hostname</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#hostname ComputeInstance#hostname}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#id ComputeInstance#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#labels ComputeInstance#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#metadata ComputeInstance#metadata}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#name ComputeInstance#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#network_acceleration_type ComputeInstance#network_acceleration_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a></code> | placement_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.platformId">platformId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#platform_id ComputeInstance#platform_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a></code> | scheduling_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.secondaryDisk">secondaryDisk</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]</code> | secondary_disk block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#service_account_id ComputeInstance#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#zone ComputeInstance#zone}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.bootDisk"></a>

```typescript
public readonly bootDisk: ComputeInstanceBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a>

boot_disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#boot_disk ComputeInstance#boot_disk}

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.networkInterface"></a>

```typescript
public readonly networkInterface: IResolvable | ComputeInstanceNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]

network_interface block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#network_interface ComputeInstance#network_interface}

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.resources"></a>

```typescript
public readonly resources: ComputeInstanceResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#resources ComputeInstance#resources}

---

##### `allowStoppingForUpdate`<sup>Optional</sup> <a name="allowStoppingForUpdate" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.allowStoppingForUpdate"></a>

```typescript
public readonly allowStoppingForUpdate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#allow_stopping_for_update ComputeInstance#allow_stopping_for_update}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#description ComputeInstance#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#folder_id ComputeInstance#folder_id}.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#hostname ComputeInstance#hostname}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#id ComputeInstance#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#labels ComputeInstance#labels}.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#metadata ComputeInstance#metadata}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#name ComputeInstance#name}.

---

##### `networkAccelerationType`<sup>Optional</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#network_acceleration_type ComputeInstance#network_acceleration_type}.

---

##### `placementPolicy`<sup>Optional</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: ComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a>

placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#placement_policy ComputeInstance#placement_policy}

---

##### `platformId`<sup>Optional</sup> <a name="platformId" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#platform_id ComputeInstance#platform_id}.

---

##### `schedulingPolicy`<sup>Optional</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: ComputeInstanceSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a>

scheduling_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#scheduling_policy ComputeInstance#scheduling_policy}

---

##### `secondaryDisk`<sup>Optional</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: IResolvable | ComputeInstanceSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]

secondary_disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#secondary_disk ComputeInstance#secondary_disk}

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#service_account_id ComputeInstance#service_account_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#timeouts ComputeInstance#timeouts}

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.ComputeInstanceConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#zone ComputeInstance#zone}.

---

### ComputeInstanceGroupAllocationPolicy <a name="ComputeInstanceGroupAllocationPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy.Initializer"></a>

```typescript
import { ComputeInstanceGroupAllocationPolicy } from '@cdktf/provider-yandex'

const computeInstanceGroupAllocationPolicy: ComputeInstanceGroupAllocationPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy.property.zones">zones</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#zones ComputeInstanceGroup#zones}. |

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#zones ComputeInstanceGroup#zones}.

---

### ComputeInstanceGroupApplicationLoadBalancer <a name="ComputeInstanceGroupApplicationLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.Initializer"></a>

```typescript
import { ComputeInstanceGroupApplicationLoadBalancer } from '@cdktf/provider-yandex'

const computeInstanceGroupApplicationLoadBalancer: ComputeInstanceGroupApplicationLoadBalancer = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupLabels">targetGroupLabels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}. |

---

##### `maxOpeningTrafficDuration`<sup>Optional</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}.

---

##### `targetGroupDescription`<sup>Optional</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}.

---

##### `targetGroupLabels`<sup>Optional</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}.

---

##### `targetGroupName`<sup>Optional</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}.

---

### ComputeInstanceGroupConfig <a name="ComputeInstanceGroupConfig" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.Initializer"></a>

```typescript
import { ComputeInstanceGroupConfig } from '@cdktf/provider-yandex'

const computeInstanceGroupConfig: ComputeInstanceGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a></code> | allocation_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a></code> | deploy_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a></code> | instance_template block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a></code> | scale_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.applicationLoadBalancer">applicationLoadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a></code> | application_load_balancer block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#deletion_protection ComputeInstanceGroup#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.healthCheck">healthCheck</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]</code> | health_check block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#id ComputeInstanceGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.loadBalancer">loadBalancer</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a></code> | load_balancer block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.maxCheckingHealthDuration">maxCheckingHealthDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_checking_health_duration ComputeInstanceGroup#max_checking_health_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.variables">variables</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#variables ComputeInstanceGroup#variables}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `allocationPolicy`<sup>Required</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: ComputeInstanceGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a>

allocation_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#allocation_policy ComputeInstanceGroup#allocation_policy}

---

##### `deployPolicy`<sup>Required</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: ComputeInstanceGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a>

deploy_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#deploy_policy ComputeInstanceGroup#deploy_policy}

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: ComputeInstanceGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a>

instance_template block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#instance_template ComputeInstanceGroup#instance_template}

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: ComputeInstanceGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a>

scale_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#scale_policy ComputeInstanceGroup#scale_policy}

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}.

---

##### `applicationLoadBalancer`<sup>Optional</sup> <a name="applicationLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.applicationLoadBalancer"></a>

```typescript
public readonly applicationLoadBalancer: ComputeInstanceGroupApplicationLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a>

application_load_balancer block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#application_load_balancer ComputeInstanceGroup#application_load_balancer}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#deletion_protection ComputeInstanceGroup#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}.

---

##### `healthCheck`<sup>Optional</sup> <a name="healthCheck" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.healthCheck"></a>

```typescript
public readonly healthCheck: IResolvable | ComputeInstanceGroupHealthCheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]

health_check block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#health_check ComputeInstanceGroup#health_check}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#id ComputeInstanceGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}.

---

##### `loadBalancer`<sup>Optional</sup> <a name="loadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.loadBalancer"></a>

```typescript
public readonly loadBalancer: ComputeInstanceGroupLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a>

load_balancer block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#load_balancer ComputeInstanceGroup#load_balancer}

---

##### `maxCheckingHealthDuration`<sup>Optional</sup> <a name="maxCheckingHealthDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.maxCheckingHealthDuration"></a>

```typescript
public readonly maxCheckingHealthDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_checking_health_duration ComputeInstanceGroup#max_checking_health_duration}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeInstanceGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#timeouts ComputeInstanceGroup#timeouts}

---

##### `variables`<sup>Optional</sup> <a name="variables" id="@cdktf/provider-yandex.ComputeInstanceGroupConfig.property.variables"></a>

```typescript
public readonly variables: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#variables ComputeInstanceGroup#variables}.

---

### ComputeInstanceGroupDeployPolicy <a name="ComputeInstanceGroupDeployPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.Initializer"></a>

```typescript
import { ComputeInstanceGroupDeployPolicy } from '@cdktf/provider-yandex'

const computeInstanceGroupDeployPolicy: ComputeInstanceGroupDeployPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_expansion ComputeInstanceGroup#max_expansion}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_unavailable ComputeInstanceGroup#max_unavailable}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxCreating">maxCreating</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_creating ComputeInstanceGroup#max_creating}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxDeleting">maxDeleting</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_deleting ComputeInstanceGroup#max_deleting}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.startupDuration">startupDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#startup_duration ComputeInstanceGroup#startup_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.strategy">strategy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#strategy ComputeInstanceGroup#strategy}. |

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_expansion ComputeInstanceGroup#max_expansion}.

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_unavailable ComputeInstanceGroup#max_unavailable}.

---

##### `maxCreating`<sup>Optional</sup> <a name="maxCreating" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxCreating"></a>

```typescript
public readonly maxCreating: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_creating ComputeInstanceGroup#max_creating}.

---

##### `maxDeleting`<sup>Optional</sup> <a name="maxDeleting" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.maxDeleting"></a>

```typescript
public readonly maxDeleting: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_deleting ComputeInstanceGroup#max_deleting}.

---

##### `startupDuration`<sup>Optional</sup> <a name="startupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.startupDuration"></a>

```typescript
public readonly startupDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#startup_duration ComputeInstanceGroup#startup_duration}.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy.property.strategy"></a>

```typescript
public readonly strategy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#strategy ComputeInstanceGroup#strategy}.

---

### ComputeInstanceGroupHealthCheck <a name="ComputeInstanceGroupHealthCheck" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheck } from '@cdktf/provider-yandex'

const computeInstanceGroupHealthCheck: ComputeInstanceGroupHealthCheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#healthy_threshold ComputeInstanceGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.httpOptions">httpOptions</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]</code> | http_options block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.interval">interval</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#interval ComputeInstanceGroup#interval}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a></code> | tcp_options block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.timeout">timeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#timeout ComputeInstanceGroup#timeout}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#unhealthy_threshold ComputeInstanceGroup#unhealthy_threshold}. |

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#healthy_threshold ComputeInstanceGroup#healthy_threshold}.

---

##### `httpOptions`<sup>Optional</sup> <a name="httpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.httpOptions"></a>

```typescript
public readonly httpOptions: IResolvable | ComputeInstanceGroupHealthCheckHttpOptions[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]

http_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#http_options ComputeInstanceGroup#http_options}

---

##### `interval`<sup>Optional</sup> <a name="interval" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#interval ComputeInstanceGroup#interval}.

---

##### `tcpOptions`<sup>Optional</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: ComputeInstanceGroupHealthCheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a>

tcp_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#tcp_options ComputeInstanceGroup#tcp_options}

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#timeout ComputeInstanceGroup#timeout}.

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#unhealthy_threshold ComputeInstanceGroup#unhealthy_threshold}.

---

### ComputeInstanceGroupHealthCheckHttpOptions <a name="ComputeInstanceGroupHealthCheckHttpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckHttpOptions } from '@cdktf/provider-yandex'

const computeInstanceGroupHealthCheckHttpOptions: ComputeInstanceGroupHealthCheckHttpOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions.property.path">path</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#path ComputeInstanceGroup#path}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}. |

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#path ComputeInstanceGroup#path}.

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}.

---

### ComputeInstanceGroupHealthCheckTcpOptions <a name="ComputeInstanceGroupHealthCheckTcpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckTcpOptions } from '@cdktf/provider-yandex'

const computeInstanceGroupHealthCheckTcpOptions: ComputeInstanceGroupHealthCheckTcpOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}. |

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#port ComputeInstanceGroup#port}.

---

### ComputeInstanceGroupInstances <a name="ComputeInstanceGroupInstances" id="@cdktf/provider-yandex.ComputeInstanceGroupInstances"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstances.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstances } from '@cdktf/provider-yandex'

const computeInstanceGroupInstances: ComputeInstanceGroupInstances = { ... }
```


### ComputeInstanceGroupInstancesNetworkInterface <a name="ComputeInstanceGroupInstancesNetworkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterface.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstancesNetworkInterface } from '@cdktf/provider-yandex'

const computeInstanceGroupInstancesNetworkInterface: ComputeInstanceGroupInstancesNetworkInterface = { ... }
```


### ComputeInstanceGroupInstanceTemplate <a name="ComputeInstanceGroupInstanceTemplate" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplate } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplate: ComputeInstanceGroupInstanceTemplate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a></code> | boot_disk block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.networkInterface">networkInterface</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]</code> | network_interface block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.hostname">hostname</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#hostname ComputeInstanceGroup#hostname}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metadata ComputeInstanceGroup#metadata}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.networkSettings">networkSettings</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]</code> | network_settings block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a></code> | placement_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.platformId">platformId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#platform_id ComputeInstanceGroup#platform_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a></code> | scheduling_policy block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.secondaryDisk">secondaryDisk</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]</code> | secondary_disk block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}. |

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.bootDisk"></a>

```typescript
public readonly bootDisk: ComputeInstanceGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a>

boot_disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#boot_disk ComputeInstanceGroup#boot_disk}

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.networkInterface"></a>

```typescript
public readonly networkInterface: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]

network_interface block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_interface ComputeInstanceGroup#network_interface}

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.resources"></a>

```typescript
public readonly resources: ComputeInstanceGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#resources ComputeInstanceGroup#resources}

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#hostname ComputeInstanceGroup#hostname}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metadata ComputeInstanceGroup#metadata}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#name ComputeInstanceGroup#name}.

---

##### `networkSettings`<sup>Optional</sup> <a name="networkSettings" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.networkSettings"></a>

```typescript
public readonly networkSettings: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]

network_settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_settings ComputeInstanceGroup#network_settings}

---

##### `placementPolicy`<sup>Optional</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: ComputeInstanceGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a>

placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#placement_policy ComputeInstanceGroup#placement_policy}

---

##### `platformId`<sup>Optional</sup> <a name="platformId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#platform_id ComputeInstanceGroup#platform_id}.

---

##### `schedulingPolicy`<sup>Optional</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: ComputeInstanceGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a>

scheduling_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#scheduling_policy ComputeInstanceGroup#scheduling_policy}

---

##### `secondaryDisk`<sup>Optional</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]

secondary_disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#secondary_disk ComputeInstanceGroup#secondary_disk}

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service_account_id ComputeInstanceGroup#service_account_id}.

---

### ComputeInstanceGroupInstanceTemplateBootDisk <a name="ComputeInstanceGroupInstanceTemplateBootDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateBootDisk } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateBootDisk: ComputeInstanceGroupInstanceTemplateBootDisk = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.deviceName">deviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.diskId">diskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a></code> | initialize_params block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.mode">mode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}. |

---

##### `deviceName`<sup>Optional</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}.

---

##### `diskId`<sup>Optional</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}.

---

##### `initializeParams`<sup>Optional</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a>

initialize_params block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initialize_params ComputeInstanceGroup#initialize_params}

---

##### `mode`<sup>Optional</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}.

---

### ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams <a name="ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateBootDiskInitializeParams: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.imageId">imageId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.snapshotId">snapshotId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}. |

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}.

---

##### `imageId`<sup>Optional</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}.

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}.

---

##### `snapshotId`<sup>Optional</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}.

---

### ComputeInstanceGroupInstanceTemplateNetworkInterface <a name="ComputeInstanceGroupInstanceTemplateNetworkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterface } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateNetworkInterface: ComputeInstanceGroupInstanceTemplateNetworkInterface = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.dnsRecord">dnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]</code> | dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipAddress">ipAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ip_address ComputeInstanceGroup#ip_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv4 ComputeInstanceGroup#ipv4}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6 ComputeInstanceGroup#ipv6}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6_address ComputeInstanceGroup#ipv6_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]</code> | ipv6_dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat ComputeInstanceGroup#nat}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.natDnsRecord">natDnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]</code> | nat_dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat_ip_address ComputeInstanceGroup#nat_ip_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_id ComputeInstanceGroup#network_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#security_group_ids ComputeInstanceGroup#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#subnet_ids ComputeInstanceGroup#subnet_ids}. |

---

##### `dnsRecord`<sup>Optional</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]

dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_record ComputeInstanceGroup#dns_record}

---

##### `ipAddress`<sup>Optional</sup> <a name="ipAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ip_address ComputeInstanceGroup#ip_address}.

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv4 ComputeInstanceGroup#ipv4}.

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6 ComputeInstanceGroup#ipv6}.

---

##### `ipv6Address`<sup>Optional</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6_address ComputeInstanceGroup#ipv6_address}.

---

##### `ipv6DnsRecord`<sup>Optional</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]

ipv6_dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ipv6_dns_record ComputeInstanceGroup#ipv6_dns_record}

---

##### `nat`<sup>Optional</sup> <a name="nat" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat ComputeInstanceGroup#nat}.

---

##### `natDnsRecord`<sup>Optional</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]

nat_dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat_dns_record ComputeInstanceGroup#nat_dns_record}

---

##### `natIpAddress`<sup>Optional</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#nat_ip_address ComputeInstanceGroup#nat_ip_address}.

---

##### `networkId`<sup>Optional</sup> <a name="networkId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#network_id ComputeInstanceGroup#network_id}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#security_group_ids ComputeInstanceGroup#security_group_ids}.

---

##### `subnetIds`<sup>Optional</sup> <a name="subnetIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#subnet_ids ComputeInstanceGroup#subnet_ids}.

---

### ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}.

---

### ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}.

---

### ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fqdn ComputeInstanceGroup#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#dns_zone_id ComputeInstanceGroup#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ptr ComputeInstanceGroup#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#ttl ComputeInstanceGroup#ttl}.

---

### ComputeInstanceGroupInstanceTemplateNetworkSettings <a name="ComputeInstanceGroupInstanceTemplateNetworkSettings" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkSettings } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateNetworkSettings: ComputeInstanceGroupInstanceTemplateNetworkSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}. |

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}.

---

### ComputeInstanceGroupInstanceTemplatePlacementPolicy <a name="ComputeInstanceGroupInstanceTemplatePlacementPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplatePlacementPolicy } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplatePlacementPolicy: ComputeInstanceGroupInstanceTemplatePlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#placement_group_id ComputeInstanceGroup#placement_group_id}. |

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#placement_group_id ComputeInstanceGroup#placement_group_id}.

---

### ComputeInstanceGroupInstanceTemplateResources <a name="ComputeInstanceGroupInstanceTemplateResources" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateResources } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateResources: ComputeInstanceGroupInstanceTemplateResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.cores">cores</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cores ComputeInstanceGroup#cores}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.memory">memory</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#memory ComputeInstanceGroup#memory}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.coreFraction">coreFraction</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#core_fraction ComputeInstanceGroup#core_fraction}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.gpus">gpus</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#gpus ComputeInstanceGroup#gpus}. |

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cores ComputeInstanceGroup#cores}.

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#memory ComputeInstanceGroup#memory}.

---

##### `coreFraction`<sup>Optional</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#core_fraction ComputeInstanceGroup#core_fraction}.

---

##### `gpus`<sup>Optional</sup> <a name="gpus" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#gpus ComputeInstanceGroup#gpus}.

---

### ComputeInstanceGroupInstanceTemplateSchedulingPolicy <a name="ComputeInstanceGroupInstanceTemplateSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSchedulingPolicy } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateSchedulingPolicy: ComputeInstanceGroupInstanceTemplateSchedulingPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#preemptible ComputeInstanceGroup#preemptible}. |

---

##### `preemptible`<sup>Optional</sup> <a name="preemptible" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#preemptible ComputeInstanceGroup#preemptible}.

---

### ComputeInstanceGroupInstanceTemplateSecondaryDisk <a name="ComputeInstanceGroupInstanceTemplateSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSecondaryDisk } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateSecondaryDisk: ComputeInstanceGroupInstanceTemplateSecondaryDisk = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.deviceName">deviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.diskId">diskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a></code> | initialize_params block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.mode">mode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}. |

---

##### `deviceName`<sup>Optional</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#device_name ComputeInstanceGroup#device_name}.

---

##### `diskId`<sup>Optional</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#disk_id ComputeInstanceGroup#disk_id}.

---

##### `initializeParams`<sup>Optional</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a>

initialize_params block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initialize_params ComputeInstanceGroup#initialize_params}

---

##### `mode`<sup>Optional</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#mode ComputeInstanceGroup#mode}.

---

### ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams <a name="ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams } from '@cdktf/provider-yandex'

const computeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.imageId">imageId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.snapshotId">snapshotId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}. |

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#description ComputeInstanceGroup#description}.

---

##### `imageId`<sup>Optional</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#image_id ComputeInstanceGroup#image_id}.

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}.

---

##### `snapshotId`<sup>Optional</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#snapshot_id ComputeInstanceGroup#snapshot_id}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#type ComputeInstanceGroup#type}.

---

### ComputeInstanceGroupLoadBalancer <a name="ComputeInstanceGroupLoadBalancer" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.Initializer"></a>

```typescript
import { ComputeInstanceGroupLoadBalancer } from '@cdktf/provider-yandex'

const computeInstanceGroupLoadBalancer: ComputeInstanceGroupLoadBalancer = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupLabels">targetGroupLabels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}. |

---

##### `maxOpeningTrafficDuration`<sup>Optional</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_opening_traffic_duration ComputeInstanceGroup#max_opening_traffic_duration}.

---

##### `targetGroupDescription`<sup>Optional</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_description ComputeInstanceGroup#target_group_description}.

---

##### `targetGroupLabels`<sup>Optional</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_labels ComputeInstanceGroup#target_group_labels}.

---

##### `targetGroupName`<sup>Optional</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target_group_name ComputeInstanceGroup#target_group_name}.

---

### ComputeInstanceGroupScalePolicy <a name="ComputeInstanceGroupScalePolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicy } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicy: ComputeInstanceGroupScalePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a></code> | auto_scale block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a></code> | fixed_scale block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.testAutoScale">testAutoScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a></code> | test_auto_scale block. |

---

##### `autoScale`<sup>Optional</sup> <a name="autoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.autoScale"></a>

```typescript
public readonly autoScale: ComputeInstanceGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a>

auto_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#auto_scale ComputeInstanceGroup#auto_scale}

---

##### `fixedScale`<sup>Optional</sup> <a name="fixedScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.fixedScale"></a>

```typescript
public readonly fixedScale: ComputeInstanceGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a>

fixed_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#fixed_scale ComputeInstanceGroup#fixed_scale}

---

##### `testAutoScale`<sup>Optional</sup> <a name="testAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy.property.testAutoScale"></a>

```typescript
public readonly testAutoScale: ComputeInstanceGroupScalePolicyTestAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a>

test_auto_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#test_auto_scale ComputeInstanceGroup#test_auto_scale}

---

### ComputeInstanceGroupScalePolicyAutoScale <a name="ComputeInstanceGroupScalePolicyAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyAutoScale } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicyAutoScale: ComputeInstanceGroupScalePolicyAutoScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.initialSize">initialSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.customRule">customRule</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]</code> | custom_rule block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.maxSize">maxSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}. |

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}.

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}.

---

##### `cpuUtilizationTarget`<sup>Optional</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}.

---

##### `customRule`<sup>Optional</sup> <a name="customRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.customRule"></a>

```typescript
public readonly customRule: IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]

custom_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#custom_rule ComputeInstanceGroup#custom_rule}

---

##### `maxSize`<sup>Optional</sup> <a name="maxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}.

---

##### `minZoneSize`<sup>Optional</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}.

---

##### `stabilizationDuration`<sup>Optional</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}.

---

##### `warmupDuration`<sup>Optional</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}.

---

### ComputeInstanceGroupScalePolicyAutoScaleCustomRule <a name="ComputeInstanceGroupScalePolicyAutoScaleCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyAutoScaleCustomRule } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicyAutoScaleCustomRule: ComputeInstanceGroupScalePolicyAutoScaleCustomRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.metricName">metricName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.metricType">metricType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.ruleType">ruleType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.target">target</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.service">service</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}. |

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}.

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}.

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}.

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}.

---

##### `service`<sup>Optional</sup> <a name="service" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}.

---

### ComputeInstanceGroupScalePolicyFixedScale <a name="ComputeInstanceGroupScalePolicyFixedScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyFixedScale } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicyFixedScale: ComputeInstanceGroupScalePolicyFixedScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}. |

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#size ComputeInstanceGroup#size}.

---

### ComputeInstanceGroupScalePolicyTestAutoScale <a name="ComputeInstanceGroupScalePolicyTestAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyTestAutoScale } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicyTestAutoScale: ComputeInstanceGroupScalePolicyTestAutoScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.initialSize">initialSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.customRule">customRule</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]</code> | custom_rule block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.maxSize">maxSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}. |

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#initial_size ComputeInstanceGroup#initial_size}.

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#measurement_duration ComputeInstanceGroup#measurement_duration}.

---

##### `cpuUtilizationTarget`<sup>Optional</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#cpu_utilization_target ComputeInstanceGroup#cpu_utilization_target}.

---

##### `customRule`<sup>Optional</sup> <a name="customRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.customRule"></a>

```typescript
public readonly customRule: IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]

custom_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#custom_rule ComputeInstanceGroup#custom_rule}

---

##### `maxSize`<sup>Optional</sup> <a name="maxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#max_size ComputeInstanceGroup#max_size}.

---

##### `minZoneSize`<sup>Optional</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#min_zone_size ComputeInstanceGroup#min_zone_size}.

---

##### `stabilizationDuration`<sup>Optional</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#stabilization_duration ComputeInstanceGroup#stabilization_duration}.

---

##### `warmupDuration`<sup>Optional</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#warmup_duration ComputeInstanceGroup#warmup_duration}.

---

### ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule <a name="ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule } from '@cdktf/provider-yandex'

const computeInstanceGroupScalePolicyTestAutoScaleCustomRule: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.metricName">metricName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.metricType">metricType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.ruleType">ruleType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.target">target</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.service">service</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}. |

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_name ComputeInstanceGroup#metric_name}.

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#metric_type ComputeInstanceGroup#metric_type}.

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#rule_type ComputeInstanceGroup#rule_type}.

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#target ComputeInstanceGroup#target}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#folder_id ComputeInstanceGroup#folder_id}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#labels ComputeInstanceGroup#labels}.

---

##### `service`<sup>Optional</sup> <a name="service" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#service ComputeInstanceGroup#service}.

---

### ComputeInstanceGroupTimeouts <a name="ComputeInstanceGroupTimeouts" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.Initializer"></a>

```typescript
import { ComputeInstanceGroupTimeouts } from '@cdktf/provider-yandex'

const computeInstanceGroupTimeouts: ComputeInstanceGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#create ComputeInstanceGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#delete ComputeInstanceGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#update ComputeInstanceGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#create ComputeInstanceGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#delete ComputeInstanceGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance_group#update ComputeInstanceGroup#update}.

---

### ComputeInstanceNetworkInterface <a name="ComputeInstanceNetworkInterface" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterface } from '@cdktf/provider-yandex'

const computeInstanceNetworkInterface: ComputeInstanceNetworkInterface = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#subnet_id ComputeInstance#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.dnsRecord">dnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]</code> | dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipAddress">ipAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ip_address ComputeInstance#ip_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv4 ComputeInstance#ipv4}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv6 ComputeInstance#ipv6}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv6_address ComputeInstance#ipv6_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]</code> | ipv6_dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#nat ComputeInstance#nat}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.natDnsRecord">natDnsRecord</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]</code> | nat_dns_record block. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#nat_ip_address ComputeInstance#nat_ip_address}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#security_group_ids ComputeInstance#security_group_ids}. |

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#subnet_id ComputeInstance#subnet_id}.

---

##### `dnsRecord`<sup>Optional</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: IResolvable | ComputeInstanceNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]

dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_record ComputeInstance#dns_record}

---

##### `ipAddress`<sup>Optional</sup> <a name="ipAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ip_address ComputeInstance#ip_address}.

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv4 ComputeInstance#ipv4}.

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv6 ComputeInstance#ipv6}.

---

##### `ipv6Address`<sup>Optional</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv6_address ComputeInstance#ipv6_address}.

---

##### `ipv6DnsRecord`<sup>Optional</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: IResolvable | ComputeInstanceNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]

ipv6_dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ipv6_dns_record ComputeInstance#ipv6_dns_record}

---

##### `nat`<sup>Optional</sup> <a name="nat" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#nat ComputeInstance#nat}.

---

##### `natDnsRecord`<sup>Optional</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: IResolvable | ComputeInstanceNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]

nat_dns_record block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#nat_dns_record ComputeInstance#nat_dns_record}

---

##### `natIpAddress`<sup>Optional</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#nat_ip_address ComputeInstance#nat_ip_address}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterface.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#security_group_ids ComputeInstance#security_group_ids}.

---

### ComputeInstanceNetworkInterfaceDnsRecord <a name="ComputeInstanceNetworkInterfaceDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceDnsRecord } from '@cdktf/provider-yandex'

const computeInstanceNetworkInterfaceDnsRecord: ComputeInstanceNetworkInterfaceDnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}.

---

### ComputeInstanceNetworkInterfaceIpv6DnsRecord <a name="ComputeInstanceNetworkInterfaceIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceIpv6DnsRecord } from '@cdktf/provider-yandex'

const computeInstanceNetworkInterfaceIpv6DnsRecord: ComputeInstanceNetworkInterfaceIpv6DnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}.

---

### ComputeInstanceNetworkInterfaceNatDnsRecord <a name="ComputeInstanceNetworkInterfaceNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceNatDnsRecord } from '@cdktf/provider-yandex'

const computeInstanceNetworkInterfaceNatDnsRecord: ComputeInstanceNetworkInterfaceNatDnsRecord = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.fqdn">fqdn</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}. |

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#fqdn ComputeInstance#fqdn}.

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#dns_zone_id ComputeInstance#dns_zone_id}.

---

##### `ptr`<sup>Optional</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ptr ComputeInstance#ptr}.

---

##### `ttl`<sup>Optional</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#ttl ComputeInstance#ttl}.

---

### ComputeInstancePlacementPolicy <a name="ComputeInstancePlacementPolicy" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicy.Initializer"></a>

```typescript
import { ComputeInstancePlacementPolicy } from '@cdktf/provider-yandex'

const computeInstancePlacementPolicy: ComputeInstancePlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy.property.hostAffinityRules">hostAffinityRules</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#host_affinity_rules ComputeInstance#host_affinity_rules}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#placement_group_id ComputeInstance#placement_group_id}. |

---

##### `hostAffinityRules`<sup>Optional</sup> <a name="hostAffinityRules" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicy.property.hostAffinityRules"></a>

```typescript
public readonly hostAffinityRules: IResolvable | ComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#host_affinity_rules ComputeInstance#host_affinity_rules}.

---

##### `placementGroupId`<sup>Optional</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicy.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#placement_group_id ComputeInstance#placement_group_id}.

---

### ComputeInstancePlacementPolicyHostAffinityRules <a name="ComputeInstancePlacementPolicyHostAffinityRules" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.Initializer"></a>

```typescript
import { ComputeInstancePlacementPolicyHostAffinityRules } from '@cdktf/provider-yandex'

const computeInstancePlacementPolicyHostAffinityRules: ComputeInstancePlacementPolicyHostAffinityRules = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.key">key</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#key ComputeInstance#key}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.op">op</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#op ComputeInstance#op}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.values">values</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#values ComputeInstance#values}. |

---

##### `key`<sup>Optional</sup> <a name="key" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#key ComputeInstance#key}.

---

##### `op`<sup>Optional</sup> <a name="op" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.op"></a>

```typescript
public readonly op: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#op ComputeInstance#op}.

---

##### `values`<sup>Optional</sup> <a name="values" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#values ComputeInstance#values}.

---

### ComputeInstanceResources <a name="ComputeInstanceResources" id="@cdktf/provider-yandex.ComputeInstanceResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceResources.Initializer"></a>

```typescript
import { ComputeInstanceResources } from '@cdktf/provider-yandex'

const computeInstanceResources: ComputeInstanceResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources.property.cores">cores</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#cores ComputeInstance#cores}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources.property.memory">memory</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#memory ComputeInstance#memory}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources.property.coreFraction">coreFraction</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#core_fraction ComputeInstance#core_fraction}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources.property.gpus">gpus</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#gpus ComputeInstance#gpus}. |

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.ComputeInstanceResources.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#cores ComputeInstance#cores}.

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ComputeInstanceResources.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#memory ComputeInstance#memory}.

---

##### `coreFraction`<sup>Optional</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ComputeInstanceResources.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#core_fraction ComputeInstance#core_fraction}.

---

##### `gpus`<sup>Optional</sup> <a name="gpus" id="@cdktf/provider-yandex.ComputeInstanceResources.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#gpus ComputeInstance#gpus}.

---

### ComputeInstanceSchedulingPolicy <a name="ComputeInstanceSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy.Initializer"></a>

```typescript
import { ComputeInstanceSchedulingPolicy } from '@cdktf/provider-yandex'

const computeInstanceSchedulingPolicy: ComputeInstanceSchedulingPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#preemptible ComputeInstance#preemptible}. |

---

##### `preemptible`<sup>Optional</sup> <a name="preemptible" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#preemptible ComputeInstance#preemptible}.

---

### ComputeInstanceSecondaryDisk <a name="ComputeInstanceSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.Initializer"></a>

```typescript
import { ComputeInstanceSecondaryDisk } from '@cdktf/provider-yandex'

const computeInstanceSecondaryDisk: ComputeInstanceSecondaryDisk = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.diskId">diskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#disk_id ComputeInstance#disk_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.autoDelete">autoDelete</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#auto_delete ComputeInstance#auto_delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.deviceName">deviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#device_name ComputeInstance#device_name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.mode">mode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#mode ComputeInstance#mode}. |

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#disk_id ComputeInstance#disk_id}.

---

##### `autoDelete`<sup>Optional</sup> <a name="autoDelete" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.autoDelete"></a>

```typescript
public readonly autoDelete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#auto_delete ComputeInstance#auto_delete}.

---

##### `deviceName`<sup>Optional</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#device_name ComputeInstance#device_name}.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDisk.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#mode ComputeInstance#mode}.

---

### ComputeInstanceTimeouts <a name="ComputeInstanceTimeouts" id="@cdktf/provider-yandex.ComputeInstanceTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeInstanceTimeouts.Initializer"></a>

```typescript
import { ComputeInstanceTimeouts } from '@cdktf/provider-yandex'

const computeInstanceTimeouts: ComputeInstanceTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#create ComputeInstance#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#delete ComputeInstance#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#update ComputeInstance#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeInstanceTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#create ComputeInstance#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeInstanceTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#delete ComputeInstance#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeInstanceTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_instance#update ComputeInstance#update}.

---

### ComputePlacementGroupConfig <a name="ComputePlacementGroupConfig" id="@cdktf/provider-yandex.ComputePlacementGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.Initializer"></a>

```typescript
import { ComputePlacementGroupConfig } from '@cdktf/provider-yandex'

const computePlacementGroupConfig: ComputePlacementGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#description ComputePlacementGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#folder_id ComputePlacementGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#id ComputePlacementGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#labels ComputePlacementGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#name ComputePlacementGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#description ComputePlacementGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#folder_id ComputePlacementGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#id ComputePlacementGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#labels ComputePlacementGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#name ComputePlacementGroup#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputePlacementGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputePlacementGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#timeouts ComputePlacementGroup#timeouts}

---

### ComputePlacementGroupTimeouts <a name="ComputePlacementGroupTimeouts" id="@cdktf/provider-yandex.ComputePlacementGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputePlacementGroupTimeouts.Initializer"></a>

```typescript
import { ComputePlacementGroupTimeouts } from '@cdktf/provider-yandex'

const computePlacementGroupTimeouts: ComputePlacementGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#create ComputePlacementGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#delete ComputePlacementGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#update ComputePlacementGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#create ComputePlacementGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#delete ComputePlacementGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputePlacementGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_placement_group#update ComputePlacementGroup#update}.

---

### ComputeSnapshotConfig <a name="ComputeSnapshotConfig" id="@cdktf/provider-yandex.ComputeSnapshotConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeSnapshotConfig.Initializer"></a>

```typescript
import { ComputeSnapshotConfig } from '@cdktf/provider-yandex'

const computeSnapshotConfig: ComputeSnapshotConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.sourceDiskId">sourceDiskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#source_disk_id ComputeSnapshot#source_disk_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#description ComputeSnapshot#description}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#folder_id ComputeSnapshot#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#id ComputeSnapshot#id}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#labels ComputeSnapshot#labels}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#name ComputeSnapshot#name}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `sourceDiskId`<sup>Required</sup> <a name="sourceDiskId" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.sourceDiskId"></a>

```typescript
public readonly sourceDiskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#source_disk_id ComputeSnapshot#source_disk_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#description ComputeSnapshot#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#folder_id ComputeSnapshot#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#id ComputeSnapshot#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#labels ComputeSnapshot#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#name ComputeSnapshot#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ComputeSnapshotConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ComputeSnapshotTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#timeouts ComputeSnapshot#timeouts}

---

### ComputeSnapshotTimeouts <a name="ComputeSnapshotTimeouts" id="@cdktf/provider-yandex.ComputeSnapshotTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ComputeSnapshotTimeouts.Initializer"></a>

```typescript
import { ComputeSnapshotTimeouts } from '@cdktf/provider-yandex'

const computeSnapshotTimeouts: ComputeSnapshotTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#create ComputeSnapshot#create}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#delete ComputeSnapshot#delete}. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#update ComputeSnapshot#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#create ComputeSnapshot#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#delete ComputeSnapshot#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ComputeSnapshotTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/compute_snapshot#update ComputeSnapshot#update}.

---

### ContainerRegistryConfig <a name="ContainerRegistryConfig" id="@cdktf/provider-yandex.ContainerRegistryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRegistryConfig.Initializer"></a>

```typescript
import { ContainerRegistryConfig } from '@cdktf/provider-yandex'

const containerRegistryConfig: ContainerRegistryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#folder_id ContainerRegistry#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#id ContainerRegistry#id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#labels ContainerRegistry#labels}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#name ContainerRegistry#name}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#folder_id ContainerRegistry#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#id ContainerRegistry#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#labels ContainerRegistry#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#name ContainerRegistry#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ContainerRegistryConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ContainerRegistryTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#timeouts ContainerRegistry#timeouts}

---

### ContainerRegistryIamBindingConfig <a name="ContainerRegistryIamBindingConfig" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.Initializer"></a>

```typescript
import { ContainerRegistryIamBindingConfig } from '@cdktf/provider-yandex'

const containerRegistryIamBindingConfig: ContainerRegistryIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#members ContainerRegistryIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.registryId">registryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#registry_id ContainerRegistryIamBinding#registry_id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#role ContainerRegistryIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#id ContainerRegistryIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#sleep_after ContainerRegistryIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#members ContainerRegistryIamBinding#members}.

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#registry_id ContainerRegistryIamBinding#registry_id}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#role ContainerRegistryIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#id ContainerRegistryIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ContainerRegistryIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry_iam_binding#sleep_after ContainerRegistryIamBinding#sleep_after}.

---

### ContainerRegistryTimeouts <a name="ContainerRegistryTimeouts" id="@cdktf/provider-yandex.ContainerRegistryTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRegistryTimeouts.Initializer"></a>

```typescript
import { ContainerRegistryTimeouts } from '@cdktf/provider-yandex'

const containerRegistryTimeouts: ContainerRegistryTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#create ContainerRegistry#create}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#delete ContainerRegistry#delete}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#update ContainerRegistry#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ContainerRegistryTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#create ContainerRegistry#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ContainerRegistryTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#delete ContainerRegistry#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ContainerRegistryTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_registry#update ContainerRegistry#update}.

---

### ContainerRepositoryConfig <a name="ContainerRepositoryConfig" id="@cdktf/provider-yandex.ContainerRepositoryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRepositoryConfig.Initializer"></a>

```typescript
import { ContainerRepositoryConfig } from '@cdktf/provider-yandex'

const containerRepositoryConfig: ContainerRepositoryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#id ContainerRepository#id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#name ContainerRepository#name}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#id ContainerRepository#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#name ContainerRepository#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ContainerRepositoryConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ContainerRepositoryTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#timeouts ContainerRepository#timeouts}

---

### ContainerRepositoryIamBindingConfig <a name="ContainerRepositoryIamBindingConfig" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.Initializer"></a>

```typescript
import { ContainerRepositoryIamBindingConfig } from '@cdktf/provider-yandex'

const containerRepositoryIamBindingConfig: ContainerRepositoryIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#members ContainerRepositoryIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.repositoryId">repositoryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#repository_id ContainerRepositoryIamBinding#repository_id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#role ContainerRepositoryIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#id ContainerRepositoryIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#sleep_after ContainerRepositoryIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#members ContainerRepositoryIamBinding#members}.

---

##### `repositoryId`<sup>Required</sup> <a name="repositoryId" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.repositoryId"></a>

```typescript
public readonly repositoryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#repository_id ContainerRepositoryIamBinding#repository_id}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#role ContainerRepositoryIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#id ContainerRepositoryIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ContainerRepositoryIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository_iam_binding#sleep_after ContainerRepositoryIamBinding#sleep_after}.

---

### ContainerRepositoryTimeouts <a name="ContainerRepositoryTimeouts" id="@cdktf/provider-yandex.ContainerRepositoryTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ContainerRepositoryTimeouts.Initializer"></a>

```typescript
import { ContainerRepositoryTimeouts } from '@cdktf/provider-yandex'

const containerRepositoryTimeouts: ContainerRepositoryTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#create ContainerRepository#create}. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#delete ContainerRepository#delete}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ContainerRepositoryTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#create ContainerRepository#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ContainerRepositoryTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/container_repository#delete ContainerRepository#delete}.

---

### DataprocClusterClusterConfig <a name="DataprocClusterClusterConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterClusterConfig.Initializer"></a>

```typescript
import { DataprocClusterClusterConfig } from '@cdktf/provider-yandex'

const dataprocClusterClusterConfig: DataprocClusterClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig.property.subclusterSpec">subclusterSpec</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]</code> | subcluster_spec block. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig.property.hadoop">hadoop</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a></code> | hadoop block. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig.property.versionId">versionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#version_id DataprocCluster#version_id}. |

---

##### `subclusterSpec`<sup>Required</sup> <a name="subclusterSpec" id="@cdktf/provider-yandex.DataprocClusterClusterConfig.property.subclusterSpec"></a>

```typescript
public readonly subclusterSpec: IResolvable | DataprocClusterClusterConfigSubclusterSpec[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]

subcluster_spec block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#subcluster_spec DataprocCluster#subcluster_spec}

---

##### `hadoop`<sup>Optional</sup> <a name="hadoop" id="@cdktf/provider-yandex.DataprocClusterClusterConfig.property.hadoop"></a>

```typescript
public readonly hadoop: DataprocClusterClusterConfigHadoop;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a>

hadoop block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#hadoop DataprocCluster#hadoop}

---

##### `versionId`<sup>Optional</sup> <a name="versionId" id="@cdktf/provider-yandex.DataprocClusterClusterConfig.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#version_id DataprocCluster#version_id}.

---

### DataprocClusterClusterConfigHadoop <a name="DataprocClusterClusterConfigHadoop" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigHadoop } from '@cdktf/provider-yandex'

const dataprocClusterClusterConfigHadoop: DataprocClusterClusterConfigHadoop = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.properties">properties</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#properties DataprocCluster#properties}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.services">services</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#services DataprocCluster#services}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.sshPublicKeys">sshPublicKeys</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#ssh_public_keys DataprocCluster#ssh_public_keys}. |

---

##### `properties`<sup>Optional</sup> <a name="properties" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#properties DataprocCluster#properties}.

---

##### `services`<sup>Optional</sup> <a name="services" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.services"></a>

```typescript
public readonly services: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#services DataprocCluster#services}.

---

##### `sshPublicKeys`<sup>Optional</sup> <a name="sshPublicKeys" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop.property.sshPublicKeys"></a>

```typescript
public readonly sshPublicKeys: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#ssh_public_keys DataprocCluster#ssh_public_keys}.

---

### DataprocClusterClusterConfigSubclusterSpec <a name="DataprocClusterClusterConfigSubclusterSpec" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpec } from '@cdktf/provider-yandex'

const dataprocClusterClusterConfigSubclusterSpec: DataprocClusterClusterConfigSubclusterSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.hostsCount">hostsCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#hosts_count DataprocCluster#hosts_count}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#name DataprocCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#role DataprocCluster#role}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#subnet_id DataprocCluster#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#assign_public_ip DataprocCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.autoscalingConfig">autoscalingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a></code> | autoscaling_config block. |

---

##### `hostsCount`<sup>Required</sup> <a name="hostsCount" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.hostsCount"></a>

```typescript
public readonly hostsCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#hosts_count DataprocCluster#hosts_count}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#name DataprocCluster#name}.

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.resources"></a>

```typescript
public readonly resources: DataprocClusterClusterConfigSubclusterSpecResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#resources DataprocCluster#resources}

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#role DataprocCluster#role}.

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#subnet_id DataprocCluster#subnet_id}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#assign_public_ip DataprocCluster#assign_public_ip}.

---

##### `autoscalingConfig`<sup>Optional</sup> <a name="autoscalingConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec.property.autoscalingConfig"></a>

```typescript
public readonly autoscalingConfig: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a>

autoscaling_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#autoscaling_config DataprocCluster#autoscaling_config}

---

### DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig <a name="DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig } from '@cdktf/provider-yandex'

const dataprocClusterClusterConfigSubclusterSpecAutoscalingConfig: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.maxHostsCount">maxHostsCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#max_hosts_count DataprocCluster#max_hosts_count}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#cpu_utilization_target DataprocCluster#cpu_utilization_target}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.decommissionTimeout">decommissionTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#decommission_timeout DataprocCluster#decommission_timeout}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#measurement_duration DataprocCluster#measurement_duration}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#preemptible DataprocCluster#preemptible}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#stabilization_duration DataprocCluster#stabilization_duration}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#warmup_duration DataprocCluster#warmup_duration}. |

---

##### `maxHostsCount`<sup>Required</sup> <a name="maxHostsCount" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.maxHostsCount"></a>

```typescript
public readonly maxHostsCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#max_hosts_count DataprocCluster#max_hosts_count}.

---

##### `cpuUtilizationTarget`<sup>Optional</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#cpu_utilization_target DataprocCluster#cpu_utilization_target}.

---

##### `decommissionTimeout`<sup>Optional</sup> <a name="decommissionTimeout" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.decommissionTimeout"></a>

```typescript
public readonly decommissionTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#decommission_timeout DataprocCluster#decommission_timeout}.

---

##### `measurementDuration`<sup>Optional</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#measurement_duration DataprocCluster#measurement_duration}.

---

##### `preemptible`<sup>Optional</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#preemptible DataprocCluster#preemptible}.

---

##### `stabilizationDuration`<sup>Optional</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#stabilization_duration DataprocCluster#stabilization_duration}.

---

##### `warmupDuration`<sup>Optional</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#warmup_duration DataprocCluster#warmup_duration}.

---

### DataprocClusterClusterConfigSubclusterSpecResources <a name="DataprocClusterClusterConfigSubclusterSpecResources" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecResources } from '@cdktf/provider-yandex'

const dataprocClusterClusterConfigSubclusterSpecResources: DataprocClusterClusterConfigSubclusterSpecResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#disk_size DataprocCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#resource_preset_id DataprocCluster#resource_preset_id}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#disk_type_id DataprocCluster#disk_type_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#disk_size DataprocCluster#disk_size}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#resource_preset_id DataprocCluster#resource_preset_id}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#disk_type_id DataprocCluster#disk_type_id}.

---

### DataprocClusterConfig <a name="DataprocClusterConfig" id="@cdktf/provider-yandex.DataprocClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterConfig.Initializer"></a>

```typescript
import { DataprocClusterConfig } from '@cdktf/provider-yandex'

const dataprocClusterConfig: DataprocClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a></code> | cluster_config block. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#name DataprocCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#service_account_id DataprocCluster#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.bucket">bucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#bucket DataprocCluster#bucket}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#deletion_protection DataprocCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#description DataprocCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#folder_id DataprocCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#host_group_ids DataprocCluster#host_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#id DataprocCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#labels DataprocCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#security_group_ids DataprocCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.uiProxy">uiProxy</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#ui_proxy DataprocCluster#ui_proxy}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterConfig.property.zoneId">zoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#zone_id DataprocCluster#zone_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataprocClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataprocClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataprocClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataprocClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.DataprocClusterConfig.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: DataprocClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a>

cluster_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#cluster_config DataprocCluster#cluster_config}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataprocClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#name DataprocCluster#name}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataprocClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#service_account_id DataprocCluster#service_account_id}.

---

##### `bucket`<sup>Optional</sup> <a name="bucket" id="@cdktf/provider-yandex.DataprocClusterConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#bucket DataprocCluster#bucket}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataprocClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#deletion_protection DataprocCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataprocClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#description DataprocCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataprocClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#folder_id DataprocCluster#folder_id}.

---

##### `hostGroupIds`<sup>Optional</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.DataprocClusterConfig.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#host_group_ids DataprocCluster#host_group_ids}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataprocClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#id DataprocCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataprocClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#labels DataprocCluster#labels}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataprocClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#security_group_ids DataprocCluster#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataprocClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: DataprocClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#timeouts DataprocCluster#timeouts}

---

##### `uiProxy`<sup>Optional</sup> <a name="uiProxy" id="@cdktf/provider-yandex.DataprocClusterConfig.property.uiProxy"></a>

```typescript
public readonly uiProxy: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#ui_proxy DataprocCluster#ui_proxy}.

---

##### `zoneId`<sup>Optional</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataprocClusterConfig.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#zone_id DataprocCluster#zone_id}.

---

### DataprocClusterTimeouts <a name="DataprocClusterTimeouts" id="@cdktf/provider-yandex.DataprocClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataprocClusterTimeouts.Initializer"></a>

```typescript
import { DataprocClusterTimeouts } from '@cdktf/provider-yandex'

const dataprocClusterTimeouts: DataprocClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#create DataprocCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#delete DataprocCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#update DataprocCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.DataprocClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#create DataprocCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.DataprocClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#delete DataprocCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.DataprocClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dataproc_cluster#update DataprocCluster#update}.

---

### DatatransferEndpointConfig <a name="DatatransferEndpointConfig" id="@cdktf/provider-yandex.DatatransferEndpointConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointConfig.Initializer"></a>

```typescript
import { DatatransferEndpointConfig } from '@cdktf/provider-yandex'

const datatransferEndpointConfig: DatatransferEndpointConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#description DatatransferEndpoint#description}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#folder_id DatatransferEndpoint#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#id DatatransferEndpoint#id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#labels DatatransferEndpoint#labels}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointConfig.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a></code> | settings block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#description DatatransferEndpoint#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#folder_id DatatransferEndpoint#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#id DatatransferEndpoint#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#labels DatatransferEndpoint#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#name DatatransferEndpoint#name}.

---

##### `settings`<sup>Optional</sup> <a name="settings" id="@cdktf/provider-yandex.DatatransferEndpointConfig.property.settings"></a>

```typescript
public readonly settings: DatatransferEndpointSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a>

settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#settings DatatransferEndpoint#settings}

---

### DatatransferEndpointSettings <a name="DatatransferEndpointSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettings.Initializer"></a>

```typescript
import { DatatransferEndpointSettings } from '@cdktf/provider-yandex'

const datatransferEndpointSettings: DatatransferEndpointSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings.property.mysqlSource">mysqlSource</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a></code> | mysql_source block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings.property.mysqlTarget">mysqlTarget</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a></code> | mysql_target block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings.property.postgresSource">postgresSource</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a></code> | postgres_source block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings.property.postgresTarget">postgresTarget</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a></code> | postgres_target block. |

---

##### `mysqlSource`<sup>Optional</sup> <a name="mysqlSource" id="@cdktf/provider-yandex.DatatransferEndpointSettings.property.mysqlSource"></a>

```typescript
public readonly mysqlSource: DatatransferEndpointSettingsMysqlSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a>

mysql_source block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_source DatatransferEndpoint#mysql_source}

---

##### `mysqlTarget`<sup>Optional</sup> <a name="mysqlTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettings.property.mysqlTarget"></a>

```typescript
public readonly mysqlTarget: DatatransferEndpointSettingsMysqlTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a>

mysql_target block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mysql_target DatatransferEndpoint#mysql_target}

---

##### `postgresSource`<sup>Optional</sup> <a name="postgresSource" id="@cdktf/provider-yandex.DatatransferEndpointSettings.property.postgresSource"></a>

```typescript
public readonly postgresSource: DatatransferEndpointSettingsPostgresSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a>

postgres_source block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_source DatatransferEndpoint#postgres_source}

---

##### `postgresTarget`<sup>Optional</sup> <a name="postgresTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettings.property.postgresTarget"></a>

```typescript
public readonly postgresTarget: DatatransferEndpointSettingsPostgresTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a>

postgres_target block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#postgres_target DatatransferEndpoint#postgres_target}

---

### DatatransferEndpointSettingsMysqlSource <a name="DatatransferEndpointSettingsMysqlSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSource } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSource: DatatransferEndpointSettingsMysqlSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a></code> | connection block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.database">database</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.excludeTablesRegex">excludeTablesRegex</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables_regex DatatransferEndpoint#exclude_tables_regex}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.includeTablesRegex">includeTablesRegex</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables_regex DatatransferEndpoint#include_tables_regex}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.objectTransferSettings">objectTransferSettings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a></code> | object_transfer_settings block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a></code> | password block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.timezone">timezone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.user">user</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsMysqlSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a>

connection block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}

---

##### `database`<sup>Optional</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}.

---

##### `excludeTablesRegex`<sup>Optional</sup> <a name="excludeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.excludeTablesRegex"></a>

```typescript
public readonly excludeTablesRegex: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables_regex DatatransferEndpoint#exclude_tables_regex}.

---

##### `includeTablesRegex`<sup>Optional</sup> <a name="includeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.includeTablesRegex"></a>

```typescript
public readonly includeTablesRegex: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables_regex DatatransferEndpoint#include_tables_regex}.

---

##### `objectTransferSettings`<sup>Optional</sup> <a name="objectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.objectTransferSettings"></a>

```typescript
public readonly objectTransferSettings: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a>

object_transfer_settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}

---

##### `password`<sup>Optional</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsMysqlSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a>

password block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}

---

##### `timezone`<sup>Optional</sup> <a name="timezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}.

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}.

---

### DatatransferEndpointSettingsMysqlSourceConnection <a name="DatatransferEndpointSettingsMysqlSourceConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnection } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceConnection: DatatransferEndpointSettingsMysqlSourceConnection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a></code> | on_premise block. |

---

##### `mdbClusterId`<sup>Optional</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}.

---

##### `onPremise`<sup>Optional</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a>

on_premise block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}

---

### DatatransferEndpointSettingsMysqlSourceConnectionOnPremise <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremise } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceConnectionOnPremise: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.hosts">hosts</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a></code> | tls_mode block. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}.

---

##### `tlsMode`<sup>Optional</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a>

tls_mode block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}

---

### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a></code> | disabled block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a></code> | enabled block. |

---

##### `disabled`<sup>Optional</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a>

disabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a>

enabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}

---

### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled = { ... }
```


### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

### DatatransferEndpointSettingsMysqlSourceObjectTransferSettings <a name="DatatransferEndpointSettingsMysqlSourceObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceObjectTransferSettings } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourceObjectTransferSettings: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.routine">routine</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#routine DatatransferEndpoint#routine}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.trigger">trigger</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.view">view</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}. |

---

##### `routine`<sup>Optional</sup> <a name="routine" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.routine"></a>

```typescript
public readonly routine: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#routine DatatransferEndpoint#routine}.

---

##### `trigger`<sup>Optional</sup> <a name="trigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.trigger"></a>

```typescript
public readonly trigger: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}.

---

##### `view`<sup>Optional</sup> <a name="view" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings.property.view"></a>

```typescript
public readonly view: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}.

---

### DatatransferEndpointSettingsMysqlSourcePassword <a name="DatatransferEndpointSettingsMysqlSourcePassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourcePassword } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlSourcePassword: DatatransferEndpointSettingsMysqlSourcePassword = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword.property.raw">raw</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}. |

---

##### `raw`<sup>Optional</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}.

---

### DatatransferEndpointSettingsMysqlTarget <a name="DatatransferEndpointSettingsMysqlTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTarget } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTarget: DatatransferEndpointSettingsMysqlTarget = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a></code> | connection block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.database">database</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a></code> | password block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.serviceSchema">serviceSchema</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.skipConstraintChecks">skipConstraintChecks</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#skip_constraint_checks DatatransferEndpoint#skip_constraint_checks}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.sqlMode">sqlMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sql_mode DatatransferEndpoint#sql_mode}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.timezone">timezone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.user">user</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsMysqlTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a>

connection block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}

---

##### `database`<sup>Optional</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}.

---

##### `password`<sup>Optional</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsMysqlTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a>

password block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}

---

##### `serviceSchema`<sup>Optional</sup> <a name="serviceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.serviceSchema"></a>

```typescript
public readonly serviceSchema: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}.

---

##### `skipConstraintChecks`<sup>Optional</sup> <a name="skipConstraintChecks" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.skipConstraintChecks"></a>

```typescript
public readonly skipConstraintChecks: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#skip_constraint_checks DatatransferEndpoint#skip_constraint_checks}.

---

##### `sqlMode`<sup>Optional</sup> <a name="sqlMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.sqlMode"></a>

```typescript
public readonly sqlMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sql_mode DatatransferEndpoint#sql_mode}.

---

##### `timezone`<sup>Optional</sup> <a name="timezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#timezone DatatransferEndpoint#timezone}.

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}.

---

### DatatransferEndpointSettingsMysqlTargetConnection <a name="DatatransferEndpointSettingsMysqlTargetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnection } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetConnection: DatatransferEndpointSettingsMysqlTargetConnection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a></code> | on_premise block. |

---

##### `mdbClusterId`<sup>Optional</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}.

---

##### `onPremise`<sup>Optional</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a>

on_premise block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}

---

### DatatransferEndpointSettingsMysqlTargetConnectionOnPremise <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremise } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetConnectionOnPremise: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.hosts">hosts</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a></code> | tls_mode block. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}.

---

##### `tlsMode`<sup>Optional</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a>

tls_mode block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}

---

### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a></code> | disabled block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a></code> | enabled block. |

---

##### `disabled`<sup>Optional</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a>

disabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a>

enabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}

---

### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled = { ... }
```


### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

### DatatransferEndpointSettingsMysqlTargetPassword <a name="DatatransferEndpointSettingsMysqlTargetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetPassword } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsMysqlTargetPassword: DatatransferEndpointSettingsMysqlTargetPassword = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword.property.raw">raw</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}. |

---

##### `raw`<sup>Optional</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}.

---

### DatatransferEndpointSettingsPostgresSource <a name="DatatransferEndpointSettingsPostgresSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSource } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSource: DatatransferEndpointSettingsPostgresSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.collapseInheritTable">collapseInheritTable</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collapse_inherit_table DatatransferEndpoint#collapse_inherit_table}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a></code> | connection block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.database">database</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.excludeTables">excludeTables</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables DatatransferEndpoint#exclude_tables}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.includeTables">includeTables</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables DatatransferEndpoint#include_tables}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.objectTransferSettings">objectTransferSettings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a></code> | object_transfer_settings block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a></code> | password block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.serviceSchema">serviceSchema</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.slotGigabyteLagLimit">slotGigabyteLagLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#slot_gigabyte_lag_limit DatatransferEndpoint#slot_gigabyte_lag_limit}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.user">user</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}. |

---

##### `collapseInheritTable`<sup>Optional</sup> <a name="collapseInheritTable" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.collapseInheritTable"></a>

```typescript
public readonly collapseInheritTable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collapse_inherit_table DatatransferEndpoint#collapse_inherit_table}.

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsPostgresSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a>

connection block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}

---

##### `database`<sup>Optional</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}.

---

##### `excludeTables`<sup>Optional</sup> <a name="excludeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.excludeTables"></a>

```typescript
public readonly excludeTables: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#exclude_tables DatatransferEndpoint#exclude_tables}.

---

##### `includeTables`<sup>Optional</sup> <a name="includeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.includeTables"></a>

```typescript
public readonly includeTables: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#include_tables DatatransferEndpoint#include_tables}.

---

##### `objectTransferSettings`<sup>Optional</sup> <a name="objectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.objectTransferSettings"></a>

```typescript
public readonly objectTransferSettings: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a>

object_transfer_settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#object_transfer_settings DatatransferEndpoint#object_transfer_settings}

---

##### `password`<sup>Optional</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsPostgresSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a>

password block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}

---

##### `serviceSchema`<sup>Optional</sup> <a name="serviceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.serviceSchema"></a>

```typescript
public readonly serviceSchema: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#service_schema DatatransferEndpoint#service_schema}.

---

##### `slotGigabyteLagLimit`<sup>Optional</sup> <a name="slotGigabyteLagLimit" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.slotGigabyteLagLimit"></a>

```typescript
public readonly slotGigabyteLagLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#slot_gigabyte_lag_limit DatatransferEndpoint#slot_gigabyte_lag_limit}.

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}.

---

### DatatransferEndpointSettingsPostgresSourceConnection <a name="DatatransferEndpointSettingsPostgresSourceConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnection } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceConnection: DatatransferEndpointSettingsPostgresSourceConnection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a></code> | on_premise block. |

---

##### `mdbClusterId`<sup>Optional</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}.

---

##### `onPremise`<sup>Optional</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a>

on_premise block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}

---

### DatatransferEndpointSettingsPostgresSourceConnectionOnPremise <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremise } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceConnectionOnPremise: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.hosts">hosts</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a></code> | tls_mode block. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}.

---

##### `tlsMode`<sup>Optional</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a>

tls_mode block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}

---

### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a></code> | disabled block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a></code> | enabled block. |

---

##### `disabled`<sup>Optional</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a>

disabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a>

enabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}

---

### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled = { ... }
```


### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

### DatatransferEndpointSettingsPostgresSourceObjectTransferSettings <a name="DatatransferEndpointSettingsPostgresSourceObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceObjectTransferSettings } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourceObjectTransferSettings: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.cast">cast</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cast DatatransferEndpoint#cast}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.collation">collation</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collation DatatransferEndpoint#collation}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.constraint">constraint</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#constraint DatatransferEndpoint#constraint}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.defaultValues">defaultValues</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#default_values DatatransferEndpoint#default_values}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.fkConstraint">fkConstraint</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#fk_constraint DatatransferEndpoint#fk_constraint}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.function">function</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#function DatatransferEndpoint#function}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.index">index</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#index DatatransferEndpoint#index}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.policy">policy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#policy DatatransferEndpoint#policy}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.primaryKey">primaryKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#primary_key DatatransferEndpoint#primary_key}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.rule">rule</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#rule DatatransferEndpoint#rule}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.sequence">sequence</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence DatatransferEndpoint#sequence}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.sequenceOwnedBy">sequenceOwnedBy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence_owned_by DatatransferEndpoint#sequence_owned_by}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.table">table</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#table DatatransferEndpoint#table}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.trigger">trigger</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#type DatatransferEndpoint#type}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.view">view</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}. |

---

##### `cast`<sup>Optional</sup> <a name="cast" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.cast"></a>

```typescript
public readonly cast: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#cast DatatransferEndpoint#cast}.

---

##### `collation`<sup>Optional</sup> <a name="collation" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.collation"></a>

```typescript
public readonly collation: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#collation DatatransferEndpoint#collation}.

---

##### `constraint`<sup>Optional</sup> <a name="constraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.constraint"></a>

```typescript
public readonly constraint: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#constraint DatatransferEndpoint#constraint}.

---

##### `defaultValues`<sup>Optional</sup> <a name="defaultValues" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.defaultValues"></a>

```typescript
public readonly defaultValues: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#default_values DatatransferEndpoint#default_values}.

---

##### `fkConstraint`<sup>Optional</sup> <a name="fkConstraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.fkConstraint"></a>

```typescript
public readonly fkConstraint: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#fk_constraint DatatransferEndpoint#fk_constraint}.

---

##### `function`<sup>Optional</sup> <a name="function" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.function"></a>

```typescript
public readonly function: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#function DatatransferEndpoint#function}.

---

##### `index`<sup>Optional</sup> <a name="index" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#index DatatransferEndpoint#index}.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#policy DatatransferEndpoint#policy}.

---

##### `primaryKey`<sup>Optional</sup> <a name="primaryKey" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.primaryKey"></a>

```typescript
public readonly primaryKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#primary_key DatatransferEndpoint#primary_key}.

---

##### `rule`<sup>Optional</sup> <a name="rule" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.rule"></a>

```typescript
public readonly rule: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#rule DatatransferEndpoint#rule}.

---

##### `sequence`<sup>Optional</sup> <a name="sequence" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.sequence"></a>

```typescript
public readonly sequence: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence DatatransferEndpoint#sequence}.

---

##### `sequenceOwnedBy`<sup>Optional</sup> <a name="sequenceOwnedBy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.sequenceOwnedBy"></a>

```typescript
public readonly sequenceOwnedBy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#sequence_owned_by DatatransferEndpoint#sequence_owned_by}.

---

##### `table`<sup>Optional</sup> <a name="table" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.table"></a>

```typescript
public readonly table: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#table DatatransferEndpoint#table}.

---

##### `trigger`<sup>Optional</sup> <a name="trigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.trigger"></a>

```typescript
public readonly trigger: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#trigger DatatransferEndpoint#trigger}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#type DatatransferEndpoint#type}.

---

##### `view`<sup>Optional</sup> <a name="view" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings.property.view"></a>

```typescript
public readonly view: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#view DatatransferEndpoint#view}.

---

### DatatransferEndpointSettingsPostgresSourcePassword <a name="DatatransferEndpointSettingsPostgresSourcePassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourcePassword } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresSourcePassword: DatatransferEndpointSettingsPostgresSourcePassword = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword.property.raw">raw</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}. |

---

##### `raw`<sup>Optional</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}.

---

### DatatransferEndpointSettingsPostgresTarget <a name="DatatransferEndpointSettingsPostgresTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTarget } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTarget: DatatransferEndpointSettingsPostgresTarget = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a></code> | connection block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.database">database</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a></code> | password block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.user">user</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}. |

---

##### `connection`<sup>Optional</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsPostgresTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a>

connection block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#connection DatatransferEndpoint#connection}

---

##### `database`<sup>Optional</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#database DatatransferEndpoint#database}.

---

##### `password`<sup>Optional</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsPostgresTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a>

password block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#password DatatransferEndpoint#password}

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#user DatatransferEndpoint#user}.

---

### DatatransferEndpointSettingsPostgresTargetConnection <a name="DatatransferEndpointSettingsPostgresTargetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnection } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetConnection: DatatransferEndpointSettingsPostgresTargetConnection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a></code> | on_premise block. |

---

##### `mdbClusterId`<sup>Optional</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#mdb_cluster_id DatatransferEndpoint#mdb_cluster_id}.

---

##### `onPremise`<sup>Optional</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a>

on_premise block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#on_premise DatatransferEndpoint#on_premise}

---

### DatatransferEndpointSettingsPostgresTargetConnectionOnPremise <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremise } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetConnectionOnPremise: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.hosts">hosts</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a></code> | tls_mode block. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#hosts DatatransferEndpoint#hosts}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#port DatatransferEndpoint#port}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#subnet_id DatatransferEndpoint#subnet_id}.

---

##### `tlsMode`<sup>Optional</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a>

tls_mode block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#tls_mode DatatransferEndpoint#tls_mode}

---

### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a></code> | disabled block. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a></code> | enabled block. |

---

##### `disabled`<sup>Optional</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a>

disabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#disabled DatatransferEndpoint#disabled}

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a>

enabled block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#enabled DatatransferEndpoint#enabled}

---

### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled = { ... }
```


### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled.property.caCertificate">caCertificate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}. |

---

##### `caCertificate`<sup>Optional</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#ca_certificate DatatransferEndpoint#ca_certificate}.

---

### DatatransferEndpointSettingsPostgresTargetPassword <a name="DatatransferEndpointSettingsPostgresTargetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetPassword } from '@cdktf/provider-yandex'

const datatransferEndpointSettingsPostgresTargetPassword: DatatransferEndpointSettingsPostgresTargetPassword = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword.property.raw">raw</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}. |

---

##### `raw`<sup>Optional</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_endpoint#raw DatatransferEndpoint#raw}.

---

### DatatransferTransferConfig <a name="DatatransferTransferConfig" id="@cdktf/provider-yandex.DatatransferTransferConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DatatransferTransferConfig.Initializer"></a>

```typescript
import { DatatransferTransferConfig } from '@cdktf/provider-yandex'

const datatransferTransferConfig: DatatransferTransferConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#description DatatransferTransfer#description}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#folder_id DatatransferTransfer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#id DatatransferTransfer#id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#labels DatatransferTransfer#labels}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#name DatatransferTransfer#name}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.sourceId">sourceId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#source_id DatatransferTransfer#source_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.targetId">targetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#target_id DatatransferTransfer#target_id}. |
| <code><a href="#@cdktf/provider-yandex.DatatransferTransferConfig.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#type DatatransferTransfer#type}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#description DatatransferTransfer#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#folder_id DatatransferTransfer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#id DatatransferTransfer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#labels DatatransferTransfer#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#name DatatransferTransfer#name}.

---

##### `sourceId`<sup>Optional</sup> <a name="sourceId" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.sourceId"></a>

```typescript
public readonly sourceId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#source_id DatatransferTransfer#source_id}.

---

##### `targetId`<sup>Optional</sup> <a name="targetId" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.targetId"></a>

```typescript
public readonly targetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#target_id DatatransferTransfer#target_id}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.DatatransferTransferConfig.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/datatransfer_transfer#type DatatransferTransfer#type}.

---

### DataYandexAlbBackendGroupConfig <a name="DataYandexAlbBackendGroupConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupConfig } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupConfig: DataYandexAlbBackendGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#backend_group_id DataYandexAlbBackendGroup#backend_group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#description DataYandexAlbBackendGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#folder_id DataYandexAlbBackendGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.grpcBackend">grpcBackend</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]</code> | grpc_backend block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.httpBackend">httpBackend</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]</code> | http_backend block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#id DataYandexAlbBackendGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#labels DataYandexAlbBackendGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#name DataYandexAlbBackendGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.streamBackend">streamBackend</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]</code> | stream_backend block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `backendGroupId`<sup>Optional</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#backend_group_id DataYandexAlbBackendGroup#backend_group_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#description DataYandexAlbBackendGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#folder_id DataYandexAlbBackendGroup#folder_id}.

---

##### `grpcBackend`<sup>Optional</sup> <a name="grpcBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.grpcBackend"></a>

```typescript
public readonly grpcBackend: IResolvable | DataYandexAlbBackendGroupGrpcBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]

grpc_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_backend DataYandexAlbBackendGroup#grpc_backend}

---

##### `httpBackend`<sup>Optional</sup> <a name="httpBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.httpBackend"></a>

```typescript
public readonly httpBackend: IResolvable | DataYandexAlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]

http_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_backend DataYandexAlbBackendGroup#http_backend}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#id DataYandexAlbBackendGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#labels DataYandexAlbBackendGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#name DataYandexAlbBackendGroup#name}.

---

##### `streamBackend`<sup>Optional</sup> <a name="streamBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupConfig.property.streamBackend"></a>

```typescript
public readonly streamBackend: IResolvable | DataYandexAlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]

stream_backend block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_backend DataYandexAlbBackendGroup#stream_backend}

---

### DataYandexAlbBackendGroupGrpcBackend <a name="DataYandexAlbBackendGroupGrpcBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackend } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackend: DataYandexAlbBackendGroupGrpcBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}. |

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}.

---

### DataYandexAlbBackendGroupGrpcBackendHealthcheck <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}. |

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}.

---

### DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}.

---

### DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}. |

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}.

---

### DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}.

---

### DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig <a name="DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}.

---

### DataYandexAlbBackendGroupGrpcBackendTls <a name="DataYandexAlbBackendGroupGrpcBackendTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendTls } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendTls: DataYandexAlbBackendGroupGrpcBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}

---

### DataYandexAlbBackendGroupGrpcBackendTlsValidationContext <a name="DataYandexAlbBackendGroupGrpcBackendTlsValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendTlsValidationContext } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupGrpcBackendTlsValidationContext: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}.

---

### DataYandexAlbBackendGroupHttpBackend <a name="DataYandexAlbBackendGroupHttpBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackend } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackend: DataYandexAlbBackendGroupHttpBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.storageBucket">storageBucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#storage_bucket DataYandexAlbBackendGroup#storage_bucket}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#target_group_ids DataYandexAlbBackendGroup#target_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}. |

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}.

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}.

---

##### `storageBucket`<sup>Optional</sup> <a name="storageBucket" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.storageBucket"></a>

```typescript
public readonly storageBucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#storage_bucket DataYandexAlbBackendGroup#storage_bucket}.

---

##### `targetGroupIds`<sup>Optional</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#target_group_ids DataYandexAlbBackendGroup#target_group_ids}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}.

---

### DataYandexAlbBackendGroupHttpBackendHealthcheck <a name="DataYandexAlbBackendGroupHttpBackendHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}. |

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}.

---

### DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}.

---

### DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}. |

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}.

---

### DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}.

---

### DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig <a name="DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendLoadBalancingConfig: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}.

---

### DataYandexAlbBackendGroupHttpBackendTls <a name="DataYandexAlbBackendGroupHttpBackendTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendTls } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendTls: DataYandexAlbBackendGroupHttpBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}

---

### DataYandexAlbBackendGroupHttpBackendTlsValidationContext <a name="DataYandexAlbBackendGroupHttpBackendTlsValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendTlsValidationContext } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupHttpBackendTlsValidationContext: DataYandexAlbBackendGroupHttpBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}.

---

### DataYandexAlbBackendGroupStreamBackend <a name="DataYandexAlbBackendGroupStreamBackend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackend } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackend: DataYandexAlbBackendGroupStreamBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a></code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | load_balancing_config block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a></code> | tls block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.weight">weight</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}. |

---

##### `healthcheck`<sup>Optional</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a>

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck DataYandexAlbBackendGroup#healthcheck}

---

##### `loadBalancingConfig`<sup>Optional</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a>

load_balancing_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#load_balancing_config DataYandexAlbBackendGroup#load_balancing_config}

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#port DataYandexAlbBackendGroup#port}.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a>

tls block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#tls DataYandexAlbBackendGroup#tls}

---

##### `weight`<sup>Optional</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#weight DataYandexAlbBackendGroup#weight}.

---

### DataYandexAlbBackendGroupStreamBackendHealthcheck <a name="DataYandexAlbBackendGroupStreamBackendHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | grpc_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | http_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | stream_healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}. |

---

##### `grpcHealthcheck`<sup>Optional</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

grpc_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#grpc_healthcheck DataYandexAlbBackendGroup#grpc_healthcheck}

---

##### `healthcheckPort`<sup>Optional</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthcheck_port DataYandexAlbBackendGroup#healthcheck_port}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#healthy_threshold DataYandexAlbBackendGroup#healthy_threshold}.

---

##### `httpHealthcheck`<sup>Optional</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

http_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http_healthcheck DataYandexAlbBackendGroup#http_healthcheck}

---

##### `intervalJitterPercent`<sup>Optional</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#interval_jitter_percent DataYandexAlbBackendGroup#interval_jitter_percent}.

---

##### `streamHealthcheck`<sup>Optional</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

stream_healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#stream_healthcheck DataYandexAlbBackendGroup#stream_healthcheck}

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#unhealthy_threshold DataYandexAlbBackendGroup#unhealthy_threshold}.

---

### DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.property.serviceName">serviceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}. |

---

##### `serviceName`<sup>Optional</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#service_name DataYandexAlbBackendGroup#service_name}.

---

### DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.host">host</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}. |

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#host DataYandexAlbBackendGroup#host}.

---

##### `http2`<sup>Optional</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#http2 DataYandexAlbBackendGroup#http2}.

---

### DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.receive">receive</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.send">send</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}. |

---

##### `receive`<sup>Optional</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#receive DataYandexAlbBackendGroup#receive}.

---

##### `send`<sup>Optional</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#send DataYandexAlbBackendGroup#send}.

---

### DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig <a name="DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendLoadBalancingConfig: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}. |

---

##### `localityAwareRoutingPercent`<sup>Optional</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#locality_aware_routing_percent DataYandexAlbBackendGroup#locality_aware_routing_percent}.

---

##### `panicThreshold`<sup>Optional</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#panic_threshold DataYandexAlbBackendGroup#panic_threshold}.

---

##### `strictLocality`<sup>Optional</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#strict_locality DataYandexAlbBackendGroup#strict_locality}.

---

### DataYandexAlbBackendGroupStreamBackendTls <a name="DataYandexAlbBackendGroupStreamBackendTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendTls } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendTls: DataYandexAlbBackendGroupStreamBackendTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls.property.sni">sni</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a></code> | validation_context block. |

---

##### `sni`<sup>Optional</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#sni DataYandexAlbBackendGroup#sni}.

---

##### `validationContext`<sup>Optional</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a>

validation_context block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#validation_context DataYandexAlbBackendGroup#validation_context}

---

### DataYandexAlbBackendGroupStreamBackendTlsValidationContext <a name="DataYandexAlbBackendGroupStreamBackendTlsValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendTlsValidationContext } from '@cdktf/provider-yandex'

const dataYandexAlbBackendGroupStreamBackendTlsValidationContext: DataYandexAlbBackendGroupStreamBackendTlsValidationContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}. |

---

##### `trustedCaBytes`<sup>Optional</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_bytes DataYandexAlbBackendGroup#trusted_ca_bytes}.

---

##### `trustedCaId`<sup>Optional</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_backend_group#trusted_ca_id DataYandexAlbBackendGroup#trusted_ca_id}.

---

### DataYandexAlbHttpRouterConfig <a name="DataYandexAlbHttpRouterConfig" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.Initializer"></a>

```typescript
import { DataYandexAlbHttpRouterConfig } from '@cdktf/provider-yandex'

const dataYandexAlbHttpRouterConfig: DataYandexAlbHttpRouterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#description DataYandexAlbHttpRouter#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#folder_id DataYandexAlbHttpRouter#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#http_router_id DataYandexAlbHttpRouter#http_router_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#id DataYandexAlbHttpRouter#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#name DataYandexAlbHttpRouter#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#description DataYandexAlbHttpRouter#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#folder_id DataYandexAlbHttpRouter#folder_id}.

---

##### `httpRouterId`<sup>Optional</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#http_router_id DataYandexAlbHttpRouter#http_router_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#id DataYandexAlbHttpRouter#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbHttpRouterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_http_router#name DataYandexAlbHttpRouter#name}.

---

### DataYandexAlbLoadBalancerAllocationPolicy <a name="DataYandexAlbLoadBalancerAllocationPolicy" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicy.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicy } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerAllocationPolicy: DataYandexAlbLoadBalancerAllocationPolicy = { ... }
```


### DataYandexAlbLoadBalancerAllocationPolicyLocation <a name="DataYandexAlbLoadBalancerAllocationPolicyLocation" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocation.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicyLocation } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerAllocationPolicyLocation: DataYandexAlbLoadBalancerAllocationPolicyLocation = { ... }
```


### DataYandexAlbLoadBalancerConfig <a name="DataYandexAlbLoadBalancerConfig" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerConfig } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerConfig: DataYandexAlbLoadBalancerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#id DataYandexAlbLoadBalancer#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.loadBalancerId">loadBalancerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#load_balancer_id DataYandexAlbLoadBalancer#load_balancer_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#name DataYandexAlbLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#id DataYandexAlbLoadBalancer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `loadBalancerId`<sup>Optional</sup> <a name="loadBalancerId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.loadBalancerId"></a>

```typescript
public readonly loadBalancerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#load_balancer_id DataYandexAlbLoadBalancer#load_balancer_id}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#name DataYandexAlbLoadBalancer#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerConfig.property.timeouts"></a>

```typescript
public readonly timeouts: DataYandexAlbLoadBalancerTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#timeouts DataYandexAlbLoadBalancer#timeouts}

---

### DataYandexAlbLoadBalancerListener <a name="DataYandexAlbLoadBalancerListener" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListener"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListener.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListener } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListener: DataYandexAlbLoadBalancerListener = { ... }
```


### DataYandexAlbLoadBalancerListenerEndpoint <a name="DataYandexAlbLoadBalancerListenerEndpoint" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpoint"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpoint.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpoint } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerEndpoint: DataYandexAlbLoadBalancerListenerEndpoint = { ... }
```


### DataYandexAlbLoadBalancerListenerEndpointAddress <a name="DataYandexAlbLoadBalancerListenerEndpointAddress" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddress.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddress } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerEndpointAddress: DataYandexAlbLoadBalancerListenerEndpointAddress = { ... }
```


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address = { ... }
```


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address = { ... }
```


### DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address <a name="DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address: DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address = { ... }
```


### DataYandexAlbLoadBalancerListenerHttp <a name="DataYandexAlbLoadBalancerListenerHttp" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttp"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttp.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttp } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerHttp: DataYandexAlbLoadBalancerListenerHttp = { ... }
```


### DataYandexAlbLoadBalancerListenerHttpHandler <a name="DataYandexAlbLoadBalancerListenerHttpHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerHttpHandler: DataYandexAlbLoadBalancerListenerHttpHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options <a name="DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options: DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options = { ... }
```


### DataYandexAlbLoadBalancerListenerHttpRedirects <a name="DataYandexAlbLoadBalancerListenerHttpRedirects" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirects"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirects.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpRedirects } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerHttpRedirects: DataYandexAlbLoadBalancerListenerHttpRedirects = { ... }
```


### DataYandexAlbLoadBalancerListenerStream <a name="DataYandexAlbLoadBalancerListenerStream" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStream"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStream.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStream } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerStream: DataYandexAlbLoadBalancerListenerStream = { ... }
```


### DataYandexAlbLoadBalancerListenerStreamHandler <a name="DataYandexAlbLoadBalancerListenerStreamHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStreamHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerStreamHandler: DataYandexAlbLoadBalancerListenerStreamHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTls <a name="DataYandexAlbLoadBalancerListenerTls" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTls"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTls.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTls } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTls: DataYandexAlbLoadBalancerListenerTls = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsDefaultHandler <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsDefaultHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsSniHandler <a name="DataYandexAlbLoadBalancerListenerTlsSniHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsSniHandler: DataYandexAlbLoadBalancerListenerTlsSniHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsSniHandlerHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options = { ... }
```


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler = { ... }
```


### DataYandexAlbLoadBalancerTimeouts <a name="DataYandexAlbLoadBalancerTimeouts" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerTimeouts } from '@cdktf/provider-yandex'

const dataYandexAlbLoadBalancerTimeouts: DataYandexAlbLoadBalancerTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#create DataYandexAlbLoadBalancer#create}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#delete DataYandexAlbLoadBalancer#delete}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#update DataYandexAlbLoadBalancer#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#create DataYandexAlbLoadBalancer#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#delete DataYandexAlbLoadBalancer#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_load_balancer#update DataYandexAlbLoadBalancer#update}.

---

### DataYandexAlbTargetGroupConfig <a name="DataYandexAlbTargetGroupConfig" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.Initializer"></a>

```typescript
import { DataYandexAlbTargetGroupConfig } from '@cdktf/provider-yandex'

const dataYandexAlbTargetGroupConfig: DataYandexAlbTargetGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#description DataYandexAlbTargetGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#folder_id DataYandexAlbTargetGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#id DataYandexAlbTargetGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#name DataYandexAlbTargetGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#target_group_id DataYandexAlbTargetGroup#target_group_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#description DataYandexAlbTargetGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#folder_id DataYandexAlbTargetGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#id DataYandexAlbTargetGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#name DataYandexAlbTargetGroup#name}.

---

##### `targetGroupId`<sup>Optional</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupConfig.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_target_group#target_group_id DataYandexAlbTargetGroup#target_group_id}.

---

### DataYandexAlbTargetGroupTarget <a name="DataYandexAlbTargetGroupTarget" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTarget.Initializer"></a>

```typescript
import { DataYandexAlbTargetGroupTarget } from '@cdktf/provider-yandex'

const dataYandexAlbTargetGroupTarget: DataYandexAlbTargetGroupTarget = { ... }
```


### DataYandexAlbVirtualHostConfig <a name="DataYandexAlbVirtualHostConfig" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostConfig } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostConfig: DataYandexAlbVirtualHostConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#http_router_id DataYandexAlbVirtualHost#http_router_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#id DataYandexAlbVirtualHost#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#name DataYandexAlbVirtualHost#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.virtualHostId">virtualHostId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#virtual_host_id DataYandexAlbVirtualHost#virtual_host_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `httpRouterId`<sup>Optional</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#http_router_id DataYandexAlbVirtualHost#http_router_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#id DataYandexAlbVirtualHost#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#name DataYandexAlbVirtualHost#name}.

---

##### `virtualHostId`<sup>Optional</sup> <a name="virtualHostId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostConfig.property.virtualHostId"></a>

```typescript
public readonly virtualHostId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/alb_virtual_host#virtual_host_id DataYandexAlbVirtualHost#virtual_host_id}.

---

### DataYandexAlbVirtualHostModifyRequestHeaders <a name="DataYandexAlbVirtualHostModifyRequestHeaders" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeaders"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeaders.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyRequestHeaders } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostModifyRequestHeaders: DataYandexAlbVirtualHostModifyRequestHeaders = { ... }
```


### DataYandexAlbVirtualHostModifyResponseHeaders <a name="DataYandexAlbVirtualHostModifyResponseHeaders" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeaders"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeaders.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyResponseHeaders } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostModifyResponseHeaders: DataYandexAlbVirtualHostModifyResponseHeaders = { ... }
```


### DataYandexAlbVirtualHostRoute <a name="DataYandexAlbVirtualHostRoute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRoute.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRoute } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRoute: DataYandexAlbVirtualHostRoute = { ... }
```


### DataYandexAlbVirtualHostRouteGrpcRoute <a name="DataYandexAlbVirtualHostRouteGrpcRoute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRoute.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRoute } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteGrpcRoute: DataYandexAlbVirtualHostRouteGrpcRoute = { ... }
```


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch = { ... }
```


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn = { ... }
```


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction: DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction = { ... }
```


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction: DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRoute <a name="DataYandexAlbVirtualHostRouteHttpRoute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRoute.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRoute } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRoute: DataYandexAlbVirtualHostRouteHttpRoute = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction <a name="DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction: DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatch <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatch" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatch"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatch.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatch } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRouteHttpMatch: DataYandexAlbVirtualHostRouteHttpRouteHttpMatch = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction: DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction = { ... }
```


### DataYandexAlbVirtualHostRouteHttpRouteRedirectAction <a name="DataYandexAlbVirtualHostRouteHttpRouteRedirectAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectAction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectAction.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteRedirectAction } from '@cdktf/provider-yandex'

const dataYandexAlbVirtualHostRouteHttpRouteRedirectAction: DataYandexAlbVirtualHostRouteHttpRouteRedirectAction = { ... }
```


### DataYandexApiGatewayConfig <a name="DataYandexApiGatewayConfig" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.Initializer"></a>

```typescript
import { DataYandexApiGatewayConfig } from '@cdktf/provider-yandex'

const dataYandexApiGatewayConfig: DataYandexApiGatewayConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.apiGatewayId">apiGatewayId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#api_gateway_id DataYandexApiGateway#api_gateway_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#folder_id DataYandexApiGateway#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#id DataYandexApiGateway#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#name DataYandexApiGateway#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `apiGatewayId`<sup>Optional</sup> <a name="apiGatewayId" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.apiGatewayId"></a>

```typescript
public readonly apiGatewayId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#api_gateway_id DataYandexApiGateway#api_gateway_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#folder_id DataYandexApiGateway#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#id DataYandexApiGateway#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexApiGatewayConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/api_gateway#name DataYandexApiGateway#name}.

---

### DataYandexCdnOriginGroupConfig <a name="DataYandexCdnOriginGroupConfig" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.Initializer"></a>

```typescript
import { DataYandexCdnOriginGroupConfig } from '@cdktf/provider-yandex'

const dataYandexCdnOriginGroupConfig: DataYandexCdnOriginGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#folder_id DataYandexCdnOriginGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#id DataYandexCdnOriginGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#name DataYandexCdnOriginGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.originGroupId">originGroupId</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#origin_group_id DataYandexCdnOriginGroup#origin_group_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#folder_id DataYandexCdnOriginGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#id DataYandexCdnOriginGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#name DataYandexCdnOriginGroup#name}.

---

##### `originGroupId`<sup>Optional</sup> <a name="originGroupId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupConfig.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_origin_group#origin_group_id DataYandexCdnOriginGroup#origin_group_id}.

---

### DataYandexCdnOriginGroupOrigin <a name="DataYandexCdnOriginGroupOrigin" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOrigin"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOrigin.Initializer"></a>

```typescript
import { DataYandexCdnOriginGroupOrigin } from '@cdktf/provider-yandex'

const dataYandexCdnOriginGroupOrigin: DataYandexCdnOriginGroupOrigin = { ... }
```


### DataYandexCdnResourceConfig <a name="DataYandexCdnResourceConfig" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.Initializer"></a>

```typescript
import { DataYandexCdnResourceConfig } from '@cdktf/provider-yandex'

const dataYandexCdnResourceConfig: DataYandexCdnResourceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.active">active</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#active DataYandexCdnResource#active}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.cname">cname</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cname DataYandexCdnResource#cname}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#id DataYandexCdnResource#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.options">options</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a></code> | options block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originGroupId">originGroupId</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_group_id DataYandexCdnResource#origin_group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originGroupName">originGroupName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_group_name DataYandexCdnResource#origin_group_name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originProtocol">originProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_protocol DataYandexCdnResource#origin_protocol}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.resourceId">resourceId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#resource_id DataYandexCdnResource#resource_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.secondaryHostnames">secondaryHostnames</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#secondary_hostnames DataYandexCdnResource#secondary_hostnames}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.sslCertificate">sslCertificate</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a></code> | ssl_certificate block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.updatedAt">updatedAt</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#updated_at DataYandexCdnResource#updated_at}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `active`<sup>Optional</sup> <a name="active" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.active"></a>

```typescript
public readonly active: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#active DataYandexCdnResource#active}.

---

##### `cname`<sup>Optional</sup> <a name="cname" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.cname"></a>

```typescript
public readonly cname: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cname DataYandexCdnResource#cname}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#id DataYandexCdnResource#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `options`<sup>Optional</sup> <a name="options" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.options"></a>

```typescript
public readonly options: DataYandexCdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a>

options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#options DataYandexCdnResource#options}

---

##### `originGroupId`<sup>Optional</sup> <a name="originGroupId" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_group_id DataYandexCdnResource#origin_group_id}.

---

##### `originGroupName`<sup>Optional</sup> <a name="originGroupName" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originGroupName"></a>

```typescript
public readonly originGroupName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_group_name DataYandexCdnResource#origin_group_name}.

---

##### `originProtocol`<sup>Optional</sup> <a name="originProtocol" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.originProtocol"></a>

```typescript
public readonly originProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#origin_protocol DataYandexCdnResource#origin_protocol}.

---

##### `resourceId`<sup>Optional</sup> <a name="resourceId" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.resourceId"></a>

```typescript
public readonly resourceId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#resource_id DataYandexCdnResource#resource_id}.

---

##### `secondaryHostnames`<sup>Optional</sup> <a name="secondaryHostnames" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.secondaryHostnames"></a>

```typescript
public readonly secondaryHostnames: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#secondary_hostnames DataYandexCdnResource#secondary_hostnames}.

---

##### `sslCertificate`<sup>Optional</sup> <a name="sslCertificate" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.sslCertificate"></a>

```typescript
public readonly sslCertificate: DataYandexCdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a>

ssl_certificate block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#ssl_certificate DataYandexCdnResource#ssl_certificate}

---

##### `updatedAt`<sup>Optional</sup> <a name="updatedAt" id="@cdktf/provider-yandex.DataYandexCdnResourceConfig.property.updatedAt"></a>

```typescript
public readonly updatedAt: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#updated_at DataYandexCdnResource#updated_at}.

---

### DataYandexCdnResourceOptions <a name="DataYandexCdnResourceOptions" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.Initializer"></a>

```typescript
import { DataYandexCdnResourceOptions } from '@cdktf/provider-yandex'

const dataYandexCdnResourceOptions: DataYandexCdnResourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.allowedHttpMethods">allowedHttpMethods</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#allowed_http_methods DataYandexCdnResource#allowed_http_methods}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.browserCacheSettings">browserCacheSettings</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#browser_cache_settings DataYandexCdnResource#browser_cache_settings}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.cacheHttpHeaders">cacheHttpHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cache_http_headers DataYandexCdnResource#cache_http_headers}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.cors">cors</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cors DataYandexCdnResource#cors}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.customHostHeader">customHostHeader</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#custom_host_header DataYandexCdnResource#custom_host_header}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.customServerName">customServerName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#custom_server_name DataYandexCdnResource#custom_server_name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.disableCache">disableCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#disable_cache DataYandexCdnResource#disable_cache}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.disableProxyForceRanges">disableProxyForceRanges</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#disable_proxy_force_ranges DataYandexCdnResource#disable_proxy_force_ranges}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.edgeCacheSettings">edgeCacheSettings</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#edge_cache_settings DataYandexCdnResource#edge_cache_settings}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.fetchedCompressed">fetchedCompressed</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#fetched_compressed DataYandexCdnResource#fetched_compressed}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.forwardHostHeader">forwardHostHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#forward_host_header DataYandexCdnResource#forward_host_header}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.gzipOn">gzipOn</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#gzip_on DataYandexCdnResource#gzip_on}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.ignoreCookie">ignoreCookie</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#ignore_cookie DataYandexCdnResource#ignore_cookie}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.ignoreQueryParams">ignoreQueryParams</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#ignore_query_params DataYandexCdnResource#ignore_query_params}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.proxyCacheMethodsSet">proxyCacheMethodsSet</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#proxy_cache_methods_set DataYandexCdnResource#proxy_cache_methods_set}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.queryParamsBlacklist">queryParamsBlacklist</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#query_params_blacklist DataYandexCdnResource#query_params_blacklist}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.queryParamsWhitelist">queryParamsWhitelist</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#query_params_whitelist DataYandexCdnResource#query_params_whitelist}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.redirectHttpsToHttp">redirectHttpsToHttp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#redirect_https_to_http DataYandexCdnResource#redirect_https_to_http}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.redirectHttpToHttps">redirectHttpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#redirect_http_to_https DataYandexCdnResource#redirect_http_to_https}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.slice">slice</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#slice DataYandexCdnResource#slice}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.staticRequestHeaders">staticRequestHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#static_request_headers DataYandexCdnResource#static_request_headers}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.staticResponseHeaders">staticResponseHeaders</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#static_response_headers DataYandexCdnResource#static_response_headers}. |

---

##### `allowedHttpMethods`<sup>Optional</sup> <a name="allowedHttpMethods" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.allowedHttpMethods"></a>

```typescript
public readonly allowedHttpMethods: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#allowed_http_methods DataYandexCdnResource#allowed_http_methods}.

---

##### `browserCacheSettings`<sup>Optional</sup> <a name="browserCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.browserCacheSettings"></a>

```typescript
public readonly browserCacheSettings: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#browser_cache_settings DataYandexCdnResource#browser_cache_settings}.

---

##### `cacheHttpHeaders`<sup>Optional</sup> <a name="cacheHttpHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.cacheHttpHeaders"></a>

```typescript
public readonly cacheHttpHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cache_http_headers DataYandexCdnResource#cache_http_headers}.

---

##### `cors`<sup>Optional</sup> <a name="cors" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.cors"></a>

```typescript
public readonly cors: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#cors DataYandexCdnResource#cors}.

---

##### `customHostHeader`<sup>Optional</sup> <a name="customHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.customHostHeader"></a>

```typescript
public readonly customHostHeader: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#custom_host_header DataYandexCdnResource#custom_host_header}.

---

##### `customServerName`<sup>Optional</sup> <a name="customServerName" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.customServerName"></a>

```typescript
public readonly customServerName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#custom_server_name DataYandexCdnResource#custom_server_name}.

---

##### `disableCache`<sup>Optional</sup> <a name="disableCache" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.disableCache"></a>

```typescript
public readonly disableCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#disable_cache DataYandexCdnResource#disable_cache}.

---

##### `disableProxyForceRanges`<sup>Optional</sup> <a name="disableProxyForceRanges" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.disableProxyForceRanges"></a>

```typescript
public readonly disableProxyForceRanges: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#disable_proxy_force_ranges DataYandexCdnResource#disable_proxy_force_ranges}.

---

##### `edgeCacheSettings`<sup>Optional</sup> <a name="edgeCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.edgeCacheSettings"></a>

```typescript
public readonly edgeCacheSettings: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#edge_cache_settings DataYandexCdnResource#edge_cache_settings}.

---

##### `fetchedCompressed`<sup>Optional</sup> <a name="fetchedCompressed" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.fetchedCompressed"></a>

```typescript
public readonly fetchedCompressed: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#fetched_compressed DataYandexCdnResource#fetched_compressed}.

---

##### `forwardHostHeader`<sup>Optional</sup> <a name="forwardHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.forwardHostHeader"></a>

```typescript
public readonly forwardHostHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#forward_host_header DataYandexCdnResource#forward_host_header}.

---

##### `gzipOn`<sup>Optional</sup> <a name="gzipOn" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.gzipOn"></a>

```typescript
public readonly gzipOn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#gzip_on DataYandexCdnResource#gzip_on}.

---

##### `ignoreCookie`<sup>Optional</sup> <a name="ignoreCookie" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.ignoreCookie"></a>

```typescript
public readonly ignoreCookie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#ignore_cookie DataYandexCdnResource#ignore_cookie}.

---

##### `ignoreQueryParams`<sup>Optional</sup> <a name="ignoreQueryParams" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.ignoreQueryParams"></a>

```typescript
public readonly ignoreQueryParams: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#ignore_query_params DataYandexCdnResource#ignore_query_params}.

---

##### `proxyCacheMethodsSet`<sup>Optional</sup> <a name="proxyCacheMethodsSet" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.proxyCacheMethodsSet"></a>

```typescript
public readonly proxyCacheMethodsSet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#proxy_cache_methods_set DataYandexCdnResource#proxy_cache_methods_set}.

---

##### `queryParamsBlacklist`<sup>Optional</sup> <a name="queryParamsBlacklist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.queryParamsBlacklist"></a>

```typescript
public readonly queryParamsBlacklist: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#query_params_blacklist DataYandexCdnResource#query_params_blacklist}.

---

##### `queryParamsWhitelist`<sup>Optional</sup> <a name="queryParamsWhitelist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.queryParamsWhitelist"></a>

```typescript
public readonly queryParamsWhitelist: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#query_params_whitelist DataYandexCdnResource#query_params_whitelist}.

---

##### `redirectHttpsToHttp`<sup>Optional</sup> <a name="redirectHttpsToHttp" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.redirectHttpsToHttp"></a>

```typescript
public readonly redirectHttpsToHttp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#redirect_https_to_http DataYandexCdnResource#redirect_https_to_http}.

---

##### `redirectHttpToHttps`<sup>Optional</sup> <a name="redirectHttpToHttps" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.redirectHttpToHttps"></a>

```typescript
public readonly redirectHttpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#redirect_http_to_https DataYandexCdnResource#redirect_http_to_https}.

---

##### `slice`<sup>Optional</sup> <a name="slice" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.slice"></a>

```typescript
public readonly slice: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#slice DataYandexCdnResource#slice}.

---

##### `staticRequestHeaders`<sup>Optional</sup> <a name="staticRequestHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.staticRequestHeaders"></a>

```typescript
public readonly staticRequestHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#static_request_headers DataYandexCdnResource#static_request_headers}.

---

##### `staticResponseHeaders`<sup>Optional</sup> <a name="staticResponseHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptions.property.staticResponseHeaders"></a>

```typescript
public readonly staticResponseHeaders: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#static_response_headers DataYandexCdnResource#static_response_headers}.

---

### DataYandexCdnResourceSslCertificate <a name="DataYandexCdnResourceSslCertificate" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate.Initializer"></a>

```typescript
import { DataYandexCdnResourceSslCertificate } from '@cdktf/provider-yandex'

const dataYandexCdnResourceSslCertificate: DataYandexCdnResourceSslCertificate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#type DataYandexCdnResource#type}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate.property.certificateManagerId">certificateManagerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#certificate_manager_id DataYandexCdnResource#certificate_manager_id}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#type DataYandexCdnResource#type}.

---

##### `certificateManagerId`<sup>Optional</sup> <a name="certificateManagerId" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate.property.certificateManagerId"></a>

```typescript
public readonly certificateManagerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/cdn_resource#certificate_manager_id DataYandexCdnResource#certificate_manager_id}.

---

### DataYandexClientConfigConfig <a name="DataYandexClientConfigConfig" id="@cdktf/provider-yandex.DataYandexClientConfigConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.Initializer"></a>

```typescript
import { DataYandexClientConfigConfig } from '@cdktf/provider-yandex'

const dataYandexClientConfigConfig: DataYandexClientConfigConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexClientConfigConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/client_config#id DataYandexClientConfig#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexClientConfigConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/client_config#id DataYandexClientConfig#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexComputeDiskConfig <a name="DataYandexComputeDiskConfig" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.Initializer"></a>

```typescript
import { DataYandexComputeDiskConfig } from '@cdktf/provider-yandex'

const dataYandexComputeDiskConfig: DataYandexComputeDiskConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.diskId">diskId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_id DataYandexComputeDisk#disk_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.diskPlacementPolicy">diskPlacementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a></code> | disk_placement_policy block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#folder_id DataYandexComputeDisk#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#id DataYandexComputeDisk#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#name DataYandexComputeDisk#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `diskId`<sup>Optional</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_id DataYandexComputeDisk#disk_id}.

---

##### `diskPlacementPolicy`<sup>Optional</sup> <a name="diskPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.diskPlacementPolicy"></a>

```typescript
public readonly diskPlacementPolicy: DataYandexComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a>

disk_placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_placement_policy DataYandexComputeDisk#disk_placement_policy}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#folder_id DataYandexComputeDisk#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#id DataYandexComputeDisk#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeDiskConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#name DataYandexComputeDisk#name}.

---

### DataYandexComputeDiskDiskPlacementPolicy <a name="DataYandexComputeDiskDiskPlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy.Initializer"></a>

```typescript
import { DataYandexComputeDiskDiskPlacementPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeDiskDiskPlacementPolicy: DataYandexComputeDiskDiskPlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy.property.diskPlacementGroupId">diskPlacementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_placement_group_id DataYandexComputeDisk#disk_placement_group_id}. |

---

##### `diskPlacementGroupId`<sup>Required</sup> <a name="diskPlacementGroupId" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy.property.diskPlacementGroupId"></a>

```typescript
public readonly diskPlacementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk#disk_placement_group_id DataYandexComputeDisk#disk_placement_group_id}.

---

### DataYandexComputeDiskPlacementGroupConfig <a name="DataYandexComputeDiskPlacementGroupConfig" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.Initializer"></a>

```typescript
import { DataYandexComputeDiskPlacementGroupConfig } from '@cdktf/provider-yandex'

const dataYandexComputeDiskPlacementGroupConfig: DataYandexComputeDiskPlacementGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#description DataYandexComputeDiskPlacementGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#folder_id DataYandexComputeDiskPlacementGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.groupId">groupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#group_id DataYandexComputeDiskPlacementGroup#group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#id DataYandexComputeDiskPlacementGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#labels DataYandexComputeDiskPlacementGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#name DataYandexComputeDiskPlacementGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#zone DataYandexComputeDiskPlacementGroup#zone}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#description DataYandexComputeDiskPlacementGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#folder_id DataYandexComputeDiskPlacementGroup#folder_id}.

---

##### `groupId`<sup>Optional</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#group_id DataYandexComputeDiskPlacementGroup#group_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#id DataYandexComputeDiskPlacementGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#labels DataYandexComputeDiskPlacementGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#name DataYandexComputeDiskPlacementGroup#name}.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexComputeDiskPlacementGroupConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_disk_placement_group#zone DataYandexComputeDiskPlacementGroup#zone}.

---

### DataYandexComputeImageConfig <a name="DataYandexComputeImageConfig" id="@cdktf/provider-yandex.DataYandexComputeImageConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.Initializer"></a>

```typescript
import { DataYandexComputeImageConfig } from '@cdktf/provider-yandex'

const dataYandexComputeImageConfig: DataYandexComputeImageConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.family">family</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#family DataYandexComputeImage#family}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#folder_id DataYandexComputeImage#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#id DataYandexComputeImage#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.imageId">imageId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#image_id DataYandexComputeImage#image_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeImageConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#name DataYandexComputeImage#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `family`<sup>Optional</sup> <a name="family" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.family"></a>

```typescript
public readonly family: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#family DataYandexComputeImage#family}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#folder_id DataYandexComputeImage#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#id DataYandexComputeImage#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `imageId`<sup>Optional</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#image_id DataYandexComputeImage#image_id}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeImageConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_image#name DataYandexComputeImage#name}.

---

### DataYandexComputeInstanceBootDisk <a name="DataYandexComputeInstanceBootDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDisk.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDisk } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceBootDisk: DataYandexComputeInstanceBootDisk = { ... }
```


### DataYandexComputeInstanceBootDiskInitializeParams <a name="DataYandexComputeInstanceBootDiskInitializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParams.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDiskInitializeParams } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceBootDiskInitializeParams: DataYandexComputeInstanceBootDiskInitializeParams = { ... }
```


### DataYandexComputeInstanceConfig <a name="DataYandexComputeInstanceConfig" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.Initializer"></a>

```typescript
import { DataYandexComputeInstanceConfig } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceConfig: DataYandexComputeInstanceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#folder_id DataYandexComputeInstance#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#id DataYandexComputeInstance#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.instanceId">instanceId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#instance_id DataYandexComputeInstance#instance_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#name DataYandexComputeInstance#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a></code> | placement_policy block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#folder_id DataYandexComputeInstance#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#id DataYandexComputeInstance#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `instanceId`<sup>Optional</sup> <a name="instanceId" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#instance_id DataYandexComputeInstance#instance_id}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#name DataYandexComputeInstance#name}.

---

##### `placementPolicy`<sup>Optional</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceConfig.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: DataYandexComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a>

placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#placement_policy DataYandexComputeInstance#placement_policy}

---

### DataYandexComputeInstanceGroupAllocationPolicy <a name="DataYandexComputeInstanceGroupAllocationPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupAllocationPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupAllocationPolicy: DataYandexComputeInstanceGroupAllocationPolicy = { ... }
```


### DataYandexComputeInstanceGroupApplicationBalancerState <a name="DataYandexComputeInstanceGroupApplicationBalancerState" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerState"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerState.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationBalancerState } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupApplicationBalancerState: DataYandexComputeInstanceGroupApplicationBalancerState = { ... }
```


### DataYandexComputeInstanceGroupApplicationLoadBalancer <a name="DataYandexComputeInstanceGroupApplicationLoadBalancer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancer.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationLoadBalancer } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupApplicationLoadBalancer: DataYandexComputeInstanceGroupApplicationLoadBalancer = { ... }
```


### DataYandexComputeInstanceGroupConfig <a name="DataYandexComputeInstanceGroupConfig" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupConfig } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupConfig: DataYandexComputeInstanceGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.instanceGroupId">instanceGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#instance_group_id DataYandexComputeInstanceGroup#instance_group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#id DataYandexComputeInstanceGroup#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `instanceGroupId`<sup>Required</sup> <a name="instanceGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.instanceGroupId"></a>

```typescript
public readonly instanceGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#instance_group_id DataYandexComputeInstanceGroup#instance_group_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance_group#id DataYandexComputeInstanceGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexComputeInstanceGroupDeployPolicy <a name="DataYandexComputeInstanceGroupDeployPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupDeployPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupDeployPolicy: DataYandexComputeInstanceGroupDeployPolicy = { ... }
```


### DataYandexComputeInstanceGroupHealthCheck <a name="DataYandexComputeInstanceGroupHealthCheck" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheck.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheck } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupHealthCheck: DataYandexComputeInstanceGroupHealthCheck = { ... }
```


### DataYandexComputeInstanceGroupHealthCheckHttpOptions <a name="DataYandexComputeInstanceGroupHealthCheckHttpOptions" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptions.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckHttpOptions } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupHealthCheckHttpOptions: DataYandexComputeInstanceGroupHealthCheckHttpOptions = { ... }
```


### DataYandexComputeInstanceGroupHealthCheckTcpOptions <a name="DataYandexComputeInstanceGroupHealthCheckTcpOptions" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptions.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckTcpOptions } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupHealthCheckTcpOptions: DataYandexComputeInstanceGroupHealthCheckTcpOptions = { ... }
```


### DataYandexComputeInstanceGroupInstances <a name="DataYandexComputeInstanceGroupInstances" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstances"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstances.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstances } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstances: DataYandexComputeInstanceGroupInstances = { ... }
```


### DataYandexComputeInstanceGroupInstancesNetworkInterface <a name="DataYandexComputeInstanceGroupInstancesNetworkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterface.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstancesNetworkInterface } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstancesNetworkInterface: DataYandexComputeInstanceGroupInstancesNetworkInterface = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplate <a name="DataYandexComputeInstanceGroupInstanceTemplate" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplate.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplate } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplate: DataYandexComputeInstanceGroupInstanceTemplate = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateBootDisk <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDisk.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDisk } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateBootDisk: DataYandexComputeInstanceGroupInstanceTemplateBootDisk = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams: DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateNetworkInterface: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateNetworkSettings: DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy <a name="DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy: DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateResources <a name="DataYandexComputeInstanceGroupInstanceTemplateResources" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResources.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateResources } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateResources: DataYandexComputeInstanceGroupInstanceTemplateResources = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy <a name="DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy: DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk = { ... }
```


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams = { ... }
```


### DataYandexComputeInstanceGroupLoadBalancer <a name="DataYandexComputeInstanceGroupLoadBalancer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancer.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancer } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupLoadBalancer: DataYandexComputeInstanceGroupLoadBalancer = { ... }
```


### DataYandexComputeInstanceGroupLoadBalancerState <a name="DataYandexComputeInstanceGroupLoadBalancerState" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerState"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerState.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancerState } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupLoadBalancerState: DataYandexComputeInstanceGroupLoadBalancerState = { ... }
```


### DataYandexComputeInstanceGroupScalePolicy <a name="DataYandexComputeInstanceGroupScalePolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicy: DataYandexComputeInstanceGroupScalePolicy = { ... }
```


### DataYandexComputeInstanceGroupScalePolicyAutoScale <a name="DataYandexComputeInstanceGroupScalePolicyAutoScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScale.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScale } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicyAutoScale: DataYandexComputeInstanceGroupScalePolicyAutoScale = { ... }
```


### DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule <a name="DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule: DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule = { ... }
```


### DataYandexComputeInstanceGroupScalePolicyFixedScale <a name="DataYandexComputeInstanceGroupScalePolicyFixedScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScale.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyFixedScale } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicyFixedScale: DataYandexComputeInstanceGroupScalePolicyFixedScale = { ... }
```


### DataYandexComputeInstanceGroupScalePolicyTestAutoScale <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScale.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScale } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicyTestAutoScale: DataYandexComputeInstanceGroupScalePolicyTestAutoScale = { ... }
```


### DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule = { ... }
```


### DataYandexComputeInstanceNetworkInterface <a name="DataYandexComputeInstanceNetworkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterface.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterface } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceNetworkInterface: DataYandexComputeInstanceNetworkInterface = { ... }
```


### DataYandexComputeInstanceNetworkInterfaceDnsRecord <a name="DataYandexComputeInstanceNetworkInterfaceDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceDnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceNetworkInterfaceDnsRecord: DataYandexComputeInstanceNetworkInterfaceDnsRecord = { ... }
```


### DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord <a name="DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord: DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord = { ... }
```


### DataYandexComputeInstanceNetworkInterfaceNatDnsRecord <a name="DataYandexComputeInstanceNetworkInterfaceNatDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecord"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecord.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceNatDnsRecord } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceNetworkInterfaceNatDnsRecord: DataYandexComputeInstanceNetworkInterfaceNatDnsRecord = { ... }
```


### DataYandexComputeInstancePlacementPolicy <a name="DataYandexComputeInstancePlacementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstancePlacementPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstancePlacementPolicy: DataYandexComputeInstancePlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy.property.hostAffinityRules">hostAffinityRules</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#host_affinity_rules DataYandexComputeInstance#host_affinity_rules}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#placement_group_id DataYandexComputeInstance#placement_group_id}. |

---

##### `hostAffinityRules`<sup>Optional</sup> <a name="hostAffinityRules" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy.property.hostAffinityRules"></a>

```typescript
public readonly hostAffinityRules: IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#host_affinity_rules DataYandexComputeInstance#host_affinity_rules}.

---

##### `placementGroupId`<sup>Optional</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#placement_group_id DataYandexComputeInstance#placement_group_id}.

---

### DataYandexComputeInstancePlacementPolicyHostAffinityRules <a name="DataYandexComputeInstancePlacementPolicyHostAffinityRules" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.Initializer"></a>

```typescript
import { DataYandexComputeInstancePlacementPolicyHostAffinityRules } from '@cdktf/provider-yandex'

const dataYandexComputeInstancePlacementPolicyHostAffinityRules: DataYandexComputeInstancePlacementPolicyHostAffinityRules = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.key">key</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#key DataYandexComputeInstance#key}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.op">op</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#op DataYandexComputeInstance#op}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.values">values</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#values DataYandexComputeInstance#values}. |

---

##### `key`<sup>Optional</sup> <a name="key" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#key DataYandexComputeInstance#key}.

---

##### `op`<sup>Optional</sup> <a name="op" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.op"></a>

```typescript
public readonly op: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#op DataYandexComputeInstance#op}.

---

##### `values`<sup>Optional</sup> <a name="values" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_instance#values DataYandexComputeInstance#values}.

---

### DataYandexComputeInstanceResources <a name="DataYandexComputeInstanceResources" id="@cdktf/provider-yandex.DataYandexComputeInstanceResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceResources.Initializer"></a>

```typescript
import { DataYandexComputeInstanceResources } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceResources: DataYandexComputeInstanceResources = { ... }
```


### DataYandexComputeInstanceSchedulingPolicy <a name="DataYandexComputeInstanceSchedulingPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicy.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSchedulingPolicy } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceSchedulingPolicy: DataYandexComputeInstanceSchedulingPolicy = { ... }
```


### DataYandexComputeInstanceSecondaryDisk <a name="DataYandexComputeInstanceSecondaryDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDisk.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSecondaryDisk } from '@cdktf/provider-yandex'

const dataYandexComputeInstanceSecondaryDisk: DataYandexComputeInstanceSecondaryDisk = { ... }
```


### DataYandexComputePlacementGroupConfig <a name="DataYandexComputePlacementGroupConfig" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.Initializer"></a>

```typescript
import { DataYandexComputePlacementGroupConfig } from '@cdktf/provider-yandex'

const dataYandexComputePlacementGroupConfig: DataYandexComputePlacementGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#description DataYandexComputePlacementGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#folder_id DataYandexComputePlacementGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.groupId">groupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#group_id DataYandexComputePlacementGroup#group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#id DataYandexComputePlacementGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#labels DataYandexComputePlacementGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#name DataYandexComputePlacementGroup#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#description DataYandexComputePlacementGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#folder_id DataYandexComputePlacementGroup#folder_id}.

---

##### `groupId`<sup>Optional</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#group_id DataYandexComputePlacementGroup#group_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#id DataYandexComputePlacementGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#labels DataYandexComputePlacementGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputePlacementGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_placement_group#name DataYandexComputePlacementGroup#name}.

---

### DataYandexComputeSnapshotConfig <a name="DataYandexComputeSnapshotConfig" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.Initializer"></a>

```typescript
import { DataYandexComputeSnapshotConfig } from '@cdktf/provider-yandex'

const dataYandexComputeSnapshotConfig: DataYandexComputeSnapshotConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#folder_id DataYandexComputeSnapshot#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#id DataYandexComputeSnapshot#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#name DataYandexComputeSnapshot#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.snapshotId">snapshotId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#snapshot_id DataYandexComputeSnapshot#snapshot_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#folder_id DataYandexComputeSnapshot#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#id DataYandexComputeSnapshot#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#name DataYandexComputeSnapshot#name}.

---

##### `snapshotId`<sup>Optional</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeSnapshotConfig.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/compute_snapshot#snapshot_id DataYandexComputeSnapshot#snapshot_id}.

---

### DataYandexContainerRegistryConfig <a name="DataYandexContainerRegistryConfig" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.Initializer"></a>

```typescript
import { DataYandexContainerRegistryConfig } from '@cdktf/provider-yandex'

const dataYandexContainerRegistryConfig: DataYandexContainerRegistryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#folder_id DataYandexContainerRegistry#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#id DataYandexContainerRegistry#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#labels DataYandexContainerRegistry#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#name DataYandexContainerRegistry#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.registryId">registryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#registry_id DataYandexContainerRegistry#registry_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#folder_id DataYandexContainerRegistry#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#id DataYandexContainerRegistry#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#labels DataYandexContainerRegistry#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#name DataYandexContainerRegistry#name}.

---

##### `registryId`<sup>Optional</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexContainerRegistryConfig.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_registry#registry_id DataYandexContainerRegistry#registry_id}.

---

### DataYandexContainerRepositoryConfig <a name="DataYandexContainerRepositoryConfig" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.Initializer"></a>

```typescript
import { DataYandexContainerRepositoryConfig } from '@cdktf/provider-yandex'

const dataYandexContainerRepositoryConfig: DataYandexContainerRepositoryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#id DataYandexContainerRepository#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#name DataYandexContainerRepository#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.repositoryId">repositoryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#repository_id DataYandexContainerRepository#repository_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#id DataYandexContainerRepository#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#name DataYandexContainerRepository#name}.

---

##### `repositoryId`<sup>Optional</sup> <a name="repositoryId" id="@cdktf/provider-yandex.DataYandexContainerRepositoryConfig.property.repositoryId"></a>

```typescript
public readonly repositoryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/container_repository#repository_id DataYandexContainerRepository#repository_id}.

---

### DataYandexDataprocClusterClusterConfig <a name="DataYandexDataprocClusterClusterConfig" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfig.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfig } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterClusterConfig: DataYandexDataprocClusterClusterConfig = { ... }
```


### DataYandexDataprocClusterClusterConfigHadoop <a name="DataYandexDataprocClusterClusterConfigHadoop" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoop"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoop.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigHadoop } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterClusterConfigHadoop: DataYandexDataprocClusterClusterConfigHadoop = { ... }
```


### DataYandexDataprocClusterClusterConfigSubclusterSpec <a name="DataYandexDataprocClusterClusterConfigSubclusterSpec" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpec.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpec } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterClusterConfigSubclusterSpec: DataYandexDataprocClusterClusterConfigSubclusterSpec = { ... }
```


### DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig: DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig = { ... }
```


### DataYandexDataprocClusterClusterConfigSubclusterSpecResources <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecResources" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResources.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecResources } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterClusterConfigSubclusterSpecResources: DataYandexDataprocClusterClusterConfigSubclusterSpecResources = { ... }
```


### DataYandexDataprocClusterConfig <a name="DataYandexDataprocClusterConfig" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.Initializer"></a>

```typescript
import { DataYandexDataprocClusterConfig } from '@cdktf/provider-yandex'

const dataYandexDataprocClusterConfig: DataYandexDataprocClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#cluster_id DataYandexDataprocCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#id DataYandexDataprocCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#name DataYandexDataprocCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#cluster_id DataYandexDataprocCluster#cluster_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#id DataYandexDataprocCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexDataprocClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dataproc_cluster#name DataYandexDataprocCluster#name}.

---

### DataYandexDnsZoneConfig <a name="DataYandexDnsZoneConfig" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.Initializer"></a>

```typescript
import { DataYandexDnsZoneConfig } from '@cdktf/provider-yandex'

const dataYandexDnsZoneConfig: DataYandexDnsZoneConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#dns_zone_id DataYandexDnsZone#dns_zone_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#folder_id DataYandexDnsZone#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#id DataYandexDnsZone#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#name DataYandexDnsZone#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `dnsZoneId`<sup>Optional</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#dns_zone_id DataYandexDnsZone#dns_zone_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#folder_id DataYandexDnsZone#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#id DataYandexDnsZone#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#name DataYandexDnsZone#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.DataYandexDnsZoneConfig.property.timeouts"></a>

```typescript
public readonly timeouts: DataYandexDnsZoneTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#timeouts DataYandexDnsZone#timeouts}

---

### DataYandexDnsZoneTimeouts <a name="DataYandexDnsZoneTimeouts" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.Initializer"></a>

```typescript
import { DataYandexDnsZoneTimeouts } from '@cdktf/provider-yandex'

const dataYandexDnsZoneTimeouts: DataYandexDnsZoneTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#create DataYandexDnsZone#create}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#delete DataYandexDnsZone#delete}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#update DataYandexDnsZone#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#create DataYandexDnsZone#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#delete DataYandexDnsZone#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/dns_zone#update DataYandexDnsZone#update}.

---

### DataYandexFunctionConfig <a name="DataYandexFunctionConfig" id="@cdktf/provider-yandex.DataYandexFunctionConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionConfig.Initializer"></a>

```typescript
import { DataYandexFunctionConfig } from '@cdktf/provider-yandex'

const dataYandexFunctionConfig: DataYandexFunctionConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#folder_id DataYandexFunction#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.functionId">functionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#function_id DataYandexFunction#function_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#id DataYandexFunction#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#name DataYandexFunction#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#folder_id DataYandexFunction#folder_id}.

---

##### `functionId`<sup>Optional</sup> <a name="functionId" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#function_id DataYandexFunction#function_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#id DataYandexFunction#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexFunctionConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function#name DataYandexFunction#name}.

---

### DataYandexFunctionScalingPolicyConfig <a name="DataYandexFunctionScalingPolicyConfig" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.Initializer"></a>

```typescript
import { DataYandexFunctionScalingPolicyConfig } from '@cdktf/provider-yandex'

const dataYandexFunctionScalingPolicyConfig: DataYandexFunctionScalingPolicyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.functionId">functionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#function_id DataYandexFunctionScalingPolicy#function_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#id DataYandexFunctionScalingPolicy#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.policy">policy</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]</code> | policy block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#function_id DataYandexFunctionScalingPolicy#function_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#id DataYandexFunctionScalingPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyConfig.property.policy"></a>

```typescript
public readonly policy: IResolvable | DataYandexFunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]

policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#policy DataYandexFunctionScalingPolicy#policy}

---

### DataYandexFunctionScalingPolicyPolicy <a name="DataYandexFunctionScalingPolicyPolicy" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy.Initializer"></a>

```typescript
import { DataYandexFunctionScalingPolicyPolicy } from '@cdktf/provider-yandex'

const dataYandexFunctionScalingPolicyPolicy: DataYandexFunctionScalingPolicyPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy.property.zoneInstancesLimit">zoneInstancesLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_instances_limit DataYandexFunctionScalingPolicy#zone_instances_limit}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy.property.zoneRequestsLimit">zoneRequestsLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_requests_limit DataYandexFunctionScalingPolicy#zone_requests_limit}. |

---

##### `zoneInstancesLimit`<sup>Optional</sup> <a name="zoneInstancesLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy.property.zoneInstancesLimit"></a>

```typescript
public readonly zoneInstancesLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_instances_limit DataYandexFunctionScalingPolicy#zone_instances_limit}.

---

##### `zoneRequestsLimit`<sup>Optional</sup> <a name="zoneRequestsLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy.property.zoneRequestsLimit"></a>

```typescript
public readonly zoneRequestsLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_scaling_policy#zone_requests_limit DataYandexFunctionScalingPolicy#zone_requests_limit}.

---

### DataYandexFunctionTriggerConfig <a name="DataYandexFunctionTriggerConfig" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerConfig } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerConfig: DataYandexFunctionTriggerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#folder_id DataYandexFunctionTrigger#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#id DataYandexFunctionTrigger#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#name DataYandexFunctionTrigger#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.triggerId">triggerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#trigger_id DataYandexFunctionTrigger#trigger_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#folder_id DataYandexFunctionTrigger#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#id DataYandexFunctionTrigger#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#name DataYandexFunctionTrigger#name}.

---

##### `triggerId`<sup>Optional</sup> <a name="triggerId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerConfig.property.triggerId"></a>

```typescript
public readonly triggerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/function_trigger#trigger_id DataYandexFunctionTrigger#trigger_id}.

---

### DataYandexFunctionTriggerDlq <a name="DataYandexFunctionTriggerDlq" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlq"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlq.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerDlq } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerDlq: DataYandexFunctionTriggerDlq = { ... }
```


### DataYandexFunctionTriggerFunction <a name="DataYandexFunctionTriggerFunction" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunction.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerFunction } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerFunction: DataYandexFunctionTriggerFunction = { ... }
```


### DataYandexFunctionTriggerIot <a name="DataYandexFunctionTriggerIot" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIot"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIot.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerIot } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerIot: DataYandexFunctionTriggerIot = { ... }
```


### DataYandexFunctionTriggerLogging <a name="DataYandexFunctionTriggerLogging" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogging"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogging.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLogging } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerLogging: DataYandexFunctionTriggerLogging = { ... }
```


### DataYandexFunctionTriggerLogGroup <a name="DataYandexFunctionTriggerLogGroup" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroup.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLogGroup } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerLogGroup: DataYandexFunctionTriggerLogGroup = { ... }
```


### DataYandexFunctionTriggerMessageQueue <a name="DataYandexFunctionTriggerMessageQueue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueue"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueue.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerMessageQueue } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerMessageQueue: DataYandexFunctionTriggerMessageQueue = { ... }
```


### DataYandexFunctionTriggerObjectStorage <a name="DataYandexFunctionTriggerObjectStorage" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorage.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerObjectStorage } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerObjectStorage: DataYandexFunctionTriggerObjectStorage = { ... }
```


### DataYandexFunctionTriggerTimer <a name="DataYandexFunctionTriggerTimer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimer.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerTimer } from '@cdktf/provider-yandex'

const dataYandexFunctionTriggerTimer: DataYandexFunctionTriggerTimer = { ... }
```


### DataYandexIamPolicyBinding <a name="DataYandexIamPolicyBinding" id="@cdktf/provider-yandex.DataYandexIamPolicyBinding"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIamPolicyBinding.Initializer"></a>

```typescript
import { DataYandexIamPolicyBinding } from '@cdktf/provider-yandex'

const dataYandexIamPolicyBinding: DataYandexIamPolicyBinding = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#members DataYandexIamPolicy#members}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#role DataYandexIamPolicy#role}. |

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.DataYandexIamPolicyBinding.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#members DataYandexIamPolicy#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexIamPolicyBinding.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#role DataYandexIamPolicy#role}.

---

### DataYandexIamPolicyConfig <a name="DataYandexIamPolicyConfig" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.Initializer"></a>

```typescript
import { DataYandexIamPolicyConfig } from '@cdktf/provider-yandex'

const dataYandexIamPolicyConfig: DataYandexIamPolicyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.binding">binding</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]</code> | binding block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#id DataYandexIamPolicy#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `binding`<sup>Required</sup> <a name="binding" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.binding"></a>

```typescript
public readonly binding: IResolvable | DataYandexIamPolicyBinding[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]

binding block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#binding DataYandexIamPolicy#binding}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_policy#id DataYandexIamPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexIamRoleConfig <a name="DataYandexIamRoleConfig" id="@cdktf/provider-yandex.DataYandexIamRoleConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.Initializer"></a>

```typescript
import { DataYandexIamRoleConfig } from '@cdktf/provider-yandex'

const dataYandexIamRoleConfig: DataYandexIamRoleConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#description DataYandexIamRole#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#id DataYandexIamRole#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamRoleConfig.property.roleId">roleId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#role_id DataYandexIamRole#role_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#description DataYandexIamRole#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#id DataYandexIamRole#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `roleId`<sup>Optional</sup> <a name="roleId" id="@cdktf/provider-yandex.DataYandexIamRoleConfig.property.roleId"></a>

```typescript
public readonly roleId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_role#role_id DataYandexIamRole#role_id}.

---

### DataYandexIamServiceAccountConfig <a name="DataYandexIamServiceAccountConfig" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.Initializer"></a>

```typescript
import { DataYandexIamServiceAccountConfig } from '@cdktf/provider-yandex'

const dataYandexIamServiceAccountConfig: DataYandexIamServiceAccountConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#folder_id DataYandexIamServiceAccount#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#id DataYandexIamServiceAccount#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#name DataYandexIamServiceAccount#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#service_account_id DataYandexIamServiceAccount#service_account_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#folder_id DataYandexIamServiceAccount#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#id DataYandexIamServiceAccount#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#name DataYandexIamServiceAccount#name}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexIamServiceAccountConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_service_account#service_account_id DataYandexIamServiceAccount#service_account_id}.

---

### DataYandexIamUserConfig <a name="DataYandexIamUserConfig" id="@cdktf/provider-yandex.DataYandexIamUserConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIamUserConfig.Initializer"></a>

```typescript
import { DataYandexIamUserConfig } from '@cdktf/provider-yandex'

const dataYandexIamUserConfig: DataYandexIamUserConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#id DataYandexIamUser#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.login">login</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#login DataYandexIamUser#login}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamUserConfig.property.userId">userId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#user_id DataYandexIamUser#user_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#id DataYandexIamUser#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `login`<sup>Optional</sup> <a name="login" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.login"></a>

```typescript
public readonly login: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#login DataYandexIamUser#login}.

---

##### `userId`<sup>Optional</sup> <a name="userId" id="@cdktf/provider-yandex.DataYandexIamUserConfig.property.userId"></a>

```typescript
public readonly userId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iam_user#user_id DataYandexIamUser#user_id}.

---

### DataYandexIotCoreDeviceConfig <a name="DataYandexIotCoreDeviceConfig" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.Initializer"></a>

```typescript
import { DataYandexIotCoreDeviceConfig } from '@cdktf/provider-yandex'

const dataYandexIotCoreDeviceConfig: DataYandexIotCoreDeviceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.deviceId">deviceId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#device_id DataYandexIotCoreDevice#device_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#id DataYandexIotCoreDevice#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#name DataYandexIotCoreDevice#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `deviceId`<sup>Optional</sup> <a name="deviceId" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#device_id DataYandexIotCoreDevice#device_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#id DataYandexIotCoreDevice#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIotCoreDeviceConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#name DataYandexIotCoreDevice#name}.

---

### DataYandexIotCoreRegistryConfig <a name="DataYandexIotCoreRegistryConfig" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.Initializer"></a>

```typescript
import { DataYandexIotCoreRegistryConfig } from '@cdktf/provider-yandex'

const dataYandexIotCoreRegistryConfig: DataYandexIotCoreRegistryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#folder_id DataYandexIotCoreRegistry#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#id DataYandexIotCoreRegistry#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#name DataYandexIotCoreRegistry#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.registryId">registryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#registry_id DataYandexIotCoreRegistry#registry_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#folder_id DataYandexIotCoreRegistry#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#id DataYandexIotCoreRegistry#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#name DataYandexIotCoreRegistry#name}.

---

##### `registryId`<sup>Optional</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexIotCoreRegistryConfig.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_registry#registry_id DataYandexIotCoreRegistry#registry_id}.

---

### DataYandexKubernetesClusterConfig <a name="DataYandexKubernetesClusterConfig" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterConfig } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterConfig: DataYandexKubernetesClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#cluster_id DataYandexKubernetesCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#folder_id DataYandexKubernetesCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#id DataYandexKubernetesCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#name DataYandexKubernetesCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#cluster_id DataYandexKubernetesCluster#cluster_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#folder_id DataYandexKubernetesCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#id DataYandexKubernetesCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexKubernetesClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_cluster#name DataYandexKubernetesCluster#name}.

---

### DataYandexKubernetesClusterKmsProvider <a name="DataYandexKubernetesClusterKmsProvider" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProvider"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProvider.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterKmsProvider } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterKmsProvider: DataYandexKubernetesClusterKmsProvider = { ... }
```


### DataYandexKubernetesClusterMaster <a name="DataYandexKubernetesClusterMaster" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMaster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMaster.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMaster } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMaster: DataYandexKubernetesClusterMaster = { ... }
```


### DataYandexKubernetesClusterMasterMaintenancePolicy <a name="DataYandexKubernetesClusterMasterMaintenancePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMasterMaintenancePolicy: DataYandexKubernetesClusterMasterMaintenancePolicy = { ... }
```


### DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow <a name="DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow: DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow = { ... }
```


### DataYandexKubernetesClusterMasterRegional <a name="DataYandexKubernetesClusterMasterRegional" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegional"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegional.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterRegional } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMasterRegional: DataYandexKubernetesClusterMasterRegional = { ... }
```


### DataYandexKubernetesClusterMasterVersionInfo <a name="DataYandexKubernetesClusterMasterVersionInfo" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfo"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfo.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterVersionInfo } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMasterVersionInfo: DataYandexKubernetesClusterMasterVersionInfo = { ... }
```


### DataYandexKubernetesClusterMasterZonal <a name="DataYandexKubernetesClusterMasterZonal" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonal"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonal.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterZonal } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterMasterZonal: DataYandexKubernetesClusterMasterZonal = { ... }
```


### DataYandexKubernetesClusterNetworkImplementation <a name="DataYandexKubernetesClusterNetworkImplementation" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementation.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementation } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterNetworkImplementation: DataYandexKubernetesClusterNetworkImplementation = { ... }
```


### DataYandexKubernetesClusterNetworkImplementationCilium <a name="DataYandexKubernetesClusterNetworkImplementationCilium" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCilium"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCilium.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementationCilium } from '@cdktf/provider-yandex'

const dataYandexKubernetesClusterNetworkImplementationCilium: DataYandexKubernetesClusterNetworkImplementationCilium = { ... }
```


### DataYandexKubernetesNodeGroupAllocationPolicy <a name="DataYandexKubernetesNodeGroupAllocationPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupAllocationPolicy: DataYandexKubernetesNodeGroupAllocationPolicy = { ... }
```


### DataYandexKubernetesNodeGroupAllocationPolicyLocation <a name="DataYandexKubernetesNodeGroupAllocationPolicyLocation" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocation.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicyLocation } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupAllocationPolicyLocation: DataYandexKubernetesNodeGroupAllocationPolicyLocation = { ... }
```


### DataYandexKubernetesNodeGroupConfig <a name="DataYandexKubernetesNodeGroupConfig" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupConfig } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupConfig: DataYandexKubernetesNodeGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#folder_id DataYandexKubernetesNodeGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#id DataYandexKubernetesNodeGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#name DataYandexKubernetesNodeGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.nodeGroupId">nodeGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#node_group_id DataYandexKubernetesNodeGroup#node_group_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#folder_id DataYandexKubernetesNodeGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#id DataYandexKubernetesNodeGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#name DataYandexKubernetesNodeGroup#name}.

---

##### `nodeGroupId`<sup>Optional</sup> <a name="nodeGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupConfig.property.nodeGroupId"></a>

```typescript
public readonly nodeGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/kubernetes_node_group#node_group_id DataYandexKubernetesNodeGroup#node_group_id}.

---

### DataYandexKubernetesNodeGroupDeployPolicy <a name="DataYandexKubernetesNodeGroupDeployPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupDeployPolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupDeployPolicy: DataYandexKubernetesNodeGroupDeployPolicy = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplate <a name="DataYandexKubernetesNodeGroupInstanceTemplate" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplate.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplate } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplate: DataYandexKubernetesNodeGroupInstanceTemplate = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplateBootDisk <a name="DataYandexKubernetesNodeGroupInstanceTemplateBootDisk" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDisk.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateBootDisk } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplateBootDisk: DataYandexKubernetesNodeGroupInstanceTemplateBootDisk = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime <a name="DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime: DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface <a name="DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface: DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy <a name="DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy: DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplateResources <a name="DataYandexKubernetesNodeGroupInstanceTemplateResources" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResources.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateResources } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplateResources: DataYandexKubernetesNodeGroupInstanceTemplateResources = { ... }
```


### DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy <a name="DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy: DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy = { ... }
```


### DataYandexKubernetesNodeGroupMaintenancePolicy <a name="DataYandexKubernetesNodeGroupMaintenancePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupMaintenancePolicy: DataYandexKubernetesNodeGroupMaintenancePolicy = { ... }
```


### DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow <a name="DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow: DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow = { ... }
```


### DataYandexKubernetesNodeGroupScalePolicy <a name="DataYandexKubernetesNodeGroupScalePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicy.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicy } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupScalePolicy: DataYandexKubernetesNodeGroupScalePolicy = { ... }
```


### DataYandexKubernetesNodeGroupScalePolicyAutoScale <a name="DataYandexKubernetesNodeGroupScalePolicyAutoScale" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScale.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyAutoScale } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupScalePolicyAutoScale: DataYandexKubernetesNodeGroupScalePolicyAutoScale = { ... }
```


### DataYandexKubernetesNodeGroupScalePolicyFixedScale <a name="DataYandexKubernetesNodeGroupScalePolicyFixedScale" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScale.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyFixedScale } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupScalePolicyFixedScale: DataYandexKubernetesNodeGroupScalePolicyFixedScale = { ... }
```


### DataYandexKubernetesNodeGroupVersionInfo <a name="DataYandexKubernetesNodeGroupVersionInfo" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfo"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfo.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupVersionInfo } from '@cdktf/provider-yandex'

const dataYandexKubernetesNodeGroupVersionInfo: DataYandexKubernetesNodeGroupVersionInfo = { ... }
```


### DataYandexLbNetworkLoadBalancerAttachedTargetGroup <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroup" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroup.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroup } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerAttachedTargetGroup: DataYandexLbNetworkLoadBalancerAttachedTargetGroup = { ... }
```


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck = { ... }
```


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions = { ... }
```


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions = { ... }
```


### DataYandexLbNetworkLoadBalancerConfig <a name="DataYandexLbNetworkLoadBalancerConfig" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerConfig } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerConfig: DataYandexLbNetworkLoadBalancerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#folder_id DataYandexLbNetworkLoadBalancer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#id DataYandexLbNetworkLoadBalancer#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#name DataYandexLbNetworkLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.networkLoadBalancerId">networkLoadBalancerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#network_load_balancer_id DataYandexLbNetworkLoadBalancer#network_load_balancer_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#folder_id DataYandexLbNetworkLoadBalancer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#id DataYandexLbNetworkLoadBalancer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#name DataYandexLbNetworkLoadBalancer#name}.

---

##### `networkLoadBalancerId`<sup>Optional</sup> <a name="networkLoadBalancerId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerConfig.property.networkLoadBalancerId"></a>

```typescript
public readonly networkLoadBalancerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_network_load_balancer#network_load_balancer_id DataYandexLbNetworkLoadBalancer#network_load_balancer_id}.

---

### DataYandexLbNetworkLoadBalancerListener <a name="DataYandexLbNetworkLoadBalancerListener" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListener"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListener.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListener } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerListener: DataYandexLbNetworkLoadBalancerListener = { ... }
```


### DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec <a name="DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerListenerExternalAddressSpec: DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec = { ... }
```


### DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec <a name="DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec } from '@cdktf/provider-yandex'

const dataYandexLbNetworkLoadBalancerListenerInternalAddressSpec: DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec = { ... }
```


### DataYandexLbTargetGroupConfig <a name="DataYandexLbTargetGroupConfig" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.Initializer"></a>

```typescript
import { DataYandexLbTargetGroupConfig } from '@cdktf/provider-yandex'

const dataYandexLbTargetGroupConfig: DataYandexLbTargetGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#folder_id DataYandexLbTargetGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#id DataYandexLbTargetGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#name DataYandexLbTargetGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#target_group_id DataYandexLbTargetGroup#target_group_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#folder_id DataYandexLbTargetGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#id DataYandexLbTargetGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#name DataYandexLbTargetGroup#name}.

---

##### `targetGroupId`<sup>Optional</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexLbTargetGroupConfig.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/lb_target_group#target_group_id DataYandexLbTargetGroup#target_group_id}.

---

### DataYandexLbTargetGroupTarget <a name="DataYandexLbTargetGroupTarget" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTarget.Initializer"></a>

```typescript
import { DataYandexLbTargetGroupTarget } from '@cdktf/provider-yandex'

const dataYandexLbTargetGroupTarget: DataYandexLbTargetGroupTarget = { ... }
```


### DataYandexLoggingGroupConfig <a name="DataYandexLoggingGroupConfig" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.Initializer"></a>

```typescript
import { DataYandexLoggingGroupConfig } from '@cdktf/provider-yandex'

const dataYandexLoggingGroupConfig: DataYandexLoggingGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#folder_id DataYandexLoggingGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.groupId">groupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#group_id DataYandexLoggingGroup#group_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#id DataYandexLoggingGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#name DataYandexLoggingGroup#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#folder_id DataYandexLoggingGroup#folder_id}.

---

##### `groupId`<sup>Optional</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#group_id DataYandexLoggingGroup#group_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#id DataYandexLoggingGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLoggingGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/logging_group#name DataYandexLoggingGroup#name}.

---

### DataYandexMdbClickhouseClusterAccess <a name="DataYandexMdbClickhouseClusterAccess" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccess.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterAccess } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterAccess: DataYandexMdbClickhouseClusterAccess = { ... }
```


### DataYandexMdbClickhouseClusterBackupWindowStart <a name="DataYandexMdbClickhouseClusterBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterBackupWindowStart: DataYandexMdbClickhouseClusterBackupWindowStart = { ... }
```


### DataYandexMdbClickhouseClusterClickhouse <a name="DataYandexMdbClickhouseClusterClickhouse" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouse"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouse.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouse } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouse: DataYandexMdbClickhouseClusterClickhouse = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfig <a name="DataYandexMdbClickhouseClusterClickhouseConfig" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfig.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfig } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfig: DataYandexMdbClickhouseClusterClickhouseConfig = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigCompression <a name="DataYandexMdbClickhouseClusterClickhouseConfigCompression" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompression"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompression.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigCompression } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigCompression: DataYandexMdbClickhouseClusterClickhouseConfigCompression = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigKafka <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafka" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafka"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafka.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafka } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigKafka: DataYandexMdbClickhouseClusterClickhouseConfigKafka = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigMergeTree <a name="DataYandexMdbClickhouseClusterClickhouseConfigMergeTree" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTree"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTree.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigMergeTree } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigMergeTree: DataYandexMdbClickhouseClusterClickhouseConfigMergeTree = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq <a name="DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseConfigRabbitmq: DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq = { ... }
```


### DataYandexMdbClickhouseClusterClickhouseResources <a name="DataYandexMdbClickhouseClusterClickhouseResources" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResources.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseResources } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterClickhouseResources: DataYandexMdbClickhouseClusterClickhouseResources = { ... }
```


### DataYandexMdbClickhouseClusterCloudStorage <a name="DataYandexMdbClickhouseClusterCloudStorage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterCloudStorage } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterCloudStorage: DataYandexMdbClickhouseClusterCloudStorage = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#enabled DataYandexMdbClickhouseCluster#enabled}. |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#enabled DataYandexMdbClickhouseCluster#enabled}.

---

### DataYandexMdbClickhouseClusterConfig <a name="DataYandexMdbClickhouseClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterConfig: DataYandexMdbClickhouseClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.cloudStorage">cloudStorage</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a></code> | cloud_storage block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#cluster_id DataYandexMdbClickhouseCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#deletion_protection DataYandexMdbClickhouseCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#folder_id DataYandexMdbClickhouseCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#id DataYandexMdbClickhouseCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#name DataYandexMdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#service_account_id DataYandexMdbClickhouseCluster#service_account_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudStorage`<sup>Optional</sup> <a name="cloudStorage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.cloudStorage"></a>

```typescript
public readonly cloudStorage: DataYandexMdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a>

cloud_storage block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#cloud_storage DataYandexMdbClickhouseCluster#cloud_storage}

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#cluster_id DataYandexMdbClickhouseCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#deletion_protection DataYandexMdbClickhouseCluster#deletion_protection}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#folder_id DataYandexMdbClickhouseCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#id DataYandexMdbClickhouseCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#name DataYandexMdbClickhouseCluster#name}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_clickhouse_cluster#service_account_id DataYandexMdbClickhouseCluster#service_account_id}.

---

### DataYandexMdbClickhouseClusterDatabase <a name="DataYandexMdbClickhouseClusterDatabase" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabase.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterDatabase } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterDatabase: DataYandexMdbClickhouseClusterDatabase = { ... }
```


### DataYandexMdbClickhouseClusterFormatSchema <a name="DataYandexMdbClickhouseClusterFormatSchema" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchema"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchema.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterFormatSchema } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterFormatSchema: DataYandexMdbClickhouseClusterFormatSchema = { ... }
```


### DataYandexMdbClickhouseClusterHost <a name="DataYandexMdbClickhouseClusterHost" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterHost: DataYandexMdbClickhouseClusterHost = { ... }
```


### DataYandexMdbClickhouseClusterMaintenanceWindow <a name="DataYandexMdbClickhouseClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterMaintenanceWindow: DataYandexMdbClickhouseClusterMaintenanceWindow = { ... }
```


### DataYandexMdbClickhouseClusterMlModel <a name="DataYandexMdbClickhouseClusterMlModel" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModel"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModel.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMlModel } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterMlModel: DataYandexMdbClickhouseClusterMlModel = { ... }
```


### DataYandexMdbClickhouseClusterShardGroup <a name="DataYandexMdbClickhouseClusterShardGroup" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroup.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterShardGroup } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterShardGroup: DataYandexMdbClickhouseClusterShardGroup = { ... }
```


### DataYandexMdbClickhouseClusterUser <a name="DataYandexMdbClickhouseClusterUser" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterUser: DataYandexMdbClickhouseClusterUser = { ... }
```


### DataYandexMdbClickhouseClusterUserPermission <a name="DataYandexMdbClickhouseClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterUserPermission: DataYandexMdbClickhouseClusterUserPermission = { ... }
```


### DataYandexMdbClickhouseClusterUserQuota <a name="DataYandexMdbClickhouseClusterUserQuota" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuota"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuota.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserQuota } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterUserQuota: DataYandexMdbClickhouseClusterUserQuota = { ... }
```


### DataYandexMdbClickhouseClusterUserSettings <a name="DataYandexMdbClickhouseClusterUserSettings" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettings.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserSettings } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterUserSettings: DataYandexMdbClickhouseClusterUserSettings = { ... }
```


### DataYandexMdbClickhouseClusterZookeeper <a name="DataYandexMdbClickhouseClusterZookeeper" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeper"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeper.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeper } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterZookeeper: DataYandexMdbClickhouseClusterZookeeper = { ... }
```


### DataYandexMdbClickhouseClusterZookeeperResources <a name="DataYandexMdbClickhouseClusterZookeeperResources" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResources.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeperResources } from '@cdktf/provider-yandex'

const dataYandexMdbClickhouseClusterZookeeperResources: DataYandexMdbClickhouseClusterZookeeperResources = { ... }
```


### DataYandexMdbElasticsearchClusterConfig <a name="DataYandexMdbElasticsearchClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfig: DataYandexMdbElasticsearchClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#cluster_id DataYandexMdbElasticsearchCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#deletion_protection DataYandexMdbElasticsearchCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#description DataYandexMdbElasticsearchCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#folder_id DataYandexMdbElasticsearchCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#id DataYandexMdbElasticsearchCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#labels DataYandexMdbElasticsearchCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#name DataYandexMdbElasticsearchCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#security_group_ids DataYandexMdbElasticsearchCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#service_account_id DataYandexMdbElasticsearchCluster#service_account_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#cluster_id DataYandexMdbElasticsearchCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#deletion_protection DataYandexMdbElasticsearchCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#description DataYandexMdbElasticsearchCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#folder_id DataYandexMdbElasticsearchCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#id DataYandexMdbElasticsearchCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#labels DataYandexMdbElasticsearchCluster#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#name DataYandexMdbElasticsearchCluster#name}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#security_group_ids DataYandexMdbElasticsearchCluster#security_group_ids}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_elasticsearch_cluster#service_account_id DataYandexMdbElasticsearchCluster#service_account_id}.

---

### DataYandexMdbElasticsearchClusterConfigA <a name="DataYandexMdbElasticsearchClusterConfigA" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigA.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigA } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfigA: DataYandexMdbElasticsearchClusterConfigA = { ... }
```


### DataYandexMdbElasticsearchClusterConfigDataNode <a name="DataYandexMdbElasticsearchClusterConfigDataNode" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNode.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNode } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfigDataNode: DataYandexMdbElasticsearchClusterConfigDataNode = { ... }
```


### DataYandexMdbElasticsearchClusterConfigDataNodeResources <a name="DataYandexMdbElasticsearchClusterConfigDataNodeResources" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResources.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNodeResources } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfigDataNodeResources: DataYandexMdbElasticsearchClusterConfigDataNodeResources = { ... }
```


### DataYandexMdbElasticsearchClusterConfigMasterNode <a name="DataYandexMdbElasticsearchClusterConfigMasterNode" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNode.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNode } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfigMasterNode: DataYandexMdbElasticsearchClusterConfigMasterNode = { ... }
```


### DataYandexMdbElasticsearchClusterConfigMasterNodeResources <a name="DataYandexMdbElasticsearchClusterConfigMasterNodeResources" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResources.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNodeResources } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterConfigMasterNodeResources: DataYandexMdbElasticsearchClusterConfigMasterNodeResources = { ... }
```


### DataYandexMdbElasticsearchClusterHost <a name="DataYandexMdbElasticsearchClusterHost" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterHost: DataYandexMdbElasticsearchClusterHost = { ... }
```


### DataYandexMdbElasticsearchClusterMaintenanceWindow <a name="DataYandexMdbElasticsearchClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbElasticsearchClusterMaintenanceWindow: DataYandexMdbElasticsearchClusterMaintenanceWindow = { ... }
```


### DataYandexMdbGreenplumClusterAccess <a name="DataYandexMdbGreenplumClusterAccess" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccess.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterAccess } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterAccess: DataYandexMdbGreenplumClusterAccess = { ... }
```


### DataYandexMdbGreenplumClusterBackupWindowStart <a name="DataYandexMdbGreenplumClusterBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterBackupWindowStart: DataYandexMdbGreenplumClusterBackupWindowStart = { ... }
```


### DataYandexMdbGreenplumClusterConfig <a name="DataYandexMdbGreenplumClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterConfig: DataYandexMdbGreenplumClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#cluster_id DataYandexMdbGreenplumCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#folder_id DataYandexMdbGreenplumCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#id DataYandexMdbGreenplumCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#name DataYandexMdbGreenplumCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#cluster_id DataYandexMdbGreenplumCluster#cluster_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#folder_id DataYandexMdbGreenplumCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#id DataYandexMdbGreenplumCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_greenplum_cluster#name DataYandexMdbGreenplumCluster#name}.

---

### DataYandexMdbGreenplumClusterMasterHosts <a name="DataYandexMdbGreenplumClusterMasterHosts" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHosts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHosts.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterHosts } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterMasterHosts: DataYandexMdbGreenplumClusterMasterHosts = { ... }
```


### DataYandexMdbGreenplumClusterMasterSubcluster <a name="DataYandexMdbGreenplumClusterMasterSubcluster" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubcluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubcluster.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubcluster } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterMasterSubcluster: DataYandexMdbGreenplumClusterMasterSubcluster = { ... }
```


### DataYandexMdbGreenplumClusterMasterSubclusterResources <a name="DataYandexMdbGreenplumClusterMasterSubclusterResources" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResources.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubclusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterMasterSubclusterResources: DataYandexMdbGreenplumClusterMasterSubclusterResources = { ... }
```


### DataYandexMdbGreenplumClusterSegmentHosts <a name="DataYandexMdbGreenplumClusterSegmentHosts" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHosts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHosts.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentHosts } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterSegmentHosts: DataYandexMdbGreenplumClusterSegmentHosts = { ... }
```


### DataYandexMdbGreenplumClusterSegmentSubcluster <a name="DataYandexMdbGreenplumClusterSegmentSubcluster" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubcluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubcluster.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubcluster } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterSegmentSubcluster: DataYandexMdbGreenplumClusterSegmentSubcluster = { ... }
```


### DataYandexMdbGreenplumClusterSegmentSubclusterResources <a name="DataYandexMdbGreenplumClusterSegmentSubclusterResources" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResources.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubclusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbGreenplumClusterSegmentSubclusterResources: DataYandexMdbGreenplumClusterSegmentSubclusterResources = { ... }
```


### DataYandexMdbKafkaClusterConfig <a name="DataYandexMdbKafkaClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfig: DataYandexMdbKafkaClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cluster_id DataYandexMdbKafkaCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a></code> | config block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#deletion_protection DataYandexMdbKafkaCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#folder_id DataYandexMdbKafkaCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#id DataYandexMdbKafkaCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#subnet_ids DataYandexMdbKafkaCluster#subnet_ids}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.topic">topic</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]</code> | topic block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]</code> | user block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cluster_id DataYandexMdbKafkaCluster#cluster_id}.

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.config"></a>

```typescript
public readonly config: DataYandexMdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#config DataYandexMdbKafkaCluster#config}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#deletion_protection DataYandexMdbKafkaCluster#deletion_protection}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#folder_id DataYandexMdbKafkaCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#id DataYandexMdbKafkaCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}.

---

##### `subnetIds`<sup>Optional</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#subnet_ids DataYandexMdbKafkaCluster#subnet_ids}.

---

##### `topic`<sup>Optional</sup> <a name="topic" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.topic"></a>

```typescript
public readonly topic: IResolvable | DataYandexMdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]

topic block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#topic DataYandexMdbKafkaCluster#topic}

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | DataYandexMdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#user DataYandexMdbKafkaCluster#user}

---

### DataYandexMdbKafkaClusterConfigA <a name="DataYandexMdbKafkaClusterConfigA" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigA } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigA: DataYandexMdbKafkaClusterConfigA = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a></code> | kafka block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#version DataYandexMdbKafkaCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.zones">zones</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#zones DataYandexMdbKafkaCluster#zones}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#assign_public_ip DataYandexMdbKafkaCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.brokersCount">brokersCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#brokers_count DataYandexMdbKafkaCluster#brokers_count}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.schemaRegistry">schemaRegistry</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#schema_registry DataYandexMdbKafkaCluster#schema_registry}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.unmanagedTopics">unmanagedTopics</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#unmanaged_topics DataYandexMdbKafkaCluster#unmanaged_topics}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a></code> | zookeeper block. |

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.kafka"></a>

```typescript
public readonly kafka: DataYandexMdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a>

kafka block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#kafka DataYandexMdbKafkaCluster#kafka}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#version DataYandexMdbKafkaCluster#version}.

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#zones DataYandexMdbKafkaCluster#zones}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#assign_public_ip DataYandexMdbKafkaCluster#assign_public_ip}.

---

##### `brokersCount`<sup>Optional</sup> <a name="brokersCount" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.brokersCount"></a>

```typescript
public readonly brokersCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#brokers_count DataYandexMdbKafkaCluster#brokers_count}.

---

##### `schemaRegistry`<sup>Optional</sup> <a name="schemaRegistry" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.schemaRegistry"></a>

```typescript
public readonly schemaRegistry: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#schema_registry DataYandexMdbKafkaCluster#schema_registry}.

---

##### `unmanagedTopics`<sup>Optional</sup> <a name="unmanagedTopics" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.unmanagedTopics"></a>

```typescript
public readonly unmanagedTopics: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#unmanaged_topics DataYandexMdbKafkaCluster#unmanaged_topics}.

---

##### `zookeeper`<sup>Optional</sup> <a name="zookeeper" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA.property.zookeeper"></a>

```typescript
public readonly zookeeper: DataYandexMdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a>

zookeeper block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#zookeeper DataYandexMdbKafkaCluster#zookeeper}

---

### DataYandexMdbKafkaClusterConfigKafka <a name="DataYandexMdbKafkaClusterConfigKafka" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafka } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigKafka: DataYandexMdbKafkaClusterConfigKafka = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka.property.kafkaConfig">kafkaConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a></code> | kafka_config block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resources DataYandexMdbKafkaCluster#resources}

---

##### `kafkaConfig`<sup>Optional</sup> <a name="kafkaConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka.property.kafkaConfig"></a>

```typescript
public readonly kafkaConfig: DataYandexMdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a>

kafka_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#kafka_config DataYandexMdbKafkaCluster#kafka_config}

---

### DataYandexMdbKafkaClusterConfigKafkaKafkaConfig <a name="DataYandexMdbKafkaClusterConfigKafkaKafkaConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafkaKafkaConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigKafkaKafkaConfig: DataYandexMdbKafkaClusterConfigKafkaKafkaConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.autoCreateTopicsEnable">autoCreateTopicsEnable</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#auto_create_topics_enable DataYandexMdbKafkaCluster#auto_create_topics_enable}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.compressionType">compressionType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#compression_type DataYandexMdbKafkaCluster#compression_type}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.defaultReplicationFactor">defaultReplicationFactor</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#default_replication_factor DataYandexMdbKafkaCluster#default_replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMessages">logFlushIntervalMessages</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_interval_messages DataYandexMdbKafkaCluster#log_flush_interval_messages}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMs">logFlushIntervalMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_interval_ms DataYandexMdbKafkaCluster#log_flush_interval_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushSchedulerIntervalMs">logFlushSchedulerIntervalMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_scheduler_interval_ms DataYandexMdbKafkaCluster#log_flush_scheduler_interval_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logPreallocate">logPreallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_preallocate DataYandexMdbKafkaCluster#log_preallocate}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionBytes">logRetentionBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_bytes DataYandexMdbKafkaCluster#log_retention_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionHours">logRetentionHours</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_hours DataYandexMdbKafkaCluster#log_retention_hours}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMinutes">logRetentionMinutes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_minutes DataYandexMdbKafkaCluster#log_retention_minutes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMs">logRetentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_ms DataYandexMdbKafkaCluster#log_retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logSegmentBytes">logSegmentBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_segment_bytes DataYandexMdbKafkaCluster#log_segment_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.numPartitions">numPartitions</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#num_partitions DataYandexMdbKafkaCluster#num_partitions}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.socketReceiveBufferBytes">socketReceiveBufferBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#socket_receive_buffer_bytes DataYandexMdbKafkaCluster#socket_receive_buffer_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.socketSendBufferBytes">socketSendBufferBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#socket_send_buffer_bytes DataYandexMdbKafkaCluster#socket_send_buffer_bytes}. |

---

##### `autoCreateTopicsEnable`<sup>Optional</sup> <a name="autoCreateTopicsEnable" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.autoCreateTopicsEnable"></a>

```typescript
public readonly autoCreateTopicsEnable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#auto_create_topics_enable DataYandexMdbKafkaCluster#auto_create_topics_enable}.

---

##### `compressionType`<sup>Optional</sup> <a name="compressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#compression_type DataYandexMdbKafkaCluster#compression_type}.

---

##### `defaultReplicationFactor`<sup>Optional</sup> <a name="defaultReplicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.defaultReplicationFactor"></a>

```typescript
public readonly defaultReplicationFactor: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#default_replication_factor DataYandexMdbKafkaCluster#default_replication_factor}.

---

##### `logFlushIntervalMessages`<sup>Optional</sup> <a name="logFlushIntervalMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMessages"></a>

```typescript
public readonly logFlushIntervalMessages: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_interval_messages DataYandexMdbKafkaCluster#log_flush_interval_messages}.

---

##### `logFlushIntervalMs`<sup>Optional</sup> <a name="logFlushIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMs"></a>

```typescript
public readonly logFlushIntervalMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_interval_ms DataYandexMdbKafkaCluster#log_flush_interval_ms}.

---

##### `logFlushSchedulerIntervalMs`<sup>Optional</sup> <a name="logFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushSchedulerIntervalMs"></a>

```typescript
public readonly logFlushSchedulerIntervalMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_flush_scheduler_interval_ms DataYandexMdbKafkaCluster#log_flush_scheduler_interval_ms}.

---

##### `logPreallocate`<sup>Optional</sup> <a name="logPreallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logPreallocate"></a>

```typescript
public readonly logPreallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_preallocate DataYandexMdbKafkaCluster#log_preallocate}.

---

##### `logRetentionBytes`<sup>Optional</sup> <a name="logRetentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionBytes"></a>

```typescript
public readonly logRetentionBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_bytes DataYandexMdbKafkaCluster#log_retention_bytes}.

---

##### `logRetentionHours`<sup>Optional</sup> <a name="logRetentionHours" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionHours"></a>

```typescript
public readonly logRetentionHours: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_hours DataYandexMdbKafkaCluster#log_retention_hours}.

---

##### `logRetentionMinutes`<sup>Optional</sup> <a name="logRetentionMinutes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMinutes"></a>

```typescript
public readonly logRetentionMinutes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_minutes DataYandexMdbKafkaCluster#log_retention_minutes}.

---

##### `logRetentionMs`<sup>Optional</sup> <a name="logRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMs"></a>

```typescript
public readonly logRetentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_retention_ms DataYandexMdbKafkaCluster#log_retention_ms}.

---

##### `logSegmentBytes`<sup>Optional</sup> <a name="logSegmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.logSegmentBytes"></a>

```typescript
public readonly logSegmentBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#log_segment_bytes DataYandexMdbKafkaCluster#log_segment_bytes}.

---

##### `numPartitions`<sup>Optional</sup> <a name="numPartitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.numPartitions"></a>

```typescript
public readonly numPartitions: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#num_partitions DataYandexMdbKafkaCluster#num_partitions}.

---

##### `socketReceiveBufferBytes`<sup>Optional</sup> <a name="socketReceiveBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.socketReceiveBufferBytes"></a>

```typescript
public readonly socketReceiveBufferBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#socket_receive_buffer_bytes DataYandexMdbKafkaCluster#socket_receive_buffer_bytes}.

---

##### `socketSendBufferBytes`<sup>Optional</sup> <a name="socketSendBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig.property.socketSendBufferBytes"></a>

```typescript
public readonly socketSendBufferBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#socket_send_buffer_bytes DataYandexMdbKafkaCluster#socket_send_buffer_bytes}.

---

### DataYandexMdbKafkaClusterConfigKafkaResources <a name="DataYandexMdbKafkaClusterConfigKafkaResources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafkaResources } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigKafkaResources: DataYandexMdbKafkaClusterConfigKafkaResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_size DataYandexMdbKafkaCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_type_id DataYandexMdbKafkaCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resource_preset_id DataYandexMdbKafkaCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_size DataYandexMdbKafkaCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_type_id DataYandexMdbKafkaCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resource_preset_id DataYandexMdbKafkaCluster#resource_preset_id}.

---

### DataYandexMdbKafkaClusterConfigZookeeper <a name="DataYandexMdbKafkaClusterConfigZookeeper" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigZookeeper } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigZookeeper: DataYandexMdbKafkaClusterConfigZookeeper = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a></code> | resources block. |

---

##### `resources`<sup>Optional</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resources DataYandexMdbKafkaCluster#resources}

---

### DataYandexMdbKafkaClusterConfigZookeeperResources <a name="DataYandexMdbKafkaClusterConfigZookeeperResources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigZookeeperResources } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterConfigZookeeperResources: DataYandexMdbKafkaClusterConfigZookeeperResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_size DataYandexMdbKafkaCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_type_id DataYandexMdbKafkaCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resource_preset_id DataYandexMdbKafkaCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Optional</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_size DataYandexMdbKafkaCluster#disk_size}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#disk_type_id DataYandexMdbKafkaCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Optional</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#resource_preset_id DataYandexMdbKafkaCluster#resource_preset_id}.

---

### DataYandexMdbKafkaClusterHost <a name="DataYandexMdbKafkaClusterHost" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterHost: DataYandexMdbKafkaClusterHost = { ... }
```


### DataYandexMdbKafkaClusterMaintenanceWindow <a name="DataYandexMdbKafkaClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterMaintenanceWindow: DataYandexMdbKafkaClusterMaintenanceWindow = { ... }
```


### DataYandexMdbKafkaClusterTopic <a name="DataYandexMdbKafkaClusterTopic" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterTopic } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterTopic: DataYandexMdbKafkaClusterTopic = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cluster_id DataYandexMdbKafkaCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.partitions">partitions</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#partitions DataYandexMdbKafkaCluster#partitions}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#replication_factor DataYandexMdbKafkaCluster#replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a></code> | topic_config block. |

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cluster_id DataYandexMdbKafkaCluster#cluster_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}.

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#partitions DataYandexMdbKafkaCluster#partitions}.

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#replication_factor DataYandexMdbKafkaCluster#replication_factor}.

---

##### `topicConfig`<sup>Optional</sup> <a name="topicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic.property.topicConfig"></a>

```typescript
public readonly topicConfig: DataYandexMdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a>

topic_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#topic_config DataYandexMdbKafkaCluster#topic_config}

---

### DataYandexMdbKafkaClusterTopicTopicConfig <a name="DataYandexMdbKafkaClusterTopicTopicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterTopicTopicConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterTopicTopicConfig: DataYandexMdbKafkaClusterTopicTopicConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cleanup_policy DataYandexMdbKafkaCluster#cleanup_policy}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.compressionType">compressionType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#compression_type DataYandexMdbKafkaCluster#compression_type}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#delete_retention_ms DataYandexMdbKafkaCluster#delete_retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#file_delete_delay_ms DataYandexMdbKafkaCluster#file_delete_delay_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.flushMessages">flushMessages</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#flush_messages DataYandexMdbKafkaCluster#flush_messages}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.flushMs">flushMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#flush_ms DataYandexMdbKafkaCluster#flush_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#max_message_bytes DataYandexMdbKafkaCluster#max_message_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#min_compaction_lag_ms DataYandexMdbKafkaCluster#min_compaction_lag_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#min_insync_replicas DataYandexMdbKafkaCluster#min_insync_replicas}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#preallocate DataYandexMdbKafkaCluster#preallocate}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#retention_bytes DataYandexMdbKafkaCluster#retention_bytes}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.retentionMs">retentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#retention_ms DataYandexMdbKafkaCluster#retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#segment_bytes DataYandexMdbKafkaCluster#segment_bytes}. |

---

##### `cleanupPolicy`<sup>Optional</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#cleanup_policy DataYandexMdbKafkaCluster#cleanup_policy}.

---

##### `compressionType`<sup>Optional</sup> <a name="compressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#compression_type DataYandexMdbKafkaCluster#compression_type}.

---

##### `deleteRetentionMs`<sup>Optional</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#delete_retention_ms DataYandexMdbKafkaCluster#delete_retention_ms}.

---

##### `fileDeleteDelayMs`<sup>Optional</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#file_delete_delay_ms DataYandexMdbKafkaCluster#file_delete_delay_ms}.

---

##### `flushMessages`<sup>Optional</sup> <a name="flushMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#flush_messages DataYandexMdbKafkaCluster#flush_messages}.

---

##### `flushMs`<sup>Optional</sup> <a name="flushMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#flush_ms DataYandexMdbKafkaCluster#flush_ms}.

---

##### `maxMessageBytes`<sup>Optional</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#max_message_bytes DataYandexMdbKafkaCluster#max_message_bytes}.

---

##### `minCompactionLagMs`<sup>Optional</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#min_compaction_lag_ms DataYandexMdbKafkaCluster#min_compaction_lag_ms}.

---

##### `minInsyncReplicas`<sup>Optional</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#min_insync_replicas DataYandexMdbKafkaCluster#min_insync_replicas}.

---

##### `preallocate`<sup>Optional</sup> <a name="preallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#preallocate DataYandexMdbKafkaCluster#preallocate}.

---

##### `retentionBytes`<sup>Optional</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#retention_bytes DataYandexMdbKafkaCluster#retention_bytes}.

---

##### `retentionMs`<sup>Optional</sup> <a name="retentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#retention_ms DataYandexMdbKafkaCluster#retention_ms}.

---

##### `segmentBytes`<sup>Optional</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#segment_bytes DataYandexMdbKafkaCluster#segment_bytes}.

---

### DataYandexMdbKafkaClusterUser <a name="DataYandexMdbKafkaClusterUser" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterUser: DataYandexMdbKafkaClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#password DataYandexMdbKafkaCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]</code> | permission block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#name DataYandexMdbKafkaCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#password DataYandexMdbKafkaCluster#password}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | DataYandexMdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#permission DataYandexMdbKafkaCluster#permission}

---

### DataYandexMdbKafkaClusterUserPermission <a name="DataYandexMdbKafkaClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaClusterUserPermission: DataYandexMdbKafkaClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#role DataYandexMdbKafkaCluster#role}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission.property.topicName">topicName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#topic_name DataYandexMdbKafkaCluster#topic_name}. |

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#role DataYandexMdbKafkaCluster#role}.

---

##### `topicName`<sup>Required</sup> <a name="topicName" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_cluster#topic_name DataYandexMdbKafkaCluster#topic_name}.

---

### DataYandexMdbKafkaConnectorConfig <a name="DataYandexMdbKafkaConnectorConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConfig: DataYandexMdbKafkaConnectorConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#cluster_id DataYandexMdbKafkaConnector#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#name DataYandexMdbKafkaConnector#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#id DataYandexMdbKafkaConnector#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#cluster_id DataYandexMdbKafkaConnector#cluster_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#name DataYandexMdbKafkaConnector#name}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_connector#id DataYandexMdbKafkaConnector#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexMdbKafkaConnectorConnectorConfigMirrormaker <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormaker" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormaker"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormaker.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormaker } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormaker: DataYandexMdbKafkaConnectorConnectorConfigMirrormaker = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster = { ... }
```


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster = { ... }
```


### DataYandexMdbKafkaTopicConfig <a name="DataYandexMdbKafkaTopicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaTopicConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaTopicConfig: DataYandexMdbKafkaTopicConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#cluster_id DataYandexMdbKafkaTopic#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#name DataYandexMdbKafkaTopic#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#id DataYandexMdbKafkaTopic#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#cluster_id DataYandexMdbKafkaTopic#cluster_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#name DataYandexMdbKafkaTopic#name}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_kafka_topic#id DataYandexMdbKafkaTopic#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexMdbKafkaTopicTopicConfig <a name="DataYandexMdbKafkaTopicTopicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfig.Initializer"></a>

```typescript
import { DataYandexMdbKafkaTopicTopicConfig } from '@cdktf/provider-yandex'

const dataYandexMdbKafkaTopicTopicConfig: DataYandexMdbKafkaTopicTopicConfig = { ... }
```


### DataYandexMdbMongodbClusterClusterConfig <a name="DataYandexMdbMongodbClusterClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterClusterConfig: DataYandexMdbMongodbClusterClusterConfig = { ... }
```


### DataYandexMdbMongodbClusterClusterConfigAccess <a name="DataYandexMdbMongodbClusterClusterConfigAccess" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccess.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigAccess } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterClusterConfigAccess: DataYandexMdbMongodbClusterClusterConfigAccess = { ... }
```


### DataYandexMdbMongodbClusterClusterConfigBackupWindowStart <a name="DataYandexMdbMongodbClusterClusterConfigBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterClusterConfigBackupWindowStart: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart = { ... }
```


### DataYandexMdbMongodbClusterConfig <a name="DataYandexMdbMongodbClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterConfig: DataYandexMdbMongodbClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#cluster_id DataYandexMdbMongodbCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#deletion_protection DataYandexMdbMongodbCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#folder_id DataYandexMdbMongodbCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#id DataYandexMdbMongodbCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#cluster_id DataYandexMdbMongodbCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#deletion_protection DataYandexMdbMongodbCluster#deletion_protection}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#folder_id DataYandexMdbMongodbCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#id DataYandexMdbMongodbCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mongodb_cluster#name DataYandexMdbMongodbCluster#name}.

---

### DataYandexMdbMongodbClusterDatabase <a name="DataYandexMdbMongodbClusterDatabase" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabase.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterDatabase } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterDatabase: DataYandexMdbMongodbClusterDatabase = { ... }
```


### DataYandexMdbMongodbClusterHost <a name="DataYandexMdbMongodbClusterHost" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterHost: DataYandexMdbMongodbClusterHost = { ... }
```


### DataYandexMdbMongodbClusterMaintenanceWindow <a name="DataYandexMdbMongodbClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterMaintenanceWindow: DataYandexMdbMongodbClusterMaintenanceWindow = { ... }
```


### DataYandexMdbMongodbClusterResources <a name="DataYandexMdbMongodbClusterResources" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResources.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterResources: DataYandexMdbMongodbClusterResources = { ... }
```


### DataYandexMdbMongodbClusterUser <a name="DataYandexMdbMongodbClusterUser" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterUser: DataYandexMdbMongodbClusterUser = { ... }
```


### DataYandexMdbMongodbClusterUserPermission <a name="DataYandexMdbMongodbClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbMongodbClusterUserPermission: DataYandexMdbMongodbClusterUserPermission = { ... }
```


### DataYandexMdbMysqlClusterAccess <a name="DataYandexMdbMysqlClusterAccess" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterAccess } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterAccess: DataYandexMdbMysqlClusterAccess = { ... }
```


### DataYandexMdbMysqlClusterBackupWindowStart <a name="DataYandexMdbMysqlClusterBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterBackupWindowStart: DataYandexMdbMysqlClusterBackupWindowStart = { ... }
```


### DataYandexMdbMysqlClusterConfig <a name="DataYandexMdbMysqlClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterConfig: DataYandexMdbMysqlClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#cluster_id DataYandexMdbMysqlCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#deletion_protection DataYandexMdbMysqlCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#description DataYandexMdbMysqlCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#folder_id DataYandexMdbMysqlCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#id DataYandexMdbMysqlCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#labels DataYandexMdbMysqlCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.mysqlConfig">mysqlConfig</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#mysql_config DataYandexMdbMysqlCluster#mysql_config}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#name DataYandexMdbMysqlCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.access"></a>

```typescript
public readonly access: DataYandexMdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#access DataYandexMdbMysqlCluster#access}

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#cluster_id DataYandexMdbMysqlCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#deletion_protection DataYandexMdbMysqlCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#description DataYandexMdbMysqlCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#folder_id DataYandexMdbMysqlCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#id DataYandexMdbMysqlCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#labels DataYandexMdbMysqlCluster#labels}.

---

##### `mysqlConfig`<sup>Optional</sup> <a name="mysqlConfig" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.mysqlConfig"></a>

```typescript
public readonly mysqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#mysql_config DataYandexMdbMysqlCluster#mysql_config}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_mysql_cluster#name DataYandexMdbMysqlCluster#name}.

---

### DataYandexMdbMysqlClusterDatabase <a name="DataYandexMdbMysqlClusterDatabase" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabase.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterDatabase } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterDatabase: DataYandexMdbMysqlClusterDatabase = { ... }
```


### DataYandexMdbMysqlClusterHost <a name="DataYandexMdbMysqlClusterHost" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterHost: DataYandexMdbMysqlClusterHost = { ... }
```


### DataYandexMdbMysqlClusterMaintenanceWindow <a name="DataYandexMdbMysqlClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterMaintenanceWindow: DataYandexMdbMysqlClusterMaintenanceWindow = { ... }
```


### DataYandexMdbMysqlClusterResources <a name="DataYandexMdbMysqlClusterResources" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResources.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterResources: DataYandexMdbMysqlClusterResources = { ... }
```


### DataYandexMdbMysqlClusterUser <a name="DataYandexMdbMysqlClusterUser" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterUser: DataYandexMdbMysqlClusterUser = { ... }
```


### DataYandexMdbMysqlClusterUserConnectionLimits <a name="DataYandexMdbMysqlClusterUserConnectionLimits" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimits"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimits.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserConnectionLimits } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterUserConnectionLimits: DataYandexMdbMysqlClusterUserConnectionLimits = { ... }
```


### DataYandexMdbMysqlClusterUserPermission <a name="DataYandexMdbMysqlClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbMysqlClusterUserPermission: DataYandexMdbMysqlClusterUserPermission = { ... }
```


### DataYandexMdbPostgresqlClusterConfig <a name="DataYandexMdbPostgresqlClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfig: DataYandexMdbPostgresqlClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#cluster_id DataYandexMdbPostgresqlCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#deletion_protection DataYandexMdbPostgresqlCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#description DataYandexMdbPostgresqlCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#folder_id DataYandexMdbPostgresqlCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#id DataYandexMdbPostgresqlCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#name DataYandexMdbPostgresqlCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#cluster_id DataYandexMdbPostgresqlCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#deletion_protection DataYandexMdbPostgresqlCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#description DataYandexMdbPostgresqlCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#folder_id DataYandexMdbPostgresqlCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#id DataYandexMdbPostgresqlCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_postgresql_cluster#name DataYandexMdbPostgresqlCluster#name}.

---

### DataYandexMdbPostgresqlClusterConfigA <a name="DataYandexMdbPostgresqlClusterConfigA" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigA.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigA } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigA: DataYandexMdbPostgresqlClusterConfigA = { ... }
```


### DataYandexMdbPostgresqlClusterConfigAccess <a name="DataYandexMdbPostgresqlClusterConfigAccess" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccess.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigAccess } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigAccess: DataYandexMdbPostgresqlClusterConfigAccess = { ... }
```


### DataYandexMdbPostgresqlClusterConfigBackupWindowStart <a name="DataYandexMdbPostgresqlClusterConfigBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigBackupWindowStart: DataYandexMdbPostgresqlClusterConfigBackupWindowStart = { ... }
```


### DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics <a name="DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics: DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics = { ... }
```


### DataYandexMdbPostgresqlClusterConfigPoolerConfig <a name="DataYandexMdbPostgresqlClusterConfigPoolerConfig" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfig.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPoolerConfig } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigPoolerConfig: DataYandexMdbPostgresqlClusterConfigPoolerConfig = { ... }
```


### DataYandexMdbPostgresqlClusterConfigResources <a name="DataYandexMdbPostgresqlClusterConfigResources" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResources.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigResources } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterConfigResources: DataYandexMdbPostgresqlClusterConfigResources = { ... }
```


### DataYandexMdbPostgresqlClusterDatabase <a name="DataYandexMdbPostgresqlClusterDatabase" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabase.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabase } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterDatabase: DataYandexMdbPostgresqlClusterDatabase = { ... }
```


### DataYandexMdbPostgresqlClusterDatabaseExtension <a name="DataYandexMdbPostgresqlClusterDatabaseExtension" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtension"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtension.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabaseExtension } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterDatabaseExtension: DataYandexMdbPostgresqlClusterDatabaseExtension = { ... }
```


### DataYandexMdbPostgresqlClusterHost <a name="DataYandexMdbPostgresqlClusterHost" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterHost: DataYandexMdbPostgresqlClusterHost = { ... }
```


### DataYandexMdbPostgresqlClusterMaintenanceWindow <a name="DataYandexMdbPostgresqlClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterMaintenanceWindow: DataYandexMdbPostgresqlClusterMaintenanceWindow = { ... }
```


### DataYandexMdbPostgresqlClusterUser <a name="DataYandexMdbPostgresqlClusterUser" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterUser: DataYandexMdbPostgresqlClusterUser = { ... }
```


### DataYandexMdbPostgresqlClusterUserPermission <a name="DataYandexMdbPostgresqlClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbPostgresqlClusterUserPermission: DataYandexMdbPostgresqlClusterUserPermission = { ... }
```


### DataYandexMdbRedisClusterConfig <a name="DataYandexMdbRedisClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbRedisClusterConfig: DataYandexMdbRedisClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#cluster_id DataYandexMdbRedisCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#deletion_protection DataYandexMdbRedisCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#folder_id DataYandexMdbRedisCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#id DataYandexMdbRedisCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#name DataYandexMdbRedisCluster#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#cluster_id DataYandexMdbRedisCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#deletion_protection DataYandexMdbRedisCluster#deletion_protection}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#folder_id DataYandexMdbRedisCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#id DataYandexMdbRedisCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_redis_cluster#name DataYandexMdbRedisCluster#name}.

---

### DataYandexMdbRedisClusterConfigA <a name="DataYandexMdbRedisClusterConfigA" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigA.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterConfigA } from '@cdktf/provider-yandex'

const dataYandexMdbRedisClusterConfigA: DataYandexMdbRedisClusterConfigA = { ... }
```


### DataYandexMdbRedisClusterHost <a name="DataYandexMdbRedisClusterHost" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbRedisClusterHost: DataYandexMdbRedisClusterHost = { ... }
```


### DataYandexMdbRedisClusterMaintenanceWindow <a name="DataYandexMdbRedisClusterMaintenanceWindow" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindow.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const dataYandexMdbRedisClusterMaintenanceWindow: DataYandexMdbRedisClusterMaintenanceWindow = { ... }
```


### DataYandexMdbRedisClusterResources <a name="DataYandexMdbRedisClusterResources" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResources.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbRedisClusterResources: DataYandexMdbRedisClusterResources = { ... }
```


### DataYandexMdbSqlserverClusterBackupWindowStart <a name="DataYandexMdbSqlserverClusterBackupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStart.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterBackupWindowStart } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterBackupWindowStart: DataYandexMdbSqlserverClusterBackupWindowStart = { ... }
```


### DataYandexMdbSqlserverClusterConfig <a name="DataYandexMdbSqlserverClusterConfig" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterConfig } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterConfig: DataYandexMdbSqlserverClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#cluster_id DataYandexMdbSqlserverCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#deletion_protection DataYandexMdbSqlserverCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#folder_id DataYandexMdbSqlserverCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#id DataYandexMdbSqlserverCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#name DataYandexMdbSqlserverCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.sqlserverConfig">sqlserverConfig</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#sqlserver_config DataYandexMdbSqlserverCluster#sqlserver_config}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#cluster_id DataYandexMdbSqlserverCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#deletion_protection DataYandexMdbSqlserverCluster#deletion_protection}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#folder_id DataYandexMdbSqlserverCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#id DataYandexMdbSqlserverCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#name DataYandexMdbSqlserverCluster#name}.

---

##### `sqlserverConfig`<sup>Optional</sup> <a name="sqlserverConfig" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterConfig.property.sqlserverConfig"></a>

```typescript
public readonly sqlserverConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/mdb_sqlserver_cluster#sqlserver_config DataYandexMdbSqlserverCluster#sqlserver_config}.

---

### DataYandexMdbSqlserverClusterDatabase <a name="DataYandexMdbSqlserverClusterDatabase" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabase.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterDatabase } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterDatabase: DataYandexMdbSqlserverClusterDatabase = { ... }
```


### DataYandexMdbSqlserverClusterHost <a name="DataYandexMdbSqlserverClusterHost" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHost.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterHost } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterHost: DataYandexMdbSqlserverClusterHost = { ... }
```


### DataYandexMdbSqlserverClusterResources <a name="DataYandexMdbSqlserverClusterResources" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResources.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterResources } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterResources: DataYandexMdbSqlserverClusterResources = { ... }
```


### DataYandexMdbSqlserverClusterUser <a name="DataYandexMdbSqlserverClusterUser" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUser.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUser } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterUser: DataYandexMdbSqlserverClusterUser = { ... }
```


### DataYandexMdbSqlserverClusterUserPermission <a name="DataYandexMdbSqlserverClusterUserPermission" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermission.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUserPermission } from '@cdktf/provider-yandex'

const dataYandexMdbSqlserverClusterUserPermission: DataYandexMdbSqlserverClusterUserPermission = { ... }
```


### DataYandexMessageQueueConfig <a name="DataYandexMessageQueueConfig" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.Initializer"></a>

```typescript
import { DataYandexMessageQueueConfig } from '@cdktf/provider-yandex'

const dataYandexMessageQueueConfig: DataYandexMessageQueueConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#name DataYandexMessageQueue#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.accessKey">accessKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#access_key DataYandexMessageQueue#access_key}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#id DataYandexMessageQueue#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.secretKey">secretKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#secret_key DataYandexMessageQueue#secret_key}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#name DataYandexMessageQueue#name}.

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#access_key DataYandexMessageQueue#access_key}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#id DataYandexMessageQueue#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `secretKey`<sup>Optional</sup> <a name="secretKey" id="@cdktf/provider-yandex.DataYandexMessageQueueConfig.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/message_queue#secret_key DataYandexMessageQueue#secret_key}.

---

### DataYandexOrganizationmanagerSamlFederationConfig <a name="DataYandexOrganizationmanagerSamlFederationConfig" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationConfig } from '@cdktf/provider-yandex'

const dataYandexOrganizationmanagerSamlFederationConfig: DataYandexOrganizationmanagerSamlFederationConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.federationId">federationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#federation_id DataYandexOrganizationmanagerSamlFederation#federation_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#id DataYandexOrganizationmanagerSamlFederation#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#labels DataYandexOrganizationmanagerSamlFederation#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#name DataYandexOrganizationmanagerSamlFederation#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#organization_id DataYandexOrganizationmanagerSamlFederation#organization_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `federationId`<sup>Optional</sup> <a name="federationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.federationId"></a>

```typescript
public readonly federationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#federation_id DataYandexOrganizationmanagerSamlFederation#federation_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#id DataYandexOrganizationmanagerSamlFederation#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#labels DataYandexOrganizationmanagerSamlFederation#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#name DataYandexOrganizationmanagerSamlFederation#name}.

---

##### `organizationId`<sup>Optional</sup> <a name="organizationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation#organization_id DataYandexOrganizationmanagerSamlFederation#organization_id}.

---

### DataYandexOrganizationmanagerSamlFederationSecuritySettings <a name="DataYandexOrganizationmanagerSamlFederationSecuritySettings" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettings.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationSecuritySettings } from '@cdktf/provider-yandex'

const dataYandexOrganizationmanagerSamlFederationSecuritySettings: DataYandexOrganizationmanagerSamlFederationSecuritySettings = { ... }
```


### DataYandexOrganizationmanagerSamlFederationUserAccountConfig <a name="DataYandexOrganizationmanagerSamlFederationUserAccountConfig" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationUserAccountConfig } from '@cdktf/provider-yandex'

const dataYandexOrganizationmanagerSamlFederationUserAccountConfig: DataYandexOrganizationmanagerSamlFederationUserAccountConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.federationId">federationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#federation_id DataYandexOrganizationmanagerSamlFederationUserAccount#federation_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.nameId">nameId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#name_id DataYandexOrganizationmanagerSamlFederationUserAccount#name_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#id DataYandexOrganizationmanagerSamlFederationUserAccount#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `federationId`<sup>Required</sup> <a name="federationId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.federationId"></a>

```typescript
public readonly federationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#federation_id DataYandexOrganizationmanagerSamlFederationUserAccount#federation_id}.

---

##### `nameId`<sup>Required</sup> <a name="nameId" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.nameId"></a>

```typescript
public readonly nameId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#name_id DataYandexOrganizationmanagerSamlFederationUserAccount#name_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationUserAccountConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/organizationmanager_saml_federation_user_account#id DataYandexOrganizationmanagerSamlFederationUserAccount#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexResourcemanagerCloudConfig <a name="DataYandexResourcemanagerCloudConfig" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.Initializer"></a>

```typescript
import { DataYandexResourcemanagerCloudConfig } from '@cdktf/provider-yandex'

const dataYandexResourcemanagerCloudConfig: DataYandexResourcemanagerCloudConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.cloudId">cloudId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#cloud_id DataYandexResourcemanagerCloud#cloud_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#description DataYandexResourcemanagerCloud#description}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#id DataYandexResourcemanagerCloud#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#name DataYandexResourcemanagerCloud#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#cloud_id DataYandexResourcemanagerCloud#cloud_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#description DataYandexResourcemanagerCloud#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#id DataYandexResourcemanagerCloud#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexResourcemanagerCloudConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_cloud#name DataYandexResourcemanagerCloud#name}.

---

### DataYandexResourcemanagerFolderConfig <a name="DataYandexResourcemanagerFolderConfig" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.Initializer"></a>

```typescript
import { DataYandexResourcemanagerFolderConfig } from '@cdktf/provider-yandex'

const dataYandexResourcemanagerFolderConfig: DataYandexResourcemanagerFolderConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.cloudId">cloudId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#cloud_id DataYandexResourcemanagerFolder#cloud_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#folder_id DataYandexResourcemanagerFolder#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#id DataYandexResourcemanagerFolder#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#labels DataYandexResourcemanagerFolder#labels}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#name DataYandexResourcemanagerFolder#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#cloud_id DataYandexResourcemanagerFolder#cloud_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#folder_id DataYandexResourcemanagerFolder#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#id DataYandexResourcemanagerFolder#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#labels DataYandexResourcemanagerFolder#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexResourcemanagerFolderConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/resourcemanager_folder#name DataYandexResourcemanagerFolder#name}.

---

### DataYandexServerlessContainerConfig <a name="DataYandexServerlessContainerConfig" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.Initializer"></a>

```typescript
import { DataYandexServerlessContainerConfig } from '@cdktf/provider-yandex'

const dataYandexServerlessContainerConfig: DataYandexServerlessContainerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.containerId">containerId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#container_id DataYandexServerlessContainer#container_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#folder_id DataYandexServerlessContainer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#id DataYandexServerlessContainer#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#name DataYandexServerlessContainer#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `containerId`<sup>Optional</sup> <a name="containerId" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.containerId"></a>

```typescript
public readonly containerId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#container_id DataYandexServerlessContainer#container_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#folder_id DataYandexServerlessContainer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#id DataYandexServerlessContainer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexServerlessContainerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/serverless_container#name DataYandexServerlessContainer#name}.

---

### DataYandexServerlessContainerImage <a name="DataYandexServerlessContainerImage" id="@cdktf/provider-yandex.DataYandexServerlessContainerImage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexServerlessContainerImage.Initializer"></a>

```typescript
import { DataYandexServerlessContainerImage } from '@cdktf/provider-yandex'

const dataYandexServerlessContainerImage: DataYandexServerlessContainerImage = { ... }
```


### DataYandexVpcAddressConfig <a name="DataYandexVpcAddressConfig" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.Initializer"></a>

```typescript
import { DataYandexVpcAddressConfig } from '@cdktf/provider-yandex'

const dataYandexVpcAddressConfig: DataYandexVpcAddressConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.addressId">addressId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#address_id DataYandexVpcAddress#address_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#folder_id DataYandexVpcAddress#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#id DataYandexVpcAddress#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#name DataYandexVpcAddress#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `addressId`<sup>Optional</sup> <a name="addressId" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.addressId"></a>

```typescript
public readonly addressId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#address_id DataYandexVpcAddress#address_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#folder_id DataYandexVpcAddress#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#id DataYandexVpcAddress#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcAddressConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_address#name DataYandexVpcAddress#name}.

---

### DataYandexVpcAddressExternalIpv4Address <a name="DataYandexVpcAddressExternalIpv4Address" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4Address.Initializer"></a>

```typescript
import { DataYandexVpcAddressExternalIpv4Address } from '@cdktf/provider-yandex'

const dataYandexVpcAddressExternalIpv4Address: DataYandexVpcAddressExternalIpv4Address = { ... }
```


### DataYandexVpcNetworkConfig <a name="DataYandexVpcNetworkConfig" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.Initializer"></a>

```typescript
import { DataYandexVpcNetworkConfig } from '@cdktf/provider-yandex'

const dataYandexVpcNetworkConfig: DataYandexVpcNetworkConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#folder_id DataYandexVpcNetwork#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#id DataYandexVpcNetwork#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#name DataYandexVpcNetwork#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#network_id DataYandexVpcNetwork#network_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#folder_id DataYandexVpcNetwork#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#id DataYandexVpcNetwork#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#name DataYandexVpcNetwork#name}.

---

##### `networkId`<sup>Optional</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexVpcNetworkConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_network#network_id DataYandexVpcNetwork#network_id}.

---

### DataYandexVpcRouteTableConfig <a name="DataYandexVpcRouteTableConfig" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.Initializer"></a>

```typescript
import { DataYandexVpcRouteTableConfig } from '@cdktf/provider-yandex'

const dataYandexVpcRouteTableConfig: DataYandexVpcRouteTableConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#folder_id DataYandexVpcRouteTable#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#id DataYandexVpcRouteTable#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#name DataYandexVpcRouteTable#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.routeTableId">routeTableId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#route_table_id DataYandexVpcRouteTable#route_table_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#folder_id DataYandexVpcRouteTable#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#id DataYandexVpcRouteTable#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#name DataYandexVpcRouteTable#name}.

---

##### `routeTableId`<sup>Optional</sup> <a name="routeTableId" id="@cdktf/provider-yandex.DataYandexVpcRouteTableConfig.property.routeTableId"></a>

```typescript
public readonly routeTableId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_route_table#route_table_id DataYandexVpcRouteTable#route_table_id}.

---

### DataYandexVpcRouteTableStaticRoute <a name="DataYandexVpcRouteTableStaticRoute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRoute.Initializer"></a>

```typescript
import { DataYandexVpcRouteTableStaticRoute } from '@cdktf/provider-yandex'

const dataYandexVpcRouteTableStaticRoute: DataYandexVpcRouteTableStaticRoute = { ... }
```


### DataYandexVpcSecurityGroupConfig <a name="DataYandexVpcSecurityGroupConfig" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupConfig } from '@cdktf/provider-yandex'

const dataYandexVpcSecurityGroupConfig: DataYandexVpcSecurityGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#folder_id DataYandexVpcSecurityGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#id DataYandexVpcSecurityGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#name DataYandexVpcSecurityGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#security_group_id DataYandexVpcSecurityGroup#security_group_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#folder_id DataYandexVpcSecurityGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#id DataYandexVpcSecurityGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#name DataYandexVpcSecurityGroup#name}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupConfig.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group#security_group_id DataYandexVpcSecurityGroup#security_group_id}.

---

### DataYandexVpcSecurityGroupEgress <a name="DataYandexVpcSecurityGroupEgress" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgress.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupEgress } from '@cdktf/provider-yandex'

const dataYandexVpcSecurityGroupEgress: DataYandexVpcSecurityGroupEgress = { ... }
```


### DataYandexVpcSecurityGroupIngress <a name="DataYandexVpcSecurityGroupIngress" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngress.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupIngress } from '@cdktf/provider-yandex'

const dataYandexVpcSecurityGroupIngress: DataYandexVpcSecurityGroupIngress = { ... }
```


### DataYandexVpcSecurityGroupRuleConfig <a name="DataYandexVpcSecurityGroupRuleConfig" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupRuleConfig } from '@cdktf/provider-yandex'

const dataYandexVpcSecurityGroupRuleConfig: DataYandexVpcSecurityGroupRuleConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.ruleId">ruleId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#rule_id DataYandexVpcSecurityGroupRule#rule_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.securityGroupBinding">securityGroupBinding</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#security_group_binding DataYandexVpcSecurityGroupRule#security_group_binding}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#id DataYandexVpcSecurityGroupRule#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `ruleId`<sup>Required</sup> <a name="ruleId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.ruleId"></a>

```typescript
public readonly ruleId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#rule_id DataYandexVpcSecurityGroupRule#rule_id}.

---

##### `securityGroupBinding`<sup>Required</sup> <a name="securityGroupBinding" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.securityGroupBinding"></a>

```typescript
public readonly securityGroupBinding: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#security_group_binding DataYandexVpcSecurityGroupRule#security_group_binding}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupRuleConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_security_group_rule#id DataYandexVpcSecurityGroupRule#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### DataYandexVpcSubnetConfig <a name="DataYandexVpcSubnetConfig" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.Initializer"></a>

```typescript
import { DataYandexVpcSubnetConfig } from '@cdktf/provider-yandex'

const dataYandexVpcSubnetConfig: DataYandexVpcSubnetConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#folder_id DataYandexVpcSubnet#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#id DataYandexVpcSubnet#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#name DataYandexVpcSubnet#name}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#subnet_id DataYandexVpcSubnet#subnet_id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#folder_id DataYandexVpcSubnet#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#id DataYandexVpcSubnet#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#name DataYandexVpcSubnet#name}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexVpcSubnetConfig.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/vpc_subnet#subnet_id DataYandexVpcSubnet#subnet_id}.

---

### DataYandexVpcSubnetDhcpOptions <a name="DataYandexVpcSubnetDhcpOptions" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptions.Initializer"></a>

```typescript
import { DataYandexVpcSubnetDhcpOptions } from '@cdktf/provider-yandex'

const dataYandexVpcSubnetDhcpOptions: DataYandexVpcSubnetDhcpOptions = { ... }
```


### DataYandexYdbDatabaseDedicatedConfig <a name="DataYandexYdbDatabaseDedicatedConfig" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedConfig } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedConfig: DataYandexYdbDatabaseDedicatedConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.databaseId">databaseId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#database_id DataYandexYdbDatabaseDedicated#database_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#folder_id DataYandexYdbDatabaseDedicated#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#id DataYandexYdbDatabaseDedicated#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#name DataYandexYdbDatabaseDedicated#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `databaseId`<sup>Optional</sup> <a name="databaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.databaseId"></a>

```typescript
public readonly databaseId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#database_id DataYandexYdbDatabaseDedicated#database_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#folder_id DataYandexYdbDatabaseDedicated#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#id DataYandexYdbDatabaseDedicated#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_dedicated#name DataYandexYdbDatabaseDedicated#name}.

---

### DataYandexYdbDatabaseDedicatedLocation <a name="DataYandexYdbDatabaseDedicatedLocation" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocation.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocation } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedLocation: DataYandexYdbDatabaseDedicatedLocation = { ... }
```


### DataYandexYdbDatabaseDedicatedLocationRegion <a name="DataYandexYdbDatabaseDedicatedLocationRegion" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegion"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegion.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationRegion } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedLocationRegion: DataYandexYdbDatabaseDedicatedLocationRegion = { ... }
```


### DataYandexYdbDatabaseDedicatedLocationZone <a name="DataYandexYdbDatabaseDedicatedLocationZone" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZone"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZone.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationZone } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedLocationZone: DataYandexYdbDatabaseDedicatedLocationZone = { ... }
```


### DataYandexYdbDatabaseDedicatedScalePolicy <a name="DataYandexYdbDatabaseDedicatedScalePolicy" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicy.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicy } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedScalePolicy: DataYandexYdbDatabaseDedicatedScalePolicy = { ... }
```


### DataYandexYdbDatabaseDedicatedScalePolicyFixedScale <a name="DataYandexYdbDatabaseDedicatedScalePolicyFixedScale" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScale.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicyFixedScale } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedScalePolicyFixedScale: DataYandexYdbDatabaseDedicatedScalePolicyFixedScale = { ... }
```


### DataYandexYdbDatabaseDedicatedStorageConfig <a name="DataYandexYdbDatabaseDedicatedStorageConfig" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfig.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedStorageConfig } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseDedicatedStorageConfig: DataYandexYdbDatabaseDedicatedStorageConfig = { ... }
```


### DataYandexYdbDatabaseServerlessConfig <a name="DataYandexYdbDatabaseServerlessConfig" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseServerlessConfig } from '@cdktf/provider-yandex'

const dataYandexYdbDatabaseServerlessConfig: DataYandexYdbDatabaseServerlessConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.databaseId">databaseId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#database_id DataYandexYdbDatabaseServerless#database_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#folder_id DataYandexYdbDatabaseServerless#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#id DataYandexYdbDatabaseServerless#id}. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#name DataYandexYdbDatabaseServerless#name}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `databaseId`<sup>Optional</sup> <a name="databaseId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.databaseId"></a>

```typescript
public readonly databaseId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#database_id DataYandexYdbDatabaseServerless#database_id}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#folder_id DataYandexYdbDatabaseServerless#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#id DataYandexYdbDatabaseServerless#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexYdbDatabaseServerlessConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/ydb_database_serverless#name DataYandexYdbDatabaseServerless#name}.

---

### DnsRecordsetConfig <a name="DnsRecordsetConfig" id="@cdktf/provider-yandex.DnsRecordsetConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DnsRecordsetConfig.Initializer"></a>

```typescript
import { DnsRecordsetConfig } from '@cdktf/provider-yandex'

const dnsRecordsetConfig: DnsRecordsetConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.data">data</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#data DnsRecordset#data}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#name DnsRecordset#name}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.ttl">ttl</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#ttl DnsRecordset#ttl}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#type DnsRecordset#type}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.zoneId">zoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#zone_id DnsRecordset#zone_id}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#id DnsRecordset#id}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `data`<sup>Required</sup> <a name="data" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.data"></a>

```typescript
public readonly data: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#data DnsRecordset#data}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#name DnsRecordset#name}.

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#ttl DnsRecordset#ttl}.

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#type DnsRecordset#type}.

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#zone_id DnsRecordset#zone_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#id DnsRecordset#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.DnsRecordsetConfig.property.timeouts"></a>

```typescript
public readonly timeouts: DnsRecordsetTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#timeouts DnsRecordset#timeouts}

---

### DnsRecordsetTimeouts <a name="DnsRecordsetTimeouts" id="@cdktf/provider-yandex.DnsRecordsetTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DnsRecordsetTimeouts.Initializer"></a>

```typescript
import { DnsRecordsetTimeouts } from '@cdktf/provider-yandex'

const dnsRecordsetTimeouts: DnsRecordsetTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#create DnsRecordset#create}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#delete DnsRecordset#delete}. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#update DnsRecordset#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.DnsRecordsetTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#create DnsRecordset#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.DnsRecordsetTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#delete DnsRecordset#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.DnsRecordsetTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_recordset#update DnsRecordset#update}.

---

### DnsZoneConfig <a name="DnsZoneConfig" id="@cdktf/provider-yandex.DnsZoneConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DnsZoneConfig.Initializer"></a>

```typescript
import { DnsZoneConfig } from '@cdktf/provider-yandex'

const dnsZoneConfig: DnsZoneConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#zone DnsZone#zone}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#description DnsZone#description}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#folder_id DnsZone#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#id DnsZone#id}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#labels DnsZone#labels}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#name DnsZone#name}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.privateNetworks">privateNetworks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#private_networks DnsZone#private_networks}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.public">public</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#public DnsZone#public}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.DnsZoneConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.DnsZoneConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.DnsZoneConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.DnsZoneConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DnsZoneConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#zone DnsZone#zone}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.DnsZoneConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#description DnsZone#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.DnsZoneConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#folder_id DnsZone#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.DnsZoneConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#id DnsZone#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.DnsZoneConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#labels DnsZone#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.DnsZoneConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#name DnsZone#name}.

---

##### `privateNetworks`<sup>Optional</sup> <a name="privateNetworks" id="@cdktf/provider-yandex.DnsZoneConfig.property.privateNetworks"></a>

```typescript
public readonly privateNetworks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#private_networks DnsZone#private_networks}.

---

##### `public`<sup>Optional</sup> <a name="public" id="@cdktf/provider-yandex.DnsZoneConfig.property.public"></a>

```typescript
public readonly public: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#public DnsZone#public}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.DnsZoneConfig.property.timeouts"></a>

```typescript
public readonly timeouts: DnsZoneTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#timeouts DnsZone#timeouts}

---

### DnsZoneTimeouts <a name="DnsZoneTimeouts" id="@cdktf/provider-yandex.DnsZoneTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.DnsZoneTimeouts.Initializer"></a>

```typescript
import { DnsZoneTimeouts } from '@cdktf/provider-yandex'

const dnsZoneTimeouts: DnsZoneTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#create DnsZone#create}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#delete DnsZone#delete}. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#update DnsZone#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.DnsZoneTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#create DnsZone#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.DnsZoneTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#delete DnsZone#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.DnsZoneTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/dns_zone#update DnsZone#update}.

---

### FunctionConfig <a name="FunctionConfig" id="@cdktf/provider-yandex.FunctionConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionConfig.Initializer"></a>

```typescript
import { FunctionConfig } from '@cdktf/provider-yandex'

const functionConfig: FunctionConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.entrypoint">entrypoint</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#entrypoint Function#entrypoint}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.memory">memory</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#memory Function#memory}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#name Function#name}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.runtime">runtime</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#runtime Function#runtime}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.userHash">userHash</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#user_hash Function#user_hash}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.content">content</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a></code> | content block. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#description Function#description}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.environment">environment</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#environment Function#environment}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#execution_timeout Function#execution_timeout}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#folder_id Function#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#id Function#id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#labels Function#labels}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.package">package</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a></code> | package block. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#service_account_id Function#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.tags">tags</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#tags Function#tags}. |
| <code><a href="#@cdktf/provider-yandex.FunctionConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `entrypoint`<sup>Required</sup> <a name="entrypoint" id="@cdktf/provider-yandex.FunctionConfig.property.entrypoint"></a>

```typescript
public readonly entrypoint: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#entrypoint Function#entrypoint}.

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.FunctionConfig.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#memory Function#memory}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.FunctionConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#name Function#name}.

---

##### `runtime`<sup>Required</sup> <a name="runtime" id="@cdktf/provider-yandex.FunctionConfig.property.runtime"></a>

```typescript
public readonly runtime: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#runtime Function#runtime}.

---

##### `userHash`<sup>Required</sup> <a name="userHash" id="@cdktf/provider-yandex.FunctionConfig.property.userHash"></a>

```typescript
public readonly userHash: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#user_hash Function#user_hash}.

---

##### `content`<sup>Optional</sup> <a name="content" id="@cdktf/provider-yandex.FunctionConfig.property.content"></a>

```typescript
public readonly content: FunctionContent;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a>

content block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#content Function#content}

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.FunctionConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#description Function#description}.

---

##### `environment`<sup>Optional</sup> <a name="environment" id="@cdktf/provider-yandex.FunctionConfig.property.environment"></a>

```typescript
public readonly environment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#environment Function#environment}.

---

##### `executionTimeout`<sup>Optional</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.FunctionConfig.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#execution_timeout Function#execution_timeout}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.FunctionConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#folder_id Function#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.FunctionConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#id Function#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.FunctionConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#labels Function#labels}.

---

##### `package`<sup>Optional</sup> <a name="package" id="@cdktf/provider-yandex.FunctionConfig.property.package"></a>

```typescript
public readonly package: FunctionPackage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a>

package block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#package Function#package}

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#service_account_id Function#service_account_id}.

---

##### `tags`<sup>Optional</sup> <a name="tags" id="@cdktf/provider-yandex.FunctionConfig.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#tags Function#tags}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.FunctionConfig.property.timeouts"></a>

```typescript
public readonly timeouts: FunctionTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#timeouts Function#timeouts}

---

### FunctionContent <a name="FunctionContent" id="@cdktf/provider-yandex.FunctionContent"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionContent.Initializer"></a>

```typescript
import { FunctionContent } from '@cdktf/provider-yandex'

const functionContent: FunctionContent = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionContent.property.zipFilename">zipFilename</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#zip_filename Function#zip_filename}. |

---

##### `zipFilename`<sup>Required</sup> <a name="zipFilename" id="@cdktf/provider-yandex.FunctionContent.property.zipFilename"></a>

```typescript
public readonly zipFilename: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#zip_filename Function#zip_filename}.

---

### FunctionIamBindingConfig <a name="FunctionIamBindingConfig" id="@cdktf/provider-yandex.FunctionIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionIamBindingConfig.Initializer"></a>

```typescript
import { FunctionIamBindingConfig } from '@cdktf/provider-yandex'

const functionIamBindingConfig: FunctionIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.functionId">functionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#function_id FunctionIamBinding#function_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#members FunctionIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#role FunctionIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#id FunctionIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#sleep_after FunctionIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#function_id FunctionIamBinding#function_id}.

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#members FunctionIamBinding#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#role FunctionIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#id FunctionIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.FunctionIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_iam_binding#sleep_after FunctionIamBinding#sleep_after}.

---

### FunctionPackage <a name="FunctionPackage" id="@cdktf/provider-yandex.FunctionPackage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionPackage.Initializer"></a>

```typescript
import { FunctionPackage } from '@cdktf/provider-yandex'

const functionPackage: FunctionPackage = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionPackage.property.bucketName">bucketName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#bucket_name Function#bucket_name}. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackage.property.objectName">objectName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#object_name Function#object_name}. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackage.property.sha256">sha256</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#sha_256 Function#sha_256}. |

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="@cdktf/provider-yandex.FunctionPackage.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#bucket_name Function#bucket_name}.

---

##### `objectName`<sup>Required</sup> <a name="objectName" id="@cdktf/provider-yandex.FunctionPackage.property.objectName"></a>

```typescript
public readonly objectName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#object_name Function#object_name}.

---

##### `sha256`<sup>Optional</sup> <a name="sha256" id="@cdktf/provider-yandex.FunctionPackage.property.sha256"></a>

```typescript
public readonly sha256: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#sha_256 Function#sha_256}.

---

### FunctionScalingPolicyConfig <a name="FunctionScalingPolicyConfig" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.Initializer"></a>

```typescript
import { FunctionScalingPolicyConfig } from '@cdktf/provider-yandex'

const functionScalingPolicyConfig: FunctionScalingPolicyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.functionId">functionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#function_id FunctionScalingPolicy#function_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#id FunctionScalingPolicy#id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.policy">policy</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]</code> | policy block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `functionId`<sup>Required</sup> <a name="functionId" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.functionId"></a>

```typescript
public readonly functionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#function_id FunctionScalingPolicy#function_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#id FunctionScalingPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="@cdktf/provider-yandex.FunctionScalingPolicyConfig.property.policy"></a>

```typescript
public readonly policy: IResolvable | FunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]

policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#policy FunctionScalingPolicy#policy}

---

### FunctionScalingPolicyPolicy <a name="FunctionScalingPolicyPolicy" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicy.Initializer"></a>

```typescript
import { FunctionScalingPolicyPolicy } from '@cdktf/provider-yandex'

const functionScalingPolicyPolicy: FunctionScalingPolicyPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.tag">tag</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#tag FunctionScalingPolicy#tag}. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.zoneInstancesLimit">zoneInstancesLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_instances_limit FunctionScalingPolicy#zone_instances_limit}. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.zoneRequestsLimit">zoneRequestsLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_requests_limit FunctionScalingPolicy#zone_requests_limit}. |

---

##### `tag`<sup>Required</sup> <a name="tag" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#tag FunctionScalingPolicy#tag}.

---

##### `zoneInstancesLimit`<sup>Optional</sup> <a name="zoneInstancesLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.zoneInstancesLimit"></a>

```typescript
public readonly zoneInstancesLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_instances_limit FunctionScalingPolicy#zone_instances_limit}.

---

##### `zoneRequestsLimit`<sup>Optional</sup> <a name="zoneRequestsLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicy.property.zoneRequestsLimit"></a>

```typescript
public readonly zoneRequestsLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_scaling_policy#zone_requests_limit FunctionScalingPolicy#zone_requests_limit}.

---

### FunctionTimeouts <a name="FunctionTimeouts" id="@cdktf/provider-yandex.FunctionTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTimeouts.Initializer"></a>

```typescript
import { FunctionTimeouts } from '@cdktf/provider-yandex'

const functionTimeouts: FunctionTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#create Function#create}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#delete Function#delete}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#update Function#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#create Function#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#delete Function#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function#update Function#update}.

---

### FunctionTriggerConfig <a name="FunctionTriggerConfig" id="@cdktf/provider-yandex.FunctionTriggerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerConfig.Initializer"></a>

```typescript
import { FunctionTriggerConfig } from '@cdktf/provider-yandex'

const functionTriggerConfig: FunctionTriggerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.function">function</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a></code> | function block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#name FunctionTrigger#name}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#description FunctionTrigger#description}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.dlq">dlq</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a></code> | dlq block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#folder_id FunctionTrigger#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.iot">iot</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a></code> | iot block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#labels FunctionTrigger#labels}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.logging">logging</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a></code> | logging block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.logGroup">logGroup</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a></code> | log_group block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.messageQueue">messageQueue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a></code> | message_queue block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.objectStorage">objectStorage</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a></code> | object_storage block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerConfig.property.timer">timer</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a></code> | timer block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.function"></a>

```typescript
public readonly function: FunctionTriggerFunction;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a>

function block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#function FunctionTrigger#function}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#name FunctionTrigger#name}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#description FunctionTrigger#description}.

---

##### `dlq`<sup>Optional</sup> <a name="dlq" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.dlq"></a>

```typescript
public readonly dlq: FunctionTriggerDlq;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a>

dlq block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#dlq FunctionTrigger#dlq}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#folder_id FunctionTrigger#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `iot`<sup>Optional</sup> <a name="iot" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.iot"></a>

```typescript
public readonly iot: FunctionTriggerIot;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a>

iot block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#iot FunctionTrigger#iot}

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#labels FunctionTrigger#labels}.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.logging"></a>

```typescript
public readonly logging: FunctionTriggerLogging;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a>

logging block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#logging FunctionTrigger#logging}

---

##### `logGroup`<sup>Optional</sup> <a name="logGroup" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.logGroup"></a>

```typescript
public readonly logGroup: FunctionTriggerLogGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a>

log_group block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#log_group FunctionTrigger#log_group}

---

##### `messageQueue`<sup>Optional</sup> <a name="messageQueue" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.messageQueue"></a>

```typescript
public readonly messageQueue: FunctionTriggerMessageQueue;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a>

message_queue block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#message_queue FunctionTrigger#message_queue}

---

##### `objectStorage`<sup>Optional</sup> <a name="objectStorage" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.objectStorage"></a>

```typescript
public readonly objectStorage: FunctionTriggerObjectStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a>

object_storage block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#object_storage FunctionTrigger#object_storage}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.timeouts"></a>

```typescript
public readonly timeouts: FunctionTriggerTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#timeouts FunctionTrigger#timeouts}

---

##### `timer`<sup>Optional</sup> <a name="timer" id="@cdktf/provider-yandex.FunctionTriggerConfig.property.timer"></a>

```typescript
public readonly timer: FunctionTriggerTimer;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a>

timer block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#timer FunctionTrigger#timer}

---

### FunctionTriggerDlq <a name="FunctionTriggerDlq" id="@cdktf/provider-yandex.FunctionTriggerDlq"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerDlq.Initializer"></a>

```typescript
import { FunctionTriggerDlq } from '@cdktf/provider-yandex'

const functionTriggerDlq: FunctionTriggerDlq = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlq.property.queueId">queueId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlq.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}. |

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.FunctionTriggerDlq.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerDlq.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}.

---

### FunctionTriggerFunction <a name="FunctionTriggerFunction" id="@cdktf/provider-yandex.FunctionTriggerFunction"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerFunction.Initializer"></a>

```typescript
import { FunctionTriggerFunction } from '@cdktf/provider-yandex'

const functionTriggerFunction: FunctionTriggerFunction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction.property.retryAttempts">retryAttempts</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_attempts FunctionTrigger#retry_attempts}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction.property.retryInterval">retryInterval</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_interval FunctionTrigger#retry_interval}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction.property.tag">tag</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#tag FunctionTrigger#tag}. |

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionTriggerFunction.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#id FunctionTrigger#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `retryAttempts`<sup>Optional</sup> <a name="retryAttempts" id="@cdktf/provider-yandex.FunctionTriggerFunction.property.retryAttempts"></a>

```typescript
public readonly retryAttempts: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_attempts FunctionTrigger#retry_attempts}.

---

##### `retryInterval`<sup>Optional</sup> <a name="retryInterval" id="@cdktf/provider-yandex.FunctionTriggerFunction.property.retryInterval"></a>

```typescript
public readonly retryInterval: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#retry_interval FunctionTrigger#retry_interval}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerFunction.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}.

---

##### `tag`<sup>Optional</sup> <a name="tag" id="@cdktf/provider-yandex.FunctionTriggerFunction.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#tag FunctionTrigger#tag}.

---

### FunctionTriggerIot <a name="FunctionTriggerIot" id="@cdktf/provider-yandex.FunctionTriggerIot"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerIot.Initializer"></a>

```typescript
import { FunctionTriggerIot } from '@cdktf/provider-yandex'

const functionTriggerIot: FunctionTriggerIot = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot.property.registryId">registryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#registry_id FunctionTrigger#registry_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot.property.deviceId">deviceId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#device_id FunctionTrigger#device_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot.property.topic">topic</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#topic FunctionTrigger#topic}. |

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.FunctionTriggerIot.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#registry_id FunctionTrigger#registry_id}.

---

##### `deviceId`<sup>Optional</sup> <a name="deviceId" id="@cdktf/provider-yandex.FunctionTriggerIot.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#device_id FunctionTrigger#device_id}.

---

##### `topic`<sup>Optional</sup> <a name="topic" id="@cdktf/provider-yandex.FunctionTriggerIot.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#topic FunctionTrigger#topic}.

---

### FunctionTriggerLogging <a name="FunctionTriggerLogging" id="@cdktf/provider-yandex.FunctionTriggerLogging"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerLogging.Initializer"></a>

```typescript
import { FunctionTriggerLogging } from '@cdktf/provider-yandex'

const functionTriggerLogging: FunctionTriggerLogging = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.groupId">groupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#group_id FunctionTrigger#group_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.levels">levels</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#levels FunctionTrigger#levels}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.resourceIds">resourceIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_ids FunctionTrigger#resource_ids}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.resourceTypes">resourceTypes</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_types FunctionTrigger#resource_types}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging.property.batchSize">batchSize</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}. |

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}.

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#group_id FunctionTrigger#group_id}.

---

##### `levels`<sup>Required</sup> <a name="levels" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.levels"></a>

```typescript
public readonly levels: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#levels FunctionTrigger#levels}.

---

##### `resourceIds`<sup>Required</sup> <a name="resourceIds" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.resourceIds"></a>

```typescript
public readonly resourceIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_ids FunctionTrigger#resource_ids}.

---

##### `resourceTypes`<sup>Required</sup> <a name="resourceTypes" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.resourceTypes"></a>

```typescript
public readonly resourceTypes: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#resource_types FunctionTrigger#resource_types}.

---

##### `batchSize`<sup>Optional</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerLogging.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}.

---

### FunctionTriggerLogGroup <a name="FunctionTriggerLogGroup" id="@cdktf/provider-yandex.FunctionTriggerLogGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerLogGroup.Initializer"></a>

```typescript
import { FunctionTriggerLogGroup } from '@cdktf/provider-yandex'

const functionTriggerLogGroup: FunctionTriggerLogGroup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup.property.logGroupIds">logGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#log_group_ids FunctionTrigger#log_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup.property.batchSize">batchSize</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}. |

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerLogGroup.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}.

---

##### `logGroupIds`<sup>Required</sup> <a name="logGroupIds" id="@cdktf/provider-yandex.FunctionTriggerLogGroup.property.logGroupIds"></a>

```typescript
public readonly logGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#log_group_ids FunctionTrigger#log_group_ids}.

---

##### `batchSize`<sup>Optional</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerLogGroup.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}.

---

### FunctionTriggerMessageQueue <a name="FunctionTriggerMessageQueue" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.Initializer"></a>

```typescript
import { FunctionTriggerMessageQueue } from '@cdktf/provider-yandex'

const functionTriggerMessageQueue: FunctionTriggerMessageQueue = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.queueId">queueId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.batchSize">batchSize</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.visibilityTimeout">visibilityTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#visibility_timeout FunctionTrigger#visibility_timeout}. |

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_cutoff FunctionTrigger#batch_cutoff}.

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#queue_id FunctionTrigger#queue_id}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#service_account_id FunctionTrigger#service_account_id}.

---

##### `batchSize`<sup>Optional</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#batch_size FunctionTrigger#batch_size}.

---

##### `visibilityTimeout`<sup>Optional</sup> <a name="visibilityTimeout" id="@cdktf/provider-yandex.FunctionTriggerMessageQueue.property.visibilityTimeout"></a>

```typescript
public readonly visibilityTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#visibility_timeout FunctionTrigger#visibility_timeout}.

---

### FunctionTriggerObjectStorage <a name="FunctionTriggerObjectStorage" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.Initializer"></a>

```typescript
import { FunctionTriggerObjectStorage } from '@cdktf/provider-yandex'

const functionTriggerObjectStorage: FunctionTriggerObjectStorage = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.bucketId">bucketId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#bucket_id FunctionTrigger#bucket_id}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.create">create</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.delete">delete</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.prefix">prefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#prefix FunctionTrigger#prefix}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.suffix">suffix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#suffix FunctionTrigger#suffix}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.update">update</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}. |

---

##### `bucketId`<sup>Required</sup> <a name="bucketId" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.bucketId"></a>

```typescript
public readonly bucketId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#bucket_id FunctionTrigger#bucket_id}.

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.create"></a>

```typescript
public readonly create: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.delete"></a>

```typescript
public readonly delete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#prefix FunctionTrigger#prefix}.

---

##### `suffix`<sup>Optional</sup> <a name="suffix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.suffix"></a>

```typescript
public readonly suffix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#suffix FunctionTrigger#suffix}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTriggerObjectStorage.property.update"></a>

```typescript
public readonly update: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}.

---

### FunctionTriggerTimeouts <a name="FunctionTriggerTimeouts" id="@cdktf/provider-yandex.FunctionTriggerTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerTimeouts.Initializer"></a>

```typescript
import { FunctionTriggerTimeouts } from '@cdktf/provider-yandex'

const functionTriggerTimeouts: FunctionTriggerTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTriggerTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#create FunctionTrigger#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTriggerTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#delete FunctionTrigger#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTriggerTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#update FunctionTrigger#update}.

---

### FunctionTriggerTimer <a name="FunctionTriggerTimer" id="@cdktf/provider-yandex.FunctionTriggerTimer"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.FunctionTriggerTimer.Initializer"></a>

```typescript
import { FunctionTriggerTimer } from '@cdktf/provider-yandex'

const functionTriggerTimer: FunctionTriggerTimer = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimer.property.cronExpression">cronExpression</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#cron_expression FunctionTrigger#cron_expression}. |

---

##### `cronExpression`<sup>Required</sup> <a name="cronExpression" id="@cdktf/provider-yandex.FunctionTriggerTimer.property.cronExpression"></a>

```typescript
public readonly cronExpression: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/function_trigger#cron_expression FunctionTrigger#cron_expression}.

---

### IamServiceAccountApiKeyConfig <a name="IamServiceAccountApiKeyConfig" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.Initializer"></a>

```typescript
import { IamServiceAccountApiKeyConfig } from '@cdktf/provider-yandex'

const iamServiceAccountApiKeyConfig: IamServiceAccountApiKeyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#service_account_id IamServiceAccountApiKey#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#description IamServiceAccountApiKey#description}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#id IamServiceAccountApiKey#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.pgpKey">pgpKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#pgp_key IamServiceAccountApiKey#pgp_key}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#service_account_id IamServiceAccountApiKey#service_account_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#description IamServiceAccountApiKey#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#id IamServiceAccountApiKey#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `pgpKey`<sup>Optional</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountApiKeyConfig.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_api_key#pgp_key IamServiceAccountApiKey#pgp_key}.

---

### IamServiceAccountConfig <a name="IamServiceAccountConfig" id="@cdktf/provider-yandex.IamServiceAccountConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountConfig.Initializer"></a>

```typescript
import { IamServiceAccountConfig } from '@cdktf/provider-yandex'

const iamServiceAccountConfig: IamServiceAccountConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#name IamServiceAccount#name}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#description IamServiceAccount#description}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#folder_id IamServiceAccount#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#id IamServiceAccount#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#name IamServiceAccount#name}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#description IamServiceAccount#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#folder_id IamServiceAccount#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#id IamServiceAccount#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.IamServiceAccountConfig.property.timeouts"></a>

```typescript
public readonly timeouts: IamServiceAccountTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#timeouts IamServiceAccount#timeouts}

---

### IamServiceAccountIamBindingConfig <a name="IamServiceAccountIamBindingConfig" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.Initializer"></a>

```typescript
import { IamServiceAccountIamBindingConfig } from '@cdktf/provider-yandex'

const iamServiceAccountIamBindingConfig: IamServiceAccountIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#members IamServiceAccountIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#role IamServiceAccountIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#service_account_id IamServiceAccountIamBinding#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#id IamServiceAccountIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#sleep_after IamServiceAccountIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#members IamServiceAccountIamBinding#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#role IamServiceAccountIamBinding#role}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#service_account_id IamServiceAccountIamBinding#service_account_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#id IamServiceAccountIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_binding#sleep_after IamServiceAccountIamBinding#sleep_after}.

---

### IamServiceAccountIamMemberConfig <a name="IamServiceAccountIamMemberConfig" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.Initializer"></a>

```typescript
import { IamServiceAccountIamMemberConfig } from '@cdktf/provider-yandex'

const iamServiceAccountIamMemberConfig: IamServiceAccountIamMemberConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.member">member</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#member IamServiceAccountIamMember#member}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#role IamServiceAccountIamMember#role}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#service_account_id IamServiceAccountIamMember#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#id IamServiceAccountIamMember#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#sleep_after IamServiceAccountIamMember#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#member IamServiceAccountIamMember#member}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#role IamServiceAccountIamMember#role}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#service_account_id IamServiceAccountIamMember#service_account_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#id IamServiceAccountIamMember#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.IamServiceAccountIamMemberConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#sleep_after IamServiceAccountIamMember#sleep_after}.

---

### IamServiceAccountIamPolicyConfig <a name="IamServiceAccountIamPolicyConfig" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.Initializer"></a>

```typescript
import { IamServiceAccountIamPolicyConfig } from '@cdktf/provider-yandex'

const iamServiceAccountIamPolicyConfig: IamServiceAccountIamPolicyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.policyData">policyData</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#policy_data IamServiceAccountIamPolicy#policy_data}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#service_account_id IamServiceAccountIamPolicy#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#id IamServiceAccountIamPolicy#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `policyData`<sup>Required</sup> <a name="policyData" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.policyData"></a>

```typescript
public readonly policyData: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#policy_data IamServiceAccountIamPolicy#policy_data}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#service_account_id IamServiceAccountIamPolicy#service_account_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountIamPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_policy#id IamServiceAccountIamPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### IamServiceAccountKeyConfig <a name="IamServiceAccountKeyConfig" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.Initializer"></a>

```typescript
import { IamServiceAccountKeyConfig } from '@cdktf/provider-yandex'

const iamServiceAccountKeyConfig: IamServiceAccountKeyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#service_account_id IamServiceAccountKey#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#description IamServiceAccountKey#description}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.format">format</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#format IamServiceAccountKey#format}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#id IamServiceAccountKey#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.keyAlgorithm">keyAlgorithm</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#key_algorithm IamServiceAccountKey#key_algorithm}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.pgpKey">pgpKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#pgp_key IamServiceAccountKey#pgp_key}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#service_account_id IamServiceAccountKey#service_account_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#description IamServiceAccountKey#description}.

---

##### `format`<sup>Optional</sup> <a name="format" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#format IamServiceAccountKey#format}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#id IamServiceAccountKey#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `keyAlgorithm`<sup>Optional</sup> <a name="keyAlgorithm" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.keyAlgorithm"></a>

```typescript
public readonly keyAlgorithm: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#key_algorithm IamServiceAccountKey#key_algorithm}.

---

##### `pgpKey`<sup>Optional</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountKeyConfig.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_key#pgp_key IamServiceAccountKey#pgp_key}.

---

### IamServiceAccountStaticAccessKeyConfig <a name="IamServiceAccountStaticAccessKeyConfig" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.Initializer"></a>

```typescript
import { IamServiceAccountStaticAccessKeyConfig } from '@cdktf/provider-yandex'

const iamServiceAccountStaticAccessKeyConfig: IamServiceAccountStaticAccessKeyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#service_account_id IamServiceAccountStaticAccessKey#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#description IamServiceAccountStaticAccessKey#description}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#id IamServiceAccountStaticAccessKey#id}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.pgpKey">pgpKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#pgp_key IamServiceAccountStaticAccessKey#pgp_key}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#service_account_id IamServiceAccountStaticAccessKey#service_account_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#description IamServiceAccountStaticAccessKey#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#id IamServiceAccountStaticAccessKey#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `pgpKey`<sup>Optional</sup> <a name="pgpKey" id="@cdktf/provider-yandex.IamServiceAccountStaticAccessKeyConfig.property.pgpKey"></a>

```typescript
public readonly pgpKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_static_access_key#pgp_key IamServiceAccountStaticAccessKey#pgp_key}.

---

### IamServiceAccountTimeouts <a name="IamServiceAccountTimeouts" id="@cdktf/provider-yandex.IamServiceAccountTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IamServiceAccountTimeouts.Initializer"></a>

```typescript
import { IamServiceAccountTimeouts } from '@cdktf/provider-yandex'

const iamServiceAccountTimeouts: IamServiceAccountTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#create IamServiceAccount#create}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#delete IamServiceAccount#delete}. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#update IamServiceAccount#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.IamServiceAccountTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#create IamServiceAccount#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.IamServiceAccountTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#delete IamServiceAccount#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.IamServiceAccountTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account#update IamServiceAccount#update}.

---

### IotCoreDeviceConfig <a name="IotCoreDeviceConfig" id="@cdktf/provider-yandex.IotCoreDeviceConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IotCoreDeviceConfig.Initializer"></a>

```typescript
import { IotCoreDeviceConfig } from '@cdktf/provider-yandex'

const iotCoreDeviceConfig: IotCoreDeviceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#name IotCoreDevice#name}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.registryId">registryId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#registry_id IotCoreDevice#registry_id}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.aliases">aliases</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#aliases IotCoreDevice#aliases}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.certificates">certificates</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#certificates IotCoreDevice#certificates}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#description IotCoreDevice#description}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#id IotCoreDevice#id}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.passwords">passwords</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#passwords IotCoreDevice#passwords}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#name IotCoreDevice#name}.

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#registry_id IotCoreDevice#registry_id}.

---

##### `aliases`<sup>Optional</sup> <a name="aliases" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.aliases"></a>

```typescript
public readonly aliases: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#aliases IotCoreDevice#aliases}.

---

##### `certificates`<sup>Optional</sup> <a name="certificates" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#certificates IotCoreDevice#certificates}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#description IotCoreDevice#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#id IotCoreDevice#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `passwords`<sup>Optional</sup> <a name="passwords" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#passwords IotCoreDevice#passwords}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.IotCoreDeviceConfig.property.timeouts"></a>

```typescript
public readonly timeouts: IotCoreDeviceTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#timeouts IotCoreDevice#timeouts}

---

### IotCoreDeviceTimeouts <a name="IotCoreDeviceTimeouts" id="@cdktf/provider-yandex.IotCoreDeviceTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IotCoreDeviceTimeouts.Initializer"></a>

```typescript
import { IotCoreDeviceTimeouts } from '@cdktf/provider-yandex'

const iotCoreDeviceTimeouts: IotCoreDeviceTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#create IotCoreDevice#create}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#delete IotCoreDevice#delete}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#update IotCoreDevice#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#create IotCoreDevice#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#delete IotCoreDevice#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.IotCoreDeviceTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_device#update IotCoreDevice#update}.

---

### IotCoreRegistryConfig <a name="IotCoreRegistryConfig" id="@cdktf/provider-yandex.IotCoreRegistryConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IotCoreRegistryConfig.Initializer"></a>

```typescript
import { IotCoreRegistryConfig } from '@cdktf/provider-yandex'

const iotCoreRegistryConfig: IotCoreRegistryConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#name IotCoreRegistry#name}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.certificates">certificates</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#certificates IotCoreRegistry#certificates}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#description IotCoreRegistry#description}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#folder_id IotCoreRegistry#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#id IotCoreRegistry#id}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#labels IotCoreRegistry#labels}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.passwords">passwords</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#passwords IotCoreRegistry#passwords}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#name IotCoreRegistry#name}.

---

##### `certificates`<sup>Optional</sup> <a name="certificates" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.certificates"></a>

```typescript
public readonly certificates: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#certificates IotCoreRegistry#certificates}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#description IotCoreRegistry#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#folder_id IotCoreRegistry#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#id IotCoreRegistry#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#labels IotCoreRegistry#labels}.

---

##### `passwords`<sup>Optional</sup> <a name="passwords" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.passwords"></a>

```typescript
public readonly passwords: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#passwords IotCoreRegistry#passwords}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.IotCoreRegistryConfig.property.timeouts"></a>

```typescript
public readonly timeouts: IotCoreRegistryTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#timeouts IotCoreRegistry#timeouts}

---

### IotCoreRegistryTimeouts <a name="IotCoreRegistryTimeouts" id="@cdktf/provider-yandex.IotCoreRegistryTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.IotCoreRegistryTimeouts.Initializer"></a>

```typescript
import { IotCoreRegistryTimeouts } from '@cdktf/provider-yandex'

const iotCoreRegistryTimeouts: IotCoreRegistryTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#create IotCoreRegistry#create}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#delete IotCoreRegistry#delete}. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#update IotCoreRegistry#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#create IotCoreRegistry#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#delete IotCoreRegistry#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.IotCoreRegistryTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iot_core_registry#update IotCoreRegistry#update}.

---

### KmsSecretCiphertextConfig <a name="KmsSecretCiphertextConfig" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.Initializer"></a>

```typescript
import { KmsSecretCiphertextConfig } from '@cdktf/provider-yandex'

const kmsSecretCiphertextConfig: KmsSecretCiphertextConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.keyId">keyId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#key_id KmsSecretCiphertext#key_id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.plaintext">plaintext</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#plaintext KmsSecretCiphertext#plaintext}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.aadContext">aadContext</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#aad_context KmsSecretCiphertext#aad_context}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#id KmsSecretCiphertext#id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `keyId`<sup>Required</sup> <a name="keyId" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#key_id KmsSecretCiphertext#key_id}.

---

##### `plaintext`<sup>Required</sup> <a name="plaintext" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.plaintext"></a>

```typescript
public readonly plaintext: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#plaintext KmsSecretCiphertext#plaintext}.

---

##### `aadContext`<sup>Optional</sup> <a name="aadContext" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.aadContext"></a>

```typescript
public readonly aadContext: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#aad_context KmsSecretCiphertext#aad_context}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#id KmsSecretCiphertext#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.KmsSecretCiphertextConfig.property.timeouts"></a>

```typescript
public readonly timeouts: KmsSecretCiphertextTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#timeouts KmsSecretCiphertext#timeouts}

---

### KmsSecretCiphertextTimeouts <a name="KmsSecretCiphertextTimeouts" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.Initializer"></a>

```typescript
import { KmsSecretCiphertextTimeouts } from '@cdktf/provider-yandex'

const kmsSecretCiphertextTimeouts: KmsSecretCiphertextTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#create KmsSecretCiphertext#create}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#delete KmsSecretCiphertext#delete}. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#read KmsSecretCiphertext#read}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#create KmsSecretCiphertext#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#delete KmsSecretCiphertext#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_secret_ciphertext#read KmsSecretCiphertext#read}.

---

### KmsSymmetricKeyConfig <a name="KmsSymmetricKeyConfig" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.Initializer"></a>

```typescript
import { KmsSymmetricKeyConfig } from '@cdktf/provider-yandex'

const kmsSymmetricKeyConfig: KmsSymmetricKeyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.defaultAlgorithm">defaultAlgorithm</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#default_algorithm KmsSymmetricKey#default_algorithm}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#description KmsSymmetricKey#description}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#folder_id KmsSymmetricKey#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#id KmsSymmetricKey#id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#labels KmsSymmetricKey#labels}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#name KmsSymmetricKey#name}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.rotationPeriod">rotationPeriod</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#rotation_period KmsSymmetricKey#rotation_period}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `defaultAlgorithm`<sup>Optional</sup> <a name="defaultAlgorithm" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.defaultAlgorithm"></a>

```typescript
public readonly defaultAlgorithm: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#default_algorithm KmsSymmetricKey#default_algorithm}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#description KmsSymmetricKey#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#folder_id KmsSymmetricKey#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#id KmsSymmetricKey#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#labels KmsSymmetricKey#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#name KmsSymmetricKey#name}.

---

##### `rotationPeriod`<sup>Optional</sup> <a name="rotationPeriod" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.rotationPeriod"></a>

```typescript
public readonly rotationPeriod: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#rotation_period KmsSymmetricKey#rotation_period}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.KmsSymmetricKeyConfig.property.timeouts"></a>

```typescript
public readonly timeouts: KmsSymmetricKeyTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#timeouts KmsSymmetricKey#timeouts}

---

### KmsSymmetricKeyIamBindingConfig <a name="KmsSymmetricKeyIamBindingConfig" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.Initializer"></a>

```typescript
import { KmsSymmetricKeyIamBindingConfig } from '@cdktf/provider-yandex'

const kmsSymmetricKeyIamBindingConfig: KmsSymmetricKeyIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#members KmsSymmetricKeyIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#role KmsSymmetricKeyIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.symmetricKeyId">symmetricKeyId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#symmetric_key_id KmsSymmetricKeyIamBinding#symmetric_key_id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#id KmsSymmetricKeyIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#sleep_after KmsSymmetricKeyIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#members KmsSymmetricKeyIamBinding#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#role KmsSymmetricKeyIamBinding#role}.

---

##### `symmetricKeyId`<sup>Required</sup> <a name="symmetricKeyId" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.symmetricKeyId"></a>

```typescript
public readonly symmetricKeyId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#symmetric_key_id KmsSymmetricKeyIamBinding#symmetric_key_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#id KmsSymmetricKeyIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.KmsSymmetricKeyIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key_iam_binding#sleep_after KmsSymmetricKeyIamBinding#sleep_after}.

---

### KmsSymmetricKeyTimeouts <a name="KmsSymmetricKeyTimeouts" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.Initializer"></a>

```typescript
import { KmsSymmetricKeyTimeouts } from '@cdktf/provider-yandex'

const kmsSymmetricKeyTimeouts: KmsSymmetricKeyTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#create KmsSymmetricKey#create}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#delete KmsSymmetricKey#delete}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#read KmsSymmetricKey#read}. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#update KmsSymmetricKey#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#create KmsSymmetricKey#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#delete KmsSymmetricKey#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#read KmsSymmetricKey#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kms_symmetric_key#update KmsSymmetricKey#update}.

---

### KubernetesClusterConfig <a name="KubernetesClusterConfig" id="@cdktf/provider-yandex.KubernetesClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterConfig.Initializer"></a>

```typescript
import { KubernetesClusterConfig } from '@cdktf/provider-yandex'

const kubernetesClusterConfig: KubernetesClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.master">master</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a></code> | master block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_id KubernetesCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.nodeServiceAccountId">nodeServiceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_service_account_id KubernetesCluster#node_service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_account_id KubernetesCluster#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.clusterIpv4Range">clusterIpv4Range</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv4_range KubernetesCluster#cluster_ipv4_range}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.clusterIpv6Range">clusterIpv6Range</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv6_range KubernetesCluster#cluster_ipv6_range}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#description KubernetesCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#folder_id KubernetesCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#id KubernetesCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.kmsProvider">kmsProvider</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a></code> | kms_provider block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#labels KubernetesCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#name KubernetesCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.networkImplementation">networkImplementation</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a></code> | network_implementation block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.networkPolicyProvider">networkPolicyProvider</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_policy_provider KubernetesCluster#network_policy_provider}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.nodeIpv4CidrMaskSize">nodeIpv4CidrMaskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_ipv4_cidr_mask_size KubernetesCluster#node_ipv4_cidr_mask_size}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.releaseChannel">releaseChannel</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#release_channel KubernetesCluster#release_channel}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceIpv4Range">serviceIpv4Range</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv4_range KubernetesCluster#service_ipv4_range}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceIpv6Range">serviceIpv6Range</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv6_range KubernetesCluster#service_ipv6_range}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `master`<sup>Required</sup> <a name="master" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.master"></a>

```typescript
public readonly master: KubernetesClusterMaster;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a>

master block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#master KubernetesCluster#master}

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_id KubernetesCluster#network_id}.

---

##### `nodeServiceAccountId`<sup>Required</sup> <a name="nodeServiceAccountId" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.nodeServiceAccountId"></a>

```typescript
public readonly nodeServiceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_service_account_id KubernetesCluster#node_service_account_id}.

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_account_id KubernetesCluster#service_account_id}.

---

##### `clusterIpv4Range`<sup>Optional</sup> <a name="clusterIpv4Range" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.clusterIpv4Range"></a>

```typescript
public readonly clusterIpv4Range: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv4_range KubernetesCluster#cluster_ipv4_range}.

---

##### `clusterIpv6Range`<sup>Optional</sup> <a name="clusterIpv6Range" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.clusterIpv6Range"></a>

```typescript
public readonly clusterIpv6Range: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cluster_ipv6_range KubernetesCluster#cluster_ipv6_range}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#description KubernetesCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#folder_id KubernetesCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#id KubernetesCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `kmsProvider`<sup>Optional</sup> <a name="kmsProvider" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.kmsProvider"></a>

```typescript
public readonly kmsProvider: KubernetesClusterKmsProvider;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a>

kms_provider block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#kms_provider KubernetesCluster#kms_provider}

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#labels KubernetesCluster#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#name KubernetesCluster#name}.

---

##### `networkImplementation`<sup>Optional</sup> <a name="networkImplementation" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.networkImplementation"></a>

```typescript
public readonly networkImplementation: KubernetesClusterNetworkImplementation;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a>

network_implementation block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_implementation KubernetesCluster#network_implementation}

---

##### `networkPolicyProvider`<sup>Optional</sup> <a name="networkPolicyProvider" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.networkPolicyProvider"></a>

```typescript
public readonly networkPolicyProvider: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#network_policy_provider KubernetesCluster#network_policy_provider}.

---

##### `nodeIpv4CidrMaskSize`<sup>Optional</sup> <a name="nodeIpv4CidrMaskSize" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.nodeIpv4CidrMaskSize"></a>

```typescript
public readonly nodeIpv4CidrMaskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#node_ipv4_cidr_mask_size KubernetesCluster#node_ipv4_cidr_mask_size}.

---

##### `releaseChannel`<sup>Optional</sup> <a name="releaseChannel" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.releaseChannel"></a>

```typescript
public readonly releaseChannel: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#release_channel KubernetesCluster#release_channel}.

---

##### `serviceIpv4Range`<sup>Optional</sup> <a name="serviceIpv4Range" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceIpv4Range"></a>

```typescript
public readonly serviceIpv4Range: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv4_range KubernetesCluster#service_ipv4_range}.

---

##### `serviceIpv6Range`<sup>Optional</sup> <a name="serviceIpv6Range" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.serviceIpv6Range"></a>

```typescript
public readonly serviceIpv6Range: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#service_ipv6_range KubernetesCluster#service_ipv6_range}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.KubernetesClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: KubernetesClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#timeouts KubernetesCluster#timeouts}

---

### KubernetesClusterKmsProvider <a name="KubernetesClusterKmsProvider" id="@cdktf/provider-yandex.KubernetesClusterKmsProvider"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterKmsProvider.Initializer"></a>

```typescript
import { KubernetesClusterKmsProvider } from '@cdktf/provider-yandex'

const kubernetesClusterKmsProvider: KubernetesClusterKmsProvider = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider.property.keyId">keyId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#key_id KubernetesCluster#key_id}. |

---

##### `keyId`<sup>Optional</sup> <a name="keyId" id="@cdktf/provider-yandex.KubernetesClusterKmsProvider.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#key_id KubernetesCluster#key_id}.

---

### KubernetesClusterMaster <a name="KubernetesClusterMaster" id="@cdktf/provider-yandex.KubernetesClusterMaster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMaster.Initializer"></a>

```typescript
import { KubernetesClusterMaster } from '@cdktf/provider-yandex'

const kubernetesClusterMaster: KubernetesClusterMaster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a></code> | maintenance_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.publicIp">publicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#public_ip KubernetesCluster#public_ip}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.regional">regional</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a></code> | regional block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#security_group_ids KubernetesCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#version KubernetesCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster.property.zonal">zonal</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a></code> | zonal block. |

---

##### `maintenancePolicy`<sup>Optional</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: KubernetesClusterMasterMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a>

maintenance_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#maintenance_policy KubernetesCluster#maintenance_policy}

---

##### `publicIp`<sup>Optional</sup> <a name="publicIp" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.publicIp"></a>

```typescript
public readonly publicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#public_ip KubernetesCluster#public_ip}.

---

##### `regional`<sup>Optional</sup> <a name="regional" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.regional"></a>

```typescript
public readonly regional: KubernetesClusterMasterRegional;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a>

regional block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#regional KubernetesCluster#regional}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#security_group_ids KubernetesCluster#security_group_ids}.

---

##### `version`<sup>Optional</sup> <a name="version" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#version KubernetesCluster#version}.

---

##### `zonal`<sup>Optional</sup> <a name="zonal" id="@cdktf/provider-yandex.KubernetesClusterMaster.property.zonal"></a>

```typescript
public readonly zonal: KubernetesClusterMasterZonal;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a>

zonal block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zonal KubernetesCluster#zonal}

---

### KubernetesClusterMasterMaintenancePolicy <a name="KubernetesClusterMasterMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy.Initializer"></a>

```typescript
import { KubernetesClusterMasterMaintenancePolicy } from '@cdktf/provider-yandex'

const kubernetesClusterMasterMaintenancePolicy: KubernetesClusterMasterMaintenancePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy.property.autoUpgrade">autoUpgrade</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#auto_upgrade KubernetesCluster#auto_upgrade}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy.property.maintenanceWindow">maintenanceWindow</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]</code> | maintenance_window block. |

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#auto_upgrade KubernetesCluster#auto_upgrade}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#maintenance_window KubernetesCluster#maintenance_window}

---

### KubernetesClusterMasterMaintenancePolicyMaintenanceWindow <a name="KubernetesClusterMasterMaintenancePolicyMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.Initializer"></a>

```typescript
import { KubernetesClusterMasterMaintenancePolicyMaintenanceWindow } from '@cdktf/provider-yandex'

const kubernetesClusterMasterMaintenancePolicyMaintenanceWindow: KubernetesClusterMasterMaintenancePolicyMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.duration">duration</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#duration KubernetesCluster#duration}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.startTime">startTime</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#start_time KubernetesCluster#start_time}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#day KubernetesCluster#day}. |

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#duration KubernetesCluster#duration}.

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#start_time KubernetesCluster#start_time}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#day KubernetesCluster#day}.

---

### KubernetesClusterMasterRegional <a name="KubernetesClusterMasterRegional" id="@cdktf/provider-yandex.KubernetesClusterMasterRegional"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterRegional.Initializer"></a>

```typescript
import { KubernetesClusterMasterRegional } from '@cdktf/provider-yandex'

const kubernetesClusterMasterRegional: KubernetesClusterMasterRegional = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional.property.region">region</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#region KubernetesCluster#region}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional.property.location">location</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]</code> | location block. |

---

##### `region`<sup>Required</sup> <a name="region" id="@cdktf/provider-yandex.KubernetesClusterMasterRegional.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#region KubernetesCluster#region}.

---

##### `location`<sup>Optional</sup> <a name="location" id="@cdktf/provider-yandex.KubernetesClusterMasterRegional.property.location"></a>

```typescript
public readonly location: IResolvable | KubernetesClusterMasterRegionalLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]

location block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#location KubernetesCluster#location}

---

### KubernetesClusterMasterRegionalLocation <a name="KubernetesClusterMasterRegionalLocation" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation.Initializer"></a>

```typescript
import { KubernetesClusterMasterRegionalLocation } from '@cdktf/provider-yandex'

const kubernetesClusterMasterRegionalLocation: KubernetesClusterMasterRegionalLocation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}. |

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}.

---

### KubernetesClusterMasterVersionInfo <a name="KubernetesClusterMasterVersionInfo" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfo"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfo.Initializer"></a>

```typescript
import { KubernetesClusterMasterVersionInfo } from '@cdktf/provider-yandex'

const kubernetesClusterMasterVersionInfo: KubernetesClusterMasterVersionInfo = { ... }
```


### KubernetesClusterMasterZonal <a name="KubernetesClusterMasterZonal" id="@cdktf/provider-yandex.KubernetesClusterMasterZonal"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterMasterZonal.Initializer"></a>

```typescript
import { KubernetesClusterMasterZonal } from '@cdktf/provider-yandex'

const kubernetesClusterMasterZonal: KubernetesClusterMasterZonal = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}. |

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterZonal.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#subnet_id KubernetesCluster#subnet_id}.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesClusterMasterZonal.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#zone KubernetesCluster#zone}.

---

### KubernetesClusterNetworkImplementation <a name="KubernetesClusterNetworkImplementation" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementation.Initializer"></a>

```typescript
import { KubernetesClusterNetworkImplementation } from '@cdktf/provider-yandex'

const kubernetesClusterNetworkImplementation: KubernetesClusterNetworkImplementation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation.property.cilium">cilium</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a></code> | cilium block. |

---

##### `cilium`<sup>Optional</sup> <a name="cilium" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementation.property.cilium"></a>

```typescript
public readonly cilium: KubernetesClusterNetworkImplementationCilium;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a>

cilium block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#cilium KubernetesCluster#cilium}

---

### KubernetesClusterNetworkImplementationCilium <a name="KubernetesClusterNetworkImplementationCilium" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium.Initializer"></a>

```typescript
import { KubernetesClusterNetworkImplementationCilium } from '@cdktf/provider-yandex'

const kubernetesClusterNetworkImplementationCilium: KubernetesClusterNetworkImplementationCilium = { ... }
```


### KubernetesClusterTimeouts <a name="KubernetesClusterTimeouts" id="@cdktf/provider-yandex.KubernetesClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesClusterTimeouts.Initializer"></a>

```typescript
import { KubernetesClusterTimeouts } from '@cdktf/provider-yandex'

const kubernetesClusterTimeouts: KubernetesClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#create KubernetesCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#delete KubernetesCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#read KubernetesCluster#read}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#update KubernetesCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.KubernetesClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#create KubernetesCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.KubernetesClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#delete KubernetesCluster#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.KubernetesClusterTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#read KubernetesCluster#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.KubernetesClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_cluster#update KubernetesCluster#update}.

---

### KubernetesNodeGroupAllocationPolicy <a name="KubernetesNodeGroupAllocationPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupAllocationPolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupAllocationPolicy: KubernetesNodeGroupAllocationPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy.property.location">location</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]</code> | location block. |

---

##### `location`<sup>Optional</sup> <a name="location" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy.property.location"></a>

```typescript
public readonly location: IResolvable | KubernetesNodeGroupAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]

location block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#location KubernetesNodeGroup#location}

---

### KubernetesNodeGroupAllocationPolicyLocation <a name="KubernetesNodeGroupAllocationPolicyLocation" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation.Initializer"></a>

```typescript
import { KubernetesNodeGroupAllocationPolicyLocation } from '@cdktf/provider-yandex'

const kubernetesNodeGroupAllocationPolicyLocation: KubernetesNodeGroupAllocationPolicyLocation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_id KubernetesNodeGroup#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#zone KubernetesNodeGroup#zone}. |

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_id KubernetesNodeGroup#subnet_id}.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#zone KubernetesNodeGroup#zone}.

---

### KubernetesNodeGroupConfig <a name="KubernetesNodeGroupConfig" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.Initializer"></a>

```typescript
import { KubernetesNodeGroupConfig } from '@cdktf/provider-yandex'

const kubernetesNodeGroupConfig: KubernetesNodeGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cluster_id KubernetesNodeGroup#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.instanceTemplate">instanceTemplate</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a></code> | instance_template block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a></code> | scale_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.allocationPolicy">allocationPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a></code> | allocation_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.allowedUnsafeSysctls">allowedUnsafeSysctls</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#allowed_unsafe_sysctls KubernetesNodeGroup#allowed_unsafe_sysctls}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.deployPolicy">deployPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a></code> | deploy_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#description KubernetesNodeGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#id KubernetesNodeGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#labels KubernetesNodeGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a></code> | maintenance_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#name KubernetesNodeGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.nodeLabels">nodeLabels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_labels KubernetesNodeGroup#node_labels}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.nodeTaints">nodeTaints</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_taints KubernetesNodeGroup#node_taints}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#version KubernetesNodeGroup#version}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cluster_id KubernetesNodeGroup#cluster_id}.

---

##### `instanceTemplate`<sup>Required</sup> <a name="instanceTemplate" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.instanceTemplate"></a>

```typescript
public readonly instanceTemplate: KubernetesNodeGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a>

instance_template block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#instance_template KubernetesNodeGroup#instance_template}

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: KubernetesNodeGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a>

scale_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#scale_policy KubernetesNodeGroup#scale_policy}

---

##### `allocationPolicy`<sup>Optional</sup> <a name="allocationPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.allocationPolicy"></a>

```typescript
public readonly allocationPolicy: KubernetesNodeGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a>

allocation_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#allocation_policy KubernetesNodeGroup#allocation_policy}

---

##### `allowedUnsafeSysctls`<sup>Optional</sup> <a name="allowedUnsafeSysctls" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.allowedUnsafeSysctls"></a>

```typescript
public readonly allowedUnsafeSysctls: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#allowed_unsafe_sysctls KubernetesNodeGroup#allowed_unsafe_sysctls}.

---

##### `deployPolicy`<sup>Optional</sup> <a name="deployPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.deployPolicy"></a>

```typescript
public readonly deployPolicy: KubernetesNodeGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a>

deploy_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#deploy_policy KubernetesNodeGroup#deploy_policy}

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#description KubernetesNodeGroup#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#id KubernetesNodeGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#labels KubernetesNodeGroup#labels}.

---

##### `maintenancePolicy`<sup>Optional</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: KubernetesNodeGroupMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a>

maintenance_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#maintenance_policy KubernetesNodeGroup#maintenance_policy}

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#name KubernetesNodeGroup#name}.

---

##### `nodeLabels`<sup>Optional</sup> <a name="nodeLabels" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.nodeLabels"></a>

```typescript
public readonly nodeLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_labels KubernetesNodeGroup#node_labels}.

---

##### `nodeTaints`<sup>Optional</sup> <a name="nodeTaints" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.nodeTaints"></a>

```typescript
public readonly nodeTaints: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#node_taints KubernetesNodeGroup#node_taints}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: KubernetesNodeGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#timeouts KubernetesNodeGroup#timeouts}

---

##### `version`<sup>Optional</sup> <a name="version" id="@cdktf/provider-yandex.KubernetesNodeGroupConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#version KubernetesNodeGroup#version}.

---

### KubernetesNodeGroupDeployPolicy <a name="KubernetesNodeGroupDeployPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupDeployPolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupDeployPolicy: KubernetesNodeGroupDeployPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_expansion KubernetesNodeGroup#max_expansion}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_unavailable KubernetesNodeGroup#max_unavailable}. |

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_expansion KubernetesNodeGroup#max_expansion}.

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max_unavailable KubernetesNodeGroup#max_unavailable}.

---

### KubernetesNodeGroupInstanceTemplate <a name="KubernetesNodeGroupInstanceTemplate" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplate } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplate: KubernetesNodeGroupInstanceTemplate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a></code> | boot_disk block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.containerRuntime">containerRuntime</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a></code> | container_runtime block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#metadata KubernetesNodeGroup#metadata}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#network_acceleration_type KubernetesNodeGroup#network_acceleration_type}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.networkInterface">networkInterface</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]</code> | network_interface block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a></code> | placement_policy block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.platformId">platformId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#platform_id KubernetesNodeGroup#platform_id}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a></code> | scheduling_policy block. |

---

##### `bootDisk`<sup>Optional</sup> <a name="bootDisk" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.bootDisk"></a>

```typescript
public readonly bootDisk: KubernetesNodeGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a>

boot_disk block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#boot_disk KubernetesNodeGroup#boot_disk}

---

##### `containerRuntime`<sup>Optional</sup> <a name="containerRuntime" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.containerRuntime"></a>

```typescript
public readonly containerRuntime: KubernetesNodeGroupInstanceTemplateContainerRuntime;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a>

container_runtime block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#container_runtime KubernetesNodeGroup#container_runtime}

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#metadata KubernetesNodeGroup#metadata}.

---

##### `nat`<sup>Optional</sup> <a name="nat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}.

---

##### `networkAccelerationType`<sup>Optional</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#network_acceleration_type KubernetesNodeGroup#network_acceleration_type}.

---

##### `networkInterface`<sup>Optional</sup> <a name="networkInterface" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.networkInterface"></a>

```typescript
public readonly networkInterface: IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]

network_interface block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#network_interface KubernetesNodeGroup#network_interface}

---

##### `placementPolicy`<sup>Optional</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: KubernetesNodeGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a>

placement_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#placement_policy KubernetesNodeGroup#placement_policy}

---

##### `platformId`<sup>Optional</sup> <a name="platformId" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#platform_id KubernetesNodeGroup#platform_id}.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.resources"></a>

```typescript
public readonly resources: KubernetesNodeGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#resources KubernetesNodeGroup#resources}

---

##### `schedulingPolicy`<sup>Optional</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: KubernetesNodeGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a>

scheduling_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#scheduling_policy KubernetesNodeGroup#scheduling_policy}

---

### KubernetesNodeGroupInstanceTemplateBootDisk <a name="KubernetesNodeGroupInstanceTemplateBootDisk" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateBootDisk } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplateBootDisk: KubernetesNodeGroupInstanceTemplateBootDisk = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}. |

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}.

---

### KubernetesNodeGroupInstanceTemplateContainerRuntime <a name="KubernetesNodeGroupInstanceTemplateContainerRuntime" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateContainerRuntime } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplateContainerRuntime: KubernetesNodeGroupInstanceTemplateContainerRuntime = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#type KubernetesNodeGroup#type}.

---

### KubernetesNodeGroupInstanceTemplateNetworkInterface <a name="KubernetesNodeGroupInstanceTemplateNetworkInterface" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateNetworkInterface } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplateNetworkInterface: KubernetesNodeGroupInstanceTemplateNetworkInterface = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_ids KubernetesNodeGroup#subnet_ids}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv4 KubernetesNodeGroup#ipv4}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv6 KubernetesNodeGroup#ipv6}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#security_group_ids KubernetesNodeGroup#security_group_ids}. |

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#subnet_ids KubernetesNodeGroup#subnet_ids}.

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv4 KubernetesNodeGroup#ipv4}.

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#ipv6 KubernetesNodeGroup#ipv6}.

---

##### `nat`<sup>Optional</sup> <a name="nat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#nat KubernetesNodeGroup#nat}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#security_group_ids KubernetesNodeGroup#security_group_ids}.

---

### KubernetesNodeGroupInstanceTemplatePlacementPolicy <a name="KubernetesNodeGroupInstanceTemplatePlacementPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplatePlacementPolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplatePlacementPolicy: KubernetesNodeGroupInstanceTemplatePlacementPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#placement_group_id KubernetesNodeGroup#placement_group_id}. |

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#placement_group_id KubernetesNodeGroup#placement_group_id}.

---

### KubernetesNodeGroupInstanceTemplateResources <a name="KubernetesNodeGroupInstanceTemplateResources" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateResources } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplateResources: KubernetesNodeGroupInstanceTemplateResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.coreFraction">coreFraction</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#core_fraction KubernetesNodeGroup#core_fraction}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.cores">cores</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cores KubernetesNodeGroup#cores}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.gpus">gpus</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#gpus KubernetesNodeGroup#gpus}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.memory">memory</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#memory KubernetesNodeGroup#memory}. |

---

##### `coreFraction`<sup>Optional</sup> <a name="coreFraction" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#core_fraction KubernetesNodeGroup#core_fraction}.

---

##### `cores`<sup>Optional</sup> <a name="cores" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#cores KubernetesNodeGroup#cores}.

---

##### `gpus`<sup>Optional</sup> <a name="gpus" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#gpus KubernetesNodeGroup#gpus}.

---

##### `memory`<sup>Optional</sup> <a name="memory" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#memory KubernetesNodeGroup#memory}.

---

### KubernetesNodeGroupInstanceTemplateSchedulingPolicy <a name="KubernetesNodeGroupInstanceTemplateSchedulingPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateSchedulingPolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupInstanceTemplateSchedulingPolicy: KubernetesNodeGroupInstanceTemplateSchedulingPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#preemptible KubernetesNodeGroup#preemptible}. |

---

##### `preemptible`<sup>Optional</sup> <a name="preemptible" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#preemptible KubernetesNodeGroup#preemptible}.

---

### KubernetesNodeGroupMaintenancePolicy <a name="KubernetesNodeGroupMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupMaintenancePolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupMaintenancePolicy: KubernetesNodeGroupMaintenancePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.autoRepair">autoRepair</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_repair KubernetesNodeGroup#auto_repair}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.autoUpgrade">autoUpgrade</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_upgrade KubernetesNodeGroup#auto_upgrade}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.maintenanceWindow">maintenanceWindow</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]</code> | maintenance_window block. |

---

##### `autoRepair`<sup>Required</sup> <a name="autoRepair" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.autoRepair"></a>

```typescript
public readonly autoRepair: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_repair KubernetesNodeGroup#auto_repair}.

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_upgrade KubernetesNodeGroup#auto_upgrade}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#maintenance_window KubernetesNodeGroup#maintenance_window}

---

### KubernetesNodeGroupMaintenancePolicyMaintenanceWindow <a name="KubernetesNodeGroupMaintenancePolicyMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.Initializer"></a>

```typescript
import { KubernetesNodeGroupMaintenancePolicyMaintenanceWindow } from '@cdktf/provider-yandex'

const kubernetesNodeGroupMaintenancePolicyMaintenanceWindow: KubernetesNodeGroupMaintenancePolicyMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.duration">duration</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#duration KubernetesNodeGroup#duration}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.startTime">startTime</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#start_time KubernetesNodeGroup#start_time}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#day KubernetesNodeGroup#day}. |

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#duration KubernetesNodeGroup#duration}.

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#start_time KubernetesNodeGroup#start_time}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#day KubernetesNodeGroup#day}.

---

### KubernetesNodeGroupScalePolicy <a name="KubernetesNodeGroupScalePolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicy } from '@cdktf/provider-yandex'

const kubernetesNodeGroupScalePolicy: KubernetesNodeGroupScalePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a></code> | auto_scale block. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a></code> | fixed_scale block. |

---

##### `autoScale`<sup>Optional</sup> <a name="autoScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy.property.autoScale"></a>

```typescript
public readonly autoScale: KubernetesNodeGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a>

auto_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#auto_scale KubernetesNodeGroup#auto_scale}

---

##### `fixedScale`<sup>Optional</sup> <a name="fixedScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy.property.fixedScale"></a>

```typescript
public readonly fixedScale: KubernetesNodeGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a>

fixed_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#fixed_scale KubernetesNodeGroup#fixed_scale}

---

### KubernetesNodeGroupScalePolicyAutoScale <a name="KubernetesNodeGroupScalePolicyAutoScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicyAutoScale } from '@cdktf/provider-yandex'

const kubernetesNodeGroupScalePolicyAutoScale: KubernetesNodeGroupScalePolicyAutoScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.initial">initial</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#initial KubernetesNodeGroup#initial}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.max">max</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max KubernetesNodeGroup#max}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.min">min</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#min KubernetesNodeGroup#min}. |

---

##### `initial`<sup>Required</sup> <a name="initial" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.initial"></a>

```typescript
public readonly initial: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#initial KubernetesNodeGroup#initial}.

---

##### `max`<sup>Required</sup> <a name="max" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.max"></a>

```typescript
public readonly max: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#max KubernetesNodeGroup#max}.

---

##### `min`<sup>Required</sup> <a name="min" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale.property.min"></a>

```typescript
public readonly min: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#min KubernetesNodeGroup#min}.

---

### KubernetesNodeGroupScalePolicyFixedScale <a name="KubernetesNodeGroupScalePolicyFixedScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicyFixedScale } from '@cdktf/provider-yandex'

const kubernetesNodeGroupScalePolicyFixedScale: KubernetesNodeGroupScalePolicyFixedScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}. |

---

##### `size`<sup>Optional</sup> <a name="size" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#size KubernetesNodeGroup#size}.

---

### KubernetesNodeGroupTimeouts <a name="KubernetesNodeGroupTimeouts" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.Initializer"></a>

```typescript
import { KubernetesNodeGroupTimeouts } from '@cdktf/provider-yandex'

const kubernetesNodeGroupTimeouts: KubernetesNodeGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#create KubernetesNodeGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#delete KubernetesNodeGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#read KubernetesNodeGroup#read}. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#update KubernetesNodeGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#create KubernetesNodeGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#delete KubernetesNodeGroup#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#read KubernetesNodeGroup#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/kubernetes_node_group#update KubernetesNodeGroup#update}.

---

### KubernetesNodeGroupVersionInfo <a name="KubernetesNodeGroupVersionInfo" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfo"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfo.Initializer"></a>

```typescript
import { KubernetesNodeGroupVersionInfo } from '@cdktf/provider-yandex'

const kubernetesNodeGroupVersionInfo: KubernetesNodeGroupVersionInfo = { ... }
```


### LbNetworkLoadBalancerAttachedTargetGroup <a name="LbNetworkLoadBalancerAttachedTargetGroup" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroup } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerAttachedTargetGroup: LbNetworkLoadBalancerAttachedTargetGroup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup.property.healthcheck">healthcheck</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]</code> | healthcheck block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_group_id LbNetworkLoadBalancer#target_group_id}. |

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup.property.healthcheck"></a>

```typescript
public readonly healthcheck: IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]

healthcheck block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthcheck LbNetworkLoadBalancer#healthcheck}

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_group_id LbNetworkLoadBalancer#target_group_id}.

---

### LbNetworkLoadBalancerAttachedTargetGroupHealthcheck <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheck" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheck } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerAttachedTargetGroupHealthcheck: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthy_threshold LbNetworkLoadBalancer#healthy_threshold}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.httpOptions">httpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a></code> | http_options block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.interval">interval</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#interval LbNetworkLoadBalancer#interval}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a></code> | tcp_options block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.timeout">timeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeout LbNetworkLoadBalancer#timeout}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#unhealthy_threshold LbNetworkLoadBalancer#unhealthy_threshold}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}.

---

##### `healthyThreshold`<sup>Optional</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthy_threshold LbNetworkLoadBalancer#healthy_threshold}.

---

##### `httpOptions`<sup>Optional</sup> <a name="httpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.httpOptions"></a>

```typescript
public readonly httpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a>

http_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#http_options LbNetworkLoadBalancer#http_options}

---

##### `interval`<sup>Optional</sup> <a name="interval" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#interval LbNetworkLoadBalancer#interval}.

---

##### `tcpOptions`<sup>Optional</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a>

tcp_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#tcp_options LbNetworkLoadBalancer#tcp_options}

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeout LbNetworkLoadBalancer#timeout}.

---

##### `unhealthyThreshold`<sup>Optional</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#unhealthy_threshold LbNetworkLoadBalancer#unhealthy_threshold}.

---

### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.property.path">path</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#path LbNetworkLoadBalancer#path}. |

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}.

---

##### `path`<sup>Optional</sup> <a name="path" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#path LbNetworkLoadBalancer#path}.

---

### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}. |

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}.

---

### LbNetworkLoadBalancerConfig <a name="LbNetworkLoadBalancerConfig" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerConfig } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerConfig: LbNetworkLoadBalancerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.attachedTargetGroup">attachedTargetGroup</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]</code> | attached_target_group block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#description LbNetworkLoadBalancer#description}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#folder_id LbNetworkLoadBalancer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#id LbNetworkLoadBalancer#id}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#labels LbNetworkLoadBalancer#labels}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.listener">listener</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]</code> | listener block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.regionId">regionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#region_id LbNetworkLoadBalancer#region_id}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#type LbNetworkLoadBalancer#type}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `attachedTargetGroup`<sup>Optional</sup> <a name="attachedTargetGroup" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.attachedTargetGroup"></a>

```typescript
public readonly attachedTargetGroup: IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]

attached_target_group block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#attached_target_group LbNetworkLoadBalancer#attached_target_group}

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#description LbNetworkLoadBalancer#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#folder_id LbNetworkLoadBalancer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#id LbNetworkLoadBalancer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#labels LbNetworkLoadBalancer#labels}.

---

##### `listener`<sup>Optional</sup> <a name="listener" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.listener"></a>

```typescript
public readonly listener: IResolvable | LbNetworkLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]

listener block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#listener LbNetworkLoadBalancer#listener}

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}.

---

##### `regionId`<sup>Optional</sup> <a name="regionId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#region_id LbNetworkLoadBalancer#region_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.timeouts"></a>

```typescript
public readonly timeouts: LbNetworkLoadBalancerTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeouts LbNetworkLoadBalancer#timeouts}

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.LbNetworkLoadBalancerConfig.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#type LbNetworkLoadBalancer#type}.

---

### LbNetworkLoadBalancerListener <a name="LbNetworkLoadBalancerListener" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListener } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerListener: LbNetworkLoadBalancerListener = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.externalAddressSpec">externalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a></code> | external_address_spec block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.internalAddressSpec">internalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a></code> | internal_address_spec block. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#protocol LbNetworkLoadBalancer#protocol}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.targetPort">targetPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_port LbNetworkLoadBalancer#target_port}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}.

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}.

---

##### `externalAddressSpec`<sup>Optional</sup> <a name="externalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.externalAddressSpec"></a>

```typescript
public readonly externalAddressSpec: LbNetworkLoadBalancerListenerExternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a>

external_address_spec block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#external_address_spec LbNetworkLoadBalancer#external_address_spec}

---

##### `internalAddressSpec`<sup>Optional</sup> <a name="internalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.internalAddressSpec"></a>

```typescript
public readonly internalAddressSpec: LbNetworkLoadBalancerListenerInternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a>

internal_address_spec block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#internal_address_spec LbNetworkLoadBalancer#internal_address_spec}

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#protocol LbNetworkLoadBalancer#protocol}.

---

##### `targetPort`<sup>Optional</sup> <a name="targetPort" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListener.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_port LbNetworkLoadBalancer#target_port}.

---

### LbNetworkLoadBalancerListenerExternalAddressSpec <a name="LbNetworkLoadBalancerListenerExternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerExternalAddressSpec } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerListenerExternalAddressSpec: LbNetworkLoadBalancerListenerExternalAddressSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec.property.ipVersion">ipVersion</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}. |

---

##### `address`<sup>Optional</sup> <a name="address" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}.

---

##### `ipVersion`<sup>Optional</sup> <a name="ipVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}.

---

### LbNetworkLoadBalancerListenerInternalAddressSpec <a name="LbNetworkLoadBalancerListenerInternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerInternalAddressSpec } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerListenerInternalAddressSpec: LbNetworkLoadBalancerListenerInternalAddressSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#subnet_id LbNetworkLoadBalancer#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.ipVersion">ipVersion</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}. |

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#subnet_id LbNetworkLoadBalancer#subnet_id}.

---

##### `address`<sup>Optional</sup> <a name="address" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}.

---

##### `ipVersion`<sup>Optional</sup> <a name="ipVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}.

---

### LbNetworkLoadBalancerTimeouts <a name="LbNetworkLoadBalancerTimeouts" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerTimeouts } from '@cdktf/provider-yandex'

const lbNetworkLoadBalancerTimeouts: LbNetworkLoadBalancerTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#create LbNetworkLoadBalancer#create}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#delete LbNetworkLoadBalancer#delete}. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#update LbNetworkLoadBalancer#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#create LbNetworkLoadBalancer#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#delete LbNetworkLoadBalancer#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#update LbNetworkLoadBalancer#update}.

---

### LbTargetGroupConfig <a name="LbTargetGroupConfig" id="@cdktf/provider-yandex.LbTargetGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbTargetGroupConfig.Initializer"></a>

```typescript
import { LbTargetGroupConfig } from '@cdktf/provider-yandex'

const lbTargetGroupConfig: LbTargetGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#description LbTargetGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#folder_id LbTargetGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#id LbTargetGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#labels LbTargetGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#name LbTargetGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.regionId">regionId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#region_id LbTargetGroup#region_id}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.target">target</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]</code> | target block. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#description LbTargetGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#folder_id LbTargetGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#id LbTargetGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#labels LbTargetGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#name LbTargetGroup#name}.

---

##### `regionId`<sup>Optional</sup> <a name="regionId" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.regionId"></a>

```typescript
public readonly regionId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#region_id LbTargetGroup#region_id}.

---

##### `target`<sup>Optional</sup> <a name="target" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.target"></a>

```typescript
public readonly target: IResolvable | LbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]

target block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#target LbTargetGroup#target}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.LbTargetGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: LbTargetGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#timeouts LbTargetGroup#timeouts}

---

### LbTargetGroupTarget <a name="LbTargetGroupTarget" id="@cdktf/provider-yandex.LbTargetGroupTarget"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbTargetGroupTarget.Initializer"></a>

```typescript
import { LbTargetGroupTarget } from '@cdktf/provider-yandex'

const lbTargetGroupTarget: LbTargetGroupTarget = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTarget.property.address">address</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#address LbTargetGroup#address}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTarget.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#subnet_id LbTargetGroup#subnet_id}. |

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.LbTargetGroupTarget.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#address LbTargetGroup#address}.

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.LbTargetGroupTarget.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#subnet_id LbTargetGroup#subnet_id}.

---

### LbTargetGroupTimeouts <a name="LbTargetGroupTimeouts" id="@cdktf/provider-yandex.LbTargetGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LbTargetGroupTimeouts.Initializer"></a>

```typescript
import { LbTargetGroupTimeouts } from '@cdktf/provider-yandex'

const lbTargetGroupTimeouts: LbTargetGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#create LbTargetGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#delete LbTargetGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#update LbTargetGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.LbTargetGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#create LbTargetGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.LbTargetGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#delete LbTargetGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.LbTargetGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_target_group#update LbTargetGroup#update}.

---

### LoggingGroupConfig <a name="LoggingGroupConfig" id="@cdktf/provider-yandex.LoggingGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LoggingGroupConfig.Initializer"></a>

```typescript
import { LoggingGroupConfig } from '@cdktf/provider-yandex'

const loggingGroupConfig: LoggingGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#description LoggingGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#folder_id LoggingGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#id LoggingGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#labels LoggingGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#name LoggingGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.retentionPeriod">retentionPeriod</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#retention_period LoggingGroup#retention_period}. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.LoggingGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.LoggingGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.LoggingGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.LoggingGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.LoggingGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#description LoggingGroup#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.LoggingGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#folder_id LoggingGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.LoggingGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#id LoggingGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.LoggingGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#labels LoggingGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.LoggingGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#name LoggingGroup#name}.

---

##### `retentionPeriod`<sup>Optional</sup> <a name="retentionPeriod" id="@cdktf/provider-yandex.LoggingGroupConfig.property.retentionPeriod"></a>

```typescript
public readonly retentionPeriod: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#retention_period LoggingGroup#retention_period}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.LoggingGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: LoggingGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#timeouts LoggingGroup#timeouts}

---

### LoggingGroupTimeouts <a name="LoggingGroupTimeouts" id="@cdktf/provider-yandex.LoggingGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.LoggingGroupTimeouts.Initializer"></a>

```typescript
import { LoggingGroupTimeouts } from '@cdktf/provider-yandex'

const loggingGroupTimeouts: LoggingGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeouts.property.default">default</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#default LoggingGroup#default}. |

---

##### `default`<sup>Optional</sup> <a name="default" id="@cdktf/provider-yandex.LoggingGroupTimeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/logging_group#default LoggingGroup#default}.

---

### MdbClickhouseClusterAccess <a name="MdbClickhouseClusterAccess" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess.Initializer"></a>

```typescript
import { MdbClickhouseClusterAccess } from '@cdktf/provider-yandex'

const mdbClickhouseClusterAccess: MdbClickhouseClusterAccess = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#data_lens MdbClickhouseCluster#data_lens}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.metrika">metrika</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metrika MdbClickhouseCluster#metrika}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.serverless">serverless</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#serverless MdbClickhouseCluster#serverless}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#web_sql MdbClickhouseCluster#web_sql}. |

---

##### `dataLens`<sup>Optional</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#data_lens MdbClickhouseCluster#data_lens}.

---

##### `metrika`<sup>Optional</sup> <a name="metrika" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.metrika"></a>

```typescript
public readonly metrika: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metrika MdbClickhouseCluster#metrika}.

---

##### `serverless`<sup>Optional</sup> <a name="serverless" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.serverless"></a>

```typescript
public readonly serverless: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#serverless MdbClickhouseCluster#serverless}.

---

##### `webSql`<sup>Optional</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbClickhouseClusterAccess.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#web_sql MdbClickhouseCluster#web_sql}.

---

### MdbClickhouseClusterBackupWindowStart <a name="MdbClickhouseClusterBackupWindowStart" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart.Initializer"></a>

```typescript
import { MdbClickhouseClusterBackupWindowStart } from '@cdktf/provider-yandex'

const mdbClickhouseClusterBackupWindowStart: MdbClickhouseClusterBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hours MdbClickhouseCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#minutes MdbClickhouseCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hours MdbClickhouseCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#minutes MdbClickhouseCluster#minutes}.

---

### MdbClickhouseClusterClickhouse <a name="MdbClickhouseClusterClickhouse" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouse"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouse.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouse } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouse: MdbClickhouseClusterClickhouse = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a></code> | config block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouse.property.resources"></a>

```typescript
public readonly resources: MdbClickhouseClusterClickhouseResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resources MdbClickhouseCluster#resources}

---

##### `config`<sup>Optional</sup> <a name="config" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouse.property.config"></a>

```typescript
public readonly config: MdbClickhouseClusterClickhouseConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#config MdbClickhouseCluster#config}

---

### MdbClickhouseClusterClickhouseConfig <a name="MdbClickhouseClusterClickhouseConfig" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfig } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfig: MdbClickhouseClusterClickhouseConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.backgroundPoolSize">backgroundPoolSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_pool_size MdbClickhouseCluster#background_pool_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.backgroundSchedulePoolSize">backgroundSchedulePoolSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_schedule_pool_size MdbClickhouseCluster#background_schedule_pool_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.compression">compression</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]</code> | compression block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.geobaseUri">geobaseUri</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#geobase_uri MdbClickhouseCluster#geobase_uri}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.graphiteRollup">graphiteRollup</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]</code> | graphite_rollup block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a></code> | kafka block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.kafkaTopic">kafkaTopic</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]</code> | kafka_topic block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.keepAliveTimeout">keepAliveTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#keep_alive_timeout MdbClickhouseCluster#keep_alive_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.logLevel">logLevel</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#log_level MdbClickhouseCluster#log_level}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.markCacheSize">markCacheSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#mark_cache_size MdbClickhouseCluster#mark_cache_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxConcurrentQueries">maxConcurrentQueries</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_concurrent_queries MdbClickhouseCluster#max_concurrent_queries}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxConnections">maxConnections</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_connections MdbClickhouseCluster#max_connections}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxPartitionSizeToDrop">maxPartitionSizeToDrop</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_partition_size_to_drop MdbClickhouseCluster#max_partition_size_to_drop}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxTableSizeToDrop">maxTableSizeToDrop</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_table_size_to_drop MdbClickhouseCluster#max_table_size_to_drop}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.mergeTree">mergeTree</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a></code> | merge_tree block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogEnabled">metricLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_enabled MdbClickhouseCluster#metric_log_enabled}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogRetentionSize">metricLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_size MdbClickhouseCluster#metric_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogRetentionTime">metricLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_time MdbClickhouseCluster#metric_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.partLogRetentionSize">partLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_size MdbClickhouseCluster#part_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.partLogRetentionTime">partLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_time MdbClickhouseCluster#part_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryLogRetentionSize">queryLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_size MdbClickhouseCluster#query_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryLogRetentionTime">queryLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_time MdbClickhouseCluster#query_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogEnabled">queryThreadLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_enabled MdbClickhouseCluster#query_thread_log_enabled}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogRetentionSize">queryThreadLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_size MdbClickhouseCluster#query_thread_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogRetentionTime">queryThreadLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_time MdbClickhouseCluster#query_thread_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.rabbitmq">rabbitmq</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a></code> | rabbitmq block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogEnabled">textLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_enabled MdbClickhouseCluster#text_log_enabled}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogLevel">textLogLevel</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_level MdbClickhouseCluster#text_log_level}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogRetentionSize">textLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_size MdbClickhouseCluster#text_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogRetentionTime">textLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_time MdbClickhouseCluster#text_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.timezone">timezone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timezone MdbClickhouseCluster#timezone}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogEnabled">traceLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_enabled MdbClickhouseCluster#trace_log_enabled}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogRetentionSize">traceLogRetentionSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_size MdbClickhouseCluster#trace_log_retention_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogRetentionTime">traceLogRetentionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_time MdbClickhouseCluster#trace_log_retention_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.uncompressedCacheSize">uncompressedCacheSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uncompressed_cache_size MdbClickhouseCluster#uncompressed_cache_size}. |

---

##### `backgroundPoolSize`<sup>Optional</sup> <a name="backgroundPoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.backgroundPoolSize"></a>

```typescript
public readonly backgroundPoolSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_pool_size MdbClickhouseCluster#background_pool_size}.

---

##### `backgroundSchedulePoolSize`<sup>Optional</sup> <a name="backgroundSchedulePoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.backgroundSchedulePoolSize"></a>

```typescript
public readonly backgroundSchedulePoolSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#background_schedule_pool_size MdbClickhouseCluster#background_schedule_pool_size}.

---

##### `compression`<sup>Optional</sup> <a name="compression" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.compression"></a>

```typescript
public readonly compression: IResolvable | MdbClickhouseClusterClickhouseConfigCompression[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]

compression block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compression MdbClickhouseCluster#compression}

---

##### `geobaseUri`<sup>Optional</sup> <a name="geobaseUri" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.geobaseUri"></a>

```typescript
public readonly geobaseUri: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#geobase_uri MdbClickhouseCluster#geobase_uri}.

---

##### `graphiteRollup`<sup>Optional</sup> <a name="graphiteRollup" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.graphiteRollup"></a>

```typescript
public readonly graphiteRollup: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]

graphite_rollup block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#graphite_rollup MdbClickhouseCluster#graphite_rollup}

---

##### `kafka`<sup>Optional</sup> <a name="kafka" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.kafka"></a>

```typescript
public readonly kafka: MdbClickhouseClusterClickhouseConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a>

kafka block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#kafka MdbClickhouseCluster#kafka}

---

##### `kafkaTopic`<sup>Optional</sup> <a name="kafkaTopic" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.kafkaTopic"></a>

```typescript
public readonly kafkaTopic: IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]

kafka_topic block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#kafka_topic MdbClickhouseCluster#kafka_topic}

---

##### `keepAliveTimeout`<sup>Optional</sup> <a name="keepAliveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#keep_alive_timeout MdbClickhouseCluster#keep_alive_timeout}.

---

##### `logLevel`<sup>Optional</sup> <a name="logLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.logLevel"></a>

```typescript
public readonly logLevel: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#log_level MdbClickhouseCluster#log_level}.

---

##### `markCacheSize`<sup>Optional</sup> <a name="markCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.markCacheSize"></a>

```typescript
public readonly markCacheSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#mark_cache_size MdbClickhouseCluster#mark_cache_size}.

---

##### `maxConcurrentQueries`<sup>Optional</sup> <a name="maxConcurrentQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxConcurrentQueries"></a>

```typescript
public readonly maxConcurrentQueries: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_concurrent_queries MdbClickhouseCluster#max_concurrent_queries}.

---

##### `maxConnections`<sup>Optional</sup> <a name="maxConnections" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxConnections"></a>

```typescript
public readonly maxConnections: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_connections MdbClickhouseCluster#max_connections}.

---

##### `maxPartitionSizeToDrop`<sup>Optional</sup> <a name="maxPartitionSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxPartitionSizeToDrop"></a>

```typescript
public readonly maxPartitionSizeToDrop: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_partition_size_to_drop MdbClickhouseCluster#max_partition_size_to_drop}.

---

##### `maxTableSizeToDrop`<sup>Optional</sup> <a name="maxTableSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.maxTableSizeToDrop"></a>

```typescript
public readonly maxTableSizeToDrop: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_table_size_to_drop MdbClickhouseCluster#max_table_size_to_drop}.

---

##### `mergeTree`<sup>Optional</sup> <a name="mergeTree" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.mergeTree"></a>

```typescript
public readonly mergeTree: MdbClickhouseClusterClickhouseConfigMergeTree;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a>

merge_tree block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree MdbClickhouseCluster#merge_tree}

---

##### `metricLogEnabled`<sup>Optional</sup> <a name="metricLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogEnabled"></a>

```typescript
public readonly metricLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_enabled MdbClickhouseCluster#metric_log_enabled}.

---

##### `metricLogRetentionSize`<sup>Optional</sup> <a name="metricLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogRetentionSize"></a>

```typescript
public readonly metricLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_size MdbClickhouseCluster#metric_log_retention_size}.

---

##### `metricLogRetentionTime`<sup>Optional</sup> <a name="metricLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.metricLogRetentionTime"></a>

```typescript
public readonly metricLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#metric_log_retention_time MdbClickhouseCluster#metric_log_retention_time}.

---

##### `partLogRetentionSize`<sup>Optional</sup> <a name="partLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.partLogRetentionSize"></a>

```typescript
public readonly partLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_size MdbClickhouseCluster#part_log_retention_size}.

---

##### `partLogRetentionTime`<sup>Optional</sup> <a name="partLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.partLogRetentionTime"></a>

```typescript
public readonly partLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#part_log_retention_time MdbClickhouseCluster#part_log_retention_time}.

---

##### `queryLogRetentionSize`<sup>Optional</sup> <a name="queryLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryLogRetentionSize"></a>

```typescript
public readonly queryLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_size MdbClickhouseCluster#query_log_retention_size}.

---

##### `queryLogRetentionTime`<sup>Optional</sup> <a name="queryLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryLogRetentionTime"></a>

```typescript
public readonly queryLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_log_retention_time MdbClickhouseCluster#query_log_retention_time}.

---

##### `queryThreadLogEnabled`<sup>Optional</sup> <a name="queryThreadLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogEnabled"></a>

```typescript
public readonly queryThreadLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_enabled MdbClickhouseCluster#query_thread_log_enabled}.

---

##### `queryThreadLogRetentionSize`<sup>Optional</sup> <a name="queryThreadLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogRetentionSize"></a>

```typescript
public readonly queryThreadLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_size MdbClickhouseCluster#query_thread_log_retention_size}.

---

##### `queryThreadLogRetentionTime`<sup>Optional</sup> <a name="queryThreadLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.queryThreadLogRetentionTime"></a>

```typescript
public readonly queryThreadLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#query_thread_log_retention_time MdbClickhouseCluster#query_thread_log_retention_time}.

---

##### `rabbitmq`<sup>Optional</sup> <a name="rabbitmq" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.rabbitmq"></a>

```typescript
public readonly rabbitmq: MdbClickhouseClusterClickhouseConfigRabbitmq;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a>

rabbitmq block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#rabbitmq MdbClickhouseCluster#rabbitmq}

---

##### `textLogEnabled`<sup>Optional</sup> <a name="textLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogEnabled"></a>

```typescript
public readonly textLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_enabled MdbClickhouseCluster#text_log_enabled}.

---

##### `textLogLevel`<sup>Optional</sup> <a name="textLogLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogLevel"></a>

```typescript
public readonly textLogLevel: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_level MdbClickhouseCluster#text_log_level}.

---

##### `textLogRetentionSize`<sup>Optional</sup> <a name="textLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogRetentionSize"></a>

```typescript
public readonly textLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_size MdbClickhouseCluster#text_log_retention_size}.

---

##### `textLogRetentionTime`<sup>Optional</sup> <a name="textLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.textLogRetentionTime"></a>

```typescript
public readonly textLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#text_log_retention_time MdbClickhouseCluster#text_log_retention_time}.

---

##### `timezone`<sup>Optional</sup> <a name="timezone" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timezone MdbClickhouseCluster#timezone}.

---

##### `traceLogEnabled`<sup>Optional</sup> <a name="traceLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogEnabled"></a>

```typescript
public readonly traceLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_enabled MdbClickhouseCluster#trace_log_enabled}.

---

##### `traceLogRetentionSize`<sup>Optional</sup> <a name="traceLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogRetentionSize"></a>

```typescript
public readonly traceLogRetentionSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_size MdbClickhouseCluster#trace_log_retention_size}.

---

##### `traceLogRetentionTime`<sup>Optional</sup> <a name="traceLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.traceLogRetentionTime"></a>

```typescript
public readonly traceLogRetentionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#trace_log_retention_time MdbClickhouseCluster#trace_log_retention_time}.

---

##### `uncompressedCacheSize`<sup>Optional</sup> <a name="uncompressedCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig.property.uncompressedCacheSize"></a>

```typescript
public readonly uncompressedCacheSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uncompressed_cache_size MdbClickhouseCluster#uncompressed_cache_size}.

---

### MdbClickhouseClusterClickhouseConfigCompression <a name="MdbClickhouseClusterClickhouseConfigCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigCompression } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigCompression: MdbClickhouseClusterClickhouseConfigCompression = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.method">method</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#method MdbClickhouseCluster#method}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.minPartSize">minPartSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size MdbClickhouseCluster#min_part_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.minPartSizeRatio">minPartSizeRatio</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size_ratio MdbClickhouseCluster#min_part_size_ratio}. |

---

##### `method`<sup>Required</sup> <a name="method" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.method"></a>

```typescript
public readonly method: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#method MdbClickhouseCluster#method}.

---

##### `minPartSize`<sup>Required</sup> <a name="minPartSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.minPartSize"></a>

```typescript
public readonly minPartSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size MdbClickhouseCluster#min_part_size}.

---

##### `minPartSizeRatio`<sup>Required</sup> <a name="minPartSizeRatio" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression.property.minPartSizeRatio"></a>

```typescript
public readonly minPartSizeRatio: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_part_size_ratio MdbClickhouseCluster#min_part_size_ratio}.

---

### MdbClickhouseClusterClickhouseConfigGraphiteRollup <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollup" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollup } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigGraphiteRollup: MdbClickhouseClusterClickhouseConfigGraphiteRollup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup.property.pattern">pattern</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]</code> | pattern block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `pattern`<sup>Optional</sup> <a name="pattern" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup.property.pattern"></a>

```typescript
public readonly pattern: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]

pattern block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#pattern MdbClickhouseCluster#pattern}

---

### MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigGraphiteRollupPattern: MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.function">function</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#function MdbClickhouseCluster#function}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.regexp">regexp</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#regexp MdbClickhouseCluster#regexp}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.retention">retention</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]</code> | retention block. |

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.function"></a>

```typescript
public readonly function: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#function MdbClickhouseCluster#function}.

---

##### `regexp`<sup>Optional</sup> <a name="regexp" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.regexp"></a>

```typescript
public readonly regexp: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#regexp MdbClickhouseCluster#regexp}.

---

##### `retention`<sup>Optional</sup> <a name="retention" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern.property.retention"></a>

```typescript
public readonly retention: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]

retention block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#retention MdbClickhouseCluster#retention}

---

### MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.property.age">age</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#age MdbClickhouseCluster#age}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.property.precision">precision</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#precision MdbClickhouseCluster#precision}. |

---

##### `age`<sup>Required</sup> <a name="age" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.property.age"></a>

```typescript
public readonly age: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#age MdbClickhouseCluster#age}.

---

##### `precision`<sup>Required</sup> <a name="precision" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention.property.precision"></a>

```typescript
public readonly precision: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#precision MdbClickhouseCluster#precision}.

---

### MdbClickhouseClusterClickhouseConfigKafka <a name="MdbClickhouseClusterClickhouseConfigKafka" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafka } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigKafka: MdbClickhouseClusterClickhouseConfigKafka = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslPassword">saslPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslUsername">saslUsername</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}. |

---

##### `saslMechanism`<sup>Optional</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}.

---

##### `saslPassword`<sup>Optional</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}.

---

##### `saslUsername`<sup>Optional</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}.

---

##### `securityProtocol`<sup>Optional</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}.

---

### MdbClickhouseClusterClickhouseConfigKafkaTopic <a name="MdbClickhouseClusterClickhouseConfigKafkaTopic" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaTopic } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigKafkaTopic: MdbClickhouseClusterClickhouseConfigKafkaTopic = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a></code> | settings block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `settings`<sup>Optional</sup> <a name="settings" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic.property.settings"></a>

```typescript
public readonly settings: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a>

settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#settings MdbClickhouseCluster#settings}

---

### MdbClickhouseClusterClickhouseConfigKafkaTopicSettings <a name="MdbClickhouseClusterClickhouseConfigKafkaTopicSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaTopicSettings } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigKafkaTopicSettings: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslPassword">saslPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslUsername">saslUsername</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}. |

---

##### `saslMechanism`<sup>Optional</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_mechanism MdbClickhouseCluster#sasl_mechanism}.

---

##### `saslPassword`<sup>Optional</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_password MdbClickhouseCluster#sasl_password}.

---

##### `saslUsername`<sup>Optional</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sasl_username MdbClickhouseCluster#sasl_username}.

---

##### `securityProtocol`<sup>Optional</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_protocol MdbClickhouseCluster#security_protocol}.

---

### MdbClickhouseClusterClickhouseConfigMergeTree <a name="MdbClickhouseClusterClickhouseConfigMergeTree" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigMergeTree } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigMergeTree: MdbClickhouseClusterClickhouseConfigMergeTree = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.maxBytesToMergeAtMinSpaceInPool">maxBytesToMergeAtMinSpaceInPool</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_merge_at_min_space_in_pool MdbClickhouseCluster#max_bytes_to_merge_at_min_space_in_pool}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.maxReplicatedMergesInQueue">maxReplicatedMergesInQueue</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replicated_merges_in_queue MdbClickhouseCluster#max_replicated_merges_in_queue}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge">numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge MdbClickhouseCluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.partsToDelayInsert">partsToDelayInsert</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_delay_insert MdbClickhouseCluster#parts_to_delay_insert}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.partsToThrowInsert">partsToThrowInsert</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_throw_insert MdbClickhouseCluster#parts_to_throw_insert}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.replicatedDeduplicationWindow">replicatedDeduplicationWindow</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window MdbClickhouseCluster#replicated_deduplication_window}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.replicatedDeduplicationWindowSeconds">replicatedDeduplicationWindowSeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window_seconds MdbClickhouseCluster#replicated_deduplication_window_seconds}. |

---

##### `maxBytesToMergeAtMinSpaceInPool`<sup>Optional</sup> <a name="maxBytesToMergeAtMinSpaceInPool" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.maxBytesToMergeAtMinSpaceInPool"></a>

```typescript
public readonly maxBytesToMergeAtMinSpaceInPool: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_merge_at_min_space_in_pool MdbClickhouseCluster#max_bytes_to_merge_at_min_space_in_pool}.

---

##### `maxReplicatedMergesInQueue`<sup>Optional</sup> <a name="maxReplicatedMergesInQueue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.maxReplicatedMergesInQueue"></a>

```typescript
public readonly maxReplicatedMergesInQueue: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replicated_merges_in_queue MdbClickhouseCluster#max_replicated_merges_in_queue}.

---

##### `numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge`<sup>Optional</sup> <a name="numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge"></a>

```typescript
public readonly numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge MdbClickhouseCluster#number_of_free_entries_in_pool_to_lower_max_size_of_merge}.

---

##### `partsToDelayInsert`<sup>Optional</sup> <a name="partsToDelayInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.partsToDelayInsert"></a>

```typescript
public readonly partsToDelayInsert: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_delay_insert MdbClickhouseCluster#parts_to_delay_insert}.

---

##### `partsToThrowInsert`<sup>Optional</sup> <a name="partsToThrowInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.partsToThrowInsert"></a>

```typescript
public readonly partsToThrowInsert: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#parts_to_throw_insert MdbClickhouseCluster#parts_to_throw_insert}.

---

##### `replicatedDeduplicationWindow`<sup>Optional</sup> <a name="replicatedDeduplicationWindow" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.replicatedDeduplicationWindow"></a>

```typescript
public readonly replicatedDeduplicationWindow: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window MdbClickhouseCluster#replicated_deduplication_window}.

---

##### `replicatedDeduplicationWindowSeconds`<sup>Optional</sup> <a name="replicatedDeduplicationWindowSeconds" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree.property.replicatedDeduplicationWindowSeconds"></a>

```typescript
public readonly replicatedDeduplicationWindowSeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replicated_deduplication_window_seconds MdbClickhouseCluster#replicated_deduplication_window_seconds}.

---

### MdbClickhouseClusterClickhouseConfigRabbitmq <a name="MdbClickhouseClusterClickhouseConfigRabbitmq" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigRabbitmq } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseConfigRabbitmq: MdbClickhouseClusterClickhouseConfigRabbitmq = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq.property.username">username</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#username MdbClickhouseCluster#username}. |

---

##### `password`<sup>Optional</sup> <a name="password" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}.

---

##### `username`<sup>Optional</sup> <a name="username" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#username MdbClickhouseCluster#username}.

---

### MdbClickhouseClusterClickhouseResources <a name="MdbClickhouseClusterClickhouseResources" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseResources } from '@cdktf/provider-yandex'

const mdbClickhouseClusterClickhouseResources: MdbClickhouseClusterClickhouseResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}.

---

### MdbClickhouseClusterCloudStorage <a name="MdbClickhouseClusterCloudStorage" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage.Initializer"></a>

```typescript
import { MdbClickhouseClusterCloudStorage } from '@cdktf/provider-yandex'

const mdbClickhouseClusterCloudStorage: MdbClickhouseClusterCloudStorage = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enabled MdbClickhouseCluster#enabled}. |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enabled MdbClickhouseCluster#enabled}.

---

### MdbClickhouseClusterConfig <a name="MdbClickhouseClusterConfig" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.Initializer"></a>

```typescript
import { MdbClickhouseClusterConfig } from '@cdktf/provider-yandex'

const mdbClickhouseClusterConfig: MdbClickhouseClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.clickhouse">clickhouse</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a></code> | clickhouse block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#environment MdbClickhouseCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#network_id MdbClickhouseCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.adminPassword">adminPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#admin_password MdbClickhouseCluster#admin_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.cloudStorage">cloudStorage</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a></code> | cloud_storage block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.copySchemaOnNewHosts">copySchemaOnNewHosts</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#copy_schema_on_new_hosts MdbClickhouseCluster#copy_schema_on_new_hosts}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.database">database</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]</code> | database block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#deletion_protection MdbClickhouseCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.embeddedKeeper">embeddedKeeper</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#embedded_keeper MdbClickhouseCluster#embedded_keeper}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#folder_id MdbClickhouseCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.formatSchema">formatSchema</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]</code> | format_schema block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#id MdbClickhouseCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#labels MdbClickhouseCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.mlModel">mlModel</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]</code> | ml_model block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_group_ids MdbClickhouseCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#service_account_id MdbClickhouseCluster#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.shardGroup">shardGroup</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]</code> | shard_group block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.sqlDatabaseManagement">sqlDatabaseManagement</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_database_management MdbClickhouseCluster#sql_database_management}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.sqlUserManagement">sqlUserManagement</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_user_management MdbClickhouseCluster#sql_user_management}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]</code> | user block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#version MdbClickhouseCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a></code> | zookeeper block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clickhouse`<sup>Required</sup> <a name="clickhouse" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.clickhouse"></a>

```typescript
public readonly clickhouse: MdbClickhouseClusterClickhouse;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a>

clickhouse block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#clickhouse MdbClickhouseCluster#clickhouse}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#environment MdbClickhouseCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbClickhouseClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#host MdbClickhouseCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#network_id MdbClickhouseCluster#network_id}.

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.access"></a>

```typescript
public readonly access: MdbClickhouseClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#access MdbClickhouseCluster#access}

---

##### `adminPassword`<sup>Optional</sup> <a name="adminPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.adminPassword"></a>

```typescript
public readonly adminPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#admin_password MdbClickhouseCluster#admin_password}.

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbClickhouseClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#backup_window_start MdbClickhouseCluster#backup_window_start}

---

##### `cloudStorage`<sup>Optional</sup> <a name="cloudStorage" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.cloudStorage"></a>

```typescript
public readonly cloudStorage: MdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a>

cloud_storage block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#cloud_storage MdbClickhouseCluster#cloud_storage}

---

##### `copySchemaOnNewHosts`<sup>Optional</sup> <a name="copySchemaOnNewHosts" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.copySchemaOnNewHosts"></a>

```typescript
public readonly copySchemaOnNewHosts: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#copy_schema_on_new_hosts MdbClickhouseCluster#copy_schema_on_new_hosts}.

---

##### `database`<sup>Optional</sup> <a name="database" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.database"></a>

```typescript
public readonly database: IResolvable | MdbClickhouseClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]

database block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#database MdbClickhouseCluster#database}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#deletion_protection MdbClickhouseCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}.

---

##### `embeddedKeeper`<sup>Optional</sup> <a name="embeddedKeeper" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.embeddedKeeper"></a>

```typescript
public readonly embeddedKeeper: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#embedded_keeper MdbClickhouseCluster#embedded_keeper}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#folder_id MdbClickhouseCluster#folder_id}.

---

##### `formatSchema`<sup>Optional</sup> <a name="formatSchema" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.formatSchema"></a>

```typescript
public readonly formatSchema: IResolvable | MdbClickhouseClusterFormatSchema[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]

format_schema block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#format_schema MdbClickhouseCluster#format_schema}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#id MdbClickhouseCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#labels MdbClickhouseCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbClickhouseClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#maintenance_window MdbClickhouseCluster#maintenance_window}

---

##### `mlModel`<sup>Optional</sup> <a name="mlModel" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.mlModel"></a>

```typescript
public readonly mlModel: IResolvable | MdbClickhouseClusterMlModel[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]

ml_model block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#ml_model MdbClickhouseCluster#ml_model}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#security_group_ids MdbClickhouseCluster#security_group_ids}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#service_account_id MdbClickhouseCluster#service_account_id}.

---

##### `shardGroup`<sup>Optional</sup> <a name="shardGroup" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.shardGroup"></a>

```typescript
public readonly shardGroup: IResolvable | MdbClickhouseClusterShardGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]

shard_group block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_group MdbClickhouseCluster#shard_group}

---

##### `sqlDatabaseManagement`<sup>Optional</sup> <a name="sqlDatabaseManagement" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.sqlDatabaseManagement"></a>

```typescript
public readonly sqlDatabaseManagement: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_database_management MdbClickhouseCluster#sql_database_management}.

---

##### `sqlUserManagement`<sup>Optional</sup> <a name="sqlUserManagement" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.sqlUserManagement"></a>

```typescript
public readonly sqlUserManagement: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sql_user_management MdbClickhouseCluster#sql_user_management}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbClickhouseClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timeouts MdbClickhouseCluster#timeouts}

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbClickhouseClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#user MdbClickhouseCluster#user}

---

##### `version`<sup>Optional</sup> <a name="version" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#version MdbClickhouseCluster#version}.

---

##### `zookeeper`<sup>Optional</sup> <a name="zookeeper" id="@cdktf/provider-yandex.MdbClickhouseClusterConfig.property.zookeeper"></a>

```typescript
public readonly zookeeper: MdbClickhouseClusterZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a>

zookeeper block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#zookeeper MdbClickhouseCluster#zookeeper}

---

### MdbClickhouseClusterDatabase <a name="MdbClickhouseClusterDatabase" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabase.Initializer"></a>

```typescript
import { MdbClickhouseClusterDatabase } from '@cdktf/provider-yandex'

const mdbClickhouseClusterDatabase: MdbClickhouseClusterDatabase = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

### MdbClickhouseClusterFormatSchema <a name="MdbClickhouseClusterFormatSchema" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.Initializer"></a>

```typescript
import { MdbClickhouseClusterFormatSchema } from '@cdktf/provider-yandex'

const mdbClickhouseClusterFormatSchema: MdbClickhouseClusterFormatSchema = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.uri">uri</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}.

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}.

---

### MdbClickhouseClusterHost <a name="MdbClickhouseClusterHost" id="@cdktf/provider-yandex.MdbClickhouseClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.Initializer"></a>

```typescript
import { MdbClickhouseClusterHost } from '@cdktf/provider-yandex'

const mdbClickhouseClusterHost: MdbClickhouseClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#zone MdbClickhouseCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#assign_public_ip MdbClickhouseCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost.property.shardName">shardName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_name MdbClickhouseCluster#shard_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#subnet_id MdbClickhouseCluster#subnet_id}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}.

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#zone MdbClickhouseCluster#zone}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#assign_public_ip MdbClickhouseCluster#assign_public_ip}.

---

##### `shardName`<sup>Optional</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_name MdbClickhouseCluster#shard_name}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbClickhouseClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#subnet_id MdbClickhouseCluster#subnet_id}.

---

### MdbClickhouseClusterMaintenanceWindow <a name="MdbClickhouseClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbClickhouseClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbClickhouseClusterMaintenanceWindow: MdbClickhouseClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#day MdbClickhouseCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hour MdbClickhouseCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#day MdbClickhouseCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#hour MdbClickhouseCluster#hour}.

---

### MdbClickhouseClusterMlModel <a name="MdbClickhouseClusterMlModel" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModel"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModel.Initializer"></a>

```typescript
import { MdbClickhouseClusterMlModel } from '@cdktf/provider-yandex'

const mdbClickhouseClusterMlModel: MdbClickhouseClusterMlModel = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.uri">uri</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#type MdbClickhouseCluster#type}.

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModel.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#uri MdbClickhouseCluster#uri}.

---

### MdbClickhouseClusterShardGroup <a name="MdbClickhouseClusterShardGroup" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroup"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.Initializer"></a>

```typescript
import { MdbClickhouseClusterShardGroup } from '@cdktf/provider-yandex'

const mdbClickhouseClusterShardGroup: MdbClickhouseClusterShardGroup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.shardNames">shardNames</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_names MdbClickhouseCluster#shard_names}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `shardNames`<sup>Required</sup> <a name="shardNames" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.shardNames"></a>

```typescript
public readonly shardNames: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#shard_names MdbClickhouseCluster#shard_names}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroup.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#description MdbClickhouseCluster#description}.

---

### MdbClickhouseClusterTimeouts <a name="MdbClickhouseClusterTimeouts" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.Initializer"></a>

```typescript
import { MdbClickhouseClusterTimeouts } from '@cdktf/provider-yandex'

const mdbClickhouseClusterTimeouts: MdbClickhouseClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#create MdbClickhouseCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#delete MdbClickhouseCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#update MdbClickhouseCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#create MdbClickhouseCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#delete MdbClickhouseCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#update MdbClickhouseCluster#update}.

---

### MdbClickhouseClusterUser <a name="MdbClickhouseClusterUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.Initializer"></a>

```typescript
import { MdbClickhouseClusterUser } from '@cdktf/provider-yandex'

const mdbClickhouseClusterUser: MdbClickhouseClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]</code> | permission block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser.property.quota">quota</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]</code> | quota block. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a></code> | settings block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#name MdbClickhouseCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#password MdbClickhouseCluster#password}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbClickhouseClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#permission MdbClickhouseCluster#permission}

---

##### `quota`<sup>Optional</sup> <a name="quota" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.property.quota"></a>

```typescript
public readonly quota: IResolvable | MdbClickhouseClusterUserQuota[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]

quota block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#quota MdbClickhouseCluster#quota}

---

##### `settings`<sup>Optional</sup> <a name="settings" id="@cdktf/provider-yandex.MdbClickhouseClusterUser.property.settings"></a>

```typescript
public readonly settings: MdbClickhouseClusterUserSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a>

settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#settings MdbClickhouseCluster#settings}

---

### MdbClickhouseClusterUserPermission <a name="MdbClickhouseClusterUserPermission" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermission.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserPermission } from '@cdktf/provider-yandex'

const mdbClickhouseClusterUserPermission: MdbClickhouseClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission.property.databaseName">databaseName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#database_name MdbClickhouseCluster#database_name}. |

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermission.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#database_name MdbClickhouseCluster#database_name}.

---

### MdbClickhouseClusterUserQuota <a name="MdbClickhouseClusterUserQuota" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserQuota } from '@cdktf/provider-yandex'

const mdbClickhouseClusterUserQuota: MdbClickhouseClusterUserQuota = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.intervalDuration">intervalDuration</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#interval_duration MdbClickhouseCluster#interval_duration}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.errors">errors</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#errors MdbClickhouseCluster#errors}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.executionTime">executionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#execution_time MdbClickhouseCluster#execution_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.queries">queries</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#queries MdbClickhouseCluster#queries}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.readRows">readRows</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_rows MdbClickhouseCluster#read_rows}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.resultRows">resultRows</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_rows MdbClickhouseCluster#result_rows}. |

---

##### `intervalDuration`<sup>Required</sup> <a name="intervalDuration" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.intervalDuration"></a>

```typescript
public readonly intervalDuration: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#interval_duration MdbClickhouseCluster#interval_duration}.

---

##### `errors`<sup>Optional</sup> <a name="errors" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.errors"></a>

```typescript
public readonly errors: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#errors MdbClickhouseCluster#errors}.

---

##### `executionTime`<sup>Optional</sup> <a name="executionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.executionTime"></a>

```typescript
public readonly executionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#execution_time MdbClickhouseCluster#execution_time}.

---

##### `queries`<sup>Optional</sup> <a name="queries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.queries"></a>

```typescript
public readonly queries: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#queries MdbClickhouseCluster#queries}.

---

##### `readRows`<sup>Optional</sup> <a name="readRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.readRows"></a>

```typescript
public readonly readRows: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_rows MdbClickhouseCluster#read_rows}.

---

##### `resultRows`<sup>Optional</sup> <a name="resultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuota.property.resultRows"></a>

```typescript
public readonly resultRows: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_rows MdbClickhouseCluster#result_rows}.

---

### MdbClickhouseClusterUserSettings <a name="MdbClickhouseClusterUserSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserSettings } from '@cdktf/provider-yandex'

const mdbClickhouseClusterUserSettings: MdbClickhouseClusterUserSettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.addHttpCorsHeader">addHttpCorsHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#add_http_cors_header MdbClickhouseCluster#add_http_cors_header}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.allowDdl">allowDdl</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#allow_ddl MdbClickhouseCluster#allow_ddl}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.compile">compile</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile MdbClickhouseCluster#compile}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.compileExpressions">compileExpressions</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile_expressions MdbClickhouseCluster#compile_expressions}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.connectTimeout">connectTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#connect_timeout MdbClickhouseCluster#connect_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.countDistinctImplementation">countDistinctImplementation</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#count_distinct_implementation MdbClickhouseCluster#count_distinct_implementation}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distinctOverflowMode">distinctOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distinct_overflow_mode MdbClickhouseCluster#distinct_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedAggregationMemoryEfficient">distributedAggregationMemoryEfficient</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_aggregation_memory_efficient MdbClickhouseCluster#distributed_aggregation_memory_efficient}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedDdlTaskTimeout">distributedDdlTaskTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_ddl_task_timeout MdbClickhouseCluster#distributed_ddl_task_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedProductMode">distributedProductMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_product_mode MdbClickhouseCluster#distributed_product_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.emptyResultForAggregationByEmptySet">emptyResultForAggregationByEmptySet</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#empty_result_for_aggregation_by_empty_set MdbClickhouseCluster#empty_result_for_aggregation_by_empty_set}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.enableHttpCompression">enableHttpCompression</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enable_http_compression MdbClickhouseCluster#enable_http_compression}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.fallbackToStaleReplicasForDistributedQueries">fallbackToStaleReplicasForDistributedQueries</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#fallback_to_stale_replicas_for_distributed_queries MdbClickhouseCluster#fallback_to_stale_replicas_for_distributed_queries}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.forceIndexByDate">forceIndexByDate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_index_by_date MdbClickhouseCluster#force_index_by_date}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.forcePrimaryKey">forcePrimaryKey</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_primary_key MdbClickhouseCluster#force_primary_key}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByOverflowMode">groupByOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_overflow_mode MdbClickhouseCluster#group_by_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByTwoLevelThreshold">groupByTwoLevelThreshold</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold MdbClickhouseCluster#group_by_two_level_threshold}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByTwoLevelThresholdBytes">groupByTwoLevelThresholdBytes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold_bytes MdbClickhouseCluster#group_by_two_level_threshold_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpConnectionTimeout">httpConnectionTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_connection_timeout MdbClickhouseCluster#http_connection_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpHeadersProgressInterval">httpHeadersProgressInterval</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_headers_progress_interval MdbClickhouseCluster#http_headers_progress_interval}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpReceiveTimeout">httpReceiveTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_receive_timeout MdbClickhouseCluster#http_receive_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpSendTimeout">httpSendTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_send_timeout MdbClickhouseCluster#http_send_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.inputFormatDefaultsForOmittedFields">inputFormatDefaultsForOmittedFields</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_defaults_for_omitted_fields MdbClickhouseCluster#input_format_defaults_for_omitted_fields}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.inputFormatValuesInterpretExpressions">inputFormatValuesInterpretExpressions</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_values_interpret_expressions MdbClickhouseCluster#input_format_values_interpret_expressions}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.insertQuorum">insertQuorum</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum MdbClickhouseCluster#insert_quorum}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.insertQuorumTimeout">insertQuorumTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum_timeout MdbClickhouseCluster#insert_quorum_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinedSubqueryRequiresAlias">joinedSubqueryRequiresAlias</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#joined_subquery_requires_alias MdbClickhouseCluster#joined_subquery_requires_alias}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinOverflowMode">joinOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_overflow_mode MdbClickhouseCluster#join_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinUseNulls">joinUseNulls</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_use_nulls MdbClickhouseCluster#join_use_nulls}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.lowCardinalityAllowInNativeFormat">lowCardinalityAllowInNativeFormat</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#low_cardinality_allow_in_native_format MdbClickhouseCluster#low_cardinality_allow_in_native_format}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxAstDepth">maxAstDepth</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_depth MdbClickhouseCluster#max_ast_depth}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxAstElements">maxAstElements</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_elements MdbClickhouseCluster#max_ast_elements}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBlockSize">maxBlockSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_block_size MdbClickhouseCluster#max_block_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesBeforeExternalGroupBy">maxBytesBeforeExternalGroupBy</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_group_by MdbClickhouseCluster#max_bytes_before_external_group_by}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesBeforeExternalSort">maxBytesBeforeExternalSort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_sort MdbClickhouseCluster#max_bytes_before_external_sort}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInDistinct">maxBytesInDistinct</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_distinct MdbClickhouseCluster#max_bytes_in_distinct}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInJoin">maxBytesInJoin</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_join MdbClickhouseCluster#max_bytes_in_join}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInSet">maxBytesInSet</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_set MdbClickhouseCluster#max_bytes_in_set}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToRead">maxBytesToRead</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_read MdbClickhouseCluster#max_bytes_to_read}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToSort">maxBytesToSort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_sort MdbClickhouseCluster#max_bytes_to_sort}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToTransfer">maxBytesToTransfer</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_transfer MdbClickhouseCluster#max_bytes_to_transfer}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxColumnsToRead">maxColumnsToRead</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_columns_to_read MdbClickhouseCluster#max_columns_to_read}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxExecutionTime">maxExecutionTime</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_execution_time MdbClickhouseCluster#max_execution_time}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxExpandedAstElements">maxExpandedAstElements</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_expanded_ast_elements MdbClickhouseCluster#max_expanded_ast_elements}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxInsertBlockSize">maxInsertBlockSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_insert_block_size MdbClickhouseCluster#max_insert_block_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxMemoryUsage">maxMemoryUsage</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage MdbClickhouseCluster#max_memory_usage}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxMemoryUsageForUser">maxMemoryUsageForUser</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage_for_user MdbClickhouseCluster#max_memory_usage_for_user}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxNetworkBandwidth">maxNetworkBandwidth</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth MdbClickhouseCluster#max_network_bandwidth}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxNetworkBandwidthForUser">maxNetworkBandwidthForUser</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth_for_user MdbClickhouseCluster#max_network_bandwidth_for_user}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxQuerySize">maxQuerySize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_query_size MdbClickhouseCluster#max_query_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxReplicaDelayForDistributedQueries">maxReplicaDelayForDistributedQueries</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replica_delay_for_distributed_queries MdbClickhouseCluster#max_replica_delay_for_distributed_queries}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxResultBytes">maxResultBytes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_bytes MdbClickhouseCluster#max_result_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxResultRows">maxResultRows</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_rows MdbClickhouseCluster#max_result_rows}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInDistinct">maxRowsInDistinct</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_distinct MdbClickhouseCluster#max_rows_in_distinct}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInJoin">maxRowsInJoin</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_join MdbClickhouseCluster#max_rows_in_join}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInSet">maxRowsInSet</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_set MdbClickhouseCluster#max_rows_in_set}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToGroupBy">maxRowsToGroupBy</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_group_by MdbClickhouseCluster#max_rows_to_group_by}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToRead">maxRowsToRead</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_read MdbClickhouseCluster#max_rows_to_read}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToSort">maxRowsToSort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_sort MdbClickhouseCluster#max_rows_to_sort}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToTransfer">maxRowsToTransfer</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_transfer MdbClickhouseCluster#max_rows_to_transfer}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxTemporaryColumns">maxTemporaryColumns</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_columns MdbClickhouseCluster#max_temporary_columns}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxTemporaryNonConstColumns">maxTemporaryNonConstColumns</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_non_const_columns MdbClickhouseCluster#max_temporary_non_const_columns}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxThreads">maxThreads</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_threads MdbClickhouseCluster#max_threads}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMaxBytesToUseCache">mergeTreeMaxBytesToUseCache</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_bytes_to_use_cache MdbClickhouseCluster#merge_tree_max_bytes_to_use_cache}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMaxRowsToUseCache">mergeTreeMaxRowsToUseCache</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_rows_to_use_cache MdbClickhouseCluster#merge_tree_max_rows_to_use_cache}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMinBytesForConcurrentRead">mergeTreeMinBytesForConcurrentRead</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_bytes_for_concurrent_read MdbClickhouseCluster#merge_tree_min_bytes_for_concurrent_read}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMinRowsForConcurrentRead">mergeTreeMinRowsForConcurrentRead</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_rows_for_concurrent_read MdbClickhouseCluster#merge_tree_min_rows_for_concurrent_read}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minBytesToUseDirectIo">minBytesToUseDirectIo</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_bytes_to_use_direct_io MdbClickhouseCluster#min_bytes_to_use_direct_io}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minCountToCompile">minCountToCompile</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile MdbClickhouseCluster#min_count_to_compile}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minCountToCompileExpression">minCountToCompileExpression</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile_expression MdbClickhouseCluster#min_count_to_compile_expression}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minExecutionSpeed">minExecutionSpeed</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed MdbClickhouseCluster#min_execution_speed}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minExecutionSpeedBytes">minExecutionSpeedBytes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed_bytes MdbClickhouseCluster#min_execution_speed_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minInsertBlockSizeBytes">minInsertBlockSizeBytes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_bytes MdbClickhouseCluster#min_insert_block_size_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minInsertBlockSizeRows">minInsertBlockSizeRows</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_rows MdbClickhouseCluster#min_insert_block_size_rows}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.outputFormatJsonQuote64BitIntegers">outputFormatJsonQuote64BitIntegers</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_64bit_integers MdbClickhouseCluster#output_format_json_quote_64bit_integers}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.outputFormatJsonQuoteDenormals">outputFormatJsonQuoteDenormals</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_denormals MdbClickhouseCluster#output_format_json_quote_denormals}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.priority">priority</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#priority MdbClickhouseCluster#priority}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.quotaMode">quotaMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#quota_mode MdbClickhouseCluster#quota_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.readonly">readonly</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#readonly MdbClickhouseCluster#readonly}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.readOverflowMode">readOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_overflow_mode MdbClickhouseCluster#read_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.receiveTimeout">receiveTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#receive_timeout MdbClickhouseCluster#receive_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.replicationAlterPartitionsSync">replicationAlterPartitionsSync</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replication_alter_partitions_sync MdbClickhouseCluster#replication_alter_partitions_sync}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.resultOverflowMode">resultOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_overflow_mode MdbClickhouseCluster#result_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.selectSequentialConsistency">selectSequentialConsistency</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#select_sequential_consistency MdbClickhouseCluster#select_sequential_consistency}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sendProgressInHttpHeaders">sendProgressInHttpHeaders</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_progress_in_http_headers MdbClickhouseCluster#send_progress_in_http_headers}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sendTimeout">sendTimeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_timeout MdbClickhouseCluster#send_timeout}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.setOverflowMode">setOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#set_overflow_mode MdbClickhouseCluster#set_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.skipUnavailableShards">skipUnavailableShards</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#skip_unavailable_shards MdbClickhouseCluster#skip_unavailable_shards}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sortOverflowMode">sortOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sort_overflow_mode MdbClickhouseCluster#sort_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.timeoutOverflowMode">timeoutOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timeout_overflow_mode MdbClickhouseCluster#timeout_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.transferOverflowMode">transferOverflowMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transfer_overflow_mode MdbClickhouseCluster#transfer_overflow_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.transformNullIn">transformNullIn</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transform_null_in MdbClickhouseCluster#transform_null_in}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.useUncompressedCache">useUncompressedCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#use_uncompressed_cache MdbClickhouseCluster#use_uncompressed_cache}. |

---

##### `addHttpCorsHeader`<sup>Optional</sup> <a name="addHttpCorsHeader" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.addHttpCorsHeader"></a>

```typescript
public readonly addHttpCorsHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#add_http_cors_header MdbClickhouseCluster#add_http_cors_header}.

---

##### `allowDdl`<sup>Optional</sup> <a name="allowDdl" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.allowDdl"></a>

```typescript
public readonly allowDdl: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#allow_ddl MdbClickhouseCluster#allow_ddl}.

---

##### `compile`<sup>Optional</sup> <a name="compile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.compile"></a>

```typescript
public readonly compile: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile MdbClickhouseCluster#compile}.

---

##### `compileExpressions`<sup>Optional</sup> <a name="compileExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.compileExpressions"></a>

```typescript
public readonly compileExpressions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#compile_expressions MdbClickhouseCluster#compile_expressions}.

---

##### `connectTimeout`<sup>Optional</sup> <a name="connectTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.connectTimeout"></a>

```typescript
public readonly connectTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#connect_timeout MdbClickhouseCluster#connect_timeout}.

---

##### `countDistinctImplementation`<sup>Optional</sup> <a name="countDistinctImplementation" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.countDistinctImplementation"></a>

```typescript
public readonly countDistinctImplementation: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#count_distinct_implementation MdbClickhouseCluster#count_distinct_implementation}.

---

##### `distinctOverflowMode`<sup>Optional</sup> <a name="distinctOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distinctOverflowMode"></a>

```typescript
public readonly distinctOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distinct_overflow_mode MdbClickhouseCluster#distinct_overflow_mode}.

---

##### `distributedAggregationMemoryEfficient`<sup>Optional</sup> <a name="distributedAggregationMemoryEfficient" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedAggregationMemoryEfficient"></a>

```typescript
public readonly distributedAggregationMemoryEfficient: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_aggregation_memory_efficient MdbClickhouseCluster#distributed_aggregation_memory_efficient}.

---

##### `distributedDdlTaskTimeout`<sup>Optional</sup> <a name="distributedDdlTaskTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedDdlTaskTimeout"></a>

```typescript
public readonly distributedDdlTaskTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_ddl_task_timeout MdbClickhouseCluster#distributed_ddl_task_timeout}.

---

##### `distributedProductMode`<sup>Optional</sup> <a name="distributedProductMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.distributedProductMode"></a>

```typescript
public readonly distributedProductMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#distributed_product_mode MdbClickhouseCluster#distributed_product_mode}.

---

##### `emptyResultForAggregationByEmptySet`<sup>Optional</sup> <a name="emptyResultForAggregationByEmptySet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.emptyResultForAggregationByEmptySet"></a>

```typescript
public readonly emptyResultForAggregationByEmptySet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#empty_result_for_aggregation_by_empty_set MdbClickhouseCluster#empty_result_for_aggregation_by_empty_set}.

---

##### `enableHttpCompression`<sup>Optional</sup> <a name="enableHttpCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.enableHttpCompression"></a>

```typescript
public readonly enableHttpCompression: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#enable_http_compression MdbClickhouseCluster#enable_http_compression}.

---

##### `fallbackToStaleReplicasForDistributedQueries`<sup>Optional</sup> <a name="fallbackToStaleReplicasForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.fallbackToStaleReplicasForDistributedQueries"></a>

```typescript
public readonly fallbackToStaleReplicasForDistributedQueries: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#fallback_to_stale_replicas_for_distributed_queries MdbClickhouseCluster#fallback_to_stale_replicas_for_distributed_queries}.

---

##### `forceIndexByDate`<sup>Optional</sup> <a name="forceIndexByDate" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.forceIndexByDate"></a>

```typescript
public readonly forceIndexByDate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_index_by_date MdbClickhouseCluster#force_index_by_date}.

---

##### `forcePrimaryKey`<sup>Optional</sup> <a name="forcePrimaryKey" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.forcePrimaryKey"></a>

```typescript
public readonly forcePrimaryKey: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#force_primary_key MdbClickhouseCluster#force_primary_key}.

---

##### `groupByOverflowMode`<sup>Optional</sup> <a name="groupByOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByOverflowMode"></a>

```typescript
public readonly groupByOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_overflow_mode MdbClickhouseCluster#group_by_overflow_mode}.

---

##### `groupByTwoLevelThreshold`<sup>Optional</sup> <a name="groupByTwoLevelThreshold" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByTwoLevelThreshold"></a>

```typescript
public readonly groupByTwoLevelThreshold: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold MdbClickhouseCluster#group_by_two_level_threshold}.

---

##### `groupByTwoLevelThresholdBytes`<sup>Optional</sup> <a name="groupByTwoLevelThresholdBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.groupByTwoLevelThresholdBytes"></a>

```typescript
public readonly groupByTwoLevelThresholdBytes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#group_by_two_level_threshold_bytes MdbClickhouseCluster#group_by_two_level_threshold_bytes}.

---

##### `httpConnectionTimeout`<sup>Optional</sup> <a name="httpConnectionTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpConnectionTimeout"></a>

```typescript
public readonly httpConnectionTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_connection_timeout MdbClickhouseCluster#http_connection_timeout}.

---

##### `httpHeadersProgressInterval`<sup>Optional</sup> <a name="httpHeadersProgressInterval" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpHeadersProgressInterval"></a>

```typescript
public readonly httpHeadersProgressInterval: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_headers_progress_interval MdbClickhouseCluster#http_headers_progress_interval}.

---

##### `httpReceiveTimeout`<sup>Optional</sup> <a name="httpReceiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpReceiveTimeout"></a>

```typescript
public readonly httpReceiveTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_receive_timeout MdbClickhouseCluster#http_receive_timeout}.

---

##### `httpSendTimeout`<sup>Optional</sup> <a name="httpSendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.httpSendTimeout"></a>

```typescript
public readonly httpSendTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#http_send_timeout MdbClickhouseCluster#http_send_timeout}.

---

##### `inputFormatDefaultsForOmittedFields`<sup>Optional</sup> <a name="inputFormatDefaultsForOmittedFields" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.inputFormatDefaultsForOmittedFields"></a>

```typescript
public readonly inputFormatDefaultsForOmittedFields: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_defaults_for_omitted_fields MdbClickhouseCluster#input_format_defaults_for_omitted_fields}.

---

##### `inputFormatValuesInterpretExpressions`<sup>Optional</sup> <a name="inputFormatValuesInterpretExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.inputFormatValuesInterpretExpressions"></a>

```typescript
public readonly inputFormatValuesInterpretExpressions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#input_format_values_interpret_expressions MdbClickhouseCluster#input_format_values_interpret_expressions}.

---

##### `insertQuorum`<sup>Optional</sup> <a name="insertQuorum" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.insertQuorum"></a>

```typescript
public readonly insertQuorum: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum MdbClickhouseCluster#insert_quorum}.

---

##### `insertQuorumTimeout`<sup>Optional</sup> <a name="insertQuorumTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.insertQuorumTimeout"></a>

```typescript
public readonly insertQuorumTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#insert_quorum_timeout MdbClickhouseCluster#insert_quorum_timeout}.

---

##### `joinedSubqueryRequiresAlias`<sup>Optional</sup> <a name="joinedSubqueryRequiresAlias" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinedSubqueryRequiresAlias"></a>

```typescript
public readonly joinedSubqueryRequiresAlias: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#joined_subquery_requires_alias MdbClickhouseCluster#joined_subquery_requires_alias}.

---

##### `joinOverflowMode`<sup>Optional</sup> <a name="joinOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinOverflowMode"></a>

```typescript
public readonly joinOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_overflow_mode MdbClickhouseCluster#join_overflow_mode}.

---

##### `joinUseNulls`<sup>Optional</sup> <a name="joinUseNulls" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.joinUseNulls"></a>

```typescript
public readonly joinUseNulls: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#join_use_nulls MdbClickhouseCluster#join_use_nulls}.

---

##### `lowCardinalityAllowInNativeFormat`<sup>Optional</sup> <a name="lowCardinalityAllowInNativeFormat" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.lowCardinalityAllowInNativeFormat"></a>

```typescript
public readonly lowCardinalityAllowInNativeFormat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#low_cardinality_allow_in_native_format MdbClickhouseCluster#low_cardinality_allow_in_native_format}.

---

##### `maxAstDepth`<sup>Optional</sup> <a name="maxAstDepth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxAstDepth"></a>

```typescript
public readonly maxAstDepth: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_depth MdbClickhouseCluster#max_ast_depth}.

---

##### `maxAstElements`<sup>Optional</sup> <a name="maxAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxAstElements"></a>

```typescript
public readonly maxAstElements: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_ast_elements MdbClickhouseCluster#max_ast_elements}.

---

##### `maxBlockSize`<sup>Optional</sup> <a name="maxBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBlockSize"></a>

```typescript
public readonly maxBlockSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_block_size MdbClickhouseCluster#max_block_size}.

---

##### `maxBytesBeforeExternalGroupBy`<sup>Optional</sup> <a name="maxBytesBeforeExternalGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesBeforeExternalGroupBy"></a>

```typescript
public readonly maxBytesBeforeExternalGroupBy: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_group_by MdbClickhouseCluster#max_bytes_before_external_group_by}.

---

##### `maxBytesBeforeExternalSort`<sup>Optional</sup> <a name="maxBytesBeforeExternalSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesBeforeExternalSort"></a>

```typescript
public readonly maxBytesBeforeExternalSort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_before_external_sort MdbClickhouseCluster#max_bytes_before_external_sort}.

---

##### `maxBytesInDistinct`<sup>Optional</sup> <a name="maxBytesInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInDistinct"></a>

```typescript
public readonly maxBytesInDistinct: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_distinct MdbClickhouseCluster#max_bytes_in_distinct}.

---

##### `maxBytesInJoin`<sup>Optional</sup> <a name="maxBytesInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInJoin"></a>

```typescript
public readonly maxBytesInJoin: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_join MdbClickhouseCluster#max_bytes_in_join}.

---

##### `maxBytesInSet`<sup>Optional</sup> <a name="maxBytesInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesInSet"></a>

```typescript
public readonly maxBytesInSet: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_in_set MdbClickhouseCluster#max_bytes_in_set}.

---

##### `maxBytesToRead`<sup>Optional</sup> <a name="maxBytesToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToRead"></a>

```typescript
public readonly maxBytesToRead: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_read MdbClickhouseCluster#max_bytes_to_read}.

---

##### `maxBytesToSort`<sup>Optional</sup> <a name="maxBytesToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToSort"></a>

```typescript
public readonly maxBytesToSort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_sort MdbClickhouseCluster#max_bytes_to_sort}.

---

##### `maxBytesToTransfer`<sup>Optional</sup> <a name="maxBytesToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxBytesToTransfer"></a>

```typescript
public readonly maxBytesToTransfer: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_bytes_to_transfer MdbClickhouseCluster#max_bytes_to_transfer}.

---

##### `maxColumnsToRead`<sup>Optional</sup> <a name="maxColumnsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxColumnsToRead"></a>

```typescript
public readonly maxColumnsToRead: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_columns_to_read MdbClickhouseCluster#max_columns_to_read}.

---

##### `maxExecutionTime`<sup>Optional</sup> <a name="maxExecutionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxExecutionTime"></a>

```typescript
public readonly maxExecutionTime: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_execution_time MdbClickhouseCluster#max_execution_time}.

---

##### `maxExpandedAstElements`<sup>Optional</sup> <a name="maxExpandedAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxExpandedAstElements"></a>

```typescript
public readonly maxExpandedAstElements: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_expanded_ast_elements MdbClickhouseCluster#max_expanded_ast_elements}.

---

##### `maxInsertBlockSize`<sup>Optional</sup> <a name="maxInsertBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxInsertBlockSize"></a>

```typescript
public readonly maxInsertBlockSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_insert_block_size MdbClickhouseCluster#max_insert_block_size}.

---

##### `maxMemoryUsage`<sup>Optional</sup> <a name="maxMemoryUsage" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxMemoryUsage"></a>

```typescript
public readonly maxMemoryUsage: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage MdbClickhouseCluster#max_memory_usage}.

---

##### `maxMemoryUsageForUser`<sup>Optional</sup> <a name="maxMemoryUsageForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxMemoryUsageForUser"></a>

```typescript
public readonly maxMemoryUsageForUser: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_memory_usage_for_user MdbClickhouseCluster#max_memory_usage_for_user}.

---

##### `maxNetworkBandwidth`<sup>Optional</sup> <a name="maxNetworkBandwidth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxNetworkBandwidth"></a>

```typescript
public readonly maxNetworkBandwidth: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth MdbClickhouseCluster#max_network_bandwidth}.

---

##### `maxNetworkBandwidthForUser`<sup>Optional</sup> <a name="maxNetworkBandwidthForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxNetworkBandwidthForUser"></a>

```typescript
public readonly maxNetworkBandwidthForUser: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_network_bandwidth_for_user MdbClickhouseCluster#max_network_bandwidth_for_user}.

---

##### `maxQuerySize`<sup>Optional</sup> <a name="maxQuerySize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxQuerySize"></a>

```typescript
public readonly maxQuerySize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_query_size MdbClickhouseCluster#max_query_size}.

---

##### `maxReplicaDelayForDistributedQueries`<sup>Optional</sup> <a name="maxReplicaDelayForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxReplicaDelayForDistributedQueries"></a>

```typescript
public readonly maxReplicaDelayForDistributedQueries: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_replica_delay_for_distributed_queries MdbClickhouseCluster#max_replica_delay_for_distributed_queries}.

---

##### `maxResultBytes`<sup>Optional</sup> <a name="maxResultBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxResultBytes"></a>

```typescript
public readonly maxResultBytes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_bytes MdbClickhouseCluster#max_result_bytes}.

---

##### `maxResultRows`<sup>Optional</sup> <a name="maxResultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxResultRows"></a>

```typescript
public readonly maxResultRows: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_result_rows MdbClickhouseCluster#max_result_rows}.

---

##### `maxRowsInDistinct`<sup>Optional</sup> <a name="maxRowsInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInDistinct"></a>

```typescript
public readonly maxRowsInDistinct: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_distinct MdbClickhouseCluster#max_rows_in_distinct}.

---

##### `maxRowsInJoin`<sup>Optional</sup> <a name="maxRowsInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInJoin"></a>

```typescript
public readonly maxRowsInJoin: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_join MdbClickhouseCluster#max_rows_in_join}.

---

##### `maxRowsInSet`<sup>Optional</sup> <a name="maxRowsInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsInSet"></a>

```typescript
public readonly maxRowsInSet: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_in_set MdbClickhouseCluster#max_rows_in_set}.

---

##### `maxRowsToGroupBy`<sup>Optional</sup> <a name="maxRowsToGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToGroupBy"></a>

```typescript
public readonly maxRowsToGroupBy: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_group_by MdbClickhouseCluster#max_rows_to_group_by}.

---

##### `maxRowsToRead`<sup>Optional</sup> <a name="maxRowsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToRead"></a>

```typescript
public readonly maxRowsToRead: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_read MdbClickhouseCluster#max_rows_to_read}.

---

##### `maxRowsToSort`<sup>Optional</sup> <a name="maxRowsToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToSort"></a>

```typescript
public readonly maxRowsToSort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_sort MdbClickhouseCluster#max_rows_to_sort}.

---

##### `maxRowsToTransfer`<sup>Optional</sup> <a name="maxRowsToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxRowsToTransfer"></a>

```typescript
public readonly maxRowsToTransfer: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_rows_to_transfer MdbClickhouseCluster#max_rows_to_transfer}.

---

##### `maxTemporaryColumns`<sup>Optional</sup> <a name="maxTemporaryColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxTemporaryColumns"></a>

```typescript
public readonly maxTemporaryColumns: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_columns MdbClickhouseCluster#max_temporary_columns}.

---

##### `maxTemporaryNonConstColumns`<sup>Optional</sup> <a name="maxTemporaryNonConstColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxTemporaryNonConstColumns"></a>

```typescript
public readonly maxTemporaryNonConstColumns: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_temporary_non_const_columns MdbClickhouseCluster#max_temporary_non_const_columns}.

---

##### `maxThreads`<sup>Optional</sup> <a name="maxThreads" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.maxThreads"></a>

```typescript
public readonly maxThreads: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#max_threads MdbClickhouseCluster#max_threads}.

---

##### `mergeTreeMaxBytesToUseCache`<sup>Optional</sup> <a name="mergeTreeMaxBytesToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMaxBytesToUseCache"></a>

```typescript
public readonly mergeTreeMaxBytesToUseCache: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_bytes_to_use_cache MdbClickhouseCluster#merge_tree_max_bytes_to_use_cache}.

---

##### `mergeTreeMaxRowsToUseCache`<sup>Optional</sup> <a name="mergeTreeMaxRowsToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMaxRowsToUseCache"></a>

```typescript
public readonly mergeTreeMaxRowsToUseCache: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_max_rows_to_use_cache MdbClickhouseCluster#merge_tree_max_rows_to_use_cache}.

---

##### `mergeTreeMinBytesForConcurrentRead`<sup>Optional</sup> <a name="mergeTreeMinBytesForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMinBytesForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinBytesForConcurrentRead: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_bytes_for_concurrent_read MdbClickhouseCluster#merge_tree_min_bytes_for_concurrent_read}.

---

##### `mergeTreeMinRowsForConcurrentRead`<sup>Optional</sup> <a name="mergeTreeMinRowsForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.mergeTreeMinRowsForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinRowsForConcurrentRead: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#merge_tree_min_rows_for_concurrent_read MdbClickhouseCluster#merge_tree_min_rows_for_concurrent_read}.

---

##### `minBytesToUseDirectIo`<sup>Optional</sup> <a name="minBytesToUseDirectIo" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minBytesToUseDirectIo"></a>

```typescript
public readonly minBytesToUseDirectIo: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_bytes_to_use_direct_io MdbClickhouseCluster#min_bytes_to_use_direct_io}.

---

##### `minCountToCompile`<sup>Optional</sup> <a name="minCountToCompile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minCountToCompile"></a>

```typescript
public readonly minCountToCompile: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile MdbClickhouseCluster#min_count_to_compile}.

---

##### `minCountToCompileExpression`<sup>Optional</sup> <a name="minCountToCompileExpression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minCountToCompileExpression"></a>

```typescript
public readonly minCountToCompileExpression: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_count_to_compile_expression MdbClickhouseCluster#min_count_to_compile_expression}.

---

##### `minExecutionSpeed`<sup>Optional</sup> <a name="minExecutionSpeed" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minExecutionSpeed"></a>

```typescript
public readonly minExecutionSpeed: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed MdbClickhouseCluster#min_execution_speed}.

---

##### `minExecutionSpeedBytes`<sup>Optional</sup> <a name="minExecutionSpeedBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minExecutionSpeedBytes"></a>

```typescript
public readonly minExecutionSpeedBytes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_execution_speed_bytes MdbClickhouseCluster#min_execution_speed_bytes}.

---

##### `minInsertBlockSizeBytes`<sup>Optional</sup> <a name="minInsertBlockSizeBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minInsertBlockSizeBytes"></a>

```typescript
public readonly minInsertBlockSizeBytes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_bytes MdbClickhouseCluster#min_insert_block_size_bytes}.

---

##### `minInsertBlockSizeRows`<sup>Optional</sup> <a name="minInsertBlockSizeRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.minInsertBlockSizeRows"></a>

```typescript
public readonly minInsertBlockSizeRows: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#min_insert_block_size_rows MdbClickhouseCluster#min_insert_block_size_rows}.

---

##### `outputFormatJsonQuote64BitIntegers`<sup>Optional</sup> <a name="outputFormatJsonQuote64BitIntegers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.outputFormatJsonQuote64BitIntegers"></a>

```typescript
public readonly outputFormatJsonQuote64BitIntegers: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_64bit_integers MdbClickhouseCluster#output_format_json_quote_64bit_integers}.

---

##### `outputFormatJsonQuoteDenormals`<sup>Optional</sup> <a name="outputFormatJsonQuoteDenormals" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.outputFormatJsonQuoteDenormals"></a>

```typescript
public readonly outputFormatJsonQuoteDenormals: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#output_format_json_quote_denormals MdbClickhouseCluster#output_format_json_quote_denormals}.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#priority MdbClickhouseCluster#priority}.

---

##### `quotaMode`<sup>Optional</sup> <a name="quotaMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.quotaMode"></a>

```typescript
public readonly quotaMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#quota_mode MdbClickhouseCluster#quota_mode}.

---

##### `readonly`<sup>Optional</sup> <a name="readonly" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.readonly"></a>

```typescript
public readonly readonly: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#readonly MdbClickhouseCluster#readonly}.

---

##### `readOverflowMode`<sup>Optional</sup> <a name="readOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.readOverflowMode"></a>

```typescript
public readonly readOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#read_overflow_mode MdbClickhouseCluster#read_overflow_mode}.

---

##### `receiveTimeout`<sup>Optional</sup> <a name="receiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.receiveTimeout"></a>

```typescript
public readonly receiveTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#receive_timeout MdbClickhouseCluster#receive_timeout}.

---

##### `replicationAlterPartitionsSync`<sup>Optional</sup> <a name="replicationAlterPartitionsSync" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.replicationAlterPartitionsSync"></a>

```typescript
public readonly replicationAlterPartitionsSync: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#replication_alter_partitions_sync MdbClickhouseCluster#replication_alter_partitions_sync}.

---

##### `resultOverflowMode`<sup>Optional</sup> <a name="resultOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.resultOverflowMode"></a>

```typescript
public readonly resultOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#result_overflow_mode MdbClickhouseCluster#result_overflow_mode}.

---

##### `selectSequentialConsistency`<sup>Optional</sup> <a name="selectSequentialConsistency" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.selectSequentialConsistency"></a>

```typescript
public readonly selectSequentialConsistency: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#select_sequential_consistency MdbClickhouseCluster#select_sequential_consistency}.

---

##### `sendProgressInHttpHeaders`<sup>Optional</sup> <a name="sendProgressInHttpHeaders" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sendProgressInHttpHeaders"></a>

```typescript
public readonly sendProgressInHttpHeaders: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_progress_in_http_headers MdbClickhouseCluster#send_progress_in_http_headers}.

---

##### `sendTimeout`<sup>Optional</sup> <a name="sendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sendTimeout"></a>

```typescript
public readonly sendTimeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#send_timeout MdbClickhouseCluster#send_timeout}.

---

##### `setOverflowMode`<sup>Optional</sup> <a name="setOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.setOverflowMode"></a>

```typescript
public readonly setOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#set_overflow_mode MdbClickhouseCluster#set_overflow_mode}.

---

##### `skipUnavailableShards`<sup>Optional</sup> <a name="skipUnavailableShards" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.skipUnavailableShards"></a>

```typescript
public readonly skipUnavailableShards: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#skip_unavailable_shards MdbClickhouseCluster#skip_unavailable_shards}.

---

##### `sortOverflowMode`<sup>Optional</sup> <a name="sortOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.sortOverflowMode"></a>

```typescript
public readonly sortOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#sort_overflow_mode MdbClickhouseCluster#sort_overflow_mode}.

---

##### `timeoutOverflowMode`<sup>Optional</sup> <a name="timeoutOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.timeoutOverflowMode"></a>

```typescript
public readonly timeoutOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#timeout_overflow_mode MdbClickhouseCluster#timeout_overflow_mode}.

---

##### `transferOverflowMode`<sup>Optional</sup> <a name="transferOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.transferOverflowMode"></a>

```typescript
public readonly transferOverflowMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transfer_overflow_mode MdbClickhouseCluster#transfer_overflow_mode}.

---

##### `transformNullIn`<sup>Optional</sup> <a name="transformNullIn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.transformNullIn"></a>

```typescript
public readonly transformNullIn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#transform_null_in MdbClickhouseCluster#transform_null_in}.

---

##### `useUncompressedCache`<sup>Optional</sup> <a name="useUncompressedCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettings.property.useUncompressedCache"></a>

```typescript
public readonly useUncompressedCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#use_uncompressed_cache MdbClickhouseCluster#use_uncompressed_cache}.

---

### MdbClickhouseClusterZookeeper <a name="MdbClickhouseClusterZookeeper" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeper"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeper.Initializer"></a>

```typescript
import { MdbClickhouseClusterZookeeper } from '@cdktf/provider-yandex'

const mdbClickhouseClusterZookeeper: MdbClickhouseClusterZookeeper = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a></code> | resources block. |

---

##### `resources`<sup>Optional</sup> <a name="resources" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeper.property.resources"></a>

```typescript
public readonly resources: MdbClickhouseClusterZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resources MdbClickhouseCluster#resources}

---

### MdbClickhouseClusterZookeeperResources <a name="MdbClickhouseClusterZookeeperResources" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.Initializer"></a>

```typescript
import { MdbClickhouseClusterZookeeperResources } from '@cdktf/provider-yandex'

const mdbClickhouseClusterZookeeperResources: MdbClickhouseClusterZookeeperResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Optional</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_size MdbClickhouseCluster#disk_size}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#disk_type_id MdbClickhouseCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Optional</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_clickhouse_cluster#resource_preset_id MdbClickhouseCluster#resource_preset_id}.

---

### MdbElasticsearchClusterConfig <a name="MdbElasticsearchClusterConfig" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfig } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfig: MdbElasticsearchClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a></code> | config block. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#environment MdbElasticsearchCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#network_id MdbElasticsearchCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#deletion_protection MdbElasticsearchCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#description MdbElasticsearchCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#folder_id MdbElasticsearchCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#id MdbElasticsearchCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#labels MdbElasticsearchCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#security_group_ids MdbElasticsearchCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#service_account_id MdbElasticsearchCluster#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.config"></a>

```typescript
public readonly config: MdbElasticsearchClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#config MdbElasticsearchCluster#config}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#environment MdbElasticsearchCluster#environment}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#network_id MdbElasticsearchCluster#network_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#deletion_protection MdbElasticsearchCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#description MdbElasticsearchCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#folder_id MdbElasticsearchCluster#folder_id}.

---

##### `host`<sup>Optional</sup> <a name="host" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbElasticsearchClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#host MdbElasticsearchCluster#host}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#id MdbElasticsearchCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#labels MdbElasticsearchCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbElasticsearchClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#maintenance_window MdbElasticsearchCluster#maintenance_window}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#security_group_ids MdbElasticsearchCluster#security_group_ids}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#service_account_id MdbElasticsearchCluster#service_account_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbElasticsearchClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#timeouts MdbElasticsearchCluster#timeouts}

---

### MdbElasticsearchClusterConfigA <a name="MdbElasticsearchClusterConfigA" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigA } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfigA: MdbElasticsearchClusterConfigA = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.adminPassword">adminPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#admin_password MdbElasticsearchCluster#admin_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.dataNode">dataNode</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a></code> | data_node block. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.edition">edition</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#edition MdbElasticsearchCluster#edition}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.masterNode">masterNode</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a></code> | master_node block. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.plugins">plugins</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#plugins MdbElasticsearchCluster#plugins}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#version MdbElasticsearchCluster#version}. |

---

##### `adminPassword`<sup>Required</sup> <a name="adminPassword" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.adminPassword"></a>

```typescript
public readonly adminPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#admin_password MdbElasticsearchCluster#admin_password}.

---

##### `dataNode`<sup>Required</sup> <a name="dataNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.dataNode"></a>

```typescript
public readonly dataNode: MdbElasticsearchClusterConfigDataNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a>

data_node block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#data_node MdbElasticsearchCluster#data_node}

---

##### `edition`<sup>Optional</sup> <a name="edition" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.edition"></a>

```typescript
public readonly edition: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#edition MdbElasticsearchCluster#edition}.

---

##### `masterNode`<sup>Optional</sup> <a name="masterNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.masterNode"></a>

```typescript
public readonly masterNode: MdbElasticsearchClusterConfigMasterNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a>

master_node block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#master_node MdbElasticsearchCluster#master_node}

---

##### `plugins`<sup>Optional</sup> <a name="plugins" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.plugins"></a>

```typescript
public readonly plugins: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#plugins MdbElasticsearchCluster#plugins}.

---

##### `version`<sup>Optional</sup> <a name="version" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigA.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#version MdbElasticsearchCluster#version}.

---

### MdbElasticsearchClusterConfigDataNode <a name="MdbElasticsearchClusterConfigDataNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigDataNode } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfigDataNode: MdbElasticsearchClusterConfigDataNode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a></code> | resources block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode.property.resources"></a>

```typescript
public readonly resources: MdbElasticsearchClusterConfigDataNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resources MdbElasticsearchCluster#resources}

---

### MdbElasticsearchClusterConfigDataNodeResources <a name="MdbElasticsearchClusterConfigDataNodeResources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigDataNodeResources } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfigDataNodeResources: MdbElasticsearchClusterConfigDataNodeResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}.

---

### MdbElasticsearchClusterConfigMasterNode <a name="MdbElasticsearchClusterConfigMasterNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigMasterNode } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfigMasterNode: MdbElasticsearchClusterConfigMasterNode = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a></code> | resources block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode.property.resources"></a>

```typescript
public readonly resources: MdbElasticsearchClusterConfigMasterNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resources MdbElasticsearchCluster#resources}

---

### MdbElasticsearchClusterConfigMasterNodeResources <a name="MdbElasticsearchClusterConfigMasterNodeResources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigMasterNodeResources } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterConfigMasterNodeResources: MdbElasticsearchClusterConfigMasterNodeResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}.

---

### MdbElasticsearchClusterHost <a name="MdbElasticsearchClusterHost" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.Initializer"></a>

```typescript
import { MdbElasticsearchClusterHost } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterHost: MdbElasticsearchClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#zone MdbElasticsearchCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#assign_public_ip MdbElasticsearchCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#subnet_id MdbElasticsearchCluster#subnet_id}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}.

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}.

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#zone MdbElasticsearchCluster#zone}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#assign_public_ip MdbElasticsearchCluster#assign_public_ip}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#subnet_id MdbElasticsearchCluster#subnet_id}.

---

### MdbElasticsearchClusterMaintenanceWindow <a name="MdbElasticsearchClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbElasticsearchClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterMaintenanceWindow: MdbElasticsearchClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#day MdbElasticsearchCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#hour MdbElasticsearchCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#day MdbElasticsearchCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#hour MdbElasticsearchCluster#hour}.

---

### MdbElasticsearchClusterTimeouts <a name="MdbElasticsearchClusterTimeouts" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.Initializer"></a>

```typescript
import { MdbElasticsearchClusterTimeouts } from '@cdktf/provider-yandex'

const mdbElasticsearchClusterTimeouts: MdbElasticsearchClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#create MdbElasticsearchCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#delete MdbElasticsearchCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#update MdbElasticsearchCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#create MdbElasticsearchCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#delete MdbElasticsearchCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#update MdbElasticsearchCluster#update}.

---

### MdbGreenplumClusterAccess <a name="MdbGreenplumClusterAccess" id="@cdktf/provider-yandex.MdbGreenplumClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterAccess.Initializer"></a>

```typescript
import { MdbGreenplumClusterAccess } from '@cdktf/provider-yandex'

const mdbGreenplumClusterAccess: MdbGreenplumClusterAccess = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#data_lens MdbGreenplumCluster#data_lens}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#web_sql MdbGreenplumCluster#web_sql}. |

---

##### `dataLens`<sup>Optional</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbGreenplumClusterAccess.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#data_lens MdbGreenplumCluster#data_lens}.

---

##### `webSql`<sup>Optional</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbGreenplumClusterAccess.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#web_sql MdbGreenplumCluster#web_sql}.

---

### MdbGreenplumClusterBackupWindowStart <a name="MdbGreenplumClusterBackupWindowStart" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart.Initializer"></a>

```typescript
import { MdbGreenplumClusterBackupWindowStart } from '@cdktf/provider-yandex'

const mdbGreenplumClusterBackupWindowStart: MdbGreenplumClusterBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#hours MdbGreenplumCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#minutes MdbGreenplumCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#hours MdbGreenplumCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#minutes MdbGreenplumCluster#minutes}.

---

### MdbGreenplumClusterConfig <a name="MdbGreenplumClusterConfig" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.Initializer"></a>

```typescript
import { MdbGreenplumClusterConfig } from '@cdktf/provider-yandex'

const mdbGreenplumClusterConfig: MdbGreenplumClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#assign_public_ip MdbGreenplumCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#environment MdbGreenplumCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.masterHostCount">masterHostCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#master_host_count MdbGreenplumCluster#master_host_count}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.masterSubcluster">masterSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a></code> | master_subcluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#name MdbGreenplumCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#network_id MdbGreenplumCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentHostCount">segmentHostCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_host_count MdbGreenplumCluster#segment_host_count}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentInHost">segmentInHost</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_in_host MdbGreenplumCluster#segment_in_host}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentSubcluster">segmentSubcluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a></code> | segment_subcluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#subnet_id MdbGreenplumCluster#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.userName">userName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_name MdbGreenplumCluster#user_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.userPassword">userPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_password MdbGreenplumCluster#user_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#version MdbGreenplumCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#zone MdbGreenplumCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#deletion_protection MdbGreenplumCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#description MdbGreenplumCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#folder_id MdbGreenplumCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#id MdbGreenplumCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#labels MdbGreenplumCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#security_group_ids MdbGreenplumCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#assign_public_ip MdbGreenplumCluster#assign_public_ip}.

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#environment MdbGreenplumCluster#environment}.

---

##### `masterHostCount`<sup>Required</sup> <a name="masterHostCount" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.masterHostCount"></a>

```typescript
public readonly masterHostCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#master_host_count MdbGreenplumCluster#master_host_count}.

---

##### `masterSubcluster`<sup>Required</sup> <a name="masterSubcluster" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.masterSubcluster"></a>

```typescript
public readonly masterSubcluster: MdbGreenplumClusterMasterSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a>

master_subcluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#master_subcluster MdbGreenplumCluster#master_subcluster}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#name MdbGreenplumCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#network_id MdbGreenplumCluster#network_id}.

---

##### `segmentHostCount`<sup>Required</sup> <a name="segmentHostCount" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentHostCount"></a>

```typescript
public readonly segmentHostCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_host_count MdbGreenplumCluster#segment_host_count}.

---

##### `segmentInHost`<sup>Required</sup> <a name="segmentInHost" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentInHost"></a>

```typescript
public readonly segmentInHost: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_in_host MdbGreenplumCluster#segment_in_host}.

---

##### `segmentSubcluster`<sup>Required</sup> <a name="segmentSubcluster" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.segmentSubcluster"></a>

```typescript
public readonly segmentSubcluster: MdbGreenplumClusterSegmentSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a>

segment_subcluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#segment_subcluster MdbGreenplumCluster#segment_subcluster}

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#subnet_id MdbGreenplumCluster#subnet_id}.

---

##### `userName`<sup>Required</sup> <a name="userName" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.userName"></a>

```typescript
public readonly userName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_name MdbGreenplumCluster#user_name}.

---

##### `userPassword`<sup>Required</sup> <a name="userPassword" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.userPassword"></a>

```typescript
public readonly userPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#user_password MdbGreenplumCluster#user_password}.

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#version MdbGreenplumCluster#version}.

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#zone MdbGreenplumCluster#zone}.

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.access"></a>

```typescript
public readonly access: MdbGreenplumClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#access MdbGreenplumCluster#access}

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbGreenplumClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#backup_window_start MdbGreenplumCluster#backup_window_start}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#deletion_protection MdbGreenplumCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#description MdbGreenplumCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#folder_id MdbGreenplumCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#id MdbGreenplumCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#labels MdbGreenplumCluster#labels}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#security_group_ids MdbGreenplumCluster#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbGreenplumClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbGreenplumClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#timeouts MdbGreenplumCluster#timeouts}

---

### MdbGreenplumClusterMasterHosts <a name="MdbGreenplumClusterMasterHosts" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHosts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHosts.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterHosts } from '@cdktf/provider-yandex'

const mdbGreenplumClusterMasterHosts: MdbGreenplumClusterMasterHosts = { ... }
```


### MdbGreenplumClusterMasterSubcluster <a name="MdbGreenplumClusterMasterSubcluster" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterSubcluster } from '@cdktf/provider-yandex'

const mdbGreenplumClusterMasterSubcluster: MdbGreenplumClusterMasterSubcluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a></code> | resources block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster.property.resources"></a>

```typescript
public readonly resources: MdbGreenplumClusterMasterSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resources MdbGreenplumCluster#resources}

---

### MdbGreenplumClusterMasterSubclusterResources <a name="MdbGreenplumClusterMasterSubclusterResources" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterSubclusterResources } from '@cdktf/provider-yandex'

const mdbGreenplumClusterMasterSubclusterResources: MdbGreenplumClusterMasterSubclusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}.

---

### MdbGreenplumClusterSegmentHosts <a name="MdbGreenplumClusterSegmentHosts" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHosts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHosts.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentHosts } from '@cdktf/provider-yandex'

const mdbGreenplumClusterSegmentHosts: MdbGreenplumClusterSegmentHosts = { ... }
```


### MdbGreenplumClusterSegmentSubcluster <a name="MdbGreenplumClusterSegmentSubcluster" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentSubcluster } from '@cdktf/provider-yandex'

const mdbGreenplumClusterSegmentSubcluster: MdbGreenplumClusterSegmentSubcluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a></code> | resources block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster.property.resources"></a>

```typescript
public readonly resources: MdbGreenplumClusterSegmentSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resources MdbGreenplumCluster#resources}

---

### MdbGreenplumClusterSegmentSubclusterResources <a name="MdbGreenplumClusterSegmentSubclusterResources" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentSubclusterResources } from '@cdktf/provider-yandex'

const mdbGreenplumClusterSegmentSubclusterResources: MdbGreenplumClusterSegmentSubclusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_size MdbGreenplumCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#disk_type_id MdbGreenplumCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#resource_preset_id MdbGreenplumCluster#resource_preset_id}.

---

### MdbGreenplumClusterTimeouts <a name="MdbGreenplumClusterTimeouts" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.Initializer"></a>

```typescript
import { MdbGreenplumClusterTimeouts } from '@cdktf/provider-yandex'

const mdbGreenplumClusterTimeouts: MdbGreenplumClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#create MdbGreenplumCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#delete MdbGreenplumCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#update MdbGreenplumCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#create MdbGreenplumCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#delete MdbGreenplumCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_greenplum_cluster#update MdbGreenplumCluster#update}.

---

### MdbKafkaClusterConfig <a name="MdbKafkaClusterConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.Initializer"></a>

```typescript
import { MdbKafkaClusterConfig } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfig: MdbKafkaClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a></code> | config block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#network_id MdbKafkaCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#deletion_protection MdbKafkaCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#description MdbKafkaCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#environment MdbKafkaCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#folder_id MdbKafkaCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#host_group_ids MdbKafkaCluster#host_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#id MdbKafkaCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#labels MdbKafkaCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#security_group_ids MdbKafkaCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#subnet_ids MdbKafkaCluster#subnet_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.topic">topic</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]</code> | topic block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]</code> | user block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.config"></a>

```typescript
public readonly config: MdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#config MdbKafkaCluster#config}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#network_id MdbKafkaCluster#network_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#deletion_protection MdbKafkaCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#description MdbKafkaCluster#description}.

---

##### `environment`<sup>Optional</sup> <a name="environment" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#environment MdbKafkaCluster#environment}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#folder_id MdbKafkaCluster#folder_id}.

---

##### `hostGroupIds`<sup>Optional</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#host_group_ids MdbKafkaCluster#host_group_ids}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#id MdbKafkaCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#labels MdbKafkaCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbKafkaClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#maintenance_window MdbKafkaCluster#maintenance_window}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#security_group_ids MdbKafkaCluster#security_group_ids}.

---

##### `subnetIds`<sup>Optional</sup> <a name="subnetIds" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#subnet_ids MdbKafkaCluster#subnet_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbKafkaClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#timeouts MdbKafkaCluster#timeouts}

---

##### `topic`<sup>Optional</sup> <a name="topic" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.topic"></a>

```typescript
public readonly topic: IResolvable | MdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]

topic block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#topic MdbKafkaCluster#topic}

---

##### `user`<sup>Optional</sup> <a name="user" id="@cdktf/provider-yandex.MdbKafkaClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#user MdbKafkaCluster#user}

---

### MdbKafkaClusterConfigA <a name="MdbKafkaClusterConfigA" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigA } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigA: MdbKafkaClusterConfigA = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a></code> | kafka block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#version MdbKafkaCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.zones">zones</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#zones MdbKafkaCluster#zones}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#assign_public_ip MdbKafkaCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.brokersCount">brokersCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#brokers_count MdbKafkaCluster#brokers_count}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.schemaRegistry">schemaRegistry</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#schema_registry MdbKafkaCluster#schema_registry}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.unmanagedTopics">unmanagedTopics</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#unmanaged_topics MdbKafkaCluster#unmanaged_topics}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a></code> | zookeeper block. |

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.kafka"></a>

```typescript
public readonly kafka: MdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a>

kafka block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#kafka MdbKafkaCluster#kafka}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#version MdbKafkaCluster#version}.

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#zones MdbKafkaCluster#zones}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#assign_public_ip MdbKafkaCluster#assign_public_ip}.

---

##### `brokersCount`<sup>Optional</sup> <a name="brokersCount" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.brokersCount"></a>

```typescript
public readonly brokersCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#brokers_count MdbKafkaCluster#brokers_count}.

---

##### `schemaRegistry`<sup>Optional</sup> <a name="schemaRegistry" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.schemaRegistry"></a>

```typescript
public readonly schemaRegistry: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#schema_registry MdbKafkaCluster#schema_registry}.

---

##### `unmanagedTopics`<sup>Optional</sup> <a name="unmanagedTopics" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.unmanagedTopics"></a>

```typescript
public readonly unmanagedTopics: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#unmanaged_topics MdbKafkaCluster#unmanaged_topics}.

---

##### `zookeeper`<sup>Optional</sup> <a name="zookeeper" id="@cdktf/provider-yandex.MdbKafkaClusterConfigA.property.zookeeper"></a>

```typescript
public readonly zookeeper: MdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a>

zookeeper block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#zookeeper MdbKafkaCluster#zookeeper}

---

### MdbKafkaClusterConfigKafka <a name="MdbKafkaClusterConfigKafka" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafka"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafka.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafka } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigKafka: MdbKafkaClusterConfigKafka = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka.property.kafkaConfig">kafkaConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a></code> | kafka_config block. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafka.property.resources"></a>

```typescript
public readonly resources: MdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resources MdbKafkaCluster#resources}

---

##### `kafkaConfig`<sup>Optional</sup> <a name="kafkaConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafka.property.kafkaConfig"></a>

```typescript
public readonly kafkaConfig: MdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a>

kafka_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#kafka_config MdbKafkaCluster#kafka_config}

---

### MdbKafkaClusterConfigKafkaKafkaConfig <a name="MdbKafkaClusterConfigKafkaKafkaConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafkaKafkaConfig } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigKafkaKafkaConfig: MdbKafkaClusterConfigKafkaKafkaConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.autoCreateTopicsEnable">autoCreateTopicsEnable</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#auto_create_topics_enable MdbKafkaCluster#auto_create_topics_enable}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.compressionType">compressionType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#compression_type MdbKafkaCluster#compression_type}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.defaultReplicationFactor">defaultReplicationFactor</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#default_replication_factor MdbKafkaCluster#default_replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMessages">logFlushIntervalMessages</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_interval_messages MdbKafkaCluster#log_flush_interval_messages}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMs">logFlushIntervalMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_interval_ms MdbKafkaCluster#log_flush_interval_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushSchedulerIntervalMs">logFlushSchedulerIntervalMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_scheduler_interval_ms MdbKafkaCluster#log_flush_scheduler_interval_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logPreallocate">logPreallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_preallocate MdbKafkaCluster#log_preallocate}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionBytes">logRetentionBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_bytes MdbKafkaCluster#log_retention_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionHours">logRetentionHours</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_hours MdbKafkaCluster#log_retention_hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMinutes">logRetentionMinutes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_minutes MdbKafkaCluster#log_retention_minutes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMs">logRetentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_ms MdbKafkaCluster#log_retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logSegmentBytes">logSegmentBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_segment_bytes MdbKafkaCluster#log_segment_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.numPartitions">numPartitions</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#num_partitions MdbKafkaCluster#num_partitions}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.socketReceiveBufferBytes">socketReceiveBufferBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#socket_receive_buffer_bytes MdbKafkaCluster#socket_receive_buffer_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.socketSendBufferBytes">socketSendBufferBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#socket_send_buffer_bytes MdbKafkaCluster#socket_send_buffer_bytes}. |

---

##### `autoCreateTopicsEnable`<sup>Optional</sup> <a name="autoCreateTopicsEnable" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.autoCreateTopicsEnable"></a>

```typescript
public readonly autoCreateTopicsEnable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#auto_create_topics_enable MdbKafkaCluster#auto_create_topics_enable}.

---

##### `compressionType`<sup>Optional</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#compression_type MdbKafkaCluster#compression_type}.

---

##### `defaultReplicationFactor`<sup>Optional</sup> <a name="defaultReplicationFactor" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.defaultReplicationFactor"></a>

```typescript
public readonly defaultReplicationFactor: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#default_replication_factor MdbKafkaCluster#default_replication_factor}.

---

##### `logFlushIntervalMessages`<sup>Optional</sup> <a name="logFlushIntervalMessages" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMessages"></a>

```typescript
public readonly logFlushIntervalMessages: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_interval_messages MdbKafkaCluster#log_flush_interval_messages}.

---

##### `logFlushIntervalMs`<sup>Optional</sup> <a name="logFlushIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushIntervalMs"></a>

```typescript
public readonly logFlushIntervalMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_interval_ms MdbKafkaCluster#log_flush_interval_ms}.

---

##### `logFlushSchedulerIntervalMs`<sup>Optional</sup> <a name="logFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logFlushSchedulerIntervalMs"></a>

```typescript
public readonly logFlushSchedulerIntervalMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_flush_scheduler_interval_ms MdbKafkaCluster#log_flush_scheduler_interval_ms}.

---

##### `logPreallocate`<sup>Optional</sup> <a name="logPreallocate" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logPreallocate"></a>

```typescript
public readonly logPreallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_preallocate MdbKafkaCluster#log_preallocate}.

---

##### `logRetentionBytes`<sup>Optional</sup> <a name="logRetentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionBytes"></a>

```typescript
public readonly logRetentionBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_bytes MdbKafkaCluster#log_retention_bytes}.

---

##### `logRetentionHours`<sup>Optional</sup> <a name="logRetentionHours" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionHours"></a>

```typescript
public readonly logRetentionHours: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_hours MdbKafkaCluster#log_retention_hours}.

---

##### `logRetentionMinutes`<sup>Optional</sup> <a name="logRetentionMinutes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMinutes"></a>

```typescript
public readonly logRetentionMinutes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_minutes MdbKafkaCluster#log_retention_minutes}.

---

##### `logRetentionMs`<sup>Optional</sup> <a name="logRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logRetentionMs"></a>

```typescript
public readonly logRetentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_retention_ms MdbKafkaCluster#log_retention_ms}.

---

##### `logSegmentBytes`<sup>Optional</sup> <a name="logSegmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.logSegmentBytes"></a>

```typescript
public readonly logSegmentBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#log_segment_bytes MdbKafkaCluster#log_segment_bytes}.

---

##### `numPartitions`<sup>Optional</sup> <a name="numPartitions" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.numPartitions"></a>

```typescript
public readonly numPartitions: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#num_partitions MdbKafkaCluster#num_partitions}.

---

##### `socketReceiveBufferBytes`<sup>Optional</sup> <a name="socketReceiveBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.socketReceiveBufferBytes"></a>

```typescript
public readonly socketReceiveBufferBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#socket_receive_buffer_bytes MdbKafkaCluster#socket_receive_buffer_bytes}.

---

##### `socketSendBufferBytes`<sup>Optional</sup> <a name="socketSendBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig.property.socketSendBufferBytes"></a>

```typescript
public readonly socketSendBufferBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#socket_send_buffer_bytes MdbKafkaCluster#socket_send_buffer_bytes}.

---

### MdbKafkaClusterConfigKafkaResources <a name="MdbKafkaClusterConfigKafkaResources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafkaResources } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigKafkaResources: MdbKafkaClusterConfigKafkaResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_size MdbKafkaCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_type_id MdbKafkaCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resource_preset_id MdbKafkaCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_size MdbKafkaCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_type_id MdbKafkaCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resource_preset_id MdbKafkaCluster#resource_preset_id}.

---

### MdbKafkaClusterConfigZookeeper <a name="MdbKafkaClusterConfigZookeeper" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigZookeeper } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigZookeeper: MdbKafkaClusterConfigZookeeper = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a></code> | resources block. |

---

##### `resources`<sup>Optional</sup> <a name="resources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper.property.resources"></a>

```typescript
public readonly resources: MdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resources MdbKafkaCluster#resources}

---

### MdbKafkaClusterConfigZookeeperResources <a name="MdbKafkaClusterConfigZookeeperResources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigZookeeperResources } from '@cdktf/provider-yandex'

const mdbKafkaClusterConfigZookeeperResources: MdbKafkaClusterConfigZookeeperResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_size MdbKafkaCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_type_id MdbKafkaCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resource_preset_id MdbKafkaCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Optional</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_size MdbKafkaCluster#disk_size}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#disk_type_id MdbKafkaCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Optional</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#resource_preset_id MdbKafkaCluster#resource_preset_id}.

---

### MdbKafkaClusterHost <a name="MdbKafkaClusterHost" id="@cdktf/provider-yandex.MdbKafkaClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterHost.Initializer"></a>

```typescript
import { MdbKafkaClusterHost } from '@cdktf/provider-yandex'

const mdbKafkaClusterHost: MdbKafkaClusterHost = { ... }
```


### MdbKafkaClusterMaintenanceWindow <a name="MdbKafkaClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbKafkaClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbKafkaClusterMaintenanceWindow: MdbKafkaClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#type MdbKafkaCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#day MdbKafkaCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#hour MdbKafkaCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#type MdbKafkaCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#day MdbKafkaCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#hour MdbKafkaCluster#hour}.

---

### MdbKafkaClusterTimeouts <a name="MdbKafkaClusterTimeouts" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts.Initializer"></a>

```typescript
import { MdbKafkaClusterTimeouts } from '@cdktf/provider-yandex'

const mdbKafkaClusterTimeouts: MdbKafkaClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#create MdbKafkaCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#delete MdbKafkaCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#read MdbKafkaCluster#read}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#update MdbKafkaCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#create MdbKafkaCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#delete MdbKafkaCluster#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#read MdbKafkaCluster#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbKafkaClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#update MdbKafkaCluster#update}.

---

### MdbKafkaClusterTopic <a name="MdbKafkaClusterTopic" id="@cdktf/provider-yandex.MdbKafkaClusterTopic"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterTopic.Initializer"></a>

```typescript
import { MdbKafkaClusterTopic } from '@cdktf/provider-yandex'

const mdbKafkaClusterTopic: MdbKafkaClusterTopic = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic.property.partitions">partitions</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#partitions MdbKafkaCluster#partitions}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#replication_factor MdbKafkaCluster#replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a></code> | topic_config block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterTopic.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}.

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.MdbKafkaClusterTopic.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#partitions MdbKafkaCluster#partitions}.

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaClusterTopic.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#replication_factor MdbKafkaCluster#replication_factor}.

---

##### `topicConfig`<sup>Optional</sup> <a name="topicConfig" id="@cdktf/provider-yandex.MdbKafkaClusterTopic.property.topicConfig"></a>

```typescript
public readonly topicConfig: MdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a>

topic_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#topic_config MdbKafkaCluster#topic_config}

---

### MdbKafkaClusterTopicTopicConfig <a name="MdbKafkaClusterTopicTopicConfig" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.Initializer"></a>

```typescript
import { MdbKafkaClusterTopicTopicConfig } from '@cdktf/provider-yandex'

const mdbKafkaClusterTopicTopicConfig: MdbKafkaClusterTopicTopicConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#cleanup_policy MdbKafkaCluster#cleanup_policy}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.compressionType">compressionType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#compression_type MdbKafkaCluster#compression_type}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#delete_retention_ms MdbKafkaCluster#delete_retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#file_delete_delay_ms MdbKafkaCluster#file_delete_delay_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.flushMessages">flushMessages</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#flush_messages MdbKafkaCluster#flush_messages}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.flushMs">flushMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#flush_ms MdbKafkaCluster#flush_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#max_message_bytes MdbKafkaCluster#max_message_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#min_compaction_lag_ms MdbKafkaCluster#min_compaction_lag_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#min_insync_replicas MdbKafkaCluster#min_insync_replicas}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#preallocate MdbKafkaCluster#preallocate}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#retention_bytes MdbKafkaCluster#retention_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.retentionMs">retentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#retention_ms MdbKafkaCluster#retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#segment_bytes MdbKafkaCluster#segment_bytes}. |

---

##### `cleanupPolicy`<sup>Optional</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#cleanup_policy MdbKafkaCluster#cleanup_policy}.

---

##### `compressionType`<sup>Optional</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#compression_type MdbKafkaCluster#compression_type}.

---

##### `deleteRetentionMs`<sup>Optional</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#delete_retention_ms MdbKafkaCluster#delete_retention_ms}.

---

##### `fileDeleteDelayMs`<sup>Optional</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#file_delete_delay_ms MdbKafkaCluster#file_delete_delay_ms}.

---

##### `flushMessages`<sup>Optional</sup> <a name="flushMessages" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#flush_messages MdbKafkaCluster#flush_messages}.

---

##### `flushMs`<sup>Optional</sup> <a name="flushMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#flush_ms MdbKafkaCluster#flush_ms}.

---

##### `maxMessageBytes`<sup>Optional</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#max_message_bytes MdbKafkaCluster#max_message_bytes}.

---

##### `minCompactionLagMs`<sup>Optional</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#min_compaction_lag_ms MdbKafkaCluster#min_compaction_lag_ms}.

---

##### `minInsyncReplicas`<sup>Optional</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#min_insync_replicas MdbKafkaCluster#min_insync_replicas}.

---

##### `preallocate`<sup>Optional</sup> <a name="preallocate" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#preallocate MdbKafkaCluster#preallocate}.

---

##### `retentionBytes`<sup>Optional</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#retention_bytes MdbKafkaCluster#retention_bytes}.

---

##### `retentionMs`<sup>Optional</sup> <a name="retentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#retention_ms MdbKafkaCluster#retention_ms}.

---

##### `segmentBytes`<sup>Optional</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#segment_bytes MdbKafkaCluster#segment_bytes}.

---

### MdbKafkaClusterUser <a name="MdbKafkaClusterUser" id="@cdktf/provider-yandex.MdbKafkaClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterUser.Initializer"></a>

```typescript
import { MdbKafkaClusterUser } from '@cdktf/provider-yandex'

const mdbKafkaClusterUser: MdbKafkaClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#password MdbKafkaCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]</code> | permission block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#name MdbKafkaCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbKafkaClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#password MdbKafkaCluster#password}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbKafkaClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#permission MdbKafkaCluster#permission}

---

### MdbKafkaClusterUserPermission <a name="MdbKafkaClusterUserPermission" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermission.Initializer"></a>

```typescript
import { MdbKafkaClusterUserPermission } from '@cdktf/provider-yandex'

const mdbKafkaClusterUserPermission: MdbKafkaClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#role MdbKafkaCluster#role}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission.property.topicName">topicName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#topic_name MdbKafkaCluster#topic_name}. |

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermission.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#role MdbKafkaCluster#role}.

---

##### `topicName`<sup>Required</sup> <a name="topicName" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermission.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_cluster#topic_name MdbKafkaCluster#topic_name}.

---

### MdbKafkaConnectorConfig <a name="MdbKafkaConnectorConfig" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.Initializer"></a>

```typescript
import { MdbKafkaConnectorConfig } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConfig: MdbKafkaConnectorConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#cluster_id MdbKafkaConnector#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#name MdbKafkaConnector#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.connectorConfigMirrormaker">connectorConfigMirrormaker</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]</code> | connector_config_mirrormaker block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#id MdbKafkaConnector#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.properties">properties</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#properties MdbKafkaConnector#properties}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.tasksMax">tasksMax</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#tasks_max MdbKafkaConnector#tasks_max}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#cluster_id MdbKafkaConnector#cluster_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#name MdbKafkaConnector#name}.

---

##### `connectorConfigMirrormaker`<sup>Optional</sup> <a name="connectorConfigMirrormaker" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.connectorConfigMirrormaker"></a>

```typescript
public readonly connectorConfigMirrormaker: IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]

connector_config_mirrormaker block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#connector_config_mirrormaker MdbKafkaConnector#connector_config_mirrormaker}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#id MdbKafkaConnector#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `properties`<sup>Optional</sup> <a name="properties" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#properties MdbKafkaConnector#properties}.

---

##### `tasksMax`<sup>Optional</sup> <a name="tasksMax" id="@cdktf/provider-yandex.MdbKafkaConnectorConfig.property.tasksMax"></a>

```typescript
public readonly tasksMax: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#tasks_max MdbKafkaConnector#tasks_max}.

---

### MdbKafkaConnectorConnectorConfigMirrormaker <a name="MdbKafkaConnectorConnectorConfigMirrormaker" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormaker } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormaker: MdbKafkaConnectorConnectorConfigMirrormaker = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#replication_factor MdbKafkaConnector#replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.sourceCluster">sourceCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a></code> | source_cluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.targetCluster">targetCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a></code> | target_cluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.topics">topics</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#topics MdbKafkaConnector#topics}. |

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#replication_factor MdbKafkaConnector#replication_factor}.

---

##### `sourceCluster`<sup>Required</sup> <a name="sourceCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.sourceCluster"></a>

```typescript
public readonly sourceCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a>

source_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#source_cluster MdbKafkaConnector#source_cluster}

---

##### `targetCluster`<sup>Required</sup> <a name="targetCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.targetCluster"></a>

```typescript
public readonly targetCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a>

target_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#target_cluster MdbKafkaConnector#target_cluster}

---

##### `topics`<sup>Required</sup> <a name="topics" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker.property.topics"></a>

```typescript
public readonly topics: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#topics MdbKafkaConnector#topics}.

---

### MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerSourceCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.alias">alias</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.externalCluster">externalCluster</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]</code> | external_cluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.thisCluster">thisCluster</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]</code> | this_cluster block. |

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}.

---

##### `externalCluster`<sup>Optional</sup> <a name="externalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.externalCluster"></a>

```typescript
public readonly externalCluster: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]

external_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#external_cluster MdbKafkaConnector#external_cluster}

---

##### `thisCluster`<sup>Optional</sup> <a name="thisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster.property.thisCluster"></a>

```typescript
public readonly thisCluster: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]

this_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#this_cluster MdbKafkaConnector#this_cluster}

---

### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslPassword">saslPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslUsername">saslUsername</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}. |

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}.

---

##### `saslMechanism`<sup>Optional</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}.

---

##### `saslPassword`<sup>Optional</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}.

---

##### `saslUsername`<sup>Optional</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}.

---

##### `securityProtocol`<sup>Optional</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}.

---

### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster = { ... }
```


### MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerTargetCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.alias">alias</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.externalCluster">externalCluster</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]</code> | external_cluster block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.thisCluster">thisCluster</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]</code> | this_cluster block. |

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}.

---

##### `externalCluster`<sup>Optional</sup> <a name="externalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.externalCluster"></a>

```typescript
public readonly externalCluster: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]

external_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#external_cluster MdbKafkaConnector#external_cluster}

---

##### `thisCluster`<sup>Optional</sup> <a name="thisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster.property.thisCluster"></a>

```typescript
public readonly thisCluster: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]

this_cluster block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#this_cluster MdbKafkaConnector#this_cluster}

---

### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslPassword">saslPassword</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslUsername">saslUsername</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}. |

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}.

---

##### `saslMechanism`<sup>Optional</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}.

---

##### `saslPassword`<sup>Optional</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}.

---

##### `saslUsername`<sup>Optional</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}.

---

##### `securityProtocol`<sup>Optional</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}.

---

### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster } from '@cdktf/provider-yandex'

const mdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster = { ... }
```


### MdbKafkaTopicConfig <a name="MdbKafkaTopicConfig" id="@cdktf/provider-yandex.MdbKafkaTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.Initializer"></a>

```typescript
import { MdbKafkaTopicConfig } from '@cdktf/provider-yandex'

const mdbKafkaTopicConfig: MdbKafkaTopicConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#cluster_id MdbKafkaTopic#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#name MdbKafkaTopic#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.partitions">partitions</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#partitions MdbKafkaTopic#partitions}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#replication_factor MdbKafkaTopic#replication_factor}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#id MdbKafkaTopic#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicConfig.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a></code> | topic_config block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#cluster_id MdbKafkaTopic#cluster_id}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#name MdbKafkaTopic#name}.

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#partitions MdbKafkaTopic#partitions}.

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#replication_factor MdbKafkaTopic#replication_factor}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#id MdbKafkaTopic#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbKafkaTopicTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#timeouts MdbKafkaTopic#timeouts}

---

##### `topicConfig`<sup>Optional</sup> <a name="topicConfig" id="@cdktf/provider-yandex.MdbKafkaTopicConfig.property.topicConfig"></a>

```typescript
public readonly topicConfig: MdbKafkaTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a>

topic_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#topic_config MdbKafkaTopic#topic_config}

---

### MdbKafkaTopicTimeouts <a name="MdbKafkaTopicTimeouts" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts.Initializer"></a>

```typescript
import { MdbKafkaTopicTimeouts } from '@cdktf/provider-yandex'

const mdbKafkaTopicTimeouts: MdbKafkaTopicTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#create MdbKafkaTopic#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#delete MdbKafkaTopic#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#read MdbKafkaTopic#read}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#update MdbKafkaTopic#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#create MdbKafkaTopic#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#delete MdbKafkaTopic#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#read MdbKafkaTopic#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbKafkaTopicTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#update MdbKafkaTopic#update}.

---

### MdbKafkaTopicTopicConfig <a name="MdbKafkaTopicTopicConfig" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.Initializer"></a>

```typescript
import { MdbKafkaTopicTopicConfig } from '@cdktf/provider-yandex'

const mdbKafkaTopicTopicConfig: MdbKafkaTopicTopicConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#cleanup_policy MdbKafkaTopic#cleanup_policy}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.compressionType">compressionType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#compression_type MdbKafkaTopic#compression_type}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#delete_retention_ms MdbKafkaTopic#delete_retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#file_delete_delay_ms MdbKafkaTopic#file_delete_delay_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.flushMessages">flushMessages</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#flush_messages MdbKafkaTopic#flush_messages}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.flushMs">flushMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#flush_ms MdbKafkaTopic#flush_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#max_message_bytes MdbKafkaTopic#max_message_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#min_compaction_lag_ms MdbKafkaTopic#min_compaction_lag_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#min_insync_replicas MdbKafkaTopic#min_insync_replicas}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#preallocate MdbKafkaTopic#preallocate}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#retention_bytes MdbKafkaTopic#retention_bytes}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.retentionMs">retentionMs</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#retention_ms MdbKafkaTopic#retention_ms}. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#segment_bytes MdbKafkaTopic#segment_bytes}. |

---

##### `cleanupPolicy`<sup>Optional</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#cleanup_policy MdbKafkaTopic#cleanup_policy}.

---

##### `compressionType`<sup>Optional</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#compression_type MdbKafkaTopic#compression_type}.

---

##### `deleteRetentionMs`<sup>Optional</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#delete_retention_ms MdbKafkaTopic#delete_retention_ms}.

---

##### `fileDeleteDelayMs`<sup>Optional</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#file_delete_delay_ms MdbKafkaTopic#file_delete_delay_ms}.

---

##### `flushMessages`<sup>Optional</sup> <a name="flushMessages" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#flush_messages MdbKafkaTopic#flush_messages}.

---

##### `flushMs`<sup>Optional</sup> <a name="flushMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#flush_ms MdbKafkaTopic#flush_ms}.

---

##### `maxMessageBytes`<sup>Optional</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#max_message_bytes MdbKafkaTopic#max_message_bytes}.

---

##### `minCompactionLagMs`<sup>Optional</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#min_compaction_lag_ms MdbKafkaTopic#min_compaction_lag_ms}.

---

##### `minInsyncReplicas`<sup>Optional</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#min_insync_replicas MdbKafkaTopic#min_insync_replicas}.

---

##### `preallocate`<sup>Optional</sup> <a name="preallocate" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#preallocate MdbKafkaTopic#preallocate}.

---

##### `retentionBytes`<sup>Optional</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#retention_bytes MdbKafkaTopic#retention_bytes}.

---

##### `retentionMs`<sup>Optional</sup> <a name="retentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#retention_ms MdbKafkaTopic#retention_ms}.

---

##### `segmentBytes`<sup>Optional</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfig.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_topic#segment_bytes MdbKafkaTopic#segment_bytes}.

---

### MdbMongodbClusterClusterConfig <a name="MdbMongodbClusterClusterConfig" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfig } from '@cdktf/provider-yandex'

const mdbMongodbClusterClusterConfig: MdbMongodbClusterClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#version MdbMongodbCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.featureCompatibilityVersion">featureCompatibilityVersion</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#feature_compatibility_version MdbMongodbCluster#feature_compatibility_version}. |

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#version MdbMongodbCluster#version}.

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.access"></a>

```typescript
public readonly access: MdbMongodbClusterClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#access MdbMongodbCluster#access}

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbMongodbClusterClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#backup_window_start MdbMongodbCluster#backup_window_start}

---

##### `featureCompatibilityVersion`<sup>Optional</sup> <a name="featureCompatibilityVersion" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfig.property.featureCompatibilityVersion"></a>

```typescript
public readonly featureCompatibilityVersion: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#feature_compatibility_version MdbMongodbCluster#feature_compatibility_version}.

---

### MdbMongodbClusterClusterConfigAccess <a name="MdbMongodbClusterClusterConfigAccess" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfigAccess } from '@cdktf/provider-yandex'

const mdbMongodbClusterClusterConfigAccess: MdbMongodbClusterClusterConfigAccess = { ... }
```


### MdbMongodbClusterClusterConfigBackupWindowStart <a name="MdbMongodbClusterClusterConfigBackupWindowStart" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfigBackupWindowStart } from '@cdktf/provider-yandex'

const mdbMongodbClusterClusterConfigBackupWindowStart: MdbMongodbClusterClusterConfigBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hours MdbMongodbCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#minutes MdbMongodbCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hours MdbMongodbCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#minutes MdbMongodbCluster#minutes}.

---

### MdbMongodbClusterConfig <a name="MdbMongodbClusterConfig" id="@cdktf/provider-yandex.MdbMongodbClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.Initializer"></a>

```typescript
import { MdbMongodbClusterConfig } from '@cdktf/provider-yandex'

const mdbMongodbClusterConfig: MdbMongodbClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.clusterConfig">clusterConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a></code> | cluster_config block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.database">database</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]</code> | database block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#environment MdbMongodbCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#network_id MdbMongodbCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]</code> | user block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.clusterId">clusterId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#cluster_id MdbMongodbCluster#cluster_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#deletion_protection MdbMongodbCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#description MdbMongodbCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#folder_id MdbMongodbCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#id MdbMongodbCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#labels MdbMongodbCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#security_group_ids MdbMongodbCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `clusterConfig`<sup>Required</sup> <a name="clusterConfig" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.clusterConfig"></a>

```typescript
public readonly clusterConfig: MdbMongodbClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a>

cluster_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#cluster_config MdbMongodbCluster#cluster_config}

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.database"></a>

```typescript
public readonly database: IResolvable | MdbMongodbClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]

database block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#database MdbMongodbCluster#database}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#environment MdbMongodbCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbMongodbClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#host MdbMongodbCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#network_id MdbMongodbCluster#network_id}.

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.resources"></a>

```typescript
public readonly resources: MdbMongodbClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#resources MdbMongodbCluster#resources}

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbMongodbClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#user MdbMongodbCluster#user}

---

##### `clusterId`<sup>Optional</sup> <a name="clusterId" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#cluster_id MdbMongodbCluster#cluster_id}.

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#deletion_protection MdbMongodbCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#description MdbMongodbCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#folder_id MdbMongodbCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#id MdbMongodbCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#labels MdbMongodbCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbMongodbClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#maintenance_window MdbMongodbCluster#maintenance_window}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#security_group_ids MdbMongodbCluster#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbMongodbClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbMongodbClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#timeouts MdbMongodbCluster#timeouts}

---

### MdbMongodbClusterDatabase <a name="MdbMongodbClusterDatabase" id="@cdktf/provider-yandex.MdbMongodbClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterDatabase.Initializer"></a>

```typescript
import { MdbMongodbClusterDatabase } from '@cdktf/provider-yandex'

const mdbMongodbClusterDatabase: MdbMongodbClusterDatabase = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterDatabase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}.

---

### MdbMongodbClusterHost <a name="MdbMongodbClusterHost" id="@cdktf/provider-yandex.MdbMongodbClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterHost.Initializer"></a>

```typescript
import { MdbMongodbClusterHost } from '@cdktf/provider-yandex'

const mdbMongodbClusterHost: MdbMongodbClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#subnet_id MdbMongodbCluster#subnet_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.zoneId">zoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#zone_id MdbMongodbCluster#zone_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#assign_public_ip MdbMongodbCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#role MdbMongodbCluster#role}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.shardName">shardName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#shard_name MdbMongodbCluster#shard_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHost.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}. |

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#subnet_id MdbMongodbCluster#subnet_id}.

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#zone_id MdbMongodbCluster#zone_id}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#assign_public_ip MdbMongodbCluster#assign_public_ip}.

---

##### `role`<sup>Optional</sup> <a name="role" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#role MdbMongodbCluster#role}.

---

##### `shardName`<sup>Optional</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#shard_name MdbMongodbCluster#shard_name}.

---

##### `type`<sup>Optional</sup> <a name="type" id="@cdktf/provider-yandex.MdbMongodbClusterHost.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}.

---

### MdbMongodbClusterMaintenanceWindow <a name="MdbMongodbClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbMongodbClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbMongodbClusterMaintenanceWindow: MdbMongodbClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#day MdbMongodbCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hour MdbMongodbCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#type MdbMongodbCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#day MdbMongodbCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#hour MdbMongodbCluster#hour}.

---

### MdbMongodbClusterResources <a name="MdbMongodbClusterResources" id="@cdktf/provider-yandex.MdbMongodbClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterResources.Initializer"></a>

```typescript
import { MdbMongodbClusterResources } from '@cdktf/provider-yandex'

const mdbMongodbClusterResources: MdbMongodbClusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_size MdbMongodbCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_type_id MdbMongodbCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#resource_preset_id MdbMongodbCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbMongodbClusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_size MdbMongodbCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbMongodbClusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#disk_type_id MdbMongodbCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbMongodbClusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#resource_preset_id MdbMongodbCluster#resource_preset_id}.

---

### MdbMongodbClusterTimeouts <a name="MdbMongodbClusterTimeouts" id="@cdktf/provider-yandex.MdbMongodbClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterTimeouts.Initializer"></a>

```typescript
import { MdbMongodbClusterTimeouts } from '@cdktf/provider-yandex'

const mdbMongodbClusterTimeouts: MdbMongodbClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#create MdbMongodbCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#delete MdbMongodbCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#update MdbMongodbCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#create MdbMongodbCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#delete MdbMongodbCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbMongodbClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#update MdbMongodbCluster#update}.

---

### MdbMongodbClusterUser <a name="MdbMongodbClusterUser" id="@cdktf/provider-yandex.MdbMongodbClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterUser.Initializer"></a>

```typescript
import { MdbMongodbClusterUser } from '@cdktf/provider-yandex'

const mdbMongodbClusterUser: MdbMongodbClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#password MdbMongodbCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]</code> | permission block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#name MdbMongodbCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbMongodbClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#password MdbMongodbCluster#password}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbMongodbClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbMongodbClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#permission MdbMongodbCluster#permission}

---

### MdbMongodbClusterUserPermission <a name="MdbMongodbClusterUserPermission" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermission.Initializer"></a>

```typescript
import { MdbMongodbClusterUserPermission } from '@cdktf/provider-yandex'

const mdbMongodbClusterUserPermission: MdbMongodbClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission.property.databaseName">databaseName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#database_name MdbMongodbCluster#database_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission.property.roles">roles</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#roles MdbMongodbCluster#roles}. |

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermission.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#database_name MdbMongodbCluster#database_name}.

---

##### `roles`<sup>Optional</sup> <a name="roles" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermission.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mongodb_cluster#roles MdbMongodbCluster#roles}.

---

### MdbMysqlClusterAccess <a name="MdbMysqlClusterAccess" id="@cdktf/provider-yandex.MdbMysqlClusterAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterAccess.Initializer"></a>

```typescript
import { MdbMysqlClusterAccess } from '@cdktf/provider-yandex'

const mdbMysqlClusterAccess: MdbMysqlClusterAccess = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#data_lens MdbMysqlCluster#data_lens}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#web_sql MdbMysqlCluster#web_sql}. |

---

##### `dataLens`<sup>Optional</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbMysqlClusterAccess.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#data_lens MdbMysqlCluster#data_lens}.

---

##### `webSql`<sup>Optional</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbMysqlClusterAccess.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#web_sql MdbMysqlCluster#web_sql}.

---

### MdbMysqlClusterBackupWindowStart <a name="MdbMysqlClusterBackupWindowStart" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart.Initializer"></a>

```typescript
import { MdbMysqlClusterBackupWindowStart } from '@cdktf/provider-yandex'

const mdbMysqlClusterBackupWindowStart: MdbMysqlClusterBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hours MdbMysqlCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#minutes MdbMysqlCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hours MdbMysqlCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#minutes MdbMysqlCluster#minutes}.

---

### MdbMysqlClusterConfig <a name="MdbMysqlClusterConfig" id="@cdktf/provider-yandex.MdbMysqlClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.Initializer"></a>

```typescript
import { MdbMysqlClusterConfig } from '@cdktf/provider-yandex'

const mdbMysqlClusterConfig: MdbMysqlClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.database">database</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]</code> | database block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#environment MdbMysqlCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#network_id MdbMysqlCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]</code> | user block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#version MdbMysqlCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.allowRegenerationHost">allowRegenerationHost</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#allow_regeneration_host MdbMysqlCluster#allow_regeneration_host}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#deletion_protection MdbMysqlCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#description MdbMysqlCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#folder_id MdbMysqlCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#id MdbMysqlCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#labels MdbMysqlCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.mysqlConfig">mysqlConfig</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#mysql_config MdbMysqlCluster#mysql_config}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.restore">restore</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a></code> | restore block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#security_group_ids MdbMysqlCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.database"></a>

```typescript
public readonly database: IResolvable | MdbMysqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]

database block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#database MdbMysqlCluster#database}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#environment MdbMysqlCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbMysqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#host MdbMysqlCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#network_id MdbMysqlCluster#network_id}.

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.resources"></a>

```typescript
public readonly resources: MdbMysqlClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#resources MdbMysqlCluster#resources}

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbMysqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#user MdbMysqlCluster#user}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#version MdbMysqlCluster#version}.

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.access"></a>

```typescript
public readonly access: MdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#access MdbMysqlCluster#access}

---

##### `allowRegenerationHost`<sup>Optional</sup> <a name="allowRegenerationHost" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.allowRegenerationHost"></a>

```typescript
public readonly allowRegenerationHost: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#allow_regeneration_host MdbMysqlCluster#allow_regeneration_host}.

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbMysqlClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_window_start MdbMysqlCluster#backup_window_start}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#deletion_protection MdbMysqlCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#description MdbMysqlCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#folder_id MdbMysqlCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#id MdbMysqlCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#labels MdbMysqlCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbMysqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#maintenance_window MdbMysqlCluster#maintenance_window}

---

##### `mysqlConfig`<sup>Optional</sup> <a name="mysqlConfig" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.mysqlConfig"></a>

```typescript
public readonly mysqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#mysql_config MdbMysqlCluster#mysql_config}.

---

##### `restore`<sup>Optional</sup> <a name="restore" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.restore"></a>

```typescript
public readonly restore: MdbMysqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a>

restore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#restore MdbMysqlCluster#restore}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#security_group_ids MdbMysqlCluster#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbMysqlClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbMysqlClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#timeouts MdbMysqlCluster#timeouts}

---

### MdbMysqlClusterDatabase <a name="MdbMysqlClusterDatabase" id="@cdktf/provider-yandex.MdbMysqlClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterDatabase.Initializer"></a>

```typescript
import { MdbMysqlClusterDatabase } from '@cdktf/provider-yandex'

const mdbMysqlClusterDatabase: MdbMysqlClusterDatabase = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterDatabase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}.

---

### MdbMysqlClusterHost <a name="MdbMysqlClusterHost" id="@cdktf/provider-yandex.MdbMysqlClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterHost.Initializer"></a>

```typescript
import { MdbMysqlClusterHost } from '@cdktf/provider-yandex'

const mdbMysqlClusterHost: MdbMysqlClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#zone MdbMysqlCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#assign_public_ip MdbMysqlCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.backupPriority">backupPriority</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_priority MdbMysqlCluster#backup_priority}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.priority">priority</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#priority MdbMysqlCluster#priority}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.replicationSourceName">replicationSourceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#replication_source_name MdbMysqlCluster#replication_source_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#subnet_id MdbMysqlCluster#subnet_id}. |

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#zone MdbMysqlCluster#zone}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#assign_public_ip MdbMysqlCluster#assign_public_ip}.

---

##### `backupPriority`<sup>Optional</sup> <a name="backupPriority" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.backupPriority"></a>

```typescript
public readonly backupPriority: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_priority MdbMysqlCluster#backup_priority}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#priority MdbMysqlCluster#priority}.

---

##### `replicationSourceName`<sup>Optional</sup> <a name="replicationSourceName" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.replicationSourceName"></a>

```typescript
public readonly replicationSourceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#replication_source_name MdbMysqlCluster#replication_source_name}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbMysqlClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#subnet_id MdbMysqlCluster#subnet_id}.

---

### MdbMysqlClusterMaintenanceWindow <a name="MdbMysqlClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbMysqlClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbMysqlClusterMaintenanceWindow: MdbMysqlClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#type MdbMysqlCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#day MdbMysqlCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hour MdbMysqlCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#type MdbMysqlCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#day MdbMysqlCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#hour MdbMysqlCluster#hour}.

---

### MdbMysqlClusterResources <a name="MdbMysqlClusterResources" id="@cdktf/provider-yandex.MdbMysqlClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterResources.Initializer"></a>

```typescript
import { MdbMysqlClusterResources } from '@cdktf/provider-yandex'

const mdbMysqlClusterResources: MdbMysqlClusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_size MdbMysqlCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_type_id MdbMysqlCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#resource_preset_id MdbMysqlCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbMysqlClusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_size MdbMysqlCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbMysqlClusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#disk_type_id MdbMysqlCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbMysqlClusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#resource_preset_id MdbMysqlCluster#resource_preset_id}.

---

### MdbMysqlClusterRestore <a name="MdbMysqlClusterRestore" id="@cdktf/provider-yandex.MdbMysqlClusterRestore"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterRestore.Initializer"></a>

```typescript
import { MdbMysqlClusterRestore } from '@cdktf/provider-yandex'

const mdbMysqlClusterRestore: MdbMysqlClusterRestore = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore.property.backupId">backupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_id MdbMysqlCluster#backup_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore.property.time">time</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#time MdbMysqlCluster#time}. |

---

##### `backupId`<sup>Required</sup> <a name="backupId" id="@cdktf/provider-yandex.MdbMysqlClusterRestore.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#backup_id MdbMysqlCluster#backup_id}.

---

##### `time`<sup>Optional</sup> <a name="time" id="@cdktf/provider-yandex.MdbMysqlClusterRestore.property.time"></a>

```typescript
public readonly time: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#time MdbMysqlCluster#time}.

---

### MdbMysqlClusterTimeouts <a name="MdbMysqlClusterTimeouts" id="@cdktf/provider-yandex.MdbMysqlClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterTimeouts.Initializer"></a>

```typescript
import { MdbMysqlClusterTimeouts } from '@cdktf/provider-yandex'

const mdbMysqlClusterTimeouts: MdbMysqlClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#create MdbMysqlCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#delete MdbMysqlCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#update MdbMysqlCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#create MdbMysqlCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#delete MdbMysqlCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbMysqlClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#update MdbMysqlCluster#update}.

---

### MdbMysqlClusterUser <a name="MdbMysqlClusterUser" id="@cdktf/provider-yandex.MdbMysqlClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterUser.Initializer"></a>

```typescript
import { MdbMysqlClusterUser } from '@cdktf/provider-yandex'

const mdbMysqlClusterUser: MdbMysqlClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#password MdbMysqlCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.authenticationPlugin">authenticationPlugin</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#authentication_plugin MdbMysqlCluster#authentication_plugin}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.connectionLimits">connectionLimits</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a></code> | connection_limits block. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.globalPermissions">globalPermissions</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#global_permissions MdbMysqlCluster#global_permissions}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]</code> | permission block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#name MdbMysqlCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#password MdbMysqlCluster#password}.

---

##### `authenticationPlugin`<sup>Optional</sup> <a name="authenticationPlugin" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.authenticationPlugin"></a>

```typescript
public readonly authenticationPlugin: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#authentication_plugin MdbMysqlCluster#authentication_plugin}.

---

##### `connectionLimits`<sup>Optional</sup> <a name="connectionLimits" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.connectionLimits"></a>

```typescript
public readonly connectionLimits: MdbMysqlClusterUserConnectionLimits;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a>

connection_limits block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#connection_limits MdbMysqlCluster#connection_limits}

---

##### `globalPermissions`<sup>Optional</sup> <a name="globalPermissions" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.globalPermissions"></a>

```typescript
public readonly globalPermissions: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#global_permissions MdbMysqlCluster#global_permissions}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbMysqlClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbMysqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#permission MdbMysqlCluster#permission}

---

### MdbMysqlClusterUserConnectionLimits <a name="MdbMysqlClusterUserConnectionLimits" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.Initializer"></a>

```typescript
import { MdbMysqlClusterUserConnectionLimits } from '@cdktf/provider-yandex'

const mdbMysqlClusterUserConnectionLimits: MdbMysqlClusterUserConnectionLimits = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxConnectionsPerHour">maxConnectionsPerHour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_connections_per_hour MdbMysqlCluster#max_connections_per_hour}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxQuestionsPerHour">maxQuestionsPerHour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_questions_per_hour MdbMysqlCluster#max_questions_per_hour}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxUpdatesPerHour">maxUpdatesPerHour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_updates_per_hour MdbMysqlCluster#max_updates_per_hour}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxUserConnections">maxUserConnections</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_user_connections MdbMysqlCluster#max_user_connections}. |

---

##### `maxConnectionsPerHour`<sup>Optional</sup> <a name="maxConnectionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxConnectionsPerHour"></a>

```typescript
public readonly maxConnectionsPerHour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_connections_per_hour MdbMysqlCluster#max_connections_per_hour}.

---

##### `maxQuestionsPerHour`<sup>Optional</sup> <a name="maxQuestionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxQuestionsPerHour"></a>

```typescript
public readonly maxQuestionsPerHour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_questions_per_hour MdbMysqlCluster#max_questions_per_hour}.

---

##### `maxUpdatesPerHour`<sup>Optional</sup> <a name="maxUpdatesPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxUpdatesPerHour"></a>

```typescript
public readonly maxUpdatesPerHour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_updates_per_hour MdbMysqlCluster#max_updates_per_hour}.

---

##### `maxUserConnections`<sup>Optional</sup> <a name="maxUserConnections" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits.property.maxUserConnections"></a>

```typescript
public readonly maxUserConnections: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#max_user_connections MdbMysqlCluster#max_user_connections}.

---

### MdbMysqlClusterUserPermission <a name="MdbMysqlClusterUserPermission" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermission.Initializer"></a>

```typescript
import { MdbMysqlClusterUserPermission } from '@cdktf/provider-yandex'

const mdbMysqlClusterUserPermission: MdbMysqlClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission.property.databaseName">databaseName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#database_name MdbMysqlCluster#database_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission.property.roles">roles</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#roles MdbMysqlCluster#roles}. |

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermission.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#database_name MdbMysqlCluster#database_name}.

---

##### `roles`<sup>Optional</sup> <a name="roles" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermission.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_cluster#roles MdbMysqlCluster#roles}.

---

### MdbPostgresqlClusterConfig <a name="MdbPostgresqlClusterConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfig } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfig: MdbPostgresqlClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a></code> | config block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.database">database</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]</code> | database block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#environment MdbPostgresqlCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#network_id MdbPostgresqlCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]</code> | user block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#deletion_protection MdbPostgresqlCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#description MdbPostgresqlCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#folder_id MdbPostgresqlCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.hostMasterName">hostMasterName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#host_master_name MdbPostgresqlCluster#host_master_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#id MdbPostgresqlCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#labels MdbPostgresqlCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.restore">restore</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a></code> | restore block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#security_group_ids MdbPostgresqlCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.config"></a>

```typescript
public readonly config: MdbPostgresqlClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#config MdbPostgresqlCluster#config}

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.database"></a>

```typescript
public readonly database: IResolvable | MdbPostgresqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]

database block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#database MdbPostgresqlCluster#database}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#environment MdbPostgresqlCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbPostgresqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#host MdbPostgresqlCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#network_id MdbPostgresqlCluster#network_id}.

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbPostgresqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#user MdbPostgresqlCluster#user}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#deletion_protection MdbPostgresqlCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#description MdbPostgresqlCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#folder_id MdbPostgresqlCluster#folder_id}.

---

##### `hostMasterName`<sup>Optional</sup> <a name="hostMasterName" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.hostMasterName"></a>

```typescript
public readonly hostMasterName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#host_master_name MdbPostgresqlCluster#host_master_name}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#id MdbPostgresqlCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#labels MdbPostgresqlCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbPostgresqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#maintenance_window MdbPostgresqlCluster#maintenance_window}

---

##### `restore`<sup>Optional</sup> <a name="restore" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.restore"></a>

```typescript
public readonly restore: MdbPostgresqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a>

restore block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#restore MdbPostgresqlCluster#restore}

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#security_group_ids MdbPostgresqlCluster#security_group_ids}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbPostgresqlClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#timeouts MdbPostgresqlCluster#timeouts}

---

### MdbPostgresqlClusterConfigA <a name="MdbPostgresqlClusterConfigA" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigA } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigA: MdbPostgresqlClusterConfigA = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a></code> | access block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.autofailover">autofailover</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#autofailover MdbPostgresqlCluster#autofailover}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.backupRetainPeriodDays">backupRetainPeriodDays</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_retain_period_days MdbPostgresqlCluster#backup_retain_period_days}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.performanceDiagnostics">performanceDiagnostics</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a></code> | performance_diagnostics block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.poolerConfig">poolerConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a></code> | pooler_config block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.postgresqlConfig">postgresqlConfig</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#postgresql_config MdbPostgresqlCluster#postgresql_config}. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.resources"></a>

```typescript
public readonly resources: MdbPostgresqlClusterConfigResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#resources MdbPostgresqlCluster#resources}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}.

---

##### `access`<sup>Optional</sup> <a name="access" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.access"></a>

```typescript
public readonly access: MdbPostgresqlClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a>

access block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#access MdbPostgresqlCluster#access}

---

##### `autofailover`<sup>Optional</sup> <a name="autofailover" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.autofailover"></a>

```typescript
public readonly autofailover: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#autofailover MdbPostgresqlCluster#autofailover}.

---

##### `backupRetainPeriodDays`<sup>Optional</sup> <a name="backupRetainPeriodDays" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.backupRetainPeriodDays"></a>

```typescript
public readonly backupRetainPeriodDays: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_retain_period_days MdbPostgresqlCluster#backup_retain_period_days}.

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbPostgresqlClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_window_start MdbPostgresqlCluster#backup_window_start}

---

##### `performanceDiagnostics`<sup>Optional</sup> <a name="performanceDiagnostics" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.performanceDiagnostics"></a>

```typescript
public readonly performanceDiagnostics: MdbPostgresqlClusterConfigPerformanceDiagnostics;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a>

performance_diagnostics block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#performance_diagnostics MdbPostgresqlCluster#performance_diagnostics}

---

##### `poolerConfig`<sup>Optional</sup> <a name="poolerConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.poolerConfig"></a>

```typescript
public readonly poolerConfig: MdbPostgresqlClusterConfigPoolerConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a>

pooler_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pooler_config MdbPostgresqlCluster#pooler_config}

---

##### `postgresqlConfig`<sup>Optional</sup> <a name="postgresqlConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigA.property.postgresqlConfig"></a>

```typescript
public readonly postgresqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#postgresql_config MdbPostgresqlCluster#postgresql_config}.

---

### MdbPostgresqlClusterConfigAccess <a name="MdbPostgresqlClusterConfigAccess" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigAccess } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigAccess: MdbPostgresqlClusterConfigAccess = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#data_lens MdbPostgresqlCluster#data_lens}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.serverless">serverless</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#serverless MdbPostgresqlCluster#serverless}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#web_sql MdbPostgresqlCluster#web_sql}. |

---

##### `dataLens`<sup>Optional</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#data_lens MdbPostgresqlCluster#data_lens}.

---

##### `serverless`<sup>Optional</sup> <a name="serverless" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.serverless"></a>

```typescript
public readonly serverless: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#serverless MdbPostgresqlCluster#serverless}.

---

##### `webSql`<sup>Optional</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#web_sql MdbPostgresqlCluster#web_sql}.

---

### MdbPostgresqlClusterConfigBackupWindowStart <a name="MdbPostgresqlClusterConfigBackupWindowStart" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigBackupWindowStart } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigBackupWindowStart: MdbPostgresqlClusterConfigBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hours MdbPostgresqlCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#minutes MdbPostgresqlCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hours MdbPostgresqlCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#minutes MdbPostgresqlCluster#minutes}.

---

### MdbPostgresqlClusterConfigPerformanceDiagnostics <a name="MdbPostgresqlClusterConfigPerformanceDiagnostics" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigPerformanceDiagnostics } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigPerformanceDiagnostics: MdbPostgresqlClusterConfigPerformanceDiagnostics = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.sessionsSamplingInterval">sessionsSamplingInterval</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#sessions_sampling_interval MdbPostgresqlCluster#sessions_sampling_interval}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.statementsSamplingInterval">statementsSamplingInterval</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#statements_sampling_interval MdbPostgresqlCluster#statements_sampling_interval}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#enabled MdbPostgresqlCluster#enabled}. |

---

##### `sessionsSamplingInterval`<sup>Required</sup> <a name="sessionsSamplingInterval" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.sessionsSamplingInterval"></a>

```typescript
public readonly sessionsSamplingInterval: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#sessions_sampling_interval MdbPostgresqlCluster#sessions_sampling_interval}.

---

##### `statementsSamplingInterval`<sup>Required</sup> <a name="statementsSamplingInterval" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.statementsSamplingInterval"></a>

```typescript
public readonly statementsSamplingInterval: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#statements_sampling_interval MdbPostgresqlCluster#statements_sampling_interval}.

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#enabled MdbPostgresqlCluster#enabled}.

---

### MdbPostgresqlClusterConfigPoolerConfig <a name="MdbPostgresqlClusterConfigPoolerConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigPoolerConfig } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigPoolerConfig: MdbPostgresqlClusterConfigPoolerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig.property.poolDiscard">poolDiscard</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pool_discard MdbPostgresqlCluster#pool_discard}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig.property.poolingMode">poolingMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pooling_mode MdbPostgresqlCluster#pooling_mode}. |

---

##### `poolDiscard`<sup>Optional</sup> <a name="poolDiscard" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig.property.poolDiscard"></a>

```typescript
public readonly poolDiscard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pool_discard MdbPostgresqlCluster#pool_discard}.

---

##### `poolingMode`<sup>Optional</sup> <a name="poolingMode" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig.property.poolingMode"></a>

```typescript
public readonly poolingMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#pooling_mode MdbPostgresqlCluster#pooling_mode}.

---

### MdbPostgresqlClusterConfigResources <a name="MdbPostgresqlClusterConfigResources" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigResources } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterConfigResources: MdbPostgresqlClusterConfigResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_size MdbPostgresqlCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#resource_preset_id MdbPostgresqlCluster#resource_preset_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_type_id MdbPostgresqlCluster#disk_type_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_size MdbPostgresqlCluster#disk_size}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#resource_preset_id MdbPostgresqlCluster#resource_preset_id}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#disk_type_id MdbPostgresqlCluster#disk_type_id}.

---

### MdbPostgresqlClusterDatabase <a name="MdbPostgresqlClusterDatabase" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabase } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterDatabase: MdbPostgresqlClusterDatabase = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.owner">owner</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#owner MdbPostgresqlCluster#owner}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.extension">extension</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]</code> | extension block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.lcCollate">lcCollate</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_collate MdbPostgresqlCluster#lc_collate}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.lcType">lcType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_type MdbPostgresqlCluster#lc_type}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}.

---

##### `owner`<sup>Required</sup> <a name="owner" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#owner MdbPostgresqlCluster#owner}.

---

##### `extension`<sup>Optional</sup> <a name="extension" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.extension"></a>

```typescript
public readonly extension: IResolvable | MdbPostgresqlClusterDatabaseExtension[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]

extension block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#extension MdbPostgresqlCluster#extension}

---

##### `lcCollate`<sup>Optional</sup> <a name="lcCollate" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.lcCollate"></a>

```typescript
public readonly lcCollate: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_collate MdbPostgresqlCluster#lc_collate}.

---

##### `lcType`<sup>Optional</sup> <a name="lcType" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabase.property.lcType"></a>

```typescript
public readonly lcType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#lc_type MdbPostgresqlCluster#lc_type}.

---

### MdbPostgresqlClusterDatabaseExtension <a name="MdbPostgresqlClusterDatabaseExtension" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabaseExtension } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterDatabaseExtension: MdbPostgresqlClusterDatabaseExtension = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}.

---

##### `version`<sup>Optional</sup> <a name="version" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#version MdbPostgresqlCluster#version}.

---

### MdbPostgresqlClusterHost <a name="MdbPostgresqlClusterHost" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.Initializer"></a>

```typescript
import { MdbPostgresqlClusterHost } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterHost: MdbPostgresqlClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#zone MdbPostgresqlCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#assign_public_ip MdbPostgresqlCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.priority">priority</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#priority MdbPostgresqlCluster#priority}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.replicationSourceName">replicationSourceName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#replication_source_name MdbPostgresqlCluster#replication_source_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#subnet_id MdbPostgresqlCluster#subnet_id}. |

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#zone MdbPostgresqlCluster#zone}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#assign_public_ip MdbPostgresqlCluster#assign_public_ip}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#priority MdbPostgresqlCluster#priority}.

---

##### `replicationSourceName`<sup>Optional</sup> <a name="replicationSourceName" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.replicationSourceName"></a>

```typescript
public readonly replicationSourceName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#replication_source_name MdbPostgresqlCluster#replication_source_name}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbPostgresqlClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#subnet_id MdbPostgresqlCluster#subnet_id}.

---

### MdbPostgresqlClusterMaintenanceWindow <a name="MdbPostgresqlClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbPostgresqlClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterMaintenanceWindow: MdbPostgresqlClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#type MdbPostgresqlCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#day MdbPostgresqlCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hour MdbPostgresqlCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#type MdbPostgresqlCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#day MdbPostgresqlCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#hour MdbPostgresqlCluster#hour}.

---

### MdbPostgresqlClusterRestore <a name="MdbPostgresqlClusterRestore" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestore"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestore.Initializer"></a>

```typescript
import { MdbPostgresqlClusterRestore } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterRestore: MdbPostgresqlClusterRestore = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.backupId">backupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_id MdbPostgresqlCluster#backup_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.time">time</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time MdbPostgresqlCluster#time}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.timeInclusive">timeInclusive</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time_inclusive MdbPostgresqlCluster#time_inclusive}. |

---

##### `backupId`<sup>Required</sup> <a name="backupId" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#backup_id MdbPostgresqlCluster#backup_id}.

---

##### `time`<sup>Optional</sup> <a name="time" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.time"></a>

```typescript
public readonly time: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time MdbPostgresqlCluster#time}.

---

##### `timeInclusive`<sup>Optional</sup> <a name="timeInclusive" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestore.property.timeInclusive"></a>

```typescript
public readonly timeInclusive: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#time_inclusive MdbPostgresqlCluster#time_inclusive}.

---

### MdbPostgresqlClusterTimeouts <a name="MdbPostgresqlClusterTimeouts" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.Initializer"></a>

```typescript
import { MdbPostgresqlClusterTimeouts } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterTimeouts: MdbPostgresqlClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#create MdbPostgresqlCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#delete MdbPostgresqlCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#update MdbPostgresqlCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#create MdbPostgresqlCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#delete MdbPostgresqlCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#update MdbPostgresqlCluster#update}.

---

### MdbPostgresqlClusterUser <a name="MdbPostgresqlClusterUser" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUser } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterUser: MdbPostgresqlClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#password MdbPostgresqlCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.connLimit">connLimit</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#conn_limit MdbPostgresqlCluster#conn_limit}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.grants">grants</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#grants MdbPostgresqlCluster#grants}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.login">login</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#login MdbPostgresqlCluster#login}. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]</code> | permission block. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.settings">settings</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#settings MdbPostgresqlCluster#settings}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#name MdbPostgresqlCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#password MdbPostgresqlCluster#password}.

---

##### `connLimit`<sup>Optional</sup> <a name="connLimit" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.connLimit"></a>

```typescript
public readonly connLimit: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#conn_limit MdbPostgresqlCluster#conn_limit}.

---

##### `grants`<sup>Optional</sup> <a name="grants" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.grants"></a>

```typescript
public readonly grants: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#grants MdbPostgresqlCluster#grants}.

---

##### `login`<sup>Optional</sup> <a name="login" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.login"></a>

```typescript
public readonly login: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#login MdbPostgresqlCluster#login}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbPostgresqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#permission MdbPostgresqlCluster#permission}

---

##### `settings`<sup>Optional</sup> <a name="settings" id="@cdktf/provider-yandex.MdbPostgresqlClusterUser.property.settings"></a>

```typescript
public readonly settings: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#settings MdbPostgresqlCluster#settings}.

---

### MdbPostgresqlClusterUserPermission <a name="MdbPostgresqlClusterUserPermission" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUserPermission } from '@cdktf/provider-yandex'

const mdbPostgresqlClusterUserPermission: MdbPostgresqlClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission.property.databaseName">databaseName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#database_name MdbPostgresqlCluster#database_name}. |

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_postgresql_cluster#database_name MdbPostgresqlCluster#database_name}.

---

### MdbRedisClusterConfig <a name="MdbRedisClusterConfig" id="@cdktf/provider-yandex.MdbRedisClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterConfig.Initializer"></a>

```typescript
import { MdbRedisClusterConfig } from '@cdktf/provider-yandex'

const mdbRedisClusterConfig: MdbRedisClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a></code> | config block. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#environment MdbRedisCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#name MdbRedisCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#network_id MdbRedisCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#deletion_protection MdbRedisCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#description MdbRedisCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#folder_id MdbRedisCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#id MdbRedisCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#labels MdbRedisCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a></code> | maintenance_window block. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.persistenceMode">persistenceMode</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#persistence_mode MdbRedisCluster#persistence_mode}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#security_group_ids MdbRedisCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.sharded">sharded</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#sharded MdbRedisCluster#sharded}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfig.property.tlsEnabled">tlsEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#tls_enabled MdbRedisCluster#tls_enabled}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.config"></a>

```typescript
public readonly config: MdbRedisClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a>

config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#config MdbRedisCluster#config}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#environment MdbRedisCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbRedisClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#host MdbRedisCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#name MdbRedisCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#network_id MdbRedisCluster#network_id}.

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.resources"></a>

```typescript
public readonly resources: MdbRedisClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#resources MdbRedisCluster#resources}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#deletion_protection MdbRedisCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#description MdbRedisCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#folder_id MdbRedisCluster#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#id MdbRedisCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#labels MdbRedisCluster#labels}.

---

##### `maintenanceWindow`<sup>Optional</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: MdbRedisClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a>

maintenance_window block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#maintenance_window MdbRedisCluster#maintenance_window}

---

##### `persistenceMode`<sup>Optional</sup> <a name="persistenceMode" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.persistenceMode"></a>

```typescript
public readonly persistenceMode: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#persistence_mode MdbRedisCluster#persistence_mode}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#security_group_ids MdbRedisCluster#security_group_ids}.

---

##### `sharded`<sup>Optional</sup> <a name="sharded" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.sharded"></a>

```typescript
public readonly sharded: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#sharded MdbRedisCluster#sharded}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbRedisClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#timeouts MdbRedisCluster#timeouts}

---

##### `tlsEnabled`<sup>Optional</sup> <a name="tlsEnabled" id="@cdktf/provider-yandex.MdbRedisClusterConfig.property.tlsEnabled"></a>

```typescript
public readonly tlsEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#tls_enabled MdbRedisCluster#tls_enabled}.

---

### MdbRedisClusterConfigA <a name="MdbRedisClusterConfigA" id="@cdktf/provider-yandex.MdbRedisClusterConfigA"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.Initializer"></a>

```typescript
import { MdbRedisClusterConfigA } from '@cdktf/provider-yandex'

const mdbRedisClusterConfigA: MdbRedisClusterConfigA = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#password MdbRedisCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#version MdbRedisCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.databases">databases</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#databases MdbRedisCluster#databases}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.maxmemoryPolicy">maxmemoryPolicy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#maxmemory_policy MdbRedisCluster#maxmemory_policy}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.notifyKeyspaceEvents">notifyKeyspaceEvents</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#notify_keyspace_events MdbRedisCluster#notify_keyspace_events}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.slowlogLogSlowerThan">slowlogLogSlowerThan</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#slowlog_log_slower_than MdbRedisCluster#slowlog_log_slower_than}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.slowlogMaxLen">slowlogMaxLen</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#slowlog_max_len MdbRedisCluster#slowlog_max_len}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA.property.timeout">timeout</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#timeout MdbRedisCluster#timeout}. |

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#password MdbRedisCluster#password}.

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#version MdbRedisCluster#version}.

---

##### `databases`<sup>Optional</sup> <a name="databases" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.databases"></a>

```typescript
public readonly databases: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#databases MdbRedisCluster#databases}.

---

##### `maxmemoryPolicy`<sup>Optional</sup> <a name="maxmemoryPolicy" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.maxmemoryPolicy"></a>

```typescript
public readonly maxmemoryPolicy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#maxmemory_policy MdbRedisCluster#maxmemory_policy}.

---

##### `notifyKeyspaceEvents`<sup>Optional</sup> <a name="notifyKeyspaceEvents" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.notifyKeyspaceEvents"></a>

```typescript
public readonly notifyKeyspaceEvents: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#notify_keyspace_events MdbRedisCluster#notify_keyspace_events}.

---

##### `slowlogLogSlowerThan`<sup>Optional</sup> <a name="slowlogLogSlowerThan" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.slowlogLogSlowerThan"></a>

```typescript
public readonly slowlogLogSlowerThan: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#slowlog_log_slower_than MdbRedisCluster#slowlog_log_slower_than}.

---

##### `slowlogMaxLen`<sup>Optional</sup> <a name="slowlogMaxLen" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.slowlogMaxLen"></a>

```typescript
public readonly slowlogMaxLen: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#slowlog_max_len MdbRedisCluster#slowlog_max_len}.

---

##### `timeout`<sup>Optional</sup> <a name="timeout" id="@cdktf/provider-yandex.MdbRedisClusterConfigA.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#timeout MdbRedisCluster#timeout}.

---

### MdbRedisClusterHost <a name="MdbRedisClusterHost" id="@cdktf/provider-yandex.MdbRedisClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterHost.Initializer"></a>

```typescript
import { MdbRedisClusterHost } from '@cdktf/provider-yandex'

const mdbRedisClusterHost: MdbRedisClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#zone MdbRedisCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHost.property.shardName">shardName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#shard_name MdbRedisCluster#shard_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#subnet_id MdbRedisCluster#subnet_id}. |

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbRedisClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#zone MdbRedisCluster#zone}.

---

##### `shardName`<sup>Optional</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbRedisClusterHost.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#shard_name MdbRedisCluster#shard_name}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbRedisClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#subnet_id MdbRedisCluster#subnet_id}.

---

### MdbRedisClusterMaintenanceWindow <a name="MdbRedisClusterMaintenanceWindow" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.Initializer"></a>

```typescript
import { MdbRedisClusterMaintenanceWindow } from '@cdktf/provider-yandex'

const mdbRedisClusterMaintenanceWindow: MdbRedisClusterMaintenanceWindow = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#type MdbRedisCluster#type}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.day">day</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#day MdbRedisCluster#day}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.hour">hour</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#hour MdbRedisCluster#hour}. |

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#type MdbRedisCluster#type}.

---

##### `day`<sup>Optional</sup> <a name="day" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#day MdbRedisCluster#day}.

---

##### `hour`<sup>Optional</sup> <a name="hour" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#hour MdbRedisCluster#hour}.

---

### MdbRedisClusterResources <a name="MdbRedisClusterResources" id="@cdktf/provider-yandex.MdbRedisClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterResources.Initializer"></a>

```typescript
import { MdbRedisClusterResources } from '@cdktf/provider-yandex'

const mdbRedisClusterResources: MdbRedisClusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#disk_size MdbRedisCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#resource_preset_id MdbRedisCluster#resource_preset_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#disk_type_id MdbRedisCluster#disk_type_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbRedisClusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#disk_size MdbRedisCluster#disk_size}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbRedisClusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#resource_preset_id MdbRedisCluster#resource_preset_id}.

---

##### `diskTypeId`<sup>Optional</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbRedisClusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#disk_type_id MdbRedisCluster#disk_type_id}.

---

### MdbRedisClusterTimeouts <a name="MdbRedisClusterTimeouts" id="@cdktf/provider-yandex.MdbRedisClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbRedisClusterTimeouts.Initializer"></a>

```typescript
import { MdbRedisClusterTimeouts } from '@cdktf/provider-yandex'

const mdbRedisClusterTimeouts: MdbRedisClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#create MdbRedisCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#delete MdbRedisCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#update MdbRedisCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#create MdbRedisCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#delete MdbRedisCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbRedisClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_redis_cluster#update MdbRedisCluster#update}.

---

### MdbSqlserverClusterBackupWindowStart <a name="MdbSqlserverClusterBackupWindowStart" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart.Initializer"></a>

```typescript
import { MdbSqlserverClusterBackupWindowStart } from '@cdktf/provider-yandex'

const mdbSqlserverClusterBackupWindowStart: MdbSqlserverClusterBackupWindowStart = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart.property.hours">hours</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#hours MdbSqlserverCluster#hours}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart.property.minutes">minutes</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#minutes MdbSqlserverCluster#minutes}. |

---

##### `hours`<sup>Optional</sup> <a name="hours" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#hours MdbSqlserverCluster#hours}.

---

##### `minutes`<sup>Optional</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#minutes MdbSqlserverCluster#minutes}.

---

### MdbSqlserverClusterConfig <a name="MdbSqlserverClusterConfig" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.Initializer"></a>

```typescript
import { MdbSqlserverClusterConfig } from '@cdktf/provider-yandex'

const mdbSqlserverClusterConfig: MdbSqlserverClusterConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.database">database</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]</code> | database block. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.environment">environment</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#environment MdbSqlserverCluster#environment}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.host">host</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]</code> | host block. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#network_id MdbSqlserverCluster#network_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a></code> | resources block. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.user">user</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]</code> | user block. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.version">version</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#version MdbSqlserverCluster#version}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a></code> | backup_window_start block. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.deletionProtection">deletionProtection</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#deletion_protection MdbSqlserverCluster#deletion_protection}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#description MdbSqlserverCluster#description}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#folder_id MdbSqlserverCluster#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.hostGroupIds">hostGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#host_group_ids MdbSqlserverCluster#host_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#id MdbSqlserverCluster#id}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#labels MdbSqlserverCluster#labels}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#security_group_ids MdbSqlserverCluster#security_group_ids}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.sqlserverConfig">sqlserverConfig</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#sqlserver_config MdbSqlserverCluster#sqlserver_config}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.database"></a>

```typescript
public readonly database: IResolvable | MdbSqlserverClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]

database block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#database MdbSqlserverCluster#database}

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.environment"></a>

```typescript
public readonly environment: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#environment MdbSqlserverCluster#environment}.

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.host"></a>

```typescript
public readonly host: IResolvable | MdbSqlserverClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]

host block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#host MdbSqlserverCluster#host}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#network_id MdbSqlserverCluster#network_id}.

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.resources"></a>

```typescript
public readonly resources: MdbSqlserverClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a>

resources block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#resources MdbSqlserverCluster#resources}

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.user"></a>

```typescript
public readonly user: IResolvable | MdbSqlserverClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]

user block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#user MdbSqlserverCluster#user}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#version MdbSqlserverCluster#version}.

---

##### `backupWindowStart`<sup>Optional</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbSqlserverClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a>

backup_window_start block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#backup_window_start MdbSqlserverCluster#backup_window_start}

---

##### `deletionProtection`<sup>Optional</sup> <a name="deletionProtection" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.deletionProtection"></a>

```typescript
public readonly deletionProtection: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#deletion_protection MdbSqlserverCluster#deletion_protection}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#description MdbSqlserverCluster#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#folder_id MdbSqlserverCluster#folder_id}.

---

##### `hostGroupIds`<sup>Optional</sup> <a name="hostGroupIds" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.hostGroupIds"></a>

```typescript
public readonly hostGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#host_group_ids MdbSqlserverCluster#host_group_ids}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#id MdbSqlserverCluster#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#labels MdbSqlserverCluster#labels}.

---

##### `securityGroupIds`<sup>Optional</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#security_group_ids MdbSqlserverCluster#security_group_ids}.

---

##### `sqlserverConfig`<sup>Optional</sup> <a name="sqlserverConfig" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.sqlserverConfig"></a>

```typescript
public readonly sqlserverConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#sqlserver_config MdbSqlserverCluster#sqlserver_config}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.MdbSqlserverClusterConfig.property.timeouts"></a>

```typescript
public readonly timeouts: MdbSqlserverClusterTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#timeouts MdbSqlserverCluster#timeouts}

---

### MdbSqlserverClusterDatabase <a name="MdbSqlserverClusterDatabase" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabase"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabase.Initializer"></a>

```typescript
import { MdbSqlserverClusterDatabase } from '@cdktf/provider-yandex'

const mdbSqlserverClusterDatabase: MdbSqlserverClusterDatabase = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabase.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}.

---

### MdbSqlserverClusterHost <a name="MdbSqlserverClusterHost" id="@cdktf/provider-yandex.MdbSqlserverClusterHost"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterHost.Initializer"></a>

```typescript
import { MdbSqlserverClusterHost } from '@cdktf/provider-yandex'

const mdbSqlserverClusterHost: MdbSqlserverClusterHost = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#zone MdbSqlserverCluster#zone}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#assign_public_ip MdbSqlserverCluster#assign_public_ip}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost.property.subnetId">subnetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#subnet_id MdbSqlserverCluster#subnet_id}. |

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbSqlserverClusterHost.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#zone MdbSqlserverCluster#zone}.

---

##### `assignPublicIp`<sup>Optional</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbSqlserverClusterHost.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#assign_public_ip MdbSqlserverCluster#assign_public_ip}.

---

##### `subnetId`<sup>Optional</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbSqlserverClusterHost.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#subnet_id MdbSqlserverCluster#subnet_id}.

---

### MdbSqlserverClusterResources <a name="MdbSqlserverClusterResources" id="@cdktf/provider-yandex.MdbSqlserverClusterResources"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterResources.Initializer"></a>

```typescript
import { MdbSqlserverClusterResources } from '@cdktf/provider-yandex'

const mdbSqlserverClusterResources: MdbSqlserverClusterResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources.property.diskSize">diskSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#disk_size MdbSqlserverCluster#disk_size}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#disk_type_id MdbSqlserverCluster#disk_type_id}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#resource_preset_id MdbSqlserverCluster#resource_preset_id}. |

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbSqlserverClusterResources.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#disk_size MdbSqlserverCluster#disk_size}.

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbSqlserverClusterResources.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#disk_type_id MdbSqlserverCluster#disk_type_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbSqlserverClusterResources.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#resource_preset_id MdbSqlserverCluster#resource_preset_id}.

---

### MdbSqlserverClusterTimeouts <a name="MdbSqlserverClusterTimeouts" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.Initializer"></a>

```typescript
import { MdbSqlserverClusterTimeouts } from '@cdktf/provider-yandex'

const mdbSqlserverClusterTimeouts: MdbSqlserverClusterTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#create MdbSqlserverCluster#create}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#delete MdbSqlserverCluster#delete}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#update MdbSqlserverCluster#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#create MdbSqlserverCluster#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#delete MdbSqlserverCluster#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#update MdbSqlserverCluster#update}.

---

### MdbSqlserverClusterUser <a name="MdbSqlserverClusterUser" id="@cdktf/provider-yandex.MdbSqlserverClusterUser"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterUser.Initializer"></a>

```typescript
import { MdbSqlserverClusterUser } from '@cdktf/provider-yandex'

const mdbSqlserverClusterUser: MdbSqlserverClusterUser = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser.property.password">password</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#password MdbSqlserverCluster#password}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser.property.permission">permission</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]</code> | permission block. |

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverClusterUser.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#name MdbSqlserverCluster#name}.

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbSqlserverClusterUser.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#password MdbSqlserverCluster#password}.

---

##### `permission`<sup>Optional</sup> <a name="permission" id="@cdktf/provider-yandex.MdbSqlserverClusterUser.property.permission"></a>

```typescript
public readonly permission: IResolvable | MdbSqlserverClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]

permission block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#permission MdbSqlserverCluster#permission}

---

### MdbSqlserverClusterUserPermission <a name="MdbSqlserverClusterUserPermission" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermission"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermission.Initializer"></a>

```typescript
import { MdbSqlserverClusterUserPermission } from '@cdktf/provider-yandex'

const mdbSqlserverClusterUserPermission: MdbSqlserverClusterUserPermission = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission.property.databaseName">databaseName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#database_name MdbSqlserverCluster#database_name}. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission.property.roles">roles</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#roles MdbSqlserverCluster#roles}. |

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermission.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#database_name MdbSqlserverCluster#database_name}.

---

##### `roles`<sup>Optional</sup> <a name="roles" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermission.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_sqlserver_cluster#roles MdbSqlserverCluster#roles}.

---

### MessageQueueConfig <a name="MessageQueueConfig" id="@cdktf/provider-yandex.MessageQueueConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.MessageQueueConfig.Initializer"></a>

```typescript
import { MessageQueueConfig } from '@cdktf/provider-yandex'

const messageQueueConfig: MessageQueueConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.accessKey">accessKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#access_key MessageQueue#access_key}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.contentBasedDeduplication">contentBasedDeduplication</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#content_based_deduplication MessageQueue#content_based_deduplication}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.delaySeconds">delaySeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#delay_seconds MessageQueue#delay_seconds}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.fifoQueue">fifoQueue</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#fifo_queue MessageQueue#fifo_queue}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#id MessageQueue#id}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.maxMessageSize">maxMessageSize</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#max_message_size MessageQueue#max_message_size}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.messageRetentionSeconds">messageRetentionSeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#message_retention_seconds MessageQueue#message_retention_seconds}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#name MessageQueue#name}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.namePrefix">namePrefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#name_prefix MessageQueue#name_prefix}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.receiveWaitTimeSeconds">receiveWaitTimeSeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#receive_wait_time_seconds MessageQueue#receive_wait_time_seconds}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.redrivePolicy">redrivePolicy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#redrive_policy MessageQueue#redrive_policy}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.secretKey">secretKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#secret_key MessageQueue#secret_key}. |
| <code><a href="#@cdktf/provider-yandex.MessageQueueConfig.property.visibilityTimeoutSeconds">visibilityTimeoutSeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#visibility_timeout_seconds MessageQueue#visibility_timeout_seconds}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.MessageQueueConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.MessageQueueConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.MessageQueueConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.MessageQueueConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="@cdktf/provider-yandex.MessageQueueConfig.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#access_key MessageQueue#access_key}.

---

##### `contentBasedDeduplication`<sup>Optional</sup> <a name="contentBasedDeduplication" id="@cdktf/provider-yandex.MessageQueueConfig.property.contentBasedDeduplication"></a>

```typescript
public readonly contentBasedDeduplication: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#content_based_deduplication MessageQueue#content_based_deduplication}.

---

##### `delaySeconds`<sup>Optional</sup> <a name="delaySeconds" id="@cdktf/provider-yandex.MessageQueueConfig.property.delaySeconds"></a>

```typescript
public readonly delaySeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#delay_seconds MessageQueue#delay_seconds}.

---

##### `fifoQueue`<sup>Optional</sup> <a name="fifoQueue" id="@cdktf/provider-yandex.MessageQueueConfig.property.fifoQueue"></a>

```typescript
public readonly fifoQueue: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#fifo_queue MessageQueue#fifo_queue}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.MessageQueueConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#id MessageQueue#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `maxMessageSize`<sup>Optional</sup> <a name="maxMessageSize" id="@cdktf/provider-yandex.MessageQueueConfig.property.maxMessageSize"></a>

```typescript
public readonly maxMessageSize: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#max_message_size MessageQueue#max_message_size}.

---

##### `messageRetentionSeconds`<sup>Optional</sup> <a name="messageRetentionSeconds" id="@cdktf/provider-yandex.MessageQueueConfig.property.messageRetentionSeconds"></a>

```typescript
public readonly messageRetentionSeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#message_retention_seconds MessageQueue#message_retention_seconds}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.MessageQueueConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#name MessageQueue#name}.

---

##### `namePrefix`<sup>Optional</sup> <a name="namePrefix" id="@cdktf/provider-yandex.MessageQueueConfig.property.namePrefix"></a>

```typescript
public readonly namePrefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#name_prefix MessageQueue#name_prefix}.

---

##### `receiveWaitTimeSeconds`<sup>Optional</sup> <a name="receiveWaitTimeSeconds" id="@cdktf/provider-yandex.MessageQueueConfig.property.receiveWaitTimeSeconds"></a>

```typescript
public readonly receiveWaitTimeSeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#receive_wait_time_seconds MessageQueue#receive_wait_time_seconds}.

---

##### `redrivePolicy`<sup>Optional</sup> <a name="redrivePolicy" id="@cdktf/provider-yandex.MessageQueueConfig.property.redrivePolicy"></a>

```typescript
public readonly redrivePolicy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#redrive_policy MessageQueue#redrive_policy}.

---

##### `secretKey`<sup>Optional</sup> <a name="secretKey" id="@cdktf/provider-yandex.MessageQueueConfig.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#secret_key MessageQueue#secret_key}.

---

##### `visibilityTimeoutSeconds`<sup>Optional</sup> <a name="visibilityTimeoutSeconds" id="@cdktf/provider-yandex.MessageQueueConfig.property.visibilityTimeoutSeconds"></a>

```typescript
public readonly visibilityTimeoutSeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/message_queue#visibility_timeout_seconds MessageQueue#visibility_timeout_seconds}.

---

### OrganizationmanagerOrganizationIamBindingConfig <a name="OrganizationmanagerOrganizationIamBindingConfig" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.Initializer"></a>

```typescript
import { OrganizationmanagerOrganizationIamBindingConfig } from '@cdktf/provider-yandex'

const organizationmanagerOrganizationIamBindingConfig: OrganizationmanagerOrganizationIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#members OrganizationmanagerOrganizationIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#organization_id OrganizationmanagerOrganizationIamBinding#organization_id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#role OrganizationmanagerOrganizationIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#id OrganizationmanagerOrganizationIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#sleep_after OrganizationmanagerOrganizationIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#members OrganizationmanagerOrganizationIamBinding#members}.

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#organization_id OrganizationmanagerOrganizationIamBinding#organization_id}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#role OrganizationmanagerOrganizationIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#id OrganizationmanagerOrganizationIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_binding#sleep_after OrganizationmanagerOrganizationIamBinding#sleep_after}.

---

### OrganizationmanagerOrganizationIamMemberConfig <a name="OrganizationmanagerOrganizationIamMemberConfig" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.Initializer"></a>

```typescript
import { OrganizationmanagerOrganizationIamMemberConfig } from '@cdktf/provider-yandex'

const organizationmanagerOrganizationIamMemberConfig: OrganizationmanagerOrganizationIamMemberConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.member">member</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#member OrganizationmanagerOrganizationIamMember#member}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#organization_id OrganizationmanagerOrganizationIamMember#organization_id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#role OrganizationmanagerOrganizationIamMember#role}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#id OrganizationmanagerOrganizationIamMember#id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#sleep_after OrganizationmanagerOrganizationIamMember#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#member OrganizationmanagerOrganizationIamMember#member}.

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#organization_id OrganizationmanagerOrganizationIamMember#organization_id}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#role OrganizationmanagerOrganizationIamMember#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#id OrganizationmanagerOrganizationIamMember#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.OrganizationmanagerOrganizationIamMemberConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_organization_iam_member#sleep_after OrganizationmanagerOrganizationIamMember#sleep_after}.

---

### OrganizationmanagerSamlFederationConfig <a name="OrganizationmanagerSamlFederationConfig" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederationConfig } from '@cdktf/provider-yandex'

const organizationmanagerSamlFederationConfig: OrganizationmanagerSamlFederationConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.issuer">issuer</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#issuer OrganizationmanagerSamlFederation#issuer}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#name OrganizationmanagerSamlFederation#name}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#organization_id OrganizationmanagerSamlFederation#organization_id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.ssoBinding">ssoBinding</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_binding OrganizationmanagerSamlFederation#sso_binding}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.ssoUrl">ssoUrl</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_url OrganizationmanagerSamlFederation#sso_url}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.autoCreateAccountOnLogin">autoCreateAccountOnLogin</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#auto_create_account_on_login OrganizationmanagerSamlFederation#auto_create_account_on_login}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.caseInsensitiveNameIds">caseInsensitiveNameIds</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#case_insensitive_name_ids OrganizationmanagerSamlFederation#case_insensitive_name_ids}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.cookieMaxAge">cookieMaxAge</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#cookie_max_age OrganizationmanagerSamlFederation#cookie_max_age}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#description OrganizationmanagerSamlFederation#description}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#id OrganizationmanagerSamlFederation#id}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#labels OrganizationmanagerSamlFederation#labels}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.securitySettings">securitySettings</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a></code> | security_settings block. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `issuer`<sup>Required</sup> <a name="issuer" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.issuer"></a>

```typescript
public readonly issuer: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#issuer OrganizationmanagerSamlFederation#issuer}.

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#name OrganizationmanagerSamlFederation#name}.

---

##### `organizationId`<sup>Required</sup> <a name="organizationId" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#organization_id OrganizationmanagerSamlFederation#organization_id}.

---

##### `ssoBinding`<sup>Required</sup> <a name="ssoBinding" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.ssoBinding"></a>

```typescript
public readonly ssoBinding: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_binding OrganizationmanagerSamlFederation#sso_binding}.

---

##### `ssoUrl`<sup>Required</sup> <a name="ssoUrl" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.ssoUrl"></a>

```typescript
public readonly ssoUrl: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#sso_url OrganizationmanagerSamlFederation#sso_url}.

---

##### `autoCreateAccountOnLogin`<sup>Optional</sup> <a name="autoCreateAccountOnLogin" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.autoCreateAccountOnLogin"></a>

```typescript
public readonly autoCreateAccountOnLogin: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#auto_create_account_on_login OrganizationmanagerSamlFederation#auto_create_account_on_login}.

---

##### `caseInsensitiveNameIds`<sup>Optional</sup> <a name="caseInsensitiveNameIds" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.caseInsensitiveNameIds"></a>

```typescript
public readonly caseInsensitiveNameIds: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#case_insensitive_name_ids OrganizationmanagerSamlFederation#case_insensitive_name_ids}.

---

##### `cookieMaxAge`<sup>Optional</sup> <a name="cookieMaxAge" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.cookieMaxAge"></a>

```typescript
public readonly cookieMaxAge: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#cookie_max_age OrganizationmanagerSamlFederation#cookie_max_age}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#description OrganizationmanagerSamlFederation#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#id OrganizationmanagerSamlFederation#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#labels OrganizationmanagerSamlFederation#labels}.

---

##### `securitySettings`<sup>Optional</sup> <a name="securitySettings" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.securitySettings"></a>

```typescript
public readonly securitySettings: OrganizationmanagerSamlFederationSecuritySettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a>

security_settings block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#security_settings OrganizationmanagerSamlFederation#security_settings}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationConfig.property.timeouts"></a>

```typescript
public readonly timeouts: OrganizationmanagerSamlFederationTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#timeouts OrganizationmanagerSamlFederation#timeouts}

---

### OrganizationmanagerSamlFederationSecuritySettings <a name="OrganizationmanagerSamlFederationSecuritySettings" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederationSecuritySettings } from '@cdktf/provider-yandex'

const organizationmanagerSamlFederationSecuritySettings: OrganizationmanagerSamlFederationSecuritySettings = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings.property.encryptedAssertions">encryptedAssertions</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#encrypted_assertions OrganizationmanagerSamlFederation#encrypted_assertions}. |

---

##### `encryptedAssertions`<sup>Required</sup> <a name="encryptedAssertions" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings.property.encryptedAssertions"></a>

```typescript
public readonly encryptedAssertions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#encrypted_assertions OrganizationmanagerSamlFederation#encrypted_assertions}.

---

### OrganizationmanagerSamlFederationTimeouts <a name="OrganizationmanagerSamlFederationTimeouts" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederationTimeouts } from '@cdktf/provider-yandex'

const organizationmanagerSamlFederationTimeouts: OrganizationmanagerSamlFederationTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#create OrganizationmanagerSamlFederation#create}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#delete OrganizationmanagerSamlFederation#delete}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#read OrganizationmanagerSamlFederation#read}. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#update OrganizationmanagerSamlFederation#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#create OrganizationmanagerSamlFederation#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#delete OrganizationmanagerSamlFederation#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#read OrganizationmanagerSamlFederation#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/organizationmanager_saml_federation#update OrganizationmanagerSamlFederation#update}.

---

### ResourcemanagerCloudConfig <a name="ResourcemanagerCloudConfig" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.Initializer"></a>

```typescript
import { ResourcemanagerCloudConfig } from '@cdktf/provider-yandex'

const resourcemanagerCloudConfig: ResourcemanagerCloudConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#description ResourcemanagerCloud#description}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#id ResourcemanagerCloud#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#labels ResourcemanagerCloud#labels}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#name ResourcemanagerCloud#name}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#organization_id ResourcemanagerCloud#organization_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#description ResourcemanagerCloud#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#id ResourcemanagerCloud#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#labels ResourcemanagerCloud#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#name ResourcemanagerCloud#name}.

---

##### `organizationId`<sup>Optional</sup> <a name="organizationId" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#organization_id ResourcemanagerCloud#organization_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ResourcemanagerCloudConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ResourcemanagerCloudTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#timeouts ResourcemanagerCloud#timeouts}

---

### ResourcemanagerCloudIamBindingConfig <a name="ResourcemanagerCloudIamBindingConfig" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.Initializer"></a>

```typescript
import { ResourcemanagerCloudIamBindingConfig } from '@cdktf/provider-yandex'

const resourcemanagerCloudIamBindingConfig: ResourcemanagerCloudIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.cloudId">cloudId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#cloud_id ResourcemanagerCloudIamBinding#cloud_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#members ResourcemanagerCloudIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#role ResourcemanagerCloudIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#id ResourcemanagerCloudIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#sleep_after ResourcemanagerCloudIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#cloud_id ResourcemanagerCloudIamBinding#cloud_id}.

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#members ResourcemanagerCloudIamBinding#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#role ResourcemanagerCloudIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#id ResourcemanagerCloudIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_binding#sleep_after ResourcemanagerCloudIamBinding#sleep_after}.

---

### ResourcemanagerCloudIamMemberConfig <a name="ResourcemanagerCloudIamMemberConfig" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.Initializer"></a>

```typescript
import { ResourcemanagerCloudIamMemberConfig } from '@cdktf/provider-yandex'

const resourcemanagerCloudIamMemberConfig: ResourcemanagerCloudIamMemberConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.cloudId">cloudId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#cloud_id ResourcemanagerCloudIamMember#cloud_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.member">member</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#member ResourcemanagerCloudIamMember#member}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#role ResourcemanagerCloudIamMember#role}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#id ResourcemanagerCloudIamMember#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#sleep_after ResourcemanagerCloudIamMember#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Required</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#cloud_id ResourcemanagerCloudIamMember#cloud_id}.

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#member ResourcemanagerCloudIamMember#member}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#role ResourcemanagerCloudIamMember#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#id ResourcemanagerCloudIamMember#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerCloudIamMemberConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud_iam_member#sleep_after ResourcemanagerCloudIamMember#sleep_after}.

---

### ResourcemanagerCloudTimeouts <a name="ResourcemanagerCloudTimeouts" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.Initializer"></a>

```typescript
import { ResourcemanagerCloudTimeouts } from '@cdktf/provider-yandex'

const resourcemanagerCloudTimeouts: ResourcemanagerCloudTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#create ResourcemanagerCloud#create}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#delete ResourcemanagerCloud#delete}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#read ResourcemanagerCloud#read}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#update ResourcemanagerCloud#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#create ResourcemanagerCloud#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#delete ResourcemanagerCloud#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#read ResourcemanagerCloud#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_cloud#update ResourcemanagerCloud#update}.

---

### ResourcemanagerFolderConfig <a name="ResourcemanagerFolderConfig" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.Initializer"></a>

```typescript
import { ResourcemanagerFolderConfig } from '@cdktf/provider-yandex'

const resourcemanagerFolderConfig: ResourcemanagerFolderConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.cloudId">cloudId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#cloud_id ResourcemanagerFolder#cloud_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#description ResourcemanagerFolder#description}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#id ResourcemanagerFolder#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#labels ResourcemanagerFolder#labels}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#name ResourcemanagerFolder#name}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#cloud_id ResourcemanagerFolder#cloud_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#description ResourcemanagerFolder#description}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#id ResourcemanagerFolder#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#labels ResourcemanagerFolder#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#name ResourcemanagerFolder#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ResourcemanagerFolderConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ResourcemanagerFolderTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#timeouts ResourcemanagerFolder#timeouts}

---

### ResourcemanagerFolderIamBindingConfig <a name="ResourcemanagerFolderIamBindingConfig" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamBindingConfig } from '@cdktf/provider-yandex'

const resourcemanagerFolderIamBindingConfig: ResourcemanagerFolderIamBindingConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#folder_id ResourcemanagerFolderIamBinding#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.members">members</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#members ResourcemanagerFolderIamBinding#members}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#role ResourcemanagerFolderIamBinding#role}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#id ResourcemanagerFolderIamBinding#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#sleep_after ResourcemanagerFolderIamBinding#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#folder_id ResourcemanagerFolderIamBinding#folder_id}.

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#members ResourcemanagerFolderIamBinding#members}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#role ResourcemanagerFolderIamBinding#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#id ResourcemanagerFolderIamBinding#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamBindingConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_binding#sleep_after ResourcemanagerFolderIamBinding#sleep_after}.

---

### ResourcemanagerFolderIamMemberConfig <a name="ResourcemanagerFolderIamMemberConfig" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamMemberConfig } from '@cdktf/provider-yandex'

const resourcemanagerFolderIamMemberConfig: ResourcemanagerFolderIamMemberConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#folder_id ResourcemanagerFolderIamMember#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.member">member</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#member ResourcemanagerFolderIamMember#member}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.role">role</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#role ResourcemanagerFolderIamMember#role}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#id ResourcemanagerFolderIamMember#id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.sleepAfter">sleepAfter</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#sleep_after ResourcemanagerFolderIamMember#sleep_after}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#folder_id ResourcemanagerFolderIamMember#folder_id}.

---

##### `member`<sup>Required</sup> <a name="member" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.member"></a>

```typescript
public readonly member: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#member ResourcemanagerFolderIamMember#member}.

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#role ResourcemanagerFolderIamMember#role}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#id ResourcemanagerFolderIamMember#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `sleepAfter`<sup>Optional</sup> <a name="sleepAfter" id="@cdktf/provider-yandex.ResourcemanagerFolderIamMemberConfig.property.sleepAfter"></a>

```typescript
public readonly sleepAfter: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_member#sleep_after ResourcemanagerFolderIamMember#sleep_after}.

---

### ResourcemanagerFolderIamPolicyConfig <a name="ResourcemanagerFolderIamPolicyConfig" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.Initializer"></a>

```typescript
import { ResourcemanagerFolderIamPolicyConfig } from '@cdktf/provider-yandex'

const resourcemanagerFolderIamPolicyConfig: ResourcemanagerFolderIamPolicyConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#folder_id ResourcemanagerFolderIamPolicy#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.policyData">policyData</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#policy_data ResourcemanagerFolderIamPolicy#policy_data}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#id ResourcemanagerFolderIamPolicy#id}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#folder_id ResourcemanagerFolderIamPolicy#folder_id}.

---

##### `policyData`<sup>Required</sup> <a name="policyData" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.policyData"></a>

```typescript
public readonly policyData: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#policy_data ResourcemanagerFolderIamPolicy#policy_data}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ResourcemanagerFolderIamPolicyConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder_iam_policy#id ResourcemanagerFolderIamPolicy#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### ResourcemanagerFolderTimeouts <a name="ResourcemanagerFolderTimeouts" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.Initializer"></a>

```typescript
import { ResourcemanagerFolderTimeouts } from '@cdktf/provider-yandex'

const resourcemanagerFolderTimeouts: ResourcemanagerFolderTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#create ResourcemanagerFolder#create}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#delete ResourcemanagerFolder#delete}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#read ResourcemanagerFolder#read}. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#update ResourcemanagerFolder#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#create ResourcemanagerFolder#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#delete ResourcemanagerFolder#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#read ResourcemanagerFolder#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/resourcemanager_folder#update ResourcemanagerFolder#update}.

---

### ServerlessContainerConfig <a name="ServerlessContainerConfig" id="@cdktf/provider-yandex.ServerlessContainerConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ServerlessContainerConfig.Initializer"></a>

```typescript
import { ServerlessContainerConfig } from '@cdktf/provider-yandex'

const serverlessContainerConfig: ServerlessContainerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.image">image</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a></code> | image block. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.memory">memory</a></code> | <code>number</code> | Container memory in megabytes, should be aligned to 128. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#name ServerlessContainer#name}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.concurrency">concurrency</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#concurrency ServerlessContainer#concurrency}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.coreFraction">coreFraction</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#core_fraction ServerlessContainer#core_fraction}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.cores">cores</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#cores ServerlessContainer#cores}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#description ServerlessContainer#description}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.executionTimeout">executionTimeout</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#execution_timeout ServerlessContainer#execution_timeout}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#folder_id ServerlessContainer#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#id ServerlessContainer#id}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#labels ServerlessContainer#labels}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#service_account_id ServerlessContainer#service_account_id}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `image`<sup>Required</sup> <a name="image" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.image"></a>

```typescript
public readonly image: ServerlessContainerImage;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a>

image block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#image ServerlessContainer#image}

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

Container memory in megabytes, should be aligned to 128.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#memory ServerlessContainer#memory}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#name ServerlessContainer#name}.

---

##### `concurrency`<sup>Optional</sup> <a name="concurrency" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.concurrency"></a>

```typescript
public readonly concurrency: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#concurrency ServerlessContainer#concurrency}.

---

##### `coreFraction`<sup>Optional</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#core_fraction ServerlessContainer#core_fraction}.

---

##### `cores`<sup>Optional</sup> <a name="cores" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#cores ServerlessContainer#cores}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#description ServerlessContainer#description}.

---

##### `executionTimeout`<sup>Optional</sup> <a name="executionTimeout" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.executionTimeout"></a>

```typescript
public readonly executionTimeout: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#execution_timeout ServerlessContainer#execution_timeout}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#folder_id ServerlessContainer#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#id ServerlessContainer#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#labels ServerlessContainer#labels}.

---

##### `serviceAccountId`<sup>Optional</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#service_account_id ServerlessContainer#service_account_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.ServerlessContainerConfig.property.timeouts"></a>

```typescript
public readonly timeouts: ServerlessContainerTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#timeouts ServerlessContainer#timeouts}

---

### ServerlessContainerImage <a name="ServerlessContainerImage" id="@cdktf/provider-yandex.ServerlessContainerImage"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ServerlessContainerImage.Initializer"></a>

```typescript
import { ServerlessContainerImage } from '@cdktf/provider-yandex'

const serverlessContainerImage: ServerlessContainerImage = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.url">url</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#url ServerlessContainer#url}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.args">args</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#args ServerlessContainer#args}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.command">command</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#command ServerlessContainer#command}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.digest">digest</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#digest ServerlessContainer#digest}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.environment">environment</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#environment ServerlessContainer#environment}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage.property.workDir">workDir</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#work_dir ServerlessContainer#work_dir}. |

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.ServerlessContainerImage.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#url ServerlessContainer#url}.

---

##### `args`<sup>Optional</sup> <a name="args" id="@cdktf/provider-yandex.ServerlessContainerImage.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#args ServerlessContainer#args}.

---

##### `command`<sup>Optional</sup> <a name="command" id="@cdktf/provider-yandex.ServerlessContainerImage.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#command ServerlessContainer#command}.

---

##### `digest`<sup>Optional</sup> <a name="digest" id="@cdktf/provider-yandex.ServerlessContainerImage.property.digest"></a>

```typescript
public readonly digest: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#digest ServerlessContainer#digest}.

---

##### `environment`<sup>Optional</sup> <a name="environment" id="@cdktf/provider-yandex.ServerlessContainerImage.property.environment"></a>

```typescript
public readonly environment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#environment ServerlessContainer#environment}.

---

##### `workDir`<sup>Optional</sup> <a name="workDir" id="@cdktf/provider-yandex.ServerlessContainerImage.property.workDir"></a>

```typescript
public readonly workDir: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#work_dir ServerlessContainer#work_dir}.

---

### ServerlessContainerTimeouts <a name="ServerlessContainerTimeouts" id="@cdktf/provider-yandex.ServerlessContainerTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.ServerlessContainerTimeouts.Initializer"></a>

```typescript
import { ServerlessContainerTimeouts } from '@cdktf/provider-yandex'

const serverlessContainerTimeouts: ServerlessContainerTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#create ServerlessContainer#create}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#delete ServerlessContainer#delete}. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#update ServerlessContainer#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.ServerlessContainerTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#create ServerlessContainer#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.ServerlessContainerTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#delete ServerlessContainer#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.ServerlessContainerTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/serverless_container#update ServerlessContainer#update}.

---

### StorageBucketConfig <a name="StorageBucketConfig" id="@cdktf/provider-yandex.StorageBucketConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketConfig.Initializer"></a>

```typescript
import { StorageBucketConfig } from '@cdktf/provider-yandex'

const storageBucketConfig: StorageBucketConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.accessKey">accessKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#access_key StorageBucket#access_key}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.acl">acl</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#acl StorageBucket#acl}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.bucket">bucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#bucket StorageBucket#bucket}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.bucketPrefix">bucketPrefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#bucket_prefix StorageBucket#bucket_prefix}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.corsRule">corsRule</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]</code> | cors_rule block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.forceDestroy">forceDestroy</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#force_destroy StorageBucket#force_destroy}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.grant">grant</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]</code> | grant block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.lifecycleRule">lifecycleRule</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]</code> | lifecycle_rule block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.logging">logging</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]</code> | logging block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.policy">policy</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#policy StorageBucket#policy}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.secretKey">secretKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#secret_key StorageBucket#secret_key}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.serverSideEncryptionConfiguration">serverSideEncryptionConfiguration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a></code> | server_side_encryption_configuration block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.versioning">versioning</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a></code> | versioning block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.website">website</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a></code> | website block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.websiteDomain">websiteDomain</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#website_domain StorageBucket#website_domain}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketConfig.property.websiteEndpoint">websiteEndpoint</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#website_endpoint StorageBucket#website_endpoint}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.StorageBucketConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.StorageBucketConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.StorageBucketConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.StorageBucketConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="@cdktf/provider-yandex.StorageBucketConfig.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#access_key StorageBucket#access_key}.

---

##### `acl`<sup>Optional</sup> <a name="acl" id="@cdktf/provider-yandex.StorageBucketConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#acl StorageBucket#acl}.

---

##### `bucket`<sup>Optional</sup> <a name="bucket" id="@cdktf/provider-yandex.StorageBucketConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#bucket StorageBucket#bucket}.

---

##### `bucketPrefix`<sup>Optional</sup> <a name="bucketPrefix" id="@cdktf/provider-yandex.StorageBucketConfig.property.bucketPrefix"></a>

```typescript
public readonly bucketPrefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#bucket_prefix StorageBucket#bucket_prefix}.

---

##### `corsRule`<sup>Optional</sup> <a name="corsRule" id="@cdktf/provider-yandex.StorageBucketConfig.property.corsRule"></a>

```typescript
public readonly corsRule: IResolvable | StorageBucketCorsRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]

cors_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#cors_rule StorageBucket#cors_rule}

---

##### `forceDestroy`<sup>Optional</sup> <a name="forceDestroy" id="@cdktf/provider-yandex.StorageBucketConfig.property.forceDestroy"></a>

```typescript
public readonly forceDestroy: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#force_destroy StorageBucket#force_destroy}.

---

##### `grant`<sup>Optional</sup> <a name="grant" id="@cdktf/provider-yandex.StorageBucketConfig.property.grant"></a>

```typescript
public readonly grant: IResolvable | StorageBucketGrant[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]

grant block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#grant StorageBucket#grant}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucketConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `lifecycleRule`<sup>Optional</sup> <a name="lifecycleRule" id="@cdktf/provider-yandex.StorageBucketConfig.property.lifecycleRule"></a>

```typescript
public readonly lifecycleRule: IResolvable | StorageBucketLifecycleRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]

lifecycle_rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#lifecycle_rule StorageBucket#lifecycle_rule}

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@cdktf/provider-yandex.StorageBucketConfig.property.logging"></a>

```typescript
public readonly logging: IResolvable | StorageBucketLogging[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]

logging block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#logging StorageBucket#logging}

---

##### `policy`<sup>Optional</sup> <a name="policy" id="@cdktf/provider-yandex.StorageBucketConfig.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#policy StorageBucket#policy}.

---

##### `secretKey`<sup>Optional</sup> <a name="secretKey" id="@cdktf/provider-yandex.StorageBucketConfig.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#secret_key StorageBucket#secret_key}.

---

##### `serverSideEncryptionConfiguration`<sup>Optional</sup> <a name="serverSideEncryptionConfiguration" id="@cdktf/provider-yandex.StorageBucketConfig.property.serverSideEncryptionConfiguration"></a>

```typescript
public readonly serverSideEncryptionConfiguration: StorageBucketServerSideEncryptionConfiguration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a>

server_side_encryption_configuration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#server_side_encryption_configuration StorageBucket#server_side_encryption_configuration}

---

##### `versioning`<sup>Optional</sup> <a name="versioning" id="@cdktf/provider-yandex.StorageBucketConfig.property.versioning"></a>

```typescript
public readonly versioning: StorageBucketVersioning;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a>

versioning block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#versioning StorageBucket#versioning}

---

##### `website`<sup>Optional</sup> <a name="website" id="@cdktf/provider-yandex.StorageBucketConfig.property.website"></a>

```typescript
public readonly website: StorageBucketWebsite;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a>

website block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#website StorageBucket#website}

---

##### `websiteDomain`<sup>Optional</sup> <a name="websiteDomain" id="@cdktf/provider-yandex.StorageBucketConfig.property.websiteDomain"></a>

```typescript
public readonly websiteDomain: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#website_domain StorageBucket#website_domain}.

---

##### `websiteEndpoint`<sup>Optional</sup> <a name="websiteEndpoint" id="@cdktf/provider-yandex.StorageBucketConfig.property.websiteEndpoint"></a>

```typescript
public readonly websiteEndpoint: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#website_endpoint StorageBucket#website_endpoint}.

---

### StorageBucketCorsRule <a name="StorageBucketCorsRule" id="@cdktf/provider-yandex.StorageBucketCorsRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketCorsRule.Initializer"></a>

```typescript
import { StorageBucketCorsRule } from '@cdktf/provider-yandex'

const storageBucketCorsRule: StorageBucketCorsRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedMethods">allowedMethods</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_methods StorageBucket#allowed_methods}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedOrigins">allowedOrigins</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_origins StorageBucket#allowed_origins}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedHeaders">allowedHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_headers StorageBucket#allowed_headers}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRule.property.exposeHeaders">exposeHeaders</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#expose_headers StorageBucket#expose_headers}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRule.property.maxAgeSeconds">maxAgeSeconds</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#max_age_seconds StorageBucket#max_age_seconds}. |

---

##### `allowedMethods`<sup>Required</sup> <a name="allowedMethods" id="@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_methods StorageBucket#allowed_methods}.

---

##### `allowedOrigins`<sup>Required</sup> <a name="allowedOrigins" id="@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_origins StorageBucket#allowed_origins}.

---

##### `allowedHeaders`<sup>Optional</sup> <a name="allowedHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRule.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#allowed_headers StorageBucket#allowed_headers}.

---

##### `exposeHeaders`<sup>Optional</sup> <a name="exposeHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRule.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#expose_headers StorageBucket#expose_headers}.

---

##### `maxAgeSeconds`<sup>Optional</sup> <a name="maxAgeSeconds" id="@cdktf/provider-yandex.StorageBucketCorsRule.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#max_age_seconds StorageBucket#max_age_seconds}.

---

### StorageBucketGrant <a name="StorageBucketGrant" id="@cdktf/provider-yandex.StorageBucketGrant"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketGrant.Initializer"></a>

```typescript
import { StorageBucketGrant } from '@cdktf/provider-yandex'

const storageBucketGrant: StorageBucketGrant = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrant.property.permissions">permissions</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#permissions StorageBucket#permissions}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrant.property.type">type</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#type StorageBucket#type}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrant.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrant.property.uri">uri</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#uri StorageBucket#uri}. |

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="@cdktf/provider-yandex.StorageBucketGrant.property.permissions"></a>

```typescript
public readonly permissions: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#permissions StorageBucket#permissions}.

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.StorageBucketGrant.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#type StorageBucket#type}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucketGrant.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `uri`<sup>Optional</sup> <a name="uri" id="@cdktf/provider-yandex.StorageBucketGrant.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#uri StorageBucket#uri}.

---

### StorageBucketLifecycleRule <a name="StorageBucketLifecycleRule" id="@cdktf/provider-yandex.StorageBucketLifecycleRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.Initializer"></a>

```typescript
import { StorageBucketLifecycleRule } from '@cdktf/provider-yandex'

const storageBucketLifecycleRule: StorageBucketLifecycleRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#enabled StorageBucket#enabled}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.abortIncompleteMultipartUploadDays">abortIncompleteMultipartUploadDays</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#abort_incomplete_multipart_upload_days StorageBucket#abort_incomplete_multipart_upload_days}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.expiration">expiration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a></code> | expiration block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.noncurrentVersionExpiration">noncurrentVersionExpiration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a></code> | noncurrent_version_expiration block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.noncurrentVersionTransition">noncurrentVersionTransition</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]</code> | noncurrent_version_transition block. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.prefix">prefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#prefix StorageBucket#prefix}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule.property.transition">transition</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]</code> | transition block. |

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#enabled StorageBucket#enabled}.

---

##### `abortIncompleteMultipartUploadDays`<sup>Optional</sup> <a name="abortIncompleteMultipartUploadDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.abortIncompleteMultipartUploadDays"></a>

```typescript
public readonly abortIncompleteMultipartUploadDays: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#abort_incomplete_multipart_upload_days StorageBucket#abort_incomplete_multipart_upload_days}.

---

##### `expiration`<sup>Optional</sup> <a name="expiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.expiration"></a>

```typescript
public readonly expiration: StorageBucketLifecycleRuleExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a>

expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#expiration StorageBucket#expiration}

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#id StorageBucket#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `noncurrentVersionExpiration`<sup>Optional</sup> <a name="noncurrentVersionExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: StorageBucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a>

noncurrent_version_expiration block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#noncurrent_version_expiration StorageBucket#noncurrent_version_expiration}

---

##### `noncurrentVersionTransition`<sup>Optional</sup> <a name="noncurrentVersionTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.noncurrentVersionTransition"></a>

```typescript
public readonly noncurrentVersionTransition: IResolvable | StorageBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]

noncurrent_version_transition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#noncurrent_version_transition StorageBucket#noncurrent_version_transition}

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#prefix StorageBucket#prefix}.

---

##### `transition`<sup>Optional</sup> <a name="transition" id="@cdktf/provider-yandex.StorageBucketLifecycleRule.property.transition"></a>

```typescript
public readonly transition: IResolvable | StorageBucketLifecycleRuleTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]

transition block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#transition StorageBucket#transition}

---

### StorageBucketLifecycleRuleExpiration <a name="StorageBucketLifecycleRuleExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleExpiration } from '@cdktf/provider-yandex'

const storageBucketLifecycleRuleExpiration: StorageBucketLifecycleRuleExpiration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.date">date</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#date StorageBucket#date}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.days">days</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.expiredObjectDeleteMarker">expiredObjectDeleteMarker</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#expired_object_delete_marker StorageBucket#expired_object_delete_marker}. |

---

##### `date`<sup>Optional</sup> <a name="date" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#date StorageBucket#date}.

---

##### `days`<sup>Optional</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}.

---

##### `expiredObjectDeleteMarker`<sup>Optional</sup> <a name="expiredObjectDeleteMarker" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration.property.expiredObjectDeleteMarker"></a>

```typescript
public readonly expiredObjectDeleteMarker: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#expired_object_delete_marker StorageBucket#expired_object_delete_marker}.

---

### StorageBucketLifecycleRuleNoncurrentVersionExpiration <a name="StorageBucketLifecycleRuleNoncurrentVersionExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleNoncurrentVersionExpiration } from '@cdktf/provider-yandex'

const storageBucketLifecycleRuleNoncurrentVersionExpiration: StorageBucketLifecycleRuleNoncurrentVersionExpiration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration.property.days">days</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}. |

---

##### `days`<sup>Optional</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}.

---

### StorageBucketLifecycleRuleNoncurrentVersionTransition <a name="StorageBucketLifecycleRuleNoncurrentVersionTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleNoncurrentVersionTransition } from '@cdktf/provider-yandex'

const storageBucketLifecycleRuleNoncurrentVersionTransition: StorageBucketLifecycleRuleNoncurrentVersionTransition = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition.property.storageClass">storageClass</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#storage_class StorageBucket#storage_class}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition.property.days">days</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}. |

---

##### `storageClass`<sup>Required</sup> <a name="storageClass" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#storage_class StorageBucket#storage_class}.

---

##### `days`<sup>Optional</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}.

---

### StorageBucketLifecycleRuleTransition <a name="StorageBucketLifecycleRuleTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleTransition } from '@cdktf/provider-yandex'

const storageBucketLifecycleRuleTransition: StorageBucketLifecycleRuleTransition = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.storageClass">storageClass</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#storage_class StorageBucket#storage_class}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.date">date</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#date StorageBucket#date}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.days">days</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}. |

---

##### `storageClass`<sup>Required</sup> <a name="storageClass" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#storage_class StorageBucket#storage_class}.

---

##### `date`<sup>Optional</sup> <a name="date" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#date StorageBucket#date}.

---

##### `days`<sup>Optional</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#days StorageBucket#days}.

---

### StorageBucketLogging <a name="StorageBucketLogging" id="@cdktf/provider-yandex.StorageBucketLogging"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketLogging.Initializer"></a>

```typescript
import { StorageBucketLogging } from '@cdktf/provider-yandex'

const storageBucketLogging: StorageBucketLogging = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLogging.property.targetBucket">targetBucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#target_bucket StorageBucket#target_bucket}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLogging.property.targetPrefix">targetPrefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#target_prefix StorageBucket#target_prefix}. |

---

##### `targetBucket`<sup>Required</sup> <a name="targetBucket" id="@cdktf/provider-yandex.StorageBucketLogging.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#target_bucket StorageBucket#target_bucket}.

---

##### `targetPrefix`<sup>Optional</sup> <a name="targetPrefix" id="@cdktf/provider-yandex.StorageBucketLogging.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#target_prefix StorageBucket#target_prefix}.

---

### StorageBucketServerSideEncryptionConfiguration <a name="StorageBucketServerSideEncryptionConfiguration" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfiguration } from '@cdktf/provider-yandex'

const storageBucketServerSideEncryptionConfiguration: StorageBucketServerSideEncryptionConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration.property.rule">rule</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a></code> | rule block. |

---

##### `rule`<sup>Required</sup> <a name="rule" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration.property.rule"></a>

```typescript
public readonly rule: StorageBucketServerSideEncryptionConfigurationRule;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a>

rule block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#rule StorageBucket#rule}

---

### StorageBucketServerSideEncryptionConfigurationRule <a name="StorageBucketServerSideEncryptionConfigurationRule" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfigurationRule } from '@cdktf/provider-yandex'

const storageBucketServerSideEncryptionConfigurationRule: StorageBucketServerSideEncryptionConfigurationRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule.property.applyServerSideEncryptionByDefault">applyServerSideEncryptionByDefault</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a></code> | apply_server_side_encryption_by_default block. |

---

##### `applyServerSideEncryptionByDefault`<sup>Required</sup> <a name="applyServerSideEncryptionByDefault" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule.property.applyServerSideEncryptionByDefault"></a>

```typescript
public readonly applyServerSideEncryptionByDefault: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a>

apply_server_side_encryption_by_default block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#apply_server_side_encryption_by_default StorageBucket#apply_server_side_encryption_by_default}

---

### StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault <a name="StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault } from '@cdktf/provider-yandex'

const storageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault.property.kmsMasterKeyId">kmsMasterKeyId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#kms_master_key_id StorageBucket#kms_master_key_id}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault.property.sseAlgorithm">sseAlgorithm</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#sse_algorithm StorageBucket#sse_algorithm}. |

---

##### `kmsMasterKeyId`<sup>Required</sup> <a name="kmsMasterKeyId" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault.property.kmsMasterKeyId"></a>

```typescript
public readonly kmsMasterKeyId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#kms_master_key_id StorageBucket#kms_master_key_id}.

---

##### `sseAlgorithm`<sup>Required</sup> <a name="sseAlgorithm" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault.property.sseAlgorithm"></a>

```typescript
public readonly sseAlgorithm: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#sse_algorithm StorageBucket#sse_algorithm}.

---

### StorageBucketVersioning <a name="StorageBucketVersioning" id="@cdktf/provider-yandex.StorageBucketVersioning"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketVersioning.Initializer"></a>

```typescript
import { StorageBucketVersioning } from '@cdktf/provider-yandex'

const storageBucketVersioning: StorageBucketVersioning = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioning.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#enabled StorageBucket#enabled}. |

---

##### `enabled`<sup>Optional</sup> <a name="enabled" id="@cdktf/provider-yandex.StorageBucketVersioning.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#enabled StorageBucket#enabled}.

---

### StorageBucketWebsite <a name="StorageBucketWebsite" id="@cdktf/provider-yandex.StorageBucketWebsite"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageBucketWebsite.Initializer"></a>

```typescript
import { StorageBucketWebsite } from '@cdktf/provider-yandex'

const storageBucketWebsite: StorageBucketWebsite = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite.property.errorDocument">errorDocument</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#error_document StorageBucket#error_document}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite.property.indexDocument">indexDocument</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#index_document StorageBucket#index_document}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite.property.redirectAllRequestsTo">redirectAllRequestsTo</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#redirect_all_requests_to StorageBucket#redirect_all_requests_to}. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite.property.routingRules">routingRules</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#routing_rules StorageBucket#routing_rules}. |

---

##### `errorDocument`<sup>Optional</sup> <a name="errorDocument" id="@cdktf/provider-yandex.StorageBucketWebsite.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#error_document StorageBucket#error_document}.

---

##### `indexDocument`<sup>Optional</sup> <a name="indexDocument" id="@cdktf/provider-yandex.StorageBucketWebsite.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#index_document StorageBucket#index_document}.

---

##### `redirectAllRequestsTo`<sup>Optional</sup> <a name="redirectAllRequestsTo" id="@cdktf/provider-yandex.StorageBucketWebsite.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#redirect_all_requests_to StorageBucket#redirect_all_requests_to}.

---

##### `routingRules`<sup>Optional</sup> <a name="routingRules" id="@cdktf/provider-yandex.StorageBucketWebsite.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_bucket#routing_rules StorageBucket#routing_rules}.

---

### StorageObjectConfig <a name="StorageObjectConfig" id="@cdktf/provider-yandex.StorageObjectConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.StorageObjectConfig.Initializer"></a>

```typescript
import { StorageObjectConfig } from '@cdktf/provider-yandex'

const storageObjectConfig: StorageObjectConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.bucket">bucket</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#bucket StorageObject#bucket}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.key">key</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#key StorageObject#key}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.accessKey">accessKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#access_key StorageObject#access_key}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.acl">acl</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#acl StorageObject#acl}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.content">content</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content StorageObject#content}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.contentBase64">contentBase64</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content_base64 StorageObject#content_base64}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.contentType">contentType</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content_type StorageObject#content_type}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#id StorageObject#id}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.secretKey">secretKey</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#secret_key StorageObject#secret_key}. |
| <code><a href="#@cdktf/provider-yandex.StorageObjectConfig.property.source">source</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#source StorageObject#source}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.StorageObjectConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.StorageObjectConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.StorageObjectConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.StorageObjectConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `bucket`<sup>Required</sup> <a name="bucket" id="@cdktf/provider-yandex.StorageObjectConfig.property.bucket"></a>

```typescript
public readonly bucket: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#bucket StorageObject#bucket}.

---

##### `key`<sup>Required</sup> <a name="key" id="@cdktf/provider-yandex.StorageObjectConfig.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#key StorageObject#key}.

---

##### `accessKey`<sup>Optional</sup> <a name="accessKey" id="@cdktf/provider-yandex.StorageObjectConfig.property.accessKey"></a>

```typescript
public readonly accessKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#access_key StorageObject#access_key}.

---

##### `acl`<sup>Optional</sup> <a name="acl" id="@cdktf/provider-yandex.StorageObjectConfig.property.acl"></a>

```typescript
public readonly acl: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#acl StorageObject#acl}.

---

##### `content`<sup>Optional</sup> <a name="content" id="@cdktf/provider-yandex.StorageObjectConfig.property.content"></a>

```typescript
public readonly content: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content StorageObject#content}.

---

##### `contentBase64`<sup>Optional</sup> <a name="contentBase64" id="@cdktf/provider-yandex.StorageObjectConfig.property.contentBase64"></a>

```typescript
public readonly contentBase64: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content_base64 StorageObject#content_base64}.

---

##### `contentType`<sup>Optional</sup> <a name="contentType" id="@cdktf/provider-yandex.StorageObjectConfig.property.contentType"></a>

```typescript
public readonly contentType: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#content_type StorageObject#content_type}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.StorageObjectConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#id StorageObject#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `secretKey`<sup>Optional</sup> <a name="secretKey" id="@cdktf/provider-yandex.StorageObjectConfig.property.secretKey"></a>

```typescript
public readonly secretKey: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#secret_key StorageObject#secret_key}.

---

##### `source`<sup>Optional</sup> <a name="source" id="@cdktf/provider-yandex.StorageObjectConfig.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/storage_object#source StorageObject#source}.

---

### VpcAddressConfig <a name="VpcAddressConfig" id="@cdktf/provider-yandex.VpcAddressConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcAddressConfig.Initializer"></a>

```typescript
import { VpcAddressConfig } from '@cdktf/provider-yandex'

const vpcAddressConfig: VpcAddressConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#description VpcAddress#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a></code> | external_ipv4_address block. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#folder_id VpcAddress#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#id VpcAddress#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#labels VpcAddress#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#name VpcAddress#name}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcAddressConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcAddressConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcAddressConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcAddressConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcAddressConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#description VpcAddress#description}.

---

##### `externalIpv4Address`<sup>Optional</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.VpcAddressConfig.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: VpcAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a>

external_ipv4_address block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#external_ipv4_address VpcAddress#external_ipv4_address}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcAddressConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#folder_id VpcAddress#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcAddressConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#id VpcAddress#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcAddressConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#labels VpcAddress#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.VpcAddressConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#name VpcAddress#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcAddressConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcAddressTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#timeouts VpcAddress#timeouts}

---

### VpcAddressExternalIpv4Address <a name="VpcAddressExternalIpv4Address" id="@cdktf/provider-yandex.VpcAddressExternalIpv4Address"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcAddressExternalIpv4Address.Initializer"></a>

```typescript
import { VpcAddressExternalIpv4Address } from '@cdktf/provider-yandex'

const vpcAddressExternalIpv4Address: VpcAddressExternalIpv4Address = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.ddosProtectionProvider">ddosProtectionProvider</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#ddos_protection_provider VpcAddress#ddos_protection_provider}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.outgoingSmtpCapability">outgoingSmtpCapability</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#outgoing_smtp_capability VpcAddress#outgoing_smtp_capability}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.zoneId">zoneId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#zone_id VpcAddress#zone_id}. |

---

##### `ddosProtectionProvider`<sup>Optional</sup> <a name="ddosProtectionProvider" id="@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.ddosProtectionProvider"></a>

```typescript
public readonly ddosProtectionProvider: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#ddos_protection_provider VpcAddress#ddos_protection_provider}.

---

##### `outgoingSmtpCapability`<sup>Optional</sup> <a name="outgoingSmtpCapability" id="@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.outgoingSmtpCapability"></a>

```typescript
public readonly outgoingSmtpCapability: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#outgoing_smtp_capability VpcAddress#outgoing_smtp_capability}.

---

##### `zoneId`<sup>Optional</sup> <a name="zoneId" id="@cdktf/provider-yandex.VpcAddressExternalIpv4Address.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#zone_id VpcAddress#zone_id}.

---

### VpcAddressTimeouts <a name="VpcAddressTimeouts" id="@cdktf/provider-yandex.VpcAddressTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcAddressTimeouts.Initializer"></a>

```typescript
import { VpcAddressTimeouts } from '@cdktf/provider-yandex'

const vpcAddressTimeouts: VpcAddressTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#create VpcAddress#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#delete VpcAddress#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#update VpcAddress#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcAddressTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#create VpcAddress#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcAddressTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#delete VpcAddress#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcAddressTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_address#update VpcAddress#update}.

---

### VpcDefaultSecurityGroupConfig <a name="VpcDefaultSecurityGroupConfig" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupConfig } from '@cdktf/provider-yandex'

const vpcDefaultSecurityGroupConfig: VpcDefaultSecurityGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#network_id VpcDefaultSecurityGroup#network_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.egress">egress</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]</code> | egress block. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#folder_id VpcDefaultSecurityGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#id VpcDefaultSecurityGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.ingress">ingress</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]</code> | ingress block. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#network_id VpcDefaultSecurityGroup#network_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.egress"></a>

```typescript
public readonly egress: IResolvable | VpcDefaultSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]

egress block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#egress VpcDefaultSecurityGroup#egress}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#folder_id VpcDefaultSecurityGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#id VpcDefaultSecurityGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.ingress"></a>

```typescript
public readonly ingress: IResolvable | VpcDefaultSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]

ingress block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#ingress VpcDefaultSecurityGroup#ingress}

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcDefaultSecurityGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#timeouts VpcDefaultSecurityGroup#timeouts}

---

### VpcDefaultSecurityGroupEgress <a name="VpcDefaultSecurityGroupEgress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupEgress } from '@cdktf/provider-yandex'

const vpcDefaultSecurityGroupEgress: VpcDefaultSecurityGroupEgress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#protocol VpcDefaultSecurityGroup#protocol}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.fromPort">fromPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#from_port VpcDefaultSecurityGroup#from_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#port VpcDefaultSecurityGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#predefined_target VpcDefaultSecurityGroup#predefined_target}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#security_group_id VpcDefaultSecurityGroup#security_group_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.toPort">toPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#to_port VpcDefaultSecurityGroup#to_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v4_cidr_blocks VpcDefaultSecurityGroup#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v6_cidr_blocks VpcDefaultSecurityGroup#v6_cidr_blocks}. |

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#protocol VpcDefaultSecurityGroup#protocol}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}.

---

##### `fromPort`<sup>Optional</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#from_port VpcDefaultSecurityGroup#from_port}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#port VpcDefaultSecurityGroup#port}.

---

##### `predefinedTarget`<sup>Optional</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#predefined_target VpcDefaultSecurityGroup#predefined_target}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#security_group_id VpcDefaultSecurityGroup#security_group_id}.

---

##### `toPort`<sup>Optional</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#to_port VpcDefaultSecurityGroup#to_port}.

---

##### `v4CidrBlocks`<sup>Optional</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v4_cidr_blocks VpcDefaultSecurityGroup#v4_cidr_blocks}.

---

##### `v6CidrBlocks`<sup>Optional</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v6_cidr_blocks VpcDefaultSecurityGroup#v6_cidr_blocks}.

---

### VpcDefaultSecurityGroupIngress <a name="VpcDefaultSecurityGroupIngress" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupIngress } from '@cdktf/provider-yandex'

const vpcDefaultSecurityGroupIngress: VpcDefaultSecurityGroupIngress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#protocol VpcDefaultSecurityGroup#protocol}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.fromPort">fromPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#from_port VpcDefaultSecurityGroup#from_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#port VpcDefaultSecurityGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#predefined_target VpcDefaultSecurityGroup#predefined_target}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#security_group_id VpcDefaultSecurityGroup#security_group_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.toPort">toPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#to_port VpcDefaultSecurityGroup#to_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v4_cidr_blocks VpcDefaultSecurityGroup#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v6_cidr_blocks VpcDefaultSecurityGroup#v6_cidr_blocks}. |

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#protocol VpcDefaultSecurityGroup#protocol}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#description VpcDefaultSecurityGroup#description}.

---

##### `fromPort`<sup>Optional</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#from_port VpcDefaultSecurityGroup#from_port}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#labels VpcDefaultSecurityGroup#labels}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#port VpcDefaultSecurityGroup#port}.

---

##### `predefinedTarget`<sup>Optional</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#predefined_target VpcDefaultSecurityGroup#predefined_target}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#security_group_id VpcDefaultSecurityGroup#security_group_id}.

---

##### `toPort`<sup>Optional</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#to_port VpcDefaultSecurityGroup#to_port}.

---

##### `v4CidrBlocks`<sup>Optional</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v4_cidr_blocks VpcDefaultSecurityGroup#v4_cidr_blocks}.

---

##### `v6CidrBlocks`<sup>Optional</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#v6_cidr_blocks VpcDefaultSecurityGroup#v6_cidr_blocks}.

---

### VpcDefaultSecurityGroupTimeouts <a name="VpcDefaultSecurityGroupTimeouts" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupTimeouts } from '@cdktf/provider-yandex'

const vpcDefaultSecurityGroupTimeouts: VpcDefaultSecurityGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#create VpcDefaultSecurityGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#delete VpcDefaultSecurityGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#read VpcDefaultSecurityGroup#read}. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#update VpcDefaultSecurityGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#create VpcDefaultSecurityGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#delete VpcDefaultSecurityGroup#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#read VpcDefaultSecurityGroup#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_default_security_group#update VpcDefaultSecurityGroup#update}.

---

### VpcNetworkConfig <a name="VpcNetworkConfig" id="@cdktf/provider-yandex.VpcNetworkConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcNetworkConfig.Initializer"></a>

```typescript
import { VpcNetworkConfig } from '@cdktf/provider-yandex'

const vpcNetworkConfig: VpcNetworkConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#description VpcNetwork#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#folder_id VpcNetwork#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#id VpcNetwork#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#labels VpcNetwork#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#name VpcNetwork#name}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcNetworkConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcNetworkConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcNetworkConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcNetworkConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcNetworkConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#description VpcNetwork#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcNetworkConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#folder_id VpcNetwork#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcNetworkConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#id VpcNetwork#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcNetworkConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#labels VpcNetwork#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.VpcNetworkConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#name VpcNetwork#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcNetworkConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcNetworkTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#timeouts VpcNetwork#timeouts}

---

### VpcNetworkTimeouts <a name="VpcNetworkTimeouts" id="@cdktf/provider-yandex.VpcNetworkTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcNetworkTimeouts.Initializer"></a>

```typescript
import { VpcNetworkTimeouts } from '@cdktf/provider-yandex'

const vpcNetworkTimeouts: VpcNetworkTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#create VpcNetwork#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#delete VpcNetwork#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#update VpcNetwork#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcNetworkTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#create VpcNetwork#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcNetworkTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#delete VpcNetwork#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcNetworkTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_network#update VpcNetwork#update}.

---

### VpcRouteTableConfig <a name="VpcRouteTableConfig" id="@cdktf/provider-yandex.VpcRouteTableConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcRouteTableConfig.Initializer"></a>

```typescript
import { VpcRouteTableConfig } from '@cdktf/provider-yandex'

const vpcRouteTableConfig: VpcRouteTableConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#network_id VpcRouteTable#network_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#description VpcRouteTable#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#folder_id VpcRouteTable#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#id VpcRouteTable#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#labels VpcRouteTable#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#name VpcRouteTable#name}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.staticRoute">staticRoute</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]</code> | static_route block. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#network_id VpcRouteTable#network_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#description VpcRouteTable#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#folder_id VpcRouteTable#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#id VpcRouteTable#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#labels VpcRouteTable#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#name VpcRouteTable#name}.

---

##### `staticRoute`<sup>Optional</sup> <a name="staticRoute" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.staticRoute"></a>

```typescript
public readonly staticRoute: IResolvable | VpcRouteTableStaticRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]

static_route block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#static_route VpcRouteTable#static_route}

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcRouteTableConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcRouteTableTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#timeouts VpcRouteTable#timeouts}

---

### VpcRouteTableStaticRoute <a name="VpcRouteTableStaticRoute" id="@cdktf/provider-yandex.VpcRouteTableStaticRoute"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcRouteTableStaticRoute.Initializer"></a>

```typescript
import { VpcRouteTableStaticRoute } from '@cdktf/provider-yandex'

const vpcRouteTableStaticRoute: VpcRouteTableStaticRoute = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute.property.destinationPrefix">destinationPrefix</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#destination_prefix VpcRouteTable#destination_prefix}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute.property.nextHopAddress">nextHopAddress</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#next_hop_address VpcRouteTable#next_hop_address}. |

---

##### `destinationPrefix`<sup>Optional</sup> <a name="destinationPrefix" id="@cdktf/provider-yandex.VpcRouteTableStaticRoute.property.destinationPrefix"></a>

```typescript
public readonly destinationPrefix: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#destination_prefix VpcRouteTable#destination_prefix}.

---

##### `nextHopAddress`<sup>Optional</sup> <a name="nextHopAddress" id="@cdktf/provider-yandex.VpcRouteTableStaticRoute.property.nextHopAddress"></a>

```typescript
public readonly nextHopAddress: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#next_hop_address VpcRouteTable#next_hop_address}.

---

### VpcRouteTableTimeouts <a name="VpcRouteTableTimeouts" id="@cdktf/provider-yandex.VpcRouteTableTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcRouteTableTimeouts.Initializer"></a>

```typescript
import { VpcRouteTableTimeouts } from '@cdktf/provider-yandex'

const vpcRouteTableTimeouts: VpcRouteTableTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#create VpcRouteTable#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#delete VpcRouteTable#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#update VpcRouteTable#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcRouteTableTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#create VpcRouteTable#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcRouteTableTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#delete VpcRouteTable#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcRouteTableTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_route_table#update VpcRouteTable#update}.

---

### VpcSecurityGroupConfig <a name="VpcSecurityGroupConfig" id="@cdktf/provider-yandex.VpcSecurityGroupConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.Initializer"></a>

```typescript
import { VpcSecurityGroupConfig } from '@cdktf/provider-yandex'

const vpcSecurityGroupConfig: VpcSecurityGroupConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#network_id VpcSecurityGroup#network_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.egress">egress</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]</code> | egress block. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#folder_id VpcSecurityGroup#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#id VpcSecurityGroup#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.ingress">ingress</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]</code> | ingress block. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#name VpcSecurityGroup#name}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#network_id VpcSecurityGroup#network_id}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.egress"></a>

```typescript
public readonly egress: IResolvable | VpcSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]

egress block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#egress VpcSecurityGroup#egress}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#folder_id VpcSecurityGroup#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#id VpcSecurityGroup#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.ingress"></a>

```typescript
public readonly ingress: IResolvable | VpcSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]

ingress block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#ingress VpcSecurityGroup#ingress}

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#name VpcSecurityGroup#name}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSecurityGroupConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSecurityGroupTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#timeouts VpcSecurityGroup#timeouts}

---

### VpcSecurityGroupEgress <a name="VpcSecurityGroupEgress" id="@cdktf/provider-yandex.VpcSecurityGroupEgress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.Initializer"></a>

```typescript
import { VpcSecurityGroupEgress } from '@cdktf/provider-yandex'

const vpcSecurityGroupEgress: VpcSecurityGroupEgress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#protocol VpcSecurityGroup#protocol}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.fromPort">fromPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#from_port VpcSecurityGroup#from_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#port VpcSecurityGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#predefined_target VpcSecurityGroup#predefined_target}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#security_group_id VpcSecurityGroup#security_group_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.toPort">toPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#to_port VpcSecurityGroup#to_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v4_cidr_blocks VpcSecurityGroup#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v6_cidr_blocks VpcSecurityGroup#v6_cidr_blocks}. |

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#protocol VpcSecurityGroup#protocol}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}.

---

##### `fromPort`<sup>Optional</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#from_port VpcSecurityGroup#from_port}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#port VpcSecurityGroup#port}.

---

##### `predefinedTarget`<sup>Optional</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#predefined_target VpcSecurityGroup#predefined_target}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#security_group_id VpcSecurityGroup#security_group_id}.

---

##### `toPort`<sup>Optional</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#to_port VpcSecurityGroup#to_port}.

---

##### `v4CidrBlocks`<sup>Optional</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v4_cidr_blocks VpcSecurityGroup#v4_cidr_blocks}.

---

##### `v6CidrBlocks`<sup>Optional</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgress.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v6_cidr_blocks VpcSecurityGroup#v6_cidr_blocks}.

---

### VpcSecurityGroupIngress <a name="VpcSecurityGroupIngress" id="@cdktf/provider-yandex.VpcSecurityGroupIngress"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.Initializer"></a>

```typescript
import { VpcSecurityGroupIngress } from '@cdktf/provider-yandex'

const vpcSecurityGroupIngress: VpcSecurityGroupIngress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#protocol VpcSecurityGroup#protocol}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.fromPort">fromPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#from_port VpcSecurityGroup#from_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#port VpcSecurityGroup#port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#predefined_target VpcSecurityGroup#predefined_target}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#security_group_id VpcSecurityGroup#security_group_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.toPort">toPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#to_port VpcSecurityGroup#to_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v4_cidr_blocks VpcSecurityGroup#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v6_cidr_blocks VpcSecurityGroup#v6_cidr_blocks}. |

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#protocol VpcSecurityGroup#protocol}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#description VpcSecurityGroup#description}.

---

##### `fromPort`<sup>Optional</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#from_port VpcSecurityGroup#from_port}.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#labels VpcSecurityGroup#labels}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#port VpcSecurityGroup#port}.

---

##### `predefinedTarget`<sup>Optional</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#predefined_target VpcSecurityGroup#predefined_target}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#security_group_id VpcSecurityGroup#security_group_id}.

---

##### `toPort`<sup>Optional</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#to_port VpcSecurityGroup#to_port}.

---

##### `v4CidrBlocks`<sup>Optional</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v4_cidr_blocks VpcSecurityGroup#v4_cidr_blocks}.

---

##### `v6CidrBlocks`<sup>Optional</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngress.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#v6_cidr_blocks VpcSecurityGroup#v6_cidr_blocks}.

---

### VpcSecurityGroupRuleConfig <a name="VpcSecurityGroupRuleConfig" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.Initializer"></a>

```typescript
import { VpcSecurityGroupRuleConfig } from '@cdktf/provider-yandex'

const vpcSecurityGroupRuleConfig: VpcSecurityGroupRuleConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.direction">direction</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#direction VpcSecurityGroupRule#direction}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.securityGroupBinding">securityGroupBinding</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_binding VpcSecurityGroupRule#security_group_binding}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#description VpcSecurityGroupRule#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.fromPort">fromPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#from_port VpcSecurityGroupRule#from_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#id VpcSecurityGroupRule#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#labels VpcSecurityGroupRule#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.port">port</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#port VpcSecurityGroupRule#port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#predefined_target VpcSecurityGroupRule#predefined_target}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.protocol">protocol</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#protocol VpcSecurityGroupRule#protocol}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_id VpcSecurityGroupRule#security_group_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.toPort">toPort</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#to_port VpcSecurityGroupRule#to_port}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v4_cidr_blocks VpcSecurityGroupRule#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v6_cidr_blocks VpcSecurityGroupRule#v6_cidr_blocks}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `direction`<sup>Required</sup> <a name="direction" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.direction"></a>

```typescript
public readonly direction: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#direction VpcSecurityGroupRule#direction}.

---

##### `securityGroupBinding`<sup>Required</sup> <a name="securityGroupBinding" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.securityGroupBinding"></a>

```typescript
public readonly securityGroupBinding: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_binding VpcSecurityGroupRule#security_group_binding}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#description VpcSecurityGroupRule#description}.

---

##### `fromPort`<sup>Optional</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#from_port VpcSecurityGroupRule#from_port}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#id VpcSecurityGroupRule#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#labels VpcSecurityGroupRule#labels}.

---

##### `port`<sup>Optional</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#port VpcSecurityGroupRule#port}.

---

##### `predefinedTarget`<sup>Optional</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#predefined_target VpcSecurityGroupRule#predefined_target}.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#protocol VpcSecurityGroupRule#protocol}.

---

##### `securityGroupId`<sup>Optional</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#security_group_id VpcSecurityGroupRule#security_group_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSecurityGroupRuleTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#timeouts VpcSecurityGroupRule#timeouts}

---

##### `toPort`<sup>Optional</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#to_port VpcSecurityGroupRule#to_port}.

---

##### `v4CidrBlocks`<sup>Optional</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v4_cidr_blocks VpcSecurityGroupRule#v4_cidr_blocks}.

---

##### `v6CidrBlocks`<sup>Optional</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupRuleConfig.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#v6_cidr_blocks VpcSecurityGroupRule#v6_cidr_blocks}.

---

### VpcSecurityGroupRuleTimeouts <a name="VpcSecurityGroupRuleTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.Initializer"></a>

```typescript
import { VpcSecurityGroupRuleTimeouts } from '@cdktf/provider-yandex'

const vpcSecurityGroupRuleTimeouts: VpcSecurityGroupRuleTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#create VpcSecurityGroupRule#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#delete VpcSecurityGroupRule#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.read">read</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#read VpcSecurityGroupRule#read}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#update VpcSecurityGroupRule#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#create VpcSecurityGroupRule#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#delete VpcSecurityGroupRule#delete}.

---

##### `read`<sup>Optional</sup> <a name="read" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#read VpcSecurityGroupRule#read}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group_rule#update VpcSecurityGroupRule#update}.

---

### VpcSecurityGroupTimeouts <a name="VpcSecurityGroupTimeouts" id="@cdktf/provider-yandex.VpcSecurityGroupTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSecurityGroupTimeouts.Initializer"></a>

```typescript
import { VpcSecurityGroupTimeouts } from '@cdktf/provider-yandex'

const vpcSecurityGroupTimeouts: VpcSecurityGroupTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#create VpcSecurityGroup#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#delete VpcSecurityGroup#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#update VpcSecurityGroup#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#create VpcSecurityGroup#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#delete VpcSecurityGroup#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcSecurityGroupTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_security_group#update VpcSecurityGroup#update}.

---

### VpcSubnetConfig <a name="VpcSubnetConfig" id="@cdktf/provider-yandex.VpcSubnetConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSubnetConfig.Initializer"></a>

```typescript
import { VpcSubnetConfig } from '@cdktf/provider-yandex'

const vpcSubnetConfig: VpcSubnetConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#network_id VpcSubnet#network_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#v4_cidr_blocks VpcSubnet#v4_cidr_blocks}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#description VpcSubnet#description}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.dhcpOptions">dhcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a></code> | dhcp_options block. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#folder_id VpcSubnet#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#id VpcSubnet#id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#labels VpcSubnet#labels}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#name VpcSubnet#name}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.routeTableId">routeTableId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#route_table_id VpcSubnet#route_table_id}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a></code> | timeouts block. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetConfig.property.zone">zone</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#zone VpcSubnet#zone}. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.VpcSubnetConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.VpcSubnetConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.VpcSubnetConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.VpcSubnetConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.VpcSubnetConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#network_id VpcSubnet#network_id}.

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSubnetConfig.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#v4_cidr_blocks VpcSubnet#v4_cidr_blocks}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.VpcSubnetConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#description VpcSubnet#description}.

---

##### `dhcpOptions`<sup>Optional</sup> <a name="dhcpOptions" id="@cdktf/provider-yandex.VpcSubnetConfig.property.dhcpOptions"></a>

```typescript
public readonly dhcpOptions: VpcSubnetDhcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a>

dhcp_options block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#dhcp_options VpcSubnet#dhcp_options}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.VpcSubnetConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#folder_id VpcSubnet#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.VpcSubnetConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#id VpcSubnet#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSubnetConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#labels VpcSubnet#labels}.

---

##### `name`<sup>Optional</sup> <a name="name" id="@cdktf/provider-yandex.VpcSubnetConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#name VpcSubnet#name}.

---

##### `routeTableId`<sup>Optional</sup> <a name="routeTableId" id="@cdktf/provider-yandex.VpcSubnetConfig.property.routeTableId"></a>

```typescript
public readonly routeTableId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#route_table_id VpcSubnet#route_table_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.VpcSubnetConfig.property.timeouts"></a>

```typescript
public readonly timeouts: VpcSubnetTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#timeouts VpcSubnet#timeouts}

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.VpcSubnetConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#zone VpcSubnet#zone}.

---

### VpcSubnetDhcpOptions <a name="VpcSubnetDhcpOptions" id="@cdktf/provider-yandex.VpcSubnetDhcpOptions"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSubnetDhcpOptions.Initializer"></a>

```typescript
import { VpcSubnetDhcpOptions } from '@cdktf/provider-yandex'

const vpcSubnetDhcpOptions: VpcSubnetDhcpOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.domainName">domainName</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#domain_name VpcSubnet#domain_name}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.domainNameServers">domainNameServers</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#domain_name_servers VpcSubnet#domain_name_servers}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.ntpServers">ntpServers</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#ntp_servers VpcSubnet#ntp_servers}. |

---

##### `domainName`<sup>Optional</sup> <a name="domainName" id="@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#domain_name VpcSubnet#domain_name}.

---

##### `domainNameServers`<sup>Optional</sup> <a name="domainNameServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.domainNameServers"></a>

```typescript
public readonly domainNameServers: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#domain_name_servers VpcSubnet#domain_name_servers}.

---

##### `ntpServers`<sup>Optional</sup> <a name="ntpServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptions.property.ntpServers"></a>

```typescript
public readonly ntpServers: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#ntp_servers VpcSubnet#ntp_servers}.

---

### VpcSubnetTimeouts <a name="VpcSubnetTimeouts" id="@cdktf/provider-yandex.VpcSubnetTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.VpcSubnetTimeouts.Initializer"></a>

```typescript
import { VpcSubnetTimeouts } from '@cdktf/provider-yandex'

const vpcSubnetTimeouts: VpcSubnetTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeouts.property.create">create</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#create VpcSubnet#create}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeouts.property.delete">delete</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#delete VpcSubnet#delete}. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeouts.property.update">update</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#update VpcSubnet#update}. |

---

##### `create`<sup>Optional</sup> <a name="create" id="@cdktf/provider-yandex.VpcSubnetTimeouts.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#create VpcSubnet#create}.

---

##### `delete`<sup>Optional</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSubnetTimeouts.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#delete VpcSubnet#delete}.

---

##### `update`<sup>Optional</sup> <a name="update" id="@cdktf/provider-yandex.VpcSubnetTimeouts.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/vpc_subnet#update VpcSubnet#update}.

---

### YandexProviderConfig <a name="YandexProviderConfig" id="@cdktf/provider-yandex.YandexProviderConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YandexProviderConfig.Initializer"></a>

```typescript
import { YandexProviderConfig } from '@cdktf/provider-yandex'

const yandexProviderConfig: YandexProviderConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.alias">alias</a></code> | <code>string</code> | Alias name. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.cloudId">cloudId</a></code> | <code>string</code> | ID of Yandex.Cloud tenant. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.endpoint">endpoint</a></code> | <code>string</code> | The API endpoint for Yandex.Cloud SDK client. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.folderId">folderId</a></code> | <code>string</code> | The default folder ID where resources will be placed. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.insecure">insecure</a></code> | <code>boolean \| cdktf.IResolvable</code> | Explicitly allow the provider to perform "insecure" SSL requests. If omitted,default value is `false`. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.maxRetries">maxRetries</a></code> | <code>number</code> | The maximum number of times an API request is being executed. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.organizationId">organizationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#organization_id YandexProvider#organization_id}. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.plaintext">plaintext</a></code> | <code>boolean \| cdktf.IResolvable</code> | Disable use of TLS. Default value is `false`. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.serviceAccountKeyFile">serviceAccountKeyFile</a></code> | <code>string</code> | Either the path to or the contents of a Service Account key file in JSON format. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.storageAccessKey">storageAccessKey</a></code> | <code>string</code> | Yandex.Cloud storage service access key.  Used when a storage data/resource doesn't have an access key explicitly specified. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.storageEndpoint">storageEndpoint</a></code> | <code>string</code> | Yandex.Cloud storage service endpoint. Default is  storage.yandexcloud.net. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.storageSecretKey">storageSecretKey</a></code> | <code>string</code> | Yandex.Cloud storage service secret key.  Used when a storage data/resource doesn't have a secret key explicitly specified. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.token">token</a></code> | <code>string</code> | The access token for API operations. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.ymqAccessKey">ymqAccessKey</a></code> | <code>string</code> | Yandex.Cloud Message Queue service access key.  Used when a message queue resource doesn't have an access key explicitly specified. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.ymqEndpoint">ymqEndpoint</a></code> | <code>string</code> | Yandex.Cloud Message Queue service endpoint. Default is  message-queue.api.cloud.yandex.net. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.ymqSecretKey">ymqSecretKey</a></code> | <code>string</code> | Yandex.Cloud Message Queue service secret key.  Used when a message queue resource doesn't have a secret key explicitly specified. |
| <code><a href="#@cdktf/provider-yandex.YandexProviderConfig.property.zone">zone</a></code> | <code>string</code> | The zone where operations will take place. Examples are ru-central1-a, ru-central2-c, etc. |

---

##### `alias`<sup>Optional</sup> <a name="alias" id="@cdktf/provider-yandex.YandexProviderConfig.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

Alias name.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#alias YandexProvider#alias}

---

##### `cloudId`<sup>Optional</sup> <a name="cloudId" id="@cdktf/provider-yandex.YandexProviderConfig.property.cloudId"></a>

```typescript
public readonly cloudId: string;
```

- *Type:* string

ID of Yandex.Cloud tenant.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#cloud_id YandexProvider#cloud_id}

---

##### `endpoint`<sup>Optional</sup> <a name="endpoint" id="@cdktf/provider-yandex.YandexProviderConfig.property.endpoint"></a>

```typescript
public readonly endpoint: string;
```

- *Type:* string

The API endpoint for Yandex.Cloud SDK client.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#endpoint YandexProvider#endpoint}

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.YandexProviderConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

The default folder ID where resources will be placed.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#folder_id YandexProvider#folder_id}

---

##### `insecure`<sup>Optional</sup> <a name="insecure" id="@cdktf/provider-yandex.YandexProviderConfig.property.insecure"></a>

```typescript
public readonly insecure: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Explicitly allow the provider to perform "insecure" SSL requests. If omitted,default value is `false`.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#insecure YandexProvider#insecure}

---

##### `maxRetries`<sup>Optional</sup> <a name="maxRetries" id="@cdktf/provider-yandex.YandexProviderConfig.property.maxRetries"></a>

```typescript
public readonly maxRetries: number;
```

- *Type:* number

The maximum number of times an API request is being executed.

If the API request still fails, an error is thrown.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#max_retries YandexProvider#max_retries}

---

##### `organizationId`<sup>Optional</sup> <a name="organizationId" id="@cdktf/provider-yandex.YandexProviderConfig.property.organizationId"></a>

```typescript
public readonly organizationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#organization_id YandexProvider#organization_id}.

---

##### `plaintext`<sup>Optional</sup> <a name="plaintext" id="@cdktf/provider-yandex.YandexProviderConfig.property.plaintext"></a>

```typescript
public readonly plaintext: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Disable use of TLS. Default value is `false`.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#plaintext YandexProvider#plaintext}

---

##### `serviceAccountKeyFile`<sup>Optional</sup> <a name="serviceAccountKeyFile" id="@cdktf/provider-yandex.YandexProviderConfig.property.serviceAccountKeyFile"></a>

```typescript
public readonly serviceAccountKeyFile: string;
```

- *Type:* string

Either the path to or the contents of a Service Account key file in JSON format.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#service_account_key_file YandexProvider#service_account_key_file}

---

##### `storageAccessKey`<sup>Optional</sup> <a name="storageAccessKey" id="@cdktf/provider-yandex.YandexProviderConfig.property.storageAccessKey"></a>

```typescript
public readonly storageAccessKey: string;
```

- *Type:* string

Yandex.Cloud storage service access key.  Used when a storage data/resource doesn't have an access key explicitly specified.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#storage_access_key YandexProvider#storage_access_key}

---

##### `storageEndpoint`<sup>Optional</sup> <a name="storageEndpoint" id="@cdktf/provider-yandex.YandexProviderConfig.property.storageEndpoint"></a>

```typescript
public readonly storageEndpoint: string;
```

- *Type:* string

Yandex.Cloud storage service endpoint. Default is  storage.yandexcloud.net.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#storage_endpoint YandexProvider#storage_endpoint}

---

##### `storageSecretKey`<sup>Optional</sup> <a name="storageSecretKey" id="@cdktf/provider-yandex.YandexProviderConfig.property.storageSecretKey"></a>

```typescript
public readonly storageSecretKey: string;
```

- *Type:* string

Yandex.Cloud storage service secret key.  Used when a storage data/resource doesn't have a secret key explicitly specified.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#storage_secret_key YandexProvider#storage_secret_key}

---

##### `token`<sup>Optional</sup> <a name="token" id="@cdktf/provider-yandex.YandexProviderConfig.property.token"></a>

```typescript
public readonly token: string;
```

- *Type:* string

The access token for API operations.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#token YandexProvider#token}

---

##### `ymqAccessKey`<sup>Optional</sup> <a name="ymqAccessKey" id="@cdktf/provider-yandex.YandexProviderConfig.property.ymqAccessKey"></a>

```typescript
public readonly ymqAccessKey: string;
```

- *Type:* string

Yandex.Cloud Message Queue service access key.  Used when a message queue resource doesn't have an access key explicitly specified.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#ymq_access_key YandexProvider#ymq_access_key}

---

##### `ymqEndpoint`<sup>Optional</sup> <a name="ymqEndpoint" id="@cdktf/provider-yandex.YandexProviderConfig.property.ymqEndpoint"></a>

```typescript
public readonly ymqEndpoint: string;
```

- *Type:* string

Yandex.Cloud Message Queue service endpoint. Default is  message-queue.api.cloud.yandex.net.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#ymq_endpoint YandexProvider#ymq_endpoint}

---

##### `ymqSecretKey`<sup>Optional</sup> <a name="ymqSecretKey" id="@cdktf/provider-yandex.YandexProviderConfig.property.ymqSecretKey"></a>

```typescript
public readonly ymqSecretKey: string;
```

- *Type:* string

Yandex.Cloud Message Queue service secret key.  Used when a message queue resource doesn't have a secret key explicitly specified.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#ymq_secret_key YandexProvider#ymq_secret_key}

---

##### `zone`<sup>Optional</sup> <a name="zone" id="@cdktf/provider-yandex.YandexProviderConfig.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

The zone where operations will take place. Examples are ru-central1-a, ru-central2-c, etc.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex#zone YandexProvider#zone}

---

### YdbDatabaseDedicatedConfig <a name="YdbDatabaseDedicatedConfig" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedConfig } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedConfig: YdbDatabaseDedicatedConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#name YdbDatabaseDedicated#name}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.networkId">networkId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#network_id YdbDatabaseDedicated#network_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#resource_preset_id YdbDatabaseDedicated#resource_preset_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.scalePolicy">scalePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a></code> | scale_policy block. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.storageConfig">storageConfig</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a></code> | storage_config block. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#subnet_ids YdbDatabaseDedicated#subnet_ids}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.assignPublicIps">assignPublicIps</a></code> | <code>boolean \| cdktf.IResolvable</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#assign_public_ips YdbDatabaseDedicated#assign_public_ips}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#description YdbDatabaseDedicated#description}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#folder_id YdbDatabaseDedicated#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#labels YdbDatabaseDedicated#labels}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a></code> | location block. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.locationId">locationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#location_id YdbDatabaseDedicated#location_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#name YdbDatabaseDedicated#name}.

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#network_id YdbDatabaseDedicated#network_id}.

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#resource_preset_id YdbDatabaseDedicated#resource_preset_id}.

---

##### `scalePolicy`<sup>Required</sup> <a name="scalePolicy" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.scalePolicy"></a>

```typescript
public readonly scalePolicy: YdbDatabaseDedicatedScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a>

scale_policy block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#scale_policy YdbDatabaseDedicated#scale_policy}

---

##### `storageConfig`<sup>Required</sup> <a name="storageConfig" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.storageConfig"></a>

```typescript
public readonly storageConfig: YdbDatabaseDedicatedStorageConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a>

storage_config block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#storage_config YdbDatabaseDedicated#storage_config}

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#subnet_ids YdbDatabaseDedicated#subnet_ids}.

---

##### `assignPublicIps`<sup>Optional</sup> <a name="assignPublicIps" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.assignPublicIps"></a>

```typescript
public readonly assignPublicIps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#assign_public_ips YdbDatabaseDedicated#assign_public_ips}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#description YdbDatabaseDedicated#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#folder_id YdbDatabaseDedicated#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#labels YdbDatabaseDedicated#labels}.

---

##### `location`<sup>Optional</sup> <a name="location" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.location"></a>

```typescript
public readonly location: YdbDatabaseDedicatedLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a>

location block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#location YdbDatabaseDedicated#location}

---

##### `locationId`<sup>Optional</sup> <a name="locationId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#location_id YdbDatabaseDedicated#location_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.YdbDatabaseDedicatedConfig.property.timeouts"></a>

```typescript
public readonly timeouts: YdbDatabaseDedicatedTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#timeouts YdbDatabaseDedicated#timeouts}

---

### YdbDatabaseDedicatedLocation <a name="YdbDatabaseDedicatedLocation" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocation"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocation.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedLocation } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedLocation: YdbDatabaseDedicatedLocation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation.property.region">region</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a></code> | region block. |

---

##### `region`<sup>Optional</sup> <a name="region" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocation.property.region"></a>

```typescript
public readonly region: YdbDatabaseDedicatedLocationRegion;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a>

region block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#region YdbDatabaseDedicated#region}

---

### YdbDatabaseDedicatedLocationRegion <a name="YdbDatabaseDedicatedLocationRegion" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedLocationRegion } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedLocationRegion: YdbDatabaseDedicatedLocationRegion = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}. |

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#id YdbDatabaseDedicated#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

### YdbDatabaseDedicatedScalePolicy <a name="YdbDatabaseDedicatedScalePolicy" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedScalePolicy } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedScalePolicy: YdbDatabaseDedicatedScalePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a></code> | fixed_scale block. |

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy.property.fixedScale"></a>

```typescript
public readonly fixedScale: YdbDatabaseDedicatedScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a>

fixed_scale block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#fixed_scale YdbDatabaseDedicated#fixed_scale}

---

### YdbDatabaseDedicatedScalePolicyFixedScale <a name="YdbDatabaseDedicatedScalePolicyFixedScale" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedScalePolicyFixedScale } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedScalePolicyFixedScale: YdbDatabaseDedicatedScalePolicyFixedScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale.property.size">size</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#size YdbDatabaseDedicated#size}. |

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#size YdbDatabaseDedicated#size}.

---

### YdbDatabaseDedicatedStorageConfig <a name="YdbDatabaseDedicatedStorageConfig" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedStorageConfig } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedStorageConfig: YdbDatabaseDedicatedStorageConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig.property.groupCount">groupCount</a></code> | <code>number</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#group_count YdbDatabaseDedicated#group_count}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig.property.storageTypeId">storageTypeId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#storage_type_id YdbDatabaseDedicated#storage_type_id}. |

---

##### `groupCount`<sup>Required</sup> <a name="groupCount" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig.property.groupCount"></a>

```typescript
public readonly groupCount: number;
```

- *Type:* number

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#group_count YdbDatabaseDedicated#group_count}.

---

##### `storageTypeId`<sup>Required</sup> <a name="storageTypeId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig.property.storageTypeId"></a>

```typescript
public readonly storageTypeId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#storage_type_id YdbDatabaseDedicated#storage_type_id}.

---

### YdbDatabaseDedicatedTimeouts <a name="YdbDatabaseDedicatedTimeouts" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedTimeouts } from '@cdktf/provider-yandex'

const ydbDatabaseDedicatedTimeouts: YdbDatabaseDedicatedTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts.property.default">default</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#default YdbDatabaseDedicated#default}. |

---

##### `default`<sup>Optional</sup> <a name="default" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_dedicated#default YdbDatabaseDedicated#default}.

---

### YdbDatabaseServerlessConfig <a name="YdbDatabaseServerlessConfig" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.Initializer"></a>

```typescript
import { YdbDatabaseServerlessConfig } from '@cdktf/provider-yandex'

const ydbDatabaseServerlessConfig: YdbDatabaseServerlessConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.count">count</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.dependsOn">dependsOn</a></code> | <code>cdktf.ITerraformDependable[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.lifecycle">lifecycle</a></code> | <code>cdktf.TerraformResourceLifecycle</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.provider">provider</a></code> | <code>cdktf.TerraformProvider</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.name">name</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#name YdbDatabaseServerless#name}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.description">description</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#description YdbDatabaseServerless#description}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.folderId">folderId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#folder_id YdbDatabaseServerless#folder_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.id">id</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#id YdbDatabaseServerless#id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#labels YdbDatabaseServerless#labels}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.locationId">locationId</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#location_id YdbDatabaseServerless#location_id}. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.timeouts">timeouts</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a></code> | timeouts block. |

---

##### `count`<sup>Optional</sup> <a name="count" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.dependsOn"></a>

```typescript
public readonly dependsOn: ITerraformDependable[];
```

- *Type:* cdktf.ITerraformDependable[]

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.lifecycle"></a>

```typescript
public readonly lifecycle: TerraformResourceLifecycle;
```

- *Type:* cdktf.TerraformResourceLifecycle

---

##### `provider`<sup>Optional</sup> <a name="provider" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.provider"></a>

```typescript
public readonly provider: TerraformProvider;
```

- *Type:* cdktf.TerraformProvider

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#name YdbDatabaseServerless#name}.

---

##### `description`<sup>Optional</sup> <a name="description" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#description YdbDatabaseServerless#description}.

---

##### `folderId`<sup>Optional</sup> <a name="folderId" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#folder_id YdbDatabaseServerless#folder_id}.

---

##### `id`<sup>Optional</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#id YdbDatabaseServerless#id}.

Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#labels YdbDatabaseServerless#labels}.

---

##### `locationId`<sup>Optional</sup> <a name="locationId" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.locationId"></a>

```typescript
public readonly locationId: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#location_id YdbDatabaseServerless#location_id}.

---

##### `timeouts`<sup>Optional</sup> <a name="timeouts" id="@cdktf/provider-yandex.YdbDatabaseServerlessConfig.property.timeouts"></a>

```typescript
public readonly timeouts: YdbDatabaseServerlessTimeouts;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a>

timeouts block.

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#timeouts YdbDatabaseServerless#timeouts}

---

### YdbDatabaseServerlessTimeouts <a name="YdbDatabaseServerlessTimeouts" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts"></a>

#### Initializer <a name="Initializer" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts.Initializer"></a>

```typescript
import { YdbDatabaseServerlessTimeouts } from '@cdktf/provider-yandex'

const ydbDatabaseServerlessTimeouts: YdbDatabaseServerlessTimeouts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts.property.default">default</a></code> | <code>string</code> | Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#default YdbDatabaseServerless#default}. |

---

##### `default`<sup>Optional</sup> <a name="default" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/ydb_database_serverless#default YdbDatabaseServerless#default}.

---

## Classes <a name="Classes" id="Classes"></a>

### AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference <a name="AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---


### AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference <a name="AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput">pathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---


### AlbBackendGroupGrpcBackendHealthcheckOutputReference <a name="AlbBackendGroupGrpcBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalInput">intervalInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">AlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">AlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalInput`<sup>Optional</sup> <a name="intervalInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: string;
```

- *Type:* string

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: string;
```

- *Type:* string

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a>

---


### AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference <a name="AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">AlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---


### AlbBackendGroupGrpcBackendList <a name="AlbBackendGroupGrpcBackendList" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendList } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.get"></a>

```typescript
public get(index: number): AlbBackendGroupGrpcBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackend[] | IResolvable;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a>[] | cdktf.IResolvable

---


### AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference <a name="AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---


### AlbBackendGroupGrpcBackendOutputReference <a name="AlbBackendGroupGrpcBackendOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: AlbBackendGroupGrpcBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: AlbBackendGroupGrpcBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putTls"></a>

```typescript
public putTls(value: AlbBackendGroupGrpcBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference">AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference">AlbBackendGroupGrpcBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.targetGroupIdsInput">targetGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a> \| cdktf.IResolvable</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupGrpcBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheckOutputReference">AlbBackendGroupGrpcBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference">AlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference</a>

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupGrpcBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference">AlbBackendGroupGrpcBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: AlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendHealthcheck">AlbBackendGroupGrpcBackendHealthcheck</a>

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: AlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendLoadBalancingConfig">AlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `targetGroupIdsInput`<sup>Optional</sup> <a name="targetGroupIdsInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.targetGroupIdsInput"></a>

```typescript
public readonly targetGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: AlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackend | IResolvable;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackend">AlbBackendGroupGrpcBackend</a> | cdktf.IResolvable

---


### AlbBackendGroupGrpcBackendTlsOutputReference <a name="AlbBackendGroupGrpcBackendTlsOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendTlsOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: AlbBackendGroupGrpcBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference">AlbBackendGroupGrpcBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupGrpcBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference">AlbBackendGroupGrpcBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: AlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTls">AlbBackendGroupGrpcBackendTls</a>

---


### AlbBackendGroupGrpcBackendTlsValidationContextOutputReference <a name="AlbBackendGroupGrpcBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupGrpcBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupGrpcBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupGrpcBackendTlsValidationContext">AlbBackendGroupGrpcBackendTlsValidationContext</a>

---


### AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference <a name="AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---


### AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference <a name="AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput">pathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---


### AlbBackendGroupHttpBackendHealthcheckOutputReference <a name="AlbBackendGroupHttpBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalInput">intervalInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">AlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">AlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalInput`<sup>Optional</sup> <a name="intervalInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: string;
```

- *Type:* string

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: string;
```

- *Type:* string

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a>

---


### AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference <a name="AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">AlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---


### AlbBackendGroupHttpBackendList <a name="AlbBackendGroupHttpBackendList" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendList } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.get"></a>

```typescript
public get(index: number): AlbBackendGroupHttpBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>[]

---


### AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference <a name="AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a>

---


### AlbBackendGroupHttpBackendOutputReference <a name="AlbBackendGroupHttpBackendOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetStorageBucket">resetStorageBucket</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetTargetGroupIds">resetTargetGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: AlbBackendGroupHttpBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: AlbBackendGroupHttpBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putTls"></a>

```typescript
public putTls(value: AlbBackendGroupHttpBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetStorageBucket` <a name="resetStorageBucket" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetStorageBucket"></a>

```typescript
public resetStorageBucket(): void
```

##### `resetTargetGroupIds` <a name="resetTargetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetTargetGroupIds"></a>

```typescript
public resetTargetGroupIds(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference">AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference">AlbBackendGroupHttpBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.storageBucketInput">storageBucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.targetGroupIdsInput">targetGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.storageBucket">storageBucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupHttpBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheckOutputReference">AlbBackendGroupHttpBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference">AlbBackendGroupHttpBackendLoadBalancingConfigOutputReference</a>

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupHttpBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference">AlbBackendGroupHttpBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: AlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendHealthcheck">AlbBackendGroupHttpBackendHealthcheck</a>

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: AlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendLoadBalancingConfig">AlbBackendGroupHttpBackendLoadBalancingConfig</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `storageBucketInput`<sup>Optional</sup> <a name="storageBucketInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.storageBucketInput"></a>

```typescript
public readonly storageBucketInput: string;
```

- *Type:* string

---

##### `targetGroupIdsInput`<sup>Optional</sup> <a name="targetGroupIdsInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.targetGroupIdsInput"></a>

```typescript
public readonly targetGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: AlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `storageBucket`<sup>Required</sup> <a name="storageBucket" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.storageBucket"></a>

```typescript
public readonly storageBucket: string;
```

- *Type:* string

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbBackendGroupHttpBackend;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackend">AlbBackendGroupHttpBackend</a>

---


### AlbBackendGroupHttpBackendTlsOutputReference <a name="AlbBackendGroupHttpBackendTlsOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendTlsOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: AlbBackendGroupHttpBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference">AlbBackendGroupHttpBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupHttpBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference">AlbBackendGroupHttpBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: AlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTls">AlbBackendGroupHttpBackendTls</a>

---


### AlbBackendGroupHttpBackendTlsValidationContextOutputReference <a name="AlbBackendGroupHttpBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupHttpBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupHttpBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupHttpBackendTlsValidationContext">AlbBackendGroupHttpBackendTlsValidationContext</a>

---


### AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference <a name="AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---


### AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference <a name="AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput">pathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* string

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---


### AlbBackendGroupStreamBackendHealthcheckOutputReference <a name="AlbBackendGroupStreamBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalInput">intervalInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">AlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">AlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalInput`<sup>Optional</sup> <a name="intervalInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: string;
```

- *Type:* string

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: string;
```

- *Type:* string

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a>

---


### AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference <a name="AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">AlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---


### AlbBackendGroupStreamBackendList <a name="AlbBackendGroupStreamBackendList" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendList } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.get"></a>

```typescript
public get(index: number): AlbBackendGroupStreamBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>[]

---


### AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference <a name="AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a>

---


### AlbBackendGroupStreamBackendOutputReference <a name="AlbBackendGroupStreamBackendOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: AlbBackendGroupStreamBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: AlbBackendGroupStreamBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putTls"></a>

```typescript
public putTls(value: AlbBackendGroupStreamBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference">AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference">AlbBackendGroupStreamBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.targetGroupIdsInput">targetGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: AlbBackendGroupStreamBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheckOutputReference">AlbBackendGroupStreamBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference">AlbBackendGroupStreamBackendLoadBalancingConfigOutputReference</a>

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: AlbBackendGroupStreamBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference">AlbBackendGroupStreamBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: AlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendHealthcheck">AlbBackendGroupStreamBackendHealthcheck</a>

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: AlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendLoadBalancingConfig">AlbBackendGroupStreamBackendLoadBalancingConfig</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `targetGroupIdsInput`<sup>Optional</sup> <a name="targetGroupIdsInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.targetGroupIdsInput"></a>

```typescript
public readonly targetGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: AlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbBackendGroupStreamBackend;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackend">AlbBackendGroupStreamBackend</a>

---


### AlbBackendGroupStreamBackendTlsOutputReference <a name="AlbBackendGroupStreamBackendTlsOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendTlsOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: AlbBackendGroupStreamBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference">AlbBackendGroupStreamBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: AlbBackendGroupStreamBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference">AlbBackendGroupStreamBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: AlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTls">AlbBackendGroupStreamBackendTls</a>

---


### AlbBackendGroupStreamBackendTlsValidationContextOutputReference <a name="AlbBackendGroupStreamBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupStreamBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupStreamBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbBackendGroupStreamBackendTlsValidationContext">AlbBackendGroupStreamBackendTlsValidationContext</a>

---


### AlbBackendGroupTimeoutsOutputReference <a name="AlbBackendGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { AlbBackendGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new AlbBackendGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbBackendGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbBackendGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbBackendGroupTimeouts">AlbBackendGroupTimeouts</a>

---


### AlbHttpRouterTimeoutsOutputReference <a name="AlbHttpRouterTimeoutsOutputReference" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.Initializer"></a>

```typescript
import { AlbHttpRouterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new AlbHttpRouterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbHttpRouterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbHttpRouterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbHttpRouterTimeouts">AlbHttpRouterTimeouts</a>

---


### AlbLoadBalancerAllocationPolicyLocationList <a name="AlbLoadBalancerAllocationPolicyLocationList" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer"></a>

```typescript
import { AlbLoadBalancerAllocationPolicyLocationList } from '@cdktf/provider-yandex'

new AlbLoadBalancerAllocationPolicyLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.get"></a>

```typescript
public get(index: number): AlbLoadBalancerAllocationPolicyLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]

---


### AlbLoadBalancerAllocationPolicyLocationOutputReference <a name="AlbLoadBalancerAllocationPolicyLocationOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerAllocationPolicyLocationOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerAllocationPolicyLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.resetDisableTraffic">resetDisableTraffic</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDisableTraffic` <a name="resetDisableTraffic" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.resetDisableTraffic"></a>

```typescript
public resetDisableTraffic(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTrafficInput">disableTrafficInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneIdInput">zoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTraffic">disableTraffic</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disableTrafficInput`<sup>Optional</sup> <a name="disableTrafficInput" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTrafficInput"></a>

```typescript
public readonly disableTrafficInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneIdInput`<sup>Optional</sup> <a name="zoneIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* string

---

##### `disableTraffic`<sup>Required</sup> <a name="disableTraffic" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTraffic"></a>

```typescript
public readonly disableTraffic: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerAllocationPolicyLocation;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>

---


### AlbLoadBalancerAllocationPolicyOutputReference <a name="AlbLoadBalancerAllocationPolicyOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.putLocation">putLocation</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putLocation` <a name="putLocation" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.putLocation"></a>

```typescript
public putLocation(value: IResolvable | AlbLoadBalancerAllocationPolicyLocation[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.putLocation.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList">AlbLoadBalancerAllocationPolicyLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.locationInput">locationInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.location"></a>

```typescript
public readonly location: AlbLoadBalancerAllocationPolicyLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocationList">AlbLoadBalancerAllocationPolicyLocationList</a>

---

##### `locationInput`<sup>Optional</sup> <a name="locationInput" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.locationInput"></a>

```typescript
public readonly locationInput: IResolvable | AlbLoadBalancerAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyLocation">AlbLoadBalancerAllocationPolicyLocation</a>[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerAllocationPolicy">AlbLoadBalancerAllocationPolicy</a>

---


### AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference <a name="AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resetAddress">resetAddress</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a>

---


### AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference <a name="AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resetAddress">resetAddress</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a>

---


### AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference <a name="AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a>

---


### AlbLoadBalancerListenerEndpointAddressList <a name="AlbLoadBalancerListenerEndpointAddressList" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressList } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointAddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.get"></a>

```typescript
public get(index: number): AlbLoadBalancerListenerEndpointAddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerEndpointAddress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]

---


### AlbLoadBalancerListenerEndpointAddressOutputReference <a name="AlbLoadBalancerListenerEndpointAddressOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointAddressOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointAddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv4Address">putExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv6Address">putExternalIpv6Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putInternalIpv4Address">putInternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetExternalIpv4Address">resetExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetExternalIpv6Address">resetExternalIpv6Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetInternalIpv4Address">resetInternalIpv4Address</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExternalIpv4Address` <a name="putExternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv4Address"></a>

```typescript
public putExternalIpv4Address(value: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv4Address.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a>

---

##### `putExternalIpv6Address` <a name="putExternalIpv6Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv6Address"></a>

```typescript
public putExternalIpv6Address(value: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putExternalIpv6Address.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a>

---

##### `putInternalIpv4Address` <a name="putInternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putInternalIpv4Address"></a>

```typescript
public putInternalIpv4Address(value: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.putInternalIpv4Address.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a>

---

##### `resetExternalIpv4Address` <a name="resetExternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetExternalIpv4Address"></a>

```typescript
public resetExternalIpv4Address(): void
```

##### `resetExternalIpv6Address` <a name="resetExternalIpv6Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetExternalIpv6Address"></a>

```typescript
public resetExternalIpv6Address(): void
```

##### `resetInternalIpv4Address` <a name="resetInternalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.resetInternalIpv4Address"></a>

```typescript
public resetInternalIpv4Address(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference">AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6Address">externalIpv6Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference">AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4Address">internalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference">AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4AddressInput">externalIpv4AddressInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6AddressInput">externalIpv6AddressInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4AddressInput">internalIpv4AddressInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalIpv4Address`<sup>Required</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference">AlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference</a>

---

##### `externalIpv6Address`<sup>Required</sup> <a name="externalIpv6Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6Address"></a>

```typescript
public readonly externalIpv6Address: AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference">AlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference</a>

---

##### `internalIpv4Address`<sup>Required</sup> <a name="internalIpv4Address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4Address"></a>

```typescript
public readonly internalIpv4Address: AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference">AlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference</a>

---

##### `externalIpv4AddressInput`<sup>Optional</sup> <a name="externalIpv4AddressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4AddressInput"></a>

```typescript
public readonly externalIpv4AddressInput: AlbLoadBalancerListenerEndpointAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv4Address">AlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a>

---

##### `externalIpv6AddressInput`<sup>Optional</sup> <a name="externalIpv6AddressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6AddressInput"></a>

```typescript
public readonly externalIpv6AddressInput: AlbLoadBalancerListenerEndpointAddressExternalIpv6Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressExternalIpv6Address">AlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a>

---

##### `internalIpv4AddressInput`<sup>Optional</sup> <a name="internalIpv4AddressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4AddressInput"></a>

```typescript
public readonly internalIpv4AddressInput: AlbLoadBalancerListenerEndpointAddressInternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressInternalIpv4Address">AlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerEndpointAddress;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>

---


### AlbLoadBalancerListenerEndpointList <a name="AlbLoadBalancerListenerEndpointList" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointList } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.get"></a>

```typescript
public get(index: number): AlbLoadBalancerListenerEndpointOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerEndpoint[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]

---


### AlbLoadBalancerListenerEndpointOutputReference <a name="AlbLoadBalancerListenerEndpointOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerEndpointOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerEndpointOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.putAddress">putAddress</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAddress` <a name="putAddress" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.putAddress"></a>

```typescript
public putAddress(value: IResolvable | AlbLoadBalancerListenerEndpointAddress[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.putAddress.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.address">address</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList">AlbLoadBalancerListenerEndpointAddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.addressInput">addressInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.portsInput">portsInput</a></code> | <code>number[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.ports">ports</a></code> | <code>number[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.address"></a>

```typescript
public readonly address: AlbLoadBalancerListenerEndpointAddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddressList">AlbLoadBalancerListenerEndpointAddressList</a>

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: IResolvable | AlbLoadBalancerListenerEndpointAddress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointAddress">AlbLoadBalancerListenerEndpointAddress</a>[]

---

##### `portsInput`<sup>Optional</sup> <a name="portsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.portsInput"></a>

```typescript
public readonly portsInput: number[];
```

- *Type:* number[]

---

##### `ports`<sup>Required</sup> <a name="ports" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.ports"></a>

```typescript
public readonly ports: number[];
```

- *Type:* number[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerEndpoint;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>

---


### AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference <a name="AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams">resetMaxConcurrentStreams</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxConcurrentStreams` <a name="resetMaxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams"></a>

```typescript
public resetMaxConcurrentStreams(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput">maxConcurrentStreamsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreamsInput`<sup>Optional</sup> <a name="maxConcurrentStreamsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput"></a>

```typescript
public readonly maxConcurrentStreamsInput: number;
```

- *Type:* number

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a>

---


### AlbLoadBalancerListenerHttpHandlerOutputReference <a name="AlbLoadBalancerListenerHttpHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.putHttp2Options">putHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetAllowHttp10">resetAllowHttp10</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetHttp2Options">resetHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetHttpRouterId">resetHttpRouterId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttp2Options` <a name="putHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.putHttp2Options"></a>

```typescript
public putHttp2Options(value: AlbLoadBalancerListenerHttpHandlerHttp2Options): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.putHttp2Options.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a>

---

##### `resetAllowHttp10` <a name="resetAllowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetAllowHttp10"></a>

```typescript
public resetAllowHttp10(): void
```

##### `resetHttp2Options` <a name="resetHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetHttp2Options"></a>

```typescript
public resetHttp2Options(): void
```

##### `resetHttpRouterId` <a name="resetHttpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.resetHttpRouterId"></a>

```typescript
public resetHttpRouterId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10Input">allowHttp10Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.http2OptionsInput">http2OptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference</a>

---

##### `allowHttp10Input`<sup>Optional</sup> <a name="allowHttp10Input" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10Input"></a>

```typescript
public readonly allowHttp10Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `http2OptionsInput`<sup>Optional</sup> <a name="http2OptionsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.http2OptionsInput"></a>

```typescript
public readonly http2OptionsInput: AlbLoadBalancerListenerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerHttp2Options">AlbLoadBalancerListenerHttpHandlerHttp2Options</a>

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a>

---


### AlbLoadBalancerListenerHttpOutputReference <a name="AlbLoadBalancerListenerHttpOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerHttpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putHandler">putHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putRedirects">putRedirects</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resetHandler">resetHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resetRedirects">resetRedirects</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHandler` <a name="putHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putHandler"></a>

```typescript
public putHandler(value: AlbLoadBalancerListenerHttpHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a>

---

##### `putRedirects` <a name="putRedirects" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putRedirects"></a>

```typescript
public putRedirects(value: AlbLoadBalancerListenerHttpRedirects): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.putRedirects.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a>

---

##### `resetHandler` <a name="resetHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resetHandler"></a>

```typescript
public resetHandler(): void
```

##### `resetRedirects` <a name="resetRedirects" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.resetRedirects"></a>

```typescript
public resetRedirects(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference">AlbLoadBalancerListenerHttpHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.redirects">redirects</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference">AlbLoadBalancerListenerHttpRedirectsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.handlerInput">handlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.redirectsInput">redirectsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerHttpHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandlerOutputReference">AlbLoadBalancerListenerHttpHandlerOutputReference</a>

---

##### `redirects`<sup>Required</sup> <a name="redirects" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.redirects"></a>

```typescript
public readonly redirects: AlbLoadBalancerListenerHttpRedirectsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference">AlbLoadBalancerListenerHttpRedirectsOutputReference</a>

---

##### `handlerInput`<sup>Optional</sup> <a name="handlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.handlerInput"></a>

```typescript
public readonly handlerInput: AlbLoadBalancerListenerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpHandler">AlbLoadBalancerListenerHttpHandler</a>

---

##### `redirectsInput`<sup>Optional</sup> <a name="redirectsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.redirectsInput"></a>

```typescript
public readonly redirectsInput: AlbLoadBalancerListenerHttpRedirects;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerHttp;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a>

---


### AlbLoadBalancerListenerHttpRedirectsOutputReference <a name="AlbLoadBalancerListenerHttpRedirectsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerHttpRedirectsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerHttpRedirectsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.resetHttpToHttps">resetHttpToHttps</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHttpToHttps` <a name="resetHttpToHttps" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.resetHttpToHttps"></a>

```typescript
public resetHttpToHttps(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttpsInput">httpToHttpsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttps">httpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpToHttpsInput`<sup>Optional</sup> <a name="httpToHttpsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttpsInput"></a>

```typescript
public readonly httpToHttpsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `httpToHttps`<sup>Required</sup> <a name="httpToHttps" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttps"></a>

```typescript
public readonly httpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirectsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerHttpRedirects;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpRedirects">AlbLoadBalancerListenerHttpRedirects</a>

---


### AlbLoadBalancerListenerList <a name="AlbLoadBalancerListenerList" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerList } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.get"></a>

```typescript
public get(index: number): AlbLoadBalancerListenerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>[]

---


### AlbLoadBalancerListenerOutputReference <a name="AlbLoadBalancerListenerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putEndpoint">putEndpoint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putHttp">putHttp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putStream">putStream</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetEndpoint">resetEndpoint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetHttp">resetHttp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetStream">resetStream</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetTls">resetTls</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putEndpoint` <a name="putEndpoint" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putEndpoint"></a>

```typescript
public putEndpoint(value: IResolvable | AlbLoadBalancerListenerEndpoint[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putEndpoint.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]

---

##### `putHttp` <a name="putHttp" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putHttp"></a>

```typescript
public putHttp(value: AlbLoadBalancerListenerHttp): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putHttp.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a>

---

##### `putStream` <a name="putStream" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putStream"></a>

```typescript
public putStream(value: AlbLoadBalancerListenerStream): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putStream.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putTls"></a>

```typescript
public putTls(value: AlbLoadBalancerListenerTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a>

---

##### `resetEndpoint` <a name="resetEndpoint" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetEndpoint"></a>

```typescript
public resetEndpoint(): void
```

##### `resetHttp` <a name="resetHttp" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetHttp"></a>

```typescript
public resetHttp(): void
```

##### `resetStream` <a name="resetStream" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetStream"></a>

```typescript
public resetStream(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.endpoint">endpoint</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList">AlbLoadBalancerListenerEndpointList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.http">http</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference">AlbLoadBalancerListenerHttpOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.stream">stream</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference">AlbLoadBalancerListenerStreamOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference">AlbLoadBalancerListenerTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.endpointInput">endpointInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.httpInput">httpInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.streamInput">streamInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `endpoint`<sup>Required</sup> <a name="endpoint" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.endpoint"></a>

```typescript
public readonly endpoint: AlbLoadBalancerListenerEndpointList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpointList">AlbLoadBalancerListenerEndpointList</a>

---

##### `http`<sup>Required</sup> <a name="http" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.http"></a>

```typescript
public readonly http: AlbLoadBalancerListenerHttpOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttpOutputReference">AlbLoadBalancerListenerHttpOutputReference</a>

---

##### `stream`<sup>Required</sup> <a name="stream" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.stream"></a>

```typescript
public readonly stream: AlbLoadBalancerListenerStreamOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference">AlbLoadBalancerListenerStreamOutputReference</a>

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.tls"></a>

```typescript
public readonly tls: AlbLoadBalancerListenerTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference">AlbLoadBalancerListenerTlsOutputReference</a>

---

##### `endpointInput`<sup>Optional</sup> <a name="endpointInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.endpointInput"></a>

```typescript
public readonly endpointInput: IResolvable | AlbLoadBalancerListenerEndpoint[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerEndpoint">AlbLoadBalancerListenerEndpoint</a>[]

---

##### `httpInput`<sup>Optional</sup> <a name="httpInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.httpInput"></a>

```typescript
public readonly httpInput: AlbLoadBalancerListenerHttp;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerHttp">AlbLoadBalancerListenerHttp</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `streamInput`<sup>Optional</sup> <a name="streamInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.streamInput"></a>

```typescript
public readonly streamInput: AlbLoadBalancerListenerStream;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a>

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: AlbLoadBalancerListenerTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListener;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListener">AlbLoadBalancerListener</a>

---


### AlbLoadBalancerListenerStreamHandlerOutputReference <a name="AlbLoadBalancerListenerStreamHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.resetBackendGroupId">resetBackendGroupId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBackendGroupId` <a name="resetBackendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.resetBackendGroupId"></a>

```typescript
public resetBackendGroupId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a>

---


### AlbLoadBalancerListenerStreamOutputReference <a name="AlbLoadBalancerListenerStreamOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerStreamOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerStreamOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.putHandler">putHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.resetHandler">resetHandler</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHandler` <a name="putHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.putHandler"></a>

```typescript
public putHandler(value: AlbLoadBalancerListenerStreamHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.putHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a>

---

##### `resetHandler` <a name="resetHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.resetHandler"></a>

```typescript
public resetHandler(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference">AlbLoadBalancerListenerStreamHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.handlerInput">handlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerStreamHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandlerOutputReference">AlbLoadBalancerListenerStreamHandlerOutputReference</a>

---

##### `handlerInput`<sup>Optional</sup> <a name="handlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.handlerInput"></a>

```typescript
public readonly handlerInput: AlbLoadBalancerListenerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStreamHandler">AlbLoadBalancerListenerStreamHandler</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerStreamOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerStream;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerStream">AlbLoadBalancerListenerStream</a>

---


### AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference <a name="AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams">resetMaxConcurrentStreams</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxConcurrentStreams` <a name="resetMaxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams"></a>

```typescript
public resetMaxConcurrentStreams(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput">maxConcurrentStreamsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreamsInput`<sup>Optional</sup> <a name="maxConcurrentStreamsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput"></a>

```typescript
public readonly maxConcurrentStreamsInput: number;
```

- *Type:* number

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a>

---


### AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference <a name="AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.putHttp2Options">putHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetAllowHttp10">resetAllowHttp10</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetHttp2Options">resetHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetHttpRouterId">resetHttpRouterId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttp2Options` <a name="putHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.putHttp2Options"></a>

```typescript
public putHttp2Options(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.putHttp2Options.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a>

---

##### `resetAllowHttp10` <a name="resetAllowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetAllowHttp10"></a>

```typescript
public resetAllowHttp10(): void
```

##### `resetHttp2Options` <a name="resetHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetHttp2Options"></a>

```typescript
public resetHttp2Options(): void
```

##### `resetHttpRouterId` <a name="resetHttpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resetHttpRouterId"></a>

```typescript
public resetHttpRouterId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10Input">allowHttp10Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2OptionsInput">http2OptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference</a>

---

##### `allowHttp10Input`<sup>Optional</sup> <a name="allowHttp10Input" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10Input"></a>

```typescript
public readonly allowHttp10Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `http2OptionsInput`<sup>Optional</sup> <a name="http2OptionsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2OptionsInput"></a>

```typescript
public readonly http2OptionsInput: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a>

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a>

---


### AlbLoadBalancerListenerTlsDefaultHandlerOutputReference <a name="AlbLoadBalancerListenerTlsDefaultHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsDefaultHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putHttpHandler">putHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putStreamHandler">putStreamHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resetHttpHandler">resetHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resetStreamHandler">resetStreamHandler</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttpHandler` <a name="putHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putHttpHandler"></a>

```typescript
public putHttpHandler(value: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putHttpHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a>

---

##### `putStreamHandler` <a name="putStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putStreamHandler"></a>

```typescript
public putStreamHandler(value: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.putStreamHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a>

---

##### `resetHttpHandler` <a name="resetHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resetHttpHandler"></a>

```typescript
public resetHttpHandler(): void
```

##### `resetStreamHandler` <a name="resetStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resetStreamHandler"></a>

```typescript
public resetStreamHandler(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIdsInput">certificateIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandlerInput">httpHandlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandlerInput">streamHandlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpHandler`<sup>Required</sup> <a name="httpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandler"></a>

```typescript
public readonly httpHandler: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference</a>

---

##### `streamHandler`<sup>Required</sup> <a name="streamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandler"></a>

```typescript
public readonly streamHandler: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference</a>

---

##### `certificateIdsInput`<sup>Optional</sup> <a name="certificateIdsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIdsInput"></a>

```typescript
public readonly certificateIdsInput: string[];
```

- *Type:* string[]

---

##### `httpHandlerInput`<sup>Optional</sup> <a name="httpHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandlerInput"></a>

```typescript
public readonly httpHandlerInput: AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">AlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a>

---

##### `streamHandlerInput`<sup>Optional</sup> <a name="streamHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandlerInput"></a>

```typescript
public readonly streamHandlerInput: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a>

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsDefaultHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a>

---


### AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference <a name="AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resetBackendGroupId">resetBackendGroupId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBackendGroupId` <a name="resetBackendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resetBackendGroupId"></a>

```typescript
public resetBackendGroupId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">AlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a>

---


### AlbLoadBalancerListenerTlsOutputReference <a name="AlbLoadBalancerListenerTlsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putDefaultHandler">putDefaultHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putSniHandler">putSniHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.resetSniHandler">resetSniHandler</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDefaultHandler` <a name="putDefaultHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putDefaultHandler"></a>

```typescript
public putDefaultHandler(value: AlbLoadBalancerListenerTlsDefaultHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putDefaultHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a>

---

##### `putSniHandler` <a name="putSniHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putSniHandler"></a>

```typescript
public putSniHandler(value: IResolvable | AlbLoadBalancerListenerTlsSniHandler[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.putSniHandler.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]

---

##### `resetSniHandler` <a name="resetSniHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.resetSniHandler"></a>

```typescript
public resetSniHandler(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.defaultHandler">defaultHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.sniHandler">sniHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList">AlbLoadBalancerListenerTlsSniHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.defaultHandlerInput">defaultHandlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.sniHandlerInput">sniHandlerInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `defaultHandler`<sup>Required</sup> <a name="defaultHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.defaultHandler"></a>

```typescript
public readonly defaultHandler: AlbLoadBalancerListenerTlsDefaultHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandlerOutputReference">AlbLoadBalancerListenerTlsDefaultHandlerOutputReference</a>

---

##### `sniHandler`<sup>Required</sup> <a name="sniHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.sniHandler"></a>

```typescript
public readonly sniHandler: AlbLoadBalancerListenerTlsSniHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList">AlbLoadBalancerListenerTlsSniHandlerList</a>

---

##### `defaultHandlerInput`<sup>Optional</sup> <a name="defaultHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.defaultHandlerInput"></a>

```typescript
public readonly defaultHandlerInput: AlbLoadBalancerListenerTlsDefaultHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsDefaultHandler">AlbLoadBalancerListenerTlsDefaultHandler</a>

---

##### `sniHandlerInput`<sup>Optional</sup> <a name="sniHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.sniHandlerInput"></a>

```typescript
public readonly sniHandlerInput: IResolvable | AlbLoadBalancerListenerTlsSniHandler[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTls">AlbLoadBalancerListenerTls</a>

---


### AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams">resetMaxConcurrentStreams</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxConcurrentStreams` <a name="resetMaxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resetMaxConcurrentStreams"></a>

```typescript
public resetMaxConcurrentStreams(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput">maxConcurrentStreamsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreamsInput`<sup>Optional</sup> <a name="maxConcurrentStreamsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreamsInput"></a>

```typescript
public readonly maxConcurrentStreamsInput: number;
```

- *Type:* number

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a>

---


### AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.putHttp2Options">putHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetAllowHttp10">resetAllowHttp10</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetHttp2Options">resetHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetHttpRouterId">resetHttpRouterId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttp2Options` <a name="putHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.putHttp2Options"></a>

```typescript
public putHttp2Options(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.putHttp2Options.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a>

---

##### `resetAllowHttp10` <a name="resetAllowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetAllowHttp10"></a>

```typescript
public resetAllowHttp10(): void
```

##### `resetHttp2Options` <a name="resetHttp2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetHttp2Options"></a>

```typescript
public resetHttp2Options(): void
```

##### `resetHttpRouterId` <a name="resetHttpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resetHttpRouterId"></a>

```typescript
public resetHttpRouterId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10Input">allowHttp10Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2OptionsInput">http2OptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterIdInput">httpRouterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference</a>

---

##### `allowHttp10Input`<sup>Optional</sup> <a name="allowHttp10Input" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10Input"></a>

```typescript
public readonly allowHttp10Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `http2OptionsInput`<sup>Optional</sup> <a name="http2OptionsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2OptionsInput"></a>

```typescript
public readonly http2OptionsInput: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a>

---

##### `httpRouterIdInput`<sup>Optional</sup> <a name="httpRouterIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterIdInput"></a>

```typescript
public readonly httpRouterIdInput: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a>

---


### AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putHttpHandler">putHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putStreamHandler">putStreamHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resetHttpHandler">resetHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resetStreamHandler">resetStreamHandler</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttpHandler` <a name="putHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putHttpHandler"></a>

```typescript
public putHttpHandler(value: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putHttpHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a>

---

##### `putStreamHandler` <a name="putStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putStreamHandler"></a>

```typescript
public putStreamHandler(value: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.putStreamHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a>

---

##### `resetHttpHandler` <a name="resetHttpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resetHttpHandler"></a>

```typescript
public resetHttpHandler(): void
```

##### `resetStreamHandler` <a name="resetStreamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resetStreamHandler"></a>

```typescript
public resetStreamHandler(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIdsInput">certificateIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandlerInput">httpHandlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandlerInput">streamHandlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpHandler`<sup>Required</sup> <a name="httpHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandler"></a>

```typescript
public readonly httpHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference</a>

---

##### `streamHandler`<sup>Required</sup> <a name="streamHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandler"></a>

```typescript
public readonly streamHandler: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference</a>

---

##### `certificateIdsInput`<sup>Optional</sup> <a name="certificateIdsInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIdsInput"></a>

```typescript
public readonly certificateIdsInput: string[];
```

- *Type:* string[]

---

##### `httpHandlerInput`<sup>Optional</sup> <a name="httpHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandlerInput"></a>

```typescript
public readonly httpHandlerInput: AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a>

---

##### `streamHandlerInput`<sup>Optional</sup> <a name="streamHandlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandlerInput"></a>

```typescript
public readonly streamHandlerInput: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a>

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsSniHandlerHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a>

---


### AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference <a name="AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resetBackendGroupId">resetBackendGroupId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBackendGroupId` <a name="resetBackendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resetBackendGroupId"></a>

```typescript
public resetBackendGroupId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">AlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a>

---


### AlbLoadBalancerListenerTlsSniHandlerList <a name="AlbLoadBalancerListenerTlsSniHandlerList" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerList } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.get"></a>

```typescript
public get(index: number): AlbLoadBalancerListenerTlsSniHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerTlsSniHandler[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>[]

---


### AlbLoadBalancerListenerTlsSniHandlerOutputReference <a name="AlbLoadBalancerListenerTlsSniHandlerOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerListenerTlsSniHandlerOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerListenerTlsSniHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.putHandler">putHandler</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHandler` <a name="putHandler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.putHandler"></a>

```typescript
public putHandler(value: AlbLoadBalancerListenerTlsSniHandlerHandler): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.putHandler.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handlerInput">handlerInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNamesInput">serverNamesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNames">serverNames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handler"></a>

```typescript
public readonly handler: AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference">AlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference</a>

---

##### `handlerInput`<sup>Optional</sup> <a name="handlerInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handlerInput"></a>

```typescript
public readonly handlerInput: AlbLoadBalancerListenerTlsSniHandlerHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerHandler">AlbLoadBalancerListenerTlsSniHandlerHandler</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `serverNamesInput`<sup>Optional</sup> <a name="serverNamesInput" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNamesInput"></a>

```typescript
public readonly serverNamesInput: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serverNames`<sup>Required</sup> <a name="serverNames" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNames"></a>

```typescript
public readonly serverNames: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerListenerTlsSniHandler;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerListenerTlsSniHandler">AlbLoadBalancerListenerTlsSniHandler</a>

---


### AlbLoadBalancerTimeoutsOutputReference <a name="AlbLoadBalancerTimeoutsOutputReference" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.Initializer"></a>

```typescript
import { AlbLoadBalancerTimeoutsOutputReference } from '@cdktf/provider-yandex'

new AlbLoadBalancerTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbLoadBalancerTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbLoadBalancerTimeouts">AlbLoadBalancerTimeouts</a>

---


### AlbTargetGroupTargetList <a name="AlbTargetGroupTargetList" id="@cdktf/provider-yandex.AlbTargetGroupTargetList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer"></a>

```typescript
import { AlbTargetGroupTargetList } from '@cdktf/provider-yandex'

new AlbTargetGroupTargetList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.get"></a>

```typescript
public get(index: number): AlbTargetGroupTargetOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbTargetGroupTargetList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>[]

---


### AlbTargetGroupTargetOutputReference <a name="AlbTargetGroupTargetOutputReference" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer"></a>

```typescript
import { AlbTargetGroupTargetOutputReference } from '@cdktf/provider-yandex'

new AlbTargetGroupTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resetPrivateIpv4Address">resetPrivateIpv4Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPrivateIpv4Address` <a name="resetPrivateIpv4Address" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resetPrivateIpv4Address"></a>

```typescript
public resetPrivateIpv4Address(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.ipAddressInput">ipAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.privateIpv4AddressInput">privateIpv4AddressInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.privateIpv4Address">privateIpv4Address</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `ipAddressInput`<sup>Optional</sup> <a name="ipAddressInput" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* string

---

##### `privateIpv4AddressInput`<sup>Optional</sup> <a name="privateIpv4AddressInput" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.privateIpv4AddressInput"></a>

```typescript
public readonly privateIpv4AddressInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `privateIpv4Address`<sup>Required</sup> <a name="privateIpv4Address" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.privateIpv4Address"></a>

```typescript
public readonly privateIpv4Address: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbTargetGroupTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbTargetGroupTarget;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTarget">AlbTargetGroupTarget</a>

---


### AlbTargetGroupTimeoutsOutputReference <a name="AlbTargetGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { AlbTargetGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new AlbTargetGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbTargetGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbTargetGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbTargetGroupTimeouts">AlbTargetGroupTimeouts</a>

---


### AlbVirtualHostModifyRequestHeadersList <a name="AlbVirtualHostModifyRequestHeadersList" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer"></a>

```typescript
import { AlbVirtualHostModifyRequestHeadersList } from '@cdktf/provider-yandex'

new AlbVirtualHostModifyRequestHeadersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.get"></a>

```typescript
public get(index: number): AlbVirtualHostModifyRequestHeadersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostModifyRequestHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>[]

---


### AlbVirtualHostModifyRequestHeadersOutputReference <a name="AlbVirtualHostModifyRequestHeadersOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostModifyRequestHeadersOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostModifyRequestHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetAppend">resetAppend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetRemove">resetRemove</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetReplace">resetReplace</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAppend` <a name="resetAppend" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetAppend"></a>

```typescript
public resetAppend(): void
```

##### `resetRemove` <a name="resetRemove" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetRemove"></a>

```typescript
public resetRemove(): void
```

##### `resetReplace` <a name="resetReplace" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.resetReplace"></a>

```typescript
public resetReplace(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.appendInput">appendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.removeInput">removeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.replaceInput">replaceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.append">append</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.remove">remove</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.replace">replace</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `appendInput`<sup>Optional</sup> <a name="appendInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.appendInput"></a>

```typescript
public readonly appendInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `removeInput`<sup>Optional</sup> <a name="removeInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.removeInput"></a>

```typescript
public readonly removeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replaceInput`<sup>Optional</sup> <a name="replaceInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.replaceInput"></a>

```typescript
public readonly replaceInput: string;
```

- *Type:* string

---

##### `append`<sup>Required</sup> <a name="append" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `remove`<sup>Required</sup> <a name="remove" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.remove"></a>

```typescript
public readonly remove: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replace`<sup>Required</sup> <a name="replace" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostModifyRequestHeaders;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyRequestHeaders">AlbVirtualHostModifyRequestHeaders</a>

---


### AlbVirtualHostModifyResponseHeadersList <a name="AlbVirtualHostModifyResponseHeadersList" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer"></a>

```typescript
import { AlbVirtualHostModifyResponseHeadersList } from '@cdktf/provider-yandex'

new AlbVirtualHostModifyResponseHeadersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.get"></a>

```typescript
public get(index: number): AlbVirtualHostModifyResponseHeadersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostModifyResponseHeaders[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>[]

---


### AlbVirtualHostModifyResponseHeadersOutputReference <a name="AlbVirtualHostModifyResponseHeadersOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostModifyResponseHeadersOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostModifyResponseHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetAppend">resetAppend</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetRemove">resetRemove</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetReplace">resetReplace</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAppend` <a name="resetAppend" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetAppend"></a>

```typescript
public resetAppend(): void
```

##### `resetRemove` <a name="resetRemove" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetRemove"></a>

```typescript
public resetRemove(): void
```

##### `resetReplace` <a name="resetReplace" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.resetReplace"></a>

```typescript
public resetReplace(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.appendInput">appendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.removeInput">removeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.replaceInput">replaceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.append">append</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.remove">remove</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.replace">replace</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `appendInput`<sup>Optional</sup> <a name="appendInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.appendInput"></a>

```typescript
public readonly appendInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `removeInput`<sup>Optional</sup> <a name="removeInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.removeInput"></a>

```typescript
public readonly removeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replaceInput`<sup>Optional</sup> <a name="replaceInput" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.replaceInput"></a>

```typescript
public readonly replaceInput: string;
```

- *Type:* string

---

##### `append`<sup>Required</sup> <a name="append" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `remove`<sup>Required</sup> <a name="remove" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.remove"></a>

```typescript
public readonly remove: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replace`<sup>Required</sup> <a name="replace" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostModifyResponseHeaders;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostModifyResponseHeaders">AlbVirtualHostModifyResponseHeaders</a>

---


### AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference <a name="AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resetExact">resetExact</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resetPrefix">resetPrefix</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetExact` <a name="resetExact" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resetExact"></a>

```typescript
public resetExact(): void
```

##### `resetPrefix` <a name="resetPrefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resetPrefix"></a>

```typescript
public resetPrefix(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exactInput">exactInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefixInput">prefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exact">exact</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `exactInput`<sup>Optional</sup> <a name="exactInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exactInput"></a>

```typescript
public readonly exactInput: string;
```

- *Type:* string

---

##### `prefixInput`<sup>Optional</sup> <a name="prefixInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* string

---

##### `exact`<sup>Required</sup> <a name="exact" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a>

---


### AlbVirtualHostRouteGrpcRouteGrpcMatchList <a name="AlbVirtualHostRouteGrpcRouteGrpcMatchList" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcMatchList } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteGrpcMatchList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.get"></a>

```typescript
public get(index: number): AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]

---


### AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference <a name="AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.putFqmn">putFqmn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resetFqmn">resetFqmn</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putFqmn` <a name="putFqmn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.putFqmn"></a>

```typescript
public putFqmn(value: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.putFqmn.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a>

---

##### `resetFqmn` <a name="resetFqmn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resetFqmn"></a>

```typescript
public resetFqmn(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmn">fqmn</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmnInput">fqmnInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqmn`<sup>Required</sup> <a name="fqmn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmn"></a>

```typescript
public readonly fqmn: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference</a>

---

##### `fqmnInput`<sup>Optional</sup> <a name="fqmnInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmnInput"></a>

```typescript
public readonly fqmnInput: AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">AlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>

---


### AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference <a name="AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetAutoHostRewrite">resetAutoHostRewrite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetHostRewrite">resetHostRewrite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetIdleTimeout">resetIdleTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetMaxTimeout">resetMaxTimeout</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAutoHostRewrite` <a name="resetAutoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetAutoHostRewrite"></a>

```typescript
public resetAutoHostRewrite(): void
```

##### `resetHostRewrite` <a name="resetHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetHostRewrite"></a>

```typescript
public resetHostRewrite(): void
```

##### `resetIdleTimeout` <a name="resetIdleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetIdleTimeout"></a>

```typescript
public resetIdleTimeout(): void
```

##### `resetMaxTimeout` <a name="resetMaxTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resetMaxTimeout"></a>

```typescript
public resetMaxTimeout(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewriteInput">autoHostRewriteInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewriteInput">hostRewriteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeoutInput">idleTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeoutInput">maxTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewrite">autoHostRewrite</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeout">maxTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoHostRewriteInput`<sup>Optional</sup> <a name="autoHostRewriteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewriteInput"></a>

```typescript
public readonly autoHostRewriteInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `hostRewriteInput`<sup>Optional</sup> <a name="hostRewriteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewriteInput"></a>

```typescript
public readonly hostRewriteInput: string;
```

- *Type:* string

---

##### `idleTimeoutInput`<sup>Optional</sup> <a name="idleTimeoutInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeoutInput"></a>

```typescript
public readonly idleTimeoutInput: string;
```

- *Type:* string

---

##### `maxTimeoutInput`<sup>Optional</sup> <a name="maxTimeoutInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeoutInput"></a>

```typescript
public readonly maxTimeoutInput: string;
```

- *Type:* string

---

##### `autoHostRewrite`<sup>Required</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `hostRewrite`<sup>Required</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

---

##### `idleTimeout`<sup>Required</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

---

##### `maxTimeout`<sup>Required</sup> <a name="maxTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeout"></a>

```typescript
public readonly maxTimeout: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteGrpcRouteGrpcRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a>

---


### AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference <a name="AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resetStatus">resetStatus</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetStatus` <a name="resetStatus" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resetStatus"></a>

```typescript
public resetStatus(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.statusInput">statusInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `statusInput`<sup>Optional</sup> <a name="statusInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.statusInput"></a>

```typescript
public readonly statusInput: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a>

---


### AlbVirtualHostRouteGrpcRouteOutputReference <a name="AlbVirtualHostRouteGrpcRouteOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteGrpcRouteOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteGrpcRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcMatch">putGrpcMatch</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcRouteAction">putGrpcRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcStatusResponseAction">putGrpcStatusResponseAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcMatch">resetGrpcMatch</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcRouteAction">resetGrpcRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcStatusResponseAction">resetGrpcStatusResponseAction</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcMatch` <a name="putGrpcMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcMatch"></a>

```typescript
public putGrpcMatch(value: IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcMatch.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]

---

##### `putGrpcRouteAction` <a name="putGrpcRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcRouteAction"></a>

```typescript
public putGrpcRouteAction(value: AlbVirtualHostRouteGrpcRouteGrpcRouteAction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcRouteAction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a>

---

##### `putGrpcStatusResponseAction` <a name="putGrpcStatusResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcStatusResponseAction"></a>

```typescript
public putGrpcStatusResponseAction(value: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.putGrpcStatusResponseAction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a>

---

##### `resetGrpcMatch` <a name="resetGrpcMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcMatch"></a>

```typescript
public resetGrpcMatch(): void
```

##### `resetGrpcRouteAction` <a name="resetGrpcRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcRouteAction"></a>

```typescript
public resetGrpcRouteAction(): void
```

##### `resetGrpcStatusResponseAction` <a name="resetGrpcStatusResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.resetGrpcStatusResponseAction"></a>

```typescript
public resetGrpcStatusResponseAction(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatch">grpcMatch</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList">AlbVirtualHostRouteGrpcRouteGrpcMatchList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteAction">grpcRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference">AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseAction">grpcStatusResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatchInput">grpcMatchInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteActionInput">grpcRouteActionInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseActionInput">grpcStatusResponseActionInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcMatch`<sup>Required</sup> <a name="grpcMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatch"></a>

```typescript
public readonly grpcMatch: AlbVirtualHostRouteGrpcRouteGrpcMatchList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatchList">AlbVirtualHostRouteGrpcRouteGrpcMatchList</a>

---

##### `grpcRouteAction`<sup>Required</sup> <a name="grpcRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteAction"></a>

```typescript
public readonly grpcRouteAction: AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference">AlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference</a>

---

##### `grpcStatusResponseAction`<sup>Required</sup> <a name="grpcStatusResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseAction"></a>

```typescript
public readonly grpcStatusResponseAction: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference</a>

---

##### `grpcMatchInput`<sup>Optional</sup> <a name="grpcMatchInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatchInput"></a>

```typescript
public readonly grpcMatchInput: IResolvable | AlbVirtualHostRouteGrpcRouteGrpcMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcMatch">AlbVirtualHostRouteGrpcRouteGrpcMatch</a>[]

---

##### `grpcRouteActionInput`<sup>Optional</sup> <a name="grpcRouteActionInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteActionInput"></a>

```typescript
public readonly grpcRouteActionInput: AlbVirtualHostRouteGrpcRouteGrpcRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcRouteAction">AlbVirtualHostRouteGrpcRouteGrpcRouteAction</a>

---

##### `grpcStatusResponseActionInput`<sup>Optional</sup> <a name="grpcStatusResponseActionInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseActionInput"></a>

```typescript
public readonly grpcStatusResponseActionInput: AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">AlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteGrpcRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a>

---


### AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference <a name="AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resetBody">resetBody</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resetStatus">resetStatus</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBody` <a name="resetBody" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resetBody"></a>

```typescript
public resetBody(): void
```

##### `resetStatus` <a name="resetStatus" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resetStatus"></a>

```typescript
public resetStatus(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.bodyInput">bodyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.statusInput">statusInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.body">body</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.status">status</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bodyInput`<sup>Optional</sup> <a name="bodyInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.bodyInput"></a>

```typescript
public readonly bodyInput: string;
```

- *Type:* string

---

##### `statusInput`<sup>Optional</sup> <a name="statusInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.statusInput"></a>

```typescript
public readonly statusInput: number;
```

- *Type:* number

---

##### `body`<sup>Required</sup> <a name="body" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.body"></a>

```typescript
public readonly body: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.status"></a>

```typescript
public readonly status: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteHttpRouteDirectResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a>

---


### AlbVirtualHostRouteHttpRouteHttpMatchList <a name="AlbVirtualHostRouteHttpRouteHttpMatchList" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpMatchList } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteHttpMatchList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.get"></a>

```typescript
public get(index: number): AlbVirtualHostRouteHttpRouteHttpMatchOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]

---


### AlbVirtualHostRouteHttpRouteHttpMatchOutputReference <a name="AlbVirtualHostRouteHttpRouteHttpMatchOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpMatchOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteHttpMatchOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.putPath">putPath</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resetHttpMethod">resetHttpMethod</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resetPath">resetPath</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPath` <a name="putPath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.putPath"></a>

```typescript
public putPath(value: AlbVirtualHostRouteHttpRouteHttpMatchPath): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.putPath.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a>

---

##### `resetHttpMethod` <a name="resetHttpMethod" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resetHttpMethod"></a>

```typescript
public resetHttpMethod(): void
```

##### `resetPath` <a name="resetPath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resetPath"></a>

```typescript
public resetPath(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.path">path</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference">AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethodInput">httpMethodInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.pathInput">pathInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethod">httpMethod</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.path"></a>

```typescript
public readonly path: AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference">AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference</a>

---

##### `httpMethodInput`<sup>Optional</sup> <a name="httpMethodInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethodInput"></a>

```typescript
public readonly httpMethodInput: string[];
```

- *Type:* string[]

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: AlbVirtualHostRouteHttpRouteHttpMatchPath;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a>

---

##### `httpMethod`<sup>Required</sup> <a name="httpMethod" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethod"></a>

```typescript
public readonly httpMethod: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>

---


### AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference <a name="AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resetExact">resetExact</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resetPrefix">resetPrefix</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetExact` <a name="resetExact" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resetExact"></a>

```typescript
public resetExact(): void
```

##### `resetPrefix` <a name="resetPrefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resetPrefix"></a>

```typescript
public resetPrefix(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exactInput">exactInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefixInput">prefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exact">exact</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `exactInput`<sup>Optional</sup> <a name="exactInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exactInput"></a>

```typescript
public readonly exactInput: string;
```

- *Type:* string

---

##### `prefixInput`<sup>Optional</sup> <a name="prefixInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* string

---

##### `exact`<sup>Required</sup> <a name="exact" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteHttpRouteHttpMatchPath;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchPath">AlbVirtualHostRouteHttpRouteHttpMatchPath</a>

---


### AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference <a name="AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetAutoHostRewrite">resetAutoHostRewrite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetHostRewrite">resetHostRewrite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetIdleTimeout">resetIdleTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetPrefixRewrite">resetPrefixRewrite</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetTimeout">resetTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetUpgradeTypes">resetUpgradeTypes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAutoHostRewrite` <a name="resetAutoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetAutoHostRewrite"></a>

```typescript
public resetAutoHostRewrite(): void
```

##### `resetHostRewrite` <a name="resetHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetHostRewrite"></a>

```typescript
public resetHostRewrite(): void
```

##### `resetIdleTimeout` <a name="resetIdleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetIdleTimeout"></a>

```typescript
public resetIdleTimeout(): void
```

##### `resetPrefixRewrite` <a name="resetPrefixRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetPrefixRewrite"></a>

```typescript
public resetPrefixRewrite(): void
```

##### `resetTimeout` <a name="resetTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetTimeout"></a>

```typescript
public resetTimeout(): void
```

##### `resetUpgradeTypes` <a name="resetUpgradeTypes" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resetUpgradeTypes"></a>

```typescript
public resetUpgradeTypes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewriteInput">autoHostRewriteInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupIdInput">backendGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewriteInput">hostRewriteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeoutInput">idleTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewriteInput">prefixRewriteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypesInput">upgradeTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewrite">autoHostRewrite</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewrite">prefixRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypes">upgradeTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoHostRewriteInput`<sup>Optional</sup> <a name="autoHostRewriteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewriteInput"></a>

```typescript
public readonly autoHostRewriteInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backendGroupIdInput`<sup>Optional</sup> <a name="backendGroupIdInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupIdInput"></a>

```typescript
public readonly backendGroupIdInput: string;
```

- *Type:* string

---

##### `hostRewriteInput`<sup>Optional</sup> <a name="hostRewriteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewriteInput"></a>

```typescript
public readonly hostRewriteInput: string;
```

- *Type:* string

---

##### `idleTimeoutInput`<sup>Optional</sup> <a name="idleTimeoutInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeoutInput"></a>

```typescript
public readonly idleTimeoutInput: string;
```

- *Type:* string

---

##### `prefixRewriteInput`<sup>Optional</sup> <a name="prefixRewriteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewriteInput"></a>

```typescript
public readonly prefixRewriteInput: string;
```

- *Type:* string

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: string;
```

- *Type:* string

---

##### `upgradeTypesInput`<sup>Optional</sup> <a name="upgradeTypesInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypesInput"></a>

```typescript
public readonly upgradeTypesInput: string[];
```

- *Type:* string[]

---

##### `autoHostRewrite`<sup>Required</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `hostRewrite`<sup>Required</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

---

##### `idleTimeout`<sup>Required</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

---

##### `prefixRewrite`<sup>Required</sup> <a name="prefixRewrite" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewrite"></a>

```typescript
public readonly prefixRewrite: string;
```

- *Type:* string

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `upgradeTypes`<sup>Required</sup> <a name="upgradeTypes" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypes"></a>

```typescript
public readonly upgradeTypes: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteHttpRouteHttpRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a>

---


### AlbVirtualHostRouteHttpRouteOutputReference <a name="AlbVirtualHostRouteHttpRouteOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putDirectResponseAction">putDirectResponseAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpMatch">putHttpMatch</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpRouteAction">putHttpRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putRedirectAction">putRedirectAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetDirectResponseAction">resetDirectResponseAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetHttpMatch">resetHttpMatch</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetHttpRouteAction">resetHttpRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetRedirectAction">resetRedirectAction</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDirectResponseAction` <a name="putDirectResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putDirectResponseAction"></a>

```typescript
public putDirectResponseAction(value: AlbVirtualHostRouteHttpRouteDirectResponseAction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putDirectResponseAction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a>

---

##### `putHttpMatch` <a name="putHttpMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpMatch"></a>

```typescript
public putHttpMatch(value: IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpMatch.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]

---

##### `putHttpRouteAction` <a name="putHttpRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpRouteAction"></a>

```typescript
public putHttpRouteAction(value: AlbVirtualHostRouteHttpRouteHttpRouteAction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putHttpRouteAction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a>

---

##### `putRedirectAction` <a name="putRedirectAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putRedirectAction"></a>

```typescript
public putRedirectAction(value: AlbVirtualHostRouteHttpRouteRedirectAction): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.putRedirectAction.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a>

---

##### `resetDirectResponseAction` <a name="resetDirectResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetDirectResponseAction"></a>

```typescript
public resetDirectResponseAction(): void
```

##### `resetHttpMatch` <a name="resetHttpMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetHttpMatch"></a>

```typescript
public resetHttpMatch(): void
```

##### `resetHttpRouteAction` <a name="resetHttpRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetHttpRouteAction"></a>

```typescript
public resetHttpRouteAction(): void
```

##### `resetRedirectAction` <a name="resetRedirectAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.resetRedirectAction"></a>

```typescript
public resetRedirectAction(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.directResponseAction">directResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference">AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpMatch">httpMatch</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList">AlbVirtualHostRouteHttpRouteHttpMatchList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteAction">httpRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference">AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.redirectAction">redirectAction</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference">AlbVirtualHostRouteHttpRouteRedirectActionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.directResponseActionInput">directResponseActionInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpMatchInput">httpMatchInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteActionInput">httpRouteActionInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.redirectActionInput">redirectActionInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `directResponseAction`<sup>Required</sup> <a name="directResponseAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.directResponseAction"></a>

```typescript
public readonly directResponseAction: AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference">AlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference</a>

---

##### `httpMatch`<sup>Required</sup> <a name="httpMatch" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpMatch"></a>

```typescript
public readonly httpMatch: AlbVirtualHostRouteHttpRouteHttpMatchList;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatchList">AlbVirtualHostRouteHttpRouteHttpMatchList</a>

---

##### `httpRouteAction`<sup>Required</sup> <a name="httpRouteAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteAction"></a>

```typescript
public readonly httpRouteAction: AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference">AlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference</a>

---

##### `redirectAction`<sup>Required</sup> <a name="redirectAction" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.redirectAction"></a>

```typescript
public readonly redirectAction: AlbVirtualHostRouteHttpRouteRedirectActionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference">AlbVirtualHostRouteHttpRouteRedirectActionOutputReference</a>

---

##### `directResponseActionInput`<sup>Optional</sup> <a name="directResponseActionInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.directResponseActionInput"></a>

```typescript
public readonly directResponseActionInput: AlbVirtualHostRouteHttpRouteDirectResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteDirectResponseAction">AlbVirtualHostRouteHttpRouteDirectResponseAction</a>

---

##### `httpMatchInput`<sup>Optional</sup> <a name="httpMatchInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpMatchInput"></a>

```typescript
public readonly httpMatchInput: IResolvable | AlbVirtualHostRouteHttpRouteHttpMatch[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpMatch">AlbVirtualHostRouteHttpRouteHttpMatch</a>[]

---

##### `httpRouteActionInput`<sup>Optional</sup> <a name="httpRouteActionInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteActionInput"></a>

```typescript
public readonly httpRouteActionInput: AlbVirtualHostRouteHttpRouteHttpRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteHttpRouteAction">AlbVirtualHostRouteHttpRouteHttpRouteAction</a>

---

##### `redirectActionInput`<sup>Optional</sup> <a name="redirectActionInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.redirectActionInput"></a>

```typescript
public readonly redirectActionInput: AlbVirtualHostRouteHttpRouteRedirectAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteHttpRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a>

---


### AlbVirtualHostRouteHttpRouteRedirectActionOutputReference <a name="AlbVirtualHostRouteHttpRouteRedirectActionOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteHttpRouteRedirectActionOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteHttpRouteRedirectActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetRemoveQuery">resetRemoveQuery</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplaceHost">resetReplaceHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePath">resetReplacePath</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePort">resetReplacePort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePrefix">resetReplacePrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplaceScheme">resetReplaceScheme</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetResponseCode">resetResponseCode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRemoveQuery` <a name="resetRemoveQuery" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetRemoveQuery"></a>

```typescript
public resetRemoveQuery(): void
```

##### `resetReplaceHost` <a name="resetReplaceHost" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplaceHost"></a>

```typescript
public resetReplaceHost(): void
```

##### `resetReplacePath` <a name="resetReplacePath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePath"></a>

```typescript
public resetReplacePath(): void
```

##### `resetReplacePort` <a name="resetReplacePort" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePort"></a>

```typescript
public resetReplacePort(): void
```

##### `resetReplacePrefix` <a name="resetReplacePrefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplacePrefix"></a>

```typescript
public resetReplacePrefix(): void
```

##### `resetReplaceScheme` <a name="resetReplaceScheme" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetReplaceScheme"></a>

```typescript
public resetReplaceScheme(): void
```

##### `resetResponseCode` <a name="resetResponseCode" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resetResponseCode"></a>

```typescript
public resetResponseCode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQueryInput">removeQueryInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHostInput">replaceHostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePathInput">replacePathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePortInput">replacePortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefixInput">replacePrefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceSchemeInput">replaceSchemeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCodeInput">responseCodeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQuery">removeQuery</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHost">replaceHost</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePath">replacePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePort">replacePort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefix">replacePrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceScheme">replaceScheme</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCode">responseCode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `removeQueryInput`<sup>Optional</sup> <a name="removeQueryInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQueryInput"></a>

```typescript
public readonly removeQueryInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replaceHostInput`<sup>Optional</sup> <a name="replaceHostInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHostInput"></a>

```typescript
public readonly replaceHostInput: string;
```

- *Type:* string

---

##### `replacePathInput`<sup>Optional</sup> <a name="replacePathInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePathInput"></a>

```typescript
public readonly replacePathInput: string;
```

- *Type:* string

---

##### `replacePortInput`<sup>Optional</sup> <a name="replacePortInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePortInput"></a>

```typescript
public readonly replacePortInput: number;
```

- *Type:* number

---

##### `replacePrefixInput`<sup>Optional</sup> <a name="replacePrefixInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefixInput"></a>

```typescript
public readonly replacePrefixInput: string;
```

- *Type:* string

---

##### `replaceSchemeInput`<sup>Optional</sup> <a name="replaceSchemeInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceSchemeInput"></a>

```typescript
public readonly replaceSchemeInput: string;
```

- *Type:* string

---

##### `responseCodeInput`<sup>Optional</sup> <a name="responseCodeInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCodeInput"></a>

```typescript
public readonly responseCodeInput: string;
```

- *Type:* string

---

##### `removeQuery`<sup>Required</sup> <a name="removeQuery" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQuery"></a>

```typescript
public readonly removeQuery: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `replaceHost`<sup>Required</sup> <a name="replaceHost" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHost"></a>

```typescript
public readonly replaceHost: string;
```

- *Type:* string

---

##### `replacePath`<sup>Required</sup> <a name="replacePath" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePath"></a>

```typescript
public readonly replacePath: string;
```

- *Type:* string

---

##### `replacePort`<sup>Required</sup> <a name="replacePort" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePort"></a>

```typescript
public readonly replacePort: number;
```

- *Type:* number

---

##### `replacePrefix`<sup>Required</sup> <a name="replacePrefix" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefix"></a>

```typescript
public readonly replacePrefix: string;
```

- *Type:* string

---

##### `replaceScheme`<sup>Required</sup> <a name="replaceScheme" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceScheme"></a>

```typescript
public readonly replaceScheme: string;
```

- *Type:* string

---

##### `responseCode`<sup>Required</sup> <a name="responseCode" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCode"></a>

```typescript
public readonly responseCode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: AlbVirtualHostRouteHttpRouteRedirectAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteRedirectAction">AlbVirtualHostRouteHttpRouteRedirectAction</a>

---


### AlbVirtualHostRouteList <a name="AlbVirtualHostRouteList" id="@cdktf/provider-yandex.AlbVirtualHostRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer"></a>

```typescript
import { AlbVirtualHostRouteList } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.get"></a>

```typescript
public get(index: number): AlbVirtualHostRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>[]

---


### AlbVirtualHostRouteOutputReference <a name="AlbVirtualHostRouteOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostRouteOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putGrpcRoute">putGrpcRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putHttpRoute">putHttpRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetGrpcRoute">resetGrpcRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetHttpRoute">resetHttpRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetName">resetName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcRoute` <a name="putGrpcRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putGrpcRoute"></a>

```typescript
public putGrpcRoute(value: AlbVirtualHostRouteGrpcRoute): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putGrpcRoute.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a>

---

##### `putHttpRoute` <a name="putHttpRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putHttpRoute"></a>

```typescript
public putHttpRoute(value: AlbVirtualHostRouteHttpRoute): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.putHttpRoute.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a>

---

##### `resetGrpcRoute` <a name="resetGrpcRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetGrpcRoute"></a>

```typescript
public resetGrpcRoute(): void
```

##### `resetHttpRoute` <a name="resetHttpRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetHttpRoute"></a>

```typescript
public resetHttpRoute(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.resetName"></a>

```typescript
public resetName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.grpcRoute">grpcRoute</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference">AlbVirtualHostRouteGrpcRouteOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.httpRoute">httpRoute</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference">AlbVirtualHostRouteHttpRouteOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.grpcRouteInput">grpcRouteInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.httpRouteInput">httpRouteInput</a></code> | <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcRoute`<sup>Required</sup> <a name="grpcRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.grpcRoute"></a>

```typescript
public readonly grpcRoute: AlbVirtualHostRouteGrpcRouteOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRouteOutputReference">AlbVirtualHostRouteGrpcRouteOutputReference</a>

---

##### `httpRoute`<sup>Required</sup> <a name="httpRoute" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.httpRoute"></a>

```typescript
public readonly httpRoute: AlbVirtualHostRouteHttpRouteOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRouteOutputReference">AlbVirtualHostRouteHttpRouteOutputReference</a>

---

##### `grpcRouteInput`<sup>Optional</sup> <a name="grpcRouteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.grpcRouteInput"></a>

```typescript
public readonly grpcRouteInput: AlbVirtualHostRouteGrpcRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteGrpcRoute">AlbVirtualHostRouteGrpcRoute</a>

---

##### `httpRouteInput`<sup>Optional</sup> <a name="httpRouteInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.httpRouteInput"></a>

```typescript
public readonly httpRouteInput: AlbVirtualHostRouteHttpRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.AlbVirtualHostRouteHttpRoute">AlbVirtualHostRouteHttpRoute</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostRoute;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostRoute">AlbVirtualHostRoute</a>

---


### AlbVirtualHostTimeoutsOutputReference <a name="AlbVirtualHostTimeoutsOutputReference" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.Initializer"></a>

```typescript
import { AlbVirtualHostTimeoutsOutputReference } from '@cdktf/provider-yandex'

new AlbVirtualHostTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.AlbVirtualHostTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | AlbVirtualHostTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.AlbVirtualHostTimeouts">AlbVirtualHostTimeouts</a>

---


### ApiGatewayTimeoutsOutputReference <a name="ApiGatewayTimeoutsOutputReference" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.Initializer"></a>

```typescript
import { ApiGatewayTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ApiGatewayTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ApiGatewayTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ApiGatewayTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ApiGatewayTimeouts">ApiGatewayTimeouts</a>

---


### CdnOriginGroupOriginList <a name="CdnOriginGroupOriginList" id="@cdktf/provider-yandex.CdnOriginGroupOriginList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer"></a>

```typescript
import { CdnOriginGroupOriginList } from '@cdktf/provider-yandex'

new CdnOriginGroupOriginList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.get"></a>

```typescript
public get(index: number): CdnOriginGroupOriginOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnOriginGroupOriginList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CdnOriginGroupOrigin[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>[]

---


### CdnOriginGroupOriginOutputReference <a name="CdnOriginGroupOriginOutputReference" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer"></a>

```typescript
import { CdnOriginGroupOriginOutputReference } from '@cdktf/provider-yandex'

new CdnOriginGroupOriginOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resetBackup">resetBackup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBackup` <a name="resetBackup" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resetBackup"></a>

```typescript
public resetBackup(): void
```

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.originGroupId">originGroupId</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.backupInput">backupInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.sourceInput">sourceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.backup">backup</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.source">source</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `originGroupId`<sup>Required</sup> <a name="originGroupId" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

---

##### `backupInput`<sup>Optional</sup> <a name="backupInput" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.backupInput"></a>

```typescript
public readonly backupInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sourceInput`<sup>Optional</sup> <a name="sourceInput" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.sourceInput"></a>

```typescript
public readonly sourceInput: string;
```

- *Type:* string

---

##### `backup`<sup>Required</sup> <a name="backup" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.backup"></a>

```typescript
public readonly backup: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `source`<sup>Required</sup> <a name="source" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnOriginGroupOriginOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CdnOriginGroupOrigin;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupOrigin">CdnOriginGroupOrigin</a>

---


### CdnOriginGroupTimeoutsOutputReference <a name="CdnOriginGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { CdnOriginGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new CdnOriginGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnOriginGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CdnOriginGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnOriginGroupTimeouts">CdnOriginGroupTimeouts</a>

---


### CdnResourceOptionsOutputReference <a name="CdnResourceOptionsOutputReference" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.Initializer"></a>

```typescript
import { CdnResourceOptionsOutputReference } from '@cdktf/provider-yandex'

new CdnResourceOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetAllowedHttpMethods">resetAllowedHttpMethods</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetBrowserCacheSettings">resetBrowserCacheSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCacheHttpHeaders">resetCacheHttpHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCors">resetCors</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCustomHostHeader">resetCustomHostHeader</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCustomServerName">resetCustomServerName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetDisableCache">resetDisableCache</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetDisableProxyForceRanges">resetDisableProxyForceRanges</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetEdgeCacheSettings">resetEdgeCacheSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetFetchedCompressed">resetFetchedCompressed</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetForwardHostHeader">resetForwardHostHeader</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetGzipOn">resetGzipOn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetIgnoreCookie">resetIgnoreCookie</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetIgnoreQueryParams">resetIgnoreQueryParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetProxyCacheMethodsSet">resetProxyCacheMethodsSet</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetQueryParamsBlacklist">resetQueryParamsBlacklist</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetQueryParamsWhitelist">resetQueryParamsWhitelist</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetRedirectHttpsToHttp">resetRedirectHttpsToHttp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetRedirectHttpToHttps">resetRedirectHttpToHttps</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetSlice">resetSlice</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetStaticRequestHeaders">resetStaticRequestHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetStaticResponseHeaders">resetStaticResponseHeaders</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAllowedHttpMethods` <a name="resetAllowedHttpMethods" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetAllowedHttpMethods"></a>

```typescript
public resetAllowedHttpMethods(): void
```

##### `resetBrowserCacheSettings` <a name="resetBrowserCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetBrowserCacheSettings"></a>

```typescript
public resetBrowserCacheSettings(): void
```

##### `resetCacheHttpHeaders` <a name="resetCacheHttpHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCacheHttpHeaders"></a>

```typescript
public resetCacheHttpHeaders(): void
```

##### `resetCors` <a name="resetCors" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCors"></a>

```typescript
public resetCors(): void
```

##### `resetCustomHostHeader` <a name="resetCustomHostHeader" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCustomHostHeader"></a>

```typescript
public resetCustomHostHeader(): void
```

##### `resetCustomServerName` <a name="resetCustomServerName" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetCustomServerName"></a>

```typescript
public resetCustomServerName(): void
```

##### `resetDisableCache` <a name="resetDisableCache" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetDisableCache"></a>

```typescript
public resetDisableCache(): void
```

##### `resetDisableProxyForceRanges` <a name="resetDisableProxyForceRanges" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetDisableProxyForceRanges"></a>

```typescript
public resetDisableProxyForceRanges(): void
```

##### `resetEdgeCacheSettings` <a name="resetEdgeCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetEdgeCacheSettings"></a>

```typescript
public resetEdgeCacheSettings(): void
```

##### `resetFetchedCompressed` <a name="resetFetchedCompressed" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetFetchedCompressed"></a>

```typescript
public resetFetchedCompressed(): void
```

##### `resetForwardHostHeader` <a name="resetForwardHostHeader" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetForwardHostHeader"></a>

```typescript
public resetForwardHostHeader(): void
```

##### `resetGzipOn` <a name="resetGzipOn" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetGzipOn"></a>

```typescript
public resetGzipOn(): void
```

##### `resetIgnoreCookie` <a name="resetIgnoreCookie" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetIgnoreCookie"></a>

```typescript
public resetIgnoreCookie(): void
```

##### `resetIgnoreQueryParams` <a name="resetIgnoreQueryParams" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetIgnoreQueryParams"></a>

```typescript
public resetIgnoreQueryParams(): void
```

##### `resetProxyCacheMethodsSet` <a name="resetProxyCacheMethodsSet" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetProxyCacheMethodsSet"></a>

```typescript
public resetProxyCacheMethodsSet(): void
```

##### `resetQueryParamsBlacklist` <a name="resetQueryParamsBlacklist" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetQueryParamsBlacklist"></a>

```typescript
public resetQueryParamsBlacklist(): void
```

##### `resetQueryParamsWhitelist` <a name="resetQueryParamsWhitelist" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetQueryParamsWhitelist"></a>

```typescript
public resetQueryParamsWhitelist(): void
```

##### `resetRedirectHttpsToHttp` <a name="resetRedirectHttpsToHttp" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetRedirectHttpsToHttp"></a>

```typescript
public resetRedirectHttpsToHttp(): void
```

##### `resetRedirectHttpToHttps` <a name="resetRedirectHttpToHttps" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetRedirectHttpToHttps"></a>

```typescript
public resetRedirectHttpToHttps(): void
```

##### `resetSlice` <a name="resetSlice" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetSlice"></a>

```typescript
public resetSlice(): void
```

##### `resetStaticRequestHeaders` <a name="resetStaticRequestHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetStaticRequestHeaders"></a>

```typescript
public resetStaticRequestHeaders(): void
```

##### `resetStaticResponseHeaders` <a name="resetStaticResponseHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.resetStaticResponseHeaders"></a>

```typescript
public resetStaticResponseHeaders(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.allowedHttpMethodsInput">allowedHttpMethodsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.browserCacheSettingsInput">browserCacheSettingsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cacheHttpHeadersInput">cacheHttpHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.corsInput">corsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customHostHeaderInput">customHostHeaderInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customServerNameInput">customServerNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableCacheInput">disableCacheInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableProxyForceRangesInput">disableProxyForceRangesInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.edgeCacheSettingsInput">edgeCacheSettingsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fetchedCompressedInput">fetchedCompressedInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.forwardHostHeaderInput">forwardHostHeaderInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.gzipOnInput">gzipOnInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreCookieInput">ignoreCookieInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreQueryParamsInput">ignoreQueryParamsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.proxyCacheMethodsSetInput">proxyCacheMethodsSetInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsBlacklistInput">queryParamsBlacklistInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsWhitelistInput">queryParamsWhitelistInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpsToHttpInput">redirectHttpsToHttpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpToHttpsInput">redirectHttpToHttpsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.sliceInput">sliceInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticRequestHeadersInput">staticRequestHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticResponseHeadersInput">staticResponseHeadersInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.allowedHttpMethods">allowedHttpMethods</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.browserCacheSettings">browserCacheSettings</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cacheHttpHeaders">cacheHttpHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cors">cors</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customHostHeader">customHostHeader</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customServerName">customServerName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableCache">disableCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableProxyForceRanges">disableProxyForceRanges</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.edgeCacheSettings">edgeCacheSettings</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fetchedCompressed">fetchedCompressed</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.forwardHostHeader">forwardHostHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.gzipOn">gzipOn</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreCookie">ignoreCookie</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreQueryParams">ignoreQueryParams</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.proxyCacheMethodsSet">proxyCacheMethodsSet</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsBlacklist">queryParamsBlacklist</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsWhitelist">queryParamsWhitelist</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpsToHttp">redirectHttpsToHttp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpToHttps">redirectHttpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.slice">slice</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticRequestHeaders">staticRequestHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticResponseHeaders">staticResponseHeaders</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowedHttpMethodsInput`<sup>Optional</sup> <a name="allowedHttpMethodsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.allowedHttpMethodsInput"></a>

```typescript
public readonly allowedHttpMethodsInput: string[];
```

- *Type:* string[]

---

##### `browserCacheSettingsInput`<sup>Optional</sup> <a name="browserCacheSettingsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.browserCacheSettingsInput"></a>

```typescript
public readonly browserCacheSettingsInput: number;
```

- *Type:* number

---

##### `cacheHttpHeadersInput`<sup>Optional</sup> <a name="cacheHttpHeadersInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cacheHttpHeadersInput"></a>

```typescript
public readonly cacheHttpHeadersInput: string[];
```

- *Type:* string[]

---

##### `corsInput`<sup>Optional</sup> <a name="corsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.corsInput"></a>

```typescript
public readonly corsInput: string[];
```

- *Type:* string[]

---

##### `customHostHeaderInput`<sup>Optional</sup> <a name="customHostHeaderInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customHostHeaderInput"></a>

```typescript
public readonly customHostHeaderInput: string;
```

- *Type:* string

---

##### `customServerNameInput`<sup>Optional</sup> <a name="customServerNameInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customServerNameInput"></a>

```typescript
public readonly customServerNameInput: string;
```

- *Type:* string

---

##### `disableCacheInput`<sup>Optional</sup> <a name="disableCacheInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableCacheInput"></a>

```typescript
public readonly disableCacheInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `disableProxyForceRangesInput`<sup>Optional</sup> <a name="disableProxyForceRangesInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableProxyForceRangesInput"></a>

```typescript
public readonly disableProxyForceRangesInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `edgeCacheSettingsInput`<sup>Optional</sup> <a name="edgeCacheSettingsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.edgeCacheSettingsInput"></a>

```typescript
public readonly edgeCacheSettingsInput: number;
```

- *Type:* number

---

##### `fetchedCompressedInput`<sup>Optional</sup> <a name="fetchedCompressedInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fetchedCompressedInput"></a>

```typescript
public readonly fetchedCompressedInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forwardHostHeaderInput`<sup>Optional</sup> <a name="forwardHostHeaderInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.forwardHostHeaderInput"></a>

```typescript
public readonly forwardHostHeaderInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gzipOnInput`<sup>Optional</sup> <a name="gzipOnInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.gzipOnInput"></a>

```typescript
public readonly gzipOnInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreCookieInput`<sup>Optional</sup> <a name="ignoreCookieInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreCookieInput"></a>

```typescript
public readonly ignoreCookieInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreQueryParamsInput`<sup>Optional</sup> <a name="ignoreQueryParamsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreQueryParamsInput"></a>

```typescript
public readonly ignoreQueryParamsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `proxyCacheMethodsSetInput`<sup>Optional</sup> <a name="proxyCacheMethodsSetInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.proxyCacheMethodsSetInput"></a>

```typescript
public readonly proxyCacheMethodsSetInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryParamsBlacklistInput`<sup>Optional</sup> <a name="queryParamsBlacklistInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsBlacklistInput"></a>

```typescript
public readonly queryParamsBlacklistInput: string[];
```

- *Type:* string[]

---

##### `queryParamsWhitelistInput`<sup>Optional</sup> <a name="queryParamsWhitelistInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsWhitelistInput"></a>

```typescript
public readonly queryParamsWhitelistInput: string[];
```

- *Type:* string[]

---

##### `redirectHttpsToHttpInput`<sup>Optional</sup> <a name="redirectHttpsToHttpInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpsToHttpInput"></a>

```typescript
public readonly redirectHttpsToHttpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `redirectHttpToHttpsInput`<sup>Optional</sup> <a name="redirectHttpToHttpsInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpToHttpsInput"></a>

```typescript
public readonly redirectHttpToHttpsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sliceInput`<sup>Optional</sup> <a name="sliceInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.sliceInput"></a>

```typescript
public readonly sliceInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `staticRequestHeadersInput`<sup>Optional</sup> <a name="staticRequestHeadersInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticRequestHeadersInput"></a>

```typescript
public readonly staticRequestHeadersInput: string[];
```

- *Type:* string[]

---

##### `staticResponseHeadersInput`<sup>Optional</sup> <a name="staticResponseHeadersInput" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticResponseHeadersInput"></a>

```typescript
public readonly staticResponseHeadersInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `allowedHttpMethods`<sup>Required</sup> <a name="allowedHttpMethods" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.allowedHttpMethods"></a>

```typescript
public readonly allowedHttpMethods: string[];
```

- *Type:* string[]

---

##### `browserCacheSettings`<sup>Required</sup> <a name="browserCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.browserCacheSettings"></a>

```typescript
public readonly browserCacheSettings: number;
```

- *Type:* number

---

##### `cacheHttpHeaders`<sup>Required</sup> <a name="cacheHttpHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cacheHttpHeaders"></a>

```typescript
public readonly cacheHttpHeaders: string[];
```

- *Type:* string[]

---

##### `cors`<sup>Required</sup> <a name="cors" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.cors"></a>

```typescript
public readonly cors: string[];
```

- *Type:* string[]

---

##### `customHostHeader`<sup>Required</sup> <a name="customHostHeader" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customHostHeader"></a>

```typescript
public readonly customHostHeader: string;
```

- *Type:* string

---

##### `customServerName`<sup>Required</sup> <a name="customServerName" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.customServerName"></a>

```typescript
public readonly customServerName: string;
```

- *Type:* string

---

##### `disableCache`<sup>Required</sup> <a name="disableCache" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableCache"></a>

```typescript
public readonly disableCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `disableProxyForceRanges`<sup>Required</sup> <a name="disableProxyForceRanges" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.disableProxyForceRanges"></a>

```typescript
public readonly disableProxyForceRanges: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `edgeCacheSettings`<sup>Required</sup> <a name="edgeCacheSettings" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.edgeCacheSettings"></a>

```typescript
public readonly edgeCacheSettings: number;
```

- *Type:* number

---

##### `fetchedCompressed`<sup>Required</sup> <a name="fetchedCompressed" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.fetchedCompressed"></a>

```typescript
public readonly fetchedCompressed: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forwardHostHeader`<sup>Required</sup> <a name="forwardHostHeader" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.forwardHostHeader"></a>

```typescript
public readonly forwardHostHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gzipOn`<sup>Required</sup> <a name="gzipOn" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.gzipOn"></a>

```typescript
public readonly gzipOn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreCookie`<sup>Required</sup> <a name="ignoreCookie" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreCookie"></a>

```typescript
public readonly ignoreCookie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreQueryParams`<sup>Required</sup> <a name="ignoreQueryParams" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.ignoreQueryParams"></a>

```typescript
public readonly ignoreQueryParams: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `proxyCacheMethodsSet`<sup>Required</sup> <a name="proxyCacheMethodsSet" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.proxyCacheMethodsSet"></a>

```typescript
public readonly proxyCacheMethodsSet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryParamsBlacklist`<sup>Required</sup> <a name="queryParamsBlacklist" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsBlacklist"></a>

```typescript
public readonly queryParamsBlacklist: string[];
```

- *Type:* string[]

---

##### `queryParamsWhitelist`<sup>Required</sup> <a name="queryParamsWhitelist" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.queryParamsWhitelist"></a>

```typescript
public readonly queryParamsWhitelist: string[];
```

- *Type:* string[]

---

##### `redirectHttpsToHttp`<sup>Required</sup> <a name="redirectHttpsToHttp" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpsToHttp"></a>

```typescript
public readonly redirectHttpsToHttp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `redirectHttpToHttps`<sup>Required</sup> <a name="redirectHttpToHttps" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.redirectHttpToHttps"></a>

```typescript
public readonly redirectHttpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `slice`<sup>Required</sup> <a name="slice" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.slice"></a>

```typescript
public readonly slice: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `staticRequestHeaders`<sup>Required</sup> <a name="staticRequestHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticRequestHeaders"></a>

```typescript
public readonly staticRequestHeaders: string[];
```

- *Type:* string[]

---

##### `staticResponseHeaders`<sup>Required</sup> <a name="staticResponseHeaders" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.staticResponseHeaders"></a>

```typescript
public readonly staticResponseHeaders: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnResourceOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceOptions">CdnResourceOptions</a>

---


### CdnResourceSslCertificateOutputReference <a name="CdnResourceSslCertificateOutputReference" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.Initializer"></a>

```typescript
import { CdnResourceSslCertificateOutputReference } from '@cdktf/provider-yandex'

new CdnResourceSslCertificateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.resetCertificateManagerId">resetCertificateManagerId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCertificateManagerId` <a name="resetCertificateManagerId" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.resetCertificateManagerId"></a>

```typescript
public resetCertificateManagerId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.certificateManagerIdInput">certificateManagerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.certificateManagerId">certificateManagerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `certificateManagerIdInput`<sup>Optional</sup> <a name="certificateManagerIdInput" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.certificateManagerIdInput"></a>

```typescript
public readonly certificateManagerIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `certificateManagerId`<sup>Required</sup> <a name="certificateManagerId" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.certificateManagerId"></a>

```typescript
public readonly certificateManagerId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnResourceSslCertificateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: CdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.CdnResourceSslCertificate">CdnResourceSslCertificate</a>

---


### CdnResourceTimeoutsOutputReference <a name="CdnResourceTimeoutsOutputReference" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.Initializer"></a>

```typescript
import { CdnResourceTimeoutsOutputReference } from '@cdktf/provider-yandex'

new CdnResourceTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.CdnResourceTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | CdnResourceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.CdnResourceTimeouts">CdnResourceTimeouts</a>

---


### ComputeDiskDiskPlacementPolicyOutputReference <a name="ComputeDiskDiskPlacementPolicyOutputReference" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeDiskDiskPlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeDiskDiskPlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupIdInput">diskPlacementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupId">diskPlacementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskPlacementGroupIdInput`<sup>Optional</sup> <a name="diskPlacementGroupIdInput" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupIdInput"></a>

```typescript
public readonly diskPlacementGroupIdInput: string;
```

- *Type:* string

---

##### `diskPlacementGroupId`<sup>Required</sup> <a name="diskPlacementGroupId" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupId"></a>

```typescript
public readonly diskPlacementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeDiskDiskPlacementPolicy">ComputeDiskDiskPlacementPolicy</a>

---


### ComputeDiskPlacementGroupTimeoutsOutputReference <a name="ComputeDiskPlacementGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeDiskPlacementGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeDiskPlacementGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeDiskPlacementGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeDiskPlacementGroupTimeouts">ComputeDiskPlacementGroupTimeouts</a>

---


### ComputeDiskTimeoutsOutputReference <a name="ComputeDiskTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeDiskTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeDiskTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeDiskTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeDiskTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeDiskTimeouts">ComputeDiskTimeouts</a>

---


### ComputeImageTimeoutsOutputReference <a name="ComputeImageTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeImageTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeImageTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeImageTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeImageTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeImageTimeouts">ComputeImageTimeouts</a>

---


### ComputeInstanceBootDiskInitializeParamsOutputReference <a name="ComputeInstanceBootDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceBootDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceBootDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetBlockSize">resetBlockSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetImageId">resetImageId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetSize">resetSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetSnapshotId">resetSnapshotId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBlockSize` <a name="resetBlockSize" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetBlockSize"></a>

```typescript
public resetBlockSize(): void
```

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetImageId` <a name="resetImageId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetImageId"></a>

```typescript
public resetImageId(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetName"></a>

```typescript
public resetName(): void
```

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetSize"></a>

```typescript
public resetSize(): void
```

##### `resetSnapshotId` <a name="resetSnapshotId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetSnapshotId"></a>

```typescript
public resetSnapshotId(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSizeInput">blockSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.imageIdInput">imageIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotIdInput">snapshotIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSize">blockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `blockSizeInput`<sup>Optional</sup> <a name="blockSizeInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSizeInput"></a>

```typescript
public readonly blockSizeInput: number;
```

- *Type:* number

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `imageIdInput`<sup>Optional</sup> <a name="imageIdInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="snapshotIdInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `blockSize`<sup>Required</sup> <a name="blockSize" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a>

---


### ComputeInstanceBootDiskOutputReference <a name="ComputeInstanceBootDiskOutputReference" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceBootDiskOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.putInitializeParams">putInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetAutoDelete">resetAutoDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetDeviceName">resetDeviceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetDiskId">resetDiskId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetInitializeParams">resetInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetMode">resetMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putInitializeParams` <a name="putInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.putInitializeParams"></a>

```typescript
public putInitializeParams(value: ComputeInstanceBootDiskInitializeParams): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.putInitializeParams.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a>

---

##### `resetAutoDelete` <a name="resetAutoDelete" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetAutoDelete"></a>

```typescript
public resetAutoDelete(): void
```

##### `resetDeviceName` <a name="resetDeviceName" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName(): void
```

##### `resetDiskId` <a name="resetDiskId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetDiskId"></a>

```typescript
public resetDiskId(): void
```

##### `resetInitializeParams` <a name="resetInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetInitializeParams"></a>

```typescript
public resetInitializeParams(): void
```

##### `resetMode` <a name="resetMode" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.resetMode"></a>

```typescript
public resetMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference">ComputeInstanceBootDiskInitializeParamsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.autoDeleteInput">autoDeleteInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.deviceNameInput">deviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.diskIdInput">diskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.initializeParamsInput">initializeParamsInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.modeInput">modeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.autoDelete">autoDelete</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceBootDiskInitializeParamsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParamsOutputReference">ComputeInstanceBootDiskInitializeParamsOutputReference</a>

---

##### `autoDeleteInput`<sup>Optional</sup> <a name="autoDeleteInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.autoDeleteInput"></a>

```typescript
public readonly autoDeleteInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deviceNameInput`<sup>Optional</sup> <a name="deviceNameInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* string

---

##### `diskIdInput`<sup>Optional</sup> <a name="diskIdInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.diskIdInput"></a>

```typescript
public readonly diskIdInput: string;
```

- *Type:* string

---

##### `initializeParamsInput`<sup>Optional</sup> <a name="initializeParamsInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.initializeParamsInput"></a>

```typescript
public readonly initializeParamsInput: ComputeInstanceBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDiskInitializeParams">ComputeInstanceBootDiskInitializeParams</a>

---

##### `modeInput`<sup>Optional</sup> <a name="modeInput" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* string

---

##### `autoDelete`<sup>Required</sup> <a name="autoDelete" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.autoDelete"></a>

```typescript
public readonly autoDelete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceBootDisk">ComputeInstanceBootDisk</a>

---


### ComputeInstanceGroupAllocationPolicyOutputReference <a name="ComputeInstanceGroupAllocationPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.zonesInput">zonesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.zones">zones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `zonesInput`<sup>Optional</sup> <a name="zonesInput" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.zonesInput"></a>

```typescript
public readonly zonesInput: string[];
```

- *Type:* string[]

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupAllocationPolicy">ComputeInstanceGroupAllocationPolicy</a>

---


### ComputeInstanceGroupApplicationLoadBalancerOutputReference <a name="ComputeInstanceGroupApplicationLoadBalancerOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupApplicationLoadBalancerOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupApplicationLoadBalancerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetMaxOpeningTrafficDuration">resetMaxOpeningTrafficDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupDescription">resetTargetGroupDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupLabels">resetTargetGroupLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupName">resetTargetGroupName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxOpeningTrafficDuration` <a name="resetMaxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetMaxOpeningTrafficDuration"></a>

```typescript
public resetMaxOpeningTrafficDuration(): void
```

##### `resetTargetGroupDescription` <a name="resetTargetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupDescription"></a>

```typescript
public resetTargetGroupDescription(): void
```

##### `resetTargetGroupLabels` <a name="resetTargetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupLabels"></a>

```typescript
public resetTargetGroupLabels(): void
```

##### `resetTargetGroupName` <a name="resetTargetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.resetTargetGroupName"></a>

```typescript
public resetTargetGroupName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDurationInput">maxOpeningTrafficDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescriptionInput">targetGroupDescriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabelsInput">targetGroupLabelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupNameInput">targetGroupNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabels">targetGroupLabels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDurationInput`<sup>Optional</sup> <a name="maxOpeningTrafficDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDurationInput"></a>

```typescript
public readonly maxOpeningTrafficDurationInput: number;
```

- *Type:* number

---

##### `targetGroupDescriptionInput`<sup>Optional</sup> <a name="targetGroupDescriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescriptionInput"></a>

```typescript
public readonly targetGroupDescriptionInput: string;
```

- *Type:* string

---

##### `targetGroupLabelsInput`<sup>Optional</sup> <a name="targetGroupLabelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabelsInput"></a>

```typescript
public readonly targetGroupLabelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `targetGroupNameInput`<sup>Optional</sup> <a name="targetGroupNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupNameInput"></a>

```typescript
public readonly targetGroupNameInput: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDuration`<sup>Required</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

---

##### `targetGroupDescription`<sup>Required</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

---

##### `targetGroupLabels`<sup>Required</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `targetGroupName`<sup>Required</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupApplicationLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupApplicationLoadBalancer">ComputeInstanceGroupApplicationLoadBalancer</a>

---


### ComputeInstanceGroupDeployPolicyOutputReference <a name="ComputeInstanceGroupDeployPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupDeployPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupDeployPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetMaxCreating">resetMaxCreating</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetMaxDeleting">resetMaxDeleting</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetStartupDuration">resetStartupDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetStrategy">resetStrategy</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxCreating` <a name="resetMaxCreating" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetMaxCreating"></a>

```typescript
public resetMaxCreating(): void
```

##### `resetMaxDeleting` <a name="resetMaxDeleting" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetMaxDeleting"></a>

```typescript
public resetMaxDeleting(): void
```

##### `resetStartupDuration` <a name="resetStartupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetStartupDuration"></a>

```typescript
public resetStartupDuration(): void
```

##### `resetStrategy` <a name="resetStrategy" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.resetStrategy"></a>

```typescript
public resetStrategy(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxCreatingInput">maxCreatingInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxDeletingInput">maxDeletingInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansionInput">maxExpansionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailableInput">maxUnavailableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.startupDurationInput">startupDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.strategyInput">strategyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxCreating">maxCreating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxDeleting">maxDeleting</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.startupDuration">startupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.strategy">strategy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxCreatingInput`<sup>Optional</sup> <a name="maxCreatingInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxCreatingInput"></a>

```typescript
public readonly maxCreatingInput: number;
```

- *Type:* number

---

##### `maxDeletingInput`<sup>Optional</sup> <a name="maxDeletingInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxDeletingInput"></a>

```typescript
public readonly maxDeletingInput: number;
```

- *Type:* number

---

##### `maxExpansionInput`<sup>Optional</sup> <a name="maxExpansionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansionInput"></a>

```typescript
public readonly maxExpansionInput: number;
```

- *Type:* number

---

##### `maxUnavailableInput`<sup>Optional</sup> <a name="maxUnavailableInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailableInput"></a>

```typescript
public readonly maxUnavailableInput: number;
```

- *Type:* number

---

##### `startupDurationInput`<sup>Optional</sup> <a name="startupDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.startupDurationInput"></a>

```typescript
public readonly startupDurationInput: number;
```

- *Type:* number

---

##### `strategyInput`<sup>Optional</sup> <a name="strategyInput" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.strategyInput"></a>

```typescript
public readonly strategyInput: string;
```

- *Type:* string

---

##### `maxCreating`<sup>Required</sup> <a name="maxCreating" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxCreating"></a>

```typescript
public readonly maxCreating: number;
```

- *Type:* number

---

##### `maxDeleting`<sup>Required</sup> <a name="maxDeleting" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxDeleting"></a>

```typescript
public readonly maxDeleting: number;
```

- *Type:* number

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

---

##### `startupDuration`<sup>Required</sup> <a name="startupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.startupDuration"></a>

```typescript
public readonly startupDuration: number;
```

- *Type:* number

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.strategy"></a>

```typescript
public readonly strategy: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupDeployPolicy">ComputeInstanceGroupDeployPolicy</a>

---


### ComputeInstanceGroupHealthCheckHttpOptionsList <a name="ComputeInstanceGroupHealthCheckHttpOptionsList" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckHttpOptionsList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupHealthCheckHttpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupHealthCheckHttpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupHealthCheckHttpOptions[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]

---


### ComputeInstanceGroupHealthCheckHttpOptionsOutputReference <a name="ComputeInstanceGroupHealthCheckHttpOptionsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckHttpOptionsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupHealthCheckHttpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.pathInput">pathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupHealthCheckHttpOptions;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>

---


### ComputeInstanceGroupHealthCheckList <a name="ComputeInstanceGroupHealthCheckList" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupHealthCheckList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupHealthCheckOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupHealthCheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>[]

---


### ComputeInstanceGroupHealthCheckOutputReference <a name="ComputeInstanceGroupHealthCheckOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupHealthCheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putHttpOptions">putHttpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putTcpOptions">putTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetHttpOptions">resetHttpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetInterval">resetInterval</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetTcpOptions">resetTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetTimeout">resetTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttpOptions` <a name="putHttpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putHttpOptions"></a>

```typescript
public putHttpOptions(value: IResolvable | ComputeInstanceGroupHealthCheckHttpOptions[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putHttpOptions.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]

---

##### `putTcpOptions` <a name="putTcpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putTcpOptions"></a>

```typescript
public putTcpOptions(value: ComputeInstanceGroupHealthCheckTcpOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.putTcpOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a>

---

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpOptions` <a name="resetHttpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetHttpOptions"></a>

```typescript
public resetHttpOptions(): void
```

##### `resetInterval` <a name="resetInterval" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetInterval"></a>

```typescript
public resetInterval(): void
```

##### `resetTcpOptions` <a name="resetTcpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetTcpOptions"></a>

```typescript
public resetTcpOptions(): void
```

##### `resetTimeout` <a name="resetTimeout" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetTimeout"></a>

```typescript
public resetTimeout(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.httpOptions">httpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList">ComputeInstanceGroupHealthCheckHttpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference">ComputeInstanceGroupHealthCheckTcpOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.httpOptionsInput">httpOptionsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.intervalInput">intervalInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.tcpOptionsInput">tcpOptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.interval">interval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpOptions`<sup>Required</sup> <a name="httpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.httpOptions"></a>

```typescript
public readonly httpOptions: ComputeInstanceGroupHealthCheckHttpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptionsList">ComputeInstanceGroupHealthCheckHttpOptionsList</a>

---

##### `tcpOptions`<sup>Required</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: ComputeInstanceGroupHealthCheckTcpOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference">ComputeInstanceGroupHealthCheckTcpOptionsOutputReference</a>

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpOptionsInput`<sup>Optional</sup> <a name="httpOptionsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.httpOptionsInput"></a>

```typescript
public readonly httpOptionsInput: IResolvable | ComputeInstanceGroupHealthCheckHttpOptions[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckHttpOptions">ComputeInstanceGroupHealthCheckHttpOptions</a>[]

---

##### `intervalInput`<sup>Optional</sup> <a name="intervalInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: number;
```

- *Type:* number

---

##### `tcpOptionsInput`<sup>Optional</sup> <a name="tcpOptionsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.tcpOptionsInput"></a>

```typescript
public readonly tcpOptionsInput: ComputeInstanceGroupHealthCheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a>

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* number

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupHealthCheck;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheck">ComputeInstanceGroupHealthCheck</a>

---


### ComputeInstanceGroupHealthCheckTcpOptionsOutputReference <a name="ComputeInstanceGroupHealthCheckTcpOptionsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupHealthCheckTcpOptionsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupHealthCheckTcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupHealthCheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupHealthCheckTcpOptions">ComputeInstanceGroupHealthCheckTcpOptions</a>

---


### ComputeInstanceGroupInstancesList <a name="ComputeInstanceGroupInstancesList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstancesList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstancesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstancesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### ComputeInstanceGroupInstancesNetworkInterfaceList <a name="ComputeInstanceGroupInstancesNetworkInterfaceList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstancesNetworkInterfaceList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstancesNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstancesNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### ComputeInstanceGroupInstancesNetworkInterfaceOutputReference <a name="ComputeInstanceGroupInstancesNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstancesNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstancesNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.index">index</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpVersion">natIpVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterface">ComputeInstanceGroupInstancesNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.index"></a>

```typescript
public readonly index: number;
```

- *Type:* number

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `natIpVersion`<sup>Required</sup> <a name="natIpVersion" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpVersion"></a>

```typescript
public readonly natIpVersion: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstancesNetworkInterface;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterface">ComputeInstanceGroupInstancesNetworkInterface</a>

---


### ComputeInstanceGroupInstancesOutputReference <a name="ComputeInstanceGroupInstancesOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstancesOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstancesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.instanceId">instanceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList">ComputeInstanceGroupInstancesNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.statusChangedAt">statusChangedAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstances">ComputeInstanceGroupInstances</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `instanceId`<sup>Required</sup> <a name="instanceId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: ComputeInstanceGroupInstancesNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstancesNetworkInterfaceList">ComputeInstanceGroupInstancesNetworkInterfaceList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `statusChangedAt`<sup>Required</sup> <a name="statusChangedAt" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.statusChangedAt"></a>

```typescript
public readonly statusChangedAt: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstancesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstances;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstances">ComputeInstanceGroupInstances</a>

---


### ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference <a name="ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetImageId">resetImageId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetSize">resetSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetSnapshotId">resetSnapshotId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetImageId` <a name="resetImageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetImageId"></a>

```typescript
public resetImageId(): void
```

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetSize"></a>

```typescript
public resetSize(): void
```

##### `resetSnapshotId` <a name="resetSnapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetSnapshotId"></a>

```typescript
public resetSnapshotId(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageIdInput">imageIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotIdInput">snapshotIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `imageIdInput`<sup>Optional</sup> <a name="imageIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="snapshotIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a>

---


### ComputeInstanceGroupInstanceTemplateBootDiskOutputReference <a name="ComputeInstanceGroupInstanceTemplateBootDiskOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateBootDiskOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.putInitializeParams">putInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetDeviceName">resetDeviceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetDiskId">resetDiskId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetInitializeParams">resetInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetMode">resetMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putInitializeParams` <a name="putInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.putInitializeParams"></a>

```typescript
public putInitializeParams(value: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.putInitializeParams.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a>

---

##### `resetDeviceName` <a name="resetDeviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName(): void
```

##### `resetDiskId` <a name="resetDiskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetDiskId"></a>

```typescript
public resetDiskId(): void
```

##### `resetInitializeParams` <a name="resetInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetInitializeParams"></a>

```typescript
public resetInitializeParams(): void
```

##### `resetMode` <a name="resetMode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resetMode"></a>

```typescript
public resetMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceNameInput">deviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskIdInput">diskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParamsInput">initializeParamsInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.modeInput">modeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference</a>

---

##### `deviceNameInput`<sup>Optional</sup> <a name="deviceNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* string

---

##### `diskIdInput`<sup>Optional</sup> <a name="diskIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskIdInput"></a>

```typescript
public readonly diskIdInput: string;
```

- *Type:* string

---

##### `initializeParamsInput`<sup>Optional</sup> <a name="initializeParamsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParamsInput"></a>

```typescript
public readonly initializeParamsInput: ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">ComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a>

---

##### `modeInput`<sup>Optional</sup> <a name="modeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* string

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a>

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceList <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>

---


### ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference <a name="ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putDnsRecord">putDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putIpv6DnsRecord">putIpv6DnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putNatDnsRecord">putNatDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetDnsRecord">resetDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpAddress">resetIpAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv4">resetIpv4</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6">resetIpv6</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6Address">resetIpv6Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6DnsRecord">resetIpv6DnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNat">resetNat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNatDnsRecord">resetNatDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNatIpAddress">resetNatIpAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNetworkId">resetNetworkId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetSubnetIds">resetSubnetIds</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDnsRecord` <a name="putDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putDnsRecord"></a>

```typescript
public putDnsRecord(value: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putDnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]

---

##### `putIpv6DnsRecord` <a name="putIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putIpv6DnsRecord"></a>

```typescript
public putIpv6DnsRecord(value: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putIpv6DnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]

---

##### `putNatDnsRecord` <a name="putNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putNatDnsRecord"></a>

```typescript
public putNatDnsRecord(value: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.putNatDnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]

---

##### `resetDnsRecord` <a name="resetDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetDnsRecord"></a>

```typescript
public resetDnsRecord(): void
```

##### `resetIpAddress` <a name="resetIpAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpAddress"></a>

```typescript
public resetIpAddress(): void
```

##### `resetIpv4` <a name="resetIpv4" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv4"></a>

```typescript
public resetIpv4(): void
```

##### `resetIpv6` <a name="resetIpv6" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6"></a>

```typescript
public resetIpv6(): void
```

##### `resetIpv6Address` <a name="resetIpv6Address" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6Address"></a>

```typescript
public resetIpv6Address(): void
```

##### `resetIpv6DnsRecord` <a name="resetIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6DnsRecord"></a>

```typescript
public resetIpv6DnsRecord(): void
```

##### `resetNat` <a name="resetNat" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNat"></a>

```typescript
public resetNat(): void
```

##### `resetNatDnsRecord` <a name="resetNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNatDnsRecord"></a>

```typescript
public resetNatDnsRecord(): void
```

##### `resetNatIpAddress` <a name="resetNatIpAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNatIpAddress"></a>

```typescript
public resetNatIpAddress(): void
```

##### `resetNetworkId` <a name="resetNetworkId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetNetworkId"></a>

```typescript
public resetNetworkId(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetSubnetIds` <a name="resetSubnetIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resetSubnetIds"></a>

```typescript
public resetSubnetIds(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecord">dnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecord">natDnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecordInput">dnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddressInput">ipAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4Input">ipv4Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6AddressInput">ipv6AddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecordInput">ipv6DnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Input">ipv6Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecordInput">natDnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natInput">natInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddressInput">natIpAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkIdInput">networkIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIdsInput">subnetIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsRecord`<sup>Required</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList</a>

---

##### `ipv6DnsRecord`<sup>Required</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList</a>

---

##### `natDnsRecord`<sup>Required</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList</a>

---

##### `dnsRecordInput`<sup>Optional</sup> <a name="dnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecordInput"></a>

```typescript
public readonly dnsRecordInput: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>[]

---

##### `ipAddressInput`<sup>Optional</sup> <a name="ipAddressInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* string

---

##### `ipv4Input`<sup>Optional</sup> <a name="ipv4Input" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4Input"></a>

```typescript
public readonly ipv4Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6AddressInput`<sup>Optional</sup> <a name="ipv6AddressInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6AddressInput"></a>

```typescript
public readonly ipv6AddressInput: string;
```

- *Type:* string

---

##### `ipv6DnsRecordInput`<sup>Optional</sup> <a name="ipv6DnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecordInput"></a>

```typescript
public readonly ipv6DnsRecordInput: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>[]

---

##### `ipv6Input`<sup>Optional</sup> <a name="ipv6Input" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Input"></a>

```typescript
public readonly ipv6Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natDnsRecordInput`<sup>Optional</sup> <a name="natDnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecordInput"></a>

```typescript
public readonly natDnsRecordInput: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">ComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>[]

---

##### `natInput`<sup>Optional</sup> <a name="natInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natInput"></a>

```typescript
public readonly natInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natIpAddressInput`<sup>Optional</sup> <a name="natIpAddressInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddressInput"></a>

```typescript
public readonly natIpAddressInput: string;
```

- *Type:* string

---

##### `networkIdInput`<sup>Optional</sup> <a name="networkIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkIdInput"></a>

```typescript
public readonly networkIdInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `subnetIdsInput`<sup>Optional</sup> <a name="subnetIdsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIdsInput"></a>

```typescript
public readonly subnetIdsInput: string[];
```

- *Type:* string[]

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>

---


### ComputeInstanceGroupInstanceTemplateNetworkSettingsList <a name="ComputeInstanceGroupInstanceTemplateNetworkSettingsList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkSettingsList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkSettingsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]

---


### ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference <a name="ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>

---


### ComputeInstanceGroupInstanceTemplateOutputReference <a name="ComputeInstanceGroupInstanceTemplateOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putBootDisk">putBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkInterface">putNetworkInterface</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkSettings">putNetworkSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putPlacementPolicy">putPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSchedulingPolicy">putSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSecondaryDisk">putSecondaryDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetHostname">resetHostname</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetMetadata">resetMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetNetworkSettings">resetNetworkSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetPlacementPolicy">resetPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetPlatformId">resetPlatformId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetSchedulingPolicy">resetSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetSecondaryDisk">resetSecondaryDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putBootDisk` <a name="putBootDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putBootDisk"></a>

```typescript
public putBootDisk(value: ComputeInstanceGroupInstanceTemplateBootDisk): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putBootDisk.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a>

---

##### `putNetworkInterface` <a name="putNetworkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkInterface"></a>

```typescript
public putNetworkInterface(value: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkInterface.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]

---

##### `putNetworkSettings` <a name="putNetworkSettings" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkSettings"></a>

```typescript
public putNetworkSettings(value: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putNetworkSettings.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]

---

##### `putPlacementPolicy` <a name="putPlacementPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putPlacementPolicy"></a>

```typescript
public putPlacementPolicy(value: ComputeInstanceGroupInstanceTemplatePlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putResources"></a>

```typescript
public putResources(value: ComputeInstanceGroupInstanceTemplateResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a>

---

##### `putSchedulingPolicy` <a name="putSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSchedulingPolicy"></a>

```typescript
public putSchedulingPolicy(value: ComputeInstanceGroupInstanceTemplateSchedulingPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSchedulingPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a>

---

##### `putSecondaryDisk` <a name="putSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSecondaryDisk"></a>

```typescript
public putSecondaryDisk(value: IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.putSecondaryDisk.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]

---

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetHostname` <a name="resetHostname" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetHostname"></a>

```typescript
public resetHostname(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetMetadata` <a name="resetMetadata" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetMetadata"></a>

```typescript
public resetMetadata(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetName"></a>

```typescript
public resetName(): void
```

##### `resetNetworkSettings` <a name="resetNetworkSettings" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetNetworkSettings"></a>

```typescript
public resetNetworkSettings(): void
```

##### `resetPlacementPolicy` <a name="resetPlacementPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetPlacementPolicy"></a>

```typescript
public resetPlacementPolicy(): void
```

##### `resetPlatformId` <a name="resetPlatformId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetPlatformId"></a>

```typescript
public resetPlatformId(): void
```

##### `resetSchedulingPolicy` <a name="resetSchedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetSchedulingPolicy"></a>

```typescript
public resetSchedulingPolicy(): void
```

##### `resetSecondaryDisk` <a name="resetSecondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetSecondaryDisk"></a>

```typescript
public resetSecondaryDisk(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference">ComputeInstanceGroupInstanceTemplateBootDiskOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettings">networkSettings</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList">ComputeInstanceGroupInstanceTemplateNetworkSettingsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference">ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference">ComputeInstanceGroupInstanceTemplateResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference">ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDisk">secondaryDisk</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList">ComputeInstanceGroupInstanceTemplateSecondaryDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.bootDiskInput">bootDiskInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.hostnameInput">hostnameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.metadataInput">metadataInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterfaceInput">networkInterfaceInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettingsInput">networkSettingsInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicyInput">placementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.platformIdInput">platformIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicyInput">schedulingPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDiskInput">secondaryDiskInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.hostname">hostname</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.bootDisk"></a>

```typescript
public readonly bootDisk: ComputeInstanceGroupInstanceTemplateBootDiskOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDiskOutputReference">ComputeInstanceGroupInstanceTemplateBootDiskOutputReference</a>

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: ComputeInstanceGroupInstanceTemplateNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterfaceList">ComputeInstanceGroupInstanceTemplateNetworkInterfaceList</a>

---

##### `networkSettings`<sup>Required</sup> <a name="networkSettings" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettings"></a>

```typescript
public readonly networkSettings: ComputeInstanceGroupInstanceTemplateNetworkSettingsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettingsList">ComputeInstanceGroupInstanceTemplateNetworkSettingsList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference">ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.resources"></a>

```typescript
public readonly resources: ComputeInstanceGroupInstanceTemplateResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference">ComputeInstanceGroupInstanceTemplateResourcesOutputReference</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference">ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference</a>

---

##### `secondaryDisk`<sup>Required</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: ComputeInstanceGroupInstanceTemplateSecondaryDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList">ComputeInstanceGroupInstanceTemplateSecondaryDiskList</a>

---

##### `bootDiskInput`<sup>Optional</sup> <a name="bootDiskInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.bootDiskInput"></a>

```typescript
public readonly bootDiskInput: ComputeInstanceGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateBootDisk">ComputeInstanceGroupInstanceTemplateBootDisk</a>

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `hostnameInput`<sup>Optional</sup> <a name="hostnameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.hostnameInput"></a>

```typescript
public readonly hostnameInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metadataInput`<sup>Optional</sup> <a name="metadataInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `networkInterfaceInput`<sup>Optional</sup> <a name="networkInterfaceInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterfaceInput"></a>

```typescript
public readonly networkInterfaceInput: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkInterface">ComputeInstanceGroupInstanceTemplateNetworkInterface</a>[]

---

##### `networkSettingsInput`<sup>Optional</sup> <a name="networkSettingsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettingsInput"></a>

```typescript
public readonly networkSettingsInput: IResolvable | ComputeInstanceGroupInstanceTemplateNetworkSettings[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateNetworkSettings">ComputeInstanceGroupInstanceTemplateNetworkSettings</a>[]

---

##### `placementPolicyInput`<sup>Optional</sup> <a name="placementPolicyInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicyInput"></a>

```typescript
public readonly placementPolicyInput: ComputeInstanceGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a>

---

##### `platformIdInput`<sup>Optional</sup> <a name="platformIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.platformIdInput"></a>

```typescript
public readonly platformIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: ComputeInstanceGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a>

---

##### `schedulingPolicyInput`<sup>Optional</sup> <a name="schedulingPolicyInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicyInput"></a>

```typescript
public readonly schedulingPolicyInput: ComputeInstanceGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a>

---

##### `secondaryDiskInput`<sup>Optional</sup> <a name="secondaryDiskInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDiskInput"></a>

```typescript
public readonly secondaryDiskInput: IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `hostname`<sup>Required</sup> <a name="hostname" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplate">ComputeInstanceGroupInstanceTemplate</a>

---


### ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference <a name="ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupIdInput">placementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `placementGroupIdInput`<sup>Optional</sup> <a name="placementGroupIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupIdInput"></a>

```typescript
public readonly placementGroupIdInput: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplatePlacementPolicy">ComputeInstanceGroupInstanceTemplatePlacementPolicy</a>

---


### ComputeInstanceGroupInstanceTemplateResourcesOutputReference <a name="ComputeInstanceGroupInstanceTemplateResourcesOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateResourcesOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resetCoreFraction">resetCoreFraction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resetGpus">resetGpus</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCoreFraction` <a name="resetCoreFraction" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resetCoreFraction"></a>

```typescript
public resetCoreFraction(): void
```

##### `resetGpus` <a name="resetGpus" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.resetGpus"></a>

```typescript
public resetGpus(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFractionInput">coreFractionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coresInput">coresInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpusInput">gpusInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memoryInput">memoryInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFractionInput`<sup>Optional</sup> <a name="coreFractionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFractionInput"></a>

```typescript
public readonly coreFractionInput: number;
```

- *Type:* number

---

##### `coresInput`<sup>Optional</sup> <a name="coresInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* number

---

##### `gpusInput`<sup>Optional</sup> <a name="gpusInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpusInput"></a>

```typescript
public readonly gpusInput: number;
```

- *Type:* number

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* number

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateResources">ComputeInstanceGroupInstanceTemplateResources</a>

---


### ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference <a name="ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resetPreemptible">resetPreemptible</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPreemptible` <a name="resetPreemptible" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resetPreemptible"></a>

```typescript
public resetPreemptible(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptibleInput">preemptibleInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptibleInput`<sup>Optional</sup> <a name="preemptibleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptibleInput"></a>

```typescript
public readonly preemptibleInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSchedulingPolicy">ComputeInstanceGroupInstanceTemplateSchedulingPolicy</a>

---


### ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference <a name="ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetImageId">resetImageId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetSize">resetSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetSnapshotId">resetSnapshotId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetImageId` <a name="resetImageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetImageId"></a>

```typescript
public resetImageId(): void
```

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetSize"></a>

```typescript
public resetSize(): void
```

##### `resetSnapshotId` <a name="resetSnapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetSnapshotId"></a>

```typescript
public resetSnapshotId(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageIdInput">imageIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotIdInput">snapshotIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `imageIdInput`<sup>Optional</sup> <a name="imageIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageIdInput"></a>

```typescript
public readonly imageIdInput: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `snapshotIdInput`<sup>Optional</sup> <a name="snapshotIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotIdInput"></a>

```typescript
public readonly snapshotIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a>

---


### ComputeInstanceGroupInstanceTemplateSecondaryDiskList <a name="ComputeInstanceGroupInstanceTemplateSecondaryDiskList" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSecondaryDiskList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateSecondaryDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>[]

---


### ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference <a name="ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.putInitializeParams">putInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetDeviceName">resetDeviceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetDiskId">resetDiskId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetInitializeParams">resetInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetMode">resetMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putInitializeParams` <a name="putInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.putInitializeParams"></a>

```typescript
public putInitializeParams(value: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.putInitializeParams.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a>

---

##### `resetDeviceName` <a name="resetDeviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName(): void
```

##### `resetDiskId` <a name="resetDiskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetDiskId"></a>

```typescript
public resetDiskId(): void
```

##### `resetInitializeParams` <a name="resetInitializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetInitializeParams"></a>

```typescript
public resetInitializeParams(): void
```

##### `resetMode` <a name="resetMode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resetMode"></a>

```typescript
public resetMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceNameInput">deviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskIdInput">diskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParamsInput">initializeParamsInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.modeInput">modeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference</a>

---

##### `deviceNameInput`<sup>Optional</sup> <a name="deviceNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* string

---

##### `diskIdInput`<sup>Optional</sup> <a name="diskIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskIdInput"></a>

```typescript
public readonly diskIdInput: string;
```

- *Type:* string

---

##### `initializeParamsInput`<sup>Optional</sup> <a name="initializeParamsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParamsInput"></a>

```typescript
public readonly initializeParamsInput: ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">ComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a>

---

##### `modeInput`<sup>Optional</sup> <a name="modeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* string

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupInstanceTemplateSecondaryDisk;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupInstanceTemplateSecondaryDisk">ComputeInstanceGroupInstanceTemplateSecondaryDisk</a>

---


### ComputeInstanceGroupLoadBalancerOutputReference <a name="ComputeInstanceGroupLoadBalancerOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupLoadBalancerOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupLoadBalancerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetMaxOpeningTrafficDuration">resetMaxOpeningTrafficDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupDescription">resetTargetGroupDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupLabels">resetTargetGroupLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupName">resetTargetGroupName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxOpeningTrafficDuration` <a name="resetMaxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetMaxOpeningTrafficDuration"></a>

```typescript
public resetMaxOpeningTrafficDuration(): void
```

##### `resetTargetGroupDescription` <a name="resetTargetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupDescription"></a>

```typescript
public resetTargetGroupDescription(): void
```

##### `resetTargetGroupLabels` <a name="resetTargetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupLabels"></a>

```typescript
public resetTargetGroupLabels(): void
```

##### `resetTargetGroupName` <a name="resetTargetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.resetTargetGroupName"></a>

```typescript
public resetTargetGroupName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDurationInput">maxOpeningTrafficDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescriptionInput">targetGroupDescriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabelsInput">targetGroupLabelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupNameInput">targetGroupNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabels">targetGroupLabels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDurationInput`<sup>Optional</sup> <a name="maxOpeningTrafficDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDurationInput"></a>

```typescript
public readonly maxOpeningTrafficDurationInput: number;
```

- *Type:* number

---

##### `targetGroupDescriptionInput`<sup>Optional</sup> <a name="targetGroupDescriptionInput" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescriptionInput"></a>

```typescript
public readonly targetGroupDescriptionInput: string;
```

- *Type:* string

---

##### `targetGroupLabelsInput`<sup>Optional</sup> <a name="targetGroupLabelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabelsInput"></a>

```typescript
public readonly targetGroupLabelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `targetGroupNameInput`<sup>Optional</sup> <a name="targetGroupNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupNameInput"></a>

```typescript
public readonly targetGroupNameInput: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDuration`<sup>Required</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

---

##### `targetGroupDescription`<sup>Required</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

---

##### `targetGroupLabels`<sup>Required</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `targetGroupName`<sup>Required</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupLoadBalancer">ComputeInstanceGroupLoadBalancer</a>

---


### ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList <a name="ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]

---


### ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference <a name="ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetService">resetService</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetService` <a name="resetService" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resetService"></a>

```typescript
public resetService(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricNameInput">metricNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricTypeInput">metricTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleTypeInput">ruleTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.serviceInput">serviceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.targetInput">targetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricName">metricName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricType">metricType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleType">ruleType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.service">service</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.target">target</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metricNameInput`<sup>Optional</sup> <a name="metricNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricNameInput"></a>

```typescript
public readonly metricNameInput: string;
```

- *Type:* string

---

##### `metricTypeInput`<sup>Optional</sup> <a name="metricTypeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricTypeInput"></a>

```typescript
public readonly metricTypeInput: string;
```

- *Type:* string

---

##### `ruleTypeInput`<sup>Optional</sup> <a name="ruleTypeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleTypeInput"></a>

```typescript
public readonly ruleTypeInput: string;
```

- *Type:* string

---

##### `serviceInput`<sup>Optional</sup> <a name="serviceInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.serviceInput"></a>

```typescript
public readonly serviceInput: string;
```

- *Type:* string

---

##### `targetInput`<sup>Optional</sup> <a name="targetInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.targetInput"></a>

```typescript
public readonly targetInput: number;
```

- *Type:* number

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

---

##### `service`<sup>Required</sup> <a name="service" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>

---


### ComputeInstanceGroupScalePolicyAutoScaleOutputReference <a name="ComputeInstanceGroupScalePolicyAutoScaleOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyAutoScaleOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.putCustomRule">putCustomRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetCpuUtilizationTarget">resetCpuUtilizationTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetCustomRule">resetCustomRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetMaxSize">resetMaxSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetMinZoneSize">resetMinZoneSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetStabilizationDuration">resetStabilizationDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetWarmupDuration">resetWarmupDuration</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putCustomRule` <a name="putCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.putCustomRule"></a>

```typescript
public putCustomRule(value: IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.putCustomRule.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]

---

##### `resetCpuUtilizationTarget` <a name="resetCpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetCpuUtilizationTarget"></a>

```typescript
public resetCpuUtilizationTarget(): void
```

##### `resetCustomRule` <a name="resetCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetCustomRule"></a>

```typescript
public resetCustomRule(): void
```

##### `resetMaxSize` <a name="resetMaxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetMaxSize"></a>

```typescript
public resetMaxSize(): void
```

##### `resetMinZoneSize` <a name="resetMinZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetMinZoneSize"></a>

```typescript
public resetMinZoneSize(): void
```

##### `resetStabilizationDuration` <a name="resetStabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetStabilizationDuration"></a>

```typescript
public resetStabilizationDuration(): void
```

##### `resetWarmupDuration` <a name="resetWarmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.resetWarmupDuration"></a>

```typescript
public resetWarmupDuration(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRule">customRule</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList">ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTargetInput">cpuUtilizationTargetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRuleInput">customRuleInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSizeInput">initialSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSizeInput">maxSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDurationInput">measurementDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSizeInput">minZoneSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDurationInput">stabilizationDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDurationInput">warmupDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSize">initialSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSize">maxSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `customRule`<sup>Required</sup> <a name="customRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRule"></a>

```typescript
public readonly customRule: ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList">ComputeInstanceGroupScalePolicyAutoScaleCustomRuleList</a>

---

##### `cpuUtilizationTargetInput`<sup>Optional</sup> <a name="cpuUtilizationTargetInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTargetInput"></a>

```typescript
public readonly cpuUtilizationTargetInput: number;
```

- *Type:* number

---

##### `customRuleInput`<sup>Optional</sup> <a name="customRuleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRuleInput"></a>

```typescript
public readonly customRuleInput: IResolvable | ComputeInstanceGroupScalePolicyAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleCustomRule">ComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>[]

---

##### `initialSizeInput`<sup>Optional</sup> <a name="initialSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSizeInput"></a>

```typescript
public readonly initialSizeInput: number;
```

- *Type:* number

---

##### `maxSizeInput`<sup>Optional</sup> <a name="maxSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSizeInput"></a>

```typescript
public readonly maxSizeInput: number;
```

- *Type:* number

---

##### `measurementDurationInput`<sup>Optional</sup> <a name="measurementDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDurationInput"></a>

```typescript
public readonly measurementDurationInput: number;
```

- *Type:* number

---

##### `minZoneSizeInput`<sup>Optional</sup> <a name="minZoneSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSizeInput"></a>

```typescript
public readonly minZoneSizeInput: number;
```

- *Type:* number

---

##### `stabilizationDurationInput`<sup>Optional</sup> <a name="stabilizationDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDurationInput"></a>

```typescript
public readonly stabilizationDurationInput: number;
```

- *Type:* number

---

##### `warmupDurationInput`<sup>Optional</sup> <a name="warmupDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDurationInput"></a>

```typescript
public readonly warmupDurationInput: number;
```

- *Type:* number

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

---

##### `maxSize`<sup>Required</sup> <a name="maxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `minZoneSize`<sup>Required</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a>

---


### ComputeInstanceGroupScalePolicyFixedScaleOutputReference <a name="ComputeInstanceGroupScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a>

---


### ComputeInstanceGroupScalePolicyOutputReference <a name="ComputeInstanceGroupScalePolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putAutoScale">putAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putFixedScale">putFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putTestAutoScale">putTestAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetAutoScale">resetAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetFixedScale">resetFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetTestAutoScale">resetTestAutoScale</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAutoScale` <a name="putAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putAutoScale"></a>

```typescript
public putAutoScale(value: ComputeInstanceGroupScalePolicyAutoScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putAutoScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a>

---

##### `putFixedScale` <a name="putFixedScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putFixedScale"></a>

```typescript
public putFixedScale(value: ComputeInstanceGroupScalePolicyFixedScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putFixedScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a>

---

##### `putTestAutoScale` <a name="putTestAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putTestAutoScale"></a>

```typescript
public putTestAutoScale(value: ComputeInstanceGroupScalePolicyTestAutoScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.putTestAutoScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a>

---

##### `resetAutoScale` <a name="resetAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetAutoScale"></a>

```typescript
public resetAutoScale(): void
```

##### `resetFixedScale` <a name="resetFixedScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetFixedScale"></a>

```typescript
public resetFixedScale(): void
```

##### `resetTestAutoScale` <a name="resetTestAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.resetTestAutoScale"></a>

```typescript
public resetTestAutoScale(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference">ComputeInstanceGroupScalePolicyAutoScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference">ComputeInstanceGroupScalePolicyFixedScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.testAutoScale">testAutoScale</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference">ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.autoScaleInput">autoScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fixedScaleInput">fixedScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.testAutoScaleInput">testAutoScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoScale`<sup>Required</sup> <a name="autoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.autoScale"></a>

```typescript
public readonly autoScale: ComputeInstanceGroupScalePolicyAutoScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScaleOutputReference">ComputeInstanceGroupScalePolicyAutoScaleOutputReference</a>

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: ComputeInstanceGroupScalePolicyFixedScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScaleOutputReference">ComputeInstanceGroupScalePolicyFixedScaleOutputReference</a>

---

##### `testAutoScale`<sup>Required</sup> <a name="testAutoScale" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.testAutoScale"></a>

```typescript
public readonly testAutoScale: ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference">ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference</a>

---

##### `autoScaleInput`<sup>Optional</sup> <a name="autoScaleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.autoScaleInput"></a>

```typescript
public readonly autoScaleInput: ComputeInstanceGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyAutoScale">ComputeInstanceGroupScalePolicyAutoScale</a>

---

##### `fixedScaleInput`<sup>Optional</sup> <a name="fixedScaleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.fixedScaleInput"></a>

```typescript
public readonly fixedScaleInput: ComputeInstanceGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyFixedScale">ComputeInstanceGroupScalePolicyFixedScale</a>

---

##### `testAutoScaleInput`<sup>Optional</sup> <a name="testAutoScaleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.testAutoScaleInput"></a>

```typescript
public readonly testAutoScaleInput: ComputeInstanceGroupScalePolicyTestAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicy">ComputeInstanceGroupScalePolicy</a>

---


### ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList <a name="ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get"></a>

```typescript
public get(index: number): ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]

---


### ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference <a name="ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetFolderId">resetFolderId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetService">resetService</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetFolderId` <a name="resetFolderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetFolderId"></a>

```typescript
public resetFolderId(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetService` <a name="resetService" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resetService"></a>

```typescript
public resetService(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderIdInput">folderIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricNameInput">metricNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricTypeInput">metricTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleTypeInput">ruleTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.serviceInput">serviceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.targetInput">targetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricName">metricName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricType">metricType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleType">ruleType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.service">service</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.target">target</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `folderIdInput`<sup>Optional</sup> <a name="folderIdInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderIdInput"></a>

```typescript
public readonly folderIdInput: string;
```

- *Type:* string

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metricNameInput`<sup>Optional</sup> <a name="metricNameInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricNameInput"></a>

```typescript
public readonly metricNameInput: string;
```

- *Type:* string

---

##### `metricTypeInput`<sup>Optional</sup> <a name="metricTypeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricTypeInput"></a>

```typescript
public readonly metricTypeInput: string;
```

- *Type:* string

---

##### `ruleTypeInput`<sup>Optional</sup> <a name="ruleTypeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleTypeInput"></a>

```typescript
public readonly ruleTypeInput: string;
```

- *Type:* string

---

##### `serviceInput`<sup>Optional</sup> <a name="serviceInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.serviceInput"></a>

```typescript
public readonly serviceInput: string;
```

- *Type:* string

---

##### `targetInput`<sup>Optional</sup> <a name="targetInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.targetInput"></a>

```typescript
public readonly targetInput: number;
```

- *Type:* number

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

---

##### `service`<sup>Required</sup> <a name="service" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>

---


### ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference <a name="ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.putCustomRule">putCustomRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetCpuUtilizationTarget">resetCpuUtilizationTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetCustomRule">resetCustomRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetMaxSize">resetMaxSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetMinZoneSize">resetMinZoneSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetStabilizationDuration">resetStabilizationDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetWarmupDuration">resetWarmupDuration</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putCustomRule` <a name="putCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.putCustomRule"></a>

```typescript
public putCustomRule(value: IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.putCustomRule.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]

---

##### `resetCpuUtilizationTarget` <a name="resetCpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetCpuUtilizationTarget"></a>

```typescript
public resetCpuUtilizationTarget(): void
```

##### `resetCustomRule` <a name="resetCustomRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetCustomRule"></a>

```typescript
public resetCustomRule(): void
```

##### `resetMaxSize` <a name="resetMaxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetMaxSize"></a>

```typescript
public resetMaxSize(): void
```

##### `resetMinZoneSize` <a name="resetMinZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetMinZoneSize"></a>

```typescript
public resetMinZoneSize(): void
```

##### `resetStabilizationDuration` <a name="resetStabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetStabilizationDuration"></a>

```typescript
public resetStabilizationDuration(): void
```

##### `resetWarmupDuration` <a name="resetWarmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resetWarmupDuration"></a>

```typescript
public resetWarmupDuration(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRule">customRule</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTargetInput">cpuUtilizationTargetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRuleInput">customRuleInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSizeInput">initialSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSizeInput">maxSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDurationInput">measurementDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSizeInput">minZoneSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDurationInput">stabilizationDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDurationInput">warmupDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSize">initialSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSize">maxSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `customRule`<sup>Required</sup> <a name="customRule" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRule"></a>

```typescript
public readonly customRule: ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList</a>

---

##### `cpuUtilizationTargetInput`<sup>Optional</sup> <a name="cpuUtilizationTargetInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTargetInput"></a>

```typescript
public readonly cpuUtilizationTargetInput: number;
```

- *Type:* number

---

##### `customRuleInput`<sup>Optional</sup> <a name="customRuleInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRuleInput"></a>

```typescript
public readonly customRuleInput: IResolvable | ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">ComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>[]

---

##### `initialSizeInput`<sup>Optional</sup> <a name="initialSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSizeInput"></a>

```typescript
public readonly initialSizeInput: number;
```

- *Type:* number

---

##### `maxSizeInput`<sup>Optional</sup> <a name="maxSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSizeInput"></a>

```typescript
public readonly maxSizeInput: number;
```

- *Type:* number

---

##### `measurementDurationInput`<sup>Optional</sup> <a name="measurementDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDurationInput"></a>

```typescript
public readonly measurementDurationInput: number;
```

- *Type:* number

---

##### `minZoneSizeInput`<sup>Optional</sup> <a name="minZoneSizeInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSizeInput"></a>

```typescript
public readonly minZoneSizeInput: number;
```

- *Type:* number

---

##### `stabilizationDurationInput`<sup>Optional</sup> <a name="stabilizationDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDurationInput"></a>

```typescript
public readonly stabilizationDurationInput: number;
```

- *Type:* number

---

##### `warmupDurationInput`<sup>Optional</sup> <a name="warmupDurationInput" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDurationInput"></a>

```typescript
public readonly warmupDurationInput: number;
```

- *Type:* number

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

---

##### `maxSize`<sup>Required</sup> <a name="maxSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `minZoneSize`<sup>Required</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceGroupScalePolicyTestAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceGroupScalePolicyTestAutoScale">ComputeInstanceGroupScalePolicyTestAutoScale</a>

---


### ComputeInstanceGroupTimeoutsOutputReference <a name="ComputeInstanceGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceGroupTimeouts">ComputeInstanceGroupTimeouts</a>

---


### ComputeInstanceNetworkInterfaceDnsRecordList <a name="ComputeInstanceNetworkInterfaceDnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceDnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceNetworkInterfaceDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]

---


### ComputeInstanceNetworkInterfaceDnsRecordOutputReference <a name="ComputeInstanceNetworkInterfaceDnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceDnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceDnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>

---


### ComputeInstanceNetworkInterfaceIpv6DnsRecordList <a name="ComputeInstanceNetworkInterfaceIpv6DnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceIpv6DnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceIpv6DnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]

---


### ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference <a name="ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceIpv6DnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>

---


### ComputeInstanceNetworkInterfaceList <a name="ComputeInstanceNetworkInterfaceList" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceList } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.get"></a>

```typescript
public get(index: number): ComputeInstanceNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>[]

---


### ComputeInstanceNetworkInterfaceNatDnsRecordList <a name="ComputeInstanceNetworkInterfaceNatDnsRecordList" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceNatDnsRecordList } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceNatDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.get"></a>

```typescript
public get(index: number): ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]

---


### ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference <a name="ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetDnsZoneId">resetDnsZoneId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetPtr">resetPtr</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetTtl">resetTtl</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDnsZoneId` <a name="resetDnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetDnsZoneId"></a>

```typescript
public resetDnsZoneId(): void
```

##### `resetPtr` <a name="resetPtr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetPtr"></a>

```typescript
public resetPtr(): void
```

##### `resetTtl` <a name="resetTtl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resetTtl"></a>

```typescript
public resetTtl(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneIdInput">dnsZoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdnInput">fqdnInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptrInput">ptrInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttlInput">ttlInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneIdInput`<sup>Optional</sup> <a name="dnsZoneIdInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneIdInput"></a>

```typescript
public readonly dnsZoneIdInput: string;
```

- *Type:* string

---

##### `fqdnInput`<sup>Optional</sup> <a name="fqdnInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdnInput"></a>

```typescript
public readonly fqdnInput: string;
```

- *Type:* string

---

##### `ptrInput`<sup>Optional</sup> <a name="ptrInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptrInput"></a>

```typescript
public readonly ptrInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttlInput`<sup>Optional</sup> <a name="ttlInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttlInput"></a>

```typescript
public readonly ttlInput: number;
```

- *Type:* number

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterfaceNatDnsRecord;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>

---


### ComputeInstanceNetworkInterfaceOutputReference <a name="ComputeInstanceNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putDnsRecord">putDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putIpv6DnsRecord">putIpv6DnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putNatDnsRecord">putNatDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetDnsRecord">resetDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpAddress">resetIpAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv4">resetIpv4</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6">resetIpv6</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6Address">resetIpv6Address</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6DnsRecord">resetIpv6DnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNat">resetNat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNatDnsRecord">resetNatDnsRecord</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNatIpAddress">resetNatIpAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDnsRecord` <a name="putDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putDnsRecord"></a>

```typescript
public putDnsRecord(value: IResolvable | ComputeInstanceNetworkInterfaceDnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putDnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]

---

##### `putIpv6DnsRecord` <a name="putIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putIpv6DnsRecord"></a>

```typescript
public putIpv6DnsRecord(value: IResolvable | ComputeInstanceNetworkInterfaceIpv6DnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putIpv6DnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]

---

##### `putNatDnsRecord` <a name="putNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putNatDnsRecord"></a>

```typescript
public putNatDnsRecord(value: IResolvable | ComputeInstanceNetworkInterfaceNatDnsRecord[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.putNatDnsRecord.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]

---

##### `resetDnsRecord` <a name="resetDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetDnsRecord"></a>

```typescript
public resetDnsRecord(): void
```

##### `resetIpAddress` <a name="resetIpAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpAddress"></a>

```typescript
public resetIpAddress(): void
```

##### `resetIpv4` <a name="resetIpv4" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv4"></a>

```typescript
public resetIpv4(): void
```

##### `resetIpv6` <a name="resetIpv6" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6"></a>

```typescript
public resetIpv6(): void
```

##### `resetIpv6Address` <a name="resetIpv6Address" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6Address"></a>

```typescript
public resetIpv6Address(): void
```

##### `resetIpv6DnsRecord` <a name="resetIpv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetIpv6DnsRecord"></a>

```typescript
public resetIpv6DnsRecord(): void
```

##### `resetNat` <a name="resetNat" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNat"></a>

```typescript
public resetNat(): void
```

##### `resetNatDnsRecord` <a name="resetNatDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNatDnsRecord"></a>

```typescript
public resetNatDnsRecord(): void
```

##### `resetNatIpAddress` <a name="resetNatIpAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetNatIpAddress"></a>

```typescript
public resetNatIpAddress(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.dnsRecord">dnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList">ComputeInstanceNetworkInterfaceDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.index">index</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList">ComputeInstanceNetworkInterfaceIpv6DnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecord">natDnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList">ComputeInstanceNetworkInterfaceNatDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpVersion">natIpVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.dnsRecordInput">dnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipAddressInput">ipAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv4Input">ipv4Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6AddressInput">ipv6AddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecordInput">ipv6DnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6Input">ipv6Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecordInput">natDnsRecordInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natInput">natInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpAddressInput">natIpAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsRecord`<sup>Required</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: ComputeInstanceNetworkInterfaceDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecordList">ComputeInstanceNetworkInterfaceDnsRecordList</a>

---

##### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.index"></a>

```typescript
public readonly index: number;
```

- *Type:* number

---

##### `ipv6DnsRecord`<sup>Required</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: ComputeInstanceNetworkInterfaceIpv6DnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecordList">ComputeInstanceNetworkInterfaceIpv6DnsRecordList</a>

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `natDnsRecord`<sup>Required</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: ComputeInstanceNetworkInterfaceNatDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecordList">ComputeInstanceNetworkInterfaceNatDnsRecordList</a>

---

##### `natIpVersion`<sup>Required</sup> <a name="natIpVersion" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpVersion"></a>

```typescript
public readonly natIpVersion: string;
```

- *Type:* string

---

##### `dnsRecordInput`<sup>Optional</sup> <a name="dnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.dnsRecordInput"></a>

```typescript
public readonly dnsRecordInput: IResolvable | ComputeInstanceNetworkInterfaceDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceDnsRecord">ComputeInstanceNetworkInterfaceDnsRecord</a>[]

---

##### `ipAddressInput`<sup>Optional</sup> <a name="ipAddressInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipAddressInput"></a>

```typescript
public readonly ipAddressInput: string;
```

- *Type:* string

---

##### `ipv4Input`<sup>Optional</sup> <a name="ipv4Input" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv4Input"></a>

```typescript
public readonly ipv4Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6AddressInput`<sup>Optional</sup> <a name="ipv6AddressInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6AddressInput"></a>

```typescript
public readonly ipv6AddressInput: string;
```

- *Type:* string

---

##### `ipv6DnsRecordInput`<sup>Optional</sup> <a name="ipv6DnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecordInput"></a>

```typescript
public readonly ipv6DnsRecordInput: IResolvable | ComputeInstanceNetworkInterfaceIpv6DnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceIpv6DnsRecord">ComputeInstanceNetworkInterfaceIpv6DnsRecord</a>[]

---

##### `ipv6Input`<sup>Optional</sup> <a name="ipv6Input" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6Input"></a>

```typescript
public readonly ipv6Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natDnsRecordInput`<sup>Optional</sup> <a name="natDnsRecordInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecordInput"></a>

```typescript
public readonly natDnsRecordInput: IResolvable | ComputeInstanceNetworkInterfaceNatDnsRecord[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceNatDnsRecord">ComputeInstanceNetworkInterfaceNatDnsRecord</a>[]

---

##### `natInput`<sup>Optional</sup> <a name="natInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natInput"></a>

```typescript
public readonly natInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natIpAddressInput`<sup>Optional</sup> <a name="natIpAddressInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpAddressInput"></a>

```typescript
public readonly natIpAddressInput: string;
```

- *Type:* string

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceNetworkInterface;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceNetworkInterface">ComputeInstanceNetworkInterface</a>

---


### ComputeInstancePlacementPolicyHostAffinityRulesList <a name="ComputeInstancePlacementPolicyHostAffinityRulesList" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer"></a>

```typescript
import { ComputeInstancePlacementPolicyHostAffinityRulesList } from '@cdktf/provider-yandex'

new ComputeInstancePlacementPolicyHostAffinityRulesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.get"></a>

```typescript
public get(index: number): ComputeInstancePlacementPolicyHostAffinityRulesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]

---


### ComputeInstancePlacementPolicyHostAffinityRulesOutputReference <a name="ComputeInstancePlacementPolicyHostAffinityRulesOutputReference" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer"></a>

```typescript
import { ComputeInstancePlacementPolicyHostAffinityRulesOutputReference } from '@cdktf/provider-yandex'

new ComputeInstancePlacementPolicyHostAffinityRulesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetKey">resetKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetOp">resetOp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetValues">resetValues</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetKey` <a name="resetKey" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetKey"></a>

```typescript
public resetKey(): void
```

##### `resetOp` <a name="resetOp" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetOp"></a>

```typescript
public resetOp(): void
```

##### `resetValues` <a name="resetValues" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetValues"></a>

```typescript
public resetValues(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.keyInput">keyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.opInput">opInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.key">key</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.op">op</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `keyInput`<sup>Optional</sup> <a name="keyInput" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* string

---

##### `opInput`<sup>Optional</sup> <a name="opInput" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.opInput"></a>

```typescript
public readonly opInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `key`<sup>Required</sup> <a name="key" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

---

##### `op`<sup>Required</sup> <a name="op" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.op"></a>

```typescript
public readonly op: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstancePlacementPolicyHostAffinityRules;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>

---


### ComputeInstancePlacementPolicyOutputReference <a name="ComputeInstancePlacementPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstancePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstancePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.putHostAffinityRules">putHostAffinityRules</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resetHostAffinityRules">resetHostAffinityRules</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resetPlacementGroupId">resetPlacementGroupId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHostAffinityRules` <a name="putHostAffinityRules" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.putHostAffinityRules"></a>

```typescript
public putHostAffinityRules(value: IResolvable | ComputeInstancePlacementPolicyHostAffinityRules[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.putHostAffinityRules.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]

---

##### `resetHostAffinityRules` <a name="resetHostAffinityRules" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resetHostAffinityRules"></a>

```typescript
public resetHostAffinityRules(): void
```

##### `resetPlacementGroupId` <a name="resetPlacementGroupId" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.resetPlacementGroupId"></a>

```typescript
public resetPlacementGroupId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.hostAffinityRules">hostAffinityRules</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList">ComputeInstancePlacementPolicyHostAffinityRulesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.hostAffinityRulesInput">hostAffinityRulesInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.placementGroupIdInput">placementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hostAffinityRules`<sup>Required</sup> <a name="hostAffinityRules" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.hostAffinityRules"></a>

```typescript
public readonly hostAffinityRules: ComputeInstancePlacementPolicyHostAffinityRulesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRulesList">ComputeInstancePlacementPolicyHostAffinityRulesList</a>

---

##### `hostAffinityRulesInput`<sup>Optional</sup> <a name="hostAffinityRulesInput" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.hostAffinityRulesInput"></a>

```typescript
public readonly hostAffinityRulesInput: IResolvable | ComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicyHostAffinityRules">ComputeInstancePlacementPolicyHostAffinityRules</a>[]

---

##### `placementGroupIdInput`<sup>Optional</sup> <a name="placementGroupIdInput" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.placementGroupIdInput"></a>

```typescript
public readonly placementGroupIdInput: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstancePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstancePlacementPolicy">ComputeInstancePlacementPolicy</a>

---


### ComputeInstanceResourcesOutputReference <a name="ComputeInstanceResourcesOutputReference" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceResourcesOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resetCoreFraction">resetCoreFraction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resetGpus">resetGpus</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCoreFraction` <a name="resetCoreFraction" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resetCoreFraction"></a>

```typescript
public resetCoreFraction(): void
```

##### `resetGpus` <a name="resetGpus" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.resetGpus"></a>

```typescript
public resetGpus(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coreFractionInput">coreFractionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coresInput">coresInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.gpusInput">gpusInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.memoryInput">memoryInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFractionInput`<sup>Optional</sup> <a name="coreFractionInput" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coreFractionInput"></a>

```typescript
public readonly coreFractionInput: number;
```

- *Type:* number

---

##### `coresInput`<sup>Optional</sup> <a name="coresInput" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* number

---

##### `gpusInput`<sup>Optional</sup> <a name="gpusInput" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.gpusInput"></a>

```typescript
public readonly gpusInput: number;
```

- *Type:* number

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* number

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceResources">ComputeInstanceResources</a>

---


### ComputeInstanceSchedulingPolicyOutputReference <a name="ComputeInstanceSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.resetPreemptible">resetPreemptible</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPreemptible` <a name="resetPreemptible" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.resetPreemptible"></a>

```typescript
public resetPreemptible(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.preemptibleInput">preemptibleInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptibleInput`<sup>Optional</sup> <a name="preemptibleInput" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.preemptibleInput"></a>

```typescript
public readonly preemptibleInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ComputeInstanceSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.ComputeInstanceSchedulingPolicy">ComputeInstanceSchedulingPolicy</a>

---


### ComputeInstanceSecondaryDiskList <a name="ComputeInstanceSecondaryDiskList" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer"></a>

```typescript
import { ComputeInstanceSecondaryDiskList } from '@cdktf/provider-yandex'

new ComputeInstanceSecondaryDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.get"></a>

```typescript
public get(index: number): ComputeInstanceSecondaryDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceSecondaryDisk[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>[]

---


### ComputeInstanceSecondaryDiskOutputReference <a name="ComputeInstanceSecondaryDiskOutputReference" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceSecondaryDiskOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceSecondaryDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetAutoDelete">resetAutoDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetDeviceName">resetDeviceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetMode">resetMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAutoDelete` <a name="resetAutoDelete" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetAutoDelete"></a>

```typescript
public resetAutoDelete(): void
```

##### `resetDeviceName` <a name="resetDeviceName" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetDeviceName"></a>

```typescript
public resetDeviceName(): void
```

##### `resetMode` <a name="resetMode" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.resetMode"></a>

```typescript
public resetMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.autoDeleteInput">autoDeleteInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.deviceNameInput">deviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.diskIdInput">diskIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.modeInput">modeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.autoDelete">autoDelete</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoDeleteInput`<sup>Optional</sup> <a name="autoDeleteInput" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.autoDeleteInput"></a>

```typescript
public readonly autoDeleteInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deviceNameInput`<sup>Optional</sup> <a name="deviceNameInput" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.deviceNameInput"></a>

```typescript
public readonly deviceNameInput: string;
```

- *Type:* string

---

##### `diskIdInput`<sup>Optional</sup> <a name="diskIdInput" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.diskIdInput"></a>

```typescript
public readonly diskIdInput: string;
```

- *Type:* string

---

##### `modeInput`<sup>Optional</sup> <a name="modeInput" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.modeInput"></a>

```typescript
public readonly modeInput: string;
```

- *Type:* string

---

##### `autoDelete`<sup>Required</sup> <a name="autoDelete" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.autoDelete"></a>

```typescript
public readonly autoDelete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceSecondaryDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceSecondaryDisk;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceSecondaryDisk">ComputeInstanceSecondaryDisk</a>

---


### ComputeInstanceTimeoutsOutputReference <a name="ComputeInstanceTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeInstanceTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeInstanceTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeInstanceTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeInstanceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeInstanceTimeouts">ComputeInstanceTimeouts</a>

---


### ComputePlacementGroupTimeoutsOutputReference <a name="ComputePlacementGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputePlacementGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputePlacementGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputePlacementGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputePlacementGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputePlacementGroupTimeouts">ComputePlacementGroupTimeouts</a>

---


### ComputeSnapshotTimeoutsOutputReference <a name="ComputeSnapshotTimeoutsOutputReference" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.Initializer"></a>

```typescript
import { ComputeSnapshotTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ComputeSnapshotTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ComputeSnapshotTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ComputeSnapshotTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ComputeSnapshotTimeouts">ComputeSnapshotTimeouts</a>

---


### ContainerRegistryTimeoutsOutputReference <a name="ContainerRegistryTimeoutsOutputReference" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.Initializer"></a>

```typescript
import { ContainerRegistryTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ContainerRegistryTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ContainerRegistryTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ContainerRegistryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ContainerRegistryTimeouts">ContainerRegistryTimeouts</a>

---


### ContainerRepositoryTimeoutsOutputReference <a name="ContainerRepositoryTimeoutsOutputReference" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.Initializer"></a>

```typescript
import { ContainerRepositoryTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ContainerRepositoryTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ContainerRepositoryTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ContainerRepositoryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ContainerRepositoryTimeouts">ContainerRepositoryTimeouts</a>

---


### DataprocClusterClusterConfigHadoopOutputReference <a name="DataprocClusterClusterConfigHadoopOutputReference" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigHadoopOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigHadoopOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetProperties">resetProperties</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetServices">resetServices</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetSshPublicKeys">resetSshPublicKeys</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetProperties` <a name="resetProperties" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetProperties"></a>

```typescript
public resetProperties(): void
```

##### `resetServices` <a name="resetServices" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetServices"></a>

```typescript
public resetServices(): void
```

##### `resetSshPublicKeys` <a name="resetSshPublicKeys" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.resetSshPublicKeys"></a>

```typescript
public resetSshPublicKeys(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.propertiesInput">propertiesInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.servicesInput">servicesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeysInput">sshPublicKeysInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.properties">properties</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.services">services</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeys">sshPublicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `propertiesInput`<sup>Optional</sup> <a name="propertiesInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.propertiesInput"></a>

```typescript
public readonly propertiesInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `servicesInput`<sup>Optional</sup> <a name="servicesInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.servicesInput"></a>

```typescript
public readonly servicesInput: string[];
```

- *Type:* string[]

---

##### `sshPublicKeysInput`<sup>Optional</sup> <a name="sshPublicKeysInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeysInput"></a>

```typescript
public readonly sshPublicKeysInput: string[];
```

- *Type:* string[]

---

##### `properties`<sup>Required</sup> <a name="properties" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `services`<sup>Required</sup> <a name="services" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.services"></a>

```typescript
public readonly services: string[];
```

- *Type:* string[]

---

##### `sshPublicKeys`<sup>Required</sup> <a name="sshPublicKeys" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeys"></a>

```typescript
public readonly sshPublicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataprocClusterClusterConfigHadoop;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a>

---


### DataprocClusterClusterConfigOutputReference <a name="DataprocClusterClusterConfigOutputReference" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putHadoop">putHadoop</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putSubclusterSpec">putSubclusterSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resetHadoop">resetHadoop</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resetVersionId">resetVersionId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHadoop` <a name="putHadoop" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putHadoop"></a>

```typescript
public putHadoop(value: DataprocClusterClusterConfigHadoop): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putHadoop.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a>

---

##### `putSubclusterSpec` <a name="putSubclusterSpec" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putSubclusterSpec"></a>

```typescript
public putSubclusterSpec(value: IResolvable | DataprocClusterClusterConfigSubclusterSpec[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.putSubclusterSpec.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]

---

##### `resetHadoop` <a name="resetHadoop" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resetHadoop"></a>

```typescript
public resetHadoop(): void
```

##### `resetVersionId` <a name="resetVersionId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.resetVersionId"></a>

```typescript
public resetVersionId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.hadoop">hadoop</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference">DataprocClusterClusterConfigHadoopOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.subclusterSpec">subclusterSpec</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList">DataprocClusterClusterConfigSubclusterSpecList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.hadoopInput">hadoopInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.subclusterSpecInput">subclusterSpecInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.versionIdInput">versionIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.versionId">versionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hadoop`<sup>Required</sup> <a name="hadoop" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.hadoop"></a>

```typescript
public readonly hadoop: DataprocClusterClusterConfigHadoopOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoopOutputReference">DataprocClusterClusterConfigHadoopOutputReference</a>

---

##### `subclusterSpec`<sup>Required</sup> <a name="subclusterSpec" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.subclusterSpec"></a>

```typescript
public readonly subclusterSpec: DataprocClusterClusterConfigSubclusterSpecList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList">DataprocClusterClusterConfigSubclusterSpecList</a>

---

##### `hadoopInput`<sup>Optional</sup> <a name="hadoopInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.hadoopInput"></a>

```typescript
public readonly hadoopInput: DataprocClusterClusterConfigHadoop;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigHadoop">DataprocClusterClusterConfigHadoop</a>

---

##### `subclusterSpecInput`<sup>Optional</sup> <a name="subclusterSpecInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.subclusterSpecInput"></a>

```typescript
public readonly subclusterSpecInput: IResolvable | DataprocClusterClusterConfigSubclusterSpec[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]

---

##### `versionIdInput`<sup>Optional</sup> <a name="versionIdInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.versionIdInput"></a>

```typescript
public readonly versionIdInput: string;
```

- *Type:* string

---

##### `versionId`<sup>Required</sup> <a name="versionId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataprocClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfig">DataprocClusterClusterConfig</a>

---


### DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference <a name="DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetCpuUtilizationTarget">resetCpuUtilizationTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetDecommissionTimeout">resetDecommissionTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetMeasurementDuration">resetMeasurementDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetPreemptible">resetPreemptible</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetStabilizationDuration">resetStabilizationDuration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetWarmupDuration">resetWarmupDuration</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCpuUtilizationTarget` <a name="resetCpuUtilizationTarget" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetCpuUtilizationTarget"></a>

```typescript
public resetCpuUtilizationTarget(): void
```

##### `resetDecommissionTimeout` <a name="resetDecommissionTimeout" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetDecommissionTimeout"></a>

```typescript
public resetDecommissionTimeout(): void
```

##### `resetMeasurementDuration` <a name="resetMeasurementDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetMeasurementDuration"></a>

```typescript
public resetMeasurementDuration(): void
```

##### `resetPreemptible` <a name="resetPreemptible" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetPreemptible"></a>

```typescript
public resetPreemptible(): void
```

##### `resetStabilizationDuration` <a name="resetStabilizationDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetStabilizationDuration"></a>

```typescript
public resetStabilizationDuration(): void
```

##### `resetWarmupDuration` <a name="resetWarmupDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resetWarmupDuration"></a>

```typescript
public resetWarmupDuration(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTargetInput">cpuUtilizationTargetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeoutInput">decommissionTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCountInput">maxHostsCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDurationInput">measurementDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptibleInput">preemptibleInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDurationInput">stabilizationDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDurationInput">warmupDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeout">decommissionTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCount">maxHostsCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cpuUtilizationTargetInput`<sup>Optional</sup> <a name="cpuUtilizationTargetInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTargetInput"></a>

```typescript
public readonly cpuUtilizationTargetInput: number;
```

- *Type:* number

---

##### `decommissionTimeoutInput`<sup>Optional</sup> <a name="decommissionTimeoutInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeoutInput"></a>

```typescript
public readonly decommissionTimeoutInput: number;
```

- *Type:* number

---

##### `maxHostsCountInput`<sup>Optional</sup> <a name="maxHostsCountInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCountInput"></a>

```typescript
public readonly maxHostsCountInput: number;
```

- *Type:* number

---

##### `measurementDurationInput`<sup>Optional</sup> <a name="measurementDurationInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDurationInput"></a>

```typescript
public readonly measurementDurationInput: number;
```

- *Type:* number

---

##### `preemptibleInput`<sup>Optional</sup> <a name="preemptibleInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptibleInput"></a>

```typescript
public readonly preemptibleInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `stabilizationDurationInput`<sup>Optional</sup> <a name="stabilizationDurationInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDurationInput"></a>

```typescript
public readonly stabilizationDurationInput: number;
```

- *Type:* number

---

##### `warmupDurationInput`<sup>Optional</sup> <a name="warmupDurationInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDurationInput"></a>

```typescript
public readonly warmupDurationInput: number;
```

- *Type:* number

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `decommissionTimeout`<sup>Required</sup> <a name="decommissionTimeout" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeout"></a>

```typescript
public readonly decommissionTimeout: number;
```

- *Type:* number

---

##### `maxHostsCount`<sup>Required</sup> <a name="maxHostsCount" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCount"></a>

```typescript
public readonly maxHostsCount: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a>

---


### DataprocClusterClusterConfigSubclusterSpecList <a name="DataprocClusterClusterConfigSubclusterSpecList" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecList } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigSubclusterSpecList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.get"></a>

```typescript
public get(index: number): DataprocClusterClusterConfigSubclusterSpecOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataprocClusterClusterConfigSubclusterSpec[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>[]

---


### DataprocClusterClusterConfigSubclusterSpecOutputReference <a name="DataprocClusterClusterConfigSubclusterSpecOutputReference" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigSubclusterSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putAutoscalingConfig">putAutoscalingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resetAutoscalingConfig">resetAutoscalingConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAutoscalingConfig` <a name="putAutoscalingConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putAutoscalingConfig"></a>

```typescript
public putAutoscalingConfig(value: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putAutoscalingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putResources"></a>

```typescript
public putResources(value: DataprocClusterClusterConfigSubclusterSpecResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a>

---

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetAutoscalingConfig` <a name="resetAutoscalingConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.resetAutoscalingConfig"></a>

```typescript
public resetAutoscalingConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfig">autoscalingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference">DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfigInput">autoscalingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCountInput">hostsCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCount">hostsCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoscalingConfig`<sup>Required</sup> <a name="autoscalingConfig" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfig"></a>

```typescript
public readonly autoscalingConfig: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference</a>

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.resources"></a>

```typescript
public readonly resources: DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference">DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference</a>

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `autoscalingConfigInput`<sup>Optional</sup> <a name="autoscalingConfigInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfigInput"></a>

```typescript
public readonly autoscalingConfigInput: DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a>

---

##### `hostsCountInput`<sup>Optional</sup> <a name="hostsCountInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCountInput"></a>

```typescript
public readonly hostsCountInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: DataprocClusterClusterConfigSubclusterSpecResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a>

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `hostsCount`<sup>Required</sup> <a name="hostsCount" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCount"></a>

```typescript
public readonly hostsCount: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataprocClusterClusterConfigSubclusterSpec;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpec">DataprocClusterClusterConfigSubclusterSpec</a>

---


### DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference <a name="DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer"></a>

```typescript
import { DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataprocClusterClusterConfigSubclusterSpecResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataprocClusterClusterConfigSubclusterSpecResources">DataprocClusterClusterConfigSubclusterSpecResources</a>

---


### DataprocClusterTimeoutsOutputReference <a name="DataprocClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { DataprocClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new DataprocClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataprocClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataprocClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataprocClusterTimeouts">DataprocClusterTimeouts</a>

---


### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.putTlsMode">putTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetHosts">resetHosts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetTlsMode">resetTlsMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTlsMode` <a name="putTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.putTlsMode"></a>

```typescript
public putTlsMode(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.putTlsMode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a>

---

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```

##### `resetHosts` <a name="resetHosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetHosts"></a>

```typescript
public resetHosts(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetTlsMode` <a name="resetTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.resetTlsMode"></a>

```typescript
public resetTlsMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.hostsInput">hostsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.tlsModeInput">tlsModeInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.hosts">hosts</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tlsMode`<sup>Required</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference</a>

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `hostsInput`<sup>Optional</sup> <a name="hostsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.hostsInput"></a>

```typescript
public readonly hostsInput: string[];
```

- *Type:* string[]

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `tlsModeInput`<sup>Optional</sup> <a name="tlsModeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.tlsModeInput"></a>

```typescript
public readonly tlsModeInput: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a>

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `hosts`<sup>Required</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a>

---


### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a>

---


### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a>

---


### DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference <a name="DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putDisabled">putDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putEnabled">putEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resetDisabled">resetDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDisabled` <a name="putDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putDisabled"></a>

```typescript
public putDisabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putDisabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a>

---

##### `putEnabled` <a name="putEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putEnabled"></a>

```typescript
public putEnabled(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.putEnabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a>

---

##### `resetDisabled` <a name="resetDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resetDisabled"></a>

```typescript
public resetDisabled(): void
```

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.disabledInput">disabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.enabledInput">enabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disabled`<sup>Required</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabledOutputReference</a>

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabledOutputReference</a>

---

##### `disabledInput`<sup>Optional</sup> <a name="disabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.disabledInput"></a>

```typescript
public readonly disabledInput: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeDisabled</a>

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeEnabled</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsModeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseTlsMode</a>

---


### DatatransferEndpointSettingsMysqlSourceConnectionOutputReference <a name="DatatransferEndpointSettingsMysqlSourceConnectionOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceConnectionOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceConnectionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.putOnPremise">putOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resetMdbClusterId">resetMdbClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resetOnPremise">resetOnPremise</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putOnPremise` <a name="putOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.putOnPremise"></a>

```typescript
public putOnPremise(value: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.putOnPremise.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a>

---

##### `resetMdbClusterId` <a name="resetMdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resetMdbClusterId"></a>

```typescript
public resetMdbClusterId(): void
```

##### `resetOnPremise` <a name="resetOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.resetOnPremise"></a>

```typescript
public resetOnPremise(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.mdbClusterIdInput">mdbClusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.onPremiseInput">onPremiseInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `onPremise`<sup>Required</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOnPremiseOutputReference</a>

---

##### `mdbClusterIdInput`<sup>Optional</sup> <a name="mdbClusterIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.mdbClusterIdInput"></a>

```typescript
public readonly mdbClusterIdInput: string;
```

- *Type:* string

---

##### `onPremiseInput`<sup>Optional</sup> <a name="onPremiseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.onPremiseInput"></a>

```typescript
public readonly onPremiseInput: DatatransferEndpointSettingsMysqlSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOnPremise">DatatransferEndpointSettingsMysqlSourceConnectionOnPremise</a>

---

##### `mdbClusterId`<sup>Required</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a>

---


### DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference <a name="DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetRoutine">resetRoutine</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetTrigger">resetTrigger</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetView">resetView</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRoutine` <a name="resetRoutine" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetRoutine"></a>

```typescript
public resetRoutine(): void
```

##### `resetTrigger` <a name="resetTrigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetTrigger"></a>

```typescript
public resetTrigger(): void
```

##### `resetView` <a name="resetView" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.resetView"></a>

```typescript
public resetView(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.routineInput">routineInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.triggerInput">triggerInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.viewInput">viewInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.routine">routine</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.trigger">trigger</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.view">view</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `routineInput`<sup>Optional</sup> <a name="routineInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.routineInput"></a>

```typescript
public readonly routineInput: string;
```

- *Type:* string

---

##### `triggerInput`<sup>Optional</sup> <a name="triggerInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.triggerInput"></a>

```typescript
public readonly triggerInput: string;
```

- *Type:* string

---

##### `viewInput`<sup>Optional</sup> <a name="viewInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.viewInput"></a>

```typescript
public readonly viewInput: string;
```

- *Type:* string

---

##### `routine`<sup>Required</sup> <a name="routine" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.routine"></a>

```typescript
public readonly routine: string;
```

- *Type:* string

---

##### `trigger`<sup>Required</sup> <a name="trigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.trigger"></a>

```typescript
public readonly trigger: string;
```

- *Type:* string

---

##### `view`<sup>Required</sup> <a name="view" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.view"></a>

```typescript
public readonly view: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a>

---


### DatatransferEndpointSettingsMysqlSourceOutputReference <a name="DatatransferEndpointSettingsMysqlSourceOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourceOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putConnection">putConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putObjectTransferSettings">putObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putPassword">putPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetConnection">resetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetDatabase">resetDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetExcludeTablesRegex">resetExcludeTablesRegex</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetIncludeTablesRegex">resetIncludeTablesRegex</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetObjectTransferSettings">resetObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetTimezone">resetTimezone</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetUser">resetUser</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConnection` <a name="putConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putConnection"></a>

```typescript
public putConnection(value: DatatransferEndpointSettingsMysqlSourceConnection): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putConnection.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a>

---

##### `putObjectTransferSettings` <a name="putObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putObjectTransferSettings"></a>

```typescript
public putObjectTransferSettings(value: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putObjectTransferSettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a>

---

##### `putPassword` <a name="putPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putPassword"></a>

```typescript
public putPassword(value: DatatransferEndpointSettingsMysqlSourcePassword): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.putPassword.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a>

---

##### `resetConnection` <a name="resetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetConnection"></a>

```typescript
public resetConnection(): void
```

##### `resetDatabase` <a name="resetDatabase" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetDatabase"></a>

```typescript
public resetDatabase(): void
```

##### `resetExcludeTablesRegex` <a name="resetExcludeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetExcludeTablesRegex"></a>

```typescript
public resetExcludeTablesRegex(): void
```

##### `resetIncludeTablesRegex` <a name="resetIncludeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetIncludeTablesRegex"></a>

```typescript
public resetIncludeTablesRegex(): void
```

##### `resetObjectTransferSettings` <a name="resetObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetObjectTransferSettings"></a>

```typescript
public resetObjectTransferSettings(): void
```

##### `resetPassword` <a name="resetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetTimezone` <a name="resetTimezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetTimezone"></a>

```typescript
public resetTimezone(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.resetUser"></a>

```typescript
public resetUser(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.objectTransferSettings">objectTransferSettings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference">DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference">DatatransferEndpointSettingsMysqlSourcePasswordOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.connectionInput">connectionInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.databaseInput">databaseInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.excludeTablesRegexInput">excludeTablesRegexInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.includeTablesRegexInput">includeTablesRegexInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.objectTransferSettingsInput">objectTransferSettingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.passwordInput">passwordInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.timezoneInput">timezoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.userInput">userInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.database">database</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.excludeTablesRegex">excludeTablesRegex</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.includeTablesRegex">includeTablesRegex</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.timezone">timezone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.user">user</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connection`<sup>Required</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsMysqlSourceConnectionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnectionOutputReference">DatatransferEndpointSettingsMysqlSourceConnectionOutputReference</a>

---

##### `objectTransferSettings`<sup>Required</sup> <a name="objectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.objectTransferSettings"></a>

```typescript
public readonly objectTransferSettings: DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference">DatatransferEndpointSettingsMysqlSourceObjectTransferSettingsOutputReference</a>

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsMysqlSourcePasswordOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference">DatatransferEndpointSettingsMysqlSourcePasswordOutputReference</a>

---

##### `connectionInput`<sup>Optional</sup> <a name="connectionInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.connectionInput"></a>

```typescript
public readonly connectionInput: DatatransferEndpointSettingsMysqlSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceConnection">DatatransferEndpointSettingsMysqlSourceConnection</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.databaseInput"></a>

```typescript
public readonly databaseInput: string;
```

- *Type:* string

---

##### `excludeTablesRegexInput`<sup>Optional</sup> <a name="excludeTablesRegexInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.excludeTablesRegexInput"></a>

```typescript
public readonly excludeTablesRegexInput: string[];
```

- *Type:* string[]

---

##### `includeTablesRegexInput`<sup>Optional</sup> <a name="includeTablesRegexInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.includeTablesRegexInput"></a>

```typescript
public readonly includeTablesRegexInput: string[];
```

- *Type:* string[]

---

##### `objectTransferSettingsInput`<sup>Optional</sup> <a name="objectTransferSettingsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.objectTransferSettingsInput"></a>

```typescript
public readonly objectTransferSettingsInput: DatatransferEndpointSettingsMysqlSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceObjectTransferSettings">DatatransferEndpointSettingsMysqlSourceObjectTransferSettings</a>

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: DatatransferEndpointSettingsMysqlSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a>

---

##### `timezoneInput`<sup>Optional</sup> <a name="timezoneInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.timezoneInput"></a>

```typescript
public readonly timezoneInput: string;
```

- *Type:* string

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.userInput"></a>

```typescript
public readonly userInput: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

---

##### `excludeTablesRegex`<sup>Required</sup> <a name="excludeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.excludeTablesRegex"></a>

```typescript
public readonly excludeTablesRegex: string[];
```

- *Type:* string[]

---

##### `includeTablesRegex`<sup>Required</sup> <a name="includeTablesRegex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.includeTablesRegex"></a>

```typescript
public readonly includeTablesRegex: string[];
```

- *Type:* string[]

---

##### `timezone`<sup>Required</sup> <a name="timezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a>

---


### DatatransferEndpointSettingsMysqlSourcePasswordOutputReference <a name="DatatransferEndpointSettingsMysqlSourcePasswordOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlSourcePasswordOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlSourcePasswordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.resetRaw">resetRaw</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRaw` <a name="resetRaw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.resetRaw"></a>

```typescript
public resetRaw(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.rawInput">rawInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.raw">raw</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `rawInput`<sup>Optional</sup> <a name="rawInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.rawInput"></a>

```typescript
public readonly rawInput: string;
```

- *Type:* string

---

##### `raw`<sup>Required</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePasswordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourcePassword">DatatransferEndpointSettingsMysqlSourcePassword</a>

---


### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.putTlsMode">putTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetHosts">resetHosts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetTlsMode">resetTlsMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTlsMode` <a name="putTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.putTlsMode"></a>

```typescript
public putTlsMode(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.putTlsMode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a>

---

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```

##### `resetHosts` <a name="resetHosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetHosts"></a>

```typescript
public resetHosts(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetTlsMode` <a name="resetTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.resetTlsMode"></a>

```typescript
public resetTlsMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.hostsInput">hostsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.tlsModeInput">tlsModeInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.hosts">hosts</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tlsMode`<sup>Required</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference</a>

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `hostsInput`<sup>Optional</sup> <a name="hostsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.hostsInput"></a>

```typescript
public readonly hostsInput: string[];
```

- *Type:* string[]

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `tlsModeInput`<sup>Optional</sup> <a name="tlsModeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.tlsModeInput"></a>

```typescript
public readonly tlsModeInput: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a>

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `hosts`<sup>Required</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a>

---


### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a>

---


### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a>

---


### DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference <a name="DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putDisabled">putDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putEnabled">putEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resetDisabled">resetDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDisabled` <a name="putDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putDisabled"></a>

```typescript
public putDisabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putDisabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a>

---

##### `putEnabled` <a name="putEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putEnabled"></a>

```typescript
public putEnabled(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.putEnabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a>

---

##### `resetDisabled` <a name="resetDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resetDisabled"></a>

```typescript
public resetDisabled(): void
```

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.disabledInput">disabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.enabledInput">enabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disabled`<sup>Required</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabledOutputReference</a>

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabledOutputReference</a>

---

##### `disabledInput`<sup>Optional</sup> <a name="disabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.disabledInput"></a>

```typescript
public readonly disabledInput: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeDisabled</a>

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeEnabled</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsModeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseTlsMode</a>

---


### DatatransferEndpointSettingsMysqlTargetConnectionOutputReference <a name="DatatransferEndpointSettingsMysqlTargetConnectionOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetConnectionOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetConnectionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.putOnPremise">putOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resetMdbClusterId">resetMdbClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resetOnPremise">resetOnPremise</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putOnPremise` <a name="putOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.putOnPremise"></a>

```typescript
public putOnPremise(value: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.putOnPremise.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a>

---

##### `resetMdbClusterId` <a name="resetMdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resetMdbClusterId"></a>

```typescript
public resetMdbClusterId(): void
```

##### `resetOnPremise` <a name="resetOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.resetOnPremise"></a>

```typescript
public resetOnPremise(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.mdbClusterIdInput">mdbClusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.onPremiseInput">onPremiseInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `onPremise`<sup>Required</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOnPremiseOutputReference</a>

---

##### `mdbClusterIdInput`<sup>Optional</sup> <a name="mdbClusterIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.mdbClusterIdInput"></a>

```typescript
public readonly mdbClusterIdInput: string;
```

- *Type:* string

---

##### `onPremiseInput`<sup>Optional</sup> <a name="onPremiseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.onPremiseInput"></a>

```typescript
public readonly onPremiseInput: DatatransferEndpointSettingsMysqlTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOnPremise">DatatransferEndpointSettingsMysqlTargetConnectionOnPremise</a>

---

##### `mdbClusterId`<sup>Required</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a>

---


### DatatransferEndpointSettingsMysqlTargetOutputReference <a name="DatatransferEndpointSettingsMysqlTargetOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putConnection">putConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putPassword">putPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetConnection">resetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetDatabase">resetDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetServiceSchema">resetServiceSchema</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetSkipConstraintChecks">resetSkipConstraintChecks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetSqlMode">resetSqlMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetTimezone">resetTimezone</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetUser">resetUser</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConnection` <a name="putConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putConnection"></a>

```typescript
public putConnection(value: DatatransferEndpointSettingsMysqlTargetConnection): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putConnection.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a>

---

##### `putPassword` <a name="putPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putPassword"></a>

```typescript
public putPassword(value: DatatransferEndpointSettingsMysqlTargetPassword): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.putPassword.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a>

---

##### `resetConnection` <a name="resetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetConnection"></a>

```typescript
public resetConnection(): void
```

##### `resetDatabase` <a name="resetDatabase" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetDatabase"></a>

```typescript
public resetDatabase(): void
```

##### `resetPassword` <a name="resetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetServiceSchema` <a name="resetServiceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetServiceSchema"></a>

```typescript
public resetServiceSchema(): void
```

##### `resetSkipConstraintChecks` <a name="resetSkipConstraintChecks" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetSkipConstraintChecks"></a>

```typescript
public resetSkipConstraintChecks(): void
```

##### `resetSqlMode` <a name="resetSqlMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetSqlMode"></a>

```typescript
public resetSqlMode(): void
```

##### `resetTimezone` <a name="resetTimezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetTimezone"></a>

```typescript
public resetTimezone(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.resetUser"></a>

```typescript
public resetUser(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference">DatatransferEndpointSettingsMysqlTargetPasswordOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.connectionInput">connectionInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.databaseInput">databaseInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.passwordInput">passwordInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.serviceSchemaInput">serviceSchemaInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.skipConstraintChecksInput">skipConstraintChecksInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.sqlModeInput">sqlModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.timezoneInput">timezoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.userInput">userInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.database">database</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.serviceSchema">serviceSchema</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.skipConstraintChecks">skipConstraintChecks</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.sqlMode">sqlMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.timezone">timezone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.user">user</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connection`<sup>Required</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsMysqlTargetConnectionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnectionOutputReference">DatatransferEndpointSettingsMysqlTargetConnectionOutputReference</a>

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsMysqlTargetPasswordOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference">DatatransferEndpointSettingsMysqlTargetPasswordOutputReference</a>

---

##### `connectionInput`<sup>Optional</sup> <a name="connectionInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.connectionInput"></a>

```typescript
public readonly connectionInput: DatatransferEndpointSettingsMysqlTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetConnection">DatatransferEndpointSettingsMysqlTargetConnection</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.databaseInput"></a>

```typescript
public readonly databaseInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: DatatransferEndpointSettingsMysqlTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a>

---

##### `serviceSchemaInput`<sup>Optional</sup> <a name="serviceSchemaInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.serviceSchemaInput"></a>

```typescript
public readonly serviceSchemaInput: string;
```

- *Type:* string

---

##### `skipConstraintChecksInput`<sup>Optional</sup> <a name="skipConstraintChecksInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.skipConstraintChecksInput"></a>

```typescript
public readonly skipConstraintChecksInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sqlModeInput`<sup>Optional</sup> <a name="sqlModeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.sqlModeInput"></a>

```typescript
public readonly sqlModeInput: string;
```

- *Type:* string

---

##### `timezoneInput`<sup>Optional</sup> <a name="timezoneInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.timezoneInput"></a>

```typescript
public readonly timezoneInput: string;
```

- *Type:* string

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.userInput"></a>

```typescript
public readonly userInput: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

---

##### `serviceSchema`<sup>Required</sup> <a name="serviceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.serviceSchema"></a>

```typescript
public readonly serviceSchema: string;
```

- *Type:* string

---

##### `skipConstraintChecks`<sup>Required</sup> <a name="skipConstraintChecks" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.skipConstraintChecks"></a>

```typescript
public readonly skipConstraintChecks: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sqlMode`<sup>Required</sup> <a name="sqlMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.sqlMode"></a>

```typescript
public readonly sqlMode: string;
```

- *Type:* string

---

##### `timezone`<sup>Required</sup> <a name="timezone" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a>

---


### DatatransferEndpointSettingsMysqlTargetPasswordOutputReference <a name="DatatransferEndpointSettingsMysqlTargetPasswordOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsMysqlTargetPasswordOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsMysqlTargetPasswordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.resetRaw">resetRaw</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRaw` <a name="resetRaw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.resetRaw"></a>

```typescript
public resetRaw(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.rawInput">rawInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.raw">raw</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `rawInput`<sup>Optional</sup> <a name="rawInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.rawInput"></a>

```typescript
public readonly rawInput: string;
```

- *Type:* string

---

##### `raw`<sup>Required</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPasswordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsMysqlTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetPassword">DatatransferEndpointSettingsMysqlTargetPassword</a>

---


### DatatransferEndpointSettingsOutputReference <a name="DatatransferEndpointSettingsOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlSource">putMysqlSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlTarget">putMysqlTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresSource">putPostgresSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresTarget">putPostgresTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetMysqlSource">resetMysqlSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetMysqlTarget">resetMysqlTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetPostgresSource">resetPostgresSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetPostgresTarget">resetPostgresTarget</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putMysqlSource` <a name="putMysqlSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlSource"></a>

```typescript
public putMysqlSource(value: DatatransferEndpointSettingsMysqlSource): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlSource.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a>

---

##### `putMysqlTarget` <a name="putMysqlTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlTarget"></a>

```typescript
public putMysqlTarget(value: DatatransferEndpointSettingsMysqlTarget): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putMysqlTarget.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a>

---

##### `putPostgresSource` <a name="putPostgresSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresSource"></a>

```typescript
public putPostgresSource(value: DatatransferEndpointSettingsPostgresSource): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresSource.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a>

---

##### `putPostgresTarget` <a name="putPostgresTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresTarget"></a>

```typescript
public putPostgresTarget(value: DatatransferEndpointSettingsPostgresTarget): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.putPostgresTarget.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a>

---

##### `resetMysqlSource` <a name="resetMysqlSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetMysqlSource"></a>

```typescript
public resetMysqlSource(): void
```

##### `resetMysqlTarget` <a name="resetMysqlTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetMysqlTarget"></a>

```typescript
public resetMysqlTarget(): void
```

##### `resetPostgresSource` <a name="resetPostgresSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetPostgresSource"></a>

```typescript
public resetPostgresSource(): void
```

##### `resetPostgresTarget` <a name="resetPostgresTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.resetPostgresTarget"></a>

```typescript
public resetPostgresTarget(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlSource">mysqlSource</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference">DatatransferEndpointSettingsMysqlSourceOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlTarget">mysqlTarget</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference">DatatransferEndpointSettingsMysqlTargetOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresSource">postgresSource</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference">DatatransferEndpointSettingsPostgresSourceOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresTarget">postgresTarget</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference">DatatransferEndpointSettingsPostgresTargetOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlSourceInput">mysqlSourceInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlTargetInput">mysqlTargetInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresSourceInput">postgresSourceInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresTargetInput">postgresTargetInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `mysqlSource`<sup>Required</sup> <a name="mysqlSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlSource"></a>

```typescript
public readonly mysqlSource: DatatransferEndpointSettingsMysqlSourceOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSourceOutputReference">DatatransferEndpointSettingsMysqlSourceOutputReference</a>

---

##### `mysqlTarget`<sup>Required</sup> <a name="mysqlTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlTarget"></a>

```typescript
public readonly mysqlTarget: DatatransferEndpointSettingsMysqlTargetOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTargetOutputReference">DatatransferEndpointSettingsMysqlTargetOutputReference</a>

---

##### `postgresSource`<sup>Required</sup> <a name="postgresSource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresSource"></a>

```typescript
public readonly postgresSource: DatatransferEndpointSettingsPostgresSourceOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference">DatatransferEndpointSettingsPostgresSourceOutputReference</a>

---

##### `postgresTarget`<sup>Required</sup> <a name="postgresTarget" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresTarget"></a>

```typescript
public readonly postgresTarget: DatatransferEndpointSettingsPostgresTargetOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference">DatatransferEndpointSettingsPostgresTargetOutputReference</a>

---

##### `mysqlSourceInput`<sup>Optional</sup> <a name="mysqlSourceInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlSourceInput"></a>

```typescript
public readonly mysqlSourceInput: DatatransferEndpointSettingsMysqlSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlSource">DatatransferEndpointSettingsMysqlSource</a>

---

##### `mysqlTargetInput`<sup>Optional</sup> <a name="mysqlTargetInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.mysqlTargetInput"></a>

```typescript
public readonly mysqlTargetInput: DatatransferEndpointSettingsMysqlTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsMysqlTarget">DatatransferEndpointSettingsMysqlTarget</a>

---

##### `postgresSourceInput`<sup>Optional</sup> <a name="postgresSourceInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresSourceInput"></a>

```typescript
public readonly postgresSourceInput: DatatransferEndpointSettingsPostgresSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a>

---

##### `postgresTargetInput`<sup>Optional</sup> <a name="postgresTargetInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.postgresTargetInput"></a>

```typescript
public readonly postgresTargetInput: DatatransferEndpointSettingsPostgresTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettings">DatatransferEndpointSettings</a>

---


### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.putTlsMode">putTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetHosts">resetHosts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetTlsMode">resetTlsMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTlsMode` <a name="putTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.putTlsMode"></a>

```typescript
public putTlsMode(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.putTlsMode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a>

---

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```

##### `resetHosts` <a name="resetHosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetHosts"></a>

```typescript
public resetHosts(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetTlsMode` <a name="resetTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.resetTlsMode"></a>

```typescript
public resetTlsMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.hostsInput">hostsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.tlsModeInput">tlsModeInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.hosts">hosts</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tlsMode`<sup>Required</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference</a>

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `hostsInput`<sup>Optional</sup> <a name="hostsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.hostsInput"></a>

```typescript
public readonly hostsInput: string[];
```

- *Type:* string[]

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `tlsModeInput`<sup>Optional</sup> <a name="tlsModeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.tlsModeInput"></a>

```typescript
public readonly tlsModeInput: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a>

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `hosts`<sup>Required</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a>

---


### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a>

---


### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a>

---


### DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference <a name="DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putDisabled">putDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putEnabled">putEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resetDisabled">resetDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDisabled` <a name="putDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putDisabled"></a>

```typescript
public putDisabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putDisabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a>

---

##### `putEnabled` <a name="putEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putEnabled"></a>

```typescript
public putEnabled(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.putEnabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a>

---

##### `resetDisabled` <a name="resetDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resetDisabled"></a>

```typescript
public resetDisabled(): void
```

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.disabledInput">disabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.enabledInput">enabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disabled`<sup>Required</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabledOutputReference</a>

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabledOutputReference</a>

---

##### `disabledInput`<sup>Optional</sup> <a name="disabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.disabledInput"></a>

```typescript
public readonly disabledInput: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeDisabled</a>

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeEnabled</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsModeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseTlsMode</a>

---


### DatatransferEndpointSettingsPostgresSourceConnectionOutputReference <a name="DatatransferEndpointSettingsPostgresSourceConnectionOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceConnectionOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceConnectionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.putOnPremise">putOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resetMdbClusterId">resetMdbClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resetOnPremise">resetOnPremise</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putOnPremise` <a name="putOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.putOnPremise"></a>

```typescript
public putOnPremise(value: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.putOnPremise.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a>

---

##### `resetMdbClusterId` <a name="resetMdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resetMdbClusterId"></a>

```typescript
public resetMdbClusterId(): void
```

##### `resetOnPremise` <a name="resetOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.resetOnPremise"></a>

```typescript
public resetOnPremise(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.mdbClusterIdInput">mdbClusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.onPremiseInput">onPremiseInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `onPremise`<sup>Required</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOnPremiseOutputReference</a>

---

##### `mdbClusterIdInput`<sup>Optional</sup> <a name="mdbClusterIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.mdbClusterIdInput"></a>

```typescript
public readonly mdbClusterIdInput: string;
```

- *Type:* string

---

##### `onPremiseInput`<sup>Optional</sup> <a name="onPremiseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.onPremiseInput"></a>

```typescript
public readonly onPremiseInput: DatatransferEndpointSettingsPostgresSourceConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOnPremise">DatatransferEndpointSettingsPostgresSourceConnectionOnPremise</a>

---

##### `mdbClusterId`<sup>Required</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a>

---


### DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference <a name="DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetCast">resetCast</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetCollation">resetCollation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetConstraint">resetConstraint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetDefaultValues">resetDefaultValues</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetFkConstraint">resetFkConstraint</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetFunction">resetFunction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetIndex">resetIndex</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetPolicy">resetPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetPrimaryKey">resetPrimaryKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetRule">resetRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetSequence">resetSequence</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetSequenceOwnedBy">resetSequenceOwnedBy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetTable">resetTable</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetTrigger">resetTrigger</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetType">resetType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetView">resetView</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCast` <a name="resetCast" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetCast"></a>

```typescript
public resetCast(): void
```

##### `resetCollation` <a name="resetCollation" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetCollation"></a>

```typescript
public resetCollation(): void
```

##### `resetConstraint` <a name="resetConstraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetConstraint"></a>

```typescript
public resetConstraint(): void
```

##### `resetDefaultValues` <a name="resetDefaultValues" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetDefaultValues"></a>

```typescript
public resetDefaultValues(): void
```

##### `resetFkConstraint` <a name="resetFkConstraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetFkConstraint"></a>

```typescript
public resetFkConstraint(): void
```

##### `resetFunction` <a name="resetFunction" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetFunction"></a>

```typescript
public resetFunction(): void
```

##### `resetIndex` <a name="resetIndex" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetIndex"></a>

```typescript
public resetIndex(): void
```

##### `resetPolicy` <a name="resetPolicy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetPolicy"></a>

```typescript
public resetPolicy(): void
```

##### `resetPrimaryKey` <a name="resetPrimaryKey" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetPrimaryKey"></a>

```typescript
public resetPrimaryKey(): void
```

##### `resetRule` <a name="resetRule" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetRule"></a>

```typescript
public resetRule(): void
```

##### `resetSequence` <a name="resetSequence" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetSequence"></a>

```typescript
public resetSequence(): void
```

##### `resetSequenceOwnedBy` <a name="resetSequenceOwnedBy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetSequenceOwnedBy"></a>

```typescript
public resetSequenceOwnedBy(): void
```

##### `resetTable` <a name="resetTable" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetTable"></a>

```typescript
public resetTable(): void
```

##### `resetTrigger` <a name="resetTrigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetTrigger"></a>

```typescript
public resetTrigger(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetType"></a>

```typescript
public resetType(): void
```

##### `resetView` <a name="resetView" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.resetView"></a>

```typescript
public resetView(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.castInput">castInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.collationInput">collationInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.constraintInput">constraintInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.defaultValuesInput">defaultValuesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fkConstraintInput">fkConstraintInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.functionInput">functionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.indexInput">indexInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.policyInput">policyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.primaryKeyInput">primaryKeyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.ruleInput">ruleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceInput">sequenceInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceOwnedByInput">sequenceOwnedByInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.tableInput">tableInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.triggerInput">triggerInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.viewInput">viewInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.cast">cast</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.collation">collation</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.constraint">constraint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.defaultValues">defaultValues</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fkConstraint">fkConstraint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.function">function</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.index">index</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.policy">policy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.primaryKey">primaryKey</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.rule">rule</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequence">sequence</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceOwnedBy">sequenceOwnedBy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.table">table</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.trigger">trigger</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.view">view</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `castInput`<sup>Optional</sup> <a name="castInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.castInput"></a>

```typescript
public readonly castInput: string;
```

- *Type:* string

---

##### `collationInput`<sup>Optional</sup> <a name="collationInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.collationInput"></a>

```typescript
public readonly collationInput: string;
```

- *Type:* string

---

##### `constraintInput`<sup>Optional</sup> <a name="constraintInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.constraintInput"></a>

```typescript
public readonly constraintInput: string;
```

- *Type:* string

---

##### `defaultValuesInput`<sup>Optional</sup> <a name="defaultValuesInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.defaultValuesInput"></a>

```typescript
public readonly defaultValuesInput: string;
```

- *Type:* string

---

##### `fkConstraintInput`<sup>Optional</sup> <a name="fkConstraintInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fkConstraintInput"></a>

```typescript
public readonly fkConstraintInput: string;
```

- *Type:* string

---

##### `functionInput`<sup>Optional</sup> <a name="functionInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.functionInput"></a>

```typescript
public readonly functionInput: string;
```

- *Type:* string

---

##### `indexInput`<sup>Optional</sup> <a name="indexInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.indexInput"></a>

```typescript
public readonly indexInput: string;
```

- *Type:* string

---

##### `policyInput`<sup>Optional</sup> <a name="policyInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.policyInput"></a>

```typescript
public readonly policyInput: string;
```

- *Type:* string

---

##### `primaryKeyInput`<sup>Optional</sup> <a name="primaryKeyInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.primaryKeyInput"></a>

```typescript
public readonly primaryKeyInput: string;
```

- *Type:* string

---

##### `ruleInput`<sup>Optional</sup> <a name="ruleInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.ruleInput"></a>

```typescript
public readonly ruleInput: string;
```

- *Type:* string

---

##### `sequenceInput`<sup>Optional</sup> <a name="sequenceInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceInput"></a>

```typescript
public readonly sequenceInput: string;
```

- *Type:* string

---

##### `sequenceOwnedByInput`<sup>Optional</sup> <a name="sequenceOwnedByInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceOwnedByInput"></a>

```typescript
public readonly sequenceOwnedByInput: string;
```

- *Type:* string

---

##### `tableInput`<sup>Optional</sup> <a name="tableInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.tableInput"></a>

```typescript
public readonly tableInput: string;
```

- *Type:* string

---

##### `triggerInput`<sup>Optional</sup> <a name="triggerInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.triggerInput"></a>

```typescript
public readonly triggerInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `viewInput`<sup>Optional</sup> <a name="viewInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.viewInput"></a>

```typescript
public readonly viewInput: string;
```

- *Type:* string

---

##### `cast`<sup>Required</sup> <a name="cast" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.cast"></a>

```typescript
public readonly cast: string;
```

- *Type:* string

---

##### `collation`<sup>Required</sup> <a name="collation" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.collation"></a>

```typescript
public readonly collation: string;
```

- *Type:* string

---

##### `constraint`<sup>Required</sup> <a name="constraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.constraint"></a>

```typescript
public readonly constraint: string;
```

- *Type:* string

---

##### `defaultValues`<sup>Required</sup> <a name="defaultValues" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.defaultValues"></a>

```typescript
public readonly defaultValues: string;
```

- *Type:* string

---

##### `fkConstraint`<sup>Required</sup> <a name="fkConstraint" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.fkConstraint"></a>

```typescript
public readonly fkConstraint: string;
```

- *Type:* string

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.function"></a>

```typescript
public readonly function: string;
```

- *Type:* string

---

##### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.index"></a>

```typescript
public readonly index: string;
```

- *Type:* string

---

##### `policy`<sup>Required</sup> <a name="policy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.policy"></a>

```typescript
public readonly policy: string;
```

- *Type:* string

---

##### `primaryKey`<sup>Required</sup> <a name="primaryKey" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.primaryKey"></a>

```typescript
public readonly primaryKey: string;
```

- *Type:* string

---

##### `rule`<sup>Required</sup> <a name="rule" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.rule"></a>

```typescript
public readonly rule: string;
```

- *Type:* string

---

##### `sequence`<sup>Required</sup> <a name="sequence" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequence"></a>

```typescript
public readonly sequence: string;
```

- *Type:* string

---

##### `sequenceOwnedBy`<sup>Required</sup> <a name="sequenceOwnedBy" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.sequenceOwnedBy"></a>

```typescript
public readonly sequenceOwnedBy: string;
```

- *Type:* string

---

##### `table`<sup>Required</sup> <a name="table" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.table"></a>

```typescript
public readonly table: string;
```

- *Type:* string

---

##### `trigger`<sup>Required</sup> <a name="trigger" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.trigger"></a>

```typescript
public readonly trigger: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `view`<sup>Required</sup> <a name="view" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.view"></a>

```typescript
public readonly view: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a>

---


### DatatransferEndpointSettingsPostgresSourceOutputReference <a name="DatatransferEndpointSettingsPostgresSourceOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourceOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putConnection">putConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putObjectTransferSettings">putObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putPassword">putPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetCollapseInheritTable">resetCollapseInheritTable</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetConnection">resetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetDatabase">resetDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetExcludeTables">resetExcludeTables</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetIncludeTables">resetIncludeTables</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetObjectTransferSettings">resetObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetServiceSchema">resetServiceSchema</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetSlotGigabyteLagLimit">resetSlotGigabyteLagLimit</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetUser">resetUser</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConnection` <a name="putConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putConnection"></a>

```typescript
public putConnection(value: DatatransferEndpointSettingsPostgresSourceConnection): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putConnection.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a>

---

##### `putObjectTransferSettings` <a name="putObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putObjectTransferSettings"></a>

```typescript
public putObjectTransferSettings(value: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putObjectTransferSettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a>

---

##### `putPassword` <a name="putPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putPassword"></a>

```typescript
public putPassword(value: DatatransferEndpointSettingsPostgresSourcePassword): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.putPassword.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a>

---

##### `resetCollapseInheritTable` <a name="resetCollapseInheritTable" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetCollapseInheritTable"></a>

```typescript
public resetCollapseInheritTable(): void
```

##### `resetConnection` <a name="resetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetConnection"></a>

```typescript
public resetConnection(): void
```

##### `resetDatabase` <a name="resetDatabase" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetDatabase"></a>

```typescript
public resetDatabase(): void
```

##### `resetExcludeTables` <a name="resetExcludeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetExcludeTables"></a>

```typescript
public resetExcludeTables(): void
```

##### `resetIncludeTables` <a name="resetIncludeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetIncludeTables"></a>

```typescript
public resetIncludeTables(): void
```

##### `resetObjectTransferSettings` <a name="resetObjectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetObjectTransferSettings"></a>

```typescript
public resetObjectTransferSettings(): void
```

##### `resetPassword` <a name="resetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetServiceSchema` <a name="resetServiceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetServiceSchema"></a>

```typescript
public resetServiceSchema(): void
```

##### `resetSlotGigabyteLagLimit` <a name="resetSlotGigabyteLagLimit" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetSlotGigabyteLagLimit"></a>

```typescript
public resetSlotGigabyteLagLimit(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.resetUser"></a>

```typescript
public resetUser(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.objectTransferSettings">objectTransferSettings</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference">DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference">DatatransferEndpointSettingsPostgresSourcePasswordOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.collapseInheritTableInput">collapseInheritTableInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.connectionInput">connectionInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.databaseInput">databaseInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.excludeTablesInput">excludeTablesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.includeTablesInput">includeTablesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.objectTransferSettingsInput">objectTransferSettingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.passwordInput">passwordInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.serviceSchemaInput">serviceSchemaInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.slotGigabyteLagLimitInput">slotGigabyteLagLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.userInput">userInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.collapseInheritTable">collapseInheritTable</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.database">database</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.excludeTables">excludeTables</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.includeTables">includeTables</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.serviceSchema">serviceSchema</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.slotGigabyteLagLimit">slotGigabyteLagLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.user">user</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connection`<sup>Required</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsPostgresSourceConnectionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnectionOutputReference">DatatransferEndpointSettingsPostgresSourceConnectionOutputReference</a>

---

##### `objectTransferSettings`<sup>Required</sup> <a name="objectTransferSettings" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.objectTransferSettings"></a>

```typescript
public readonly objectTransferSettings: DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference">DatatransferEndpointSettingsPostgresSourceObjectTransferSettingsOutputReference</a>

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsPostgresSourcePasswordOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference">DatatransferEndpointSettingsPostgresSourcePasswordOutputReference</a>

---

##### `collapseInheritTableInput`<sup>Optional</sup> <a name="collapseInheritTableInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.collapseInheritTableInput"></a>

```typescript
public readonly collapseInheritTableInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `connectionInput`<sup>Optional</sup> <a name="connectionInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.connectionInput"></a>

```typescript
public readonly connectionInput: DatatransferEndpointSettingsPostgresSourceConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceConnection">DatatransferEndpointSettingsPostgresSourceConnection</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.databaseInput"></a>

```typescript
public readonly databaseInput: string;
```

- *Type:* string

---

##### `excludeTablesInput`<sup>Optional</sup> <a name="excludeTablesInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.excludeTablesInput"></a>

```typescript
public readonly excludeTablesInput: string[];
```

- *Type:* string[]

---

##### `includeTablesInput`<sup>Optional</sup> <a name="includeTablesInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.includeTablesInput"></a>

```typescript
public readonly includeTablesInput: string[];
```

- *Type:* string[]

---

##### `objectTransferSettingsInput`<sup>Optional</sup> <a name="objectTransferSettingsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.objectTransferSettingsInput"></a>

```typescript
public readonly objectTransferSettingsInput: DatatransferEndpointSettingsPostgresSourceObjectTransferSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceObjectTransferSettings">DatatransferEndpointSettingsPostgresSourceObjectTransferSettings</a>

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: DatatransferEndpointSettingsPostgresSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a>

---

##### `serviceSchemaInput`<sup>Optional</sup> <a name="serviceSchemaInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.serviceSchemaInput"></a>

```typescript
public readonly serviceSchemaInput: string;
```

- *Type:* string

---

##### `slotGigabyteLagLimitInput`<sup>Optional</sup> <a name="slotGigabyteLagLimitInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.slotGigabyteLagLimitInput"></a>

```typescript
public readonly slotGigabyteLagLimitInput: number;
```

- *Type:* number

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.userInput"></a>

```typescript
public readonly userInput: string;
```

- *Type:* string

---

##### `collapseInheritTable`<sup>Required</sup> <a name="collapseInheritTable" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.collapseInheritTable"></a>

```typescript
public readonly collapseInheritTable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

---

##### `excludeTables`<sup>Required</sup> <a name="excludeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.excludeTables"></a>

```typescript
public readonly excludeTables: string[];
```

- *Type:* string[]

---

##### `includeTables`<sup>Required</sup> <a name="includeTables" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.includeTables"></a>

```typescript
public readonly includeTables: string[];
```

- *Type:* string[]

---

##### `serviceSchema`<sup>Required</sup> <a name="serviceSchema" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.serviceSchema"></a>

```typescript
public readonly serviceSchema: string;
```

- *Type:* string

---

##### `slotGigabyteLagLimit`<sup>Required</sup> <a name="slotGigabyteLagLimit" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.slotGigabyteLagLimit"></a>

```typescript
public readonly slotGigabyteLagLimit: number;
```

- *Type:* number

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSource;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSource">DatatransferEndpointSettingsPostgresSource</a>

---


### DatatransferEndpointSettingsPostgresSourcePasswordOutputReference <a name="DatatransferEndpointSettingsPostgresSourcePasswordOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresSourcePasswordOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresSourcePasswordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.resetRaw">resetRaw</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRaw` <a name="resetRaw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.resetRaw"></a>

```typescript
public resetRaw(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.rawInput">rawInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.raw">raw</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `rawInput`<sup>Optional</sup> <a name="rawInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.rawInput"></a>

```typescript
public readonly rawInput: string;
```

- *Type:* string

---

##### `raw`<sup>Required</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePasswordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresSourcePassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresSourcePassword">DatatransferEndpointSettingsPostgresSourcePassword</a>

---


### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.putTlsMode">putTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetHosts">resetHosts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetTlsMode">resetTlsMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTlsMode` <a name="putTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.putTlsMode"></a>

```typescript
public putTlsMode(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.putTlsMode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a>

---

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```

##### `resetHosts` <a name="resetHosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetHosts"></a>

```typescript
public resetHosts(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetTlsMode` <a name="resetTlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.resetTlsMode"></a>

```typescript
public resetTlsMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.tlsMode">tlsMode</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.hostsInput">hostsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.tlsModeInput">tlsModeInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.hosts">hosts</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tlsMode`<sup>Required</sup> <a name="tlsMode" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.tlsMode"></a>

```typescript
public readonly tlsMode: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference</a>

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `hostsInput`<sup>Optional</sup> <a name="hostsInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.hostsInput"></a>

```typescript
public readonly hostsInput: string[];
```

- *Type:* string[]

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `tlsModeInput`<sup>Optional</sup> <a name="tlsModeInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.tlsModeInput"></a>

```typescript
public readonly tlsModeInput: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a>

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `hosts`<sup>Required</sup> <a name="hosts" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a>

---


### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a>

---


### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate">resetCaCertificate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCaCertificate` <a name="resetCaCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.resetCaCertificate"></a>

```typescript
public resetCaCertificate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput">caCertificateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate">caCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `caCertificateInput`<sup>Optional</sup> <a name="caCertificateInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificateInput"></a>

```typescript
public readonly caCertificateInput: string;
```

- *Type:* string

---

##### `caCertificate`<sup>Required</sup> <a name="caCertificate" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.caCertificate"></a>

```typescript
public readonly caCertificate: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a>

---


### DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference <a name="DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putDisabled">putDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putEnabled">putEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resetDisabled">resetDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDisabled` <a name="putDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putDisabled"></a>

```typescript
public putDisabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putDisabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a>

---

##### `putEnabled` <a name="putEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putEnabled"></a>

```typescript
public putEnabled(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.putEnabled.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a>

---

##### `resetDisabled` <a name="resetDisabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resetDisabled"></a>

```typescript
public resetDisabled(): void
```

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.disabled">disabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.enabled">enabled</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.disabledInput">disabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.enabledInput">enabledInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disabled`<sup>Required</sup> <a name="disabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.disabled"></a>

```typescript
public readonly disabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabledOutputReference</a>

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.enabled"></a>

```typescript
public readonly enabled: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabledOutputReference</a>

---

##### `disabledInput`<sup>Optional</sup> <a name="disabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.disabledInput"></a>

```typescript
public readonly disabledInput: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeDisabled</a>

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeEnabled</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsModeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseTlsMode</a>

---


### DatatransferEndpointSettingsPostgresTargetConnectionOutputReference <a name="DatatransferEndpointSettingsPostgresTargetConnectionOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetConnectionOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetConnectionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.putOnPremise">putOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resetMdbClusterId">resetMdbClusterId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resetOnPremise">resetOnPremise</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putOnPremise` <a name="putOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.putOnPremise"></a>

```typescript
public putOnPremise(value: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.putOnPremise.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a>

---

##### `resetMdbClusterId` <a name="resetMdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resetMdbClusterId"></a>

```typescript
public resetMdbClusterId(): void
```

##### `resetOnPremise` <a name="resetOnPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.resetOnPremise"></a>

```typescript
public resetOnPremise(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.onPremise">onPremise</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.mdbClusterIdInput">mdbClusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.onPremiseInput">onPremiseInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.mdbClusterId">mdbClusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `onPremise`<sup>Required</sup> <a name="onPremise" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.onPremise"></a>

```typescript
public readonly onPremise: DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOnPremiseOutputReference</a>

---

##### `mdbClusterIdInput`<sup>Optional</sup> <a name="mdbClusterIdInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.mdbClusterIdInput"></a>

```typescript
public readonly mdbClusterIdInput: string;
```

- *Type:* string

---

##### `onPremiseInput`<sup>Optional</sup> <a name="onPremiseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.onPremiseInput"></a>

```typescript
public readonly onPremiseInput: DatatransferEndpointSettingsPostgresTargetConnectionOnPremise;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOnPremise">DatatransferEndpointSettingsPostgresTargetConnectionOnPremise</a>

---

##### `mdbClusterId`<sup>Required</sup> <a name="mdbClusterId" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.mdbClusterId"></a>

```typescript
public readonly mdbClusterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a>

---


### DatatransferEndpointSettingsPostgresTargetOutputReference <a name="DatatransferEndpointSettingsPostgresTargetOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putConnection">putConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putPassword">putPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetConnection">resetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetDatabase">resetDatabase</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetUser">resetUser</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConnection` <a name="putConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putConnection"></a>

```typescript
public putConnection(value: DatatransferEndpointSettingsPostgresTargetConnection): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putConnection.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a>

---

##### `putPassword` <a name="putPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putPassword"></a>

```typescript
public putPassword(value: DatatransferEndpointSettingsPostgresTargetPassword): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.putPassword.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a>

---

##### `resetConnection` <a name="resetConnection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetConnection"></a>

```typescript
public resetConnection(): void
```

##### `resetDatabase` <a name="resetDatabase" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetDatabase"></a>

```typescript
public resetDatabase(): void
```

##### `resetPassword` <a name="resetPassword" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetUser` <a name="resetUser" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.resetUser"></a>

```typescript
public resetUser(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.connection">connection</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.password">password</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference">DatatransferEndpointSettingsPostgresTargetPasswordOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.connectionInput">connectionInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.databaseInput">databaseInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.passwordInput">passwordInput</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.userInput">userInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.database">database</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.user">user</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connection`<sup>Required</sup> <a name="connection" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.connection"></a>

```typescript
public readonly connection: DatatransferEndpointSettingsPostgresTargetConnectionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnectionOutputReference">DatatransferEndpointSettingsPostgresTargetConnectionOutputReference</a>

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.password"></a>

```typescript
public readonly password: DatatransferEndpointSettingsPostgresTargetPasswordOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference">DatatransferEndpointSettingsPostgresTargetPasswordOutputReference</a>

---

##### `connectionInput`<sup>Optional</sup> <a name="connectionInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.connectionInput"></a>

```typescript
public readonly connectionInput: DatatransferEndpointSettingsPostgresTargetConnection;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetConnection">DatatransferEndpointSettingsPostgresTargetConnection</a>

---

##### `databaseInput`<sup>Optional</sup> <a name="databaseInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.databaseInput"></a>

```typescript
public readonly databaseInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: DatatransferEndpointSettingsPostgresTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a>

---

##### `userInput`<sup>Optional</sup> <a name="userInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.userInput"></a>

```typescript
public readonly userInput: string;
```

- *Type:* string

---

##### `database`<sup>Required</sup> <a name="database" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.database"></a>

```typescript
public readonly database: string;
```

- *Type:* string

---

##### `user`<sup>Required</sup> <a name="user" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTarget">DatatransferEndpointSettingsPostgresTarget</a>

---


### DatatransferEndpointSettingsPostgresTargetPasswordOutputReference <a name="DatatransferEndpointSettingsPostgresTargetPasswordOutputReference" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.Initializer"></a>

```typescript
import { DatatransferEndpointSettingsPostgresTargetPasswordOutputReference } from '@cdktf/provider-yandex'

new DatatransferEndpointSettingsPostgresTargetPasswordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.resetRaw">resetRaw</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRaw` <a name="resetRaw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.resetRaw"></a>

```typescript
public resetRaw(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.rawInput">rawInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.raw">raw</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `rawInput`<sup>Optional</sup> <a name="rawInput" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.rawInput"></a>

```typescript
public readonly rawInput: string;
```

- *Type:* string

---

##### `raw`<sup>Required</sup> <a name="raw" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.raw"></a>

```typescript
public readonly raw: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPasswordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DatatransferEndpointSettingsPostgresTargetPassword;
```

- *Type:* <a href="#@cdktf/provider-yandex.DatatransferEndpointSettingsPostgresTargetPassword">DatatransferEndpointSettingsPostgresTargetPassword</a>

---


### DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---


### DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---


### DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a>

---


### DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheckStreamHealthcheck</a>

---


### DataYandexAlbBackendGroupGrpcBackendList <a name="DataYandexAlbBackendGroupGrpcBackendList" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendList } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.get"></a>

```typescript
public get(index: number): DataYandexAlbBackendGroupGrpcBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupGrpcBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>[]

---


### DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---


### DataYandexAlbBackendGroupGrpcBackendOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: DataYandexAlbBackendGroupGrpcBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putTls"></a>

```typescript
public putTls(value: DataYandexAlbBackendGroupGrpcBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference">DataYandexAlbBackendGroupGrpcBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference">DataYandexAlbBackendGroupGrpcBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfigOutputReference</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupGrpcBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference">DataYandexAlbBackendGroupGrpcBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: DataYandexAlbBackendGroupGrpcBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendHealthcheck">DataYandexAlbBackendGroupGrpcBackendHealthcheck</a>

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig">DataYandexAlbBackendGroupGrpcBackendLoadBalancingConfig</a>

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: DataYandexAlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupGrpcBackend;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackend">DataYandexAlbBackendGroupGrpcBackend</a>

---


### DataYandexAlbBackendGroupGrpcBackendTlsOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendTlsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendTlsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTls">DataYandexAlbBackendGroupGrpcBackendTls</a>

---


### DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference <a name="DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupGrpcBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupGrpcBackendTlsValidationContext">DataYandexAlbBackendGroupGrpcBackendTlsValidationContext</a>

---


### DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---


### DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---


### DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a>

---


### DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference <a name="DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheckStreamHealthcheck</a>

---


### DataYandexAlbBackendGroupHttpBackendList <a name="DataYandexAlbBackendGroupHttpBackendList" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendList } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.get"></a>

```typescript
public get(index: number): DataYandexAlbBackendGroupHttpBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupHttpBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>[]

---


### DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference <a name="DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a>

---


### DataYandexAlbBackendGroupHttpBackendOutputReference <a name="DataYandexAlbBackendGroupHttpBackendOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetStorageBucket">resetStorageBucket</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetTargetGroupIds">resetTargetGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: DataYandexAlbBackendGroupHttpBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putTls"></a>

```typescript
public putTls(value: DataYandexAlbBackendGroupHttpBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetStorageBucket` <a name="resetStorageBucket" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetStorageBucket"></a>

```typescript
public resetStorageBucket(): void
```

##### `resetTargetGroupIds` <a name="resetTargetGroupIds" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetTargetGroupIds"></a>

```typescript
public resetTargetGroupIds(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference">DataYandexAlbBackendGroupHttpBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.storageBucketInput">storageBucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.targetGroupIdsInput">targetGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.storageBucket">storageBucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference">DataYandexAlbBackendGroupHttpBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfigOutputReference</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupHttpBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference">DataYandexAlbBackendGroupHttpBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: DataYandexAlbBackendGroupHttpBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendHealthcheck">DataYandexAlbBackendGroupHttpBackendHealthcheck</a>

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig">DataYandexAlbBackendGroupHttpBackendLoadBalancingConfig</a>

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `storageBucketInput`<sup>Optional</sup> <a name="storageBucketInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.storageBucketInput"></a>

```typescript
public readonly storageBucketInput: string;
```

- *Type:* string

---

##### `targetGroupIdsInput`<sup>Optional</sup> <a name="targetGroupIdsInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.targetGroupIdsInput"></a>

```typescript
public readonly targetGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: DataYandexAlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `storageBucket`<sup>Required</sup> <a name="storageBucket" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.storageBucket"></a>

```typescript
public readonly storageBucket: string;
```

- *Type:* string

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupHttpBackend;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackend">DataYandexAlbBackendGroupHttpBackend</a>

---


### DataYandexAlbBackendGroupHttpBackendTlsOutputReference <a name="DataYandexAlbBackendGroupHttpBackendTlsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendTlsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: DataYandexAlbBackendGroupHttpBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: DataYandexAlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTls">DataYandexAlbBackendGroupHttpBackendTls</a>

---


### DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference <a name="DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupHttpBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupHttpBackendTlsValidationContext">DataYandexAlbBackendGroupHttpBackendTlsValidationContext</a>

---


### DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName">resetServiceName</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetServiceName` <a name="resetServiceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.resetServiceName"></a>

```typescript
public resetServiceName(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput">serviceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName">serviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `serviceNameInput`<sup>Optional</sup> <a name="serviceNameInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceNameInput"></a>

```typescript
public readonly serviceNameInput: string;
```

- *Type:* string

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---


### DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHost">resetHost</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2">resetHttp2</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHost` <a name="resetHost" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHost"></a>

```typescript
public resetHost(): void
```

##### `resetHttp2` <a name="resetHttp2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.resetHttp2"></a>

```typescript
public resetHttp2(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput">hostInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input">http2Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.host">host</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2">http2</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `hostInput`<sup>Optional</sup> <a name="hostInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.hostInput"></a>

```typescript
public readonly hostInput: string;
```

- *Type:* string

---

##### `http2Input`<sup>Optional</sup> <a name="http2Input" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2Input"></a>

```typescript
public readonly http2Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `host`<sup>Required</sup> <a name="host" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

---

##### `http2`<sup>Required</sup> <a name="http2" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.http2"></a>

```typescript
public readonly http2: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---


### DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck">putGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck">putHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck">putStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetGrpcHealthcheck">resetGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthcheckPort">resetHealthcheckPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHttpHealthcheck">resetHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetIntervalJitterPercent">resetIntervalJitterPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetStreamHealthcheck">resetStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putGrpcHealthcheck` <a name="putGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck"></a>

```typescript
public putGrpcHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putGrpcHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---

##### `putHttpHealthcheck` <a name="putHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck"></a>

```typescript
public putHttpHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putHttpHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---

##### `putStreamHealthcheck` <a name="putStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck"></a>

```typescript
public putStreamHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.putStreamHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---

##### `resetGrpcHealthcheck` <a name="resetGrpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetGrpcHealthcheck"></a>

```typescript
public resetGrpcHealthcheck(): void
```

##### `resetHealthcheckPort` <a name="resetHealthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthcheckPort"></a>

```typescript
public resetHealthcheckPort(): void
```

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpHealthcheck` <a name="resetHttpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetHttpHealthcheck"></a>

```typescript
public resetHttpHealthcheck(): void
```

##### `resetIntervalJitterPercent` <a name="resetIntervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetIntervalJitterPercent"></a>

```typescript
public resetIntervalJitterPercent(): void
```

##### `resetStreamHealthcheck` <a name="resetStreamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetStreamHealthcheck"></a>

```typescript
public resetStreamHealthcheck(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheck">grpcHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheck">httpHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.interval">interval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheck">streamHealthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheckInput">grpcHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPortInput">healthcheckPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheckInput">httpHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercentInput">intervalJitterPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheckInput">streamHealthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPort">healthcheckPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercent">intervalJitterPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcHealthcheck`<sup>Required</sup> <a name="grpcHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheck"></a>

```typescript
public readonly grpcHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheckOutputReference</a>

---

##### `httpHealthcheck`<sup>Required</sup> <a name="httpHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheck"></a>

```typescript
public readonly httpHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheckOutputReference</a>

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: string;
```

- *Type:* string

---

##### `streamHealthcheck`<sup>Required</sup> <a name="streamHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheck"></a>

```typescript
public readonly streamHealthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference</a>

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `grpcHealthcheckInput`<sup>Optional</sup> <a name="grpcHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.grpcHealthcheckInput"></a>

```typescript
public readonly grpcHealthcheckInput: DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckGrpcHealthcheck</a>

---

##### `healthcheckPortInput`<sup>Optional</sup> <a name="healthcheckPortInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPortInput"></a>

```typescript
public readonly healthcheckPortInput: number;
```

- *Type:* number

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpHealthcheckInput`<sup>Optional</sup> <a name="httpHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.httpHealthcheckInput"></a>

```typescript
public readonly httpHealthcheckInput: DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckHttpHealthcheck</a>

---

##### `intervalJitterPercentInput`<sup>Optional</sup> <a name="intervalJitterPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercentInput"></a>

```typescript
public readonly intervalJitterPercentInput: number;
```

- *Type:* number

---

##### `streamHealthcheckInput`<sup>Optional</sup> <a name="streamHealthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.streamHealthcheckInput"></a>

```typescript
public readonly streamHealthcheckInput: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthcheckPort`<sup>Required</sup> <a name="healthcheckPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthcheckPort"></a>

```typescript
public readonly healthcheckPort: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `intervalJitterPercent`<sup>Required</sup> <a name="intervalJitterPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.intervalJitterPercent"></a>

```typescript
public readonly intervalJitterPercent: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a>

---


### DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference <a name="DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetReceive">resetReceive</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetSend">resetSend</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetReceive` <a name="resetReceive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetReceive"></a>

```typescript
public resetReceive(): void
```

##### `resetSend` <a name="resetSend" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.resetSend"></a>

```typescript
public resetSend(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput">receiveInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput">sendInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receive">receive</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.send">send</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `receiveInput`<sup>Optional</sup> <a name="receiveInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receiveInput"></a>

```typescript
public readonly receiveInput: string;
```

- *Type:* string

---

##### `sendInput`<sup>Optional</sup> <a name="sendInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.sendInput"></a>

```typescript
public readonly sendInput: string;
```

- *Type:* string

---

##### `receive`<sup>Required</sup> <a name="receive" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.receive"></a>

```typescript
public readonly receive: string;
```

- *Type:* string

---

##### `send`<sup>Required</sup> <a name="send" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.send"></a>

```typescript
public readonly send: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheckStreamHealthcheck</a>

---


### DataYandexAlbBackendGroupStreamBackendList <a name="DataYandexAlbBackendGroupStreamBackendList" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendList } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.get"></a>

```typescript
public get(index: number): DataYandexAlbBackendGroupStreamBackendOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupStreamBackend[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>[]

---


### DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference <a name="DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent">resetLocalityAwareRoutingPercent</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetPanicThreshold">resetPanicThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetStrictLocality">resetStrictLocality</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetLocalityAwareRoutingPercent` <a name="resetLocalityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetLocalityAwareRoutingPercent"></a>

```typescript
public resetLocalityAwareRoutingPercent(): void
```

##### `resetPanicThreshold` <a name="resetPanicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetPanicThreshold"></a>

```typescript
public resetPanicThreshold(): void
```

##### `resetStrictLocality` <a name="resetStrictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.resetStrictLocality"></a>

```typescript
public resetStrictLocality(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput">localityAwareRoutingPercentInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThresholdInput">panicThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocalityInput">strictLocalityInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent">localityAwareRoutingPercent</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThreshold">panicThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocality">strictLocality</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `localityAwareRoutingPercentInput`<sup>Optional</sup> <a name="localityAwareRoutingPercentInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercentInput"></a>

```typescript
public readonly localityAwareRoutingPercentInput: number;
```

- *Type:* number

---

##### `panicThresholdInput`<sup>Optional</sup> <a name="panicThresholdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThresholdInput"></a>

```typescript
public readonly panicThresholdInput: number;
```

- *Type:* number

---

##### `strictLocalityInput`<sup>Optional</sup> <a name="strictLocalityInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocalityInput"></a>

```typescript
public readonly strictLocalityInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `localityAwareRoutingPercent`<sup>Required</sup> <a name="localityAwareRoutingPercent" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.localityAwareRoutingPercent"></a>

```typescript
public readonly localityAwareRoutingPercent: number;
```

- *Type:* number

---

##### `panicThreshold`<sup>Required</sup> <a name="panicThreshold" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.panicThreshold"></a>

```typescript
public readonly panicThreshold: number;
```

- *Type:* number

---

##### `strictLocality`<sup>Required</sup> <a name="strictLocality" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.strictLocality"></a>

```typescript
public readonly strictLocality: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a>

---


### DataYandexAlbBackendGroupStreamBackendOutputReference <a name="DataYandexAlbBackendGroupStreamBackendOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig">putLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putTls">putTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetHealthcheck">resetHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetLoadBalancingConfig">resetLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetTls">resetTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetWeight">resetWeight</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: DataYandexAlbBackendGroupStreamBackendHealthcheck): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a>

---

##### `putLoadBalancingConfig` <a name="putLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig"></a>

```typescript
public putLoadBalancingConfig(value: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putLoadBalancingConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a>

---

##### `putTls` <a name="putTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putTls"></a>

```typescript
public putTls(value: DataYandexAlbBackendGroupStreamBackendTls): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.putTls.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a>

---

##### `resetHealthcheck` <a name="resetHealthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetHealthcheck"></a>

```typescript
public resetHealthcheck(): void
```

##### `resetLoadBalancingConfig` <a name="resetLoadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetLoadBalancingConfig"></a>

```typescript
public resetLoadBalancingConfig(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetTls` <a name="resetTls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetTls"></a>

```typescript
public resetTls(): void
```

##### `resetWeight` <a name="resetWeight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.resetWeight"></a>

```typescript
public resetWeight(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfig">loadBalancingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.targetGroupIds">targetGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference">DataYandexAlbBackendGroupStreamBackendTlsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfigInput">loadBalancingConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.tlsInput">tlsInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.weightInput">weightInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.weight">weight</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference">DataYandexAlbBackendGroupStreamBackendHealthcheckOutputReference</a>

---

##### `loadBalancingConfig`<sup>Required</sup> <a name="loadBalancingConfig" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfig"></a>

```typescript
public readonly loadBalancingConfig: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfigOutputReference</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `targetGroupIds`<sup>Required</sup> <a name="targetGroupIds" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.targetGroupIds"></a>

```typescript
public readonly targetGroupIds: string[];
```

- *Type:* string[]

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbBackendGroupStreamBackendTlsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference">DataYandexAlbBackendGroupStreamBackendTlsOutputReference</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: DataYandexAlbBackendGroupStreamBackendHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendHealthcheck">DataYandexAlbBackendGroupStreamBackendHealthcheck</a>

---

##### `loadBalancingConfigInput`<sup>Optional</sup> <a name="loadBalancingConfigInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.loadBalancingConfigInput"></a>

```typescript
public readonly loadBalancingConfigInput: DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig">DataYandexAlbBackendGroupStreamBackendLoadBalancingConfig</a>

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `tlsInput`<sup>Optional</sup> <a name="tlsInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.tlsInput"></a>

```typescript
public readonly tlsInput: DataYandexAlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a>

---

##### `weightInput`<sup>Optional</sup> <a name="weightInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.weightInput"></a>

```typescript
public readonly weightInput: number;
```

- *Type:* number

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `weight`<sup>Required</sup> <a name="weight" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbBackendGroupStreamBackend;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackend">DataYandexAlbBackendGroupStreamBackend</a>

---


### DataYandexAlbBackendGroupStreamBackendTlsOutputReference <a name="DataYandexAlbBackendGroupStreamBackendTlsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendTlsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.putValidationContext">putValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resetSni">resetSni</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resetValidationContext">resetValidationContext</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putValidationContext` <a name="putValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.putValidationContext"></a>

```typescript
public putValidationContext(value: DataYandexAlbBackendGroupStreamBackendTlsValidationContext): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.putValidationContext.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a>

---

##### `resetSni` <a name="resetSni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resetSni"></a>

```typescript
public resetSni(): void
```

##### `resetValidationContext` <a name="resetValidationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.resetValidationContext"></a>

```typescript
public resetValidationContext(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.validationContext">validationContext</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.sniInput">sniInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.validationContextInput">validationContextInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.sni">sni</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `validationContext`<sup>Required</sup> <a name="validationContext" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.validationContext"></a>

```typescript
public readonly validationContext: DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference">DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference</a>

---

##### `sniInput`<sup>Optional</sup> <a name="sniInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.sniInput"></a>

```typescript
public readonly sniInput: string;
```

- *Type:* string

---

##### `validationContextInput`<sup>Optional</sup> <a name="validationContextInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.validationContextInput"></a>

```typescript
public readonly validationContextInput: DataYandexAlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a>

---

##### `sni`<sup>Required</sup> <a name="sni" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.sni"></a>

```typescript
public readonly sni: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTls">DataYandexAlbBackendGroupStreamBackendTls</a>

---


### DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference <a name="DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaBytes">resetTrustedCaBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaId">resetTrustedCaId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTrustedCaBytes` <a name="resetTrustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaBytes"></a>

```typescript
public resetTrustedCaBytes(): void
```

##### `resetTrustedCaId` <a name="resetTrustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.resetTrustedCaId"></a>

```typescript
public resetTrustedCaId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytesInput">trustedCaBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaIdInput">trustedCaIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytes">trustedCaBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaId">trustedCaId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `trustedCaBytesInput`<sup>Optional</sup> <a name="trustedCaBytesInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytesInput"></a>

```typescript
public readonly trustedCaBytesInput: string;
```

- *Type:* string

---

##### `trustedCaIdInput`<sup>Optional</sup> <a name="trustedCaIdInput" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaIdInput"></a>

```typescript
public readonly trustedCaIdInput: string;
```

- *Type:* string

---

##### `trustedCaBytes`<sup>Required</sup> <a name="trustedCaBytes" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaBytes"></a>

```typescript
public readonly trustedCaBytes: string;
```

- *Type:* string

---

##### `trustedCaId`<sup>Required</sup> <a name="trustedCaId" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.trustedCaId"></a>

```typescript
public readonly trustedCaId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContextOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbBackendGroupStreamBackendTlsValidationContext;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbBackendGroupStreamBackendTlsValidationContext">DataYandexAlbBackendGroupStreamBackendTlsValidationContext</a>

---


### DataYandexAlbLoadBalancerAllocationPolicyList <a name="DataYandexAlbLoadBalancerAllocationPolicyList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicyList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerAllocationPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerAllocationPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerAllocationPolicyLocationList <a name="DataYandexAlbLoadBalancerAllocationPolicyLocationList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicyLocationList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerAllocationPolicyLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference <a name="DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTraffic">disableTraffic</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocation">DataYandexAlbLoadBalancerAllocationPolicyLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `disableTraffic`<sup>Required</sup> <a name="disableTraffic" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.disableTraffic"></a>

```typescript
public readonly disableTraffic: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerAllocationPolicyLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocation">DataYandexAlbLoadBalancerAllocationPolicyLocation</a>

---


### DataYandexAlbLoadBalancerAllocationPolicyOutputReference <a name="DataYandexAlbLoadBalancerAllocationPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList">DataYandexAlbLoadBalancerAllocationPolicyLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicy">DataYandexAlbLoadBalancerAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.location"></a>

```typescript
public readonly location: DataYandexAlbLoadBalancerAllocationPolicyLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyLocationList">DataYandexAlbLoadBalancerAllocationPolicyLocationList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerAllocationPolicy">DataYandexAlbLoadBalancerAllocationPolicy</a>

---


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4Address</a>

---


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference <a name="DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6Address</a>

---


### DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList <a name="DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference <a name="DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address">DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address">DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4Address</a>

---


### DataYandexAlbLoadBalancerListenerEndpointAddressList <a name="DataYandexAlbLoadBalancerListenerEndpointAddressList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference <a name="DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4Address">externalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6Address">externalIpv6Address</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4Address">internalIpv4Address</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddress">DataYandexAlbLoadBalancerListenerEndpointAddress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalIpv4Address`<sup>Required</sup> <a name="externalIpv4Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv4Address"></a>

```typescript
public readonly externalIpv4Address: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv4AddressList</a>

---

##### `externalIpv6Address`<sup>Required</sup> <a name="externalIpv6Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.externalIpv6Address"></a>

```typescript
public readonly externalIpv6Address: DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressExternalIpv6AddressList</a>

---

##### `internalIpv4Address`<sup>Required</sup> <a name="internalIpv4Address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.internalIpv4Address"></a>

```typescript
public readonly internalIpv4Address: DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList">DataYandexAlbLoadBalancerListenerEndpointAddressInternalIpv4AddressList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerEndpointAddress;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddress">DataYandexAlbLoadBalancerListenerEndpointAddress</a>

---


### DataYandexAlbLoadBalancerListenerEndpointList <a name="DataYandexAlbLoadBalancerListenerEndpointList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerEndpointOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerEndpointOutputReference <a name="DataYandexAlbLoadBalancerListenerEndpointOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerEndpointOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerEndpointOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.address">address</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList">DataYandexAlbLoadBalancerListenerEndpointAddressList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.ports">ports</a></code> | <code>number[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpoint">DataYandexAlbLoadBalancerListenerEndpoint</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.address"></a>

```typescript
public readonly address: DataYandexAlbLoadBalancerListenerEndpointAddressList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointAddressList">DataYandexAlbLoadBalancerListenerEndpointAddressList</a>

---

##### `ports`<sup>Required</sup> <a name="ports" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.ports"></a>

```typescript
public readonly ports: number[];
```

- *Type:* number[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerEndpoint;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpoint">DataYandexAlbLoadBalancerListenerEndpoint</a>

---


### DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList <a name="DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference <a name="DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerHttpHandlerHttp2Options</a>

---


### DataYandexAlbLoadBalancerListenerHttpHandlerList <a name="DataYandexAlbLoadBalancerListenerHttpHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandler">DataYandexAlbLoadBalancerListenerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerHttpHandlerHttp2OptionsList</a>

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandler">DataYandexAlbLoadBalancerListenerHttpHandler</a>

---


### DataYandexAlbLoadBalancerListenerHttpList <a name="DataYandexAlbLoadBalancerListenerHttpList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerHttpOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerHttpOutputReference <a name="DataYandexAlbLoadBalancerListenerHttpOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList">DataYandexAlbLoadBalancerListenerHttpHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.redirects">redirects</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList">DataYandexAlbLoadBalancerListenerHttpRedirectsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttp">DataYandexAlbLoadBalancerListenerHttp</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.handler"></a>

```typescript
public readonly handler: DataYandexAlbLoadBalancerListenerHttpHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpHandlerList">DataYandexAlbLoadBalancerListenerHttpHandlerList</a>

---

##### `redirects`<sup>Required</sup> <a name="redirects" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.redirects"></a>

```typescript
public readonly redirects: DataYandexAlbLoadBalancerListenerHttpRedirectsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList">DataYandexAlbLoadBalancerListenerHttpRedirectsList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerHttp;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttp">DataYandexAlbLoadBalancerListenerHttp</a>

---


### DataYandexAlbLoadBalancerListenerHttpRedirectsList <a name="DataYandexAlbLoadBalancerListenerHttpRedirectsList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpRedirectsList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpRedirectsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference <a name="DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttps">httpToHttps</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirects">DataYandexAlbLoadBalancerListenerHttpRedirects</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpToHttps`<sup>Required</sup> <a name="httpToHttps" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.httpToHttps"></a>

```typescript
public readonly httpToHttps: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirectsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerHttpRedirects;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpRedirects">DataYandexAlbLoadBalancerListenerHttpRedirects</a>

---


### DataYandexAlbLoadBalancerListenerList <a name="DataYandexAlbLoadBalancerListenerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerOutputReference <a name="DataYandexAlbLoadBalancerListenerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.endpoint">endpoint</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList">DataYandexAlbLoadBalancerListenerEndpointList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.http">http</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList">DataYandexAlbLoadBalancerListenerHttpList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.stream">stream</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList">DataYandexAlbLoadBalancerListenerStreamList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.tls">tls</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList">DataYandexAlbLoadBalancerListenerTlsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListener">DataYandexAlbLoadBalancerListener</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `endpoint`<sup>Required</sup> <a name="endpoint" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.endpoint"></a>

```typescript
public readonly endpoint: DataYandexAlbLoadBalancerListenerEndpointList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerEndpointList">DataYandexAlbLoadBalancerListenerEndpointList</a>

---

##### `http`<sup>Required</sup> <a name="http" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.http"></a>

```typescript
public readonly http: DataYandexAlbLoadBalancerListenerHttpList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerHttpList">DataYandexAlbLoadBalancerListenerHttpList</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `stream`<sup>Required</sup> <a name="stream" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.stream"></a>

```typescript
public readonly stream: DataYandexAlbLoadBalancerListenerStreamList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList">DataYandexAlbLoadBalancerListenerStreamList</a>

---

##### `tls`<sup>Required</sup> <a name="tls" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.tls"></a>

```typescript
public readonly tls: DataYandexAlbLoadBalancerListenerTlsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList">DataYandexAlbLoadBalancerListenerTlsList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListener;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListener">DataYandexAlbLoadBalancerListener</a>

---


### DataYandexAlbLoadBalancerListenerStreamHandlerList <a name="DataYandexAlbLoadBalancerListenerStreamHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStreamHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerStreamHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandler">DataYandexAlbLoadBalancerListenerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandler">DataYandexAlbLoadBalancerListenerStreamHandler</a>

---


### DataYandexAlbLoadBalancerListenerStreamList <a name="DataYandexAlbLoadBalancerListenerStreamList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStreamList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerStreamList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerStreamOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerStreamOutputReference <a name="DataYandexAlbLoadBalancerListenerStreamOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerStreamOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerStreamOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList">DataYandexAlbLoadBalancerListenerStreamHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStream">DataYandexAlbLoadBalancerListenerStream</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.handler"></a>

```typescript
public readonly handler: DataYandexAlbLoadBalancerListenerStreamHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamHandlerList">DataYandexAlbLoadBalancerListenerStreamHandlerList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStreamOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerStream;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerStream">DataYandexAlbLoadBalancerListenerStream</a>

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2Options</a>

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerHttp2OptionsList</a>

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

---

##### `httpHandler`<sup>Required</sup> <a name="httpHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.httpHandler"></a>

```typescript
public readonly httpHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerHttpHandlerList</a>

---

##### `streamHandler`<sup>Required</sup> <a name="streamHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.streamHandler"></a>

```typescript
public readonly streamHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsDefaultHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerStreamHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsList <a name="DataYandexAlbLoadBalancerListenerTlsList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.defaultHandler">defaultHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.sniHandler">sniHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTls">DataYandexAlbLoadBalancerListenerTls</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `defaultHandler`<sup>Required</sup> <a name="defaultHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.defaultHandler"></a>

```typescript
public readonly defaultHandler: DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList">DataYandexAlbLoadBalancerListenerTlsDefaultHandlerList</a>

---

##### `sniHandler`<sup>Required</sup> <a name="sniHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.sniHandler"></a>

```typescript
public readonly sniHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTls;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTls">DataYandexAlbLoadBalancerListenerTls</a>

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams">maxConcurrentStreams</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConcurrentStreams`<sup>Required</sup> <a name="maxConcurrentStreams" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.maxConcurrentStreams"></a>

```typescript
public readonly maxConcurrentStreams: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2Options</a>

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10">allowHttp10</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2Options">http2Options</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterId">httpRouterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowHttp10`<sup>Required</sup> <a name="allowHttp10" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.allowHttp10"></a>

```typescript
public readonly allowHttp10: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `http2Options`<sup>Required</sup> <a name="http2Options" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.http2Options"></a>

```typescript
public readonly http2Options: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerHttp2OptionsList</a>

---

##### `httpRouterId`<sup>Required</sup> <a name="httpRouterId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.httpRouterId"></a>

```typescript
public readonly httpRouterId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIds">certificateIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandler">httpHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandler">streamHandler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `certificateIds`<sup>Required</sup> <a name="certificateIds" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.certificateIds"></a>

```typescript
public readonly certificateIds: string[];
```

- *Type:* string[]

---

##### `httpHandler`<sup>Required</sup> <a name="httpHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.httpHandler"></a>

```typescript
public readonly httpHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerHttpHandlerList</a>

---

##### `streamHandler`<sup>Required</sup> <a name="streamHandler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.streamHandler"></a>

```typescript
public readonly streamHandler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerStreamHandler</a>

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerList <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerList" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerList } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.get"></a>

```typescript
public get(index: number): DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference <a name="DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handler">handler</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNames">serverNames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandler">DataYandexAlbLoadBalancerListenerTlsSniHandler</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `handler`<sup>Required</sup> <a name="handler" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.handler"></a>

```typescript
public readonly handler: DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList">DataYandexAlbLoadBalancerListenerTlsSniHandlerHandlerList</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `serverNames`<sup>Required</sup> <a name="serverNames" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.serverNames"></a>

```typescript
public readonly serverNames: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandlerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbLoadBalancerListenerTlsSniHandler;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerListenerTlsSniHandler">DataYandexAlbLoadBalancerListenerTlsSniHandler</a>

---


### DataYandexAlbLoadBalancerTimeoutsOutputReference <a name="DataYandexAlbLoadBalancerTimeoutsOutputReference" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbLoadBalancerTimeoutsOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbLoadBalancerTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexAlbLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexAlbLoadBalancerTimeouts">DataYandexAlbLoadBalancerTimeouts</a>

---


### DataYandexAlbTargetGroupTargetList <a name="DataYandexAlbTargetGroupTargetList" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer"></a>

```typescript
import { DataYandexAlbTargetGroupTargetList } from '@cdktf/provider-yandex'

new DataYandexAlbTargetGroupTargetList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.get"></a>

```typescript
public get(index: number): DataYandexAlbTargetGroupTargetOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbTargetGroupTargetOutputReference <a name="DataYandexAlbTargetGroupTargetOutputReference" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbTargetGroupTargetOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbTargetGroupTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.privateIpv4Address">privateIpv4Address</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTarget">DataYandexAlbTargetGroupTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `privateIpv4Address`<sup>Required</sup> <a name="privateIpv4Address" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.privateIpv4Address"></a>

```typescript
public readonly privateIpv4Address: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbTargetGroupTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbTargetGroupTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbTargetGroupTarget">DataYandexAlbTargetGroupTarget</a>

---


### DataYandexAlbVirtualHostModifyRequestHeadersList <a name="DataYandexAlbVirtualHostModifyRequestHeadersList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyRequestHeadersList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostModifyRequestHeadersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostModifyRequestHeadersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostModifyRequestHeadersOutputReference <a name="DataYandexAlbVirtualHostModifyRequestHeadersOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyRequestHeadersOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostModifyRequestHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.append">append</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.remove">remove</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.replace">replace</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeaders">DataYandexAlbVirtualHostModifyRequestHeaders</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `append`<sup>Required</sup> <a name="append" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `remove`<sup>Required</sup> <a name="remove" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.remove"></a>

```typescript
public readonly remove: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `replace`<sup>Required</sup> <a name="replace" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostModifyRequestHeaders;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyRequestHeaders">DataYandexAlbVirtualHostModifyRequestHeaders</a>

---


### DataYandexAlbVirtualHostModifyResponseHeadersList <a name="DataYandexAlbVirtualHostModifyResponseHeadersList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyResponseHeadersList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostModifyResponseHeadersList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostModifyResponseHeadersOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostModifyResponseHeadersOutputReference <a name="DataYandexAlbVirtualHostModifyResponseHeadersOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostModifyResponseHeadersOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostModifyResponseHeadersOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.append">append</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.remove">remove</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.replace">replace</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeaders">DataYandexAlbVirtualHostModifyResponseHeaders</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `append`<sup>Required</sup> <a name="append" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.append"></a>

```typescript
public readonly append: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `remove`<sup>Required</sup> <a name="remove" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.remove"></a>

```typescript
public readonly remove: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `replace`<sup>Required</sup> <a name="replace" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.replace"></a>

```typescript
public readonly replace: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeadersOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostModifyResponseHeaders;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostModifyResponseHeaders">DataYandexAlbVirtualHostModifyResponseHeaders</a>

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exact">exact</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `exact`<sup>Required</sup> <a name="exact" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmn</a>

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmn">fqmn</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqmn`<sup>Required</sup> <a name="fqmn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.fqmn"></a>

```typescript
public readonly fqmn: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchFqmnList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatch</a>

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewrite">autoHostRewrite</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeout">maxTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction">DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoHostRewrite`<sup>Required</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `hostRewrite`<sup>Required</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

---

##### `idleTimeout`<sup>Required</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

---

##### `maxTimeout`<sup>Required</sup> <a name="maxTimeout" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.maxTimeout"></a>

```typescript
public readonly maxTimeout: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction">DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteAction</a>

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference <a name="DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction">DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseAction</a>

---


### DataYandexAlbVirtualHostRouteGrpcRouteList <a name="DataYandexAlbVirtualHostRouteGrpcRouteList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteGrpcRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteGrpcRouteOutputReference <a name="DataYandexAlbVirtualHostRouteGrpcRouteOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteGrpcRouteOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteGrpcRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatch">grpcMatch</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteAction">grpcRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseAction">grpcStatusResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRoute">DataYandexAlbVirtualHostRouteGrpcRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcMatch`<sup>Required</sup> <a name="grpcMatch" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcMatch"></a>

```typescript
public readonly grpcMatch: DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcMatchList</a>

---

##### `grpcRouteAction`<sup>Required</sup> <a name="grpcRouteAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcRouteAction"></a>

```typescript
public readonly grpcRouteAction: DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcRouteActionList</a>

---

##### `grpcStatusResponseAction`<sup>Required</sup> <a name="grpcStatusResponseAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.grpcStatusResponseAction"></a>

```typescript
public readonly grpcStatusResponseAction: DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList">DataYandexAlbVirtualHostRouteGrpcRouteGrpcStatusResponseActionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteGrpcRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRoute">DataYandexAlbVirtualHostRouteGrpcRoute</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList <a name="DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.body">body</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.status">status</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction">DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `body`<sup>Required</sup> <a name="body" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.body"></a>

```typescript
public readonly body: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.status"></a>

```typescript
public readonly status: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction">DataYandexAlbVirtualHostRouteHttpRouteDirectResponseAction</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethod">httpMethod</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.path">path</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatch">DataYandexAlbVirtualHostRouteHttpRouteHttpMatch</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpMethod`<sup>Required</sup> <a name="httpMethod" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.httpMethod"></a>

```typescript
public readonly httpMethod: string[];
```

- *Type:* string[]

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.path"></a>

```typescript
public readonly path: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRouteHttpMatch;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatch">DataYandexAlbVirtualHostRouteHttpRouteHttpMatch</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exact">exact</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `exact`<sup>Required</sup> <a name="exact" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.exact"></a>

```typescript
public readonly exact: string;
```

- *Type:* string

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPathOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchPath</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewrite">autoHostRewrite</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupId">backendGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewrite">hostRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeout">idleTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewrite">prefixRewrite</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeout">timeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypes">upgradeTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction">DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoHostRewrite`<sup>Required</sup> <a name="autoHostRewrite" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.autoHostRewrite"></a>

```typescript
public readonly autoHostRewrite: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `backendGroupId`<sup>Required</sup> <a name="backendGroupId" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.backendGroupId"></a>

```typescript
public readonly backendGroupId: string;
```

- *Type:* string

---

##### `hostRewrite`<sup>Required</sup> <a name="hostRewrite" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.hostRewrite"></a>

```typescript
public readonly hostRewrite: string;
```

- *Type:* string

---

##### `idleTimeout`<sup>Required</sup> <a name="idleTimeout" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.idleTimeout"></a>

```typescript
public readonly idleTimeout: string;
```

- *Type:* string

---

##### `prefixRewrite`<sup>Required</sup> <a name="prefixRewrite" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.prefixRewrite"></a>

```typescript
public readonly prefixRewrite: string;
```

- *Type:* string

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.timeout"></a>

```typescript
public readonly timeout: string;
```

- *Type:* string

---

##### `upgradeTypes`<sup>Required</sup> <a name="upgradeTypes" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.upgradeTypes"></a>

```typescript
public readonly upgradeTypes: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction">DataYandexAlbVirtualHostRouteHttpRouteHttpRouteAction</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteList <a name="DataYandexAlbVirtualHostRouteHttpRouteList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.directResponseAction">directResponseAction</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList">DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.httpMatch">httpMatch</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteAction">httpRouteAction</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList">DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.redirectAction">redirectAction</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList">DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRoute">DataYandexAlbVirtualHostRouteHttpRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `directResponseAction`<sup>Required</sup> <a name="directResponseAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.directResponseAction"></a>

```typescript
public readonly directResponseAction: DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList">DataYandexAlbVirtualHostRouteHttpRouteDirectResponseActionList</a>

---

##### `httpMatch`<sup>Required</sup> <a name="httpMatch" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.httpMatch"></a>

```typescript
public readonly httpMatch: DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList">DataYandexAlbVirtualHostRouteHttpRouteHttpMatchList</a>

---

##### `httpRouteAction`<sup>Required</sup> <a name="httpRouteAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.httpRouteAction"></a>

```typescript
public readonly httpRouteAction: DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList">DataYandexAlbVirtualHostRouteHttpRouteHttpRouteActionList</a>

---

##### `redirectAction`<sup>Required</sup> <a name="redirectAction" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.redirectAction"></a>

```typescript
public readonly redirectAction: DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList">DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRoute">DataYandexAlbVirtualHostRouteHttpRoute</a>

---


### DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList <a name="DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference <a name="DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQuery">removeQuery</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHost">replaceHost</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePath">replacePath</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePort">replacePort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefix">replacePrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceScheme">replaceScheme</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCode">responseCode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectAction">DataYandexAlbVirtualHostRouteHttpRouteRedirectAction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `removeQuery`<sup>Required</sup> <a name="removeQuery" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.removeQuery"></a>

```typescript
public readonly removeQuery: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `replaceHost`<sup>Required</sup> <a name="replaceHost" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceHost"></a>

```typescript
public readonly replaceHost: string;
```

- *Type:* string

---

##### `replacePath`<sup>Required</sup> <a name="replacePath" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePath"></a>

```typescript
public readonly replacePath: string;
```

- *Type:* string

---

##### `replacePort`<sup>Required</sup> <a name="replacePort" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePort"></a>

```typescript
public readonly replacePort: number;
```

- *Type:* number

---

##### `replacePrefix`<sup>Required</sup> <a name="replacePrefix" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replacePrefix"></a>

```typescript
public readonly replacePrefix: string;
```

- *Type:* string

---

##### `replaceScheme`<sup>Required</sup> <a name="replaceScheme" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.replaceScheme"></a>

```typescript
public readonly replaceScheme: string;
```

- *Type:* string

---

##### `responseCode`<sup>Required</sup> <a name="responseCode" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.responseCode"></a>

```typescript
public readonly responseCode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectActionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRouteHttpRouteRedirectAction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteRedirectAction">DataYandexAlbVirtualHostRouteHttpRouteRedirectAction</a>

---


### DataYandexAlbVirtualHostRouteList <a name="DataYandexAlbVirtualHostRouteList" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteList } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.get"></a>

```typescript
public get(index: number): DataYandexAlbVirtualHostRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexAlbVirtualHostRouteOutputReference <a name="DataYandexAlbVirtualHostRouteOutputReference" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer"></a>

```typescript
import { DataYandexAlbVirtualHostRouteOutputReference } from '@cdktf/provider-yandex'

new DataYandexAlbVirtualHostRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.grpcRoute">grpcRoute</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList">DataYandexAlbVirtualHostRouteGrpcRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.httpRoute">httpRoute</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList">DataYandexAlbVirtualHostRouteHttpRouteList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRoute">DataYandexAlbVirtualHostRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `grpcRoute`<sup>Required</sup> <a name="grpcRoute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.grpcRoute"></a>

```typescript
public readonly grpcRoute: DataYandexAlbVirtualHostRouteGrpcRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteGrpcRouteList">DataYandexAlbVirtualHostRouteGrpcRouteList</a>

---

##### `httpRoute`<sup>Required</sup> <a name="httpRoute" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.httpRoute"></a>

```typescript
public readonly httpRoute: DataYandexAlbVirtualHostRouteHttpRouteList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteHttpRouteList">DataYandexAlbVirtualHostRouteHttpRouteList</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexAlbVirtualHostRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexAlbVirtualHostRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexAlbVirtualHostRoute">DataYandexAlbVirtualHostRoute</a>

---


### DataYandexCdnOriginGroupOriginList <a name="DataYandexCdnOriginGroupOriginList" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer"></a>

```typescript
import { DataYandexCdnOriginGroupOriginList } from '@cdktf/provider-yandex'

new DataYandexCdnOriginGroupOriginList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.get"></a>

```typescript
public get(index: number): DataYandexCdnOriginGroupOriginOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexCdnOriginGroupOriginOutputReference <a name="DataYandexCdnOriginGroupOriginOutputReference" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer"></a>

```typescript
import { DataYandexCdnOriginGroupOriginOutputReference } from '@cdktf/provider-yandex'

new DataYandexCdnOriginGroupOriginOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.backup">backup</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.originGroupId">originGroupId</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.source">source</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOrigin">DataYandexCdnOriginGroupOrigin</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backup`<sup>Required</sup> <a name="backup" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.backup"></a>

```typescript
public readonly backup: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `originGroupId`<sup>Required</sup> <a name="originGroupId" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.originGroupId"></a>

```typescript
public readonly originGroupId: number;
```

- *Type:* number

---

##### `source`<sup>Required</sup> <a name="source" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.source"></a>

```typescript
public readonly source: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexCdnOriginGroupOriginOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexCdnOriginGroupOrigin;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnOriginGroupOrigin">DataYandexCdnOriginGroupOrigin</a>

---


### DataYandexCdnResourceOptionsOutputReference <a name="DataYandexCdnResourceOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexCdnResourceOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexCdnResourceOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetAllowedHttpMethods">resetAllowedHttpMethods</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetBrowserCacheSettings">resetBrowserCacheSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCacheHttpHeaders">resetCacheHttpHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCors">resetCors</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCustomHostHeader">resetCustomHostHeader</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCustomServerName">resetCustomServerName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetDisableCache">resetDisableCache</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetDisableProxyForceRanges">resetDisableProxyForceRanges</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetEdgeCacheSettings">resetEdgeCacheSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetFetchedCompressed">resetFetchedCompressed</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetForwardHostHeader">resetForwardHostHeader</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetGzipOn">resetGzipOn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetIgnoreCookie">resetIgnoreCookie</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetIgnoreQueryParams">resetIgnoreQueryParams</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetProxyCacheMethodsSet">resetProxyCacheMethodsSet</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetQueryParamsBlacklist">resetQueryParamsBlacklist</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetQueryParamsWhitelist">resetQueryParamsWhitelist</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetRedirectHttpsToHttp">resetRedirectHttpsToHttp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetRedirectHttpToHttps">resetRedirectHttpToHttps</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetSlice">resetSlice</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetStaticRequestHeaders">resetStaticRequestHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetStaticResponseHeaders">resetStaticResponseHeaders</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAllowedHttpMethods` <a name="resetAllowedHttpMethods" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetAllowedHttpMethods"></a>

```typescript
public resetAllowedHttpMethods(): void
```

##### `resetBrowserCacheSettings` <a name="resetBrowserCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetBrowserCacheSettings"></a>

```typescript
public resetBrowserCacheSettings(): void
```

##### `resetCacheHttpHeaders` <a name="resetCacheHttpHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCacheHttpHeaders"></a>

```typescript
public resetCacheHttpHeaders(): void
```

##### `resetCors` <a name="resetCors" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCors"></a>

```typescript
public resetCors(): void
```

##### `resetCustomHostHeader` <a name="resetCustomHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCustomHostHeader"></a>

```typescript
public resetCustomHostHeader(): void
```

##### `resetCustomServerName` <a name="resetCustomServerName" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetCustomServerName"></a>

```typescript
public resetCustomServerName(): void
```

##### `resetDisableCache` <a name="resetDisableCache" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetDisableCache"></a>

```typescript
public resetDisableCache(): void
```

##### `resetDisableProxyForceRanges` <a name="resetDisableProxyForceRanges" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetDisableProxyForceRanges"></a>

```typescript
public resetDisableProxyForceRanges(): void
```

##### `resetEdgeCacheSettings` <a name="resetEdgeCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetEdgeCacheSettings"></a>

```typescript
public resetEdgeCacheSettings(): void
```

##### `resetFetchedCompressed` <a name="resetFetchedCompressed" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetFetchedCompressed"></a>

```typescript
public resetFetchedCompressed(): void
```

##### `resetForwardHostHeader` <a name="resetForwardHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetForwardHostHeader"></a>

```typescript
public resetForwardHostHeader(): void
```

##### `resetGzipOn` <a name="resetGzipOn" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetGzipOn"></a>

```typescript
public resetGzipOn(): void
```

##### `resetIgnoreCookie` <a name="resetIgnoreCookie" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetIgnoreCookie"></a>

```typescript
public resetIgnoreCookie(): void
```

##### `resetIgnoreQueryParams` <a name="resetIgnoreQueryParams" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetIgnoreQueryParams"></a>

```typescript
public resetIgnoreQueryParams(): void
```

##### `resetProxyCacheMethodsSet` <a name="resetProxyCacheMethodsSet" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetProxyCacheMethodsSet"></a>

```typescript
public resetProxyCacheMethodsSet(): void
```

##### `resetQueryParamsBlacklist` <a name="resetQueryParamsBlacklist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetQueryParamsBlacklist"></a>

```typescript
public resetQueryParamsBlacklist(): void
```

##### `resetQueryParamsWhitelist` <a name="resetQueryParamsWhitelist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetQueryParamsWhitelist"></a>

```typescript
public resetQueryParamsWhitelist(): void
```

##### `resetRedirectHttpsToHttp` <a name="resetRedirectHttpsToHttp" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetRedirectHttpsToHttp"></a>

```typescript
public resetRedirectHttpsToHttp(): void
```

##### `resetRedirectHttpToHttps` <a name="resetRedirectHttpToHttps" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetRedirectHttpToHttps"></a>

```typescript
public resetRedirectHttpToHttps(): void
```

##### `resetSlice` <a name="resetSlice" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetSlice"></a>

```typescript
public resetSlice(): void
```

##### `resetStaticRequestHeaders` <a name="resetStaticRequestHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetStaticRequestHeaders"></a>

```typescript
public resetStaticRequestHeaders(): void
```

##### `resetStaticResponseHeaders` <a name="resetStaticResponseHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.resetStaticResponseHeaders"></a>

```typescript
public resetStaticResponseHeaders(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.allowedHttpMethodsInput">allowedHttpMethodsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.browserCacheSettingsInput">browserCacheSettingsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cacheHttpHeadersInput">cacheHttpHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.corsInput">corsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customHostHeaderInput">customHostHeaderInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customServerNameInput">customServerNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableCacheInput">disableCacheInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableProxyForceRangesInput">disableProxyForceRangesInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.edgeCacheSettingsInput">edgeCacheSettingsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fetchedCompressedInput">fetchedCompressedInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.forwardHostHeaderInput">forwardHostHeaderInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.gzipOnInput">gzipOnInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreCookieInput">ignoreCookieInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreQueryParamsInput">ignoreQueryParamsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.proxyCacheMethodsSetInput">proxyCacheMethodsSetInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsBlacklistInput">queryParamsBlacklistInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsWhitelistInput">queryParamsWhitelistInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpsToHttpInput">redirectHttpsToHttpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpToHttpsInput">redirectHttpToHttpsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.sliceInput">sliceInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticRequestHeadersInput">staticRequestHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticResponseHeadersInput">staticResponseHeadersInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.allowedHttpMethods">allowedHttpMethods</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.browserCacheSettings">browserCacheSettings</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cacheHttpHeaders">cacheHttpHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cors">cors</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customHostHeader">customHostHeader</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customServerName">customServerName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableCache">disableCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableProxyForceRanges">disableProxyForceRanges</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.edgeCacheSettings">edgeCacheSettings</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fetchedCompressed">fetchedCompressed</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.forwardHostHeader">forwardHostHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.gzipOn">gzipOn</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreCookie">ignoreCookie</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreQueryParams">ignoreQueryParams</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.proxyCacheMethodsSet">proxyCacheMethodsSet</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsBlacklist">queryParamsBlacklist</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsWhitelist">queryParamsWhitelist</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpsToHttp">redirectHttpsToHttp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpToHttps">redirectHttpToHttps</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.slice">slice</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticRequestHeaders">staticRequestHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticResponseHeaders">staticResponseHeaders</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowedHttpMethodsInput`<sup>Optional</sup> <a name="allowedHttpMethodsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.allowedHttpMethodsInput"></a>

```typescript
public readonly allowedHttpMethodsInput: string[];
```

- *Type:* string[]

---

##### `browserCacheSettingsInput`<sup>Optional</sup> <a name="browserCacheSettingsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.browserCacheSettingsInput"></a>

```typescript
public readonly browserCacheSettingsInput: number;
```

- *Type:* number

---

##### `cacheHttpHeadersInput`<sup>Optional</sup> <a name="cacheHttpHeadersInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cacheHttpHeadersInput"></a>

```typescript
public readonly cacheHttpHeadersInput: string[];
```

- *Type:* string[]

---

##### `corsInput`<sup>Optional</sup> <a name="corsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.corsInput"></a>

```typescript
public readonly corsInput: string[];
```

- *Type:* string[]

---

##### `customHostHeaderInput`<sup>Optional</sup> <a name="customHostHeaderInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customHostHeaderInput"></a>

```typescript
public readonly customHostHeaderInput: string;
```

- *Type:* string

---

##### `customServerNameInput`<sup>Optional</sup> <a name="customServerNameInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customServerNameInput"></a>

```typescript
public readonly customServerNameInput: string;
```

- *Type:* string

---

##### `disableCacheInput`<sup>Optional</sup> <a name="disableCacheInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableCacheInput"></a>

```typescript
public readonly disableCacheInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `disableProxyForceRangesInput`<sup>Optional</sup> <a name="disableProxyForceRangesInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableProxyForceRangesInput"></a>

```typescript
public readonly disableProxyForceRangesInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `edgeCacheSettingsInput`<sup>Optional</sup> <a name="edgeCacheSettingsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.edgeCacheSettingsInput"></a>

```typescript
public readonly edgeCacheSettingsInput: number;
```

- *Type:* number

---

##### `fetchedCompressedInput`<sup>Optional</sup> <a name="fetchedCompressedInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fetchedCompressedInput"></a>

```typescript
public readonly fetchedCompressedInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forwardHostHeaderInput`<sup>Optional</sup> <a name="forwardHostHeaderInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.forwardHostHeaderInput"></a>

```typescript
public readonly forwardHostHeaderInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gzipOnInput`<sup>Optional</sup> <a name="gzipOnInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.gzipOnInput"></a>

```typescript
public readonly gzipOnInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreCookieInput`<sup>Optional</sup> <a name="ignoreCookieInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreCookieInput"></a>

```typescript
public readonly ignoreCookieInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreQueryParamsInput`<sup>Optional</sup> <a name="ignoreQueryParamsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreQueryParamsInput"></a>

```typescript
public readonly ignoreQueryParamsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `proxyCacheMethodsSetInput`<sup>Optional</sup> <a name="proxyCacheMethodsSetInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.proxyCacheMethodsSetInput"></a>

```typescript
public readonly proxyCacheMethodsSetInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryParamsBlacklistInput`<sup>Optional</sup> <a name="queryParamsBlacklistInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsBlacklistInput"></a>

```typescript
public readonly queryParamsBlacklistInput: string[];
```

- *Type:* string[]

---

##### `queryParamsWhitelistInput`<sup>Optional</sup> <a name="queryParamsWhitelistInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsWhitelistInput"></a>

```typescript
public readonly queryParamsWhitelistInput: string[];
```

- *Type:* string[]

---

##### `redirectHttpsToHttpInput`<sup>Optional</sup> <a name="redirectHttpsToHttpInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpsToHttpInput"></a>

```typescript
public readonly redirectHttpsToHttpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `redirectHttpToHttpsInput`<sup>Optional</sup> <a name="redirectHttpToHttpsInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpToHttpsInput"></a>

```typescript
public readonly redirectHttpToHttpsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sliceInput`<sup>Optional</sup> <a name="sliceInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.sliceInput"></a>

```typescript
public readonly sliceInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `staticRequestHeadersInput`<sup>Optional</sup> <a name="staticRequestHeadersInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticRequestHeadersInput"></a>

```typescript
public readonly staticRequestHeadersInput: string[];
```

- *Type:* string[]

---

##### `staticResponseHeadersInput`<sup>Optional</sup> <a name="staticResponseHeadersInput" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticResponseHeadersInput"></a>

```typescript
public readonly staticResponseHeadersInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `allowedHttpMethods`<sup>Required</sup> <a name="allowedHttpMethods" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.allowedHttpMethods"></a>

```typescript
public readonly allowedHttpMethods: string[];
```

- *Type:* string[]

---

##### `browserCacheSettings`<sup>Required</sup> <a name="browserCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.browserCacheSettings"></a>

```typescript
public readonly browserCacheSettings: number;
```

- *Type:* number

---

##### `cacheHttpHeaders`<sup>Required</sup> <a name="cacheHttpHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cacheHttpHeaders"></a>

```typescript
public readonly cacheHttpHeaders: string[];
```

- *Type:* string[]

---

##### `cors`<sup>Required</sup> <a name="cors" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.cors"></a>

```typescript
public readonly cors: string[];
```

- *Type:* string[]

---

##### `customHostHeader`<sup>Required</sup> <a name="customHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customHostHeader"></a>

```typescript
public readonly customHostHeader: string;
```

- *Type:* string

---

##### `customServerName`<sup>Required</sup> <a name="customServerName" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.customServerName"></a>

```typescript
public readonly customServerName: string;
```

- *Type:* string

---

##### `disableCache`<sup>Required</sup> <a name="disableCache" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableCache"></a>

```typescript
public readonly disableCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `disableProxyForceRanges`<sup>Required</sup> <a name="disableProxyForceRanges" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.disableProxyForceRanges"></a>

```typescript
public readonly disableProxyForceRanges: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `edgeCacheSettings`<sup>Required</sup> <a name="edgeCacheSettings" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.edgeCacheSettings"></a>

```typescript
public readonly edgeCacheSettings: number;
```

- *Type:* number

---

##### `fetchedCompressed`<sup>Required</sup> <a name="fetchedCompressed" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.fetchedCompressed"></a>

```typescript
public readonly fetchedCompressed: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forwardHostHeader`<sup>Required</sup> <a name="forwardHostHeader" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.forwardHostHeader"></a>

```typescript
public readonly forwardHostHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `gzipOn`<sup>Required</sup> <a name="gzipOn" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.gzipOn"></a>

```typescript
public readonly gzipOn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreCookie`<sup>Required</sup> <a name="ignoreCookie" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreCookie"></a>

```typescript
public readonly ignoreCookie: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ignoreQueryParams`<sup>Required</sup> <a name="ignoreQueryParams" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.ignoreQueryParams"></a>

```typescript
public readonly ignoreQueryParams: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `proxyCacheMethodsSet`<sup>Required</sup> <a name="proxyCacheMethodsSet" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.proxyCacheMethodsSet"></a>

```typescript
public readonly proxyCacheMethodsSet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryParamsBlacklist`<sup>Required</sup> <a name="queryParamsBlacklist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsBlacklist"></a>

```typescript
public readonly queryParamsBlacklist: string[];
```

- *Type:* string[]

---

##### `queryParamsWhitelist`<sup>Required</sup> <a name="queryParamsWhitelist" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.queryParamsWhitelist"></a>

```typescript
public readonly queryParamsWhitelist: string[];
```

- *Type:* string[]

---

##### `redirectHttpsToHttp`<sup>Required</sup> <a name="redirectHttpsToHttp" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpsToHttp"></a>

```typescript
public readonly redirectHttpsToHttp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `redirectHttpToHttps`<sup>Required</sup> <a name="redirectHttpToHttps" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.redirectHttpToHttps"></a>

```typescript
public readonly redirectHttpToHttps: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `slice`<sup>Required</sup> <a name="slice" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.slice"></a>

```typescript
public readonly slice: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `staticRequestHeaders`<sup>Required</sup> <a name="staticRequestHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticRequestHeaders"></a>

```typescript
public readonly staticRequestHeaders: string[];
```

- *Type:* string[]

---

##### `staticResponseHeaders`<sup>Required</sup> <a name="staticResponseHeaders" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.staticResponseHeaders"></a>

```typescript
public readonly staticResponseHeaders: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexCdnResourceOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexCdnResourceOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceOptions">DataYandexCdnResourceOptions</a>

---


### DataYandexCdnResourceSslCertificateOutputReference <a name="DataYandexCdnResourceSslCertificateOutputReference" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.Initializer"></a>

```typescript
import { DataYandexCdnResourceSslCertificateOutputReference } from '@cdktf/provider-yandex'

new DataYandexCdnResourceSslCertificateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.resetCertificateManagerId">resetCertificateManagerId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCertificateManagerId` <a name="resetCertificateManagerId" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.resetCertificateManagerId"></a>

```typescript
public resetCertificateManagerId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.certificateManagerIdInput">certificateManagerIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.certificateManagerId">certificateManagerId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `certificateManagerIdInput`<sup>Optional</sup> <a name="certificateManagerIdInput" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.certificateManagerIdInput"></a>

```typescript
public readonly certificateManagerIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `certificateManagerId`<sup>Required</sup> <a name="certificateManagerId" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.certificateManagerId"></a>

```typescript
public readonly certificateManagerId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexCdnResourceSslCertificateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexCdnResourceSslCertificate;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexCdnResourceSslCertificate">DataYandexCdnResourceSslCertificate</a>

---


### DataYandexComputeDiskDiskPlacementPolicyOutputReference <a name="DataYandexComputeDiskDiskPlacementPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeDiskDiskPlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeDiskDiskPlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupIdInput">diskPlacementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupId">diskPlacementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskPlacementGroupIdInput`<sup>Optional</sup> <a name="diskPlacementGroupIdInput" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupIdInput"></a>

```typescript
public readonly diskPlacementGroupIdInput: string;
```

- *Type:* string

---

##### `diskPlacementGroupId`<sup>Required</sup> <a name="diskPlacementGroupId" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.diskPlacementGroupId"></a>

```typescript
public readonly diskPlacementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeDiskDiskPlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeDiskDiskPlacementPolicy">DataYandexComputeDiskDiskPlacementPolicy</a>

---


### DataYandexComputeInstanceBootDiskInitializeParamsList <a name="DataYandexComputeInstanceBootDiskInitializeParamsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDiskInitializeParamsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceBootDiskInitializeParamsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceBootDiskInitializeParamsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceBootDiskInitializeParamsOutputReference <a name="DataYandexComputeInstanceBootDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceBootDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSize">blockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParams">DataYandexComputeInstanceBootDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `blockSize`<sup>Required</sup> <a name="blockSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.blockSize"></a>

```typescript
public readonly blockSize: number;
```

- *Type:* number

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParams">DataYandexComputeInstanceBootDiskInitializeParams</a>

---


### DataYandexComputeInstanceBootDiskList <a name="DataYandexComputeInstanceBootDiskList" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDiskList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceBootDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceBootDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceBootDiskOutputReference <a name="DataYandexComputeInstanceBootDiskOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceBootDiskOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.autoDelete">autoDelete</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList">DataYandexComputeInstanceBootDiskInitializeParamsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDisk">DataYandexComputeInstanceBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoDelete`<sup>Required</sup> <a name="autoDelete" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.autoDelete"></a>

```typescript
public readonly autoDelete: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: DataYandexComputeInstanceBootDiskInitializeParamsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskInitializeParamsList">DataYandexComputeInstanceBootDiskInitializeParamsList</a>

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceBootDisk">DataYandexComputeInstanceBootDisk</a>

---


### DataYandexComputeInstanceGroupAllocationPolicyList <a name="DataYandexComputeInstanceGroupAllocationPolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupAllocationPolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupAllocationPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupAllocationPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupAllocationPolicyOutputReference <a name="DataYandexComputeInstanceGroupAllocationPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.zones">zones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicy">DataYandexComputeInstanceGroupAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupAllocationPolicy">DataYandexComputeInstanceGroupAllocationPolicy</a>

---


### DataYandexComputeInstanceGroupApplicationBalancerStateList <a name="DataYandexComputeInstanceGroupApplicationBalancerStateList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationBalancerStateList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupApplicationBalancerStateList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference <a name="DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerState">DataYandexComputeInstanceGroupApplicationBalancerState</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerStateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupApplicationBalancerState;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationBalancerState">DataYandexComputeInstanceGroupApplicationBalancerState</a>

---


### DataYandexComputeInstanceGroupApplicationLoadBalancerList <a name="DataYandexComputeInstanceGroupApplicationLoadBalancerList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationLoadBalancerList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupApplicationLoadBalancerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference <a name="DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabels">targetGroupLabels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancer">DataYandexComputeInstanceGroupApplicationLoadBalancer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDuration`<sup>Required</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupDescription`<sup>Required</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `targetGroupLabels`<sup>Required</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `targetGroupName`<sup>Required</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupApplicationLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupApplicationLoadBalancer">DataYandexComputeInstanceGroupApplicationLoadBalancer</a>

---


### DataYandexComputeInstanceGroupDeployPolicyList <a name="DataYandexComputeInstanceGroupDeployPolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupDeployPolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupDeployPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupDeployPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupDeployPolicyOutputReference <a name="DataYandexComputeInstanceGroupDeployPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupDeployPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupDeployPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxCreating">maxCreating</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxDeleting">maxDeleting</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.startupDuration">startupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.strategy">strategy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicy">DataYandexComputeInstanceGroupDeployPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxCreating`<sup>Required</sup> <a name="maxCreating" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxCreating"></a>

```typescript
public readonly maxCreating: number;
```

- *Type:* number

---

##### `maxDeleting`<sup>Required</sup> <a name="maxDeleting" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxDeleting"></a>

```typescript
public readonly maxDeleting: number;
```

- *Type:* number

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

---

##### `startupDuration`<sup>Required</sup> <a name="startupDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.startupDuration"></a>

```typescript
public readonly startupDuration: number;
```

- *Type:* number

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.strategy"></a>

```typescript
public readonly strategy: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupDeployPolicy">DataYandexComputeInstanceGroupDeployPolicy</a>

---


### DataYandexComputeInstanceGroupHealthCheckHttpOptionsList <a name="DataYandexComputeInstanceGroupHealthCheckHttpOptionsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckHttpOptionsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckHttpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference <a name="DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptions">DataYandexComputeInstanceGroupHealthCheckHttpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupHealthCheckHttpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptions">DataYandexComputeInstanceGroupHealthCheckHttpOptions</a>

---


### DataYandexComputeInstanceGroupHealthCheckList <a name="DataYandexComputeInstanceGroupHealthCheckList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupHealthCheckOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupHealthCheckOutputReference <a name="DataYandexComputeInstanceGroupHealthCheckOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.httpOptions">httpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList">DataYandexComputeInstanceGroupHealthCheckHttpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.interval">interval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList">DataYandexComputeInstanceGroupHealthCheckTcpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheck">DataYandexComputeInstanceGroupHealthCheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `httpOptions`<sup>Required</sup> <a name="httpOptions" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.httpOptions"></a>

```typescript
public readonly httpOptions: DataYandexComputeInstanceGroupHealthCheckHttpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckHttpOptionsList">DataYandexComputeInstanceGroupHealthCheckHttpOptionsList</a>

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

---

##### `tcpOptions`<sup>Required</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: DataYandexComputeInstanceGroupHealthCheckTcpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList">DataYandexComputeInstanceGroupHealthCheckTcpOptionsList</a>

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupHealthCheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheck">DataYandexComputeInstanceGroupHealthCheck</a>

---


### DataYandexComputeInstanceGroupHealthCheckTcpOptionsList <a name="DataYandexComputeInstanceGroupHealthCheckTcpOptionsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckTcpOptionsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckTcpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference <a name="DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptions">DataYandexComputeInstanceGroupHealthCheckTcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupHealthCheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupHealthCheckTcpOptions">DataYandexComputeInstanceGroupHealthCheckTcpOptions</a>

---


### DataYandexComputeInstanceGroupInstancesList <a name="DataYandexComputeInstanceGroupInstancesList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstancesList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstancesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstancesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstancesNetworkInterfaceList <a name="DataYandexComputeInstanceGroupInstancesNetworkInterfaceList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstancesNetworkInterfaceList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstancesNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference <a name="DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.index">index</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpVersion">natIpVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterface">DataYandexComputeInstanceGroupInstancesNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.index"></a>

```typescript
public readonly index: number;
```

- *Type:* number

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `natIpVersion`<sup>Required</sup> <a name="natIpVersion" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.natIpVersion"></a>

```typescript
public readonly natIpVersion: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstancesNetworkInterface;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterface">DataYandexComputeInstanceGroupInstancesNetworkInterface</a>

---


### DataYandexComputeInstanceGroupInstancesOutputReference <a name="DataYandexComputeInstanceGroupInstancesOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstancesOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstancesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.instanceId">instanceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList">DataYandexComputeInstanceGroupInstancesNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.status">status</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.statusChangedAt">statusChangedAt</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstances">DataYandexComputeInstanceGroupInstances</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `instanceId`<sup>Required</sup> <a name="instanceId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.instanceId"></a>

```typescript
public readonly instanceId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: DataYandexComputeInstanceGroupInstancesNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesNetworkInterfaceList">DataYandexComputeInstanceGroupInstancesNetworkInterfaceList</a>

---

##### `status`<sup>Required</sup> <a name="status" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

---

##### `statusChangedAt`<sup>Required</sup> <a name="statusChangedAt" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.statusChangedAt"></a>

```typescript
public readonly statusChangedAt: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstancesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstances;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstances">DataYandexComputeInstanceGroupInstances</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams">DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParams</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateBootDiskList <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDiskList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDiskList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateBootDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList">DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDisk">DataYandexComputeInstanceGroupInstanceTemplateBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList">DataYandexComputeInstanceGroupInstanceTemplateBootDiskInitializeParamsList</a>

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDisk">DataYandexComputeInstanceGroupInstanceTemplateBootDisk</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateList <a name="DataYandexComputeInstanceGroupInstanceTemplateList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecord</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecord</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecord</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecord">dnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecord">natDnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkId">networkId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsRecord`<sup>Required</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceDnsRecordList</a>

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `ipv6DnsRecord`<sup>Required</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceIpv6DnsRecordList</a>

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `natDnsRecord`<sup>Required</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceNatDnsRecordList</a>

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `networkId`<sup>Required</sup> <a name="networkId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.networkId"></a>

```typescript
public readonly networkId: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterface</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings">DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings">DataYandexComputeInstanceGroupInstanceTemplateNetworkSettings</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList">DataYandexComputeInstanceGroupInstanceTemplateBootDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.hostname">hostname</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.metadata">metadata</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettings">networkSettings</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList">DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList">DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList">DataYandexComputeInstanceGroupInstanceTemplateResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList">DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDisk">secondaryDisk</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplate">DataYandexComputeInstanceGroupInstanceTemplate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.bootDisk"></a>

```typescript
public readonly bootDisk: DataYandexComputeInstanceGroupInstanceTemplateBootDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateBootDiskList">DataYandexComputeInstanceGroupInstanceTemplateBootDiskList</a>

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `hostname`<sup>Required</sup> <a name="hostname" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList">DataYandexComputeInstanceGroupInstanceTemplateNetworkInterfaceList</a>

---

##### `networkSettings`<sup>Required</sup> <a name="networkSettings" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.networkSettings"></a>

```typescript
public readonly networkSettings: DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList">DataYandexComputeInstanceGroupInstanceTemplateNetworkSettingsList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList">DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList</a>

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexComputeInstanceGroupInstanceTemplateResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList">DataYandexComputeInstanceGroupInstanceTemplateResourcesList</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList">DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList</a>

---

##### `secondaryDisk`<sup>Required</sup> <a name="secondaryDisk" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.secondaryDisk"></a>

```typescript
public readonly secondaryDisk: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList</a>

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplate">DataYandexComputeInstanceGroupInstanceTemplate</a>

---


### DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList <a name="DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy">DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy">DataYandexComputeInstanceGroupInstanceTemplatePlacementPolicy</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateResourcesList <a name="DataYandexComputeInstanceGroupInstanceTemplateResourcesList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateResourcesList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResources">DataYandexComputeInstanceGroupInstanceTemplateResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateResources">DataYandexComputeInstanceGroupInstanceTemplateResources</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList <a name="DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy">DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy">DataYandexComputeInstanceGroupInstanceTemplateSchedulingPolicy</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageId">imageId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotId">snapshotId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `imageId`<sup>Required</sup> <a name="imageId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.imageId"></a>

```typescript
public readonly imageId: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `snapshotId`<sup>Required</sup> <a name="snapshotId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.snapshotId"></a>

```typescript
public readonly snapshotId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParams</a>

---


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference <a name="DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParams">initializeParams</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `initializeParams`<sup>Required</sup> <a name="initializeParams" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.initializeParams"></a>

```typescript
public readonly initializeParams: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskInitializeParamsList</a>

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk">DataYandexComputeInstanceGroupInstanceTemplateSecondaryDisk</a>

---


### DataYandexComputeInstanceGroupLoadBalancerList <a name="DataYandexComputeInstanceGroupLoadBalancerList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancerList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupLoadBalancerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupLoadBalancerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupLoadBalancerOutputReference <a name="DataYandexComputeInstanceGroupLoadBalancerOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancerOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupLoadBalancerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDuration">maxOpeningTrafficDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescription">targetGroupDescription</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabels">targetGroupLabels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupName">targetGroupName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancer">DataYandexComputeInstanceGroupLoadBalancer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxOpeningTrafficDuration`<sup>Required</sup> <a name="maxOpeningTrafficDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.maxOpeningTrafficDuration"></a>

```typescript
public readonly maxOpeningTrafficDuration: number;
```

- *Type:* number

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupDescription`<sup>Required</sup> <a name="targetGroupDescription" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupDescription"></a>

```typescript
public readonly targetGroupDescription: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `targetGroupLabels`<sup>Required</sup> <a name="targetGroupLabels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupLabels"></a>

```typescript
public readonly targetGroupLabels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `targetGroupName`<sup>Required</sup> <a name="targetGroupName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.targetGroupName"></a>

```typescript
public readonly targetGroupName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupLoadBalancer;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancer">DataYandexComputeInstanceGroupLoadBalancer</a>

---


### DataYandexComputeInstanceGroupLoadBalancerStateList <a name="DataYandexComputeInstanceGroupLoadBalancerStateList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancerStateList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupLoadBalancerStateList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupLoadBalancerStateOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupLoadBalancerStateOutputReference <a name="DataYandexComputeInstanceGroupLoadBalancerStateOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupLoadBalancerStateOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupLoadBalancerStateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.statusMessage">statusMessage</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerState">DataYandexComputeInstanceGroupLoadBalancerState</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `statusMessage`<sup>Required</sup> <a name="statusMessage" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.statusMessage"></a>

```typescript
public readonly statusMessage: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerStateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupLoadBalancerState;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupLoadBalancerState">DataYandexComputeInstanceGroupLoadBalancerState</a>

---


### DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList <a name="DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricName">metricName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricType">metricType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleType">ruleType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.service">service</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.target">target</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule">DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

---

##### `service`<sup>Required</sup> <a name="service" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule">DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRule</a>

---


### DataYandexComputeInstanceGroupScalePolicyAutoScaleList <a name="DataYandexComputeInstanceGroupScalePolicyAutoScaleList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScaleList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyAutoScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRule">customRule</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList">DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSize">initialSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSize">maxSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScale">DataYandexComputeInstanceGroupScalePolicyAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `customRule`<sup>Required</sup> <a name="customRule" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.customRule"></a>

```typescript
public readonly customRule: DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList">DataYandexComputeInstanceGroupScalePolicyAutoScaleCustomRuleList</a>

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

---

##### `maxSize`<sup>Required</sup> <a name="maxSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `minZoneSize`<sup>Required</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScale">DataYandexComputeInstanceGroupScalePolicyAutoScale</a>

---


### DataYandexComputeInstanceGroupScalePolicyFixedScaleList <a name="DataYandexComputeInstanceGroupScalePolicyFixedScaleList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyFixedScaleList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyFixedScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScale">DataYandexComputeInstanceGroupScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScale">DataYandexComputeInstanceGroupScalePolicyFixedScale</a>

---


### DataYandexComputeInstanceGroupScalePolicyList <a name="DataYandexComputeInstanceGroupScalePolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList">DataYandexComputeInstanceGroupScalePolicyAutoScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList">DataYandexComputeInstanceGroupScalePolicyFixedScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.testAutoScale">testAutoScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicy">DataYandexComputeInstanceGroupScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoScale`<sup>Required</sup> <a name="autoScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.autoScale"></a>

```typescript
public readonly autoScale: DataYandexComputeInstanceGroupScalePolicyAutoScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyAutoScaleList">DataYandexComputeInstanceGroupScalePolicyAutoScaleList</a>

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: DataYandexComputeInstanceGroupScalePolicyFixedScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyFixedScaleList">DataYandexComputeInstanceGroupScalePolicyFixedScaleList</a>

---

##### `testAutoScale`<sup>Required</sup> <a name="testAutoScale" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.testAutoScale"></a>

```typescript
public readonly testAutoScale: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicy">DataYandexComputeInstanceGroupScalePolicy</a>

---


### DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderId">folderId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricName">metricName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricType">metricType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleType">ruleType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.service">service</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.target">target</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `folderId`<sup>Required</sup> <a name="folderId" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.folderId"></a>

```typescript
public readonly folderId: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `metricName`<sup>Required</sup> <a name="metricName" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricName"></a>

```typescript
public readonly metricName: string;
```

- *Type:* string

---

##### `metricType`<sup>Required</sup> <a name="metricType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.metricType"></a>

```typescript
public readonly metricType: string;
```

- *Type:* string

---

##### `ruleType`<sup>Required</sup> <a name="ruleType" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.ruleType"></a>

```typescript
public readonly ruleType: string;
```

- *Type:* string

---

##### `service`<sup>Required</sup> <a name="service" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

---

##### `target`<sup>Required</sup> <a name="target" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.target"></a>

```typescript
public readonly target: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRule</a>

---


### DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference <a name="DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRule">customRule</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSize">initialSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSize">maxSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSize">minZoneSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScale">DataYandexComputeInstanceGroupScalePolicyTestAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `customRule`<sup>Required</sup> <a name="customRule" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.customRule"></a>

```typescript
public readonly customRule: DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList">DataYandexComputeInstanceGroupScalePolicyTestAutoScaleCustomRuleList</a>

---

##### `initialSize`<sup>Required</sup> <a name="initialSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.initialSize"></a>

```typescript
public readonly initialSize: number;
```

- *Type:* number

---

##### `maxSize`<sup>Required</sup> <a name="maxSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.maxSize"></a>

```typescript
public readonly maxSize: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `minZoneSize`<sup>Required</sup> <a name="minZoneSize" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.minZoneSize"></a>

```typescript
public readonly minZoneSize: number;
```

- *Type:* number

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceGroupScalePolicyTestAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceGroupScalePolicyTestAutoScale">DataYandexComputeInstanceGroupScalePolicyTestAutoScale</a>

---


### DataYandexComputeInstanceNetworkInterfaceDnsRecordList <a name="DataYandexComputeInstanceNetworkInterfaceDnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceDnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference <a name="DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecord">DataYandexComputeInstanceNetworkInterfaceDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceNetworkInterfaceDnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecord">DataYandexComputeInstanceNetworkInterfaceDnsRecord</a>

---


### DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList <a name="DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference <a name="DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord">DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord">DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecord</a>

---


### DataYandexComputeInstanceNetworkInterfaceList <a name="DataYandexComputeInstanceNetworkInterfaceList" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList <a name="DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference <a name="DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId">dnsZoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptr">ptr</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttl">ttl</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecord">DataYandexComputeInstanceNetworkInterfaceNatDnsRecord</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsZoneId`<sup>Required</sup> <a name="dnsZoneId" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.dnsZoneId"></a>

```typescript
public readonly dnsZoneId: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `ptr`<sup>Required</sup> <a name="ptr" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ptr"></a>

```typescript
public readonly ptr: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ttl`<sup>Required</sup> <a name="ttl" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.ttl"></a>

```typescript
public readonly ttl: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceNetworkInterfaceNatDnsRecord;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecord">DataYandexComputeInstanceNetworkInterfaceNatDnsRecord</a>

---


### DataYandexComputeInstanceNetworkInterfaceOutputReference <a name="DataYandexComputeInstanceNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.dnsRecord">dnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList">DataYandexComputeInstanceNetworkInterfaceDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.index">index</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipAddress">ipAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6Address">ipv6Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecord">ipv6DnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList">DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.macAddress">macAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecord">natDnsRecord</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList">DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natIpAddress">natIpAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natIpVersion">natIpVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterface">DataYandexComputeInstanceNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dnsRecord`<sup>Required</sup> <a name="dnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.dnsRecord"></a>

```typescript
public readonly dnsRecord: DataYandexComputeInstanceNetworkInterfaceDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceDnsRecordList">DataYandexComputeInstanceNetworkInterfaceDnsRecordList</a>

---

##### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.index"></a>

```typescript
public readonly index: number;
```

- *Type:* number

---

##### `ipAddress`<sup>Required</sup> <a name="ipAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipAddress"></a>

```typescript
public readonly ipAddress: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6Address`<sup>Required</sup> <a name="ipv6Address" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6Address"></a>

```typescript
public readonly ipv6Address: string;
```

- *Type:* string

---

##### `ipv6DnsRecord`<sup>Required</sup> <a name="ipv6DnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.ipv6DnsRecord"></a>

```typescript
public readonly ipv6DnsRecord: DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList">DataYandexComputeInstanceNetworkInterfaceIpv6DnsRecordList</a>

---

##### `macAddress`<sup>Required</sup> <a name="macAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.macAddress"></a>

```typescript
public readonly macAddress: string;
```

- *Type:* string

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `natDnsRecord`<sup>Required</sup> <a name="natDnsRecord" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natDnsRecord"></a>

```typescript
public readonly natDnsRecord: DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList">DataYandexComputeInstanceNetworkInterfaceNatDnsRecordList</a>

---

##### `natIpAddress`<sup>Required</sup> <a name="natIpAddress" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natIpAddress"></a>

```typescript
public readonly natIpAddress: string;
```

- *Type:* string

---

##### `natIpVersion`<sup>Required</sup> <a name="natIpVersion" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.natIpVersion"></a>

```typescript
public readonly natIpVersion: string;
```

- *Type:* string

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceNetworkInterface;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceNetworkInterface">DataYandexComputeInstanceNetworkInterface</a>

---


### DataYandexComputeInstancePlacementPolicyHostAffinityRulesList <a name="DataYandexComputeInstancePlacementPolicyHostAffinityRulesList" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer"></a>

```typescript
import { DataYandexComputeInstancePlacementPolicyHostAffinityRulesList } from '@cdktf/provider-yandex'

new DataYandexComputeInstancePlacementPolicyHostAffinityRulesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]

---


### DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference <a name="DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetKey">resetKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetOp">resetOp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetValues">resetValues</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetKey` <a name="resetKey" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetKey"></a>

```typescript
public resetKey(): void
```

##### `resetOp` <a name="resetOp" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetOp"></a>

```typescript
public resetOp(): void
```

##### `resetValues` <a name="resetValues" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.resetValues"></a>

```typescript
public resetValues(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.keyInput">keyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.opInput">opInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.valuesInput">valuesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.key">key</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.op">op</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.values">values</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `keyInput`<sup>Optional</sup> <a name="keyInput" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.keyInput"></a>

```typescript
public readonly keyInput: string;
```

- *Type:* string

---

##### `opInput`<sup>Optional</sup> <a name="opInput" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.opInput"></a>

```typescript
public readonly opInput: string;
```

- *Type:* string

---

##### `valuesInput`<sup>Optional</sup> <a name="valuesInput" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.valuesInput"></a>

```typescript
public readonly valuesInput: string[];
```

- *Type:* string[]

---

##### `key`<sup>Required</sup> <a name="key" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

---

##### `op`<sup>Required</sup> <a name="op" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.op"></a>

```typescript
public readonly op: string;
```

- *Type:* string

---

##### `values`<sup>Required</sup> <a name="values" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>

---


### DataYandexComputeInstancePlacementPolicyOutputReference <a name="DataYandexComputeInstancePlacementPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstancePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstancePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.putHostAffinityRules">putHostAffinityRules</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resetHostAffinityRules">resetHostAffinityRules</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resetPlacementGroupId">resetPlacementGroupId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHostAffinityRules` <a name="putHostAffinityRules" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.putHostAffinityRules"></a>

```typescript
public putHostAffinityRules(value: IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.putHostAffinityRules.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]

---

##### `resetHostAffinityRules` <a name="resetHostAffinityRules" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resetHostAffinityRules"></a>

```typescript
public resetHostAffinityRules(): void
```

##### `resetPlacementGroupId` <a name="resetPlacementGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.resetPlacementGroupId"></a>

```typescript
public resetPlacementGroupId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.hostAffinityRules">hostAffinityRules</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList">DataYandexComputeInstancePlacementPolicyHostAffinityRulesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.hostAffinityRulesInput">hostAffinityRulesInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.placementGroupIdInput">placementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hostAffinityRules`<sup>Required</sup> <a name="hostAffinityRules" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.hostAffinityRules"></a>

```typescript
public readonly hostAffinityRules: DataYandexComputeInstancePlacementPolicyHostAffinityRulesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRulesList">DataYandexComputeInstancePlacementPolicyHostAffinityRulesList</a>

---

##### `hostAffinityRulesInput`<sup>Optional</sup> <a name="hostAffinityRulesInput" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.hostAffinityRulesInput"></a>

```typescript
public readonly hostAffinityRulesInput: IResolvable | DataYandexComputeInstancePlacementPolicyHostAffinityRules[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyHostAffinityRules">DataYandexComputeInstancePlacementPolicyHostAffinityRules</a>[]

---

##### `placementGroupIdInput`<sup>Optional</sup> <a name="placementGroupIdInput" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.placementGroupIdInput"></a>

```typescript
public readonly placementGroupIdInput: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstancePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstancePlacementPolicy">DataYandexComputeInstancePlacementPolicy</a>

---


### DataYandexComputeInstanceResourcesList <a name="DataYandexComputeInstanceResourcesList" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceResourcesList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceResourcesOutputReference <a name="DataYandexComputeInstanceResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResources">DataYandexComputeInstanceResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceResources">DataYandexComputeInstanceResources</a>

---


### DataYandexComputeInstanceSchedulingPolicyList <a name="DataYandexComputeInstanceSchedulingPolicyList" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSchedulingPolicyList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceSchedulingPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceSchedulingPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceSchedulingPolicyOutputReference <a name="DataYandexComputeInstanceSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicy">DataYandexComputeInstanceSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSchedulingPolicy">DataYandexComputeInstanceSchedulingPolicy</a>

---


### DataYandexComputeInstanceSecondaryDiskList <a name="DataYandexComputeInstanceSecondaryDiskList" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSecondaryDiskList } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceSecondaryDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.get"></a>

```typescript
public get(index: number): DataYandexComputeInstanceSecondaryDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexComputeInstanceSecondaryDiskOutputReference <a name="DataYandexComputeInstanceSecondaryDiskOutputReference" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer"></a>

```typescript
import { DataYandexComputeInstanceSecondaryDiskOutputReference } from '@cdktf/provider-yandex'

new DataYandexComputeInstanceSecondaryDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.autoDelete">autoDelete</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.deviceName">deviceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.diskId">diskId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.mode">mode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDisk">DataYandexComputeInstanceSecondaryDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoDelete`<sup>Required</sup> <a name="autoDelete" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.autoDelete"></a>

```typescript
public readonly autoDelete: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `deviceName`<sup>Required</sup> <a name="deviceName" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.deviceName"></a>

```typescript
public readonly deviceName: string;
```

- *Type:* string

---

##### `diskId`<sup>Required</sup> <a name="diskId" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.diskId"></a>

```typescript
public readonly diskId: string;
```

- *Type:* string

---

##### `mode`<sup>Required</sup> <a name="mode" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.mode"></a>

```typescript
public readonly mode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexComputeInstanceSecondaryDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexComputeInstanceSecondaryDisk">DataYandexComputeInstanceSecondaryDisk</a>

---


### DataYandexDataprocClusterClusterConfigHadoopList <a name="DataYandexDataprocClusterClusterConfigHadoopList" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigHadoopList } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigHadoopList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.get"></a>

```typescript
public get(index: number): DataYandexDataprocClusterClusterConfigHadoopOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexDataprocClusterClusterConfigHadoopOutputReference <a name="DataYandexDataprocClusterClusterConfigHadoopOutputReference" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigHadoopOutputReference } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigHadoopOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.properties">properties</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.services">services</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeys">sshPublicKeys</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoop">DataYandexDataprocClusterClusterConfigHadoop</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `properties`<sup>Required</sup> <a name="properties" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.properties"></a>

```typescript
public readonly properties: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `services`<sup>Required</sup> <a name="services" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.services"></a>

```typescript
public readonly services: string[];
```

- *Type:* string[]

---

##### `sshPublicKeys`<sup>Required</sup> <a name="sshPublicKeys" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.sshPublicKeys"></a>

```typescript
public readonly sshPublicKeys: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexDataprocClusterClusterConfigHadoop;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoop">DataYandexDataprocClusterClusterConfigHadoop</a>

---


### DataYandexDataprocClusterClusterConfigList <a name="DataYandexDataprocClusterClusterConfigList" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigList } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.get"></a>

```typescript
public get(index: number): DataYandexDataprocClusterClusterConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexDataprocClusterClusterConfigOutputReference <a name="DataYandexDataprocClusterClusterConfigOutputReference" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.hadoop">hadoop</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList">DataYandexDataprocClusterClusterConfigHadoopList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.subclusterSpec">subclusterSpec</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList">DataYandexDataprocClusterClusterConfigSubclusterSpecList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.versionId">versionId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfig">DataYandexDataprocClusterClusterConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hadoop`<sup>Required</sup> <a name="hadoop" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.hadoop"></a>

```typescript
public readonly hadoop: DataYandexDataprocClusterClusterConfigHadoopList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigHadoopList">DataYandexDataprocClusterClusterConfigHadoopList</a>

---

##### `subclusterSpec`<sup>Required</sup> <a name="subclusterSpec" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.subclusterSpec"></a>

```typescript
public readonly subclusterSpec: DataYandexDataprocClusterClusterConfigSubclusterSpecList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList">DataYandexDataprocClusterClusterConfigSubclusterSpecList</a>

---

##### `versionId`<sup>Required</sup> <a name="versionId" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.versionId"></a>

```typescript
public readonly versionId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexDataprocClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfig">DataYandexDataprocClusterClusterConfig</a>

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.get"></a>

```typescript
public get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTarget">cpuUtilizationTarget</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeout">decommissionTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCount">maxHostsCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDuration">measurementDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptible">preemptible</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDuration">stabilizationDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDuration">warmupDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cpuUtilizationTarget`<sup>Required</sup> <a name="cpuUtilizationTarget" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.cpuUtilizationTarget"></a>

```typescript
public readonly cpuUtilizationTarget: number;
```

- *Type:* number

---

##### `decommissionTimeout`<sup>Required</sup> <a name="decommissionTimeout" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.decommissionTimeout"></a>

```typescript
public readonly decommissionTimeout: number;
```

- *Type:* number

---

##### `maxHostsCount`<sup>Required</sup> <a name="maxHostsCount" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.maxHostsCount"></a>

```typescript
public readonly maxHostsCount: number;
```

- *Type:* number

---

##### `measurementDuration`<sup>Required</sup> <a name="measurementDuration" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.measurementDuration"></a>

```typescript
public readonly measurementDuration: number;
```

- *Type:* number

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `stabilizationDuration`<sup>Required</sup> <a name="stabilizationDuration" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.stabilizationDuration"></a>

```typescript
public readonly stabilizationDuration: number;
```

- *Type:* number

---

##### `warmupDuration`<sup>Required</sup> <a name="warmupDuration" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.warmupDuration"></a>

```typescript
public readonly warmupDuration: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig">DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfig</a>

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecList <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecList" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecList } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.get"></a>

```typescript
public get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfig">autoscalingConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList">DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCount">hostsCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList">DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpec">DataYandexDataprocClusterClusterConfigSubclusterSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `autoscalingConfig`<sup>Required</sup> <a name="autoscalingConfig" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.autoscalingConfig"></a>

```typescript
public readonly autoscalingConfig: DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList">DataYandexDataprocClusterClusterConfigSubclusterSpecAutoscalingConfigList</a>

---

##### `hostsCount`<sup>Required</sup> <a name="hostsCount" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.hostsCount"></a>

```typescript
public readonly hostsCount: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList">DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList</a>

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexDataprocClusterClusterConfigSubclusterSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpec">DataYandexDataprocClusterClusterConfigSubclusterSpec</a>

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.get"></a>

```typescript
public get(index: number): DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference <a name="DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResources">DataYandexDataprocClusterClusterConfigSubclusterSpecResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexDataprocClusterClusterConfigSubclusterSpecResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexDataprocClusterClusterConfigSubclusterSpecResources">DataYandexDataprocClusterClusterConfigSubclusterSpecResources</a>

---


### DataYandexDnsZoneTimeoutsOutputReference <a name="DataYandexDnsZoneTimeoutsOutputReference" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.Initializer"></a>

```typescript
import { DataYandexDnsZoneTimeoutsOutputReference } from '@cdktf/provider-yandex'

new DataYandexDnsZoneTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexDnsZoneTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexDnsZoneTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexDnsZoneTimeouts">DataYandexDnsZoneTimeouts</a>

---


### DataYandexFunctionScalingPolicyPolicyList <a name="DataYandexFunctionScalingPolicyPolicyList" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer"></a>

```typescript
import { DataYandexFunctionScalingPolicyPolicyList } from '@cdktf/provider-yandex'

new DataYandexFunctionScalingPolicyPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.get"></a>

```typescript
public get(index: number): DataYandexFunctionScalingPolicyPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexFunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>[]

---


### DataYandexFunctionScalingPolicyPolicyOutputReference <a name="DataYandexFunctionScalingPolicyPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionScalingPolicyPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionScalingPolicyPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resetZoneInstancesLimit">resetZoneInstancesLimit</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resetZoneRequestsLimit">resetZoneRequestsLimit</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetZoneInstancesLimit` <a name="resetZoneInstancesLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resetZoneInstancesLimit"></a>

```typescript
public resetZoneInstancesLimit(): void
```

##### `resetZoneRequestsLimit` <a name="resetZoneRequestsLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.resetZoneRequestsLimit"></a>

```typescript
public resetZoneRequestsLimit(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.tag">tag</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimitInput">zoneInstancesLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimitInput">zoneRequestsLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimit">zoneInstancesLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimit">zoneRequestsLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tag`<sup>Required</sup> <a name="tag" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

---

##### `zoneInstancesLimitInput`<sup>Optional</sup> <a name="zoneInstancesLimitInput" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimitInput"></a>

```typescript
public readonly zoneInstancesLimitInput: number;
```

- *Type:* number

---

##### `zoneRequestsLimitInput`<sup>Optional</sup> <a name="zoneRequestsLimitInput" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimitInput"></a>

```typescript
public readonly zoneRequestsLimitInput: number;
```

- *Type:* number

---

##### `zoneInstancesLimit`<sup>Required</sup> <a name="zoneInstancesLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimit"></a>

```typescript
public readonly zoneInstancesLimit: number;
```

- *Type:* number

---

##### `zoneRequestsLimit`<sup>Required</sup> <a name="zoneRequestsLimit" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimit"></a>

```typescript
public readonly zoneRequestsLimit: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexFunctionScalingPolicyPolicy;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexFunctionScalingPolicyPolicy">DataYandexFunctionScalingPolicyPolicy</a>

---


### DataYandexFunctionTriggerDlqList <a name="DataYandexFunctionTriggerDlqList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerDlqList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerDlqList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerDlqOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerDlqOutputReference <a name="DataYandexFunctionTriggerDlqOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerDlqOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerDlqOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.queueId">queueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlq">DataYandexFunctionTriggerDlq</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerDlqOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerDlq;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerDlq">DataYandexFunctionTriggerDlq</a>

---


### DataYandexFunctionTriggerFunctionList <a name="DataYandexFunctionTriggerFunctionList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerFunctionList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerFunctionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerFunctionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerFunctionOutputReference <a name="DataYandexFunctionTriggerFunctionOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerFunctionOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerFunctionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.retryAttempts">retryAttempts</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.retryInterval">retryInterval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.tag">tag</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunction">DataYandexFunctionTriggerFunction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `retryAttempts`<sup>Required</sup> <a name="retryAttempts" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.retryAttempts"></a>

```typescript
public readonly retryAttempts: string;
```

- *Type:* string

---

##### `retryInterval`<sup>Required</sup> <a name="retryInterval" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.retryInterval"></a>

```typescript
public readonly retryInterval: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `tag`<sup>Required</sup> <a name="tag" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerFunctionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerFunction;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerFunction">DataYandexFunctionTriggerFunction</a>

---


### DataYandexFunctionTriggerIotList <a name="DataYandexFunctionTriggerIotList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerIotList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerIotList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerIotOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerIotOutputReference <a name="DataYandexFunctionTriggerIotOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerIotOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerIotOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.deviceId">deviceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.topic">topic</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIot">DataYandexFunctionTriggerIot</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `deviceId`<sup>Required</sup> <a name="deviceId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* string

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

##### `topic`<sup>Required</sup> <a name="topic" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerIotOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerIot;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerIot">DataYandexFunctionTriggerIot</a>

---


### DataYandexFunctionTriggerLoggingList <a name="DataYandexFunctionTriggerLoggingList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLoggingList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerLoggingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerLoggingOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerLoggingOutputReference <a name="DataYandexFunctionTriggerLoggingOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLoggingOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.groupId">groupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.levels">levels</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.resourceIds">resourceIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.resourceTypes">resourceTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogging">DataYandexFunctionTriggerLogging</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

---

##### `levels`<sup>Required</sup> <a name="levels" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.levels"></a>

```typescript
public readonly levels: string[];
```

- *Type:* string[]

---

##### `resourceIds`<sup>Required</sup> <a name="resourceIds" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.resourceIds"></a>

```typescript
public readonly resourceIds: string[];
```

- *Type:* string[]

---

##### `resourceTypes`<sup>Required</sup> <a name="resourceTypes" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.resourceTypes"></a>

```typescript
public readonly resourceTypes: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerLogging;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogging">DataYandexFunctionTriggerLogging</a>

---


### DataYandexFunctionTriggerLogGroupList <a name="DataYandexFunctionTriggerLogGroupList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLogGroupList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerLogGroupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerLogGroupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerLogGroupOutputReference <a name="DataYandexFunctionTriggerLogGroupOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerLogGroupOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerLogGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.logGroupIds">logGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroup">DataYandexFunctionTriggerLogGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `logGroupIds`<sup>Required</sup> <a name="logGroupIds" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.logGroupIds"></a>

```typescript
public readonly logGroupIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerLogGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerLogGroup">DataYandexFunctionTriggerLogGroup</a>

---


### DataYandexFunctionTriggerMessageQueueList <a name="DataYandexFunctionTriggerMessageQueueList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerMessageQueueList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerMessageQueueList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerMessageQueueOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerMessageQueueOutputReference <a name="DataYandexFunctionTriggerMessageQueueOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerMessageQueueOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerMessageQueueOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.queueId">queueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.visibilityTimeout">visibilityTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueue">DataYandexFunctionTriggerMessageQueue</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `visibilityTimeout`<sup>Required</sup> <a name="visibilityTimeout" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.visibilityTimeout"></a>

```typescript
public readonly visibilityTimeout: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueueOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerMessageQueue;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerMessageQueue">DataYandexFunctionTriggerMessageQueue</a>

---


### DataYandexFunctionTriggerObjectStorageList <a name="DataYandexFunctionTriggerObjectStorageList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerObjectStorageList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerObjectStorageList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerObjectStorageOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerObjectStorageOutputReference <a name="DataYandexFunctionTriggerObjectStorageOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerObjectStorageOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerObjectStorageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.bucketId">bucketId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.create">create</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.delete">delete</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.suffix">suffix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.update">update</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorage">DataYandexFunctionTriggerObjectStorage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bucketId`<sup>Required</sup> <a name="bucketId" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.bucketId"></a>

```typescript
public readonly bucketId: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.create"></a>

```typescript
public readonly create: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.delete"></a>

```typescript
public readonly delete: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `suffix`<sup>Required</sup> <a name="suffix" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.suffix"></a>

```typescript
public readonly suffix: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.update"></a>

```typescript
public readonly update: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerObjectStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerObjectStorage">DataYandexFunctionTriggerObjectStorage</a>

---


### DataYandexFunctionTriggerTimerList <a name="DataYandexFunctionTriggerTimerList" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerTimerList } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerTimerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.get"></a>

```typescript
public get(index: number): DataYandexFunctionTriggerTimerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexFunctionTriggerTimerOutputReference <a name="DataYandexFunctionTriggerTimerOutputReference" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer"></a>

```typescript
import { DataYandexFunctionTriggerTimerOutputReference } from '@cdktf/provider-yandex'

new DataYandexFunctionTriggerTimerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.cronExpression">cronExpression</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimer">DataYandexFunctionTriggerTimer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cronExpression`<sup>Required</sup> <a name="cronExpression" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.cronExpression"></a>

```typescript
public readonly cronExpression: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexFunctionTriggerTimerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexFunctionTriggerTimer;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexFunctionTriggerTimer">DataYandexFunctionTriggerTimer</a>

---


### DataYandexIamPolicyBindingList <a name="DataYandexIamPolicyBindingList" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer"></a>

```typescript
import { DataYandexIamPolicyBindingList } from '@cdktf/provider-yandex'

new DataYandexIamPolicyBindingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.get"></a>

```typescript
public get(index: number): DataYandexIamPolicyBindingOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexIamPolicyBinding[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>[]

---


### DataYandexIamPolicyBindingOutputReference <a name="DataYandexIamPolicyBindingOutputReference" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer"></a>

```typescript
import { DataYandexIamPolicyBindingOutputReference } from '@cdktf/provider-yandex'

new DataYandexIamPolicyBindingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.membersInput">membersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.members">members</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `membersInput`<sup>Optional</sup> <a name="membersInput" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.membersInput"></a>

```typescript
public readonly membersInput: string[];
```

- *Type:* string[]

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `members`<sup>Required</sup> <a name="members" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.members"></a>

```typescript
public readonly members: string[];
```

- *Type:* string[]

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexIamPolicyBindingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexIamPolicyBinding;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexIamPolicyBinding">DataYandexIamPolicyBinding</a>

---


### DataYandexKubernetesClusterKmsProviderList <a name="DataYandexKubernetesClusterKmsProviderList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterKmsProviderList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterKmsProviderList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterKmsProviderOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterKmsProviderOutputReference <a name="DataYandexKubernetesClusterKmsProviderOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterKmsProviderOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterKmsProviderOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.keyId">keyId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProvider">DataYandexKubernetesClusterKmsProvider</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `keyId`<sup>Required</sup> <a name="keyId" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProviderOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterKmsProvider;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterKmsProvider">DataYandexKubernetesClusterKmsProvider</a>

---


### DataYandexKubernetesClusterMasterList <a name="DataYandexKubernetesClusterMasterList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterMaintenancePolicyList <a name="DataYandexKubernetesClusterMasterMaintenancePolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterMaintenancePolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList <a name="DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference <a name="DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.duration">duration</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTime">startTime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow">DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow">DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>

---


### DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference <a name="DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgrade">autoUpgrade</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList">DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicy">DataYandexKubernetesClusterMasterMaintenancePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList">DataYandexKubernetesClusterMasterMaintenancePolicyMaintenanceWindowList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMasterMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicy">DataYandexKubernetesClusterMasterMaintenancePolicy</a>

---


### DataYandexKubernetesClusterMasterOutputReference <a name="DataYandexKubernetesClusterMasterOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.clusterCaCertificate">clusterCaCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.externalV4Address">externalV4Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.externalV4Endpoint">externalV4Endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalV4Address">internalV4Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalV4Endpoint">internalV4Endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList">DataYandexKubernetesClusterMasterMaintenancePolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.publicIp">publicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.regional">regional</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList">DataYandexKubernetesClusterMasterRegionalList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.versionInfo">versionInfo</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList">DataYandexKubernetesClusterMasterVersionInfoList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.zonal">zonal</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList">DataYandexKubernetesClusterMasterZonalList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMaster">DataYandexKubernetesClusterMaster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `clusterCaCertificate`<sup>Required</sup> <a name="clusterCaCertificate" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.clusterCaCertificate"></a>

```typescript
public readonly clusterCaCertificate: string;
```

- *Type:* string

---

##### `externalV4Address`<sup>Required</sup> <a name="externalV4Address" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.externalV4Address"></a>

```typescript
public readonly externalV4Address: string;
```

- *Type:* string

---

##### `externalV4Endpoint`<sup>Required</sup> <a name="externalV4Endpoint" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.externalV4Endpoint"></a>

```typescript
public readonly externalV4Endpoint: string;
```

- *Type:* string

---

##### `internalV4Address`<sup>Required</sup> <a name="internalV4Address" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalV4Address"></a>

```typescript
public readonly internalV4Address: string;
```

- *Type:* string

---

##### `internalV4Endpoint`<sup>Required</sup> <a name="internalV4Endpoint" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalV4Endpoint"></a>

```typescript
public readonly internalV4Endpoint: string;
```

- *Type:* string

---

##### `maintenancePolicy`<sup>Required</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: DataYandexKubernetesClusterMasterMaintenancePolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterMaintenancePolicyList">DataYandexKubernetesClusterMasterMaintenancePolicyList</a>

---

##### `publicIp`<sup>Required</sup> <a name="publicIp" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.publicIp"></a>

```typescript
public readonly publicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `regional`<sup>Required</sup> <a name="regional" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.regional"></a>

```typescript
public readonly regional: DataYandexKubernetesClusterMasterRegionalList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList">DataYandexKubernetesClusterMasterRegionalList</a>

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `versionInfo`<sup>Required</sup> <a name="versionInfo" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.versionInfo"></a>

```typescript
public readonly versionInfo: DataYandexKubernetesClusterMasterVersionInfoList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList">DataYandexKubernetesClusterMasterVersionInfoList</a>

---

##### `zonal`<sup>Required</sup> <a name="zonal" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.zonal"></a>

```typescript
public readonly zonal: DataYandexKubernetesClusterMasterZonalList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList">DataYandexKubernetesClusterMasterZonalList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMaster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMaster">DataYandexKubernetesClusterMaster</a>

---


### DataYandexKubernetesClusterMasterRegionalList <a name="DataYandexKubernetesClusterMasterRegionalList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterRegionalList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterRegionalList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterRegionalOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterRegionalOutputReference <a name="DataYandexKubernetesClusterMasterRegionalOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterRegionalOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterRegionalOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.region">region</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegional">DataYandexKubernetesClusterMasterRegional</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `region`<sup>Required</sup> <a name="region" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegionalOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMasterRegional;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterRegional">DataYandexKubernetesClusterMasterRegional</a>

---


### DataYandexKubernetesClusterMasterVersionInfoList <a name="DataYandexKubernetesClusterMasterVersionInfoList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterVersionInfoList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterVersionInfoList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterVersionInfoOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterVersionInfoOutputReference <a name="DataYandexKubernetesClusterMasterVersionInfoOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterVersionInfoOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterVersionInfoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.currentVersion">currentVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.newRevisionAvailable">newRevisionAvailable</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.newRevisionSummary">newRevisionSummary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.versionDeprecated">versionDeprecated</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfo">DataYandexKubernetesClusterMasterVersionInfo</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `currentVersion`<sup>Required</sup> <a name="currentVersion" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.currentVersion"></a>

```typescript
public readonly currentVersion: string;
```

- *Type:* string

---

##### `newRevisionAvailable`<sup>Required</sup> <a name="newRevisionAvailable" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.newRevisionAvailable"></a>

```typescript
public readonly newRevisionAvailable: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `newRevisionSummary`<sup>Required</sup> <a name="newRevisionSummary" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.newRevisionSummary"></a>

```typescript
public readonly newRevisionSummary: string;
```

- *Type:* string

---

##### `versionDeprecated`<sup>Required</sup> <a name="versionDeprecated" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.versionDeprecated"></a>

```typescript
public readonly versionDeprecated: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMasterVersionInfo;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterVersionInfo">DataYandexKubernetesClusterMasterVersionInfo</a>

---


### DataYandexKubernetesClusterMasterZonalList <a name="DataYandexKubernetesClusterMasterZonalList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterZonalList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterZonalList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterMasterZonalOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterMasterZonalOutputReference <a name="DataYandexKubernetesClusterMasterZonalOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterMasterZonalOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterMasterZonalOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonal">DataYandexKubernetesClusterMasterZonal</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonalOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterMasterZonal;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterMasterZonal">DataYandexKubernetesClusterMasterZonal</a>

---


### DataYandexKubernetesClusterNetworkImplementationCiliumList <a name="DataYandexKubernetesClusterNetworkImplementationCiliumList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementationCiliumList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterNetworkImplementationCiliumList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference <a name="DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.routingMode">routingMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCilium">DataYandexKubernetesClusterNetworkImplementationCilium</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `routingMode`<sup>Required</sup> <a name="routingMode" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.routingMode"></a>

```typescript
public readonly routingMode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterNetworkImplementationCilium;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCilium">DataYandexKubernetesClusterNetworkImplementationCilium</a>

---


### DataYandexKubernetesClusterNetworkImplementationList <a name="DataYandexKubernetesClusterNetworkImplementationList" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementationList } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterNetworkImplementationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesClusterNetworkImplementationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesClusterNetworkImplementationOutputReference <a name="DataYandexKubernetesClusterNetworkImplementationOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesClusterNetworkImplementationOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesClusterNetworkImplementationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.cilium">cilium</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList">DataYandexKubernetesClusterNetworkImplementationCiliumList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementation">DataYandexKubernetesClusterNetworkImplementation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cilium`<sup>Required</sup> <a name="cilium" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.cilium"></a>

```typescript
public readonly cilium: DataYandexKubernetesClusterNetworkImplementationCiliumList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationCiliumList">DataYandexKubernetesClusterNetworkImplementationCiliumList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesClusterNetworkImplementation;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesClusterNetworkImplementation">DataYandexKubernetesClusterNetworkImplementation</a>

---


### DataYandexKubernetesNodeGroupAllocationPolicyList <a name="DataYandexKubernetesNodeGroupAllocationPolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupAllocationPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupAllocationPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupAllocationPolicyLocationList <a name="DataYandexKubernetesNodeGroupAllocationPolicyLocationList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicyLocationList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupAllocationPolicyLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference <a name="DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocation">DataYandexKubernetesNodeGroupAllocationPolicyLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupAllocationPolicyLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocation">DataYandexKubernetesNodeGroupAllocationPolicyLocation</a>

---


### DataYandexKubernetesNodeGroupAllocationPolicyOutputReference <a name="DataYandexKubernetesNodeGroupAllocationPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList">DataYandexKubernetesNodeGroupAllocationPolicyLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicy">DataYandexKubernetesNodeGroupAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.location"></a>

```typescript
public readonly location: DataYandexKubernetesNodeGroupAllocationPolicyLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyLocationList">DataYandexKubernetesNodeGroupAllocationPolicyLocationList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupAllocationPolicy">DataYandexKubernetesNodeGroupAllocationPolicy</a>

---


### DataYandexKubernetesNodeGroupDeployPolicyList <a name="DataYandexKubernetesNodeGroupDeployPolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupDeployPolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupDeployPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupDeployPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupDeployPolicyOutputReference <a name="DataYandexKubernetesNodeGroupDeployPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupDeployPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupDeployPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicy">DataYandexKubernetesNodeGroupDeployPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupDeployPolicy">DataYandexKubernetesNodeGroupDeployPolicy</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList <a name="DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDisk">DataYandexKubernetesNodeGroupInstanceTemplateBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDisk">DataYandexKubernetesNodeGroupInstanceTemplateBootDisk</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList <a name="DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime">DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime">DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntime</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateList <a name="DataYandexKubernetesNodeGroupInstanceTemplateList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList <a name="DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface">DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface">DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterface</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList">DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntime">containerRuntime</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList">DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.metadata">metadata</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.nat">nat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList">DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList">DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList">DataYandexKubernetesNodeGroupInstanceTemplateResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList">DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplate">DataYandexKubernetesNodeGroupInstanceTemplate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.bootDisk"></a>

```typescript
public readonly bootDisk: DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList">DataYandexKubernetesNodeGroupInstanceTemplateBootDiskList</a>

---

##### `containerRuntime`<sup>Required</sup> <a name="containerRuntime" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntime"></a>

```typescript
public readonly containerRuntime: DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList">DataYandexKubernetesNodeGroupInstanceTemplateContainerRuntimeList</a>

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.metadata"></a>

```typescript
public readonly metadata: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.nat"></a>

```typescript
public readonly nat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `networkAccelerationType`<sup>Required</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList">DataYandexKubernetesNodeGroupInstanceTemplateNetworkInterfaceList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList">DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList</a>

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexKubernetesNodeGroupInstanceTemplateResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList">DataYandexKubernetesNodeGroupInstanceTemplateResourcesList</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList">DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplate">DataYandexKubernetesNodeGroupInstanceTemplate</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList <a name="DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy">DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy">DataYandexKubernetesNodeGroupInstanceTemplatePlacementPolicy</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateResourcesList <a name="DataYandexKubernetesNodeGroupInstanceTemplateResourcesList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateResourcesList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResources">DataYandexKubernetesNodeGroupInstanceTemplateResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateResources">DataYandexKubernetesNodeGroupInstanceTemplateResources</a>

---


### DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList <a name="DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference <a name="DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy">DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy">DataYandexKubernetesNodeGroupInstanceTemplateSchedulingPolicy</a>

---


### DataYandexKubernetesNodeGroupMaintenancePolicyList <a name="DataYandexKubernetesNodeGroupMaintenancePolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupMaintenancePolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList <a name="DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference <a name="DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.duration">duration</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTime">startTime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow">DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow">DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>

---


### DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference <a name="DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepair">autoRepair</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgrade">autoUpgrade</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList">DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicy">DataYandexKubernetesNodeGroupMaintenancePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoRepair`<sup>Required</sup> <a name="autoRepair" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepair"></a>

```typescript
public readonly autoRepair: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList">DataYandexKubernetesNodeGroupMaintenancePolicyMaintenanceWindowList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupMaintenancePolicy">DataYandexKubernetesNodeGroupMaintenancePolicy</a>

---


### DataYandexKubernetesNodeGroupScalePolicyAutoScaleList <a name="DataYandexKubernetesNodeGroupScalePolicyAutoScaleList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyAutoScaleList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyAutoScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference <a name="DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initial">initial</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.max">max</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.min">min</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScale">DataYandexKubernetesNodeGroupScalePolicyAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `initial`<sup>Required</sup> <a name="initial" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initial"></a>

```typescript
public readonly initial: number;
```

- *Type:* number

---

##### `max`<sup>Required</sup> <a name="max" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.max"></a>

```typescript
public readonly max: number;
```

- *Type:* number

---

##### `min`<sup>Required</sup> <a name="min" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.min"></a>

```typescript
public readonly min: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScale">DataYandexKubernetesNodeGroupScalePolicyAutoScale</a>

---


### DataYandexKubernetesNodeGroupScalePolicyFixedScaleList <a name="DataYandexKubernetesNodeGroupScalePolicyFixedScaleList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyFixedScaleList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyFixedScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference <a name="DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScale">DataYandexKubernetesNodeGroupScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScale">DataYandexKubernetesNodeGroupScalePolicyFixedScale</a>

---


### DataYandexKubernetesNodeGroupScalePolicyList <a name="DataYandexKubernetesNodeGroupScalePolicyList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupScalePolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupScalePolicyOutputReference <a name="DataYandexKubernetesNodeGroupScalePolicyOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupScalePolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList">DataYandexKubernetesNodeGroupScalePolicyAutoScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList">DataYandexKubernetesNodeGroupScalePolicyFixedScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicy">DataYandexKubernetesNodeGroupScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoScale`<sup>Required</sup> <a name="autoScale" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.autoScale"></a>

```typescript
public readonly autoScale: DataYandexKubernetesNodeGroupScalePolicyAutoScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyAutoScaleList">DataYandexKubernetesNodeGroupScalePolicyAutoScaleList</a>

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: DataYandexKubernetesNodeGroupScalePolicyFixedScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyFixedScaleList">DataYandexKubernetesNodeGroupScalePolicyFixedScaleList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupScalePolicy">DataYandexKubernetesNodeGroupScalePolicy</a>

---


### DataYandexKubernetesNodeGroupVersionInfoList <a name="DataYandexKubernetesNodeGroupVersionInfoList" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupVersionInfoList } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupVersionInfoList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.get"></a>

```typescript
public get(index: number): DataYandexKubernetesNodeGroupVersionInfoOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexKubernetesNodeGroupVersionInfoOutputReference <a name="DataYandexKubernetesNodeGroupVersionInfoOutputReference" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer"></a>

```typescript
import { DataYandexKubernetesNodeGroupVersionInfoOutputReference } from '@cdktf/provider-yandex'

new DataYandexKubernetesNodeGroupVersionInfoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.currentVersion">currentVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.newRevisionAvailable">newRevisionAvailable</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.newRevisionSummary">newRevisionSummary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.versionDeprecated">versionDeprecated</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfo">DataYandexKubernetesNodeGroupVersionInfo</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `currentVersion`<sup>Required</sup> <a name="currentVersion" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.currentVersion"></a>

```typescript
public readonly currentVersion: string;
```

- *Type:* string

---

##### `newRevisionAvailable`<sup>Required</sup> <a name="newRevisionAvailable" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.newRevisionAvailable"></a>

```typescript
public readonly newRevisionAvailable: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `newRevisionSummary`<sup>Required</sup> <a name="newRevisionSummary" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.newRevisionSummary"></a>

```typescript
public readonly newRevisionSummary: string;
```

- *Type:* string

---

##### `versionDeprecated`<sup>Required</sup> <a name="versionDeprecated" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.versionDeprecated"></a>

```typescript
public readonly versionDeprecated: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexKubernetesNodeGroupVersionInfo;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexKubernetesNodeGroupVersionInfo">DataYandexKubernetesNodeGroupVersionInfo</a>

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a>

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptions">httpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.interval">interval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `httpOptions`<sup>Required</sup> <a name="httpOptions" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptions"></a>

```typescript
public readonly httpOptions: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsList</a>

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `tcpOptions`<sup>Required</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList</a>

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a>

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupList <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference <a name="DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroup">DataYandexLbNetworkLoadBalancerAttachedTargetGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList">DataYandexLbNetworkLoadBalancerAttachedTargetGroupHealthcheckList</a>

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerAttachedTargetGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerAttachedTargetGroup">DataYandexLbNetworkLoadBalancerAttachedTargetGroup</a>

---


### DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList <a name="DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference <a name="DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersion">ipVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec">DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ipVersion`<sup>Required</sup> <a name="ipVersion" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec">DataYandexLbNetworkLoadBalancerListenerExternalAddressSpec</a>

---


### DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList <a name="DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference <a name="DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersion">ipVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec">DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ipVersion`<sup>Required</sup> <a name="ipVersion" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec">DataYandexLbNetworkLoadBalancerListenerInternalAddressSpec</a>

---


### DataYandexLbNetworkLoadBalancerListenerList <a name="DataYandexLbNetworkLoadBalancerListenerList" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerList } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.get"></a>

```typescript
public get(index: number): DataYandexLbNetworkLoadBalancerListenerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbNetworkLoadBalancerListenerOutputReference <a name="DataYandexLbNetworkLoadBalancerListenerOutputReference" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer"></a>

```typescript
import { DataYandexLbNetworkLoadBalancerListenerOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbNetworkLoadBalancerListenerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpec">externalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList">DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpec">internalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList">DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.targetPort">targetPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListener">DataYandexLbNetworkLoadBalancerListener</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalAddressSpec`<sup>Required</sup> <a name="externalAddressSpec" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpec"></a>

```typescript
public readonly externalAddressSpec: DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList">DataYandexLbNetworkLoadBalancerListenerExternalAddressSpecList</a>

---

##### `internalAddressSpec`<sup>Required</sup> <a name="internalAddressSpec" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpec"></a>

```typescript
public readonly internalAddressSpec: DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList">DataYandexLbNetworkLoadBalancerListenerInternalAddressSpecList</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `targetPort`<sup>Required</sup> <a name="targetPort" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListenerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbNetworkLoadBalancerListener;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbNetworkLoadBalancerListener">DataYandexLbNetworkLoadBalancerListener</a>

---


### DataYandexLbTargetGroupTargetList <a name="DataYandexLbTargetGroupTargetList" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer"></a>

```typescript
import { DataYandexLbTargetGroupTargetList } from '@cdktf/provider-yandex'

new DataYandexLbTargetGroupTargetList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.get"></a>

```typescript
public get(index: number): DataYandexLbTargetGroupTargetOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexLbTargetGroupTargetOutputReference <a name="DataYandexLbTargetGroupTargetOutputReference" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer"></a>

```typescript
import { DataYandexLbTargetGroupTargetOutputReference } from '@cdktf/provider-yandex'

new DataYandexLbTargetGroupTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTarget">DataYandexLbTargetGroupTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexLbTargetGroupTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexLbTargetGroupTarget;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexLbTargetGroupTarget">DataYandexLbTargetGroupTarget</a>

---


### DataYandexMdbClickhouseClusterAccessList <a name="DataYandexMdbClickhouseClusterAccessList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterAccessList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterAccessList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterAccessOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterAccessOutputReference <a name="DataYandexMdbClickhouseClusterAccessOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterAccessOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.metrika">metrika</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.serverless">serverless</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccess">DataYandexMdbClickhouseClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `metrika`<sup>Required</sup> <a name="metrika" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.metrika"></a>

```typescript
public readonly metrika: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `serverless`<sup>Required</sup> <a name="serverless" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.serverless"></a>

```typescript
public readonly serverless: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterAccess">DataYandexMdbClickhouseClusterAccess</a>

---


### DataYandexMdbClickhouseClusterBackupWindowStartList <a name="DataYandexMdbClickhouseClusterBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterBackupWindowStartOutputReference <a name="DataYandexMdbClickhouseClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStart">DataYandexMdbClickhouseClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterBackupWindowStart">DataYandexMdbClickhouseClusterBackupWindowStart</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigCompressionList <a name="DataYandexMdbClickhouseClusterClickhouseConfigCompressionList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigCompressionList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigCompressionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.method">method</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSize">minPartSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatio">minPartSizeRatio</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompression">DataYandexMdbClickhouseClusterClickhouseConfigCompression</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `method`<sup>Required</sup> <a name="method" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.method"></a>

```typescript
public readonly method: string;
```

- *Type:* string

---

##### `minPartSize`<sup>Required</sup> <a name="minPartSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSize"></a>

```typescript
public readonly minPartSize: number;
```

- *Type:* number

---

##### `minPartSizeRatio`<sup>Required</sup> <a name="minPartSizeRatio" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatio"></a>

```typescript
public readonly minPartSizeRatio: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigCompression;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompression">DataYandexMdbClickhouseClusterClickhouseConfigCompression</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.pattern">pattern</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.pattern"></a>

```typescript
public readonly pattern: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollup</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.function">function</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexp">regexp</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retention">retention</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.function"></a>

```typescript
public readonly function: string;
```

- *Type:* string

---

##### `regexp`<sup>Required</sup> <a name="regexp" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexp"></a>

```typescript
public readonly regexp: string;
```

- *Type:* string

---

##### `retention`<sup>Required</sup> <a name="retention" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retention"></a>

```typescript
public readonly retention: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.age">age</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precision">precision</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `age`<sup>Required</sup> <a name="age" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.age"></a>

```typescript
public readonly age: number;
```

- *Type:* number

---

##### `precision`<sup>Required</sup> <a name="precision" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precision"></a>

```typescript
public readonly precision: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaList <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafka">DataYandexMdbClickhouseClusterClickhouseConfigKafka</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafka">DataYandexMdbClickhouseClusterClickhouseConfigKafka</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settings"></a>

```typescript
public readonly settings: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopic</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigList <a name="DataYandexMdbClickhouseClusterClickhouseConfigList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList <a name="DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPool">maxBytesToMergeAtMinSpaceInPool</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueue">maxReplicatedMergesInQueue</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge">numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsert">partsToDelayInsert</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsert">partsToThrowInsert</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindow">replicatedDeduplicationWindow</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSeconds">replicatedDeduplicationWindowSeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTree">DataYandexMdbClickhouseClusterClickhouseConfigMergeTree</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxBytesToMergeAtMinSpaceInPool`<sup>Required</sup> <a name="maxBytesToMergeAtMinSpaceInPool" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPool"></a>

```typescript
public readonly maxBytesToMergeAtMinSpaceInPool: number;
```

- *Type:* number

---

##### `maxReplicatedMergesInQueue`<sup>Required</sup> <a name="maxReplicatedMergesInQueue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueue"></a>

```typescript
public readonly maxReplicatedMergesInQueue: number;
```

- *Type:* number

---

##### `numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge`<sup>Required</sup> <a name="numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge"></a>

```typescript
public readonly numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge: number;
```

- *Type:* number

---

##### `partsToDelayInsert`<sup>Required</sup> <a name="partsToDelayInsert" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsert"></a>

```typescript
public readonly partsToDelayInsert: number;
```

- *Type:* number

---

##### `partsToThrowInsert`<sup>Required</sup> <a name="partsToThrowInsert" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsert"></a>

```typescript
public readonly partsToThrowInsert: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindow`<sup>Required</sup> <a name="replicatedDeduplicationWindow" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindow"></a>

```typescript
public readonly replicatedDeduplicationWindow: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindowSeconds`<sup>Required</sup> <a name="replicatedDeduplicationWindowSeconds" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSeconds"></a>

```typescript
public readonly replicatedDeduplicationWindowSeconds: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigMergeTree;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTree">DataYandexMdbClickhouseClusterClickhouseConfigMergeTree</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSize">backgroundPoolSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSize">backgroundSchedulePoolSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.compression">compression</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList">DataYandexMdbClickhouseClusterClickhouseConfigCompressionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUri">geobaseUri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollup">graphiteRollup</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopic">kafkaTopic</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeout">keepAliveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.logLevel">logLevel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSize">markCacheSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueries">maxConcurrentQueries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnections">maxConnections</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDrop">maxPartitionSizeToDrop</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDrop">maxTableSizeToDrop</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTree">mergeTree</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList">DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabled">metricLogEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSize">metricLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTime">metricLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSize">partLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTime">partLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSize">queryLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTime">queryLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabled">queryThreadLogEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSize">queryThreadLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTime">queryThreadLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmq">rabbitmq</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList">DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabled">textLogEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevel">textLogLevel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSize">textLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTime">textLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.timezone">timezone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabled">traceLogEnabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSize">traceLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTime">traceLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSize">uncompressedCacheSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfig">DataYandexMdbClickhouseClusterClickhouseConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backgroundPoolSize`<sup>Required</sup> <a name="backgroundPoolSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSize"></a>

```typescript
public readonly backgroundPoolSize: number;
```

- *Type:* number

---

##### `backgroundSchedulePoolSize`<sup>Required</sup> <a name="backgroundSchedulePoolSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSize"></a>

```typescript
public readonly backgroundSchedulePoolSize: number;
```

- *Type:* number

---

##### `compression`<sup>Required</sup> <a name="compression" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.compression"></a>

```typescript
public readonly compression: DataYandexMdbClickhouseClusterClickhouseConfigCompressionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigCompressionList">DataYandexMdbClickhouseClusterClickhouseConfigCompressionList</a>

---

##### `geobaseUri`<sup>Required</sup> <a name="geobaseUri" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUri"></a>

```typescript
public readonly geobaseUri: string;
```

- *Type:* string

---

##### `graphiteRollup`<sup>Required</sup> <a name="graphiteRollup" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollup"></a>

```typescript
public readonly graphiteRollup: DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList">DataYandexMdbClickhouseClusterClickhouseConfigGraphiteRollupList</a>

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.kafka"></a>

```typescript
public readonly kafka: DataYandexMdbClickhouseClusterClickhouseConfigKafkaList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaList</a>

---

##### `kafkaTopic`<sup>Required</sup> <a name="kafkaTopic" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopic"></a>

```typescript
public readonly kafkaTopic: DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList">DataYandexMdbClickhouseClusterClickhouseConfigKafkaTopicList</a>

---

##### `keepAliveTimeout`<sup>Required</sup> <a name="keepAliveTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* number

---

##### `logLevel`<sup>Required</sup> <a name="logLevel" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.logLevel"></a>

```typescript
public readonly logLevel: string;
```

- *Type:* string

---

##### `markCacheSize`<sup>Required</sup> <a name="markCacheSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSize"></a>

```typescript
public readonly markCacheSize: number;
```

- *Type:* number

---

##### `maxConcurrentQueries`<sup>Required</sup> <a name="maxConcurrentQueries" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueries"></a>

```typescript
public readonly maxConcurrentQueries: number;
```

- *Type:* number

---

##### `maxConnections`<sup>Required</sup> <a name="maxConnections" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnections"></a>

```typescript
public readonly maxConnections: number;
```

- *Type:* number

---

##### `maxPartitionSizeToDrop`<sup>Required</sup> <a name="maxPartitionSizeToDrop" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDrop"></a>

```typescript
public readonly maxPartitionSizeToDrop: number;
```

- *Type:* number

---

##### `maxTableSizeToDrop`<sup>Required</sup> <a name="maxTableSizeToDrop" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDrop"></a>

```typescript
public readonly maxTableSizeToDrop: number;
```

- *Type:* number

---

##### `mergeTree`<sup>Required</sup> <a name="mergeTree" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTree"></a>

```typescript
public readonly mergeTree: DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList">DataYandexMdbClickhouseClusterClickhouseConfigMergeTreeList</a>

---

##### `metricLogEnabled`<sup>Required</sup> <a name="metricLogEnabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabled"></a>

```typescript
public readonly metricLogEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `metricLogRetentionSize`<sup>Required</sup> <a name="metricLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSize"></a>

```typescript
public readonly metricLogRetentionSize: number;
```

- *Type:* number

---

##### `metricLogRetentionTime`<sup>Required</sup> <a name="metricLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTime"></a>

```typescript
public readonly metricLogRetentionTime: number;
```

- *Type:* number

---

##### `partLogRetentionSize`<sup>Required</sup> <a name="partLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSize"></a>

```typescript
public readonly partLogRetentionSize: number;
```

- *Type:* number

---

##### `partLogRetentionTime`<sup>Required</sup> <a name="partLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTime"></a>

```typescript
public readonly partLogRetentionTime: number;
```

- *Type:* number

---

##### `queryLogRetentionSize`<sup>Required</sup> <a name="queryLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSize"></a>

```typescript
public readonly queryLogRetentionSize: number;
```

- *Type:* number

---

##### `queryLogRetentionTime`<sup>Required</sup> <a name="queryLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTime"></a>

```typescript
public readonly queryLogRetentionTime: number;
```

- *Type:* number

---

##### `queryThreadLogEnabled`<sup>Required</sup> <a name="queryThreadLogEnabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabled"></a>

```typescript
public readonly queryThreadLogEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `queryThreadLogRetentionSize`<sup>Required</sup> <a name="queryThreadLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSize"></a>

```typescript
public readonly queryThreadLogRetentionSize: number;
```

- *Type:* number

---

##### `queryThreadLogRetentionTime`<sup>Required</sup> <a name="queryThreadLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTime"></a>

```typescript
public readonly queryThreadLogRetentionTime: number;
```

- *Type:* number

---

##### `rabbitmq`<sup>Required</sup> <a name="rabbitmq" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmq"></a>

```typescript
public readonly rabbitmq: DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList">DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList</a>

---

##### `textLogEnabled`<sup>Required</sup> <a name="textLogEnabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabled"></a>

```typescript
public readonly textLogEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `textLogLevel`<sup>Required</sup> <a name="textLogLevel" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevel"></a>

```typescript
public readonly textLogLevel: string;
```

- *Type:* string

---

##### `textLogRetentionSize`<sup>Required</sup> <a name="textLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSize"></a>

```typescript
public readonly textLogRetentionSize: number;
```

- *Type:* number

---

##### `textLogRetentionTime`<sup>Required</sup> <a name="textLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTime"></a>

```typescript
public readonly textLogRetentionTime: number;
```

- *Type:* number

---

##### `timezone`<sup>Required</sup> <a name="timezone" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

---

##### `traceLogEnabled`<sup>Required</sup> <a name="traceLogEnabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabled"></a>

```typescript
public readonly traceLogEnabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `traceLogRetentionSize`<sup>Required</sup> <a name="traceLogRetentionSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSize"></a>

```typescript
public readonly traceLogRetentionSize: number;
```

- *Type:* number

---

##### `traceLogRetentionTime`<sup>Required</sup> <a name="traceLogRetentionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTime"></a>

```typescript
public readonly traceLogRetentionTime: number;
```

- *Type:* number

---

##### `uncompressedCacheSize`<sup>Required</sup> <a name="uncompressedCacheSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSize"></a>

```typescript
public readonly uncompressedCacheSize: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfig">DataYandexMdbClickhouseClusterClickhouseConfig</a>

---


### DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList <a name="DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.username">username</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq">DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `username`<sup>Required</sup> <a name="username" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq">DataYandexMdbClickhouseClusterClickhouseConfigRabbitmq</a>

---


### DataYandexMdbClickhouseClusterClickhouseList <a name="DataYandexMdbClickhouseClusterClickhouseList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList">DataYandexMdbClickhouseClusterClickhouseConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList">DataYandexMdbClickhouseClusterClickhouseResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouse">DataYandexMdbClickhouseClusterClickhouse</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.config"></a>

```typescript
public readonly config: DataYandexMdbClickhouseClusterClickhouseConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseConfigList">DataYandexMdbClickhouseClusterClickhouseConfigList</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbClickhouseClusterClickhouseResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList">DataYandexMdbClickhouseClusterClickhouseResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouse;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouse">DataYandexMdbClickhouseClusterClickhouse</a>

---


### DataYandexMdbClickhouseClusterClickhouseResourcesList <a name="DataYandexMdbClickhouseClusterClickhouseResourcesList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference <a name="DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResources">DataYandexMdbClickhouseClusterClickhouseResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterClickhouseResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterClickhouseResources">DataYandexMdbClickhouseClusterClickhouseResources</a>

---


### DataYandexMdbClickhouseClusterCloudStorageOutputReference <a name="DataYandexMdbClickhouseClusterCloudStorageOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterCloudStorageOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterCloudStorageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterCloudStorage">DataYandexMdbClickhouseClusterCloudStorage</a>

---


### DataYandexMdbClickhouseClusterDatabaseList <a name="DataYandexMdbClickhouseClusterDatabaseList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterDatabaseList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterDatabaseOutputReference <a name="DataYandexMdbClickhouseClusterDatabaseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabase">DataYandexMdbClickhouseClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterDatabase;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterDatabase">DataYandexMdbClickhouseClusterDatabase</a>

---


### DataYandexMdbClickhouseClusterFormatSchemaList <a name="DataYandexMdbClickhouseClusterFormatSchemaList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterFormatSchemaList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterFormatSchemaList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterFormatSchemaOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterFormatSchemaOutputReference <a name="DataYandexMdbClickhouseClusterFormatSchemaOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterFormatSchemaOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterFormatSchemaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.uri">uri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchema">DataYandexMdbClickhouseClusterFormatSchema</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchemaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterFormatSchema;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterFormatSchema">DataYandexMdbClickhouseClusterFormatSchema</a>

---


### DataYandexMdbClickhouseClusterHostList <a name="DataYandexMdbClickhouseClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterHostOutputReference <a name="DataYandexMdbClickhouseClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHost">DataYandexMdbClickhouseClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterHost">DataYandexMdbClickhouseClusterHost</a>

---


### DataYandexMdbClickhouseClusterMaintenanceWindowList <a name="DataYandexMdbClickhouseClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference <a name="DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindow">DataYandexMdbClickhouseClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMaintenanceWindow">DataYandexMdbClickhouseClusterMaintenanceWindow</a>

---


### DataYandexMdbClickhouseClusterMlModelList <a name="DataYandexMdbClickhouseClusterMlModelList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMlModelList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterMlModelList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterMlModelOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterMlModelOutputReference <a name="DataYandexMdbClickhouseClusterMlModelOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterMlModelOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterMlModelOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.uri">uri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModel">DataYandexMdbClickhouseClusterMlModel</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModelOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterMlModel;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterMlModel">DataYandexMdbClickhouseClusterMlModel</a>

---


### DataYandexMdbClickhouseClusterShardGroupList <a name="DataYandexMdbClickhouseClusterShardGroupList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterShardGroupList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterShardGroupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterShardGroupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterShardGroupOutputReference <a name="DataYandexMdbClickhouseClusterShardGroupOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterShardGroupOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterShardGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.shardNames">shardNames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroup">DataYandexMdbClickhouseClusterShardGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `shardNames`<sup>Required</sup> <a name="shardNames" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.shardNames"></a>

```typescript
public readonly shardNames: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterShardGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterShardGroup">DataYandexMdbClickhouseClusterShardGroup</a>

---


### DataYandexMdbClickhouseClusterUserList <a name="DataYandexMdbClickhouseClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterUserOutputReference <a name="DataYandexMdbClickhouseClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList">DataYandexMdbClickhouseClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.quota">quota</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList">DataYandexMdbClickhouseClusterUserQuotaList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList">DataYandexMdbClickhouseClusterUserSettingsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUser">DataYandexMdbClickhouseClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbClickhouseClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList">DataYandexMdbClickhouseClusterUserPermissionList</a>

---

##### `quota`<sup>Required</sup> <a name="quota" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.quota"></a>

```typescript
public readonly quota: DataYandexMdbClickhouseClusterUserQuotaList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList">DataYandexMdbClickhouseClusterUserQuotaList</a>

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.settings"></a>

```typescript
public readonly settings: DataYandexMdbClickhouseClusterUserSettingsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList">DataYandexMdbClickhouseClusterUserSettingsList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterUser;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUser">DataYandexMdbClickhouseClusterUser</a>

---


### DataYandexMdbClickhouseClusterUserPermissionList <a name="DataYandexMdbClickhouseClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterUserPermissionOutputReference <a name="DataYandexMdbClickhouseClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermission">DataYandexMdbClickhouseClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterUserPermission;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserPermission">DataYandexMdbClickhouseClusterUserPermission</a>

---


### DataYandexMdbClickhouseClusterUserQuotaList <a name="DataYandexMdbClickhouseClusterUserQuotaList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserQuotaList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserQuotaList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterUserQuotaOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterUserQuotaOutputReference <a name="DataYandexMdbClickhouseClusterUserQuotaOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserQuotaOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserQuotaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.errors">errors</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.executionTime">executionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.intervalDuration">intervalDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.queries">queries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.readRows">readRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.resultRows">resultRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuota">DataYandexMdbClickhouseClusterUserQuota</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `errors`<sup>Required</sup> <a name="errors" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.errors"></a>

```typescript
public readonly errors: number;
```

- *Type:* number

---

##### `executionTime`<sup>Required</sup> <a name="executionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.executionTime"></a>

```typescript
public readonly executionTime: number;
```

- *Type:* number

---

##### `intervalDuration`<sup>Required</sup> <a name="intervalDuration" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.intervalDuration"></a>

```typescript
public readonly intervalDuration: number;
```

- *Type:* number

---

##### `queries`<sup>Required</sup> <a name="queries" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.queries"></a>

```typescript
public readonly queries: number;
```

- *Type:* number

---

##### `readRows`<sup>Required</sup> <a name="readRows" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.readRows"></a>

```typescript
public readonly readRows: number;
```

- *Type:* number

---

##### `resultRows`<sup>Required</sup> <a name="resultRows" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.resultRows"></a>

```typescript
public readonly resultRows: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuotaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterUserQuota;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserQuota">DataYandexMdbClickhouseClusterUserQuota</a>

---


### DataYandexMdbClickhouseClusterUserSettingsList <a name="DataYandexMdbClickhouseClusterUserSettingsList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserSettingsList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserSettingsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterUserSettingsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterUserSettingsOutputReference <a name="DataYandexMdbClickhouseClusterUserSettingsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterUserSettingsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterUserSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeader">addHttpCorsHeader</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.allowDdl">allowDdl</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.compile">compile</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.compileExpressions">compileExpressions</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.connectTimeout">connectTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementation">countDistinctImplementation</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowMode">distinctOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficient">distributedAggregationMemoryEfficient</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeout">distributedDdlTaskTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedProductMode">distributedProductMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySet">emptyResultForAggregationByEmptySet</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompression">enableHttpCompression</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueries">fallbackToStaleReplicasForDistributedQueries</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDate">forceIndexByDate</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKey">forcePrimaryKey</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowMode">groupByOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThreshold">groupByTwoLevelThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytes">groupByTwoLevelThresholdBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeout">httpConnectionTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressInterval">httpHeadersProgressInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeout">httpReceiveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeout">httpSendTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFields">inputFormatDefaultsForOmittedFields</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressions">inputFormatValuesInterpretExpressions</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.insertQuorum">insertQuorum</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeout">insertQuorumTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAlias">joinedSubqueryRequiresAlias</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowMode">joinOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinUseNulls">joinUseNulls</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormat">lowCardinalityAllowInNativeFormat</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepth">maxAstDepth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxAstElements">maxAstElements</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSize">maxBlockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupBy">maxBytesBeforeExternalGroupBy</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSort">maxBytesBeforeExternalSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinct">maxBytesInDistinct</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoin">maxBytesInJoin</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSet">maxBytesInSet</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToRead">maxBytesToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSort">maxBytesToSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransfer">maxBytesToTransfer</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToRead">maxColumnsToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTime">maxExecutionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElements">maxExpandedAstElements</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSize">maxInsertBlockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsage">maxMemoryUsage</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUser">maxMemoryUsageForUser</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidth">maxNetworkBandwidth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUser">maxNetworkBandwidthForUser</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySize">maxQuerySize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueries">maxReplicaDelayForDistributedQueries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytes">maxResultBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxResultRows">maxResultRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinct">maxRowsInDistinct</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoin">maxRowsInJoin</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSet">maxRowsInSet</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupBy">maxRowsToGroupBy</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToRead">maxRowsToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSort">maxRowsToSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransfer">maxRowsToTransfer</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumns">maxTemporaryColumns</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumns">maxTemporaryNonConstColumns</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxThreads">maxThreads</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCache">mergeTreeMaxBytesToUseCache</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCache">mergeTreeMaxRowsToUseCache</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentRead">mergeTreeMinBytesForConcurrentRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentRead">mergeTreeMinRowsForConcurrentRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIo">minBytesToUseDirectIo</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompile">minCountToCompile</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpression">minCountToCompileExpression</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeed">minExecutionSpeed</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytes">minExecutionSpeedBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytes">minInsertBlockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRows">minInsertBlockSizeRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegers">outputFormatJsonQuote64BitIntegers</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormals">outputFormatJsonQuoteDenormals</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.quotaMode">quotaMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.readonly">readonly</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.readOverflowMode">readOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeout">receiveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSync">replicationAlterPartitionsSync</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowMode">resultOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistency">selectSequentialConsistency</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeaders">sendProgressInHttpHeaders</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sendTimeout">sendTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.setOverflowMode">setOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShards">skipUnavailableShards</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowMode">sortOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowMode">timeoutOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowMode">transferOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.transformNullIn">transformNullIn</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCache">useUncompressedCache</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettings">DataYandexMdbClickhouseClusterUserSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addHttpCorsHeader`<sup>Required</sup> <a name="addHttpCorsHeader" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeader"></a>

```typescript
public readonly addHttpCorsHeader: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `allowDdl`<sup>Required</sup> <a name="allowDdl" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.allowDdl"></a>

```typescript
public readonly allowDdl: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `compile`<sup>Required</sup> <a name="compile" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.compile"></a>

```typescript
public readonly compile: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `compileExpressions`<sup>Required</sup> <a name="compileExpressions" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.compileExpressions"></a>

```typescript
public readonly compileExpressions: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `connectTimeout`<sup>Required</sup> <a name="connectTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.connectTimeout"></a>

```typescript
public readonly connectTimeout: number;
```

- *Type:* number

---

##### `countDistinctImplementation`<sup>Required</sup> <a name="countDistinctImplementation" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementation"></a>

```typescript
public readonly countDistinctImplementation: string;
```

- *Type:* string

---

##### `distinctOverflowMode`<sup>Required</sup> <a name="distinctOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowMode"></a>

```typescript
public readonly distinctOverflowMode: string;
```

- *Type:* string

---

##### `distributedAggregationMemoryEfficient`<sup>Required</sup> <a name="distributedAggregationMemoryEfficient" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficient"></a>

```typescript
public readonly distributedAggregationMemoryEfficient: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `distributedDdlTaskTimeout`<sup>Required</sup> <a name="distributedDdlTaskTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeout"></a>

```typescript
public readonly distributedDdlTaskTimeout: number;
```

- *Type:* number

---

##### `distributedProductMode`<sup>Required</sup> <a name="distributedProductMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.distributedProductMode"></a>

```typescript
public readonly distributedProductMode: string;
```

- *Type:* string

---

##### `emptyResultForAggregationByEmptySet`<sup>Required</sup> <a name="emptyResultForAggregationByEmptySet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySet"></a>

```typescript
public readonly emptyResultForAggregationByEmptySet: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `enableHttpCompression`<sup>Required</sup> <a name="enableHttpCompression" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompression"></a>

```typescript
public readonly enableHttpCompression: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fallbackToStaleReplicasForDistributedQueries`<sup>Required</sup> <a name="fallbackToStaleReplicasForDistributedQueries" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueries"></a>

```typescript
public readonly fallbackToStaleReplicasForDistributedQueries: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `forceIndexByDate`<sup>Required</sup> <a name="forceIndexByDate" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDate"></a>

```typescript
public readonly forceIndexByDate: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `forcePrimaryKey`<sup>Required</sup> <a name="forcePrimaryKey" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKey"></a>

```typescript
public readonly forcePrimaryKey: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `groupByOverflowMode`<sup>Required</sup> <a name="groupByOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowMode"></a>

```typescript
public readonly groupByOverflowMode: string;
```

- *Type:* string

---

##### `groupByTwoLevelThreshold`<sup>Required</sup> <a name="groupByTwoLevelThreshold" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThreshold"></a>

```typescript
public readonly groupByTwoLevelThreshold: number;
```

- *Type:* number

---

##### `groupByTwoLevelThresholdBytes`<sup>Required</sup> <a name="groupByTwoLevelThresholdBytes" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytes"></a>

```typescript
public readonly groupByTwoLevelThresholdBytes: number;
```

- *Type:* number

---

##### `httpConnectionTimeout`<sup>Required</sup> <a name="httpConnectionTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeout"></a>

```typescript
public readonly httpConnectionTimeout: number;
```

- *Type:* number

---

##### `httpHeadersProgressInterval`<sup>Required</sup> <a name="httpHeadersProgressInterval" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressInterval"></a>

```typescript
public readonly httpHeadersProgressInterval: number;
```

- *Type:* number

---

##### `httpReceiveTimeout`<sup>Required</sup> <a name="httpReceiveTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeout"></a>

```typescript
public readonly httpReceiveTimeout: number;
```

- *Type:* number

---

##### `httpSendTimeout`<sup>Required</sup> <a name="httpSendTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeout"></a>

```typescript
public readonly httpSendTimeout: number;
```

- *Type:* number

---

##### `inputFormatDefaultsForOmittedFields`<sup>Required</sup> <a name="inputFormatDefaultsForOmittedFields" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFields"></a>

```typescript
public readonly inputFormatDefaultsForOmittedFields: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `inputFormatValuesInterpretExpressions`<sup>Required</sup> <a name="inputFormatValuesInterpretExpressions" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressions"></a>

```typescript
public readonly inputFormatValuesInterpretExpressions: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `insertQuorum`<sup>Required</sup> <a name="insertQuorum" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.insertQuorum"></a>

```typescript
public readonly insertQuorum: number;
```

- *Type:* number

---

##### `insertQuorumTimeout`<sup>Required</sup> <a name="insertQuorumTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeout"></a>

```typescript
public readonly insertQuorumTimeout: number;
```

- *Type:* number

---

##### `joinedSubqueryRequiresAlias`<sup>Required</sup> <a name="joinedSubqueryRequiresAlias" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAlias"></a>

```typescript
public readonly joinedSubqueryRequiresAlias: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `joinOverflowMode`<sup>Required</sup> <a name="joinOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowMode"></a>

```typescript
public readonly joinOverflowMode: string;
```

- *Type:* string

---

##### `joinUseNulls`<sup>Required</sup> <a name="joinUseNulls" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.joinUseNulls"></a>

```typescript
public readonly joinUseNulls: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `lowCardinalityAllowInNativeFormat`<sup>Required</sup> <a name="lowCardinalityAllowInNativeFormat" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormat"></a>

```typescript
public readonly lowCardinalityAllowInNativeFormat: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `maxAstDepth`<sup>Required</sup> <a name="maxAstDepth" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepth"></a>

```typescript
public readonly maxAstDepth: number;
```

- *Type:* number

---

##### `maxAstElements`<sup>Required</sup> <a name="maxAstElements" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxAstElements"></a>

```typescript
public readonly maxAstElements: number;
```

- *Type:* number

---

##### `maxBlockSize`<sup>Required</sup> <a name="maxBlockSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSize"></a>

```typescript
public readonly maxBlockSize: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalGroupBy`<sup>Required</sup> <a name="maxBytesBeforeExternalGroupBy" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupBy"></a>

```typescript
public readonly maxBytesBeforeExternalGroupBy: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalSort`<sup>Required</sup> <a name="maxBytesBeforeExternalSort" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSort"></a>

```typescript
public readonly maxBytesBeforeExternalSort: number;
```

- *Type:* number

---

##### `maxBytesInDistinct`<sup>Required</sup> <a name="maxBytesInDistinct" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinct"></a>

```typescript
public readonly maxBytesInDistinct: number;
```

- *Type:* number

---

##### `maxBytesInJoin`<sup>Required</sup> <a name="maxBytesInJoin" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoin"></a>

```typescript
public readonly maxBytesInJoin: number;
```

- *Type:* number

---

##### `maxBytesInSet`<sup>Required</sup> <a name="maxBytesInSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSet"></a>

```typescript
public readonly maxBytesInSet: number;
```

- *Type:* number

---

##### `maxBytesToRead`<sup>Required</sup> <a name="maxBytesToRead" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToRead"></a>

```typescript
public readonly maxBytesToRead: number;
```

- *Type:* number

---

##### `maxBytesToSort`<sup>Required</sup> <a name="maxBytesToSort" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSort"></a>

```typescript
public readonly maxBytesToSort: number;
```

- *Type:* number

---

##### `maxBytesToTransfer`<sup>Required</sup> <a name="maxBytesToTransfer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransfer"></a>

```typescript
public readonly maxBytesToTransfer: number;
```

- *Type:* number

---

##### `maxColumnsToRead`<sup>Required</sup> <a name="maxColumnsToRead" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToRead"></a>

```typescript
public readonly maxColumnsToRead: number;
```

- *Type:* number

---

##### `maxExecutionTime`<sup>Required</sup> <a name="maxExecutionTime" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTime"></a>

```typescript
public readonly maxExecutionTime: number;
```

- *Type:* number

---

##### `maxExpandedAstElements`<sup>Required</sup> <a name="maxExpandedAstElements" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElements"></a>

```typescript
public readonly maxExpandedAstElements: number;
```

- *Type:* number

---

##### `maxInsertBlockSize`<sup>Required</sup> <a name="maxInsertBlockSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSize"></a>

```typescript
public readonly maxInsertBlockSize: number;
```

- *Type:* number

---

##### `maxMemoryUsage`<sup>Required</sup> <a name="maxMemoryUsage" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsage"></a>

```typescript
public readonly maxMemoryUsage: number;
```

- *Type:* number

---

##### `maxMemoryUsageForUser`<sup>Required</sup> <a name="maxMemoryUsageForUser" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUser"></a>

```typescript
public readonly maxMemoryUsageForUser: number;
```

- *Type:* number

---

##### `maxNetworkBandwidth`<sup>Required</sup> <a name="maxNetworkBandwidth" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidth"></a>

```typescript
public readonly maxNetworkBandwidth: number;
```

- *Type:* number

---

##### `maxNetworkBandwidthForUser`<sup>Required</sup> <a name="maxNetworkBandwidthForUser" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUser"></a>

```typescript
public readonly maxNetworkBandwidthForUser: number;
```

- *Type:* number

---

##### `maxQuerySize`<sup>Required</sup> <a name="maxQuerySize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySize"></a>

```typescript
public readonly maxQuerySize: number;
```

- *Type:* number

---

##### `maxReplicaDelayForDistributedQueries`<sup>Required</sup> <a name="maxReplicaDelayForDistributedQueries" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueries"></a>

```typescript
public readonly maxReplicaDelayForDistributedQueries: number;
```

- *Type:* number

---

##### `maxResultBytes`<sup>Required</sup> <a name="maxResultBytes" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytes"></a>

```typescript
public readonly maxResultBytes: number;
```

- *Type:* number

---

##### `maxResultRows`<sup>Required</sup> <a name="maxResultRows" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxResultRows"></a>

```typescript
public readonly maxResultRows: number;
```

- *Type:* number

---

##### `maxRowsInDistinct`<sup>Required</sup> <a name="maxRowsInDistinct" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinct"></a>

```typescript
public readonly maxRowsInDistinct: number;
```

- *Type:* number

---

##### `maxRowsInJoin`<sup>Required</sup> <a name="maxRowsInJoin" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoin"></a>

```typescript
public readonly maxRowsInJoin: number;
```

- *Type:* number

---

##### `maxRowsInSet`<sup>Required</sup> <a name="maxRowsInSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSet"></a>

```typescript
public readonly maxRowsInSet: number;
```

- *Type:* number

---

##### `maxRowsToGroupBy`<sup>Required</sup> <a name="maxRowsToGroupBy" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupBy"></a>

```typescript
public readonly maxRowsToGroupBy: number;
```

- *Type:* number

---

##### `maxRowsToRead`<sup>Required</sup> <a name="maxRowsToRead" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToRead"></a>

```typescript
public readonly maxRowsToRead: number;
```

- *Type:* number

---

##### `maxRowsToSort`<sup>Required</sup> <a name="maxRowsToSort" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSort"></a>

```typescript
public readonly maxRowsToSort: number;
```

- *Type:* number

---

##### `maxRowsToTransfer`<sup>Required</sup> <a name="maxRowsToTransfer" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransfer"></a>

```typescript
public readonly maxRowsToTransfer: number;
```

- *Type:* number

---

##### `maxTemporaryColumns`<sup>Required</sup> <a name="maxTemporaryColumns" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumns"></a>

```typescript
public readonly maxTemporaryColumns: number;
```

- *Type:* number

---

##### `maxTemporaryNonConstColumns`<sup>Required</sup> <a name="maxTemporaryNonConstColumns" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumns"></a>

```typescript
public readonly maxTemporaryNonConstColumns: number;
```

- *Type:* number

---

##### `maxThreads`<sup>Required</sup> <a name="maxThreads" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.maxThreads"></a>

```typescript
public readonly maxThreads: number;
```

- *Type:* number

---

##### `mergeTreeMaxBytesToUseCache`<sup>Required</sup> <a name="mergeTreeMaxBytesToUseCache" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCache"></a>

```typescript
public readonly mergeTreeMaxBytesToUseCache: number;
```

- *Type:* number

---

##### `mergeTreeMaxRowsToUseCache`<sup>Required</sup> <a name="mergeTreeMaxRowsToUseCache" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCache"></a>

```typescript
public readonly mergeTreeMaxRowsToUseCache: number;
```

- *Type:* number

---

##### `mergeTreeMinBytesForConcurrentRead`<sup>Required</sup> <a name="mergeTreeMinBytesForConcurrentRead" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinBytesForConcurrentRead: number;
```

- *Type:* number

---

##### `mergeTreeMinRowsForConcurrentRead`<sup>Required</sup> <a name="mergeTreeMinRowsForConcurrentRead" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinRowsForConcurrentRead: number;
```

- *Type:* number

---

##### `minBytesToUseDirectIo`<sup>Required</sup> <a name="minBytesToUseDirectIo" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIo"></a>

```typescript
public readonly minBytesToUseDirectIo: number;
```

- *Type:* number

---

##### `minCountToCompile`<sup>Required</sup> <a name="minCountToCompile" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompile"></a>

```typescript
public readonly minCountToCompile: number;
```

- *Type:* number

---

##### `minCountToCompileExpression`<sup>Required</sup> <a name="minCountToCompileExpression" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpression"></a>

```typescript
public readonly minCountToCompileExpression: number;
```

- *Type:* number

---

##### `minExecutionSpeed`<sup>Required</sup> <a name="minExecutionSpeed" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeed"></a>

```typescript
public readonly minExecutionSpeed: number;
```

- *Type:* number

---

##### `minExecutionSpeedBytes`<sup>Required</sup> <a name="minExecutionSpeedBytes" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytes"></a>

```typescript
public readonly minExecutionSpeedBytes: number;
```

- *Type:* number

---

##### `minInsertBlockSizeBytes`<sup>Required</sup> <a name="minInsertBlockSizeBytes" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytes"></a>

```typescript
public readonly minInsertBlockSizeBytes: number;
```

- *Type:* number

---

##### `minInsertBlockSizeRows`<sup>Required</sup> <a name="minInsertBlockSizeRows" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRows"></a>

```typescript
public readonly minInsertBlockSizeRows: number;
```

- *Type:* number

---

##### `outputFormatJsonQuote64BitIntegers`<sup>Required</sup> <a name="outputFormatJsonQuote64BitIntegers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegers"></a>

```typescript
public readonly outputFormatJsonQuote64BitIntegers: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `outputFormatJsonQuoteDenormals`<sup>Required</sup> <a name="outputFormatJsonQuoteDenormals" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormals"></a>

```typescript
public readonly outputFormatJsonQuoteDenormals: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `quotaMode`<sup>Required</sup> <a name="quotaMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.quotaMode"></a>

```typescript
public readonly quotaMode: string;
```

- *Type:* string

---

##### `readonly`<sup>Required</sup> <a name="readonly" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.readonly"></a>

```typescript
public readonly readonly: number;
```

- *Type:* number

---

##### `readOverflowMode`<sup>Required</sup> <a name="readOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.readOverflowMode"></a>

```typescript
public readonly readOverflowMode: string;
```

- *Type:* string

---

##### `receiveTimeout`<sup>Required</sup> <a name="receiveTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeout"></a>

```typescript
public readonly receiveTimeout: number;
```

- *Type:* number

---

##### `replicationAlterPartitionsSync`<sup>Required</sup> <a name="replicationAlterPartitionsSync" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSync"></a>

```typescript
public readonly replicationAlterPartitionsSync: number;
```

- *Type:* number

---

##### `resultOverflowMode`<sup>Required</sup> <a name="resultOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowMode"></a>

```typescript
public readonly resultOverflowMode: string;
```

- *Type:* string

---

##### `selectSequentialConsistency`<sup>Required</sup> <a name="selectSequentialConsistency" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistency"></a>

```typescript
public readonly selectSequentialConsistency: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `sendProgressInHttpHeaders`<sup>Required</sup> <a name="sendProgressInHttpHeaders" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeaders"></a>

```typescript
public readonly sendProgressInHttpHeaders: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `sendTimeout`<sup>Required</sup> <a name="sendTimeout" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sendTimeout"></a>

```typescript
public readonly sendTimeout: number;
```

- *Type:* number

---

##### `setOverflowMode`<sup>Required</sup> <a name="setOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.setOverflowMode"></a>

```typescript
public readonly setOverflowMode: string;
```

- *Type:* string

---

##### `skipUnavailableShards`<sup>Required</sup> <a name="skipUnavailableShards" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShards"></a>

```typescript
public readonly skipUnavailableShards: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `sortOverflowMode`<sup>Required</sup> <a name="sortOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowMode"></a>

```typescript
public readonly sortOverflowMode: string;
```

- *Type:* string

---

##### `timeoutOverflowMode`<sup>Required</sup> <a name="timeoutOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowMode"></a>

```typescript
public readonly timeoutOverflowMode: string;
```

- *Type:* string

---

##### `transferOverflowMode`<sup>Required</sup> <a name="transferOverflowMode" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowMode"></a>

```typescript
public readonly transferOverflowMode: string;
```

- *Type:* string

---

##### `transformNullIn`<sup>Required</sup> <a name="transformNullIn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.transformNullIn"></a>

```typescript
public readonly transformNullIn: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `useUncompressedCache`<sup>Required</sup> <a name="useUncompressedCache" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCache"></a>

```typescript
public readonly useUncompressedCache: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterUserSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterUserSettings">DataYandexMdbClickhouseClusterUserSettings</a>

---


### DataYandexMdbClickhouseClusterZookeeperList <a name="DataYandexMdbClickhouseClusterZookeeperList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeperList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterZookeeperList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterZookeeperOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterZookeeperOutputReference <a name="DataYandexMdbClickhouseClusterZookeeperOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeperOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterZookeeperOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList">DataYandexMdbClickhouseClusterZookeeperResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeper">DataYandexMdbClickhouseClusterZookeeper</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbClickhouseClusterZookeeperResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList">DataYandexMdbClickhouseClusterZookeeperResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeper">DataYandexMdbClickhouseClusterZookeeper</a>

---


### DataYandexMdbClickhouseClusterZookeeperResourcesList <a name="DataYandexMdbClickhouseClusterZookeeperResourcesList" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeperResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterZookeeperResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference <a name="DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResources">DataYandexMdbClickhouseClusterZookeeperResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbClickhouseClusterZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbClickhouseClusterZookeeperResources">DataYandexMdbClickhouseClusterZookeeperResources</a>

---


### DataYandexMdbElasticsearchClusterConfigAList <a name="DataYandexMdbElasticsearchClusterConfigAList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigAList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigAList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterConfigAOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterConfigAOutputReference <a name="DataYandexMdbElasticsearchClusterConfigAOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.adminPassword">adminPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.dataNode">dataNode</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList">DataYandexMdbElasticsearchClusterConfigDataNodeList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.edition">edition</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.masterNode">masterNode</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList">DataYandexMdbElasticsearchClusterConfigMasterNodeList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.plugins">plugins</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigA">DataYandexMdbElasticsearchClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `adminPassword`<sup>Required</sup> <a name="adminPassword" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.adminPassword"></a>

```typescript
public readonly adminPassword: string;
```

- *Type:* string

---

##### `dataNode`<sup>Required</sup> <a name="dataNode" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.dataNode"></a>

```typescript
public readonly dataNode: DataYandexMdbElasticsearchClusterConfigDataNodeList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList">DataYandexMdbElasticsearchClusterConfigDataNodeList</a>

---

##### `edition`<sup>Required</sup> <a name="edition" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.edition"></a>

```typescript
public readonly edition: string;
```

- *Type:* string

---

##### `masterNode`<sup>Required</sup> <a name="masterNode" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.masterNode"></a>

```typescript
public readonly masterNode: DataYandexMdbElasticsearchClusterConfigMasterNodeList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList">DataYandexMdbElasticsearchClusterConfigMasterNodeList</a>

---

##### `plugins`<sup>Required</sup> <a name="plugins" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.plugins"></a>

```typescript
public readonly plugins: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigA">DataYandexMdbElasticsearchClusterConfigA</a>

---


### DataYandexMdbElasticsearchClusterConfigDataNodeList <a name="DataYandexMdbElasticsearchClusterConfigDataNodeList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNodeList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigDataNodeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference <a name="DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList">DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNode">DataYandexMdbElasticsearchClusterConfigDataNode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList">DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterConfigDataNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNode">DataYandexMdbElasticsearchClusterConfigDataNode</a>

---


### DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList <a name="DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference <a name="DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResources">DataYandexMdbElasticsearchClusterConfigDataNodeResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterConfigDataNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigDataNodeResources">DataYandexMdbElasticsearchClusterConfigDataNodeResources</a>

---


### DataYandexMdbElasticsearchClusterConfigMasterNodeList <a name="DataYandexMdbElasticsearchClusterConfigMasterNodeList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNodeList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigMasterNodeList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference <a name="DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList">DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNode">DataYandexMdbElasticsearchClusterConfigMasterNode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList">DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterConfigMasterNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNode">DataYandexMdbElasticsearchClusterConfigMasterNode</a>

---


### DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList <a name="DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference <a name="DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResources">DataYandexMdbElasticsearchClusterConfigMasterNodeResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterConfigMasterNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterConfigMasterNodeResources">DataYandexMdbElasticsearchClusterConfigMasterNodeResources</a>

---


### DataYandexMdbElasticsearchClusterHostList <a name="DataYandexMdbElasticsearchClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterHostOutputReference <a name="DataYandexMdbElasticsearchClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHost">DataYandexMdbElasticsearchClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterHost">DataYandexMdbElasticsearchClusterHost</a>

---


### DataYandexMdbElasticsearchClusterMaintenanceWindowList <a name="DataYandexMdbElasticsearchClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference <a name="DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindow">DataYandexMdbElasticsearchClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbElasticsearchClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbElasticsearchClusterMaintenanceWindow">DataYandexMdbElasticsearchClusterMaintenanceWindow</a>

---


### DataYandexMdbGreenplumClusterAccessList <a name="DataYandexMdbGreenplumClusterAccessList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterAccessList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterAccessList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterAccessOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterAccessOutputReference <a name="DataYandexMdbGreenplumClusterAccessOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterAccessOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccess">DataYandexMdbGreenplumClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterAccess">DataYandexMdbGreenplumClusterAccess</a>

---


### DataYandexMdbGreenplumClusterBackupWindowStartList <a name="DataYandexMdbGreenplumClusterBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterBackupWindowStartOutputReference <a name="DataYandexMdbGreenplumClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStart">DataYandexMdbGreenplumClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterBackupWindowStart">DataYandexMdbGreenplumClusterBackupWindowStart</a>

---


### DataYandexMdbGreenplumClusterMasterHostsList <a name="DataYandexMdbGreenplumClusterMasterHostsList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterHostsList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterHostsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterMasterHostsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterMasterHostsOutputReference <a name="DataYandexMdbGreenplumClusterMasterHostsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterHostsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterHostsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHosts">DataYandexMdbGreenplumClusterMasterHosts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHostsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterMasterHosts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterHosts">DataYandexMdbGreenplumClusterMasterHosts</a>

---


### DataYandexMdbGreenplumClusterMasterSubclusterList <a name="DataYandexMdbGreenplumClusterMasterSubclusterList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubclusterList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterSubclusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterMasterSubclusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterMasterSubclusterOutputReference <a name="DataYandexMdbGreenplumClusterMasterSubclusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubclusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterSubclusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList">DataYandexMdbGreenplumClusterMasterSubclusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubcluster">DataYandexMdbGreenplumClusterMasterSubcluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbGreenplumClusterMasterSubclusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList">DataYandexMdbGreenplumClusterMasterSubclusterResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterMasterSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubcluster">DataYandexMdbGreenplumClusterMasterSubcluster</a>

---


### DataYandexMdbGreenplumClusterMasterSubclusterResourcesList <a name="DataYandexMdbGreenplumClusterMasterSubclusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubclusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterSubclusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference <a name="DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResources">DataYandexMdbGreenplumClusterMasterSubclusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterMasterSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterMasterSubclusterResources">DataYandexMdbGreenplumClusterMasterSubclusterResources</a>

---


### DataYandexMdbGreenplumClusterSegmentHostsList <a name="DataYandexMdbGreenplumClusterSegmentHostsList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentHostsList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentHostsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterSegmentHostsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterSegmentHostsOutputReference <a name="DataYandexMdbGreenplumClusterSegmentHostsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentHostsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentHostsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHosts">DataYandexMdbGreenplumClusterSegmentHosts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHostsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterSegmentHosts;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentHosts">DataYandexMdbGreenplumClusterSegmentHosts</a>

---


### DataYandexMdbGreenplumClusterSegmentSubclusterList <a name="DataYandexMdbGreenplumClusterSegmentSubclusterList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubclusterList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentSubclusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference <a name="DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList">DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubcluster">DataYandexMdbGreenplumClusterSegmentSubcluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList">DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterSegmentSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubcluster">DataYandexMdbGreenplumClusterSegmentSubcluster</a>

---


### DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList <a name="DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference <a name="DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResources">DataYandexMdbGreenplumClusterSegmentSubclusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbGreenplumClusterSegmentSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbGreenplumClusterSegmentSubclusterResources">DataYandexMdbGreenplumClusterSegmentSubclusterResources</a>

---


### DataYandexMdbKafkaClusterConfigAOutputReference <a name="DataYandexMdbKafkaClusterConfigAOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putKafka">putKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putZookeeper">putZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetBrokersCount">resetBrokersCount</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetSchemaRegistry">resetSchemaRegistry</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetUnmanagedTopics">resetUnmanagedTopics</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetZookeeper">resetZookeeper</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putKafka` <a name="putKafka" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putKafka"></a>

```typescript
public putKafka(value: DataYandexMdbKafkaClusterConfigKafka): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putKafka.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a>

---

##### `putZookeeper` <a name="putZookeeper" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putZookeeper"></a>

```typescript
public putZookeeper(value: DataYandexMdbKafkaClusterConfigZookeeper): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.putZookeeper.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a>

---

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetBrokersCount` <a name="resetBrokersCount" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetBrokersCount"></a>

```typescript
public resetBrokersCount(): void
```

##### `resetSchemaRegistry` <a name="resetSchemaRegistry" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetSchemaRegistry"></a>

```typescript
public resetSchemaRegistry(): void
```

##### `resetUnmanagedTopics` <a name="resetUnmanagedTopics" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetUnmanagedTopics"></a>

```typescript
public resetUnmanagedTopics(): void
```

##### `resetZookeeper` <a name="resetZookeeper" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.resetZookeeper"></a>

```typescript
public resetZookeeper(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference">DataYandexMdbKafkaClusterConfigKafkaOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference">DataYandexMdbKafkaClusterConfigZookeeperOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.brokersCountInput">brokersCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.kafkaInput">kafkaInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.schemaRegistryInput">schemaRegistryInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.unmanagedTopicsInput">unmanagedTopicsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zonesInput">zonesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zookeeperInput">zookeeperInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.brokersCount">brokersCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.schemaRegistry">schemaRegistry</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.unmanagedTopics">unmanagedTopics</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zones">zones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.kafka"></a>

```typescript
public readonly kafka: DataYandexMdbKafkaClusterConfigKafkaOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference">DataYandexMdbKafkaClusterConfigKafkaOutputReference</a>

---

##### `zookeeper`<sup>Required</sup> <a name="zookeeper" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zookeeper"></a>

```typescript
public readonly zookeeper: DataYandexMdbKafkaClusterConfigZookeeperOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference">DataYandexMdbKafkaClusterConfigZookeeperOutputReference</a>

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `brokersCountInput`<sup>Optional</sup> <a name="brokersCountInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.brokersCountInput"></a>

```typescript
public readonly brokersCountInput: number;
```

- *Type:* number

---

##### `kafkaInput`<sup>Optional</sup> <a name="kafkaInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.kafkaInput"></a>

```typescript
public readonly kafkaInput: DataYandexMdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a>

---

##### `schemaRegistryInput`<sup>Optional</sup> <a name="schemaRegistryInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.schemaRegistryInput"></a>

```typescript
public readonly schemaRegistryInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `unmanagedTopicsInput`<sup>Optional</sup> <a name="unmanagedTopicsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.unmanagedTopicsInput"></a>

```typescript
public readonly unmanagedTopicsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `zonesInput`<sup>Optional</sup> <a name="zonesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zonesInput"></a>

```typescript
public readonly zonesInput: string[];
```

- *Type:* string[]

---

##### `zookeeperInput`<sup>Optional</sup> <a name="zookeeperInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zookeeperInput"></a>

```typescript
public readonly zookeeperInput: DataYandexMdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a>

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `brokersCount`<sup>Required</sup> <a name="brokersCount" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.brokersCount"></a>

```typescript
public readonly brokersCount: number;
```

- *Type:* number

---

##### `schemaRegistry`<sup>Required</sup> <a name="schemaRegistry" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.schemaRegistry"></a>

```typescript
public readonly schemaRegistry: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `unmanagedTopics`<sup>Required</sup> <a name="unmanagedTopics" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.unmanagedTopics"></a>

```typescript
public readonly unmanagedTopics: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigA">DataYandexMdbKafkaClusterConfigA</a>

---


### DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference <a name="DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetAutoCreateTopicsEnable">resetAutoCreateTopicsEnable</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetCompressionType">resetCompressionType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetDefaultReplicationFactor">resetDefaultReplicationFactor</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMessages">resetLogFlushIntervalMessages</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMs">resetLogFlushIntervalMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushSchedulerIntervalMs">resetLogFlushSchedulerIntervalMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogPreallocate">resetLogPreallocate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionBytes">resetLogRetentionBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionHours">resetLogRetentionHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMinutes">resetLogRetentionMinutes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMs">resetLogRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogSegmentBytes">resetLogSegmentBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetNumPartitions">resetNumPartitions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketReceiveBufferBytes">resetSocketReceiveBufferBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketSendBufferBytes">resetSocketSendBufferBytes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAutoCreateTopicsEnable` <a name="resetAutoCreateTopicsEnable" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetAutoCreateTopicsEnable"></a>

```typescript
public resetAutoCreateTopicsEnable(): void
```

##### `resetCompressionType` <a name="resetCompressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetCompressionType"></a>

```typescript
public resetCompressionType(): void
```

##### `resetDefaultReplicationFactor` <a name="resetDefaultReplicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetDefaultReplicationFactor"></a>

```typescript
public resetDefaultReplicationFactor(): void
```

##### `resetLogFlushIntervalMessages` <a name="resetLogFlushIntervalMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMessages"></a>

```typescript
public resetLogFlushIntervalMessages(): void
```

##### `resetLogFlushIntervalMs` <a name="resetLogFlushIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMs"></a>

```typescript
public resetLogFlushIntervalMs(): void
```

##### `resetLogFlushSchedulerIntervalMs` <a name="resetLogFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushSchedulerIntervalMs"></a>

```typescript
public resetLogFlushSchedulerIntervalMs(): void
```

##### `resetLogPreallocate` <a name="resetLogPreallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogPreallocate"></a>

```typescript
public resetLogPreallocate(): void
```

##### `resetLogRetentionBytes` <a name="resetLogRetentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionBytes"></a>

```typescript
public resetLogRetentionBytes(): void
```

##### `resetLogRetentionHours` <a name="resetLogRetentionHours" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionHours"></a>

```typescript
public resetLogRetentionHours(): void
```

##### `resetLogRetentionMinutes` <a name="resetLogRetentionMinutes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMinutes"></a>

```typescript
public resetLogRetentionMinutes(): void
```

##### `resetLogRetentionMs` <a name="resetLogRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMs"></a>

```typescript
public resetLogRetentionMs(): void
```

##### `resetLogSegmentBytes` <a name="resetLogSegmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogSegmentBytes"></a>

```typescript
public resetLogSegmentBytes(): void
```

##### `resetNumPartitions` <a name="resetNumPartitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetNumPartitions"></a>

```typescript
public resetNumPartitions(): void
```

##### `resetSocketReceiveBufferBytes` <a name="resetSocketReceiveBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketReceiveBufferBytes"></a>

```typescript
public resetSocketReceiveBufferBytes(): void
```

##### `resetSocketSendBufferBytes` <a name="resetSocketSendBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketSendBufferBytes"></a>

```typescript
public resetSocketSendBufferBytes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnableInput">autoCreateTopicsEnableInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionTypeInput">compressionTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactorInput">defaultReplicationFactorInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessagesInput">logFlushIntervalMessagesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMsInput">logFlushIntervalMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMsInput">logFlushSchedulerIntervalMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocateInput">logPreallocateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytesInput">logRetentionBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHoursInput">logRetentionHoursInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutesInput">logRetentionMinutesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMsInput">logRetentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytesInput">logSegmentBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitionsInput">numPartitionsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytesInput">socketReceiveBufferBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytesInput">socketSendBufferBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnable">autoCreateTopicsEnable</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactor">defaultReplicationFactor</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessages">logFlushIntervalMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMs">logFlushIntervalMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMs">logFlushSchedulerIntervalMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocate">logPreallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytes">logRetentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHours">logRetentionHours</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutes">logRetentionMinutes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMs">logRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytes">logSegmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitions">numPartitions</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytes">socketReceiveBufferBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytes">socketSendBufferBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoCreateTopicsEnableInput`<sup>Optional</sup> <a name="autoCreateTopicsEnableInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnableInput"></a>

```typescript
public readonly autoCreateTopicsEnableInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compressionTypeInput`<sup>Optional</sup> <a name="compressionTypeInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionTypeInput"></a>

```typescript
public readonly compressionTypeInput: string;
```

- *Type:* string

---

##### `defaultReplicationFactorInput`<sup>Optional</sup> <a name="defaultReplicationFactorInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactorInput"></a>

```typescript
public readonly defaultReplicationFactorInput: string;
```

- *Type:* string

---

##### `logFlushIntervalMessagesInput`<sup>Optional</sup> <a name="logFlushIntervalMessagesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessagesInput"></a>

```typescript
public readonly logFlushIntervalMessagesInput: string;
```

- *Type:* string

---

##### `logFlushIntervalMsInput`<sup>Optional</sup> <a name="logFlushIntervalMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMsInput"></a>

```typescript
public readonly logFlushIntervalMsInput: string;
```

- *Type:* string

---

##### `logFlushSchedulerIntervalMsInput`<sup>Optional</sup> <a name="logFlushSchedulerIntervalMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMsInput"></a>

```typescript
public readonly logFlushSchedulerIntervalMsInput: string;
```

- *Type:* string

---

##### `logPreallocateInput`<sup>Optional</sup> <a name="logPreallocateInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocateInput"></a>

```typescript
public readonly logPreallocateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `logRetentionBytesInput`<sup>Optional</sup> <a name="logRetentionBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytesInput"></a>

```typescript
public readonly logRetentionBytesInput: string;
```

- *Type:* string

---

##### `logRetentionHoursInput`<sup>Optional</sup> <a name="logRetentionHoursInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHoursInput"></a>

```typescript
public readonly logRetentionHoursInput: string;
```

- *Type:* string

---

##### `logRetentionMinutesInput`<sup>Optional</sup> <a name="logRetentionMinutesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutesInput"></a>

```typescript
public readonly logRetentionMinutesInput: string;
```

- *Type:* string

---

##### `logRetentionMsInput`<sup>Optional</sup> <a name="logRetentionMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMsInput"></a>

```typescript
public readonly logRetentionMsInput: string;
```

- *Type:* string

---

##### `logSegmentBytesInput`<sup>Optional</sup> <a name="logSegmentBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytesInput"></a>

```typescript
public readonly logSegmentBytesInput: string;
```

- *Type:* string

---

##### `numPartitionsInput`<sup>Optional</sup> <a name="numPartitionsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitionsInput"></a>

```typescript
public readonly numPartitionsInput: string;
```

- *Type:* string

---

##### `socketReceiveBufferBytesInput`<sup>Optional</sup> <a name="socketReceiveBufferBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytesInput"></a>

```typescript
public readonly socketReceiveBufferBytesInput: string;
```

- *Type:* string

---

##### `socketSendBufferBytesInput`<sup>Optional</sup> <a name="socketSendBufferBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytesInput"></a>

```typescript
public readonly socketSendBufferBytesInput: string;
```

- *Type:* string

---

##### `autoCreateTopicsEnable`<sup>Required</sup> <a name="autoCreateTopicsEnable" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnable"></a>

```typescript
public readonly autoCreateTopicsEnable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `defaultReplicationFactor`<sup>Required</sup> <a name="defaultReplicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactor"></a>

```typescript
public readonly defaultReplicationFactor: string;
```

- *Type:* string

---

##### `logFlushIntervalMessages`<sup>Required</sup> <a name="logFlushIntervalMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessages"></a>

```typescript
public readonly logFlushIntervalMessages: string;
```

- *Type:* string

---

##### `logFlushIntervalMs`<sup>Required</sup> <a name="logFlushIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMs"></a>

```typescript
public readonly logFlushIntervalMs: string;
```

- *Type:* string

---

##### `logFlushSchedulerIntervalMs`<sup>Required</sup> <a name="logFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMs"></a>

```typescript
public readonly logFlushSchedulerIntervalMs: string;
```

- *Type:* string

---

##### `logPreallocate`<sup>Required</sup> <a name="logPreallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocate"></a>

```typescript
public readonly logPreallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `logRetentionBytes`<sup>Required</sup> <a name="logRetentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytes"></a>

```typescript
public readonly logRetentionBytes: string;
```

- *Type:* string

---

##### `logRetentionHours`<sup>Required</sup> <a name="logRetentionHours" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHours"></a>

```typescript
public readonly logRetentionHours: string;
```

- *Type:* string

---

##### `logRetentionMinutes`<sup>Required</sup> <a name="logRetentionMinutes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutes"></a>

```typescript
public readonly logRetentionMinutes: string;
```

- *Type:* string

---

##### `logRetentionMs`<sup>Required</sup> <a name="logRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMs"></a>

```typescript
public readonly logRetentionMs: string;
```

- *Type:* string

---

##### `logSegmentBytes`<sup>Required</sup> <a name="logSegmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytes"></a>

```typescript
public readonly logSegmentBytes: string;
```

- *Type:* string

---

##### `numPartitions`<sup>Required</sup> <a name="numPartitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitions"></a>

```typescript
public readonly numPartitions: string;
```

- *Type:* string

---

##### `socketReceiveBufferBytes`<sup>Required</sup> <a name="socketReceiveBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytes"></a>

```typescript
public readonly socketReceiveBufferBytes: string;
```

- *Type:* string

---

##### `socketSendBufferBytes`<sup>Required</sup> <a name="socketSendBufferBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytes"></a>

```typescript
public readonly socketSendBufferBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a>

---


### DataYandexMdbKafkaClusterConfigKafkaOutputReference <a name="DataYandexMdbKafkaClusterConfigKafkaOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafkaOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigKafkaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig">putKafkaConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.resetKafkaConfig">resetKafkaConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putKafkaConfig` <a name="putKafkaConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig"></a>

```typescript
public putKafkaConfig(value: DataYandexMdbKafkaClusterConfigKafkaKafkaConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putResources"></a>

```typescript
public putResources(value: DataYandexMdbKafkaClusterConfigKafkaResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a>

---

##### `resetKafkaConfig` <a name="resetKafkaConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.resetKafkaConfig"></a>

```typescript
public resetKafkaConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfig">kafkaConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference">DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference">DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfigInput">kafkaConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `kafkaConfig`<sup>Required</sup> <a name="kafkaConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfig"></a>

```typescript
public readonly kafkaConfig: DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference">DataYandexMdbKafkaClusterConfigKafkaKafkaConfigOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference">DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference</a>

---

##### `kafkaConfigInput`<sup>Optional</sup> <a name="kafkaConfigInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfigInput"></a>

```typescript
public readonly kafkaConfigInput: DataYandexMdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaKafkaConfig">DataYandexMdbKafkaClusterConfigKafkaKafkaConfig</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: DataYandexMdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafka">DataYandexMdbKafkaClusterConfigKafka</a>

---


### DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference <a name="DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigKafkaResources">DataYandexMdbKafkaClusterConfigKafkaResources</a>

---


### DataYandexMdbKafkaClusterConfigZookeeperOutputReference <a name="DataYandexMdbKafkaClusterConfigZookeeperOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigZookeeperOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigZookeeperOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.resetResources">resetResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.putResources"></a>

```typescript
public putResources(value: DataYandexMdbKafkaClusterConfigZookeeperResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a>

---

##### `resetResources` <a name="resetResources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.resetResources"></a>

```typescript
public resetResources(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference">DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference">DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: DataYandexMdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeper">DataYandexMdbKafkaClusterConfigZookeeper</a>

---


### DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference <a name="DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskSize">resetDiskSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetResourcePresetId">resetResourcePresetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskSize` <a name="resetDiskSize" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskSize"></a>

```typescript
public resetDiskSize(): void
```

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```

##### `resetResourcePresetId` <a name="resetResourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.resetResourcePresetId"></a>

```typescript
public resetResourcePresetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterConfigZookeeperResources">DataYandexMdbKafkaClusterConfigZookeeperResources</a>

---


### DataYandexMdbKafkaClusterHostList <a name="DataYandexMdbKafkaClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaClusterHostOutputReference <a name="DataYandexMdbKafkaClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHost">DataYandexMdbKafkaClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterHost">DataYandexMdbKafkaClusterHost</a>

---


### DataYandexMdbKafkaClusterMaintenanceWindowList <a name="DataYandexMdbKafkaClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaClusterMaintenanceWindowOutputReference <a name="DataYandexMdbKafkaClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindow">DataYandexMdbKafkaClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterMaintenanceWindow">DataYandexMdbKafkaClusterMaintenanceWindow</a>

---


### DataYandexMdbKafkaClusterTopicList <a name="DataYandexMdbKafkaClusterTopicList" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterTopicList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterTopicList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaClusterTopicOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>[]

---


### DataYandexMdbKafkaClusterTopicOutputReference <a name="DataYandexMdbKafkaClusterTopicOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterTopicOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterTopicOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.putTopicConfig">putTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.resetTopicConfig">resetTopicConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTopicConfig` <a name="putTopicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.putTopicConfig"></a>

```typescript
public putTopicConfig(value: DataYandexMdbKafkaClusterTopicTopicConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.putTopicConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a>

---

##### `resetTopicConfig` <a name="resetTopicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.resetTopicConfig"></a>

```typescript
public resetTopicConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference">DataYandexMdbKafkaClusterTopicTopicConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.clusterIdInput">clusterIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.partitionsInput">partitionsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.replicationFactorInput">replicationFactorInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.topicConfigInput">topicConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.clusterId">clusterId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.partitions">partitions</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `topicConfig`<sup>Required</sup> <a name="topicConfig" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.topicConfig"></a>

```typescript
public readonly topicConfig: DataYandexMdbKafkaClusterTopicTopicConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference">DataYandexMdbKafkaClusterTopicTopicConfigOutputReference</a>

---

##### `clusterIdInput`<sup>Optional</sup> <a name="clusterIdInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.clusterIdInput"></a>

```typescript
public readonly clusterIdInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `partitionsInput`<sup>Optional</sup> <a name="partitionsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.partitionsInput"></a>

```typescript
public readonly partitionsInput: number;
```

- *Type:* number

---

##### `replicationFactorInput`<sup>Optional</sup> <a name="replicationFactorInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.replicationFactorInput"></a>

```typescript
public readonly replicationFactorInput: number;
```

- *Type:* number

---

##### `topicConfigInput`<sup>Optional</sup> <a name="topicConfigInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.topicConfigInput"></a>

```typescript
public readonly topicConfigInput: DataYandexMdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a>

---

##### `clusterId`<sup>Required</sup> <a name="clusterId" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.clusterId"></a>

```typescript
public readonly clusterId: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterTopic;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopic">DataYandexMdbKafkaClusterTopic</a>

---


### DataYandexMdbKafkaClusterTopicTopicConfigOutputReference <a name="DataYandexMdbKafkaClusterTopicTopicConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterTopicTopicConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterTopicTopicConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetCleanupPolicy">resetCleanupPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetCompressionType">resetCompressionType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetDeleteRetentionMs">resetDeleteRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFileDeleteDelayMs">resetFileDeleteDelayMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMessages">resetFlushMessages</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMs">resetFlushMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMaxMessageBytes">resetMaxMessageBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMinCompactionLagMs">resetMinCompactionLagMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMinInsyncReplicas">resetMinInsyncReplicas</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetPreallocate">resetPreallocate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionBytes">resetRetentionBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionMs">resetRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetSegmentBytes">resetSegmentBytes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCleanupPolicy` <a name="resetCleanupPolicy" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetCleanupPolicy"></a>

```typescript
public resetCleanupPolicy(): void
```

##### `resetCompressionType` <a name="resetCompressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetCompressionType"></a>

```typescript
public resetCompressionType(): void
```

##### `resetDeleteRetentionMs` <a name="resetDeleteRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetDeleteRetentionMs"></a>

```typescript
public resetDeleteRetentionMs(): void
```

##### `resetFileDeleteDelayMs` <a name="resetFileDeleteDelayMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFileDeleteDelayMs"></a>

```typescript
public resetFileDeleteDelayMs(): void
```

##### `resetFlushMessages` <a name="resetFlushMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMessages"></a>

```typescript
public resetFlushMessages(): void
```

##### `resetFlushMs` <a name="resetFlushMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMs"></a>

```typescript
public resetFlushMs(): void
```

##### `resetMaxMessageBytes` <a name="resetMaxMessageBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMaxMessageBytes"></a>

```typescript
public resetMaxMessageBytes(): void
```

##### `resetMinCompactionLagMs` <a name="resetMinCompactionLagMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMinCompactionLagMs"></a>

```typescript
public resetMinCompactionLagMs(): void
```

##### `resetMinInsyncReplicas` <a name="resetMinInsyncReplicas" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetMinInsyncReplicas"></a>

```typescript
public resetMinInsyncReplicas(): void
```

##### `resetPreallocate` <a name="resetPreallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetPreallocate"></a>

```typescript
public resetPreallocate(): void
```

##### `resetRetentionBytes` <a name="resetRetentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionBytes"></a>

```typescript
public resetRetentionBytes(): void
```

##### `resetRetentionMs` <a name="resetRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionMs"></a>

```typescript
public resetRetentionMs(): void
```

##### `resetSegmentBytes` <a name="resetSegmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.resetSegmentBytes"></a>

```typescript
public resetSegmentBytes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicyInput">cleanupPolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.compressionTypeInput">compressionTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMsInput">deleteRetentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput">fileDeleteDelayMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessagesInput">flushMessagesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMsInput">flushMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytesInput">maxMessageBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMsInput">minCompactionLagMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicasInput">minInsyncReplicasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.preallocateInput">preallocateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytesInput">retentionBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMsInput">retentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytesInput">segmentBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessages">flushMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMs">flushMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMs">retentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cleanupPolicyInput`<sup>Optional</sup> <a name="cleanupPolicyInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicyInput"></a>

```typescript
public readonly cleanupPolicyInput: string;
```

- *Type:* string

---

##### `compressionTypeInput`<sup>Optional</sup> <a name="compressionTypeInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.compressionTypeInput"></a>

```typescript
public readonly compressionTypeInput: string;
```

- *Type:* string

---

##### `deleteRetentionMsInput`<sup>Optional</sup> <a name="deleteRetentionMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMsInput"></a>

```typescript
public readonly deleteRetentionMsInput: string;
```

- *Type:* string

---

##### `fileDeleteDelayMsInput`<sup>Optional</sup> <a name="fileDeleteDelayMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput"></a>

```typescript
public readonly fileDeleteDelayMsInput: string;
```

- *Type:* string

---

##### `flushMessagesInput`<sup>Optional</sup> <a name="flushMessagesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessagesInput"></a>

```typescript
public readonly flushMessagesInput: string;
```

- *Type:* string

---

##### `flushMsInput`<sup>Optional</sup> <a name="flushMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMsInput"></a>

```typescript
public readonly flushMsInput: string;
```

- *Type:* string

---

##### `maxMessageBytesInput`<sup>Optional</sup> <a name="maxMessageBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytesInput"></a>

```typescript
public readonly maxMessageBytesInput: string;
```

- *Type:* string

---

##### `minCompactionLagMsInput`<sup>Optional</sup> <a name="minCompactionLagMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMsInput"></a>

```typescript
public readonly minCompactionLagMsInput: string;
```

- *Type:* string

---

##### `minInsyncReplicasInput`<sup>Optional</sup> <a name="minInsyncReplicasInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicasInput"></a>

```typescript
public readonly minInsyncReplicasInput: string;
```

- *Type:* string

---

##### `preallocateInput`<sup>Optional</sup> <a name="preallocateInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.preallocateInput"></a>

```typescript
public readonly preallocateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytesInput`<sup>Optional</sup> <a name="retentionBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytesInput"></a>

```typescript
public readonly retentionBytesInput: string;
```

- *Type:* string

---

##### `retentionMsInput`<sup>Optional</sup> <a name="retentionMsInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMsInput"></a>

```typescript
public readonly retentionMsInput: string;
```

- *Type:* string

---

##### `segmentBytesInput`<sup>Optional</sup> <a name="segmentBytesInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytesInput"></a>

```typescript
public readonly segmentBytesInput: string;
```

- *Type:* string

---

##### `cleanupPolicy`<sup>Required</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `deleteRetentionMs`<sup>Required</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

---

##### `fileDeleteDelayMs`<sup>Required</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

---

##### `flushMessages`<sup>Required</sup> <a name="flushMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

---

##### `flushMs`<sup>Required</sup> <a name="flushMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

---

##### `maxMessageBytes`<sup>Required</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

---

##### `minCompactionLagMs`<sup>Required</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

---

##### `minInsyncReplicas`<sup>Required</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

---

##### `preallocate`<sup>Required</sup> <a name="preallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytes`<sup>Required</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

---

##### `retentionMs`<sup>Required</sup> <a name="retentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

---

##### `segmentBytes`<sup>Required</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterTopicTopicConfig">DataYandexMdbKafkaClusterTopicTopicConfig</a>

---


### DataYandexMdbKafkaClusterUserList <a name="DataYandexMdbKafkaClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>[]

---


### DataYandexMdbKafkaClusterUserOutputReference <a name="DataYandexMdbKafkaClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | DataYandexMdbKafkaClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]

---

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList">DataYandexMdbKafkaClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbKafkaClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList">DataYandexMdbKafkaClusterUserPermissionList</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | DataYandexMdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUser">DataYandexMdbKafkaClusterUser</a>

---


### DataYandexMdbKafkaClusterUserPermissionList <a name="DataYandexMdbKafkaClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>[]

---


### DataYandexMdbKafkaClusterUserPermissionOutputReference <a name="DataYandexMdbKafkaClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.topicNameInput">topicNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.topicName">topicName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `topicNameInput`<sup>Optional</sup> <a name="topicNameInput" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.topicNameInput"></a>

```typescript
public readonly topicNameInput: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `topicName`<sup>Required</sup> <a name="topicName" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DataYandexMdbKafkaClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaClusterUserPermission">DataYandexMdbKafkaClusterUserPermission</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceCluster">sourceCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetCluster">targetCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topics">topics</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormaker">DataYandexMdbKafkaConnectorConnectorConfigMirrormaker</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

##### `sourceCluster`<sup>Required</sup> <a name="sourceCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceCluster"></a>

```typescript
public readonly sourceCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList</a>

---

##### `targetCluster`<sup>Required</sup> <a name="targetCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetCluster"></a>

```typescript
public readonly targetCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList</a>

---

##### `topics`<sup>Required</sup> <a name="topics" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topics"></a>

```typescript
public readonly topics: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormaker;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormaker">DataYandexMdbKafkaConnectorConnectorConfigMirrormaker</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalCluster">externalCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisCluster">thisCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `alias`<sup>Required</sup> <a name="alias" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `externalCluster`<sup>Required</sup> <a name="externalCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalCluster"></a>

```typescript
public readonly externalCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList</a>

---

##### `thisCluster`<sup>Required</sup> <a name="thisCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisCluster"></a>

```typescript
public readonly thisCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalCluster">externalCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisCluster">thisCluster</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `alias`<sup>Required</sup> <a name="alias" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `externalCluster`<sup>Required</sup> <a name="externalCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalCluster"></a>

```typescript
public readonly externalCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList</a>

---

##### `thisCluster`<sup>Required</sup> <a name="thisCluster" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisCluster"></a>

```typescript
public readonly thisCluster: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a>

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference <a name="DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">DataYandexMdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>

---


### DataYandexMdbKafkaTopicTopicConfigList <a name="DataYandexMdbKafkaTopicTopicConfigList" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer"></a>

```typescript
import { DataYandexMdbKafkaTopicTopicConfigList } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaTopicTopicConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.get"></a>

```typescript
public get(index: number): DataYandexMdbKafkaTopicTopicConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbKafkaTopicTopicConfigOutputReference <a name="DataYandexMdbKafkaTopicTopicConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbKafkaTopicTopicConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbKafkaTopicTopicConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.flushMessages">flushMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.flushMs">flushMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.preallocate">preallocate</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.retentionMs">retentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfig">DataYandexMdbKafkaTopicTopicConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cleanupPolicy`<sup>Required</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `deleteRetentionMs`<sup>Required</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

---

##### `fileDeleteDelayMs`<sup>Required</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

---

##### `flushMessages`<sup>Required</sup> <a name="flushMessages" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

---

##### `flushMs`<sup>Required</sup> <a name="flushMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

---

##### `maxMessageBytes`<sup>Required</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

---

##### `minCompactionLagMs`<sup>Required</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

---

##### `minInsyncReplicas`<sup>Required</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

---

##### `preallocate`<sup>Required</sup> <a name="preallocate" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.preallocate"></a>

```typescript
public readonly preallocate: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `retentionBytes`<sup>Required</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

---

##### `retentionMs`<sup>Required</sup> <a name="retentionMs" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

---

##### `segmentBytes`<sup>Required</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbKafkaTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbKafkaTopicTopicConfig">DataYandexMdbKafkaTopicTopicConfig</a>

---


### DataYandexMdbMongodbClusterClusterConfigAccessList <a name="DataYandexMdbMongodbClusterClusterConfigAccessList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigAccessList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigAccessList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterClusterConfigAccessOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterClusterConfigAccessOutputReference <a name="DataYandexMdbMongodbClusterClusterConfigAccessOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigAccessOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccess">DataYandexMdbMongodbClusterClusterConfigAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccess">DataYandexMdbMongodbClusterClusterConfigAccess</a>

---


### DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList <a name="DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference <a name="DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStart">DataYandexMdbMongodbClusterClusterConfigBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStart">DataYandexMdbMongodbClusterClusterConfigBackupWindowStart</a>

---


### DataYandexMdbMongodbClusterClusterConfigList <a name="DataYandexMdbMongodbClusterClusterConfigList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterClusterConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterClusterConfigOutputReference <a name="DataYandexMdbMongodbClusterClusterConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterClusterConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterClusterConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList">DataYandexMdbMongodbClusterClusterConfigAccessList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList">DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersion">featureCompatibilityVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfig">DataYandexMdbMongodbClusterClusterConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.access"></a>

```typescript
public readonly access: DataYandexMdbMongodbClusterClusterConfigAccessList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigAccessList">DataYandexMdbMongodbClusterClusterConfigAccessList</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList">DataYandexMdbMongodbClusterClusterConfigBackupWindowStartList</a>

---

##### `featureCompatibilityVersion`<sup>Required</sup> <a name="featureCompatibilityVersion" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersion"></a>

```typescript
public readonly featureCompatibilityVersion: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterClusterConfig">DataYandexMdbMongodbClusterClusterConfig</a>

---


### DataYandexMdbMongodbClusterDatabaseList <a name="DataYandexMdbMongodbClusterDatabaseList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterDatabaseList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterDatabaseOutputReference <a name="DataYandexMdbMongodbClusterDatabaseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabase">DataYandexMdbMongodbClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterDatabase;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterDatabase">DataYandexMdbMongodbClusterDatabase</a>

---


### DataYandexMdbMongodbClusterHostList <a name="DataYandexMdbMongodbClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterHostOutputReference <a name="DataYandexMdbMongodbClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHost">DataYandexMdbMongodbClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterHost">DataYandexMdbMongodbClusterHost</a>

---


### DataYandexMdbMongodbClusterMaintenanceWindowList <a name="DataYandexMdbMongodbClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterMaintenanceWindowOutputReference <a name="DataYandexMdbMongodbClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindow">DataYandexMdbMongodbClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterMaintenanceWindow">DataYandexMdbMongodbClusterMaintenanceWindow</a>

---


### DataYandexMdbMongodbClusterResourcesList <a name="DataYandexMdbMongodbClusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterResourcesOutputReference <a name="DataYandexMdbMongodbClusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResources">DataYandexMdbMongodbClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterResources">DataYandexMdbMongodbClusterResources</a>

---


### DataYandexMdbMongodbClusterUserList <a name="DataYandexMdbMongodbClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterUserOutputReference <a name="DataYandexMdbMongodbClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList">DataYandexMdbMongodbClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUser">DataYandexMdbMongodbClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbMongodbClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList">DataYandexMdbMongodbClusterUserPermissionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterUser;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUser">DataYandexMdbMongodbClusterUser</a>

---


### DataYandexMdbMongodbClusterUserPermissionList <a name="DataYandexMdbMongodbClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbMongodbClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMongodbClusterUserPermissionOutputReference <a name="DataYandexMdbMongodbClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMongodbClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMongodbClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermission">DataYandexMdbMongodbClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMongodbClusterUserPermission;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMongodbClusterUserPermission">DataYandexMdbMongodbClusterUserPermission</a>

---


### DataYandexMdbMysqlClusterAccessOutputReference <a name="DataYandexMdbMysqlClusterAccessOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterAccessOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterAccess">DataYandexMdbMysqlClusterAccess</a>

---


### DataYandexMdbMysqlClusterBackupWindowStartList <a name="DataYandexMdbMysqlClusterBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterBackupWindowStartOutputReference <a name="DataYandexMdbMysqlClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStart">DataYandexMdbMysqlClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterBackupWindowStart">DataYandexMdbMysqlClusterBackupWindowStart</a>

---


### DataYandexMdbMysqlClusterDatabaseList <a name="DataYandexMdbMysqlClusterDatabaseList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterDatabaseList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterDatabaseOutputReference <a name="DataYandexMdbMysqlClusterDatabaseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabase">DataYandexMdbMysqlClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterDatabase;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterDatabase">DataYandexMdbMysqlClusterDatabase</a>

---


### DataYandexMdbMysqlClusterHostList <a name="DataYandexMdbMysqlClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterHostOutputReference <a name="DataYandexMdbMysqlClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.backupPriority">backupPriority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.replicationSource">replicationSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHost">DataYandexMdbMysqlClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `backupPriority`<sup>Required</sup> <a name="backupPriority" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.backupPriority"></a>

```typescript
public readonly backupPriority: number;
```

- *Type:* number

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `replicationSource`<sup>Required</sup> <a name="replicationSource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.replicationSource"></a>

```typescript
public readonly replicationSource: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterHost">DataYandexMdbMysqlClusterHost</a>

---


### DataYandexMdbMysqlClusterMaintenanceWindowList <a name="DataYandexMdbMysqlClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterMaintenanceWindowOutputReference <a name="DataYandexMdbMysqlClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindow">DataYandexMdbMysqlClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterMaintenanceWindow">DataYandexMdbMysqlClusterMaintenanceWindow</a>

---


### DataYandexMdbMysqlClusterResourcesList <a name="DataYandexMdbMysqlClusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterResourcesOutputReference <a name="DataYandexMdbMysqlClusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResources">DataYandexMdbMysqlClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterResources">DataYandexMdbMysqlClusterResources</a>

---


### DataYandexMdbMysqlClusterUserConnectionLimitsList <a name="DataYandexMdbMysqlClusterUserConnectionLimitsList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserConnectionLimitsList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserConnectionLimitsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference <a name="DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHour">maxConnectionsPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHour">maxQuestionsPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHour">maxUpdatesPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnections">maxUserConnections</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimits">DataYandexMdbMysqlClusterUserConnectionLimits</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConnectionsPerHour`<sup>Required</sup> <a name="maxConnectionsPerHour" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHour"></a>

```typescript
public readonly maxConnectionsPerHour: number;
```

- *Type:* number

---

##### `maxQuestionsPerHour`<sup>Required</sup> <a name="maxQuestionsPerHour" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHour"></a>

```typescript
public readonly maxQuestionsPerHour: number;
```

- *Type:* number

---

##### `maxUpdatesPerHour`<sup>Required</sup> <a name="maxUpdatesPerHour" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHour"></a>

```typescript
public readonly maxUpdatesPerHour: number;
```

- *Type:* number

---

##### `maxUserConnections`<sup>Required</sup> <a name="maxUserConnections" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnections"></a>

```typescript
public readonly maxUserConnections: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterUserConnectionLimits;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimits">DataYandexMdbMysqlClusterUserConnectionLimits</a>

---


### DataYandexMdbMysqlClusterUserList <a name="DataYandexMdbMysqlClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterUserOutputReference <a name="DataYandexMdbMysqlClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.authenticationPlugin">authenticationPlugin</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.connectionLimits">connectionLimits</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList">DataYandexMdbMysqlClusterUserConnectionLimitsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.globalPermissions">globalPermissions</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList">DataYandexMdbMysqlClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUser">DataYandexMdbMysqlClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `authenticationPlugin`<sup>Required</sup> <a name="authenticationPlugin" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.authenticationPlugin"></a>

```typescript
public readonly authenticationPlugin: string;
```

- *Type:* string

---

##### `connectionLimits`<sup>Required</sup> <a name="connectionLimits" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.connectionLimits"></a>

```typescript
public readonly connectionLimits: DataYandexMdbMysqlClusterUserConnectionLimitsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserConnectionLimitsList">DataYandexMdbMysqlClusterUserConnectionLimitsList</a>

---

##### `globalPermissions`<sup>Required</sup> <a name="globalPermissions" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.globalPermissions"></a>

```typescript
public readonly globalPermissions: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbMysqlClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList">DataYandexMdbMysqlClusterUserPermissionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterUser;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUser">DataYandexMdbMysqlClusterUser</a>

---


### DataYandexMdbMysqlClusterUserPermissionList <a name="DataYandexMdbMysqlClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbMysqlClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbMysqlClusterUserPermissionOutputReference <a name="DataYandexMdbMysqlClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbMysqlClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbMysqlClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermission">DataYandexMdbMysqlClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbMysqlClusterUserPermission;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbMysqlClusterUserPermission">DataYandexMdbMysqlClusterUserPermission</a>

---


### DataYandexMdbPostgresqlClusterConfigAccessList <a name="DataYandexMdbPostgresqlClusterConfigAccessList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigAccessList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigAccessList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigAccessOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigAccessOutputReference <a name="DataYandexMdbPostgresqlClusterConfigAccessOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigAccessOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.serverless">serverless</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.webSql">webSql</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccess">DataYandexMdbPostgresqlClusterConfigAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `serverless`<sup>Required</sup> <a name="serverless" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.serverless"></a>

```typescript
public readonly serverless: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccess">DataYandexMdbPostgresqlClusterConfigAccess</a>

---


### DataYandexMdbPostgresqlClusterConfigAList <a name="DataYandexMdbPostgresqlClusterConfigAList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigAList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigAList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigAOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigAOutputReference <a name="DataYandexMdbPostgresqlClusterConfigAOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList">DataYandexMdbPostgresqlClusterConfigAccessList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.autofailover">autofailover</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDays">backupRetainPeriodDays</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList">DataYandexMdbPostgresqlClusterConfigBackupWindowStartList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnostics">performanceDiagnostics</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList">DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.poolerConfig">poolerConfig</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList">DataYandexMdbPostgresqlClusterConfigPoolerConfigList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfig">postgresqlConfig</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList">DataYandexMdbPostgresqlClusterConfigResourcesList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigA">DataYandexMdbPostgresqlClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.access"></a>

```typescript
public readonly access: DataYandexMdbPostgresqlClusterConfigAccessList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAccessList">DataYandexMdbPostgresqlClusterConfigAccessList</a>

---

##### `autofailover`<sup>Required</sup> <a name="autofailover" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.autofailover"></a>

```typescript
public readonly autofailover: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `backupRetainPeriodDays`<sup>Required</sup> <a name="backupRetainPeriodDays" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDays"></a>

```typescript
public readonly backupRetainPeriodDays: number;
```

- *Type:* number

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: DataYandexMdbPostgresqlClusterConfigBackupWindowStartList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList">DataYandexMdbPostgresqlClusterConfigBackupWindowStartList</a>

---

##### `performanceDiagnostics`<sup>Required</sup> <a name="performanceDiagnostics" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnostics"></a>

```typescript
public readonly performanceDiagnostics: DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList">DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList</a>

---

##### `poolerConfig`<sup>Required</sup> <a name="poolerConfig" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.poolerConfig"></a>

```typescript
public readonly poolerConfig: DataYandexMdbPostgresqlClusterConfigPoolerConfigList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList">DataYandexMdbPostgresqlClusterConfigPoolerConfigList</a>

---

##### `postgresqlConfig`<sup>Required</sup> <a name="postgresqlConfig" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfig"></a>

```typescript
public readonly postgresqlConfig: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.resources"></a>

```typescript
public readonly resources: DataYandexMdbPostgresqlClusterConfigResourcesList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList">DataYandexMdbPostgresqlClusterConfigResourcesList</a>

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigA">DataYandexMdbPostgresqlClusterConfigA</a>

---


### DataYandexMdbPostgresqlClusterConfigBackupWindowStartList <a name="DataYandexMdbPostgresqlClusterConfigBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference <a name="DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStart">DataYandexMdbPostgresqlClusterConfigBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigBackupWindowStart">DataYandexMdbPostgresqlClusterConfigBackupWindowStart</a>

---


### DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList <a name="DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference <a name="DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabled">enabled</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingInterval">sessionsSamplingInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingInterval">statementsSamplingInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics">DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabled"></a>

```typescript
public readonly enabled: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `sessionsSamplingInterval`<sup>Required</sup> <a name="sessionsSamplingInterval" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingInterval"></a>

```typescript
public readonly sessionsSamplingInterval: number;
```

- *Type:* number

---

##### `statementsSamplingInterval`<sup>Required</sup> <a name="statementsSamplingInterval" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingInterval"></a>

```typescript
public readonly statementsSamplingInterval: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics">DataYandexMdbPostgresqlClusterConfigPerformanceDiagnostics</a>

---


### DataYandexMdbPostgresqlClusterConfigPoolerConfigList <a name="DataYandexMdbPostgresqlClusterConfigPoolerConfigList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPoolerConfigList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigPoolerConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference <a name="DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscard">poolDiscard</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingMode">poolingMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfig">DataYandexMdbPostgresqlClusterConfigPoolerConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `poolDiscard`<sup>Required</sup> <a name="poolDiscard" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscard"></a>

```typescript
public readonly poolDiscard: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `poolingMode`<sup>Required</sup> <a name="poolingMode" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingMode"></a>

```typescript
public readonly poolingMode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigPoolerConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigPoolerConfig">DataYandexMdbPostgresqlClusterConfigPoolerConfig</a>

---


### DataYandexMdbPostgresqlClusterConfigResourcesList <a name="DataYandexMdbPostgresqlClusterConfigResourcesList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterConfigResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterConfigResourcesOutputReference <a name="DataYandexMdbPostgresqlClusterConfigResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterConfigResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterConfigResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResources">DataYandexMdbPostgresqlClusterConfigResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterConfigResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterConfigResources">DataYandexMdbPostgresqlClusterConfigResources</a>

---


### DataYandexMdbPostgresqlClusterDatabaseExtensionList <a name="DataYandexMdbPostgresqlClusterDatabaseExtensionList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabaseExtensionList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterDatabaseExtensionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference <a name="DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtension">DataYandexMdbPostgresqlClusterDatabaseExtension</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterDatabaseExtension;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtension">DataYandexMdbPostgresqlClusterDatabaseExtension</a>

---


### DataYandexMdbPostgresqlClusterDatabaseList <a name="DataYandexMdbPostgresqlClusterDatabaseList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabaseList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterDatabaseOutputReference <a name="DataYandexMdbPostgresqlClusterDatabaseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.extension">extension</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList">DataYandexMdbPostgresqlClusterDatabaseExtensionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.lcCollate">lcCollate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.lcType">lcType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.owner">owner</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabase">DataYandexMdbPostgresqlClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `extension`<sup>Required</sup> <a name="extension" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.extension"></a>

```typescript
public readonly extension: DataYandexMdbPostgresqlClusterDatabaseExtensionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseExtensionList">DataYandexMdbPostgresqlClusterDatabaseExtensionList</a>

---

##### `lcCollate`<sup>Required</sup> <a name="lcCollate" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.lcCollate"></a>

```typescript
public readonly lcCollate: string;
```

- *Type:* string

---

##### `lcType`<sup>Required</sup> <a name="lcType" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.lcType"></a>

```typescript
public readonly lcType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `owner`<sup>Required</sup> <a name="owner" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterDatabase;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterDatabase">DataYandexMdbPostgresqlClusterDatabase</a>

---


### DataYandexMdbPostgresqlClusterHostList <a name="DataYandexMdbPostgresqlClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterHostOutputReference <a name="DataYandexMdbPostgresqlClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.replicationSource">replicationSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHost">DataYandexMdbPostgresqlClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `replicationSource`<sup>Required</sup> <a name="replicationSource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.replicationSource"></a>

```typescript
public readonly replicationSource: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterHost">DataYandexMdbPostgresqlClusterHost</a>

---


### DataYandexMdbPostgresqlClusterMaintenanceWindowList <a name="DataYandexMdbPostgresqlClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference <a name="DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindow">DataYandexMdbPostgresqlClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterMaintenanceWindow">DataYandexMdbPostgresqlClusterMaintenanceWindow</a>

---


### DataYandexMdbPostgresqlClusterUserList <a name="DataYandexMdbPostgresqlClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterUserOutputReference <a name="DataYandexMdbPostgresqlClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.connLimit">connLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.grants">grants</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.login">login</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList">DataYandexMdbPostgresqlClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.settings">settings</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUser">DataYandexMdbPostgresqlClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connLimit`<sup>Required</sup> <a name="connLimit" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.connLimit"></a>

```typescript
public readonly connLimit: number;
```

- *Type:* number

---

##### `grants`<sup>Required</sup> <a name="grants" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.grants"></a>

```typescript
public readonly grants: string[];
```

- *Type:* string[]

---

##### `login`<sup>Required</sup> <a name="login" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.login"></a>

```typescript
public readonly login: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbPostgresqlClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList">DataYandexMdbPostgresqlClusterUserPermissionList</a>

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.settings"></a>

```typescript
public readonly settings: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterUser;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUser">DataYandexMdbPostgresqlClusterUser</a>

---


### DataYandexMdbPostgresqlClusterUserPermissionList <a name="DataYandexMdbPostgresqlClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbPostgresqlClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbPostgresqlClusterUserPermissionOutputReference <a name="DataYandexMdbPostgresqlClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbPostgresqlClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbPostgresqlClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermission">DataYandexMdbPostgresqlClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbPostgresqlClusterUserPermission;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbPostgresqlClusterUserPermission">DataYandexMdbPostgresqlClusterUserPermission</a>

---


### DataYandexMdbRedisClusterConfigAList <a name="DataYandexMdbRedisClusterConfigAList" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterConfigAList } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterConfigAList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.get"></a>

```typescript
public get(index: number): DataYandexMdbRedisClusterConfigAOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbRedisClusterConfigAOutputReference <a name="DataYandexMdbRedisClusterConfigAOutputReference" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.databases">databases</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.maxmemoryPolicy">maxmemoryPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEvents">notifyKeyspaceEvents</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThan">slowlogLogSlowerThan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.slowlogMaxLen">slowlogMaxLen</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigA">DataYandexMdbRedisClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databases`<sup>Required</sup> <a name="databases" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.databases"></a>

```typescript
public readonly databases: number;
```

- *Type:* number

---

##### `maxmemoryPolicy`<sup>Required</sup> <a name="maxmemoryPolicy" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.maxmemoryPolicy"></a>

```typescript
public readonly maxmemoryPolicy: string;
```

- *Type:* string

---

##### `notifyKeyspaceEvents`<sup>Required</sup> <a name="notifyKeyspaceEvents" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEvents"></a>

```typescript
public readonly notifyKeyspaceEvents: string;
```

- *Type:* string

---

##### `slowlogLogSlowerThan`<sup>Required</sup> <a name="slowlogLogSlowerThan" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThan"></a>

```typescript
public readonly slowlogLogSlowerThan: number;
```

- *Type:* number

---

##### `slowlogMaxLen`<sup>Required</sup> <a name="slowlogMaxLen" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.slowlogMaxLen"></a>

```typescript
public readonly slowlogMaxLen: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbRedisClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterConfigA">DataYandexMdbRedisClusterConfigA</a>

---


### DataYandexMdbRedisClusterHostList <a name="DataYandexMdbRedisClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbRedisClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbRedisClusterHostOutputReference <a name="DataYandexMdbRedisClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHost">DataYandexMdbRedisClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbRedisClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterHost">DataYandexMdbRedisClusterHost</a>

---


### DataYandexMdbRedisClusterMaintenanceWindowList <a name="DataYandexMdbRedisClusterMaintenanceWindowList" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterMaintenanceWindowList } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.get"></a>

```typescript
public get(index: number): DataYandexMdbRedisClusterMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbRedisClusterMaintenanceWindowOutputReference <a name="DataYandexMdbRedisClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindow">DataYandexMdbRedisClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbRedisClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterMaintenanceWindow">DataYandexMdbRedisClusterMaintenanceWindow</a>

---


### DataYandexMdbRedisClusterResourcesList <a name="DataYandexMdbRedisClusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbRedisClusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbRedisClusterResourcesOutputReference <a name="DataYandexMdbRedisClusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbRedisClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbRedisClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResources">DataYandexMdbRedisClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbRedisClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbRedisClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbRedisClusterResources">DataYandexMdbRedisClusterResources</a>

---


### DataYandexMdbSqlserverClusterBackupWindowStartList <a name="DataYandexMdbSqlserverClusterBackupWindowStartList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterBackupWindowStartList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterBackupWindowStartList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterBackupWindowStartOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterBackupWindowStartOutputReference <a name="DataYandexMdbSqlserverClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStart">DataYandexMdbSqlserverClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterBackupWindowStart">DataYandexMdbSqlserverClusterBackupWindowStart</a>

---


### DataYandexMdbSqlserverClusterDatabaseList <a name="DataYandexMdbSqlserverClusterDatabaseList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterDatabaseList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterDatabaseOutputReference <a name="DataYandexMdbSqlserverClusterDatabaseOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabase">DataYandexMdbSqlserverClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterDatabase;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterDatabase">DataYandexMdbSqlserverClusterDatabase</a>

---


### DataYandexMdbSqlserverClusterHostList <a name="DataYandexMdbSqlserverClusterHostList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterHostList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterHostOutputReference <a name="DataYandexMdbSqlserverClusterHostOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterHostOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHost">DataYandexMdbSqlserverClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterHost">DataYandexMdbSqlserverClusterHost</a>

---


### DataYandexMdbSqlserverClusterResourcesList <a name="DataYandexMdbSqlserverClusterResourcesList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterResourcesList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterResourcesList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterResourcesOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterResourcesOutputReference <a name="DataYandexMdbSqlserverClusterResourcesOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResources">DataYandexMdbSqlserverClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterResources">DataYandexMdbSqlserverClusterResources</a>

---


### DataYandexMdbSqlserverClusterUserList <a name="DataYandexMdbSqlserverClusterUserList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUserList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterUserOutputReference <a name="DataYandexMdbSqlserverClusterUserOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUserOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList">DataYandexMdbSqlserverClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUser">DataYandexMdbSqlserverClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: DataYandexMdbSqlserverClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList">DataYandexMdbSqlserverClusterUserPermissionList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterUser;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUser">DataYandexMdbSqlserverClusterUser</a>

---


### DataYandexMdbSqlserverClusterUserPermissionList <a name="DataYandexMdbSqlserverClusterUserPermissionList" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUserPermissionList } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.get"></a>

```typescript
public get(index: number): DataYandexMdbSqlserverClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexMdbSqlserverClusterUserPermissionOutputReference <a name="DataYandexMdbSqlserverClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { DataYandexMdbSqlserverClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new DataYandexMdbSqlserverClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermission">DataYandexMdbSqlserverClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexMdbSqlserverClusterUserPermission;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexMdbSqlserverClusterUserPermission">DataYandexMdbSqlserverClusterUserPermission</a>

---


### DataYandexOrganizationmanagerSamlFederationSecuritySettingsList <a name="DataYandexOrganizationmanagerSamlFederationSecuritySettingsList" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationSecuritySettingsList } from '@cdktf/provider-yandex'

new DataYandexOrganizationmanagerSamlFederationSecuritySettingsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.get"></a>

```typescript
public get(index: number): DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference <a name="DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer"></a>

```typescript
import { DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference } from '@cdktf/provider-yandex'

new DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertions">encryptedAssertions</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettings">DataYandexOrganizationmanagerSamlFederationSecuritySettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `encryptedAssertions`<sup>Required</sup> <a name="encryptedAssertions" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertions"></a>

```typescript
public readonly encryptedAssertions: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexOrganizationmanagerSamlFederationSecuritySettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexOrganizationmanagerSamlFederationSecuritySettings">DataYandexOrganizationmanagerSamlFederationSecuritySettings</a>

---


### DataYandexServerlessContainerImageList <a name="DataYandexServerlessContainerImageList" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer"></a>

```typescript
import { DataYandexServerlessContainerImageList } from '@cdktf/provider-yandex'

new DataYandexServerlessContainerImageList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.get"></a>

```typescript
public get(index: number): DataYandexServerlessContainerImageOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexServerlessContainerImageOutputReference <a name="DataYandexServerlessContainerImageOutputReference" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer"></a>

```typescript
import { DataYandexServerlessContainerImageOutputReference } from '@cdktf/provider-yandex'

new DataYandexServerlessContainerImageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.args">args</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.command">command</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.digest">digest</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.environment">environment</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.workDir">workDir</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImage">DataYandexServerlessContainerImage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `args`<sup>Required</sup> <a name="args" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

---

##### `command`<sup>Required</sup> <a name="command" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

---

##### `digest`<sup>Required</sup> <a name="digest" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.digest"></a>

```typescript
public readonly digest: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.environment"></a>

```typescript
public readonly environment: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

##### `workDir`<sup>Required</sup> <a name="workDir" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.workDir"></a>

```typescript
public readonly workDir: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexServerlessContainerImageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexServerlessContainerImage;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexServerlessContainerImage">DataYandexServerlessContainerImage</a>

---


### DataYandexVpcAddressExternalIpv4AddressList <a name="DataYandexVpcAddressExternalIpv4AddressList" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer"></a>

```typescript
import { DataYandexVpcAddressExternalIpv4AddressList } from '@cdktf/provider-yandex'

new DataYandexVpcAddressExternalIpv4AddressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.get"></a>

```typescript
public get(index: number): DataYandexVpcAddressExternalIpv4AddressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexVpcAddressExternalIpv4AddressOutputReference <a name="DataYandexVpcAddressExternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { DataYandexVpcAddressExternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new DataYandexVpcAddressExternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProvider">ddosProtectionProvider</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapability">outgoingSmtpCapability</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4Address">DataYandexVpcAddressExternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ddosProtectionProvider`<sup>Required</sup> <a name="ddosProtectionProvider" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProvider"></a>

```typescript
public readonly ddosProtectionProvider: string;
```

- *Type:* string

---

##### `outgoingSmtpCapability`<sup>Required</sup> <a name="outgoingSmtpCapability" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapability"></a>

```typescript
public readonly outgoingSmtpCapability: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexVpcAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcAddressExternalIpv4Address">DataYandexVpcAddressExternalIpv4Address</a>

---


### DataYandexVpcRouteTableStaticRouteList <a name="DataYandexVpcRouteTableStaticRouteList" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer"></a>

```typescript
import { DataYandexVpcRouteTableStaticRouteList } from '@cdktf/provider-yandex'

new DataYandexVpcRouteTableStaticRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.get"></a>

```typescript
public get(index: number): DataYandexVpcRouteTableStaticRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexVpcRouteTableStaticRouteOutputReference <a name="DataYandexVpcRouteTableStaticRouteOutputReference" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer"></a>

```typescript
import { DataYandexVpcRouteTableStaticRouteOutputReference } from '@cdktf/provider-yandex'

new DataYandexVpcRouteTableStaticRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.destinationPrefix">destinationPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.nextHopAddress">nextHopAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRoute">DataYandexVpcRouteTableStaticRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `destinationPrefix`<sup>Required</sup> <a name="destinationPrefix" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.destinationPrefix"></a>

```typescript
public readonly destinationPrefix: string;
```

- *Type:* string

---

##### `nextHopAddress`<sup>Required</sup> <a name="nextHopAddress" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.nextHopAddress"></a>

```typescript
public readonly nextHopAddress: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexVpcRouteTableStaticRoute;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcRouteTableStaticRoute">DataYandexVpcRouteTableStaticRoute</a>

---


### DataYandexVpcSecurityGroupEgressList <a name="DataYandexVpcSecurityGroupEgressList" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupEgressList } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroupEgressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.get"></a>

```typescript
public get(index: number): DataYandexVpcSecurityGroupEgressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexVpcSecurityGroupEgressOutputReference <a name="DataYandexVpcSecurityGroupEgressOutputReference" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupEgressOutputReference } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroupEgressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgress">DataYandexVpcSecurityGroupEgress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexVpcSecurityGroupEgress;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupEgress">DataYandexVpcSecurityGroupEgress</a>

---


### DataYandexVpcSecurityGroupIngressList <a name="DataYandexVpcSecurityGroupIngressList" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupIngressList } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroupIngressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.get"></a>

```typescript
public get(index: number): DataYandexVpcSecurityGroupIngressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexVpcSecurityGroupIngressOutputReference <a name="DataYandexVpcSecurityGroupIngressOutputReference" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer"></a>

```typescript
import { DataYandexVpcSecurityGroupIngressOutputReference } from '@cdktf/provider-yandex'

new DataYandexVpcSecurityGroupIngressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.labels">labels</a></code> | <code>cdktf.StringMap</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngress">DataYandexVpcSecurityGroupIngress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.labels"></a>

```typescript
public readonly labels: StringMap;
```

- *Type:* cdktf.StringMap

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexVpcSecurityGroupIngress;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSecurityGroupIngress">DataYandexVpcSecurityGroupIngress</a>

---


### DataYandexVpcSubnetDhcpOptionsList <a name="DataYandexVpcSubnetDhcpOptionsList" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer"></a>

```typescript
import { DataYandexVpcSubnetDhcpOptionsList } from '@cdktf/provider-yandex'

new DataYandexVpcSubnetDhcpOptionsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.get"></a>

```typescript
public get(index: number): DataYandexVpcSubnetDhcpOptionsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexVpcSubnetDhcpOptionsOutputReference <a name="DataYandexVpcSubnetDhcpOptionsOutputReference" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer"></a>

```typescript
import { DataYandexVpcSubnetDhcpOptionsOutputReference } from '@cdktf/provider-yandex'

new DataYandexVpcSubnetDhcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.domainName">domainName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.domainNameServers">domainNameServers</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.ntpServers">ntpServers</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptions">DataYandexVpcSubnetDhcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domainName`<sup>Required</sup> <a name="domainName" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* string

---

##### `domainNameServers`<sup>Required</sup> <a name="domainNameServers" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.domainNameServers"></a>

```typescript
public readonly domainNameServers: string[];
```

- *Type:* string[]

---

##### `ntpServers`<sup>Required</sup> <a name="ntpServers" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.ntpServers"></a>

```typescript
public readonly ntpServers: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexVpcSubnetDhcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexVpcSubnetDhcpOptions">DataYandexVpcSubnetDhcpOptions</a>

---


### DataYandexYdbDatabaseDedicatedLocationList <a name="DataYandexYdbDatabaseDedicatedLocationList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedLocationOutputReference <a name="DataYandexYdbDatabaseDedicatedLocationOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.region">region</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList">DataYandexYdbDatabaseDedicatedLocationRegionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.zone">zone</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList">DataYandexYdbDatabaseDedicatedLocationZoneList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocation">DataYandexYdbDatabaseDedicatedLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `region`<sup>Required</sup> <a name="region" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.region"></a>

```typescript
public readonly region: DataYandexYdbDatabaseDedicatedLocationRegionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList">DataYandexYdbDatabaseDedicatedLocationRegionList</a>

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.zone"></a>

```typescript
public readonly zone: DataYandexYdbDatabaseDedicatedLocationZoneList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList">DataYandexYdbDatabaseDedicatedLocationZoneList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocation">DataYandexYdbDatabaseDedicatedLocation</a>

---


### DataYandexYdbDatabaseDedicatedLocationRegionList <a name="DataYandexYdbDatabaseDedicatedLocationRegionList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationRegionList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationRegionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedLocationRegionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedLocationRegionOutputReference <a name="DataYandexYdbDatabaseDedicatedLocationRegionOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationRegionOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationRegionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegion">DataYandexYdbDatabaseDedicatedLocationRegion</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedLocationRegion;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationRegion">DataYandexYdbDatabaseDedicatedLocationRegion</a>

---


### DataYandexYdbDatabaseDedicatedLocationZoneList <a name="DataYandexYdbDatabaseDedicatedLocationZoneList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationZoneList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationZoneList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedLocationZoneOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedLocationZoneOutputReference <a name="DataYandexYdbDatabaseDedicatedLocationZoneOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedLocationZoneOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedLocationZoneOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZone">DataYandexYdbDatabaseDedicatedLocationZone</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZoneOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedLocationZone;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedLocationZone">DataYandexYdbDatabaseDedicatedLocationZone</a>

---


### DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList <a name="DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference <a name="DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScale">DataYandexYdbDatabaseDedicatedScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScale">DataYandexYdbDatabaseDedicatedScalePolicyFixedScale</a>

---


### DataYandexYdbDatabaseDedicatedScalePolicyList <a name="DataYandexYdbDatabaseDedicatedScalePolicyList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicyList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedScalePolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedScalePolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedScalePolicyOutputReference <a name="DataYandexYdbDatabaseDedicatedScalePolicyOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedScalePolicyOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList">DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicy">DataYandexYdbDatabaseDedicatedScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList">DataYandexYdbDatabaseDedicatedScalePolicyFixedScaleList</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedScalePolicy">DataYandexYdbDatabaseDedicatedScalePolicy</a>

---


### DataYandexYdbDatabaseDedicatedStorageConfigList <a name="DataYandexYdbDatabaseDedicatedStorageConfigList" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedStorageConfigList } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedStorageConfigList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.get"></a>

```typescript
public get(index: number): DataYandexYdbDatabaseDedicatedStorageConfigOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### DataYandexYdbDatabaseDedicatedStorageConfigOutputReference <a name="DataYandexYdbDatabaseDedicatedStorageConfigOutputReference" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer"></a>

```typescript
import { DataYandexYdbDatabaseDedicatedStorageConfigOutputReference } from '@cdktf/provider-yandex'

new DataYandexYdbDatabaseDedicatedStorageConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.groupCount">groupCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeId">storageTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfig">DataYandexYdbDatabaseDedicatedStorageConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `groupCount`<sup>Required</sup> <a name="groupCount" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.groupCount"></a>

```typescript
public readonly groupCount: number;
```

- *Type:* number

---

##### `storageTypeId`<sup>Required</sup> <a name="storageTypeId" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeId"></a>

```typescript
public readonly storageTypeId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: DataYandexYdbDatabaseDedicatedStorageConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.DataYandexYdbDatabaseDedicatedStorageConfig">DataYandexYdbDatabaseDedicatedStorageConfig</a>

---


### DnsRecordsetTimeoutsOutputReference <a name="DnsRecordsetTimeoutsOutputReference" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.Initializer"></a>

```typescript
import { DnsRecordsetTimeoutsOutputReference } from '@cdktf/provider-yandex'

new DnsRecordsetTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DnsRecordsetTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsRecordsetTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DnsRecordsetTimeouts">DnsRecordsetTimeouts</a>

---


### DnsZoneTimeoutsOutputReference <a name="DnsZoneTimeoutsOutputReference" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.Initializer"></a>

```typescript
import { DnsZoneTimeoutsOutputReference } from '@cdktf/provider-yandex'

new DnsZoneTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.DnsZoneTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | DnsZoneTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.DnsZoneTimeouts">DnsZoneTimeouts</a>

---


### FunctionContentOutputReference <a name="FunctionContentOutputReference" id="@cdktf/provider-yandex.FunctionContentOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionContentOutputReference.Initializer"></a>

```typescript
import { FunctionContentOutputReference } from '@cdktf/provider-yandex'

new FunctionContentOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionContentOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionContentOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionContentOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionContentOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionContentOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionContentOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionContentOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.property.zipFilenameInput">zipFilenameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.property.zipFilename">zipFilename</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionContentOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionContentOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionContentOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `zipFilenameInput`<sup>Optional</sup> <a name="zipFilenameInput" id="@cdktf/provider-yandex.FunctionContentOutputReference.property.zipFilenameInput"></a>

```typescript
public readonly zipFilenameInput: string;
```

- *Type:* string

---

##### `zipFilename`<sup>Required</sup> <a name="zipFilename" id="@cdktf/provider-yandex.FunctionContentOutputReference.property.zipFilename"></a>

```typescript
public readonly zipFilename: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionContentOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionContent;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionContent">FunctionContent</a>

---


### FunctionPackageOutputReference <a name="FunctionPackageOutputReference" id="@cdktf/provider-yandex.FunctionPackageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionPackageOutputReference.Initializer"></a>

```typescript
import { FunctionPackageOutputReference } from '@cdktf/provider-yandex'

new FunctionPackageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionPackageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.resetSha256">resetSha256</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionPackageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionPackageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionPackageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionPackageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionPackageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionPackageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSha256` <a name="resetSha256" id="@cdktf/provider-yandex.FunctionPackageOutputReference.resetSha256"></a>

```typescript
public resetSha256(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.bucketNameInput">bucketNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.objectNameInput">objectNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.sha256Input">sha256Input</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.bucketName">bucketName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.objectName">objectName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.sha256">sha256</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionPackageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bucketNameInput`<sup>Optional</sup> <a name="bucketNameInput" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.bucketNameInput"></a>

```typescript
public readonly bucketNameInput: string;
```

- *Type:* string

---

##### `objectNameInput`<sup>Optional</sup> <a name="objectNameInput" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.objectNameInput"></a>

```typescript
public readonly objectNameInput: string;
```

- *Type:* string

---

##### `sha256Input`<sup>Optional</sup> <a name="sha256Input" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.sha256Input"></a>

```typescript
public readonly sha256Input: string;
```

- *Type:* string

---

##### `bucketName`<sup>Required</sup> <a name="bucketName" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.bucketName"></a>

```typescript
public readonly bucketName: string;
```

- *Type:* string

---

##### `objectName`<sup>Required</sup> <a name="objectName" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.objectName"></a>

```typescript
public readonly objectName: string;
```

- *Type:* string

---

##### `sha256`<sup>Required</sup> <a name="sha256" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.sha256"></a>

```typescript
public readonly sha256: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionPackageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionPackage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionPackage">FunctionPackage</a>

---


### FunctionScalingPolicyPolicyList <a name="FunctionScalingPolicyPolicyList" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer"></a>

```typescript
import { FunctionScalingPolicyPolicyList } from '@cdktf/provider-yandex'

new FunctionScalingPolicyPolicyList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.get"></a>

```typescript
public get(index: number): FunctionScalingPolicyPolicyOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FunctionScalingPolicyPolicy[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>[]

---


### FunctionScalingPolicyPolicyOutputReference <a name="FunctionScalingPolicyPolicyOutputReference" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer"></a>

```typescript
import { FunctionScalingPolicyPolicyOutputReference } from '@cdktf/provider-yandex'

new FunctionScalingPolicyPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resetZoneInstancesLimit">resetZoneInstancesLimit</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resetZoneRequestsLimit">resetZoneRequestsLimit</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetZoneInstancesLimit` <a name="resetZoneInstancesLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resetZoneInstancesLimit"></a>

```typescript
public resetZoneInstancesLimit(): void
```

##### `resetZoneRequestsLimit` <a name="resetZoneRequestsLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.resetZoneRequestsLimit"></a>

```typescript
public resetZoneRequestsLimit(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.tagInput">tagInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimitInput">zoneInstancesLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimitInput">zoneRequestsLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.tag">tag</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimit">zoneInstancesLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimit">zoneRequestsLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `tagInput`<sup>Optional</sup> <a name="tagInput" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.tagInput"></a>

```typescript
public readonly tagInput: string;
```

- *Type:* string

---

##### `zoneInstancesLimitInput`<sup>Optional</sup> <a name="zoneInstancesLimitInput" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimitInput"></a>

```typescript
public readonly zoneInstancesLimitInput: number;
```

- *Type:* number

---

##### `zoneRequestsLimitInput`<sup>Optional</sup> <a name="zoneRequestsLimitInput" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimitInput"></a>

```typescript
public readonly zoneRequestsLimitInput: number;
```

- *Type:* number

---

##### `tag`<sup>Required</sup> <a name="tag" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

---

##### `zoneInstancesLimit`<sup>Required</sup> <a name="zoneInstancesLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneInstancesLimit"></a>

```typescript
public readonly zoneInstancesLimit: number;
```

- *Type:* number

---

##### `zoneRequestsLimit`<sup>Required</sup> <a name="zoneRequestsLimit" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.zoneRequestsLimit"></a>

```typescript
public readonly zoneRequestsLimit: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionScalingPolicyPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FunctionScalingPolicyPolicy;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionScalingPolicyPolicy">FunctionScalingPolicyPolicy</a>

---


### FunctionTimeoutsOutputReference <a name="FunctionTimeoutsOutputReference" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.Initializer"></a>

```typescript
import { FunctionTimeoutsOutputReference } from '@cdktf/provider-yandex'

new FunctionTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FunctionTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionTimeouts">FunctionTimeouts</a>

---


### FunctionTriggerDlqOutputReference <a name="FunctionTriggerDlqOutputReference" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerDlqOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerDlqOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.queueIdInput">queueIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.queueId">queueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `queueIdInput`<sup>Optional</sup> <a name="queueIdInput" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.queueIdInput"></a>

```typescript
public readonly queueIdInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerDlqOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerDlq;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerDlq">FunctionTriggerDlq</a>

---


### FunctionTriggerFunctionOutputReference <a name="FunctionTriggerFunctionOutputReference" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerFunctionOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerFunctionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetRetryAttempts">resetRetryAttempts</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetRetryInterval">resetRetryInterval</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetServiceAccountId">resetServiceAccountId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetTag">resetTag</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRetryAttempts` <a name="resetRetryAttempts" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetRetryAttempts"></a>

```typescript
public resetRetryAttempts(): void
```

##### `resetRetryInterval` <a name="resetRetryInterval" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetRetryInterval"></a>

```typescript
public resetRetryInterval(): void
```

##### `resetServiceAccountId` <a name="resetServiceAccountId" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetServiceAccountId"></a>

```typescript
public resetServiceAccountId(): void
```

##### `resetTag` <a name="resetTag" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.resetTag"></a>

```typescript
public resetTag(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryAttemptsInput">retryAttemptsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryIntervalInput">retryIntervalInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.tagInput">tagInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryAttempts">retryAttempts</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryInterval">retryInterval</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.tag">tag</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `retryAttemptsInput`<sup>Optional</sup> <a name="retryAttemptsInput" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryAttemptsInput"></a>

```typescript
public readonly retryAttemptsInput: string;
```

- *Type:* string

---

##### `retryIntervalInput`<sup>Optional</sup> <a name="retryIntervalInput" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryIntervalInput"></a>

```typescript
public readonly retryIntervalInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `tagInput`<sup>Optional</sup> <a name="tagInput" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.tagInput"></a>

```typescript
public readonly tagInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `retryAttempts`<sup>Required</sup> <a name="retryAttempts" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryAttempts"></a>

```typescript
public readonly retryAttempts: string;
```

- *Type:* string

---

##### `retryInterval`<sup>Required</sup> <a name="retryInterval" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.retryInterval"></a>

```typescript
public readonly retryInterval: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `tag`<sup>Required</sup> <a name="tag" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.tag"></a>

```typescript
public readonly tag: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerFunctionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerFunction;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerFunction">FunctionTriggerFunction</a>

---


### FunctionTriggerIotOutputReference <a name="FunctionTriggerIotOutputReference" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerIotOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerIotOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resetDeviceId">resetDeviceId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resetTopic">resetTopic</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDeviceId` <a name="resetDeviceId" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resetDeviceId"></a>

```typescript
public resetDeviceId(): void
```

##### `resetTopic` <a name="resetTopic" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.resetTopic"></a>

```typescript
public resetTopic(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.deviceIdInput">deviceIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.registryIdInput">registryIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.topicInput">topicInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.deviceId">deviceId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.registryId">registryId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.topic">topic</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `deviceIdInput`<sup>Optional</sup> <a name="deviceIdInput" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.deviceIdInput"></a>

```typescript
public readonly deviceIdInput: string;
```

- *Type:* string

---

##### `registryIdInput`<sup>Optional</sup> <a name="registryIdInput" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.registryIdInput"></a>

```typescript
public readonly registryIdInput: string;
```

- *Type:* string

---

##### `topicInput`<sup>Optional</sup> <a name="topicInput" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.topicInput"></a>

```typescript
public readonly topicInput: string;
```

- *Type:* string

---

##### `deviceId`<sup>Required</sup> <a name="deviceId" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.deviceId"></a>

```typescript
public readonly deviceId: string;
```

- *Type:* string

---

##### `registryId`<sup>Required</sup> <a name="registryId" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.registryId"></a>

```typescript
public readonly registryId: string;
```

- *Type:* string

---

##### `topic`<sup>Required</sup> <a name="topic" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.topic"></a>

```typescript
public readonly topic: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerIotOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerIot;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerIot">FunctionTriggerIot</a>

---


### FunctionTriggerLoggingOutputReference <a name="FunctionTriggerLoggingOutputReference" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerLoggingOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.resetBatchSize">resetBatchSize</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBatchSize` <a name="resetBatchSize" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.resetBatchSize"></a>

```typescript
public resetBatchSize(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchCutoffInput">batchCutoffInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchSizeInput">batchSizeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.groupIdInput">groupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.levelsInput">levelsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceIdsInput">resourceIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceTypesInput">resourceTypesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.groupId">groupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.levels">levels</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceIds">resourceIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceTypes">resourceTypes</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoffInput`<sup>Optional</sup> <a name="batchCutoffInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchCutoffInput"></a>

```typescript
public readonly batchCutoffInput: string;
```

- *Type:* string

---

##### `batchSizeInput`<sup>Optional</sup> <a name="batchSizeInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchSizeInput"></a>

```typescript
public readonly batchSizeInput: string;
```

- *Type:* string

---

##### `groupIdInput`<sup>Optional</sup> <a name="groupIdInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.groupIdInput"></a>

```typescript
public readonly groupIdInput: string;
```

- *Type:* string

---

##### `levelsInput`<sup>Optional</sup> <a name="levelsInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.levelsInput"></a>

```typescript
public readonly levelsInput: string[];
```

- *Type:* string[]

---

##### `resourceIdsInput`<sup>Optional</sup> <a name="resourceIdsInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceIdsInput"></a>

```typescript
public readonly resourceIdsInput: string[];
```

- *Type:* string[]

---

##### `resourceTypesInput`<sup>Optional</sup> <a name="resourceTypesInput" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceTypesInput"></a>

```typescript
public readonly resourceTypesInput: string[];
```

- *Type:* string[]

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string

---

##### `levels`<sup>Required</sup> <a name="levels" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.levels"></a>

```typescript
public readonly levels: string[];
```

- *Type:* string[]

---

##### `resourceIds`<sup>Required</sup> <a name="resourceIds" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceIds"></a>

```typescript
public readonly resourceIds: string[];
```

- *Type:* string[]

---

##### `resourceTypes`<sup>Required</sup> <a name="resourceTypes" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.resourceTypes"></a>

```typescript
public readonly resourceTypes: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerLogging;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogging">FunctionTriggerLogging</a>

---


### FunctionTriggerLogGroupOutputReference <a name="FunctionTriggerLogGroupOutputReference" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerLogGroupOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerLogGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.resetBatchSize">resetBatchSize</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBatchSize` <a name="resetBatchSize" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.resetBatchSize"></a>

```typescript
public resetBatchSize(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchCutoffInput">batchCutoffInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchSizeInput">batchSizeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.logGroupIdsInput">logGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.logGroupIds">logGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoffInput`<sup>Optional</sup> <a name="batchCutoffInput" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchCutoffInput"></a>

```typescript
public readonly batchCutoffInput: string;
```

- *Type:* string

---

##### `batchSizeInput`<sup>Optional</sup> <a name="batchSizeInput" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchSizeInput"></a>

```typescript
public readonly batchSizeInput: string;
```

- *Type:* string

---

##### `logGroupIdsInput`<sup>Optional</sup> <a name="logGroupIdsInput" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.logGroupIdsInput"></a>

```typescript
public readonly logGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `logGroupIds`<sup>Required</sup> <a name="logGroupIds" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.logGroupIds"></a>

```typescript
public readonly logGroupIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerLogGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerLogGroup;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerLogGroup">FunctionTriggerLogGroup</a>

---


### FunctionTriggerMessageQueueOutputReference <a name="FunctionTriggerMessageQueueOutputReference" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerMessageQueueOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerMessageQueueOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resetBatchSize">resetBatchSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resetVisibilityTimeout">resetVisibilityTimeout</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetBatchSize` <a name="resetBatchSize" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resetBatchSize"></a>

```typescript
public resetBatchSize(): void
```

##### `resetVisibilityTimeout` <a name="resetVisibilityTimeout" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.resetVisibilityTimeout"></a>

```typescript
public resetVisibilityTimeout(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchCutoffInput">batchCutoffInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchSizeInput">batchSizeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.queueIdInput">queueIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.serviceAccountIdInput">serviceAccountIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.visibilityTimeoutInput">visibilityTimeoutInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchCutoff">batchCutoff</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchSize">batchSize</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.queueId">queueId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.serviceAccountId">serviceAccountId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.visibilityTimeout">visibilityTimeout</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `batchCutoffInput`<sup>Optional</sup> <a name="batchCutoffInput" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchCutoffInput"></a>

```typescript
public readonly batchCutoffInput: string;
```

- *Type:* string

---

##### `batchSizeInput`<sup>Optional</sup> <a name="batchSizeInput" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchSizeInput"></a>

```typescript
public readonly batchSizeInput: string;
```

- *Type:* string

---

##### `queueIdInput`<sup>Optional</sup> <a name="queueIdInput" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.queueIdInput"></a>

```typescript
public readonly queueIdInput: string;
```

- *Type:* string

---

##### `serviceAccountIdInput`<sup>Optional</sup> <a name="serviceAccountIdInput" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.serviceAccountIdInput"></a>

```typescript
public readonly serviceAccountIdInput: string;
```

- *Type:* string

---

##### `visibilityTimeoutInput`<sup>Optional</sup> <a name="visibilityTimeoutInput" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.visibilityTimeoutInput"></a>

```typescript
public readonly visibilityTimeoutInput: string;
```

- *Type:* string

---

##### `batchCutoff`<sup>Required</sup> <a name="batchCutoff" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchCutoff"></a>

```typescript
public readonly batchCutoff: string;
```

- *Type:* string

---

##### `batchSize`<sup>Required</sup> <a name="batchSize" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.batchSize"></a>

```typescript
public readonly batchSize: string;
```

- *Type:* string

---

##### `queueId`<sup>Required</sup> <a name="queueId" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.queueId"></a>

```typescript
public readonly queueId: string;
```

- *Type:* string

---

##### `serviceAccountId`<sup>Required</sup> <a name="serviceAccountId" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.serviceAccountId"></a>

```typescript
public readonly serviceAccountId: string;
```

- *Type:* string

---

##### `visibilityTimeout`<sup>Required</sup> <a name="visibilityTimeout" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.visibilityTimeout"></a>

```typescript
public readonly visibilityTimeout: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerMessageQueueOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerMessageQueue;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerMessageQueue">FunctionTriggerMessageQueue</a>

---


### FunctionTriggerObjectStorageOutputReference <a name="FunctionTriggerObjectStorageOutputReference" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerObjectStorageOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerObjectStorageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetPrefix">resetPrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetSuffix">resetSuffix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetPrefix` <a name="resetPrefix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetPrefix"></a>

```typescript
public resetPrefix(): void
```

##### `resetSuffix` <a name="resetSuffix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetSuffix"></a>

```typescript
public resetSuffix(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.bucketIdInput">bucketIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.createInput">createInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.deleteInput">deleteInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.prefixInput">prefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.suffixInput">suffixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.updateInput">updateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.bucketId">bucketId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.create">create</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.delete">delete</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.suffix">suffix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.update">update</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bucketIdInput`<sup>Optional</sup> <a name="bucketIdInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.bucketIdInput"></a>

```typescript
public readonly bucketIdInput: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.createInput"></a>

```typescript
public readonly createInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `prefixInput`<sup>Optional</sup> <a name="prefixInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* string

---

##### `suffixInput`<sup>Optional</sup> <a name="suffixInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.suffixInput"></a>

```typescript
public readonly suffixInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `bucketId`<sup>Required</sup> <a name="bucketId" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.bucketId"></a>

```typescript
public readonly bucketId: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.create"></a>

```typescript
public readonly create: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.delete"></a>

```typescript
public readonly delete: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `suffix`<sup>Required</sup> <a name="suffix" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.suffix"></a>

```typescript
public readonly suffix: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.update"></a>

```typescript
public readonly update: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerObjectStorageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerObjectStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerObjectStorage">FunctionTriggerObjectStorage</a>

---


### FunctionTriggerTimeoutsOutputReference <a name="FunctionTriggerTimeoutsOutputReference" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerTimeoutsOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | FunctionTriggerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.FunctionTriggerTimeouts">FunctionTriggerTimeouts</a>

---


### FunctionTriggerTimerOutputReference <a name="FunctionTriggerTimerOutputReference" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.Initializer"></a>

```typescript
import { FunctionTriggerTimerOutputReference } from '@cdktf/provider-yandex'

new FunctionTriggerTimerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.cronExpressionInput">cronExpressionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.cronExpression">cronExpression</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cronExpressionInput`<sup>Optional</sup> <a name="cronExpressionInput" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.cronExpressionInput"></a>

```typescript
public readonly cronExpressionInput: string;
```

- *Type:* string

---

##### `cronExpression`<sup>Required</sup> <a name="cronExpression" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.cronExpression"></a>

```typescript
public readonly cronExpression: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.FunctionTriggerTimerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: FunctionTriggerTimer;
```

- *Type:* <a href="#@cdktf/provider-yandex.FunctionTriggerTimer">FunctionTriggerTimer</a>

---


### IamServiceAccountTimeoutsOutputReference <a name="IamServiceAccountTimeoutsOutputReference" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.Initializer"></a>

```typescript
import { IamServiceAccountTimeoutsOutputReference } from '@cdktf/provider-yandex'

new IamServiceAccountTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.IamServiceAccountTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IamServiceAccountTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IamServiceAccountTimeouts">IamServiceAccountTimeouts</a>

---


### IotCoreDeviceTimeoutsOutputReference <a name="IotCoreDeviceTimeoutsOutputReference" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.Initializer"></a>

```typescript
import { IotCoreDeviceTimeoutsOutputReference } from '@cdktf/provider-yandex'

new IotCoreDeviceTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.IotCoreDeviceTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IotCoreDeviceTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IotCoreDeviceTimeouts">IotCoreDeviceTimeouts</a>

---


### IotCoreRegistryTimeoutsOutputReference <a name="IotCoreRegistryTimeoutsOutputReference" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.Initializer"></a>

```typescript
import { IotCoreRegistryTimeoutsOutputReference } from '@cdktf/provider-yandex'

new IotCoreRegistryTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.IotCoreRegistryTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | IotCoreRegistryTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.IotCoreRegistryTimeouts">IotCoreRegistryTimeouts</a>

---


### KmsSecretCiphertextTimeoutsOutputReference <a name="KmsSecretCiphertextTimeoutsOutputReference" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.Initializer"></a>

```typescript
import { KmsSecretCiphertextTimeoutsOutputReference } from '@cdktf/provider-yandex'

new KmsSecretCiphertextTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KmsSecretCiphertextTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KmsSecretCiphertextTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KmsSecretCiphertextTimeouts">KmsSecretCiphertextTimeouts</a>

---


### KmsSymmetricKeyTimeoutsOutputReference <a name="KmsSymmetricKeyTimeoutsOutputReference" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.Initializer"></a>

```typescript
import { KmsSymmetricKeyTimeoutsOutputReference } from '@cdktf/provider-yandex'

new KmsSymmetricKeyTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KmsSymmetricKeyTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KmsSymmetricKeyTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KmsSymmetricKeyTimeouts">KmsSymmetricKeyTimeouts</a>

---


### KubernetesClusterKmsProviderOutputReference <a name="KubernetesClusterKmsProviderOutputReference" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterKmsProviderOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterKmsProviderOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.resetKeyId">resetKeyId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetKeyId` <a name="resetKeyId" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.resetKeyId"></a>

```typescript
public resetKeyId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.keyIdInput">keyIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.keyId">keyId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `keyIdInput`<sup>Optional</sup> <a name="keyIdInput" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.keyIdInput"></a>

```typescript
public readonly keyIdInput: string;
```

- *Type:* string

---

##### `keyId`<sup>Required</sup> <a name="keyId" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.keyId"></a>

```typescript
public readonly keyId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterKmsProviderOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterKmsProvider;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterKmsProvider">KubernetesClusterKmsProvider</a>

---


### KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList <a name="KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer"></a>

```typescript
import { KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList } from '@cdktf/provider-yandex'

new KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get"></a>

```typescript
public get(index: number): KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]

---


### KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference <a name="KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.durationInput">durationInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTimeInput">startTimeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.duration">duration</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTime">startTime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `durationInput`<sup>Optional</sup> <a name="durationInput" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.durationInput"></a>

```typescript
public readonly durationInput: string;
```

- *Type:* string

---

##### `startTimeInput`<sup>Optional</sup> <a name="startTimeInput" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>

---


### KubernetesClusterMasterMaintenancePolicyOutputReference <a name="KubernetesClusterMasterMaintenancePolicyOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterMaintenancePolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterMaintenancePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.putMaintenanceWindow.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]

---

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList">KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgradeInput">autoUpgradeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgrade">autoUpgrade</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList">KubernetesClusterMasterMaintenancePolicyMaintenanceWindowList</a>

---

##### `autoUpgradeInput`<sup>Optional</sup> <a name="autoUpgradeInput" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgradeInput"></a>

```typescript
public readonly autoUpgradeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: IResolvable | KubernetesClusterMasterMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyMaintenanceWindow">KubernetesClusterMasterMaintenancePolicyMaintenanceWindow</a>[]

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterMasterMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a>

---


### KubernetesClusterMasterOutputReference <a name="KubernetesClusterMasterOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putMaintenancePolicy">putMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putRegional">putRegional</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putZonal">putZonal</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetMaintenancePolicy">resetMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetPublicIp">resetPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetRegional">resetRegional</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetVersion">resetVersion</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetZonal">resetZonal</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putMaintenancePolicy` <a name="putMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putMaintenancePolicy"></a>

```typescript
public putMaintenancePolicy(value: KubernetesClusterMasterMaintenancePolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putMaintenancePolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a>

---

##### `putRegional` <a name="putRegional" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putRegional"></a>

```typescript
public putRegional(value: KubernetesClusterMasterRegional): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putRegional.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a>

---

##### `putZonal` <a name="putZonal" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putZonal"></a>

```typescript
public putZonal(value: KubernetesClusterMasterZonal): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.putZonal.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a>

---

##### `resetMaintenancePolicy` <a name="resetMaintenancePolicy" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetMaintenancePolicy"></a>

```typescript
public resetMaintenancePolicy(): void
```

##### `resetPublicIp` <a name="resetPublicIp" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetPublicIp"></a>

```typescript
public resetPublicIp(): void
```

##### `resetRegional` <a name="resetRegional" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetRegional"></a>

```typescript
public resetRegional(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```

##### `resetVersion` <a name="resetVersion" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetVersion"></a>

```typescript
public resetVersion(): void
```

##### `resetZonal` <a name="resetZonal" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.resetZonal"></a>

```typescript
public resetZonal(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.clusterCaCertificate">clusterCaCertificate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.externalV4Address">externalV4Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.externalV4Endpoint">externalV4Endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalV4Address">internalV4Address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalV4Endpoint">internalV4Endpoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.maintenancePolicy">maintenancePolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference">KubernetesClusterMasterMaintenancePolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.regional">regional</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference">KubernetesClusterMasterRegionalOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.versionInfo">versionInfo</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList">KubernetesClusterMasterVersionInfoList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.zonal">zonal</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference">KubernetesClusterMasterZonalOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.maintenancePolicyInput">maintenancePolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.publicIpInput">publicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.regionalInput">regionalInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.zonalInput">zonalInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.publicIp">publicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `clusterCaCertificate`<sup>Required</sup> <a name="clusterCaCertificate" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.clusterCaCertificate"></a>

```typescript
public readonly clusterCaCertificate: string;
```

- *Type:* string

---

##### `externalV4Address`<sup>Required</sup> <a name="externalV4Address" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.externalV4Address"></a>

```typescript
public readonly externalV4Address: string;
```

- *Type:* string

---

##### `externalV4Endpoint`<sup>Required</sup> <a name="externalV4Endpoint" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.externalV4Endpoint"></a>

```typescript
public readonly externalV4Endpoint: string;
```

- *Type:* string

---

##### `internalV4Address`<sup>Required</sup> <a name="internalV4Address" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalV4Address"></a>

```typescript
public readonly internalV4Address: string;
```

- *Type:* string

---

##### `internalV4Endpoint`<sup>Required</sup> <a name="internalV4Endpoint" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalV4Endpoint"></a>

```typescript
public readonly internalV4Endpoint: string;
```

- *Type:* string

---

##### `maintenancePolicy`<sup>Required</sup> <a name="maintenancePolicy" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.maintenancePolicy"></a>

```typescript
public readonly maintenancePolicy: KubernetesClusterMasterMaintenancePolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicyOutputReference">KubernetesClusterMasterMaintenancePolicyOutputReference</a>

---

##### `regional`<sup>Required</sup> <a name="regional" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.regional"></a>

```typescript
public readonly regional: KubernetesClusterMasterRegionalOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference">KubernetesClusterMasterRegionalOutputReference</a>

---

##### `versionInfo`<sup>Required</sup> <a name="versionInfo" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.versionInfo"></a>

```typescript
public readonly versionInfo: KubernetesClusterMasterVersionInfoList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList">KubernetesClusterMasterVersionInfoList</a>

---

##### `zonal`<sup>Required</sup> <a name="zonal" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.zonal"></a>

```typescript
public readonly zonal: KubernetesClusterMasterZonalOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference">KubernetesClusterMasterZonalOutputReference</a>

---

##### `maintenancePolicyInput`<sup>Optional</sup> <a name="maintenancePolicyInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.maintenancePolicyInput"></a>

```typescript
public readonly maintenancePolicyInput: KubernetesClusterMasterMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterMaintenancePolicy">KubernetesClusterMasterMaintenancePolicy</a>

---

##### `publicIpInput`<sup>Optional</sup> <a name="publicIpInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.publicIpInput"></a>

```typescript
public readonly publicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `regionalInput`<sup>Optional</sup> <a name="regionalInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.regionalInput"></a>

```typescript
public readonly regionalInput: KubernetesClusterMasterRegional;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a>

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `zonalInput`<sup>Optional</sup> <a name="zonalInput" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.zonalInput"></a>

```typescript
public readonly zonalInput: KubernetesClusterMasterZonal;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a>

---

##### `publicIp`<sup>Required</sup> <a name="publicIp" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.publicIp"></a>

```typescript
public readonly publicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterMaster;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMaster">KubernetesClusterMaster</a>

---


### KubernetesClusterMasterRegionalLocationList <a name="KubernetesClusterMasterRegionalLocationList" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer"></a>

```typescript
import { KubernetesClusterMasterRegionalLocationList } from '@cdktf/provider-yandex'

new KubernetesClusterMasterRegionalLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.get"></a>

```typescript
public get(index: number): KubernetesClusterMasterRegionalLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesClusterMasterRegionalLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]

---


### KubernetesClusterMasterRegionalLocationOutputReference <a name="KubernetesClusterMasterRegionalLocationOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterRegionalLocationOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterRegionalLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resetZone">resetZone</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.resetZone"></a>

```typescript
public resetZone(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesClusterMasterRegionalLocation;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>

---


### KubernetesClusterMasterRegionalOutputReference <a name="KubernetesClusterMasterRegionalOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterRegionalOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterRegionalOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.putLocation">putLocation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.resetLocation">resetLocation</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putLocation` <a name="putLocation" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.putLocation"></a>

```typescript
public putLocation(value: IResolvable | KubernetesClusterMasterRegionalLocation[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.putLocation.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]

---

##### `resetLocation` <a name="resetLocation" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.resetLocation"></a>

```typescript
public resetLocation(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList">KubernetesClusterMasterRegionalLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.locationInput">locationInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.regionInput">regionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.region">region</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.location"></a>

```typescript
public readonly location: KubernetesClusterMasterRegionalLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocationList">KubernetesClusterMasterRegionalLocationList</a>

---

##### `locationInput`<sup>Optional</sup> <a name="locationInput" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.locationInput"></a>

```typescript
public readonly locationInput: IResolvable | KubernetesClusterMasterRegionalLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegionalLocation">KubernetesClusterMasterRegionalLocation</a>[]

---

##### `regionInput`<sup>Optional</sup> <a name="regionInput" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.regionInput"></a>

```typescript
public readonly regionInput: string;
```

- *Type:* string

---

##### `region`<sup>Required</sup> <a name="region" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.region"></a>

```typescript
public readonly region: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterRegionalOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterMasterRegional;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterRegional">KubernetesClusterMasterRegional</a>

---


### KubernetesClusterMasterVersionInfoList <a name="KubernetesClusterMasterVersionInfoList" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer"></a>

```typescript
import { KubernetesClusterMasterVersionInfoList } from '@cdktf/provider-yandex'

new KubernetesClusterMasterVersionInfoList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.get"></a>

```typescript
public get(index: number): KubernetesClusterMasterVersionInfoOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### KubernetesClusterMasterVersionInfoOutputReference <a name="KubernetesClusterMasterVersionInfoOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterVersionInfoOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterVersionInfoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.currentVersion">currentVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.newRevisionAvailable">newRevisionAvailable</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.newRevisionSummary">newRevisionSummary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.versionDeprecated">versionDeprecated</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfo">KubernetesClusterMasterVersionInfo</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `currentVersion`<sup>Required</sup> <a name="currentVersion" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.currentVersion"></a>

```typescript
public readonly currentVersion: string;
```

- *Type:* string

---

##### `newRevisionAvailable`<sup>Required</sup> <a name="newRevisionAvailable" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.newRevisionAvailable"></a>

```typescript
public readonly newRevisionAvailable: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `newRevisionSummary`<sup>Required</sup> <a name="newRevisionSummary" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.newRevisionSummary"></a>

```typescript
public readonly newRevisionSummary: string;
```

- *Type:* string

---

##### `versionDeprecated`<sup>Required</sup> <a name="versionDeprecated" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.versionDeprecated"></a>

```typescript
public readonly versionDeprecated: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterVersionInfoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterMasterVersionInfo;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterVersionInfo">KubernetesClusterMasterVersionInfo</a>

---


### KubernetesClusterMasterZonalOutputReference <a name="KubernetesClusterMasterZonalOutputReference" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterMasterZonalOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterMasterZonalOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resetZone">resetZone</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.resetZone"></a>

```typescript
public resetZone(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterMasterZonalOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterMasterZonal;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterMasterZonal">KubernetesClusterMasterZonal</a>

---


### KubernetesClusterNetworkImplementationCiliumOutputReference <a name="KubernetesClusterNetworkImplementationCiliumOutputReference" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterNetworkImplementationCiliumOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterNetworkImplementationCiliumOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterNetworkImplementationCilium;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a>

---


### KubernetesClusterNetworkImplementationOutputReference <a name="KubernetesClusterNetworkImplementationOutputReference" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterNetworkImplementationOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterNetworkImplementationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.putCilium">putCilium</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.resetCilium">resetCilium</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putCilium` <a name="putCilium" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.putCilium"></a>

```typescript
public putCilium(value: KubernetesClusterNetworkImplementationCilium): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.putCilium.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a>

---

##### `resetCilium` <a name="resetCilium" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.resetCilium"></a>

```typescript
public resetCilium(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.cilium">cilium</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference">KubernetesClusterNetworkImplementationCiliumOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.ciliumInput">ciliumInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cilium`<sup>Required</sup> <a name="cilium" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.cilium"></a>

```typescript
public readonly cilium: KubernetesClusterNetworkImplementationCiliumOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCiliumOutputReference">KubernetesClusterNetworkImplementationCiliumOutputReference</a>

---

##### `ciliumInput`<sup>Optional</sup> <a name="ciliumInput" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.ciliumInput"></a>

```typescript
public readonly ciliumInput: KubernetesClusterNetworkImplementationCilium;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementationCilium">KubernetesClusterNetworkImplementationCilium</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterNetworkImplementationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesClusterNetworkImplementation;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesClusterNetworkImplementation">KubernetesClusterNetworkImplementation</a>

---


### KubernetesClusterTimeoutsOutputReference <a name="KubernetesClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { KubernetesClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new KubernetesClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesClusterTimeouts">KubernetesClusterTimeouts</a>

---


### KubernetesNodeGroupAllocationPolicyLocationList <a name="KubernetesNodeGroupAllocationPolicyLocationList" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer"></a>

```typescript
import { KubernetesNodeGroupAllocationPolicyLocationList } from '@cdktf/provider-yandex'

new KubernetesNodeGroupAllocationPolicyLocationList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.get"></a>

```typescript
public get(index: number): KubernetesNodeGroupAllocationPolicyLocationOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]

---


### KubernetesNodeGroupAllocationPolicyLocationOutputReference <a name="KubernetesNodeGroupAllocationPolicyLocationOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupAllocationPolicyLocationOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupAllocationPolicyLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resetZone">resetZone</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```

##### `resetZone` <a name="resetZone" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.resetZone"></a>

```typescript
public resetZone(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupAllocationPolicyLocation;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>

---


### KubernetesNodeGroupAllocationPolicyOutputReference <a name="KubernetesNodeGroupAllocationPolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupAllocationPolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupAllocationPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.putLocation">putLocation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.resetLocation">resetLocation</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putLocation` <a name="putLocation" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.putLocation"></a>

```typescript
public putLocation(value: IResolvable | KubernetesNodeGroupAllocationPolicyLocation[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.putLocation.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]

---

##### `resetLocation` <a name="resetLocation" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.resetLocation"></a>

```typescript
public resetLocation(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.location">location</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList">KubernetesNodeGroupAllocationPolicyLocationList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.locationInput">locationInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `location`<sup>Required</sup> <a name="location" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.location"></a>

```typescript
public readonly location: KubernetesNodeGroupAllocationPolicyLocationList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocationList">KubernetesNodeGroupAllocationPolicyLocationList</a>

---

##### `locationInput`<sup>Optional</sup> <a name="locationInput" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.locationInput"></a>

```typescript
public readonly locationInput: IResolvable | KubernetesNodeGroupAllocationPolicyLocation[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyLocation">KubernetesNodeGroupAllocationPolicyLocation</a>[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupAllocationPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupAllocationPolicy">KubernetesNodeGroupAllocationPolicy</a>

---


### KubernetesNodeGroupDeployPolicyOutputReference <a name="KubernetesNodeGroupDeployPolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupDeployPolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupDeployPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansionInput">maxExpansionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailableInput">maxUnavailableInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansion">maxExpansion</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailable">maxUnavailable</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxExpansionInput`<sup>Optional</sup> <a name="maxExpansionInput" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansionInput"></a>

```typescript
public readonly maxExpansionInput: number;
```

- *Type:* number

---

##### `maxUnavailableInput`<sup>Optional</sup> <a name="maxUnavailableInput" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailableInput"></a>

```typescript
public readonly maxUnavailableInput: number;
```

- *Type:* number

---

##### `maxExpansion`<sup>Required</sup> <a name="maxExpansion" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxExpansion"></a>

```typescript
public readonly maxExpansion: number;
```

- *Type:* number

---

##### `maxUnavailable`<sup>Required</sup> <a name="maxUnavailable" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupDeployPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupDeployPolicy">KubernetesNodeGroupDeployPolicy</a>

---


### KubernetesNodeGroupInstanceTemplateBootDiskOutputReference <a name="KubernetesNodeGroupInstanceTemplateBootDiskOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateBootDiskOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateBootDiskOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resetSize">resetSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resetSize"></a>

```typescript
public resetSize(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a>

---


### KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference <a name="KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplateContainerRuntime;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a>

---


### KubernetesNodeGroupInstanceTemplateNetworkInterfaceList <a name="KubernetesNodeGroupInstanceTemplateNetworkInterfaceList" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateNetworkInterfaceList } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateNetworkInterfaceList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get"></a>

```typescript
public get(index: number): KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]

---


### KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference <a name="KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv4">resetIpv4</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6">resetIpv6</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetNat">resetNat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetSecurityGroupIds">resetSecurityGroupIds</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetIpv4` <a name="resetIpv4" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv4"></a>

```typescript
public resetIpv4(): void
```

##### `resetIpv6` <a name="resetIpv6" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetIpv6"></a>

```typescript
public resetIpv6(): void
```

##### `resetNat` <a name="resetNat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetNat"></a>

```typescript
public resetNat(): void
```

##### `resetSecurityGroupIds` <a name="resetSecurityGroupIds" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.resetSecurityGroupIds"></a>

```typescript
public resetSecurityGroupIds(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4Input">ipv4Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Input">ipv6Input</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.natInput">natInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIdsInput">securityGroupIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIdsInput">subnetIdsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4">ipv4</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6">ipv6</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds">securityGroupIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds">subnetIds</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `ipv4Input`<sup>Optional</sup> <a name="ipv4Input" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4Input"></a>

```typescript
public readonly ipv4Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6Input`<sup>Optional</sup> <a name="ipv6Input" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6Input"></a>

```typescript
public readonly ipv6Input: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `natInput`<sup>Optional</sup> <a name="natInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.natInput"></a>

```typescript
public readonly natInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `securityGroupIdsInput`<sup>Optional</sup> <a name="securityGroupIdsInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIdsInput"></a>

```typescript
public readonly securityGroupIdsInput: string[];
```

- *Type:* string[]

---

##### `subnetIdsInput`<sup>Optional</sup> <a name="subnetIdsInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIdsInput"></a>

```typescript
public readonly subnetIdsInput: string[];
```

- *Type:* string[]

---

##### `ipv4`<sup>Required</sup> <a name="ipv4" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv4"></a>

```typescript
public readonly ipv4: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `ipv6`<sup>Required</sup> <a name="ipv6" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.ipv6"></a>

```typescript
public readonly ipv6: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `securityGroupIds`<sup>Required</sup> <a name="securityGroupIds" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.securityGroupIds"></a>

```typescript
public readonly securityGroupIds: string[];
```

- *Type:* string[]

---

##### `subnetIds`<sup>Required</sup> <a name="subnetIds" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.subnetIds"></a>

```typescript
public readonly subnetIds: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>

---


### KubernetesNodeGroupInstanceTemplateOutputReference <a name="KubernetesNodeGroupInstanceTemplateOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putBootDisk">putBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putContainerRuntime">putContainerRuntime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putNetworkInterface">putNetworkInterface</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putPlacementPolicy">putPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putSchedulingPolicy">putSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetBootDisk">resetBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetContainerRuntime">resetContainerRuntime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetMetadata">resetMetadata</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNat">resetNat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNetworkAccelerationType">resetNetworkAccelerationType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNetworkInterface">resetNetworkInterface</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetPlacementPolicy">resetPlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetPlatformId">resetPlatformId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetResources">resetResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetSchedulingPolicy">resetSchedulingPolicy</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putBootDisk` <a name="putBootDisk" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putBootDisk"></a>

```typescript
public putBootDisk(value: KubernetesNodeGroupInstanceTemplateBootDisk): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putBootDisk.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a>

---

##### `putContainerRuntime` <a name="putContainerRuntime" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putContainerRuntime"></a>

```typescript
public putContainerRuntime(value: KubernetesNodeGroupInstanceTemplateContainerRuntime): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putContainerRuntime.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a>

---

##### `putNetworkInterface` <a name="putNetworkInterface" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putNetworkInterface"></a>

```typescript
public putNetworkInterface(value: IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putNetworkInterface.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]

---

##### `putPlacementPolicy` <a name="putPlacementPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putPlacementPolicy"></a>

```typescript
public putPlacementPolicy(value: KubernetesNodeGroupInstanceTemplatePlacementPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putPlacementPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putResources"></a>

```typescript
public putResources(value: KubernetesNodeGroupInstanceTemplateResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a>

---

##### `putSchedulingPolicy` <a name="putSchedulingPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putSchedulingPolicy"></a>

```typescript
public putSchedulingPolicy(value: KubernetesNodeGroupInstanceTemplateSchedulingPolicy): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.putSchedulingPolicy.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a>

---

##### `resetBootDisk` <a name="resetBootDisk" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetBootDisk"></a>

```typescript
public resetBootDisk(): void
```

##### `resetContainerRuntime` <a name="resetContainerRuntime" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetContainerRuntime"></a>

```typescript
public resetContainerRuntime(): void
```

##### `resetMetadata` <a name="resetMetadata" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetMetadata"></a>

```typescript
public resetMetadata(): void
```

##### `resetNat` <a name="resetNat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNat"></a>

```typescript
public resetNat(): void
```

##### `resetNetworkAccelerationType` <a name="resetNetworkAccelerationType" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNetworkAccelerationType"></a>

```typescript
public resetNetworkAccelerationType(): void
```

##### `resetNetworkInterface` <a name="resetNetworkInterface" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetNetworkInterface"></a>

```typescript
public resetNetworkInterface(): void
```

##### `resetPlacementPolicy` <a name="resetPlacementPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetPlacementPolicy"></a>

```typescript
public resetPlacementPolicy(): void
```

##### `resetPlatformId` <a name="resetPlatformId" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetPlatformId"></a>

```typescript
public resetPlatformId(): void
```

##### `resetResources` <a name="resetResources" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetResources"></a>

```typescript
public resetResources(): void
```

##### `resetSchedulingPolicy` <a name="resetSchedulingPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.resetSchedulingPolicy"></a>

```typescript
public resetSchedulingPolicy(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.bootDisk">bootDisk</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference">KubernetesNodeGroupInstanceTemplateBootDiskOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntime">containerRuntime</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference">KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterface">networkInterface</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList">KubernetesNodeGroupInstanceTemplateNetworkInterfaceList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicy">placementPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference">KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference">KubernetesNodeGroupInstanceTemplateResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicy">schedulingPolicy</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference">KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.bootDiskInput">bootDiskInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntimeInput">containerRuntimeInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.metadataInput">metadataInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.natInput">natInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationTypeInput">networkAccelerationTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterfaceInput">networkInterfaceInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicyInput">placementPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.platformIdInput">platformIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicyInput">schedulingPolicyInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.metadata">metadata</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.nat">nat</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationType">networkAccelerationType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.platformId">platformId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootDisk`<sup>Required</sup> <a name="bootDisk" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.bootDisk"></a>

```typescript
public readonly bootDisk: KubernetesNodeGroupInstanceTemplateBootDiskOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDiskOutputReference">KubernetesNodeGroupInstanceTemplateBootDiskOutputReference</a>

---

##### `containerRuntime`<sup>Required</sup> <a name="containerRuntime" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntime"></a>

```typescript
public readonly containerRuntime: KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference">KubernetesNodeGroupInstanceTemplateContainerRuntimeOutputReference</a>

---

##### `networkInterface`<sup>Required</sup> <a name="networkInterface" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterface"></a>

```typescript
public readonly networkInterface: KubernetesNodeGroupInstanceTemplateNetworkInterfaceList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterfaceList">KubernetesNodeGroupInstanceTemplateNetworkInterfaceList</a>

---

##### `placementPolicy`<sup>Required</sup> <a name="placementPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicy"></a>

```typescript
public readonly placementPolicy: KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference">KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.resources"></a>

```typescript
public readonly resources: KubernetesNodeGroupInstanceTemplateResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference">KubernetesNodeGroupInstanceTemplateResourcesOutputReference</a>

---

##### `schedulingPolicy`<sup>Required</sup> <a name="schedulingPolicy" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicy"></a>

```typescript
public readonly schedulingPolicy: KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference">KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference</a>

---

##### `bootDiskInput`<sup>Optional</sup> <a name="bootDiskInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.bootDiskInput"></a>

```typescript
public readonly bootDiskInput: KubernetesNodeGroupInstanceTemplateBootDisk;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateBootDisk">KubernetesNodeGroupInstanceTemplateBootDisk</a>

---

##### `containerRuntimeInput`<sup>Optional</sup> <a name="containerRuntimeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.containerRuntimeInput"></a>

```typescript
public readonly containerRuntimeInput: KubernetesNodeGroupInstanceTemplateContainerRuntime;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateContainerRuntime">KubernetesNodeGroupInstanceTemplateContainerRuntime</a>

---

##### `metadataInput`<sup>Optional</sup> <a name="metadataInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.metadataInput"></a>

```typescript
public readonly metadataInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `natInput`<sup>Optional</sup> <a name="natInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.natInput"></a>

```typescript
public readonly natInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `networkAccelerationTypeInput`<sup>Optional</sup> <a name="networkAccelerationTypeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationTypeInput"></a>

```typescript
public readonly networkAccelerationTypeInput: string;
```

- *Type:* string

---

##### `networkInterfaceInput`<sup>Optional</sup> <a name="networkInterfaceInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkInterfaceInput"></a>

```typescript
public readonly networkInterfaceInput: IResolvable | KubernetesNodeGroupInstanceTemplateNetworkInterface[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateNetworkInterface">KubernetesNodeGroupInstanceTemplateNetworkInterface</a>[]

---

##### `placementPolicyInput`<sup>Optional</sup> <a name="placementPolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.placementPolicyInput"></a>

```typescript
public readonly placementPolicyInput: KubernetesNodeGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a>

---

##### `platformIdInput`<sup>Optional</sup> <a name="platformIdInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.platformIdInput"></a>

```typescript
public readonly platformIdInput: string;
```

- *Type:* string

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: KubernetesNodeGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a>

---

##### `schedulingPolicyInput`<sup>Optional</sup> <a name="schedulingPolicyInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.schedulingPolicyInput"></a>

```typescript
public readonly schedulingPolicyInput: KubernetesNodeGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a>

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.metadata"></a>

```typescript
public readonly metadata: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `nat`<sup>Required</sup> <a name="nat" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.nat"></a>

```typescript
public readonly nat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `networkAccelerationType`<sup>Required</sup> <a name="networkAccelerationType" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.networkAccelerationType"></a>

```typescript
public readonly networkAccelerationType: string;
```

- *Type:* string

---

##### `platformId`<sup>Required</sup> <a name="platformId" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.platformId"></a>

```typescript
public readonly platformId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplate;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplate">KubernetesNodeGroupInstanceTemplate</a>

---


### KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference <a name="KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupIdInput">placementGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId">placementGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `placementGroupIdInput`<sup>Optional</sup> <a name="placementGroupIdInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupIdInput"></a>

```typescript
public readonly placementGroupIdInput: string;
```

- *Type:* string

---

##### `placementGroupId`<sup>Required</sup> <a name="placementGroupId" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.placementGroupId"></a>

```typescript
public readonly placementGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplatePlacementPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplatePlacementPolicy">KubernetesNodeGroupInstanceTemplatePlacementPolicy</a>

---


### KubernetesNodeGroupInstanceTemplateResourcesOutputReference <a name="KubernetesNodeGroupInstanceTemplateResourcesOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateResourcesOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetCoreFraction">resetCoreFraction</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetCores">resetCores</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetGpus">resetGpus</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetMemory">resetMemory</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCoreFraction` <a name="resetCoreFraction" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetCoreFraction"></a>

```typescript
public resetCoreFraction(): void
```

##### `resetCores` <a name="resetCores" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetCores"></a>

```typescript
public resetCores(): void
```

##### `resetGpus` <a name="resetGpus" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetGpus"></a>

```typescript
public resetGpus(): void
```

##### `resetMemory` <a name="resetMemory" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.resetMemory"></a>

```typescript
public resetMemory(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFractionInput">coreFractionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coresInput">coresInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpusInput">gpusInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memoryInput">memoryInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFraction">coreFraction</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.cores">cores</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpus">gpus</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memory">memory</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `coreFractionInput`<sup>Optional</sup> <a name="coreFractionInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFractionInput"></a>

```typescript
public readonly coreFractionInput: number;
```

- *Type:* number

---

##### `coresInput`<sup>Optional</sup> <a name="coresInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coresInput"></a>

```typescript
public readonly coresInput: number;
```

- *Type:* number

---

##### `gpusInput`<sup>Optional</sup> <a name="gpusInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpusInput"></a>

```typescript
public readonly gpusInput: number;
```

- *Type:* number

---

##### `memoryInput`<sup>Optional</sup> <a name="memoryInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memoryInput"></a>

```typescript
public readonly memoryInput: number;
```

- *Type:* number

---

##### `coreFraction`<sup>Required</sup> <a name="coreFraction" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.coreFraction"></a>

```typescript
public readonly coreFraction: number;
```

- *Type:* number

---

##### `cores`<sup>Required</sup> <a name="cores" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.cores"></a>

```typescript
public readonly cores: number;
```

- *Type:* number

---

##### `gpus`<sup>Required</sup> <a name="gpus" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.gpus"></a>

```typescript
public readonly gpus: number;
```

- *Type:* number

---

##### `memory`<sup>Required</sup> <a name="memory" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.memory"></a>

```typescript
public readonly memory: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplateResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateResources">KubernetesNodeGroupInstanceTemplateResources</a>

---


### KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference <a name="KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resetPreemptible">resetPreemptible</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPreemptible` <a name="resetPreemptible" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.resetPreemptible"></a>

```typescript
public resetPreemptible(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptibleInput">preemptibleInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible">preemptible</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `preemptibleInput`<sup>Optional</sup> <a name="preemptibleInput" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptibleInput"></a>

```typescript
public readonly preemptibleInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `preemptible`<sup>Required</sup> <a name="preemptible" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.preemptible"></a>

```typescript
public readonly preemptible: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupInstanceTemplateSchedulingPolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupInstanceTemplateSchedulingPolicy">KubernetesNodeGroupInstanceTemplateSchedulingPolicy</a>

---


### KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList <a name="KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer"></a>

```typescript
import { KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList } from '@cdktf/provider-yandex'

new KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get"></a>

```typescript
public get(index: number): KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]

---


### KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference <a name="KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.durationInput">durationInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTimeInput">startTimeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.duration">duration</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTime">startTime</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `durationInput`<sup>Optional</sup> <a name="durationInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.durationInput"></a>

```typescript
public readonly durationInput: string;
```

- *Type:* string

---

##### `startTimeInput`<sup>Optional</sup> <a name="startTimeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTimeInput"></a>

```typescript
public readonly startTimeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `duration`<sup>Required</sup> <a name="duration" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.duration"></a>

```typescript
public readonly duration: string;
```

- *Type:* string

---

##### `startTime`<sup>Required</sup> <a name="startTime" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.startTime"></a>

```typescript
public readonly startTime: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>

---


### KubernetesNodeGroupMaintenancePolicyOutputReference <a name="KubernetesNodeGroupMaintenancePolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupMaintenancePolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupMaintenancePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.putMaintenanceWindow">putMaintenanceWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.resetMaintenanceWindow">resetMaintenanceWindow</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putMaintenanceWindow` <a name="putMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.putMaintenanceWindow"></a>

```typescript
public putMaintenanceWindow(value: IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.putMaintenanceWindow.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]

---

##### `resetMaintenanceWindow` <a name="resetMaintenanceWindow" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.resetMaintenanceWindow"></a>

```typescript
public resetMaintenanceWindow(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindow">maintenanceWindow</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList">KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepairInput">autoRepairInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgradeInput">autoUpgradeInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindowInput">maintenanceWindowInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepair">autoRepair</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgrade">autoUpgrade</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maintenanceWindow`<sup>Required</sup> <a name="maintenanceWindow" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindow"></a>

```typescript
public readonly maintenanceWindow: KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList">KubernetesNodeGroupMaintenancePolicyMaintenanceWindowList</a>

---

##### `autoRepairInput`<sup>Optional</sup> <a name="autoRepairInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepairInput"></a>

```typescript
public readonly autoRepairInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `autoUpgradeInput`<sup>Optional</sup> <a name="autoUpgradeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgradeInput"></a>

```typescript
public readonly autoUpgradeInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maintenanceWindowInput`<sup>Optional</sup> <a name="maintenanceWindowInput" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.maintenanceWindowInput"></a>

```typescript
public readonly maintenanceWindowInput: IResolvable | KubernetesNodeGroupMaintenancePolicyMaintenanceWindow[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyMaintenanceWindow">KubernetesNodeGroupMaintenancePolicyMaintenanceWindow</a>[]

---

##### `autoRepair`<sup>Required</sup> <a name="autoRepair" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoRepair"></a>

```typescript
public readonly autoRepair: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `autoUpgrade`<sup>Required</sup> <a name="autoUpgrade" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.autoUpgrade"></a>

```typescript
public readonly autoUpgrade: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupMaintenancePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupMaintenancePolicy">KubernetesNodeGroupMaintenancePolicy</a>

---


### KubernetesNodeGroupScalePolicyAutoScaleOutputReference <a name="KubernetesNodeGroupScalePolicyAutoScaleOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicyAutoScaleOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupScalePolicyAutoScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initialInput">initialInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.maxInput">maxInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.minInput">minInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initial">initial</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.max">max</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.min">min</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `initialInput`<sup>Optional</sup> <a name="initialInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initialInput"></a>

```typescript
public readonly initialInput: number;
```

- *Type:* number

---

##### `maxInput`<sup>Optional</sup> <a name="maxInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.maxInput"></a>

```typescript
public readonly maxInput: number;
```

- *Type:* number

---

##### `minInput`<sup>Optional</sup> <a name="minInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.minInput"></a>

```typescript
public readonly minInput: number;
```

- *Type:* number

---

##### `initial`<sup>Required</sup> <a name="initial" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.initial"></a>

```typescript
public readonly initial: number;
```

- *Type:* number

---

##### `max`<sup>Required</sup> <a name="max" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.max"></a>

```typescript
public readonly max: number;
```

- *Type:* number

---

##### `min`<sup>Required</sup> <a name="min" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.min"></a>

```typescript
public readonly min: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a>

---


### KubernetesNodeGroupScalePolicyFixedScaleOutputReference <a name="KubernetesNodeGroupScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.resetSize">resetSize</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSize` <a name="resetSize" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.resetSize"></a>

```typescript
public resetSize(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a>

---


### KubernetesNodeGroupScalePolicyOutputReference <a name="KubernetesNodeGroupScalePolicyOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupScalePolicyOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putAutoScale">putAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putFixedScale">putFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resetAutoScale">resetAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resetFixedScale">resetFixedScale</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAutoScale` <a name="putAutoScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putAutoScale"></a>

```typescript
public putAutoScale(value: KubernetesNodeGroupScalePolicyAutoScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putAutoScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a>

---

##### `putFixedScale` <a name="putFixedScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putFixedScale"></a>

```typescript
public putFixedScale(value: KubernetesNodeGroupScalePolicyFixedScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.putFixedScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a>

---

##### `resetAutoScale` <a name="resetAutoScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resetAutoScale"></a>

```typescript
public resetAutoScale(): void
```

##### `resetFixedScale` <a name="resetFixedScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.resetFixedScale"></a>

```typescript
public resetFixedScale(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.autoScale">autoScale</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference">KubernetesNodeGroupScalePolicyAutoScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference">KubernetesNodeGroupScalePolicyFixedScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.autoScaleInput">autoScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fixedScaleInput">fixedScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoScale`<sup>Required</sup> <a name="autoScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.autoScale"></a>

```typescript
public readonly autoScale: KubernetesNodeGroupScalePolicyAutoScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScaleOutputReference">KubernetesNodeGroupScalePolicyAutoScaleOutputReference</a>

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: KubernetesNodeGroupScalePolicyFixedScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScaleOutputReference">KubernetesNodeGroupScalePolicyFixedScaleOutputReference</a>

---

##### `autoScaleInput`<sup>Optional</sup> <a name="autoScaleInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.autoScaleInput"></a>

```typescript
public readonly autoScaleInput: KubernetesNodeGroupScalePolicyAutoScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyAutoScale">KubernetesNodeGroupScalePolicyAutoScale</a>

---

##### `fixedScaleInput`<sup>Optional</sup> <a name="fixedScaleInput" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.fixedScaleInput"></a>

```typescript
public readonly fixedScaleInput: KubernetesNodeGroupScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyFixedScale">KubernetesNodeGroupScalePolicyFixedScale</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupScalePolicy">KubernetesNodeGroupScalePolicy</a>

---


### KubernetesNodeGroupTimeoutsOutputReference <a name="KubernetesNodeGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | KubernetesNodeGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.KubernetesNodeGroupTimeouts">KubernetesNodeGroupTimeouts</a>

---


### KubernetesNodeGroupVersionInfoList <a name="KubernetesNodeGroupVersionInfoList" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer"></a>

```typescript
import { KubernetesNodeGroupVersionInfoList } from '@cdktf/provider-yandex'

new KubernetesNodeGroupVersionInfoList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.get"></a>

```typescript
public get(index: number): KubernetesNodeGroupVersionInfoOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### KubernetesNodeGroupVersionInfoOutputReference <a name="KubernetesNodeGroupVersionInfoOutputReference" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer"></a>

```typescript
import { KubernetesNodeGroupVersionInfoOutputReference } from '@cdktf/provider-yandex'

new KubernetesNodeGroupVersionInfoOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.currentVersion">currentVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.newRevisionAvailable">newRevisionAvailable</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.newRevisionSummary">newRevisionSummary</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.versionDeprecated">versionDeprecated</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfo">KubernetesNodeGroupVersionInfo</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `currentVersion`<sup>Required</sup> <a name="currentVersion" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.currentVersion"></a>

```typescript
public readonly currentVersion: string;
```

- *Type:* string

---

##### `newRevisionAvailable`<sup>Required</sup> <a name="newRevisionAvailable" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.newRevisionAvailable"></a>

```typescript
public readonly newRevisionAvailable: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `newRevisionSummary`<sup>Required</sup> <a name="newRevisionSummary" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.newRevisionSummary"></a>

```typescript
public readonly newRevisionSummary: string;
```

- *Type:* string

---

##### `versionDeprecated`<sup>Required</sup> <a name="versionDeprecated" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.versionDeprecated"></a>

```typescript
public readonly versionDeprecated: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.KubernetesNodeGroupVersionInfoOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: KubernetesNodeGroupVersionInfo;
```

- *Type:* <a href="#@cdktf/provider-yandex.KubernetesNodeGroupVersionInfo">KubernetesNodeGroupVersionInfo</a>

---


### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resetPath">resetPath</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPath` <a name="resetPath" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.resetPath"></a>

```typescript
public resetPath(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.pathInput">pathInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.path">path</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `pathInput`<sup>Optional</sup> <a name="pathInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.pathInput"></a>

```typescript
public readonly pathInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `path`<sup>Required</sup> <a name="path" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a>

---


### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get"></a>

```typescript
public get(index: number): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]

---


### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putHttpOptions">putHttpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putTcpOptions">putTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetHealthyThreshold">resetHealthyThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetHttpOptions">resetHttpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetInterval">resetInterval</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetTcpOptions">resetTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetTimeout">resetTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetUnhealthyThreshold">resetUnhealthyThreshold</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHttpOptions` <a name="putHttpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putHttpOptions"></a>

```typescript
public putHttpOptions(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putHttpOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a>

---

##### `putTcpOptions` <a name="putTcpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putTcpOptions"></a>

```typescript
public putTcpOptions(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.putTcpOptions.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a>

---

##### `resetHealthyThreshold` <a name="resetHealthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetHealthyThreshold"></a>

```typescript
public resetHealthyThreshold(): void
```

##### `resetHttpOptions` <a name="resetHttpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetHttpOptions"></a>

```typescript
public resetHttpOptions(): void
```

##### `resetInterval` <a name="resetInterval" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetInterval"></a>

```typescript
public resetInterval(): void
```

##### `resetTcpOptions` <a name="resetTcpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetTcpOptions"></a>

```typescript
public resetTcpOptions(): void
```

##### `resetTimeout` <a name="resetTimeout" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetTimeout"></a>

```typescript
public resetTimeout(): void
```

##### `resetUnhealthyThreshold` <a name="resetUnhealthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.resetUnhealthyThreshold"></a>

```typescript
public resetUnhealthyThreshold(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptions">httpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptions">tcpOptions</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThresholdInput">healthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptionsInput">httpOptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.intervalInput">intervalInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptionsInput">tcpOptionsInput</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThresholdInput">unhealthyThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThreshold">healthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.interval">interval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThreshold">unhealthyThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `httpOptions`<sup>Required</sup> <a name="httpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptions"></a>

```typescript
public readonly httpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference</a>

---

##### `tcpOptions`<sup>Required</sup> <a name="tcpOptions" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptions"></a>

```typescript
public readonly tcpOptions: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference</a>

---

##### `healthyThresholdInput`<sup>Optional</sup> <a name="healthyThresholdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThresholdInput"></a>

```typescript
public readonly healthyThresholdInput: number;
```

- *Type:* number

---

##### `httpOptionsInput`<sup>Optional</sup> <a name="httpOptionsInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.httpOptionsInput"></a>

```typescript
public readonly httpOptionsInput: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions</a>

---

##### `intervalInput`<sup>Optional</sup> <a name="intervalInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.intervalInput"></a>

```typescript
public readonly intervalInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `tcpOptionsInput`<sup>Optional</sup> <a name="tcpOptionsInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.tcpOptionsInput"></a>

```typescript
public readonly tcpOptionsInput: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a>

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* number

---

##### `unhealthyThresholdInput`<sup>Optional</sup> <a name="unhealthyThresholdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThresholdInput"></a>

```typescript
public readonly unhealthyThresholdInput: number;
```

- *Type:* number

---

##### `healthyThreshold`<sup>Required</sup> <a name="healthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.healthyThreshold"></a>

```typescript
public readonly healthyThreshold: number;
```

- *Type:* number

---

##### `interval`<sup>Required</sup> <a name="interval" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.interval"></a>

```typescript
public readonly interval: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `unhealthyThreshold`<sup>Required</sup> <a name="unhealthyThreshold" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.unhealthyThreshold"></a>

```typescript
public readonly unhealthyThreshold: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>

---


### LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference <a name="LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions</a>

---


### LbNetworkLoadBalancerAttachedTargetGroupList <a name="LbNetworkLoadBalancerAttachedTargetGroupList" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupList } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.get"></a>

```typescript
public get(index: number): LbNetworkLoadBalancerAttachedTargetGroupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>[]

---


### LbNetworkLoadBalancerAttachedTargetGroupOutputReference <a name="LbNetworkLoadBalancerAttachedTargetGroupOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerAttachedTargetGroupOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerAttachedTargetGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.putHealthcheck">putHealthcheck</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putHealthcheck` <a name="putHealthcheck" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.putHealthcheck"></a>

```typescript
public putHealthcheck(value: IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.putHealthcheck.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheck">healthcheck</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheckInput">healthcheckInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupIdInput">targetGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupId">targetGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `healthcheck`<sup>Required</sup> <a name="healthcheck" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheck"></a>

```typescript
public readonly healthcheck: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList">LbNetworkLoadBalancerAttachedTargetGroupHealthcheckList</a>

---

##### `healthcheckInput`<sup>Optional</sup> <a name="healthcheckInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.healthcheckInput"></a>

```typescript
public readonly healthcheckInput: IResolvable | LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupHealthcheck">LbNetworkLoadBalancerAttachedTargetGroupHealthcheck</a>[]

---

##### `targetGroupIdInput`<sup>Optional</sup> <a name="targetGroupIdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupIdInput"></a>

```typescript
public readonly targetGroupIdInput: string;
```

- *Type:* string

---

##### `targetGroupId`<sup>Required</sup> <a name="targetGroupId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.targetGroupId"></a>

```typescript
public readonly targetGroupId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerAttachedTargetGroup;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerAttachedTargetGroup">LbNetworkLoadBalancerAttachedTargetGroup</a>

---


### LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference <a name="LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resetIpVersion">resetIpVersion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetIpVersion` <a name="resetIpVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.resetIpVersion"></a>

```typescript
public resetIpVersion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersionInput">ipVersionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersion">ipVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `ipVersionInput`<sup>Optional</sup> <a name="ipVersionInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersionInput"></a>

```typescript
public readonly ipVersionInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ipVersion`<sup>Required</sup> <a name="ipVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbNetworkLoadBalancerListenerExternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a>

---


### LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference <a name="LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resetAddress">resetAddress</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resetIpVersion">resetIpVersion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddress` <a name="resetAddress" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resetAddress"></a>

```typescript
public resetAddress(): void
```

##### `resetIpVersion` <a name="resetIpVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.resetIpVersion"></a>

```typescript
public resetIpVersion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersionInput">ipVersionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersion">ipVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `ipVersionInput`<sup>Optional</sup> <a name="ipVersionInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersionInput"></a>

```typescript
public readonly ipVersionInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ipVersion`<sup>Required</sup> <a name="ipVersion" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.ipVersion"></a>

```typescript
public readonly ipVersion: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: LbNetworkLoadBalancerListenerInternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a>

---


### LbNetworkLoadBalancerListenerList <a name="LbNetworkLoadBalancerListenerList" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerList } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerListenerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.get"></a>

```typescript
public get(index: number): LbNetworkLoadBalancerListenerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerListener[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>[]

---


### LbNetworkLoadBalancerListenerOutputReference <a name="LbNetworkLoadBalancerListenerOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerListenerOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerListenerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putExternalAddressSpec">putExternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putInternalAddressSpec">putInternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetExternalAddressSpec">resetExternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetInternalAddressSpec">resetInternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetProtocol">resetProtocol</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetTargetPort">resetTargetPort</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExternalAddressSpec` <a name="putExternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putExternalAddressSpec"></a>

```typescript
public putExternalAddressSpec(value: LbNetworkLoadBalancerListenerExternalAddressSpec): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putExternalAddressSpec.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a>

---

##### `putInternalAddressSpec` <a name="putInternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putInternalAddressSpec"></a>

```typescript
public putInternalAddressSpec(value: LbNetworkLoadBalancerListenerInternalAddressSpec): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.putInternalAddressSpec.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a>

---

##### `resetExternalAddressSpec` <a name="resetExternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetExternalAddressSpec"></a>

```typescript
public resetExternalAddressSpec(): void
```

##### `resetInternalAddressSpec` <a name="resetInternalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetInternalAddressSpec"></a>

```typescript
public resetInternalAddressSpec(): void
```

##### `resetProtocol` <a name="resetProtocol" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetProtocol"></a>

```typescript
public resetProtocol(): void
```

##### `resetTargetPort` <a name="resetTargetPort" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.resetTargetPort"></a>

```typescript
public resetTargetPort(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpec">externalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference">LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpec">internalAddressSpec</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference">LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpecInput">externalAddressSpecInput</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpecInput">internalAddressSpecInput</a></code> | <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.targetPortInput">targetPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.targetPort">targetPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalAddressSpec`<sup>Required</sup> <a name="externalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpec"></a>

```typescript
public readonly externalAddressSpec: LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference">LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference</a>

---

##### `internalAddressSpec`<sup>Required</sup> <a name="internalAddressSpec" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpec"></a>

```typescript
public readonly internalAddressSpec: LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference">LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference</a>

---

##### `externalAddressSpecInput`<sup>Optional</sup> <a name="externalAddressSpecInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.externalAddressSpecInput"></a>

```typescript
public readonly externalAddressSpecInput: LbNetworkLoadBalancerListenerExternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerExternalAddressSpec">LbNetworkLoadBalancerListenerExternalAddressSpec</a>

---

##### `internalAddressSpecInput`<sup>Optional</sup> <a name="internalAddressSpecInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalAddressSpecInput"></a>

```typescript
public readonly internalAddressSpecInput: LbNetworkLoadBalancerListenerInternalAddressSpec;
```

- *Type:* <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListenerInternalAddressSpec">LbNetworkLoadBalancerListenerInternalAddressSpec</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `targetPortInput`<sup>Optional</sup> <a name="targetPortInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.targetPortInput"></a>

```typescript
public readonly targetPortInput: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `targetPort`<sup>Required</sup> <a name="targetPort" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerListenerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerListener;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerListener">LbNetworkLoadBalancerListener</a>

---


### LbNetworkLoadBalancerTimeoutsOutputReference <a name="LbNetworkLoadBalancerTimeoutsOutputReference" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.Initializer"></a>

```typescript
import { LbNetworkLoadBalancerTimeoutsOutputReference } from '@cdktf/provider-yandex'

new LbNetworkLoadBalancerTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbNetworkLoadBalancerTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbNetworkLoadBalancerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbNetworkLoadBalancerTimeouts">LbNetworkLoadBalancerTimeouts</a>

---


### LbTargetGroupTargetList <a name="LbTargetGroupTargetList" id="@cdktf/provider-yandex.LbTargetGroupTargetList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer"></a>

```typescript
import { LbTargetGroupTargetList } from '@cdktf/provider-yandex'

new LbTargetGroupTargetList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.LbTargetGroupTargetList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbTargetGroupTargetList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbTargetGroupTargetList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbTargetGroupTargetList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbTargetGroupTargetList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.LbTargetGroupTargetList.get"></a>

```typescript
public get(index: number): LbTargetGroupTargetOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.LbTargetGroupTargetList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbTargetGroupTargetList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbTargetGroupTargetList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbTargetGroupTargetList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbTargetGroupTarget[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>[]

---


### LbTargetGroupTargetOutputReference <a name="LbTargetGroupTargetOutputReference" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer"></a>

```typescript
import { LbTargetGroupTargetOutputReference } from '@cdktf/provider-yandex'

new LbTargetGroupTargetOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.addressInput">addressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addressInput`<sup>Optional</sup> <a name="addressInput" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.addressInput"></a>

```typescript
public readonly addressInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbTargetGroupTargetOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbTargetGroupTarget;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTarget">LbTargetGroupTarget</a>

---


### LbTargetGroupTimeoutsOutputReference <a name="LbTargetGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { LbTargetGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new LbTargetGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LbTargetGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LbTargetGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LbTargetGroupTimeouts">LbTargetGroupTimeouts</a>

---


### LoggingGroupTimeoutsOutputReference <a name="LoggingGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { LoggingGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new LoggingGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.resetDefault">resetDefault</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDefault` <a name="resetDefault" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.defaultInput">defaultInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.default">default</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `defaultInput`<sup>Optional</sup> <a name="defaultInput" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* string

---

##### `default`<sup>Required</sup> <a name="default" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.LoggingGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | LoggingGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.LoggingGroupTimeouts">LoggingGroupTimeouts</a>

---


### MdbClickhouseClusterAccessOutputReference <a name="MdbClickhouseClusterAccessOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterAccessOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetDataLens">resetDataLens</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetMetrika">resetMetrika</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetServerless">resetServerless</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetWebSql">resetWebSql</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDataLens` <a name="resetDataLens" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetDataLens"></a>

```typescript
public resetDataLens(): void
```

##### `resetMetrika` <a name="resetMetrika" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetMetrika"></a>

```typescript
public resetMetrika(): void
```

##### `resetServerless` <a name="resetServerless" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetServerless"></a>

```typescript
public resetServerless(): void
```

##### `resetWebSql` <a name="resetWebSql" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.resetWebSql"></a>

```typescript
public resetWebSql(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.dataLensInput">dataLensInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.metrikaInput">metrikaInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.serverlessInput">serverlessInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.webSqlInput">webSqlInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.metrika">metrika</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.serverless">serverless</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLensInput`<sup>Optional</sup> <a name="dataLensInput" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.dataLensInput"></a>

```typescript
public readonly dataLensInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `metrikaInput`<sup>Optional</sup> <a name="metrikaInput" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.metrikaInput"></a>

```typescript
public readonly metrikaInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serverlessInput`<sup>Optional</sup> <a name="serverlessInput" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.serverlessInput"></a>

```typescript
public readonly serverlessInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSqlInput`<sup>Optional</sup> <a name="webSqlInput" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.webSqlInput"></a>

```typescript
public readonly webSqlInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `metrika`<sup>Required</sup> <a name="metrika" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.metrika"></a>

```typescript
public readonly metrika: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serverless`<sup>Required</sup> <a name="serverless" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.serverless"></a>

```typescript
public readonly serverless: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterAccess">MdbClickhouseClusterAccess</a>

---


### MdbClickhouseClusterBackupWindowStartOutputReference <a name="MdbClickhouseClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterBackupWindowStart">MdbClickhouseClusterBackupWindowStart</a>

---


### MdbClickhouseClusterClickhouseConfigCompressionList <a name="MdbClickhouseClusterClickhouseConfigCompressionList" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigCompressionList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigCompressionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterClickhouseConfigCompressionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigCompression[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]

---


### MdbClickhouseClusterClickhouseConfigCompressionOutputReference <a name="MdbClickhouseClusterClickhouseConfigCompressionOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigCompressionOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigCompressionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.methodInput">methodInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeInput">minPartSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatioInput">minPartSizeRatioInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.method">method</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSize">minPartSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatio">minPartSizeRatio</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `methodInput`<sup>Optional</sup> <a name="methodInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.methodInput"></a>

```typescript
public readonly methodInput: string;
```

- *Type:* string

---

##### `minPartSizeInput`<sup>Optional</sup> <a name="minPartSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeInput"></a>

```typescript
public readonly minPartSizeInput: number;
```

- *Type:* number

---

##### `minPartSizeRatioInput`<sup>Optional</sup> <a name="minPartSizeRatioInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatioInput"></a>

```typescript
public readonly minPartSizeRatioInput: number;
```

- *Type:* number

---

##### `method`<sup>Required</sup> <a name="method" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.method"></a>

```typescript
public readonly method: string;
```

- *Type:* string

---

##### `minPartSize`<sup>Required</sup> <a name="minPartSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSize"></a>

```typescript
public readonly minPartSize: number;
```

- *Type:* number

---

##### `minPartSizeRatio`<sup>Required</sup> <a name="minPartSizeRatio" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.minPartSizeRatio"></a>

```typescript
public readonly minPartSizeRatio: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigCompression;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupList <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupList" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.putPattern">putPattern</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resetPattern">resetPattern</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPattern` <a name="putPattern" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.putPattern"></a>

```typescript
public putPattern(value: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.putPattern.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]

---

##### `resetPattern` <a name="resetPattern" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.resetPattern"></a>

```typescript
public resetPattern(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.pattern">pattern</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.patternInput">patternInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `pattern`<sup>Required</sup> <a name="pattern" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.pattern"></a>

```typescript
public readonly pattern: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `patternInput`<sup>Optional</sup> <a name="patternInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.patternInput"></a>

```typescript
public readonly patternInput: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>[]

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.putRetention">putRetention</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resetRegexp">resetRegexp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resetRetention">resetRetention</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putRetention` <a name="putRetention" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.putRetention"></a>

```typescript
public putRetention(value: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.putRetention.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]

---

##### `resetRegexp` <a name="resetRegexp" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resetRegexp"></a>

```typescript
public resetRegexp(): void
```

##### `resetRetention` <a name="resetRetention" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.resetRetention"></a>

```typescript
public resetRetention(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retention">retention</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.functionInput">functionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexpInput">regexpInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retentionInput">retentionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.function">function</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexp">regexp</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `retention`<sup>Required</sup> <a name="retention" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retention"></a>

```typescript
public readonly retention: MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList</a>

---

##### `functionInput`<sup>Optional</sup> <a name="functionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.functionInput"></a>

```typescript
public readonly functionInput: string;
```

- *Type:* string

---

##### `regexpInput`<sup>Optional</sup> <a name="regexpInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexpInput"></a>

```typescript
public readonly regexpInput: string;
```

- *Type:* string

---

##### `retentionInput`<sup>Optional</sup> <a name="retentionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.retentionInput"></a>

```typescript
public readonly retentionInput: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]

---

##### `function`<sup>Required</sup> <a name="function" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.function"></a>

```typescript
public readonly function: string;
```

- *Type:* string

---

##### `regexp`<sup>Required</sup> <a name="regexp" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.regexp"></a>

```typescript
public readonly regexp: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern">MdbClickhouseClusterClickhouseConfigGraphiteRollupPattern</a>

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>[]

---


### MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference <a name="MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.ageInput">ageInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precisionInput">precisionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.age">age</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precision">precision</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `ageInput`<sup>Optional</sup> <a name="ageInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.ageInput"></a>

```typescript
public readonly ageInput: number;
```

- *Type:* number

---

##### `precisionInput`<sup>Optional</sup> <a name="precisionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precisionInput"></a>

```typescript
public readonly precisionInput: number;
```

- *Type:* number

---

##### `age`<sup>Required</sup> <a name="age" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.age"></a>

```typescript
public readonly age: number;
```

- *Type:* number

---

##### `precision`<sup>Required</sup> <a name="precision" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.precision"></a>

```typescript
public readonly precision: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetentionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention">MdbClickhouseClusterClickhouseConfigGraphiteRollupPatternRetention</a>

---


### MdbClickhouseClusterClickhouseConfigKafkaOutputReference <a name="MdbClickhouseClusterClickhouseConfigKafkaOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigKafkaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslMechanism">resetSaslMechanism</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslPassword">resetSaslPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslUsername">resetSaslUsername</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSecurityProtocol">resetSecurityProtocol</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSaslMechanism` <a name="resetSaslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslMechanism"></a>

```typescript
public resetSaslMechanism(): void
```

##### `resetSaslPassword` <a name="resetSaslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslPassword"></a>

```typescript
public resetSaslPassword(): void
```

##### `resetSaslUsername` <a name="resetSaslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSaslUsername"></a>

```typescript
public resetSaslUsername(): void
```

##### `resetSecurityProtocol` <a name="resetSecurityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.resetSecurityProtocol"></a>

```typescript
public resetSecurityProtocol(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanismInput">saslMechanismInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPasswordInput">saslPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsernameInput">saslUsernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocolInput">securityProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `saslMechanismInput`<sup>Optional</sup> <a name="saslMechanismInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanismInput"></a>

```typescript
public readonly saslMechanismInput: string;
```

- *Type:* string

---

##### `saslPasswordInput`<sup>Optional</sup> <a name="saslPasswordInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPasswordInput"></a>

```typescript
public readonly saslPasswordInput: string;
```

- *Type:* string

---

##### `saslUsernameInput`<sup>Optional</sup> <a name="saslUsernameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsernameInput"></a>

```typescript
public readonly saslUsernameInput: string;
```

- *Type:* string

---

##### `securityProtocolInput`<sup>Optional</sup> <a name="securityProtocolInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocolInput"></a>

```typescript
public readonly securityProtocolInput: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a>

---


### MdbClickhouseClusterClickhouseConfigKafkaTopicList <a name="MdbClickhouseClusterClickhouseConfigKafkaTopicList" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaTopicList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigKafkaTopicList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]

---


### MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference <a name="MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.putSettings">putSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resetSettings">resetSettings</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putSettings` <a name="putSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.putSettings"></a>

```typescript
public putSettings(value: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.putSettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a>

---

##### `resetSettings` <a name="resetSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.resetSettings"></a>

```typescript
public resetSettings(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference">MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settingsInput">settingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settings"></a>

```typescript
public readonly settings: MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference">MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `settingsInput`<sup>Optional</sup> <a name="settingsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.settingsInput"></a>

```typescript
public readonly settingsInput: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>

---


### MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference <a name="MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslMechanism">resetSaslMechanism</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslPassword">resetSaslPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslUsername">resetSaslUsername</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSecurityProtocol">resetSecurityProtocol</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSaslMechanism` <a name="resetSaslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslMechanism"></a>

```typescript
public resetSaslMechanism(): void
```

##### `resetSaslPassword` <a name="resetSaslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslPassword"></a>

```typescript
public resetSaslPassword(): void
```

##### `resetSaslUsername` <a name="resetSaslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSaslUsername"></a>

```typescript
public resetSaslUsername(): void
```

##### `resetSecurityProtocol` <a name="resetSecurityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.resetSecurityProtocol"></a>

```typescript
public resetSecurityProtocol(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanismInput">saslMechanismInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPasswordInput">saslPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsernameInput">saslUsernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocolInput">securityProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `saslMechanismInput`<sup>Optional</sup> <a name="saslMechanismInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanismInput"></a>

```typescript
public readonly saslMechanismInput: string;
```

- *Type:* string

---

##### `saslPasswordInput`<sup>Optional</sup> <a name="saslPasswordInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPasswordInput"></a>

```typescript
public readonly saslPasswordInput: string;
```

- *Type:* string

---

##### `saslUsernameInput`<sup>Optional</sup> <a name="saslUsernameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsernameInput"></a>

```typescript
public readonly saslUsernameInput: string;
```

- *Type:* string

---

##### `securityProtocolInput`<sup>Optional</sup> <a name="securityProtocolInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocolInput"></a>

```typescript
public readonly securityProtocolInput: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseConfigKafkaTopicSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicSettings">MdbClickhouseClusterClickhouseConfigKafkaTopicSettings</a>

---


### MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference <a name="MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetMaxBytesToMergeAtMinSpaceInPool">resetMaxBytesToMergeAtMinSpaceInPool</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetMaxReplicatedMergesInQueue">resetMaxReplicatedMergesInQueue</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge">resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetPartsToDelayInsert">resetPartsToDelayInsert</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetPartsToThrowInsert">resetPartsToThrowInsert</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetReplicatedDeduplicationWindow">resetReplicatedDeduplicationWindow</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetReplicatedDeduplicationWindowSeconds">resetReplicatedDeduplicationWindowSeconds</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxBytesToMergeAtMinSpaceInPool` <a name="resetMaxBytesToMergeAtMinSpaceInPool" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetMaxBytesToMergeAtMinSpaceInPool"></a>

```typescript
public resetMaxBytesToMergeAtMinSpaceInPool(): void
```

##### `resetMaxReplicatedMergesInQueue` <a name="resetMaxReplicatedMergesInQueue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetMaxReplicatedMergesInQueue"></a>

```typescript
public resetMaxReplicatedMergesInQueue(): void
```

##### `resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge` <a name="resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge"></a>

```typescript
public resetNumberOfFreeEntriesInPoolToLowerMaxSizeOfMerge(): void
```

##### `resetPartsToDelayInsert` <a name="resetPartsToDelayInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetPartsToDelayInsert"></a>

```typescript
public resetPartsToDelayInsert(): void
```

##### `resetPartsToThrowInsert` <a name="resetPartsToThrowInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetPartsToThrowInsert"></a>

```typescript
public resetPartsToThrowInsert(): void
```

##### `resetReplicatedDeduplicationWindow` <a name="resetReplicatedDeduplicationWindow" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetReplicatedDeduplicationWindow"></a>

```typescript
public resetReplicatedDeduplicationWindow(): void
```

##### `resetReplicatedDeduplicationWindowSeconds` <a name="resetReplicatedDeduplicationWindowSeconds" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.resetReplicatedDeduplicationWindowSeconds"></a>

```typescript
public resetReplicatedDeduplicationWindowSeconds(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPoolInput">maxBytesToMergeAtMinSpaceInPoolInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueueInput">maxReplicatedMergesInQueueInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput">numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsertInput">partsToDelayInsertInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsertInput">partsToThrowInsertInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowInput">replicatedDeduplicationWindowInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSecondsInput">replicatedDeduplicationWindowSecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPool">maxBytesToMergeAtMinSpaceInPool</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueue">maxReplicatedMergesInQueue</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge">numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsert">partsToDelayInsert</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsert">partsToThrowInsert</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindow">replicatedDeduplicationWindow</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSeconds">replicatedDeduplicationWindowSeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxBytesToMergeAtMinSpaceInPoolInput`<sup>Optional</sup> <a name="maxBytesToMergeAtMinSpaceInPoolInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPoolInput"></a>

```typescript
public readonly maxBytesToMergeAtMinSpaceInPoolInput: number;
```

- *Type:* number

---

##### `maxReplicatedMergesInQueueInput`<sup>Optional</sup> <a name="maxReplicatedMergesInQueueInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueueInput"></a>

```typescript
public readonly maxReplicatedMergesInQueueInput: number;
```

- *Type:* number

---

##### `numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput`<sup>Optional</sup> <a name="numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput"></a>

```typescript
public readonly numberOfFreeEntriesInPoolToLowerMaxSizeOfMergeInput: number;
```

- *Type:* number

---

##### `partsToDelayInsertInput`<sup>Optional</sup> <a name="partsToDelayInsertInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsertInput"></a>

```typescript
public readonly partsToDelayInsertInput: number;
```

- *Type:* number

---

##### `partsToThrowInsertInput`<sup>Optional</sup> <a name="partsToThrowInsertInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsertInput"></a>

```typescript
public readonly partsToThrowInsertInput: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindowInput`<sup>Optional</sup> <a name="replicatedDeduplicationWindowInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowInput"></a>

```typescript
public readonly replicatedDeduplicationWindowInput: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindowSecondsInput`<sup>Optional</sup> <a name="replicatedDeduplicationWindowSecondsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSecondsInput"></a>

```typescript
public readonly replicatedDeduplicationWindowSecondsInput: number;
```

- *Type:* number

---

##### `maxBytesToMergeAtMinSpaceInPool`<sup>Required</sup> <a name="maxBytesToMergeAtMinSpaceInPool" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxBytesToMergeAtMinSpaceInPool"></a>

```typescript
public readonly maxBytesToMergeAtMinSpaceInPool: number;
```

- *Type:* number

---

##### `maxReplicatedMergesInQueue`<sup>Required</sup> <a name="maxReplicatedMergesInQueue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.maxReplicatedMergesInQueue"></a>

```typescript
public readonly maxReplicatedMergesInQueue: number;
```

- *Type:* number

---

##### `numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge`<sup>Required</sup> <a name="numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge"></a>

```typescript
public readonly numberOfFreeEntriesInPoolToLowerMaxSizeOfMerge: number;
```

- *Type:* number

---

##### `partsToDelayInsert`<sup>Required</sup> <a name="partsToDelayInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToDelayInsert"></a>

```typescript
public readonly partsToDelayInsert: number;
```

- *Type:* number

---

##### `partsToThrowInsert`<sup>Required</sup> <a name="partsToThrowInsert" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.partsToThrowInsert"></a>

```typescript
public readonly partsToThrowInsert: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindow`<sup>Required</sup> <a name="replicatedDeduplicationWindow" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindow"></a>

```typescript
public readonly replicatedDeduplicationWindow: number;
```

- *Type:* number

---

##### `replicatedDeduplicationWindowSeconds`<sup>Required</sup> <a name="replicatedDeduplicationWindowSeconds" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.replicatedDeduplicationWindowSeconds"></a>

```typescript
public readonly replicatedDeduplicationWindowSeconds: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseConfigMergeTree;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a>

---


### MdbClickhouseClusterClickhouseConfigOutputReference <a name="MdbClickhouseClusterClickhouseConfigOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putCompression">putCompression</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putGraphiteRollup">putGraphiteRollup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafka">putKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafkaTopic">putKafkaTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putMergeTree">putMergeTree</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putRabbitmq">putRabbitmq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetBackgroundPoolSize">resetBackgroundPoolSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetBackgroundSchedulePoolSize">resetBackgroundSchedulePoolSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetCompression">resetCompression</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetGeobaseUri">resetGeobaseUri</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetGraphiteRollup">resetGraphiteRollup</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKafka">resetKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKafkaTopic">resetKafkaTopic</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKeepAliveTimeout">resetKeepAliveTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetLogLevel">resetLogLevel</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMarkCacheSize">resetMarkCacheSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxConcurrentQueries">resetMaxConcurrentQueries</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxConnections">resetMaxConnections</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxPartitionSizeToDrop">resetMaxPartitionSizeToDrop</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxTableSizeToDrop">resetMaxTableSizeToDrop</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMergeTree">resetMergeTree</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogEnabled">resetMetricLogEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogRetentionSize">resetMetricLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogRetentionTime">resetMetricLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetPartLogRetentionSize">resetPartLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetPartLogRetentionTime">resetPartLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryLogRetentionSize">resetQueryLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryLogRetentionTime">resetQueryLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogEnabled">resetQueryThreadLogEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogRetentionSize">resetQueryThreadLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogRetentionTime">resetQueryThreadLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetRabbitmq">resetRabbitmq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogEnabled">resetTextLogEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogLevel">resetTextLogLevel</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogRetentionSize">resetTextLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogRetentionTime">resetTextLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTimezone">resetTimezone</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogEnabled">resetTraceLogEnabled</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogRetentionSize">resetTraceLogRetentionSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogRetentionTime">resetTraceLogRetentionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetUncompressedCacheSize">resetUncompressedCacheSize</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putCompression` <a name="putCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putCompression"></a>

```typescript
public putCompression(value: IResolvable | MdbClickhouseClusterClickhouseConfigCompression[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putCompression.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]

---

##### `putGraphiteRollup` <a name="putGraphiteRollup" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putGraphiteRollup"></a>

```typescript
public putGraphiteRollup(value: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putGraphiteRollup.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]

---

##### `putKafka` <a name="putKafka" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafka"></a>

```typescript
public putKafka(value: MdbClickhouseClusterClickhouseConfigKafka): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafka.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a>

---

##### `putKafkaTopic` <a name="putKafkaTopic" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafkaTopic"></a>

```typescript
public putKafkaTopic(value: IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putKafkaTopic.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]

---

##### `putMergeTree` <a name="putMergeTree" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putMergeTree"></a>

```typescript
public putMergeTree(value: MdbClickhouseClusterClickhouseConfigMergeTree): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putMergeTree.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a>

---

##### `putRabbitmq` <a name="putRabbitmq" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putRabbitmq"></a>

```typescript
public putRabbitmq(value: MdbClickhouseClusterClickhouseConfigRabbitmq): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.putRabbitmq.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a>

---

##### `resetBackgroundPoolSize` <a name="resetBackgroundPoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetBackgroundPoolSize"></a>

```typescript
public resetBackgroundPoolSize(): void
```

##### `resetBackgroundSchedulePoolSize` <a name="resetBackgroundSchedulePoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetBackgroundSchedulePoolSize"></a>

```typescript
public resetBackgroundSchedulePoolSize(): void
```

##### `resetCompression` <a name="resetCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetCompression"></a>

```typescript
public resetCompression(): void
```

##### `resetGeobaseUri` <a name="resetGeobaseUri" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetGeobaseUri"></a>

```typescript
public resetGeobaseUri(): void
```

##### `resetGraphiteRollup` <a name="resetGraphiteRollup" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetGraphiteRollup"></a>

```typescript
public resetGraphiteRollup(): void
```

##### `resetKafka` <a name="resetKafka" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKafka"></a>

```typescript
public resetKafka(): void
```

##### `resetKafkaTopic` <a name="resetKafkaTopic" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKafkaTopic"></a>

```typescript
public resetKafkaTopic(): void
```

##### `resetKeepAliveTimeout` <a name="resetKeepAliveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetKeepAliveTimeout"></a>

```typescript
public resetKeepAliveTimeout(): void
```

##### `resetLogLevel` <a name="resetLogLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetLogLevel"></a>

```typescript
public resetLogLevel(): void
```

##### `resetMarkCacheSize` <a name="resetMarkCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMarkCacheSize"></a>

```typescript
public resetMarkCacheSize(): void
```

##### `resetMaxConcurrentQueries` <a name="resetMaxConcurrentQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxConcurrentQueries"></a>

```typescript
public resetMaxConcurrentQueries(): void
```

##### `resetMaxConnections` <a name="resetMaxConnections" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxConnections"></a>

```typescript
public resetMaxConnections(): void
```

##### `resetMaxPartitionSizeToDrop` <a name="resetMaxPartitionSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxPartitionSizeToDrop"></a>

```typescript
public resetMaxPartitionSizeToDrop(): void
```

##### `resetMaxTableSizeToDrop` <a name="resetMaxTableSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMaxTableSizeToDrop"></a>

```typescript
public resetMaxTableSizeToDrop(): void
```

##### `resetMergeTree` <a name="resetMergeTree" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMergeTree"></a>

```typescript
public resetMergeTree(): void
```

##### `resetMetricLogEnabled` <a name="resetMetricLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogEnabled"></a>

```typescript
public resetMetricLogEnabled(): void
```

##### `resetMetricLogRetentionSize` <a name="resetMetricLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogRetentionSize"></a>

```typescript
public resetMetricLogRetentionSize(): void
```

##### `resetMetricLogRetentionTime` <a name="resetMetricLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetMetricLogRetentionTime"></a>

```typescript
public resetMetricLogRetentionTime(): void
```

##### `resetPartLogRetentionSize` <a name="resetPartLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetPartLogRetentionSize"></a>

```typescript
public resetPartLogRetentionSize(): void
```

##### `resetPartLogRetentionTime` <a name="resetPartLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetPartLogRetentionTime"></a>

```typescript
public resetPartLogRetentionTime(): void
```

##### `resetQueryLogRetentionSize` <a name="resetQueryLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryLogRetentionSize"></a>

```typescript
public resetQueryLogRetentionSize(): void
```

##### `resetQueryLogRetentionTime` <a name="resetQueryLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryLogRetentionTime"></a>

```typescript
public resetQueryLogRetentionTime(): void
```

##### `resetQueryThreadLogEnabled` <a name="resetQueryThreadLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogEnabled"></a>

```typescript
public resetQueryThreadLogEnabled(): void
```

##### `resetQueryThreadLogRetentionSize` <a name="resetQueryThreadLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogRetentionSize"></a>

```typescript
public resetQueryThreadLogRetentionSize(): void
```

##### `resetQueryThreadLogRetentionTime` <a name="resetQueryThreadLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetQueryThreadLogRetentionTime"></a>

```typescript
public resetQueryThreadLogRetentionTime(): void
```

##### `resetRabbitmq` <a name="resetRabbitmq" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetRabbitmq"></a>

```typescript
public resetRabbitmq(): void
```

##### `resetTextLogEnabled` <a name="resetTextLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogEnabled"></a>

```typescript
public resetTextLogEnabled(): void
```

##### `resetTextLogLevel` <a name="resetTextLogLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogLevel"></a>

```typescript
public resetTextLogLevel(): void
```

##### `resetTextLogRetentionSize` <a name="resetTextLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogRetentionSize"></a>

```typescript
public resetTextLogRetentionSize(): void
```

##### `resetTextLogRetentionTime` <a name="resetTextLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTextLogRetentionTime"></a>

```typescript
public resetTextLogRetentionTime(): void
```

##### `resetTimezone` <a name="resetTimezone" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTimezone"></a>

```typescript
public resetTimezone(): void
```

##### `resetTraceLogEnabled` <a name="resetTraceLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogEnabled"></a>

```typescript
public resetTraceLogEnabled(): void
```

##### `resetTraceLogRetentionSize` <a name="resetTraceLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogRetentionSize"></a>

```typescript
public resetTraceLogRetentionSize(): void
```

##### `resetTraceLogRetentionTime` <a name="resetTraceLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetTraceLogRetentionTime"></a>

```typescript
public resetTraceLogRetentionTime(): void
```

##### `resetUncompressedCacheSize` <a name="resetUncompressedCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.resetUncompressedCacheSize"></a>

```typescript
public resetUncompressedCacheSize(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.compression">compression</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList">MdbClickhouseClusterClickhouseConfigCompressionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollup">graphiteRollup</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList">MdbClickhouseClusterClickhouseConfigGraphiteRollupList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference">MdbClickhouseClusterClickhouseConfigKafkaOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopic">kafkaTopic</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList">MdbClickhouseClusterClickhouseConfigKafkaTopicList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTree">mergeTree</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference">MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmq">rabbitmq</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference">MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSizeInput">backgroundPoolSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSizeInput">backgroundSchedulePoolSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.compressionInput">compressionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUriInput">geobaseUriInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollupInput">graphiteRollupInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaInput">kafkaInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopicInput">kafkaTopicInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeoutInput">keepAliveTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.logLevelInput">logLevelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSizeInput">markCacheSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueriesInput">maxConcurrentQueriesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnectionsInput">maxConnectionsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDropInput">maxPartitionSizeToDropInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDropInput">maxTableSizeToDropInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTreeInput">mergeTreeInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabledInput">metricLogEnabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSizeInput">metricLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTimeInput">metricLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSizeInput">partLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTimeInput">partLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSizeInput">queryLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTimeInput">queryLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabledInput">queryThreadLogEnabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSizeInput">queryThreadLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTimeInput">queryThreadLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmqInput">rabbitmqInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabledInput">textLogEnabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevelInput">textLogLevelInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSizeInput">textLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTimeInput">textLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.timezoneInput">timezoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabledInput">traceLogEnabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSizeInput">traceLogRetentionSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTimeInput">traceLogRetentionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSizeInput">uncompressedCacheSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSize">backgroundPoolSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSize">backgroundSchedulePoolSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUri">geobaseUri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeout">keepAliveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.logLevel">logLevel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSize">markCacheSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueries">maxConcurrentQueries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnections">maxConnections</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDrop">maxPartitionSizeToDrop</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDrop">maxTableSizeToDrop</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabled">metricLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSize">metricLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTime">metricLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSize">partLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTime">partLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSize">queryLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTime">queryLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabled">queryThreadLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSize">queryThreadLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTime">queryThreadLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabled">textLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevel">textLogLevel</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSize">textLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTime">textLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.timezone">timezone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabled">traceLogEnabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSize">traceLogRetentionSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTime">traceLogRetentionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSize">uncompressedCacheSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `compression`<sup>Required</sup> <a name="compression" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.compression"></a>

```typescript
public readonly compression: MdbClickhouseClusterClickhouseConfigCompressionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompressionList">MdbClickhouseClusterClickhouseConfigCompressionList</a>

---

##### `graphiteRollup`<sup>Required</sup> <a name="graphiteRollup" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollup"></a>

```typescript
public readonly graphiteRollup: MdbClickhouseClusterClickhouseConfigGraphiteRollupList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollupList">MdbClickhouseClusterClickhouseConfigGraphiteRollupList</a>

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafka"></a>

```typescript
public readonly kafka: MdbClickhouseClusterClickhouseConfigKafkaOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaOutputReference">MdbClickhouseClusterClickhouseConfigKafkaOutputReference</a>

---

##### `kafkaTopic`<sup>Required</sup> <a name="kafkaTopic" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopic"></a>

```typescript
public readonly kafkaTopic: MdbClickhouseClusterClickhouseConfigKafkaTopicList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopicList">MdbClickhouseClusterClickhouseConfigKafkaTopicList</a>

---

##### `mergeTree`<sup>Required</sup> <a name="mergeTree" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTree"></a>

```typescript
public readonly mergeTree: MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference">MdbClickhouseClusterClickhouseConfigMergeTreeOutputReference</a>

---

##### `rabbitmq`<sup>Required</sup> <a name="rabbitmq" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmq"></a>

```typescript
public readonly rabbitmq: MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference">MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference</a>

---

##### `backgroundPoolSizeInput`<sup>Optional</sup> <a name="backgroundPoolSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSizeInput"></a>

```typescript
public readonly backgroundPoolSizeInput: number;
```

- *Type:* number

---

##### `backgroundSchedulePoolSizeInput`<sup>Optional</sup> <a name="backgroundSchedulePoolSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSizeInput"></a>

```typescript
public readonly backgroundSchedulePoolSizeInput: number;
```

- *Type:* number

---

##### `compressionInput`<sup>Optional</sup> <a name="compressionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.compressionInput"></a>

```typescript
public readonly compressionInput: IResolvable | MdbClickhouseClusterClickhouseConfigCompression[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigCompression">MdbClickhouseClusterClickhouseConfigCompression</a>[]

---

##### `geobaseUriInput`<sup>Optional</sup> <a name="geobaseUriInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUriInput"></a>

```typescript
public readonly geobaseUriInput: string;
```

- *Type:* string

---

##### `graphiteRollupInput`<sup>Optional</sup> <a name="graphiteRollupInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.graphiteRollupInput"></a>

```typescript
public readonly graphiteRollupInput: IResolvable | MdbClickhouseClusterClickhouseConfigGraphiteRollup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigGraphiteRollup">MdbClickhouseClusterClickhouseConfigGraphiteRollup</a>[]

---

##### `kafkaInput`<sup>Optional</sup> <a name="kafkaInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaInput"></a>

```typescript
public readonly kafkaInput: MdbClickhouseClusterClickhouseConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafka">MdbClickhouseClusterClickhouseConfigKafka</a>

---

##### `kafkaTopicInput`<sup>Optional</sup> <a name="kafkaTopicInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.kafkaTopicInput"></a>

```typescript
public readonly kafkaTopicInput: IResolvable | MdbClickhouseClusterClickhouseConfigKafkaTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigKafkaTopic">MdbClickhouseClusterClickhouseConfigKafkaTopic</a>[]

---

##### `keepAliveTimeoutInput`<sup>Optional</sup> <a name="keepAliveTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeoutInput"></a>

```typescript
public readonly keepAliveTimeoutInput: number;
```

- *Type:* number

---

##### `logLevelInput`<sup>Optional</sup> <a name="logLevelInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.logLevelInput"></a>

```typescript
public readonly logLevelInput: string;
```

- *Type:* string

---

##### `markCacheSizeInput`<sup>Optional</sup> <a name="markCacheSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSizeInput"></a>

```typescript
public readonly markCacheSizeInput: number;
```

- *Type:* number

---

##### `maxConcurrentQueriesInput`<sup>Optional</sup> <a name="maxConcurrentQueriesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueriesInput"></a>

```typescript
public readonly maxConcurrentQueriesInput: number;
```

- *Type:* number

---

##### `maxConnectionsInput`<sup>Optional</sup> <a name="maxConnectionsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnectionsInput"></a>

```typescript
public readonly maxConnectionsInput: number;
```

- *Type:* number

---

##### `maxPartitionSizeToDropInput`<sup>Optional</sup> <a name="maxPartitionSizeToDropInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDropInput"></a>

```typescript
public readonly maxPartitionSizeToDropInput: number;
```

- *Type:* number

---

##### `maxTableSizeToDropInput`<sup>Optional</sup> <a name="maxTableSizeToDropInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDropInput"></a>

```typescript
public readonly maxTableSizeToDropInput: number;
```

- *Type:* number

---

##### `mergeTreeInput`<sup>Optional</sup> <a name="mergeTreeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.mergeTreeInput"></a>

```typescript
public readonly mergeTreeInput: MdbClickhouseClusterClickhouseConfigMergeTree;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigMergeTree">MdbClickhouseClusterClickhouseConfigMergeTree</a>

---

##### `metricLogEnabledInput`<sup>Optional</sup> <a name="metricLogEnabledInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabledInput"></a>

```typescript
public readonly metricLogEnabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `metricLogRetentionSizeInput`<sup>Optional</sup> <a name="metricLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSizeInput"></a>

```typescript
public readonly metricLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `metricLogRetentionTimeInput`<sup>Optional</sup> <a name="metricLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTimeInput"></a>

```typescript
public readonly metricLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `partLogRetentionSizeInput`<sup>Optional</sup> <a name="partLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSizeInput"></a>

```typescript
public readonly partLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `partLogRetentionTimeInput`<sup>Optional</sup> <a name="partLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTimeInput"></a>

```typescript
public readonly partLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `queryLogRetentionSizeInput`<sup>Optional</sup> <a name="queryLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSizeInput"></a>

```typescript
public readonly queryLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `queryLogRetentionTimeInput`<sup>Optional</sup> <a name="queryLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTimeInput"></a>

```typescript
public readonly queryLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `queryThreadLogEnabledInput`<sup>Optional</sup> <a name="queryThreadLogEnabledInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabledInput"></a>

```typescript
public readonly queryThreadLogEnabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryThreadLogRetentionSizeInput`<sup>Optional</sup> <a name="queryThreadLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSizeInput"></a>

```typescript
public readonly queryThreadLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `queryThreadLogRetentionTimeInput`<sup>Optional</sup> <a name="queryThreadLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTimeInput"></a>

```typescript
public readonly queryThreadLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `rabbitmqInput`<sup>Optional</sup> <a name="rabbitmqInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.rabbitmqInput"></a>

```typescript
public readonly rabbitmqInput: MdbClickhouseClusterClickhouseConfigRabbitmq;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a>

---

##### `textLogEnabledInput`<sup>Optional</sup> <a name="textLogEnabledInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabledInput"></a>

```typescript
public readonly textLogEnabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `textLogLevelInput`<sup>Optional</sup> <a name="textLogLevelInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevelInput"></a>

```typescript
public readonly textLogLevelInput: string;
```

- *Type:* string

---

##### `textLogRetentionSizeInput`<sup>Optional</sup> <a name="textLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSizeInput"></a>

```typescript
public readonly textLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `textLogRetentionTimeInput`<sup>Optional</sup> <a name="textLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTimeInput"></a>

```typescript
public readonly textLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `timezoneInput`<sup>Optional</sup> <a name="timezoneInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.timezoneInput"></a>

```typescript
public readonly timezoneInput: string;
```

- *Type:* string

---

##### `traceLogEnabledInput`<sup>Optional</sup> <a name="traceLogEnabledInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabledInput"></a>

```typescript
public readonly traceLogEnabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `traceLogRetentionSizeInput`<sup>Optional</sup> <a name="traceLogRetentionSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSizeInput"></a>

```typescript
public readonly traceLogRetentionSizeInput: number;
```

- *Type:* number

---

##### `traceLogRetentionTimeInput`<sup>Optional</sup> <a name="traceLogRetentionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTimeInput"></a>

```typescript
public readonly traceLogRetentionTimeInput: number;
```

- *Type:* number

---

##### `uncompressedCacheSizeInput`<sup>Optional</sup> <a name="uncompressedCacheSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSizeInput"></a>

```typescript
public readonly uncompressedCacheSizeInput: number;
```

- *Type:* number

---

##### `backgroundPoolSize`<sup>Required</sup> <a name="backgroundPoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundPoolSize"></a>

```typescript
public readonly backgroundPoolSize: number;
```

- *Type:* number

---

##### `backgroundSchedulePoolSize`<sup>Required</sup> <a name="backgroundSchedulePoolSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.backgroundSchedulePoolSize"></a>

```typescript
public readonly backgroundSchedulePoolSize: number;
```

- *Type:* number

---

##### `geobaseUri`<sup>Required</sup> <a name="geobaseUri" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.geobaseUri"></a>

```typescript
public readonly geobaseUri: string;
```

- *Type:* string

---

##### `keepAliveTimeout`<sup>Required</sup> <a name="keepAliveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.keepAliveTimeout"></a>

```typescript
public readonly keepAliveTimeout: number;
```

- *Type:* number

---

##### `logLevel`<sup>Required</sup> <a name="logLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.logLevel"></a>

```typescript
public readonly logLevel: string;
```

- *Type:* string

---

##### `markCacheSize`<sup>Required</sup> <a name="markCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.markCacheSize"></a>

```typescript
public readonly markCacheSize: number;
```

- *Type:* number

---

##### `maxConcurrentQueries`<sup>Required</sup> <a name="maxConcurrentQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConcurrentQueries"></a>

```typescript
public readonly maxConcurrentQueries: number;
```

- *Type:* number

---

##### `maxConnections`<sup>Required</sup> <a name="maxConnections" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxConnections"></a>

```typescript
public readonly maxConnections: number;
```

- *Type:* number

---

##### `maxPartitionSizeToDrop`<sup>Required</sup> <a name="maxPartitionSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxPartitionSizeToDrop"></a>

```typescript
public readonly maxPartitionSizeToDrop: number;
```

- *Type:* number

---

##### `maxTableSizeToDrop`<sup>Required</sup> <a name="maxTableSizeToDrop" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.maxTableSizeToDrop"></a>

```typescript
public readonly maxTableSizeToDrop: number;
```

- *Type:* number

---

##### `metricLogEnabled`<sup>Required</sup> <a name="metricLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogEnabled"></a>

```typescript
public readonly metricLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `metricLogRetentionSize`<sup>Required</sup> <a name="metricLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionSize"></a>

```typescript
public readonly metricLogRetentionSize: number;
```

- *Type:* number

---

##### `metricLogRetentionTime`<sup>Required</sup> <a name="metricLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.metricLogRetentionTime"></a>

```typescript
public readonly metricLogRetentionTime: number;
```

- *Type:* number

---

##### `partLogRetentionSize`<sup>Required</sup> <a name="partLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionSize"></a>

```typescript
public readonly partLogRetentionSize: number;
```

- *Type:* number

---

##### `partLogRetentionTime`<sup>Required</sup> <a name="partLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.partLogRetentionTime"></a>

```typescript
public readonly partLogRetentionTime: number;
```

- *Type:* number

---

##### `queryLogRetentionSize`<sup>Required</sup> <a name="queryLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionSize"></a>

```typescript
public readonly queryLogRetentionSize: number;
```

- *Type:* number

---

##### `queryLogRetentionTime`<sup>Required</sup> <a name="queryLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryLogRetentionTime"></a>

```typescript
public readonly queryLogRetentionTime: number;
```

- *Type:* number

---

##### `queryThreadLogEnabled`<sup>Required</sup> <a name="queryThreadLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogEnabled"></a>

```typescript
public readonly queryThreadLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `queryThreadLogRetentionSize`<sup>Required</sup> <a name="queryThreadLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionSize"></a>

```typescript
public readonly queryThreadLogRetentionSize: number;
```

- *Type:* number

---

##### `queryThreadLogRetentionTime`<sup>Required</sup> <a name="queryThreadLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.queryThreadLogRetentionTime"></a>

```typescript
public readonly queryThreadLogRetentionTime: number;
```

- *Type:* number

---

##### `textLogEnabled`<sup>Required</sup> <a name="textLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogEnabled"></a>

```typescript
public readonly textLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `textLogLevel`<sup>Required</sup> <a name="textLogLevel" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogLevel"></a>

```typescript
public readonly textLogLevel: string;
```

- *Type:* string

---

##### `textLogRetentionSize`<sup>Required</sup> <a name="textLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionSize"></a>

```typescript
public readonly textLogRetentionSize: number;
```

- *Type:* number

---

##### `textLogRetentionTime`<sup>Required</sup> <a name="textLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.textLogRetentionTime"></a>

```typescript
public readonly textLogRetentionTime: number;
```

- *Type:* number

---

##### `timezone`<sup>Required</sup> <a name="timezone" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.timezone"></a>

```typescript
public readonly timezone: string;
```

- *Type:* string

---

##### `traceLogEnabled`<sup>Required</sup> <a name="traceLogEnabled" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogEnabled"></a>

```typescript
public readonly traceLogEnabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `traceLogRetentionSize`<sup>Required</sup> <a name="traceLogRetentionSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionSize"></a>

```typescript
public readonly traceLogRetentionSize: number;
```

- *Type:* number

---

##### `traceLogRetentionTime`<sup>Required</sup> <a name="traceLogRetentionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.traceLogRetentionTime"></a>

```typescript
public readonly traceLogRetentionTime: number;
```

- *Type:* number

---

##### `uncompressedCacheSize`<sup>Required</sup> <a name="uncompressedCacheSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.uncompressedCacheSize"></a>

```typescript
public readonly uncompressedCacheSize: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a>

---


### MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference <a name="MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resetPassword">resetPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resetUsername">resetUsername</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPassword` <a name="resetPassword" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resetPassword"></a>

```typescript
public resetPassword(): void
```

##### `resetUsername` <a name="resetUsername" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.resetUsername"></a>

```typescript
public resetUsername(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.usernameInput">usernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.username">username</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `usernameInput`<sup>Optional</sup> <a name="usernameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.usernameInput"></a>

```typescript
public readonly usernameInput: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `username`<sup>Required</sup> <a name="username" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmqOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseConfigRabbitmq;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigRabbitmq">MdbClickhouseClusterClickhouseConfigRabbitmq</a>

---


### MdbClickhouseClusterClickhouseOutputReference <a name="MdbClickhouseClusterClickhouseOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putConfig">putConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.resetConfig">resetConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConfig` <a name="putConfig" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putConfig"></a>

```typescript
public putConfig(value: MdbClickhouseClusterClickhouseConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putResources"></a>

```typescript
public putResources(value: MdbClickhouseClusterClickhouseResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a>

---

##### `resetConfig` <a name="resetConfig" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.resetConfig"></a>

```typescript
public resetConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.config">config</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference">MdbClickhouseClusterClickhouseConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference">MdbClickhouseClusterClickhouseResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.configInput">configInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `config`<sup>Required</sup> <a name="config" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.config"></a>

```typescript
public readonly config: MdbClickhouseClusterClickhouseConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfigOutputReference">MdbClickhouseClusterClickhouseConfigOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbClickhouseClusterClickhouseResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference">MdbClickhouseClusterClickhouseResourcesOutputReference</a>

---

##### `configInput`<sup>Optional</sup> <a name="configInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.configInput"></a>

```typescript
public readonly configInput: MdbClickhouseClusterClickhouseConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseConfig">MdbClickhouseClusterClickhouseConfig</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbClickhouseClusterClickhouseResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouse;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouse">MdbClickhouseClusterClickhouse</a>

---


### MdbClickhouseClusterClickhouseResourcesOutputReference <a name="MdbClickhouseClusterClickhouseResourcesOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterClickhouseResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterClickhouseResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterClickhouseResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterClickhouseResources">MdbClickhouseClusterClickhouseResources</a>

---


### MdbClickhouseClusterCloudStorageOutputReference <a name="MdbClickhouseClusterCloudStorageOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterCloudStorageOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterCloudStorageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterCloudStorageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterCloudStorage;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterCloudStorage">MdbClickhouseClusterCloudStorage</a>

---


### MdbClickhouseClusterDatabaseList <a name="MdbClickhouseClusterDatabaseList" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer"></a>

```typescript
import { MdbClickhouseClusterDatabaseList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>[]

---


### MdbClickhouseClusterDatabaseOutputReference <a name="MdbClickhouseClusterDatabaseOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterDatabase;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterDatabase">MdbClickhouseClusterDatabase</a>

---


### MdbClickhouseClusterFormatSchemaList <a name="MdbClickhouseClusterFormatSchemaList" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer"></a>

```typescript
import { MdbClickhouseClusterFormatSchemaList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterFormatSchemaList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterFormatSchemaOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterFormatSchema[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>[]

---


### MdbClickhouseClusterFormatSchemaOutputReference <a name="MdbClickhouseClusterFormatSchemaOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterFormatSchemaOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterFormatSchemaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.uriInput">uriInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.uri">uri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `uriInput`<sup>Optional</sup> <a name="uriInput" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.uriInput"></a>

```typescript
public readonly uriInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterFormatSchemaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterFormatSchema;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterFormatSchema">MdbClickhouseClusterFormatSchema</a>

---


### MdbClickhouseClusterHostList <a name="MdbClickhouseClusterHostList" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer"></a>

```typescript
import { MdbClickhouseClusterHostList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>[]

---


### MdbClickhouseClusterHostOutputReference <a name="MdbClickhouseClusterHostOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetShardName">resetShardName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetShardName` <a name="resetShardName" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetShardName"></a>

```typescript
public resetShardName(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.shardNameInput">shardNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `shardNameInput`<sup>Optional</sup> <a name="shardNameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.shardNameInput"></a>

```typescript
public readonly shardNameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterHost">MdbClickhouseClusterHost</a>

---


### MdbClickhouseClusterMaintenanceWindowOutputReference <a name="MdbClickhouseClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMaintenanceWindow">MdbClickhouseClusterMaintenanceWindow</a>

---


### MdbClickhouseClusterMlModelList <a name="MdbClickhouseClusterMlModelList" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer"></a>

```typescript
import { MdbClickhouseClusterMlModelList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterMlModelList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterMlModelOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterMlModel[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>[]

---


### MdbClickhouseClusterMlModelOutputReference <a name="MdbClickhouseClusterMlModelOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterMlModelOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterMlModelOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.uriInput">uriInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.uri">uri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `uriInput`<sup>Optional</sup> <a name="uriInput" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.uriInput"></a>

```typescript
public readonly uriInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterMlModelOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterMlModel;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterMlModel">MdbClickhouseClusterMlModel</a>

---


### MdbClickhouseClusterShardGroupList <a name="MdbClickhouseClusterShardGroupList" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer"></a>

```typescript
import { MdbClickhouseClusterShardGroupList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterShardGroupList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterShardGroupOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterShardGroup[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>[]

---


### MdbClickhouseClusterShardGroupOutputReference <a name="MdbClickhouseClusterShardGroupOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterShardGroupOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterShardGroupOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.resetDescription">resetDescription</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.shardNamesInput">shardNamesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.shardNames">shardNames</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `shardNamesInput`<sup>Optional</sup> <a name="shardNamesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.shardNamesInput"></a>

```typescript
public readonly shardNamesInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `shardNames`<sup>Required</sup> <a name="shardNames" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.shardNames"></a>

```typescript
public readonly shardNames: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterShardGroupOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterShardGroup;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterShardGroup">MdbClickhouseClusterShardGroup</a>

---


### MdbClickhouseClusterTimeoutsOutputReference <a name="MdbClickhouseClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterTimeouts">MdbClickhouseClusterTimeouts</a>

---


### MdbClickhouseClusterUserList <a name="MdbClickhouseClusterUserList" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>[]

---


### MdbClickhouseClusterUserOutputReference <a name="MdbClickhouseClusterUserOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putQuota">putQuota</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putSettings">putSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetQuota">resetQuota</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetSettings">resetSettings</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbClickhouseClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]

---

##### `putQuota` <a name="putQuota" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putQuota"></a>

```typescript
public putQuota(value: IResolvable | MdbClickhouseClusterUserQuota[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putQuota.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]

---

##### `putSettings` <a name="putSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putSettings"></a>

```typescript
public putSettings(value: MdbClickhouseClusterUserSettings): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.putSettings.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a>

---

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```

##### `resetQuota` <a name="resetQuota" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetQuota"></a>

```typescript
public resetQuota(): void
```

##### `resetSettings` <a name="resetSettings" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.resetSettings"></a>

```typescript
public resetSettings(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList">MdbClickhouseClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.quota">quota</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList">MdbClickhouseClusterUserQuotaList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.settings">settings</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference">MdbClickhouseClusterUserSettingsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.quotaInput">quotaInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.settingsInput">settingsInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbClickhouseClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList">MdbClickhouseClusterUserPermissionList</a>

---

##### `quota`<sup>Required</sup> <a name="quota" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.quota"></a>

```typescript
public readonly quota: MdbClickhouseClusterUserQuotaList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList">MdbClickhouseClusterUserQuotaList</a>

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.settings"></a>

```typescript
public readonly settings: MdbClickhouseClusterUserSettingsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference">MdbClickhouseClusterUserSettingsOutputReference</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbClickhouseClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]

---

##### `quotaInput`<sup>Optional</sup> <a name="quotaInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.quotaInput"></a>

```typescript
public readonly quotaInput: IResolvable | MdbClickhouseClusterUserQuota[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]

---

##### `settingsInput`<sup>Optional</sup> <a name="settingsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.settingsInput"></a>

```typescript
public readonly settingsInput: MdbClickhouseClusterUserSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUser">MdbClickhouseClusterUser</a>

---


### MdbClickhouseClusterUserPermissionList <a name="MdbClickhouseClusterUserPermissionList" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>[]

---


### MdbClickhouseClusterUserPermissionOutputReference <a name="MdbClickhouseClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.databaseNameInput">databaseNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseNameInput`<sup>Optional</sup> <a name="databaseNameInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserPermission">MdbClickhouseClusterUserPermission</a>

---


### MdbClickhouseClusterUserQuotaList <a name="MdbClickhouseClusterUserQuotaList" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserQuotaList } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserQuotaList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.get"></a>

```typescript
public get(index: number): MdbClickhouseClusterUserQuotaOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUserQuota[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>[]

---


### MdbClickhouseClusterUserQuotaOutputReference <a name="MdbClickhouseClusterUserQuotaOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserQuotaOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserQuotaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetErrors">resetErrors</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetExecutionTime">resetExecutionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetQueries">resetQueries</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetReadRows">resetReadRows</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetResultRows">resetResultRows</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetErrors` <a name="resetErrors" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetErrors"></a>

```typescript
public resetErrors(): void
```

##### `resetExecutionTime` <a name="resetExecutionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetExecutionTime"></a>

```typescript
public resetExecutionTime(): void
```

##### `resetQueries` <a name="resetQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetQueries"></a>

```typescript
public resetQueries(): void
```

##### `resetReadRows` <a name="resetReadRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetReadRows"></a>

```typescript
public resetReadRows(): void
```

##### `resetResultRows` <a name="resetResultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.resetResultRows"></a>

```typescript
public resetResultRows(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.errorsInput">errorsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.executionTimeInput">executionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.intervalDurationInput">intervalDurationInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.queriesInput">queriesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.readRowsInput">readRowsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.resultRowsInput">resultRowsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.errors">errors</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.executionTime">executionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.intervalDuration">intervalDuration</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.queries">queries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.readRows">readRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.resultRows">resultRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `errorsInput`<sup>Optional</sup> <a name="errorsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.errorsInput"></a>

```typescript
public readonly errorsInput: number;
```

- *Type:* number

---

##### `executionTimeInput`<sup>Optional</sup> <a name="executionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.executionTimeInput"></a>

```typescript
public readonly executionTimeInput: number;
```

- *Type:* number

---

##### `intervalDurationInput`<sup>Optional</sup> <a name="intervalDurationInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.intervalDurationInput"></a>

```typescript
public readonly intervalDurationInput: number;
```

- *Type:* number

---

##### `queriesInput`<sup>Optional</sup> <a name="queriesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.queriesInput"></a>

```typescript
public readonly queriesInput: number;
```

- *Type:* number

---

##### `readRowsInput`<sup>Optional</sup> <a name="readRowsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.readRowsInput"></a>

```typescript
public readonly readRowsInput: number;
```

- *Type:* number

---

##### `resultRowsInput`<sup>Optional</sup> <a name="resultRowsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.resultRowsInput"></a>

```typescript
public readonly resultRowsInput: number;
```

- *Type:* number

---

##### `errors`<sup>Required</sup> <a name="errors" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.errors"></a>

```typescript
public readonly errors: number;
```

- *Type:* number

---

##### `executionTime`<sup>Required</sup> <a name="executionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.executionTime"></a>

```typescript
public readonly executionTime: number;
```

- *Type:* number

---

##### `intervalDuration`<sup>Required</sup> <a name="intervalDuration" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.intervalDuration"></a>

```typescript
public readonly intervalDuration: number;
```

- *Type:* number

---

##### `queries`<sup>Required</sup> <a name="queries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.queries"></a>

```typescript
public readonly queries: number;
```

- *Type:* number

---

##### `readRows`<sup>Required</sup> <a name="readRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.readRows"></a>

```typescript
public readonly readRows: number;
```

- *Type:* number

---

##### `resultRows`<sup>Required</sup> <a name="resultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.resultRows"></a>

```typescript
public readonly resultRows: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserQuotaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbClickhouseClusterUserQuota;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserQuota">MdbClickhouseClusterUserQuota</a>

---


### MdbClickhouseClusterUserSettingsOutputReference <a name="MdbClickhouseClusterUserSettingsOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterUserSettingsOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterUserSettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetAddHttpCorsHeader">resetAddHttpCorsHeader</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetAllowDdl">resetAllowDdl</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCompile">resetCompile</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCompileExpressions">resetCompileExpressions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetConnectTimeout">resetConnectTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCountDistinctImplementation">resetCountDistinctImplementation</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistinctOverflowMode">resetDistinctOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedAggregationMemoryEfficient">resetDistributedAggregationMemoryEfficient</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedDdlTaskTimeout">resetDistributedDdlTaskTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedProductMode">resetDistributedProductMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetEmptyResultForAggregationByEmptySet">resetEmptyResultForAggregationByEmptySet</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetEnableHttpCompression">resetEnableHttpCompression</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetFallbackToStaleReplicasForDistributedQueries">resetFallbackToStaleReplicasForDistributedQueries</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetForceIndexByDate">resetForceIndexByDate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetForcePrimaryKey">resetForcePrimaryKey</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByOverflowMode">resetGroupByOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByTwoLevelThreshold">resetGroupByTwoLevelThreshold</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByTwoLevelThresholdBytes">resetGroupByTwoLevelThresholdBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpConnectionTimeout">resetHttpConnectionTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpHeadersProgressInterval">resetHttpHeadersProgressInterval</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpReceiveTimeout">resetHttpReceiveTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpSendTimeout">resetHttpSendTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInputFormatDefaultsForOmittedFields">resetInputFormatDefaultsForOmittedFields</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInputFormatValuesInterpretExpressions">resetInputFormatValuesInterpretExpressions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInsertQuorum">resetInsertQuorum</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInsertQuorumTimeout">resetInsertQuorumTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinedSubqueryRequiresAlias">resetJoinedSubqueryRequiresAlias</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinOverflowMode">resetJoinOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinUseNulls">resetJoinUseNulls</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetLowCardinalityAllowInNativeFormat">resetLowCardinalityAllowInNativeFormat</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxAstDepth">resetMaxAstDepth</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxAstElements">resetMaxAstElements</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBlockSize">resetMaxBlockSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesBeforeExternalGroupBy">resetMaxBytesBeforeExternalGroupBy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesBeforeExternalSort">resetMaxBytesBeforeExternalSort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInDistinct">resetMaxBytesInDistinct</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInJoin">resetMaxBytesInJoin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInSet">resetMaxBytesInSet</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToRead">resetMaxBytesToRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToSort">resetMaxBytesToSort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToTransfer">resetMaxBytesToTransfer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxColumnsToRead">resetMaxColumnsToRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxExecutionTime">resetMaxExecutionTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxExpandedAstElements">resetMaxExpandedAstElements</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxInsertBlockSize">resetMaxInsertBlockSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxMemoryUsage">resetMaxMemoryUsage</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxMemoryUsageForUser">resetMaxMemoryUsageForUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxNetworkBandwidth">resetMaxNetworkBandwidth</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxNetworkBandwidthForUser">resetMaxNetworkBandwidthForUser</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxQuerySize">resetMaxQuerySize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxReplicaDelayForDistributedQueries">resetMaxReplicaDelayForDistributedQueries</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxResultBytes">resetMaxResultBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxResultRows">resetMaxResultRows</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInDistinct">resetMaxRowsInDistinct</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInJoin">resetMaxRowsInJoin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInSet">resetMaxRowsInSet</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToGroupBy">resetMaxRowsToGroupBy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToRead">resetMaxRowsToRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToSort">resetMaxRowsToSort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToTransfer">resetMaxRowsToTransfer</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxTemporaryColumns">resetMaxTemporaryColumns</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxTemporaryNonConstColumns">resetMaxTemporaryNonConstColumns</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxThreads">resetMaxThreads</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMaxBytesToUseCache">resetMergeTreeMaxBytesToUseCache</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMaxRowsToUseCache">resetMergeTreeMaxRowsToUseCache</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMinBytesForConcurrentRead">resetMergeTreeMinBytesForConcurrentRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMinRowsForConcurrentRead">resetMergeTreeMinRowsForConcurrentRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinBytesToUseDirectIo">resetMinBytesToUseDirectIo</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinCountToCompile">resetMinCountToCompile</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinCountToCompileExpression">resetMinCountToCompileExpression</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinExecutionSpeed">resetMinExecutionSpeed</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinExecutionSpeedBytes">resetMinExecutionSpeedBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinInsertBlockSizeBytes">resetMinInsertBlockSizeBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinInsertBlockSizeRows">resetMinInsertBlockSizeRows</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetOutputFormatJsonQuote64BitIntegers">resetOutputFormatJsonQuote64BitIntegers</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetOutputFormatJsonQuoteDenormals">resetOutputFormatJsonQuoteDenormals</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetPriority">resetPriority</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetQuotaMode">resetQuotaMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReadonly">resetReadonly</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReadOverflowMode">resetReadOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReceiveTimeout">resetReceiveTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReplicationAlterPartitionsSync">resetReplicationAlterPartitionsSync</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetResultOverflowMode">resetResultOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSelectSequentialConsistency">resetSelectSequentialConsistency</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSendProgressInHttpHeaders">resetSendProgressInHttpHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSendTimeout">resetSendTimeout</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSetOverflowMode">resetSetOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSkipUnavailableShards">resetSkipUnavailableShards</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSortOverflowMode">resetSortOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTimeoutOverflowMode">resetTimeoutOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTransferOverflowMode">resetTransferOverflowMode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTransformNullIn">resetTransformNullIn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetUseUncompressedCache">resetUseUncompressedCache</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAddHttpCorsHeader` <a name="resetAddHttpCorsHeader" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetAddHttpCorsHeader"></a>

```typescript
public resetAddHttpCorsHeader(): void
```

##### `resetAllowDdl` <a name="resetAllowDdl" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetAllowDdl"></a>

```typescript
public resetAllowDdl(): void
```

##### `resetCompile` <a name="resetCompile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCompile"></a>

```typescript
public resetCompile(): void
```

##### `resetCompileExpressions` <a name="resetCompileExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCompileExpressions"></a>

```typescript
public resetCompileExpressions(): void
```

##### `resetConnectTimeout` <a name="resetConnectTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetConnectTimeout"></a>

```typescript
public resetConnectTimeout(): void
```

##### `resetCountDistinctImplementation` <a name="resetCountDistinctImplementation" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetCountDistinctImplementation"></a>

```typescript
public resetCountDistinctImplementation(): void
```

##### `resetDistinctOverflowMode` <a name="resetDistinctOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistinctOverflowMode"></a>

```typescript
public resetDistinctOverflowMode(): void
```

##### `resetDistributedAggregationMemoryEfficient` <a name="resetDistributedAggregationMemoryEfficient" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedAggregationMemoryEfficient"></a>

```typescript
public resetDistributedAggregationMemoryEfficient(): void
```

##### `resetDistributedDdlTaskTimeout` <a name="resetDistributedDdlTaskTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedDdlTaskTimeout"></a>

```typescript
public resetDistributedDdlTaskTimeout(): void
```

##### `resetDistributedProductMode` <a name="resetDistributedProductMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetDistributedProductMode"></a>

```typescript
public resetDistributedProductMode(): void
```

##### `resetEmptyResultForAggregationByEmptySet` <a name="resetEmptyResultForAggregationByEmptySet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetEmptyResultForAggregationByEmptySet"></a>

```typescript
public resetEmptyResultForAggregationByEmptySet(): void
```

##### `resetEnableHttpCompression` <a name="resetEnableHttpCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetEnableHttpCompression"></a>

```typescript
public resetEnableHttpCompression(): void
```

##### `resetFallbackToStaleReplicasForDistributedQueries` <a name="resetFallbackToStaleReplicasForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetFallbackToStaleReplicasForDistributedQueries"></a>

```typescript
public resetFallbackToStaleReplicasForDistributedQueries(): void
```

##### `resetForceIndexByDate` <a name="resetForceIndexByDate" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetForceIndexByDate"></a>

```typescript
public resetForceIndexByDate(): void
```

##### `resetForcePrimaryKey` <a name="resetForcePrimaryKey" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetForcePrimaryKey"></a>

```typescript
public resetForcePrimaryKey(): void
```

##### `resetGroupByOverflowMode` <a name="resetGroupByOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByOverflowMode"></a>

```typescript
public resetGroupByOverflowMode(): void
```

##### `resetGroupByTwoLevelThreshold` <a name="resetGroupByTwoLevelThreshold" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByTwoLevelThreshold"></a>

```typescript
public resetGroupByTwoLevelThreshold(): void
```

##### `resetGroupByTwoLevelThresholdBytes` <a name="resetGroupByTwoLevelThresholdBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetGroupByTwoLevelThresholdBytes"></a>

```typescript
public resetGroupByTwoLevelThresholdBytes(): void
```

##### `resetHttpConnectionTimeout` <a name="resetHttpConnectionTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpConnectionTimeout"></a>

```typescript
public resetHttpConnectionTimeout(): void
```

##### `resetHttpHeadersProgressInterval` <a name="resetHttpHeadersProgressInterval" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpHeadersProgressInterval"></a>

```typescript
public resetHttpHeadersProgressInterval(): void
```

##### `resetHttpReceiveTimeout` <a name="resetHttpReceiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpReceiveTimeout"></a>

```typescript
public resetHttpReceiveTimeout(): void
```

##### `resetHttpSendTimeout` <a name="resetHttpSendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetHttpSendTimeout"></a>

```typescript
public resetHttpSendTimeout(): void
```

##### `resetInputFormatDefaultsForOmittedFields` <a name="resetInputFormatDefaultsForOmittedFields" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInputFormatDefaultsForOmittedFields"></a>

```typescript
public resetInputFormatDefaultsForOmittedFields(): void
```

##### `resetInputFormatValuesInterpretExpressions` <a name="resetInputFormatValuesInterpretExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInputFormatValuesInterpretExpressions"></a>

```typescript
public resetInputFormatValuesInterpretExpressions(): void
```

##### `resetInsertQuorum` <a name="resetInsertQuorum" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInsertQuorum"></a>

```typescript
public resetInsertQuorum(): void
```

##### `resetInsertQuorumTimeout` <a name="resetInsertQuorumTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetInsertQuorumTimeout"></a>

```typescript
public resetInsertQuorumTimeout(): void
```

##### `resetJoinedSubqueryRequiresAlias` <a name="resetJoinedSubqueryRequiresAlias" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinedSubqueryRequiresAlias"></a>

```typescript
public resetJoinedSubqueryRequiresAlias(): void
```

##### `resetJoinOverflowMode` <a name="resetJoinOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinOverflowMode"></a>

```typescript
public resetJoinOverflowMode(): void
```

##### `resetJoinUseNulls` <a name="resetJoinUseNulls" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetJoinUseNulls"></a>

```typescript
public resetJoinUseNulls(): void
```

##### `resetLowCardinalityAllowInNativeFormat` <a name="resetLowCardinalityAllowInNativeFormat" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetLowCardinalityAllowInNativeFormat"></a>

```typescript
public resetLowCardinalityAllowInNativeFormat(): void
```

##### `resetMaxAstDepth` <a name="resetMaxAstDepth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxAstDepth"></a>

```typescript
public resetMaxAstDepth(): void
```

##### `resetMaxAstElements` <a name="resetMaxAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxAstElements"></a>

```typescript
public resetMaxAstElements(): void
```

##### `resetMaxBlockSize` <a name="resetMaxBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBlockSize"></a>

```typescript
public resetMaxBlockSize(): void
```

##### `resetMaxBytesBeforeExternalGroupBy` <a name="resetMaxBytesBeforeExternalGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesBeforeExternalGroupBy"></a>

```typescript
public resetMaxBytesBeforeExternalGroupBy(): void
```

##### `resetMaxBytesBeforeExternalSort` <a name="resetMaxBytesBeforeExternalSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesBeforeExternalSort"></a>

```typescript
public resetMaxBytesBeforeExternalSort(): void
```

##### `resetMaxBytesInDistinct` <a name="resetMaxBytesInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInDistinct"></a>

```typescript
public resetMaxBytesInDistinct(): void
```

##### `resetMaxBytesInJoin` <a name="resetMaxBytesInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInJoin"></a>

```typescript
public resetMaxBytesInJoin(): void
```

##### `resetMaxBytesInSet` <a name="resetMaxBytesInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesInSet"></a>

```typescript
public resetMaxBytesInSet(): void
```

##### `resetMaxBytesToRead` <a name="resetMaxBytesToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToRead"></a>

```typescript
public resetMaxBytesToRead(): void
```

##### `resetMaxBytesToSort` <a name="resetMaxBytesToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToSort"></a>

```typescript
public resetMaxBytesToSort(): void
```

##### `resetMaxBytesToTransfer` <a name="resetMaxBytesToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxBytesToTransfer"></a>

```typescript
public resetMaxBytesToTransfer(): void
```

##### `resetMaxColumnsToRead` <a name="resetMaxColumnsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxColumnsToRead"></a>

```typescript
public resetMaxColumnsToRead(): void
```

##### `resetMaxExecutionTime` <a name="resetMaxExecutionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxExecutionTime"></a>

```typescript
public resetMaxExecutionTime(): void
```

##### `resetMaxExpandedAstElements` <a name="resetMaxExpandedAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxExpandedAstElements"></a>

```typescript
public resetMaxExpandedAstElements(): void
```

##### `resetMaxInsertBlockSize` <a name="resetMaxInsertBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxInsertBlockSize"></a>

```typescript
public resetMaxInsertBlockSize(): void
```

##### `resetMaxMemoryUsage` <a name="resetMaxMemoryUsage" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxMemoryUsage"></a>

```typescript
public resetMaxMemoryUsage(): void
```

##### `resetMaxMemoryUsageForUser` <a name="resetMaxMemoryUsageForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxMemoryUsageForUser"></a>

```typescript
public resetMaxMemoryUsageForUser(): void
```

##### `resetMaxNetworkBandwidth` <a name="resetMaxNetworkBandwidth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxNetworkBandwidth"></a>

```typescript
public resetMaxNetworkBandwidth(): void
```

##### `resetMaxNetworkBandwidthForUser` <a name="resetMaxNetworkBandwidthForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxNetworkBandwidthForUser"></a>

```typescript
public resetMaxNetworkBandwidthForUser(): void
```

##### `resetMaxQuerySize` <a name="resetMaxQuerySize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxQuerySize"></a>

```typescript
public resetMaxQuerySize(): void
```

##### `resetMaxReplicaDelayForDistributedQueries` <a name="resetMaxReplicaDelayForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxReplicaDelayForDistributedQueries"></a>

```typescript
public resetMaxReplicaDelayForDistributedQueries(): void
```

##### `resetMaxResultBytes` <a name="resetMaxResultBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxResultBytes"></a>

```typescript
public resetMaxResultBytes(): void
```

##### `resetMaxResultRows` <a name="resetMaxResultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxResultRows"></a>

```typescript
public resetMaxResultRows(): void
```

##### `resetMaxRowsInDistinct` <a name="resetMaxRowsInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInDistinct"></a>

```typescript
public resetMaxRowsInDistinct(): void
```

##### `resetMaxRowsInJoin` <a name="resetMaxRowsInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInJoin"></a>

```typescript
public resetMaxRowsInJoin(): void
```

##### `resetMaxRowsInSet` <a name="resetMaxRowsInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsInSet"></a>

```typescript
public resetMaxRowsInSet(): void
```

##### `resetMaxRowsToGroupBy` <a name="resetMaxRowsToGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToGroupBy"></a>

```typescript
public resetMaxRowsToGroupBy(): void
```

##### `resetMaxRowsToRead` <a name="resetMaxRowsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToRead"></a>

```typescript
public resetMaxRowsToRead(): void
```

##### `resetMaxRowsToSort` <a name="resetMaxRowsToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToSort"></a>

```typescript
public resetMaxRowsToSort(): void
```

##### `resetMaxRowsToTransfer` <a name="resetMaxRowsToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxRowsToTransfer"></a>

```typescript
public resetMaxRowsToTransfer(): void
```

##### `resetMaxTemporaryColumns` <a name="resetMaxTemporaryColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxTemporaryColumns"></a>

```typescript
public resetMaxTemporaryColumns(): void
```

##### `resetMaxTemporaryNonConstColumns` <a name="resetMaxTemporaryNonConstColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxTemporaryNonConstColumns"></a>

```typescript
public resetMaxTemporaryNonConstColumns(): void
```

##### `resetMaxThreads` <a name="resetMaxThreads" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMaxThreads"></a>

```typescript
public resetMaxThreads(): void
```

##### `resetMergeTreeMaxBytesToUseCache` <a name="resetMergeTreeMaxBytesToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMaxBytesToUseCache"></a>

```typescript
public resetMergeTreeMaxBytesToUseCache(): void
```

##### `resetMergeTreeMaxRowsToUseCache` <a name="resetMergeTreeMaxRowsToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMaxRowsToUseCache"></a>

```typescript
public resetMergeTreeMaxRowsToUseCache(): void
```

##### `resetMergeTreeMinBytesForConcurrentRead` <a name="resetMergeTreeMinBytesForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMinBytesForConcurrentRead"></a>

```typescript
public resetMergeTreeMinBytesForConcurrentRead(): void
```

##### `resetMergeTreeMinRowsForConcurrentRead` <a name="resetMergeTreeMinRowsForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMergeTreeMinRowsForConcurrentRead"></a>

```typescript
public resetMergeTreeMinRowsForConcurrentRead(): void
```

##### `resetMinBytesToUseDirectIo` <a name="resetMinBytesToUseDirectIo" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinBytesToUseDirectIo"></a>

```typescript
public resetMinBytesToUseDirectIo(): void
```

##### `resetMinCountToCompile` <a name="resetMinCountToCompile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinCountToCompile"></a>

```typescript
public resetMinCountToCompile(): void
```

##### `resetMinCountToCompileExpression` <a name="resetMinCountToCompileExpression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinCountToCompileExpression"></a>

```typescript
public resetMinCountToCompileExpression(): void
```

##### `resetMinExecutionSpeed` <a name="resetMinExecutionSpeed" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinExecutionSpeed"></a>

```typescript
public resetMinExecutionSpeed(): void
```

##### `resetMinExecutionSpeedBytes` <a name="resetMinExecutionSpeedBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinExecutionSpeedBytes"></a>

```typescript
public resetMinExecutionSpeedBytes(): void
```

##### `resetMinInsertBlockSizeBytes` <a name="resetMinInsertBlockSizeBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinInsertBlockSizeBytes"></a>

```typescript
public resetMinInsertBlockSizeBytes(): void
```

##### `resetMinInsertBlockSizeRows` <a name="resetMinInsertBlockSizeRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetMinInsertBlockSizeRows"></a>

```typescript
public resetMinInsertBlockSizeRows(): void
```

##### `resetOutputFormatJsonQuote64BitIntegers` <a name="resetOutputFormatJsonQuote64BitIntegers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetOutputFormatJsonQuote64BitIntegers"></a>

```typescript
public resetOutputFormatJsonQuote64BitIntegers(): void
```

##### `resetOutputFormatJsonQuoteDenormals` <a name="resetOutputFormatJsonQuoteDenormals" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetOutputFormatJsonQuoteDenormals"></a>

```typescript
public resetOutputFormatJsonQuoteDenormals(): void
```

##### `resetPriority` <a name="resetPriority" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetPriority"></a>

```typescript
public resetPriority(): void
```

##### `resetQuotaMode` <a name="resetQuotaMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetQuotaMode"></a>

```typescript
public resetQuotaMode(): void
```

##### `resetReadonly` <a name="resetReadonly" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReadonly"></a>

```typescript
public resetReadonly(): void
```

##### `resetReadOverflowMode` <a name="resetReadOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReadOverflowMode"></a>

```typescript
public resetReadOverflowMode(): void
```

##### `resetReceiveTimeout` <a name="resetReceiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReceiveTimeout"></a>

```typescript
public resetReceiveTimeout(): void
```

##### `resetReplicationAlterPartitionsSync` <a name="resetReplicationAlterPartitionsSync" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetReplicationAlterPartitionsSync"></a>

```typescript
public resetReplicationAlterPartitionsSync(): void
```

##### `resetResultOverflowMode` <a name="resetResultOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetResultOverflowMode"></a>

```typescript
public resetResultOverflowMode(): void
```

##### `resetSelectSequentialConsistency` <a name="resetSelectSequentialConsistency" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSelectSequentialConsistency"></a>

```typescript
public resetSelectSequentialConsistency(): void
```

##### `resetSendProgressInHttpHeaders` <a name="resetSendProgressInHttpHeaders" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSendProgressInHttpHeaders"></a>

```typescript
public resetSendProgressInHttpHeaders(): void
```

##### `resetSendTimeout` <a name="resetSendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSendTimeout"></a>

```typescript
public resetSendTimeout(): void
```

##### `resetSetOverflowMode` <a name="resetSetOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSetOverflowMode"></a>

```typescript
public resetSetOverflowMode(): void
```

##### `resetSkipUnavailableShards` <a name="resetSkipUnavailableShards" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSkipUnavailableShards"></a>

```typescript
public resetSkipUnavailableShards(): void
```

##### `resetSortOverflowMode` <a name="resetSortOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetSortOverflowMode"></a>

```typescript
public resetSortOverflowMode(): void
```

##### `resetTimeoutOverflowMode` <a name="resetTimeoutOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTimeoutOverflowMode"></a>

```typescript
public resetTimeoutOverflowMode(): void
```

##### `resetTransferOverflowMode` <a name="resetTransferOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTransferOverflowMode"></a>

```typescript
public resetTransferOverflowMode(): void
```

##### `resetTransformNullIn` <a name="resetTransformNullIn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetTransformNullIn"></a>

```typescript
public resetTransformNullIn(): void
```

##### `resetUseUncompressedCache` <a name="resetUseUncompressedCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.resetUseUncompressedCache"></a>

```typescript
public resetUseUncompressedCache(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeaderInput">addHttpCorsHeaderInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.allowDdlInput">allowDdlInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileExpressionsInput">compileExpressionsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileInput">compileInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.connectTimeoutInput">connectTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementationInput">countDistinctImplementationInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowModeInput">distinctOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficientInput">distributedAggregationMemoryEfficientInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeoutInput">distributedDdlTaskTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedProductModeInput">distributedProductModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySetInput">emptyResultForAggregationByEmptySetInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompressionInput">enableHttpCompressionInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueriesInput">fallbackToStaleReplicasForDistributedQueriesInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDateInput">forceIndexByDateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKeyInput">forcePrimaryKeyInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowModeInput">groupByOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytesInput">groupByTwoLevelThresholdBytesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdInput">groupByTwoLevelThresholdInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeoutInput">httpConnectionTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressIntervalInput">httpHeadersProgressIntervalInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeoutInput">httpReceiveTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeoutInput">httpSendTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFieldsInput">inputFormatDefaultsForOmittedFieldsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressionsInput">inputFormatValuesInterpretExpressionsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumInput">insertQuorumInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeoutInput">insertQuorumTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAliasInput">joinedSubqueryRequiresAliasInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowModeInput">joinOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinUseNullsInput">joinUseNullsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormatInput">lowCardinalityAllowInNativeFormatInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepthInput">maxAstDepthInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstElementsInput">maxAstElementsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSizeInput">maxBlockSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupByInput">maxBytesBeforeExternalGroupByInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSortInput">maxBytesBeforeExternalSortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinctInput">maxBytesInDistinctInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoinInput">maxBytesInJoinInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSetInput">maxBytesInSetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToReadInput">maxBytesToReadInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSortInput">maxBytesToSortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransferInput">maxBytesToTransferInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToReadInput">maxColumnsToReadInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTimeInput">maxExecutionTimeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElementsInput">maxExpandedAstElementsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSizeInput">maxInsertBlockSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUserInput">maxMemoryUsageForUserInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageInput">maxMemoryUsageInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUserInput">maxNetworkBandwidthForUserInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthInput">maxNetworkBandwidthInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySizeInput">maxQuerySizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueriesInput">maxReplicaDelayForDistributedQueriesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytesInput">maxResultBytesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultRowsInput">maxResultRowsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinctInput">maxRowsInDistinctInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoinInput">maxRowsInJoinInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSetInput">maxRowsInSetInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupByInput">maxRowsToGroupByInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToReadInput">maxRowsToReadInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSortInput">maxRowsToSortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransferInput">maxRowsToTransferInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumnsInput">maxTemporaryColumnsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumnsInput">maxTemporaryNonConstColumnsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxThreadsInput">maxThreadsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCacheInput">mergeTreeMaxBytesToUseCacheInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCacheInput">mergeTreeMaxRowsToUseCacheInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentReadInput">mergeTreeMinBytesForConcurrentReadInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentReadInput">mergeTreeMinRowsForConcurrentReadInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIoInput">minBytesToUseDirectIoInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpressionInput">minCountToCompileExpressionInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileInput">minCountToCompileInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytesInput">minExecutionSpeedBytesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedInput">minExecutionSpeedInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytesInput">minInsertBlockSizeBytesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRowsInput">minInsertBlockSizeRowsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegersInput">outputFormatJsonQuote64BitIntegersInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormalsInput">outputFormatJsonQuoteDenormalsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.priorityInput">priorityInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.quotaModeInput">quotaModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readonlyInput">readonlyInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readOverflowModeInput">readOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeoutInput">receiveTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSyncInput">replicationAlterPartitionsSyncInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowModeInput">resultOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistencyInput">selectSequentialConsistencyInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeadersInput">sendProgressInHttpHeadersInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendTimeoutInput">sendTimeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.setOverflowModeInput">setOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShardsInput">skipUnavailableShardsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowModeInput">sortOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowModeInput">timeoutOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowModeInput">transferOverflowModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transformNullInInput">transformNullInInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCacheInput">useUncompressedCacheInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeader">addHttpCorsHeader</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.allowDdl">allowDdl</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compile">compile</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileExpressions">compileExpressions</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.connectTimeout">connectTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementation">countDistinctImplementation</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowMode">distinctOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficient">distributedAggregationMemoryEfficient</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeout">distributedDdlTaskTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedProductMode">distributedProductMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySet">emptyResultForAggregationByEmptySet</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompression">enableHttpCompression</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueries">fallbackToStaleReplicasForDistributedQueries</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDate">forceIndexByDate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKey">forcePrimaryKey</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowMode">groupByOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThreshold">groupByTwoLevelThreshold</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytes">groupByTwoLevelThresholdBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeout">httpConnectionTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressInterval">httpHeadersProgressInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeout">httpReceiveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeout">httpSendTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFields">inputFormatDefaultsForOmittedFields</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressions">inputFormatValuesInterpretExpressions</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorum">insertQuorum</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeout">insertQuorumTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAlias">joinedSubqueryRequiresAlias</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowMode">joinOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinUseNulls">joinUseNulls</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormat">lowCardinalityAllowInNativeFormat</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepth">maxAstDepth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstElements">maxAstElements</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSize">maxBlockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupBy">maxBytesBeforeExternalGroupBy</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSort">maxBytesBeforeExternalSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinct">maxBytesInDistinct</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoin">maxBytesInJoin</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSet">maxBytesInSet</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToRead">maxBytesToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSort">maxBytesToSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransfer">maxBytesToTransfer</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToRead">maxColumnsToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTime">maxExecutionTime</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElements">maxExpandedAstElements</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSize">maxInsertBlockSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsage">maxMemoryUsage</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUser">maxMemoryUsageForUser</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidth">maxNetworkBandwidth</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUser">maxNetworkBandwidthForUser</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySize">maxQuerySize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueries">maxReplicaDelayForDistributedQueries</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytes">maxResultBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultRows">maxResultRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinct">maxRowsInDistinct</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoin">maxRowsInJoin</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSet">maxRowsInSet</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupBy">maxRowsToGroupBy</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToRead">maxRowsToRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSort">maxRowsToSort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransfer">maxRowsToTransfer</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumns">maxTemporaryColumns</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumns">maxTemporaryNonConstColumns</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxThreads">maxThreads</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCache">mergeTreeMaxBytesToUseCache</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCache">mergeTreeMaxRowsToUseCache</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentRead">mergeTreeMinBytesForConcurrentRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentRead">mergeTreeMinRowsForConcurrentRead</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIo">minBytesToUseDirectIo</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompile">minCountToCompile</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpression">minCountToCompileExpression</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeed">minExecutionSpeed</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytes">minExecutionSpeedBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytes">minInsertBlockSizeBytes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRows">minInsertBlockSizeRows</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegers">outputFormatJsonQuote64BitIntegers</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormals">outputFormatJsonQuoteDenormals</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.quotaMode">quotaMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readonly">readonly</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readOverflowMode">readOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeout">receiveTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSync">replicationAlterPartitionsSync</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowMode">resultOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistency">selectSequentialConsistency</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeaders">sendProgressInHttpHeaders</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendTimeout">sendTimeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.setOverflowMode">setOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShards">skipUnavailableShards</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowMode">sortOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowMode">timeoutOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowMode">transferOverflowMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transformNullIn">transformNullIn</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCache">useUncompressedCache</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `addHttpCorsHeaderInput`<sup>Optional</sup> <a name="addHttpCorsHeaderInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeaderInput"></a>

```typescript
public readonly addHttpCorsHeaderInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `allowDdlInput`<sup>Optional</sup> <a name="allowDdlInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.allowDdlInput"></a>

```typescript
public readonly allowDdlInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compileExpressionsInput`<sup>Optional</sup> <a name="compileExpressionsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileExpressionsInput"></a>

```typescript
public readonly compileExpressionsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compileInput`<sup>Optional</sup> <a name="compileInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileInput"></a>

```typescript
public readonly compileInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `connectTimeoutInput`<sup>Optional</sup> <a name="connectTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.connectTimeoutInput"></a>

```typescript
public readonly connectTimeoutInput: number;
```

- *Type:* number

---

##### `countDistinctImplementationInput`<sup>Optional</sup> <a name="countDistinctImplementationInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementationInput"></a>

```typescript
public readonly countDistinctImplementationInput: string;
```

- *Type:* string

---

##### `distinctOverflowModeInput`<sup>Optional</sup> <a name="distinctOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowModeInput"></a>

```typescript
public readonly distinctOverflowModeInput: string;
```

- *Type:* string

---

##### `distributedAggregationMemoryEfficientInput`<sup>Optional</sup> <a name="distributedAggregationMemoryEfficientInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficientInput"></a>

```typescript
public readonly distributedAggregationMemoryEfficientInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `distributedDdlTaskTimeoutInput`<sup>Optional</sup> <a name="distributedDdlTaskTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeoutInput"></a>

```typescript
public readonly distributedDdlTaskTimeoutInput: number;
```

- *Type:* number

---

##### `distributedProductModeInput`<sup>Optional</sup> <a name="distributedProductModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedProductModeInput"></a>

```typescript
public readonly distributedProductModeInput: string;
```

- *Type:* string

---

##### `emptyResultForAggregationByEmptySetInput`<sup>Optional</sup> <a name="emptyResultForAggregationByEmptySetInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySetInput"></a>

```typescript
public readonly emptyResultForAggregationByEmptySetInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enableHttpCompressionInput`<sup>Optional</sup> <a name="enableHttpCompressionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompressionInput"></a>

```typescript
public readonly enableHttpCompressionInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fallbackToStaleReplicasForDistributedQueriesInput`<sup>Optional</sup> <a name="fallbackToStaleReplicasForDistributedQueriesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueriesInput"></a>

```typescript
public readonly fallbackToStaleReplicasForDistributedQueriesInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forceIndexByDateInput`<sup>Optional</sup> <a name="forceIndexByDateInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDateInput"></a>

```typescript
public readonly forceIndexByDateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forcePrimaryKeyInput`<sup>Optional</sup> <a name="forcePrimaryKeyInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKeyInput"></a>

```typescript
public readonly forcePrimaryKeyInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `groupByOverflowModeInput`<sup>Optional</sup> <a name="groupByOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowModeInput"></a>

```typescript
public readonly groupByOverflowModeInput: string;
```

- *Type:* string

---

##### `groupByTwoLevelThresholdBytesInput`<sup>Optional</sup> <a name="groupByTwoLevelThresholdBytesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytesInput"></a>

```typescript
public readonly groupByTwoLevelThresholdBytesInput: number;
```

- *Type:* number

---

##### `groupByTwoLevelThresholdInput`<sup>Optional</sup> <a name="groupByTwoLevelThresholdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdInput"></a>

```typescript
public readonly groupByTwoLevelThresholdInput: number;
```

- *Type:* number

---

##### `httpConnectionTimeoutInput`<sup>Optional</sup> <a name="httpConnectionTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeoutInput"></a>

```typescript
public readonly httpConnectionTimeoutInput: number;
```

- *Type:* number

---

##### `httpHeadersProgressIntervalInput`<sup>Optional</sup> <a name="httpHeadersProgressIntervalInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressIntervalInput"></a>

```typescript
public readonly httpHeadersProgressIntervalInput: number;
```

- *Type:* number

---

##### `httpReceiveTimeoutInput`<sup>Optional</sup> <a name="httpReceiveTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeoutInput"></a>

```typescript
public readonly httpReceiveTimeoutInput: number;
```

- *Type:* number

---

##### `httpSendTimeoutInput`<sup>Optional</sup> <a name="httpSendTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeoutInput"></a>

```typescript
public readonly httpSendTimeoutInput: number;
```

- *Type:* number

---

##### `inputFormatDefaultsForOmittedFieldsInput`<sup>Optional</sup> <a name="inputFormatDefaultsForOmittedFieldsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFieldsInput"></a>

```typescript
public readonly inputFormatDefaultsForOmittedFieldsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `inputFormatValuesInterpretExpressionsInput`<sup>Optional</sup> <a name="inputFormatValuesInterpretExpressionsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressionsInput"></a>

```typescript
public readonly inputFormatValuesInterpretExpressionsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `insertQuorumInput`<sup>Optional</sup> <a name="insertQuorumInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumInput"></a>

```typescript
public readonly insertQuorumInput: number;
```

- *Type:* number

---

##### `insertQuorumTimeoutInput`<sup>Optional</sup> <a name="insertQuorumTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeoutInput"></a>

```typescript
public readonly insertQuorumTimeoutInput: number;
```

- *Type:* number

---

##### `joinedSubqueryRequiresAliasInput`<sup>Optional</sup> <a name="joinedSubqueryRequiresAliasInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAliasInput"></a>

```typescript
public readonly joinedSubqueryRequiresAliasInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `joinOverflowModeInput`<sup>Optional</sup> <a name="joinOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowModeInput"></a>

```typescript
public readonly joinOverflowModeInput: string;
```

- *Type:* string

---

##### `joinUseNullsInput`<sup>Optional</sup> <a name="joinUseNullsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinUseNullsInput"></a>

```typescript
public readonly joinUseNullsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `lowCardinalityAllowInNativeFormatInput`<sup>Optional</sup> <a name="lowCardinalityAllowInNativeFormatInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormatInput"></a>

```typescript
public readonly lowCardinalityAllowInNativeFormatInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maxAstDepthInput`<sup>Optional</sup> <a name="maxAstDepthInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepthInput"></a>

```typescript
public readonly maxAstDepthInput: number;
```

- *Type:* number

---

##### `maxAstElementsInput`<sup>Optional</sup> <a name="maxAstElementsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstElementsInput"></a>

```typescript
public readonly maxAstElementsInput: number;
```

- *Type:* number

---

##### `maxBlockSizeInput`<sup>Optional</sup> <a name="maxBlockSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSizeInput"></a>

```typescript
public readonly maxBlockSizeInput: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalGroupByInput`<sup>Optional</sup> <a name="maxBytesBeforeExternalGroupByInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupByInput"></a>

```typescript
public readonly maxBytesBeforeExternalGroupByInput: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalSortInput`<sup>Optional</sup> <a name="maxBytesBeforeExternalSortInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSortInput"></a>

```typescript
public readonly maxBytesBeforeExternalSortInput: number;
```

- *Type:* number

---

##### `maxBytesInDistinctInput`<sup>Optional</sup> <a name="maxBytesInDistinctInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinctInput"></a>

```typescript
public readonly maxBytesInDistinctInput: number;
```

- *Type:* number

---

##### `maxBytesInJoinInput`<sup>Optional</sup> <a name="maxBytesInJoinInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoinInput"></a>

```typescript
public readonly maxBytesInJoinInput: number;
```

- *Type:* number

---

##### `maxBytesInSetInput`<sup>Optional</sup> <a name="maxBytesInSetInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSetInput"></a>

```typescript
public readonly maxBytesInSetInput: number;
```

- *Type:* number

---

##### `maxBytesToReadInput`<sup>Optional</sup> <a name="maxBytesToReadInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToReadInput"></a>

```typescript
public readonly maxBytesToReadInput: number;
```

- *Type:* number

---

##### `maxBytesToSortInput`<sup>Optional</sup> <a name="maxBytesToSortInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSortInput"></a>

```typescript
public readonly maxBytesToSortInput: number;
```

- *Type:* number

---

##### `maxBytesToTransferInput`<sup>Optional</sup> <a name="maxBytesToTransferInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransferInput"></a>

```typescript
public readonly maxBytesToTransferInput: number;
```

- *Type:* number

---

##### `maxColumnsToReadInput`<sup>Optional</sup> <a name="maxColumnsToReadInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToReadInput"></a>

```typescript
public readonly maxColumnsToReadInput: number;
```

- *Type:* number

---

##### `maxExecutionTimeInput`<sup>Optional</sup> <a name="maxExecutionTimeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTimeInput"></a>

```typescript
public readonly maxExecutionTimeInput: number;
```

- *Type:* number

---

##### `maxExpandedAstElementsInput`<sup>Optional</sup> <a name="maxExpandedAstElementsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElementsInput"></a>

```typescript
public readonly maxExpandedAstElementsInput: number;
```

- *Type:* number

---

##### `maxInsertBlockSizeInput`<sup>Optional</sup> <a name="maxInsertBlockSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSizeInput"></a>

```typescript
public readonly maxInsertBlockSizeInput: number;
```

- *Type:* number

---

##### `maxMemoryUsageForUserInput`<sup>Optional</sup> <a name="maxMemoryUsageForUserInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUserInput"></a>

```typescript
public readonly maxMemoryUsageForUserInput: number;
```

- *Type:* number

---

##### `maxMemoryUsageInput`<sup>Optional</sup> <a name="maxMemoryUsageInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageInput"></a>

```typescript
public readonly maxMemoryUsageInput: number;
```

- *Type:* number

---

##### `maxNetworkBandwidthForUserInput`<sup>Optional</sup> <a name="maxNetworkBandwidthForUserInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUserInput"></a>

```typescript
public readonly maxNetworkBandwidthForUserInput: number;
```

- *Type:* number

---

##### `maxNetworkBandwidthInput`<sup>Optional</sup> <a name="maxNetworkBandwidthInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthInput"></a>

```typescript
public readonly maxNetworkBandwidthInput: number;
```

- *Type:* number

---

##### `maxQuerySizeInput`<sup>Optional</sup> <a name="maxQuerySizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySizeInput"></a>

```typescript
public readonly maxQuerySizeInput: number;
```

- *Type:* number

---

##### `maxReplicaDelayForDistributedQueriesInput`<sup>Optional</sup> <a name="maxReplicaDelayForDistributedQueriesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueriesInput"></a>

```typescript
public readonly maxReplicaDelayForDistributedQueriesInput: number;
```

- *Type:* number

---

##### `maxResultBytesInput`<sup>Optional</sup> <a name="maxResultBytesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytesInput"></a>

```typescript
public readonly maxResultBytesInput: number;
```

- *Type:* number

---

##### `maxResultRowsInput`<sup>Optional</sup> <a name="maxResultRowsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultRowsInput"></a>

```typescript
public readonly maxResultRowsInput: number;
```

- *Type:* number

---

##### `maxRowsInDistinctInput`<sup>Optional</sup> <a name="maxRowsInDistinctInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinctInput"></a>

```typescript
public readonly maxRowsInDistinctInput: number;
```

- *Type:* number

---

##### `maxRowsInJoinInput`<sup>Optional</sup> <a name="maxRowsInJoinInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoinInput"></a>

```typescript
public readonly maxRowsInJoinInput: number;
```

- *Type:* number

---

##### `maxRowsInSetInput`<sup>Optional</sup> <a name="maxRowsInSetInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSetInput"></a>

```typescript
public readonly maxRowsInSetInput: number;
```

- *Type:* number

---

##### `maxRowsToGroupByInput`<sup>Optional</sup> <a name="maxRowsToGroupByInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupByInput"></a>

```typescript
public readonly maxRowsToGroupByInput: number;
```

- *Type:* number

---

##### `maxRowsToReadInput`<sup>Optional</sup> <a name="maxRowsToReadInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToReadInput"></a>

```typescript
public readonly maxRowsToReadInput: number;
```

- *Type:* number

---

##### `maxRowsToSortInput`<sup>Optional</sup> <a name="maxRowsToSortInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSortInput"></a>

```typescript
public readonly maxRowsToSortInput: number;
```

- *Type:* number

---

##### `maxRowsToTransferInput`<sup>Optional</sup> <a name="maxRowsToTransferInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransferInput"></a>

```typescript
public readonly maxRowsToTransferInput: number;
```

- *Type:* number

---

##### `maxTemporaryColumnsInput`<sup>Optional</sup> <a name="maxTemporaryColumnsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumnsInput"></a>

```typescript
public readonly maxTemporaryColumnsInput: number;
```

- *Type:* number

---

##### `maxTemporaryNonConstColumnsInput`<sup>Optional</sup> <a name="maxTemporaryNonConstColumnsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumnsInput"></a>

```typescript
public readonly maxTemporaryNonConstColumnsInput: number;
```

- *Type:* number

---

##### `maxThreadsInput`<sup>Optional</sup> <a name="maxThreadsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxThreadsInput"></a>

```typescript
public readonly maxThreadsInput: number;
```

- *Type:* number

---

##### `mergeTreeMaxBytesToUseCacheInput`<sup>Optional</sup> <a name="mergeTreeMaxBytesToUseCacheInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCacheInput"></a>

```typescript
public readonly mergeTreeMaxBytesToUseCacheInput: number;
```

- *Type:* number

---

##### `mergeTreeMaxRowsToUseCacheInput`<sup>Optional</sup> <a name="mergeTreeMaxRowsToUseCacheInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCacheInput"></a>

```typescript
public readonly mergeTreeMaxRowsToUseCacheInput: number;
```

- *Type:* number

---

##### `mergeTreeMinBytesForConcurrentReadInput`<sup>Optional</sup> <a name="mergeTreeMinBytesForConcurrentReadInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentReadInput"></a>

```typescript
public readonly mergeTreeMinBytesForConcurrentReadInput: number;
```

- *Type:* number

---

##### `mergeTreeMinRowsForConcurrentReadInput`<sup>Optional</sup> <a name="mergeTreeMinRowsForConcurrentReadInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentReadInput"></a>

```typescript
public readonly mergeTreeMinRowsForConcurrentReadInput: number;
```

- *Type:* number

---

##### `minBytesToUseDirectIoInput`<sup>Optional</sup> <a name="minBytesToUseDirectIoInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIoInput"></a>

```typescript
public readonly minBytesToUseDirectIoInput: number;
```

- *Type:* number

---

##### `minCountToCompileExpressionInput`<sup>Optional</sup> <a name="minCountToCompileExpressionInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpressionInput"></a>

```typescript
public readonly minCountToCompileExpressionInput: number;
```

- *Type:* number

---

##### `minCountToCompileInput`<sup>Optional</sup> <a name="minCountToCompileInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileInput"></a>

```typescript
public readonly minCountToCompileInput: number;
```

- *Type:* number

---

##### `minExecutionSpeedBytesInput`<sup>Optional</sup> <a name="minExecutionSpeedBytesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytesInput"></a>

```typescript
public readonly minExecutionSpeedBytesInput: number;
```

- *Type:* number

---

##### `minExecutionSpeedInput`<sup>Optional</sup> <a name="minExecutionSpeedInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedInput"></a>

```typescript
public readonly minExecutionSpeedInput: number;
```

- *Type:* number

---

##### `minInsertBlockSizeBytesInput`<sup>Optional</sup> <a name="minInsertBlockSizeBytesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytesInput"></a>

```typescript
public readonly minInsertBlockSizeBytesInput: number;
```

- *Type:* number

---

##### `minInsertBlockSizeRowsInput`<sup>Optional</sup> <a name="minInsertBlockSizeRowsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRowsInput"></a>

```typescript
public readonly minInsertBlockSizeRowsInput: number;
```

- *Type:* number

---

##### `outputFormatJsonQuote64BitIntegersInput`<sup>Optional</sup> <a name="outputFormatJsonQuote64BitIntegersInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegersInput"></a>

```typescript
public readonly outputFormatJsonQuote64BitIntegersInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `outputFormatJsonQuoteDenormalsInput`<sup>Optional</sup> <a name="outputFormatJsonQuoteDenormalsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormalsInput"></a>

```typescript
public readonly outputFormatJsonQuoteDenormalsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `priorityInput`<sup>Optional</sup> <a name="priorityInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* number

---

##### `quotaModeInput`<sup>Optional</sup> <a name="quotaModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.quotaModeInput"></a>

```typescript
public readonly quotaModeInput: string;
```

- *Type:* string

---

##### `readonlyInput`<sup>Optional</sup> <a name="readonlyInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readonlyInput"></a>

```typescript
public readonly readonlyInput: number;
```

- *Type:* number

---

##### `readOverflowModeInput`<sup>Optional</sup> <a name="readOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readOverflowModeInput"></a>

```typescript
public readonly readOverflowModeInput: string;
```

- *Type:* string

---

##### `receiveTimeoutInput`<sup>Optional</sup> <a name="receiveTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeoutInput"></a>

```typescript
public readonly receiveTimeoutInput: number;
```

- *Type:* number

---

##### `replicationAlterPartitionsSyncInput`<sup>Optional</sup> <a name="replicationAlterPartitionsSyncInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSyncInput"></a>

```typescript
public readonly replicationAlterPartitionsSyncInput: number;
```

- *Type:* number

---

##### `resultOverflowModeInput`<sup>Optional</sup> <a name="resultOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowModeInput"></a>

```typescript
public readonly resultOverflowModeInput: string;
```

- *Type:* string

---

##### `selectSequentialConsistencyInput`<sup>Optional</sup> <a name="selectSequentialConsistencyInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistencyInput"></a>

```typescript
public readonly selectSequentialConsistencyInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sendProgressInHttpHeadersInput`<sup>Optional</sup> <a name="sendProgressInHttpHeadersInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeadersInput"></a>

```typescript
public readonly sendProgressInHttpHeadersInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sendTimeoutInput`<sup>Optional</sup> <a name="sendTimeoutInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendTimeoutInput"></a>

```typescript
public readonly sendTimeoutInput: number;
```

- *Type:* number

---

##### `setOverflowModeInput`<sup>Optional</sup> <a name="setOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.setOverflowModeInput"></a>

```typescript
public readonly setOverflowModeInput: string;
```

- *Type:* string

---

##### `skipUnavailableShardsInput`<sup>Optional</sup> <a name="skipUnavailableShardsInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShardsInput"></a>

```typescript
public readonly skipUnavailableShardsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sortOverflowModeInput`<sup>Optional</sup> <a name="sortOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowModeInput"></a>

```typescript
public readonly sortOverflowModeInput: string;
```

- *Type:* string

---

##### `timeoutOverflowModeInput`<sup>Optional</sup> <a name="timeoutOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowModeInput"></a>

```typescript
public readonly timeoutOverflowModeInput: string;
```

- *Type:* string

---

##### `transferOverflowModeInput`<sup>Optional</sup> <a name="transferOverflowModeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowModeInput"></a>

```typescript
public readonly transferOverflowModeInput: string;
```

- *Type:* string

---

##### `transformNullInInput`<sup>Optional</sup> <a name="transformNullInInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transformNullInInput"></a>

```typescript
public readonly transformNullInInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `useUncompressedCacheInput`<sup>Optional</sup> <a name="useUncompressedCacheInput" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCacheInput"></a>

```typescript
public readonly useUncompressedCacheInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `addHttpCorsHeader`<sup>Required</sup> <a name="addHttpCorsHeader" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.addHttpCorsHeader"></a>

```typescript
public readonly addHttpCorsHeader: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `allowDdl`<sup>Required</sup> <a name="allowDdl" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.allowDdl"></a>

```typescript
public readonly allowDdl: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compile`<sup>Required</sup> <a name="compile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compile"></a>

```typescript
public readonly compile: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compileExpressions`<sup>Required</sup> <a name="compileExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.compileExpressions"></a>

```typescript
public readonly compileExpressions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `connectTimeout`<sup>Required</sup> <a name="connectTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.connectTimeout"></a>

```typescript
public readonly connectTimeout: number;
```

- *Type:* number

---

##### `countDistinctImplementation`<sup>Required</sup> <a name="countDistinctImplementation" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.countDistinctImplementation"></a>

```typescript
public readonly countDistinctImplementation: string;
```

- *Type:* string

---

##### `distinctOverflowMode`<sup>Required</sup> <a name="distinctOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distinctOverflowMode"></a>

```typescript
public readonly distinctOverflowMode: string;
```

- *Type:* string

---

##### `distributedAggregationMemoryEfficient`<sup>Required</sup> <a name="distributedAggregationMemoryEfficient" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedAggregationMemoryEfficient"></a>

```typescript
public readonly distributedAggregationMemoryEfficient: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `distributedDdlTaskTimeout`<sup>Required</sup> <a name="distributedDdlTaskTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedDdlTaskTimeout"></a>

```typescript
public readonly distributedDdlTaskTimeout: number;
```

- *Type:* number

---

##### `distributedProductMode`<sup>Required</sup> <a name="distributedProductMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.distributedProductMode"></a>

```typescript
public readonly distributedProductMode: string;
```

- *Type:* string

---

##### `emptyResultForAggregationByEmptySet`<sup>Required</sup> <a name="emptyResultForAggregationByEmptySet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.emptyResultForAggregationByEmptySet"></a>

```typescript
public readonly emptyResultForAggregationByEmptySet: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enableHttpCompression`<sup>Required</sup> <a name="enableHttpCompression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.enableHttpCompression"></a>

```typescript
public readonly enableHttpCompression: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `fallbackToStaleReplicasForDistributedQueries`<sup>Required</sup> <a name="fallbackToStaleReplicasForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.fallbackToStaleReplicasForDistributedQueries"></a>

```typescript
public readonly fallbackToStaleReplicasForDistributedQueries: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forceIndexByDate`<sup>Required</sup> <a name="forceIndexByDate" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forceIndexByDate"></a>

```typescript
public readonly forceIndexByDate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `forcePrimaryKey`<sup>Required</sup> <a name="forcePrimaryKey" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.forcePrimaryKey"></a>

```typescript
public readonly forcePrimaryKey: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `groupByOverflowMode`<sup>Required</sup> <a name="groupByOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByOverflowMode"></a>

```typescript
public readonly groupByOverflowMode: string;
```

- *Type:* string

---

##### `groupByTwoLevelThreshold`<sup>Required</sup> <a name="groupByTwoLevelThreshold" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThreshold"></a>

```typescript
public readonly groupByTwoLevelThreshold: number;
```

- *Type:* number

---

##### `groupByTwoLevelThresholdBytes`<sup>Required</sup> <a name="groupByTwoLevelThresholdBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.groupByTwoLevelThresholdBytes"></a>

```typescript
public readonly groupByTwoLevelThresholdBytes: number;
```

- *Type:* number

---

##### `httpConnectionTimeout`<sup>Required</sup> <a name="httpConnectionTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpConnectionTimeout"></a>

```typescript
public readonly httpConnectionTimeout: number;
```

- *Type:* number

---

##### `httpHeadersProgressInterval`<sup>Required</sup> <a name="httpHeadersProgressInterval" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpHeadersProgressInterval"></a>

```typescript
public readonly httpHeadersProgressInterval: number;
```

- *Type:* number

---

##### `httpReceiveTimeout`<sup>Required</sup> <a name="httpReceiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpReceiveTimeout"></a>

```typescript
public readonly httpReceiveTimeout: number;
```

- *Type:* number

---

##### `httpSendTimeout`<sup>Required</sup> <a name="httpSendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.httpSendTimeout"></a>

```typescript
public readonly httpSendTimeout: number;
```

- *Type:* number

---

##### `inputFormatDefaultsForOmittedFields`<sup>Required</sup> <a name="inputFormatDefaultsForOmittedFields" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatDefaultsForOmittedFields"></a>

```typescript
public readonly inputFormatDefaultsForOmittedFields: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `inputFormatValuesInterpretExpressions`<sup>Required</sup> <a name="inputFormatValuesInterpretExpressions" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.inputFormatValuesInterpretExpressions"></a>

```typescript
public readonly inputFormatValuesInterpretExpressions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `insertQuorum`<sup>Required</sup> <a name="insertQuorum" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorum"></a>

```typescript
public readonly insertQuorum: number;
```

- *Type:* number

---

##### `insertQuorumTimeout`<sup>Required</sup> <a name="insertQuorumTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.insertQuorumTimeout"></a>

```typescript
public readonly insertQuorumTimeout: number;
```

- *Type:* number

---

##### `joinedSubqueryRequiresAlias`<sup>Required</sup> <a name="joinedSubqueryRequiresAlias" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinedSubqueryRequiresAlias"></a>

```typescript
public readonly joinedSubqueryRequiresAlias: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `joinOverflowMode`<sup>Required</sup> <a name="joinOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinOverflowMode"></a>

```typescript
public readonly joinOverflowMode: string;
```

- *Type:* string

---

##### `joinUseNulls`<sup>Required</sup> <a name="joinUseNulls" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.joinUseNulls"></a>

```typescript
public readonly joinUseNulls: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `lowCardinalityAllowInNativeFormat`<sup>Required</sup> <a name="lowCardinalityAllowInNativeFormat" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.lowCardinalityAllowInNativeFormat"></a>

```typescript
public readonly lowCardinalityAllowInNativeFormat: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `maxAstDepth`<sup>Required</sup> <a name="maxAstDepth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstDepth"></a>

```typescript
public readonly maxAstDepth: number;
```

- *Type:* number

---

##### `maxAstElements`<sup>Required</sup> <a name="maxAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxAstElements"></a>

```typescript
public readonly maxAstElements: number;
```

- *Type:* number

---

##### `maxBlockSize`<sup>Required</sup> <a name="maxBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBlockSize"></a>

```typescript
public readonly maxBlockSize: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalGroupBy`<sup>Required</sup> <a name="maxBytesBeforeExternalGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalGroupBy"></a>

```typescript
public readonly maxBytesBeforeExternalGroupBy: number;
```

- *Type:* number

---

##### `maxBytesBeforeExternalSort`<sup>Required</sup> <a name="maxBytesBeforeExternalSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesBeforeExternalSort"></a>

```typescript
public readonly maxBytesBeforeExternalSort: number;
```

- *Type:* number

---

##### `maxBytesInDistinct`<sup>Required</sup> <a name="maxBytesInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInDistinct"></a>

```typescript
public readonly maxBytesInDistinct: number;
```

- *Type:* number

---

##### `maxBytesInJoin`<sup>Required</sup> <a name="maxBytesInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInJoin"></a>

```typescript
public readonly maxBytesInJoin: number;
```

- *Type:* number

---

##### `maxBytesInSet`<sup>Required</sup> <a name="maxBytesInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesInSet"></a>

```typescript
public readonly maxBytesInSet: number;
```

- *Type:* number

---

##### `maxBytesToRead`<sup>Required</sup> <a name="maxBytesToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToRead"></a>

```typescript
public readonly maxBytesToRead: number;
```

- *Type:* number

---

##### `maxBytesToSort`<sup>Required</sup> <a name="maxBytesToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToSort"></a>

```typescript
public readonly maxBytesToSort: number;
```

- *Type:* number

---

##### `maxBytesToTransfer`<sup>Required</sup> <a name="maxBytesToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxBytesToTransfer"></a>

```typescript
public readonly maxBytesToTransfer: number;
```

- *Type:* number

---

##### `maxColumnsToRead`<sup>Required</sup> <a name="maxColumnsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxColumnsToRead"></a>

```typescript
public readonly maxColumnsToRead: number;
```

- *Type:* number

---

##### `maxExecutionTime`<sup>Required</sup> <a name="maxExecutionTime" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExecutionTime"></a>

```typescript
public readonly maxExecutionTime: number;
```

- *Type:* number

---

##### `maxExpandedAstElements`<sup>Required</sup> <a name="maxExpandedAstElements" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxExpandedAstElements"></a>

```typescript
public readonly maxExpandedAstElements: number;
```

- *Type:* number

---

##### `maxInsertBlockSize`<sup>Required</sup> <a name="maxInsertBlockSize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxInsertBlockSize"></a>

```typescript
public readonly maxInsertBlockSize: number;
```

- *Type:* number

---

##### `maxMemoryUsage`<sup>Required</sup> <a name="maxMemoryUsage" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsage"></a>

```typescript
public readonly maxMemoryUsage: number;
```

- *Type:* number

---

##### `maxMemoryUsageForUser`<sup>Required</sup> <a name="maxMemoryUsageForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxMemoryUsageForUser"></a>

```typescript
public readonly maxMemoryUsageForUser: number;
```

- *Type:* number

---

##### `maxNetworkBandwidth`<sup>Required</sup> <a name="maxNetworkBandwidth" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidth"></a>

```typescript
public readonly maxNetworkBandwidth: number;
```

- *Type:* number

---

##### `maxNetworkBandwidthForUser`<sup>Required</sup> <a name="maxNetworkBandwidthForUser" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxNetworkBandwidthForUser"></a>

```typescript
public readonly maxNetworkBandwidthForUser: number;
```

- *Type:* number

---

##### `maxQuerySize`<sup>Required</sup> <a name="maxQuerySize" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxQuerySize"></a>

```typescript
public readonly maxQuerySize: number;
```

- *Type:* number

---

##### `maxReplicaDelayForDistributedQueries`<sup>Required</sup> <a name="maxReplicaDelayForDistributedQueries" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxReplicaDelayForDistributedQueries"></a>

```typescript
public readonly maxReplicaDelayForDistributedQueries: number;
```

- *Type:* number

---

##### `maxResultBytes`<sup>Required</sup> <a name="maxResultBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultBytes"></a>

```typescript
public readonly maxResultBytes: number;
```

- *Type:* number

---

##### `maxResultRows`<sup>Required</sup> <a name="maxResultRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxResultRows"></a>

```typescript
public readonly maxResultRows: number;
```

- *Type:* number

---

##### `maxRowsInDistinct`<sup>Required</sup> <a name="maxRowsInDistinct" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInDistinct"></a>

```typescript
public readonly maxRowsInDistinct: number;
```

- *Type:* number

---

##### `maxRowsInJoin`<sup>Required</sup> <a name="maxRowsInJoin" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInJoin"></a>

```typescript
public readonly maxRowsInJoin: number;
```

- *Type:* number

---

##### `maxRowsInSet`<sup>Required</sup> <a name="maxRowsInSet" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsInSet"></a>

```typescript
public readonly maxRowsInSet: number;
```

- *Type:* number

---

##### `maxRowsToGroupBy`<sup>Required</sup> <a name="maxRowsToGroupBy" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToGroupBy"></a>

```typescript
public readonly maxRowsToGroupBy: number;
```

- *Type:* number

---

##### `maxRowsToRead`<sup>Required</sup> <a name="maxRowsToRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToRead"></a>

```typescript
public readonly maxRowsToRead: number;
```

- *Type:* number

---

##### `maxRowsToSort`<sup>Required</sup> <a name="maxRowsToSort" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToSort"></a>

```typescript
public readonly maxRowsToSort: number;
```

- *Type:* number

---

##### `maxRowsToTransfer`<sup>Required</sup> <a name="maxRowsToTransfer" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxRowsToTransfer"></a>

```typescript
public readonly maxRowsToTransfer: number;
```

- *Type:* number

---

##### `maxTemporaryColumns`<sup>Required</sup> <a name="maxTemporaryColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryColumns"></a>

```typescript
public readonly maxTemporaryColumns: number;
```

- *Type:* number

---

##### `maxTemporaryNonConstColumns`<sup>Required</sup> <a name="maxTemporaryNonConstColumns" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxTemporaryNonConstColumns"></a>

```typescript
public readonly maxTemporaryNonConstColumns: number;
```

- *Type:* number

---

##### `maxThreads`<sup>Required</sup> <a name="maxThreads" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.maxThreads"></a>

```typescript
public readonly maxThreads: number;
```

- *Type:* number

---

##### `mergeTreeMaxBytesToUseCache`<sup>Required</sup> <a name="mergeTreeMaxBytesToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxBytesToUseCache"></a>

```typescript
public readonly mergeTreeMaxBytesToUseCache: number;
```

- *Type:* number

---

##### `mergeTreeMaxRowsToUseCache`<sup>Required</sup> <a name="mergeTreeMaxRowsToUseCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMaxRowsToUseCache"></a>

```typescript
public readonly mergeTreeMaxRowsToUseCache: number;
```

- *Type:* number

---

##### `mergeTreeMinBytesForConcurrentRead`<sup>Required</sup> <a name="mergeTreeMinBytesForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinBytesForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinBytesForConcurrentRead: number;
```

- *Type:* number

---

##### `mergeTreeMinRowsForConcurrentRead`<sup>Required</sup> <a name="mergeTreeMinRowsForConcurrentRead" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.mergeTreeMinRowsForConcurrentRead"></a>

```typescript
public readonly mergeTreeMinRowsForConcurrentRead: number;
```

- *Type:* number

---

##### `minBytesToUseDirectIo`<sup>Required</sup> <a name="minBytesToUseDirectIo" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minBytesToUseDirectIo"></a>

```typescript
public readonly minBytesToUseDirectIo: number;
```

- *Type:* number

---

##### `minCountToCompile`<sup>Required</sup> <a name="minCountToCompile" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompile"></a>

```typescript
public readonly minCountToCompile: number;
```

- *Type:* number

---

##### `minCountToCompileExpression`<sup>Required</sup> <a name="minCountToCompileExpression" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minCountToCompileExpression"></a>

```typescript
public readonly minCountToCompileExpression: number;
```

- *Type:* number

---

##### `minExecutionSpeed`<sup>Required</sup> <a name="minExecutionSpeed" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeed"></a>

```typescript
public readonly minExecutionSpeed: number;
```

- *Type:* number

---

##### `minExecutionSpeedBytes`<sup>Required</sup> <a name="minExecutionSpeedBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minExecutionSpeedBytes"></a>

```typescript
public readonly minExecutionSpeedBytes: number;
```

- *Type:* number

---

##### `minInsertBlockSizeBytes`<sup>Required</sup> <a name="minInsertBlockSizeBytes" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeBytes"></a>

```typescript
public readonly minInsertBlockSizeBytes: number;
```

- *Type:* number

---

##### `minInsertBlockSizeRows`<sup>Required</sup> <a name="minInsertBlockSizeRows" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.minInsertBlockSizeRows"></a>

```typescript
public readonly minInsertBlockSizeRows: number;
```

- *Type:* number

---

##### `outputFormatJsonQuote64BitIntegers`<sup>Required</sup> <a name="outputFormatJsonQuote64BitIntegers" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuote64BitIntegers"></a>

```typescript
public readonly outputFormatJsonQuote64BitIntegers: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `outputFormatJsonQuoteDenormals`<sup>Required</sup> <a name="outputFormatJsonQuoteDenormals" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.outputFormatJsonQuoteDenormals"></a>

```typescript
public readonly outputFormatJsonQuoteDenormals: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `quotaMode`<sup>Required</sup> <a name="quotaMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.quotaMode"></a>

```typescript
public readonly quotaMode: string;
```

- *Type:* string

---

##### `readonly`<sup>Required</sup> <a name="readonly" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readonly"></a>

```typescript
public readonly readonly: number;
```

- *Type:* number

---

##### `readOverflowMode`<sup>Required</sup> <a name="readOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.readOverflowMode"></a>

```typescript
public readonly readOverflowMode: string;
```

- *Type:* string

---

##### `receiveTimeout`<sup>Required</sup> <a name="receiveTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.receiveTimeout"></a>

```typescript
public readonly receiveTimeout: number;
```

- *Type:* number

---

##### `replicationAlterPartitionsSync`<sup>Required</sup> <a name="replicationAlterPartitionsSync" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.replicationAlterPartitionsSync"></a>

```typescript
public readonly replicationAlterPartitionsSync: number;
```

- *Type:* number

---

##### `resultOverflowMode`<sup>Required</sup> <a name="resultOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.resultOverflowMode"></a>

```typescript
public readonly resultOverflowMode: string;
```

- *Type:* string

---

##### `selectSequentialConsistency`<sup>Required</sup> <a name="selectSequentialConsistency" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.selectSequentialConsistency"></a>

```typescript
public readonly selectSequentialConsistency: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sendProgressInHttpHeaders`<sup>Required</sup> <a name="sendProgressInHttpHeaders" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendProgressInHttpHeaders"></a>

```typescript
public readonly sendProgressInHttpHeaders: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sendTimeout`<sup>Required</sup> <a name="sendTimeout" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sendTimeout"></a>

```typescript
public readonly sendTimeout: number;
```

- *Type:* number

---

##### `setOverflowMode`<sup>Required</sup> <a name="setOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.setOverflowMode"></a>

```typescript
public readonly setOverflowMode: string;
```

- *Type:* string

---

##### `skipUnavailableShards`<sup>Required</sup> <a name="skipUnavailableShards" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.skipUnavailableShards"></a>

```typescript
public readonly skipUnavailableShards: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sortOverflowMode`<sup>Required</sup> <a name="sortOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.sortOverflowMode"></a>

```typescript
public readonly sortOverflowMode: string;
```

- *Type:* string

---

##### `timeoutOverflowMode`<sup>Required</sup> <a name="timeoutOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.timeoutOverflowMode"></a>

```typescript
public readonly timeoutOverflowMode: string;
```

- *Type:* string

---

##### `transferOverflowMode`<sup>Required</sup> <a name="transferOverflowMode" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transferOverflowMode"></a>

```typescript
public readonly transferOverflowMode: string;
```

- *Type:* string

---

##### `transformNullIn`<sup>Required</sup> <a name="transformNullIn" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.transformNullIn"></a>

```typescript
public readonly transformNullIn: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `useUncompressedCache`<sup>Required</sup> <a name="useUncompressedCache" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.useUncompressedCache"></a>

```typescript
public readonly useUncompressedCache: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterUserSettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterUserSettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterUserSettings">MdbClickhouseClusterUserSettings</a>

---


### MdbClickhouseClusterZookeeperOutputReference <a name="MdbClickhouseClusterZookeeperOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterZookeeperOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterZookeeperOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.resetResources">resetResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.putResources"></a>

```typescript
public putResources(value: MdbClickhouseClusterZookeeperResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a>

---

##### `resetResources` <a name="resetResources" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.resetResources"></a>

```typescript
public resetResources(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference">MdbClickhouseClusterZookeeperResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbClickhouseClusterZookeeperResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference">MdbClickhouseClusterZookeeperResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbClickhouseClusterZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeper">MdbClickhouseClusterZookeeper</a>

---


### MdbClickhouseClusterZookeeperResourcesOutputReference <a name="MdbClickhouseClusterZookeeperResourcesOutputReference" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.Initializer"></a>

```typescript
import { MdbClickhouseClusterZookeeperResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbClickhouseClusterZookeeperResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetDiskSize">resetDiskSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetResourcePresetId">resetResourcePresetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskSize` <a name="resetDiskSize" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetDiskSize"></a>

```typescript
public resetDiskSize(): void
```

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```

##### `resetResourcePresetId` <a name="resetResourcePresetId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.resetResourcePresetId"></a>

```typescript
public resetResourcePresetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbClickhouseClusterZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbClickhouseClusterZookeeperResources">MdbClickhouseClusterZookeeperResources</a>

---


### MdbElasticsearchClusterConfigAOutputReference <a name="MdbElasticsearchClusterConfigAOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putDataNode">putDataNode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putMasterNode">putMasterNode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetEdition">resetEdition</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetMasterNode">resetMasterNode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetPlugins">resetPlugins</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetVersion">resetVersion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putDataNode` <a name="putDataNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putDataNode"></a>

```typescript
public putDataNode(value: MdbElasticsearchClusterConfigDataNode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putDataNode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a>

---

##### `putMasterNode` <a name="putMasterNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putMasterNode"></a>

```typescript
public putMasterNode(value: MdbElasticsearchClusterConfigMasterNode): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.putMasterNode.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a>

---

##### `resetEdition` <a name="resetEdition" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetEdition"></a>

```typescript
public resetEdition(): void
```

##### `resetMasterNode` <a name="resetMasterNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetMasterNode"></a>

```typescript
public resetMasterNode(): void
```

##### `resetPlugins` <a name="resetPlugins" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetPlugins"></a>

```typescript
public resetPlugins(): void
```

##### `resetVersion` <a name="resetVersion" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.resetVersion"></a>

```typescript
public resetVersion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.dataNode">dataNode</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference">MdbElasticsearchClusterConfigDataNodeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.masterNode">masterNode</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference">MdbElasticsearchClusterConfigMasterNodeOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.adminPasswordInput">adminPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.dataNodeInput">dataNodeInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.editionInput">editionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.masterNodeInput">masterNodeInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.pluginsInput">pluginsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.adminPassword">adminPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.edition">edition</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.plugins">plugins</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataNode`<sup>Required</sup> <a name="dataNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.dataNode"></a>

```typescript
public readonly dataNode: MdbElasticsearchClusterConfigDataNodeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference">MdbElasticsearchClusterConfigDataNodeOutputReference</a>

---

##### `masterNode`<sup>Required</sup> <a name="masterNode" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.masterNode"></a>

```typescript
public readonly masterNode: MdbElasticsearchClusterConfigMasterNodeOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference">MdbElasticsearchClusterConfigMasterNodeOutputReference</a>

---

##### `adminPasswordInput`<sup>Optional</sup> <a name="adminPasswordInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.adminPasswordInput"></a>

```typescript
public readonly adminPasswordInput: string;
```

- *Type:* string

---

##### `dataNodeInput`<sup>Optional</sup> <a name="dataNodeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.dataNodeInput"></a>

```typescript
public readonly dataNodeInput: MdbElasticsearchClusterConfigDataNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a>

---

##### `editionInput`<sup>Optional</sup> <a name="editionInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.editionInput"></a>

```typescript
public readonly editionInput: string;
```

- *Type:* string

---

##### `masterNodeInput`<sup>Optional</sup> <a name="masterNodeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.masterNodeInput"></a>

```typescript
public readonly masterNodeInput: MdbElasticsearchClusterConfigMasterNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a>

---

##### `pluginsInput`<sup>Optional</sup> <a name="pluginsInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.pluginsInput"></a>

```typescript
public readonly pluginsInput: string[];
```

- *Type:* string[]

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `adminPassword`<sup>Required</sup> <a name="adminPassword" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.adminPassword"></a>

```typescript
public readonly adminPassword: string;
```

- *Type:* string

---

##### `edition`<sup>Required</sup> <a name="edition" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.edition"></a>

```typescript
public readonly edition: string;
```

- *Type:* string

---

##### `plugins`<sup>Required</sup> <a name="plugins" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.plugins"></a>

```typescript
public readonly plugins: string[];
```

- *Type:* string[]

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigA">MdbElasticsearchClusterConfigA</a>

---


### MdbElasticsearchClusterConfigDataNodeOutputReference <a name="MdbElasticsearchClusterConfigDataNodeOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigDataNodeOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterConfigDataNodeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.putResources">putResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.putResources"></a>

```typescript
public putResources(value: MdbElasticsearchClusterConfigDataNodeResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference">MdbElasticsearchClusterConfigDataNodeResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbElasticsearchClusterConfigDataNodeResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference">MdbElasticsearchClusterConfigDataNodeResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbElasticsearchClusterConfigDataNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterConfigDataNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNode">MdbElasticsearchClusterConfigDataNode</a>

---


### MdbElasticsearchClusterConfigDataNodeResourcesOutputReference <a name="MdbElasticsearchClusterConfigDataNodeResourcesOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigDataNodeResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterConfigDataNodeResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterConfigDataNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigDataNodeResources">MdbElasticsearchClusterConfigDataNodeResources</a>

---


### MdbElasticsearchClusterConfigMasterNodeOutputReference <a name="MdbElasticsearchClusterConfigMasterNodeOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigMasterNodeOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterConfigMasterNodeOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.putResources">putResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.putResources"></a>

```typescript
public putResources(value: MdbElasticsearchClusterConfigMasterNodeResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference">MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference">MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbElasticsearchClusterConfigMasterNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterConfigMasterNode;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNode">MdbElasticsearchClusterConfigMasterNode</a>

---


### MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference <a name="MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterConfigMasterNodeResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterConfigMasterNodeResources">MdbElasticsearchClusterConfigMasterNodeResources</a>

---


### MdbElasticsearchClusterHostList <a name="MdbElasticsearchClusterHostList" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer"></a>

```typescript
import { MdbElasticsearchClusterHostList } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.get"></a>

```typescript
public get(index: number): MdbElasticsearchClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbElasticsearchClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>[]

---


### MdbElasticsearchClusterHostOutputReference <a name="MdbElasticsearchClusterHostOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbElasticsearchClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterHost">MdbElasticsearchClusterHost</a>

---


### MdbElasticsearchClusterMaintenanceWindowOutputReference <a name="MdbElasticsearchClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbElasticsearchClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterMaintenanceWindow">MdbElasticsearchClusterMaintenanceWindow</a>

---


### MdbElasticsearchClusterTimeoutsOutputReference <a name="MdbElasticsearchClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbElasticsearchClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbElasticsearchClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbElasticsearchClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbElasticsearchClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbElasticsearchClusterTimeouts">MdbElasticsearchClusterTimeouts</a>

---


### MdbGreenplumClusterAccessOutputReference <a name="MdbGreenplumClusterAccessOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterAccessOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resetDataLens">resetDataLens</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resetWebSql">resetWebSql</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDataLens` <a name="resetDataLens" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resetDataLens"></a>

```typescript
public resetDataLens(): void
```

##### `resetWebSql` <a name="resetWebSql" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.resetWebSql"></a>

```typescript
public resetWebSql(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.dataLensInput">dataLensInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.webSqlInput">webSqlInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLensInput`<sup>Optional</sup> <a name="dataLensInput" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.dataLensInput"></a>

```typescript
public readonly dataLensInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSqlInput`<sup>Optional</sup> <a name="webSqlInput" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.webSqlInput"></a>

```typescript
public readonly webSqlInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterAccess">MdbGreenplumClusterAccess</a>

---


### MdbGreenplumClusterBackupWindowStartOutputReference <a name="MdbGreenplumClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterBackupWindowStart">MdbGreenplumClusterBackupWindowStart</a>

---


### MdbGreenplumClusterMasterHostsList <a name="MdbGreenplumClusterMasterHostsList" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterHostsList } from '@cdktf/provider-yandex'

new MdbGreenplumClusterMasterHostsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.get"></a>

```typescript
public get(index: number): MdbGreenplumClusterMasterHostsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### MdbGreenplumClusterMasterHostsOutputReference <a name="MdbGreenplumClusterMasterHostsOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterHostsOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterMasterHostsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHosts">MdbGreenplumClusterMasterHosts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterHostsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterMasterHosts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterHosts">MdbGreenplumClusterMasterHosts</a>

---


### MdbGreenplumClusterMasterSubclusterOutputReference <a name="MdbGreenplumClusterMasterSubclusterOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterSubclusterOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterMasterSubclusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.putResources">putResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.putResources"></a>

```typescript
public putResources(value: MdbGreenplumClusterMasterSubclusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference">MdbGreenplumClusterMasterSubclusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbGreenplumClusterMasterSubclusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference">MdbGreenplumClusterMasterSubclusterResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbGreenplumClusterMasterSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterMasterSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubcluster">MdbGreenplumClusterMasterSubcluster</a>

---


### MdbGreenplumClusterMasterSubclusterResourcesOutputReference <a name="MdbGreenplumClusterMasterSubclusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterMasterSubclusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterMasterSubclusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterMasterSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterMasterSubclusterResources">MdbGreenplumClusterMasterSubclusterResources</a>

---


### MdbGreenplumClusterSegmentHostsList <a name="MdbGreenplumClusterSegmentHostsList" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentHostsList } from '@cdktf/provider-yandex'

new MdbGreenplumClusterSegmentHostsList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.get"></a>

```typescript
public get(index: number): MdbGreenplumClusterSegmentHostsOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### MdbGreenplumClusterSegmentHostsOutputReference <a name="MdbGreenplumClusterSegmentHostsOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentHostsOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterSegmentHostsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHosts">MdbGreenplumClusterSegmentHosts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentHostsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterSegmentHosts;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentHosts">MdbGreenplumClusterSegmentHosts</a>

---


### MdbGreenplumClusterSegmentSubclusterOutputReference <a name="MdbGreenplumClusterSegmentSubclusterOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentSubclusterOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterSegmentSubclusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.putResources">putResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.putResources"></a>

```typescript
public putResources(value: MdbGreenplumClusterSegmentSubclusterResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference">MdbGreenplumClusterSegmentSubclusterResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbGreenplumClusterSegmentSubclusterResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference">MdbGreenplumClusterSegmentSubclusterResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbGreenplumClusterSegmentSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterSegmentSubcluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubcluster">MdbGreenplumClusterSegmentSubcluster</a>

---


### MdbGreenplumClusterSegmentSubclusterResourcesOutputReference <a name="MdbGreenplumClusterSegmentSubclusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterSegmentSubclusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterSegmentSubclusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbGreenplumClusterSegmentSubclusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbGreenplumClusterSegmentSubclusterResources">MdbGreenplumClusterSegmentSubclusterResources</a>

---


### MdbGreenplumClusterTimeoutsOutputReference <a name="MdbGreenplumClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbGreenplumClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbGreenplumClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbGreenplumClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbGreenplumClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbGreenplumClusterTimeouts">MdbGreenplumClusterTimeouts</a>

---


### MdbKafkaClusterConfigAOutputReference <a name="MdbKafkaClusterConfigAOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putKafka">putKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putZookeeper">putZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetBrokersCount">resetBrokersCount</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetSchemaRegistry">resetSchemaRegistry</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetUnmanagedTopics">resetUnmanagedTopics</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetZookeeper">resetZookeeper</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putKafka` <a name="putKafka" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putKafka"></a>

```typescript
public putKafka(value: MdbKafkaClusterConfigKafka): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putKafka.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a>

---

##### `putZookeeper` <a name="putZookeeper" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putZookeeper"></a>

```typescript
public putZookeeper(value: MdbKafkaClusterConfigZookeeper): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.putZookeeper.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a>

---

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetBrokersCount` <a name="resetBrokersCount" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetBrokersCount"></a>

```typescript
public resetBrokersCount(): void
```

##### `resetSchemaRegistry` <a name="resetSchemaRegistry" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetSchemaRegistry"></a>

```typescript
public resetSchemaRegistry(): void
```

##### `resetUnmanagedTopics` <a name="resetUnmanagedTopics" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetUnmanagedTopics"></a>

```typescript
public resetUnmanagedTopics(): void
```

##### `resetZookeeper` <a name="resetZookeeper" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.resetZookeeper"></a>

```typescript
public resetZookeeper(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.kafka">kafka</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference">MdbKafkaClusterConfigKafkaOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zookeeper">zookeeper</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference">MdbKafkaClusterConfigZookeeperOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.brokersCountInput">brokersCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.kafkaInput">kafkaInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.schemaRegistryInput">schemaRegistryInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.unmanagedTopicsInput">unmanagedTopicsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zonesInput">zonesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zookeeperInput">zookeeperInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.brokersCount">brokersCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.schemaRegistry">schemaRegistry</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.unmanagedTopics">unmanagedTopics</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zones">zones</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `kafka`<sup>Required</sup> <a name="kafka" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.kafka"></a>

```typescript
public readonly kafka: MdbKafkaClusterConfigKafkaOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference">MdbKafkaClusterConfigKafkaOutputReference</a>

---

##### `zookeeper`<sup>Required</sup> <a name="zookeeper" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zookeeper"></a>

```typescript
public readonly zookeeper: MdbKafkaClusterConfigZookeeperOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference">MdbKafkaClusterConfigZookeeperOutputReference</a>

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `brokersCountInput`<sup>Optional</sup> <a name="brokersCountInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.brokersCountInput"></a>

```typescript
public readonly brokersCountInput: number;
```

- *Type:* number

---

##### `kafkaInput`<sup>Optional</sup> <a name="kafkaInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.kafkaInput"></a>

```typescript
public readonly kafkaInput: MdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a>

---

##### `schemaRegistryInput`<sup>Optional</sup> <a name="schemaRegistryInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.schemaRegistryInput"></a>

```typescript
public readonly schemaRegistryInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `unmanagedTopicsInput`<sup>Optional</sup> <a name="unmanagedTopicsInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.unmanagedTopicsInput"></a>

```typescript
public readonly unmanagedTopicsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `zonesInput`<sup>Optional</sup> <a name="zonesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zonesInput"></a>

```typescript
public readonly zonesInput: string[];
```

- *Type:* string[]

---

##### `zookeeperInput`<sup>Optional</sup> <a name="zookeeperInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zookeeperInput"></a>

```typescript
public readonly zookeeperInput: MdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a>

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `brokersCount`<sup>Required</sup> <a name="brokersCount" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.brokersCount"></a>

```typescript
public readonly brokersCount: number;
```

- *Type:* number

---

##### `schemaRegistry`<sup>Required</sup> <a name="schemaRegistry" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.schemaRegistry"></a>

```typescript
public readonly schemaRegistry: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `unmanagedTopics`<sup>Required</sup> <a name="unmanagedTopics" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.unmanagedTopics"></a>

```typescript
public readonly unmanagedTopics: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `zones`<sup>Required</sup> <a name="zones" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.zones"></a>

```typescript
public readonly zones: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigA">MdbKafkaClusterConfigA</a>

---


### MdbKafkaClusterConfigKafkaKafkaConfigOutputReference <a name="MdbKafkaClusterConfigKafkaKafkaConfigOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafkaKafkaConfigOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigKafkaKafkaConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetAutoCreateTopicsEnable">resetAutoCreateTopicsEnable</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetCompressionType">resetCompressionType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetDefaultReplicationFactor">resetDefaultReplicationFactor</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMessages">resetLogFlushIntervalMessages</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMs">resetLogFlushIntervalMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushSchedulerIntervalMs">resetLogFlushSchedulerIntervalMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogPreallocate">resetLogPreallocate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionBytes">resetLogRetentionBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionHours">resetLogRetentionHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMinutes">resetLogRetentionMinutes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMs">resetLogRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogSegmentBytes">resetLogSegmentBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetNumPartitions">resetNumPartitions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketReceiveBufferBytes">resetSocketReceiveBufferBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketSendBufferBytes">resetSocketSendBufferBytes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAutoCreateTopicsEnable` <a name="resetAutoCreateTopicsEnable" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetAutoCreateTopicsEnable"></a>

```typescript
public resetAutoCreateTopicsEnable(): void
```

##### `resetCompressionType` <a name="resetCompressionType" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetCompressionType"></a>

```typescript
public resetCompressionType(): void
```

##### `resetDefaultReplicationFactor` <a name="resetDefaultReplicationFactor" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetDefaultReplicationFactor"></a>

```typescript
public resetDefaultReplicationFactor(): void
```

##### `resetLogFlushIntervalMessages` <a name="resetLogFlushIntervalMessages" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMessages"></a>

```typescript
public resetLogFlushIntervalMessages(): void
```

##### `resetLogFlushIntervalMs` <a name="resetLogFlushIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushIntervalMs"></a>

```typescript
public resetLogFlushIntervalMs(): void
```

##### `resetLogFlushSchedulerIntervalMs` <a name="resetLogFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogFlushSchedulerIntervalMs"></a>

```typescript
public resetLogFlushSchedulerIntervalMs(): void
```

##### `resetLogPreallocate` <a name="resetLogPreallocate" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogPreallocate"></a>

```typescript
public resetLogPreallocate(): void
```

##### `resetLogRetentionBytes` <a name="resetLogRetentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionBytes"></a>

```typescript
public resetLogRetentionBytes(): void
```

##### `resetLogRetentionHours` <a name="resetLogRetentionHours" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionHours"></a>

```typescript
public resetLogRetentionHours(): void
```

##### `resetLogRetentionMinutes` <a name="resetLogRetentionMinutes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMinutes"></a>

```typescript
public resetLogRetentionMinutes(): void
```

##### `resetLogRetentionMs` <a name="resetLogRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogRetentionMs"></a>

```typescript
public resetLogRetentionMs(): void
```

##### `resetLogSegmentBytes` <a name="resetLogSegmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetLogSegmentBytes"></a>

```typescript
public resetLogSegmentBytes(): void
```

##### `resetNumPartitions` <a name="resetNumPartitions" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetNumPartitions"></a>

```typescript
public resetNumPartitions(): void
```

##### `resetSocketReceiveBufferBytes` <a name="resetSocketReceiveBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketReceiveBufferBytes"></a>

```typescript
public resetSocketReceiveBufferBytes(): void
```

##### `resetSocketSendBufferBytes` <a name="resetSocketSendBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.resetSocketSendBufferBytes"></a>

```typescript
public resetSocketSendBufferBytes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnableInput">autoCreateTopicsEnableInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionTypeInput">compressionTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactorInput">defaultReplicationFactorInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessagesInput">logFlushIntervalMessagesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMsInput">logFlushIntervalMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMsInput">logFlushSchedulerIntervalMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocateInput">logPreallocateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytesInput">logRetentionBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHoursInput">logRetentionHoursInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutesInput">logRetentionMinutesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMsInput">logRetentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytesInput">logSegmentBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitionsInput">numPartitionsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytesInput">socketReceiveBufferBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytesInput">socketSendBufferBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnable">autoCreateTopicsEnable</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactor">defaultReplicationFactor</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessages">logFlushIntervalMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMs">logFlushIntervalMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMs">logFlushSchedulerIntervalMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocate">logPreallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytes">logRetentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHours">logRetentionHours</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutes">logRetentionMinutes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMs">logRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytes">logSegmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitions">numPartitions</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytes">socketReceiveBufferBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytes">socketSendBufferBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `autoCreateTopicsEnableInput`<sup>Optional</sup> <a name="autoCreateTopicsEnableInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnableInput"></a>

```typescript
public readonly autoCreateTopicsEnableInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compressionTypeInput`<sup>Optional</sup> <a name="compressionTypeInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionTypeInput"></a>

```typescript
public readonly compressionTypeInput: string;
```

- *Type:* string

---

##### `defaultReplicationFactorInput`<sup>Optional</sup> <a name="defaultReplicationFactorInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactorInput"></a>

```typescript
public readonly defaultReplicationFactorInput: string;
```

- *Type:* string

---

##### `logFlushIntervalMessagesInput`<sup>Optional</sup> <a name="logFlushIntervalMessagesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessagesInput"></a>

```typescript
public readonly logFlushIntervalMessagesInput: string;
```

- *Type:* string

---

##### `logFlushIntervalMsInput`<sup>Optional</sup> <a name="logFlushIntervalMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMsInput"></a>

```typescript
public readonly logFlushIntervalMsInput: string;
```

- *Type:* string

---

##### `logFlushSchedulerIntervalMsInput`<sup>Optional</sup> <a name="logFlushSchedulerIntervalMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMsInput"></a>

```typescript
public readonly logFlushSchedulerIntervalMsInput: string;
```

- *Type:* string

---

##### `logPreallocateInput`<sup>Optional</sup> <a name="logPreallocateInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocateInput"></a>

```typescript
public readonly logPreallocateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `logRetentionBytesInput`<sup>Optional</sup> <a name="logRetentionBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytesInput"></a>

```typescript
public readonly logRetentionBytesInput: string;
```

- *Type:* string

---

##### `logRetentionHoursInput`<sup>Optional</sup> <a name="logRetentionHoursInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHoursInput"></a>

```typescript
public readonly logRetentionHoursInput: string;
```

- *Type:* string

---

##### `logRetentionMinutesInput`<sup>Optional</sup> <a name="logRetentionMinutesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutesInput"></a>

```typescript
public readonly logRetentionMinutesInput: string;
```

- *Type:* string

---

##### `logRetentionMsInput`<sup>Optional</sup> <a name="logRetentionMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMsInput"></a>

```typescript
public readonly logRetentionMsInput: string;
```

- *Type:* string

---

##### `logSegmentBytesInput`<sup>Optional</sup> <a name="logSegmentBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytesInput"></a>

```typescript
public readonly logSegmentBytesInput: string;
```

- *Type:* string

---

##### `numPartitionsInput`<sup>Optional</sup> <a name="numPartitionsInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitionsInput"></a>

```typescript
public readonly numPartitionsInput: string;
```

- *Type:* string

---

##### `socketReceiveBufferBytesInput`<sup>Optional</sup> <a name="socketReceiveBufferBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytesInput"></a>

```typescript
public readonly socketReceiveBufferBytesInput: string;
```

- *Type:* string

---

##### `socketSendBufferBytesInput`<sup>Optional</sup> <a name="socketSendBufferBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytesInput"></a>

```typescript
public readonly socketSendBufferBytesInput: string;
```

- *Type:* string

---

##### `autoCreateTopicsEnable`<sup>Required</sup> <a name="autoCreateTopicsEnable" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.autoCreateTopicsEnable"></a>

```typescript
public readonly autoCreateTopicsEnable: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `defaultReplicationFactor`<sup>Required</sup> <a name="defaultReplicationFactor" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.defaultReplicationFactor"></a>

```typescript
public readonly defaultReplicationFactor: string;
```

- *Type:* string

---

##### `logFlushIntervalMessages`<sup>Required</sup> <a name="logFlushIntervalMessages" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMessages"></a>

```typescript
public readonly logFlushIntervalMessages: string;
```

- *Type:* string

---

##### `logFlushIntervalMs`<sup>Required</sup> <a name="logFlushIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushIntervalMs"></a>

```typescript
public readonly logFlushIntervalMs: string;
```

- *Type:* string

---

##### `logFlushSchedulerIntervalMs`<sup>Required</sup> <a name="logFlushSchedulerIntervalMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logFlushSchedulerIntervalMs"></a>

```typescript
public readonly logFlushSchedulerIntervalMs: string;
```

- *Type:* string

---

##### `logPreallocate`<sup>Required</sup> <a name="logPreallocate" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logPreallocate"></a>

```typescript
public readonly logPreallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `logRetentionBytes`<sup>Required</sup> <a name="logRetentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionBytes"></a>

```typescript
public readonly logRetentionBytes: string;
```

- *Type:* string

---

##### `logRetentionHours`<sup>Required</sup> <a name="logRetentionHours" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionHours"></a>

```typescript
public readonly logRetentionHours: string;
```

- *Type:* string

---

##### `logRetentionMinutes`<sup>Required</sup> <a name="logRetentionMinutes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMinutes"></a>

```typescript
public readonly logRetentionMinutes: string;
```

- *Type:* string

---

##### `logRetentionMs`<sup>Required</sup> <a name="logRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logRetentionMs"></a>

```typescript
public readonly logRetentionMs: string;
```

- *Type:* string

---

##### `logSegmentBytes`<sup>Required</sup> <a name="logSegmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.logSegmentBytes"></a>

```typescript
public readonly logSegmentBytes: string;
```

- *Type:* string

---

##### `numPartitions`<sup>Required</sup> <a name="numPartitions" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.numPartitions"></a>

```typescript
public readonly numPartitions: string;
```

- *Type:* string

---

##### `socketReceiveBufferBytes`<sup>Required</sup> <a name="socketReceiveBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketReceiveBufferBytes"></a>

```typescript
public readonly socketReceiveBufferBytes: string;
```

- *Type:* string

---

##### `socketSendBufferBytes`<sup>Required</sup> <a name="socketSendBufferBytes" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.socketSendBufferBytes"></a>

```typescript
public readonly socketSendBufferBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a>

---


### MdbKafkaClusterConfigKafkaOutputReference <a name="MdbKafkaClusterConfigKafkaOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafkaOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigKafkaOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig">putKafkaConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.resetKafkaConfig">resetKafkaConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putKafkaConfig` <a name="putKafkaConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig"></a>

```typescript
public putKafkaConfig(value: MdbKafkaClusterConfigKafkaKafkaConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putKafkaConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putResources"></a>

```typescript
public putResources(value: MdbKafkaClusterConfigKafkaResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a>

---

##### `resetKafkaConfig` <a name="resetKafkaConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.resetKafkaConfig"></a>

```typescript
public resetKafkaConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfig">kafkaConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference">MdbKafkaClusterConfigKafkaKafkaConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference">MdbKafkaClusterConfigKafkaResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfigInput">kafkaConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `kafkaConfig`<sup>Required</sup> <a name="kafkaConfig" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfig"></a>

```typescript
public readonly kafkaConfig: MdbKafkaClusterConfigKafkaKafkaConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfigOutputReference">MdbKafkaClusterConfigKafkaKafkaConfigOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbKafkaClusterConfigKafkaResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference">MdbKafkaClusterConfigKafkaResourcesOutputReference</a>

---

##### `kafkaConfigInput`<sup>Optional</sup> <a name="kafkaConfigInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.kafkaConfigInput"></a>

```typescript
public readonly kafkaConfigInput: MdbKafkaClusterConfigKafkaKafkaConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaKafkaConfig">MdbKafkaClusterConfigKafkaKafkaConfig</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigKafka;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafka">MdbKafkaClusterConfigKafka</a>

---


### MdbKafkaClusterConfigKafkaResourcesOutputReference <a name="MdbKafkaClusterConfigKafkaResourcesOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigKafkaResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigKafkaResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigKafkaResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigKafkaResources">MdbKafkaClusterConfigKafkaResources</a>

---


### MdbKafkaClusterConfigZookeeperOutputReference <a name="MdbKafkaClusterConfigZookeeperOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigZookeeperOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigZookeeperOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.resetResources">resetResources</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.putResources"></a>

```typescript
public putResources(value: MdbKafkaClusterConfigZookeeperResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a>

---

##### `resetResources` <a name="resetResources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.resetResources"></a>

```typescript
public resetResources(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference">MdbKafkaClusterConfigZookeeperResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbKafkaClusterConfigZookeeperResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference">MdbKafkaClusterConfigZookeeperResourcesOutputReference</a>

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigZookeeper;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeper">MdbKafkaClusterConfigZookeeper</a>

---


### MdbKafkaClusterConfigZookeeperResourcesOutputReference <a name="MdbKafkaClusterConfigZookeeperResourcesOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterConfigZookeeperResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterConfigZookeeperResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskSize">resetDiskSize</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetResourcePresetId">resetResourcePresetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskSize` <a name="resetDiskSize" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskSize"></a>

```typescript
public resetDiskSize(): void
```

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```

##### `resetResourcePresetId` <a name="resetResourcePresetId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.resetResourcePresetId"></a>

```typescript
public resetResourcePresetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterConfigZookeeperResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterConfigZookeeperResources">MdbKafkaClusterConfigZookeeperResources</a>

---


### MdbKafkaClusterHostList <a name="MdbKafkaClusterHostList" id="@cdktf/provider-yandex.MdbKafkaClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer"></a>

```typescript
import { MdbKafkaClusterHostList } from '@cdktf/provider-yandex'

new MdbKafkaClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.get"></a>

```typescript
public get(index: number): MdbKafkaClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---


### MdbKafkaClusterHostOutputReference <a name="MdbKafkaClusterHostOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterHost">MdbKafkaClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterHost;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterHost">MdbKafkaClusterHost</a>

---


### MdbKafkaClusterMaintenanceWindowOutputReference <a name="MdbKafkaClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterMaintenanceWindow">MdbKafkaClusterMaintenanceWindow</a>

---


### MdbKafkaClusterTimeoutsOutputReference <a name="MdbKafkaClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTimeouts">MdbKafkaClusterTimeouts</a>

---


### MdbKafkaClusterTopicList <a name="MdbKafkaClusterTopicList" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer"></a>

```typescript
import { MdbKafkaClusterTopicList } from '@cdktf/provider-yandex'

new MdbKafkaClusterTopicList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.get"></a>

```typescript
public get(index: number): MdbKafkaClusterTopicOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterTopicList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterTopic[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>[]

---


### MdbKafkaClusterTopicOutputReference <a name="MdbKafkaClusterTopicOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterTopicOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterTopicOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.putTopicConfig">putTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.resetTopicConfig">resetTopicConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putTopicConfig` <a name="putTopicConfig" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.putTopicConfig"></a>

```typescript
public putTopicConfig(value: MdbKafkaClusterTopicTopicConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.putTopicConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a>

---

##### `resetTopicConfig` <a name="resetTopicConfig" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.resetTopicConfig"></a>

```typescript
public resetTopicConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.topicConfig">topicConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference">MdbKafkaClusterTopicTopicConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.partitionsInput">partitionsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.replicationFactorInput">replicationFactorInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.topicConfigInput">topicConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.partitions">partitions</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `topicConfig`<sup>Required</sup> <a name="topicConfig" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.topicConfig"></a>

```typescript
public readonly topicConfig: MdbKafkaClusterTopicTopicConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference">MdbKafkaClusterTopicTopicConfigOutputReference</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `partitionsInput`<sup>Optional</sup> <a name="partitionsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.partitionsInput"></a>

```typescript
public readonly partitionsInput: number;
```

- *Type:* number

---

##### `replicationFactorInput`<sup>Optional</sup> <a name="replicationFactorInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.replicationFactorInput"></a>

```typescript
public readonly replicationFactorInput: number;
```

- *Type:* number

---

##### `topicConfigInput`<sup>Optional</sup> <a name="topicConfigInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.topicConfigInput"></a>

```typescript
public readonly topicConfigInput: MdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a>

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `partitions`<sup>Required</sup> <a name="partitions" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.partitions"></a>

```typescript
public readonly partitions: number;
```

- *Type:* number

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterTopicOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterTopic;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopic">MdbKafkaClusterTopic</a>

---


### MdbKafkaClusterTopicTopicConfigOutputReference <a name="MdbKafkaClusterTopicTopicConfigOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterTopicTopicConfigOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterTopicTopicConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetCleanupPolicy">resetCleanupPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetCompressionType">resetCompressionType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetDeleteRetentionMs">resetDeleteRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFileDeleteDelayMs">resetFileDeleteDelayMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMessages">resetFlushMessages</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMs">resetFlushMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMaxMessageBytes">resetMaxMessageBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMinCompactionLagMs">resetMinCompactionLagMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMinInsyncReplicas">resetMinInsyncReplicas</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetPreallocate">resetPreallocate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionBytes">resetRetentionBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionMs">resetRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetSegmentBytes">resetSegmentBytes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCleanupPolicy` <a name="resetCleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetCleanupPolicy"></a>

```typescript
public resetCleanupPolicy(): void
```

##### `resetCompressionType` <a name="resetCompressionType" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetCompressionType"></a>

```typescript
public resetCompressionType(): void
```

##### `resetDeleteRetentionMs` <a name="resetDeleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetDeleteRetentionMs"></a>

```typescript
public resetDeleteRetentionMs(): void
```

##### `resetFileDeleteDelayMs` <a name="resetFileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFileDeleteDelayMs"></a>

```typescript
public resetFileDeleteDelayMs(): void
```

##### `resetFlushMessages` <a name="resetFlushMessages" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMessages"></a>

```typescript
public resetFlushMessages(): void
```

##### `resetFlushMs` <a name="resetFlushMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetFlushMs"></a>

```typescript
public resetFlushMs(): void
```

##### `resetMaxMessageBytes` <a name="resetMaxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMaxMessageBytes"></a>

```typescript
public resetMaxMessageBytes(): void
```

##### `resetMinCompactionLagMs` <a name="resetMinCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMinCompactionLagMs"></a>

```typescript
public resetMinCompactionLagMs(): void
```

##### `resetMinInsyncReplicas` <a name="resetMinInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetMinInsyncReplicas"></a>

```typescript
public resetMinInsyncReplicas(): void
```

##### `resetPreallocate` <a name="resetPreallocate" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetPreallocate"></a>

```typescript
public resetPreallocate(): void
```

##### `resetRetentionBytes` <a name="resetRetentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionBytes"></a>

```typescript
public resetRetentionBytes(): void
```

##### `resetRetentionMs` <a name="resetRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetRetentionMs"></a>

```typescript
public resetRetentionMs(): void
```

##### `resetSegmentBytes` <a name="resetSegmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.resetSegmentBytes"></a>

```typescript
public resetSegmentBytes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicyInput">cleanupPolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.compressionTypeInput">compressionTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMsInput">deleteRetentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput">fileDeleteDelayMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessagesInput">flushMessagesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMsInput">flushMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytesInput">maxMessageBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMsInput">minCompactionLagMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicasInput">minInsyncReplicasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.preallocateInput">preallocateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytesInput">retentionBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMsInput">retentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytesInput">segmentBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessages">flushMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMs">flushMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMs">retentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cleanupPolicyInput`<sup>Optional</sup> <a name="cleanupPolicyInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicyInput"></a>

```typescript
public readonly cleanupPolicyInput: string;
```

- *Type:* string

---

##### `compressionTypeInput`<sup>Optional</sup> <a name="compressionTypeInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.compressionTypeInput"></a>

```typescript
public readonly compressionTypeInput: string;
```

- *Type:* string

---

##### `deleteRetentionMsInput`<sup>Optional</sup> <a name="deleteRetentionMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMsInput"></a>

```typescript
public readonly deleteRetentionMsInput: string;
```

- *Type:* string

---

##### `fileDeleteDelayMsInput`<sup>Optional</sup> <a name="fileDeleteDelayMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput"></a>

```typescript
public readonly fileDeleteDelayMsInput: string;
```

- *Type:* string

---

##### `flushMessagesInput`<sup>Optional</sup> <a name="flushMessagesInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessagesInput"></a>

```typescript
public readonly flushMessagesInput: string;
```

- *Type:* string

---

##### `flushMsInput`<sup>Optional</sup> <a name="flushMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMsInput"></a>

```typescript
public readonly flushMsInput: string;
```

- *Type:* string

---

##### `maxMessageBytesInput`<sup>Optional</sup> <a name="maxMessageBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytesInput"></a>

```typescript
public readonly maxMessageBytesInput: string;
```

- *Type:* string

---

##### `minCompactionLagMsInput`<sup>Optional</sup> <a name="minCompactionLagMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMsInput"></a>

```typescript
public readonly minCompactionLagMsInput: string;
```

- *Type:* string

---

##### `minInsyncReplicasInput`<sup>Optional</sup> <a name="minInsyncReplicasInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicasInput"></a>

```typescript
public readonly minInsyncReplicasInput: string;
```

- *Type:* string

---

##### `preallocateInput`<sup>Optional</sup> <a name="preallocateInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.preallocateInput"></a>

```typescript
public readonly preallocateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytesInput`<sup>Optional</sup> <a name="retentionBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytesInput"></a>

```typescript
public readonly retentionBytesInput: string;
```

- *Type:* string

---

##### `retentionMsInput`<sup>Optional</sup> <a name="retentionMsInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMsInput"></a>

```typescript
public readonly retentionMsInput: string;
```

- *Type:* string

---

##### `segmentBytesInput`<sup>Optional</sup> <a name="segmentBytesInput" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytesInput"></a>

```typescript
public readonly segmentBytesInput: string;
```

- *Type:* string

---

##### `cleanupPolicy`<sup>Required</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `deleteRetentionMs`<sup>Required</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

---

##### `fileDeleteDelayMs`<sup>Required</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

---

##### `flushMessages`<sup>Required</sup> <a name="flushMessages" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

---

##### `flushMs`<sup>Required</sup> <a name="flushMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

---

##### `maxMessageBytes`<sup>Required</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

---

##### `minCompactionLagMs`<sup>Required</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

---

##### `minInsyncReplicas`<sup>Required</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

---

##### `preallocate`<sup>Required</sup> <a name="preallocate" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytes`<sup>Required</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

---

##### `retentionMs`<sup>Required</sup> <a name="retentionMs" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

---

##### `segmentBytes`<sup>Required</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaClusterTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterTopicTopicConfig">MdbKafkaClusterTopicTopicConfig</a>

---


### MdbKafkaClusterUserList <a name="MdbKafkaClusterUserList" id="@cdktf/provider-yandex.MdbKafkaClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer"></a>

```typescript
import { MdbKafkaClusterUserList } from '@cdktf/provider-yandex'

new MdbKafkaClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.get"></a>

```typescript
public get(index: number): MdbKafkaClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>[]

---


### MdbKafkaClusterUserOutputReference <a name="MdbKafkaClusterUserOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbKafkaClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]

---

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList">MdbKafkaClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbKafkaClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList">MdbKafkaClusterUserPermissionList</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUser">MdbKafkaClusterUser</a>

---


### MdbKafkaClusterUserPermissionList <a name="MdbKafkaClusterUserPermissionList" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbKafkaClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbKafkaClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbKafkaClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>[]

---


### MdbKafkaClusterUserPermissionOutputReference <a name="MdbKafkaClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbKafkaClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.topicNameInput">topicNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.topicName">topicName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `topicNameInput`<sup>Optional</sup> <a name="topicNameInput" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.topicNameInput"></a>

```typescript
public readonly topicNameInput: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `topicName`<sup>Required</sup> <a name="topicName" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.topicName"></a>

```typescript
public readonly topicName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaClusterUserPermission">MdbKafkaClusterUserPermission</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerList <a name="MdbKafkaConnectorConnectorConfigMirrormakerList" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerList } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.get"></a>

```typescript
public get(index: number): MdbKafkaConnectorConnectorConfigMirrormakerOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>[]

---


### MdbKafkaConnectorConnectorConfigMirrormakerOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putSourceCluster">putSourceCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putTargetCluster">putTargetCluster</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putSourceCluster` <a name="putSourceCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putSourceCluster"></a>

```typescript
public putSourceCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putSourceCluster.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a>

---

##### `putTargetCluster` <a name="putTargetCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putTargetCluster"></a>

```typescript
public putTargetCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.putTargetCluster.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceCluster">sourceCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetCluster">targetCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactorInput">replicationFactorInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceClusterInput">sourceClusterInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetClusterInput">targetClusterInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topicsInput">topicsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactor">replicationFactor</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topics">topics</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `sourceCluster`<sup>Required</sup> <a name="sourceCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceCluster"></a>

```typescript
public readonly sourceCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference</a>

---

##### `targetCluster`<sup>Required</sup> <a name="targetCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetCluster"></a>

```typescript
public readonly targetCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference</a>

---

##### `replicationFactorInput`<sup>Optional</sup> <a name="replicationFactorInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactorInput"></a>

```typescript
public readonly replicationFactorInput: number;
```

- *Type:* number

---

##### `sourceClusterInput`<sup>Optional</sup> <a name="sourceClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.sourceClusterInput"></a>

```typescript
public readonly sourceClusterInput: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a>

---

##### `targetClusterInput`<sup>Optional</sup> <a name="targetClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.targetClusterInput"></a>

```typescript
public readonly targetClusterInput: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a>

---

##### `topicsInput`<sup>Optional</sup> <a name="topicsInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topicsInput"></a>

```typescript
public readonly topicsInput: string;
```

- *Type:* string

---

##### `replicationFactor`<sup>Required</sup> <a name="replicationFactor" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.replicationFactor"></a>

```typescript
public readonly replicationFactor: number;
```

- *Type:* number

---

##### `topics`<sup>Required</sup> <a name="topics" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.topics"></a>

```typescript
public readonly topics: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormaker">MdbKafkaConnectorConnectorConfigMirrormaker</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get"></a>

```typescript
public get(index: number): MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]

---


### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslMechanism">resetSaslMechanism</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslPassword">resetSaslPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslUsername">resetSaslUsername</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSecurityProtocol">resetSecurityProtocol</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSaslMechanism` <a name="resetSaslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslMechanism"></a>

```typescript
public resetSaslMechanism(): void
```

##### `resetSaslPassword` <a name="resetSaslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslPassword"></a>

```typescript
public resetSaslPassword(): void
```

##### `resetSaslUsername` <a name="resetSaslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSaslUsername"></a>

```typescript
public resetSaslUsername(): void
```

##### `resetSecurityProtocol` <a name="resetSecurityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.resetSecurityProtocol"></a>

```typescript
public resetSecurityProtocol(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServersInput">bootstrapServersInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanismInput">saslMechanismInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPasswordInput">saslPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsernameInput">saslUsernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocolInput">securityProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootstrapServersInput`<sup>Optional</sup> <a name="bootstrapServersInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServersInput"></a>

```typescript
public readonly bootstrapServersInput: string;
```

- *Type:* string

---

##### `saslMechanismInput`<sup>Optional</sup> <a name="saslMechanismInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanismInput"></a>

```typescript
public readonly saslMechanismInput: string;
```

- *Type:* string

---

##### `saslPasswordInput`<sup>Optional</sup> <a name="saslPasswordInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPasswordInput"></a>

```typescript
public readonly saslPasswordInput: string;
```

- *Type:* string

---

##### `saslUsernameInput`<sup>Optional</sup> <a name="saslUsernameInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsernameInput"></a>

```typescript
public readonly saslUsernameInput: string;
```

- *Type:* string

---

##### `securityProtocolInput`<sup>Optional</sup> <a name="securityProtocolInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocolInput"></a>

```typescript
public readonly securityProtocolInput: string;
```

- *Type:* string

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putExternalCluster">putExternalCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putThisCluster">putThisCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetAlias">resetAlias</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetExternalCluster">resetExternalCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetThisCluster">resetThisCluster</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExternalCluster` <a name="putExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putExternalCluster"></a>

```typescript
public putExternalCluster(value: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putExternalCluster.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]

---

##### `putThisCluster` <a name="putThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putThisCluster"></a>

```typescript
public putThisCluster(value: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.putThisCluster.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]

---

##### `resetAlias` <a name="resetAlias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetAlias"></a>

```typescript
public resetAlias(): void
```

##### `resetExternalCluster` <a name="resetExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetExternalCluster"></a>

```typescript
public resetExternalCluster(): void
```

##### `resetThisCluster` <a name="resetThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.resetThisCluster"></a>

```typescript
public resetThisCluster(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalCluster">externalCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisCluster">thisCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.aliasInput">aliasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalClusterInput">externalClusterInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisClusterInput">thisClusterInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalCluster`<sup>Required</sup> <a name="externalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalCluster"></a>

```typescript
public readonly externalCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterList</a>

---

##### `thisCluster`<sup>Required</sup> <a name="thisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisCluster"></a>

```typescript
public readonly thisCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList</a>

---

##### `aliasInput`<sup>Optional</sup> <a name="aliasInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.aliasInput"></a>

```typescript
public readonly aliasInput: string;
```

- *Type:* string

---

##### `externalClusterInput`<sup>Optional</sup> <a name="externalClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.externalClusterInput"></a>

```typescript
public readonly externalClusterInput: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster</a>[]

---

##### `thisClusterInput`<sup>Optional</sup> <a name="thisClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.thisClusterInput"></a>

```typescript
public readonly thisClusterInput: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]

---

##### `alias`<sup>Required</sup> <a name="alias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get"></a>

```typescript
public get(index: number): MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>[]

---


### MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get"></a>

```typescript
public get(index: number): MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]

---


### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslMechanism">resetSaslMechanism</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslPassword">resetSaslPassword</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslUsername">resetSaslUsername</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSecurityProtocol">resetSecurityProtocol</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetSaslMechanism` <a name="resetSaslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslMechanism"></a>

```typescript
public resetSaslMechanism(): void
```

##### `resetSaslPassword` <a name="resetSaslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslPassword"></a>

```typescript
public resetSaslPassword(): void
```

##### `resetSaslUsername` <a name="resetSaslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSaslUsername"></a>

```typescript
public resetSaslUsername(): void
```

##### `resetSecurityProtocol` <a name="resetSecurityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.resetSecurityProtocol"></a>

```typescript
public resetSecurityProtocol(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServersInput">bootstrapServersInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanismInput">saslMechanismInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPasswordInput">saslPasswordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsernameInput">saslUsernameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocolInput">securityProtocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServers">bootstrapServers</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanism">saslMechanism</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPassword">saslPassword</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsername">saslUsername</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocol">securityProtocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `bootstrapServersInput`<sup>Optional</sup> <a name="bootstrapServersInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServersInput"></a>

```typescript
public readonly bootstrapServersInput: string;
```

- *Type:* string

---

##### `saslMechanismInput`<sup>Optional</sup> <a name="saslMechanismInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanismInput"></a>

```typescript
public readonly saslMechanismInput: string;
```

- *Type:* string

---

##### `saslPasswordInput`<sup>Optional</sup> <a name="saslPasswordInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPasswordInput"></a>

```typescript
public readonly saslPasswordInput: string;
```

- *Type:* string

---

##### `saslUsernameInput`<sup>Optional</sup> <a name="saslUsernameInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsernameInput"></a>

```typescript
public readonly saslUsernameInput: string;
```

- *Type:* string

---

##### `securityProtocolInput`<sup>Optional</sup> <a name="securityProtocolInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocolInput"></a>

```typescript
public readonly securityProtocolInput: string;
```

- *Type:* string

---

##### `bootstrapServers`<sup>Required</sup> <a name="bootstrapServers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.bootstrapServers"></a>

```typescript
public readonly bootstrapServers: string;
```

- *Type:* string

---

##### `saslMechanism`<sup>Required</sup> <a name="saslMechanism" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslMechanism"></a>

```typescript
public readonly saslMechanism: string;
```

- *Type:* string

---

##### `saslPassword`<sup>Required</sup> <a name="saslPassword" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslPassword"></a>

```typescript
public readonly saslPassword: string;
```

- *Type:* string

---

##### `saslUsername`<sup>Required</sup> <a name="saslUsername" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.saslUsername"></a>

```typescript
public readonly saslUsername: string;
```

- *Type:* string

---

##### `securityProtocol`<sup>Required</sup> <a name="securityProtocol" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.securityProtocol"></a>

```typescript
public readonly securityProtocol: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putExternalCluster">putExternalCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putThisCluster">putThisCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetAlias">resetAlias</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetExternalCluster">resetExternalCluster</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetThisCluster">resetThisCluster</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExternalCluster` <a name="putExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putExternalCluster"></a>

```typescript
public putExternalCluster(value: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putExternalCluster.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]

---

##### `putThisCluster` <a name="putThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putThisCluster"></a>

```typescript
public putThisCluster(value: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.putThisCluster.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]

---

##### `resetAlias` <a name="resetAlias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetAlias"></a>

```typescript
public resetAlias(): void
```

##### `resetExternalCluster` <a name="resetExternalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetExternalCluster"></a>

```typescript
public resetExternalCluster(): void
```

##### `resetThisCluster` <a name="resetThisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.resetThisCluster"></a>

```typescript
public resetThisCluster(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalCluster">externalCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisCluster">thisCluster</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.aliasInput">aliasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalClusterInput">externalClusterInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisClusterInput">thisClusterInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.alias">alias</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `externalCluster`<sup>Required</sup> <a name="externalCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalCluster"></a>

```typescript
public readonly externalCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterList</a>

---

##### `thisCluster`<sup>Required</sup> <a name="thisCluster" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisCluster"></a>

```typescript
public readonly thisCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList</a>

---

##### `aliasInput`<sup>Optional</sup> <a name="aliasInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.aliasInput"></a>

```typescript
public readonly aliasInput: string;
```

- *Type:* string

---

##### `externalClusterInput`<sup>Optional</sup> <a name="externalClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.externalClusterInput"></a>

```typescript
public readonly externalClusterInput: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster</a>[]

---

##### `thisClusterInput`<sup>Optional</sup> <a name="thisClusterInput" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.thisClusterInput"></a>

```typescript
public readonly thisClusterInput: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]

---

##### `alias`<sup>Required</sup> <a name="alias" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.alias"></a>

```typescript
public readonly alias: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster</a>

---


### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get"></a>

```typescript
public get(index: number): MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>[]

---


### MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference <a name="MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer"></a>

```typescript
import { MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster">MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster</a>

---


### MdbKafkaTopicTimeoutsOutputReference <a name="MdbKafkaTopicTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbKafkaTopicTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaTopicTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaTopicTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbKafkaTopicTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbKafkaTopicTimeouts">MdbKafkaTopicTimeouts</a>

---


### MdbKafkaTopicTopicConfigOutputReference <a name="MdbKafkaTopicTopicConfigOutputReference" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.Initializer"></a>

```typescript
import { MdbKafkaTopicTopicConfigOutputReference } from '@cdktf/provider-yandex'

new MdbKafkaTopicTopicConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetCleanupPolicy">resetCleanupPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetCompressionType">resetCompressionType</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetDeleteRetentionMs">resetDeleteRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFileDeleteDelayMs">resetFileDeleteDelayMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFlushMessages">resetFlushMessages</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFlushMs">resetFlushMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMaxMessageBytes">resetMaxMessageBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMinCompactionLagMs">resetMinCompactionLagMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMinInsyncReplicas">resetMinInsyncReplicas</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetPreallocate">resetPreallocate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetRetentionBytes">resetRetentionBytes</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetRetentionMs">resetRetentionMs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetSegmentBytes">resetSegmentBytes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCleanupPolicy` <a name="resetCleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetCleanupPolicy"></a>

```typescript
public resetCleanupPolicy(): void
```

##### `resetCompressionType` <a name="resetCompressionType" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetCompressionType"></a>

```typescript
public resetCompressionType(): void
```

##### `resetDeleteRetentionMs` <a name="resetDeleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetDeleteRetentionMs"></a>

```typescript
public resetDeleteRetentionMs(): void
```

##### `resetFileDeleteDelayMs` <a name="resetFileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFileDeleteDelayMs"></a>

```typescript
public resetFileDeleteDelayMs(): void
```

##### `resetFlushMessages` <a name="resetFlushMessages" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFlushMessages"></a>

```typescript
public resetFlushMessages(): void
```

##### `resetFlushMs` <a name="resetFlushMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetFlushMs"></a>

```typescript
public resetFlushMs(): void
```

##### `resetMaxMessageBytes` <a name="resetMaxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMaxMessageBytes"></a>

```typescript
public resetMaxMessageBytes(): void
```

##### `resetMinCompactionLagMs` <a name="resetMinCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMinCompactionLagMs"></a>

```typescript
public resetMinCompactionLagMs(): void
```

##### `resetMinInsyncReplicas` <a name="resetMinInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetMinInsyncReplicas"></a>

```typescript
public resetMinInsyncReplicas(): void
```

##### `resetPreallocate` <a name="resetPreallocate" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetPreallocate"></a>

```typescript
public resetPreallocate(): void
```

##### `resetRetentionBytes` <a name="resetRetentionBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetRetentionBytes"></a>

```typescript
public resetRetentionBytes(): void
```

##### `resetRetentionMs` <a name="resetRetentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetRetentionMs"></a>

```typescript
public resetRetentionMs(): void
```

##### `resetSegmentBytes` <a name="resetSegmentBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.resetSegmentBytes"></a>

```typescript
public resetSegmentBytes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicyInput">cleanupPolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.compressionTypeInput">compressionTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMsInput">deleteRetentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput">fileDeleteDelayMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMessagesInput">flushMessagesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMsInput">flushMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytesInput">maxMessageBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMsInput">minCompactionLagMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicasInput">minInsyncReplicasInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.preallocateInput">preallocateInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionBytesInput">retentionBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionMsInput">retentionMsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.segmentBytesInput">segmentBytesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicy">cleanupPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.compressionType">compressionType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMs">deleteRetentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMs">fileDeleteDelayMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMessages">flushMessages</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMs">flushMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytes">maxMessageBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMs">minCompactionLagMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicas">minInsyncReplicas</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.preallocate">preallocate</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionBytes">retentionBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionMs">retentionMs</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.segmentBytes">segmentBytes</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `cleanupPolicyInput`<sup>Optional</sup> <a name="cleanupPolicyInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicyInput"></a>

```typescript
public readonly cleanupPolicyInput: string;
```

- *Type:* string

---

##### `compressionTypeInput`<sup>Optional</sup> <a name="compressionTypeInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.compressionTypeInput"></a>

```typescript
public readonly compressionTypeInput: string;
```

- *Type:* string

---

##### `deleteRetentionMsInput`<sup>Optional</sup> <a name="deleteRetentionMsInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMsInput"></a>

```typescript
public readonly deleteRetentionMsInput: string;
```

- *Type:* string

---

##### `fileDeleteDelayMsInput`<sup>Optional</sup> <a name="fileDeleteDelayMsInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMsInput"></a>

```typescript
public readonly fileDeleteDelayMsInput: string;
```

- *Type:* string

---

##### `flushMessagesInput`<sup>Optional</sup> <a name="flushMessagesInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMessagesInput"></a>

```typescript
public readonly flushMessagesInput: string;
```

- *Type:* string

---

##### `flushMsInput`<sup>Optional</sup> <a name="flushMsInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMsInput"></a>

```typescript
public readonly flushMsInput: string;
```

- *Type:* string

---

##### `maxMessageBytesInput`<sup>Optional</sup> <a name="maxMessageBytesInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytesInput"></a>

```typescript
public readonly maxMessageBytesInput: string;
```

- *Type:* string

---

##### `minCompactionLagMsInput`<sup>Optional</sup> <a name="minCompactionLagMsInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMsInput"></a>

```typescript
public readonly minCompactionLagMsInput: string;
```

- *Type:* string

---

##### `minInsyncReplicasInput`<sup>Optional</sup> <a name="minInsyncReplicasInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicasInput"></a>

```typescript
public readonly minInsyncReplicasInput: string;
```

- *Type:* string

---

##### `preallocateInput`<sup>Optional</sup> <a name="preallocateInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.preallocateInput"></a>

```typescript
public readonly preallocateInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytesInput`<sup>Optional</sup> <a name="retentionBytesInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionBytesInput"></a>

```typescript
public readonly retentionBytesInput: string;
```

- *Type:* string

---

##### `retentionMsInput`<sup>Optional</sup> <a name="retentionMsInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionMsInput"></a>

```typescript
public readonly retentionMsInput: string;
```

- *Type:* string

---

##### `segmentBytesInput`<sup>Optional</sup> <a name="segmentBytesInput" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.segmentBytesInput"></a>

```typescript
public readonly segmentBytesInput: string;
```

- *Type:* string

---

##### `cleanupPolicy`<sup>Required</sup> <a name="cleanupPolicy" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.cleanupPolicy"></a>

```typescript
public readonly cleanupPolicy: string;
```

- *Type:* string

---

##### `compressionType`<sup>Required</sup> <a name="compressionType" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.compressionType"></a>

```typescript
public readonly compressionType: string;
```

- *Type:* string

---

##### `deleteRetentionMs`<sup>Required</sup> <a name="deleteRetentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.deleteRetentionMs"></a>

```typescript
public readonly deleteRetentionMs: string;
```

- *Type:* string

---

##### `fileDeleteDelayMs`<sup>Required</sup> <a name="fileDeleteDelayMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.fileDeleteDelayMs"></a>

```typescript
public readonly fileDeleteDelayMs: string;
```

- *Type:* string

---

##### `flushMessages`<sup>Required</sup> <a name="flushMessages" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMessages"></a>

```typescript
public readonly flushMessages: string;
```

- *Type:* string

---

##### `flushMs`<sup>Required</sup> <a name="flushMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.flushMs"></a>

```typescript
public readonly flushMs: string;
```

- *Type:* string

---

##### `maxMessageBytes`<sup>Required</sup> <a name="maxMessageBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.maxMessageBytes"></a>

```typescript
public readonly maxMessageBytes: string;
```

- *Type:* string

---

##### `minCompactionLagMs`<sup>Required</sup> <a name="minCompactionLagMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minCompactionLagMs"></a>

```typescript
public readonly minCompactionLagMs: string;
```

- *Type:* string

---

##### `minInsyncReplicas`<sup>Required</sup> <a name="minInsyncReplicas" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.minInsyncReplicas"></a>

```typescript
public readonly minInsyncReplicas: string;
```

- *Type:* string

---

##### `preallocate`<sup>Required</sup> <a name="preallocate" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.preallocate"></a>

```typescript
public readonly preallocate: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `retentionBytes`<sup>Required</sup> <a name="retentionBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionBytes"></a>

```typescript
public readonly retentionBytes: string;
```

- *Type:* string

---

##### `retentionMs`<sup>Required</sup> <a name="retentionMs" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.retentionMs"></a>

```typescript
public readonly retentionMs: string;
```

- *Type:* string

---

##### `segmentBytes`<sup>Required</sup> <a name="segmentBytes" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.segmentBytes"></a>

```typescript
public readonly segmentBytes: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbKafkaTopicTopicConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbKafkaTopicTopicConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbKafkaTopicTopicConfig">MdbKafkaTopicTopicConfig</a>

---


### MdbMongodbClusterClusterConfigAccessOutputReference <a name="MdbMongodbClusterClusterConfigAccessOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfigAccessOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterClusterConfigAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.dataLens">dataLens</a></code> | <code>cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: IResolvable;
```

- *Type:* cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMongodbClusterClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a>

---


### MdbMongodbClusterClusterConfigBackupWindowStartOutputReference <a name="MdbMongodbClusterClusterConfigBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfigBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterClusterConfigBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMongodbClusterClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a>

---


### MdbMongodbClusterClusterConfigOutputReference <a name="MdbMongodbClusterClusterConfigOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterClusterConfigOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterClusterConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetFeatureCompatibilityVersion">resetFeatureCompatibilityVersion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putAccess"></a>

```typescript
public putAccess(value: MdbMongodbClusterClusterConfigAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a>

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbMongodbClusterClusterConfigBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a>

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetFeatureCompatibilityVersion` <a name="resetFeatureCompatibilityVersion" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.resetFeatureCompatibilityVersion"></a>

```typescript
public resetFeatureCompatibilityVersion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference">MdbMongodbClusterClusterConfigAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference">MdbMongodbClusterClusterConfigBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersionInput">featureCompatibilityVersionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersion">featureCompatibilityVersion</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.access"></a>

```typescript
public readonly access: MdbMongodbClusterClusterConfigAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccessOutputReference">MdbMongodbClusterClusterConfigAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbMongodbClusterClusterConfigBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStartOutputReference">MdbMongodbClusterClusterConfigBackupWindowStartOutputReference</a>

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.accessInput"></a>

```typescript
public readonly accessInput: MdbMongodbClusterClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigAccess">MdbMongodbClusterClusterConfigAccess</a>

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbMongodbClusterClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfigBackupWindowStart">MdbMongodbClusterClusterConfigBackupWindowStart</a>

---

##### `featureCompatibilityVersionInput`<sup>Optional</sup> <a name="featureCompatibilityVersionInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersionInput"></a>

```typescript
public readonly featureCompatibilityVersionInput: string;
```

- *Type:* string

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `featureCompatibilityVersion`<sup>Required</sup> <a name="featureCompatibilityVersion" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.featureCompatibilityVersion"></a>

```typescript
public readonly featureCompatibilityVersion: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterClusterConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMongodbClusterClusterConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterClusterConfig">MdbMongodbClusterClusterConfig</a>

---


### MdbMongodbClusterDatabaseList <a name="MdbMongodbClusterDatabaseList" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer"></a>

```typescript
import { MdbMongodbClusterDatabaseList } from '@cdktf/provider-yandex'

new MdbMongodbClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.get"></a>

```typescript
public get(index: number): MdbMongodbClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>[]

---


### MdbMongodbClusterDatabaseOutputReference <a name="MdbMongodbClusterDatabaseOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterDatabase;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterDatabase">MdbMongodbClusterDatabase</a>

---


### MdbMongodbClusterHostList <a name="MdbMongodbClusterHostList" id="@cdktf/provider-yandex.MdbMongodbClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer"></a>

```typescript
import { MdbMongodbClusterHostList } from '@cdktf/provider-yandex'

new MdbMongodbClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.get"></a>

```typescript
public get(index: number): MdbMongodbClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>[]

---


### MdbMongodbClusterHostOutputReference <a name="MdbMongodbClusterHostOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetRole">resetRole</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetShardName">resetShardName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetType">resetType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetRole` <a name="resetRole" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetRole"></a>

```typescript
public resetRole(): void
```

##### `resetShardName` <a name="resetShardName" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetShardName"></a>

```typescript
public resetShardName(): void
```

##### `resetType` <a name="resetType" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.resetType"></a>

```typescript
public resetType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.health">health</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.roleInput">roleInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.shardNameInput">shardNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.zoneIdInput">zoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `health`<sup>Required</sup> <a name="health" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.health"></a>

```typescript
public readonly health: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `roleInput`<sup>Optional</sup> <a name="roleInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.roleInput"></a>

```typescript
public readonly roleInput: string;
```

- *Type:* string

---

##### `shardNameInput`<sup>Optional</sup> <a name="shardNameInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.shardNameInput"></a>

```typescript
public readonly shardNameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `zoneIdInput`<sup>Optional</sup> <a name="zoneIdInput" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterHost">MdbMongodbClusterHost</a>

---


### MdbMongodbClusterMaintenanceWindowOutputReference <a name="MdbMongodbClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMongodbClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterMaintenanceWindow">MdbMongodbClusterMaintenanceWindow</a>

---


### MdbMongodbClusterResourcesOutputReference <a name="MdbMongodbClusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMongodbClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterResources">MdbMongodbClusterResources</a>

---


### MdbMongodbClusterTimeoutsOutputReference <a name="MdbMongodbClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterTimeouts">MdbMongodbClusterTimeouts</a>

---


### MdbMongodbClusterUserList <a name="MdbMongodbClusterUserList" id="@cdktf/provider-yandex.MdbMongodbClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer"></a>

```typescript
import { MdbMongodbClusterUserList } from '@cdktf/provider-yandex'

new MdbMongodbClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.get"></a>

```typescript
public get(index: number): MdbMongodbClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>[]

---


### MdbMongodbClusterUserOutputReference <a name="MdbMongodbClusterUserOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbMongodbClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]

---

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList">MdbMongodbClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbMongodbClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList">MdbMongodbClusterUserPermissionList</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbMongodbClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUser">MdbMongodbClusterUser</a>

---


### MdbMongodbClusterUserPermissionList <a name="MdbMongodbClusterUserPermissionList" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbMongodbClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbMongodbClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbMongodbClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>[]

---


### MdbMongodbClusterUserPermissionOutputReference <a name="MdbMongodbClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbMongodbClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbMongodbClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.resetRoles">resetRoles</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRoles` <a name="resetRoles" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.resetRoles"></a>

```typescript
public resetRoles(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.databaseNameInput">databaseNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.rolesInput">rolesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseNameInput`<sup>Optional</sup> <a name="databaseNameInput" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* string

---

##### `rolesInput`<sup>Optional</sup> <a name="rolesInput" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.rolesInput"></a>

```typescript
public readonly rolesInput: string[];
```

- *Type:* string[]

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMongodbClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMongodbClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMongodbClusterUserPermission">MdbMongodbClusterUserPermission</a>

---


### MdbMysqlClusterAccessOutputReference <a name="MdbMysqlClusterAccessOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterAccessOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resetDataLens">resetDataLens</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resetWebSql">resetWebSql</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDataLens` <a name="resetDataLens" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resetDataLens"></a>

```typescript
public resetDataLens(): void
```

##### `resetWebSql` <a name="resetWebSql" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.resetWebSql"></a>

```typescript
public resetWebSql(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.dataLensInput">dataLensInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.webSqlInput">webSqlInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLensInput`<sup>Optional</sup> <a name="dataLensInput" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.dataLensInput"></a>

```typescript
public readonly dataLensInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSqlInput`<sup>Optional</sup> <a name="webSqlInput" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.webSqlInput"></a>

```typescript
public readonly webSqlInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterAccess">MdbMysqlClusterAccess</a>

---


### MdbMysqlClusterBackupWindowStartOutputReference <a name="MdbMysqlClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterBackupWindowStart">MdbMysqlClusterBackupWindowStart</a>

---


### MdbMysqlClusterDatabaseList <a name="MdbMysqlClusterDatabaseList" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer"></a>

```typescript
import { MdbMysqlClusterDatabaseList } from '@cdktf/provider-yandex'

new MdbMysqlClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.get"></a>

```typescript
public get(index: number): MdbMysqlClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>[]

---


### MdbMysqlClusterDatabaseOutputReference <a name="MdbMysqlClusterDatabaseOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterDatabase;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterDatabase">MdbMysqlClusterDatabase</a>

---


### MdbMysqlClusterHostList <a name="MdbMysqlClusterHostList" id="@cdktf/provider-yandex.MdbMysqlClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer"></a>

```typescript
import { MdbMysqlClusterHostList } from '@cdktf/provider-yandex'

new MdbMysqlClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.get"></a>

```typescript
public get(index: number): MdbMysqlClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>[]

---


### MdbMysqlClusterHostOutputReference <a name="MdbMysqlClusterHostOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetBackupPriority">resetBackupPriority</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetPriority">resetPriority</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetReplicationSourceName">resetReplicationSourceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetBackupPriority` <a name="resetBackupPriority" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetBackupPriority"></a>

```typescript
public resetBackupPriority(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetName"></a>

```typescript
public resetName(): void
```

##### `resetPriority` <a name="resetPriority" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetPriority"></a>

```typescript
public resetPriority(): void
```

##### `resetReplicationSourceName` <a name="resetReplicationSourceName" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetReplicationSourceName"></a>

```typescript
public resetReplicationSourceName(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSource">replicationSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.backupPriorityInput">backupPriorityInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.priorityInput">priorityInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSourceNameInput">replicationSourceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.backupPriority">backupPriority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSourceName">replicationSourceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `replicationSource`<sup>Required</sup> <a name="replicationSource" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSource"></a>

```typescript
public readonly replicationSource: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupPriorityInput`<sup>Optional</sup> <a name="backupPriorityInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.backupPriorityInput"></a>

```typescript
public readonly backupPriorityInput: number;
```

- *Type:* number

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `priorityInput`<sup>Optional</sup> <a name="priorityInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* number

---

##### `replicationSourceNameInput`<sup>Optional</sup> <a name="replicationSourceNameInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSourceNameInput"></a>

```typescript
public readonly replicationSourceNameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupPriority`<sup>Required</sup> <a name="backupPriority" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.backupPriority"></a>

```typescript
public readonly backupPriority: number;
```

- *Type:* number

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `replicationSourceName`<sup>Required</sup> <a name="replicationSourceName" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.replicationSourceName"></a>

```typescript
public readonly replicationSourceName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterHost">MdbMysqlClusterHost</a>

---


### MdbMysqlClusterMaintenanceWindowOutputReference <a name="MdbMysqlClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterMaintenanceWindow">MdbMysqlClusterMaintenanceWindow</a>

---


### MdbMysqlClusterResourcesOutputReference <a name="MdbMysqlClusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterResources">MdbMysqlClusterResources</a>

---


### MdbMysqlClusterRestoreOutputReference <a name="MdbMysqlClusterRestoreOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterRestoreOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterRestoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.resetTime">resetTime</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTime` <a name="resetTime" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.resetTime"></a>

```typescript
public resetTime(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.backupIdInput">backupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.timeInput">timeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.backupId">backupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.time">time</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backupIdInput`<sup>Optional</sup> <a name="backupIdInput" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* string

---

##### `timeInput`<sup>Optional</sup> <a name="timeInput" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.timeInput"></a>

```typescript
public readonly timeInput: string;
```

- *Type:* string

---

##### `backupId`<sup>Required</sup> <a name="backupId" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* string

---

##### `time`<sup>Required</sup> <a name="time" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.time"></a>

```typescript
public readonly time: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterRestoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterRestore">MdbMysqlClusterRestore</a>

---


### MdbMysqlClusterTimeoutsOutputReference <a name="MdbMysqlClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterTimeouts">MdbMysqlClusterTimeouts</a>

---


### MdbMysqlClusterUserConnectionLimitsOutputReference <a name="MdbMysqlClusterUserConnectionLimitsOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterUserConnectionLimitsOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterUserConnectionLimitsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxConnectionsPerHour">resetMaxConnectionsPerHour</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxQuestionsPerHour">resetMaxQuestionsPerHour</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxUpdatesPerHour">resetMaxUpdatesPerHour</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxUserConnections">resetMaxUserConnections</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetMaxConnectionsPerHour` <a name="resetMaxConnectionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxConnectionsPerHour"></a>

```typescript
public resetMaxConnectionsPerHour(): void
```

##### `resetMaxQuestionsPerHour` <a name="resetMaxQuestionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxQuestionsPerHour"></a>

```typescript
public resetMaxQuestionsPerHour(): void
```

##### `resetMaxUpdatesPerHour` <a name="resetMaxUpdatesPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxUpdatesPerHour"></a>

```typescript
public resetMaxUpdatesPerHour(): void
```

##### `resetMaxUserConnections` <a name="resetMaxUserConnections" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.resetMaxUserConnections"></a>

```typescript
public resetMaxUserConnections(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHourInput">maxConnectionsPerHourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHourInput">maxQuestionsPerHourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHourInput">maxUpdatesPerHourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnectionsInput">maxUserConnectionsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHour">maxConnectionsPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHour">maxQuestionsPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHour">maxUpdatesPerHour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnections">maxUserConnections</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `maxConnectionsPerHourInput`<sup>Optional</sup> <a name="maxConnectionsPerHourInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHourInput"></a>

```typescript
public readonly maxConnectionsPerHourInput: number;
```

- *Type:* number

---

##### `maxQuestionsPerHourInput`<sup>Optional</sup> <a name="maxQuestionsPerHourInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHourInput"></a>

```typescript
public readonly maxQuestionsPerHourInput: number;
```

- *Type:* number

---

##### `maxUpdatesPerHourInput`<sup>Optional</sup> <a name="maxUpdatesPerHourInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHourInput"></a>

```typescript
public readonly maxUpdatesPerHourInput: number;
```

- *Type:* number

---

##### `maxUserConnectionsInput`<sup>Optional</sup> <a name="maxUserConnectionsInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnectionsInput"></a>

```typescript
public readonly maxUserConnectionsInput: number;
```

- *Type:* number

---

##### `maxConnectionsPerHour`<sup>Required</sup> <a name="maxConnectionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxConnectionsPerHour"></a>

```typescript
public readonly maxConnectionsPerHour: number;
```

- *Type:* number

---

##### `maxQuestionsPerHour`<sup>Required</sup> <a name="maxQuestionsPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxQuestionsPerHour"></a>

```typescript
public readonly maxQuestionsPerHour: number;
```

- *Type:* number

---

##### `maxUpdatesPerHour`<sup>Required</sup> <a name="maxUpdatesPerHour" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUpdatesPerHour"></a>

```typescript
public readonly maxUpdatesPerHour: number;
```

- *Type:* number

---

##### `maxUserConnections`<sup>Required</sup> <a name="maxUserConnections" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.maxUserConnections"></a>

```typescript
public readonly maxUserConnections: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbMysqlClusterUserConnectionLimits;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a>

---


### MdbMysqlClusterUserList <a name="MdbMysqlClusterUserList" id="@cdktf/provider-yandex.MdbMysqlClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer"></a>

```typescript
import { MdbMysqlClusterUserList } from '@cdktf/provider-yandex'

new MdbMysqlClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.get"></a>

```typescript
public get(index: number): MdbMysqlClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>[]

---


### MdbMysqlClusterUserOutputReference <a name="MdbMysqlClusterUserOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putConnectionLimits">putConnectionLimits</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetAuthenticationPlugin">resetAuthenticationPlugin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetConnectionLimits">resetConnectionLimits</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetGlobalPermissions">resetGlobalPermissions</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putConnectionLimits` <a name="putConnectionLimits" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putConnectionLimits"></a>

```typescript
public putConnectionLimits(value: MdbMysqlClusterUserConnectionLimits): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putConnectionLimits.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a>

---

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbMysqlClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]

---

##### `resetAuthenticationPlugin` <a name="resetAuthenticationPlugin" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetAuthenticationPlugin"></a>

```typescript
public resetAuthenticationPlugin(): void
```

##### `resetConnectionLimits` <a name="resetConnectionLimits" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetConnectionLimits"></a>

```typescript
public resetConnectionLimits(): void
```

##### `resetGlobalPermissions` <a name="resetGlobalPermissions" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetGlobalPermissions"></a>

```typescript
public resetGlobalPermissions(): void
```

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.connectionLimits">connectionLimits</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference">MdbMysqlClusterUserConnectionLimitsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList">MdbMysqlClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.authenticationPluginInput">authenticationPluginInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.connectionLimitsInput">connectionLimitsInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.globalPermissionsInput">globalPermissionsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.authenticationPlugin">authenticationPlugin</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.globalPermissions">globalPermissions</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `connectionLimits`<sup>Required</sup> <a name="connectionLimits" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.connectionLimits"></a>

```typescript
public readonly connectionLimits: MdbMysqlClusterUserConnectionLimitsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimitsOutputReference">MdbMysqlClusterUserConnectionLimitsOutputReference</a>

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbMysqlClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList">MdbMysqlClusterUserPermissionList</a>

---

##### `authenticationPluginInput`<sup>Optional</sup> <a name="authenticationPluginInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.authenticationPluginInput"></a>

```typescript
public readonly authenticationPluginInput: string;
```

- *Type:* string

---

##### `connectionLimitsInput`<sup>Optional</sup> <a name="connectionLimitsInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.connectionLimitsInput"></a>

```typescript
public readonly connectionLimitsInput: MdbMysqlClusterUserConnectionLimits;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserConnectionLimits">MdbMysqlClusterUserConnectionLimits</a>

---

##### `globalPermissionsInput`<sup>Optional</sup> <a name="globalPermissionsInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.globalPermissionsInput"></a>

```typescript
public readonly globalPermissionsInput: string[];
```

- *Type:* string[]

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbMysqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]

---

##### `authenticationPlugin`<sup>Required</sup> <a name="authenticationPlugin" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.authenticationPlugin"></a>

```typescript
public readonly authenticationPlugin: string;
```

- *Type:* string

---

##### `globalPermissions`<sup>Required</sup> <a name="globalPermissions" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.globalPermissions"></a>

```typescript
public readonly globalPermissions: string[];
```

- *Type:* string[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUser">MdbMysqlClusterUser</a>

---


### MdbMysqlClusterUserPermissionList <a name="MdbMysqlClusterUserPermissionList" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbMysqlClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbMysqlClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbMysqlClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>[]

---


### MdbMysqlClusterUserPermissionOutputReference <a name="MdbMysqlClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbMysqlClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbMysqlClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.resetRoles">resetRoles</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRoles` <a name="resetRoles" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.resetRoles"></a>

```typescript
public resetRoles(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.databaseNameInput">databaseNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.rolesInput">rolesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseNameInput`<sup>Optional</sup> <a name="databaseNameInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* string

---

##### `rolesInput`<sup>Optional</sup> <a name="rolesInput" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.rolesInput"></a>

```typescript
public readonly rolesInput: string[];
```

- *Type:* string[]

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbMysqlClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbMysqlClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbMysqlClusterUserPermission">MdbMysqlClusterUserPermission</a>

---


### MdbPostgresqlClusterConfigAccessOutputReference <a name="MdbPostgresqlClusterConfigAccessOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigAccessOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigAccessOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetDataLens">resetDataLens</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetServerless">resetServerless</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetWebSql">resetWebSql</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDataLens` <a name="resetDataLens" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetDataLens"></a>

```typescript
public resetDataLens(): void
```

##### `resetServerless` <a name="resetServerless" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetServerless"></a>

```typescript
public resetServerless(): void
```

##### `resetWebSql` <a name="resetWebSql" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.resetWebSql"></a>

```typescript
public resetWebSql(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.dataLensInput">dataLensInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.serverlessInput">serverlessInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.webSqlInput">webSqlInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.dataLens">dataLens</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.serverless">serverless</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.webSql">webSql</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dataLensInput`<sup>Optional</sup> <a name="dataLensInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.dataLensInput"></a>

```typescript
public readonly dataLensInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serverlessInput`<sup>Optional</sup> <a name="serverlessInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.serverlessInput"></a>

```typescript
public readonly serverlessInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSqlInput`<sup>Optional</sup> <a name="webSqlInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.webSqlInput"></a>

```typescript
public readonly webSqlInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `dataLens`<sup>Required</sup> <a name="dataLens" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.dataLens"></a>

```typescript
public readonly dataLens: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `serverless`<sup>Required</sup> <a name="serverless" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.serverless"></a>

```typescript
public readonly serverless: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `webSql`<sup>Required</sup> <a name="webSql" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.webSql"></a>

```typescript
public readonly webSql: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a>

---


### MdbPostgresqlClusterConfigAOutputReference <a name="MdbPostgresqlClusterConfigAOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putAccess">putAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putBackupWindowStart">putBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPerformanceDiagnostics">putPerformanceDiagnostics</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPoolerConfig">putPoolerConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putResources">putResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetAccess">resetAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetAutofailover">resetAutofailover</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetBackupRetainPeriodDays">resetBackupRetainPeriodDays</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetBackupWindowStart">resetBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPerformanceDiagnostics">resetPerformanceDiagnostics</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPoolerConfig">resetPoolerConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPostgresqlConfig">resetPostgresqlConfig</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putAccess` <a name="putAccess" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putAccess"></a>

```typescript
public putAccess(value: MdbPostgresqlClusterConfigAccess): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putAccess.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a>

---

##### `putBackupWindowStart` <a name="putBackupWindowStart" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putBackupWindowStart"></a>

```typescript
public putBackupWindowStart(value: MdbPostgresqlClusterConfigBackupWindowStart): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putBackupWindowStart.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a>

---

##### `putPerformanceDiagnostics` <a name="putPerformanceDiagnostics" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPerformanceDiagnostics"></a>

```typescript
public putPerformanceDiagnostics(value: MdbPostgresqlClusterConfigPerformanceDiagnostics): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPerformanceDiagnostics.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a>

---

##### `putPoolerConfig` <a name="putPoolerConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPoolerConfig"></a>

```typescript
public putPoolerConfig(value: MdbPostgresqlClusterConfigPoolerConfig): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putPoolerConfig.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a>

---

##### `putResources` <a name="putResources" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putResources"></a>

```typescript
public putResources(value: MdbPostgresqlClusterConfigResources): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.putResources.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a>

---

##### `resetAccess` <a name="resetAccess" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetAccess"></a>

```typescript
public resetAccess(): void
```

##### `resetAutofailover` <a name="resetAutofailover" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetAutofailover"></a>

```typescript
public resetAutofailover(): void
```

##### `resetBackupRetainPeriodDays` <a name="resetBackupRetainPeriodDays" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetBackupRetainPeriodDays"></a>

```typescript
public resetBackupRetainPeriodDays(): void
```

##### `resetBackupWindowStart` <a name="resetBackupWindowStart" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetBackupWindowStart"></a>

```typescript
public resetBackupWindowStart(): void
```

##### `resetPerformanceDiagnostics` <a name="resetPerformanceDiagnostics" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPerformanceDiagnostics"></a>

```typescript
public resetPerformanceDiagnostics(): void
```

##### `resetPoolerConfig` <a name="resetPoolerConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPoolerConfig"></a>

```typescript
public resetPoolerConfig(): void
```

##### `resetPostgresqlConfig` <a name="resetPostgresqlConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.resetPostgresqlConfig"></a>

```typescript
public resetPostgresqlConfig(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.access">access</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference">MdbPostgresqlClusterConfigAccessOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupWindowStart">backupWindowStart</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference">MdbPostgresqlClusterConfigBackupWindowStartOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnostics">performanceDiagnostics</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference">MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.poolerConfig">poolerConfig</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference">MdbPostgresqlClusterConfigPoolerConfigOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.resources">resources</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference">MdbPostgresqlClusterConfigResourcesOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.accessInput">accessInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.autofailoverInput">autofailoverInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDaysInput">backupRetainPeriodDaysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupWindowStartInput">backupWindowStartInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnosticsInput">performanceDiagnosticsInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.poolerConfigInput">poolerConfigInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfigInput">postgresqlConfigInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.resourcesInput">resourcesInput</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.autofailover">autofailover</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDays">backupRetainPeriodDays</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfig">postgresqlConfig</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `access`<sup>Required</sup> <a name="access" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.access"></a>

```typescript
public readonly access: MdbPostgresqlClusterConfigAccessOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccessOutputReference">MdbPostgresqlClusterConfigAccessOutputReference</a>

---

##### `backupWindowStart`<sup>Required</sup> <a name="backupWindowStart" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupWindowStart"></a>

```typescript
public readonly backupWindowStart: MdbPostgresqlClusterConfigBackupWindowStartOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference">MdbPostgresqlClusterConfigBackupWindowStartOutputReference</a>

---

##### `performanceDiagnostics`<sup>Required</sup> <a name="performanceDiagnostics" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnostics"></a>

```typescript
public readonly performanceDiagnostics: MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference">MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference</a>

---

##### `poolerConfig`<sup>Required</sup> <a name="poolerConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.poolerConfig"></a>

```typescript
public readonly poolerConfig: MdbPostgresqlClusterConfigPoolerConfigOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference">MdbPostgresqlClusterConfigPoolerConfigOutputReference</a>

---

##### `resources`<sup>Required</sup> <a name="resources" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.resources"></a>

```typescript
public readonly resources: MdbPostgresqlClusterConfigResourcesOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference">MdbPostgresqlClusterConfigResourcesOutputReference</a>

---

##### `accessInput`<sup>Optional</sup> <a name="accessInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.accessInput"></a>

```typescript
public readonly accessInput: MdbPostgresqlClusterConfigAccess;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigAccess">MdbPostgresqlClusterConfigAccess</a>

---

##### `autofailoverInput`<sup>Optional</sup> <a name="autofailoverInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.autofailoverInput"></a>

```typescript
public readonly autofailoverInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupRetainPeriodDaysInput`<sup>Optional</sup> <a name="backupRetainPeriodDaysInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDaysInput"></a>

```typescript
public readonly backupRetainPeriodDaysInput: number;
```

- *Type:* number

---

##### `backupWindowStartInput`<sup>Optional</sup> <a name="backupWindowStartInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupWindowStartInput"></a>

```typescript
public readonly backupWindowStartInput: MdbPostgresqlClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a>

---

##### `performanceDiagnosticsInput`<sup>Optional</sup> <a name="performanceDiagnosticsInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.performanceDiagnosticsInput"></a>

```typescript
public readonly performanceDiagnosticsInput: MdbPostgresqlClusterConfigPerformanceDiagnostics;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a>

---

##### `poolerConfigInput`<sup>Optional</sup> <a name="poolerConfigInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.poolerConfigInput"></a>

```typescript
public readonly poolerConfigInput: MdbPostgresqlClusterConfigPoolerConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a>

---

##### `postgresqlConfigInput`<sup>Optional</sup> <a name="postgresqlConfigInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfigInput"></a>

```typescript
public readonly postgresqlConfigInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `resourcesInput`<sup>Optional</sup> <a name="resourcesInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.resourcesInput"></a>

```typescript
public readonly resourcesInput: MdbPostgresqlClusterConfigResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a>

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `autofailover`<sup>Required</sup> <a name="autofailover" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.autofailover"></a>

```typescript
public readonly autofailover: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `backupRetainPeriodDays`<sup>Required</sup> <a name="backupRetainPeriodDays" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.backupRetainPeriodDays"></a>

```typescript
public readonly backupRetainPeriodDays: number;
```

- *Type:* number

---

##### `postgresqlConfig`<sup>Required</sup> <a name="postgresqlConfig" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.postgresqlConfig"></a>

```typescript
public readonly postgresqlConfig: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigA">MdbPostgresqlClusterConfigA</a>

---


### MdbPostgresqlClusterConfigBackupWindowStartOutputReference <a name="MdbPostgresqlClusterConfigBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigBackupWindowStart">MdbPostgresqlClusterConfigBackupWindowStart</a>

---


### MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference <a name="MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingIntervalInput">sessionsSamplingIntervalInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingIntervalInput">statementsSamplingIntervalInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingInterval">sessionsSamplingInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingInterval">statementsSamplingInterval</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sessionsSamplingIntervalInput`<sup>Optional</sup> <a name="sessionsSamplingIntervalInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingIntervalInput"></a>

```typescript
public readonly sessionsSamplingIntervalInput: number;
```

- *Type:* number

---

##### `statementsSamplingIntervalInput`<sup>Optional</sup> <a name="statementsSamplingIntervalInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingIntervalInput"></a>

```typescript
public readonly statementsSamplingIntervalInput: number;
```

- *Type:* number

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `sessionsSamplingInterval`<sup>Required</sup> <a name="sessionsSamplingInterval" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.sessionsSamplingInterval"></a>

```typescript
public readonly sessionsSamplingInterval: number;
```

- *Type:* number

---

##### `statementsSamplingInterval`<sup>Required</sup> <a name="statementsSamplingInterval" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.statementsSamplingInterval"></a>

```typescript
public readonly statementsSamplingInterval: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnosticsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigPerformanceDiagnostics;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPerformanceDiagnostics">MdbPostgresqlClusterConfigPerformanceDiagnostics</a>

---


### MdbPostgresqlClusterConfigPoolerConfigOutputReference <a name="MdbPostgresqlClusterConfigPoolerConfigOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigPoolerConfigOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigPoolerConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resetPoolDiscard">resetPoolDiscard</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resetPoolingMode">resetPoolingMode</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetPoolDiscard` <a name="resetPoolDiscard" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resetPoolDiscard"></a>

```typescript
public resetPoolDiscard(): void
```

##### `resetPoolingMode` <a name="resetPoolingMode" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.resetPoolingMode"></a>

```typescript
public resetPoolingMode(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscardInput">poolDiscardInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingModeInput">poolingModeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscard">poolDiscard</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingMode">poolingMode</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `poolDiscardInput`<sup>Optional</sup> <a name="poolDiscardInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscardInput"></a>

```typescript
public readonly poolDiscardInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `poolingModeInput`<sup>Optional</sup> <a name="poolingModeInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingModeInput"></a>

```typescript
public readonly poolingModeInput: string;
```

- *Type:* string

---

##### `poolDiscard`<sup>Required</sup> <a name="poolDiscard" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolDiscard"></a>

```typescript
public readonly poolDiscard: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `poolingMode`<sup>Required</sup> <a name="poolingMode" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.poolingMode"></a>

```typescript
public readonly poolingMode: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigPoolerConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigPoolerConfig">MdbPostgresqlClusterConfigPoolerConfig</a>

---


### MdbPostgresqlClusterConfigResourcesOutputReference <a name="MdbPostgresqlClusterConfigResourcesOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterConfigResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterConfigResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterConfigResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterConfigResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterConfigResources">MdbPostgresqlClusterConfigResources</a>

---


### MdbPostgresqlClusterDatabaseExtensionList <a name="MdbPostgresqlClusterDatabaseExtensionList" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabaseExtensionList } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterDatabaseExtensionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.get"></a>

```typescript
public get(index: number): MdbPostgresqlClusterDatabaseExtensionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterDatabaseExtension[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]

---


### MdbPostgresqlClusterDatabaseExtensionOutputReference <a name="MdbPostgresqlClusterDatabaseExtensionOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabaseExtensionOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterDatabaseExtensionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.resetVersion">resetVersion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetVersion` <a name="resetVersion" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.resetVersion"></a>

```typescript
public resetVersion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterDatabaseExtension;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>

---


### MdbPostgresqlClusterDatabaseList <a name="MdbPostgresqlClusterDatabaseList" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabaseList } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.get"></a>

```typescript
public get(index: number): MdbPostgresqlClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>[]

---


### MdbPostgresqlClusterDatabaseOutputReference <a name="MdbPostgresqlClusterDatabaseOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.putExtension">putExtension</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetExtension">resetExtension</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetLcCollate">resetLcCollate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetLcType">resetLcType</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExtension` <a name="putExtension" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.putExtension"></a>

```typescript
public putExtension(value: IResolvable | MdbPostgresqlClusterDatabaseExtension[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.putExtension.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]

---

##### `resetExtension` <a name="resetExtension" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetExtension"></a>

```typescript
public resetExtension(): void
```

##### `resetLcCollate` <a name="resetLcCollate" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetLcCollate"></a>

```typescript
public resetLcCollate(): void
```

##### `resetLcType` <a name="resetLcType" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.resetLcType"></a>

```typescript
public resetLcType(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.extension">extension</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList">MdbPostgresqlClusterDatabaseExtensionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.extensionInput">extensionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcCollateInput">lcCollateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcTypeInput">lcTypeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.ownerInput">ownerInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcCollate">lcCollate</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcType">lcType</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.owner">owner</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `extension`<sup>Required</sup> <a name="extension" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.extension"></a>

```typescript
public readonly extension: MdbPostgresqlClusterDatabaseExtensionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtensionList">MdbPostgresqlClusterDatabaseExtensionList</a>

---

##### `extensionInput`<sup>Optional</sup> <a name="extensionInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.extensionInput"></a>

```typescript
public readonly extensionInput: IResolvable | MdbPostgresqlClusterDatabaseExtension[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseExtension">MdbPostgresqlClusterDatabaseExtension</a>[]

---

##### `lcCollateInput`<sup>Optional</sup> <a name="lcCollateInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcCollateInput"></a>

```typescript
public readonly lcCollateInput: string;
```

- *Type:* string

---

##### `lcTypeInput`<sup>Optional</sup> <a name="lcTypeInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcTypeInput"></a>

```typescript
public readonly lcTypeInput: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `ownerInput`<sup>Optional</sup> <a name="ownerInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.ownerInput"></a>

```typescript
public readonly ownerInput: string;
```

- *Type:* string

---

##### `lcCollate`<sup>Required</sup> <a name="lcCollate" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcCollate"></a>

```typescript
public readonly lcCollate: string;
```

- *Type:* string

---

##### `lcType`<sup>Required</sup> <a name="lcType" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.lcType"></a>

```typescript
public readonly lcType: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `owner`<sup>Required</sup> <a name="owner" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.owner"></a>

```typescript
public readonly owner: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterDatabase;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterDatabase">MdbPostgresqlClusterDatabase</a>

---


### MdbPostgresqlClusterHostList <a name="MdbPostgresqlClusterHostList" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer"></a>

```typescript
import { MdbPostgresqlClusterHostList } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.get"></a>

```typescript
public get(index: number): MdbPostgresqlClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>[]

---


### MdbPostgresqlClusterHostOutputReference <a name="MdbPostgresqlClusterHostOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetName">resetName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetPriority">resetPriority</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetReplicationSourceName">resetReplicationSourceName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetName` <a name="resetName" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetName"></a>

```typescript
public resetName(): void
```

##### `resetPriority` <a name="resetPriority" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetPriority"></a>

```typescript
public resetPriority(): void
```

##### `resetReplicationSourceName` <a name="resetReplicationSourceName" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetReplicationSourceName"></a>

```typescript
public resetReplicationSourceName(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSource">replicationSource</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.role">role</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.priorityInput">priorityInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSourceNameInput">replicationSourceNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.priority">priority</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSourceName">replicationSourceName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `replicationSource`<sup>Required</sup> <a name="replicationSource" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSource"></a>

```typescript
public readonly replicationSource: string;
```

- *Type:* string

---

##### `role`<sup>Required</sup> <a name="role" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `priorityInput`<sup>Optional</sup> <a name="priorityInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.priorityInput"></a>

```typescript
public readonly priorityInput: number;
```

- *Type:* number

---

##### `replicationSourceNameInput`<sup>Optional</sup> <a name="replicationSourceNameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSourceNameInput"></a>

```typescript
public readonly replicationSourceNameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `priority`<sup>Required</sup> <a name="priority" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

---

##### `replicationSourceName`<sup>Required</sup> <a name="replicationSourceName" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.replicationSourceName"></a>

```typescript
public readonly replicationSourceName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterHost">MdbPostgresqlClusterHost</a>

---


### MdbPostgresqlClusterMaintenanceWindowOutputReference <a name="MdbPostgresqlClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterMaintenanceWindow">MdbPostgresqlClusterMaintenanceWindow</a>

---


### MdbPostgresqlClusterRestoreOutputReference <a name="MdbPostgresqlClusterRestoreOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterRestoreOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterRestoreOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resetTime">resetTime</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resetTimeInclusive">resetTimeInclusive</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTime` <a name="resetTime" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resetTime"></a>

```typescript
public resetTime(): void
```

##### `resetTimeInclusive` <a name="resetTimeInclusive" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.resetTimeInclusive"></a>

```typescript
public resetTimeInclusive(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.backupIdInput">backupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInclusiveInput">timeInclusiveInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInput">timeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.backupId">backupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.time">time</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInclusive">timeInclusive</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `backupIdInput`<sup>Optional</sup> <a name="backupIdInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.backupIdInput"></a>

```typescript
public readonly backupIdInput: string;
```

- *Type:* string

---

##### `timeInclusiveInput`<sup>Optional</sup> <a name="timeInclusiveInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInclusiveInput"></a>

```typescript
public readonly timeInclusiveInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `timeInput`<sup>Optional</sup> <a name="timeInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInput"></a>

```typescript
public readonly timeInput: string;
```

- *Type:* string

---

##### `backupId`<sup>Required</sup> <a name="backupId" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.backupId"></a>

```typescript
public readonly backupId: string;
```

- *Type:* string

---

##### `time`<sup>Required</sup> <a name="time" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.time"></a>

```typescript
public readonly time: string;
```

- *Type:* string

---

##### `timeInclusive`<sup>Required</sup> <a name="timeInclusive" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.timeInclusive"></a>

```typescript
public readonly timeInclusive: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterRestoreOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbPostgresqlClusterRestore;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterRestore">MdbPostgresqlClusterRestore</a>

---


### MdbPostgresqlClusterTimeoutsOutputReference <a name="MdbPostgresqlClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterTimeouts">MdbPostgresqlClusterTimeouts</a>

---


### MdbPostgresqlClusterUserList <a name="MdbPostgresqlClusterUserList" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUserList } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.get"></a>

```typescript
public get(index: number): MdbPostgresqlClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>[]

---


### MdbPostgresqlClusterUserOutputReference <a name="MdbPostgresqlClusterUserOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetConnLimit">resetConnLimit</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetGrants">resetGrants</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetLogin">resetLogin</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetSettings">resetSettings</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbPostgresqlClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]

---

##### `resetConnLimit` <a name="resetConnLimit" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetConnLimit"></a>

```typescript
public resetConnLimit(): void
```

##### `resetGrants` <a name="resetGrants" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetGrants"></a>

```typescript
public resetGrants(): void
```

##### `resetLogin` <a name="resetLogin" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetLogin"></a>

```typescript
public resetLogin(): void
```

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```

##### `resetSettings` <a name="resetSettings" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.resetSettings"></a>

```typescript
public resetSettings(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList">MdbPostgresqlClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.connLimitInput">connLimitInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.grantsInput">grantsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.loginInput">loginInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.settingsInput">settingsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.connLimit">connLimit</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.grants">grants</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.login">login</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.settings">settings</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbPostgresqlClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList">MdbPostgresqlClusterUserPermissionList</a>

---

##### `connLimitInput`<sup>Optional</sup> <a name="connLimitInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.connLimitInput"></a>

```typescript
public readonly connLimitInput: number;
```

- *Type:* number

---

##### `grantsInput`<sup>Optional</sup> <a name="grantsInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.grantsInput"></a>

```typescript
public readonly grantsInput: string[];
```

- *Type:* string[]

---

##### `loginInput`<sup>Optional</sup> <a name="loginInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.loginInput"></a>

```typescript
public readonly loginInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbPostgresqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]

---

##### `settingsInput`<sup>Optional</sup> <a name="settingsInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.settingsInput"></a>

```typescript
public readonly settingsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `connLimit`<sup>Required</sup> <a name="connLimit" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.connLimit"></a>

```typescript
public readonly connLimit: number;
```

- *Type:* number

---

##### `grants`<sup>Required</sup> <a name="grants" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.grants"></a>

```typescript
public readonly grants: string[];
```

- *Type:* string[]

---

##### `login`<sup>Required</sup> <a name="login" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.login"></a>

```typescript
public readonly login: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `settings`<sup>Required</sup> <a name="settings" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.settings"></a>

```typescript
public readonly settings: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUser">MdbPostgresqlClusterUser</a>

---


### MdbPostgresqlClusterUserPermissionList <a name="MdbPostgresqlClusterUserPermissionList" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbPostgresqlClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>[]

---


### MdbPostgresqlClusterUserPermissionOutputReference <a name="MdbPostgresqlClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbPostgresqlClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbPostgresqlClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.databaseNameInput">databaseNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseNameInput`<sup>Optional</sup> <a name="databaseNameInput" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* string

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbPostgresqlClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbPostgresqlClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbPostgresqlClusterUserPermission">MdbPostgresqlClusterUserPermission</a>

---


### MdbRedisClusterConfigAOutputReference <a name="MdbRedisClusterConfigAOutputReference" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.Initializer"></a>

```typescript
import { MdbRedisClusterConfigAOutputReference } from '@cdktf/provider-yandex'

new MdbRedisClusterConfigAOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetDatabases">resetDatabases</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetMaxmemoryPolicy">resetMaxmemoryPolicy</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetNotifyKeyspaceEvents">resetNotifyKeyspaceEvents</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetSlowlogLogSlowerThan">resetSlowlogLogSlowerThan</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetSlowlogMaxLen">resetSlowlogMaxLen</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetTimeout">resetTimeout</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDatabases` <a name="resetDatabases" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetDatabases"></a>

```typescript
public resetDatabases(): void
```

##### `resetMaxmemoryPolicy` <a name="resetMaxmemoryPolicy" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetMaxmemoryPolicy"></a>

```typescript
public resetMaxmemoryPolicy(): void
```

##### `resetNotifyKeyspaceEvents` <a name="resetNotifyKeyspaceEvents" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetNotifyKeyspaceEvents"></a>

```typescript
public resetNotifyKeyspaceEvents(): void
```

##### `resetSlowlogLogSlowerThan` <a name="resetSlowlogLogSlowerThan" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetSlowlogLogSlowerThan"></a>

```typescript
public resetSlowlogLogSlowerThan(): void
```

##### `resetSlowlogMaxLen` <a name="resetSlowlogMaxLen" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetSlowlogMaxLen"></a>

```typescript
public resetSlowlogMaxLen(): void
```

##### `resetTimeout` <a name="resetTimeout" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.resetTimeout"></a>

```typescript
public resetTimeout(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.databasesInput">databasesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.maxmemoryPolicyInput">maxmemoryPolicyInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEventsInput">notifyKeyspaceEventsInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThanInput">slowlogLogSlowerThanInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogMaxLenInput">slowlogMaxLenInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.timeoutInput">timeoutInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.versionInput">versionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.databases">databases</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.maxmemoryPolicy">maxmemoryPolicy</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEvents">notifyKeyspaceEvents</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThan">slowlogLogSlowerThan</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogMaxLen">slowlogMaxLen</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.timeout">timeout</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.version">version</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databasesInput`<sup>Optional</sup> <a name="databasesInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.databasesInput"></a>

```typescript
public readonly databasesInput: number;
```

- *Type:* number

---

##### `maxmemoryPolicyInput`<sup>Optional</sup> <a name="maxmemoryPolicyInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.maxmemoryPolicyInput"></a>

```typescript
public readonly maxmemoryPolicyInput: string;
```

- *Type:* string

---

##### `notifyKeyspaceEventsInput`<sup>Optional</sup> <a name="notifyKeyspaceEventsInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEventsInput"></a>

```typescript
public readonly notifyKeyspaceEventsInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `slowlogLogSlowerThanInput`<sup>Optional</sup> <a name="slowlogLogSlowerThanInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThanInput"></a>

```typescript
public readonly slowlogLogSlowerThanInput: number;
```

- *Type:* number

---

##### `slowlogMaxLenInput`<sup>Optional</sup> <a name="slowlogMaxLenInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogMaxLenInput"></a>

```typescript
public readonly slowlogMaxLenInput: number;
```

- *Type:* number

---

##### `timeoutInput`<sup>Optional</sup> <a name="timeoutInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.timeoutInput"></a>

```typescript
public readonly timeoutInput: number;
```

- *Type:* number

---

##### `versionInput`<sup>Optional</sup> <a name="versionInput" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.versionInput"></a>

```typescript
public readonly versionInput: string;
```

- *Type:* string

---

##### `databases`<sup>Required</sup> <a name="databases" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.databases"></a>

```typescript
public readonly databases: number;
```

- *Type:* number

---

##### `maxmemoryPolicy`<sup>Required</sup> <a name="maxmemoryPolicy" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.maxmemoryPolicy"></a>

```typescript
public readonly maxmemoryPolicy: string;
```

- *Type:* string

---

##### `notifyKeyspaceEvents`<sup>Required</sup> <a name="notifyKeyspaceEvents" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.notifyKeyspaceEvents"></a>

```typescript
public readonly notifyKeyspaceEvents: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `slowlogLogSlowerThan`<sup>Required</sup> <a name="slowlogLogSlowerThan" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogLogSlowerThan"></a>

```typescript
public readonly slowlogLogSlowerThan: number;
```

- *Type:* number

---

##### `slowlogMaxLen`<sup>Required</sup> <a name="slowlogMaxLen" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.slowlogMaxLen"></a>

```typescript
public readonly slowlogMaxLen: number;
```

- *Type:* number

---

##### `timeout`<sup>Required</sup> <a name="timeout" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.timeout"></a>

```typescript
public readonly timeout: number;
```

- *Type:* number

---

##### `version`<sup>Required</sup> <a name="version" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterConfigAOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbRedisClusterConfigA;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterConfigA">MdbRedisClusterConfigA</a>

---


### MdbRedisClusterHostList <a name="MdbRedisClusterHostList" id="@cdktf/provider-yandex.MdbRedisClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer"></a>

```typescript
import { MdbRedisClusterHostList } from '@cdktf/provider-yandex'

new MdbRedisClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbRedisClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbRedisClusterHostList.get"></a>

```typescript
public get(index: number): MdbRedisClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbRedisClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbRedisClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>[]

---


### MdbRedisClusterHostOutputReference <a name="MdbRedisClusterHostOutputReference" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbRedisClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbRedisClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resetShardName">resetShardName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetShardName` <a name="resetShardName" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resetShardName"></a>

```typescript
public resetShardName(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.shardNameInput">shardNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.shardName">shardName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `shardNameInput`<sup>Optional</sup> <a name="shardNameInput" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.shardNameInput"></a>

```typescript
public readonly shardNameInput: string;
```

- *Type:* string

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `shardName`<sup>Required</sup> <a name="shardName" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.shardName"></a>

```typescript
public readonly shardName: string;
```

- *Type:* string

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbRedisClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterHost">MdbRedisClusterHost</a>

---


### MdbRedisClusterMaintenanceWindowOutputReference <a name="MdbRedisClusterMaintenanceWindowOutputReference" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.Initializer"></a>

```typescript
import { MdbRedisClusterMaintenanceWindowOutputReference } from '@cdktf/provider-yandex'

new MdbRedisClusterMaintenanceWindowOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resetDay">resetDay</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resetHour">resetHour</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDay` <a name="resetDay" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resetDay"></a>

```typescript
public resetDay(): void
```

##### `resetHour` <a name="resetHour" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.resetHour"></a>

```typescript
public resetHour(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.dayInput">dayInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.hourInput">hourInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.day">day</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.hour">hour</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dayInput`<sup>Optional</sup> <a name="dayInput" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.dayInput"></a>

```typescript
public readonly dayInput: string;
```

- *Type:* string

---

##### `hourInput`<sup>Optional</sup> <a name="hourInput" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.hourInput"></a>

```typescript
public readonly hourInput: number;
```

- *Type:* number

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `day`<sup>Required</sup> <a name="day" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.day"></a>

```typescript
public readonly day: string;
```

- *Type:* string

---

##### `hour`<sup>Required</sup> <a name="hour" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.hour"></a>

```typescript
public readonly hour: number;
```

- *Type:* number

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindowOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbRedisClusterMaintenanceWindow;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterMaintenanceWindow">MdbRedisClusterMaintenanceWindow</a>

---


### MdbRedisClusterResourcesOutputReference <a name="MdbRedisClusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbRedisClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbRedisClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.resetDiskTypeId">resetDiskTypeId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDiskTypeId` <a name="resetDiskTypeId" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.resetDiskTypeId"></a>

```typescript
public resetDiskTypeId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbRedisClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbRedisClusterResources">MdbRedisClusterResources</a>

---


### MdbRedisClusterTimeoutsOutputReference <a name="MdbRedisClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbRedisClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbRedisClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbRedisClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbRedisClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbRedisClusterTimeouts">MdbRedisClusterTimeouts</a>

---


### MdbSqlserverClusterBackupWindowStartOutputReference <a name="MdbSqlserverClusterBackupWindowStartOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterBackupWindowStartOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterBackupWindowStartOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resetHours">resetHours</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resetMinutes">resetMinutes</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetHours` <a name="resetHours" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resetHours"></a>

```typescript
public resetHours(): void
```

##### `resetMinutes` <a name="resetMinutes" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.resetMinutes"></a>

```typescript
public resetMinutes(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.hoursInput">hoursInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.minutesInput">minutesInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.hours">hours</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.minutes">minutes</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `hoursInput`<sup>Optional</sup> <a name="hoursInput" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.hoursInput"></a>

```typescript
public readonly hoursInput: number;
```

- *Type:* number

---

##### `minutesInput`<sup>Optional</sup> <a name="minutesInput" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.minutesInput"></a>

```typescript
public readonly minutesInput: number;
```

- *Type:* number

---

##### `hours`<sup>Required</sup> <a name="hours" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.hours"></a>

```typescript
public readonly hours: number;
```

- *Type:* number

---

##### `minutes`<sup>Required</sup> <a name="minutes" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.minutes"></a>

```typescript
public readonly minutes: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStartOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbSqlserverClusterBackupWindowStart;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterBackupWindowStart">MdbSqlserverClusterBackupWindowStart</a>

---


### MdbSqlserverClusterDatabaseList <a name="MdbSqlserverClusterDatabaseList" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer"></a>

```typescript
import { MdbSqlserverClusterDatabaseList } from '@cdktf/provider-yandex'

new MdbSqlserverClusterDatabaseList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.get"></a>

```typescript
public get(index: number): MdbSqlserverClusterDatabaseOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterDatabase[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>[]

---


### MdbSqlserverClusterDatabaseOutputReference <a name="MdbSqlserverClusterDatabaseOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterDatabaseOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterDatabaseOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterDatabaseOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterDatabase;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterDatabase">MdbSqlserverClusterDatabase</a>

---


### MdbSqlserverClusterHostList <a name="MdbSqlserverClusterHostList" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer"></a>

```typescript
import { MdbSqlserverClusterHostList } from '@cdktf/provider-yandex'

new MdbSqlserverClusterHostList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.get"></a>

```typescript
public get(index: number): MdbSqlserverClusterHostOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterHostList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterHost[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>[]

---


### MdbSqlserverClusterHostOutputReference <a name="MdbSqlserverClusterHostOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterHostOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterHostOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resetAssignPublicIp">resetAssignPublicIp</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resetSubnetId">resetSubnetId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAssignPublicIp` <a name="resetAssignPublicIp" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resetAssignPublicIp"></a>

```typescript
public resetAssignPublicIp(): void
```

##### `resetSubnetId` <a name="resetSubnetId" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.resetSubnetId"></a>

```typescript
public resetSubnetId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.fqdn">fqdn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.assignPublicIpInput">assignPublicIpInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.subnetIdInput">subnetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.zoneInput">zoneInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.assignPublicIp">assignPublicIp</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.subnetId">subnetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.zone">zone</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fqdn`<sup>Required</sup> <a name="fqdn" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.fqdn"></a>

```typescript
public readonly fqdn: string;
```

- *Type:* string

---

##### `assignPublicIpInput`<sup>Optional</sup> <a name="assignPublicIpInput" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.assignPublicIpInput"></a>

```typescript
public readonly assignPublicIpInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetIdInput`<sup>Optional</sup> <a name="subnetIdInput" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.subnetIdInput"></a>

```typescript
public readonly subnetIdInput: string;
```

- *Type:* string

---

##### `zoneInput`<sup>Optional</sup> <a name="zoneInput" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.zoneInput"></a>

```typescript
public readonly zoneInput: string;
```

- *Type:* string

---

##### `assignPublicIp`<sup>Required</sup> <a name="assignPublicIp" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.assignPublicIp"></a>

```typescript
public readonly assignPublicIp: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `subnetId`<sup>Required</sup> <a name="subnetId" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.subnetId"></a>

```typescript
public readonly subnetId: string;
```

- *Type:* string

---

##### `zone`<sup>Required</sup> <a name="zone" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterHostOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterHost;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterHost">MdbSqlserverClusterHost</a>

---


### MdbSqlserverClusterResourcesOutputReference <a name="MdbSqlserverClusterResourcesOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterResourcesOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterResourcesOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskSizeInput">diskSizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskTypeIdInput">diskTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.resourcePresetIdInput">resourcePresetIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskSize">diskSize</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskTypeId">diskTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.resourcePresetId">resourcePresetId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `diskSizeInput`<sup>Optional</sup> <a name="diskSizeInput" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskSizeInput"></a>

```typescript
public readonly diskSizeInput: number;
```

- *Type:* number

---

##### `diskTypeIdInput`<sup>Optional</sup> <a name="diskTypeIdInput" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskTypeIdInput"></a>

```typescript
public readonly diskTypeIdInput: string;
```

- *Type:* string

---

##### `resourcePresetIdInput`<sup>Optional</sup> <a name="resourcePresetIdInput" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.resourcePresetIdInput"></a>

```typescript
public readonly resourcePresetIdInput: string;
```

- *Type:* string

---

##### `diskSize`<sup>Required</sup> <a name="diskSize" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskSize"></a>

```typescript
public readonly diskSize: number;
```

- *Type:* number

---

##### `diskTypeId`<sup>Required</sup> <a name="diskTypeId" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.diskTypeId"></a>

```typescript
public readonly diskTypeId: string;
```

- *Type:* string

---

##### `resourcePresetId`<sup>Required</sup> <a name="resourcePresetId" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.resourcePresetId"></a>

```typescript
public readonly resourcePresetId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterResourcesOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: MdbSqlserverClusterResources;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterResources">MdbSqlserverClusterResources</a>

---


### MdbSqlserverClusterTimeoutsOutputReference <a name="MdbSqlserverClusterTimeoutsOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterTimeoutsOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterTimeouts">MdbSqlserverClusterTimeouts</a>

---


### MdbSqlserverClusterUserList <a name="MdbSqlserverClusterUserList" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer"></a>

```typescript
import { MdbSqlserverClusterUserList } from '@cdktf/provider-yandex'

new MdbSqlserverClusterUserList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.get"></a>

```typescript
public get(index: number): MdbSqlserverClusterUserOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterUserList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterUser[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>[]

---


### MdbSqlserverClusterUserOutputReference <a name="MdbSqlserverClusterUserOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterUserOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterUserOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.putPermission">putPermission</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.resetPermission">resetPermission</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putPermission` <a name="putPermission" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.putPermission"></a>

```typescript
public putPermission(value: IResolvable | MdbSqlserverClusterUserPermission[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.putPermission.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]

---

##### `resetPermission` <a name="resetPermission" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.resetPermission"></a>

```typescript
public resetPermission(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.permission">permission</a></code> | <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList">MdbSqlserverClusterUserPermissionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.nameInput">nameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.passwordInput">passwordInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.permissionInput">permissionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.password">password</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `permission`<sup>Required</sup> <a name="permission" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.permission"></a>

```typescript
public readonly permission: MdbSqlserverClusterUserPermissionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList">MdbSqlserverClusterUserPermissionList</a>

---

##### `nameInput`<sup>Optional</sup> <a name="nameInput" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.nameInput"></a>

```typescript
public readonly nameInput: string;
```

- *Type:* string

---

##### `passwordInput`<sup>Optional</sup> <a name="passwordInput" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.passwordInput"></a>

```typescript
public readonly passwordInput: string;
```

- *Type:* string

---

##### `permissionInput`<sup>Optional</sup> <a name="permissionInput" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.permissionInput"></a>

```typescript
public readonly permissionInput: IResolvable | MdbSqlserverClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]

---

##### `name`<sup>Required</sup> <a name="name" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `password`<sup>Required</sup> <a name="password" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterUserOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterUser;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUser">MdbSqlserverClusterUser</a>

---


### MdbSqlserverClusterUserPermissionList <a name="MdbSqlserverClusterUserPermissionList" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer"></a>

```typescript
import { MdbSqlserverClusterUserPermissionList } from '@cdktf/provider-yandex'

new MdbSqlserverClusterUserPermissionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.get"></a>

```typescript
public get(index: number): MdbSqlserverClusterUserPermissionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterUserPermission[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>[]

---


### MdbSqlserverClusterUserPermissionOutputReference <a name="MdbSqlserverClusterUserPermissionOutputReference" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer"></a>

```typescript
import { MdbSqlserverClusterUserPermissionOutputReference } from '@cdktf/provider-yandex'

new MdbSqlserverClusterUserPermissionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.resetRoles">resetRoles</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetRoles` <a name="resetRoles" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.resetRoles"></a>

```typescript
public resetRoles(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.databaseNameInput">databaseNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.rolesInput">rolesInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.databaseName">databaseName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.roles">roles</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `databaseNameInput`<sup>Optional</sup> <a name="databaseNameInput" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.databaseNameInput"></a>

```typescript
public readonly databaseNameInput: string;
```

- *Type:* string

---

##### `rolesInput`<sup>Optional</sup> <a name="rolesInput" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.rolesInput"></a>

```typescript
public readonly rolesInput: string[];
```

- *Type:* string[]

---

##### `databaseName`<sup>Required</sup> <a name="databaseName" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.databaseName"></a>

```typescript
public readonly databaseName: string;
```

- *Type:* string

---

##### `roles`<sup>Required</sup> <a name="roles" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.roles"></a>

```typescript
public readonly roles: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.MdbSqlserverClusterUserPermissionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | MdbSqlserverClusterUserPermission;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.MdbSqlserverClusterUserPermission">MdbSqlserverClusterUserPermission</a>

---


### OrganizationmanagerSamlFederationSecuritySettingsOutputReference <a name="OrganizationmanagerSamlFederationSecuritySettingsOutputReference" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederationSecuritySettingsOutputReference } from '@cdktf/provider-yandex'

new OrganizationmanagerSamlFederationSecuritySettingsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertionsInput">encryptedAssertionsInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertions">encryptedAssertions</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `encryptedAssertionsInput`<sup>Optional</sup> <a name="encryptedAssertionsInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertionsInput"></a>

```typescript
public readonly encryptedAssertionsInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `encryptedAssertions`<sup>Required</sup> <a name="encryptedAssertions" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.encryptedAssertions"></a>

```typescript
public readonly encryptedAssertions: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettingsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: OrganizationmanagerSamlFederationSecuritySettings;
```

- *Type:* <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationSecuritySettings">OrganizationmanagerSamlFederationSecuritySettings</a>

---


### OrganizationmanagerSamlFederationTimeoutsOutputReference <a name="OrganizationmanagerSamlFederationTimeoutsOutputReference" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.Initializer"></a>

```typescript
import { OrganizationmanagerSamlFederationTimeoutsOutputReference } from '@cdktf/provider-yandex'

new OrganizationmanagerSamlFederationTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | OrganizationmanagerSamlFederationTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.OrganizationmanagerSamlFederationTimeouts">OrganizationmanagerSamlFederationTimeouts</a>

---


### ResourcemanagerCloudTimeoutsOutputReference <a name="ResourcemanagerCloudTimeoutsOutputReference" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.Initializer"></a>

```typescript
import { ResourcemanagerCloudTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ResourcemanagerCloudTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ResourcemanagerCloudTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ResourcemanagerCloudTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ResourcemanagerCloudTimeouts">ResourcemanagerCloudTimeouts</a>

---


### ResourcemanagerFolderTimeoutsOutputReference <a name="ResourcemanagerFolderTimeoutsOutputReference" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.Initializer"></a>

```typescript
import { ResourcemanagerFolderTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ResourcemanagerFolderTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ResourcemanagerFolderTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ResourcemanagerFolderTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ResourcemanagerFolderTimeouts">ResourcemanagerFolderTimeouts</a>

---


### ServerlessContainerImageOutputReference <a name="ServerlessContainerImageOutputReference" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.Initializer"></a>

```typescript
import { ServerlessContainerImageOutputReference } from '@cdktf/provider-yandex'

new ServerlessContainerImageOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetArgs">resetArgs</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetCommand">resetCommand</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetDigest">resetDigest</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetEnvironment">resetEnvironment</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetWorkDir">resetWorkDir</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetArgs` <a name="resetArgs" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetArgs"></a>

```typescript
public resetArgs(): void
```

##### `resetCommand` <a name="resetCommand" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetCommand"></a>

```typescript
public resetCommand(): void
```

##### `resetDigest` <a name="resetDigest" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetDigest"></a>

```typescript
public resetDigest(): void
```

##### `resetEnvironment` <a name="resetEnvironment" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetEnvironment"></a>

```typescript
public resetEnvironment(): void
```

##### `resetWorkDir` <a name="resetWorkDir" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.resetWorkDir"></a>

```typescript
public resetWorkDir(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.argsInput">argsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.commandInput">commandInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.digestInput">digestInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.environmentInput">environmentInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.urlInput">urlInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.workDirInput">workDirInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.args">args</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.command">command</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.digest">digest</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.environment">environment</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.url">url</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.workDir">workDir</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `argsInput`<sup>Optional</sup> <a name="argsInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.argsInput"></a>

```typescript
public readonly argsInput: string[];
```

- *Type:* string[]

---

##### `commandInput`<sup>Optional</sup> <a name="commandInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.commandInput"></a>

```typescript
public readonly commandInput: string[];
```

- *Type:* string[]

---

##### `digestInput`<sup>Optional</sup> <a name="digestInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.digestInput"></a>

```typescript
public readonly digestInput: string;
```

- *Type:* string

---

##### `environmentInput`<sup>Optional</sup> <a name="environmentInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.environmentInput"></a>

```typescript
public readonly environmentInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `urlInput`<sup>Optional</sup> <a name="urlInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.urlInput"></a>

```typescript
public readonly urlInput: string;
```

- *Type:* string

---

##### `workDirInput`<sup>Optional</sup> <a name="workDirInput" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.workDirInput"></a>

```typescript
public readonly workDirInput: string;
```

- *Type:* string

---

##### `args`<sup>Required</sup> <a name="args" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

---

##### `command`<sup>Required</sup> <a name="command" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

---

##### `digest`<sup>Required</sup> <a name="digest" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.digest"></a>

```typescript
public readonly digest: string;
```

- *Type:* string

---

##### `environment`<sup>Required</sup> <a name="environment" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.environment"></a>

```typescript
public readonly environment: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `url`<sup>Required</sup> <a name="url" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

##### `workDir`<sup>Required</sup> <a name="workDir" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.workDir"></a>

```typescript
public readonly workDir: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ServerlessContainerImageOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: ServerlessContainerImage;
```

- *Type:* <a href="#@cdktf/provider-yandex.ServerlessContainerImage">ServerlessContainerImage</a>

---


### ServerlessContainerTimeoutsOutputReference <a name="ServerlessContainerTimeoutsOutputReference" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.Initializer"></a>

```typescript
import { ServerlessContainerTimeoutsOutputReference } from '@cdktf/provider-yandex'

new ServerlessContainerTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.ServerlessContainerTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | ServerlessContainerTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.ServerlessContainerTimeouts">ServerlessContainerTimeouts</a>

---


### StorageBucketCorsRuleList <a name="StorageBucketCorsRuleList" id="@cdktf/provider-yandex.StorageBucketCorsRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer"></a>

```typescript
import { StorageBucketCorsRuleList } from '@cdktf/provider-yandex'

new StorageBucketCorsRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.get"></a>

```typescript
public get(index: number): StorageBucketCorsRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketCorsRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketCorsRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>[]

---


### StorageBucketCorsRuleOutputReference <a name="StorageBucketCorsRuleOutputReference" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer"></a>

```typescript
import { StorageBucketCorsRuleOutputReference } from '@cdktf/provider-yandex'

new StorageBucketCorsRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetAllowedHeaders">resetAllowedHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetExposeHeaders">resetExposeHeaders</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetMaxAgeSeconds">resetMaxAgeSeconds</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetAllowedHeaders` <a name="resetAllowedHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetAllowedHeaders"></a>

```typescript
public resetAllowedHeaders(): void
```

##### `resetExposeHeaders` <a name="resetExposeHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetExposeHeaders"></a>

```typescript
public resetExposeHeaders(): void
```

##### `resetMaxAgeSeconds` <a name="resetMaxAgeSeconds" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.resetMaxAgeSeconds"></a>

```typescript
public resetMaxAgeSeconds(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedHeadersInput">allowedHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedMethodsInput">allowedMethodsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedOriginsInput">allowedOriginsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.exposeHeadersInput">exposeHeadersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.maxAgeSecondsInput">maxAgeSecondsInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedHeaders">allowedHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedMethods">allowedMethods</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedOrigins">allowedOrigins</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.exposeHeaders">exposeHeaders</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.maxAgeSeconds">maxAgeSeconds</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `allowedHeadersInput`<sup>Optional</sup> <a name="allowedHeadersInput" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedHeadersInput"></a>

```typescript
public readonly allowedHeadersInput: string[];
```

- *Type:* string[]

---

##### `allowedMethodsInput`<sup>Optional</sup> <a name="allowedMethodsInput" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedMethodsInput"></a>

```typescript
public readonly allowedMethodsInput: string[];
```

- *Type:* string[]

---

##### `allowedOriginsInput`<sup>Optional</sup> <a name="allowedOriginsInput" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedOriginsInput"></a>

```typescript
public readonly allowedOriginsInput: string[];
```

- *Type:* string[]

---

##### `exposeHeadersInput`<sup>Optional</sup> <a name="exposeHeadersInput" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.exposeHeadersInput"></a>

```typescript
public readonly exposeHeadersInput: string[];
```

- *Type:* string[]

---

##### `maxAgeSecondsInput`<sup>Optional</sup> <a name="maxAgeSecondsInput" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.maxAgeSecondsInput"></a>

```typescript
public readonly maxAgeSecondsInput: number;
```

- *Type:* number

---

##### `allowedHeaders`<sup>Required</sup> <a name="allowedHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedHeaders"></a>

```typescript
public readonly allowedHeaders: string[];
```

- *Type:* string[]

---

##### `allowedMethods`<sup>Required</sup> <a name="allowedMethods" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedMethods"></a>

```typescript
public readonly allowedMethods: string[];
```

- *Type:* string[]

---

##### `allowedOrigins`<sup>Required</sup> <a name="allowedOrigins" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.allowedOrigins"></a>

```typescript
public readonly allowedOrigins: string[];
```

- *Type:* string[]

---

##### `exposeHeaders`<sup>Required</sup> <a name="exposeHeaders" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.exposeHeaders"></a>

```typescript
public readonly exposeHeaders: string[];
```

- *Type:* string[]

---

##### `maxAgeSeconds`<sup>Required</sup> <a name="maxAgeSeconds" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.maxAgeSeconds"></a>

```typescript
public readonly maxAgeSeconds: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketCorsRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketCorsRule;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketCorsRule">StorageBucketCorsRule</a>

---


### StorageBucketGrantList <a name="StorageBucketGrantList" id="@cdktf/provider-yandex.StorageBucketGrantList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketGrantList.Initializer"></a>

```typescript
import { StorageBucketGrantList } from '@cdktf/provider-yandex'

new StorageBucketGrantList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketGrantList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketGrantList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketGrantList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketGrantList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketGrantList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketGrantList.get"></a>

```typescript
public get(index: number): StorageBucketGrantOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketGrantList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketGrantList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketGrantList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketGrantList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketGrant[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>[]

---


### StorageBucketGrantOutputReference <a name="StorageBucketGrantOutputReference" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer"></a>

```typescript
import { StorageBucketGrantOutputReference } from '@cdktf/provider-yandex'

new StorageBucketGrantOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.resetUri">resetUri</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.resetId"></a>

```typescript
public resetId(): void
```

##### `resetUri` <a name="resetUri" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.resetUri"></a>

```typescript
public resetUri(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.permissionsInput">permissionsInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.typeInput">typeInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.uriInput">uriInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.permissions">permissions</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.uri">uri</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `permissionsInput`<sup>Optional</sup> <a name="permissionsInput" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.permissionsInput"></a>

```typescript
public readonly permissionsInput: string[];
```

- *Type:* string[]

---

##### `typeInput`<sup>Optional</sup> <a name="typeInput" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.typeInput"></a>

```typescript
public readonly typeInput: string;
```

- *Type:* string

---

##### `uriInput`<sup>Optional</sup> <a name="uriInput" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.uriInput"></a>

```typescript
public readonly uriInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.permissions"></a>

```typescript
public readonly permissions: string[];
```

- *Type:* string[]

---

##### `type`<sup>Required</sup> <a name="type" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uri`<sup>Required</sup> <a name="uri" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.uri"></a>

```typescript
public readonly uri: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketGrantOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketGrant;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketGrant">StorageBucketGrant</a>

---


### StorageBucketLifecycleRuleExpirationOutputReference <a name="StorageBucketLifecycleRuleExpirationOutputReference" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleExpirationOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetDate">resetDate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetDays">resetDays</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetExpiredObjectDeleteMarker">resetExpiredObjectDeleteMarker</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDate` <a name="resetDate" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetDate"></a>

```typescript
public resetDate(): void
```

##### `resetDays` <a name="resetDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetDays"></a>

```typescript
public resetDays(): void
```

##### `resetExpiredObjectDeleteMarker` <a name="resetExpiredObjectDeleteMarker" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.resetExpiredObjectDeleteMarker"></a>

```typescript
public resetExpiredObjectDeleteMarker(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.dateInput">dateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.daysInput">daysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarkerInput">expiredObjectDeleteMarkerInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.date">date</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.days">days</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarker">expiredObjectDeleteMarker</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dateInput`<sup>Optional</sup> <a name="dateInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.dateInput"></a>

```typescript
public readonly dateInput: string;
```

- *Type:* string

---

##### `daysInput`<sup>Optional</sup> <a name="daysInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* number

---

##### `expiredObjectDeleteMarkerInput`<sup>Optional</sup> <a name="expiredObjectDeleteMarkerInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarkerInput"></a>

```typescript
public readonly expiredObjectDeleteMarkerInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `date`<sup>Required</sup> <a name="date" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* string

---

##### `days`<sup>Required</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

---

##### `expiredObjectDeleteMarker`<sup>Required</sup> <a name="expiredObjectDeleteMarker" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.expiredObjectDeleteMarker"></a>

```typescript
public readonly expiredObjectDeleteMarker: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketLifecycleRuleExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a>

---


### StorageBucketLifecycleRuleList <a name="StorageBucketLifecycleRuleList" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleList } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.get"></a>

```typescript
public get(index: number): StorageBucketLifecycleRuleOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRule[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>[]

---


### StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference <a name="StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resetDays">resetDays</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDays` <a name="resetDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.resetDays"></a>

```typescript
public resetDays(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.daysInput">daysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.days">days</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `daysInput`<sup>Optional</sup> <a name="daysInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* number

---

##### `days`<sup>Required</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a>

---


### StorageBucketLifecycleRuleNoncurrentVersionTransitionList <a name="StorageBucketLifecycleRuleNoncurrentVersionTransitionList" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleNoncurrentVersionTransitionList } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleNoncurrentVersionTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.get"></a>

```typescript
public get(index: number): StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]

---


### StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference <a name="StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.resetDays">resetDays</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDays` <a name="resetDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.resetDays"></a>

```typescript
public resetDays(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.daysInput">daysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClassInput">storageClassInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.days">days</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClass">storageClass</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `daysInput`<sup>Optional</sup> <a name="daysInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* number

---

##### `storageClassInput`<sup>Optional</sup> <a name="storageClassInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* string

---

##### `days`<sup>Required</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

---

##### `storageClass`<sup>Required</sup> <a name="storageClass" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRuleNoncurrentVersionTransition;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>

---


### StorageBucketLifecycleRuleOutputReference <a name="StorageBucketLifecycleRuleOutputReference" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putExpiration">putExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionExpiration">putNoncurrentVersionExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionTransition">putNoncurrentVersionTransition</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putTransition">putTransition</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetAbortIncompleteMultipartUploadDays">resetAbortIncompleteMultipartUploadDays</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetExpiration">resetExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetId">resetId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetNoncurrentVersionExpiration">resetNoncurrentVersionExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetNoncurrentVersionTransition">resetNoncurrentVersionTransition</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetPrefix">resetPrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetTransition">resetTransition</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putExpiration` <a name="putExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putExpiration"></a>

```typescript
public putExpiration(value: StorageBucketLifecycleRuleExpiration): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putExpiration.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a>

---

##### `putNoncurrentVersionExpiration` <a name="putNoncurrentVersionExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionExpiration"></a>

```typescript
public putNoncurrentVersionExpiration(value: StorageBucketLifecycleRuleNoncurrentVersionExpiration): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionExpiration.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a>

---

##### `putNoncurrentVersionTransition` <a name="putNoncurrentVersionTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionTransition"></a>

```typescript
public putNoncurrentVersionTransition(value: IResolvable | StorageBucketLifecycleRuleNoncurrentVersionTransition[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putNoncurrentVersionTransition.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]

---

##### `putTransition` <a name="putTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putTransition"></a>

```typescript
public putTransition(value: IResolvable | StorageBucketLifecycleRuleTransition[]): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.putTransition.parameter.value"></a>

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]

---

##### `resetAbortIncompleteMultipartUploadDays` <a name="resetAbortIncompleteMultipartUploadDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetAbortIncompleteMultipartUploadDays"></a>

```typescript
public resetAbortIncompleteMultipartUploadDays(): void
```

##### `resetExpiration` <a name="resetExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetExpiration"></a>

```typescript
public resetExpiration(): void
```

##### `resetId` <a name="resetId" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetId"></a>

```typescript
public resetId(): void
```

##### `resetNoncurrentVersionExpiration` <a name="resetNoncurrentVersionExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetNoncurrentVersionExpiration"></a>

```typescript
public resetNoncurrentVersionExpiration(): void
```

##### `resetNoncurrentVersionTransition` <a name="resetNoncurrentVersionTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetNoncurrentVersionTransition"></a>

```typescript
public resetNoncurrentVersionTransition(): void
```

##### `resetPrefix` <a name="resetPrefix" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetPrefix"></a>

```typescript
public resetPrefix(): void
```

##### `resetTransition` <a name="resetTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.resetTransition"></a>

```typescript
public resetTransition(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.expiration">expiration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference">StorageBucketLifecycleRuleExpirationOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionExpiration">noncurrentVersionExpiration</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference">StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionTransition">noncurrentVersionTransition</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList">StorageBucketLifecycleRuleNoncurrentVersionTransitionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.transition">transition</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList">StorageBucketLifecycleRuleTransitionList</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDaysInput">abortIncompleteMultipartUploadDaysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.expirationInput">expirationInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionExpirationInput">noncurrentVersionExpirationInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionTransitionInput">noncurrentVersionTransitionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.prefixInput">prefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.transitionInput">transitionInput</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDays">abortIncompleteMultipartUploadDays</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `expiration`<sup>Required</sup> <a name="expiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.expiration"></a>

```typescript
public readonly expiration: StorageBucketLifecycleRuleExpirationOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpirationOutputReference">StorageBucketLifecycleRuleExpirationOutputReference</a>

---

##### `noncurrentVersionExpiration`<sup>Required</sup> <a name="noncurrentVersionExpiration" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionExpiration"></a>

```typescript
public readonly noncurrentVersionExpiration: StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference">StorageBucketLifecycleRuleNoncurrentVersionExpirationOutputReference</a>

---

##### `noncurrentVersionTransition`<sup>Required</sup> <a name="noncurrentVersionTransition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionTransition"></a>

```typescript
public readonly noncurrentVersionTransition: StorageBucketLifecycleRuleNoncurrentVersionTransitionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransitionList">StorageBucketLifecycleRuleNoncurrentVersionTransitionList</a>

---

##### `transition`<sup>Required</sup> <a name="transition" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.transition"></a>

```typescript
public readonly transition: StorageBucketLifecycleRuleTransitionList;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList">StorageBucketLifecycleRuleTransitionList</a>

---

##### `abortIncompleteMultipartUploadDaysInput`<sup>Optional</sup> <a name="abortIncompleteMultipartUploadDaysInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDaysInput"></a>

```typescript
public readonly abortIncompleteMultipartUploadDaysInput: number;
```

- *Type:* number

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `expirationInput`<sup>Optional</sup> <a name="expirationInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.expirationInput"></a>

```typescript
public readonly expirationInput: StorageBucketLifecycleRuleExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleExpiration">StorageBucketLifecycleRuleExpiration</a>

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `noncurrentVersionExpirationInput`<sup>Optional</sup> <a name="noncurrentVersionExpirationInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionExpirationInput"></a>

```typescript
public readonly noncurrentVersionExpirationInput: StorageBucketLifecycleRuleNoncurrentVersionExpiration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionExpiration">StorageBucketLifecycleRuleNoncurrentVersionExpiration</a>

---

##### `noncurrentVersionTransitionInput`<sup>Optional</sup> <a name="noncurrentVersionTransitionInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.noncurrentVersionTransitionInput"></a>

```typescript
public readonly noncurrentVersionTransitionInput: IResolvable | StorageBucketLifecycleRuleNoncurrentVersionTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleNoncurrentVersionTransition">StorageBucketLifecycleRuleNoncurrentVersionTransition</a>[]

---

##### `prefixInput`<sup>Optional</sup> <a name="prefixInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.prefixInput"></a>

```typescript
public readonly prefixInput: string;
```

- *Type:* string

---

##### `transitionInput`<sup>Optional</sup> <a name="transitionInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.transitionInput"></a>

```typescript
public readonly transitionInput: IResolvable | StorageBucketLifecycleRuleTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]

---

##### `abortIncompleteMultipartUploadDays`<sup>Required</sup> <a name="abortIncompleteMultipartUploadDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.abortIncompleteMultipartUploadDays"></a>

```typescript
public readonly abortIncompleteMultipartUploadDays: number;
```

- *Type:* number

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `prefix`<sup>Required</sup> <a name="prefix" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRule;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRule">StorageBucketLifecycleRule</a>

---


### StorageBucketLifecycleRuleTransitionList <a name="StorageBucketLifecycleRuleTransitionList" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleTransitionList } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleTransitionList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.get"></a>

```typescript
public get(index: number): StorageBucketLifecycleRuleTransitionOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRuleTransition[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>[]

---


### StorageBucketLifecycleRuleTransitionOutputReference <a name="StorageBucketLifecycleRuleTransitionOutputReference" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer"></a>

```typescript
import { StorageBucketLifecycleRuleTransitionOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLifecycleRuleTransitionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resetDate">resetDate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resetDays">resetDays</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDate` <a name="resetDate" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resetDate"></a>

```typescript
public resetDate(): void
```

##### `resetDays` <a name="resetDays" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.resetDays"></a>

```typescript
public resetDays(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.dateInput">dateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.daysInput">daysInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.storageClassInput">storageClassInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.date">date</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.days">days</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.storageClass">storageClass</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `dateInput`<sup>Optional</sup> <a name="dateInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.dateInput"></a>

```typescript
public readonly dateInput: string;
```

- *Type:* string

---

##### `daysInput`<sup>Optional</sup> <a name="daysInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.daysInput"></a>

```typescript
public readonly daysInput: number;
```

- *Type:* number

---

##### `storageClassInput`<sup>Optional</sup> <a name="storageClassInput" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.storageClassInput"></a>

```typescript
public readonly storageClassInput: string;
```

- *Type:* string

---

##### `date`<sup>Required</sup> <a name="date" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.date"></a>

```typescript
public readonly date: string;
```

- *Type:* string

---

##### `days`<sup>Required</sup> <a name="days" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.days"></a>

```typescript
public readonly days: number;
```

- *Type:* number

---

##### `storageClass`<sup>Required</sup> <a name="storageClass" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.storageClass"></a>

```typescript
public readonly storageClass: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLifecycleRuleTransitionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLifecycleRuleTransition;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLifecycleRuleTransition">StorageBucketLifecycleRuleTransition</a>

---


### StorageBucketLoggingList <a name="StorageBucketLoggingList" id="@cdktf/provider-yandex.StorageBucketLoggingList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLoggingList.Initializer"></a>

```typescript
import { StorageBucketLoggingList } from '@cdktf/provider-yandex'

new StorageBucketLoggingList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.StorageBucketLoggingList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLoggingList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLoggingList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLoggingList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLoggingList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.StorageBucketLoggingList.get"></a>

```typescript
public get(index: number): StorageBucketLoggingOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.StorageBucketLoggingList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLoggingList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLoggingList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLoggingList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLogging[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>[]

---


### StorageBucketLoggingOutputReference <a name="StorageBucketLoggingOutputReference" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer"></a>

```typescript
import { StorageBucketLoggingOutputReference } from '@cdktf/provider-yandex'

new StorageBucketLoggingOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.resetTargetPrefix">resetTargetPrefix</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetTargetPrefix` <a name="resetTargetPrefix" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.resetTargetPrefix"></a>

```typescript
public resetTargetPrefix(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetBucketInput">targetBucketInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetPrefixInput">targetPrefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetBucket">targetBucket</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetPrefix">targetPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `targetBucketInput`<sup>Optional</sup> <a name="targetBucketInput" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetBucketInput"></a>

```typescript
public readonly targetBucketInput: string;
```

- *Type:* string

---

##### `targetPrefixInput`<sup>Optional</sup> <a name="targetPrefixInput" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetPrefixInput"></a>

```typescript
public readonly targetPrefixInput: string;
```

- *Type:* string

---

##### `targetBucket`<sup>Required</sup> <a name="targetBucket" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetBucket"></a>

```typescript
public readonly targetBucket: string;
```

- *Type:* string

---

##### `targetPrefix`<sup>Required</sup> <a name="targetPrefix" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.targetPrefix"></a>

```typescript
public readonly targetPrefix: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketLoggingOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | StorageBucketLogging;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.StorageBucketLogging">StorageBucketLogging</a>

---


### StorageBucketServerSideEncryptionConfigurationOutputReference <a name="StorageBucketServerSideEncryptionConfigurationOutputReference" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfigurationOutputReference } from '@cdktf/provider-yandex'

new StorageBucketServerSideEncryptionConfigurationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.putRule">putRule</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putRule` <a name="putRule" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.putRule"></a>

```typescript
public putRule(value: StorageBucketServerSideEncryptionConfigurationRule): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.putRule.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.rule">rule</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference">StorageBucketServerSideEncryptionConfigurationRuleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.ruleInput">ruleInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `rule`<sup>Required</sup> <a name="rule" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.rule"></a>

```typescript
public readonly rule: StorageBucketServerSideEncryptionConfigurationRuleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference">StorageBucketServerSideEncryptionConfigurationRuleOutputReference</a>

---

##### `ruleInput`<sup>Optional</sup> <a name="ruleInput" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.ruleInput"></a>

```typescript
public readonly ruleInput: StorageBucketServerSideEncryptionConfigurationRule;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketServerSideEncryptionConfiguration;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfiguration">StorageBucketServerSideEncryptionConfiguration</a>

---


### StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference <a name="StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference } from '@cdktf/provider-yandex'

new StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.kmsMasterKeyIdInput">kmsMasterKeyIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.sseAlgorithmInput">sseAlgorithmInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.kmsMasterKeyId">kmsMasterKeyId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.sseAlgorithm">sseAlgorithm</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `kmsMasterKeyIdInput`<sup>Optional</sup> <a name="kmsMasterKeyIdInput" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.kmsMasterKeyIdInput"></a>

```typescript
public readonly kmsMasterKeyIdInput: string;
```

- *Type:* string

---

##### `sseAlgorithmInput`<sup>Optional</sup> <a name="sseAlgorithmInput" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.sseAlgorithmInput"></a>

```typescript
public readonly sseAlgorithmInput: string;
```

- *Type:* string

---

##### `kmsMasterKeyId`<sup>Required</sup> <a name="kmsMasterKeyId" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.kmsMasterKeyId"></a>

```typescript
public readonly kmsMasterKeyId: string;
```

- *Type:* string

---

##### `sseAlgorithm`<sup>Required</sup> <a name="sseAlgorithm" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.sseAlgorithm"></a>

```typescript
public readonly sseAlgorithm: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a>

---


### StorageBucketServerSideEncryptionConfigurationRuleOutputReference <a name="StorageBucketServerSideEncryptionConfigurationRuleOutputReference" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.Initializer"></a>

```typescript
import { StorageBucketServerSideEncryptionConfigurationRuleOutputReference } from '@cdktf/provider-yandex'

new StorageBucketServerSideEncryptionConfigurationRuleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.putApplyServerSideEncryptionByDefault">putApplyServerSideEncryptionByDefault</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putApplyServerSideEncryptionByDefault` <a name="putApplyServerSideEncryptionByDefault" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.putApplyServerSideEncryptionByDefault"></a>

```typescript
public putApplyServerSideEncryptionByDefault(value: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.putApplyServerSideEncryptionByDefault.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.applyServerSideEncryptionByDefault">applyServerSideEncryptionByDefault</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.applyServerSideEncryptionByDefaultInput">applyServerSideEncryptionByDefaultInput</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `applyServerSideEncryptionByDefault`<sup>Required</sup> <a name="applyServerSideEncryptionByDefault" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.applyServerSideEncryptionByDefault"></a>

```typescript
public readonly applyServerSideEncryptionByDefault: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefaultOutputReference</a>

---

##### `applyServerSideEncryptionByDefaultInput`<sup>Optional</sup> <a name="applyServerSideEncryptionByDefaultInput" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.applyServerSideEncryptionByDefaultInput"></a>

```typescript
public readonly applyServerSideEncryptionByDefaultInput: StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault">StorageBucketServerSideEncryptionConfigurationRuleApplyServerSideEncryptionByDefault</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRuleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketServerSideEncryptionConfigurationRule;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketServerSideEncryptionConfigurationRule">StorageBucketServerSideEncryptionConfigurationRule</a>

---


### StorageBucketVersioningOutputReference <a name="StorageBucketVersioningOutputReference" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.Initializer"></a>

```typescript
import { StorageBucketVersioningOutputReference } from '@cdktf/provider-yandex'

new StorageBucketVersioningOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.resetEnabled">resetEnabled</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetEnabled` <a name="resetEnabled" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.resetEnabled"></a>

```typescript
public resetEnabled(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.enabledInput">enabledInput</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.enabled">enabled</a></code> | <code>boolean \| cdktf.IResolvable</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `enabledInput`<sup>Optional</sup> <a name="enabledInput" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.enabledInput"></a>

```typescript
public readonly enabledInput: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `enabled`<sup>Required</sup> <a name="enabled" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.enabled"></a>

```typescript
public readonly enabled: boolean | IResolvable;
```

- *Type:* boolean | cdktf.IResolvable

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketVersioningOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketVersioning;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketVersioning">StorageBucketVersioning</a>

---


### StorageBucketWebsiteOutputReference <a name="StorageBucketWebsiteOutputReference" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.Initializer"></a>

```typescript
import { StorageBucketWebsiteOutputReference } from '@cdktf/provider-yandex'

new StorageBucketWebsiteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetErrorDocument">resetErrorDocument</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetIndexDocument">resetIndexDocument</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetRedirectAllRequestsTo">resetRedirectAllRequestsTo</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetRoutingRules">resetRoutingRules</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetErrorDocument` <a name="resetErrorDocument" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetErrorDocument"></a>

```typescript
public resetErrorDocument(): void
```

##### `resetIndexDocument` <a name="resetIndexDocument" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetIndexDocument"></a>

```typescript
public resetIndexDocument(): void
```

##### `resetRedirectAllRequestsTo` <a name="resetRedirectAllRequestsTo" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetRedirectAllRequestsTo"></a>

```typescript
public resetRedirectAllRequestsTo(): void
```

##### `resetRoutingRules` <a name="resetRoutingRules" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.resetRoutingRules"></a>

```typescript
public resetRoutingRules(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.errorDocumentInput">errorDocumentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.indexDocumentInput">indexDocumentInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.redirectAllRequestsToInput">redirectAllRequestsToInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.routingRulesInput">routingRulesInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.errorDocument">errorDocument</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.indexDocument">indexDocument</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.redirectAllRequestsTo">redirectAllRequestsTo</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.routingRules">routingRules</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `errorDocumentInput`<sup>Optional</sup> <a name="errorDocumentInput" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.errorDocumentInput"></a>

```typescript
public readonly errorDocumentInput: string;
```

- *Type:* string

---

##### `indexDocumentInput`<sup>Optional</sup> <a name="indexDocumentInput" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.indexDocumentInput"></a>

```typescript
public readonly indexDocumentInput: string;
```

- *Type:* string

---

##### `redirectAllRequestsToInput`<sup>Optional</sup> <a name="redirectAllRequestsToInput" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.redirectAllRequestsToInput"></a>

```typescript
public readonly redirectAllRequestsToInput: string;
```

- *Type:* string

---

##### `routingRulesInput`<sup>Optional</sup> <a name="routingRulesInput" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.routingRulesInput"></a>

```typescript
public readonly routingRulesInput: string;
```

- *Type:* string

---

##### `errorDocument`<sup>Required</sup> <a name="errorDocument" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.errorDocument"></a>

```typescript
public readonly errorDocument: string;
```

- *Type:* string

---

##### `indexDocument`<sup>Required</sup> <a name="indexDocument" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.indexDocument"></a>

```typescript
public readonly indexDocument: string;
```

- *Type:* string

---

##### `redirectAllRequestsTo`<sup>Required</sup> <a name="redirectAllRequestsTo" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.redirectAllRequestsTo"></a>

```typescript
public readonly redirectAllRequestsTo: string;
```

- *Type:* string

---

##### `routingRules`<sup>Required</sup> <a name="routingRules" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.routingRules"></a>

```typescript
public readonly routingRules: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.StorageBucketWebsiteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: StorageBucketWebsite;
```

- *Type:* <a href="#@cdktf/provider-yandex.StorageBucketWebsite">StorageBucketWebsite</a>

---


### VpcAddressExternalIpv4AddressOutputReference <a name="VpcAddressExternalIpv4AddressOutputReference" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.Initializer"></a>

```typescript
import { VpcAddressExternalIpv4AddressOutputReference } from '@cdktf/provider-yandex'

new VpcAddressExternalIpv4AddressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetDdosProtectionProvider">resetDdosProtectionProvider</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetOutgoingSmtpCapability">resetOutgoingSmtpCapability</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetZoneId">resetZoneId</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDdosProtectionProvider` <a name="resetDdosProtectionProvider" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetDdosProtectionProvider"></a>

```typescript
public resetDdosProtectionProvider(): void
```

##### `resetOutgoingSmtpCapability` <a name="resetOutgoingSmtpCapability" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetOutgoingSmtpCapability"></a>

```typescript
public resetOutgoingSmtpCapability(): void
```

##### `resetZoneId` <a name="resetZoneId" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.resetZoneId"></a>

```typescript
public resetZoneId(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.address">address</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProviderInput">ddosProtectionProviderInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapabilityInput">outgoingSmtpCapabilityInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.zoneIdInput">zoneIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProvider">ddosProtectionProvider</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapability">outgoingSmtpCapability</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.zoneId">zoneId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `address`<sup>Required</sup> <a name="address" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.address"></a>

```typescript
public readonly address: string;
```

- *Type:* string

---

##### `ddosProtectionProviderInput`<sup>Optional</sup> <a name="ddosProtectionProviderInput" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProviderInput"></a>

```typescript
public readonly ddosProtectionProviderInput: string;
```

- *Type:* string

---

##### `outgoingSmtpCapabilityInput`<sup>Optional</sup> <a name="outgoingSmtpCapabilityInput" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapabilityInput"></a>

```typescript
public readonly outgoingSmtpCapabilityInput: string;
```

- *Type:* string

---

##### `zoneIdInput`<sup>Optional</sup> <a name="zoneIdInput" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.zoneIdInput"></a>

```typescript
public readonly zoneIdInput: string;
```

- *Type:* string

---

##### `ddosProtectionProvider`<sup>Required</sup> <a name="ddosProtectionProvider" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.ddosProtectionProvider"></a>

```typescript
public readonly ddosProtectionProvider: string;
```

- *Type:* string

---

##### `outgoingSmtpCapability`<sup>Required</sup> <a name="outgoingSmtpCapability" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.outgoingSmtpCapability"></a>

```typescript
public readonly outgoingSmtpCapability: string;
```

- *Type:* string

---

##### `zoneId`<sup>Required</sup> <a name="zoneId" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.zoneId"></a>

```typescript
public readonly zoneId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcAddressExternalIpv4AddressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VpcAddressExternalIpv4Address;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcAddressExternalIpv4Address">VpcAddressExternalIpv4Address</a>

---


### VpcAddressTimeoutsOutputReference <a name="VpcAddressTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcAddressTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcAddressTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcAddressTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcAddressTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcAddressTimeouts">VpcAddressTimeouts</a>

---


### VpcDefaultSecurityGroupEgressList <a name="VpcDefaultSecurityGroupEgressList" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupEgressList } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroupEgressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.get"></a>

```typescript
public get(index: number): VpcDefaultSecurityGroupEgressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcDefaultSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>[]

---


### VpcDefaultSecurityGroupEgressOutputReference <a name="VpcDefaultSecurityGroupEgressOutputReference" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupEgressOutputReference } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroupEgressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetFromPort">resetFromPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetPredefinedTarget">resetPredefinedTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetToPort">resetToPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetV4CidrBlocks">resetV4CidrBlocks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetV6CidrBlocks">resetV6CidrBlocks</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFromPort` <a name="resetFromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetFromPort"></a>

```typescript
public resetFromPort(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetPredefinedTarget` <a name="resetPredefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetPredefinedTarget"></a>

```typescript
public resetPredefinedTarget(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

##### `resetToPort` <a name="resetToPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetToPort"></a>

```typescript
public resetToPort(): void
```

##### `resetV4CidrBlocks` <a name="resetV4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetV4CidrBlocks"></a>

```typescript
public resetV4CidrBlocks(): void
```

##### `resetV6CidrBlocks` <a name="resetV6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.resetV6CidrBlocks"></a>

```typescript
public resetV6CidrBlocks(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fromPortInput">fromPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.predefinedTargetInput">predefinedTargetInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.toPortInput">toPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v6CidrBlocksInput">v6CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `fromPortInput`<sup>Optional</sup> <a name="fromPortInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* number

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `predefinedTargetInput`<sup>Optional</sup> <a name="predefinedTargetInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.predefinedTargetInput"></a>

```typescript
public readonly predefinedTargetInput: string;
```

- *Type:* string

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `toPortInput`<sup>Optional</sup> <a name="toPortInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* number

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocksInput`<sup>Optional</sup> <a name="v6CidrBlocksInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v6CidrBlocksInput"></a>

```typescript
public readonly v6CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupEgressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcDefaultSecurityGroupEgress;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupEgress">VpcDefaultSecurityGroupEgress</a>

---


### VpcDefaultSecurityGroupIngressList <a name="VpcDefaultSecurityGroupIngressList" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupIngressList } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroupIngressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.get"></a>

```typescript
public get(index: number): VpcDefaultSecurityGroupIngressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcDefaultSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>[]

---


### VpcDefaultSecurityGroupIngressOutputReference <a name="VpcDefaultSecurityGroupIngressOutputReference" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupIngressOutputReference } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroupIngressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetFromPort">resetFromPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetPredefinedTarget">resetPredefinedTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetToPort">resetToPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetV4CidrBlocks">resetV4CidrBlocks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetV6CidrBlocks">resetV6CidrBlocks</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFromPort` <a name="resetFromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetFromPort"></a>

```typescript
public resetFromPort(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetPredefinedTarget` <a name="resetPredefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetPredefinedTarget"></a>

```typescript
public resetPredefinedTarget(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

##### `resetToPort` <a name="resetToPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetToPort"></a>

```typescript
public resetToPort(): void
```

##### `resetV4CidrBlocks` <a name="resetV4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetV4CidrBlocks"></a>

```typescript
public resetV4CidrBlocks(): void
```

##### `resetV6CidrBlocks` <a name="resetV6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.resetV6CidrBlocks"></a>

```typescript
public resetV6CidrBlocks(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fromPortInput">fromPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.predefinedTargetInput">predefinedTargetInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.toPortInput">toPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v6CidrBlocksInput">v6CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `fromPortInput`<sup>Optional</sup> <a name="fromPortInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* number

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `predefinedTargetInput`<sup>Optional</sup> <a name="predefinedTargetInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.predefinedTargetInput"></a>

```typescript
public readonly predefinedTargetInput: string;
```

- *Type:* string

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `toPortInput`<sup>Optional</sup> <a name="toPortInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* number

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocksInput`<sup>Optional</sup> <a name="v6CidrBlocksInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v6CidrBlocksInput"></a>

```typescript
public readonly v6CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupIngressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcDefaultSecurityGroupIngress;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupIngress">VpcDefaultSecurityGroupIngress</a>

---


### VpcDefaultSecurityGroupTimeoutsOutputReference <a name="VpcDefaultSecurityGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcDefaultSecurityGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcDefaultSecurityGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcDefaultSecurityGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcDefaultSecurityGroupTimeouts">VpcDefaultSecurityGroupTimeouts</a>

---


### VpcNetworkTimeoutsOutputReference <a name="VpcNetworkTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcNetworkTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcNetworkTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcNetworkTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcNetworkTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcNetworkTimeouts">VpcNetworkTimeouts</a>

---


### VpcRouteTableStaticRouteList <a name="VpcRouteTableStaticRouteList" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer"></a>

```typescript
import { VpcRouteTableStaticRouteList } from '@cdktf/provider-yandex'

new VpcRouteTableStaticRouteList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.get"></a>

```typescript
public get(index: number): VpcRouteTableStaticRouteOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcRouteTableStaticRoute[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>[]

---


### VpcRouteTableStaticRouteOutputReference <a name="VpcRouteTableStaticRouteOutputReference" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer"></a>

```typescript
import { VpcRouteTableStaticRouteOutputReference } from '@cdktf/provider-yandex'

new VpcRouteTableStaticRouteOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resetDestinationPrefix">resetDestinationPrefix</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resetNextHopAddress">resetNextHopAddress</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDestinationPrefix` <a name="resetDestinationPrefix" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resetDestinationPrefix"></a>

```typescript
public resetDestinationPrefix(): void
```

##### `resetNextHopAddress` <a name="resetNextHopAddress" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.resetNextHopAddress"></a>

```typescript
public resetNextHopAddress(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.destinationPrefixInput">destinationPrefixInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.nextHopAddressInput">nextHopAddressInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.destinationPrefix">destinationPrefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.nextHopAddress">nextHopAddress</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `destinationPrefixInput`<sup>Optional</sup> <a name="destinationPrefixInput" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.destinationPrefixInput"></a>

```typescript
public readonly destinationPrefixInput: string;
```

- *Type:* string

---

##### `nextHopAddressInput`<sup>Optional</sup> <a name="nextHopAddressInput" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.nextHopAddressInput"></a>

```typescript
public readonly nextHopAddressInput: string;
```

- *Type:* string

---

##### `destinationPrefix`<sup>Required</sup> <a name="destinationPrefix" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.destinationPrefix"></a>

```typescript
public readonly destinationPrefix: string;
```

- *Type:* string

---

##### `nextHopAddress`<sup>Required</sup> <a name="nextHopAddress" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.nextHopAddress"></a>

```typescript
public readonly nextHopAddress: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcRouteTableStaticRouteOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcRouteTableStaticRoute;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableStaticRoute">VpcRouteTableStaticRoute</a>

---


### VpcRouteTableTimeoutsOutputReference <a name="VpcRouteTableTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcRouteTableTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcRouteTableTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcRouteTableTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcRouteTableTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcRouteTableTimeouts">VpcRouteTableTimeouts</a>

---


### VpcSecurityGroupEgressList <a name="VpcSecurityGroupEgressList" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer"></a>

```typescript
import { VpcSecurityGroupEgressList } from '@cdktf/provider-yandex'

new VpcSecurityGroupEgressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.get"></a>

```typescript
public get(index: number): VpcSecurityGroupEgressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupEgressList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupEgress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>[]

---


### VpcSecurityGroupEgressOutputReference <a name="VpcSecurityGroupEgressOutputReference" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer"></a>

```typescript
import { VpcSecurityGroupEgressOutputReference } from '@cdktf/provider-yandex'

new VpcSecurityGroupEgressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetFromPort">resetFromPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetPredefinedTarget">resetPredefinedTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetToPort">resetToPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetV4CidrBlocks">resetV4CidrBlocks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetV6CidrBlocks">resetV6CidrBlocks</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFromPort` <a name="resetFromPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetFromPort"></a>

```typescript
public resetFromPort(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetPredefinedTarget` <a name="resetPredefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetPredefinedTarget"></a>

```typescript
public resetPredefinedTarget(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

##### `resetToPort` <a name="resetToPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetToPort"></a>

```typescript
public resetToPort(): void
```

##### `resetV4CidrBlocks` <a name="resetV4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetV4CidrBlocks"></a>

```typescript
public resetV4CidrBlocks(): void
```

##### `resetV6CidrBlocks` <a name="resetV6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.resetV6CidrBlocks"></a>

```typescript
public resetV6CidrBlocks(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fromPortInput">fromPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.predefinedTargetInput">predefinedTargetInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.toPortInput">toPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v6CidrBlocksInput">v6CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `fromPortInput`<sup>Optional</sup> <a name="fromPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* number

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `predefinedTargetInput`<sup>Optional</sup> <a name="predefinedTargetInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.predefinedTargetInput"></a>

```typescript
public readonly predefinedTargetInput: string;
```

- *Type:* string

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `toPortInput`<sup>Optional</sup> <a name="toPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* number

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocksInput`<sup>Optional</sup> <a name="v6CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v6CidrBlocksInput"></a>

```typescript
public readonly v6CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupEgressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupEgress;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupEgress">VpcSecurityGroupEgress</a>

---


### VpcSecurityGroupIngressList <a name="VpcSecurityGroupIngressList" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer"></a>

```typescript
import { VpcSecurityGroupIngressList } from '@cdktf/provider-yandex'

new VpcSecurityGroupIngressList(terraformResource: IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.wrapsSet">wrapsSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `wrapsSet`<sup>Required</sup> <a name="wrapsSet" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.Initializer.parameter.wrapsSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.get">get</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `get` <a name="get" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.get"></a>

```typescript
public get(index: number): VpcSecurityGroupIngressOutputReference
```

###### `index`<sup>Required</sup> <a name="index" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.get.parameter.index"></a>

- *Type:* number

the index of the item to return.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]</code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupIngressList.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupIngress[];
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>[]

---


### VpcSecurityGroupIngressOutputReference <a name="VpcSecurityGroupIngressOutputReference" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer"></a>

```typescript
import { VpcSecurityGroupIngressOutputReference } from '@cdktf/provider-yandex'

new VpcSecurityGroupIngressOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex">complexObjectIndex</a></code> | <code>number</code> | the index of this item in the list. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet">complexObjectIsFromSet</a></code> | <code>boolean</code> | whether the list is wrapping a set (will add tolist() to be able to access an item via an index). |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

##### `complexObjectIndex`<sup>Required</sup> <a name="complexObjectIndex" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIndex"></a>

- *Type:* number

the index of this item in the list.

---

##### `complexObjectIsFromSet`<sup>Required</sup> <a name="complexObjectIsFromSet" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.Initializer.parameter.complexObjectIsFromSet"></a>

- *Type:* boolean

whether the list is wrapping a set (will add tolist() to be able to access an item via an index).

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetDescription">resetDescription</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetFromPort">resetFromPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetLabels">resetLabels</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetPort">resetPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetPredefinedTarget">resetPredefinedTarget</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetSecurityGroupId">resetSecurityGroupId</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetToPort">resetToPort</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetV4CidrBlocks">resetV4CidrBlocks</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetV6CidrBlocks">resetV6CidrBlocks</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDescription` <a name="resetDescription" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetDescription"></a>

```typescript
public resetDescription(): void
```

##### `resetFromPort` <a name="resetFromPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetFromPort"></a>

```typescript
public resetFromPort(): void
```

##### `resetLabels` <a name="resetLabels" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetLabels"></a>

```typescript
public resetLabels(): void
```

##### `resetPort` <a name="resetPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetPort"></a>

```typescript
public resetPort(): void
```

##### `resetPredefinedTarget` <a name="resetPredefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetPredefinedTarget"></a>

```typescript
public resetPredefinedTarget(): void
```

##### `resetSecurityGroupId` <a name="resetSecurityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetSecurityGroupId"></a>

```typescript
public resetSecurityGroupId(): void
```

##### `resetToPort` <a name="resetToPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetToPort"></a>

```typescript
public resetToPort(): void
```

##### `resetV4CidrBlocks` <a name="resetV4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetV4CidrBlocks"></a>

```typescript
public resetV4CidrBlocks(): void
```

##### `resetV6CidrBlocks` <a name="resetV6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.resetV6CidrBlocks"></a>

```typescript
public resetV6CidrBlocks(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.descriptionInput">descriptionInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fromPortInput">fromPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.labelsInput">labelsInput</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.portInput">portInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.predefinedTargetInput">predefinedTargetInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.protocolInput">protocolInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.securityGroupIdInput">securityGroupIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.toPortInput">toPortInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v4CidrBlocksInput">v4CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v6CidrBlocksInput">v6CidrBlocksInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fromPort">fromPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.predefinedTarget">predefinedTarget</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.protocol">protocol</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.securityGroupId">securityGroupId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.toPort">toPort</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v4CidrBlocks">v4CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v6CidrBlocks">v6CidrBlocks</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `descriptionInput`<sup>Optional</sup> <a name="descriptionInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.descriptionInput"></a>

```typescript
public readonly descriptionInput: string;
```

- *Type:* string

---

##### `fromPortInput`<sup>Optional</sup> <a name="fromPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fromPortInput"></a>

```typescript
public readonly fromPortInput: number;
```

- *Type:* number

---

##### `labelsInput`<sup>Optional</sup> <a name="labelsInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.labelsInput"></a>

```typescript
public readonly labelsInput: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `portInput`<sup>Optional</sup> <a name="portInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.portInput"></a>

```typescript
public readonly portInput: number;
```

- *Type:* number

---

##### `predefinedTargetInput`<sup>Optional</sup> <a name="predefinedTargetInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.predefinedTargetInput"></a>

```typescript
public readonly predefinedTargetInput: string;
```

- *Type:* string

---

##### `protocolInput`<sup>Optional</sup> <a name="protocolInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.protocolInput"></a>

```typescript
public readonly protocolInput: string;
```

- *Type:* string

---

##### `securityGroupIdInput`<sup>Optional</sup> <a name="securityGroupIdInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.securityGroupIdInput"></a>

```typescript
public readonly securityGroupIdInput: string;
```

- *Type:* string

---

##### `toPortInput`<sup>Optional</sup> <a name="toPortInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.toPortInput"></a>

```typescript
public readonly toPortInput: number;
```

- *Type:* number

---

##### `v4CidrBlocksInput`<sup>Optional</sup> <a name="v4CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v4CidrBlocksInput"></a>

```typescript
public readonly v4CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocksInput`<sup>Optional</sup> <a name="v6CidrBlocksInput" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v6CidrBlocksInput"></a>

```typescript
public readonly v6CidrBlocksInput: string[];
```

- *Type:* string[]

---

##### `description`<sup>Required</sup> <a name="description" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `fromPort`<sup>Required</sup> <a name="fromPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.fromPort"></a>

```typescript
public readonly fromPort: number;
```

- *Type:* number

---

##### `labels`<sup>Required</sup> <a name="labels" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

---

##### `port`<sup>Required</sup> <a name="port" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `predefinedTarget`<sup>Required</sup> <a name="predefinedTarget" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.predefinedTarget"></a>

```typescript
public readonly predefinedTarget: string;
```

- *Type:* string

---

##### `protocol`<sup>Required</sup> <a name="protocol" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

---

##### `securityGroupId`<sup>Required</sup> <a name="securityGroupId" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.securityGroupId"></a>

```typescript
public readonly securityGroupId: string;
```

- *Type:* string

---

##### `toPort`<sup>Required</sup> <a name="toPort" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.toPort"></a>

```typescript
public readonly toPort: number;
```

- *Type:* number

---

##### `v4CidrBlocks`<sup>Required</sup> <a name="v4CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v4CidrBlocks"></a>

```typescript
public readonly v4CidrBlocks: string[];
```

- *Type:* string[]

---

##### `v6CidrBlocks`<sup>Required</sup> <a name="v6CidrBlocks" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.v6CidrBlocks"></a>

```typescript
public readonly v6CidrBlocks: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupIngressOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupIngress;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupIngress">VpcSecurityGroupIngress</a>

---


### VpcSecurityGroupRuleTimeoutsOutputReference <a name="VpcSecurityGroupRuleTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcSecurityGroupRuleTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcSecurityGroupRuleTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetRead">resetRead</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetRead` <a name="resetRead" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetRead"></a>

```typescript
public resetRead(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.readInput">readInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.read">read</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `readInput`<sup>Optional</sup> <a name="readInput" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.readInput"></a>

```typescript
public readonly readInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `read`<sup>Required</sup> <a name="read" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.read"></a>

```typescript
public readonly read: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupRuleTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupRuleTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupRuleTimeouts">VpcSecurityGroupRuleTimeouts</a>

---


### VpcSecurityGroupTimeoutsOutputReference <a name="VpcSecurityGroupTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcSecurityGroupTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcSecurityGroupTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSecurityGroupTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSecurityGroupTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSecurityGroupTimeouts">VpcSecurityGroupTimeouts</a>

---


### VpcSubnetDhcpOptionsOutputReference <a name="VpcSubnetDhcpOptionsOutputReference" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.Initializer"></a>

```typescript
import { VpcSubnetDhcpOptionsOutputReference } from '@cdktf/provider-yandex'

new VpcSubnetDhcpOptionsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetDomainName">resetDomainName</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetDomainNameServers">resetDomainNameServers</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetNtpServers">resetNtpServers</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDomainName` <a name="resetDomainName" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetDomainName"></a>

```typescript
public resetDomainName(): void
```

##### `resetDomainNameServers` <a name="resetDomainNameServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetDomainNameServers"></a>

```typescript
public resetDomainNameServers(): void
```

##### `resetNtpServers` <a name="resetNtpServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.resetNtpServers"></a>

```typescript
public resetNtpServers(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameInput">domainNameInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameServersInput">domainNameServersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.ntpServersInput">ntpServersInput</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainName">domainName</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameServers">domainNameServers</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.ntpServers">ntpServers</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `domainNameInput`<sup>Optional</sup> <a name="domainNameInput" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameInput"></a>

```typescript
public readonly domainNameInput: string;
```

- *Type:* string

---

##### `domainNameServersInput`<sup>Optional</sup> <a name="domainNameServersInput" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameServersInput"></a>

```typescript
public readonly domainNameServersInput: string[];
```

- *Type:* string[]

---

##### `ntpServersInput`<sup>Optional</sup> <a name="ntpServersInput" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.ntpServersInput"></a>

```typescript
public readonly ntpServersInput: string[];
```

- *Type:* string[]

---

##### `domainName`<sup>Required</sup> <a name="domainName" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainName"></a>

```typescript
public readonly domainName: string;
```

- *Type:* string

---

##### `domainNameServers`<sup>Required</sup> <a name="domainNameServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.domainNameServers"></a>

```typescript
public readonly domainNameServers: string[];
```

- *Type:* string[]

---

##### `ntpServers`<sup>Required</sup> <a name="ntpServers" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.ntpServers"></a>

```typescript
public readonly ntpServers: string[];
```

- *Type:* string[]

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSubnetDhcpOptionsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: VpcSubnetDhcpOptions;
```

- *Type:* <a href="#@cdktf/provider-yandex.VpcSubnetDhcpOptions">VpcSubnetDhcpOptions</a>

---


### VpcSubnetTimeoutsOutputReference <a name="VpcSubnetTimeoutsOutputReference" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.Initializer"></a>

```typescript
import { VpcSubnetTimeoutsOutputReference } from '@cdktf/provider-yandex'

new VpcSubnetTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetCreate">resetCreate</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetDelete">resetDelete</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetUpdate">resetUpdate</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetCreate` <a name="resetCreate" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetCreate"></a>

```typescript
public resetCreate(): void
```

##### `resetDelete` <a name="resetDelete" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetDelete"></a>

```typescript
public resetDelete(): void
```

##### `resetUpdate` <a name="resetUpdate" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.resetUpdate"></a>

```typescript
public resetUpdate(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.createInput">createInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.deleteInput">deleteInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.updateInput">updateInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.create">create</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.delete">delete</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.update">update</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `createInput`<sup>Optional</sup> <a name="createInput" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.createInput"></a>

```typescript
public readonly createInput: string;
```

- *Type:* string

---

##### `deleteInput`<sup>Optional</sup> <a name="deleteInput" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.deleteInput"></a>

```typescript
public readonly deleteInput: string;
```

- *Type:* string

---

##### `updateInput`<sup>Optional</sup> <a name="updateInput" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.updateInput"></a>

```typescript
public readonly updateInput: string;
```

- *Type:* string

---

##### `create`<sup>Required</sup> <a name="create" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.create"></a>

```typescript
public readonly create: string;
```

- *Type:* string

---

##### `delete`<sup>Required</sup> <a name="delete" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.delete"></a>

```typescript
public readonly delete: string;
```

- *Type:* string

---

##### `update`<sup>Required</sup> <a name="update" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.update"></a>

```typescript
public readonly update: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.VpcSubnetTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | VpcSubnetTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.VpcSubnetTimeouts">VpcSubnetTimeouts</a>

---


### YdbDatabaseDedicatedLocationOutputReference <a name="YdbDatabaseDedicatedLocationOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedLocationOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedLocationOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.putRegion">putRegion</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.resetRegion">resetRegion</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putRegion` <a name="putRegion" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.putRegion"></a>

```typescript
public putRegion(value: YdbDatabaseDedicatedLocationRegion): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.putRegion.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a>

---

##### `resetRegion` <a name="resetRegion" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.resetRegion"></a>

```typescript
public resetRegion(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.region">region</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference">YdbDatabaseDedicatedLocationRegionOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.regionInput">regionInput</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `region`<sup>Required</sup> <a name="region" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.region"></a>

```typescript
public readonly region: YdbDatabaseDedicatedLocationRegionOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference">YdbDatabaseDedicatedLocationRegionOutputReference</a>

---

##### `regionInput`<sup>Optional</sup> <a name="regionInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.regionInput"></a>

```typescript
public readonly regionInput: YdbDatabaseDedicatedLocationRegion;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: YdbDatabaseDedicatedLocation;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocation">YdbDatabaseDedicatedLocation</a>

---


### YdbDatabaseDedicatedLocationRegionOutputReference <a name="YdbDatabaseDedicatedLocationRegionOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedLocationRegionOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedLocationRegionOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.idInput">idInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `idInput`<sup>Optional</sup> <a name="idInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.idInput"></a>

```typescript
public readonly idInput: string;
```

- *Type:* string

---

##### `id`<sup>Required</sup> <a name="id" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegionOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: YdbDatabaseDedicatedLocationRegion;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedLocationRegion">YdbDatabaseDedicatedLocationRegion</a>

---


### YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference <a name="YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.sizeInput">sizeInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.size">size</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `sizeInput`<sup>Optional</sup> <a name="sizeInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.sizeInput"></a>

```typescript
public readonly sizeInput: number;
```

- *Type:* number

---

##### `size`<sup>Required</sup> <a name="size" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.size"></a>

```typescript
public readonly size: number;
```

- *Type:* number

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: YdbDatabaseDedicatedScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a>

---


### YdbDatabaseDedicatedScalePolicyOutputReference <a name="YdbDatabaseDedicatedScalePolicyOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedScalePolicyOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedScalePolicyOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.putFixedScale">putFixedScale</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `putFixedScale` <a name="putFixedScale" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.putFixedScale"></a>

```typescript
public putFixedScale(value: YdbDatabaseDedicatedScalePolicyFixedScale): void
```

###### `value`<sup>Required</sup> <a name="value" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.putFixedScale.parameter.value"></a>

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScale">fixedScale</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference">YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScaleInput">fixedScaleInput</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `fixedScale`<sup>Required</sup> <a name="fixedScale" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScale"></a>

```typescript
public readonly fixedScale: YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference">YdbDatabaseDedicatedScalePolicyFixedScaleOutputReference</a>

---

##### `fixedScaleInput`<sup>Optional</sup> <a name="fixedScaleInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.fixedScaleInput"></a>

```typescript
public readonly fixedScaleInput: YdbDatabaseDedicatedScalePolicyFixedScale;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyFixedScale">YdbDatabaseDedicatedScalePolicyFixedScale</a>

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicyOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: YdbDatabaseDedicatedScalePolicy;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedScalePolicy">YdbDatabaseDedicatedScalePolicy</a>

---


### YdbDatabaseDedicatedStorageConfigOutputReference <a name="YdbDatabaseDedicatedStorageConfigOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedStorageConfigOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedStorageConfigOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.groupCountInput">groupCountInput</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeIdInput">storageTypeIdInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.groupCount">groupCount</a></code> | <code>number</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeId">storageTypeId</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.internalValue">internalValue</a></code> | <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `groupCountInput`<sup>Optional</sup> <a name="groupCountInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.groupCountInput"></a>

```typescript
public readonly groupCountInput: number;
```

- *Type:* number

---

##### `storageTypeIdInput`<sup>Optional</sup> <a name="storageTypeIdInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeIdInput"></a>

```typescript
public readonly storageTypeIdInput: string;
```

- *Type:* string

---

##### `groupCount`<sup>Required</sup> <a name="groupCount" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.groupCount"></a>

```typescript
public readonly groupCount: number;
```

- *Type:* number

---

##### `storageTypeId`<sup>Required</sup> <a name="storageTypeId" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.storageTypeId"></a>

```typescript
public readonly storageTypeId: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfigOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: YdbDatabaseDedicatedStorageConfig;
```

- *Type:* <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedStorageConfig">YdbDatabaseDedicatedStorageConfig</a>

---


### YdbDatabaseDedicatedTimeoutsOutputReference <a name="YdbDatabaseDedicatedTimeoutsOutputReference" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseDedicatedTimeoutsOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseDedicatedTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.resetDefault">resetDefault</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDefault` <a name="resetDefault" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.defaultInput">defaultInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.default">default</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `defaultInput`<sup>Optional</sup> <a name="defaultInput" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* string

---

##### `default`<sup>Required</sup> <a name="default" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseDedicatedTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | YdbDatabaseDedicatedTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.YdbDatabaseDedicatedTimeouts">YdbDatabaseDedicatedTimeouts</a>

---


### YdbDatabaseServerlessTimeoutsOutputReference <a name="YdbDatabaseServerlessTimeoutsOutputReference" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference"></a>

#### Initializers <a name="Initializers" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.Initializer"></a>

```typescript
import { YdbDatabaseServerlessTimeoutsOutputReference } from '@cdktf/provider-yandex'

new YdbDatabaseServerlessTimeoutsOutputReference(terraformResource: IInterpolatingParent, terraformAttribute: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.Initializer.parameter.terraformResource">terraformResource</a></code> | <code>cdktf.IInterpolatingParent</code> | The parent resource. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.Initializer.parameter.terraformAttribute">terraformAttribute</a></code> | <code>string</code> | The attribute on the parent resource this class is referencing. |

---

##### `terraformResource`<sup>Required</sup> <a name="terraformResource" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.Initializer.parameter.terraformResource"></a>

- *Type:* cdktf.IInterpolatingParent

The parent resource.

---

##### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.Initializer.parameter.terraformAttribute"></a>

- *Type:* string

The attribute on the parent resource this class is referencing.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.computeFqn">computeFqn</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getAnyMapAttribute">getAnyMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanAttribute">getBooleanAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanMapAttribute">getBooleanMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getListAttribute">getListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberAttribute">getNumberAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberListAttribute">getNumberListAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberMapAttribute">getNumberMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringAttribute">getStringAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringMapAttribute">getStringMapAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.interpolationForAttribute">interpolationForAttribute</a></code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.resolve">resolve</a></code> | Produce the Token's value at resolution time. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.toString">toString</a></code> | Return a string representation of this resolvable object. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.resetDefault">resetDefault</a></code> | *No description.* |

---

##### `computeFqn` <a name="computeFqn" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.computeFqn"></a>

```typescript
public computeFqn(): string
```

##### `getAnyMapAttribute` <a name="getAnyMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getAnyMapAttribute"></a>

```typescript
public getAnyMapAttribute(terraformAttribute: string): {[ key: string ]: any}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getAnyMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanAttribute` <a name="getBooleanAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanAttribute"></a>

```typescript
public getBooleanAttribute(terraformAttribute: string): IResolvable
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getBooleanMapAttribute` <a name="getBooleanMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanMapAttribute"></a>

```typescript
public getBooleanMapAttribute(terraformAttribute: string): {[ key: string ]: boolean}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getBooleanMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getListAttribute` <a name="getListAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getListAttribute"></a>

```typescript
public getListAttribute(terraformAttribute: string): string[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberAttribute` <a name="getNumberAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberAttribute"></a>

```typescript
public getNumberAttribute(terraformAttribute: string): number
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberListAttribute` <a name="getNumberListAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberListAttribute"></a>

```typescript
public getNumberListAttribute(terraformAttribute: string): number[]
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberListAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getNumberMapAttribute` <a name="getNumberMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberMapAttribute"></a>

```typescript
public getNumberMapAttribute(terraformAttribute: string): {[ key: string ]: number}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getNumberMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringAttribute` <a name="getStringAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringAttribute"></a>

```typescript
public getStringAttribute(terraformAttribute: string): string
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `getStringMapAttribute` <a name="getStringMapAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringMapAttribute"></a>

```typescript
public getStringMapAttribute(terraformAttribute: string): {[ key: string ]: string}
```

###### `terraformAttribute`<sup>Required</sup> <a name="terraformAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.getStringMapAttribute.parameter.terraformAttribute"></a>

- *Type:* string

---

##### `interpolationForAttribute` <a name="interpolationForAttribute" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.interpolationForAttribute"></a>

```typescript
public interpolationForAttribute(property: string): IResolvable
```

###### `property`<sup>Required</sup> <a name="property" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.interpolationForAttribute.parameter.property"></a>

- *Type:* string

---

##### `resolve` <a name="resolve" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.resolve"></a>

```typescript
public resolve(_context: IResolveContext): any
```

Produce the Token's value at resolution time.

###### `_context`<sup>Required</sup> <a name="_context" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.resolve.parameter._context"></a>

- *Type:* cdktf.IResolveContext

---

##### `toString` <a name="toString" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.toString"></a>

```typescript
public toString(): string
```

Return a string representation of this resolvable object.

Returns a reversible string representation.

##### `resetDefault` <a name="resetDefault" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.resetDefault"></a>

```typescript
public resetDefault(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.creationStack">creationStack</a></code> | <code>string[]</code> | The creation stack of this resolvable which will be appended to errors thrown during resolution. |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.fqn">fqn</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.defaultInput">defaultInput</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.default">default</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.internalValue">internalValue</a></code> | <code>cdktf.IResolvable \| <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a></code> | *No description.* |

---

##### `creationStack`<sup>Required</sup> <a name="creationStack" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.creationStack"></a>

```typescript
public readonly creationStack: string[];
```

- *Type:* string[]

The creation stack of this resolvable which will be appended to errors thrown during resolution.

If this returns an empty array the stack will not be attached.

---

##### `fqn`<sup>Required</sup> <a name="fqn" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.fqn"></a>

```typescript
public readonly fqn: string;
```

- *Type:* string

---

##### `defaultInput`<sup>Optional</sup> <a name="defaultInput" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.defaultInput"></a>

```typescript
public readonly defaultInput: string;
```

- *Type:* string

---

##### `default`<sup>Required</sup> <a name="default" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.default"></a>

```typescript
public readonly default: string;
```

- *Type:* string

---

##### `internalValue`<sup>Optional</sup> <a name="internalValue" id="@cdktf/provider-yandex.YdbDatabaseServerlessTimeoutsOutputReference.property.internalValue"></a>

```typescript
public readonly internalValue: IResolvable | YdbDatabaseServerlessTimeouts;
```

- *Type:* cdktf.IResolvable | <a href="#@cdktf/provider-yandex.YdbDatabaseServerlessTimeouts">YdbDatabaseServerlessTimeouts</a>

---



